var searchIndex = {};
searchIndex["arena"] = {"doc":"The arena, a fast but limited type of allocator.","items":[[3,"TypedArena","arena","An arena that can hold objects of only one type.",null,null],[12,"ptr","","A pointer to the next object to be allocated.",0,null],[12,"end","","A pointer to the end of the allocated area. When this pointer is reached, a new chunk is allocated.",0,null],[12,"chunks","","A vector of arena chunks.",0,null],[12,"_own","","Marker indicating that dropping the arena causes its owned instances of `T` to be dropped.",0,null],[3,"TypedArenaChunk","","",null,null],[12,"storage","","The raw storage for the arena chunk.",1,null],[3,"DroplessArena","","",null,null],[12,"ptr","","A pointer to the next object to be allocated.",2,null],[12,"end","","A pointer to the end of the allocated area. When this pointer is reached, a new chunk is allocated.",2,null],[12,"chunks","","A vector of arena chunks.",2,null],[3,"SyncTypedArena","","",null,null],[12,"lock","","",3,null],[3,"SyncDroplessArena","","",null,null],[12,"lock","","",4,null],[17,"PAGE","","",null,null],[11,"new","","",1,{"inputs":[{"name":"usize"}],"output":{"name":"typedarenachunk"}}],[11,"destroy","","Destroys this arena chunk.",1,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"start","","",1,null],[11,"end","","",1,null],[11,"new","","Creates a new `TypedArena`.",0,{"inputs":[],"output":{"name":"typedarena"}}],[11,"alloc","","Allocates an object in the `TypedArena`, returning a reference to it.",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"alloc_slice","","Allocates a slice of objects that are copied into the `TypedArena`, returning a mutable reference to it. Will panic if passed a zero-sized types.",0,null],[11,"grow","","Grows the arena.",0,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"clear","","Clears the arena. Deallocates all but the longest chunk which may be reused.",0,{"inputs":[{"name":"self"}],"output":null}],[11,"clear_last_chunk","","",0,{"inputs":[{"name":"self"},{"name":"typedarenachunk"}],"output":null}],[11,"drop","","",0,{"inputs":[{"name":"self"}],"output":null}],[11,"new","","",2,{"inputs":[],"output":{"name":"droplessarena"}}],[11,"in_arena","","",2,null],[11,"align_for","","",2,{"inputs":[{"name":"self"}],"output":null}],[11,"grow","","",2,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"alloc","","",2,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"alloc_slice","","Allocates a slice of objects that are copied into the `DroplessArena`, returning a mutable reference to it. Will panic if passed a zero-sized type.",2,null],[11,"new","","",3,{"inputs":[],"output":{"name":"synctypedarena"}}],[11,"alloc","","",3,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"alloc_slice","","",3,null],[11,"clear","","",3,{"inputs":[{"name":"self"}],"output":null}],[11,"new","","",4,{"inputs":[],"output":{"name":"syncdroplessarena"}}],[11,"in_arena","","",4,null],[11,"alloc","","",4,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"alloc_slice","","",4,null]],"paths":[[3,"TypedArena"],[3,"TypedArenaChunk"],[3,"DroplessArena"],[3,"SyncTypedArena"],[3,"SyncDroplessArena"]]};
searchIndex["fmt_macros"] = {"doc":"Macro support for format strings","items":[[3,"Argument","fmt_macros","Representation of an argument specification.",null,null],[12,"position","","Where to find this argument",0,null],[12,"format","","How to format the argument",0,null],[3,"FormatSpec","","Specification for the formatting of an argument in the format string.",null,null],[12,"fill","","Optionally specified character to fill alignment with",1,null],[12,"align","","Optionally specified alignment",1,null],[12,"flags","","Packed version of various flags provided",1,null],[12,"precision","","The integer precision to use",1,null],[12,"width","","The string width requested for the resulting format",1,null],[12,"ty","","The descriptor string representing the name of the format desired for this argument, this can be empty or any number of characters, although it is required to be one word.",1,null],[3,"Parser","","The parser structure for interpreting the input format string. This is modeled as an iterator over `Piece` structures to form a stream of tokens being output.",null,null],[12,"input","","",2,null],[12,"cur","","",2,null],[12,"errors","","Error messages accumulated during parsing",2,null],[12,"curarg","","Current position of implicit positional argument pointer",2,null],[4,"Piece","","A piece is a portion of the format string which represents the next part to emit. These are emitted as a stream by the `Parser` class.",null,null],[13,"String","","A literal string which should directly be emitted",3,null],[13,"NextArgument","","This describes that formatting should process the next argument (as specified inside) for emission.",3,null],[4,"Position","","Enum describing where an argument for a format can be located.",null,null],[13,"ArgumentImplicitlyIs","","The argument is implied to be located at an index",4,null],[13,"ArgumentIs","","The argument is located at a specific index given in the format",4,null],[13,"ArgumentNamed","","The argument has a name.",4,null],[4,"Alignment","","Enum of alignments which are supported.",null,null],[13,"AlignLeft","","The value will be aligned to the left.",5,null],[13,"AlignRight","","The value will be aligned to the right.",5,null],[13,"AlignCenter","","The value will be aligned in the center.",5,null],[13,"AlignUnknown","","The value will take on a default alignment.",5,null],[4,"Flag","","Various flags which can be applied to format strings. The meaning of these flags is defined by the formatters themselves.",null,null],[13,"FlagSignPlus","","A `+` will be used to denote positive numbers.",6,null],[13,"FlagSignMinus","","A `-` will be used to denote negative numbers. This is the default.",6,null],[13,"FlagAlternate","","An alternate form will be used for the value. In the case of numbers, this means that the number will be prefixed with the supplied string.",6,null],[13,"FlagSignAwareZeroPad","","For numbers, this means that the number will be padded with zeroes, and the sign (`+` or `-`) will precede them.",6,null],[13,"FlagDebugLowerHex","","For Debug / `?`, format integers in lower-case hexadecimal.",6,null],[13,"FlagDebugUpperHex","","For Debug / `?`, format integers in upper-case hexadecimal.",6,null],[4,"Count","","A count is used for the precision and width parameters of an integer, and can reference either an argument or a literal integer.",null,null],[13,"CountIs","","The count is specified explicitly.",7,null],[13,"CountIsName","","The count is specified by the argument with the given name.",7,null],[13,"CountIsParam","","The count is specified by the argument at the given index.",7,null],[13,"CountImplied","","The count is implied and cannot be explicitly specified.",7,null],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"piece"}}],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"piece"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"piece"}],"output":{"name":"bool"}}],[11,"clone","","",0,{"inputs":[{"name":"self"}],"output":{"name":"argument"}}],[11,"eq","","",0,{"inputs":[{"name":"self"},{"name":"argument"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"self"},{"name":"argument"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"self"}],"output":{"name":"formatspec"}}],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"formatspec"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"self"},{"name":"formatspec"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"position"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"position"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"self"},{"name":"position"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"alignment"}}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"flag"}}],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"flag"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"count"}}],[11,"eq","","",7,{"inputs":[{"name":"self"},{"name":"count"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"self"},{"name":"count"}],"output":{"name":"bool"}}],[11,"next","","",2,{"inputs":[{"name":"self"}],"output":{"generics":["piece"],"name":"option"}}],[11,"new","","Creates a new parser for the given format string",2,{"inputs":[{"name":"str"}],"output":{"name":"parser"}}],[11,"err","","Notifies of an error. The message doesn't actually need to be of type String, but I think it does when this eventually uses conditions so it might as well start using it now.",2,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"err_with_note","","Notifies of an error. The message doesn't actually need to be of type String, but I think it does when this eventually uses conditions so it might as well start using it now.",2,{"inputs":[{"name":"self"},{"name":"str"},{"name":"str"}],"output":null}],[11,"consume","","Optionally consumes the specified character. If the character is not at the current position, then the current iterator isn't moved and false is returned, otherwise the character is consumed and true is returned.",2,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"bool"}}],[11,"must_consume","","Forces consumption of the specified character. If the character is not found, an error is emitted.",2,{"inputs":[{"name":"self"},{"name":"char"}],"output":null}],[11,"ws","","Consumes all whitespace characters until the first non-whitespace character",2,{"inputs":[{"name":"self"}],"output":null}],[11,"string","","Parses all of a string which is to be considered a \"raw literal\" in a format string. This is everything outside of the braces.",2,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"str"}}],[11,"argument","","Parses an Argument structure, or what's contained within braces inside the format string",2,{"inputs":[{"name":"self"}],"output":{"name":"argument"}}],[11,"position","","Parses a positional argument for a format. This could either be an integer index of an argument, a named argument, or a blank string. Returns `Some(parsed_position)` if the position is not implicitly consuming a macro argument, `None` if it's the case.",2,{"inputs":[{"name":"self"}],"output":{"generics":["position"],"name":"option"}}],[11,"format","","Parses a format specifier at the current position, returning all of the relevant information in the FormatSpec struct.",2,{"inputs":[{"name":"self"}],"output":{"name":"formatspec"}}],[11,"count","","Parses a Count parameter at the current position. This does not check for 'CountIsNextParam' because that is only used in precision, not width.",2,{"inputs":[{"name":"self"}],"output":{"name":"count"}}],[11,"word","","Parses a word starting at the current position. A word is considered to be an alphabetic character followed by any number of alphanumeric characters.",2,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"integer","","Optionally parses an integer at the current position. This doesn't deal with overflow at all, it's just accumulating digits.",2,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"option"}}]],"paths":[[3,"Argument"],[3,"FormatSpec"],[3,"Parser"],[4,"Piece"],[4,"Position"],[4,"Alignment"],[4,"Flag"],[4,"Count"]]};
searchIndex["graphviz"] = {"doc":"Generate files suitable for use with Graphviz","items":[[3,"Id","graphviz","`Id` is a Graphviz `ID`.",null,null],[12,"name","","",0,null],[4,"LabelText","","The text for a graphviz label on a node or edge.",null,null],[13,"LabelStr","","This kind of label preserves the text directly as is.",1,null],[13,"EscStr","","This kind of label uses the graphviz label escString type: http://www.graphviz.org/content/attrs#kescString",1,null],[13,"HtmlStr","","This uses a graphviz [HTML string label][html]. The string is printed exactly as given, but between `<` and `>`. No escaping is performed.",1,null],[4,"Style","","The style for a node or edge. See http://www.graphviz.org/doc/info/attrs.html#k:style for descriptions. Note that some of these are not valid for edges.",null,null],[13,"None","","",2,null],[13,"Solid","","",2,null],[13,"Dashed","","",2,null],[13,"Dotted","","",2,null],[13,"Bold","","",2,null],[13,"Rounded","","",2,null],[13,"Diagonals","","",2,null],[13,"Filled","","",2,null],[13,"Striped","","",2,null],[13,"Wedged","","",2,null],[4,"RenderOption","","",null,null],[13,"NoEdgeLabels","","",3,null],[13,"NoNodeLabels","","",3,null],[13,"NoEdgeStyles","","",3,null],[13,"NoNodeStyles","","",3,null],[5,"escape_html","","Escape tags in such a way that it is suitable for inclusion in a Graphviz HTML label.",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"default_options","","Returns vec holding all the default render options.",null,{"inputs":[],"output":{"generics":["renderoption"],"name":"vec"}}],[5,"render","","Renders directed graph `g` into the writer `w` in DOT syntax. (Simple wrapper around `render_opts` that passes a default set of options.)",null,{"inputs":[{"name":"g"},{"name":"w"}],"output":{"name":"result"}}],[5,"render_opts","","Renders directed graph `g` into the writer `w` in DOT syntax. (Main entry point for the library.)",null,null],[6,"Nodes","","",null,null],[6,"Edges","","",null,null],[8,"Labeller","","Each instance of a type that implements `Label<C>` maps to a unique identifier with respect to `C`, which is used to identify it in the generated .dot file. They can also provide more elaborate (and non-unique) label text that is used in the graphviz rendered output. The graph instance is responsible for providing the DOT compatible identifiers for the nodes and (optionally) rendered labels for the nodes and edges, as well as an identifier for the graph itself.",null,null],[16,"Node","","",4,null],[16,"Edge","","",4,null],[10,"graph_id","","Must return a DOT compatible identifier naming the graph.",4,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[10,"node_id","","Maps `n` to a unique identifier with respect to `self`. The implementor is responsible for ensuring that the returned name is a valid DOT identifier.",4,null],[11,"node_shape","","Maps `n` to one of the [graphviz `shape` names][1]. If `None` is returned, no `shape` attribute is specified.",4,null],[11,"node_label","","Maps `n` to a label that will be used in the rendered output. The label need not be unique, and may be the empty string; the default is just the output from `node_id`.",4,null],[11,"edge_label","","Maps `e` to a label that will be used in the rendered output. The label need not be unique, and may be the empty string; the default is in fact the empty string.",4,null],[11,"node_style","","Maps `n` to a style that will be used in the rendered output.",4,null],[11,"edge_style","","Maps `e` to a style that will be used in the rendered output.",4,null],[8,"GraphWalk","","GraphWalk is an abstraction over a directed graph = (nodes,edges) made up of node handles `N` and edge handles `E`, where each `E` can be mapped to its source and target nodes.",null,null],[16,"Node","","",5,null],[16,"Edge","","",5,null],[10,"nodes","","Returns all the nodes in this graph.",5,{"inputs":[{"name":"self"}],"output":{"name":"nodes"}}],[10,"edges","","Returns all of the edges in this graph.",5,{"inputs":[{"name":"self"}],"output":{"name":"edges"}}],[10,"source","","The source node for `edge`.",5,null],[10,"target","","The target node for `edge`.",5,null],[8,"IntoCow","","",null,null],[10,"into_cow","","",6,{"inputs":[{"name":"self"}],"output":{"name":"cow"}}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"style"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"style"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",2,null],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_slice","","",2,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"new","","Creates an `Id` named `name`.",0,{"inputs":[{"name":"name"}],"output":{"generics":["id"],"name":"result"}}],[11,"as_slice","","",0,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"name","","",0,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"label","","",1,{"inputs":[{"name":"s"}],"output":{"name":"labeltext"}}],[11,"escaped","","",1,{"inputs":[{"name":"s"}],"output":{"name":"labeltext"}}],[11,"html","","",1,{"inputs":[{"name":"s"}],"output":{"name":"labeltext"}}],[11,"escape_char","","",1,{"inputs":[{"name":"char"},{"name":"f"}],"output":null}],[11,"escape_str","","",1,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"to_dot_string","","Renders text as string suitable for a label in a .dot file. This includes quotes or suitable delimiters.",1,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"pre_escaped_content","","Decomposes content into string suitable for making EscStr that yields same content as self.  The result obeys the law render(`lt`) == render(`EscStr(lt.pre_escaped_content())`) for all `lt: LabelText`.",1,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"prefix_line","","Puts `prefix` on a line above this label, with a blank line separator.",1,{"inputs":[{"name":"self"},{"name":"labeltext"}],"output":{"name":"labeltext"}}],[11,"suffix_line","","Puts `suffix` on a line below this label, with a blank line separator.",1,{"inputs":[{"name":"self"},{"name":"labeltext"}],"output":{"name":"labeltext"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"renderoption"}}],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"renderoption"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}]],"paths":[[3,"Id"],[4,"LabelText"],[4,"Style"],[4,"RenderOption"],[8,"Labeller"],[8,"GraphWalk"],[8,"IntoCow"]]};
searchIndex["proc_macro"] = {"doc":"A support library for macro authors when defining new macros.","items":[[3,"Diagnostic","proc_macro","A structure representing a diagnostic message and associated children messages.",null,null],[12,"level","","",0,null],[12,"message","","",0,null],[12,"span","","",0,null],[12,"children","","",0,null],[3,"TokenStream","","The main type provided by this crate, representing an abstract stream of tokens.",null,null],[12,"0","","",1,null],[3,"LexError","","Error returned from `TokenStream::from_str`.",null,null],[12,"_inner","","",2,null],[3,"Span","","A region of source code, along with macro expansion information.",null,null],[12,"0","","",3,null],[3,"LineColumn","","A line-column pair representing the start or end of a `Span`.",null,null],[12,"line","","The 1-indexed line in the source file on which the span starts or ends (inclusive).",4,null],[12,"column","","The 0-indexed column (in UTF-8 characters) in the source file on which the span starts or ends (inclusive).",4,null],[3,"SourceFile","","The source file of a given `Span`.",null,null],[12,"filemap","","",5,null],[3,"Group","","A delimited token stream",null,null],[12,"delimiter","","",6,null],[12,"stream","","",6,null],[12,"span","","",6,null],[3,"Op","","An `Op` is an operator like `+` or `-`, and only represents one character.",null,null],[12,"op","","",7,null],[12,"spacing","","",7,null],[12,"span","","",7,null],[3,"Term","","An interned string.",null,null],[12,"sym","","",8,null],[12,"span","","",8,null],[3,"Literal","","A literal character (`'a'`), string (`\"hello\"`), a number (`2.3`), etc.",null,null],[12,"lit","","",9,null],[12,"suffix","","",9,null],[12,"span","","",9,null],[4,"Level","","An enum representing a diagnostic level.",null,null],[13,"Error","","An error.",10,null],[13,"Warning","","A warning.",10,null],[13,"Note","","A note.",10,null],[13,"Help","","A help message.",10,null],[13,"__Nonexhaustive","","",10,null],[4,"TokenTree","","A single token or a delimited sequence of token trees (e.g. `[1, (), ..]`).",null,null],[13,"Group","","A delimited tokenstream",11,null],[13,"Term","","A unicode identifier",11,null],[13,"Op","","A punctuation character (`+`, `,`, `$`, etc.).",11,null],[13,"Literal","","A literal character (`'a'`), string (`\"hello\"`), number (`2.3`), etc.",11,null],[4,"Delimiter","","Describes how a sequence of token trees is delimited.",null,null],[13,"Parenthesis","","`( ... )`",12,null],[13,"Brace","","`{ ... }`",12,null],[13,"Bracket","","`[ ... ]`",12,null],[13,"None","","An implicit delimiter, e.g. `$var`, where $var is  `...`.",12,null],[4,"Spacing","","Whether an `Op` is either followed immediately by another `Op` or followed by whitespace.",null,null],[13,"Alone","","e.g. `+` is `Alone` in `+ =`.",13,null],[13,"Joint","","e.g. `+` is `Joint` in `+=`.",13,null],[5,"quote_span","","Quote a `Span` into a `TokenStream`. This is needed to implement a custom quoter.",null,{"inputs":[{"name":"span"}],"output":{"name":"tokenstream"}}],[5,"parse_to_lex_err","","",null,{"inputs":[{"name":"diagnosticbuilder"}],"output":{"name":"lexerror"}}],[0,"diagnostic","","",null,null],[3,"Diagnostic","proc_macro::diagnostic","A structure representing a diagnostic message and associated children messages.",null,null],[12,"level","","",0,null],[12,"message","","",0,null],[12,"span","","",0,null],[12,"children","","",0,null],[4,"Level","","An enum representing a diagnostic level.",null,null],[13,"Error","","An error.",10,null],[13,"Warning","","A warning.",10,null],[13,"Note","","A note.",10,null],[13,"Help","","A help message.",10,null],[13,"__Nonexhaustive","","",10,null],[0,"__internal","","",null,null],[5,"level_to_internal_level","proc_macro::diagnostic::__internal","",null,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"clone","proc_macro","",10,{"inputs":[{"name":"self"}],"output":{"name":"level"}}],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"self"}],"output":{"name":"diagnostic"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Create a new diagnostic with the given `level` and `message`.",0,{"inputs":[{"name":"level"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"spanned","","Create a new diagnostic with the given `level` and `message` pointing to the given `span`.",0,{"inputs":[{"name":"span"},{"name":"level"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"span_error","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"error","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"span_warning","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"warning","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"span_note","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"note","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"span_help","","Add a new child diagnostic message to `self` with the level identified by this methods name with the given `span` and `message`.",0,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"help","","Add a new child diagnostic message to `self` with the level identified by this method's name with the given `message`.",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"level","","Returns the diagnostic `level` for `self`.",0,{"inputs":[{"name":"self"}],"output":{"name":"level"}}],[11,"emit","","Emit the diagnostic.",0,{"inputs":[{"name":"self"}],"output":null}],[0,"token_stream","","Implementation details for the `TokenTree` type, such as iterators.",null,null],[3,"IntoIter","proc_macro::token_stream","An iterator over `TokenTree`s.",null,null],[12,"cursor","","",14,null],[12,"stack","","",14,null],[11,"clone","","",14,{"inputs":[{"name":"self"}],"output":{"name":"intoiter"}}],[11,"next","","",14,{"inputs":[{"name":"self"}],"output":{"generics":["tokentree"],"name":"option"}}],[11,"into_iter","proc_macro","",1,{"inputs":[{"name":"self"}],"output":{"name":"intoiter"}}],[0,"quote","","Quasiquoter This file contains the implementation internals of the quasiquoter provided by `quote!`. This quasiquoter uses macros 2.0 hygiene to reliably access items from `proc_macro`, to build a `proc_macro::TokenStream`.",null,null],[3,"Quoter","proc_macro::quote","",null,null],[4,"LiteralKind","","",null,null],[13,"Byte","","",15,null],[13,"Char","","",15,null],[13,"Float","","",15,null],[13,"Str_","","",15,null],[13,"Integer","","",15,null],[13,"ByteStr","","",15,null],[13,"StrRaw","","",15,null],[13,"ByteStrRaw","","",15,null],[5,"unquote","","",null,{"inputs":[{"name":"t"}],"output":{"name":"tokenstream"}}],[8,"Quote","","",null,null],[10,"quote","","",16,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"expand","","",17,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[11,"quote","proc_macro","",1,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",11,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",6,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",7,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",8,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",3,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"with_contents_and_suffix","proc_macro::quote","",15,{"inputs":[{"name":"self"},{"name":"term"},{"generics":["term"],"name":"option"}],"output":{"name":"literal"}}],[11,"kind_contents_and_suffix","proc_macro","",9,null],[11,"quote","proc_macro::quote","",15,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","proc_macro","",9,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",12,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"quote","","",13,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[0,"__internal","","Permanently unstable internal implementation details of this crate. This should not be used.",null,null],[3,"Quoter","proc_macro::__internal","",null,null],[4,"LiteralKind","","",null,null],[13,"Byte","","",15,null],[13,"Char","","",15,null],[13,"Float","","",15,null],[13,"Str_","","",15,null],[13,"Integer","","",15,null],[13,"ByteStr","","",15,null],[13,"StrRaw","","",15,null],[13,"ByteStrRaw","","",15,null],[5,"unquote","","",null,{"inputs":[{"name":"t"}],"output":{"name":"tokenstream"}}],[5,"lookup_char_pos","","",null,{"inputs":[{"name":"bytepos"}],"output":{"name":"loc"}}],[5,"new_token_stream","","",null,{"inputs":[{"generics":["item"],"name":"p"}],"output":{"name":"tokenstream"}}],[5,"token_stream_wrap","","",null,{"inputs":[{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[5,"token_stream_parse_items","","",null,{"inputs":[{"name":"tokenstream"}],"output":{"generics":["vec","lexerror"],"name":"result"}}],[5,"token_stream_inner","","",null,{"inputs":[{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[5,"set_sess","","",null,{"inputs":[{"name":"extctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"in_sess","","",null,{"inputs":[],"output":{"name":"bool"}}],[5,"with_sess","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[17,"CURRENT_SESS","","",null,null],[8,"Registry","","",null,null],[10,"register_custom_derive","","",18,null],[10,"register_attr_proc_macro","","",18,null],[10,"register_bang_proc_macro","","",18,null],[11,"clone","proc_macro","",1,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty `TokenStream`.",1,{"inputs":[],"output":{"name":"tokenstream"}}],[11,"is_empty","","Checks if this `TokenStream` is empty.",1,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"from_str","","",1,{"inputs":[{"name":"str"}],"output":{"generics":["tokenstream","lexerror"],"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",1,{"inputs":[{"name":"tokentree"}],"output":{"name":"tokenstream"}}],[11,"from_iter","","",1,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"from_iter","","",1,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"def_site","","A span that resolves at the macro definition site.",3,{"inputs":[],"output":{"name":"span"}}],[11,"call_site","","The span of the invocation of the current procedural macro.",3,{"inputs":[],"output":{"name":"span"}}],[11,"source_file","","The original source file into which this span points.",3,{"inputs":[{"name":"self"}],"output":{"name":"sourcefile"}}],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated from, if any.",3,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"option"}}],[11,"source","","The span for the origin source code that `self` was generated from. If this `Span` wasn't generated from other macro expansions then the return value is the same as `*self`.",3,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"start","","Get the starting line/column in the source file for this span.",3,{"inputs":[{"name":"self"}],"output":{"name":"linecolumn"}}],[11,"end","","Get the ending line/column in the source file for this span.",3,{"inputs":[{"name":"self"}],"output":{"name":"linecolumn"}}],[11,"join","","Create a new span encompassing `self` and `other`.",3,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"resolved_at","","Creates a new span with the same line/column information as `self` but that resolves symbols as though it were at `other`.",3,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"located_at","","Creates a new span with the same name resolution behavior as `self` but with the line/column information of `other`.",3,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"eq","","Compares to spans to see if they're equal.",3,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"error","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"warning","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"note","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"help","","Create a new `Diagnostic` with the given `message` at the span `self`.",3,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"diagnostic"}}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"linecolumn"}}],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"linecolumn"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"self"},{"name":"linecolumn"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",4,null],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"sourcefile"}}],[11,"path","","Get the path to this source file.",5,{"inputs":[{"name":"self"}],"output":{"name":"filename"}}],[11,"is_real","","Returns `true` if this source file is a real source file, and not generated by an external macro's expansion.",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_ref","","",5,{"inputs":[{"name":"self"}],"output":{"name":"filename"}}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"self"}],"output":{"name":"tokentree"}}],[11,"span","","Returns the span of this token, accessing the `span` method of each of the internal tokens.",11,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"set_span","","Configures the span for only this token.",11,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",11,{"inputs":[{"name":"group"}],"output":{"name":"tokentree"}}],[11,"from","","",11,{"inputs":[{"name":"term"}],"output":{"name":"tokentree"}}],[11,"from","","",11,{"inputs":[{"name":"op"}],"output":{"name":"tokentree"}}],[11,"from","","",11,{"inputs":[{"name":"literal"}],"output":{"name":"tokentree"}}],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"group"}}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",12,{"inputs":[{"name":"self"}],"output":{"name":"delimiter"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"self"},{"name":"delimiter"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",12,null],[11,"new","","Creates a new `group` with the given delimiter and token stream.",6,{"inputs":[{"name":"delimiter"},{"name":"tokenstream"}],"output":{"name":"group"}}],[11,"delimiter","","Returns the delimiter of this `Group`",6,{"inputs":[{"name":"self"}],"output":{"name":"delimiter"}}],[11,"stream","","Returns the `TokenStream` of tokens that are delimited in this `Group`.",6,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"span","","Returns the span for the delimiters of this token stream, spanning the entire `Group`.",6,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"set_span","","Configures the span for this `Group`'s delimiters, but not its internal tokens.",6,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"op"}}],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"spacing"}}],[11,"fmt","","",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"self"},{"name":"spacing"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",13,null],[11,"new","","Creates a new `Op` from the given character and spacing.",7,{"inputs":[{"name":"char"},{"name":"spacing"}],"output":{"name":"op"}}],[11,"op","","Returns the character this operation represents, for example `'+'`",7,{"inputs":[{"name":"self"}],"output":{"name":"char"}}],[11,"spacing","","Returns the spacing of this operator, indicating whether it's a joint operator with more operators coming next in the token stream or an `Alone` meaning that the operator has ended.",7,{"inputs":[{"name":"self"}],"output":{"name":"spacing"}}],[11,"span","","Returns the span for this operator character",7,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"set_span","","Configure the span for this operator's character",7,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",8,{"inputs":[{"name":"self"}],"output":{"name":"term"}}],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new `Term` with the given `string` as well as the specified `span`.",8,{"inputs":[{"name":"str"},{"name":"span"}],"output":{"name":"term"}}],[11,"as_str","","Get a reference to the interned string.",8,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"span","","Returns the span of this `Term`, encompassing the entire string returned by `as_str`.",8,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"set_span","","Configures the span of this `Term`, possibly changing hygiene information.",8,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"literal"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"u8_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"u8"}],"output":{"name":"literal"}}],[11,"u16_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"u16"}],"output":{"name":"literal"}}],[11,"u32_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"u32"}],"output":{"name":"literal"}}],[11,"u64_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"u64"}],"output":{"name":"literal"}}],[11,"u128_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"u128"}],"output":{"name":"literal"}}],[11,"usize_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"usize"}],"output":{"name":"literal"}}],[11,"i8_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"i8"}],"output":{"name":"literal"}}],[11,"i16_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"i16"}],"output":{"name":"literal"}}],[11,"i32_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"i32"}],"output":{"name":"literal"}}],[11,"i64_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"i64"}],"output":{"name":"literal"}}],[11,"i128_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"i128"}],"output":{"name":"literal"}}],[11,"isize_suffixed","","Creates a new suffixed integer literal with the specified value.",9,{"inputs":[{"name":"isize"}],"output":{"name":"literal"}}],[11,"u8_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"u8"}],"output":{"name":"literal"}}],[11,"u16_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"u16"}],"output":{"name":"literal"}}],[11,"u32_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"u32"}],"output":{"name":"literal"}}],[11,"u64_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"u64"}],"output":{"name":"literal"}}],[11,"u128_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"u128"}],"output":{"name":"literal"}}],[11,"usize_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"usize"}],"output":{"name":"literal"}}],[11,"i8_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"i8"}],"output":{"name":"literal"}}],[11,"i16_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"i16"}],"output":{"name":"literal"}}],[11,"i32_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"i32"}],"output":{"name":"literal"}}],[11,"i64_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"i64"}],"output":{"name":"literal"}}],[11,"i128_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"i128"}],"output":{"name":"literal"}}],[11,"isize_unsuffixed","","Creates a new unsuffixed integer literal with the specified value.",9,{"inputs":[{"name":"isize"}],"output":{"name":"literal"}}],[11,"f32_unsuffixed","","Creates a new unsuffixed floating-point literal.",9,{"inputs":[{"name":"f32"}],"output":{"name":"literal"}}],[11,"f32_suffixed","","Creates a new suffixed floating-point literal.",9,{"inputs":[{"name":"f32"}],"output":{"name":"literal"}}],[11,"f64_unsuffixed","","Creates a new unsuffixed floating-point literal.",9,{"inputs":[{"name":"f64"}],"output":{"name":"literal"}}],[11,"f64_suffixed","","Creates a new suffixed floating-point literal.",9,{"inputs":[{"name":"f64"}],"output":{"name":"literal"}}],[11,"string","","String literal.",9,{"inputs":[{"name":"str"}],"output":{"name":"literal"}}],[11,"character","","Character literal.",9,{"inputs":[{"name":"char"}],"output":{"name":"literal"}}],[11,"byte_string","","Byte string literal.",9,null],[11,"span","","Returns the span encompassing this literal.",9,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"set_span","","Configures the span associated for this literal.",9,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_internal","","",12,{"inputs":[{"name":"delimtoken"}],"output":{"name":"delimiter"}}],[11,"to_internal","","",12,{"inputs":[{"name":"self"}],"output":{"name":"delimtoken"}}],[11,"from_internal","","",11,{"inputs":[{"name":"tokenstream"},{"name":"vec"}],"output":{"name":"tokentree"}}],[11,"to_internal","","",11,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[14,"quote","","`quote!(..)` accepts arbitrary tokens and expands into a `TokenStream` describing the input. For example, `quote!(a + b)` will produce a expression, that, when evaluated, constructs the `TokenStream` `[Word(\"a\"), Op('+', Alone), Word(\"b\")]`.",null,null]],"paths":[[3,"Diagnostic"],[3,"TokenStream"],[3,"LexError"],[3,"Span"],[3,"LineColumn"],[3,"SourceFile"],[3,"Group"],[3,"Op"],[3,"Term"],[3,"Literal"],[4,"Level"],[4,"TokenTree"],[4,"Delimiter"],[4,"Spacing"],[3,"IntoIter"],[4,"LiteralKind"],[8,"Quote"],[3,"Quoter"],[8,"Registry"]]};
searchIndex["rustc"] = {"doc":"The \"main crate\" of the Rust compiler. This crate contains common type definitions that are used by the other crates in the rustc \"family\". Some prominent examples (note that each of these modules has their own README with further details).","items":[[0,"macros","rustc","",null,null],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0038","rustc::diagnostics","",null,null],[0,"__register_diagnostic_E0072","","",null,null],[0,"__register_diagnostic_E0080","","",null,null],[0,"__register_diagnostic_E0106","","",null,null],[0,"__register_diagnostic_E0119","","",null,null],[0,"__register_diagnostic_E0136","","",null,null],[0,"__register_diagnostic_E0137","","",null,null],[0,"__register_diagnostic_E0138","","",null,null],[0,"__register_diagnostic_E0139","","",null,null],[0,"__register_diagnostic_E0152","","",null,null],[0,"__register_diagnostic_E0214","","",null,null],[0,"__register_diagnostic_E0230","","",null,null],[0,"__register_diagnostic_E0231","","",null,null],[0,"__register_diagnostic_E0232","","",null,null],[0,"__register_diagnostic_E0261","","",null,null],[0,"__register_diagnostic_E0262","","",null,null],[0,"__register_diagnostic_E0263","","",null,null],[0,"__register_diagnostic_E0264","","",null,null],[0,"__register_diagnostic_E0271","","",null,null],[0,"__register_diagnostic_E0275","","",null,null],[0,"__register_diagnostic_E0276","","",null,null],[0,"__register_diagnostic_E0277","","",null,null],[0,"__register_diagnostic_E0281","","",null,null],[0,"__register_diagnostic_E0282","","",null,null],[0,"__register_diagnostic_E0283","","",null,null],[0,"__register_diagnostic_E0296","","",null,null],[0,"__register_diagnostic_E0308","","",null,null],[0,"__register_diagnostic_E0309","","",null,null],[0,"__register_diagnostic_E0310","","",null,null],[0,"__register_diagnostic_E0317","","",null,null],[0,"__register_diagnostic_E0391","","",null,null],[0,"__register_diagnostic_E0398","","",null,null],[0,"__register_diagnostic_E0452","","",null,null],[0,"__register_diagnostic_E0453","","",null,null],[0,"__register_diagnostic_E0478","","",null,null],[0,"__register_diagnostic_E0491","","",null,null],[0,"__register_diagnostic_E0496","","",null,null],[0,"__register_diagnostic_E0497","","",null,null],[0,"__register_diagnostic_E0512","","",null,null],[0,"__register_diagnostic_E0517","","",null,null],[0,"__register_diagnostic_E0518","","",null,null],[0,"__register_diagnostic_E0522","","",null,null],[0,"__register_diagnostic_E0525","","",null,null],[0,"__register_diagnostic_E0580","","",null,null],[0,"__register_diagnostic_E0562","","",null,null],[0,"__register_diagnostic_E0591","","",null,null],[0,"__register_diagnostic_E0593","","",null,null],[0,"__register_diagnostic_E0601","","",null,null],[0,"__register_diagnostic_E0602","","",null,null],[0,"__register_diagnostic_E0621","","",null,null],[0,"__register_diagnostic_E0644","","",null,null],[0,"__register_diagnostic_E0692","","",null,null],[0,"__register_diagnostic_E0909","","",null,null],[0,"__register_diagnostic_E0910","","",null,null],[0,"__register_diagnostic_E0911","","",null,null],[0,"__register_diagnostic_E0278","","",null,null],[0,"__register_diagnostic_E0279","","",null,null],[0,"__register_diagnostic_E0280","","",null,null],[0,"__register_diagnostic_E0284","","",null,null],[0,"__register_diagnostic_E0311","","",null,null],[0,"__register_diagnostic_E0312","","",null,null],[0,"__register_diagnostic_E0313","","",null,null],[0,"__register_diagnostic_E0314","","",null,null],[0,"__register_diagnostic_E0315","","",null,null],[0,"__register_diagnostic_E0316","","",null,null],[0,"__register_diagnostic_E0320","","",null,null],[0,"__register_diagnostic_E0473","","",null,null],[0,"__register_diagnostic_E0474","","",null,null],[0,"__register_diagnostic_E0475","","",null,null],[0,"__register_diagnostic_E0476","","",null,null],[0,"__register_diagnostic_E0477","","",null,null],[0,"__register_diagnostic_E0479","","",null,null],[0,"__register_diagnostic_E0480","","",null,null],[0,"__register_diagnostic_E0481","","",null,null],[0,"__register_diagnostic_E0482","","",null,null],[0,"__register_diagnostic_E0483","","",null,null],[0,"__register_diagnostic_E0484","","",null,null],[0,"__register_diagnostic_E0485","","",null,null],[0,"__register_diagnostic_E0486","","",null,null],[0,"__register_diagnostic_E0487","","",null,null],[0,"__register_diagnostic_E0488","","",null,null],[0,"__register_diagnostic_E0489","","",null,null],[0,"__register_diagnostic_E0490","","",null,null],[0,"__register_diagnostic_E0495","","",null,null],[0,"__register_diagnostic_E0566","","",null,null],[0,"__register_diagnostic_E0623","","",null,null],[0,"__register_diagnostic_E0628","","",null,null],[0,"__register_diagnostic_E0631","","",null,null],[0,"__register_diagnostic_E0637","","",null,null],[0,"__register_diagnostic_E0657","","",null,null],[0,"__register_diagnostic_E0687","","",null,null],[0,"__register_diagnostic_E0688","","",null,null],[0,"__register_diagnostic_E0906","","",null,null],[0,"cfg","rustc","Module that constructs a control-flow graph representing an item. Uses `Graph` as the underlying representation.",null,null],[3,"CFG","rustc::cfg","",null,null],[12,"owner_def_id","","",0,null],[12,"graph","","",0,null],[12,"entry","","",0,null],[12,"exit","","",0,null],[3,"CFGEdgeData","","",null,null],[12,"exiting_scopes","","",1,null],[4,"CFGNodeData","","",null,null],[13,"AST","","",2,null],[13,"Entry","","",2,null],[13,"Exit","","",2,null],[13,"Dummy","","",2,null],[13,"Unreachable","","",2,null],[0,"construct","","",null,null],[3,"CFGBuilder","rustc::cfg::construct","",null,null],[12,"tcx","","",3,null],[12,"owner_def_id","","",3,null],[12,"tables","","",3,null],[12,"graph","","",3,null],[12,"fn_exit","","",3,null],[12,"loop_scopes","","",3,null],[12,"breakable_block_scopes","","",3,null],[3,"BlockScope","","",null,null],[12,"block_expr_id","","",4,null],[12,"break_index","","",4,null],[3,"LoopScope","","",null,null],[12,"loop_id","","",5,null],[12,"continue_index","","",5,null],[12,"break_index","","",5,null],[4,"ScopeCfKind","","",null,null],[13,"Break","","",6,null],[13,"Continue","","",6,null],[5,"construct","","",null,{"inputs":[{"name":"tyctxt"},{"name":"body"}],"output":{"name":"cfg"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"blockscope"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"loopscope"}}],[11,"block","","",3,{"inputs":[{"name":"self"},{"name":"block"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"stmt","","",3,{"inputs":[{"name":"self"},{"name":"stmt"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"decl","","",3,{"inputs":[{"name":"self"},{"name":"decl"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"pat","","",3,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"pats_all","","Handles case where all of the patterns must match.",3,{"inputs":[{"name":"self"},{"name":"i"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"expr","","",3,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"call","","",3,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cfgindex"},{"name":"expr"},{"name":"i"}],"output":{"name":"cfgindex"}}],[11,"exprs","","Constructs graph for `exprs` evaluated in order",3,{"inputs":[{"name":"self"},{"name":"i"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"opt_expr","","Constructs graph for `opt_expr` evaluated, if Some",3,{"inputs":[{"name":"self"},{"name":"option"},{"name":"cfgindex"}],"output":{"name":"cfgindex"}}],[11,"straightline","","Handles case of an expression that evaluates `subexprs` in order",3,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cfgindex"},{"name":"i"}],"output":{"name":"cfgindex"}}],[11,"match_","","",3,null],[11,"add_dummy_node","","",3,null],[11,"add_ast_node","","",3,null],[11,"add_unreachable_node","","",3,{"inputs":[{"name":"self"}],"output":{"name":"cfgindex"}}],[11,"add_node","","",3,null],[11,"add_contained_edge","","",3,{"inputs":[{"name":"self"},{"name":"cfgindex"},{"name":"cfgindex"}],"output":null}],[11,"add_exiting_edge","","",3,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cfgindex"},{"name":"scope"},{"name":"cfgindex"}],"output":null}],[11,"add_returning_edge","","",3,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cfgindex"}],"output":null}],[11,"find_scope_edge","","",3,null],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"scopecfkind"}}],[11,"assert_receiver_is_total_eq","","",6,null],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"scopecfkind"}],"output":{"name":"bool"}}],[0,"graphviz","rustc::cfg","",null,null],[3,"LabelledCFG","rustc::cfg::graphviz","",null,null],[12,"tcx","","",7,null],[12,"cfg","","",7,null],[12,"name","","",7,null],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",7,null],[6,"Node","","",null,null],[6,"Edge","","",null,null],[11,"local_id_to_string","","",7,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"string"}}],[11,"graph_id","","",7,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"node_id","","",7,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",7,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",7,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",7,{"inputs":[{"name":"self"}],"output":{"generics":["node"],"name":"nodes"}}],[11,"edges","","",7,{"inputs":[{"name":"self"}],"output":{"generics":["edge"],"name":"edges"}}],[11,"source","","",7,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",7,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"node"}}],[6,"CFGIndex","rustc::cfg","",null,null],[6,"CFGGraph","","",null,null],[6,"CFGNode","","",null,null],[6,"CFGEdge","","",null,null],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"cfgnodedata"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"id","","",2,{"inputs":[{"name":"self"}],"output":{"name":"itemlocalid"}}],[11,"fmt","","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",0,{"inputs":[{"name":"tyctxt"},{"name":"body"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",0,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[0,"dep_graph","rustc","",null,null],[3,"DepTrackingMap","rustc::dep_graph","A DepTrackingMap offers a subset of the `Map` API and ensures that we make calls to `read` and `write` as appropriate. We key the maps with a unique type for brevity.",null,null],[12,"phantom","","",8,null],[12,"graph","","",8,null],[12,"map","","",8,null],[3,"DepNode","","",null,null],[12,"kind","","",9,null],[12,"hash","","",9,null],[3,"WorkProductId","","A \"work product\" corresponds to a `.o` (or other) file that we save in between runs. These ids do not have a DefId but rather some independent path or string that persists between runs without the need to be mapped or unmapped. (This ensures we can serialize them even in the absence of a tcx.)",null,null],[12,"hash","","",10,null],[3,"DepGraph","","",null,null],[12,"data","","",11,null],[12,"fingerprints","","",11,null],[3,"WorkProduct","","A \"work product\" is an intermediate result that we save into the incremental directory for later re-use. The primary example are the object files that we save for each partition at code generation time.",null,null],[12,"cgu_name","","",12,null],[12,"saved_files","","Saved files associated with this CGU",12,null],[3,"DepNodeIndex","","",null,null],[12,"0","","",13,null],[3,"PreviousDepGraph","","",null,null],[12,"data","","",14,null],[12,"index","","",14,null],[3,"DepGraphQuery","","",null,null],[12,"graph","","",15,null],[12,"indices","","",15,null],[3,"AssertDepGraphSafe","","A convenient override that lets you pass arbitrary state into a task. Every use should be accompanied by a comment explaining why it makes sense (or how it could be refactored away in the future).",null,null],[12,"0","","",16,null],[3,"SerializedDepGraph","","Data for use when recompiling the current crate.",null,null],[12,"nodes","","The set of all DepNodes in the graph",17,null],[12,"fingerprints","","The set of all Fingerprints in the graph. Each Fingerprint corresponds to the DepNode at the same index in the nodes vector.",17,null],[12,"edge_list_indices","","For each DepNode, stores the list of edges originating from that DepNode. Encoded as a [start, end) pair indexing into edge_list_data, which holds the actual DepNodeIndices of the target nodes.",17,null],[12,"edge_list_data","","A flattened list of all edge targets in the graph. Edge sources are implicit in edge_list_indices.",17,null],[3,"SerializedDepNodeIndex","","",null,null],[12,"0","","",18,null],[4,"DepKind","","",null,null],[13,"Null","","",19,null],[13,"Krate","","",19,null],[13,"HirBody","","",19,null],[13,"Hir","","",19,null],[13,"CrateMetadata","","",19,null],[13,"RegionScopeTree","","",19,null],[13,"Coherence","","",19,null],[13,"CoherenceInherentImplOverlapCheck","","",19,null],[13,"CoherenceCheckTrait","","",19,null],[13,"PrivacyAccessLevels","","",19,null],[13,"MirConstQualif","","",19,null],[13,"MirBuilt","","",19,null],[13,"MirConst","","",19,null],[13,"MirValidated","","",19,null],[13,"MirOptimized","","",19,null],[13,"MirShim","","",19,null],[13,"BorrowCheckKrate","","",19,null],[13,"BorrowCheck","","",19,null],[13,"MirBorrowCheck","","",19,null],[13,"UnsafetyCheckResult","","",19,null],[13,"UnsafeDeriveOnReprPacked","","",19,null],[13,"Reachability","","",19,null],[13,"MirKeys","","",19,null],[13,"CrateVariances","","",19,null],[13,"AssociatedItems","","",19,null],[13,"TypeOfItem","","",19,null],[13,"GenericsOfItem","","",19,null],[13,"PredicatesOfItem","","",19,null],[13,"InferredOutlivesOf","","",19,null],[13,"InferredOutlivesCrate","","",19,null],[13,"SuperPredicatesOfItem","","",19,null],[13,"TraitDefOfItem","","",19,null],[13,"AdtDefOfItem","","",19,null],[13,"ImplTraitRef","","",19,null],[13,"ImplPolarity","","",19,null],[13,"FnSignature","","",19,null],[13,"CoerceUnsizedInfo","","",19,null],[13,"ItemVarianceConstraints","","",19,null],[13,"ItemVariances","","",19,null],[13,"IsConstFn","","",19,null],[13,"IsForeignItem","","",19,null],[13,"TypeParamPredicates","","",19,null],[13,"SizedConstraint","","",19,null],[13,"DtorckConstraint","","",19,null],[13,"AdtDestructor","","",19,null],[13,"AssociatedItemDefIds","","",19,null],[13,"InherentImpls","","",19,null],[13,"TypeckBodiesKrate","","",19,null],[13,"TypeckTables","","",19,null],[13,"UsedTraitImports","","",19,null],[13,"HasTypeckTables","","",19,null],[13,"ConstEval","","",19,null],[13,"CheckMatch","","",19,null],[13,"SymbolName","","",19,null],[13,"InstanceSymbolName","","",19,null],[13,"SpecializationGraph","","",19,null],[13,"ObjectSafety","","",19,null],[13,"FulfillObligation","","",19,null],[13,"VtableMethods","","",19,null],[13,"IsCopy","","",19,null],[13,"IsSized","","",19,null],[13,"IsFreeze","","",19,null],[13,"NeedsDrop","","",19,null],[13,"Layout","","",19,null],[13,"TraitImpls","","",19,null],[13,"AllLocalTraitImpls","","",19,null],[13,"TraitSelect","","",19,null],[13,"ParamEnv","","",19,null],[13,"DescribeDef","","",19,null],[13,"DefSpan","","",19,null],[13,"LookupStability","","",19,null],[13,"LookupDeprecationEntry","","",19,null],[13,"ConstIsRvaluePromotableToStatic","","",19,null],[13,"RvaluePromotableMap","","",19,null],[13,"ImplParent","","",19,null],[13,"TraitOfItem","","",19,null],[13,"IsReachableNonGeneric","","",19,null],[13,"IsUnreachableLocalDefinition","","",19,null],[13,"IsMirAvailable","","",19,null],[13,"ItemAttrs","","",19,null],[13,"TransFnAttrs","","",19,null],[13,"FnArgNames","","",19,null],[13,"RenderedConst","","",19,null],[13,"DylibDepFormats","","",19,null],[13,"IsPanicRuntime","","",19,null],[13,"IsCompilerBuiltins","","",19,null],[13,"HasGlobalAllocator","","",19,null],[13,"ExternCrate","","",19,null],[13,"LintLevels","","",19,null],[13,"Specializes","","",19,null],[13,"InScopeTraits","","",19,null],[13,"ModuleExports","","",19,null],[13,"IsSanitizerRuntime","","",19,null],[13,"IsProfilerRuntime","","",19,null],[13,"GetPanicStrategy","","",19,null],[13,"IsNoBuiltins","","",19,null],[13,"ImplDefaultness","","",19,null],[13,"CheckItemWellFormed","","",19,null],[13,"CheckTraitItemWellFormed","","",19,null],[13,"CheckImplItemWellFormed","","",19,null],[13,"ReachableNonGenerics","","",19,null],[13,"NativeLibraries","","",19,null],[13,"PluginRegistrarFn","","",19,null],[13,"DeriveRegistrarFn","","",19,null],[13,"CrateDisambiguator","","",19,null],[13,"CrateHash","","",19,null],[13,"OriginalCrateName","","",19,null],[13,"ExtraFileName","","",19,null],[13,"ImplementationsOfTrait","","",19,null],[13,"AllTraitImplementations","","",19,null],[13,"DllimportForeignItems","","",19,null],[13,"IsDllimportForeignItem","","",19,null],[13,"IsStaticallyIncludedForeignItem","","",19,null],[13,"NativeLibraryKind","","",19,null],[13,"LinkArgs","","",19,null],[13,"ResolveLifetimes","","",19,null],[13,"NamedRegion","","",19,null],[13,"IsLateBound","","",19,null],[13,"ObjectLifetimeDefaults","","",19,null],[13,"Visibility","","",19,null],[13,"DepKind","","",19,null],[13,"CrateName","","",19,null],[13,"ItemChildren","","",19,null],[13,"ExternModStmtCnum","","",19,null],[13,"GetLangItems","","",19,null],[13,"DefinedLangItems","","",19,null],[13,"MissingLangItems","","",19,null],[13,"VisibleParentMap","","",19,null],[13,"MissingExternCrateItem","","",19,null],[13,"UsedCrateSource","","",19,null],[13,"PostorderCnums","","",19,null],[13,"EraseRegionsTy","","",19,null],[13,"Freevars","","",19,null],[13,"MaybeUnusedTraitImport","","",19,null],[13,"MaybeUnusedExternCrates","","",19,null],[13,"StabilityIndex","","",19,null],[13,"AllTraits","","",19,null],[13,"AllCrateNums","","",19,null],[13,"ExportedSymbols","","",19,null],[13,"CollectAndPartitionTranslationItems","","",19,null],[13,"IsTranslatedItem","","",19,null],[13,"CodegenUnit","","",19,null],[13,"CompileCodegenUnit","","",19,null],[13,"OutputFilenames","","",19,null],[13,"NormalizeProjectionTy","","",19,null],[13,"NormalizeTyAfterErasingRegions","","",19,null],[13,"DropckOutlives","","",19,null],[13,"EvaluateObligation","","",19,null],[13,"SubstituteNormalizeAndTestPredicates","","",19,null],[13,"TargetFeaturesWhitelist","","",19,null],[13,"InstanceDefSizeEstimate","","",19,null],[13,"WasmCustomSections","","",19,null],[13,"Features","","",19,null],[13,"ProgramClausesFor","","",19,null],[13,"ProgramClausesForEnv","","",19,null],[13,"WasmImportModuleMap","","",19,null],[13,"ForeignModules","","",19,null],[13,"UpstreamMonomorphizations","","",19,null],[13,"UpstreamMonomorphizationsFor","","",19,null],[4,"DepConstructor","","",null,null],[13,"Null","","",20,null],[13,"Krate","","",20,null],[13,"HirBody","","",20,null],[13,"Hir","","",20,null],[13,"CrateMetadata","","",20,null],[13,"RegionScopeTree","","",20,null],[13,"Coherence","","",20,null],[13,"CoherenceInherentImplOverlapCheck","","",20,null],[13,"CoherenceCheckTrait","","",20,null],[13,"PrivacyAccessLevels","","",20,null],[13,"MirConstQualif","","",20,null],[13,"MirBuilt","","",20,null],[13,"MirConst","","",20,null],[13,"MirValidated","","",20,null],[13,"MirOptimized","","",20,null],[13,"MirShim","","",20,null],[12,"instance_def","rustc::dep_graph::DepConstructor","",20,null],[13,"BorrowCheckKrate","rustc::dep_graph","",20,null],[13,"BorrowCheck","","",20,null],[13,"MirBorrowCheck","","",20,null],[13,"UnsafetyCheckResult","","",20,null],[13,"UnsafeDeriveOnReprPacked","","",20,null],[13,"Reachability","","",20,null],[13,"MirKeys","","",20,null],[13,"CrateVariances","","",20,null],[13,"AssociatedItems","","",20,null],[13,"TypeOfItem","","",20,null],[13,"GenericsOfItem","","",20,null],[13,"PredicatesOfItem","","",20,null],[13,"InferredOutlivesOf","","",20,null],[13,"InferredOutlivesCrate","","",20,null],[13,"SuperPredicatesOfItem","","",20,null],[13,"TraitDefOfItem","","",20,null],[13,"AdtDefOfItem","","",20,null],[13,"ImplTraitRef","","",20,null],[13,"ImplPolarity","","",20,null],[13,"FnSignature","","",20,null],[13,"CoerceUnsizedInfo","","",20,null],[13,"ItemVarianceConstraints","","",20,null],[13,"ItemVariances","","",20,null],[13,"IsConstFn","","",20,null],[13,"IsForeignItem","","",20,null],[13,"TypeParamPredicates","","",20,null],[12,"item_id","rustc::dep_graph::DepConstructor","",20,null],[12,"param_id","","",20,null],[13,"SizedConstraint","rustc::dep_graph","",20,null],[13,"DtorckConstraint","","",20,null],[13,"AdtDestructor","","",20,null],[13,"AssociatedItemDefIds","","",20,null],[13,"InherentImpls","","",20,null],[13,"TypeckBodiesKrate","","",20,null],[13,"TypeckTables","","",20,null],[13,"UsedTraitImports","","",20,null],[13,"HasTypeckTables","","",20,null],[13,"ConstEval","","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[13,"CheckMatch","rustc::dep_graph","",20,null],[13,"SymbolName","","",20,null],[13,"InstanceSymbolName","","",20,null],[12,"instance","rustc::dep_graph::DepConstructor","",20,null],[13,"SpecializationGraph","rustc::dep_graph","",20,null],[13,"ObjectSafety","","",20,null],[13,"FulfillObligation","","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[12,"trait_ref","","",20,null],[13,"VtableMethods","rustc::dep_graph","",20,null],[12,"trait_ref","rustc::dep_graph::DepConstructor","",20,null],[13,"IsCopy","rustc::dep_graph","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[13,"IsSized","rustc::dep_graph","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[13,"IsFreeze","rustc::dep_graph","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[13,"NeedsDrop","rustc::dep_graph","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[13,"Layout","rustc::dep_graph","",20,null],[12,"param_env","rustc::dep_graph::DepConstructor","",20,null],[13,"TraitImpls","rustc::dep_graph","",20,null],[13,"AllLocalTraitImpls","","",20,null],[13,"TraitSelect","","",20,null],[13,"ParamEnv","","",20,null],[13,"DescribeDef","","",20,null],[13,"DefSpan","","",20,null],[13,"LookupStability","","",20,null],[13,"LookupDeprecationEntry","","",20,null],[13,"ConstIsRvaluePromotableToStatic","","",20,null],[13,"RvaluePromotableMap","","",20,null],[13,"ImplParent","","",20,null],[13,"TraitOfItem","","",20,null],[13,"IsReachableNonGeneric","","",20,null],[13,"IsUnreachableLocalDefinition","","",20,null],[13,"IsMirAvailable","","",20,null],[13,"ItemAttrs","","",20,null],[13,"TransFnAttrs","","",20,null],[13,"FnArgNames","","",20,null],[13,"RenderedConst","","",20,null],[13,"DylibDepFormats","","",20,null],[13,"IsPanicRuntime","","",20,null],[13,"IsCompilerBuiltins","","",20,null],[13,"HasGlobalAllocator","","",20,null],[13,"ExternCrate","","",20,null],[13,"LintLevels","","",20,null],[13,"Specializes","","",20,null],[12,"impl1","rustc::dep_graph::DepConstructor","",20,null],[12,"impl2","","",20,null],[13,"InScopeTraits","rustc::dep_graph","",20,null],[13,"ModuleExports","","",20,null],[13,"IsSanitizerRuntime","","",20,null],[13,"IsProfilerRuntime","","",20,null],[13,"GetPanicStrategy","","",20,null],[13,"IsNoBuiltins","","",20,null],[13,"ImplDefaultness","","",20,null],[13,"CheckItemWellFormed","","",20,null],[13,"CheckTraitItemWellFormed","","",20,null],[13,"CheckImplItemWellFormed","","",20,null],[13,"ReachableNonGenerics","","",20,null],[13,"NativeLibraries","","",20,null],[13,"PluginRegistrarFn","","",20,null],[13,"DeriveRegistrarFn","","",20,null],[13,"CrateDisambiguator","","",20,null],[13,"CrateHash","","",20,null],[13,"OriginalCrateName","","",20,null],[13,"ExtraFileName","","",20,null],[13,"ImplementationsOfTrait","","",20,null],[12,"krate","rustc::dep_graph::DepConstructor","",20,null],[12,"trait_id","","",20,null],[13,"AllTraitImplementations","rustc::dep_graph","",20,null],[13,"DllimportForeignItems","","",20,null],[13,"IsDllimportForeignItem","","",20,null],[13,"IsStaticallyIncludedForeignItem","","",20,null],[13,"NativeLibraryKind","","",20,null],[13,"LinkArgs","","",20,null],[13,"ResolveLifetimes","","",20,null],[13,"NamedRegion","","",20,null],[13,"IsLateBound","","",20,null],[13,"ObjectLifetimeDefaults","","",20,null],[13,"Visibility","","",20,null],[13,"DepKind","","",20,null],[13,"CrateName","","",20,null],[13,"ItemChildren","","",20,null],[13,"ExternModStmtCnum","","",20,null],[13,"GetLangItems","","",20,null],[13,"DefinedLangItems","","",20,null],[13,"MissingLangItems","","",20,null],[13,"VisibleParentMap","","",20,null],[13,"MissingExternCrateItem","","",20,null],[13,"UsedCrateSource","","",20,null],[13,"PostorderCnums","","",20,null],[13,"EraseRegionsTy","","",20,null],[12,"ty","rustc::dep_graph::DepConstructor","",20,null],[13,"Freevars","rustc::dep_graph","",20,null],[13,"MaybeUnusedTraitImport","","",20,null],[13,"MaybeUnusedExternCrates","","",20,null],[13,"StabilityIndex","","",20,null],[13,"AllTraits","","",20,null],[13,"AllCrateNums","","",20,null],[13,"ExportedSymbols","","",20,null],[13,"CollectAndPartitionTranslationItems","","",20,null],[13,"IsTranslatedItem","","",20,null],[13,"CodegenUnit","","",20,null],[13,"CompileCodegenUnit","","",20,null],[13,"OutputFilenames","","",20,null],[13,"NormalizeProjectionTy","","",20,null],[13,"NormalizeTyAfterErasingRegions","","",20,null],[13,"DropckOutlives","","",20,null],[13,"EvaluateObligation","","",20,null],[13,"SubstituteNormalizeAndTestPredicates","","",20,null],[12,"key","rustc::dep_graph::DepConstructor","",20,null],[13,"TargetFeaturesWhitelist","rustc::dep_graph","",20,null],[13,"InstanceDefSizeEstimate","","",20,null],[12,"instance_def","rustc::dep_graph::DepConstructor","",20,null],[13,"WasmCustomSections","rustc::dep_graph","",20,null],[13,"Features","","",20,null],[13,"ProgramClausesFor","","",20,null],[13,"ProgramClausesForEnv","","",20,null],[13,"WasmImportModuleMap","","",20,null],[13,"ForeignModules","","",20,null],[13,"UpstreamMonomorphizations","","",20,null],[13,"UpstreamMonomorphizationsFor","","",20,null],[4,"DepNodeColor","","",null,null],[13,"Red","","",21,null],[13,"Green","","",21,null],[4,"OpenTask","","",null,null],[13,"Regular","","",22,null],[13,"Anon","","",22,null],[13,"Ignore","","",22,null],[13,"EvalAlways","","",22,null],[12,"node","rustc::dep_graph::OpenTask","",22,null],[4,"WorkProductFileKind","rustc::dep_graph","",null,null],[13,"Object","","",23,null],[13,"Bytecode","","",23,null],[13,"BytecodeCompressed","","",23,null],[0,"debug","","Code for debugging the dep-graph.",null,null],[3,"DepNodeFilter","rustc::dep_graph::debug","A dep-node filter goes from a user-defined string to a query over nodes. Right now the format is like this:",null,null],[12,"text","","",24,null],[3,"EdgeFilter","","A filter like `F -> G` where `F` and `G` are valid dep-node filters. This can be used to test the source/target independently.",null,null],[12,"source","","",25,null],[12,"target","","",25,null],[11,"fmt","","",24,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",24,{"inputs":[{"name":"str"}],"output":{"name":"self"}}],[11,"accepts_all","","True if all nodes always pass the filter.",24,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"test","","Tests whether `node` meets the filter, returning true if so.",24,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"new","","",25,{"inputs":[{"name":"str"}],"output":{"generics":["edgefilter","box"],"name":"result"}}],[11,"test","","",25,{"inputs":[{"name":"self"},{"name":"depnode"},{"name":"depnode"}],"output":{"name":"bool"}}],[0,"dep_node","rustc::dep_graph","This module defines the `DepNode` type which the compiler uses to represent nodes in the dependency graph. A `DepNode` consists of a `DepKind` (which specifies the kind of thing it represents, like a piece of HIR, MIR, etc) and a `Fingerprint`, a 128 bit hash value the exact meaning of which depends on the node's `DepKind`. Together, the kind and the fingerprint fully identify a dependency node, even across multiple compilation sessions. In other words, the value of the fingerprint does not depend on anything that is specific to a given compilation session, like an unpredictable interning key (e.g. NodeId, DefId, Symbol) or the numeric value of a pointer. The concept behind this could be compared to how git commit hashes uniquely identify a given commit and has a few advantages:",null,null],[3,"DepNode","rustc::dep_graph::dep_node","",null,null],[12,"kind","","",9,null],[12,"hash","","",9,null],[3,"WorkProductId","","A \"work product\" corresponds to a `.o` (or other) file that we save in between runs. These ids do not have a DefId but rather some independent path or string that persists between runs without the need to be mapped or unmapped. (This ensures we can serialize them even in the absence of a tcx.)",null,null],[12,"hash","","",10,null],[4,"DepKind","","",null,null],[13,"Null","","",19,null],[13,"Krate","","",19,null],[13,"HirBody","","",19,null],[13,"Hir","","",19,null],[13,"CrateMetadata","","",19,null],[13,"RegionScopeTree","","",19,null],[13,"Coherence","","",19,null],[13,"CoherenceInherentImplOverlapCheck","","",19,null],[13,"CoherenceCheckTrait","","",19,null],[13,"PrivacyAccessLevels","","",19,null],[13,"MirConstQualif","","",19,null],[13,"MirBuilt","","",19,null],[13,"MirConst","","",19,null],[13,"MirValidated","","",19,null],[13,"MirOptimized","","",19,null],[13,"MirShim","","",19,null],[13,"BorrowCheckKrate","","",19,null],[13,"BorrowCheck","","",19,null],[13,"MirBorrowCheck","","",19,null],[13,"UnsafetyCheckResult","","",19,null],[13,"UnsafeDeriveOnReprPacked","","",19,null],[13,"Reachability","","",19,null],[13,"MirKeys","","",19,null],[13,"CrateVariances","","",19,null],[13,"AssociatedItems","","",19,null],[13,"TypeOfItem","","",19,null],[13,"GenericsOfItem","","",19,null],[13,"PredicatesOfItem","","",19,null],[13,"InferredOutlivesOf","","",19,null],[13,"InferredOutlivesCrate","","",19,null],[13,"SuperPredicatesOfItem","","",19,null],[13,"TraitDefOfItem","","",19,null],[13,"AdtDefOfItem","","",19,null],[13,"ImplTraitRef","","",19,null],[13,"ImplPolarity","","",19,null],[13,"FnSignature","","",19,null],[13,"CoerceUnsizedInfo","","",19,null],[13,"ItemVarianceConstraints","","",19,null],[13,"ItemVariances","","",19,null],[13,"IsConstFn","","",19,null],[13,"IsForeignItem","","",19,null],[13,"TypeParamPredicates","","",19,null],[13,"SizedConstraint","","",19,null],[13,"DtorckConstraint","","",19,null],[13,"AdtDestructor","","",19,null],[13,"AssociatedItemDefIds","","",19,null],[13,"InherentImpls","","",19,null],[13,"TypeckBodiesKrate","","",19,null],[13,"TypeckTables","","",19,null],[13,"UsedTraitImports","","",19,null],[13,"HasTypeckTables","","",19,null],[13,"ConstEval","","",19,null],[13,"CheckMatch","","",19,null],[13,"SymbolName","","",19,null],[13,"InstanceSymbolName","","",19,null],[13,"SpecializationGraph","","",19,null],[13,"ObjectSafety","","",19,null],[13,"FulfillObligation","","",19,null],[13,"VtableMethods","","",19,null],[13,"IsCopy","","",19,null],[13,"IsSized","","",19,null],[13,"IsFreeze","","",19,null],[13,"NeedsDrop","","",19,null],[13,"Layout","","",19,null],[13,"TraitImpls","","",19,null],[13,"AllLocalTraitImpls","","",19,null],[13,"TraitSelect","","",19,null],[13,"ParamEnv","","",19,null],[13,"DescribeDef","","",19,null],[13,"DefSpan","","",19,null],[13,"LookupStability","","",19,null],[13,"LookupDeprecationEntry","","",19,null],[13,"ConstIsRvaluePromotableToStatic","","",19,null],[13,"RvaluePromotableMap","","",19,null],[13,"ImplParent","","",19,null],[13,"TraitOfItem","","",19,null],[13,"IsReachableNonGeneric","","",19,null],[13,"IsUnreachableLocalDefinition","","",19,null],[13,"IsMirAvailable","","",19,null],[13,"ItemAttrs","","",19,null],[13,"TransFnAttrs","","",19,null],[13,"FnArgNames","","",19,null],[13,"RenderedConst","","",19,null],[13,"DylibDepFormats","","",19,null],[13,"IsPanicRuntime","","",19,null],[13,"IsCompilerBuiltins","","",19,null],[13,"HasGlobalAllocator","","",19,null],[13,"ExternCrate","","",19,null],[13,"LintLevels","","",19,null],[13,"Specializes","","",19,null],[13,"InScopeTraits","","",19,null],[13,"ModuleExports","","",19,null],[13,"IsSanitizerRuntime","","",19,null],[13,"IsProfilerRuntime","","",19,null],[13,"GetPanicStrategy","","",19,null],[13,"IsNoBuiltins","","",19,null],[13,"ImplDefaultness","","",19,null],[13,"CheckItemWellFormed","","",19,null],[13,"CheckTraitItemWellFormed","","",19,null],[13,"CheckImplItemWellFormed","","",19,null],[13,"ReachableNonGenerics","","",19,null],[13,"NativeLibraries","","",19,null],[13,"PluginRegistrarFn","","",19,null],[13,"DeriveRegistrarFn","","",19,null],[13,"CrateDisambiguator","","",19,null],[13,"CrateHash","","",19,null],[13,"OriginalCrateName","","",19,null],[13,"ExtraFileName","","",19,null],[13,"ImplementationsOfTrait","","",19,null],[13,"AllTraitImplementations","","",19,null],[13,"DllimportForeignItems","","",19,null],[13,"IsDllimportForeignItem","","",19,null],[13,"IsStaticallyIncludedForeignItem","","",19,null],[13,"NativeLibraryKind","","",19,null],[13,"LinkArgs","","",19,null],[13,"ResolveLifetimes","","",19,null],[13,"NamedRegion","","",19,null],[13,"IsLateBound","","",19,null],[13,"ObjectLifetimeDefaults","","",19,null],[13,"Visibility","","",19,null],[13,"DepKind","","",19,null],[13,"CrateName","","",19,null],[13,"ItemChildren","","",19,null],[13,"ExternModStmtCnum","","",19,null],[13,"GetLangItems","","",19,null],[13,"DefinedLangItems","","",19,null],[13,"MissingLangItems","","",19,null],[13,"VisibleParentMap","","",19,null],[13,"MissingExternCrateItem","","",19,null],[13,"UsedCrateSource","","",19,null],[13,"PostorderCnums","","",19,null],[13,"EraseRegionsTy","","",19,null],[13,"Freevars","","",19,null],[13,"MaybeUnusedTraitImport","","",19,null],[13,"MaybeUnusedExternCrates","","",19,null],[13,"StabilityIndex","","",19,null],[13,"AllTraits","","",19,null],[13,"AllCrateNums","","",19,null],[13,"ExportedSymbols","","",19,null],[13,"CollectAndPartitionTranslationItems","","",19,null],[13,"IsTranslatedItem","","",19,null],[13,"CodegenUnit","","",19,null],[13,"CompileCodegenUnit","","",19,null],[13,"OutputFilenames","","",19,null],[13,"NormalizeProjectionTy","","",19,null],[13,"NormalizeTyAfterErasingRegions","","",19,null],[13,"DropckOutlives","","",19,null],[13,"EvaluateObligation","","",19,null],[13,"SubstituteNormalizeAndTestPredicates","","",19,null],[13,"TargetFeaturesWhitelist","","",19,null],[13,"InstanceDefSizeEstimate","","",19,null],[13,"WasmCustomSections","","",19,null],[13,"Features","","",19,null],[13,"ProgramClausesFor","","",19,null],[13,"ProgramClausesForEnv","","",19,null],[13,"WasmImportModuleMap","","",19,null],[13,"ForeignModules","","",19,null],[13,"UpstreamMonomorphizations","","",19,null],[13,"UpstreamMonomorphizationsFor","","",19,null],[4,"DepConstructor","","",null,null],[13,"Null","","",20,null],[13,"Krate","","",20,null],[13,"HirBody","","",20,null],[13,"Hir","","",20,null],[13,"CrateMetadata","","",20,null],[13,"RegionScopeTree","","",20,null],[13,"Coherence","","",20,null],[13,"CoherenceInherentImplOverlapCheck","","",20,null],[13,"CoherenceCheckTrait","","",20,null],[13,"PrivacyAccessLevels","","",20,null],[13,"MirConstQualif","","",20,null],[13,"MirBuilt","","",20,null],[13,"MirConst","","",20,null],[13,"MirValidated","","",20,null],[13,"MirOptimized","","",20,null],[13,"MirShim","","",20,null],[12,"instance_def","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"BorrowCheckKrate","rustc::dep_graph::dep_node","",20,null],[13,"BorrowCheck","","",20,null],[13,"MirBorrowCheck","","",20,null],[13,"UnsafetyCheckResult","","",20,null],[13,"UnsafeDeriveOnReprPacked","","",20,null],[13,"Reachability","","",20,null],[13,"MirKeys","","",20,null],[13,"CrateVariances","","",20,null],[13,"AssociatedItems","","",20,null],[13,"TypeOfItem","","",20,null],[13,"GenericsOfItem","","",20,null],[13,"PredicatesOfItem","","",20,null],[13,"InferredOutlivesOf","","",20,null],[13,"InferredOutlivesCrate","","",20,null],[13,"SuperPredicatesOfItem","","",20,null],[13,"TraitDefOfItem","","",20,null],[13,"AdtDefOfItem","","",20,null],[13,"ImplTraitRef","","",20,null],[13,"ImplPolarity","","",20,null],[13,"FnSignature","","",20,null],[13,"CoerceUnsizedInfo","","",20,null],[13,"ItemVarianceConstraints","","",20,null],[13,"ItemVariances","","",20,null],[13,"IsConstFn","","",20,null],[13,"IsForeignItem","","",20,null],[13,"TypeParamPredicates","","",20,null],[12,"item_id","rustc::dep_graph::dep_node::DepConstructor","",20,null],[12,"param_id","","",20,null],[13,"SizedConstraint","rustc::dep_graph::dep_node","",20,null],[13,"DtorckConstraint","","",20,null],[13,"AdtDestructor","","",20,null],[13,"AssociatedItemDefIds","","",20,null],[13,"InherentImpls","","",20,null],[13,"TypeckBodiesKrate","","",20,null],[13,"TypeckTables","","",20,null],[13,"UsedTraitImports","","",20,null],[13,"HasTypeckTables","","",20,null],[13,"ConstEval","","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"CheckMatch","rustc::dep_graph::dep_node","",20,null],[13,"SymbolName","","",20,null],[13,"InstanceSymbolName","","",20,null],[12,"instance","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"SpecializationGraph","rustc::dep_graph::dep_node","",20,null],[13,"ObjectSafety","","",20,null],[13,"FulfillObligation","","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[12,"trait_ref","","",20,null],[13,"VtableMethods","rustc::dep_graph::dep_node","",20,null],[12,"trait_ref","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"IsCopy","rustc::dep_graph::dep_node","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"IsSized","rustc::dep_graph::dep_node","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"IsFreeze","rustc::dep_graph::dep_node","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"NeedsDrop","rustc::dep_graph::dep_node","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"Layout","rustc::dep_graph::dep_node","",20,null],[12,"param_env","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"TraitImpls","rustc::dep_graph::dep_node","",20,null],[13,"AllLocalTraitImpls","","",20,null],[13,"TraitSelect","","",20,null],[13,"ParamEnv","","",20,null],[13,"DescribeDef","","",20,null],[13,"DefSpan","","",20,null],[13,"LookupStability","","",20,null],[13,"LookupDeprecationEntry","","",20,null],[13,"ConstIsRvaluePromotableToStatic","","",20,null],[13,"RvaluePromotableMap","","",20,null],[13,"ImplParent","","",20,null],[13,"TraitOfItem","","",20,null],[13,"IsReachableNonGeneric","","",20,null],[13,"IsUnreachableLocalDefinition","","",20,null],[13,"IsMirAvailable","","",20,null],[13,"ItemAttrs","","",20,null],[13,"TransFnAttrs","","",20,null],[13,"FnArgNames","","",20,null],[13,"RenderedConst","","",20,null],[13,"DylibDepFormats","","",20,null],[13,"IsPanicRuntime","","",20,null],[13,"IsCompilerBuiltins","","",20,null],[13,"HasGlobalAllocator","","",20,null],[13,"ExternCrate","","",20,null],[13,"LintLevels","","",20,null],[13,"Specializes","","",20,null],[12,"impl1","rustc::dep_graph::dep_node::DepConstructor","",20,null],[12,"impl2","","",20,null],[13,"InScopeTraits","rustc::dep_graph::dep_node","",20,null],[13,"ModuleExports","","",20,null],[13,"IsSanitizerRuntime","","",20,null],[13,"IsProfilerRuntime","","",20,null],[13,"GetPanicStrategy","","",20,null],[13,"IsNoBuiltins","","",20,null],[13,"ImplDefaultness","","",20,null],[13,"CheckItemWellFormed","","",20,null],[13,"CheckTraitItemWellFormed","","",20,null],[13,"CheckImplItemWellFormed","","",20,null],[13,"ReachableNonGenerics","","",20,null],[13,"NativeLibraries","","",20,null],[13,"PluginRegistrarFn","","",20,null],[13,"DeriveRegistrarFn","","",20,null],[13,"CrateDisambiguator","","",20,null],[13,"CrateHash","","",20,null],[13,"OriginalCrateName","","",20,null],[13,"ExtraFileName","","",20,null],[13,"ImplementationsOfTrait","","",20,null],[12,"krate","rustc::dep_graph::dep_node::DepConstructor","",20,null],[12,"trait_id","","",20,null],[13,"AllTraitImplementations","rustc::dep_graph::dep_node","",20,null],[13,"DllimportForeignItems","","",20,null],[13,"IsDllimportForeignItem","","",20,null],[13,"IsStaticallyIncludedForeignItem","","",20,null],[13,"NativeLibraryKind","","",20,null],[13,"LinkArgs","","",20,null],[13,"ResolveLifetimes","","",20,null],[13,"NamedRegion","","",20,null],[13,"IsLateBound","","",20,null],[13,"ObjectLifetimeDefaults","","",20,null],[13,"Visibility","","",20,null],[13,"DepKind","","",20,null],[13,"CrateName","","",20,null],[13,"ItemChildren","","",20,null],[13,"ExternModStmtCnum","","",20,null],[13,"GetLangItems","","",20,null],[13,"DefinedLangItems","","",20,null],[13,"MissingLangItems","","",20,null],[13,"VisibleParentMap","","",20,null],[13,"MissingExternCrateItem","","",20,null],[13,"UsedCrateSource","","",20,null],[13,"PostorderCnums","","",20,null],[13,"EraseRegionsTy","","",20,null],[12,"ty","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"Freevars","rustc::dep_graph::dep_node","",20,null],[13,"MaybeUnusedTraitImport","","",20,null],[13,"MaybeUnusedExternCrates","","",20,null],[13,"StabilityIndex","","",20,null],[13,"AllTraits","","",20,null],[13,"AllCrateNums","","",20,null],[13,"ExportedSymbols","","",20,null],[13,"CollectAndPartitionTranslationItems","","",20,null],[13,"IsTranslatedItem","","",20,null],[13,"CodegenUnit","","",20,null],[13,"CompileCodegenUnit","","",20,null],[13,"OutputFilenames","","",20,null],[13,"NormalizeProjectionTy","","",20,null],[13,"NormalizeTyAfterErasingRegions","","",20,null],[13,"DropckOutlives","","",20,null],[13,"EvaluateObligation","","",20,null],[13,"SubstituteNormalizeAndTestPredicates","","",20,null],[12,"key","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"TargetFeaturesWhitelist","rustc::dep_graph::dep_node","",20,null],[13,"InstanceDefSizeEstimate","","",20,null],[12,"instance_def","rustc::dep_graph::dep_node::DepConstructor","",20,null],[13,"WasmCustomSections","rustc::dep_graph::dep_node","",20,null],[13,"Features","","",20,null],[13,"ProgramClausesFor","","",20,null],[13,"ProgramClausesForEnv","","",20,null],[13,"WasmImportModuleMap","","",20,null],[13,"ForeignModules","","",20,null],[13,"UpstreamMonomorphizations","","",20,null],[13,"UpstreamMonomorphizationsFor","","",20,null],[0,"label_strs","","Contains variant => str representations for constructing DepNode groups for tests.",null,null],[17,"Null","rustc::dep_graph::dep_node::label_strs","",null,null],[17,"Krate","","",null,null],[17,"HirBody","","",null,null],[17,"Hir","","",null,null],[17,"CrateMetadata","","",null,null],[17,"RegionScopeTree","","",null,null],[17,"Coherence","","",null,null],[17,"CoherenceInherentImplOverlapCheck","","",null,null],[17,"CoherenceCheckTrait","","",null,null],[17,"PrivacyAccessLevels","","",null,null],[17,"MirConstQualif","","",null,null],[17,"MirBuilt","","",null,null],[17,"MirConst","","",null,null],[17,"MirValidated","","",null,null],[17,"MirOptimized","","",null,null],[17,"MirShim","","",null,null],[17,"BorrowCheckKrate","","",null,null],[17,"BorrowCheck","","",null,null],[17,"MirBorrowCheck","","",null,null],[17,"UnsafetyCheckResult","","",null,null],[17,"UnsafeDeriveOnReprPacked","","",null,null],[17,"Reachability","","",null,null],[17,"MirKeys","","",null,null],[17,"CrateVariances","","",null,null],[17,"AssociatedItems","","",null,null],[17,"TypeOfItem","","",null,null],[17,"GenericsOfItem","","",null,null],[17,"PredicatesOfItem","","",null,null],[17,"InferredOutlivesOf","","",null,null],[17,"InferredOutlivesCrate","","",null,null],[17,"SuperPredicatesOfItem","","",null,null],[17,"TraitDefOfItem","","",null,null],[17,"AdtDefOfItem","","",null,null],[17,"ImplTraitRef","","",null,null],[17,"ImplPolarity","","",null,null],[17,"FnSignature","","",null,null],[17,"CoerceUnsizedInfo","","",null,null],[17,"ItemVarianceConstraints","","",null,null],[17,"ItemVariances","","",null,null],[17,"IsConstFn","","",null,null],[17,"IsForeignItem","","",null,null],[17,"TypeParamPredicates","","",null,null],[17,"SizedConstraint","","",null,null],[17,"DtorckConstraint","","",null,null],[17,"AdtDestructor","","",null,null],[17,"AssociatedItemDefIds","","",null,null],[17,"InherentImpls","","",null,null],[17,"TypeckBodiesKrate","","",null,null],[17,"TypeckTables","","",null,null],[17,"UsedTraitImports","","",null,null],[17,"HasTypeckTables","","",null,null],[17,"ConstEval","","",null,null],[17,"CheckMatch","","",null,null],[17,"SymbolName","","",null,null],[17,"InstanceSymbolName","","",null,null],[17,"SpecializationGraph","","",null,null],[17,"ObjectSafety","","",null,null],[17,"FulfillObligation","","",null,null],[17,"VtableMethods","","",null,null],[17,"IsCopy","","",null,null],[17,"IsSized","","",null,null],[17,"IsFreeze","","",null,null],[17,"NeedsDrop","","",null,null],[17,"Layout","","",null,null],[17,"TraitImpls","","",null,null],[17,"AllLocalTraitImpls","","",null,null],[17,"TraitSelect","","",null,null],[17,"ParamEnv","","",null,null],[17,"DescribeDef","","",null,null],[17,"DefSpan","","",null,null],[17,"LookupStability","","",null,null],[17,"LookupDeprecationEntry","","",null,null],[17,"ConstIsRvaluePromotableToStatic","","",null,null],[17,"RvaluePromotableMap","","",null,null],[17,"ImplParent","","",null,null],[17,"TraitOfItem","","",null,null],[17,"IsReachableNonGeneric","","",null,null],[17,"IsUnreachableLocalDefinition","","",null,null],[17,"IsMirAvailable","","",null,null],[17,"ItemAttrs","","",null,null],[17,"TransFnAttrs","","",null,null],[17,"FnArgNames","","",null,null],[17,"RenderedConst","","",null,null],[17,"DylibDepFormats","","",null,null],[17,"IsPanicRuntime","","",null,null],[17,"IsCompilerBuiltins","","",null,null],[17,"HasGlobalAllocator","","",null,null],[17,"ExternCrate","","",null,null],[17,"LintLevels","","",null,null],[17,"Specializes","","",null,null],[17,"InScopeTraits","","",null,null],[17,"ModuleExports","","",null,null],[17,"IsSanitizerRuntime","","",null,null],[17,"IsProfilerRuntime","","",null,null],[17,"GetPanicStrategy","","",null,null],[17,"IsNoBuiltins","","",null,null],[17,"ImplDefaultness","","",null,null],[17,"CheckItemWellFormed","","",null,null],[17,"CheckTraitItemWellFormed","","",null,null],[17,"CheckImplItemWellFormed","","",null,null],[17,"ReachableNonGenerics","","",null,null],[17,"NativeLibraries","","",null,null],[17,"PluginRegistrarFn","","",null,null],[17,"DeriveRegistrarFn","","",null,null],[17,"CrateDisambiguator","","",null,null],[17,"CrateHash","","",null,null],[17,"OriginalCrateName","","",null,null],[17,"ExtraFileName","","",null,null],[17,"ImplementationsOfTrait","","",null,null],[17,"AllTraitImplementations","","",null,null],[17,"DllimportForeignItems","","",null,null],[17,"IsDllimportForeignItem","","",null,null],[17,"IsStaticallyIncludedForeignItem","","",null,null],[17,"NativeLibraryKind","","",null,null],[17,"LinkArgs","","",null,null],[17,"ResolveLifetimes","","",null,null],[17,"NamedRegion","","",null,null],[17,"IsLateBound","","",null,null],[17,"ObjectLifetimeDefaults","","",null,null],[17,"Visibility","","",null,null],[17,"DepKind","","",null,null],[17,"CrateName","","",null,null],[17,"ItemChildren","","",null,null],[17,"ExternModStmtCnum","","",null,null],[17,"GetLangItems","","",null,null],[17,"DefinedLangItems","","",null,null],[17,"MissingLangItems","","",null,null],[17,"VisibleParentMap","","",null,null],[17,"MissingExternCrateItem","","",null,null],[17,"UsedCrateSource","","",null,null],[17,"PostorderCnums","","",null,null],[17,"EraseRegionsTy","","",null,null],[17,"Freevars","","",null,null],[17,"MaybeUnusedTraitImport","","",null,null],[17,"MaybeUnusedExternCrates","","",null,null],[17,"StabilityIndex","","",null,null],[17,"AllTraits","","",null,null],[17,"AllCrateNums","","",null,null],[17,"ExportedSymbols","","",null,null],[17,"CollectAndPartitionTranslationItems","","",null,null],[17,"IsTranslatedItem","","",null,null],[17,"CodegenUnit","","",null,null],[17,"CompileCodegenUnit","","",null,null],[17,"OutputFilenames","","",null,null],[17,"NormalizeProjectionTy","","",null,null],[17,"NormalizeTyAfterErasingRegions","","",null,null],[17,"DropckOutlives","","",null,null],[17,"EvaluateObligation","","",null,null],[17,"SubstituteNormalizeAndTestPredicates","","",null,null],[17,"TargetFeaturesWhitelist","","",null,null],[17,"InstanceDefSizeEstimate","","",null,null],[17,"WasmCustomSections","","",null,null],[17,"Features","","",null,null],[17,"ProgramClausesFor","","",null,null],[17,"ProgramClausesForEnv","","",null,null],[17,"WasmImportModuleMap","","",null,null],[17,"ForeignModules","","",null,null],[17,"UpstreamMonomorphizations","","",null,null],[17,"UpstreamMonomorphizationsFor","","",null,null],[8,"DepNodeParams","rustc::dep_graph::dep_node","",null,null],[18,"CAN_RECONSTRUCT_QUERY_KEY","","",26,null],[11,"to_fingerprint","","This method turns the parameters of a DepNodeConstructor into an opaque Fingerprint to be used in DepNode. Not all DepNodeParams support being turned into a Fingerprint (they don't need to if the corresponding DepNode is anonymous).",26,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"fingerprint"}}],[11,"to_debug_str","","",26,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::dep_graph","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fingerprint_needed_for_crate_hash","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"depkind"}}],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",19,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",19,null],[11,"partial_cmp","","",19,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",19,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"name":"ordering"}}],[11,"hash","","",19,null],[11,"encode","","",19,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"__d"}],"output":{"generics":["depkind"],"name":"result"}}],[11,"can_reconstruct_query_key","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_anon","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_input","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_eval_always","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_params","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"depnode"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",9,null],[11,"partial_cmp","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"le","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"gt","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"ge","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"cmp","","",9,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"ordering"}}],[11,"hash","","",9,null],[11,"encode","","",9,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",9,{"inputs":[{"name":"__d"}],"output":{"generics":["depnode"],"name":"result"}}],[11,"new","","",9,{"inputs":[{"name":"tyctxt"},{"name":"depconstructor"}],"output":{"name":"depnode"}}],[11,"from_def_path_hash","","Construct a DepNode from the given DepKind and DefPathHash. This method will assert that the given DepKind actually requires a single DefId/DefPathHash parameter.",9,{"inputs":[{"name":"depkind"},{"name":"defpathhash"}],"output":{"name":"depnode"}}],[11,"new_no_params","","Create a new, parameterless DepNode. This method will assert that the DepNode corresponding to the given DepKind actually does not require any parameters.",9,{"inputs":[{"name":"depkind"}],"output":{"name":"depnode"}}],[11,"extract_def_id","","Extract the DefId corresponding to this DepNode. This will work if two conditions are met:",9,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["defid"],"name":"option"}}],[11,"from_label_string","","Used in testing",9,{"inputs":[{"name":"str"},{"name":"defpathhash"}],"output":{"generics":["depnode"],"name":"result"}}],[11,"has_label_string","","Used in testing",9,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"workproductid"}}],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",10,null],[11,"partial_cmp","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"bool"}}],[11,"le","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"bool"}}],[11,"gt","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"bool"}}],[11,"ge","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"bool"}}],[11,"cmp","","",10,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"name":"ordering"}}],[11,"hash","","",10,null],[11,"encode","","",10,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",10,{"inputs":[{"name":"__d"}],"output":{"generics":["workproductid"],"name":"result"}}],[11,"from_cgu_name","","",10,{"inputs":[{"name":"str"}],"output":{"name":"workproductid"}}],[11,"from_fingerprint","","",10,{"inputs":[{"name":"fingerprint"}],"output":{"name":"workproductid"}}],[11,"hash_stable","","",10,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"dep_tracking_map","","",null,null],[3,"DepTrackingMap","rustc::dep_graph::dep_tracking_map","A DepTrackingMap offers a subset of the `Map` API and ensures that we make calls to `read` and `write` as appropriate. We key the maps with a unique type for brevity.",null,null],[12,"phantom","","",8,null],[12,"graph","","",8,null],[12,"map","","",8,null],[8,"DepTrackingMapConfig","","",null,null],[16,"Key","","",27,null],[16,"Value","","",27,null],[10,"to_dep_kind","","",27,{"inputs":[],"output":{"name":"depkind"}}],[11,"new","rustc::dep_graph","",8,{"inputs":[{"name":"depgraph"}],"output":{"name":"deptrackingmap"}}],[0,"graph","","",null,null],[3,"DepGraph","rustc::dep_graph::graph","",null,null],[12,"data","","",11,null],[12,"fingerprints","","",11,null],[3,"DepNodeIndex","","",null,null],[12,"0","","",13,null],[3,"DepGraphData","","",null,null],[12,"current","","The new encoding of the dependency graph, optimized for red/green tracking. The `current` field is the dependency graph of only the current compilation session: We don't merge the previous dep-graph into current one anymore.",28,null],[12,"previous","","The dep-graph from the previous compilation session. It contains all nodes and edges as well as all fingerprints of nodes that have them.",28,null],[12,"colors","","",28,null],[12,"previous_work_products","","When we load, there may be `.o` files, cached mir, or other such things available to us. If we find that they are not dirty, we load the path to the file storing those work-products here into this map. We can later look for and extract that data.",28,null],[12,"work_products","","Work-products that we generate in this run.",28,null],[12,"dep_node_debug","","",28,null],[12,"loaded_from_cache","","",28,null],[3,"WorkProduct","","A \"work product\" is an intermediate result that we save into the incremental directory for later re-use. The primary example are the object files that we save for each partition at code generation time.",null,null],[12,"cgu_name","","",12,null],[12,"saved_files","","Saved files associated with this CGU",12,null],[3,"CurrentDepGraph","","",null,null],[12,"nodes","","",29,null],[12,"edges","","",29,null],[12,"node_to_node_index","","",29,null],[12,"forbidden_edge","","",29,null],[12,"anon_id_seed","","",29,null],[12,"total_read_count","","",29,null],[12,"total_duplicate_read_count","","",29,null],[3,"RegularOpenTask","","",null,null],[12,"node","","",30,null],[12,"reads","","",30,null],[12,"read_set","","",30,null],[3,"AnonOpenTask","","",null,null],[12,"reads","","",31,null],[12,"read_set","","",31,null],[3,"DepNodeColorMap","","",null,null],[12,"values","","",32,null],[4,"DepNodeColor","","",null,null],[13,"Red","","",21,null],[13,"Green","","",21,null],[4,"WorkProductFileKind","","",null,null],[13,"Object","","",23,null],[13,"Bytecode","","",23,null],[13,"BytecodeCompressed","","",23,null],[4,"OpenTask","","",null,null],[13,"Regular","","",22,null],[13,"Anon","","",22,null],[13,"Ignore","","",22,null],[13,"EvalAlways","","",22,null],[12,"node","rustc::dep_graph::graph::OpenTask","",22,null],[17,"COMPRESSED_NONE","rustc::dep_graph::graph","",null,null],[17,"COMPRESSED_RED","","",null,null],[17,"COMPRESSED_FIRST_GREEN","","",null,null],[11,"clone","rustc::dep_graph","",11,{"inputs":[{"name":"self"}],"output":{"name":"depgraph"}}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"depnodeindex"}}],[11,"eq","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",13,null],[11,"hash","","",13,null],[11,"partial_cmp","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"bool"}}],[11,"le","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"bool"}}],[11,"gt","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"bool"}}],[11,"ge","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"bool"}}],[11,"cmp","","",13,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"ordering"}}],[11,"decode","","",13,{"inputs":[{"name":"__d"}],"output":{"generics":["depnodeindex"],"name":"result"}}],[11,"encode","","",13,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",13,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",13,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"INVALID","","",13,null],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"depnodecolor"}}],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",21,{"inputs":[{"name":"self"},{"name":"depnodecolor"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"self"},{"name":"depnodecolor"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",21,null],[11,"hash","","",21,null],[11,"is_green","","",21,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"new","","",11,{"inputs":[{"name":"previousdepgraph"}],"output":{"name":"depgraph"}}],[11,"new_disabled","","",11,{"inputs":[],"output":{"name":"depgraph"}}],[11,"is_fully_enabled","","True if we are actually building the full dep-graph.",11,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"query","","",11,{"inputs":[{"name":"self"}],"output":{"name":"depgraphquery"}}],[11,"assert_ignored","","",11,{"inputs":[{"name":"self"}],"output":null}],[11,"with_ignore","","",11,{"inputs":[{"name":"self"},{"name":"op"}],"output":{"name":"r"}}],[11,"with_task","","Starts a new dep-graph task. Dep-graph tasks are specified using a free function (`task`) and not a closure -- this is intentional because we want to exercise tight control over what state they have access to. In particular, we want to prevent implicit 'leaks' of tracked state into the task (which could then be read without generating correct edges in the dep-graph -- see the [rustc guide] for more details on the dep-graph). To this end, the task function gets exactly two pieces of state: the context `cx` and an argument `arg`. Both of these bits of state must be of some type that implements `DepGraphSafe` and hence does not leak.",11,null],[11,"input_task","","Creates a new dep-graph input with value `input`",11,null],[11,"with_task_impl","","",11,null],[11,"with_anon_task","","Execute something within an \"anonymous\" task, that is, a task the DepNode of which is determined by the list of inputs it read from.",11,null],[11,"with_eval_always_task","","Execute something within an \"eval-always\" task which is a task",11,null],[11,"read","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":null}],[11,"read_index","","",11,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":null}],[11,"dep_node_index_of","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"depnodeindex"}}],[11,"dep_node_exists","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"fingerprint_of","","",11,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":{"name":"fingerprint"}}],[11,"prev_fingerprint_of","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["fingerprint"],"name":"option"}}],[11,"prev_dep_node_index_of","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"serializeddepnodeindex"}}],[11,"insert_previous_work_product","","Indicates that a previous work product exists for `v`. This is invoked during initial start-up based on what nodes are clean (and what files exist in the incr. directory).",11,{"inputs":[{"name":"self"},{"name":"workproductid"},{"name":"workproduct"}],"output":null}],[11,"insert_work_product","","Indicates that we created the given work-product in this run for `v`. This record will be preserved and loaded in the next run.",11,{"inputs":[{"name":"self"},{"name":"workproductid"},{"name":"workproduct"}],"output":null}],[11,"previous_work_product","","Check whether a previous work product exists for `v` and, if so, return the path that leads to it. Used to skip doing work.",11,{"inputs":[{"name":"self"},{"name":"workproductid"}],"output":{"generics":["workproduct"],"name":"option"}}],[11,"work_products","","Access the map of work-products created during this run. Only used during saving of the dep-graph.",11,{"inputs":[{"name":"self"}],"output":{"generics":["fxhashmap"],"name":"readguard"}}],[11,"previous_work_products","","Access the map of work-products created during the cached run. Only used during saving of the dep-graph.",11,{"inputs":[{"name":"self"}],"output":{"generics":["fxhashmap"],"name":"readguard"}}],[11,"register_dep_node_debug_str","","",11,{"inputs":[{"name":"self"},{"name":"depnode"},{"name":"f"}],"output":null}],[11,"dep_node_debug_str","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["string"],"name":"option"}}],[11,"edge_deduplication_data","","",11,null],[11,"serialize","","",11,{"inputs":[{"name":"self"}],"output":{"name":"serializeddepgraph"}}],[11,"node_color","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["depnodecolor"],"name":"option"}}],[11,"try_mark_green","","",11,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"depnode"}],"output":{"generics":["depnodeindex"],"name":"option"}}],[11,"is_green","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"exec_cache_promotions","","",11,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":null}],[11,"mark_loaded_from_cache","","",11,{"inputs":[{"name":"self"},{"name":"depnodeindex"},{"name":"bool"}],"output":null}],[11,"was_loaded_from_cache","","",11,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["bool"],"name":"option"}}],[11,"clone","","",12,{"inputs":[{"name":"self"}],"output":{"name":"workproduct"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",12,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",12,{"inputs":[{"name":"__d"}],"output":{"generics":["workproduct"],"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"self"}],"output":{"name":"workproductfilekind"}}],[11,"fmt","","",23,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"__d"}],"output":{"generics":["workproductfilekind"],"name":"result"}}],[11,"new","rustc::dep_graph::graph","",29,{"inputs":[],"output":{"name":"currentdepgraph"}}],[11,"complete_task","","",29,{"inputs":[{"name":"self"},{"name":"depnode"},{"name":"opentask"}],"output":{"name":"depnodeindex"}}],[11,"pop_anon_task","","",29,{"inputs":[{"name":"self"},{"name":"depkind"},{"name":"opentask"}],"output":{"name":"depnodeindex"}}],[11,"complete_eval_always_task","","",29,{"inputs":[{"name":"self"},{"name":"depnode"},{"name":"opentask"}],"output":{"name":"depnodeindex"}}],[11,"read_index","","",29,{"inputs":[{"name":"self"},{"name":"depnodeindex"}],"output":null}],[11,"alloc_node","","",29,{"inputs":[{"name":"self"},{"name":"depnode"},{"generics":["depnodeindex"],"name":"vec"}],"output":{"name":"depnodeindex"}}],[11,"new","","",32,{"inputs":[{"name":"usize"}],"output":{"name":"depnodecolormap"}}],[11,"get","","",32,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"generics":["depnodecolor"],"name":"option"}}],[11,"insert","","",32,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"},{"name":"depnodecolor"}],"output":null}],[0,"prev","rustc::dep_graph","",null,null],[3,"PreviousDepGraph","rustc::dep_graph::prev","",null,null],[12,"data","","",14,null],[12,"index","","",14,null],[11,"fmt","rustc::dep_graph","",14,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",14,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",14,{"inputs":[{"name":"__d"}],"output":{"generics":["previousdepgraph"],"name":"result"}}],[11,"new","","",14,{"inputs":[{"name":"serializeddepgraph"}],"output":{"name":"previousdepgraph"}}],[11,"edges_from","","",14,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"option"}}],[11,"index_to_node","","",14,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"depnode"}}],[11,"node_to_index","","",14,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"serializeddepnodeindex"}}],[11,"node_to_index_opt","","",14,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["serializeddepnodeindex"],"name":"option"}}],[11,"fingerprint_of","","",14,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["fingerprint"],"name":"option"}}],[11,"fingerprint_by_index","","",14,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"fingerprint"}}],[11,"node_count","","",14,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[0,"query","","",null,null],[3,"DepGraphQuery","rustc::dep_graph::query","",null,null],[12,"graph","","",15,null],[12,"indices","","",15,null],[11,"new","rustc::dep_graph","",15,null],[11,"contains_node","","",15,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"nodes","","",15,{"inputs":[{"name":"self"}],"output":{"generics":["depnode"],"name":"vec"}}],[11,"edges","","",15,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"reachable_nodes","","",15,{"inputs":[{"name":"self"},{"name":"depnode"},{"name":"direction"}],"output":{"generics":["depnode"],"name":"vec"}}],[11,"transitive_successors","","All nodes reachable from `node`. In other words, things that will have to be recomputed if `node` changes.",15,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["depnode"],"name":"vec"}}],[11,"transitive_predecessors","","All nodes that can reach `node`.",15,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["depnode"],"name":"vec"}}],[11,"immediate_successors","","Just the outgoing edges from `node`.",15,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["depnode"],"name":"vec"}}],[0,"safe","","The `DepGraphSafe` trait",null,null],[3,"AssertDepGraphSafe","rustc::dep_graph::safe","A convenient override that lets you pass arbitrary state into a task. Every use should be accompanied by a comment explaining why it makes sense (or how it could be refactored away in the future).",null,null],[12,"0","","",16,null],[8,"DepGraphSafe","","The `DepGraphSafe` trait is used to specify what kinds of values are safe to \"leak\" into a task. The idea is that this should be only be implemented for things like the tcx as well as various id types, which will create reads in the dep-graph whenever the trait loads anything that might depend on the input program.",null,null],[0,"serialized","rustc::dep_graph","The data that we will serialize and deserialize.",null,null],[3,"SerializedDepNodeIndex","rustc::dep_graph::serialized","",null,null],[12,"0","","",18,null],[3,"SerializedDepGraph","","Data for use when recompiling the current crate.",null,null],[12,"nodes","","The set of all DepNodes in the graph",17,null],[12,"fingerprints","","The set of all Fingerprints in the graph. Each Fingerprint corresponds to the DepNode at the same index in the nodes vector.",17,null],[12,"edge_list_indices","","For each DepNode, stores the list of edges originating from that DepNode. Encoded as a [start, end) pair indexing into edge_list_data, which holds the actual DepNodeIndices of the target nodes.",17,null],[12,"edge_list_data","","A flattened list of all edge targets in the graph. Edge sources are implicit in edge_list_indices.",17,null],[11,"clone","rustc::dep_graph","",18,{"inputs":[{"name":"self"}],"output":{"name":"serializeddepnodeindex"}}],[11,"eq","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",18,null],[11,"hash","","",18,null],[11,"partial_cmp","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"bool"}}],[11,"cmp","","",18,{"inputs":[{"name":"self"},{"name":"serializeddepnodeindex"}],"output":{"name":"ordering"}}],[11,"decode","","",18,{"inputs":[{"name":"__d"}],"output":{"generics":["serializeddepnodeindex"],"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",18,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",18,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"__d"}],"output":{"generics":["serializeddepgraph"],"name":"result"}}],[11,"new","","",17,{"inputs":[],"output":{"name":"serializeddepgraph"}}],[11,"edge_targets_from","","",17,null],[0,"label_strs","","Contains variant => str representations for constructing DepNode groups for tests.",null,null],[17,"Null","rustc::dep_graph::label_strs","",null,null],[17,"Krate","","",null,null],[17,"HirBody","","",null,null],[17,"Hir","","",null,null],[17,"CrateMetadata","","",null,null],[17,"RegionScopeTree","","",null,null],[17,"Coherence","","",null,null],[17,"CoherenceInherentImplOverlapCheck","","",null,null],[17,"CoherenceCheckTrait","","",null,null],[17,"PrivacyAccessLevels","","",null,null],[17,"MirConstQualif","","",null,null],[17,"MirBuilt","","",null,null],[17,"MirConst","","",null,null],[17,"MirValidated","","",null,null],[17,"MirOptimized","","",null,null],[17,"MirShim","","",null,null],[17,"BorrowCheckKrate","","",null,null],[17,"BorrowCheck","","",null,null],[17,"MirBorrowCheck","","",null,null],[17,"UnsafetyCheckResult","","",null,null],[17,"UnsafeDeriveOnReprPacked","","",null,null],[17,"Reachability","","",null,null],[17,"MirKeys","","",null,null],[17,"CrateVariances","","",null,null],[17,"AssociatedItems","","",null,null],[17,"TypeOfItem","","",null,null],[17,"GenericsOfItem","","",null,null],[17,"PredicatesOfItem","","",null,null],[17,"InferredOutlivesOf","","",null,null],[17,"InferredOutlivesCrate","","",null,null],[17,"SuperPredicatesOfItem","","",null,null],[17,"TraitDefOfItem","","",null,null],[17,"AdtDefOfItem","","",null,null],[17,"ImplTraitRef","","",null,null],[17,"ImplPolarity","","",null,null],[17,"FnSignature","","",null,null],[17,"CoerceUnsizedInfo","","",null,null],[17,"ItemVarianceConstraints","","",null,null],[17,"ItemVariances","","",null,null],[17,"IsConstFn","","",null,null],[17,"IsForeignItem","","",null,null],[17,"TypeParamPredicates","","",null,null],[17,"SizedConstraint","","",null,null],[17,"DtorckConstraint","","",null,null],[17,"AdtDestructor","","",null,null],[17,"AssociatedItemDefIds","","",null,null],[17,"InherentImpls","","",null,null],[17,"TypeckBodiesKrate","","",null,null],[17,"TypeckTables","","",null,null],[17,"UsedTraitImports","","",null,null],[17,"HasTypeckTables","","",null,null],[17,"ConstEval","","",null,null],[17,"CheckMatch","","",null,null],[17,"SymbolName","","",null,null],[17,"InstanceSymbolName","","",null,null],[17,"SpecializationGraph","","",null,null],[17,"ObjectSafety","","",null,null],[17,"FulfillObligation","","",null,null],[17,"VtableMethods","","",null,null],[17,"IsCopy","","",null,null],[17,"IsSized","","",null,null],[17,"IsFreeze","","",null,null],[17,"NeedsDrop","","",null,null],[17,"Layout","","",null,null],[17,"TraitImpls","","",null,null],[17,"AllLocalTraitImpls","","",null,null],[17,"TraitSelect","","",null,null],[17,"ParamEnv","","",null,null],[17,"DescribeDef","","",null,null],[17,"DefSpan","","",null,null],[17,"LookupStability","","",null,null],[17,"LookupDeprecationEntry","","",null,null],[17,"ConstIsRvaluePromotableToStatic","","",null,null],[17,"RvaluePromotableMap","","",null,null],[17,"ImplParent","","",null,null],[17,"TraitOfItem","","",null,null],[17,"IsReachableNonGeneric","","",null,null],[17,"IsUnreachableLocalDefinition","","",null,null],[17,"IsMirAvailable","","",null,null],[17,"ItemAttrs","","",null,null],[17,"TransFnAttrs","","",null,null],[17,"FnArgNames","","",null,null],[17,"RenderedConst","","",null,null],[17,"DylibDepFormats","","",null,null],[17,"IsPanicRuntime","","",null,null],[17,"IsCompilerBuiltins","","",null,null],[17,"HasGlobalAllocator","","",null,null],[17,"ExternCrate","","",null,null],[17,"LintLevels","","",null,null],[17,"Specializes","","",null,null],[17,"InScopeTraits","","",null,null],[17,"ModuleExports","","",null,null],[17,"IsSanitizerRuntime","","",null,null],[17,"IsProfilerRuntime","","",null,null],[17,"GetPanicStrategy","","",null,null],[17,"IsNoBuiltins","","",null,null],[17,"ImplDefaultness","","",null,null],[17,"CheckItemWellFormed","","",null,null],[17,"CheckTraitItemWellFormed","","",null,null],[17,"CheckImplItemWellFormed","","",null,null],[17,"ReachableNonGenerics","","",null,null],[17,"NativeLibraries","","",null,null],[17,"PluginRegistrarFn","","",null,null],[17,"DeriveRegistrarFn","","",null,null],[17,"CrateDisambiguator","","",null,null],[17,"CrateHash","","",null,null],[17,"OriginalCrateName","","",null,null],[17,"ExtraFileName","","",null,null],[17,"ImplementationsOfTrait","","",null,null],[17,"AllTraitImplementations","","",null,null],[17,"DllimportForeignItems","","",null,null],[17,"IsDllimportForeignItem","","",null,null],[17,"IsStaticallyIncludedForeignItem","","",null,null],[17,"NativeLibraryKind","","",null,null],[17,"LinkArgs","","",null,null],[17,"ResolveLifetimes","","",null,null],[17,"NamedRegion","","",null,null],[17,"IsLateBound","","",null,null],[17,"ObjectLifetimeDefaults","","",null,null],[17,"Visibility","","",null,null],[17,"DepKind","","",null,null],[17,"CrateName","","",null,null],[17,"ItemChildren","","",null,null],[17,"ExternModStmtCnum","","",null,null],[17,"GetLangItems","","",null,null],[17,"DefinedLangItems","","",null,null],[17,"MissingLangItems","","",null,null],[17,"VisibleParentMap","","",null,null],[17,"MissingExternCrateItem","","",null,null],[17,"UsedCrateSource","","",null,null],[17,"PostorderCnums","","",null,null],[17,"EraseRegionsTy","","",null,null],[17,"Freevars","","",null,null],[17,"MaybeUnusedTraitImport","","",null,null],[17,"MaybeUnusedExternCrates","","",null,null],[17,"StabilityIndex","","",null,null],[17,"AllTraits","","",null,null],[17,"AllCrateNums","","",null,null],[17,"ExportedSymbols","","",null,null],[17,"CollectAndPartitionTranslationItems","","",null,null],[17,"IsTranslatedItem","","",null,null],[17,"CodegenUnit","","",null,null],[17,"CompileCodegenUnit","","",null,null],[17,"OutputFilenames","","",null,null],[17,"NormalizeProjectionTy","","",null,null],[17,"NormalizeTyAfterErasingRegions","","",null,null],[17,"DropckOutlives","","",null,null],[17,"EvaluateObligation","","",null,null],[17,"SubstituteNormalizeAndTestPredicates","","",null,null],[17,"TargetFeaturesWhitelist","","",null,null],[17,"InstanceDefSizeEstimate","","",null,null],[17,"WasmCustomSections","","",null,null],[17,"Features","","",null,null],[17,"ProgramClausesFor","","",null,null],[17,"ProgramClausesForEnv","","",null,null],[17,"WasmImportModuleMap","","",null,null],[17,"ForeignModules","","",null,null],[17,"UpstreamMonomorphizations","","",null,null],[17,"UpstreamMonomorphizationsFor","","",null,null],[8,"DepTrackingMapConfig","rustc::dep_graph","",null,null],[16,"Key","","",27,null],[16,"Value","","",27,null],[10,"to_dep_kind","","",27,{"inputs":[],"output":{"name":"depkind"}}],[8,"DepGraphSafe","","The `DepGraphSafe` trait is used to specify what kinds of values are safe to \"leak\" into a task. The idea is that this should be only be implemented for things like the tcx as well as various id types, which will create reads in the dep-graph whenever the trait loads anything that might depend on the input program.",null,null],[0,"hir","rustc","",null,null],[3,"HirId","rustc::hir","A HirId uniquely identifies a node in the HIR of the current crate. It is composed of the `owner`, which is the DefIndex of the directly enclosing hir::Item, hir::TraitItem, or hir::ImplItem (i.e. the closest \"item-like\"), and the `local_id` which is unique within the given owner.",null,null],[12,"owner","","",33,null],[12,"local_id","","",33,null],[3,"ItemLocalId","","An `ItemLocalId` uniquely identifies something within a given \"item-like\", that is within a hir::Item, hir::TraitItem, or hir::ImplItem. There is no guarantee that the numerical value of a given `ItemLocalId` corresponds to the node's position within the owning item in any way, but there is a guarantee that the `LocalItemId`s within an owner occupy a dense range of integers starting at zero, so a mapping that maps all or most nodes within an \"item-like\" to something else can be implement by a `Vec` instead of a tree or hash map.",null,null],[12,"0","","",34,null],[3,"Label","","",null,null],[12,"name","","",35,null],[12,"span","","",35,null],[3,"Lifetime","","",null,null],[12,"id","","",36,null],[12,"span","","",36,null],[12,"name","","Either \"'a\", referring to a named lifetime definition, or \"\" (aka keywords::Invalid), for elision placeholders.",36,null],[3,"LifetimeDef","","A lifetime definition, eg `'a: 'b+'c+'d`",null,null],[12,"lifetime","","",37,null],[12,"bounds","","",37,null],[12,"pure_wrt_drop","","",37,null],[12,"in_band","","",37,null],[3,"Path","","A \"Path\" is essentially Rust's notion of a name; for instance: `std::cmp::PartialEq`. It's represented as a sequence of identifiers, along with a bunch of supporting information.",null,null],[12,"span","","",38,null],[12,"def","","The definition that the path resolved to.",38,null],[12,"segments","","The segments in the path: the things separated by `::`.",38,null],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of types.",null,null],[12,"name","","The identifier portion of this path segment.",39,null],[12,"parameters","","Type/lifetime parameters attached to this path. They come in two flavors: `Path<A,B,C>` and `Path(A,B) -> C`. Note that this is more than just simple syntactic sugar; the use of parens affects the region binding rules, so we preserve the distinction.",39,null],[12,"infer_types","","Whether to infer remaining type parameters, if any. This only applies to expression and pattern paths, and out of those only the segments with no type parameters to begin with, e.g. `Vec::new` is `<Vec<..>>::new::<..>`.",39,null],[3,"PathParameters","","",null,null],[12,"lifetimes","","The lifetime parameters for this path segment.",40,null],[12,"types","","The type parameters for this path segment, if present.",40,null],[12,"bindings","","Bindings (equality constraints) on associated types, if present. E.g., `Foo<A=Bar>`.",40,null],[12,"parenthesized","","Were parameters written in parenthesized form `Fn(T) -> U`? This is required mostly for pretty-printing and diagnostics, but also for changing lifetime elision rules to be \"function-like\".",40,null],[3,"TyParam","","",null,null],[12,"name","","",41,null],[12,"id","","",41,null],[12,"bounds","","",41,null],[12,"default","","",41,null],[12,"span","","",41,null],[12,"pure_wrt_drop","","",41,null],[12,"synthetic","","",41,null],[12,"attrs","","",41,null],[3,"Generics","","Represents lifetimes and type parameters attached to a declaration of a function, enum, trait, etc.",null,null],[12,"params","","",42,null],[12,"where_clause","","",42,null],[12,"span","","",42,null],[3,"WhereClause","","A `where` clause in a definition",null,null],[12,"id","","",43,null],[12,"predicates","","",43,null],[3,"WhereBoundPredicate","","A type bound, eg `for<'c> Foo: Send+Clone+'c`",null,null],[12,"span","","",44,null],[12,"bound_generic_params","","Any generics from a `for` binding",44,null],[12,"bounded_ty","","The type being bounded",44,null],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",44,null],[3,"WhereRegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",null,null],[12,"span","","",45,null],[12,"lifetime","","",45,null],[12,"bounds","","",45,null],[3,"WhereEqPredicate","","An equality predicate (unsupported), e.g. `T=int`",null,null],[12,"id","","",46,null],[12,"span","","",46,null],[12,"lhs_ty","","",46,null],[12,"rhs_ty","","",46,null],[3,"Crate","","The top-level data structure that stores the entire contents of the crate currently being compiled.",null,null],[12,"module","","",47,null],[12,"attrs","","",47,null],[12,"span","","",47,null],[12,"exported_macros","","",47,null],[12,"items","","",47,null],[12,"trait_items","","",47,null],[12,"impl_items","","",47,null],[12,"bodies","","",47,null],[12,"trait_impls","","",47,null],[12,"trait_auto_impl","","",47,null],[12,"body_ids","","A list of the body ids written out in the order in which they appear in the crate. If you're going to process all the bodies in the crate, you should iterate over this list rather than the keys of bodies.",47,null],[3,"MacroDef","","A macro definition, in this crate or imported from another.",null,null],[12,"name","","",48,null],[12,"vis","","",48,null],[12,"attrs","","",48,null],[12,"id","","",48,null],[12,"span","","",48,null],[12,"body","","",48,null],[12,"legacy","","",48,null],[3,"Block","","",null,null],[12,"stmts","","Statements in a block",49,null],[12,"expr","","An expression at the end of the block without a semicolon, if any",49,null],[12,"id","","",49,null],[12,"hir_id","","",49,null],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",49,null],[12,"span","","",49,null],[12,"targeted_by_break","","If true, then there may exist `break 'a` values that aim to break out of this block early. As of this writing, this is not currently permitted in Rust itself, but it is generated as part of `catch` statements.",49,null],[12,"recovered","","If true, don't emit return value type errors as the parser had to recover from a parse error so this block will not have an appropriate type. A parse error will have been emitted so the compilation will never succeed if this is true.",49,null],[3,"Pat","","",null,null],[12,"id","","",50,null],[12,"hir_id","","",50,null],[12,"node","","",50,null],[12,"span","","",50,null],[3,"FieldPat","","A single field in a struct pattern",null,null],[12,"id","","",51,null],[12,"name","","The identifier for the field",51,null],[12,"pat","","The pattern the field is destructured to",51,null],[12,"is_shorthand","","",51,null],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",null,null],[12,"pat","","",52,null],[12,"ty","","",52,null],[12,"init","","Initializer expression to set the value, if any",52,null],[12,"id","","",52,null],[12,"hir_id","","",52,null],[12,"span","","",52,null],[12,"attrs","","",52,null],[12,"source","","",52,null],[3,"Arm","","represents one arm of a 'match'",null,null],[12,"attrs","","",53,null],[12,"pats","","",53,null],[12,"guard","","",53,null],[12,"body","","",53,null],[3,"Field","","",null,null],[12,"id","","",54,null],[12,"name","","",54,null],[12,"expr","","",54,null],[12,"span","","",54,null],[12,"is_shorthand","","",54,null],[3,"BodyId","","",null,null],[12,"node_id","","",55,null],[3,"Body","","The body of a function, closure, or constant value. In the case of a function, the body contains not only the function body itself (which is an expression), but also the argument patterns, since those are something that the caller doesn't really care about.",null,null],[12,"arguments","","",56,null],[12,"value","","",56,null],[12,"is_generator","","",56,null],[3,"Expr","","An expression",null,null],[12,"id","","",57,null],[12,"span","","",57,null],[12,"node","","",57,null],[12,"attrs","","",57,null],[12,"hir_id","","",57,null],[3,"Destination","","",null,null],[12,"label","","",58,null],[12,"target_id","","",58,null],[3,"MutTy","","",null,null],[12,"ty","","",59,null],[12,"mutbl","","",59,null],[3,"MethodSig","","Represents a method's signature in a trait declaration or implementation.",null,null],[12,"unsafety","","",60,null],[12,"constness","","",60,null],[12,"abi","","",60,null],[12,"decl","","",60,null],[3,"TraitItemId","","",null,null],[12,"node_id","","",61,null],[3,"TraitItem","","Represents an item declaration within a trait declaration, possibly including a default implementation. A trait item is either required (meaning it doesn't have an implementation, just a signature) or provided (meaning it has a default implementation).",null,null],[12,"id","","",62,null],[12,"name","","",62,null],[12,"hir_id","","",62,null],[12,"attrs","","",62,null],[12,"generics","","",62,null],[12,"node","","",62,null],[12,"span","","",62,null],[3,"ImplItemId","","",null,null],[12,"node_id","","",63,null],[3,"ImplItem","","Represents anything within an `impl` block",null,null],[12,"id","","",64,null],[12,"name","","",64,null],[12,"hir_id","","",64,null],[12,"vis","","",64,null],[12,"defaultness","","",64,null],[12,"attrs","","",64,null],[12,"generics","","",64,null],[12,"node","","",64,null],[12,"span","","",64,null],[3,"TypeBinding","","",null,null],[12,"id","","",65,null],[12,"name","","",65,null],[12,"ty","","",65,null],[12,"span","","",65,null],[3,"Ty","","",null,null],[12,"id","","",66,null],[12,"node","","",66,null],[12,"span","","",66,null],[12,"hir_id","","",66,null],[3,"BareFnTy","","",null,null],[12,"unsafety","","",67,null],[12,"abi","","",67,null],[12,"generic_params","","",67,null],[12,"decl","","",67,null],[12,"arg_names","","",67,null],[3,"ExistTy","","",null,null],[12,"generics","","",68,null],[12,"bounds","","",68,null],[3,"InlineAsmOutput","","",null,null],[12,"constraint","","",69,null],[12,"is_rw","","",69,null],[12,"is_indirect","","",69,null],[3,"InlineAsm","","",null,null],[12,"asm","","",70,null],[12,"asm_str_style","","",70,null],[12,"outputs","","",70,null],[12,"inputs","","",70,null],[12,"clobbers","","",70,null],[12,"volatile","","",70,null],[12,"alignstack","","",70,null],[12,"dialect","","",70,null],[12,"ctxt","","",70,null],[3,"Arg","","represents an argument in a function header",null,null],[12,"pat","","",71,null],[12,"id","","",71,null],[12,"hir_id","","",71,null],[3,"FnDecl","","Represents the header (not the body) of a function declaration",null,null],[12,"inputs","","",72,null],[12,"output","","",72,null],[12,"variadic","","",72,null],[12,"has_implicit_self","","True if this function has an `self`, `&self` or `&mut self` receiver (but not a `self: Xxx` one).",72,null],[3,"Mod","","",null,null],[12,"inner","","A span from the first token past `{` to the last token until `}`. For `mod foo;`, the inner span ranges from the first token to the last token in the external file.",73,null],[12,"item_ids","","",73,null],[3,"ForeignMod","","",null,null],[12,"abi","","",74,null],[12,"items","","",74,null],[3,"GlobalAsm","","",null,null],[12,"asm","","",75,null],[12,"ctxt","","",75,null],[3,"EnumDef","","",null,null],[12,"variants","","",76,null],[3,"Variant_","","",null,null],[12,"name","","",77,null],[12,"attrs","","",77,null],[12,"data","","",77,null],[12,"disr_expr","","Explicit discriminant, eg `Foo = 1`",77,null],[3,"TraitRef","","TraitRef's appear in impls.",null,null],[12,"path","","",78,null],[12,"ref_id","","",78,null],[3,"PolyTraitRef","","",null,null],[12,"bound_generic_params","","The `'a` in `<'a> Foo<&'a T>`",79,null],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",79,null],[12,"span","","",79,null],[3,"StructField","","",null,null],[12,"span","","",80,null],[12,"name","","",80,null],[12,"vis","","",80,null],[12,"id","","",80,null],[12,"ty","","",80,null],[12,"attrs","","",80,null],[3,"ItemId","","",null,null],[12,"id","","",81,null],[3,"Item","","An item",null,null],[12,"name","","",82,null],[12,"id","","",82,null],[12,"hir_id","","",82,null],[12,"attrs","","",82,null],[12,"node","","",82,null],[12,"vis","","",82,null],[12,"span","","",82,null],[3,"TraitItemRef","","A reference from an trait to one of its associated items. This contains the item's id, naturally, but also the item's name and some other high-level details (like whether it is an associated type or method, and whether it is public). This allows other passes to find the impl they want without loading the id (which means fewer edges in the incremental compilation graph).",null,null],[12,"id","","",83,null],[12,"name","","",83,null],[12,"kind","","",83,null],[12,"span","","",83,null],[12,"defaultness","","",83,null],[3,"ImplItemRef","","A reference from an impl to one of its associated items. This contains the item's id, naturally, but also the item's name and some other high-level details (like whether it is an associated type or method, and whether it is public). This allows other passes to find the impl they want without loading the id (which means fewer edges in the incremental compilation graph).",null,null],[12,"id","","",84,null],[12,"name","","",84,null],[12,"kind","","",84,null],[12,"span","","",84,null],[12,"vis","","",84,null],[12,"defaultness","","",84,null],[3,"ForeignItem","","",null,null],[12,"name","","",85,null],[12,"attrs","","",85,null],[12,"node","","",85,null],[12,"id","","",85,null],[12,"span","","",85,null],[12,"vis","","",85,null],[3,"Freevar","","A free variable referred to in a function.",null,null],[12,"def","","The variable being accessed free.",86,null],[12,"span","","",86,null],[3,"TraitCandidate","","",null,null],[12,"def_id","","",87,null],[12,"import_id","","",87,null],[3,"TransFnAttrs","","",null,null],[12,"flags","","",88,null],[12,"inline","","",88,null],[12,"export_name","","",88,null],[12,"target_features","","",88,null],[12,"linkage","","",88,null],[3,"TransFnAttrFlags","","",null,null],[12,"bits","","",89,null],[4,"LifetimeName","","",null,null],[13,"Implicit","","User typed nothing. e.g. the lifetime in `&u32`.",90,null],[13,"Underscore","","User typed `'_`.",90,null],[13,"Fresh","","Synthetic name generated when user elided a lifetime in an impl header, e.g. the lifetimes in cases like these:",90,null],[13,"Static","","User wrote `'static`",90,null],[13,"Name","","Some user-given name like `'x`",90,null],[4,"TyParamBound","","The AST represents all type param bounds as types. typeck::collect::compute_bounds matches these against the \"special\" built-in traits (see middle::lang_items) and detects Copy, Send and Sync.",null,null],[13,"TraitTyParamBound","","",91,null],[13,"RegionTyParamBound","","",91,null],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the modifier is `Maybe`. Negative bounds should also be handled here.",null,null],[13,"None","","",92,null],[13,"Maybe","","",92,null],[4,"GenericParam","","",null,null],[13,"Lifetime","","",93,null],[13,"Type","","",93,null],[4,"UnsafeGeneric","","",null,null],[13,"Region","","",94,null],[13,"Type","","",94,null],[4,"SyntheticTyParamKind","","Synthetic Type Parameters are converted to an other form during lowering, this allows to track the original form they had. Useful for error messages.",null,null],[13,"ImplTrait","","",95,null],[4,"WherePredicate","","A single predicate in a `where` clause",null,null],[13,"BoundPredicate","","A type binding, eg `for<'c> Foo: Send+Clone+'c`",96,null],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",96,null],[13,"EqPredicate","","An equality predicate (unsupported)",96,null],[4,"BindingAnnotation","","Explicit binding annotations given in the HIR for a binding. Note that this is not the final binding mode that we infer after type inference.",null,null],[13,"Unannotated","","No binding annotation given: this means that the final binding mode will depend on whether we have skipped through a `&` reference when matching. For example, the `x` in `Some(x)` will have binding mode `None`; if you do `let Some(x) = &Some(22)`, it will ultimately be inferred to be by-reference.",97,null],[13,"Mutable","","Annotated with `mut x` -- could be either ref or not, similar to `None`.",97,null],[13,"Ref","","Annotated as `ref`, like `ref x`",97,null],[13,"RefMut","","Annotated as `ref mut x`.",97,null],[4,"RangeEnd","","",null,null],[13,"Included","","",98,null],[13,"Excluded","","",98,null],[4,"PatKind","","",null,null],[13,"Wild","","Represents a wildcard pattern (`_`)",99,null],[13,"Binding","","A fresh binding `ref mut binding @ OPT_SUBPATTERN`. The `NodeId` is the canonical ID for the variable being bound, e.g. in `Ok(x) | Err(x)`, both `x` use the same canonical ID, which is the pattern ID of the first `x`.",99,null],[13,"Struct","","A struct or struct variant pattern, e.g. `Variant {x, y, ..}`. The `bool` is `true` in the presence of a `..`.",99,null],[13,"TupleStruct","","A tuple struct/variant pattern `Variant(x, y, .., z)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",99,null],[13,"Path","","A path pattern for an unit struct/variant or a (maybe-associated) constant.",99,null],[13,"Tuple","","A tuple pattern `(a, b)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",99,null],[13,"Box","","A `box` pattern",99,null],[13,"Ref","","A reference pattern, e.g. `&mut (a, b)`",99,null],[13,"Lit","","A literal",99,null],[13,"Range","","A range pattern, e.g. `1...2` or `1..2`",99,null],[13,"Slice","","`[a, b, ..i, y, z]` is represented as: `PatKind::Slice(box [a, b], Some(i), box [y, z])`",99,null],[4,"Mutability","","",null,null],[13,"MutMutable","","",100,null],[13,"MutImmutable","","",100,null],[4,"BinOp_","","",null,null],[13,"BiAdd","","The `+` operator (addition)",101,null],[13,"BiSub","","The `-` operator (subtraction)",101,null],[13,"BiMul","","The `*` operator (multiplication)",101,null],[13,"BiDiv","","The `/` operator (division)",101,null],[13,"BiRem","","The `%` operator (modulus)",101,null],[13,"BiAnd","","The `&&` operator (logical and)",101,null],[13,"BiOr","","The `||` operator (logical or)",101,null],[13,"BiBitXor","","The `^` operator (bitwise xor)",101,null],[13,"BiBitAnd","","The `&` operator (bitwise and)",101,null],[13,"BiBitOr","","The `|` operator (bitwise or)",101,null],[13,"BiShl","","The `<<` operator (shift left)",101,null],[13,"BiShr","","The `>>` operator (shift right)",101,null],[13,"BiEq","","The `==` operator (equality)",101,null],[13,"BiLt","","The `<` operator (less than)",101,null],[13,"BiLe","","The `<=` operator (less than or equal to)",101,null],[13,"BiNe","","The `!=` operator (not equal to)",101,null],[13,"BiGe","","The `>=` operator (greater than or equal to)",101,null],[13,"BiGt","","The `>` operator (greater than)",101,null],[4,"UnOp","","",null,null],[13,"UnDeref","","The `*` operator for dereferencing",102,null],[13,"UnNot","","The `!` operator for logical inversion",102,null],[13,"UnNeg","","The `-` operator for negation",102,null],[4,"Stmt_","","",null,null],[13,"StmtDecl","","Could be an item or a local (let) binding:",103,null],[13,"StmtExpr","","Expr without trailing semi-colon (must have unit type):",103,null],[13,"StmtSemi","","Expr with trailing semi-colon (may have any type):",103,null],[4,"Decl_","","",null,null],[13,"DeclLocal","","A local (let) binding:",104,null],[13,"DeclItem","","An item binding:",104,null],[4,"BlockCheckMode","","",null,null],[13,"DefaultBlock","","",105,null],[13,"UnsafeBlock","","",105,null],[13,"PushUnsafeBlock","","",105,null],[13,"PopUnsafeBlock","","",105,null],[4,"UnsafeSource","","",null,null],[13,"CompilerGenerated","","",106,null],[13,"UserProvided","","",106,null],[4,"BodyOwnerKind","","",null,null],[13,"Fn","","Functions and methods.",107,null],[13,"Const","","Constants and associated constants.",107,null],[13,"Static","","Initializer of a `static` item.",107,null],[4,"Expr_","","",null,null],[13,"ExprBox","","A `box x` expression.",108,null],[13,"ExprArray","","An array (`[a, b, c, d]`)",108,null],[13,"ExprCall","","A function call",108,null],[13,"ExprMethodCall","","A method call (`x.foo::<'static, Bar, Baz>(a, b, c, d)`)",108,null],[13,"ExprTup","","A tuple (`(a, b, c ,d)`)",108,null],[13,"ExprBinary","","A binary operation (For example: `a + b`, `a * b`)",108,null],[13,"ExprUnary","","A unary operation (For example: `!x`, `*x`)",108,null],[13,"ExprLit","","A literal (For example: `1`, `\"foo\"`)",108,null],[13,"ExprCast","","A cast (`foo as f64`)",108,null],[13,"ExprType","","",108,null],[13,"ExprIf","","An `if` block, with an optional else block",108,null],[13,"ExprWhile","","A while loop, with an optional label",108,null],[13,"ExprLoop","","Conditionless loop (can be exited with break, continue, or return)",108,null],[13,"ExprMatch","","A `match` block, with a source that indicates whether or not it is the result of a desugaring, and if so, which kind.",108,null],[13,"ExprClosure","","A closure (for example, `move |a, b, c| {a + b + c}`).",108,null],[13,"ExprBlock","","A block (`{ ... }`)",108,null],[13,"ExprAssign","","An assignment (`a = foo()`)",108,null],[13,"ExprAssignOp","","An assignment with an operator",108,null],[13,"ExprField","","Access of a named (`obj.foo`) or unnamed (`obj.0`) struct or tuple field",108,null],[13,"ExprIndex","","An indexing operation (`foo[2]`)",108,null],[13,"ExprPath","","Path to a definition, possibly containing lifetime or type parameters.",108,null],[13,"ExprAddrOf","","A referencing operation (`&a` or `&mut a`)",108,null],[13,"ExprBreak","","A `break`, with an optional label to break",108,null],[13,"ExprAgain","","A `continue`, with an optional label",108,null],[13,"ExprRet","","A `return`, with an optional value to be returned",108,null],[13,"ExprInlineAsm","","Inline assembly (from `asm!`), with its outputs and inputs.",108,null],[13,"ExprStruct","","A struct or struct-like variant literal expression.",108,null],[13,"ExprRepeat","","An array literal constructed from one repeated element.",108,null],[13,"ExprYield","","A suspension point for generators. This is `yield <expr>` in Rust.",108,null],[4,"QPath","","Optionally `Self`-qualified value/type path or associated extension.",null,null],[13,"Resolved","","Path to a definition, optionally \"fully-qualified\" with a `Self` type, if the path points to an associated item in a trait.",109,null],[13,"TypeRelative","","Type-related paths, e.g. `<T>::default` or `<T>::Output`. Will be resolved by type-checking to an associated item.",109,null],[4,"LocalSource","","Hints at the original code for a let statement",null,null],[13,"Normal","","A `match _ { .. }`",110,null],[13,"ForLoopDesugar","","A desugared `for _ in _ { .. }` loop",110,null],[4,"MatchSource","","Hints at the original code for a `match _ { .. }`",null,null],[13,"Normal","","A `match _ { .. }`",111,null],[13,"IfLetDesugar","","An `if let _ = _ { .. }` (optionally with `else { .. }`)",111,null],[12,"contains_else_clause","rustc::hir::MatchSource","",111,null],[13,"WhileLetDesugar","rustc::hir","A `while let _ = _ { .. }` (which was desugared to a `loop { match _ { .. } }`)",111,null],[13,"ForLoopDesugar","","A desugared `for _ in _ { .. }` loop",111,null],[13,"TryDesugar","","A desugared `?` operator",111,null],[4,"LoopSource","","The loop type that yielded an ExprLoop",null,null],[13,"Loop","","A `loop { .. }` loop",112,null],[13,"WhileLet","","A `while let _ = _ { .. }` loop",112,null],[13,"ForLoop","","A `for _ in _ { .. }` loop",112,null],[4,"LoopIdError","","",null,null],[13,"OutsideLoopScope","","",113,null],[13,"UnlabeledCfInWhileCondition","","",113,null],[13,"UnresolvedLabel","","",113,null],[4,"LoopIdResult","","",null,null],[13,"Ok","","",114,null],[13,"Err","","",114,null],[4,"ScopeTarget","","",null,null],[13,"Block","","",115,null],[13,"Loop","","",115,null],[4,"GeneratorMovability","","",null,null],[13,"Static","","",116,null],[13,"Movable","","",116,null],[4,"CaptureClause","","",null,null],[13,"CaptureByValue","","",117,null],[13,"CaptureByRef","","",117,null],[4,"TraitMethod","","A trait method's body (or just argument names).",null,null],[13,"Required","","No default body in the trait, just a signature.",118,null],[13,"Provided","","Both signature and body are provided in the trait.",118,null],[4,"TraitItemKind","","Represents a trait method or associated constant or type",null,null],[13,"Const","","An associated constant with an optional value (otherwise `impl`s must contain a value)",119,null],[13,"Method","","A method with an optional body",119,null],[13,"Type","","An associated type with (possibly empty) bounds and optional concrete type",119,null],[4,"ImplItemKind","","Represents different contents within `impl`s",null,null],[13,"Const","","An associated constant of the given type, set to the constant result of the expression",120,null],[13,"Method","","A method implementation with the given signature and body",120,null],[13,"Type","","An associated type",120,null],[4,"PrimTy","","Not represented directly in the AST, referred to by name through a ty_path.",null,null],[13,"TyInt","","",121,null],[13,"TyUint","","",121,null],[13,"TyFloat","","",121,null],[13,"TyStr","","",121,null],[13,"TyBool","","",121,null],[13,"TyChar","","",121,null],[4,"Ty_","","The different kinds of types recognized by the compiler",null,null],[13,"TySlice","","A variable length slice (`[T]`)",122,null],[13,"TyArray","","A fixed length array (`[T; n]`)",122,null],[13,"TyPtr","","A raw pointer (`*const T` or `*mut T`)",122,null],[13,"TyRptr","","A reference (`&'a T` or `&'a mut T`)",122,null],[13,"TyBareFn","","A bare function (e.g. `fn(usize) -> bool`)",122,null],[13,"TyNever","","The never type (`!`)",122,null],[13,"TyTup","","A tuple (`(A, B, C, D,...)`)",122,null],[13,"TyPath","","A path to a type definition (`module::module::...::Type`), or an associated type, e.g. `<Vec<T> as Trait>::Type` or `<T>::Target`.",122,null],[13,"TyTraitObject","","A trait object type `Bound1 + Bound2 + Bound3` where `Bound` is a trait or a lifetime.",122,null],[13,"TyImplTraitExistential","","An existentially quantified (there exists a type satisfying) `impl Bound1 + Bound2 + Bound3` type where `Bound` is a trait or a lifetime.",122,null],[13,"TyTypeof","","Unused for now",122,null],[13,"TyInfer","","TyInfer means the type should be inferred instead of it having been specified. This can appear anywhere in a type.",122,null],[13,"TyErr","","Placeholder for a type that has failed to be defined.",122,null],[4,"IsAuto","","Is the trait definition an auto trait?",null,null],[13,"Yes","","",123,null],[13,"No","","",123,null],[4,"Unsafety","","",null,null],[13,"Unsafe","","",124,null],[13,"Normal","","",124,null],[4,"Constness","","",null,null],[13,"Const","","",125,null],[13,"NotConst","","",125,null],[4,"Defaultness","","",null,null],[13,"Default","","",126,null],[12,"has_value","rustc::hir::Defaultness","",126,null],[13,"Final","rustc::hir","",126,null],[4,"ImplPolarity","","",null,null],[13,"Positive","","`impl Trait for Type`",127,null],[13,"Negative","","`impl !Trait for Type`",127,null],[4,"FunctionRetTy","","",null,null],[13,"DefaultReturn","","Return type is not specified.",128,null],[13,"Return","","Everything else",128,null],[4,"UseKind","","",null,null],[13,"Single","","One import, e.g. `use foo::bar` or `use foo::bar as baz`. Also produced for each element of a list `use`, e.g.",129,null],[13,"Glob","","Glob import, e.g. `use foo::*`.",129,null],[13,"ListStem","","Degenerate list import, e.g. `use foo::{a, b}` produces an additional `use foo::{}` for performing checks such as unstable feature gating. May be removed in the future.",129,null],[4,"Visibility","","",null,null],[13,"Public","","",130,null],[13,"Crate","","",130,null],[13,"Restricted","","",130,null],[12,"path","rustc::hir::Visibility","",130,null],[12,"id","","",130,null],[13,"Inherited","rustc::hir","",130,null],[4,"VariantData","","Fields and Ids of enum variants and structs",null,null],[13,"Struct","","",131,null],[13,"Tuple","","",131,null],[13,"Unit","","",131,null],[4,"Item_","","",null,null],[13,"ItemExternCrate","","An `extern crate` item, with optional original crate name if the crate was renamed.",132,null],[13,"ItemUse","","`use foo::bar::*;` or `use foo::bar::baz as quux;`",132,null],[13,"ItemStatic","","A `static` item",132,null],[13,"ItemConst","","A `const` item",132,null],[13,"ItemFn","","A function declaration",132,null],[13,"ItemMod","","A module",132,null],[13,"ItemForeignMod","","An external module",132,null],[13,"ItemGlobalAsm","","Module-level inline assembly (from global_asm!)",132,null],[13,"ItemTy","","A type alias, e.g. `type Foo = Bar<u8>`",132,null],[13,"ItemEnum","","An enum definition, e.g. `enum Foo<A, B> {C<A>, D<B>}`",132,null],[13,"ItemStruct","","A struct definition, e.g. `struct Foo<A> {x: A}`",132,null],[13,"ItemUnion","","A union definition, e.g. `union Foo<A, B> {x: A, y: B}`",132,null],[13,"ItemTrait","","Represents a Trait Declaration",132,null],[13,"ItemTraitAlias","","Represents a Trait Alias Declaration",132,null],[13,"ItemImpl","","An implementation, eg `impl<A> Trait for Foo { .. }`",132,null],[4,"AssociatedItemKind","","",null,null],[13,"Const","","",133,null],[13,"Method","","",133,null],[12,"has_self","rustc::hir::AssociatedItemKind","",133,null],[13,"Type","rustc::hir","",133,null],[4,"ForeignItem_","","An item within an `extern` block",null,null],[13,"ForeignItemFn","","A foreign function",134,null],[13,"ForeignItemStatic","","A foreign static item (`static ext: u8`), with optional mutability (the boolean is true when mutable)",134,null],[13,"ForeignItemType","","A foreign type",134,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"check_attr","","This module implements some validity checks for attributes. In particular it verifies that `#[inline]` and `#[repr]` attributes are attached to items that actually support them and if there are conflicts between multiple such attributes attached to the same item.",null,null],[3,"CheckAttrVisitor","rustc::hir::check_attr","",null,null],[12,"tcx","","",135,null],[4,"Target","","",null,null],[13,"Fn","","",136,null],[13,"Struct","","",136,null],[13,"Union","","",136,null],[13,"Enum","","",136,null],[13,"Const","","",136,null],[13,"ForeignMod","","",136,null],[13,"Expression","","",136,null],[13,"Statement","","",136,null],[13,"Closure","","",136,null],[13,"Static","","",136,null],[13,"Other","","",136,null],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"is_c_like_enum","","",null,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"clone","","",136,{"inputs":[{"name":"self"}],"output":{"name":"target"}}],[11,"eq","","",136,{"inputs":[{"name":"self"},{"name":"target"}],"output":{"name":"bool"}}],[11,"from_item","","",136,{"inputs":[{"name":"item"}],"output":{"name":"target"}}],[11,"check_attributes","","Check any attribute.",135,{"inputs":[{"name":"self"},{"name":"item"},{"name":"target"}],"output":null}],[11,"check_inline","","Check if an `#[inline]` is applied to a function or a closure.",135,{"inputs":[{"name":"self"},{"name":"attribute"},{"name":"span"},{"name":"target"}],"output":null}],[11,"check_non_exhaustive","","Check if the `#[non_exhaustive]` attribute on an `item` is valid.",135,{"inputs":[{"name":"self"},{"name":"attribute"},{"name":"item"},{"name":"target"}],"output":null}],[11,"check_repr","","Check if the `#[repr]` attributes on `item` are valid.",135,{"inputs":[{"name":"self"},{"name":"item"},{"name":"target"}],"output":null}],[11,"emit_repr_error","","",135,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"check_stmt_attributes","","",135,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"check_expr_attributes","","",135,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"check_used","","",135,{"inputs":[{"name":"self"},{"name":"item"},{"name":"target"}],"output":null}],[11,"nested_visit_map","","",135,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",135,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_stmt","","",135,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_expr","","",135,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[0,"def","rustc::hir","",null,null],[3,"PathResolution","rustc::hir::def","The result of resolving a path before lowering to HIR. `base_def` is definition of resolved part of the path, `unresolved_segments` is the number of unresolved segments.",null,null],[12,"base_def","","",137,null],[12,"unresolved_segments","","",137,null],[3,"Export","","",null,null],[12,"ident","","The name of the target.",138,null],[12,"def","","The definition of the target.",138,null],[12,"span","","The span of the target definition.",138,null],[12,"vis","","The visibility of the export. We include non-`pub` exports for hygienic macros that get used from extern crates.",138,null],[12,"is_import","","True if from a `use` or and `extern crate`. Used in rustdoc.",138,null],[4,"CtorKind","","",null,null],[13,"Fn","","Constructor function automatically created by a tuple struct/variant.",139,null],[13,"Const","","Constructor constant automatically created by a unit struct/variant.",139,null],[13,"Fictive","","Unusable name in value namespace created by a struct variant.",139,null],[4,"Def","","",null,null],[13,"Mod","","",140,null],[13,"Struct","","",140,null],[13,"Union","","",140,null],[13,"Enum","","",140,null],[13,"Variant","","",140,null],[13,"Trait","","",140,null],[13,"TyAlias","","",140,null],[13,"TyForeign","","",140,null],[13,"TraitAlias","","",140,null],[13,"AssociatedTy","","",140,null],[13,"PrimTy","","",140,null],[13,"TyParam","","",140,null],[13,"SelfTy","","",140,null],[13,"Fn","","",140,null],[13,"Const","","",140,null],[13,"Static","","",140,null],[13,"StructCtor","","",140,null],[13,"VariantCtor","","",140,null],[13,"Method","","",140,null],[13,"AssociatedConst","","",140,null],[13,"Local","","",140,null],[13,"Upvar","","",140,null],[13,"Label","","",140,null],[13,"Macro","","",140,null],[13,"GlobalAsm","","",140,null],[13,"Err","","",140,null],[6,"DefMap","","Definition mapping",null,null],[6,"ExportMap","","This is the replacement export map. It maps a module to all of the exports within.",null,null],[11,"clone","","",139,{"inputs":[{"name":"self"}],"output":{"name":"ctorkind"}}],[11,"eq","","",139,{"inputs":[{"name":"self"},{"name":"ctorkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",139,null],[11,"encode","","",139,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",139,{"inputs":[{"name":"__d"}],"output":{"generics":["ctorkind"],"name":"result"}}],[11,"hash","","",139,null],[11,"fmt","","",139,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",140,{"inputs":[{"name":"self"}],"output":{"name":"def"}}],[11,"eq","","",140,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",140,null],[11,"encode","","",140,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",140,{"inputs":[{"name":"__d"}],"output":{"generics":["def"],"name":"result"}}],[11,"hash","","",140,null],[11,"fmt","","",140,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",137,{"inputs":[{"name":"self"}],"output":{"name":"pathresolution"}}],[11,"fmt","","",137,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",137,{"inputs":[{"name":"def"}],"output":{"name":"self"}}],[11,"with_unresolved_segments","","",137,{"inputs":[{"name":"def"},{"name":"usize"}],"output":{"name":"self"}}],[11,"base_def","","",137,{"inputs":[{"name":"self"}],"output":{"name":"def"}}],[11,"unresolved_segments","","",137,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"kind_name","","",137,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",138,{"inputs":[{"name":"self"}],"output":{"name":"export"}}],[11,"fmt","","",138,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",138,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",138,{"inputs":[{"name":"__d"}],"output":{"generics":["export"],"name":"result"}}],[11,"from_ast","","",139,{"inputs":[{"name":"variantdata"}],"output":{"name":"ctorkind"}}],[11,"from_hir","","",139,{"inputs":[{"name":"variantdata"}],"output":{"name":"ctorkind"}}],[11,"def_id","","",140,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"kind_name","","A human readable kind name",140,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[0,"def_id","rustc::hir","",null,null],[3,"CrateNum","rustc::hir::def_id","",null,null],[12,"0","","",141,null],[3,"DefIndex","","A DefIndex is an index into the hir-map for a crate, identifying a particular definition. It should really be considered an interned shorthand for a particular DefPath.",null,null],[12,"0","","",142,null],[3,"DefId","","A DefId identifies a particular definition, by combining a crate index and a def index.",null,null],[12,"krate","","",143,null],[12,"index","","",143,null],[3,"LocalDefId","","A LocalDefId is equivalent to a DefId with `krate == LOCAL_CRATE`. Since we encode this information in the type, we can ensure at compile time that no DefIds from upstream crates get thrown into the mix. There are quite a few cases where we know that only DefIds from the local crate are expected and a DefId from a different crate would signify a bug somewhere. This is when LocalDefId comes in handy.",null,null],[12,"0","","",144,null],[4,"DefIndexAddressSpace","","",null,null],[13,"Low","","",145,null],[13,"High","","",145,null],[17,"LOCAL_CRATE","","Item definitions in the currently-compiled crate would have the CrateNum LOCAL_CRATE in their DefId.",null,null],[17,"BUILTIN_MACROS_CRATE","","Virtual crate for builtin macros",null,null],[17,"INVALID_CRATE","","A CrateNum value that indicates that something is wrong.",null,null],[17,"RESERVED_FOR_INCR_COMP_CACHE","","A special CrateNum that we use for the tcx.rcache when decoding from the incr. comp. cache.",null,null],[17,"CRATE_DEF_INDEX","","The crate root is always assigned index 0 by the AST Map code, thanks to `NodeCollector::new`.",null,null],[11,"clone","","",141,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"eq","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",141,null],[11,"hash","","",141,null],[11,"partial_cmp","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"le","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"gt","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"ge","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"cmp","","",141,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"ordering"}}],[11,"new","","",141,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",141,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",141,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",141,{"inputs":[{"name":"usize"}],"output":{"name":"cratenum"}}],[11,"from_u32","","",141,{"inputs":[{"name":"u32"}],"output":{"name":"cratenum"}}],[11,"as_usize","","",141,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"as_u32","","",141,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"as_def_id","","",141,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"fmt","","",141,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",142,{"inputs":[{"name":"self"}],"output":{"name":"defindex"}}],[11,"assert_receiver_is_total_eq","","",142,null],[11,"cmp","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"le","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"gt","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"ge","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"eq","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"hash","","",142,null],[11,"fmt","","",142,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"address_space","","",142,{"inputs":[{"name":"self"}],"output":{"name":"defindexaddressspace"}}],[11,"as_array_index","","Converts this DefIndex into a zero-based array index. This index is the offset within the given DefIndexAddressSpace.",142,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"from_array_index","","",142,{"inputs":[{"name":"usize"},{"name":"defindexaddressspace"}],"output":{"name":"defindex"}}],[11,"from_proc_macro_index","","",142,{"inputs":[{"name":"usize"}],"output":{"name":"defindex"}}],[11,"to_proc_macro_index","","",142,{"inputs":[{"name":"defindex"}],"output":{"name":"usize"}}],[11,"from_raw_u32","","",142,{"inputs":[{"name":"u32"}],"output":{"name":"defindex"}}],[11,"as_raw_u32","","",142,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"clone","","",145,{"inputs":[{"name":"self"}],"output":{"name":"defindexaddressspace"}}],[11,"assert_receiver_is_total_eq","","",145,null],[11,"eq","","",145,{"inputs":[{"name":"self"},{"name":"defindexaddressspace"}],"output":{"name":"bool"}}],[11,"hash","","",145,null],[11,"index","","",145,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",143,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"assert_receiver_is_total_eq","","",143,null],[11,"cmp","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"le","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"gt","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ge","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"eq","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ne","","",143,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"hash","","",143,null],[11,"fmt","","",143,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"local","","Make a local `DefId` with the given index.",143,{"inputs":[{"name":"defindex"}],"output":{"name":"defid"}}],[11,"is_local","","",143,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"to_local","","",143,{"inputs":[{"name":"self"}],"output":{"name":"localdefid"}}],[11,"clone","","",144,{"inputs":[{"name":"self"}],"output":{"name":"localdefid"}}],[11,"assert_receiver_is_total_eq","","",144,null],[11,"eq","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"bool"}}],[11,"ne","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"bool"}}],[11,"cmp","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"bool"}}],[11,"le","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"bool"}}],[11,"gt","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"bool"}}],[11,"ge","","",144,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"bool"}}],[11,"hash","","",144,null],[11,"from_def_id","","",144,{"inputs":[{"name":"defid"}],"output":{"name":"localdefid"}}],[11,"to_def_id","","",144,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"fmt","","",144,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"intravisit","rustc::hir","HIR walker for walking the contents of nodes.",null,null],[3,"IdRange","rustc::hir::intravisit","",null,null],[12,"min","","",146,null],[12,"max","","",146,null],[3,"IdRangeComputingVisitor","","",null,null],[12,"result","","",147,null],[12,"map","","",147,null],[4,"FnKind","","",null,null],[13,"ItemFn","","fn foo() or extern \"Abi\" fn foo()",148,null],[13,"Method","","fn foo(&self)",148,null],[13,"Closure","","|x, y| {}",148,null],[4,"NestedVisitorMap","","Specifies what nested things a visitor wants to visit. The most common choice is `OnlyBodies`, which will cause the visitor to visit fn bodies for fns that it encounters, but skip over nested item-like things.",null,null],[13,"None","","Do not visit any nested things. When you add a new \"non-nested\" thing, you will want to audit such uses to see if they remain valid.",149,null],[13,"OnlyBodies","","Do not visit nested item-like things, but visit nested things that are inside of an item-like.",149,null],[13,"All","","Visit all nested things, including item-likes.",149,null],[5,"walk_crate","","Walks the contents of a crate. See also `Crate::visit_all_items`.",null,{"inputs":[{"name":"v"},{"name":"crate"}],"output":null}],[5,"walk_macro_def","","",null,{"inputs":[{"name":"v"},{"name":"macrodef"}],"output":null}],[5,"walk_mod","","",null,{"inputs":[{"name":"v"},{"name":"mod"},{"name":"nodeid"}],"output":null}],[5,"walk_body","","",null,{"inputs":[{"name":"v"},{"name":"body"}],"output":null}],[5,"walk_local","","",null,{"inputs":[{"name":"v"},{"name":"local"}],"output":null}],[5,"walk_label","","",null,{"inputs":[{"name":"v"},{"name":"label"}],"output":null}],[5,"walk_lifetime","","",null,{"inputs":[{"name":"v"},{"name":"lifetime"}],"output":null}],[5,"walk_poly_trait_ref","","",null,{"inputs":[{"name":"v"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[5,"walk_trait_ref","","",null,{"inputs":[{"name":"v"},{"name":"traitref"}],"output":null}],[5,"walk_item","","",null,{"inputs":[{"name":"v"},{"name":"item"}],"output":null}],[5,"walk_enum_def","","",null,{"inputs":[{"name":"v"},{"name":"enumdef"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[5,"walk_variant","","",null,{"inputs":[{"name":"v"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[5,"walk_ty","","",null,{"inputs":[{"name":"v"},{"name":"ty"}],"output":null}],[5,"walk_qpath","","",null,{"inputs":[{"name":"v"},{"name":"qpath"},{"name":"nodeid"},{"name":"span"}],"output":null}],[5,"walk_path","","",null,{"inputs":[{"name":"v"},{"name":"path"}],"output":null}],[5,"walk_path_segment","","",null,{"inputs":[{"name":"v"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[5,"walk_path_parameters","","",null,{"inputs":[{"name":"v"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[5,"walk_assoc_type_binding","","",null,{"inputs":[{"name":"v"},{"name":"typebinding"}],"output":null}],[5,"walk_pat","","",null,{"inputs":[{"name":"v"},{"name":"pat"}],"output":null}],[5,"walk_foreign_item","","",null,{"inputs":[{"name":"v"},{"name":"foreignitem"}],"output":null}],[5,"walk_ty_param_bound","","",null,{"inputs":[{"name":"v"},{"name":"typarambound"}],"output":null}],[5,"walk_generic_param","","",null,{"inputs":[{"name":"v"},{"name":"genericparam"}],"output":null}],[5,"walk_generics","","",null,{"inputs":[{"name":"v"},{"name":"generics"}],"output":null}],[5,"walk_where_predicate","","",null,{"inputs":[{"name":"v"},{"name":"wherepredicate"}],"output":null}],[5,"walk_fn_ret_ty","","",null,{"inputs":[{"name":"v"},{"name":"functionretty"}],"output":null}],[5,"walk_fn_decl","","",null,{"inputs":[{"name":"v"},{"name":"fndecl"}],"output":null}],[5,"walk_fn_kind","","",null,{"inputs":[{"name":"v"},{"name":"fnkind"}],"output":null}],[5,"walk_fn","","",null,{"inputs":[{"name":"v"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[5,"walk_trait_item","","",null,{"inputs":[{"name":"v"},{"name":"traititem"}],"output":null}],[5,"walk_trait_item_ref","","",null,{"inputs":[{"name":"v"},{"name":"traititemref"}],"output":null}],[5,"walk_impl_item","","",null,{"inputs":[{"name":"v"},{"name":"implitem"}],"output":null}],[5,"walk_impl_item_ref","","",null,{"inputs":[{"name":"v"},{"name":"implitemref"}],"output":null}],[5,"walk_struct_def","","",null,{"inputs":[{"name":"v"},{"name":"variantdata"}],"output":null}],[5,"walk_struct_field","","",null,{"inputs":[{"name":"v"},{"name":"structfield"}],"output":null}],[5,"walk_block","","",null,{"inputs":[{"name":"v"},{"name":"block"}],"output":null}],[5,"walk_stmt","","",null,{"inputs":[{"name":"v"},{"name":"stmt"}],"output":null}],[5,"walk_decl","","",null,{"inputs":[{"name":"v"},{"name":"decl"}],"output":null}],[5,"walk_expr","","",null,{"inputs":[{"name":"v"},{"name":"expr"}],"output":null}],[5,"walk_arm","","",null,{"inputs":[{"name":"v"},{"name":"arm"}],"output":null}],[5,"walk_vis","","",null,{"inputs":[{"name":"v"},{"name":"visibility"}],"output":null}],[5,"walk_associated_item_kind","","",null,{"inputs":[{"name":"v"},{"name":"associateditemkind"}],"output":null}],[5,"walk_defaultness","","",null,{"inputs":[{"name":"v"},{"name":"defaultness"}],"output":null}],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially overridden.  Each method's default implementation recursively visits the substructure of the input via the corresponding `walk` method; e.g. the `visit_mod` method by default calls `intravisit::walk_mod`.",null,null],[10,"nested_visit_map","","The default versions of the `visit_nested_XXX` routines invoke this method to get a map to use. By selecting an enum variant, you control which kinds of nested HIR are visited; see `NestedVisitorMap` for details. By \"nested HIR\", we are referring to bits of HIR that are not directly embedded within one another but rather indirectly, through a table in the crate. This is done to control dependencies during incremental compilation: the non-inline bits of HIR can be tracked and hashed separately.",150,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_item","","Invoked when a nested item is encountered. By default does nothing unless you override `nested_visit_map` to return `Some(_)`, in which case it will walk the item. You probably don't want to override this method -- instead, override `nested_visit_map` or use the \"shallow\" or \"deep\" visit patterns described on `itemlikevisit::ItemLikeVisitor`. The only reason to override this method is if you want a nested pattern but cannot supply a `Map`; see `nested_visit_map` for advice.",150,{"inputs":[{"name":"self"},{"name":"itemid"}],"output":null}],[11,"visit_nested_trait_item","","Like `visit_nested_item()`, but for trait items. See `visit_nested_item()` for advice on when to override this method.",150,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":null}],[11,"visit_nested_impl_item","","Like `visit_nested_item()`, but for impl items. See `visit_nested_item()` for advice on when to override this method.",150,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":null}],[11,"visit_nested_body","","Invoked to visit the body of a function, method or closure. Like visit_nested_item, does nothing by default unless you override `nested_visit_map` to return `Some(_)`, in which case it will walk the body.",150,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_item","","Visit the top-level item and (optionally) nested items / impl items. See `visit_nested_item` for details.",150,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_body","","",150,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"as_deep_visitor","","When invoking `visit_all_item_likes()`, you need to supply an item-like visitor.  This method converts a \"intra-visit\" visitor into an item-like visitor that walks the entire tree. If you use this, you probably don't want to process the contents of nested item-like things, since the outer loop will visit them as well.",150,{"inputs":[{"name":"self"}],"output":{"name":"deepvisitor"}}],[11,"visit_id","","",150,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"visit_def_mention","","",150,{"inputs":[{"name":"self"},{"name":"def"}],"output":null}],[11,"visit_name","","",150,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":null}],[11,"visit_mod","","",150,{"inputs":[{"name":"self"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_foreign_item","","",150,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_local","","",150,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",150,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",150,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_arm","","",150,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",150,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_decl","","",150,{"inputs":[{"name":"self"},{"name":"decl"}],"output":null}],[11,"visit_expr","","",150,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",150,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_generic_param","","",150,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"visit_generics","","",150,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_where_predicate","","",150,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":null}],[11,"visit_fn_decl","","",150,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":null}],[11,"visit_fn","","",150,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",150,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_trait_item_ref","","",150,{"inputs":[{"name":"self"},{"name":"traititemref"}],"output":null}],[11,"visit_impl_item","","",150,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_impl_item_ref","","",150,{"inputs":[{"name":"self"},{"name":"implitemref"}],"output":null}],[11,"visit_trait_ref","","",150,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_ty_param_bound","","",150,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":null}],[11,"visit_poly_trait_ref","","",150,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_variant_data","","",150,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"name"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_struct_field","","",150,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_enum_def","","",150,{"inputs":[{"name":"self"},{"name":"enumdef"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_variant","","",150,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_label","","",150,{"inputs":[{"name":"self"},{"name":"label"}],"output":null}],[11,"visit_lifetime","","",150,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_qpath","","",150,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_path","","",150,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_path_segment","","",150,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[11,"visit_path_parameters","","",150,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[11,"visit_assoc_type_binding","","",150,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":null}],[11,"visit_attribute","","",150,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_macro_def","","",150,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"visit_vis","","",150,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":null}],[11,"visit_associated_item_kind","","",150,{"inputs":[{"name":"self"},{"name":"associateditemkind"}],"output":null}],[11,"visit_defaultness","","",150,{"inputs":[{"name":"self"},{"name":"defaultness"}],"output":null}],[11,"clone","","",148,{"inputs":[{"name":"self"}],"output":{"name":"fnkind"}}],[11,"eq","","",148,{"inputs":[{"name":"self"},{"name":"fnkind"}],"output":{"name":"bool"}}],[11,"ne","","",148,{"inputs":[{"name":"self"},{"name":"fnkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",148,null],[11,"attrs","","",148,null],[11,"intra","","Returns the map to use for an \"intra item-like\" thing (if any). e.g., function body.",149,{"inputs":[{"name":"self"}],"output":{"generics":["map"],"name":"option"}}],[11,"inter","","Returns the map to use for an \"item-like\" thing (if any). e.g., item, impl-item.",149,{"inputs":[{"name":"self"}],"output":{"generics":["map"],"name":"option"}}],[11,"clone","","",146,{"inputs":[{"name":"self"}],"output":{"name":"idrange"}}],[11,"encode","","",146,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",146,{"inputs":[{"name":"__d"}],"output":{"generics":["idrange"],"name":"result"}}],[11,"fmt","","",146,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",146,{"inputs":[{"name":"self"},{"name":"idrange"}],"output":{"name":"bool"}}],[11,"ne","","",146,{"inputs":[{"name":"self"},{"name":"idrange"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",146,null],[11,"max","","",146,{"inputs":[],"output":{"name":"idrange"}}],[11,"empty","","",146,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"contains","","",146,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"add","","",146,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"new","","",147,{"inputs":[{"name":"map"}],"output":{"name":"idrangecomputingvisitor"}}],[11,"result","","",147,{"inputs":[{"name":"self"}],"output":{"name":"idrange"}}],[11,"nested_visit_map","","",147,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_id","","",147,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[0,"itemlikevisit","rustc::hir","",null,null],[3,"DeepVisitor","rustc::hir::itemlikevisit","",null,null],[12,"visitor","","",151,null],[8,"ItemLikeVisitor","","The \"item-like visitor\" visitor defines only the top-level methods that can be invoked by `Crate::visit_all_item_likes()`. Whether this trait is the right one to implement will depend on the overall pattern you need. Here are the three available patterns, in roughly the order of desirability:",null,null],[10,"visit_item","","",152,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[10,"visit_trait_item","","",152,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[10,"visit_impl_item","","",152,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"new","","",151,{"inputs":[{"name":"v"}],"output":{"name":"self"}}],[11,"visit_item","","",151,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",151,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",151,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"lowering","rustc::hir","Lowers the AST to the HIR.",null,null],[3,"LoweringContext","rustc::hir::lowering","",null,null],[12,"crate_root","","",153,null],[12,"sess","","",153,null],[12,"cstore","","",153,null],[12,"parent_def","","",153,null],[12,"resolver","","",153,null],[12,"name_map","","",153,null],[12,"items","","The items being lowered are collected here.",153,null],[12,"trait_items","","",153,null],[12,"impl_items","","",153,null],[12,"bodies","","",153,null],[12,"exported_macros","","",153,null],[12,"trait_impls","","",153,null],[12,"trait_auto_impl","","",153,null],[12,"is_generator","","",153,null],[12,"catch_scopes","","",153,null],[12,"loop_scopes","","",153,null],[12,"is_in_loop_condition","","",153,null],[12,"is_in_trait_impl","","",153,null],[12,"anonymous_lifetime_mode","","What to do when we encounter either an \"anonymous lifetime reference\". The term \"anonymous\" is meant to encompass both `'_` lifetimes as well as fully elided cases where nothing is written at all (e.g., `&T` or `std::cell::Ref<T>`).",153,null],[12,"in_band_ty_params","","",153,null],[12,"lifetimes_to_define","","",153,null],[12,"is_collecting_in_band_lifetimes","","",153,null],[12,"in_scope_lifetimes","","",153,null],[12,"type_def_lifetime_params","","",153,null],[12,"current_hir_id_owner","","",153,null],[12,"item_local_id_counters","","",153,null],[12,"node_id_to_hir_id","","",153,null],[3,"LoweredNodeId","","",null,null],[12,"node_id","","",154,null],[12,"hir_id","","",154,null],[4,"ImplTraitContext","","",null,null],[13,"Universal","","Treat `impl Trait` as shorthand for a new universal generic parameter. Example: `fn foo(x: impl Debug)`, where `impl Debug` is conceptually equivalent to a fresh universal parameter like `fn foo<T: Debug>(x: T)`.",155,null],[13,"Existential","","Treat `impl Trait` as shorthand for a new universal existential parameter. Example: `fn foo() -> impl Debug`, where `impl Debug` is conceptually equivalent to a fresh existential parameter like `abstract type T; fn foo() -> T`.",155,null],[13,"Disallowed","","`impl Trait` is not accepted in this position.",155,null],[4,"ParamMode","","",null,null],[13,"Explicit","","Any path in a type context.",156,null],[13,"Optional","","The `module::Type` in `module::Type::method` in an expression.",156,null],[4,"ParenthesizedGenericArgs","","",null,null],[13,"Ok","","",157,null],[13,"Warn","","",157,null],[13,"Err","","",157,null],[4,"AnonymousLifetimeMode","","What to do when we encounter an anonymous lifetime reference. Anonymous lifetime references come in two flavors.  You have implicit, or fully elided, references to lifetimes, like the one in `&T` or `Ref<T>`, and you have `'_` lifetimes, like `&'_ T` or `Ref<'_, T>`.  These often behave the same, but not always:",null,null],[13,"CreateParameter","","For Modern cases, create a new anonymous region parameter and reference that.",158,null],[13,"PassThrough","","Pass responsibility to `resolve_lifetime` code for all cases.",158,null],[5,"lower_crate","","",null,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"depgraph"},{"name":"crate"},{"name":"resolver"}],"output":{"name":"crate"}}],[5,"body_ids","","",null,{"inputs":[{"name":"btreemap"}],"output":{"generics":["bodyid"],"name":"vec"}}],[17,"HIR_ID_COUNTER_LOCKED","","",null,null],[8,"Resolver","","",null,null],[10,"resolve_hir_path","","Resolve a hir path generated by the lowerer when expanding `for`, `if let`, etc.",159,{"inputs":[{"name":"self"},{"name":"path"},{"name":"bool"}],"output":null}],[10,"get_resolution","","Obtain the resolution for a node id",159,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["pathresolution"],"name":"option"}}],[10,"definitions","","We must keep the set of definitions up to date as we add nodes that weren't in the AST. This should only return `None` during testing.",159,{"inputs":[{"name":"self"}],"output":{"name":"definitions"}}],[10,"resolve_str_path","","Given suffix [\"b\",\"c\",\"d\"], creates a HIR path for `[::crate_root]::b::c::d` and resolves it based on `is_value`.",159,null],[11,"clone","","",155,{"inputs":[{"name":"self"}],"output":{"name":"impltraitcontext"}}],[11,"fmt","","",155,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",156,{"inputs":[{"name":"self"}],"output":{"name":"parammode"}}],[11,"eq","","",156,{"inputs":[{"name":"self"},{"name":"parammode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",156,null],[11,"clone","","",158,{"inputs":[{"name":"self"}],"output":{"name":"anonymouslifetimemode"}}],[11,"lower_crate","","",153,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"allocate_hir_id_counter","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"t"}],"output":null}],[11,"lower_node_id_generic","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"lowerednodeid"}}],[11,"with_hir_id_owner","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"lower_node_id","","This method allocates a new HirId for the given NodeId and stores it in the LoweringContext's NodeId => HirId map. Take care not to call this method if the resulting HirId is then not actually used in the HIR, as that would trigger an assertion in the HirIdValidator later on, which makes sure that all NodeIds got mapped properly. Calling the method twice with the same NodeId is fine though.",153,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"lowerednodeid"}}],[11,"lower_node_id_with_owner","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"nodeid"}],"output":{"name":"lowerednodeid"}}],[11,"record_body","","",153,{"inputs":[{"name":"self"},{"name":"expr"},{"generics":["fndecl"],"name":"option"}],"output":{"name":"bodyid"}}],[11,"next_id","","",153,{"inputs":[{"name":"self"}],"output":{"name":"lowerednodeid"}}],[11,"expect_full_def","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"def"}}],[11,"diagnostic","","",153,{"inputs":[{"name":"self"}],"output":{"name":"handler"}}],[11,"str_to_ident","","",153,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"name"}}],[11,"allow_internal_unstable","","",153,{"inputs":[{"name":"self"},{"name":"compilerdesugaringkind"},{"name":"span"}],"output":{"name":"span"}}],[11,"collect_in_band_defs","","Creates a new hir::GenericParam for every new lifetime and type parameter encountered while evaluating `f`. Definitions are created with the parent provided. If no `parent_id` is provided, no definitions will be returned.",153,null],[11,"maybe_collect_in_band_lifetime","","When there is a reference to some lifetime `'a`, and in-band lifetimes are enabled, then we want to push that lifetime into the vector of names to define later. In that case, it will get added to the appropriate generics.",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":null}],[11,"collect_fresh_in_band_lifetime","","When we have either an elided or `'_` lifetime in an impl header, we convert it to",153,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"lifetimename"}}],[11,"with_in_scope_lifetime_defs","","",153,null],[11,"with_parent_impl_lifetime_defs","","",153,null],[11,"add_in_band_defs","","Appends in-band lifetime defs and argument-position `impl Trait` defs to the existing set of generics.",153,null],[11,"with_catch_scope","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[11,"lower_body","","",153,{"inputs":[{"name":"self"},{"generics":["fndecl"],"name":"option"},{"name":"f"}],"output":{"name":"bodyid"}}],[11,"with_loop_scope","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[11,"with_loop_condition_scope","","",153,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"t"}}],[11,"with_new_scopes","","",153,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"t"}}],[11,"with_parent_def","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[11,"def_key","","",153,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defkey"}}],[11,"lower_ident","","",153,{"inputs":[{"name":"self"},{"name":"ident"}],"output":{"name":"name"}}],[11,"lower_label","","",153,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"}],"output":{"generics":["label"],"name":"option"}}],[11,"lower_loop_destination","","",153,{"inputs":[{"name":"self"},{"name":"option"}],"output":{"name":"destination"}}],[11,"lower_attrs","","",153,null],[11,"lower_attr","","",153,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"lower_token_stream","","",153,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[11,"lower_token_tree","","",153,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"tokenstream"}}],[11,"lower_token","","",153,{"inputs":[{"name":"self"},{"name":"token"},{"name":"span"}],"output":{"name":"tokenstream"}}],[11,"lower_arm","","",153,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"arm"}}],[11,"lower_ty_binding","","",153,{"inputs":[{"name":"self"},{"name":"typebinding"},{"name":"impltraitcontext"}],"output":{"name":"typebinding"}}],[11,"lower_ty","","",153,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"impltraitcontext"}],"output":{"generics":["ty"],"name":"p"}}],[11,"lifetimes_from_impl_trait_bounds","","",153,null],[11,"lower_foreign_mod","","",153,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"lower_global_asm","","",153,{"inputs":[{"name":"self"},{"name":"globalasm"}],"output":{"generics":["globalasm"],"name":"p"}}],[11,"lower_variant","","",153,{"inputs":[{"name":"self"},{"name":"variant"}],"output":{"name":"variant"}}],[11,"lower_qpath","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"option"},{"name":"path"},{"name":"parammode"},{"name":"impltraitcontext"}],"output":{"name":"qpath"}}],[11,"lower_path_extra","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"path"},{"generics":["name"],"name":"option"},{"name":"parammode"}],"output":{"name":"path"}}],[11,"lower_path","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"path"},{"name":"parammode"}],"output":{"name":"path"}}],[11,"lower_path_segment","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathsegment"},{"name":"parammode"},{"name":"usize"},{"name":"parenthesizedgenericargs"},{"name":"impltraitcontext"}],"output":{"name":"pathsegment"}}],[11,"lower_angle_bracketed_parameter_data","","",153,null],[11,"lower_parenthesized_parameter_data","","",153,null],[11,"lower_local","","",153,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"generics":["local"],"name":"p"}}],[11,"lower_mutability","","",153,{"inputs":[{"name":"self"},{"name":"mutability"}],"output":{"name":"mutability"}}],[11,"lower_arg","","",153,{"inputs":[{"name":"self"},{"name":"arg"}],"output":{"name":"arg"}}],[11,"lower_fn_args_to_names","","",153,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"generics":["spanned"],"name":"hirvec"}}],[11,"lower_fn_decl","","",153,{"inputs":[{"name":"self"},{"name":"fndecl"},{"generics":["defid"],"name":"option"},{"name":"bool"}],"output":{"generics":["fndecl"],"name":"p"}}],[11,"lower_ty_param_bound","","",153,{"inputs":[{"name":"self"},{"name":"typarambound"},{"name":"impltraitcontext"}],"output":{"name":"typarambound"}}],[11,"lower_ty_param","","",153,null],[11,"lower_lifetime","","",153,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"new_named_lifetime","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"lifetimename"}],"output":{"name":"lifetime"}}],[11,"lower_lifetime_def","","",153,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"lifetimedef"}}],[11,"lower_lifetimes","","",153,{"inputs":[{"name":"self"},{"name":"vec"}],"output":{"generics":["lifetime"],"name":"hirvec"}}],[11,"lower_generic_params","","",153,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"nodemap"},{"name":"impltraitcontext"}],"output":{"generics":["genericparam"],"name":"hirvec"}}],[11,"lower_generics","","",153,{"inputs":[{"name":"self"},{"name":"generics"},{"name":"impltraitcontext"}],"output":{"name":"generics"}}],[11,"lower_where_clause","","",153,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"whereclause"}}],[11,"lower_where_predicate","","",153,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"lower_variant_data","","",153,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"variantdata"}}],[11,"lower_trait_ref","","",153,{"inputs":[{"name":"self"},{"name":"traitref"},{"name":"impltraitcontext"}],"output":{"name":"traitref"}}],[11,"lower_poly_trait_ref","","",153,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"impltraitcontext"}],"output":{"name":"polytraitref"}}],[11,"lower_struct_field","","",153,null],[11,"lower_field","","",153,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"field"}}],[11,"lower_mt","","",153,{"inputs":[{"name":"self"},{"name":"mutty"},{"name":"impltraitcontext"}],"output":{"name":"mutty"}}],[11,"lower_bounds","","",153,null],[11,"lower_block","","",153,{"inputs":[{"name":"self"},{"name":"block"},{"name":"bool"}],"output":{"generics":["block"],"name":"p"}}],[11,"lower_item_kind","","",153,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"name"},{"name":"hirvec"},{"name":"visibility"},{"name":"itemkind"}],"output":{"name":"item_"}}],[11,"lower_use_tree","","",153,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"path"},{"name":"nodeid"},{"name":"visibility"},{"name":"name"},{"name":"hirvec"}],"output":{"name":"item_"}}],[11,"lower_trait_item","","",153,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"traititem"}}],[11,"lower_trait_item_ref","","",153,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"traititemref"}}],[11,"lower_impl_item","","",153,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"implitem"}}],[11,"lower_impl_item_ref","","",153,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"implitemref"}}],[11,"lower_mod","","",153,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"lower_item_id","","",153,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"generics":["itemid"],"name":"smallvector"}}],[11,"lower_item_id_use_tree","","",153,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"smallvector"}],"output":null}],[11,"lower_item","","",153,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"generics":["item"],"name":"option"}}],[11,"lower_foreign_item","","",153,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"foreignitem"}}],[11,"lower_method_sig","","",153,{"inputs":[{"name":"self"},{"name":"methodsig"},{"name":"defid"},{"name":"bool"}],"output":{"name":"methodsig"}}],[11,"lower_is_auto","","",153,{"inputs":[{"name":"self"},{"name":"isauto"}],"output":{"name":"isauto"}}],[11,"lower_unsafety","","",153,{"inputs":[{"name":"self"},{"name":"unsafety"}],"output":{"name":"unsafety"}}],[11,"lower_constness","","",153,{"inputs":[{"name":"self"},{"generics":["constness"],"name":"spanned"}],"output":{"name":"constness"}}],[11,"lower_unop","","",153,{"inputs":[{"name":"self"},{"name":"unop"}],"output":{"name":"unop"}}],[11,"lower_binop","","",153,{"inputs":[{"name":"self"},{"name":"binop"}],"output":{"name":"binop"}}],[11,"lower_pat","","",153,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"generics":["pat"],"name":"p"}}],[11,"lower_range_end","","",153,{"inputs":[{"name":"self"},{"name":"rangeend"}],"output":{"name":"rangeend"}}],[11,"lower_expr","","",153,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"expr"}}],[11,"lower_stmt","","",153,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"lower_capture_clause","","",153,{"inputs":[{"name":"self"},{"name":"captureby"}],"output":{"name":"captureclause"}}],[11,"lower_visibility","","If an `explicit_owner` is given, this method allocates the `HirId` in the address space of that item instead of the item currently being lowered. This can happen during `lower_impl_item_ref()` where we need to lower a `Visibility` value although we haven't lowered the owning `ImplItem` in question yet.",153,{"inputs":[{"name":"self"},{"name":"visibility"},{"generics":["nodeid"],"name":"option"}],"output":{"name":"visibility"}}],[11,"lower_defaultness","","",153,{"inputs":[{"name":"self"},{"name":"defaultness"},{"name":"bool"}],"output":{"name":"defaultness"}}],[11,"lower_block_check_mode","","",153,{"inputs":[{"name":"self"},{"name":"blockcheckmode"}],"output":{"name":"blockcheckmode"}}],[11,"lower_binding_mode","","",153,{"inputs":[{"name":"self"},{"name":"bindingmode"}],"output":{"name":"bindingannotation"}}],[11,"lower_unsafe_source","","",153,{"inputs":[{"name":"self"},{"name":"unsafesource"}],"output":{"name":"unsafesource"}}],[11,"lower_impl_polarity","","",153,{"inputs":[{"name":"self"},{"name":"implpolarity"}],"output":{"name":"implpolarity"}}],[11,"lower_trait_bound_modifier","","",153,{"inputs":[{"name":"self"},{"name":"traitboundmodifier"}],"output":{"name":"traitboundmodifier"}}],[11,"arm","","",153,{"inputs":[{"name":"self"},{"generics":["p"],"name":"hirvec"},{"generics":["expr"],"name":"p"}],"output":{"name":"arm"}}],[11,"field","","",153,{"inputs":[{"name":"self"},{"name":"name"},{"generics":["expr"],"name":"p"},{"name":"span"}],"output":{"name":"field"}}],[11,"expr_break","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_call","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"hirvec"}],"output":{"name":"expr"}}],[11,"expr_ident","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"nodeid"}],"output":{"name":"expr"}}],[11,"expr_ident_with_attrs","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"nodeid"},{"generics":["attribute"],"name":"thinvec"}],"output":{"name":"expr"}}],[11,"expr_mut_addr_of","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"name":"expr"}}],[11,"expr_std_path","","",153,null],[11,"expr_match","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["arm"],"name":"hirvec"},{"name":"matchsource"}],"output":{"name":"expr"}}],[11,"expr_block","","",153,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"},{"generics":["attribute"],"name":"thinvec"}],"output":{"name":"expr"}}],[11,"expr_tuple","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"hirvec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"expr_"},{"generics":["attribute"],"name":"thinvec"}],"output":{"name":"expr"}}],[11,"stmt_let_pat","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"option"},{"generics":["pat"],"name":"p"},{"name":"localsource"}],"output":{"name":"stmt"}}],[11,"stmt_let","","",153,null],[11,"block_expr","","",153,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"name":"block"}}],[11,"block_all","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"hirvec"},{"generics":["p"],"name":"option"}],"output":{"name":"block"}}],[11,"pat_ok","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_err","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_some","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_none","","",153,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_std_enum","","",153,null],[11,"pat_ident","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_ident_binding_mode","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"bindingannotation"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_wild","","",153,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"patkind"}],"output":{"generics":["pat"],"name":"p"}}],[11,"std_path","","Given suffix [\"b\",\"c\",\"d\"], returns path `::std::b::c::d` when `fld.cx.use_std`, and `::core::b::c::d` otherwise. The path is also resolved according to `is_value`.",153,null],[11,"ty_path","","",153,{"inputs":[{"name":"self"},{"name":"lowerednodeid"},{"name":"span"},{"name":"qpath"}],"output":{"generics":["ty"],"name":"p"}}],[11,"elided_ref_lifetime","","Invoked to create the lifetime argument for a type `&T` with no explicit lifetime.",153,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"lifetime"}}],[11,"elided_path_lifetimes","","Invoked to create the lifetime argument(s) for a path like `std::cell::Ref<T>`; note that implicit lifetimes in these sorts of cases are deprecated. This may therefore report a warning or an error, depending on the mode.",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"}],"output":{"name":"p"}}],[11,"elided_dyn_bound","","Invoked to create the lifetime argument(s) for an elided trait object bound, like the bound in `Box<dyn Debug>`. This method is not invoked when the bound is written, even if it is written with `'_` like in `Box<dyn Debug + '_>`. In those cases, `lower_lifetime` is invoked.",153,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"lifetime"}}],[11,"new_implicit_lifetime","","",153,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"lifetime"}}],[11,"maybe_lint_bare_trait","","",153,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"wrap_in_try_constructor","","",153,{"inputs":[{"name":"self"},{"name":"str"},{"name":"expr"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[0,"map","rustc::hir","",null,null],[3,"DefCollector","rustc::hir::map","Creates def ids for nodes in the AST.",null,null],[12,"definitions","","",160,null],[12,"parent_def","","",160,null],[12,"expansion","","",160,null],[12,"visit_macro_invoc","","",160,null],[3,"MacroInvocationData","","",null,null],[12,"mark","","",161,null],[12,"def_index","","",161,null],[12,"const_expr","","",161,null],[3,"Forest","","Stores a crate and any number of inlined items from other crates.",null,null],[12,"krate","","",162,null],[12,"dep_graph","","",162,null],[3,"Map","","Represents a mapping from Node IDs to AST elements and their parent Node IDs",null,null],[12,"forest","","The backing storage for all the AST nodes.",163,null],[12,"dep_graph","","Same as the dep_graph in forest, just available with one fewer deref. This is a gratuitous micro-optimization.",163,null],[12,"crate_hash","","The SVH of the local crate.",163,null],[12,"map","","NodeIds are sequential integers from 0, so we can be super-compact by storing them in a vector. Not everything with a NodeId is in the map, but empirically the occupancy is about 75-80%, so there's not too much overhead (certainly less than a hashmap, since they (at the time of writing) have a maximum of 75% occupancy).",163,null],[12,"definitions","","",163,null],[12,"hir_to_node_id","","The reverse mapping of `node_to_hir_id`.",163,null],[3,"NodesMatchingSuffix","","",null,null],[12,"map","","",164,null],[12,"item_name","","",164,null],[12,"in_which","","",164,null],[12,"idx","","",164,null],[4,"Node","","",null,null],[13,"NodeItem","","",165,null],[13,"NodeForeignItem","","",165,null],[13,"NodeTraitItem","","",165,null],[13,"NodeImplItem","","",165,null],[13,"NodeVariant","","",165,null],[13,"NodeField","","",165,null],[13,"NodeExpr","","",165,null],[13,"NodeStmt","","",165,null],[13,"NodeTy","","",165,null],[13,"NodeTraitRef","","",165,null],[13,"NodeBinding","","",165,null],[13,"NodePat","","",165,null],[13,"NodeBlock","","",165,null],[13,"NodeLocal","","",165,null],[13,"NodeMacroDef","","",165,null],[13,"NodeStructCtor","","NodeStructCtor represents a tuple struct.",165,null],[13,"NodeLifetime","","",165,null],[13,"NodeTyParam","","",165,null],[13,"NodeVisibility","","",165,null],[4,"MapEntry","","Represents an entry and its parent NodeID. The odd layout is to bring down the total size.",null,null],[13,"NotPresent","","Placeholder for holes in the map.",166,null],[13,"EntryItem","","All the node types, with a parent ID.",166,null],[13,"EntryForeignItem","","",166,null],[13,"EntryTraitItem","","",166,null],[13,"EntryImplItem","","",166,null],[13,"EntryVariant","","",166,null],[13,"EntryField","","",166,null],[13,"EntryExpr","","",166,null],[13,"EntryStmt","","",166,null],[13,"EntryTy","","",166,null],[13,"EntryTraitRef","","",166,null],[13,"EntryBinding","","",166,null],[13,"EntryPat","","",166,null],[13,"EntryBlock","","",166,null],[13,"EntryStructCtor","","",166,null],[13,"EntryLifetime","","",166,null],[13,"EntryTyParam","","",166,null],[13,"EntryVisibility","","",166,null],[13,"EntryLocal","","",166,null],[13,"EntryMacroDef","","",166,null],[13,"RootCrate","","Roots for node trees. The DepNodeIndex is the dependency node of the crate's root module.",166,null],[5,"map_crate","","",null,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"forest"},{"name":"definitions"}],"output":{"name":"map"}}],[5,"node_id_to_string","","",null,{"inputs":[{"name":"map"},{"name":"nodeid"},{"name":"bool"}],"output":{"name":"string"}}],[5,"describe_def","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["def"],"name":"option"}}],[0,"blocks","","This module provides a simplified abstraction for working with code blocks identified by their integer node-id.  In particular, it captures a common set of attributes that all \"function-like things\" (represented by `FnLike` instances) share.  For example, all `FnLike` instances have a type signature (be it explicit or inferred).  And all `FnLike` instances have a body, i.e. the code that is run when the function-like thing it represents is invoked.",null,null],[3,"FnLikeNode","rustc::hir::map::blocks","An FnLikeNode is a Node that is like a fn, in that it has a decl and a body (as well as a NodeId, a span, etc).",null,null],[12,"node","","",167,null],[3,"ItemFnParts","","These are all the components one can extract from a fn item for use when implementing FnLikeNode operations.",null,null],[12,"name","","",168,null],[12,"decl","","",168,null],[12,"unsafety","","",168,null],[12,"constness","","",168,null],[12,"abi","","",168,null],[12,"vis","","",168,null],[12,"generics","","",168,null],[12,"body","","",168,null],[12,"id","","",168,null],[12,"span","","",168,null],[12,"attrs","","",168,null],[3,"ClosureParts","","These are all the components one can extract from a closure expr for use when implementing FnLikeNode operations.",null,null],[12,"decl","","",169,null],[12,"body","","",169,null],[12,"id","","",169,null],[12,"span","","",169,null],[12,"attrs","","",169,null],[4,"Code","","Carries either an FnLikeNode or a Expr, as these are the two constructs that correspond to \"code\" (as in, something from which we can construct a control-flow graph).",null,null],[13,"FnLike","","",170,null],[13,"Expr","","",170,null],[8,"MaybeFnLike","","MaybeFnLike wraps a method that indicates if an object corresponds to some FnLikeNode.",null,null],[10,"is_fn_like","","",171,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",167,{"inputs":[{"name":"self"}],"output":{"name":"fnlikenode"}}],[11,"fmt","","",167,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_fn_like","rustc::hir","",82,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",62,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",57,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","rustc::hir::map::blocks","",170,{"inputs":[{"name":"self"}],"output":{"name":"code"}}],[11,"id","","",170,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"from_node","","Attempts to construct a Code from presumed FnLike or Expr node input.",170,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"generics":["code"],"name":"option"}}],[11,"new","","",169,null],[11,"from_node","","Attempts to construct a FnLikeNode from presumed FnLike node input.",167,{"inputs":[{"name":"node"}],"output":{"generics":["fnlikenode"],"name":"option"}}],[11,"body","","",167,{"inputs":[{"name":"self"}],"output":{"name":"bodyid"}}],[11,"decl","","",167,{"inputs":[{"name":"self"}],"output":{"name":"fndecl"}}],[11,"span","","",167,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"id","","",167,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"constness","","",167,{"inputs":[{"name":"self"}],"output":{"name":"constness"}}],[11,"unsafety","","",167,{"inputs":[{"name":"self"}],"output":{"name":"unsafety"}}],[11,"kind","","",167,{"inputs":[{"name":"self"}],"output":{"name":"fnkind"}}],[11,"handle","","",167,{"inputs":[{"name":"self"},{"name":"i"},{"name":"m"},{"name":"c"}],"output":{"name":"a"}}],[0,"collector","rustc::hir::map","",null,null],[3,"NodeCollector","rustc::hir::map::collector","A Visitor that walks over the HIR and collects Nodes into a HIR map",null,null],[12,"krate","","The crate",172,null],[12,"map","","The node map",172,null],[12,"parent_node","","The parent of this node",172,null],[12,"current_dep_node_owner","","",172,null],[12,"current_signature_dep_index","","",172,null],[12,"current_full_dep_index","","",172,null],[12,"currently_in_body","","",172,null],[12,"dep_graph","","",172,null],[12,"definitions","","",172,null],[12,"hcx","","",172,null],[12,"hir_body_nodes","","",172,null],[3,"HirItemLike","","",null,null],[12,"item_like","","",173,null],[12,"hash_bodies","","",173,null],[11,"root","","",172,{"inputs":[{"name":"crate"},{"name":"depgraph"},{"name":"definitions"},{"name":"stablehashingcontext"}],"output":{"name":"nodecollector"}}],[11,"finalize_and_compute_crate_hash","","",172,null],[11,"insert_entry","","",172,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"mapentry"}],"output":null}],[11,"insert","","",172,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"node"}],"output":null}],[11,"with_parent","","",172,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"with_dep_node_owner","","",172,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"t"},{"name":"f"}],"output":null}],[11,"nested_visit_map","","Because we want to track parent items and so forth, enable deep walking so that we walk nested items in the context of their outer items.",172,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_item","","",172,{"inputs":[{"name":"self"},{"name":"itemid"}],"output":null}],[11,"visit_nested_trait_item","","",172,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":null}],[11,"visit_nested_impl_item","","",172,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":null}],[11,"visit_nested_body","","",172,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_item","","",172,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",172,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_generics","","",172,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_trait_item","","",172,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",172,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_pat","","",172,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",172,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_stmt","","",172,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_ty","","",172,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_trait_ref","","",172,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_fn","","",172,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_block","","",172,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_local","","",172,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_lifetime","","",172,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_vis","","",172,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":null}],[11,"visit_macro_def","","",172,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"visit_variant","","",172,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",172,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_trait_item_ref","","",172,{"inputs":[{"name":"self"},{"name":"traititemref"}],"output":null}],[11,"visit_impl_item_ref","","",172,{"inputs":[{"name":"self"},{"name":"implitemref"}],"output":null}],[11,"hash_stable","","",173,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"def_collector","rustc::hir::map","",null,null],[3,"DefCollector","rustc::hir::map::def_collector","Creates def ids for nodes in the AST.",null,null],[12,"definitions","","",160,null],[12,"parent_def","","",160,null],[12,"expansion","","",160,null],[12,"visit_macro_invoc","","",160,null],[3,"MacroInvocationData","","",null,null],[12,"mark","","",161,null],[12,"def_index","","",161,null],[12,"const_expr","","",161,null],[11,"new","rustc::hir::map","",160,{"inputs":[{"name":"definitions"},{"name":"mark"}],"output":{"name":"self"}}],[11,"collect_root","","",160,{"inputs":[{"name":"self"},{"name":"str"},{"name":"cratedisambiguator"}],"output":null}],[11,"create_def","","",160,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"defpathdata"},{"name":"defindexaddressspace"},{"name":"span"}],"output":{"name":"defindex"}}],[11,"with_parent","","",160,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"f"}],"output":null}],[11,"visit_const_expr","","",160,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_macro_invoc","","",160,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"visit_item","","",160,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_use_tree","","",160,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"visit_foreign_item","","",160,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_generic_param","","",160,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"visit_trait_item","","",160,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",160,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_pat","","",160,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",160,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",160,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_stmt","","",160,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_token","","",160,{"inputs":[{"name":"self"},{"name":"token"}],"output":null}],[0,"definitions","","For each definition, we track the following data.  A definition here is defined somewhat circularly as \"something with a def-id\", but it generally corresponds to things like structs, enums, etc. There are also some rather random cases (like const initializer expressions) that are mostly just leftovers.",null,null],[3,"DefPathTable","rustc::hir::map::definitions","The DefPathTable maps DefIndexes to DefKeys and vice versa. Internally the DefPathTable holds a tree of DefKeys, where each DefKey stores the DefIndex of its parent. There is one DefPathTable for each crate.",null,null],[12,"index_to_key","","",174,null],[12,"def_path_hashes","","",174,null],[3,"Definitions","","The definition table containing node definitions. It holds the DefPathTable for local DefIds/DefPaths and it also stores a mapping from NodeIds to local DefIds.",null,null],[12,"table","","",175,null],[12,"node_to_def_index","","",175,null],[12,"def_index_to_node","","",175,null],[12,"node_to_hir_id","","",175,null],[12,"macro_def_scopes","","",175,null],[12,"expansions","","",175,null],[12,"next_disambiguator","","",175,null],[12,"def_index_to_span","","",175,null],[3,"DefKey","","A unique identifier that we can use to lookup a definition precisely. It combines the index of the definition's parent (if any) with a `DisambiguatedDefPathData`.",null,null],[12,"parent","","Parent path.",176,null],[12,"disambiguated_data","","Identifier of this node.",176,null],[3,"DisambiguatedDefPathData","","Pair of `DefPathData` and an integer disambiguator. The integer is normally 0, but in the event that there are multiple defs with the same `parent` and `data`, we use this field to disambiguate between them. This introduces some artificial ordering dependency but means that if you have (e.g.) two impls for the same type in the same module, they do get distinct def-ids.",null,null],[12,"data","","",177,null],[12,"disambiguator","","",177,null],[3,"DefPath","","",null,null],[12,"data","","the path leading from the crate root to the item",178,null],[12,"krate","","what krate root is this path relative to?",178,null],[3,"DefPathHash","","",null,null],[12,"0","","",179,null],[4,"DefPathData","","",null,null],[13,"CrateRoot","","The crate root (marker)",180,null],[13,"Misc","","",180,null],[13,"Impl","","An impl",180,null],[13,"Trait","","A trait",180,null],[13,"AssocTypeInTrait","","An associated type declaration (i.e., in a trait)",180,null],[13,"AssocTypeInImpl","","An associated type value (i.e., in an impl)",180,null],[13,"TypeNs","","Something in the type NS",180,null],[13,"ValueNs","","Something in the value NS",180,null],[13,"Module","","A module declaration",180,null],[13,"MacroDef","","A macro rule",180,null],[13,"ClosureExpr","","A closure expression",180,null],[13,"TypeParam","","A type parameter (generic parameter)",180,null],[13,"LifetimeDef","","A lifetime definition",180,null],[13,"EnumVariant","","A variant of a enum",180,null],[13,"Field","","A struct field",180,null],[13,"StructCtor","","Implicit ctor for a tuple-like struct",180,null],[13,"Initializer","","Initializer for a const",180,null],[13,"ImplTrait","","An `impl Trait` type node.",180,null],[13,"Typeof","","A `typeof` type node.",180,null],[13,"GlobalMetaData","","GlobalMetaData identifies a piece of crate metadata that is global to a whole crate (as opposed to just one item). GlobalMetaData components are only supposed to show up right below the crate root.",180,null],[4,"GlobalMetaDataKind","","",null,null],[13,"Krate","","",181,null],[13,"CrateDeps","","",181,null],[13,"DylibDependencyFormats","","",181,null],[13,"LangItems","","",181,null],[13,"LangItemsMissing","","",181,null],[13,"NativeLibraries","","",181,null],[13,"CodeMap","","",181,null],[13,"Impls","","",181,null],[13,"ExportedSymbols","","",181,null],[17,"GLOBAL_MD_ADDRESS_SPACE","","",null,null],[11,"clone","","",174,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"allocate","","",174,{"inputs":[{"name":"self"},{"name":"defkey"},{"name":"defpathhash"},{"name":"defindexaddressspace"}],"output":{"name":"defindex"}}],[11,"next_id","","",174,{"inputs":[{"name":"self"},{"name":"defindexaddressspace"}],"output":{"name":"defindex"}}],[11,"def_key","","",174,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defkey"}}],[11,"def_path_hash","","",174,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defpathhash"}}],[11,"add_def_path_hashes_to","","",174,{"inputs":[{"name":"self"},{"name":"cratenum"},{"name":"fxhashmap"}],"output":null}],[11,"size","","",174,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"encode","","",174,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",174,{"inputs":[{"name":"d"}],"output":{"generics":["defpathtable"],"name":"result"}}],[11,"clone","","",175,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"clone","","",176,{"inputs":[{"name":"self"}],"output":{"name":"defkey"}}],[11,"fmt","","",176,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",176,{"inputs":[{"name":"self"},{"name":"defkey"}],"output":{"name":"bool"}}],[11,"ne","","",176,{"inputs":[{"name":"self"},{"name":"defkey"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",176,null],[11,"hash","","",176,null],[11,"encode","","",176,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",176,{"inputs":[{"name":"__d"}],"output":{"generics":["defkey"],"name":"result"}}],[11,"compute_stable_hash","","",176,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"defpathhash"}}],[11,"root_parent_stable_hash","","",176,{"inputs":[{"name":"str"},{"name":"cratedisambiguator"}],"output":{"name":"defpathhash"}}],[11,"clone","","",177,{"inputs":[{"name":"self"}],"output":{"name":"disambiguateddefpathdata"}}],[11,"fmt","","",177,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",177,{"inputs":[{"name":"self"},{"name":"disambiguateddefpathdata"}],"output":{"name":"bool"}}],[11,"ne","","",177,{"inputs":[{"name":"self"},{"name":"disambiguateddefpathdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",177,null],[11,"hash","","",177,null],[11,"encode","","",177,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",177,{"inputs":[{"name":"__d"}],"output":{"generics":["disambiguateddefpathdata"],"name":"result"}}],[11,"clone","","",178,{"inputs":[{"name":"self"}],"output":{"name":"defpath"}}],[11,"fmt","","",178,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",178,{"inputs":[{"name":"self"},{"name":"defpath"}],"output":{"name":"bool"}}],[11,"ne","","",178,{"inputs":[{"name":"self"},{"name":"defpath"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",178,null],[11,"hash","","",178,null],[11,"encode","","",178,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",178,{"inputs":[{"name":"__d"}],"output":{"generics":["defpath"],"name":"result"}}],[11,"is_local","","",178,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"make","","",178,{"inputs":[{"name":"cratenum"},{"name":"defindex"},{"name":"fn"}],"output":{"name":"defpath"}}],[11,"to_string_no_crate","","Returns a string representation of the DefPath without the crate-prefix. This method is useful if you don't have a TyCtxt available.",178,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"to_filename_friendly_no_crate","","Return filename friendly string of the DefPah without the crate-prefix. This method is useful if you don't have a TyCtxt available.",178,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"clone","","",180,{"inputs":[{"name":"self"}],"output":{"name":"defpathdata"}}],[11,"fmt","","",180,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",180,null],[11,"eq","","",180,{"inputs":[{"name":"self"},{"name":"defpathdata"}],"output":{"name":"bool"}}],[11,"ne","","",180,{"inputs":[{"name":"self"},{"name":"defpathdata"}],"output":{"name":"bool"}}],[11,"hash","","",180,null],[11,"encode","","",180,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",180,{"inputs":[{"name":"__d"}],"output":{"generics":["defpathdata"],"name":"result"}}],[11,"clone","","",179,{"inputs":[{"name":"self"}],"output":{"name":"defpathhash"}}],[11,"hash","","",179,null],[11,"eq","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"bool"}}],[11,"ne","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",179,null],[11,"partial_cmp","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"bool"}}],[11,"le","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"bool"}}],[11,"gt","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"bool"}}],[11,"ge","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"bool"}}],[11,"cmp","","",179,{"inputs":[{"name":"self"},{"name":"defpathhash"}],"output":{"name":"ordering"}}],[11,"fmt","","",179,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",179,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",179,{"inputs":[{"name":"__d"}],"output":{"generics":["defpathhash"],"name":"result"}}],[11,"hash_stable","","",179,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","Create new empty definition map.",175,{"inputs":[],"output":{"name":"definitions"}}],[11,"def_path_table","","",175,{"inputs":[{"name":"self"}],"output":{"name":"defpathtable"}}],[11,"def_index_counts_lo_hi","","Get the number of definitions.",175,null],[11,"def_key","","",175,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defkey"}}],[11,"def_path_hash","","",175,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defpathhash"}}],[11,"def_path","","Returns the path from the crate root to `index`. The root nodes are not included in the path (i.e., this will be an empty vector for the crate root). For an inlined item, this will be the path of the item in the external crate (but the path will begin with the path to the external crate).",175,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defpath"}}],[11,"opt_def_index","","",175,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["defindex"],"name":"option"}}],[11,"opt_local_def_id","","",175,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"local_def_id","","",175,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"defid"}}],[11,"as_local_node_id","","",175,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"node_to_hir_id","","",175,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"hirid"}}],[11,"find_node_for_hir_id","","",175,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"nodeid"}}],[11,"def_index_to_hir_id","","",175,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"hirid"}}],[11,"opt_span","","Retrieve the span of the given `DefId` if `DefId` is in the local crate, the span exists and it's not DUMMY_SP",175,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["span"],"name":"option"}}],[11,"create_root_def","","Add a definition with a parent definition.",175,{"inputs":[{"name":"self"},{"name":"str"},{"name":"cratedisambiguator"}],"output":{"name":"defindex"}}],[11,"create_def_with_parent","","Add a definition with a parent definition.",175,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"nodeid"},{"name":"defpathdata"},{"name":"defindexaddressspace"},{"name":"mark"},{"name":"span"}],"output":{"name":"defindex"}}],[11,"init_node_id_to_hir_id_mapping","","Initialize the ast::NodeId to HirId mapping once it has been generated during AST to HIR lowering.",175,{"inputs":[{"name":"self"},{"generics":["nodeid","hirid"],"name":"indexvec"}],"output":null}],[11,"expansion","","",175,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"mark"}}],[11,"macro_def_scope","","",175,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"defid"}}],[11,"add_macro_def_scope","","",175,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"defid"}],"output":null}],[11,"get_opt_name","","",180,{"inputs":[{"name":"self"}],"output":{"generics":["internedstring"],"name":"option"}}],[11,"as_interned_str","","",180,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"to_string","","",180,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"clone","","",181,{"inputs":[{"name":"self"}],"output":{"name":"globalmetadatakind"}}],[11,"fmt","","",181,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",181,{"inputs":[{"name":"self"},{"name":"globalmetadatakind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",181,null],[11,"partial_cmp","","",181,{"inputs":[{"name":"self"},{"name":"globalmetadatakind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",181,{"inputs":[{"name":"self"},{"name":"globalmetadatakind"}],"output":{"name":"ordering"}}],[11,"hash","","",181,null],[11,"encode","","",181,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",181,{"inputs":[{"name":"__d"}],"output":{"generics":["globalmetadatakind"],"name":"result"}}],[11,"allocate_def_indices","","",181,{"inputs":[{"name":"definitions"}],"output":null}],[11,"def_index","","",181,{"inputs":[{"name":"self"},{"name":"defpathtable"}],"output":{"name":"defindex"}}],[11,"name","","",181,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[0,"hir_id_validator","rustc::hir::map","",null,null],[3,"HirIdValidator","rustc::hir::map::hir_id_validator","",null,null],[12,"hir_map","","",182,null],[12,"owner_def_index","","",182,null],[12,"hir_ids_seen","","",182,null],[12,"errors","","",182,null],[3,"OuterVisitor","","",null,null],[12,"hir_map","","",183,null],[12,"errors","","",183,null],[5,"check_crate","","",null,{"inputs":[{"name":"map"}],"output":null}],[11,"new_inner_visitor","","",183,{"inputs":[{"name":"self"},{"name":"map"}],"output":{"name":"hiridvalidator"}}],[11,"visit_item","","",183,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",183,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",183,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"check","","",182,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"nested_visit_map","","",182,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_id","","",182,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"visit_impl_item_ref","","",182,{"inputs":[{"name":"self"},{"name":"implitemref"}],"output":null}],[17,"ITEM_LIKE_SPACE","rustc::hir::map","",null,null],[17,"REGULAR_SPACE","","",null,null],[8,"Named","","",null,null],[10,"name","","",184,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"clone","","",165,{"inputs":[{"name":"self"}],"output":{"name":"node"}}],[11,"fmt","","",165,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",166,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",166,{"inputs":[{"name":"self"}],"output":{"name":"mapentry"}}],[11,"parent_node","","",166,{"inputs":[{"name":"self"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"to_node","","",166,{"inputs":[{"name":"self"}],"output":{"generics":["node"],"name":"option"}}],[11,"associated_body","","",166,{"inputs":[{"name":"self"}],"output":{"generics":["bodyid"],"name":"option"}}],[11,"is_body_owner","","",166,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"new","","",162,{"inputs":[{"name":"crate"},{"name":"depgraph"}],"output":{"name":"forest"}}],[11,"krate","","",162,{"inputs":[{"name":"self"}],"output":{"name":"crate"}}],[11,"clone","","",163,{"inputs":[{"name":"self"}],"output":{"name":"map"}}],[11,"read","","Registers a read in the dependency graph of the AST node with the given `id`. This needs to be called each time a public function returns the HIR for a node -- in other words, when it \"reveals\" the content of a node to the caller (who might not otherwise have had access to those contents, and hence needs a read recorded). If the function just returns a DefId or NodeId, no actual content was returned, so no read is needed.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"definitions","","",163,{"inputs":[{"name":"self"}],"output":{"name":"definitions"}}],[11,"def_key","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defkey"}}],[11,"def_path_from_id","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["defpath"],"name":"option"}}],[11,"def_path","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpath"}}],[11,"local_def_id","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"defid"}}],[11,"opt_local_def_id","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"as_local_node_id","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"hir_to_node_id","","",163,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"nodeid"}}],[11,"node_to_hir_id","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"hirid"}}],[11,"def_index_to_hir_id","","",163,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"hirid"}}],[11,"def_index_to_node_id","","",163,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"nodeid"}}],[11,"local_def_id_to_hir_id","","",163,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"hirid"}}],[11,"local_def_id_to_node_id","","",163,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"nodeid"}}],[11,"describe_def","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["def"],"name":"option"}}],[11,"entry_count","","",163,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"find_entry","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["mapentry"],"name":"option"}}],[11,"krate","","",163,{"inputs":[{"name":"self"}],"output":{"name":"crate"}}],[11,"trait_item","","",163,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"traititem"}}],[11,"impl_item","","",163,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"implitem"}}],[11,"body","","",163,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"body"}}],[11,"body_owner","","Returns the `NodeId` that corresponds to the definition of which this is the body of, i.e. a `fn`, `const` or `static` item (possibly associated), or a closure, or the body itself for embedded constant expressions (e.g. `N` in `[T; N]`).",163,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"nodeid"}}],[11,"body_owner_def_id","","",163,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"defid"}}],[11,"maybe_body_owned_by","","Given a node id, returns the `BodyId` associated with it, if the node is a body owner, otherwise returns `None`.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["bodyid"],"name":"option"}}],[11,"body_owned_by","","Given a body owner's id, returns the `BodyId` associated with it.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bodyid"}}],[11,"body_owner_kind","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bodyownerkind"}}],[11,"ty_param_owner","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"ty_param_name","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"name"}}],[11,"trait_impls","","",163,null],[11,"trait_auto_impl","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"trait_is_auto","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"krate_attrs","","Get the attributes on the krate. This is preferable to invoking `krate.attrs` because it registers a tighter dep-graph access.",163,null],[11,"get","","Retrieve the Node corresponding to `id`, panicking if it cannot be found.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"node"}}],[11,"get_if_local","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["node"],"name":"option"}}],[11,"find","","Retrieve the Node corresponding to `id`, returning None if cannot be found.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["node"],"name":"option"}}],[11,"get_parent_node","","Similar to get_parent, returns the parent node id or id if there is no parent. Note that the parent may be CRATE_NODE_ID, which is not itself present in the map -- so passing the return value of get_parent_node to get may actually panic. This function returns the immediate parent in the AST, whereas get_parent returns the enclosing item. Note that this might not be the actual parent node in the AST - some kinds of nodes are not in the map and these will never appear as the parent_node. So you can always walk the parent_nodes from a node to the root of the ast (unless you get the same id back here that can happen if the id is not in the map itself or is just weird).",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"is_argument","","Check if the node is an argument. An argument is a local variable whose immediate parent is an item or a closure.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"walk_parent_nodes","","If there is some error when walking the parents (e.g., a node does not have a parent in the map or a node can't be found), then we return the last good node id we found. Note that reaching the crate root (id == 0), is not an error, since items in the crate module have the crate root as parent.",163,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"},{"name":"f2"}],"output":{"generics":["nodeid","nodeid"],"name":"result"}}],[11,"get_return_block","","Retrieve the NodeId for `id`'s enclosing method, unless there's a `while` or `loop` before reaching it, as block tail returns are not available in them.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"get_parent","","Retrieve the NodeId for `id`'s parent item, or `id` itself if no parent item is in this map. The \"parent item\" is the closest parent node in the AST which is recorded by the map and is an item, either an item in a module, trait, or impl.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"get_module_parent","","Returns the NodeId of `id`'s nearest module parent, or `id` itself if no module parent is in this map.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"defid"}}],[11,"get_enclosing_scope","","Returns the nearest enclosing scope. A scope is an item or block. FIXME it is not clear to me that all items qualify as scopes - statics and associated types probably shouldn't, for example. Behavior in this regard should be expected to be highly unstable.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"get_parent_did","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"defid"}}],[11,"get_foreign_abi","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"abi"}}],[11,"expect_item","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"item"}}],[11,"expect_impl_item","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"implitem"}}],[11,"expect_trait_item","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"traititem"}}],[11,"expect_variant_data","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"variantdata"}}],[11,"expect_variant","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"variant"}}],[11,"expect_foreign_item","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"foreignitem"}}],[11,"expect_expr","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"expr"}}],[11,"name","","Returns the name associated with the given NodeId's AST.",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"name"}}],[11,"attrs","","Given a node ID, get a list of attributes associated with the AST corresponding to the Node ID",163,null],[11,"nodes_matching_suffix","","Returns an iterator that yields the node id's with paths that match `parts`.  (Requires `parts` is non-empty.)",163,null],[11,"span","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"span"}}],[11,"span_if_local","","",163,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["span"],"name":"option"}}],[11,"node_to_string","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"string"}}],[11,"node_to_user_string","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"string"}}],[11,"node_to_pretty_string","","",163,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"string"}}],[11,"suffix_matches","","Returns true only if some suffix of the module path for parent matches `self.in_which`.",164,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"matches_names","","",164,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"name"}],"output":{"name":"bool"}}],[11,"next","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"name","rustc::hir","",82,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"name","","",85,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"name","","",77,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"name","","",80,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"name","","",62,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"name","","",64,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"nested","rustc::hir::map","",163,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[0,"pat_util","rustc::hir","",null,null],[3,"EnumerateAndAdjust","rustc::hir::pat_util","",null,null],[12,"enumerate","","",185,null],[12,"gap_pos","","",185,null],[12,"gap_len","","",185,null],[8,"EnumerateAndAdjustIterator","","",null,null],[10,"enumerate_and_adjust","","",186,{"inputs":[{"name":"self"},{"name":"usize"},{"generics":["usize"],"name":"option"}],"output":{"name":"enumerateandadjust"}}],[11,"next","","",185,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",185,null],[11,"is_refutable","rustc::hir","",50,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_const","","",50,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"each_binding","","Call `f` on every \"binding\" in a pattern, e.g., on `a` in `match foo() { Some(a) => (), None => () }`",50,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"contains_bindings","","Checks if the pattern contains any patterns that bind something to an ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",50,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to an ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",50,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"simple_name","","",50,{"inputs":[{"name":"self"}],"output":{"generics":["name"],"name":"option"}}],[11,"necessary_variants","","Return variants that are necessary to exist for the pattern to match.",50,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"vec"}}],[11,"contains_explicit_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings, and if yes whether it contains mutable or just immutables ones.",50,{"inputs":[{"name":"self"}],"output":{"generics":["mutability"],"name":"option"}}],[11,"contains_explicit_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut` bindings, and if yes whether its containing mutable ones or just immutables ones.",53,{"inputs":[{"name":"self"}],"output":{"generics":["mutability"],"name":"option"}}],[0,"print","","",null,null],[3,"NoAnn","rustc::hir::print","",null,null],[3,"State","","",null,null],[12,"s","","",187,null],[12,"cm","","",187,null],[12,"comments","","",187,null],[12,"literals","","",187,null],[12,"cur_cmnt","","",187,null],[12,"boxes","","",187,null],[12,"ann","","",187,null],[4,"AnnNode","","",null,null],[13,"NodeName","","",188,null],[13,"NodeBlock","","",188,null],[13,"NodeItem","","",188,null],[13,"NodeSubItem","","",188,null],[13,"NodeExpr","","",188,null],[13,"NodePat","","",188,null],[4,"Nested","","",null,null],[13,"Item","","",189,null],[13,"TraitItem","","",189,null],[13,"ImplItem","","",189,null],[13,"Body","","",189,null],[13,"BodyArgPat","","",189,null],[5,"print_crate","","Requires you to pass an input filename and reader so that it can scan the input text for comments and literals to copy forward.",null,{"inputs":[{"name":"codemap"},{"name":"parsesess"},{"name":"crate"},{"name":"filename"},{"name":"read"},{"generics":["write"],"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"result"}}],[5,"to_string","","",null,{"inputs":[{"name":"ppann"},{"name":"f"}],"output":{"name":"string"}}],[5,"visibility_qualified","","",null,{"inputs":[{"name":"visibility"},{"name":"str"}],"output":{"name":"string"}}],[5,"expr_requires_semi_to_be_stmt","","Does this expression require a semicolon to be treated as a statement? The negation of this: 'can this expression be used as a statement without a semicolon' -- is used as an early-bail-out in the parser so that, for instance,     if true {...} else {...}      |x| 5 isn't parsed as (if true {...} else {...} | x) | 5",null,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it. note that in one case (stmt_semi), we've already seen the semicolon, and thus don't need another.",null,{"inputs":[{"name":"stmt_"}],"output":{"name":"bool"}}],[5,"bin_op_to_assoc_op","","",null,{"inputs":[{"name":"binop_"}],"output":{"name":"assocop"}}],[5,"contains_exterior_struct_lit","","Expressions that syntactically contain an \"exterior\" struct literal i.e. not surrounded by any parens or other delimiters, e.g. `X { y: 1 }`, `X { y: 1 }.method()`, `foo == X { y: 1 }` and `X { y: 1 } == foo` all do, but `(X { y: 1 }) == foo` does not.",null,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[17,"NO_ANN","","",null,null],[17,"indent_unit","","",null,null],[17,"default_columns","","",null,null],[8,"PpAnn","","",null,null],[11,"nested","","",190,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[11,"pre","","",190,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"post","","",190,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"nested","rustc::hir","",47,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[11,"writer","rustc::hir::print","",187,{"inputs":[{"name":"self"}],"output":{"name":"printer"}}],[11,"boxes","","",187,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"comments","","",187,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"cur_cmnt","","",187,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"cur_lit","","",187,{"inputs":[{"name":"self"}],"output":{"generics":["literal"],"name":"option"}}],[11,"bump_lit","","",187,{"inputs":[{"name":"self"}],"output":{"generics":["literal"],"name":"option"}}],[11,"new_from_input","","",187,{"inputs":[{"name":"codemap"},{"name":"parsesess"},{"name":"filename"},{"name":"read"},{"generics":["write"],"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"state"}}],[11,"new","","",187,{"inputs":[{"name":"codemap"},{"generics":["write"],"name":"box"},{"name":"ppann"},{"generics":["vec"],"name":"option"},{"generics":["vec"],"name":"option"}],"output":{"name":"state"}}],[11,"cbox","","",187,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"nbsp","","",187,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"word_nbsp","","",187,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"head","","",187,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"bopen","","",187,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"bclose_","","",187,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"}],"output":{"name":"result"}}],[11,"bclose_maybe_open","","",187,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"},{"name":"bool"}],"output":{"name":"result"}}],[11,"bclose","","",187,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"result"}}],[11,"in_cbox","","",187,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"space_if_not_bol","","",187,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"break_offset_if_not_bol","","",187,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[11,"synth_comment","","",187,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"name":"result"}}],[11,"commasep_cmnt","","",187,null],[11,"commasep_exprs","","",187,null],[11,"print_mod","","",187,null],[11,"print_foreign_mod","","",187,null],[11,"print_opt_lifetime","","",187,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"result"}}],[11,"print_type","","",187,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"result"}}],[11,"print_foreign_item","","",187,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"result"}}],[11,"print_associated_const","","",187,{"inputs":[{"name":"self"},{"name":"name"},{"name":"ty"},{"generics":["bodyid"],"name":"option"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_associated_type","","",187,{"inputs":[{"name":"self"},{"name":"name"},{"generics":["typarambounds"],"name":"option"},{"generics":["ty"],"name":"option"}],"output":{"name":"result"}}],[11,"print_item","","Pretty-print an item",187,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"result"}}],[11,"print_trait_ref","","",187,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"print_formal_generic_params","","",187,null],[11,"print_poly_trait_ref","","",187,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"result"}}],[11,"print_enum_def","","",187,{"inputs":[{"name":"self"},{"name":"enumdef"},{"name":"generics"},{"name":"name"},{"name":"span"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_variants","","",187,null],[11,"print_visibility","","",187,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_defaultness","","",187,{"inputs":[{"name":"self"},{"name":"defaultness"}],"output":{"name":"result"}}],[11,"print_struct","","",187,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"generics"},{"name":"name"},{"name":"span"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_variant","","",187,{"inputs":[{"name":"self"},{"name":"variant"}],"output":{"name":"result"}}],[11,"print_method_sig","","",187,null],[11,"print_trait_item","","",187,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"result"}}],[11,"print_impl_item","","",187,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"result"}}],[11,"print_stmt","","",187,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"name":"result"}}],[11,"print_block","","",187,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed","","",187,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed_indent","","",187,{"inputs":[{"name":"self"},{"name":"block"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_block_with_attrs","","",187,null],[11,"print_block_maybe_unclosed","","",187,null],[11,"print_else","","",187,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"option"}],"output":{"name":"result"}}],[11,"print_if","","",187,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"generics":["expr"],"name":"option"}],"output":{"name":"result"}}],[11,"print_if_let","","",187,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"expr"},{"name":"block"},{"generics":["expr"],"name":"option"}],"output":{"name":"result"}}],[11,"print_call_post","","",187,null],[11,"print_expr_maybe_paren","","",187,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"i8"}],"output":{"name":"result"}}],[11,"print_expr_as_cond","","Print an expr using syntax that's acceptable in a condition position, such as the `cond` in `if cond { ... }`.",187,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_vec","","",187,null],[11,"print_expr_repeat","","",187,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"bodyid"}],"output":{"name":"result"}}],[11,"print_expr_struct","","",187,null],[11,"print_expr_tup","","",187,null],[11,"print_expr_call","","",187,null],[11,"print_expr_method_call","","",187,null],[11,"print_expr_binary","","",187,{"inputs":[{"name":"self"},{"name":"binop"},{"name":"expr"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_unary","","",187,{"inputs":[{"name":"self"},{"name":"unop"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_addr_of","","",187,{"inputs":[{"name":"self"},{"name":"mutability"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr","","",187,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_local_decl","","",187,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"result"}}],[11,"print_decl","","",187,{"inputs":[{"name":"self"},{"name":"decl"}],"output":{"name":"result"}}],[11,"print_usize","","",187,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_name","","",187,{"inputs":[{"name":"self"},{"name":"name"}],"output":{"name":"result"}}],[11,"print_for_decl","","",187,{"inputs":[{"name":"self"},{"name":"local"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_path","","",187,{"inputs":[{"name":"self"},{"name":"path"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_qpath","","",187,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_path_parameters","","",187,{"inputs":[{"name":"self"},{"name":"pathparameters"},{"name":"bool"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_pat","","",187,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"result"}}],[11,"print_arm","","",187,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"result"}}],[11,"print_fn","","",187,null],[11,"print_closure_args","","",187,{"inputs":[{"name":"self"},{"name":"fndecl"},{"name":"bodyid"}],"output":{"name":"result"}}],[11,"print_capture_clause","","",187,{"inputs":[{"name":"self"},{"name":"captureclause"}],"output":{"name":"result"}}],[11,"print_bounds","","",187,null],[11,"print_lifetime","","",187,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"result"}}],[11,"print_lifetime_def","","",187,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"result"}}],[11,"print_generic_params","","",187,null],[11,"print_ty_param","","",187,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"result"}}],[11,"print_where_clause","","",187,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"result"}}],[11,"print_mutability","","",187,{"inputs":[{"name":"self"},{"name":"mutability"}],"output":{"name":"result"}}],[11,"print_mt","","",187,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"result"}}],[11,"print_fn_output","","",187,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_ty_fn","","",187,null],[11,"maybe_print_trailing_comment","","",187,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["bytepos"],"name":"option"}],"output":{"name":"result"}}],[11,"print_remaining_comments","","",187,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"print_opt_abi_and_extern_if_nondefault","","",187,{"inputs":[{"name":"self"},{"generics":["abi"],"name":"option"}],"output":{"name":"result"}}],[11,"print_extern_opt_abi","","",187,{"inputs":[{"name":"self"},{"generics":["abi"],"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_header_info","","",187,{"inputs":[{"name":"self"},{"name":"unsafety"},{"name":"constness"},{"name":"abi"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_unsafety","","",187,{"inputs":[{"name":"self"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"print_is_auto","","",187,{"inputs":[{"name":"self"},{"name":"isauto"}],"output":{"name":"result"}}],[0,"svh","rustc::hir","Calculation and management of a Strict Version Hash for crates",null,null],[3,"Svh","rustc::hir::svh","",null,null],[12,"hash","","",191,null],[11,"clone","","",191,{"inputs":[{"name":"self"}],"output":{"name":"svh"}}],[11,"eq","","",191,{"inputs":[{"name":"self"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",191,{"inputs":[{"name":"self"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",191,null],[11,"fmt","","",191,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Create a new `Svh` given the hash. If you actually want to compute the SVH from some HIR, you want the `calculate_svh` function found in `librustc_incremental`.",191,{"inputs":[{"name":"u64"}],"output":{"name":"svh"}}],[11,"as_u64","","",191,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"to_string","","",191,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"hash","","",191,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"fmt","","",191,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",191,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",191,{"inputs":[{"name":"d"}],"output":{"generics":["svh"],"name":"result"}}],[11,"hash_stable","","",191,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[6,"HirVec","rustc::hir","HIR doesn't commit to a concrete storage type and has its own alias for a vector. It can be `Vec`, `P<[T]>` or potentially `Box<[T]>`, or some other container with similar behavior. Unlike AST, HIR is mostly a static structure, so we can use an owned slice instead of `Vec` to avoid keeping extra capacity.",null,null],[6,"TyParamBounds","","",null,null],[6,"CrateConfig","","",null,null],[6,"BinOp","","",null,null],[6,"Stmt","","A statement",null,null],[6,"Decl","","",null,null],[6,"Variant","","",null,null],[6,"FreevarMap","","",null,null],[6,"CaptureModeMap","","",null,null],[6,"TraitMap","","",null,null],[6,"GlobMap","","",null,null],[17,"CRATE_HIR_ID","","The `HirId` corresponding to CRATE_NODE_ID and CRATE_DEF_INDEX",null,null],[17,"DUMMY_HIR_ID","","",null,null],[17,"DUMMY_ITEM_LOCAL_ID","","",null,null],[8,"GenericParamsExt","","",null,null],[10,"lifetimes","","",192,{"inputs":[{"name":"self"}],"output":{"generics":["iter"],"name":"filtermap"}}],[10,"ty_params","","",192,{"inputs":[{"name":"self"}],"output":{"generics":["iter"],"name":"filtermap"}}],[11,"clone","","",33,{"inputs":[{"name":"self"}],"output":{"name":"hirid"}}],[11,"eq","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",33,null],[11,"hash","","",33,null],[11,"partial_cmp","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"le","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"gt","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"ge","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"cmp","","",33,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"ordering"}}],[11,"fmt","","",33,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"owner_def_id","","",33,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"owner_local_def_id","","",33,{"inputs":[{"name":"self"}],"output":{"name":"localdefid"}}],[11,"default_encode","","",33,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"default_decode","","",33,{"inputs":[{"name":"d"}],"output":{"generics":["hirid"],"name":"result"}}],[11,"clone","","",34,{"inputs":[{"name":"self"}],"output":{"name":"itemlocalid"}}],[11,"eq","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",34,null],[11,"hash","","",34,null],[11,"partial_cmp","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"le","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"gt","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"ge","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"cmp","","",34,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"ordering"}}],[11,"fmt","","",34,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",34,{"inputs":[{"name":"__d"}],"output":{"generics":["itemlocalid"],"name":"result"}}],[11,"as_usize","","",34,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new","","",34,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",34,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",35,{"inputs":[{"name":"self"}],"output":{"name":"label"}}],[11,"eq","","",35,{"inputs":[{"name":"self"},{"name":"label"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"self"},{"name":"label"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",35,null],[11,"encode","","",35,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",35,{"inputs":[{"name":"__d"}],"output":{"generics":["label"],"name":"result"}}],[11,"hash","","",35,null],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",36,{"inputs":[{"name":"self"}],"output":{"name":"lifetime"}}],[11,"eq","","",36,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",36,null],[11,"encode","","",36,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",36,{"inputs":[{"name":"__d"}],"output":{"generics":["lifetime"],"name":"result"}}],[11,"hash","","",36,null],[11,"fmt","","",90,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",90,{"inputs":[{"name":"self"}],"output":{"name":"lifetimename"}}],[11,"eq","","",90,{"inputs":[{"name":"self"},{"name":"lifetimename"}],"output":{"name":"bool"}}],[11,"ne","","",90,{"inputs":[{"name":"self"},{"name":"lifetimename"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",90,null],[11,"encode","","",90,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",90,{"inputs":[{"name":"__d"}],"output":{"generics":["lifetimename"],"name":"result"}}],[11,"hash","","",90,null],[11,"name","","",90,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"fmt","","",36,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_elided","","",36,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_static","","",36,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",37,{"inputs":[{"name":"self"}],"output":{"name":"lifetimedef"}}],[11,"eq","","",37,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",37,null],[11,"encode","","",37,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",37,{"inputs":[{"name":"__d"}],"output":{"generics":["lifetimedef"],"name":"result"}}],[11,"hash","","",37,null],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"path"}}],[11,"eq","","",38,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",38,null],[11,"encode","","",38,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",38,{"inputs":[{"name":"__d"}],"output":{"generics":["path"],"name":"result"}}],[11,"hash","","",38,null],[11,"is_global","","",38,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",39,{"inputs":[{"name":"self"}],"output":{"name":"pathsegment"}}],[11,"eq","","",39,{"inputs":[{"name":"self"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"self"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",39,null],[11,"encode","","",39,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",39,{"inputs":[{"name":"__d"}],"output":{"generics":["pathsegment"],"name":"result"}}],[11,"hash","","",39,null],[11,"fmt","","",39,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_name","","Convert an identifier to the corresponding segment.",39,{"inputs":[{"name":"name"}],"output":{"name":"pathsegment"}}],[11,"new","","",39,{"inputs":[{"name":"name"},{"name":"pathparameters"},{"name":"bool"}],"output":{"name":"self"}}],[11,"with_parameters","","",39,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"clone","","",40,{"inputs":[{"name":"self"}],"output":{"name":"pathparameters"}}],[11,"eq","","",40,{"inputs":[{"name":"self"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"self"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",40,null],[11,"encode","","",40,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",40,{"inputs":[{"name":"__d"}],"output":{"generics":["pathparameters"],"name":"result"}}],[11,"hash","","",40,null],[11,"fmt","","",40,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"none","","",40,{"inputs":[],"output":{"name":"self"}}],[11,"is_empty","","",40,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"inputs","","",40,null],[11,"clone","","",91,{"inputs":[{"name":"self"}],"output":{"name":"typarambound"}}],[11,"eq","","",91,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"ne","","",91,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",91,null],[11,"encode","","",91,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",91,{"inputs":[{"name":"__d"}],"output":{"generics":["typarambound"],"name":"result"}}],[11,"hash","","",91,null],[11,"fmt","","",91,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",91,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",92,{"inputs":[{"name":"self"}],"output":{"name":"traitboundmodifier"}}],[11,"eq","","",92,{"inputs":[{"name":"self"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",92,null],[11,"encode","","",92,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",92,{"inputs":[{"name":"__d"}],"output":{"generics":["traitboundmodifier"],"name":"result"}}],[11,"hash","","",92,null],[11,"fmt","","",92,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",41,{"inputs":[{"name":"self"}],"output":{"name":"typaram"}}],[11,"eq","","",41,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",41,null],[11,"encode","","",41,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",41,{"inputs":[{"name":"__d"}],"output":{"generics":["typaram"],"name":"result"}}],[11,"hash","","",41,null],[11,"fmt","","",41,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",93,{"inputs":[{"name":"self"}],"output":{"name":"genericparam"}}],[11,"eq","","",93,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":{"name":"bool"}}],[11,"ne","","",93,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",93,null],[11,"encode","","",93,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",93,{"inputs":[{"name":"__d"}],"output":{"generics":["genericparam"],"name":"result"}}],[11,"hash","","",93,null],[11,"fmt","","",93,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_lifetime_param","","",93,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_type_param","","",93,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"self"}],"output":{"name":"generics"}}],[11,"eq","","",42,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",42,null],[11,"encode","","",42,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",42,{"inputs":[{"name":"__d"}],"output":{"generics":["generics"],"name":"result"}}],[11,"hash","","",42,null],[11,"fmt","","",42,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",42,{"inputs":[],"output":{"name":"generics"}}],[11,"is_lt_parameterized","","",42,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_type_parameterized","","",42,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"lifetimes","","",42,null],[11,"ty_params","","",42,null],[11,"attr_name","","",94,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"carries_unsafe_attr","","",42,{"inputs":[{"name":"self"}],"output":{"generics":["unsafegeneric"],"name":"option"}}],[11,"clone","","",95,{"inputs":[{"name":"self"}],"output":{"name":"synthetictyparamkind"}}],[11,"eq","","",95,{"inputs":[{"name":"self"},{"name":"synthetictyparamkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",95,null],[11,"encode","","",95,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",95,{"inputs":[{"name":"__d"}],"output":{"generics":["synthetictyparamkind"],"name":"result"}}],[11,"hash","","",95,null],[11,"fmt","","",95,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",43,{"inputs":[{"name":"self"}],"output":{"name":"whereclause"}}],[11,"eq","","",43,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",43,null],[11,"encode","","",43,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",43,{"inputs":[{"name":"__d"}],"output":{"generics":["whereclause"],"name":"result"}}],[11,"hash","","",43,null],[11,"fmt","","",43,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",96,{"inputs":[{"name":"self"}],"output":{"name":"wherepredicate"}}],[11,"eq","","",96,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",96,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",96,null],[11,"encode","","",96,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",96,{"inputs":[{"name":"__d"}],"output":{"generics":["wherepredicate"],"name":"result"}}],[11,"hash","","",96,null],[11,"fmt","","",96,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",96,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",44,{"inputs":[{"name":"self"}],"output":{"name":"whereboundpredicate"}}],[11,"eq","","",44,{"inputs":[{"name":"self"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",44,{"inputs":[{"name":"self"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",44,null],[11,"encode","","",44,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",44,{"inputs":[{"name":"__d"}],"output":{"generics":["whereboundpredicate"],"name":"result"}}],[11,"hash","","",44,null],[11,"fmt","","",44,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",45,{"inputs":[{"name":"self"}],"output":{"name":"whereregionpredicate"}}],[11,"eq","","",45,{"inputs":[{"name":"self"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",45,{"inputs":[{"name":"self"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",45,null],[11,"encode","","",45,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",45,{"inputs":[{"name":"__d"}],"output":{"generics":["whereregionpredicate"],"name":"result"}}],[11,"hash","","",45,null],[11,"fmt","","",45,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",46,{"inputs":[{"name":"self"}],"output":{"name":"whereeqpredicate"}}],[11,"eq","","",46,{"inputs":[{"name":"self"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"self"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",46,null],[11,"encode","","",46,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",46,{"inputs":[{"name":"__d"}],"output":{"generics":["whereeqpredicate"],"name":"result"}}],[11,"hash","","",46,null],[11,"fmt","","",46,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",47,{"inputs":[{"name":"self"}],"output":{"name":"crate"}}],[11,"eq","","",47,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"ne","","",47,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",47,null],[11,"encode","","",47,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",47,{"inputs":[{"name":"__d"}],"output":{"generics":["crate"],"name":"result"}}],[11,"fmt","","",47,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"item","","",47,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"item"}}],[11,"trait_item","","",47,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"traititem"}}],[11,"impl_item","","",47,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"implitem"}}],[11,"visit_all_item_likes","","Visits all items in the crate in some deterministic (but unspecified) order. If you just need to process every item, but don't care about nesting, this method is the best choice.",47,{"inputs":[{"name":"self"},{"name":"v"}],"output":null}],[11,"body","","",47,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"body"}}],[11,"clone","","",48,{"inputs":[{"name":"self"}],"output":{"name":"macrodef"}}],[11,"eq","","",48,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",48,null],[11,"encode","","",48,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",48,{"inputs":[{"name":"__d"}],"output":{"generics":["macrodef"],"name":"result"}}],[11,"hash","","",48,null],[11,"fmt","","",48,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",49,{"inputs":[{"name":"self"}],"output":{"name":"block"}}],[11,"eq","","",49,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"bool"}}],[11,"ne","","",49,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",49,null],[11,"encode","","",49,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",49,{"inputs":[{"name":"__d"}],"output":{"generics":["block"],"name":"result"}}],[11,"hash","","",49,null],[11,"fmt","","",49,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",50,{"inputs":[{"name":"self"}],"output":{"name":"pat"}}],[11,"eq","","",50,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"ne","","",50,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",50,null],[11,"encode","","",50,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",50,{"inputs":[{"name":"__d"}],"output":{"generics":["pat"],"name":"result"}}],[11,"hash","","",50,null],[11,"fmt","","",50,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"walk_","","",50,{"inputs":[{"name":"self"},{"name":"g"}],"output":{"name":"bool"}}],[11,"walk","","",50,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"self"}],"output":{"name":"fieldpat"}}],[11,"eq","","",51,{"inputs":[{"name":"self"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"self"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",51,null],[11,"encode","","",51,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",51,{"inputs":[{"name":"__d"}],"output":{"generics":["fieldpat"],"name":"result"}}],[11,"hash","","",51,null],[11,"fmt","","",51,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",97,{"inputs":[{"name":"self"}],"output":{"name":"bindingannotation"}}],[11,"eq","","",97,{"inputs":[{"name":"self"},{"name":"bindingannotation"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",97,null],[11,"encode","","",97,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",97,{"inputs":[{"name":"__d"}],"output":{"generics":["bindingannotation"],"name":"result"}}],[11,"hash","","",97,null],[11,"fmt","","",97,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",98,{"inputs":[{"name":"self"}],"output":{"name":"rangeend"}}],[11,"eq","","",98,{"inputs":[{"name":"self"},{"name":"rangeend"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",98,null],[11,"encode","","",98,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",98,{"inputs":[{"name":"__d"}],"output":{"generics":["rangeend"],"name":"result"}}],[11,"hash","","",98,null],[11,"fmt","","",98,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",99,{"inputs":[{"name":"self"}],"output":{"name":"patkind"}}],[11,"eq","","",99,{"inputs":[{"name":"self"},{"name":"patkind"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"self"},{"name":"patkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",99,null],[11,"encode","","",99,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",99,{"inputs":[{"name":"__d"}],"output":{"generics":["patkind"],"name":"result"}}],[11,"hash","","",99,null],[11,"fmt","","",99,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",100,{"inputs":[{"name":"self"}],"output":{"name":"mutability"}}],[11,"eq","","",100,{"inputs":[{"name":"self"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",100,null],[11,"encode","","",100,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",100,{"inputs":[{"name":"__d"}],"output":{"generics":["mutability"],"name":"result"}}],[11,"hash","","",100,null],[11,"fmt","","",100,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"and","","Return MutMutable only if both arguments are mutable.",100,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"self"}}],[11,"clone","","",101,{"inputs":[{"name":"self"}],"output":{"name":"binop_"}}],[11,"eq","","",101,{"inputs":[{"name":"self"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",101,null],[11,"encode","","",101,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",101,{"inputs":[{"name":"__d"}],"output":{"generics":["binop_"],"name":"result"}}],[11,"hash","","",101,null],[11,"fmt","","",101,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_str","","",101,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"is_lazy","","",101,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_shift","","",101,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_comparison","","",101,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_by_value","","Returns `true` if the binary operator takes its arguments by value",101,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"into","","",101,{"inputs":[{"name":"self"}],"output":{"name":"binopkind"}}],[11,"clone","","",102,{"inputs":[{"name":"self"}],"output":{"name":"unop"}}],[11,"eq","","",102,{"inputs":[{"name":"self"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",102,null],[11,"encode","","",102,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",102,{"inputs":[{"name":"__d"}],"output":{"generics":["unop"],"name":"result"}}],[11,"hash","","",102,null],[11,"fmt","","",102,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_str","","",102,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"is_by_value","","Returns `true` if the unary operator takes its argument by value",102,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",103,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",103,{"inputs":[{"name":"self"}],"output":{"name":"stmt_"}}],[11,"eq","","",103,{"inputs":[{"name":"self"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"self"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",103,null],[11,"encode","","",103,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",103,{"inputs":[{"name":"__d"}],"output":{"generics":["stmt_"],"name":"result"}}],[11,"hash","","",103,null],[11,"attrs","","",103,null],[11,"id","","",103,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"clone","","",52,{"inputs":[{"name":"self"}],"output":{"name":"local"}}],[11,"eq","","",52,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",52,null],[11,"encode","","",52,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",52,{"inputs":[{"name":"__d"}],"output":{"generics":["local"],"name":"result"}}],[11,"hash","","",52,null],[11,"fmt","","",52,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",104,{"inputs":[{"name":"self"}],"output":{"name":"decl_"}}],[11,"eq","","",104,{"inputs":[{"name":"self"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"self"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",104,null],[11,"encode","","",104,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",104,{"inputs":[{"name":"__d"}],"output":{"generics":["decl_"],"name":"result"}}],[11,"hash","","",104,null],[11,"fmt","","",104,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"attrs","","",104,null],[11,"is_local","","",104,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"self"}],"output":{"name":"arm"}}],[11,"eq","","",53,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"ne","","",53,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",53,null],[11,"encode","","",53,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",53,{"inputs":[{"name":"__d"}],"output":{"generics":["arm"],"name":"result"}}],[11,"hash","","",53,null],[11,"fmt","","",53,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",54,{"inputs":[{"name":"self"}],"output":{"name":"field"}}],[11,"eq","","",54,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",54,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",54,null],[11,"encode","","",54,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",54,{"inputs":[{"name":"__d"}],"output":{"generics":["field"],"name":"result"}}],[11,"hash","","",54,null],[11,"fmt","","",54,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",105,{"inputs":[{"name":"self"}],"output":{"name":"blockcheckmode"}}],[11,"eq","","",105,{"inputs":[{"name":"self"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"self"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",105,null],[11,"encode","","",105,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",105,{"inputs":[{"name":"__d"}],"output":{"generics":["blockcheckmode"],"name":"result"}}],[11,"hash","","",105,null],[11,"fmt","","",105,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"self"}],"output":{"name":"unsafesource"}}],[11,"eq","","",106,{"inputs":[{"name":"self"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",106,null],[11,"encode","","",106,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",106,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafesource"],"name":"result"}}],[11,"hash","","",106,null],[11,"fmt","","",106,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",55,{"inputs":[{"name":"self"}],"output":{"name":"bodyid"}}],[11,"eq","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",55,null],[11,"partial_cmp","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"bool"}}],[11,"le","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"bool"}}],[11,"gt","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"bool"}}],[11,"ge","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"bool"}}],[11,"cmp","","",55,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"ordering"}}],[11,"encode","","",55,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",55,{"inputs":[{"name":"__d"}],"output":{"generics":["bodyid"],"name":"result"}}],[11,"hash","","",55,null],[11,"fmt","","",55,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",56,{"inputs":[{"name":"self"}],"output":{"name":"body"}}],[11,"eq","","",56,{"inputs":[{"name":"self"},{"name":"body"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"self"},{"name":"body"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",56,null],[11,"encode","","",56,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",56,{"inputs":[{"name":"__d"}],"output":{"generics":["body"],"name":"result"}}],[11,"hash","","",56,null],[11,"fmt","","",56,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"id","","",56,{"inputs":[{"name":"self"}],"output":{"name":"bodyid"}}],[11,"clone","","",107,{"inputs":[{"name":"self"}],"output":{"name":"bodyownerkind"}}],[11,"fmt","","",107,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",57,{"inputs":[{"name":"self"}],"output":{"name":"expr"}}],[11,"eq","","",57,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"ne","","",57,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",57,null],[11,"encode","","",57,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",57,{"inputs":[{"name":"__d"}],"output":{"generics":["expr"],"name":"result"}}],[11,"hash","","",57,null],[11,"precedence","","",57,{"inputs":[{"name":"self"}],"output":{"name":"exprprecedence"}}],[11,"fmt","","",57,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"self"}],"output":{"name":"expr_"}}],[11,"eq","","",108,{"inputs":[{"name":"self"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"ne","","",108,{"inputs":[{"name":"self"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",108,null],[11,"encode","","",108,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",108,{"inputs":[{"name":"__d"}],"output":{"generics":["expr_"],"name":"result"}}],[11,"hash","","",108,null],[11,"fmt","","",108,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",109,{"inputs":[{"name":"self"}],"output":{"name":"qpath"}}],[11,"eq","","",109,{"inputs":[{"name":"self"},{"name":"qpath"}],"output":{"name":"bool"}}],[11,"ne","","",109,{"inputs":[{"name":"self"},{"name":"qpath"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",109,null],[11,"encode","","",109,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",109,{"inputs":[{"name":"__d"}],"output":{"generics":["qpath"],"name":"result"}}],[11,"hash","","",109,null],[11,"fmt","","",109,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",110,{"inputs":[{"name":"self"}],"output":{"name":"localsource"}}],[11,"eq","","",110,{"inputs":[{"name":"self"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",110,null],[11,"encode","","",110,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",110,{"inputs":[{"name":"__d"}],"output":{"generics":["localsource"],"name":"result"}}],[11,"hash","","",110,null],[11,"fmt","","",110,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",111,{"inputs":[{"name":"self"}],"output":{"name":"matchsource"}}],[11,"eq","","",111,{"inputs":[{"name":"self"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"ne","","",111,{"inputs":[{"name":"self"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",111,null],[11,"encode","","",111,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",111,{"inputs":[{"name":"__d"}],"output":{"generics":["matchsource"],"name":"result"}}],[11,"hash","","",111,null],[11,"fmt","","",111,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"self"}],"output":{"name":"loopsource"}}],[11,"eq","","",112,{"inputs":[{"name":"self"},{"name":"loopsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",112,null],[11,"encode","","",112,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",112,{"inputs":[{"name":"__d"}],"output":{"generics":["loopsource"],"name":"result"}}],[11,"hash","","",112,null],[11,"fmt","","",112,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"self"}],"output":{"name":"loopiderror"}}],[11,"eq","","",113,{"inputs":[{"name":"self"},{"name":"loopiderror"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",113,null],[11,"encode","","",113,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",113,{"inputs":[{"name":"__d"}],"output":{"generics":["loopiderror"],"name":"result"}}],[11,"hash","","",113,null],[11,"fmt","","",113,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",113,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"self"}],"output":{"name":"loopidresult"}}],[11,"eq","","",114,{"inputs":[{"name":"self"},{"name":"loopidresult"}],"output":{"name":"bool"}}],[11,"ne","","",114,{"inputs":[{"name":"self"},{"name":"loopidresult"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",114,null],[11,"encode","","",114,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",114,{"inputs":[{"name":"__d"}],"output":{"generics":["loopidresult"],"name":"result"}}],[11,"hash","","",114,null],[11,"fmt","","",114,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into","","",114,{"inputs":[{"name":"self"}],"output":{"generics":["nodeid","loopiderror"],"name":"result"}}],[11,"from","","",114,{"inputs":[{"generics":["nodeid","loopiderror"],"name":"result"}],"output":{"name":"self"}}],[11,"clone","","",115,{"inputs":[{"name":"self"}],"output":{"name":"scopetarget"}}],[11,"eq","","",115,{"inputs":[{"name":"self"},{"name":"scopetarget"}],"output":{"name":"bool"}}],[11,"ne","","",115,{"inputs":[{"name":"self"},{"name":"scopetarget"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",115,null],[11,"encode","","",115,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",115,{"inputs":[{"name":"__d"}],"output":{"generics":["scopetarget"],"name":"result"}}],[11,"hash","","",115,null],[11,"fmt","","",115,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"opt_id","","",115,{"inputs":[{"name":"self"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"clone","","",58,{"inputs":[{"name":"self"}],"output":{"name":"destination"}}],[11,"eq","","",58,{"inputs":[{"name":"self"},{"name":"destination"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"self"},{"name":"destination"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",58,null],[11,"encode","","",58,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",58,{"inputs":[{"name":"__d"}],"output":{"generics":["destination"],"name":"result"}}],[11,"hash","","",58,null],[11,"fmt","","",58,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",116,{"inputs":[{"name":"self"}],"output":{"name":"generatormovability"}}],[11,"eq","","",116,{"inputs":[{"name":"self"},{"name":"generatormovability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",116,null],[11,"encode","","",116,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",116,{"inputs":[{"name":"__d"}],"output":{"generics":["generatormovability"],"name":"result"}}],[11,"hash","","",116,null],[11,"fmt","","",116,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",117,{"inputs":[{"name":"self"}],"output":{"name":"captureclause"}}],[11,"eq","","",117,{"inputs":[{"name":"self"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",117,null],[11,"encode","","",117,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",117,{"inputs":[{"name":"__d"}],"output":{"generics":["captureclause"],"name":"result"}}],[11,"hash","","",117,null],[11,"fmt","","",117,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",59,{"inputs":[{"name":"self"}],"output":{"name":"mutty"}}],[11,"eq","","",59,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",59,null],[11,"encode","","",59,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",59,{"inputs":[{"name":"__d"}],"output":{"generics":["mutty"],"name":"result"}}],[11,"hash","","",59,null],[11,"fmt","","",59,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",60,{"inputs":[{"name":"self"}],"output":{"name":"methodsig"}}],[11,"eq","","",60,{"inputs":[{"name":"self"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"ne","","",60,{"inputs":[{"name":"self"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",60,null],[11,"encode","","",60,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",60,{"inputs":[{"name":"__d"}],"output":{"generics":["methodsig"],"name":"result"}}],[11,"hash","","",60,null],[11,"fmt","","",60,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",61,{"inputs":[{"name":"self"}],"output":{"name":"traititemid"}}],[11,"eq","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"bool"}}],[11,"ne","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",61,null],[11,"partial_cmp","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"bool"}}],[11,"le","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"bool"}}],[11,"gt","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"bool"}}],[11,"ge","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"bool"}}],[11,"cmp","","",61,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":{"name":"ordering"}}],[11,"encode","","",61,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",61,{"inputs":[{"name":"__d"}],"output":{"generics":["traititemid"],"name":"result"}}],[11,"hash","","",61,null],[11,"fmt","","",61,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",62,{"inputs":[{"name":"self"}],"output":{"name":"traititem"}}],[11,"eq","","",62,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"ne","","",62,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",62,null],[11,"encode","","",62,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",62,{"inputs":[{"name":"__d"}],"output":{"generics":["traititem"],"name":"result"}}],[11,"hash","","",62,null],[11,"fmt","","",62,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",118,{"inputs":[{"name":"self"}],"output":{"name":"traitmethod"}}],[11,"eq","","",118,{"inputs":[{"name":"self"},{"name":"traitmethod"}],"output":{"name":"bool"}}],[11,"ne","","",118,{"inputs":[{"name":"self"},{"name":"traitmethod"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",118,null],[11,"encode","","",118,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",118,{"inputs":[{"name":"__d"}],"output":{"generics":["traitmethod"],"name":"result"}}],[11,"hash","","",118,null],[11,"fmt","","",118,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",119,{"inputs":[{"name":"self"}],"output":{"name":"traititemkind"}}],[11,"eq","","",119,{"inputs":[{"name":"self"},{"name":"traititemkind"}],"output":{"name":"bool"}}],[11,"ne","","",119,{"inputs":[{"name":"self"},{"name":"traititemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",119,null],[11,"encode","","",119,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",119,{"inputs":[{"name":"__d"}],"output":{"generics":["traititemkind"],"name":"result"}}],[11,"hash","","",119,null],[11,"fmt","","",119,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",63,{"inputs":[{"name":"self"}],"output":{"name":"implitemid"}}],[11,"eq","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"bool"}}],[11,"ne","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",63,null],[11,"partial_cmp","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"bool"}}],[11,"le","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"bool"}}],[11,"gt","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"bool"}}],[11,"ge","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"bool"}}],[11,"cmp","","",63,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":{"name":"ordering"}}],[11,"encode","","",63,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",63,{"inputs":[{"name":"__d"}],"output":{"generics":["implitemid"],"name":"result"}}],[11,"hash","","",63,null],[11,"fmt","","",63,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",64,{"inputs":[{"name":"self"}],"output":{"name":"implitem"}}],[11,"eq","","",64,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"ne","","",64,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",64,null],[11,"encode","","",64,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",64,{"inputs":[{"name":"__d"}],"output":{"generics":["implitem"],"name":"result"}}],[11,"hash","","",64,null],[11,"fmt","","",64,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",120,{"inputs":[{"name":"self"}],"output":{"name":"implitemkind"}}],[11,"eq","","",120,{"inputs":[{"name":"self"},{"name":"implitemkind"}],"output":{"name":"bool"}}],[11,"ne","","",120,{"inputs":[{"name":"self"},{"name":"implitemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",120,null],[11,"encode","","",120,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",120,{"inputs":[{"name":"__d"}],"output":{"generics":["implitemkind"],"name":"result"}}],[11,"hash","","",120,null],[11,"fmt","","",120,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",65,{"inputs":[{"name":"self"}],"output":{"name":"typebinding"}}],[11,"eq","","",65,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",65,null],[11,"encode","","",65,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",65,{"inputs":[{"name":"__d"}],"output":{"generics":["typebinding"],"name":"result"}}],[11,"hash","","",65,null],[11,"fmt","","",65,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",66,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"eq","","",66,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ne","","",66,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",66,null],[11,"encode","","",66,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",66,{"inputs":[{"name":"__d"}],"output":{"generics":["ty"],"name":"result"}}],[11,"hash","","",66,null],[11,"fmt","","",66,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",121,{"inputs":[{"name":"self"}],"output":{"name":"primty"}}],[11,"eq","","",121,{"inputs":[{"name":"self"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"ne","","",121,{"inputs":[{"name":"self"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",121,null],[11,"encode","","",121,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",121,{"inputs":[{"name":"__d"}],"output":{"generics":["primty"],"name":"result"}}],[11,"hash","","",121,null],[11,"fmt","","",121,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",67,{"inputs":[{"name":"self"}],"output":{"name":"barefnty"}}],[11,"eq","","",67,{"inputs":[{"name":"self"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"self"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",67,null],[11,"encode","","",67,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",67,{"inputs":[{"name":"__d"}],"output":{"generics":["barefnty"],"name":"result"}}],[11,"hash","","",67,null],[11,"fmt","","",67,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",68,{"inputs":[{"name":"self"}],"output":{"name":"existty"}}],[11,"eq","","",68,{"inputs":[{"name":"self"},{"name":"existty"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"self"},{"name":"existty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",68,null],[11,"encode","","",68,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",68,{"inputs":[{"name":"__d"}],"output":{"generics":["existty"],"name":"result"}}],[11,"hash","","",68,null],[11,"fmt","","",68,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",122,{"inputs":[{"name":"self"}],"output":{"name":"ty_"}}],[11,"eq","","",122,{"inputs":[{"name":"self"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"ne","","",122,{"inputs":[{"name":"self"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",122,null],[11,"encode","","",122,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",122,{"inputs":[{"name":"__d"}],"output":{"generics":["ty_"],"name":"result"}}],[11,"hash","","",122,null],[11,"fmt","","",122,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",69,{"inputs":[{"name":"self"}],"output":{"name":"inlineasmoutput"}}],[11,"eq","","",69,{"inputs":[{"name":"self"},{"name":"inlineasmoutput"}],"output":{"name":"bool"}}],[11,"ne","","",69,{"inputs":[{"name":"self"},{"name":"inlineasmoutput"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",69,null],[11,"encode","","",69,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",69,{"inputs":[{"name":"__d"}],"output":{"generics":["inlineasmoutput"],"name":"result"}}],[11,"hash","","",69,null],[11,"fmt","","",69,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",70,{"inputs":[{"name":"self"}],"output":{"name":"inlineasm"}}],[11,"eq","","",70,{"inputs":[{"name":"self"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"self"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",70,null],[11,"encode","","",70,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",70,{"inputs":[{"name":"__d"}],"output":{"generics":["inlineasm"],"name":"result"}}],[11,"hash","","",70,null],[11,"fmt","","",70,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",71,{"inputs":[{"name":"self"}],"output":{"name":"arg"}}],[11,"eq","","",71,{"inputs":[{"name":"self"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"self"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",71,null],[11,"encode","","",71,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",71,{"inputs":[{"name":"__d"}],"output":{"generics":["arg"],"name":"result"}}],[11,"hash","","",71,null],[11,"fmt","","",71,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",72,{"inputs":[{"name":"self"}],"output":{"name":"fndecl"}}],[11,"eq","","",72,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",72,null],[11,"encode","","",72,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",72,{"inputs":[{"name":"__d"}],"output":{"generics":["fndecl"],"name":"result"}}],[11,"hash","","",72,null],[11,"fmt","","",72,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",123,{"inputs":[{"name":"self"}],"output":{"name":"isauto"}}],[11,"eq","","",123,{"inputs":[{"name":"self"},{"name":"isauto"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",123,null],[11,"encode","","",123,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",123,{"inputs":[{"name":"__d"}],"output":{"generics":["isauto"],"name":"result"}}],[11,"hash","","",123,null],[11,"fmt","","",123,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",124,{"inputs":[{"name":"self"}],"output":{"name":"unsafety"}}],[11,"eq","","",124,{"inputs":[{"name":"self"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",124,null],[11,"encode","","",124,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",124,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafety"],"name":"result"}}],[11,"hash","","",124,null],[11,"fmt","","",124,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",125,{"inputs":[{"name":"self"}],"output":{"name":"constness"}}],[11,"eq","","",125,{"inputs":[{"name":"self"},{"name":"constness"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",125,null],[11,"encode","","",125,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",125,{"inputs":[{"name":"__d"}],"output":{"generics":["constness"],"name":"result"}}],[11,"hash","","",125,null],[11,"fmt","","",125,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",126,{"inputs":[{"name":"self"}],"output":{"name":"defaultness"}}],[11,"eq","","",126,{"inputs":[{"name":"self"},{"name":"defaultness"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"self"},{"name":"defaultness"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",126,null],[11,"encode","","",126,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",126,{"inputs":[{"name":"__d"}],"output":{"generics":["defaultness"],"name":"result"}}],[11,"hash","","",126,null],[11,"fmt","","",126,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"has_value","","",126,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_final","","",126,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_default","","",126,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",124,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",127,{"inputs":[{"name":"self"}],"output":{"name":"implpolarity"}}],[11,"eq","","",127,{"inputs":[{"name":"self"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",127,null],[11,"encode","","",127,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",127,{"inputs":[{"name":"__d"}],"output":{"generics":["implpolarity"],"name":"result"}}],[11,"hash","","",127,null],[11,"fmt","","",127,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",128,{"inputs":[{"name":"self"}],"output":{"name":"functionretty"}}],[11,"eq","","",128,{"inputs":[{"name":"self"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"ne","","",128,{"inputs":[{"name":"self"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",128,null],[11,"encode","","",128,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",128,{"inputs":[{"name":"__d"}],"output":{"generics":["functionretty"],"name":"result"}}],[11,"hash","","",128,null],[11,"fmt","","",128,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",128,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",73,{"inputs":[{"name":"self"}],"output":{"name":"mod"}}],[11,"eq","","",73,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",73,null],[11,"encode","","",73,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",73,{"inputs":[{"name":"__d"}],"output":{"generics":["mod"],"name":"result"}}],[11,"hash","","",73,null],[11,"fmt","","",73,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",74,{"inputs":[{"name":"self"}],"output":{"name":"foreignmod"}}],[11,"eq","","",74,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",74,null],[11,"encode","","",74,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",74,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignmod"],"name":"result"}}],[11,"hash","","",74,null],[11,"fmt","","",74,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",75,{"inputs":[{"name":"self"}],"output":{"name":"globalasm"}}],[11,"eq","","",75,{"inputs":[{"name":"self"},{"name":"globalasm"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"self"},{"name":"globalasm"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",75,null],[11,"encode","","",75,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",75,{"inputs":[{"name":"__d"}],"output":{"generics":["globalasm"],"name":"result"}}],[11,"hash","","",75,null],[11,"fmt","","",75,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",76,{"inputs":[{"name":"self"}],"output":{"name":"enumdef"}}],[11,"eq","","",76,{"inputs":[{"name":"self"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"self"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",76,null],[11,"encode","","",76,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",76,{"inputs":[{"name":"__d"}],"output":{"generics":["enumdef"],"name":"result"}}],[11,"hash","","",76,null],[11,"fmt","","",76,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",77,{"inputs":[{"name":"self"}],"output":{"name":"variant_"}}],[11,"eq","","",77,{"inputs":[{"name":"self"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"ne","","",77,{"inputs":[{"name":"self"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",77,null],[11,"encode","","",77,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",77,{"inputs":[{"name":"__d"}],"output":{"generics":["variant_"],"name":"result"}}],[11,"hash","","",77,null],[11,"fmt","","",77,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"self"}],"output":{"name":"usekind"}}],[11,"eq","","",129,{"inputs":[{"name":"self"},{"name":"usekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",129,null],[11,"encode","","",129,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",129,{"inputs":[{"name":"__d"}],"output":{"generics":["usekind"],"name":"result"}}],[11,"hash","","",129,null],[11,"fmt","","",129,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",78,{"inputs":[{"name":"self"}],"output":{"name":"traitref"}}],[11,"eq","","",78,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",78,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",78,null],[11,"encode","","",78,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",78,{"inputs":[{"name":"__d"}],"output":{"generics":["traitref"],"name":"result"}}],[11,"hash","","",78,null],[11,"fmt","","",78,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",79,{"inputs":[{"name":"self"}],"output":{"name":"polytraitref"}}],[11,"eq","","",79,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",79,null],[11,"encode","","",79,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",79,{"inputs":[{"name":"__d"}],"output":{"generics":["polytraitref"],"name":"result"}}],[11,"hash","","",79,null],[11,"fmt","","",79,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"self"}],"output":{"name":"visibility"}}],[11,"eq","","",130,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"ne","","",130,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",130,null],[11,"encode","","",130,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",130,{"inputs":[{"name":"__d"}],"output":{"generics":["visibility"],"name":"result"}}],[11,"hash","","",130,null],[11,"fmt","","",130,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_pub_restricted","","",130,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",80,{"inputs":[{"name":"self"}],"output":{"name":"structfield"}}],[11,"eq","","",80,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":{"name":"bool"}}],[11,"ne","","",80,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",80,null],[11,"encode","","",80,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",80,{"inputs":[{"name":"__d"}],"output":{"generics":["structfield"],"name":"result"}}],[11,"hash","","",80,null],[11,"fmt","","",80,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_positional","","",80,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",131,{"inputs":[{"name":"self"}],"output":{"name":"variantdata"}}],[11,"eq","","",131,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"bool"}}],[11,"ne","","",131,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",131,null],[11,"encode","","",131,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",131,{"inputs":[{"name":"__d"}],"output":{"generics":["variantdata"],"name":"result"}}],[11,"hash","","",131,null],[11,"fmt","","",131,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fields","","",131,null],[11,"id","","",131,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"is_struct","","",131,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_tuple","","",131,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_unit","","",131,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",81,{"inputs":[{"name":"self"}],"output":{"name":"itemid"}}],[11,"eq","","",81,{"inputs":[{"name":"self"},{"name":"itemid"}],"output":{"name":"bool"}}],[11,"ne","","",81,{"inputs":[{"name":"self"},{"name":"itemid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",81,null],[11,"encode","","",81,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",81,{"inputs":[{"name":"__d"}],"output":{"generics":["itemid"],"name":"result"}}],[11,"hash","","",81,null],[11,"fmt","","",81,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",82,{"inputs":[{"name":"self"}],"output":{"name":"item"}}],[11,"eq","","",82,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",82,null],[11,"encode","","",82,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",82,{"inputs":[{"name":"__d"}],"output":{"generics":["item"],"name":"result"}}],[11,"hash","","",82,null],[11,"fmt","","",82,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"self"}],"output":{"name":"item_"}}],[11,"eq","","",132,{"inputs":[{"name":"self"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"ne","","",132,{"inputs":[{"name":"self"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",132,null],[11,"encode","","",132,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",132,{"inputs":[{"name":"__d"}],"output":{"generics":["item_"],"name":"result"}}],[11,"hash","","",132,null],[11,"fmt","","",132,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"descriptive_variant","","",132,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"adt_kind","","",132,{"inputs":[{"name":"self"}],"output":{"generics":["adtkind"],"name":"option"}}],[11,"generics","","",132,{"inputs":[{"name":"self"}],"output":{"generics":["generics"],"name":"option"}}],[11,"clone","","",83,{"inputs":[{"name":"self"}],"output":{"name":"traititemref"}}],[11,"eq","","",83,{"inputs":[{"name":"self"},{"name":"traititemref"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"self"},{"name":"traititemref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",83,null],[11,"encode","","",83,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",83,{"inputs":[{"name":"__d"}],"output":{"generics":["traititemref"],"name":"result"}}],[11,"hash","","",83,null],[11,"fmt","","",83,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",84,{"inputs":[{"name":"self"}],"output":{"name":"implitemref"}}],[11,"eq","","",84,{"inputs":[{"name":"self"},{"name":"implitemref"}],"output":{"name":"bool"}}],[11,"ne","","",84,{"inputs":[{"name":"self"},{"name":"implitemref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",84,null],[11,"encode","","",84,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",84,{"inputs":[{"name":"__d"}],"output":{"generics":["implitemref"],"name":"result"}}],[11,"hash","","",84,null],[11,"fmt","","",84,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"self"}],"output":{"name":"associateditemkind"}}],[11,"eq","","",133,{"inputs":[{"name":"self"},{"name":"associateditemkind"}],"output":{"name":"bool"}}],[11,"ne","","",133,{"inputs":[{"name":"self"},{"name":"associateditemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",133,null],[11,"encode","","",133,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",133,{"inputs":[{"name":"__d"}],"output":{"generics":["associateditemkind"],"name":"result"}}],[11,"hash","","",133,null],[11,"fmt","","",133,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",85,{"inputs":[{"name":"self"}],"output":{"name":"foreignitem"}}],[11,"eq","","",85,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"ne","","",85,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",85,null],[11,"encode","","",85,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",85,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignitem"],"name":"result"}}],[11,"hash","","",85,null],[11,"fmt","","",85,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"self"}],"output":{"name":"foreignitem_"}}],[11,"eq","","",134,{"inputs":[{"name":"self"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"ne","","",134,{"inputs":[{"name":"self"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",134,null],[11,"encode","","",134,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",134,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignitem_"],"name":"result"}}],[11,"hash","","",134,null],[11,"fmt","","",134,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"descriptive_variant","","",134,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"fmt","","",86,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",86,{"inputs":[{"name":"self"}],"output":{"name":"freevar"}}],[11,"encode","","",86,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",86,{"inputs":[{"name":"__d"}],"output":{"generics":["freevar"],"name":"result"}}],[11,"var_id","","",86,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"clone","","",87,{"inputs":[{"name":"self"}],"output":{"name":"traitcandidate"}}],[11,"fmt","","",87,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",88,{"inputs":[{"name":"self"}],"output":{"name":"transfnattrs"}}],[11,"encode","","",88,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",88,{"inputs":[{"name":"__d"}],"output":{"generics":["transfnattrs"],"name":"result"}}],[11,"hash","","",88,null],[11,"eq","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"ne","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",89,null],[11,"clone","","",89,{"inputs":[{"name":"self"}],"output":{"name":"transfnattrflags"}}],[11,"partial_cmp","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"le","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"gt","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"ge","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"cmp","","",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"ordering"}}],[11,"hash","","",89,null],[11,"encode","","",89,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",89,{"inputs":[{"name":"__d"}],"output":{"generics":["transfnattrflags"],"name":"result"}}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"COLD","","",89,null],[18,"ALLOCATOR","","",89,null],[18,"UNWIND","","",89,null],[18,"RUSTC_ALLOCATOR_NOUNWIND","","",89,null],[18,"NAKED","","",89,null],[18,"NO_MANGLE","","",89,null],[18,"RUSTC_STD_INTERNAL_SYMBOL","","",89,null],[18,"NO_DEBUG","","",89,null],[11,"empty","","Returns an empty set of flags.",89,{"inputs":[],"output":{"name":"transfnattrflags"}}],[11,"all","","Returns the set containing all flags.",89,{"inputs":[],"output":{"name":"transfnattrflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",89,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",89,{"inputs":[{"name":"u8"}],"output":{"generics":["transfnattrflags"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",89,{"inputs":[{"name":"u8"}],"output":{"name":"transfnattrflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",89,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",89,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"transfnattrflags"}}],[11,"bitor_assign","","Adds the set of flags.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"transfnattrflags"}}],[11,"bitxor_assign","","Toggles the set of flags.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"transfnattrflags"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":{"name":"transfnattrflags"}}],[11,"sub_assign","","Disables all flags enabled in the set.",89,{"inputs":[{"name":"self"},{"name":"transfnattrflags"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",89,{"inputs":[{"name":"self"}],"output":{"name":"transfnattrflags"}}],[11,"extend","","",89,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",89,{"inputs":[{"name":"t"}],"output":{"name":"transfnattrflags"}}],[11,"new","","",88,{"inputs":[],"output":{"name":"transfnattrs"}}],[11,"requests_inline","","True if `#[inline]` or `#[inline(always)]` is present.",88,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"contains_extern_indicator","","True if `#[no_mangle]` or `#[export_name(...)]` is present.",88,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[0,"ich","rustc","ICH - Incremental Compilation Hash",null,null],[3,"Fingerprint","rustc::ich","",null,null],[12,"0","","",193,null],[12,"1","","",193,null],[3,"CachingCodemapView","","",null,null],[12,"codemap","","",194,null],[12,"line_cache","","",194,null],[12,"time_stamp","","",194,null],[3,"StableHashingContext","","This is the context state available during incr. comp. hashing. It contains enough information to transform DefIds and HirIds into stable DefPaths (i.e. a reference to the TyCtxt) and it holds a few caches for speeding up various things (e.g. each DefId/DefPath is only hashed once).",null,null],[12,"sess","","",195,null],[12,"definitions","","",195,null],[12,"cstore","","",195,null],[12,"body_resolver","","",195,null],[12,"hash_spans","","",195,null],[12,"hash_bodies","","",195,null],[12,"node_id_hashing_mode","","",195,null],[12,"raw_codemap","","",195,null],[12,"caching_codemap","","",195,null],[12,"alloc_id_recursion_tracker","","",195,null],[4,"NodeIdHashingMode","","",null,null],[13,"Ignore","","",196,null],[13,"HashDefPath","","",196,null],[5,"hash_stable_trait_impls","","",null,{"inputs":[{"name":"stablehashingcontext"},{"name":"stablehasher"},{"name":"vec"},{"name":"hashmap"}],"output":null}],[5,"compute_ignored_attr_names","","",null,{"inputs":[],"output":{"generics":["symbol"],"name":"fxhashset"}}],[0,"fingerprint","","",null,null],[3,"Fingerprint","rustc::ich::fingerprint","",null,null],[12,"0","","",193,null],[12,"1","","",193,null],[11,"assert_receiver_is_total_eq","rustc::ich","",193,null],[11,"eq","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"bool"}}],[11,"ne","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"bool"}}],[11,"cmp","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"bool"}}],[11,"le","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"bool"}}],[11,"gt","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"bool"}}],[11,"ge","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"bool"}}],[11,"hash","","",193,null],[11,"fmt","","",193,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",193,{"inputs":[{"name":"self"}],"output":{"name":"fingerprint"}}],[18,"ZERO","","",193,null],[11,"from_smaller_hash","","",193,{"inputs":[{"name":"u64"}],"output":{"name":"fingerprint"}}],[11,"to_smaller_hash","","",193,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"as_value","","",193,null],[11,"combine","","",193,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"fingerprint"}}],[11,"to_hex","","",193,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"encode_opaque","","",193,{"inputs":[{"name":"self"},{"name":"encoder"}],"output":{"name":"encoderesult"}}],[11,"decode_opaque","","",193,{"inputs":[{"name":"decoder"}],"output":{"generics":["fingerprint","string"],"name":"result"}}],[11,"fmt","","",193,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"finish","","",193,{"inputs":[{"name":"stablehasher"}],"output":{"name":"self"}}],[11,"hash_stable","","",193,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[0,"caching_codemap_view","","",null,null],[3,"CacheEntry","rustc::ich::caching_codemap_view","",null,null],[12,"time_stamp","","",197,null],[12,"line_number","","",197,null],[12,"line_start","","",197,null],[12,"line_end","","",197,null],[12,"file","","",197,null],[12,"file_index","","",197,null],[3,"CachingCodemapView","","",null,null],[12,"codemap","","",194,null],[12,"line_cache","","",194,null],[12,"time_stamp","","",194,null],[11,"clone","","",197,{"inputs":[{"name":"self"}],"output":{"name":"cacheentry"}}],[11,"clone","rustc::ich","",194,{"inputs":[{"name":"self"}],"output":{"name":"cachingcodemapview"}}],[11,"new","","",194,{"inputs":[{"name":"codemap"}],"output":{"name":"cachingcodemapview"}}],[11,"byte_pos_to_line_and_col","","",194,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"option"}}],[0,"hcx","","",null,null],[3,"StableHashingContext","rustc::ich::hcx","This is the context state available during incr. comp. hashing. It contains enough information to transform DefIds and HirIds into stable DefPaths (i.e. a reference to the TyCtxt) and it holds a few caches for speeding up various things (e.g. each DefId/DefPath is only hashed once).",null,null],[12,"sess","","",195,null],[12,"definitions","","",195,null],[12,"cstore","","",195,null],[12,"body_resolver","","",195,null],[12,"hash_spans","","",195,null],[12,"hash_bodies","","",195,null],[12,"node_id_hashing_mode","","",195,null],[12,"raw_codemap","","",195,null],[12,"caching_codemap","","",195,null],[12,"alloc_id_recursion_tracker","","",195,null],[3,"BodyResolver","","The BodyResolver allows to map a BodyId to the corresponding hir::Body. We could also just store a plain reference to the hir::Crate but we want to avoid that the crate is used to get untracked access to all of the HIR.",null,null],[12,"0","","",198,null],[4,"NodeIdHashingMode","","",null,null],[13,"Ignore","","",196,null],[13,"HashDefPath","","",196,null],[5,"compute_ignored_attr_names","","",null,{"inputs":[],"output":{"generics":["symbol"],"name":"fxhashset"}}],[5,"hash_stable_trait_impls","","",null,{"inputs":[{"name":"stablehashingcontext"},{"name":"stablehasher"},{"name":"vec"},{"name":"hashmap"}],"output":null}],[8,"StableHashingContextProvider","","Something that can provide a stable hashing context.",null,null],[10,"get_stable_hashing_context","","",199,{"inputs":[{"name":"self"}],"output":{"name":"stablehashingcontext"}}],[11,"clone","rustc::ich","",195,{"inputs":[{"name":"self"}],"output":{"name":"stablehashingcontext"}}],[11,"eq","","",196,{"inputs":[{"name":"self"},{"name":"nodeidhashingmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",196,null],[11,"clone","","",196,{"inputs":[{"name":"self"}],"output":{"name":"nodeidhashingmode"}}],[11,"clone","rustc::ich::hcx","",198,{"inputs":[{"name":"self"}],"output":{"name":"bodyresolver"}}],[11,"body","","",198,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"body"}}],[11,"new","rustc::ich","",195,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"definitions"},{"name":"cratestore"}],"output":{"name":"self"}}],[11,"sess","","",195,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"while_hashing_hir_bodies","","",195,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"f"}],"output":null}],[11,"while_hashing_spans","","",195,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"f"}],"output":null}],[11,"with_node_id_hashing_mode","","",195,{"inputs":[{"name":"self"},{"name":"nodeidhashingmode"},{"name":"f"}],"output":null}],[11,"def_path_hash","","",195,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpathhash"}}],[11,"local_def_path_hash","","",195,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defpathhash"}}],[11,"node_to_hir_id","","",195,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"hirid"}}],[11,"hash_bodies","","",195,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"codemap","","",195,{"inputs":[{"name":"self"}],"output":{"name":"cachingcodemapview"}}],[11,"is_ignored_attr","","",195,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"hash_hir_item_like","","",195,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"get_stable_hashing_context","","",195,{"inputs":[{"name":"self"}],"output":{"name":"stablehashingcontext"}}],[11,"hash_stable","rustc::hir","",55,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",33,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",33,null],[0,"impls_cstore","rustc::ich","This module contains `HashStable` implementations for various data types from rustc::middle::cstore in no particular order.",null,null],[0,"impls_hir","","This module contains `HashStable` implementations for various HIR data types in no particular order.",null,null],[11,"hash_stable","rustc::hir::def_id","",143,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",143,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"}],"output":{"name":"defpathhash"}}],[11,"hash_stable","","",144,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",144,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"}],"output":{"name":"defpathhash"}}],[11,"hash_stable","","",141,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",141,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"}],"output":{"name":"defpathhash"}}],[11,"hash_stable","rustc::hir","",34,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",34,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"}],"output":{"name":"itemlocalid"}}],[11,"hash_stable","","",81,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",61,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",63,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",90,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",35,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",36,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",37,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",38,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",39,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",40,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",91,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",92,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",41,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",93,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",42,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",95,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",43,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",96,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",44,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",45,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",46,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",59,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",60,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",65,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",66,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",121,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",67,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",68,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",122,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",72,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",128,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",78,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",79,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",109,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",48,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",49,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",50,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",51,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",97,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",98,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",99,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",101,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",102,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",52,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",104,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",53,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",54,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",105,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",106,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",57,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",108,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",110,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",112,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",111,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",116,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",117,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",58,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",114,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",113,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",115,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",62,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",118,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",119,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",64,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",120,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",130,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",126,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",127,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",73,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",74,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",76,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",77,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",129,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",80,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",131,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",82,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",132,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",83,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",84,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",133,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",85,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",134,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",103,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",71,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",56,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",55,null],[11,"hash_stable","","",69,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",75,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",70,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::hir::def","",139,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",140,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::hir","",100,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",123,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",124,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",125,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::hir::def_id","",142,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",142,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"}],"output":{"name":"defpathhash"}}],[11,"hash_stable","rustc::hir::def","",138,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::hir","",87,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",87,null],[11,"hash_stable","","",88,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",89,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",86,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"impls_mir","rustc::ich","This module contains `HashStable` implementations for various MIR data types in no particular order.",null,null],[0,"impls_misc","","This module contains `HashStable` implementations for various data types that don't fit into any of the other impls_xxx modules.",null,null],[0,"impls_ty","","This module contains `HashStable` implementations for various data types from rustc::ty in no particular order.",null,null],[4,"AllocDiscriminant","rustc::ich::impls_ty","",null,null],[13,"Alloc","","",200,null],[13,"Static","","",200,null],[13,"Function","","",200,null],[11,"hash_stable","","",200,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"impls_syntax","rustc::ich","This module contains `HashStable` implementations for various data types from libsyntax in no particular order.",null,null],[5,"hash_token","rustc::ich::impls_syntax","",null,{"inputs":[{"name":"token"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[5,"stable_byte_pos","","",null,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"u32"}}],[5,"stable_multibyte_char","","",null,null],[5,"stable_non_narrow_char","","",null,null],[17,"ATTR_DIRTY","rustc::ich","",null,null],[17,"ATTR_CLEAN","","",null,null],[17,"ATTR_IF_THIS_CHANGED","","",null,null],[17,"ATTR_THEN_THIS_WOULD_NEED","","",null,null],[17,"ATTR_PARTITION_REUSED","","",null,null],[17,"ATTR_PARTITION_TRANSLATED","","",null,null],[17,"DEP_GRAPH_ASSERT_ATTRS","","",null,null],[17,"IGNORED_ATTRIBUTES","","",null,null],[8,"StableHashingContextProvider","","Something that can provide a stable hashing context.",null,null],[10,"get_stable_hashing_context","","",199,{"inputs":[{"name":"self"}],"output":{"name":"stablehashingcontext"}}],[0,"infer","rustc","See the Book for more information.",null,null],[3,"TypeFreshener","rustc::infer","",null,null],[12,"infcx","","",201,null],[12,"freshen_count","","",201,null],[12,"freshen_map","","",201,null],[3,"InferOk","","",null,null],[12,"value","","",202,null],[12,"obligations","","",202,null],[3,"InferCtxt","","",null,null],[12,"tcx","","",203,null],[12,"in_progress_tables","","During type-checking/inference of a body, `in_progress_tables` contains a reference to the tables being built up, which are used for reading closure kinds/signatures as they are inferred, and for error reporting logic to read arbitrary node types.",203,null],[12,"projection_cache","","",203,null],[12,"type_variables","","",203,null],[12,"int_unification_table","","",203,null],[12,"float_unification_table","","",203,null],[12,"region_constraints","","",203,null],[12,"lexical_region_resolutions","","",203,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used for things that have to do with the parameters in scope.",203,null],[12,"evaluation_cache","","Caches the results of trait evaluation.",203,null],[12,"reported_trait_errors","","",203,null],[12,"tainted_by_errors_flag","","",203,null],[12,"err_count_on_creation","","",203,null],[12,"in_snapshot","","",203,null],[12,"region_obligations","","",203,null],[12,"universe","","What is the innermost universe we have created? Starts out as `UniverseIndex::root()` but grows from there as we enter universal quantifiers.",203,null],[3,"TypeTrace","","The trace designates the path through inference that we took to encounter an error or subtyping constraint.",null,null],[12,"cause","","",204,null],[12,"values","","",204,null],[3,"RegionObligation","","See the `region_obligations` field for more information.",null,null],[12,"sub_region","","",205,null],[12,"sup_type","","",205,null],[12,"cause","","",205,null],[3,"InferCtxtBuilder","","Helper type of a temporary returned by tcx.infer_ctxt(). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(InferCtxt<'b, 'gcx, 'tcx>).",null,null],[12,"global_tcx","","",206,null],[12,"arena","","",206,null],[12,"fresh_tables","","",206,null],[3,"CombinedSnapshot","","",null,null],[12,"projection_cache_snapshot","","",207,null],[12,"type_snapshot","","",207,null],[12,"int_snapshot","","",207,null],[12,"float_snapshot","","",207,null],[12,"region_constraints_snapshot","","",207,null],[12,"region_obligations_snapshot","","",207,null],[12,"universe","","",207,null],[12,"was_in_snapshot","","",207,null],[12,"_in_progress_tables","","",207,null],[4,"ValuePairs","","See `error_reporting` module for more details",null,null],[13,"Types","","",208,null],[13,"Regions","","",208,null],[13,"TraitRefs","","",208,null],[13,"PolyTraitRefs","","",208,null],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",null,null],[13,"Subtype","","",209,null],[13,"InfStackClosure","","",209,null],[13,"InvokeClosure","","",209,null],[13,"DerefPointer","","",209,null],[13,"FreeVariable","","",209,null],[13,"IndexSlice","","",209,null],[13,"RelateObjectBound","","",209,null],[13,"RelateParamBound","","",209,null],[13,"RelateRegionParamBound","","",209,null],[13,"RelateDefaultParamBound","","",209,null],[13,"Reborrow","","",209,null],[13,"ReborrowUpvar","","",209,null],[13,"DataBorrowed","","",209,null],[13,"ReferenceOutlivesReferent","","",209,null],[13,"ParameterInScope","","",209,null],[13,"ExprTypeIsNotInScope","","",209,null],[13,"BindingTypeIsNotValidAtDecl","","",209,null],[13,"CallRcvr","","",209,null],[13,"CallArg","","",209,null],[13,"CallReturn","","",209,null],[13,"Operand","","",209,null],[13,"AddrOf","","",209,null],[13,"AutoBorrow","","",209,null],[13,"SafeDestructor","","",209,null],[13,"CompareImplMethodObligation","","",209,null],[12,"span","rustc::infer::SubregionOrigin","",209,null],[12,"item_name","","",209,null],[12,"impl_item_def_id","","",209,null],[12,"trait_item_def_id","","",209,null],[4,"ParameterOrigin","rustc::infer","Places that type/region parameters can appear.",null,null],[13,"Path","","",210,null],[13,"MethodCall","","",210,null],[13,"OverloadedOperator","","",210,null],[13,"OverloadedDeref","","",210,null],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",null,null],[13,"FnCall","","when a fn is called",211,null],[13,"HigherRankedType","","when two higher-ranked types are compared",211,null],[13,"AssocTypeProjection","","when projecting an associated type",211,null],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",null,null],[13,"MiscVariable","","",212,null],[13,"PatternRegion","","",212,null],[13,"AddrOfRegion","","",212,null],[13,"Autoref","","",212,null],[13,"Coercion","","",212,null],[13,"EarlyBoundRegion","","",212,null],[13,"LateBoundRegion","","",212,null],[13,"UpvarRegion","","",212,null],[13,"BoundRegionInCoherence","","",212,null],[13,"NLL","","",212,null],[4,"NLLRegionVariableOrigin","","",null,null],[13,"FreeRegion","","",213,null],[13,"Inferred","","",213,null],[4,"FixupError","","",null,null],[13,"UnresolvedIntTy","","",214,null],[13,"UnresolvedFloatTy","","",214,null],[13,"UnresolvedTy","","",214,null],[0,"anon_types","","",null,null],[3,"AnonTypeDecl","rustc::infer::anon_types","Information about the anonymous, abstract types whose values we are inferring in this function (these are the `impl Trait` that appear in the return type).",null,null],[12,"substs","","The substitutions that we apply to the abstract that that this `impl Trait` desugars to. e.g., if:",215,null],[12,"concrete_ty","","The type variable that represents the value of the abstract type that we require. In other words, after we compile this function, we will be created a constraint like:",215,null],[12,"has_required_region_bounds","","True if the `impl Trait` bounds include region bounds. For example, this would be true for:",215,null],[3,"ReverseMapper","","",null,null],[12,"tcx","","",216,null],[12,"tainted_by_errors","","If errors have already been reported in this fn, we suppress our own errors because they are sometimes derivative.",216,null],[12,"anon_type_def_id","","",216,null],[12,"map","","",216,null],[12,"map_missing_regions_to_empty","","",216,null],[12,"hidden_ty","","initially `Some`, set to `None` once error has been reported",216,null],[3,"Instantiator","","",null,null],[12,"infcx","","",217,null],[12,"parent_def_id","","",217,null],[12,"body_id","","",217,null],[12,"param_env","","",217,null],[12,"anon_types","","",217,null],[12,"obligations","","",217,null],[6,"AnonTypeMap","","",null,null],[11,"clone","","",215,{"inputs":[{"name":"self"}],"output":{"name":"anontypedecl"}}],[11,"fmt","","",215,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"instantiate_anon_types","rustc::infer","Replace all anonymized types in `value` with fresh inference variables and creates appropriate obligations. For example, given the input:",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"nodeid"},{"name":"paramenv"},{"name":"t"}],"output":{"name":"inferok"}}],[11,"constrain_anon_types","","Given the map `anon_types` containing the existential `impl Trait` types whose underlying, hidden types are being inferred, this method adds constraints to the regions appearing in those underlying hidden types to ensure that they at least do not refer to random scopes within the current function. These constraints are not (quite) sufficient to guarantee that the regions are actually legal values; that final condition is imposed after region inference is done.",203,{"inputs":[{"name":"self"},{"name":"anontypemap"},{"name":"frr"}],"output":null}],[11,"constrain_anon_type","","",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"anontypedecl"},{"name":"frr"}],"output":null}],[11,"infer_anon_definition_from_instantiation","","Given the fully resolved, instantiated type for an anonymous type, i.e., the value of an inference variable like C1 or C2 (*), computes the \"definition type\" for an abstract type definition -- that is, the inferred value of `Foo1<'x>` or `Foo2<'x>` that we would conceptually use in its definition:",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"anontypedecl"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"new","rustc::infer::anon_types","",216,{"inputs":[{"name":"tyctxt"},{"name":"bool"},{"name":"defid"},{"generics":["kind","kind"],"name":"fxhashmap"},{"name":"ty"}],"output":{"name":"self"}}],[11,"fold_kind_mapping_missing_regions_to_empty","","",216,{"inputs":[{"name":"self"},{"name":"kind"}],"output":{"name":"kind"}}],[11,"fold_kind_normally","","",216,{"inputs":[{"name":"self"},{"name":"kind"}],"output":{"name":"kind"}}],[11,"tcx","","",216,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_region","","",216,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",216,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"instantiate_anon_types_in_map","","",217,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"fold_anon_ty","","",217,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[0,"at","rustc::infer","A nice interface for working with the infcx.  The basic idea is to do `infcx.at(cause, param_env)`, which sets the \"cause\" of the operation as well as the surrounding parameter environment.  Then you can do something like `.sub(a, b)` or `.eq(a, b)` to create a subtype or equality relationship respectively. The first argument is always the \"expected\" output from the POV of diagnostics.",null,null],[3,"At","rustc::infer::at","",null,null],[12,"infcx","","",218,null],[12,"cause","","",218,null],[12,"param_env","","",218,null],[3,"Trace","","",null,null],[12,"at","","",219,null],[12,"a_is_expected","","",219,null],[12,"trace","","",219,null],[8,"ToTrace","","",null,null],[10,"to_trace","","",220,{"inputs":[{"name":"obligationcause"},{"name":"bool"},{"name":"self"},{"name":"self"}],"output":{"name":"typetrace"}}],[11,"at","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"paramenv"}],"output":{"name":"at"}}],[11,"eq_impl_headers","rustc::infer::at","Hacky routine for equating two impl headers in coherence.",218,{"inputs":[{"name":"self"},{"name":"implheader"},{"name":"implheader"}],"output":{"name":"inferresult"}}],[11,"sub_exp","","Make `a <: b` where `a` may or may not be expected",218,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"sup","","Make `actual <: expected`. For example, if type-checking a call like `foo(x)`, where `foo: fn(i32)`, you might have `sup(i32, x)`, since the \"expected\" type is the type that appears in the signature.",218,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"sub","","Make `expected <: actual`",218,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"eq_exp","","Make `expected <: actual`",218,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"eq","","Make `expected <: actual`",218,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"lub","","Compute the least-upper-bound, or mutual supertype, of two values. The order of the arguments doesn't matter, but since this can result in an error (e.g., if asked to compute LUB of u32 and i32), it is meaningful to call one of them the \"expected type\".",218,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"glb","","Compute the greatest-lower-bound, or mutual subtype, of two values. As with `lub` order doesn't matter, except for error cases.",218,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"trace","","Sets the \"trace\" values that will be used for error-reporting, but doesn't actually perform any operation yet (this is useful when you want to set the trace using distinct values from those you wish to operate upon).",218,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"trace"}}],[11,"trace_exp","","Like `trace`, but the expected value is determined by the boolean argument (if true, then the first argument `a` is the \"expected\" value).",218,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"trace"}}],[11,"sub","","Make `a <: b` where `a` may or may not be expected (if `a_is_expected` is true, then `a` is expected). Make `expected <: actual`",219,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"eq","","Make `a == b`; the expectation is set by the call to `trace()`.",219,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"lub","","",219,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[11,"glb","","",219,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"inferresult"}}],[0,"canonical","rustc::infer","Canonicalization is the key to constructing a query in the middle of type inference. Ordinarily, it is not possible to store types from type inference in query keys, because they contain references to inference variables whose lifetimes are too short and so forth. Canonicalizing a value T1 using `canonicalize_query` produces two things:",null,null],[3,"Canonical","rustc::infer::canonical","A \"canonicalized\" type `V` is one where all free inference variables have been rewriten to \"canonical vars\". These are numbered starting from 0 in order of first appearance.",null,null],[12,"variables","","",221,null],[12,"value","","",221,null],[3,"CanonicalVarValues","","A set of values corresponding to the canonical variables from some `Canonical`. You can give these values to `canonical_value.substitute` to substitute them into the canonical value at the right places.",null,null],[12,"var_values","","",222,null],[3,"CanonicalVarInfo","","Information about a canonical variable that is included with the canonical value. This is sufficient information for code to create a copy of the canonical value in some other inference context, with fresh inference variables replacing the canonical values.",null,null],[12,"kind","","",223,null],[3,"QueryResult","","After we execute a query with a canonicalized key, we get back a `Canonical<QueryResult<..>>`. You can use `instantiate_query_result` to access the data in this result.",null,null],[12,"var_values","","",224,null],[12,"region_constraints","","",224,null],[12,"certainty","","",224,null],[12,"value","","",224,null],[3,"CanonicalizeAllFreeRegions","","If this flag is true, then all free regions will be replaced with a canonical var. This is used to make queries as generic as possible. For example, the query `F: Foo<'static>` would be canonicalized to `F: Foo<'0>`.",null,null],[12,"0","","",225,null],[3,"Canonicalizer","","",null,null],[12,"infcx","","",226,null],[12,"tcx","","",226,null],[12,"variables","","",226,null],[12,"indices","","",226,null],[12,"var_values","","",226,null],[12,"canonicalize_all_free_regions","","",226,null],[12,"needs_canonical_flags","","",226,null],[3,"CanonicalVarValuesSubst","","",null,null],[12,"tcx","","",227,null],[12,"var_values","","",227,null],[4,"CanonicalVarKind","","Describes the \"kind\" of the canonical variable. This is a \"kind\" in the type-theory sense of the term -- i.e., a \"meta\" type system that analyzes type-like values.",null,null],[13,"Ty","","Some kind of type inference variable.",228,null],[13,"Region","","Region variable `'?R`.",228,null],[4,"CanonicalTyVarKind","","Rust actually has more than one category of type variables; notably, the type variables we create for literals (e.g., 22 or 22.) can only be instantiated with integral/float types (e.g., usize or f32). In order to faithfully reproduce a type, we need to know what set of types a given type variable can be unified with.",null,null],[13,"General","","General type variable `?T` that can be unified with arbitrary types.",229,null],[13,"Int","","Integral type variable `?I` (that can only be unified with integral types).",229,null],[13,"Float","","Floating-point type variable `?F` (that can only be unified with float types).",229,null],[4,"Certainty","","Indicates whether or not we were able to prove the query to be true.",null,null],[13,"Proven","","The query is known to be true, presuming that you apply the given `var_values` and the region-constraints are satisfied.",230,null],[13,"Ambiguous","","The query is not known to be true, but also not known to be false. The `var_values` represent either values that must hold in order for the query to be true, or helpful tips that might make it true. Currently rustc's trait solver cannot distinguish the two (e.g., due to our preference for where clauses over impls).",230,null],[5,"substitute_value","","Substitute the values from `var_values` into `value`. `var_values` must be values for the set of cnaonical variables that appear in `value`.",null,{"inputs":[{"name":"tyctxt"},{"name":"canonicalvarvalues"},{"name":"t"}],"output":{"name":"t"}}],[6,"CanonicalVarInfos","","",null,null],[6,"QueryRegionConstraint","","",null,null],[8,"Canonicalize","","Trait implemented by values that can be canonicalized. It mainly serves to identify the interning table we will use.",null,null],[16,"Canonicalized","","",231,null],[10,"intern","","After a value has been fully canonicalized and lifted, this method will allocate it in a global arena.",231,null],[11,"clone","","",221,{"inputs":[{"name":"self"}],"output":{"name":"canonical"}}],[11,"fmt","","",221,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",221,{"inputs":[{"name":"self"},{"name":"canonical"}],"output":{"name":"bool"}}],[11,"ne","","",221,{"inputs":[{"name":"self"},{"name":"canonical"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",221,null],[11,"hash","","",221,null],[11,"decode","","",221,{"inputs":[{"name":"__dv"}],"output":{"generics":["canonical"],"name":"result"}}],[11,"encode","","",221,{"inputs":[{"name":"self"},{"name":"__sv"}],"output":{"name":"result"}}],[11,"clone","","",222,{"inputs":[{"name":"self"}],"output":{"name":"canonicalvarvalues"}}],[11,"fmt","","",222,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",222,{"inputs":[{"name":"self"},{"name":"canonicalvarvalues"}],"output":{"name":"bool"}}],[11,"ne","","",222,{"inputs":[{"name":"self"},{"name":"canonicalvarvalues"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",222,null],[11,"hash","","",222,null],[11,"decode","","",222,{"inputs":[{"name":"__d"}],"output":{"generics":["canonicalvarvalues"],"name":"result"}}],[11,"encode","","",222,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",223,{"inputs":[{"name":"self"}],"output":{"name":"canonicalvarinfo"}}],[11,"fmt","","",223,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",223,{"inputs":[{"name":"self"},{"name":"canonicalvarinfo"}],"output":{"name":"bool"}}],[11,"ne","","",223,{"inputs":[{"name":"self"},{"name":"canonicalvarinfo"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",223,null],[11,"hash","","",223,null],[11,"decode","","",223,{"inputs":[{"name":"__d"}],"output":{"generics":["canonicalvarinfo"],"name":"result"}}],[11,"encode","","",223,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",228,{"inputs":[{"name":"self"}],"output":{"name":"canonicalvarkind"}}],[11,"fmt","","",228,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",228,{"inputs":[{"name":"self"},{"name":"canonicalvarkind"}],"output":{"name":"bool"}}],[11,"ne","","",228,{"inputs":[{"name":"self"},{"name":"canonicalvarkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",228,null],[11,"hash","","",228,null],[11,"decode","","",228,{"inputs":[{"name":"__d"}],"output":{"generics":["canonicalvarkind"],"name":"result"}}],[11,"encode","","",228,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",229,{"inputs":[{"name":"self"}],"output":{"name":"canonicaltyvarkind"}}],[11,"fmt","","",229,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",229,{"inputs":[{"name":"self"},{"name":"canonicaltyvarkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",229,null],[11,"hash","","",229,null],[11,"decode","","",229,{"inputs":[{"name":"__d"}],"output":{"generics":["canonicaltyvarkind"],"name":"result"}}],[11,"encode","","",229,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",224,{"inputs":[{"name":"self"}],"output":{"name":"queryresult"}}],[11,"fmt","","",224,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",230,{"inputs":[{"name":"self"}],"output":{"name":"certainty"}}],[11,"fmt","","",230,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_proven","","",230,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ambiguous","","",230,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_proven","","",224,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ambiguous","","",224,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_proven","","",221,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ambiguous","","",221,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"instantiate_canonical_with_fresh_inference_vars","rustc::infer","Creates a substitution S for the canonical value with fresh inference variables and applies it to the canonical value. Returns both the instantiated result and the substitution S.",203,null],[11,"fresh_inference_vars_for_canonical_vars","","Given the \"infos\" about the canonical variables from some canonical, creates fresh inference variables with the same characteristics. You can then use `substitute` to instantiate the canonical variable with these inference variables.",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"slice"}],"output":{"name":"canonicalvarvalues"}}],[11,"fresh_inference_var_for_canonical_var","","Given the \"info\" about a canonical variable, creates a fresh inference variable with the same characteristics.",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"canonicalvarinfo"}],"output":{"name":"kind"}}],[11,"instantiate_query_result","","Given the (canonicalized) result to a canonical query, instantiates the result so it can be used, plugging in the values from the canonical query. (Note that the result may have been ambiguous; you should check the certainty level of the query before applying this function.)",203,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"paramenv"},{"name":"canonicalvarvalues"},{"name":"canonical"}],"output":{"name":"inferresult"}}],[11,"query_region_constraints_into_obligations","","Converts the region constraints resulting from a query into an iterator of obligations.",203,null],[11,"unify_canonical_vars","","Given two sets of values for the same set of canonical variables, unify them. The second set is produced lazilly by supplying indices from the first set.",203,null],[11,"canonicalize_query","","Canonicalizes a query value `V`. When we canonicalize a query, we not only canonicalize unbound inference variables, but we also replace all free regions whatsoever. So for example a query like `T: Trait<'static>` would be canonicalized to",203,null],[11,"canonicalize_response","","Canonicalizes a query response `V`. When we canonicalize a query response, we only canonicalize unbound inference variables, and we leave other free regions alone. So, continuing with the example from `canonicalize_query`, if there was an input query `T: Trait<'static>`, it would have been canonicalized to",203,null],[11,"tcx","rustc::infer::canonical","",226,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_region","","",226,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",226,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"canonicalize","","The main `canonicalize` method, shared impl of `canonicalize_query` and `canonicalize_response`.",226,null],[11,"canonical_var","","Creates a canonical variable replacing `kind` from the input, or returns an existing variable if `kind` has already been seen. `kind` is expected to be an unbound variable (or potentially a free region).",226,{"inputs":[{"name":"self"},{"name":"canonicalvarinfo"},{"name":"kind"}],"output":{"name":"canonicalvar"}}],[11,"canonicalize_ty_var","","Given a type variable `ty_var` of the given kind, first check if `ty_var` is bound to anything; if so, canonicalize that. Otherwise, create a new canonical variable for `ty_var`.",226,{"inputs":[{"name":"self"},{"name":"canonicaltyvarkind"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"substitute","","Instantiate the wrapped value, replacing each canonical value with the value given in `var_values`.",221,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"canonicalvarvalues"}],"output":{"name":"v"}}],[11,"substitute_projected","","Invoke `projection_fn` with `self.value` to get a value V that is expressed in terms of the same canonical variables bound in `self`. Apply the substitution `var_values` to this value V, replacing each of the canonical variables.",221,null],[11,"tcx","","",227,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",227,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",227,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"super_fold_with","","",230,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"certainty"}}],[11,"super_visit_with","","",230,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",223,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"canonicalvarinfo"}}],[11,"super_visit_with","","",223,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",228,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"canonicalvarkind"}}],[11,"super_visit_with","","",228,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",230,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",223,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",228,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"super_fold_with","","",232,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"canonicalvarinfos"}}],[11,"super_visit_with","","",232,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",221,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",221,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",221,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["canonical"],"name":"option"}}],[11,"iter","","",222,null],[11,"len","","",222,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"lift_to_tcx","","",222,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["canonicalvarvalues"],"name":"option"}}],[11,"super_fold_with","","",222,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",222,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",224,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",224,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",224,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["queryresult"],"name":"option"}}],[11,"index","","",222,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"kind"}}],[0,"combine","rustc::infer","",null,null],[3,"CombineFields","rustc::infer::combine","",null,null],[12,"infcx","","",233,null],[12,"trace","","",233,null],[12,"cause","","",233,null],[12,"param_env","","",233,null],[12,"obligations","","",233,null],[3,"Generalizer","","",null,null],[12,"infcx","","",234,null],[12,"span","","Span, used when creating new type variables and things.",234,null],[12,"for_vid_sub_root","","The vid of the type variable that is in the process of being instantiated; if we find this within the type we are folding, that means we would have created a cyclic type.",234,null],[12,"ambient_variance","","Track the variance as we descend into the type.",234,null],[12,"needs_wf","","See the field `needs_wf` in `Generalization`.",234,null],[12,"root_ty","","The root type that we are generalizing. Used when reporting cycles.",234,null],[3,"Generalization","","Result from a generalization operation. This includes not only the generalized type, but also a bool flag indicating whether further WF checks are needed.",null,null],[12,"ty","","",235,null],[12,"needs_wf","","If true, then the generalized type may not be well-formed, even if the source type is well-formed, so we should add an additional check to enforce that it is. This arises in particular around 'bivariant' type parameters that are only constrained by a where-clause. As an example, imagine a type:",235,null],[4,"RelationDir","","",null,null],[13,"SubtypeOf","","",236,null],[13,"SupertypeOf","","",236,null],[13,"EqTo","","",236,null],[5,"int_unification_error","","",null,null],[5,"float_unification_error","","",null,null],[8,"RelateResultCompare","","",null,null],[10,"compare","","",237,{"inputs":[{"name":"self"},{"name":"t"},{"name":"f"}],"output":{"name":"relateresult"}}],[11,"clone","","",233,{"inputs":[{"name":"self"}],"output":{"name":"combinefields"}}],[11,"clone","","",236,{"inputs":[{"name":"self"}],"output":{"name":"relationdir"}}],[11,"assert_receiver_is_total_eq","","",236,null],[11,"eq","","",236,{"inputs":[{"name":"self"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"hash","","",236,null],[11,"fmt","","",236,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"super_combine_tys","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"r"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"unify_integral_variable","","",203,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"intvid"},{"name":"intvarvalue"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"unify_float_variable","","",203,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"floatvid"},{"name":"floatty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"tcx","rustc::infer::combine","",233,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"equate","","",233,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"equate"}}],[11,"sub","","",233,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"sub"}}],[11,"lub","","",233,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"lub"}}],[11,"glb","","",233,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"glb"}}],[11,"instantiate","","Here dir is either EqTo, SubtypeOf, or SupertypeOf. The idea is that we should ensure that the type `a_ty` is equal to, a subtype of, or a supertype of (respectively) the type to which `b_vid` is bound.",233,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"relationdir"},{"name":"tyvid"},{"name":"bool"}],"output":{"name":"relateresult"}}],[11,"generalize","","Attempts to generalize `ty` for the type variable `for_vid`. This checks for cycle -- that is, whether the type `ty` references `for_vid`. The `dir` is the \"direction\" for which we a performing the generalization (i.e., are we producing a type that can be used as a supertype etc).",233,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tyvid"},{"name":"relationdir"}],"output":{"generics":["generalization"],"name":"relateresult"}}],[11,"tcx","","",234,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"tag","","",234,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"a_is_expected","","",234,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"binders","","",234,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[11,"relate_item_substs","","",234,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"},{"name":"substs"}],"output":{"generics":["substs"],"name":"relateresult"}}],[11,"relate_with_variance","","",234,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",234,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"regions","","",234,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[0,"equate","rustc::infer","",null,null],[3,"Equate","rustc::infer::equate","Ensures `a` is made equal to `b`. Returns `a` on success.",null,null],[12,"fields","","",238,null],[12,"a_is_expected","","",238,null],[11,"new","","",238,{"inputs":[{"name":"combinefields"},{"name":"bool"}],"output":{"name":"equate"}}],[11,"tag","","",238,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"tcx","","",238,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"a_is_expected","","",238,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"relate_item_substs","","",238,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"},{"name":"substs"}],"output":{"generics":["substs"],"name":"relateresult"}}],[11,"relate_with_variance","","",238,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",238,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"regions","","",238,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[11,"binders","","",238,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[0,"error_reporting","rustc::infer","Error Reporting Code for the inference engine",null,null],[4,"FailureCode","rustc::infer::error_reporting","",null,null],[13,"Error0317","","",239,null],[13,"Error0580","","",239,null],[13,"Error0308","","",239,null],[13,"Error0644","","",239,null],[0,"note","","",null,null],[11,"note_region_origin","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"subregionorigin"}],"output":null}],[11,"report_concrete_failure","","",203,{"inputs":[{"name":"self"},{"name":"scopetree"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"diagnosticbuilder"}}],[0,"need_type_info","rustc::infer::error_reporting","",null,null],[3,"FindLocalByTypeVisitor","rustc::infer::error_reporting::need_type_info","",null,null],[12,"infcx","","",240,null],[12,"target_ty","","",240,null],[12,"hir_map","","",240,null],[12,"found_local_pattern","","",240,null],[12,"found_arg_pattern","","",240,null],[11,"node_matches_type","","",240,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"nested_visit_map","","",240,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_local","","",240,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_body","","",240,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"extract_type_name","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"string"}}],[11,"need_type_info","","",203,{"inputs":[{"name":"self"},{"generics":["bodyid"],"name":"option"},{"name":"span"},{"name":"ty"}],"output":null}],[0,"nice_region_error","rustc::infer::error_reporting","",null,null],[3,"NiceRegionError","rustc::infer::error_reporting::nice_region_error","",null,null],[12,"tcx","","",241,null],[12,"error","","",241,null],[12,"regions","","",241,null],[12,"tables","","",241,null],[0,"different_lifetimes","","Error Reporting for Anonymous Region Lifetime Errors where both the regions are anonymous.",null,null],[11,"try_report_anon_anon_conflict","","Print the error message for lifetime errors when both the concerned regions are anonymous.",241,{"inputs":[{"name":"self"}],"output":{"generics":["errorreported"],"name":"option"}}],[0,"find_anon_type","","",null,null],[3,"FindNestedTypeVisitor","rustc::infer::error_reporting::nice_region_error::find_anon_type","",null,null],[12,"tcx","","",242,null],[12,"bound_region","","",242,null],[12,"found_type","","",242,null],[12,"depth","","",242,null],[3,"TyPathVisitor","","",null,null],[12,"tcx","","",243,null],[12,"found_it","","",243,null],[12,"bound_region","","",243,null],[12,"depth","","",243,null],[11,"find_anon_type","rustc::infer::error_reporting::nice_region_error","This function calls the `visit_ty` method for the parameters corresponding to the anonymous regions. The `nested_visitor.found_type` contains the anonymous type.",241,{"inputs":[{"name":"self"},{"name":"region"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"find_component_for_bound_region","","",241,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"boundregion"}],"output":{"generics":["ty"],"name":"option"}}],[11,"nested_visit_map","rustc::infer::error_reporting::nice_region_error::find_anon_type","",242,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_ty","","",242,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"nested_visit_map","","",243,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_lifetime","","",243,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_ty","","",243,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[0,"named_anon_conflict","rustc::infer::error_reporting::nice_region_error","Error Reporting for Anonymous Region Lifetime Errors where one region is named and the other is anonymous.",null,null],[11,"try_report_named_anon_conflict","","When given a `ConcreteFailure` for a function with arguments containing a named region and an anonymous region, emit an descriptive diagnostic error.",241,{"inputs":[{"name":"self"}],"output":{"generics":["errorreported"],"name":"option"}}],[11,"is_named_region","","",241,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[0,"outlives_closure","","Error Reporting for Anonymous Region Lifetime Errors where both the regions are anonymous.",null,null],[11,"try_report_outlives_closure","","Print the error message for lifetime errors when binding excapes a closure.",241,{"inputs":[{"name":"self"}],"output":{"generics":["errorreported"],"name":"option"}}],[0,"util","","Helper functions corresponding to lifetime errors due to anonymous regions.",null,null],[3,"AnonymousArgInfo","rustc::infer::error_reporting::nice_region_error::util","",null,null],[12,"arg","","",244,null],[12,"arg_ty","","",244,null],[12,"bound_region","","",244,null],[12,"is_first","","",244,null],[3,"FreeRegionInfo","","",null,null],[12,"def_id","","",245,null],[12,"boundregion","","",245,null],[12,"is_impl_item","","",245,null],[11,"fmt","","",244,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",245,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"find_arg_with_region","rustc::infer::error_reporting::nice_region_error","",241,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["anonymousarginfo"],"name":"option"}}],[11,"is_suitable_region","","",241,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"generics":["freeregioninfo"],"name":"option"}}],[11,"is_return_type_anon","","",241,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"boundregion"},{"name":"fndecl"}],"output":{"generics":["span"],"name":"option"}}],[11,"is_self_anon","","",241,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_bound_region_in_impl_item","","",241,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"try_report_nice_region_error","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"regionresolutionerror"}],"output":{"name":"bool"}}],[11,"new","rustc::infer::error_reporting::nice_region_error","",241,{"inputs":[{"name":"tyctxt"},{"name":"regionresolutionerror"},{"generics":["typecktables"],"name":"option"}],"output":{"name":"self"}}],[11,"new_from_span","","",241,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"region"},{"name":"region"},{"generics":["typecktables"],"name":"option"}],"output":{"name":"self"}}],[11,"try_report","","",241,{"inputs":[{"name":"self"}],"output":{"generics":["errorreported"],"name":"option"}}],[11,"get_regions","","",241,null],[11,"report_region_errors","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"scopetree"},{"name":"vec"},{"name":"bool"}],"output":null}],[11,"process_errors","","",203,{"inputs":[{"name":"self"},{"name":"vec"}],"output":{"generics":["regionresolutionerror"],"name":"vec"}}],[11,"check_and_note_conflicting_crates","","Adds a note if the types come from similarly named crates",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"typeerror"},{"name":"span"}],"output":null}],[11,"note_error_origin","","",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"obligationcause"}],"output":null}],[11,"highlight_outer","","Given that `other_ty` is the same as a type argument for `name` in `sub`, populate `value` highlighting `name` and every type argument that isn't at `pos` (which is `other_ty`), and populate `other_value` with `other_ty`.",203,{"inputs":[{"name":"self"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"},{"name":"string"},{"name":"substs"},{"name":"usize"},{"name":"ty"}],"output":null}],[11,"cmp_type_arg","","If `other_ty` is the same as a type argument present in `sub`, highlight `path` in `t1_out`, as that is the difference to the other type.",203,{"inputs":[{"name":"self"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"},{"name":"string"},{"name":"substs"},{"name":"string"},{"name":"ty"}],"output":{"name":"option"}}],[11,"push_comma","","Add a `,` to the type representation only if it is appropriate.",203,{"inputs":[{"name":"self"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"},{"name":"usize"},{"name":"usize"}],"output":null}],[11,"cmp","","Compare two given types, eliding parts that are the same between them and highlighting relevant differences, and return two representation of those types for highlighted printing.",203,null],[11,"note_type_err","","",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"obligationcause"},{"name":"option"},{"generics":["valuepairs"],"name":"option"},{"name":"typeerror"}],"output":null}],[11,"report_and_explain_type_error","","",203,{"inputs":[{"name":"self"},{"name":"typetrace"},{"name":"typeerror"}],"output":{"name":"diagnosticbuilder"}}],[11,"values_str","","",203,{"inputs":[{"name":"self"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str_ty","","",203,{"inputs":[{"name":"self"},{"name":"expectedfound"}],"output":{"name":"option"}}],[11,"expected_found_str","","Returns a string of the form \"expected `{}`, found `{}`\".",203,{"inputs":[{"name":"self"},{"name":"expectedfound"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",203,{"inputs":[{"name":"self"},{"name":"scopetree"},{"name":"span"},{"generics":["subregionorigin"],"name":"option"},{"name":"generickind"},{"name":"region"}],"output":null}],[11,"report_sub_sup_conflict","","",203,{"inputs":[{"name":"self"},{"name":"scopetree"},{"name":"regionvariableorigin"},{"name":"subregionorigin"},{"name":"region"},{"name":"subregionorigin"},{"name":"region"}],"output":null}],[11,"report_inference_failure","","",203,{"inputs":[{"name":"self"},{"name":"regionvariableorigin"}],"output":{"name":"diagnosticbuilder"}}],[0,"fudge","","",null,null],[3,"RegionFudger","rustc::infer::fudge","",null,null],[12,"infcx","","",246,null],[12,"type_variables","","",246,null],[12,"region_vars","","",246,null],[12,"origin","","",246,null],[11,"fudge_regions_if_ok","rustc::infer","This rather funky routine is used while processing expected types. What happens here is that we want to propagate a coercion through the return type of a fn to its argument. Consider the type of `Option::Some`, which is basically `for<T> fn(T) -> Option<T>`. So if we have an expression `Some(&[1, 2, 3])`, and that has the expected type `Option<&[u32]>`, we would like to type check `&[1, 2, 3]` with the expectation of `&[u32]`. This will cause us to coerce from `&[u32; 3]` to `&[u32]` and make the users life more pleasant.",203,{"inputs":[{"name":"self"},{"name":"regionvariableorigin"},{"name":"f"}],"output":{"name":"result"}}],[11,"tcx","rustc::infer::fudge","",246,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",246,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",246,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[0,"glb","rustc::infer","",null,null],[3,"Glb","rustc::infer::glb","\"Greatest lower bound\" (common subtype)",null,null],[12,"fields","","",247,null],[12,"a_is_expected","","",247,null],[11,"new","","",247,{"inputs":[{"name":"combinefields"},{"name":"bool"}],"output":{"name":"glb"}}],[11,"tag","","",247,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"tcx","","",247,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"a_is_expected","","",247,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",247,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",247,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"regions","","",247,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[11,"binders","","",247,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[11,"infcx","","",247,{"inputs":[{"name":"self"}],"output":{"name":"inferctxt"}}],[11,"cause","","",247,{"inputs":[{"name":"self"}],"output":{"name":"obligationcause"}}],[11,"relate_bound","","",247,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[0,"higher_ranked","rustc::infer","Helper routines for higher-ranked things. See the `doc` module at the end of the file for details.",null,null],[3,"HrMatchResult","rustc::infer::higher_ranked","",null,null],[12,"value","","",248,null],[5,"var_ids","","",null,{"inputs":[{"name":"combinefields"},{"name":"lazybtreemap"}],"output":{"generics":["regionvid"],"name":"vec"}}],[5,"is_var_in_set","","",null,null],[5,"fold_regions_in","","",null,{"inputs":[{"name":"tyctxt"},{"name":"t"},{"name":"f"}],"output":{"name":"t"}}],[11,"higher_ranked_sub","rustc::infer::combine","",233,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"},{"name":"bool"}],"output":{"generics":["binder"],"name":"relateresult"}}],[11,"higher_ranked_match","","The value consists of a pair `(t, u)` where `t` is the matcher and `u` is a value. The idea is to find a substitution `S` such that `S(t) == b`, and then return `S(u)`. In other words, find values for the late-bound regions in `a` that can make `t == b` and then replace the LBR in `u` with those values.",233,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"t"},{"name":"bool"}],"output":{"generics":["hrmatchresult"],"name":"relateresult"}}],[11,"higher_ranked_lub","","",233,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"},{"name":"bool"}],"output":{"generics":["binder"],"name":"relateresult"}}],[11,"higher_ranked_glb","","",233,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"},{"name":"bool"}],"output":{"generics":["binder"],"name":"relateresult"}}],[11,"tainted_regions","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"combinedsnapshot"},{"name":"region"},{"name":"taintdirections"}],"output":{"generics":["region"],"name":"fxhashset"}}],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any types/regions which existed before `snapshot` was started. This is used in the sub/lub/glb computations. The idea here is that when we are computing lub/glb of two regions, we sometimes create intermediate region variables. Those region variables may touch some of the skolemized or other \"forbidden\" regions we created to replace bound regions, but they don't really represent an \"external\" constraint.",203,{"inputs":[{"name":"self"},{"name":"combinedsnapshot"}],"output":{"generics":["regionvid"],"name":"vec"}}],[11,"skolemize_late_bound_regions","","Replace all regions bound by `binder` with skolemized regions and return a map indicating which bound-region was replaced with what skolemized region. This is the first step of checking subtyping when higher-ranked things are involved.",203,null],[11,"leak_check","","Searches the region constraints created since `snapshot` was started and checks to determine whether any of the skolemized regions created in `skol_map` would \"escape\" -- meaning that they are related to other regions in some way. If so, the higher-ranked subtyping doesn't hold. See `README.md` for more details.",203,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"span"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"}],"output":{"name":"relateresult"}}],[11,"plug_leaks","","This code converts from skolemized regions back to late-bound regions. It works by replacing each region in the taint set of a skolemized region with a bound-region. The bound region will be bound by the outer-most binder in `value`; the caller must ensure that there is such a binder and it is the right place.",203,{"inputs":[{"name":"self"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"pop_skolemized","","Pops the skolemized regions found in `skol_map` from the region inference context. Whenever you create skolemized regions via `skolemize_late_bound_regions`, they must be popped before you commit the enclosing snapshot (if you do not commit, e.g. within a probe or as a result of an error, then this is not necessary, as popping happens as part of the rollback).",203,{"inputs":[{"name":"self"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"}],"output":null}],[0,"lattice","","Lattice Variables",null,null],[5,"super_lattice_tys","rustc::infer::lattice","",null,{"inputs":[{"name":"l"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[8,"LatticeDir","","",null,null],[10,"infcx","","",249,{"inputs":[{"name":"self"}],"output":{"name":"inferctxt"}}],[10,"cause","","",249,{"inputs":[{"name":"self"}],"output":{"name":"obligationcause"}}],[10,"relate_bound","","",249,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[0,"lub","rustc::infer","",null,null],[3,"Lub","rustc::infer::lub","\"Least upper bound\" (common supertype)",null,null],[12,"fields","","",250,null],[12,"a_is_expected","","",250,null],[11,"new","","",250,{"inputs":[{"name":"combinefields"},{"name":"bool"}],"output":{"name":"lub"}}],[11,"tag","","",250,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"tcx","","",250,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"a_is_expected","","",250,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",250,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",250,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"regions","","",250,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[11,"binders","","",250,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[11,"infcx","","",250,{"inputs":[{"name":"self"}],"output":{"name":"inferctxt"}}],[11,"cause","","",250,{"inputs":[{"name":"self"}],"output":{"name":"obligationcause"}}],[11,"relate_bound","","",250,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[0,"region_constraints","rustc::infer","See README.md",null,null],[3,"RegionConstraintCollector","rustc::infer::region_constraints","",null,null],[12,"var_infos","","For each `RegionVid`, the corresponding `RegionVariableOrigin`.",251,null],[12,"data","","",251,null],[12,"lubs","","For a given pair of regions (R1, R2), maps to a region R3 that is designated as their LUB (edges R1 <= R3 and R2 <= R3 exist). This prevents us from making many such regions.",251,null],[12,"glbs","","For a given pair of regions (R1, R2), maps to a region R3 that is designated as their GLB (edges R3 <= R1 and R3 <= R2 exist). This prevents us from making many such regions.",251,null],[12,"bound_count","","Global counter used during the GLB algorithm to create unique names for fresh bound regions",251,null],[12,"undo_log","","The undo log records actions that might later be undone.",251,null],[12,"unification_table","","When we add a R1 == R2 constriant, we currently add (a) edges R1 <= R2 and R2 <= R1 and (b) we unify the two regions in this table. You can then call `opportunistic_resolve_var` early which will map R1 and R2 to some common region (i.e., either R1 or R2). This is important when dropck and other such code is iterating to a fixed point, because otherwise we sometimes would wind up with a fresh stream of region variables that have been equated but appear distinct.",251,null],[3,"RegionConstraintData","","The full set of region constraints gathered up by the collector. Describes constraints between the region variables and other regions, as well as other conditions that must be verified, or assumptions that can be made.",null,null],[12,"constraints","","Constraints of the form `A <= B`, where either `A` or `B` can be a region variable (or neither, as it happens).",252,null],[12,"verifys","","A \"verify\" is something that we need to verify after inference is done, but which does not directly affect inference in any way.",252,null],[12,"givens","","A \"given\" is a relationship that is known to hold. In particular, we often know from closure fn signatures that a particular free region must be a subregion of a region variable:",252,null],[3,"Verify","","VerifyGenericBound(T, _, R, RS): The parameter type `T` (or associated type) must outlive the region `R`. `T` is known to outlive `RS`. Therefore verify that `R <= RS[i]` for some `i`. Inference variables may be involved (but this verification step doesn't influence inference).",null,null],[12,"kind","","",253,null],[12,"origin","","",253,null],[12,"region","","",253,null],[12,"bound","","",253,null],[3,"TwoRegions","","",null,null],[12,"a","","",254,null],[12,"b","","",254,null],[3,"RegionVariableInfo","","",null,null],[12,"origin","","",255,null],[12,"universe","","",255,null],[3,"RegionSnapshot","","",null,null],[12,"length","","",256,null],[12,"region_snapshot","","",256,null],[3,"TaintDirections","","When working with skolemized regions, we often wish to find all of the regions that are either reachable from a skolemized region, or which can reach a skolemized region, or both. We call such regions tained regions.  This struct allows you to decide what set of tainted regions you want.",null,null],[12,"incoming","","",257,null],[12,"outgoing","","",257,null],[4,"Constraint","","A constraint that influences the inference process.",null,null],[13,"VarSubVar","","One region variable is subregion of another",258,null],[13,"RegSubVar","","Concrete region is subregion of region variable",258,null],[13,"VarSubReg","","Region variable is subregion of concrete region. This does not directly affect inference, but instead is checked after inference is complete.",258,null],[13,"RegSubReg","","A constraint where neither side is a variable. This does not directly affect inference, but instead is checked after inference is complete.",258,null],[4,"GenericKind","","",null,null],[13,"Param","","",259,null],[13,"Projection","","",259,null],[4,"VerifyBound","","When we introduce a verification step, we wish to test that a particular region (let's call it `'min`) meets some bound. The bound is described the by the following grammar:",null,null],[13,"AnyRegion","","B = exists {R} --> some 'r in {R} must outlive 'min",260,null],[13,"AllRegions","","B = forall {R} --> all 'r in {R} must outlive 'min",260,null],[13,"AnyBound","","B = exists {B} --> 'min must meet some bound b in {B}",260,null],[13,"AllBounds","","B = forall {B} --> 'min must meet all bounds b in {B}",260,null],[4,"UndoLogEntry","","",null,null],[13,"OpenSnapshot","","Pushed when we start a snapshot.",261,null],[13,"CommitedSnapshot","","Replaces an `OpenSnapshot` when a snapshot is committed, but that snapshot is not the root. If the root snapshot is unrolled, all nested snapshots must be committed.",261,null],[13,"AddVar","","We added `RegionVid`",261,null],[13,"AddConstraint","","We added the given `constraint`",261,null],[13,"AddVerify","","We added the given `verify`",261,null],[13,"AddGiven","","We added the given `given`",261,null],[13,"AddCombination","","We added a GLB/LUB \"combination variable\"",261,null],[13,"Purged","","During skolemization, we sometimes purge entries from the undo log in a kind of minisnapshot (unlike other snapshots, this purging actually takes place on success). In that case, we replace the corresponding entry with `Noop` so as to avoid the need to do a bunch of swapping. (We can't use `swap_remove` as the order of the vector is important.)",261,null],[4,"CombineMapType","","",null,null],[13,"Lub","","",262,null],[13,"Glb","","",262,null],[0,"taint","","",null,null],[3,"TaintSet","rustc::infer::region_constraints::taint","",null,null],[12,"directions","","",263,null],[12,"regions","","",263,null],[11,"fmt","","",263,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",263,{"inputs":[{"name":"taintdirections"},{"name":"region"}],"output":{"name":"self"}}],[11,"fixed_point","","",263,null],[11,"into_set","","",263,{"inputs":[{"name":"self"}],"output":{"generics":["region"],"name":"fxhashset"}}],[11,"len","","",263,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"add_edge","","",263,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":null}],[6,"VarInfos","rustc::infer::region_constraints","",null,null],[6,"CombineMap","","",null,null],[11,"fmt","","",252,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",252,{"inputs":[],"output":{"name":"regionconstraintdata"}}],[11,"clone","","",252,{"inputs":[{"name":"self"}],"output":{"name":"regionconstraintdata"}}],[11,"clone","","",258,{"inputs":[{"name":"self"}],"output":{"name":"constraint"}}],[11,"eq","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",258,null],[11,"hash","","",258,null],[11,"fmt","","",258,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"le","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"gt","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ge","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"cmp","","",258,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"ordering"}}],[11,"fmt","","",253,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",253,{"inputs":[{"name":"self"}],"output":{"name":"verify"}}],[11,"clone","","",259,{"inputs":[{"name":"self"}],"output":{"name":"generickind"}}],[11,"eq","","",259,{"inputs":[{"name":"self"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"self"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",259,null],[11,"fmt","","",260,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",260,{"inputs":[{"name":"self"}],"output":{"name":"verifybound"}}],[11,"clone","","",254,{"inputs":[{"name":"self"}],"output":{"name":"tworegions"}}],[11,"eq","","",254,{"inputs":[{"name":"self"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",254,{"inputs":[{"name":"self"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",254,null],[11,"hash","","",254,null],[11,"clone","","",261,{"inputs":[{"name":"self"}],"output":{"name":"undologentry"}}],[11,"eq","","",261,{"inputs":[{"name":"self"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",261,{"inputs":[{"name":"self"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",262,{"inputs":[{"name":"self"}],"output":{"name":"combinemaptype"}}],[11,"eq","","",262,{"inputs":[{"name":"self"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"fmt","","",255,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",255,{"inputs":[{"name":"self"}],"output":{"name":"regionvariableinfo"}}],[11,"fmt","","",257,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"incoming","","",257,{"inputs":[],"output":{"name":"self"}}],[11,"outgoing","","",257,{"inputs":[],"output":{"name":"self"}}],[11,"both","","",257,{"inputs":[],"output":{"name":"self"}}],[11,"new","","",251,{"inputs":[],"output":{"name":"regionconstraintcollector"}}],[11,"num_region_vars","","",251,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"region_constraint_data","","",251,{"inputs":[{"name":"self"}],"output":{"name":"regionconstraintdata"}}],[11,"into_infos_and_data","","Once all the constraints have been gathered, extract out the final data.",251,null],[11,"take_and_reset_data","","Takes (and clears) the current set of constraints. Note that the set of variables remains intact, but all relationships between them are reset.  This is used during NLL checking to grab the set of constraints that arose from a particular operation.",251,{"inputs":[{"name":"self"}],"output":{"name":"regionconstraintdata"}}],[11,"data","","",251,{"inputs":[{"name":"self"}],"output":{"name":"regionconstraintdata"}}],[11,"in_snapshot","","",251,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"start_snapshot","","",251,{"inputs":[{"name":"self"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",251,{"inputs":[{"name":"self"},{"name":"regionsnapshot"}],"output":null}],[11,"rollback_to","","",251,{"inputs":[{"name":"self"},{"name":"regionsnapshot"}],"output":null}],[11,"rollback_undo_entry","","",251,{"inputs":[{"name":"self"},{"name":"undologentry"}],"output":null}],[11,"new_region_var","","",251,{"inputs":[{"name":"self"},{"name":"universeindex"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"var_universe","","Returns the universe for the given variable.",251,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"universeindex"}}],[11,"var_origin","","Returns the origin for the given variable.",251,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"regionvariableorigin"}}],[11,"pop_skolemized","","Removes all the edges to/from the skolemized regions that are in `skols`. This is used after a higher-ranked operation completes to remove all trace of the skolemized regions created in that time.",251,{"inputs":[{"name":"self"},{"name":"universeindex"},{"name":"fxhashset"},{"name":"regionsnapshot"}],"output":null}],[11,"new_bound","","",251,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_constraint","","",251,{"inputs":[{"name":"self"},{"name":"constraint"},{"name":"subregionorigin"}],"output":null}],[11,"add_verify","","",251,{"inputs":[{"name":"self"},{"name":"verify"}],"output":null}],[11,"add_given","","",251,{"inputs":[{"name":"self"},{"name":"region"},{"name":"regionvid"}],"output":null}],[11,"make_eqregion","","",251,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[11,"make_subregion","","",251,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",251,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"generickind"},{"name":"region"},{"name":"verifybound"}],"output":null}],[11,"lub_regions","","",251,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",251,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"opportunistic_resolve_var","","",251,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_map","","",251,{"inputs":[{"name":"self"},{"name":"combinemaptype"}],"output":{"name":"fxhashmap"}}],[11,"combine_vars","","",251,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"}],"output":{"name":"region"}}],[11,"universe","","",251,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"universeindex"}}],[11,"vars_created_since_snapshot","","",251,{"inputs":[{"name":"self"},{"name":"regionsnapshot"}],"output":{"generics":["regionvid"],"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` since the mark `mark` was made---`r0` itself will be the first entry. The `directions` parameter controls what kind of relations are considered. For example, one can say that only \"incoming\" edges to `r0` are desired, in which case one will get the set of regions `{r|r <= r0}`. This is used when checking whether skolemized regions are being improperly related to other regions.",251,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"regionsnapshot"},{"name":"region"},{"name":"taintdirections"}],"output":{"generics":["region"],"name":"fxhashset"}}],[11,"fmt","","",256,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",259,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",259,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"to_ty","","",259,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"for_each_region","","",260,{"inputs":[{"name":"self"},{"name":"fnmut"}],"output":null}],[11,"must_hold","","",260,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"cannot_hold","","",260,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"or","","",260,{"inputs":[{"name":"self"},{"name":"verifybound"}],"output":{"name":"verifybound"}}],[11,"and","","",260,{"inputs":[{"name":"self"},{"name":"verifybound"}],"output":{"name":"verifybound"}}],[11,"is_empty","","True if this region constraint data contains no constraints.",252,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[0,"lexical_region_resolve","rustc::infer","The code to do lexical region resolution.",null,null],[3,"LexicalRegionResolutions","rustc::infer::lexical_region_resolve","Contains the result of lexical region resolution. Offers methods to lookup up the final value of a region variable.",null,null],[12,"values","","",264,null],[12,"error_region","","",264,null],[3,"RegionAndOrigin","","",null,null],[12,"region","","",265,null],[12,"origin","","",265,null],[3,"LexicalResolver","","",null,null],[12,"region_rels","","",266,null],[12,"var_infos","","",266,null],[12,"data","","",266,null],[4,"VarValue","","",null,null],[13,"Value","","",267,null],[13,"ErrorValue","","",267,null],[4,"RegionResolutionError","","",null,null],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",268,null],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a)",268,null],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",268,null],[5,"resolve","","This function performs lexical region resolution given a complete set of constraints and variable origins. It performs a fixed-point iteration to find region values which satisfy all constraints, assuming such values can be found. It returns the final values of all the variables as well as a set of errors that must be reported.",null,null],[0,"graphviz","","This module provides linkage between libgraphviz traits and `rustc::middle::typeck::infer::region_constraints`, generating a rendering of the graph represented by the list of `Constraint` instances (which make up the edges of the graph), as well as the origin for each constraint (which are attached to the labels on each edge).",null,null],[3,"ConstraintGraph","rustc::infer::lexical_region_resolve::graphviz","",null,null],[12,"graph_name","","",269,null],[12,"region_rels","","",269,null],[12,"map","","",269,null],[12,"node_ids","","",269,null],[4,"Node","","",null,null],[13,"RegionVid","","",270,null],[13,"Region","","",270,null],[4,"Edge","","",null,null],[13,"Constraint","","",271,null],[13,"EnclScope","","",271,null],[5,"print_help_message","","",null,{"inputs":[],"output":null}],[5,"maybe_print_constraints_for","","",null,{"inputs":[{"name":"regionconstraintdata"},{"name":"regionrelations"}],"output":null}],[5,"constraint_to_nodes","","",null,null],[5,"edge_to_nodes","","",null,null],[5,"dump_region_data_to","","",null,{"inputs":[{"name":"regionrelations"},{"name":"btreemap"},{"name":"str"}],"output":{"name":"result"}}],[6,"ConstraintMap","","",null,null],[11,"clone","","",270,{"inputs":[{"name":"self"}],"output":{"name":"node"}}],[11,"hash","","",270,null],[11,"eq","","",270,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"bool"}}],[11,"ne","","",270,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",270,null],[11,"fmt","","",270,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",271,{"inputs":[{"name":"self"}],"output":{"name":"edge"}}],[11,"eq","","",271,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",271,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",271,null],[11,"fmt","","",271,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",269,{"inputs":[{"name":"string"},{"name":"regionrelations"},{"name":"btreemap"}],"output":{"name":"constraintgraph"}}],[11,"graph_id","","",269,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"node_id","","",269,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",269,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",269,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",269,{"inputs":[{"name":"self"}],"output":{"generics":["node"],"name":"nodes"}}],[11,"edges","","",269,{"inputs":[{"name":"self"}],"output":{"generics":["edge"],"name":"edges"}}],[11,"source","","",269,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",269,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"node"}}],[6,"RegionGraph","rustc::infer::lexical_region_resolve","",null,null],[11,"clone","","",267,{"inputs":[{"name":"self"}],"output":{"name":"varvalue"}}],[11,"fmt","","",267,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",268,{"inputs":[{"name":"self"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",268,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"infer_variable_values","","",266,{"inputs":[{"name":"self"},{"name":"vec"}],"output":{"name":"lexicalregionresolutions"}}],[11,"num_vars","","",266,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"construct_var_data","","Initially, the value for all variables is set to `'empty`, the empty region. The `expansion` phase will grow this larger.",266,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"lexicalregionresolutions"}}],[11,"dump_constraints","","",266,{"inputs":[{"name":"self"},{"name":"regionrelations"}],"output":null}],[11,"expand_givens","","",266,{"inputs":[{"name":"self"},{"name":"graph"}],"output":null}],[11,"expansion","","",266,{"inputs":[{"name":"self"},{"name":"lexicalregionresolutions"}],"output":null}],[11,"expand_node","","",266,{"inputs":[{"name":"self"},{"name":"region"},{"name":"regionvid"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"lub_concrete_regions","","",266,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"collect_errors","","After expansion is complete, go and check upper bounds (i.e., cases where the region cannot grow larger than a fixed point) and check that they are satisfied.",266,{"inputs":[{"name":"self"},{"name":"lexicalregionresolutions"},{"name":"vec"}],"output":null}],[11,"collect_var_errors","","Go over the variables that were declared to be error variables and create a `RegionResolutionError` for each of them.",266,{"inputs":[{"name":"self"},{"name":"lexicalregionresolutions"},{"name":"graph"},{"name":"vec"}],"output":null}],[11,"construct_graph","","",266,{"inputs":[{"name":"self"}],"output":{"generics":["constraint"],"name":"graph"}}],[11,"collect_error_for_expanding_node","","",266,null],[11,"collect_concrete_regions","","",266,null],[11,"iterate_until_fixed_point","","",266,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":null}],[11,"bound_is_met","","",266,{"inputs":[{"name":"self"},{"name":"verifybound"},{"name":"lexicalregionresolutions"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","","",265,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"normalize","","",264,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"value","","",264,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"varvalue"}}],[11,"value_mut","","",264,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"varvalue"}}],[11,"resolve_var","","",264,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"region"}}],[0,"outlives","rustc::infer","Various code related to computing outlives relations.",null,null],[0,"env","rustc::infer::outlives","",null,null],[3,"OutlivesEnvironment","rustc::infer::outlives::env","The `OutlivesEnvironment` collects information about what outlives what in a given type-checking setting. For example, if we have a where-clause like `where T: 'a` in scope, then the `OutlivesEnvironment` would record that (in its `region_bound_pairs` field). Similarly, it contains methods for processing and adding implied bounds into the outlives environment.",null,null],[12,"param_env","","",272,null],[12,"free_region_map","","",272,null],[12,"region_bound_pairs","","",272,null],[11,"clone","","",272,{"inputs":[{"name":"self"}],"output":{"name":"outlivesenvironment"}}],[11,"new","","",272,{"inputs":[{"name":"paramenv"}],"output":{"name":"self"}}],[11,"free_region_map","","Borrows current value of the `free_region_map`.",272,{"inputs":[{"name":"self"}],"output":{"name":"freeregionmap"}}],[11,"region_bound_pairs","","Borrows current value of the `region_bound_pairs`.",272,null],[11,"into_free_region_map","","Returns ownership of the `free_region_map`.",272,{"inputs":[{"name":"self"}],"output":{"name":"freeregionmap"}}],[11,"push_snapshot_pre_closure","","This is a hack to support the old-skool regionck, which processes region constraints from the main function and the closure together. In that context, when we enter a closure, we want to be able to \"save\" the state of the surrounding a function. We can then add implied bounds and the like from the closure arguments into the environment -- these should only apply in the closure body, so once we exit, we invoke `pop_snapshot_post_closure` to remove them.",272,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"pop_snapshot_post_closure","","See `push_snapshot_pre_closure`.",272,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"add_implied_bounds","","This method adds \"implied bounds\" into the outlives environment. Implied bounds are outlives relationships that we can deduce on the basis that certain types must be well-formed -- these are either the types that appear in the function signature or else the input types to an impl. For example, if you have a function like",272,null],[11,"add_outlives_bounds","","Processes outlives bounds that are known to hold, whether from implied or other sources.",272,{"inputs":[{"name":"self"},{"generics":["inferctxt"],"name":"option"},{"name":"i"}],"output":null}],[0,"free_region_map","rustc::infer::outlives","",null,null],[3,"FreeRegionMap","rustc::infer::outlives::free_region_map","",null,null],[12,"relation","","",273,null],[5,"is_free","","",null,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[5,"is_free_or_static","","",null,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[8,"FreeRegionRelations","","The NLL region handling code represents free region relations in a slightly different way; this trait allows functions to be abstract over which version is in use.",null,null],[10,"sub_free_regions","","Tests whether `r_a <= r_b`. Both must be free regions or `'static`.",274,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",273,{"inputs":[{"name":"self"}],"output":{"name":"freeregionmap"}}],[11,"encode","","",273,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",273,{"inputs":[{"name":"__d"}],"output":{"generics":["freeregionmap"],"name":"result"}}],[11,"fmt","","",273,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",273,{"inputs":[],"output":{"name":"self"}}],[11,"is_empty","","",273,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"relate_regions","","",273,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":null}],[11,"lub_free_regions","","Compute the least-upper-bound of two free regions. In some cases, this is more conservative than necessary, in order to avoid making arbitrary choices. See `TransitiveRelation::postdom_upper_bound` for more details.",273,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"sub_free_regions","","",273,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"hash_stable","","",273,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"lift_to_tcx","","",273,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["freeregionmap"],"name":"option"}}],[0,"bounds","rustc::infer::outlives","",null,null],[4,"OutlivesBound","rustc::infer::outlives::bounds","Outlives bounds are relationships between generic parameters, whether they both be regions (`'a: 'b`) or whether types are involved (`T: 'a`).  These relationships can be extracted from the full set of predicates we understand or also from types (in which case they are called implied bounds). They are fed to the `OutlivesEnv` which in turn is supplied to the region checker and other parts of the inference system.",null,null],[13,"RegionSubRegion","","",275,null],[13,"RegionSubParam","","",275,null],[13,"RegionSubProjection","","",275,null],[5,"explicit_outlives_bounds","","",null,null],[11,"fmt","","",275,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"implied_outlives_bounds","rustc::infer","Implied bounds are region relationships that we deduce automatically.  The idea is that (e.g.) a caller must check that a function's argument types are well-formed immediately before calling that fn, and hence the callee can assume that its argument types are well-formed. This may imply certain relationships between generic parameters. For example:",203,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"nodeid"},{"name":"ty"},{"name":"span"}],"output":{"generics":["outlivesbound"],"name":"vec"}}],[11,"implied_bounds_from_components","","When we have an implied bound that `T: 'a`, we can further break this down to determine what relationships would have to hold for `T: 'a` to hold. We get to assume that the caller has validated those relationships.",203,{"inputs":[{"name":"region"},{"generics":["component"],"name":"vec"}],"output":{"generics":["outlivesbound"],"name":"vec"}}],[0,"obligations","rustc::infer::outlives","Code that handles \"type-outlives\" constraints like `T: 'a`. This is based on the `outlives_components` function defined on the tcx, but it adds a bit of heuristics on top, in particular to deal with associated types and projections.",null,null],[3,"TypeOutlives","rustc::infer::outlives::obligations","",null,null],[12,"infcx","","",276,null],[12,"region_bound_pairs","","",276,null],[12,"implicit_region_bound","","",276,null],[12,"param_env","","",276,null],[11,"register_region_obligation","rustc::infer","Registers that the given region obligation must be resolved from within the scope of `body_id`. These regions are enqueued and later processed by regionck, when full type information is available (see `region_obligations` field for more information).",203,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"regionobligation"}],"output":null}],[11,"take_registered_region_obligations","","Trait queries just want to pass back type obligations \"as is\"",203,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"process_registered_region_obligations","","Process the region obligations that must be proven (during `regionck`) for the given `body_id`, given information about the region bounds in scope and so forth. This function must be invoked for all relevant body-ids before region inference is done (or else an assert will fire).",203,null],[11,"type_must_outlive","","Processes a single ad-hoc region obligation that was not registered in advance.",203,null],[11,"new","rustc::infer::outlives::obligations","",276,null],[11,"type_must_outlive","","Adds constraints to inference such that `T: 'a` holds (or reports an error if it cannot).",276,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"ty"},{"name":"region"}],"output":null}],[11,"tcx","","",276,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"components_must_outlive","","",276,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"generics":["component"],"name":"vec"},{"name":"region"}],"output":null}],[11,"param_ty_must_outlive","","",276,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"region"},{"name":"paramty"}],"output":null}],[11,"projection_must_outlive","","",276,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"region"},{"name":"projectionty"}],"output":null}],[11,"type_bound","","",276,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"verifybound"}}],[11,"param_bound","","",276,{"inputs":[{"name":"self"},{"name":"paramty"}],"output":{"name":"verifybound"}}],[11,"projection_declared_bounds","","",276,{"inputs":[{"name":"self"},{"name":"projectionty"}],"output":{"generics":["region"],"name":"vec"}}],[11,"projection_bound","","",276,{"inputs":[{"name":"self"},{"generics":["region"],"name":"vec"},{"name":"projectionty"}],"output":{"name":"verifybound"}}],[11,"recursive_type_bound","","",276,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"verifybound"}}],[11,"declared_generic_bounds_from_env","","",276,{"inputs":[{"name":"self"},{"name":"generickind"}],"output":{"generics":["region"],"name":"vec"}}],[11,"declared_projection_bounds_from_trait","","Given a projection like `<T as Foo<'x>>::Bar`, returns any bounds declared in the trait definition. For example, if the trait were",276,{"inputs":[{"name":"self"},{"name":"projectionty"}],"output":{"generics":["region"],"name":"vec"}}],[11,"region_bounds_declared_on_associated_item","","Given the def-id of an associated item, returns any region bounds attached to that associated item from the trait definition.",276,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["region"],"name":"vec"}}],[11,"collect_outlives_from_predicate_list","","Searches through a predicate list for a predicate `T: 'a`.",276,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"i"}],"output":{"generics":["region"],"name":"vec"}}],[0,"resolve","rustc::infer","",null,null],[3,"OpportunisticTypeResolver","rustc::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces type variables that have been unified with the things they have been unified with (similar to `shallow_resolve`, but deep). This is useful for printing messages etc but also required at various points for correctness.",null,null],[12,"infcx","","",277,null],[3,"OpportunisticTypeAndRegionResolver","","The opportunistic type and region resolver is similar to the opportunistic type resolver, but also opportunistically resolves regions. It is useful for canonicalization.",null,null],[12,"infcx","","",278,null],[3,"UnresolvedTypeFinder","","The unresolved type finder walks your type and searches for type variables that don't yet have a value. They get pushed into a vector. It does not construct the fully resolved type (which might involve some hashing and so forth).",null,null],[12,"infcx","","",279,null],[3,"FullTypeResolver","","",null,null],[12,"infcx","","",280,null],[12,"err","","",280,null],[5,"fully_resolve","","Full type resolution replaces all type and region variables with their concrete results. If any variable cannot be replaced (never unified, etc) then an `Err` result is returned.",null,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"fixupresult"}}],[11,"new","","",277,{"inputs":[{"name":"inferctxt"}],"output":{"name":"self"}}],[11,"tcx","","",277,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",277,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"new","","",278,{"inputs":[{"name":"inferctxt"}],"output":{"name":"self"}}],[11,"tcx","","",278,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",278,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",278,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","","",279,{"inputs":[{"name":"inferctxt"}],"output":{"name":"self"}}],[11,"visit_ty","","",279,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"tcx","","",280,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",280,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",280,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[0,"freshen","rustc::infer","Freshening is the process of replacing unknown variables with fresh types. The idea is that the type, after freshening, contains no inference variables but instead contains either a value for each variable or fresh \"arbitrary\" types wherever a variable would have been.",null,null],[3,"TypeFreshener","rustc::infer::freshen","",null,null],[12,"infcx","","",201,null],[12,"freshen_count","","",201,null],[12,"freshen_map","","",201,null],[11,"new","rustc::infer","",201,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"freshen","","",201,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"option"},{"name":"inferty"},{"name":"f"}],"output":{"name":"ty"}}],[11,"tcx","","",201,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_region","","",201,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",201,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[0,"sub","","",null,null],[3,"Sub","rustc::infer::sub","Ensures `a` is made a subtype of `b`. Returns `a` on success.",null,null],[12,"fields","","",281,null],[12,"a_is_expected","","",281,null],[11,"new","","",281,{"inputs":[{"name":"combinefields"},{"name":"bool"}],"output":{"name":"sub"}}],[11,"with_expected_switched","","",281,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"tag","","",281,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"tcx","","",281,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"a_is_expected","","",281,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"with_cause","","",281,{"inputs":[{"name":"self"},{"name":"cause"},{"name":"f"}],"output":{"name":"r"}}],[11,"relate_with_variance","","",281,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",281,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"regions","","",281,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[11,"binders","","",281,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[0,"type_variable","rustc::infer","",null,null],[3,"TypeVariableTable","rustc::infer::type_variable","",null,null],[12,"values","","",282,null],[12,"eq_relations","","Two variables are unified in `eq_relations` when we have a constraint `?X == ?Y`. This table also stores, for each key, the known value.",282,null],[12,"sub_relations","","Two variables are unified in `eq_relations` when we have a constraint `?X <: ?Y` or a constraint `?Y <: ?X`. This second table exists only to help with the occurs check. In particular, we want to report constraints like these as an occurs check violation:",282,null],[3,"TypeVariableData","","",null,null],[12,"origin","","",283,null],[12,"diverging","","",283,null],[3,"Snapshot","","",null,null],[12,"snapshot","","",284,null],[12,"eq_snapshot","","",284,null],[12,"sub_snapshot","","",284,null],[3,"Instantiate","","",null,null],[12,"vid","","",285,null],[3,"Delegate","","",null,null],[3,"TyVidEqKey","","These structs (a newtyped TyVid) are used as the unification key for the `eq_relations`; they carry a `TypeVariableValue` along with them.",null,null],[12,"vid","","",286,null],[12,"phantom","","",286,null],[4,"TypeVariableOrigin","","Reasons to create a type inference variable",null,null],[13,"MiscVariable","","",287,null],[13,"NormalizeProjectionType","","",287,null],[13,"TypeInference","","",287,null],[13,"TypeParameterDefinition","","",287,null],[13,"ClosureSynthetic","","one of the upvars or closure kind parameters in a `ClosureSubsts` (before it has been determined)",287,null],[13,"SubstitutionPlaceholder","","",287,null],[13,"AutoDeref","","",287,null],[13,"AdjustmentType","","",287,null],[13,"DivergingStmt","","",287,null],[13,"DivergingBlockExpr","","",287,null],[13,"DivergingFn","","",287,null],[13,"LatticeVariable","","",287,null],[13,"Generalized","","",287,null],[4,"TypeVariableValue","","",null,null],[13,"Known","","",288,null],[12,"value","rustc::infer::type_variable::TypeVariableValue","",288,null],[13,"Unknown","rustc::infer::type_variable","",288,null],[12,"universe","rustc::infer::type_variable::TypeVariableValue","",288,null],[6,"TypeVariableMap","rustc::infer::type_variable","",null,null],[11,"clone","","",287,{"inputs":[{"name":"self"}],"output":{"name":"typevariableorigin"}}],[11,"fmt","","",287,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",288,{"inputs":[{"name":"self"}],"output":{"name":"typevariablevalue"}}],[11,"fmt","","",288,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"known","","If this value is known, returns the type it is known to be. Otherwise, `None`.",288,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"option"}}],[11,"is_unknown","","",288,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"new","","",282,{"inputs":[],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","Returns the diverges flag given when `vid` was created.",282,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"var_origin","","Returns the origin that was given when `vid` was created.",282,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"typevariableorigin"}}],[11,"equate","","Records that `a == b`, depending on `dir`.",282,{"inputs":[{"name":"self"},{"name":"tyvid"},{"name":"tyvid"}],"output":null}],[11,"sub","","Records that `a <: b`, depending on `dir`.",282,{"inputs":[{"name":"self"},{"name":"tyvid"},{"name":"tyvid"}],"output":null}],[11,"instantiate","","Instantiates `vid` with the type `ty`.",282,{"inputs":[{"name":"self"},{"name":"tyvid"},{"name":"ty"}],"output":null}],[11,"new_var","","Creates a new type variable.",282,{"inputs":[{"name":"self"},{"name":"universeindex"},{"name":"bool"},{"name":"typevariableorigin"}],"output":{"name":"tyvid"}}],[11,"num_vars","","Returns the number of type variables created thus far.",282,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"root_var","","Returns the \"root\" variable of `vid` in the `eq_relations` equivalence table. All type variables that have been equated will yield the same root variable (per the union-find algorithm), so `root_var(a) == root_var(b)` implies that `a == b` (transitively).",282,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"sub_root_var","","Returns the \"root\" variable of `vid` in the `sub_relations` equivalence table. All type variables that have been are related via equality or subtyping will yield the same root variable (per the union-find algorithm), so `sub_root_var(a) == sub_root_var(b)` implies that:",282,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"sub_unified","","True if `a` and `b` have same \"sub-root\" (i.e., exists some type X such that `forall i in {a, b}. (i <: X || X <: i)`.",282,{"inputs":[{"name":"self"},{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"probe","","Retrieves the type to which `vid` has been instantiated, if any.",282,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"typevariablevalue"}}],[11,"replace_if_possible","","If `t` is a type-inference variable, and it has been instantiated, then return the with which it was instantiated. Otherwise, returns `t`.",282,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"snapshot","","Creates a snapshot of the type variable state.  This snapshot must later be committed (`commit()`) or rolled back (`rollback_to()`).  Nested snapshots are permitted, but must be processed in a stack-like fashion.",282,{"inputs":[{"name":"self"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Undoes all changes since the snapshot was created. Any snapshots created since that point must already have been committed or rolled back.",282,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":null}],[11,"commit","","Commits all changes since the snapshot was created, making them permanent (unless this snapshot was created within another snapshot). Any snapshots created since that point must already have been committed or rolled back.",282,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":null}],[11,"types_created_since_snapshot","","Returns a map `{V1 -> V2}`, where the keys `{V1}` are ty-variables created during the snapshot, and the values `{V2}` are the root variables that they were unified with, along with their origin.",282,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":{"name":"typevariablemap"}}],[11,"types_escaping_snapshot","","Find the set of type variables that existed before `s` but which have only been unified since `s` started, and return the types with which they were unified. So if we had a type variable `V0`, then we started the snapshot, then we created a type variable `V1`, unifed `V0` with `T0`, and unified `V1` with `T1`, this function would return `{T0}`.",282,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":{"generics":["ty"],"name":"vec"}}],[11,"unsolved_variables","","Returns indices of all variables that are not yet instantiated.",282,{"inputs":[{"name":"self"}],"output":{"generics":["tyvid"],"name":"vec"}}],[11,"reverse","","",289,{"inputs":[{"name":"vec"},{"name":"instantiate"}],"output":null}],[11,"clone","","",286,{"inputs":[{"name":"self"}],"output":{"name":"tyvideqkey"}}],[11,"fmt","","",286,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",286,{"inputs":[{"name":"self"},{"name":"tyvideqkey"}],"output":{"name":"bool"}}],[11,"ne","","",286,{"inputs":[{"name":"self"},{"name":"tyvideqkey"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",286,null],[11,"from","","",286,{"inputs":[{"name":"tyvid"}],"output":{"name":"self"}}],[11,"index","","",286,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_index","","",286,{"inputs":[{"name":"u32"}],"output":{"name":"self"}}],[11,"tag","","",286,{"inputs":[],"output":{"name":"str"}}],[11,"unify_values","","",288,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["noerror"],"name":"result"}}],[0,"unify_key","rustc::infer","",null,null],[3,"RegionVidKey","rustc::infer::unify_key","",null,null],[12,"min_vid","","The minimum region vid in the unification set. This is needed to have a canonical name for a type to prevent infinite recursion.",290,null],[8,"ToType","","",null,null],[10,"to_type","","",291,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"eq","","",290,{"inputs":[{"name":"self"},{"name":"regionvidkey"}],"output":{"name":"bool"}}],[11,"ne","","",290,{"inputs":[{"name":"self"},{"name":"regionvidkey"}],"output":{"name":"bool"}}],[11,"clone","","",290,{"inputs":[{"name":"self"}],"output":{"name":"regionvidkey"}}],[11,"fmt","","",290,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"unify_values","","",290,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["noerror"],"name":"result"}}],[6,"InferResult","rustc::infer","",null,null],[6,"Bound","","",null,null],[6,"UnitResult","","",null,null],[6,"FixupResult","","",null,null],[6,"SkolemizationMap","","A map returned by `skolemize_late_bound_regions()` indicating the skolemized region that each late-bound region was replaced with.",null,null],[11,"fmt","","",202,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",208,{"inputs":[{"name":"self"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",208,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",204,{"inputs":[{"name":"self"}],"output":{"name":"typetrace"}}],[11,"clone","","",209,{"inputs":[{"name":"self"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",209,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",210,{"inputs":[{"name":"self"}],"output":{"name":"parameterorigin"}}],[11,"fmt","","",210,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",211,{"inputs":[{"name":"self"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",211,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",212,{"inputs":[{"name":"self"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",212,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",213,{"inputs":[{"name":"self"}],"output":{"name":"nllregionvariableorigin"}}],[11,"fmt","","",213,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",213,{"inputs":[{"name":"self"},{"name":"nllregionvariableorigin"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"self"},{"name":"nllregionvariableorigin"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",213,null],[11,"hash","","",213,null],[11,"clone","","",214,{"inputs":[{"name":"self"}],"output":{"name":"fixuperror"}}],[11,"fmt","","",214,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",205,{"inputs":[{"name":"self"}],"output":{"name":"regionobligation"}}],[11,"fmt","","",214,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"with_fresh_in_progress_tables","","Used only by `rustc_typeck` during body type-checking/inference, will initialize `in_progress_tables` with fresh `TypeckTables`.",206,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"self"}}],[11,"enter","","",206,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"unit","","",202,{"inputs":[{"name":"self"}],"output":{"name":"inferok"}}],[11,"into_obligations","","",202,{"inputs":[{"name":"self"}],"output":{"name":"predicateobligations"}}],[11,"is_in_snapshot","","",203,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"freshen","","",203,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",203,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"freshener","","",203,{"inputs":[{"name":"self"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",203,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"unconstrainednumeric"}}],[11,"unsolved_variables","","",203,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"vec"}}],[11,"combine_fields","","",203,{"inputs":[{"name":"self"},{"name":"typetrace"},{"name":"paramenv"}],"output":{"name":"combinefields"}}],[11,"save_and_restore_in_snapshot_flag","","",203,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"start_snapshot","","",203,{"inputs":[{"name":"self"}],"output":{"name":"combinedsnapshot"}}],[11,"rollback_to","","",203,{"inputs":[{"name":"self"},{"name":"str"},{"name":"combinedsnapshot"}],"output":null}],[11,"commit_from","","",203,{"inputs":[{"name":"self"},{"name":"combinedsnapshot"}],"output":null}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",203,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",203,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"in_snapshot","","",203,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"t"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",203,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",203,{"inputs":[{"name":"self"},{"name":"region"},{"name":"regionvid"}],"output":null}],[11,"can_sub","","",203,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"t"},{"name":"t"}],"output":{"name":"unitresult"}}],[11,"can_eq","","",203,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"t"},{"name":"t"}],"output":{"name":"unitresult"}}],[11,"sub_regions","","",203,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[11,"subtype_predicate","","",203,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"paramenv"},{"name":"polysubtypepredicate"}],"output":{"generics":["inferresult"],"name":"option"}}],[11,"region_outlives_predicate","","",203,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"polyregionoutlivespredicate"}],"output":{"name":"unitresult"}}],[11,"next_ty_var_id","","",203,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"typevariableorigin"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",203,{"inputs":[{"name":"self"},{"name":"typevariableorigin"}],"output":{"name":"ty"}}],[11,"next_diverging_ty_var","","",203,{"inputs":[{"name":"self"},{"name":"typevariableorigin"}],"output":{"name":"ty"}}],[11,"next_int_var_id","","",203,{"inputs":[{"name":"self"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",203,{"inputs":[{"name":"self"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","Create a fresh region variable with the next available index.",203,{"inputs":[{"name":"self"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"num_region_vars","","Number of region variables created so far.",203,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"next_nll_region_var","","Just a convenient wrapper of `next_region_var` for using during NLL.",203,{"inputs":[{"name":"self"},{"name":"nllregionvariableorigin"}],"output":{"name":"region"}}],[11,"region_var_for_def","","Create a region inference variable for the given region parameter definition.",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"type_var_for_def","","Create a type inference variable for the given type parameter definition. The substitutions are for actual parameters that may be referred to by the default of this type parameter, if it exists. E.g. `struct Foo<A, B, C = (A, B)>(...);` when used in a path such as `Foo::<T, U>::new()` will use an inference variable for `C` with `[T, U]` as the substitutions for the default, `(T, U)`.",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"typeparameterdef"}],"output":{"name":"ty"}}],[11,"fresh_substs_for_item","","Given a set of generics defined on a type or impl, returns a substitution mapping each type/region parameter to a fresh inference variable.",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"}],"output":{"name":"substs"}}],[11,"is_tainted_by_errors","","True if errors have been reported since this infcx was created.  This is sometimes used as a heuristic to skip reporting errors that often occur as a result of earlier errors, but where it's hard to be 100% sure (e.g., unresolved inference variables, regionck errors).",203,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"set_tainted_by_errors","","Set the \"tainted by errors\" flag to true. We call this when we observe an error from a prior pass.",203,{"inputs":[{"name":"self"}],"output":null}],[11,"resolve_regions_and_report_errors","","Process the region constraints and report any errors that result. After this, no more unification operations should be done -- or the compiler will panic -- but it is legal to use `resolve_type_vars_if_possible` as well as `fully_resolve`.",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"scopetree"},{"name":"outlivesenvironment"}],"output":null}],[11,"resolve_regions_and_report_errors_unless_nll","","Like `resolve_regions_and_report_errors`, but skips error reporting if NLL is enabled.  This is used for fn bodies where the same error may later be reported by the NLL-based inference.",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"scopetree"},{"name":"outlivesenvironment"}],"output":null}],[11,"resolve_regions_and_report_errors_inner","","",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"scopetree"},{"name":"outlivesenvironment"},{"name":"bool"}],"output":null}],[11,"take_and_reset_region_constraints","","Obtains (and clears) the current set of region constraints. The inference context is still usable: further unifications will simply add new constraints.",203,{"inputs":[{"name":"self"}],"output":{"name":"regionconstraintdata"}}],[11,"with_region_constraints","","Gives temporary access to the region constraint data.",203,null],[11,"take_region_var_origins","","Takes ownership of the list of variable regions. This implies that all the region constriants have already been taken, and hence that `resolve_regions_and_report_errors` can never be called. This is used only during NLL processing to \"hand off\" ownership of the set of region vairables into the NLL region context.",203,{"inputs":[{"name":"self"}],"output":{"name":"varinfos"}}],[11,"ty_to_string","","",203,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"string"}}],[11,"tys_to_string","","",203,null],[11,"trait_ref_to_string","","",203,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",203,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in `value` with their final value. Note that region variables are unaffected. If a type variable has not been unified, it is left as is.  This is an idempotent operation that does not affect inference state in any way and so you can do it at will.",203,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"any_unresolved_type_vars","","Returns true if `T` contains unresolved type variables. In the process of visiting `T`, this will resolve (where possible) type variables in `T`, but it never constructs the final, resolved type, so it's more efficient than `resolve_type_vars_if_possible()`.",203,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"resolve_type_and_region_vars_if_possible","","",203,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in `value`. Region inference must have been run already (e.g., by calling `resolve_regions_and_report_errors`).  If some variable was never unified, an `Err` results.",203,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"fixupresult"}}],[11,"type_error_struct_with_diag","","",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"m"},{"name":"ty"}],"output":{"name":"diagnosticbuilder"}}],[11,"report_mismatched_types","","",203,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"ty"},{"name":"ty"},{"name":"typeerror"}],"output":{"name":"diagnosticbuilder"}}],[11,"replace_late_bound_regions_with_fresh_var","","",203,null],[11,"match_poly_projection_predicate","","Given a higher-ranked projection predicate like:",203,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"paramenv"},{"name":"polyprojectionpredicate"},{"name":"traitref"}],"output":{"generics":["hrmatchresult"],"name":"inferresult"}}],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_constraints`",203,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"generickind"},{"name":"region"},{"name":"verifybound"}],"output":null}],[11,"type_moves_by_default","","",203,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"ty"},{"name":"span"}],"output":{"name":"bool"}}],[11,"closure_kind","","Obtains the latest type of the given closure; this may be a closure in the current function, in which case its `ClosureKind` may not yet be known.",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"generics":["closurekind"],"name":"option"}}],[11,"closure_sig","","Obtain the signature of a closure.  For closures, unlike `tcx.fn_sig(def_id)`, this method will work during the type-checking of the enclosing function and return the closure signature in its partially inferred state.",203,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"polyfnsig"}}],[11,"partially_normalize_associated_types_in","","Normalizes associated types in `value`, potentially returning new obligations that must further be processed.",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"name":"paramenv"},{"name":"t"}],"output":{"name":"inferok"}}],[11,"borrow_region_constraints","","",203,{"inputs":[{"name":"self"}],"output":{"generics":["regionconstraintcollector"],"name":"refmut"}}],[11,"clear_caches","","Clears the selection, evaluation, and projection cachesThis is useful when repeatedly attemping to select an Obligation while changing only its ParamEnv, since FulfillmentContext doesn't use 'probe'",203,{"inputs":[{"name":"self"}],"output":null}],[11,"universe","","",203,{"inputs":[{"name":"self"}],"output":{"name":"universeindex"}}],[11,"span","","",204,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"types","","",204,{"inputs":[{"name":"obligationcause"},{"name":"bool"},{"name":"ty"},{"name":"ty"}],"output":{"name":"typetrace"}}],[11,"dummy","","",204,{"inputs":[{"name":"tyctxt"}],"output":{"name":"typetrace"}}],[11,"fmt","","",204,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",209,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"from_obligation_cause","","",209,{"inputs":[{"name":"obligationcause"},{"name":"f"}],"output":{"name":"self"}}],[11,"span","","",212,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"super_fold_with","","",208,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",208,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"fmt","","",205,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"lint","rustc","Lints, aka compiler warnings.",null,null],[3,"LateContext","rustc::lint","Context for lint checking after type checking.",null,null],[12,"tcx","","Type context we're checking in.",292,null],[12,"tables","","Side-tables for the body we are in.",292,null],[12,"param_env","","Parameter environment for the item we are in.",292,null],[12,"access_levels","","Items accessible from the crate being checked.",292,null],[12,"lint_sess","","The store of registered lints and the lint levels.",292,null],[12,"last_ast_node_with_lint_attrs","","",292,null],[12,"generics","","Generic type parameters in scope for the item we are in.",292,null],[3,"EarlyContext","","Context for lint checking of the AST, after expansion, before lowering to HIR.",null,null],[12,"sess","","Type context we're checking in.",293,null],[12,"krate","","The crate being checked.",293,null],[12,"builder","","",293,null],[12,"lint_sess","","The store of registered lints and the lint levels.",293,null],[12,"buffered","","",293,null],[3,"LintStore","","Information about the registered lints.",null,null],[12,"lints","","Registered lints. The bool is true if the lint was added by a plugin.",294,null],[12,"early_passes","","Trait objects for each lint pass. This is only `None` while performing a lint pass. See the definition of `LintSession::new`.",294,null],[12,"late_passes","","",294,null],[12,"by_name","","Lints indexed by name.",294,null],[12,"lint_groups","","Map of registered lint groups to what lints they expand to. The bool is true if the lint group was added by a plugin.",294,null],[12,"future_incompatible","","Extra info for future incompatibility lints, describing the issue or RFC that caused the incompatibility.",294,null],[3,"FutureIncompatibleInfo","","Extra information for a future incompatibility lint. See the call to `register_future_incompatible` in `librustc_lint/lib.rs` for guidelines.",null,null],[12,"id","","",295,null],[12,"reference","","e.g., a URL for an issue/PR/RFC or error code",295,null],[12,"edition","","If this is an edition fixing lint, the edition in which this lint becomes obsolete",295,null],[3,"BufferedEarlyLint","","Lints that are buffered up early on in the `Session` before the `LintLevels` is calculated",null,null],[12,"lint_id","","",296,null],[12,"ast_id","","",296,null],[12,"span","","",296,null],[12,"msg","","",296,null],[12,"diagnostic","","",296,null],[3,"Lint","","Specification of a single lint.",null,null],[12,"name","","A string identifier for the lint.",297,null],[12,"default_level","","Default level for the lint.",297,null],[12,"desc","","Description of the lint or the issue it detects.",297,null],[12,"edition_deny","","Deny lint after this edition",297,null],[3,"LintId","","Identifies a lint known to the compiler.",null,null],[12,"lint","","",298,null],[3,"LintLevelSets","","",null,null],[12,"list","","",299,null],[12,"lint_cap","","",299,null],[3,"LintLevelMap","","",null,null],[12,"sets","","",300,null],[12,"id_to_set","","",300,null],[3,"LintBuffer","","",null,null],[12,"map","","",301,null],[3,"LintLevelMapBuilder","","",null,null],[12,"levels","","",302,null],[12,"tcx","","",302,null],[4,"Level","","Setting for how to handle a lint.",null,null],[13,"Allow","","",303,null],[13,"Warn","","",303,null],[13,"Deny","","",303,null],[13,"Forbid","","",303,null],[4,"LintSource","","How a lint level was set.",null,null],[13,"Default","","Lint is at the default level as declared in rustc or a plugin.",304,null],[13,"Node","","Lint level was set by an attribute.",304,null],[13,"CommandLine","","Lint level was set by a command-line flag.",304,null],[5,"check_crate","","Perform lint checking on a crate.",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"check_ast_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":null}],[5,"struct_lint_level","","",null,{"inputs":[{"name":"session"},{"name":"lint"},{"name":"level"},{"name":"lintsource"},{"generics":["multispan"],"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[5,"lint_levels","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["lintlevelmap"],"name":"lrc"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"builtin","","Some lints that are built in to the compiler.",null,null],[3,"HardwiredLints","rustc::lint::builtin","Does nothing as a lint pass, but registers some `Lint`s which are used by other parts of the compiler.",null,null],[4,"BuiltinLintDiagnostics","","",null,null],[13,"Normal","","",305,null],[13,"BareTraitObject","","",305,null],[13,"AbsPathWithModule","","",305,null],[7,"EXCEEDING_BITSHIFTS","","",null,null],[7,"CONST_ERR","","",null,null],[7,"UNUSED_IMPORTS","","",null,null],[7,"UNUSED_EXTERN_CRATES","","",null,null],[7,"UNUSED_QUALIFICATIONS","","",null,null],[7,"UNKNOWN_LINTS","","",null,null],[7,"UNUSED_VARIABLES","","",null,null],[7,"UNUSED_ASSIGNMENTS","","",null,null],[7,"DEAD_CODE","","",null,null],[7,"UNREACHABLE_CODE","","",null,null],[7,"UNREACHABLE_PATTERNS","","",null,null],[7,"UNUSED_MACROS","","",null,null],[7,"WARNINGS","","",null,null],[7,"UNUSED_FEATURES","","",null,null],[7,"STABLE_FEATURES","","",null,null],[7,"UNKNOWN_CRATE_TYPES","","",null,null],[7,"TRIVIAL_CASTS","","",null,null],[7,"TRIVIAL_NUMERIC_CASTS","","",null,null],[7,"PRIVATE_IN_PUBLIC","","",null,null],[7,"PUB_USE_OF_PRIVATE_EXTERN_CRATE","","",null,null],[7,"INVALID_TYPE_PARAM_DEFAULT","","",null,null],[7,"RENAMED_AND_REMOVED_LINTS","","",null,null],[7,"SAFE_EXTERN_STATICS","","",null,null],[7,"SAFE_PACKED_BORROWS","","",null,null],[7,"PATTERNS_IN_FNS_WITHOUT_BODY","","",null,null],[7,"LEGACY_DIRECTORY_OWNERSHIP","","",null,null],[7,"LEGACY_IMPORTS","","",null,null],[7,"LEGACY_CONSTRUCTOR_VISIBILITY","","",null,null],[7,"MISSING_FRAGMENT_SPECIFIER","","",null,null],[7,"PARENTHESIZED_PARAMS_IN_TYPES_AND_MODULES","","",null,null],[7,"LATE_BOUND_LIFETIME_ARGUMENTS","","",null,null],[7,"INCOHERENT_FUNDAMENTAL_IMPLS","","",null,null],[7,"DEPRECATED","","",null,null],[7,"UNUSED_UNSAFE","","",null,null],[7,"UNUSED_MUT","","",null,null],[7,"SINGLE_USE_LIFETIMES","","",null,null],[7,"TYVAR_BEHIND_RAW_POINTER","","",null,null],[7,"ELIDED_LIFETIMES_IN_PATHS","","",null,null],[7,"BARE_TRAIT_OBJECTS","","",null,null],[7,"ABSOLUTE_PATHS_NOT_STARTING_WITH_CRATE","","",null,null],[7,"ILLEGAL_FLOATING_POINT_LITERAL_PATTERN","","",null,null],[7,"UNSTABLE_NAME_COLLISIONS","","",null,null],[11,"clone","","",306,{"inputs":[{"name":"self"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",306,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"eq","","",305,{"inputs":[{"name":"self"},{"name":"builtinlintdiagnostics"}],"output":{"name":"bool"}}],[11,"ne","","",305,{"inputs":[{"name":"self"},{"name":"builtinlintdiagnostics"}],"output":{"name":"bool"}}],[11,"encode","","",305,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",305,{"inputs":[{"name":"__d"}],"output":{"generics":["builtinlintdiagnostics"],"name":"result"}}],[11,"fmt","","",305,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"run","","",305,{"inputs":[{"name":"self"},{"name":"session"},{"name":"diagnosticbuilder"}],"output":null}],[0,"context","rustc::lint","Implementation of lint checking.",null,null],[3,"LintStore","rustc::lint::context","Information about the registered lints.",null,null],[12,"lints","","Registered lints. The bool is true if the lint was added by a plugin.",294,null],[12,"early_passes","","Trait objects for each lint pass. This is only `None` while performing a lint pass. See the definition of `LintSession::new`.",294,null],[12,"late_passes","","",294,null],[12,"by_name","","Lints indexed by name.",294,null],[12,"lint_groups","","Map of registered lint groups to what lints they expand to. The bool is true if the lint group was added by a plugin.",294,null],[12,"future_incompatible","","Extra info for future incompatibility lints, describing the issue or RFC that caused the incompatibility.",294,null],[3,"LintSession","","",null,null],[12,"lints","","Reference to the store of registered lints.",307,null],[12,"passes","","Trait objects for each lint pass.",307,null],[3,"BufferedEarlyLint","","Lints that are buffered up early on in the `Session` before the `LintLevels` is calculated",null,null],[12,"lint_id","","",296,null],[12,"ast_id","","",296,null],[12,"span","","",296,null],[12,"msg","","",296,null],[12,"diagnostic","","",296,null],[3,"FutureIncompatibleInfo","","Extra information for a future incompatibility lint. See the call to `register_future_incompatible` in `librustc_lint/lib.rs` for guidelines.",null,null],[12,"id","","",295,null],[12,"reference","","e.g., a URL for an issue/PR/RFC or error code",295,null],[12,"edition","","If this is an edition fixing lint, the edition in which this lint becomes obsolete",295,null],[3,"LateContext","","Context for lint checking after type checking.",null,null],[12,"tcx","","Type context we're checking in.",292,null],[12,"tables","","Side-tables for the body we are in.",292,null],[12,"param_env","","Parameter environment for the item we are in.",292,null],[12,"access_levels","","Items accessible from the crate being checked.",292,null],[12,"lint_sess","","The store of registered lints and the lint levels.",292,null],[12,"last_ast_node_with_lint_attrs","","",292,null],[12,"generics","","Generic type parameters in scope for the item we are in.",292,null],[3,"EarlyContext","","Context for lint checking of the AST, after expansion, before lowering to HIR.",null,null],[12,"sess","","Type context we're checking in.",293,null],[12,"krate","","The crate being checked.",293,null],[12,"builder","","",293,null],[12,"lint_sess","","The store of registered lints and the lint levels.",293,null],[12,"buffered","","",293,null],[4,"TargetLint","","The target of the `by_name` map, which accounts for renaming/deprecation.",null,null],[13,"Id","","A direct lint target",308,null],[13,"Renamed","","Temporary renaming, used for easing migration pain; see #16545",308,null],[13,"Removed","","Lint with this name existed previously, but has been removed/deprecated. The string argument is the reason for removal.",308,null],[4,"FindLintError","","",null,null],[13,"NotFound","","",309,null],[13,"Removed","","",309,null],[4,"CheckLintNameResult","","",null,null],[13,"Ok","","",310,null],[13,"NoLint","","Lint doesn't exist",310,null],[13,"Warning","","The lint is either renamed or removed. This is the warning message.",310,null],[5,"check_crate","","Perform lint checking on a crate.",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"check_ast_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":null}],[8,"LintPassObject","","",null,null],[10,"take_passes","","",311,{"inputs":[{"name":"lintstore"}],"output":{"generics":["vec"],"name":"option"}}],[10,"restore_passes","","",311,{"inputs":[{"name":"lintstore"},{"generics":["vec"],"name":"option"}],"output":null}],[8,"LintContext","","",null,null],[16,"PassObject","","",312,null],[10,"sess","","",312,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[10,"lints","","",312,{"inputs":[{"name":"self"}],"output":{"name":"lintstore"}}],[10,"lint_sess","","",312,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[10,"lint_sess_mut","","",312,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[10,"enter_attrs","","",312,null],[10,"exit_attrs","","",312,null],[11,"lookup_and_emit","","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"}],"output":null}],[11,"lookup_and_emit_with_diagnostics","","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"},{"name":"builtinlintdiagnostics"}],"output":null}],[10,"lookup","","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"s"},{"name":"str"}],"output":null}],[11,"struct_span_lint","","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_lint_note","","Emit a lint and note at the appropriate level, for a particular span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"span"},{"name":"str"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_lint_help","","Emit a lint and help at the appropriate level, for a particular span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"str"}],"output":null}],[10,"with_lint_attrs","","Merge the lints specified by any lint attributes into the current lint context, call the provided function, then reset the lints in effect to their previous state.",312,null],[11,"eq","rustc::lint","",296,{"inputs":[{"name":"self"},{"name":"bufferedearlylint"}],"output":{"name":"bool"}}],[11,"ne","","",296,{"inputs":[{"name":"self"},{"name":"bufferedearlylint"}],"output":{"name":"bool"}}],[11,"encode","","",296,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",296,{"inputs":[{"name":"__d"}],"output":{"generics":["bufferedearlylint"],"name":"result"}}],[11,"fmt","","",296,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",294,{"inputs":[],"output":{"name":"lintstore"}}],[11,"get_lints","","",294,null],[11,"get_lint_groups","","",294,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"register_early_pass","","",294,{"inputs":[{"name":"self"},{"generics":["session"],"name":"option"},{"name":"bool"},{"name":"earlylintpassobject"}],"output":null}],[11,"register_late_pass","","",294,{"inputs":[{"name":"self"},{"generics":["session"],"name":"option"},{"name":"bool"},{"name":"latelintpassobject"}],"output":null}],[11,"push_pass","","",294,{"inputs":[{"name":"self"},{"generics":["session"],"name":"option"},{"name":"bool"},{"name":"box"}],"output":null}],[11,"register_future_incompatible","","",294,{"inputs":[{"name":"self"},{"generics":["session"],"name":"option"},{"generics":["futureincompatibleinfo"],"name":"vec"}],"output":null}],[11,"future_incompatible","","",294,{"inputs":[{"name":"self"},{"name":"lintid"}],"output":{"generics":["futureincompatibleinfo"],"name":"option"}}],[11,"register_group","","",294,{"inputs":[{"name":"self"},{"generics":["session"],"name":"option"},{"name":"bool"},{"name":"str"},{"generics":["lintid"],"name":"vec"}],"output":null}],[11,"register_renamed","","",294,{"inputs":[{"name":"self"},{"name":"str"},{"name":"str"}],"output":null}],[11,"register_removed","","",294,{"inputs":[{"name":"self"},{"name":"str"},{"name":"str"}],"output":null}],[11,"find_lints","","",294,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["vec","findlinterror"],"name":"result"}}],[11,"check_lint_name_cmdline","","Checks the validity of lint names derived from the command line",294,{"inputs":[{"name":"self"},{"name":"session"},{"name":"str"},{"name":"level"}],"output":null}],[11,"check_lint_name","","Checks the name of a lint for its existence, and whether it was renamed or removed. Generates a DiagnosticBuilder containing a warning for renamed and removed lints. This is over both lint names from attributes and those passed on the command line. Since it emits non-fatal warnings and there are two lint passes that inspect attributes, this is only run from the late pass to avoid printing duplicate warnings.",294,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"checklintnameresult"}}],[11,"new","rustc::lint::context","Creates a new `LintSession`, by moving out the `LintStore`'s initial lint levels and pass objects. These can be restored using the `restore` method.",307,{"inputs":[{"name":"rwlock"}],"output":{"name":"lintsession"}}],[11,"restore","","Restores the levels back to the original lint store.",307,{"inputs":[{"name":"self"},{"name":"rwlock"}],"output":null}],[11,"new","rustc::lint","",293,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"earlycontext"}}],[11,"check_id","","",293,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"sess","","Get the overall compiler `Session` object.",292,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"lints","","",292,{"inputs":[{"name":"self"}],"output":{"name":"lintstore"}}],[11,"lint_sess","","",292,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[11,"lint_sess_mut","","",292,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[11,"enter_attrs","","",292,null],[11,"exit_attrs","","",292,null],[11,"lookup","","",292,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"with_lint_attrs","","",292,null],[11,"sess","","Get the overall compiler `Session` object.",293,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"lints","","",293,{"inputs":[{"name":"self"}],"output":{"name":"lintstore"}}],[11,"lint_sess","","",293,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[11,"lint_sess_mut","","",293,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[11,"enter_attrs","","",293,null],[11,"exit_attrs","","",293,null],[11,"lookup","","",293,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"with_lint_attrs","","",293,null],[11,"with_param_env","","",292,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"nested_visit_map","","Because lints are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",292,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",292,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_body","","",292,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"visit_item","","",292,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",292,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_pat","","",292,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",292,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_stmt","","",292,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_fn","","",292,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_variant_data","","",292,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"name"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_struct_field","","",292,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",292,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_ty","","",292,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_name","","",292,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":null}],[11,"visit_mod","","",292,{"inputs":[{"name":"self"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_local","","",292,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",292,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_arm","","",292,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_decl","","",292,{"inputs":[{"name":"self"},{"name":"decl"}],"output":null}],[11,"visit_generic_param","","",292,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"visit_generics","","",292,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_where_predicate","","",292,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":null}],[11,"visit_poly_trait_ref","","",292,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_trait_item","","",292,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",292,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_lifetime","","",292,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_path","","",292,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_attribute","","",292,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_item","","",293,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",293,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_pat","","",293,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",293,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_stmt","","",293,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_fn","","",293,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_variant_data","","",293,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_struct_field","","",293,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",293,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_ty","","",293,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_ident","","",293,{"inputs":[{"name":"self"},{"name":"ident"}],"output":null}],[11,"visit_mod","","",293,null],[11,"visit_local","","",293,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",293,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_arm","","",293,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_expr_post","","",293,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_generic_param","","",293,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"visit_generics","","",293,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_where_predicate","","",293,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":null}],[11,"visit_poly_trait_ref","","",293,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_trait_item","","",293,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",293,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_lifetime","","",293,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_path","","",293,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_attribute","","",293,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_mac_def","","",293,{"inputs":[{"name":"self"},{"name":"macrodef"},{"name":"nodeid"}],"output":null}],[11,"encode","","",298,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",298,{"inputs":[{"name":"d"}],"output":{"generics":["lintid"],"name":"result"}}],[0,"levels","","",null,null],[3,"LintLevelSets","rustc::lint::levels","",null,null],[12,"list","","",299,null],[12,"lint_cap","","",299,null],[3,"LintLevelsBuilder","","",null,null],[12,"sess","","",313,null],[12,"sets","","",313,null],[12,"id_to_set","","",313,null],[12,"cur","","",313,null],[12,"warn_about_weird_lints","","",313,null],[3,"BuilderPush","","",null,null],[12,"prev","","",314,null],[3,"LintLevelMap","","",null,null],[12,"sets","","",300,null],[12,"id_to_set","","",300,null],[4,"LintSet","","",null,null],[13,"CommandLine","","",315,null],[12,"specs","rustc::lint::levels::LintSet","",315,null],[13,"Node","rustc::lint::levels","",315,null],[12,"specs","rustc::lint::levels::LintSet","",315,null],[12,"parent","","",315,null],[11,"new","rustc::lint","",299,{"inputs":[{"name":"session"}],"output":{"name":"lintlevelsets"}}],[11,"builder","","",299,{"inputs":[{"name":"session"}],"output":{"name":"lintlevelsbuilder"}}],[11,"process_command_line","","",299,{"inputs":[{"name":"self"},{"name":"session"}],"output":null}],[11,"get_lint_level","","",299,null],[11,"get_lint_id_level","","",299,null],[11,"new","rustc::lint::levels","",313,{"inputs":[{"name":"session"},{"name":"lintlevelsets"}],"output":{"name":"lintlevelsbuilder"}}],[11,"push","","Pushes a list of AST lint attributes onto this context.",313,null],[11,"pop","","Called after `push` when the scope of a set of attributes are exited.",313,{"inputs":[{"name":"self"},{"name":"builderpush"}],"output":null}],[11,"struct_lint","","Used to emit a lint-related diagnostic based on the current state of this lint context.",313,{"inputs":[{"name":"self"},{"name":"lint"},{"generics":["multispan"],"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"register_id","","Registers the ID provided with the current set of lints stored in this context.",313,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":null}],[11,"build","","",313,{"inputs":[{"name":"self"}],"output":{"name":"lintlevelsets"}}],[11,"build_map","","",313,{"inputs":[{"name":"self"}],"output":{"name":"lintlevelmap"}}],[11,"level_and_source","rustc::lint","If the `id` was previously registered with `register_id` when building this `LintLevelMap` this returns the corresponding lint level and source of the lint level for the lint provided.",300,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"hirid"},{"name":"session"}],"output":{"name":"option"}}],[11,"lint_level_set","","Returns if this `id` has lint level information.",300,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["u32"],"name":"option"}}],[11,"hash_stable","","",300,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",298,{"inputs":[{"name":"self"},{"name":"hcx"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",298,{"inputs":[{"name":"self"},{"name":"hcx"}],"output":{"name":"str"}}],[6,"LintArray","","",null,null],[6,"EarlyLintPassObject","","A lint pass boxed up as a trait object.",null,null],[6,"LateLintPassObject","","",null,null],[6,"LevelSource","","",null,null],[8,"LintContext","","",null,null],[16,"PassObject","","",312,null],[10,"sess","","",312,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[10,"lints","","",312,{"inputs":[{"name":"self"}],"output":{"name":"lintstore"}}],[10,"lint_sess","","",312,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[10,"lint_sess_mut","","",312,{"inputs":[{"name":"self"}],"output":{"name":"lintsession"}}],[10,"enter_attrs","","",312,null],[10,"exit_attrs","","",312,null],[11,"lookup_and_emit","rustc::lint::context","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"}],"output":null}],[11,"lookup_and_emit_with_diagnostics","","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"},{"name":"builtinlintdiagnostics"}],"output":null}],[10,"lookup","rustc::lint","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_lint","rustc::lint::context","Emit a lint at the appropriate level, for a particular span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"s"},{"name":"str"}],"output":null}],[11,"struct_span_lint","","",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_lint_note","","Emit a lint and note at the appropriate level, for a particular span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"span"},{"name":"str"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_lint_help","","Emit a lint and help at the appropriate level, for a particular span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",312,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"str"}],"output":null}],[10,"with_lint_attrs","rustc::lint","Merge the lints specified by any lint attributes into the current lint context, call the provided function, then reset the lints in effect to their previous state.",312,null],[8,"LintPass","","",null,null],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",316,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[8,"LateLintPass","","Trait for types providing lint checks.",null,null],[11,"check_body","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"body"}],"output":null}],[11,"check_body_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"body"}],"output":null}],[11,"check_name","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"span"},{"name":"name"}],"output":null}],[11,"check_crate","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"crate"}],"output":null}],[11,"check_crate_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"crate"}],"output":null}],[11,"check_mod","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_mod_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_foreign_item","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"foreignitem"}],"output":null}],[11,"check_foreign_item_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"foreignitem"}],"output":null}],[11,"check_item","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_item_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_local","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"local"}],"output":null}],[11,"check_block","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"block"}],"output":null}],[11,"check_block_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"block"}],"output":null}],[11,"check_stmt","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"stmt"}],"output":null}],[11,"check_arm","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"arm"}],"output":null}],[11,"check_pat","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"pat"}],"output":null}],[11,"check_decl","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"decl"}],"output":null}],[11,"check_expr","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"check_expr_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"check_ty","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"ty"}],"output":null}],[11,"check_generic_param","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"genericparam"}],"output":null}],[11,"check_generics","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"generics"}],"output":null}],[11,"check_where_predicate","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"wherepredicate"}],"output":null}],[11,"check_poly_trait_ref","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"check_fn","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"body"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_fn_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"body"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_trait_item","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"traititem"}],"output":null}],[11,"check_trait_item_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"traititem"}],"output":null}],[11,"check_impl_item","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"implitem"}],"output":null}],[11,"check_impl_item_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"implitem"}],"output":null}],[11,"check_struct_def","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variantdata"},{"name":"name"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"check_struct_def_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variantdata"},{"name":"name"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"check_struct_field","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"structfield"}],"output":null}],[11,"check_variant","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_variant_post","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_lifetime","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"lifetime"}],"output":null}],[11,"check_path","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"check_attribute","","",317,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"attribute"}],"output":null}],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such as `#[allow(...)]`. Called with all the attributes of that node.",317,null],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",317,null],[8,"EarlyLintPass","","",null,null],[11,"check_ident","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"ident"}],"output":null}],[11,"check_crate","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"crate"}],"output":null}],[11,"check_crate_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"crate"}],"output":null}],[11,"check_mod","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_mod_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_foreign_item","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"foreignitem"}],"output":null}],[11,"check_foreign_item_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"foreignitem"}],"output":null}],[11,"check_item","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"item"}],"output":null}],[11,"check_item_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"item"}],"output":null}],[11,"check_local","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"local"}],"output":null}],[11,"check_block","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"block"}],"output":null}],[11,"check_block_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"block"}],"output":null}],[11,"check_stmt","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"stmt"}],"output":null}],[11,"check_arm","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"arm"}],"output":null}],[11,"check_pat","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"pat"}],"output":null}],[11,"check_expr","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"expr"}],"output":null}],[11,"check_expr_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"expr"}],"output":null}],[11,"check_ty","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"ty"}],"output":null}],[11,"check_generic_param","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"genericparam"}],"output":null}],[11,"check_generics","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"generics"}],"output":null}],[11,"check_where_predicate","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"wherepredicate"}],"output":null}],[11,"check_poly_trait_ref","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"check_fn","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_fn_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_trait_item","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"traititem"}],"output":null}],[11,"check_trait_item_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"traititem"}],"output":null}],[11,"check_impl_item","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"implitem"}],"output":null}],[11,"check_impl_item_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"implitem"}],"output":null}],[11,"check_struct_def","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"variantdata"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"check_struct_def_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"variantdata"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"check_struct_field","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"structfield"}],"output":null}],[11,"check_variant","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_variant_post","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_lifetime","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"lifetime"}],"output":null}],[11,"check_path","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"check_attribute","","",318,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"attribute"}],"output":null}],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such as `#[allow(...)]`. Called with all the attributes of that node.",318,null],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",318,null],[11,"clone","","",297,{"inputs":[{"name":"self"}],"output":{"name":"lint"}}],[11,"fmt","","",297,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",297,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"default_level","","",297,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"level"}}],[11,"clone","","",298,{"inputs":[{"name":"self"}],"output":{"name":"lintid"}}],[11,"fmt","","",298,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",298,{"inputs":[{"name":"self"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",298,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"of","","Get the `LintId` for a `Lint`.",298,{"inputs":[{"name":"lint"}],"output":{"name":"lintid"}}],[11,"lint_name_raw","","",298,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"to_string","","Get the name of the lint.",298,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"clone","","",303,{"inputs":[{"name":"self"}],"output":{"name":"level"}}],[11,"eq","","",303,{"inputs":[{"name":"self"},{"name":"level"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",303,{"inputs":[{"name":"self"},{"name":"level"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"assert_receiver_is_total_eq","","",303,null],[11,"cmp","","",303,{"inputs":[{"name":"self"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"fmt","","",303,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",303,null],[11,"hash_stable","","",303,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"as_str","","Convert a level to a lower-case string.",303,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",303,{"inputs":[{"name":"str"}],"output":{"generics":["level"],"name":"option"}}],[11,"clone","","",304,{"inputs":[{"name":"self"}],"output":{"name":"lintsource"}}],[11,"eq","","",304,{"inputs":[{"name":"self"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",304,{"inputs":[{"name":"self"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",304,null],[11,"hash_stable","","",304,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",301,{"inputs":[],"output":{"name":"lintbuffer"}}],[11,"add_lint","","",301,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"multispan"},{"name":"str"},{"name":"builtinlintdiagnostics"}],"output":null}],[11,"take","","",301,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["bufferedearlylint"],"name":"vec"}}],[11,"get_any","","",301,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"with_lint_attrs","","",302,null],[11,"nested_visit_map","","",302,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",302,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",302,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_expr","","",302,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_struct_field","","",302,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",302,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_local","","",302,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_trait_item","","",302,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",302,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"middle","rustc","",null,null],[0,"allocator","rustc::middle","",null,null],[4,"AllocatorKind","rustc::middle::allocator","",null,null],[13,"Global","","",319,null],[13,"DefaultLib","","",319,null],[13,"DefaultExe","","",319,null],[11,"clone","","",319,{"inputs":[{"name":"self"}],"output":{"name":"allocatorkind"}}],[11,"fn_name","","",319,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"string"}}],[0,"borrowck","rustc::middle","",null,null],[3,"BorrowCheckResult","rustc::middle::borrowck","",null,null],[12,"used_mut_nodes","","",320,null],[11,"fmt","","",320,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",320,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",320,{"inputs":[{"name":"__d"}],"output":{"generics":["borrowcheckresult"],"name":"result"}}],[11,"hash_stable","","",320,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"expr_use_visitor","rustc::middle","A different sort of visitor for walking fn bodies.  Unlike the normal visitor, which just walks the entire body in one shot, the `ExprUseVisitor` determines how expressions are being used.",null,null],[3,"ExprUseVisitor","rustc::middle::expr_use_visitor","",null,null],[12,"mc","","",321,null],[12,"delegate","","",321,null],[12,"param_env","","",321,null],[4,"LoanCause","","",null,null],[13,"ClosureCapture","","",322,null],[13,"AddrOf","","",322,null],[13,"AutoRef","","",322,null],[13,"AutoUnsafe","","",322,null],[13,"RefBinding","","",322,null],[13,"OverloadedOperator","","",322,null],[13,"ClosureInvocation","","",322,null],[13,"ForLoop","","",322,null],[13,"MatchDiscriminant","","",322,null],[4,"ConsumeMode","","",null,null],[13,"Copy","","",323,null],[13,"Move","","",323,null],[4,"MoveReason","","",null,null],[13,"DirectRefMove","","",324,null],[13,"PatBindingMove","","",324,null],[13,"CaptureMove","","",324,null],[4,"MatchMode","","",null,null],[13,"NonBindingMatch","","",325,null],[13,"BorrowingMatch","","",325,null],[13,"CopyingMatch","","",325,null],[13,"MovingMatch","","",325,null],[4,"TrackMatchMode","","",null,null],[13,"Unknown","","",326,null],[13,"Definite","","",326,null],[13,"Conflicting","","",326,null],[4,"MutateMode","","",null,null],[13,"Init","","",327,null],[13,"JustWrite","","",327,null],[13,"WriteAndRead","","",327,null],[4,"OverloadedCallType","","",null,null],[13,"FnOverloadedCall","","",328,null],[13,"FnMutOverloadedCall","","",328,null],[13,"FnOnceOverloadedCall","","",328,null],[5,"copy_or_move","","",null,{"inputs":[{"name":"memcategorizationcontext"},{"name":"paramenv"},{"name":"cmt_"},{"name":"movereason"}],"output":{"name":"consumemode"}}],[8,"Delegate","","This trait defines the callbacks you can expect to receive when employing the ExprUseVisitor.",null,null],[10,"consume","","",329,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[10,"matched_pat","","",329,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"matchmode"}],"output":null}],[10,"consume_pat","","",329,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[10,"borrow","","",329,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[10,"decl_without_init","","",329,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[10,"mutate","","",329,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[11,"clone","","",322,{"inputs":[{"name":"self"}],"output":{"name":"loancause"}}],[11,"eq","","",322,{"inputs":[{"name":"self"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",322,{"inputs":[{"name":"self"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"fmt","","",322,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",323,{"inputs":[{"name":"self"}],"output":{"name":"consumemode"}}],[11,"eq","","",323,{"inputs":[{"name":"self"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",323,{"inputs":[{"name":"self"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"fmt","","",323,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",324,{"inputs":[{"name":"self"}],"output":{"name":"movereason"}}],[11,"eq","","",324,{"inputs":[{"name":"self"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"fmt","","",324,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",325,{"inputs":[{"name":"self"}],"output":{"name":"matchmode"}}],[11,"eq","","",325,{"inputs":[{"name":"self"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"fmt","","",325,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",326,{"inputs":[{"name":"self"}],"output":{"name":"trackmatchmode"}}],[11,"eq","","",326,{"inputs":[{"name":"self"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"ne","","",326,{"inputs":[{"name":"self"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"fmt","","",326,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"lub","","",326,{"inputs":[{"name":"self"},{"name":"matchmode"}],"output":null}],[11,"match_mode","","",326,{"inputs":[{"name":"self"}],"output":{"name":"matchmode"}}],[11,"clone","","",327,{"inputs":[{"name":"self"}],"output":{"name":"mutatemode"}}],[11,"eq","","",327,{"inputs":[{"name":"self"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"fmt","","",327,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",328,{"inputs":[{"name":"self"}],"output":{"name":"overloadedcalltype"}}],[11,"from_trait_id","","",328,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"overloadedcalltype"}}],[11,"from_method_id","","",328,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"overloadedcalltype"}}],[11,"new","","Creates the ExprUseVisitor, configuring it with the various options provided:",321,{"inputs":[{"name":"delegate"},{"name":"tyctxt"},{"name":"paramenv"},{"name":"scopetree"},{"name":"typecktables"},{"generics":["lrc"],"name":"option"}],"output":{"name":"self"}}],[11,"with_infer","","",321,{"inputs":[{"name":"delegate"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"scopetree"},{"name":"typecktables"}],"output":{"name":"self"}}],[11,"consume_body","","",321,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"tcx","","",321,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"delegate_consume","","",321,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"}],"output":null}],[11,"consume_exprs","","",321,null],[11,"consume_expr","","",321,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"mutate_expr","","",321,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"name":"mutatemode"}],"output":null}],[11,"borrow_expr","","",321,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[11,"select_from_expr","","",321,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"walk_expr","","",321,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"walk_callee","","",321,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"}],"output":null}],[11,"walk_stmt","","",321,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"walk_local","","",321,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"walk_block","","Indicates that the value of `blk` will be consumed, meaning either copied or moved depending on its type.",321,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"walk_struct_expr","","",321,null],[11,"walk_adjustment","","",321,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"walk_autoref","","Walks the autoref `autoref` applied to the autoderef'd `expr`. `cmt_base` is the mem-categorized form of `expr` after all relevant autoderefs have occurred.",321,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cmt_"},{"name":"autoborrow"}],"output":null}],[11,"arm_move_mode","","",321,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"arm"}],"output":{"name":"trackmatchmode"}}],[11,"walk_arm","","",321,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"arm"},{"name":"matchmode"}],"output":null}],[11,"walk_irrefutable_pat","","Walks a pat that occurs in isolation (i.e. top-level of fn arg or let binding.  Not a match arm or nested pat.)",321,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"pat"}],"output":null}],[11,"determine_pat_move_mode","","Identifies any bindings within `pat` and accumulates within `mode` whether the overall pattern/match structure is a move, copy, or borrow.",321,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"pat"},{"name":"trackmatchmode"}],"output":null}],[11,"walk_pat","","The core driver for walking a pattern; `match_mode` must be established up front, e.g. via `determine_pat_move_mode` (see also `walk_irrefutable_pat` for patterns that stand alone).",321,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"pat"},{"name":"matchmode"}],"output":null}],[11,"walk_captures","","",321,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"span"}],"output":null}],[11,"cat_captured_var","","",321,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"freevar"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[0,"const_val","rustc::middle","",null,null],[3,"ConstEvalErr","rustc::middle::const_val","",null,null],[12,"span","","",330,null],[12,"kind","","",330,null],[3,"FrameInfo","","",null,null],[12,"span","","",331,null],[12,"location","","",331,null],[4,"ConstVal","","",null,null],[13,"Unevaluated","","",332,null],[13,"Value","","",332,null],[4,"ErrKind","","",null,null],[13,"NonConstPath","","",333,null],[13,"UnimplementedConstVal","","",333,null],[13,"IndexOutOfBounds","","",333,null],[12,"len","rustc::middle::const_val::ErrKind","",333,null],[12,"index","","",333,null],[13,"LayoutError","rustc::middle::const_val","",333,null],[13,"TypeckError","","",333,null],[13,"CheckMatchError","","",333,null],[13,"Miri","","",333,null],[4,"ConstEvalErrDescription","","",null,null],[13,"Simple","","",334,null],[13,"Backtrace","","",334,null],[5,"struct_error","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[6,"EvalResult","","",null,null],[11,"clone","","",332,{"inputs":[{"name":"self"}],"output":{"name":"constval"}}],[11,"fmt","","",332,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",332,null],[11,"encode","","",332,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",332,{"inputs":[{"name":"__d"}],"output":{"generics":["constval"],"name":"result"}}],[11,"assert_receiver_is_total_eq","","",332,null],[11,"eq","","",332,{"inputs":[{"name":"self"},{"name":"constval"}],"output":{"name":"bool"}}],[11,"ne","","",332,{"inputs":[{"name":"self"},{"name":"constval"}],"output":{"name":"bool"}}],[11,"to_raw_bits","","",332,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"option"}}],[11,"unwrap_u64","","",332,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"clone","","",330,{"inputs":[{"name":"self"}],"output":{"name":"constevalerr"}}],[11,"fmt","","",330,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",333,{"inputs":[{"name":"self"}],"output":{"name":"errkind"}}],[11,"fmt","","",333,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",331,{"inputs":[{"name":"self"}],"output":{"name":"frameinfo"}}],[11,"fmt","","",331,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",334,{"inputs":[{"name":"self"}],"output":{"name":"constevalerrdescription"}}],[11,"fmt","","",334,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"into_oneline","","Return a one-line description of the error, for lints and such",334,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"description","","",330,{"inputs":[{"name":"self"}],"output":{"name":"constevalerrdescription"}}],[11,"struct_error","","",330,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"span"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"note","","",330,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"span"},{"name":"str"},{"name":"diagnosticbuilder"}],"output":null}],[11,"report","","",330,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"span"},{"name":"str"}],"output":null}],[0,"cstore","rustc::middle","the rustc crate store interface. This also includes types that are mostly used as a part of that interface, but these should probably get a better home if someone can find one.",null,null],[3,"LinkMeta","rustc::middle::cstore","",null,null],[12,"crate_hash","","",335,null],[3,"CrateSource","","Where a crate came from on the local filesystem. One of these three options must be non-None.",null,null],[12,"dylib","","",336,null],[12,"rlib","","",336,null],[12,"rmeta","","",336,null],[3,"NativeLibrary","","",null,null],[12,"kind","","",337,null],[12,"name","","",337,null],[12,"cfg","","",337,null],[12,"foreign_module","","",337,null],[3,"ForeignModule","","",null,null],[12,"foreign_items","","",338,null],[12,"def_id","","",338,null],[3,"ExternCrate","","",null,null],[12,"src","","",339,null],[12,"span","","span of the extern crate that caused this to be loaded",339,null],[12,"path_len","","Number of links to reach the extern; used to select the extern with the shortest path",339,null],[12,"direct","","If true, then this crate is the crate named by the extern crate referenced above. If false, then this crate is a dep of the crate.",339,null],[3,"EncodedMetadata","","",null,null],[12,"raw_data","","",340,null],[3,"DummyCrateStore","","A dummy crate store that does not support any non-local crates, for test purposes.",null,null],[4,"DepKind","","",null,null],[13,"UnexportedMacrosOnly","","A dependency that is only used for its macros, none of which are visible from other crates. These are included in the metadata only as placeholders and are ignored when decoding.",341,null],[13,"MacrosOnly","","A dependency that is only used for its macros.",341,null],[13,"Implicit","","A dependency that is always injected into the dependency list and so doesn't need to be linked to an rlib, e.g. the injected allocator.",341,null],[13,"Explicit","","A dependency that is required by an rlib version of this crate. Ordinary `extern crate`s result in `Explicit` dependencies.",341,null],[4,"LibSource","","",null,null],[13,"Some","","",342,null],[13,"MetadataOnly","","",342,null],[13,"None","","",342,null],[4,"LinkagePreference","","",null,null],[13,"RequireDynamic","","",343,null],[13,"RequireStatic","","",343,null],[4,"NativeLibraryKind","","",null,null],[13,"NativeStatic","","native static library (.a archive)",344,null],[13,"NativeStaticNobundle","","native static library, which doesn't get bundled into .rlibs",344,null],[13,"NativeFramework","","macOS-specific",344,null],[13,"NativeUnknown","","default way to specify a dynamic library",344,null],[4,"LoadedMacro","","",null,null],[13,"MacroDef","","",345,null],[13,"ProcMacro","","",345,null],[4,"ExternCrateSource","","",null,null],[13,"Extern","","Crate is loaded by `extern crate`.",346,null],[13,"Use","","",346,null],[13,"Path","","Crate is implicitly loaded by an absolute or an `extern::` path.",346,null],[5,"validate_crate_name","","",null,{"inputs":[{"generics":["session"],"name":"option"},{"name":"str"},{"generics":["span"],"name":"option"}],"output":null}],[5,"used_crates","","",null,{"inputs":[{"name":"tyctxt"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[8,"MetadataLoader","","The backend's way to give the crate store access to the metadata in a library. Note that it returns the raw metadata bytes stored in the library file, whether it is compressed, uncompressed, some weird mix, etc. rmeta files are backend independent and not handled here.",null,null],[10,"get_rlib_metadata","","",347,{"inputs":[{"name":"self"},{"name":"target"},{"name":"path"}],"output":{"generics":["metadataref","string"],"name":"result"}}],[10,"get_dylib_metadata","","",347,{"inputs":[{"name":"self"},{"name":"target"},{"name":"path"}],"output":{"generics":["metadataref","string"],"name":"result"}}],[8,"CrateStore","","A store of Rust crates, through with their metadata can be accessed.",null,null],[10,"crate_data_as_rc_any","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["any"],"name":"lrc"}}],[10,"metadata_loader","","",348,{"inputs":[{"name":"self"}],"output":{"name":"metadataloader"}}],[10,"def_key","","",348,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defkey"}}],[10,"def_path","","",348,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpath"}}],[10,"def_path_hash","","",348,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpathhash"}}],[10,"def_path_table","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defpathtable"],"name":"lrc"}}],[10,"visibility_untracked","","",348,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"visibility"}}],[10,"export_macros_untracked","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":null}],[10,"dep_kind_untracked","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"depkind"}}],[10,"crate_name_untracked","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[10,"crate_disambiguator_untracked","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratedisambiguator"}}],[10,"crate_hash_untracked","","",348,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"svh"}}],[10,"struct_field_names_untracked","","",348,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["name"],"name":"vec"}}],[10,"item_children_untracked","","",348,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"generics":["export"],"name":"vec"}}],[10,"load_macro_untracked","","",348,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"name":"loadedmacro"}}],[10,"extern_mod_stmt_cnum_untracked","","",348,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["cratenum"],"name":"option"}}],[10,"item_generics_cloned_untracked","","",348,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"name":"generics"}}],[10,"associated_item_cloned_untracked","","",348,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"associateditem"}}],[10,"postorder_cnums_untracked","","",348,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[10,"crates_untracked","","",348,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[10,"encode_metadata","","",348,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"linkmeta"}],"output":{"name":"encodedmetadata"}}],[10,"metadata_encoding_version","","",348,null],[8,"CrateLoader","","",null,null],[10,"process_extern_crate","","",349,{"inputs":[{"name":"self"},{"name":"item"},{"name":"definitions"}],"output":{"name":"cratenum"}}],[10,"process_path_extern","","",349,{"inputs":[{"name":"self"},{"name":"symbol"},{"name":"span"}],"output":{"name":"cratenum"}}],[10,"process_use_extern","","",349,{"inputs":[{"name":"self"},{"name":"symbol"},{"name":"span"},{"name":"nodeid"},{"name":"definitions"}],"output":{"name":"cratenum"}}],[10,"postprocess","","",349,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"clone","","",335,{"inputs":[{"name":"self"}],"output":{"name":"linkmeta"}}],[11,"fmt","","",335,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",336,{"inputs":[{"name":"self"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",336,{"inputs":[{"name":"self"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"clone","","",336,{"inputs":[{"name":"self"}],"output":{"name":"cratesource"}}],[11,"fmt","","",336,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",341,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",341,{"inputs":[{"name":"__d"}],"output":{"generics":["depkind"],"name":"result"}}],[11,"clone","","",341,{"inputs":[{"name":"self"}],"output":{"name":"depkind"}}],[11,"cmp","","",341,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",341,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"assert_receiver_is_total_eq","","",341,null],[11,"eq","","",341,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"name":"bool"}}],[11,"fmt","","",341,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"macros_only","","",341,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"eq","","",342,{"inputs":[{"name":"self"},{"name":"libsource"}],"output":{"name":"bool"}}],[11,"ne","","",342,{"inputs":[{"name":"self"},{"name":"libsource"}],"output":{"name":"bool"}}],[11,"clone","","",342,{"inputs":[{"name":"self"}],"output":{"name":"libsource"}}],[11,"fmt","","",342,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_some","","",342,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"option","","",342,{"inputs":[{"name":"self"}],"output":{"generics":["pathbuf"],"name":"option"}}],[11,"fmt","","",343,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",343,{"inputs":[{"name":"self"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"clone","","",343,{"inputs":[{"name":"self"}],"output":{"name":"linkagepreference"}}],[11,"encode","","",343,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",343,{"inputs":[{"name":"__d"}],"output":{"generics":["linkagepreference"],"name":"result"}}],[11,"clone","","",344,{"inputs":[{"name":"self"}],"output":{"name":"nativelibrarykind"}}],[11,"eq","","",344,{"inputs":[{"name":"self"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",344,null],[11,"partial_cmp","","",344,{"inputs":[{"name":"self"},{"name":"nativelibrarykind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",344,{"inputs":[{"name":"self"},{"name":"nativelibrarykind"}],"output":{"name":"ordering"}}],[11,"hash","","",344,null],[11,"encode","","",344,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",344,{"inputs":[{"name":"__d"}],"output":{"generics":["nativelibrarykind"],"name":"result"}}],[11,"clone","","",337,{"inputs":[{"name":"self"}],"output":{"name":"nativelibrary"}}],[11,"hash","","",337,null],[11,"encode","","",337,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",337,{"inputs":[{"name":"__d"}],"output":{"generics":["nativelibrary"],"name":"result"}}],[11,"clone","","",338,{"inputs":[{"name":"self"}],"output":{"name":"foreignmodule"}}],[11,"hash","","",338,null],[11,"encode","","",338,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",338,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignmodule"],"name":"result"}}],[11,"clone","","",339,{"inputs":[{"name":"self"}],"output":{"name":"externcrate"}}],[11,"fmt","","",339,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",346,{"inputs":[{"name":"self"}],"output":{"name":"externcratesource"}}],[11,"fmt","","",346,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",340,{"inputs":[],"output":{"name":"encodedmetadata"}}],[11,"crate_data_as_rc_any","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["any"],"name":"lrc"}}],[11,"visibility_untracked","","",350,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"visibility"}}],[11,"item_generics_cloned_untracked","","",350,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"name":"generics"}}],[11,"associated_item_cloned_untracked","","",350,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"associateditem"}}],[11,"dep_kind_untracked","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"depkind"}}],[11,"export_macros_untracked","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":null}],[11,"crate_name_untracked","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[11,"crate_disambiguator_untracked","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratedisambiguator"}}],[11,"crate_hash_untracked","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"svh"}}],[11,"def_key","","",350,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defkey"}}],[11,"def_path","","",350,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpath"}}],[11,"def_path_hash","","",350,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpathhash"}}],[11,"def_path_table","","",350,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defpathtable"],"name":"lrc"}}],[11,"struct_field_names_untracked","","",350,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["name"],"name":"vec"}}],[11,"item_children_untracked","","",350,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"generics":["export"],"name":"vec"}}],[11,"load_macro_untracked","","",350,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"name":"loadedmacro"}}],[11,"crates_untracked","","",350,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[11,"extern_mod_stmt_cnum_untracked","","",350,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["cratenum"],"name":"option"}}],[11,"encode_metadata","","",350,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"linkmeta"}],"output":{"name":"encodedmetadata"}}],[11,"metadata_encoding_version","","",350,null],[11,"postorder_cnums_untracked","","",350,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[11,"metadata_loader","","",350,{"inputs":[{"name":"self"}],"output":{"name":"metadataloader"}}],[0,"dataflow","rustc::middle","A module for propagating forward dataflow information. The analysis assumes that the items to be propagated can be represented as bits and thus uses bitvectors. Your job is simply to specify the so-called GEN and KILL bits for each expression.",null,null],[3,"DataFlowContext","rustc::middle::dataflow","",null,null],[12,"tcx","","",351,null],[12,"analysis_name","","a name for the analysis using this dataflow instance",351,null],[12,"oper","","the data flow operator",351,null],[12,"bits_per_id","","number of bits to propagate per id",351,null],[12,"words_per_id","","number of words we will use to store bits_per_id. equal to bits_per_id/usize::BITS rounded up.",351,null],[12,"local_id_to_index","","",351,null],[12,"gens","","bits generated as we exit the cfg node. Updated by `add_gen()`.",351,null],[12,"scope_kills","","bits killed as we exit the cfg node, or non-locally jump over it. Updated by `add_kill(KillFrom::ScopeEnd)`.",351,null],[12,"action_kills","","bits killed as we exit the cfg node directly; if it is jumped over, e.g. via `break`, the kills are not reflected in the jump's effects. Updated by `add_kill(KillFrom::Execution)`.",351,null],[12,"on_entry","","bits that are valid on entry to the cfg node. Updated by `propagate()`.",351,null],[3,"PropagationContext","","",null,null],[12,"dfcx","","",352,null],[12,"changed","","",352,null],[3,"Union","","",null,null],[3,"Subtract","","",null,null],[4,"EntryOrExit","","",null,null],[13,"Entry","","",353,null],[13,"Exit","","",353,null],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill takes effect only when control flows directly through the node in question, or if the kill's effect is associated with any control-flow directly through or indirectly over the node.",null,null],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control flow goes over the node. A kill associated with the end of the scope of a variable declaration `let x;` is an example of a `ScopeEnd` kill.",354,null],[13,"Execution","","An `Execution` kill is one that takes effect only when control flow goes through the node to completion. A kill associated with an assignment statement `x = expr;` is an example of an `Execution` kill.",354,null],[5,"get_cfg_indices","","",null,null],[5,"build_local_id_to_index","","",null,{"inputs":[{"generics":["body"],"name":"option"},{"name":"cfg"}],"output":{"generics":["itemlocalid","vec"],"name":"fxhashmap"}}],[5,"mut_bits_to_string","","",null,null],[5,"bits_to_string","","",null,null],[5,"bitwise","","",null,null],[5,"set_bit","","",null,null],[5,"bit_str","","",null,{"inputs":[{"name":"usize"}],"output":{"name":"string"}}],[8,"BitwiseOperator","","",null,null],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",355,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",null,null],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",356,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",353,{"inputs":[{"name":"self"}],"output":{"name":"entryorexit"}}],[11,"fmt","","",353,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",351,{"inputs":[{"name":"self"}],"output":{"name":"dataflowcontext"}}],[11,"has_bitset_for_local_id","","",351,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"nested","","",351,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[11,"pre","","",351,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"clone","","",354,{"inputs":[{"name":"self"}],"output":{"name":"killfrom"}}],[11,"eq","","",354,{"inputs":[{"name":"self"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"fmt","","",354,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",351,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"generics":["body"],"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",351,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"usize"}],"output":null}],[11,"add_kill","","Indicates that `id` kills `bit`",351,{"inputs":[{"name":"self"},{"name":"killfrom"},{"name":"itemlocalid"},{"name":"usize"}],"output":null}],[11,"apply_gen_kill","","Applies the gen and kill sets for `cfgidx` to `bits`",351,null],[11,"compute_id_range","","",351,null],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`. Only useful after `propagate()` has been called.",351,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`. Only useful after `propagate()` has been called.",351,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"cfgindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",351,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit","","Helper for iterating over the bits in a bit set. Returns false on the first call to `f` that returns false; if all calls to `f` return true, then returns true.",351,null],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow exits through any number of enclosing scopes on its way to the new destination. This function infers the kill bits of those control operators based on the kill bits associated with those scopes.",351,{"inputs":[{"name":"self"},{"name":"cfg"}],"output":null}],[11,"propagate","","Performs the data flow analysis.",351,{"inputs":[{"name":"self"},{"name":"cfg"},{"name":"body"}],"output":null}],[11,"walk_cfg","","",352,null],[11,"reset","","",352,null],[11,"propagate_bits_into_graph_successors_of","","",352,null],[11,"propagate_bits_into_entry_set_for","","",352,null],[11,"join","","",357,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",358,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[0,"dead","rustc::middle","",null,null],[3,"MarkSymbolVisitor","rustc::middle::dead","",null,null],[12,"worklist","","",359,null],[12,"tcx","","",359,null],[12,"tables","","",359,null],[12,"live_symbols","","",359,null],[12,"repr_has_repr_c","","",359,null],[12,"in_pat","","",359,null],[12,"inherited_pub_visibility","","",359,null],[12,"ignore_variant_stack","","",359,null],[3,"LifeSeeder","","",null,null],[12,"worklist","","",360,null],[12,"krate","","",360,null],[12,"tcx","","",360,null],[3,"DeadVisitor","","",null,null],[12,"tcx","","",361,null],[12,"live_symbols","","",361,null],[5,"should_explore","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"has_allow_dead_code_or_lang_attr","","",null,null],[5,"create_and_seed_worklist","","",null,{"inputs":[{"name":"tyctxt"},{"name":"accesslevels"},{"name":"crate"}],"output":{"generics":["nodeid"],"name":"vec"}}],[5,"find_live","","",null,{"inputs":[{"name":"tyctxt"},{"name":"accesslevels"},{"name":"crate"}],"output":{"generics":["fxhashset"],"name":"box"}}],[5,"get_struct_ctor_id","","",null,{"inputs":[{"name":"item"}],"output":{"generics":["nodeid"],"name":"option"}}],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[11,"check_def_id","","",359,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"insert_def_id","","",359,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"handle_definition","","",359,{"inputs":[{"name":"self"},{"name":"def"}],"output":null}],[11,"lookup_and_handle_method","","",359,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":null}],[11,"handle_field_access","","",359,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"nodeid"}],"output":null}],[11,"handle_field_pattern_match","","",359,null],[11,"mark_live_symbols","","",359,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_node","","",359,{"inputs":[{"name":"self"},{"name":"node"}],"output":null}],[11,"mark_as_used_if_union","","",359,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"hirvec"}],"output":null}],[11,"nested_visit_map","","",359,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",359,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_variant_data","","",359,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"name"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_expr","","",359,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_arm","","",359,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",359,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_path","","",359,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_item","","",360,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",360,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",360,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"should_warn_about_item","","",361,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"bool"}}],[11,"should_warn_about_field","","",361,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":{"name":"bool"}}],[11,"should_warn_about_variant","","",361,{"inputs":[{"name":"self"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"should_warn_about_foreign_item","","",361,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"symbol_is_live","","",361,{"inputs":[{"name":"self"},{"name":"nodeid"},{"generics":["nodeid"],"name":"option"}],"output":{"name":"bool"}}],[11,"warn_dead_code","","",361,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"name"},{"name":"str"},{"name":"str"}],"output":null}],[11,"nested_visit_map","","Walk nested items in place so that we don't report dead-code on inner functions when the outer function is already getting an error. We could do this also by checking the parents, but this is how the code is setup and it seems harmless enough.",361,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",361,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_variant","","",361,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_foreign_item","","",361,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_struct_field","","",361,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_impl_item","","",361,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_trait_item","","",361,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[0,"dependency_format","rustc::middle","Resolution of mixing rlibs and dylibs",null,null],[4,"Linkage","rustc::middle::dependency_format","",null,null],[13,"NotLinked","","",362,null],[13,"IncludedFromDylib","","",362,null],[13,"Static","","",362,null],[13,"Dynamic","","",362,null],[5,"calculate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"calculate_type","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratetype"}],"output":{"name":"dependencylist"}}],[5,"add_library","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"},{"name":"linkagepreference"},{"name":"fxhashmap"}],"output":null}],[5,"attempt_static","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["dependencylist"],"name":"option"}}],[5,"activate_injected_dep","","",null,{"inputs":[{"generics":["cratenum"],"name":"option"},{"name":"dependencylist"},{"name":"fn"}],"output":null}],[5,"activate_injected_allocator","","",null,{"inputs":[{"name":"session"},{"name":"dependencylist"}],"output":null}],[5,"verify_ok","","",null,null],[6,"DependencyList","","A list of dependencies for a certain crate type.",null,null],[6,"Dependencies","","A mapping of all required dependencies for a particular flavor of output.",null,null],[11,"clone","","",362,{"inputs":[{"name":"self"}],"output":{"name":"linkage"}}],[11,"eq","","",362,{"inputs":[{"name":"self"},{"name":"linkage"}],"output":{"name":"bool"}}],[11,"fmt","","",362,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"entry","rustc::middle","",null,null],[3,"EntryContext","rustc::middle::entry","",null,null],[12,"session","","",363,null],[12,"map","","",363,null],[12,"main_fn","","",363,null],[12,"attr_main_fn","","",363,null],[12,"start_fn","","",363,null],[12,"non_main_fns","","",363,null],[5,"find_entry_point","","",null,{"inputs":[{"name":"session"},{"name":"map"},{"name":"str"}],"output":null}],[5,"entry_point_type","","",null,{"inputs":[{"name":"item"},{"name":"bool"}],"output":{"name":"entrypointtype"}}],[5,"find_item","","",null,{"inputs":[{"name":"item"},{"name":"entrycontext"},{"name":"bool"}],"output":null}],[5,"configure_main","","",null,{"inputs":[{"name":"entrycontext"},{"name":"str"}],"output":null}],[11,"visit_item","","",363,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",363,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",363,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"exported_symbols","rustc::middle","",null,null],[4,"SymbolExportLevel","rustc::middle::exported_symbols","The SymbolExportLevel of a symbols specifies from which kinds of crates the symbol will be exported. `C` symbols will be exported from any kind of crate, including cdylibs which export very few things. `Rust` will only be exported if the crate produced is a Rust dylib.",null,null],[13,"C","","",364,null],[13,"Rust","","",364,null],[4,"ExportedSymbol","","",null,null],[13,"NonGeneric","","",365,null],[13,"Generic","","",365,null],[13,"NoDefId","","",365,null],[5,"metadata_symbol_name","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"assert_receiver_is_total_eq","","",364,null],[11,"eq","","",364,{"inputs":[{"name":"self"},{"name":"symbolexportlevel"}],"output":{"name":"bool"}}],[11,"fmt","","",364,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",364,{"inputs":[{"name":"self"}],"output":{"name":"symbolexportlevel"}}],[11,"encode","","",364,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",364,{"inputs":[{"name":"__d"}],"output":{"generics":["symbolexportlevel"],"name":"result"}}],[11,"hash_stable","","",364,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"is_below_threshold","","",364,{"inputs":[{"name":"self"},{"name":"symbolexportlevel"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",365,null],[11,"eq","","",365,{"inputs":[{"name":"self"},{"name":"exportedsymbol"}],"output":{"name":"bool"}}],[11,"ne","","",365,{"inputs":[{"name":"self"},{"name":"exportedsymbol"}],"output":{"name":"bool"}}],[11,"fmt","","",365,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",365,{"inputs":[{"name":"self"}],"output":{"name":"exportedsymbol"}}],[11,"encode","","",365,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",365,{"inputs":[{"name":"__d"}],"output":{"generics":["exportedsymbol"],"name":"result"}}],[11,"symbol_name","","",365,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"symbolname"}}],[11,"compare_stable","","",365,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"exportedsymbol"}],"output":{"name":"ordering"}}],[11,"hash_stable","","",365,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"free_region","rustc::middle","This file handles the relationships between free regions -- meaning lifetime parameters. Ordinarily, free regions are unrelated to one another, but they can be related via implied or explicit bounds.  In that case, we track the bounds using the `TransitiveRelation` type and use that to decide when one free region outlives another and so forth.",null,null],[3,"RegionRelations","rustc::middle::free_region","Combines a `region::ScopeTree` (which governs relationships between scopes) and a `FreeRegionMap` (which governs relationships between free regions) to yield a complete relation between concrete regions.",null,null],[12,"tcx","","",366,null],[12,"context","","context used to fetch the region maps",366,null],[12,"region_scope_tree","","region maps for the given context",366,null],[12,"free_regions","","free-region relationships",366,null],[11,"new","","",366,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"scopetree"},{"name":"freeregionmap"}],"output":{"name":"self"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run after inference and sadly the logic is somewhat duplicated with the code in infer.rs.",366,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"is_static","","Determines whether this free-region is required to be 'static",366,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"lub_free_regions","","",366,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[0,"intrinsicck","rustc::middle","",null,null],[3,"ItemVisitor","rustc::middle::intrinsicck","",null,null],[12,"tcx","","",367,null],[3,"ExprVisitor","","",null,null],[12,"tcx","","",368,null],[12,"tables","","",368,null],[12,"param_env","","",368,null],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"unpack_option_like","","If the type is `Option<T>`, it will return `T`, otherwise the type itself. Works on most `Option`-like types.",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"def_id_is_transmute","","",368,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"check_transmute","","",368,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"ty"}],"output":null}],[11,"nested_visit_map","","",367,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",367,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"nested_visit_map","","",368,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_expr","","",368,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[0,"lang_items","rustc::middle","",null,null],[3,"LanguageItems","rustc::middle::lang_items","",null,null],[12,"items","","",369,null],[12,"missing","","",369,null],[3,"LanguageItemCollector","","",null,null],[12,"items","","",370,null],[12,"tcx","","",370,null],[12,"item_refs","","",370,null],[4,"LangItem","","",null,null],[13,"CharImplItem","","",371,null],[13,"StrImplItem","","",371,null],[13,"SliceImplItem","","",371,null],[13,"SliceU8ImplItem","","",371,null],[13,"StrAllocImplItem","","",371,null],[13,"SliceAllocImplItem","","",371,null],[13,"SliceU8AllocImplItem","","",371,null],[13,"ConstPtrImplItem","","",371,null],[13,"MutPtrImplItem","","",371,null],[13,"I8ImplItem","","",371,null],[13,"I16ImplItem","","",371,null],[13,"I32ImplItem","","",371,null],[13,"I64ImplItem","","",371,null],[13,"I128ImplItem","","",371,null],[13,"IsizeImplItem","","",371,null],[13,"U8ImplItem","","",371,null],[13,"U16ImplItem","","",371,null],[13,"U32ImplItem","","",371,null],[13,"U64ImplItem","","",371,null],[13,"U128ImplItem","","",371,null],[13,"UsizeImplItem","","",371,null],[13,"F32ImplItem","","",371,null],[13,"F64ImplItem","","",371,null],[13,"F32RuntimeImplItem","","",371,null],[13,"F64RuntimeImplItem","","",371,null],[13,"SizedTraitLangItem","","",371,null],[13,"UnsizeTraitLangItem","","",371,null],[13,"CopyTraitLangItem","","",371,null],[13,"CloneTraitLangItem","","",371,null],[13,"SyncTraitLangItem","","",371,null],[13,"FreezeTraitLangItem","","",371,null],[13,"DropTraitLangItem","","",371,null],[13,"CoerceUnsizedTraitLangItem","","",371,null],[13,"AddTraitLangItem","","",371,null],[13,"SubTraitLangItem","","",371,null],[13,"MulTraitLangItem","","",371,null],[13,"DivTraitLangItem","","",371,null],[13,"RemTraitLangItem","","",371,null],[13,"NegTraitLangItem","","",371,null],[13,"NotTraitLangItem","","",371,null],[13,"BitXorTraitLangItem","","",371,null],[13,"BitAndTraitLangItem","","",371,null],[13,"BitOrTraitLangItem","","",371,null],[13,"ShlTraitLangItem","","",371,null],[13,"ShrTraitLangItem","","",371,null],[13,"AddAssignTraitLangItem","","",371,null],[13,"SubAssignTraitLangItem","","",371,null],[13,"MulAssignTraitLangItem","","",371,null],[13,"DivAssignTraitLangItem","","",371,null],[13,"RemAssignTraitLangItem","","",371,null],[13,"BitXorAssignTraitLangItem","","",371,null],[13,"BitAndAssignTraitLangItem","","",371,null],[13,"BitOrAssignTraitLangItem","","",371,null],[13,"ShlAssignTraitLangItem","","",371,null],[13,"ShrAssignTraitLangItem","","",371,null],[13,"IndexTraitLangItem","","",371,null],[13,"IndexMutTraitLangItem","","",371,null],[13,"UnsafeCellTypeLangItem","","",371,null],[13,"DerefTraitLangItem","","",371,null],[13,"DerefMutTraitLangItem","","",371,null],[13,"FnTraitLangItem","","",371,null],[13,"FnMutTraitLangItem","","",371,null],[13,"FnOnceTraitLangItem","","",371,null],[13,"GeneratorStateLangItem","","",371,null],[13,"GeneratorTraitLangItem","","",371,null],[13,"EqTraitLangItem","","",371,null],[13,"PartialOrdTraitLangItem","","",371,null],[13,"OrdTraitLangItem","","",371,null],[13,"PanicFnLangItem","","",371,null],[13,"PanicBoundsCheckFnLangItem","","",371,null],[13,"PanicFmtLangItem","","",371,null],[13,"ExchangeMallocFnLangItem","","",371,null],[13,"BoxFreeFnLangItem","","",371,null],[13,"DropInPlaceFnLangItem","","",371,null],[13,"OomLangItem","","",371,null],[13,"StartFnLangItem","","",371,null],[13,"EhPersonalityLangItem","","",371,null],[13,"EhUnwindResumeLangItem","","",371,null],[13,"MSVCTryFilterLangItem","","",371,null],[13,"OwnedBoxLangItem","","",371,null],[13,"PhantomDataItem","","",371,null],[13,"NonZeroItem","","",371,null],[13,"DebugTraitLangItem","","",371,null],[13,"I128AddFnLangItem","","",371,null],[13,"U128AddFnLangItem","","",371,null],[13,"I128SubFnLangItem","","",371,null],[13,"U128SubFnLangItem","","",371,null],[13,"I128MulFnLangItem","","",371,null],[13,"U128MulFnLangItem","","",371,null],[13,"I128DivFnLangItem","","",371,null],[13,"U128DivFnLangItem","","",371,null],[13,"I128RemFnLangItem","","",371,null],[13,"U128RemFnLangItem","","",371,null],[13,"I128ShlFnLangItem","","",371,null],[13,"U128ShlFnLangItem","","",371,null],[13,"I128ShrFnLangItem","","",371,null],[13,"U128ShrFnLangItem","","",371,null],[13,"I128AddoFnLangItem","","",371,null],[13,"U128AddoFnLangItem","","",371,null],[13,"I128SuboFnLangItem","","",371,null],[13,"U128SuboFnLangItem","","",371,null],[13,"I128MuloFnLangItem","","",371,null],[13,"U128MuloFnLangItem","","",371,null],[13,"I128ShloFnLangItem","","",371,null],[13,"U128ShloFnLangItem","","",371,null],[13,"I128ShroFnLangItem","","",371,null],[13,"U128ShroFnLangItem","","",371,null],[13,"TerminationTraitLangItem","","",371,null],[5,"extract","","",null,null],[5,"collect","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"name":"languageitems"}}],[11,"fmt","","",371,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",371,{"inputs":[{"name":"self"}],"output":{"name":"langitem"}}],[11,"eq","","",371,{"inputs":[{"name":"self"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",371,null],[11,"hash","","",371,null],[11,"encode","","",371,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",371,{"inputs":[{"name":"__d"}],"output":{"generics":["langitem"],"name":"result"}}],[11,"from_u32","","",371,{"inputs":[{"name":"u32"}],"output":{"generics":["langitem"],"name":"option"}}],[11,"name","","",371,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"new","","",369,{"inputs":[],"output":{"name":"languageitems"}}],[11,"items","","",369,null],[11,"require","","",369,{"inputs":[{"name":"self"},{"name":"langitem"}],"output":{"generics":["defid","string"],"name":"result"}}],[11,"fn_trait_kind","","",369,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["closurekind"],"name":"option"}}],[11,"char_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"str_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"slice_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"slice_u8_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"str_alloc_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"slice_alloc_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"slice_u8_alloc_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"const_ptr_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"mut_ptr_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i8_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i16_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i32_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i64_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"isize_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u8_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u16_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u32_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u64_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"usize_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"f32_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"f64_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"f32_runtime_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"f64_runtime_impl","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"sized_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"unsize_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"copy_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"clone_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"sync_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"freeze_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"drop_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"coerce_unsized_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"add_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"sub_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"mul_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"div_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"rem_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"neg_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"not_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"bitxor_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"bitand_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"bitor_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"shl_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"shr_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"add_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"sub_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"mul_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"div_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"rem_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"bitxor_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"bitand_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"bitor_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"shl_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"shr_assign_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"index_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"index_mut_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"unsafe_cell_type","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"deref_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"deref_mut_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"fn_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"fn_mut_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"fn_once_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"gen_state","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"gen_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"eq_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"partial_ord_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"ord_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"panic_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"panic_bounds_check_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"panic_fmt","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"exchange_malloc_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"box_free_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"drop_in_place_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"oom","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"start_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"eh_personality","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"eh_unwind_resume","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"msvc_try_filter","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"owned_box","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"phantom_data","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"non_zero","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"debug_trait","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_add_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_add_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_sub_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_sub_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_mul_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_mul_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_div_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_div_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_rem_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_rem_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_shl_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_shl_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_shr_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_shr_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_addo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_addo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_subo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_subo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_mulo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_mulo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_shlo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_shlo_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"i128_shro_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"u128_shro_fn","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"termination","","",369,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"visit_item","","",370,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",370,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",370,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"new","","",370,{"inputs":[{"name":"tyctxt"}],"output":{"name":"languageitemcollector"}}],[11,"collect_item","","",370,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"defid"}],"output":null}],[0,"liveness","rustc::middle","A classic liveness analysis based on dataflow over the AST.  Computes, for each local variable in a function, whether that variable is live at a given point.  Program execution points are identified by their id.",null,null],[3,"Variable","rustc::middle::liveness","",null,null],[12,"0","","",372,null],[3,"LiveNode","","",null,null],[12,"0","","",373,null],[3,"CaptureInfo","","",null,null],[12,"ln","","",374,null],[12,"var_nid","","",374,null],[3,"LocalInfo","","",null,null],[12,"id","","",375,null],[12,"name","","",375,null],[12,"is_shorthand","","",375,null],[3,"IrMaps","","",null,null],[12,"tcx","","",376,null],[12,"num_live_nodes","","",376,null],[12,"num_vars","","",376,null],[12,"live_node_map","","",376,null],[12,"variable_map","","",376,null],[12,"capture_info_map","","",376,null],[12,"var_kinds","","",376,null],[12,"lnks","","",376,null],[3,"Users","","",null,null],[12,"reader","","",377,null],[12,"writer","","",377,null],[12,"used","","",377,null],[3,"Specials","","",null,null],[12,"exit_ln","","",378,null],[12,"fallthrough_ln","","",378,null],[12,"clean_exit_var","","",378,null],[3,"Liveness","","",null,null],[12,"ir","","",379,null],[12,"tables","","",379,null],[12,"s","","",379,null],[12,"successors","","",379,null],[12,"users","","",379,null],[12,"break_ln","","",379,null],[12,"cont_ln","","",379,null],[12,"breakable_block_ln","","",379,null],[4,"LoopKind","","For use with `propagate_through_loop`.",null,null],[13,"LoopLoop","","An endless `loop` loop.",380,null],[13,"WhileLoop","","A `while` loop, with the given expression as condition.",380,null],[4,"LiveNodeKind","","",null,null],[13,"FreeVarNode","","",381,null],[13,"ExprNode","","",381,null],[13,"VarDefNode","","",381,null],[13,"ExitNode","","",381,null],[4,"VarKind","","",null,null],[13,"Arg","","",382,null],[13,"Local","","",382,null],[13,"CleanExit","","",382,null],[5,"live_node_kind_to_string","","",null,{"inputs":[{"name":"livenodekind"},{"name":"tyctxt"}],"output":{"name":"string"}}],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"invalid_node","","",null,{"inputs":[],"output":{"name":"livenode"}}],[5,"visit_fn","","",null,{"inputs":[{"name":"irmaps"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[5,"visit_local","","",null,{"inputs":[{"name":"irmaps"},{"name":"local"}],"output":null}],[5,"visit_arm","","",null,{"inputs":[{"name":"irmaps"},{"name":"arm"}],"output":null}],[5,"visit_expr","","",null,{"inputs":[{"name":"irmaps"},{"name":"expr"}],"output":null}],[5,"invalid_users","","",null,{"inputs":[],"output":{"name":"users"}}],[5,"check_local","","",null,{"inputs":[{"name":"liveness"},{"name":"local"}],"output":null}],[5,"check_arm","","",null,{"inputs":[{"name":"liveness"},{"name":"arm"}],"output":null}],[5,"check_expr","","",null,{"inputs":[{"name":"liveness"},{"name":"expr"}],"output":null}],[17,"ACC_READ","","",null,null],[17,"ACC_WRITE","","",null,null],[17,"ACC_USE","","",null,null],[11,"clone","","",372,{"inputs":[{"name":"self"}],"output":{"name":"variable"}}],[11,"eq","","",372,{"inputs":[{"name":"self"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"ne","","",372,{"inputs":[{"name":"self"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"eq","","",373,{"inputs":[{"name":"self"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"ne","","",373,{"inputs":[{"name":"self"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"get","","",372,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"get","","",373,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",373,{"inputs":[{"name":"self"}],"output":{"name":"livenode"}}],[11,"clone","","",381,{"inputs":[{"name":"self"}],"output":{"name":"livenodekind"}}],[11,"eq","","",381,{"inputs":[{"name":"self"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"ne","","",381,{"inputs":[{"name":"self"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"fmt","","",381,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"nested_visit_map","","",376,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_fn","","",376,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_local","","",376,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_expr","","",376,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_arm","","",376,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"fmt","","",373,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",372,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_valid","","",373,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",375,{"inputs":[{"name":"self"}],"output":{"name":"localinfo"}}],[11,"fmt","","",375,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",382,{"inputs":[{"name":"self"}],"output":{"name":"varkind"}}],[11,"fmt","","",382,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",376,{"inputs":[{"name":"tyctxt"}],"output":{"name":"irmaps"}}],[11,"add_live_node","","",376,{"inputs":[{"name":"self"},{"name":"livenodekind"}],"output":{"name":"livenode"}}],[11,"add_live_node_for_node","","",376,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"livenodekind"}],"output":null}],[11,"add_variable","","",376,{"inputs":[{"name":"self"},{"name":"varkind"}],"output":{"name":"variable"}}],[11,"variable","","",376,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":{"name":"variable"}}],[11,"variable_name","","",376,{"inputs":[{"name":"self"},{"name":"variable"}],"output":{"name":"string"}}],[11,"variable_is_shorthand","","",376,{"inputs":[{"name":"self"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"set_captures","","",376,{"inputs":[{"name":"self"},{"name":"nodeid"},{"generics":["captureinfo"],"name":"vec"}],"output":null}],[11,"lnk","","",376,{"inputs":[{"name":"self"},{"name":"livenode"}],"output":{"name":"livenodekind"}}],[11,"clone","","",377,{"inputs":[{"name":"self"}],"output":{"name":"users"}}],[11,"clone","","",378,{"inputs":[{"name":"self"}],"output":{"name":"specials"}}],[11,"new","","",379,{"inputs":[{"name":"irmaps"},{"name":"bodyid"}],"output":{"name":"liveness"}}],[11,"live_node","","",379,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":{"name":"livenode"}}],[11,"variable","","",379,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":{"name":"variable"}}],[11,"pat_bindings","","",379,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"f"}],"output":null}],[11,"arm_pats_bindings","","",379,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"option"},{"name":"f"}],"output":null}],[11,"define_bindings_in_pat","","",379,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"define_bindings_in_arm_pats","","",379,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"option"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"idx","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":{"name":"usize"}}],[11,"live_on_entry","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":{"generics":["livenodekind"],"name":"option"}}],[11,"live_on_exit","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":{"generics":["livenodekind"],"name":"option"}}],[11,"used_on_entry","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"assigned_on_entry","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":{"generics":["livenodekind"],"name":"option"}}],[11,"assigned_on_exit","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":{"generics":["livenodekind"],"name":"option"}}],[11,"indices2","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"livenode"},{"name":"f"}],"output":null}],[11,"write_vars","","",379,{"inputs":[{"name":"self"},{"name":"write"},{"name":"livenode"},{"name":"f"}],"output":{"name":"result"}}],[11,"ln_str","","",379,{"inputs":[{"name":"self"},{"name":"livenode"}],"output":{"name":"string"}}],[11,"init_empty","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"livenode"}],"output":null}],[11,"init_from_succ","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"livenode"}],"output":null}],[11,"merge_from_succ","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"livenode"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"define","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"}],"output":null}],[11,"acc","","",379,{"inputs":[{"name":"self"},{"name":"livenode"},{"name":"variable"},{"name":"u32"}],"output":null}],[11,"compute","","",379,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"livenode"}}],[11,"propagate_through_block","","",379,{"inputs":[{"name":"self"},{"name":"block"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"propagate_through_stmt","","",379,{"inputs":[{"name":"self"},{"name":"stmt"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"propagate_through_decl","","",379,{"inputs":[{"name":"self"},{"name":"decl"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"propagate_through_local","","",379,{"inputs":[{"name":"self"},{"name":"local"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"propagate_through_exprs","","",379,null],[11,"propagate_through_opt_expr","","",379,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"option"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"propagate_through_expr","","",379,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"propagate_through_place_components","","",379,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"write_place","","",379,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"livenode"},{"name":"u32"}],"output":{"name":"livenode"}}],[11,"access_var","","",379,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"nodeid"},{"name":"livenode"},{"name":"u32"},{"name":"span"}],"output":{"name":"livenode"}}],[11,"access_path","","",379,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"path"},{"name":"livenode"},{"name":"u32"}],"output":{"name":"livenode"}}],[11,"propagate_through_loop","","",379,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"loopkind"},{"name":"block"},{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"nested_visit_map","","",379,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_local","","",379,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_expr","","",379,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_arm","","",379,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"check_place","","",379,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"should_warn","","",379,{"inputs":[{"name":"self"},{"name":"variable"}],"output":{"generics":["string"],"name":"option"}}],[11,"warn_about_unused_args","","",379,{"inputs":[{"name":"self"},{"name":"body"},{"name":"livenode"}],"output":null}],[11,"warn_about_unused_or_dead_vars_in_pat","","",379,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"warn_about_unused","","",379,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"name":"livenode"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"warn_about_dead_assign","","",379,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"name":"livenode"},{"name":"variable"}],"output":null}],[11,"report_dead_assign","","",379,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"variable"},{"name":"bool"}],"output":null}],[0,"mem_categorization","rustc::middle","Categorization",null,null],[3,"Upvar","rustc::middle::mem_categorization","",null,null],[12,"id","","",383,null],[12,"kind","","",383,null],[3,"FieldIndex","","",null,null],[12,"0","","",384,null],[12,"1","","",384,null],[3,"cmt_","","",null,null],[12,"id","","",385,null],[12,"span","","",385,null],[12,"cat","","",385,null],[12,"mutbl","","",385,null],[12,"ty","","",385,null],[12,"note","","",385,null],[3,"MemCategorizationContext","","",null,null],[12,"tcx","","",386,null],[12,"region_scope_tree","","",386,null],[12,"tables","","",386,null],[12,"rvalue_promotable_map","","",386,null],[12,"infcx","","",386,null],[4,"Categorization","","",null,null],[13,"Rvalue","","",387,null],[13,"StaticItem","","",387,null],[13,"Upvar","","",387,null],[13,"Local","","",387,null],[13,"Deref","","",387,null],[13,"Interior","","",387,null],[13,"Downcast","","",387,null],[4,"PointerKind","","",null,null],[13,"Unique","","`Box<T>`",388,null],[13,"BorrowedPtr","","`&T`",388,null],[13,"UnsafePtr","","`*T`",388,null],[4,"InteriorKind","","",null,null],[13,"InteriorField","","",389,null],[13,"InteriorElement","","",389,null],[4,"InteriorOffsetKind","","",null,null],[13,"Index","","",390,null],[13,"Pattern","","",390,null],[4,"MutabilityCategory","","",null,null],[13,"McImmutable","","",391,null],[13,"McDeclared","","",391,null],[13,"McInherited","","",391,null],[4,"Note","","",null,null],[13,"NoteClosureEnv","","",392,null],[13,"NoteUpvarRef","","",392,null],[13,"NoteIndex","","",392,null],[13,"NoteNone","","",392,null],[4,"ImmutabilityBlame","","",null,null],[13,"ImmLocal","","",393,null],[13,"ClosureEnv","","",393,null],[13,"LocalDeref","","",393,null],[13,"AdtFieldDeref","","",393,null],[4,"Aliasability","","",null,null],[13,"FreelyAliasable","","",394,null],[13,"NonAliasable","","",394,null],[13,"ImmutableUnique","","",394,null],[4,"AliasableReason","","",null,null],[13,"AliasableBorrowed","","",395,null],[13,"AliasableStatic","","",395,null],[13,"AliasableStaticMut","","",395,null],[5,"ptr_sigil","","",null,{"inputs":[{"name":"pointerkind"}],"output":{"name":"str"}}],[6,"cmt","","",null,null],[6,"McResult","","",null,null],[8,"ast_node","","",null,null],[10,"id","","",396,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[10,"span","","",396,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",387,{"inputs":[{"name":"self"}],"output":{"name":"categorization"}}],[11,"fmt","","",387,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",387,{"inputs":[{"name":"self"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",387,{"inputs":[{"name":"self"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",383,{"inputs":[{"name":"self"}],"output":{"name":"upvar"}}],[11,"eq","","",383,{"inputs":[{"name":"self"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",383,{"inputs":[{"name":"self"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",388,{"inputs":[{"name":"self"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",388,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",388,{"inputs":[{"name":"self"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",388,{"inputs":[{"name":"self"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",388,null],[11,"hash","","",388,null],[11,"clone","","",389,{"inputs":[{"name":"self"}],"output":{"name":"interiorkind"}}],[11,"eq","","",389,{"inputs":[{"name":"self"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",389,{"inputs":[{"name":"self"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",389,null],[11,"hash","","",389,null],[11,"clone","","",384,{"inputs":[{"name":"self"}],"output":{"name":"fieldindex"}}],[11,"assert_receiver_is_total_eq","","",384,null],[11,"eq","","",384,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"hash","","",384,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"clone","","",390,{"inputs":[{"name":"self"}],"output":{"name":"interioroffsetkind"}}],[11,"eq","","",390,{"inputs":[{"name":"self"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",390,null],[11,"hash","","",390,null],[11,"fmt","","",390,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",391,{"inputs":[{"name":"self"}],"output":{"name":"mutabilitycategory"}}],[11,"eq","","",391,{"inputs":[{"name":"self"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",391,null],[11,"hash","","",391,null],[11,"fmt","","",391,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",392,{"inputs":[{"name":"self"}],"output":{"name":"note"}}],[11,"eq","","",392,{"inputs":[{"name":"self"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",392,{"inputs":[{"name":"self"},{"name":"note"}],"output":{"name":"bool"}}],[11,"fmt","","",392,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",385,{"inputs":[{"name":"self"}],"output":{"name":"cmt_"}}],[11,"fmt","","",385,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",385,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",385,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"resolve_field","","",385,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"option"}}],[11,"immutability_blame","","",385,{"inputs":[{"name":"self"}],"output":{"generics":["immutabilityblame"],"name":"option"}}],[11,"id","rustc::hir","",57,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"span","","",57,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"id","","",50,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"span","","",50,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",386,{"inputs":[{"name":"self"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",391,{"inputs":[{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",391,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"from_pointer_kind","","",391,{"inputs":[{"name":"mutabilitycategory"},{"name":"pointerkind"}],"output":{"name":"mutabilitycategory"}}],[11,"from_local","","",391,{"inputs":[{"name":"tyctxt"},{"name":"typecktables"},{"name":"nodeid"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",391,{"inputs":[{"name":"self"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",391,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_immutable","","",391,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"to_user_str","","",391,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"new","","",386,{"inputs":[{"name":"tyctxt"},{"name":"scopetree"},{"name":"typecktables"},{"generics":["lrc"],"name":"option"}],"output":{"name":"memcategorizationcontext"}}],[11,"with_infer","","Creates a `MemCategorizationContext` during type inference. This is used during upvar analysis and a few other places. Because the typeck tables are not yet complete, the results from the analysis must be used with caution:",386,{"inputs":[{"name":"inferctxt"},{"name":"scopetree"},{"name":"typecktables"}],"output":{"name":"memcategorizationcontext"}}],[11,"type_moves_by_default","","",386,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"ty"},{"name":"span"}],"output":{"name":"bool"}}],[11,"resolve_type_vars_if_possible","","",386,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"is_tainted_by_errors","","",386,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"resolve_type_vars_or_error","","",386,{"inputs":[{"name":"self"},{"name":"hirid"},{"generics":["ty"],"name":"option"}],"output":{"generics":["ty"],"name":"mcresult"}}],[11,"node_ty","","",386,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["ty"],"name":"mcresult"}}],[11,"expr_ty","","",386,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["ty"],"name":"mcresult"}}],[11,"expr_ty_adjusted","","",386,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["ty"],"name":"mcresult"}}],[11,"pat_ty","","Returns the type of value that this pattern matches against. Some non-obvious cases:",386,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"generics":["ty"],"name":"mcresult"}}],[11,"pat_ty_unadjusted","","Like `pat_ty`, but ignores implicit `&` patterns.",386,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"generics":["ty"],"name":"mcresult"}}],[11,"cat_expr","","",386,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_expr_adjusted","","",386,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cmt_"},{"name":"adjustment"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_expr_adjusted_with","","",386,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"f"},{"name":"adjustment"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_expr_unadjusted","","",386,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_def","","",386,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"ty"},{"name":"def"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_upvar","","",386,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"nodeid"},{"name":"nodeid"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"env_deref","","",386,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"upvarid"},{"name":"mutabilitycategory"},{"name":"borrowkind"},{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`. This could be `'static` if `id` is part of a constant expression.",386,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",386,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"ty"}],"output":{"name":"cmt_"}}],[11,"cat_rvalue","","",386,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"region"},{"name":"ty"}],"output":{"name":"cmt_"}}],[11,"cat_field","","",386,{"inputs":[{"name":"self"},{"name":"n"},{"name":"cmt"},{"name":"usize"},{"name":"name"},{"name":"ty"}],"output":{"name":"cmt_"}}],[11,"cat_overloaded_place","","",386,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"name":"note"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_deref","","",386,null],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",386,{"inputs":[{"name":"self"},{"name":"n"},{"name":"cmt"},{"name":"ty"},{"name":"interioroffsetkind"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"cat_imm_interior","","",386,{"inputs":[{"name":"self"},{"name":"n"},{"name":"cmt"},{"name":"ty"},{"name":"interiorkind"}],"output":{"name":"cmt_"}}],[11,"cat_downcast_if_needed","","",386,{"inputs":[{"name":"self"},{"name":"n"},{"name":"cmt"},{"name":"defid"}],"output":{"name":"cmt"}}],[11,"cat_pattern","","",386,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"pat"},{"name":"f"}],"output":{"name":"mcresult"}}],[11,"cat_pattern_","","",386,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"pat"},{"name":"f"}],"output":{"name":"mcresult"}}],[11,"clone","","",394,{"inputs":[{"name":"self"}],"output":{"name":"aliasability"}}],[11,"fmt","","",394,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",395,{"inputs":[{"name":"self"}],"output":{"name":"aliasablereason"}}],[11,"fmt","","",395,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"guarantor","","Returns `self` after stripping away any derefs or interior content. The return value is basically the `cmt` which determines how long the value in `self` remains live.",385,{"inputs":[{"name":"self"}],"output":{"name":"cmt_"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this place represents a freely aliasable pointer type.",385,{"inputs":[{"name":"self"}],"output":{"name":"aliasability"}}],[11,"upvar_cat","","",385,{"inputs":[{"name":"self"}],"output":{"generics":["categorization"],"name":"option"}}],[11,"descriptive_string","","",385,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"fmt","","",389,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",383,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",383,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"privacy","rustc::middle","A pass that checks to make sure private fields and methods aren't used outside their scopes. This pass will also generate a set of exported items which are available for use externally when compiled as a library.",null,null],[3,"AccessLevels","rustc::middle::privacy","",null,null],[12,"map","","",397,null],[4,"AccessLevel","","",null,null],[13,"Reachable","","",398,null],[13,"Exported","","",398,null],[13,"Public","","",398,null],[6,"ExternalExports","","A set containing all exported definitions from external crates. The set does not contain any entries from local crates.",null,null],[11,"clone","","",398,{"inputs":[{"name":"self"}],"output":{"name":"accesslevel"}}],[11,"fmt","","",398,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",398,{"inputs":[{"name":"self"},{"name":"accesslevel"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",398,null],[11,"partial_cmp","","",398,{"inputs":[{"name":"self"},{"name":"accesslevel"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",398,{"inputs":[{"name":"self"},{"name":"accesslevel"}],"output":{"name":"ordering"}}],[11,"clone","","",397,{"inputs":[{"name":"self"}],"output":{"name":"accesslevels"}}],[11,"is_reachable","","",397,{"inputs":[{"name":"self"},{"name":"id"}],"output":{"name":"bool"}}],[11,"is_exported","","",397,{"inputs":[{"name":"self"},{"name":"id"}],"output":{"name":"bool"}}],[11,"is_public","","",397,{"inputs":[{"name":"self"},{"name":"id"}],"output":{"name":"bool"}}],[11,"default","","",397,{"inputs":[],"output":{"name":"self"}}],[11,"fmt","","",397,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"reachable","rustc::middle","",null,null],[3,"ReachableContext","rustc::middle::reachable","",null,null],[12,"tcx","","",399,null],[12,"tables","","",399,null],[12,"reachable_symbols","","",399,null],[12,"worklist","","",399,null],[12,"any_library","","",399,null],[3,"CollectPrivateImplItemsVisitor","","",null,null],[12,"tcx","","",400,null],[12,"access_levels","","",400,null],[12,"worklist","","",400,null],[3,"ReachableSet","","",null,null],[12,"0","","",401,null],[5,"generics_require_inlining","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[5,"item_might_be_inlined","","",null,{"inputs":[{"name":"item"},{"name":"transfnattrs"}],"output":{"name":"bool"}}],[5,"method_might_be_inlined","","",null,{"inputs":[{"name":"tyctxt"},{"name":"implitem"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"reachable_set","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"reachableset"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[11,"nested_visit_map","","",399,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",399,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_expr","","",399,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"def_id_represents_local_inlined_item","","",399,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"propagate","","",399,{"inputs":[{"name":"self"}],"output":null}],[11,"propagate_node","","",399,{"inputs":[{"name":"self"},{"name":"node"},{"name":"nodeid"}],"output":null}],[11,"visit_item","","",400,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",400,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",400,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"clone","","",401,{"inputs":[{"name":"self"}],"output":{"name":"reachableset"}}],[0,"region","rustc::middle","This file builds up the `ScopeTree`, which describes the parent links in the region hierarchy.",null,null],[3,"Scope","rustc::middle::region","Scope represents a statically-describable scope that can be used to bound the lifetime/region for values.",null,null],[12,"id","","",402,null],[12,"code","","",402,null],[3,"BlockRemainder","","Represents a subscope of `block` for a binding that is introduced by `block.stmts[first_statement_index]`. Such subscopes represent a suffix of the block. Note that each subscope does not include the initializer expression, if any, for the statement indexed by `first_statement_index`.",null,null],[12,"block","","",403,null],[12,"first_statement_index","","",403,null],[3,"FirstStatementIndex","","",null,null],[12,"0","","",404,null],[3,"ScopeTree","","The region scope tree encodes information about region relationships.",null,null],[12,"root_body","","If not empty, this body is the root of this region hierarchy.",405,null],[12,"root_parent","","The parent of the root body owner, if the latter is an an associated const or method, as impls/traits can also have lifetime parameters free in this body.",405,null],[12,"parent_map","","`parent_map` maps from a scope id to the enclosing scope id; this is usually corresponding to the lexical nesting, though in the case of closures the parent scope is the innermost conditional expression or repeating block. (Note that the enclosing scope id for the block associated with a closure is the closure itself.)",405,null],[12,"var_map","","`var_map` maps from a variable or binding id to the block in which that variable is declared.",405,null],[12,"destruction_scopes","","maps from a node-id to the associated destruction scope (if any)",405,null],[12,"rvalue_scopes","","`rvalue_scopes` includes entries for those expressions whose cleanup scope is larger than the default. The map goes from the expression id to the cleanup scope id. For rvalues not present in this table, the appropriate cleanup scope is the innermost enclosing statement, conditional expression, or repeating block (see `terminating_scopes`). In constants, None is used to indicate that certain expressions escape into 'static and should have no local cleanup scope.",405,null],[12,"closure_tree","","Encodes the hierarchy of fn bodies. Every fn body (including closures) forms its own distinct region hierarchy, rooted in the block that is the fn body. This map points from the id of that root block to the id of the root block for the enclosing fn, if any. Thus the map structures the fn bodies into a hierarchy based on their lexical mapping. This is used to handle the relationships between regions in a fn and in a closure defined by that fn. See the \"Modeling closures\" section of the README in infer::region_constraints for more details.",405,null],[12,"yield_in_scope","","If there are any `yield` nested within a scope, this map stores the `Span` of the last one and its index in the postorder of the Visitor traversal on the HIR.",405,null],[12,"body_expr_count","","The number of visit_expr and visit_pat calls done in the body. Used to sanity check visit_expr/visit_pat call count when calculating generator interiors.",405,null],[3,"Context","","",null,null],[12,"root_id","","the root of the current region tree. This is typically the id of the innermost fn body. Each fn forms its own disjoint tree in the region hierarchy. These fn bodies are themselves arranged into a tree. See the \"Modeling closures\" section of the README in infer::region_constraints for more details.",406,null],[12,"var_parent","","the scope that contains any new variables declared",406,null],[12,"parent","","region parent of expressions etc",406,null],[3,"RegionResolutionVisitor","","",null,null],[12,"tcx","","",407,null],[12,"expr_and_pat_count","","",407,null],[12,"scope_tree","","",407,null],[12,"cx","","",407,null],[12,"terminating_scopes","","`terminating_scopes` is a set containing the ids of each statement, or conditional/repeating expression. These scopes are calling \"terminating scopes\" because, when attempting to find the scope of a temporary, by default we search up the enclosing scopes until we encounter the terminating scope. A conditional/repeating expression is one which is not guaranteed to execute exactly once upon entering the parent scope. This could be because the expression only executes conditionally, such as the expression `b` in `a && b`, or because the expression may execute many times, such as a loop body. The reason that we distinguish such expressions is that, upon exiting the parent scope, we cannot statically know how many times the expression executed, and thus if the expression creates temporaries we cannot know statically how many such temporaries we would have to cleanup. Therefore we ensure that the temporaries never outlast the conditional/repeating expression, preventing the need for dynamic checks and/or arbitrary amounts of stack space. Terminating scopes end up being contained in a DestructionScope that contains the destructor's execution.",407,null],[3,"ExprLocatorVisitor","","",null,null],[12,"id","","",408,null],[12,"result","","",408,null],[12,"expr_and_pat_count","","",408,null],[4,"ScopeData","","",null,null],[13,"Node","","",409,null],[13,"CallSite","","",409,null],[13,"Arguments","","",409,null],[13,"Destruction","","",409,null],[13,"Remainder","","",409,null],[5,"record_var_lifetime","","Records the lifetime of a local variable as `cx.var_parent`",null,{"inputs":[{"name":"regionresolutionvisitor"},{"name":"itemlocalid"},{"name":"span"}],"output":null}],[5,"resolve_block","","",null,{"inputs":[{"name":"regionresolutionvisitor"},{"name":"block"}],"output":null}],[5,"resolve_arm","","",null,{"inputs":[{"name":"regionresolutionvisitor"},{"name":"arm"}],"output":null}],[5,"resolve_pat","","",null,{"inputs":[{"name":"regionresolutionvisitor"},{"name":"pat"}],"output":null}],[5,"resolve_stmt","","",null,{"inputs":[{"name":"regionresolutionvisitor"},{"name":"stmt"}],"output":null}],[5,"resolve_expr","","",null,{"inputs":[{"name":"regionresolutionvisitor"},{"name":"expr"}],"output":null}],[5,"resolve_local","","",null,{"inputs":[{"name":"regionresolutionvisitor"},{"generics":["pat"],"name":"option"},{"generics":["expr"],"name":"option"}],"output":null}],[5,"region_scope_tree","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["scopetree"],"name":"lrc"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[17,"SCOPE_DATA_NODE","","",null,null],[17,"SCOPE_DATA_CALLSITE","","",null,null],[17,"SCOPE_DATA_ARGUMENTS","","",null,null],[17,"SCOPE_DATA_DESTRUCTION","","",null,null],[17,"SCOPE_DATA_REMAINDER_MAX","","",null,null],[11,"clone","","",402,{"inputs":[{"name":"self"}],"output":{"name":"scope"}}],[11,"eq","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"ne","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"le","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"gt","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"ge","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",402,null],[11,"cmp","","",402,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"ordering"}}],[11,"hash","","",402,null],[11,"encode","","",402,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",402,{"inputs":[{"name":"__d"}],"output":{"generics":["scope"],"name":"result"}}],[11,"clone","","",409,{"inputs":[{"name":"self"}],"output":{"name":"scopedata"}}],[11,"eq","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"bool"}}],[11,"ne","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"bool"}}],[11,"le","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"bool"}}],[11,"gt","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"bool"}}],[11,"ge","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",409,null],[11,"cmp","","",409,{"inputs":[{"name":"self"},{"name":"scopedata"}],"output":{"name":"ordering"}}],[11,"hash","","",409,null],[11,"fmt","","",409,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",409,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",409,{"inputs":[{"name":"__d"}],"output":{"generics":["scopedata"],"name":"result"}}],[11,"clone","","",403,{"inputs":[{"name":"self"}],"output":{"name":"blockremainder"}}],[11,"eq","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",403,null],[11,"cmp","","",403,{"inputs":[{"name":"self"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"hash","","",403,null],[11,"encode","","",403,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",403,{"inputs":[{"name":"__d"}],"output":{"generics":["blockremainder"],"name":"result"}}],[11,"fmt","","",403,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",404,{"inputs":[{"name":"self"}],"output":{"name":"firststatementindex"}}],[11,"eq","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"bool"}}],[11,"ne","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",404,null],[11,"hash","","",404,null],[11,"partial_cmp","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"bool"}}],[11,"le","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"bool"}}],[11,"gt","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"bool"}}],[11,"ge","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"bool"}}],[11,"cmp","","",404,{"inputs":[{"name":"self"},{"name":"firststatementindex"}],"output":{"name":"ordering"}}],[11,"decode","","",404,{"inputs":[{"name":"__d"}],"output":{"generics":["firststatementindex"],"name":"result"}}],[11,"encode","","",404,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",404,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",404,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",404,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",402,{"inputs":[{"name":"scopedata"}],"output":{"name":"self"}}],[11,"fmt","","",402,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"data","","",402,{"inputs":[{"name":"self"}],"output":{"name":"scopedata"}}],[11,"Node","","",402,{"inputs":[{"name":"itemlocalid"}],"output":{"name":"self"}}],[11,"CallSite","","",402,{"inputs":[{"name":"itemlocalid"}],"output":{"name":"self"}}],[11,"Arguments","","",402,{"inputs":[{"name":"itemlocalid"}],"output":{"name":"self"}}],[11,"Destruction","","",402,{"inputs":[{"name":"itemlocalid"}],"output":{"name":"self"}}],[11,"Remainder","","",402,{"inputs":[{"name":"blockremainder"}],"output":{"name":"self"}}],[11,"item_local_id","","Returns a item-local id associated with this scope.",402,{"inputs":[{"name":"self"}],"output":{"name":"itemlocalid"}}],[11,"node_id","","",402,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"scopetree"}],"output":{"name":"nodeid"}}],[11,"span","","Returns the span of this Scope.  Note that in general the returned span may not correspond to the span of any node id in the AST.",402,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"scopetree"}],"output":{"name":"span"}}],[11,"default","","",405,{"inputs":[],"output":{"name":"scopetree"}}],[11,"fmt","","",405,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",406,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",406,{"inputs":[{"name":"self"}],"output":{"name":"context"}}],[11,"nested_visit_map","","",408,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_pat","","",408,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",408,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"record_scope_parent","","",405,{"inputs":[{"name":"self"},{"name":"scope"},{"generics":["scope"],"name":"option"}],"output":null}],[11,"each_encl_scope","","",405,{"inputs":[{"name":"self"},{"name":"e"}],"output":null}],[11,"each_var_scope","","",405,{"inputs":[{"name":"self"},{"name":"e"}],"output":null}],[11,"opt_destruction_scope","","",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"generics":["scope"],"name":"option"}}],[11,"record_closure_parent","","Records that `sub_closure` is defined within `sup_closure`. These ids should be the id of the block that is the fn body, which is also the root of the region hierarchy for that fn.",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"itemlocalid"}],"output":null}],[11,"closure_is_enclosed_by","","",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"itemlocalid"}],"output":{"name":"bool"}}],[11,"record_var_scope","","",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"scope"}],"output":null}],[11,"record_rvalue_scope","","",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"generics":["scope"],"name":"option"}],"output":null}],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",405,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"generics":["scope"],"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",405,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"scope"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"scope"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"generics":["scope"],"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",405,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"name":"regionkind"}}],[11,"scopes_intersect","","",405,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false otherwise.",405,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"scope"}],"output":{"name":"bool"}}],[11,"containing_body","","Returns the id of the innermost containing body",405,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"generics":["itemlocalid"],"name":"option"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest scope which is greater than or equal to both `scope_a` and `scope_b`.",405,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"scope"}],"output":{"name":"scope"}}],[11,"early_free_scope","","Assuming that the provided region was defined within this `ScopeTree`, returns the outermost `Scope` that the region outlives.",405,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"earlyboundregion"}],"output":{"name":"scope"}}],[11,"free_scope","","Assuming that the provided region was defined within this `ScopeTree`, returns the outermost `Scope` that the region outlives.",405,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"freeregion"}],"output":{"name":"scope"}}],[11,"yield_in_scope","","Checks whether the given scope contains a `yield`. If so, returns `Some((span, expr_count))` with the span of a yield we found and the number of expressions and patterns appearing before the `yield` in the body + 1. If there a are multiple yields in a scope, the one with the highest number is returned.",405,{"inputs":[{"name":"self"},{"name":"scope"}],"output":{"name":"option"}}],[11,"yield_in_scope_for_expr","","Checks whether the given scope contains a `yield` and if that yield could execute after `expr`. If so, it returns the span of that `yield`. `scope` must be inside the body.",405,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"nodeid"},{"name":"body"}],"output":{"generics":["span"],"name":"option"}}],[11,"body_expr_count","","Gives the number of expressions visited in a body. Used to sanity check visit_expr call count when calculating generator interiors.",405,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"generics":["usize"],"name":"option"}}],[11,"record_child_scope","","Records the current parent (if any) as the parent of `child_scope`.",407,{"inputs":[{"name":"self"},{"name":"scope"}],"output":null}],[11,"enter_scope","","Records the current parent (if any) as the parent of `child_scope`, and sets `child_scope` as the new current parent.",407,{"inputs":[{"name":"self"},{"name":"scope"}],"output":null}],[11,"enter_node_scope_with_dtor","","",407,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":null}],[11,"nested_visit_map","","",407,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_block","","",407,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_body","","",407,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"visit_arm","","",407,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",407,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_stmt","","",407,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_expr","","",407,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_local","","",407,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"hash_stable","","",405,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"recursion_limit","rustc::middle","",null,null],[5,"update_limits","rustc::middle::recursion_limit","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":null}],[5,"update_limit","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"once"},{"name":"str"},{"name":"str"},{"name":"usize"}],"output":null}],[0,"resolve_lifetime","rustc::middle","Name resolution for lifetimes.",null,null],[3,"NamedRegionMap","rustc::middle::resolve_lifetime","Maps the id of each lifetime reference to the lifetime decl that it corresponds to.",null,null],[12,"defs","","",410,null],[12,"late_bound","","",410,null],[12,"object_lifetime_defaults","","",410,null],[3,"ResolveLifetimes","","See `NamedRegionMap`.",null,null],[12,"defs","","",411,null],[12,"late_bound","","",411,null],[12,"object_lifetime_defaults","","",411,null],[3,"LifetimeContext","","",null,null],[12,"tcx","","",412,null],[12,"map","","",412,null],[12,"scope","","",412,null],[12,"trait_ref_hack","","",412,null],[12,"is_in_fn_syntax","","",412,null],[12,"labels_in_fn","","",412,null],[12,"xcrate_object_lifetime_defaults","","",412,null],[12,"lifetime_uses","","",412,null],[3,"ElisionFailureInfo","","",null,null],[12,"parent","","Where we can find the argument pattern.",413,null],[12,"index","","The index of the argument in the original definition.",413,null],[12,"lifetime_count","","",413,null],[12,"have_bound_regions","","",413,null],[3,"Original","","",null,null],[12,"kind","","",414,null],[12,"span","","",414,null],[3,"Shadower","","",null,null],[12,"kind","","",415,null],[12,"span","","",415,null],[4,"LifetimeDefOrigin","","The origin of a named lifetime definition.",null,null],[13,"Explicit","","",416,null],[13,"InBand","","",416,null],[4,"LifetimeUseSet","","",null,null],[13,"One","","",417,null],[13,"Many","","",417,null],[4,"Region","","",null,null],[13,"Static","","",418,null],[13,"EarlyBound","","",418,null],[13,"LateBound","","",418,null],[13,"LateBoundAnon","","",418,null],[13,"Free","","",418,null],[4,"Set1","","A set containing, at most, one known element. If two distinct values are inserted into a set, then it becomes `Many`, which can be used to detect ambiguities.",null,null],[13,"Empty","","",419,null],[13,"One","","",419,null],[13,"Many","","",419,null],[4,"Scope","","",null,null],[13,"Binder","","Declares lifetimes, and each can be early-bound or late-bound. The `DebruijnIndex` of late-bound lifetimes starts at `1` and it should be shifted by the number of `Binder`s in between the declaration `Binder` and the location it's referenced from.",420,null],[12,"lifetimes","rustc::middle::resolve_lifetime::Scope","",420,null],[12,"next_early_index","","if we extend this scope with another scope, what is the next index we should use for an early-bound region?",420,null],[12,"abstract_type_parent","","Whether or not this binder would serve as the parent binder for abstract types introduced within. For example:",420,null],[12,"s","","",420,null],[13,"Body","rustc::middle::resolve_lifetime","Lifetimes introduced by a fn are scoped to the call-site for that fn, if this is a fn body, otherwise the original definitions are used. Unspecified lifetimes are inferred, unless an elision scope is nested, e.g. `(&T, fn(&T) -> &T);` becomes `(&'_ T, for<'a> fn(&'a T) -> &'a T)`.",420,null],[12,"id","rustc::middle::resolve_lifetime::Scope","",420,null],[12,"s","","",420,null],[13,"Elision","rustc::middle::resolve_lifetime","A scope which either determines unspecified lifetimes or errors on them (e.g. due to ambiguity). For more details, see `Elide`.",420,null],[12,"elide","rustc::middle::resolve_lifetime::Scope","",420,null],[12,"s","","",420,null],[13,"ObjectLifetimeDefault","rustc::middle::resolve_lifetime","Use a specific lifetime (if `Some`) or leave it unset (to be inferred in a function body or potentially error outside one), for the default choice of lifetime in a trait object type.",420,null],[12,"lifetime","rustc::middle::resolve_lifetime::Scope","",420,null],[12,"s","","",420,null],[13,"Root","rustc::middle::resolve_lifetime","",420,null],[4,"Elide","","",null,null],[13,"FreshLateAnon","","Use a fresh anonymous late-bound lifetime each time, by incrementing the counter to generate sequential indices.",421,null],[13,"Exact","","Always use this one lifetime.",421,null],[13,"Error","","Less or more than one lifetime were found, error on unspecified.",421,null],[4,"ShadowKind","","",null,null],[13,"Label","","",422,null],[13,"Lifetime","","",422,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"resolve_lifetimes","","Computes the `ResolveLifetimes` map that contains data for the entire crate. You should not read the result of this query directly, but rather use `named_region_map`, `is_late_bound_map`, etc.",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["resolvelifetimes"],"name":"lrc"}}],[5,"krate","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"name":"namedregionmap"}}],[5,"original_label","","",null,{"inputs":[{"name":"span"}],"output":{"name":"original"}}],[5,"shadower_label","","",null,{"inputs":[{"name":"span"}],"output":{"name":"shadower"}}],[5,"original_lifetime","","",null,{"inputs":[{"name":"span"}],"output":{"name":"original"}}],[5,"shadower_lifetime","","",null,{"inputs":[{"name":"lifetime"}],"output":{"name":"shadower"}}],[5,"check_mixed_explicit_and_in_band_defs","","",null,null],[5,"signal_shadowing_problem","","",null,{"inputs":[{"name":"tyctxt"},{"name":"name"},{"name":"original"},{"name":"shadower"}],"output":null}],[5,"extract_labels","","",null,{"inputs":[{"name":"lifetimecontext"},{"name":"body"}],"output":null}],[5,"compute_object_lifetime_defaults","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["vec"],"name":"nodemap"}}],[5,"object_lifetime_defaults_for_item","","Scan the bounds and where-clauses on parameters to extract bounds of the form `T:'a` so as to determine the `ObjectLifetimeDefault` for each type parameter.",null,{"inputs":[{"name":"tyctxt"},{"name":"generics"}],"output":{"generics":["objectlifetimedefault"],"name":"vec"}}],[5,"insert_late_bound_lifetimes","","Detects late-bound lifetimes and inserts them into `map.late_bound`.",null,{"inputs":[{"name":"namedregionmap"},{"name":"fndecl"},{"name":"generics"}],"output":null}],[5,"report_missing_lifetime_specifiers","","",null,{"inputs":[{"name":"session"},{"name":"span"},{"name":"usize"}],"output":{"name":"diagnosticbuilder"}}],[6,"ObjectLifetimeDefault","","",null,null],[6,"ScopeRef","","",null,null],[17,"ROOT_SCOPE","","",null,null],[11,"clone","","",416,{"inputs":[{"name":"self"}],"output":{"name":"lifetimedeforigin"}}],[11,"eq","","",416,{"inputs":[{"name":"self"},{"name":"lifetimedeforigin"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",416,null],[11,"hash","","",416,null],[11,"encode","","",416,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",416,{"inputs":[{"name":"__d"}],"output":{"generics":["lifetimedeforigin"],"name":"result"}}],[11,"fmt","","",416,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_is_in_band","","",416,{"inputs":[{"name":"bool"}],"output":{"name":"self"}}],[11,"clone","","",417,{"inputs":[{"name":"self"}],"output":{"name":"lifetimeuseset"}}],[11,"fmt","","",417,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",418,{"inputs":[{"name":"self"}],"output":{"name":"region"}}],[11,"eq","","",418,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",418,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",418,null],[11,"hash","","",418,null],[11,"encode","","",418,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",418,{"inputs":[{"name":"__d"}],"output":{"generics":["region"],"name":"result"}}],[11,"fmt","","",418,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"early","","",418,null],[11,"late","","",418,null],[11,"late_anon","","",418,{"inputs":[{"name":"cell"}],"output":{"name":"region"}}],[11,"id","","",418,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"shifted","","",418,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"region"}}],[11,"from_depth","","",418,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"region"}}],[11,"subst","","",418,null],[11,"clone","","",419,{"inputs":[{"name":"self"}],"output":{"name":"set1"}}],[11,"eq","","",419,{"inputs":[{"name":"self"},{"name":"set1"}],"output":{"name":"bool"}}],[11,"ne","","",419,{"inputs":[{"name":"self"},{"name":"set1"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",419,null],[11,"encode","","",419,{"inputs":[{"name":"self"},{"name":"__st"}],"output":{"name":"result"}}],[11,"decode","","",419,{"inputs":[{"name":"__dt"}],"output":{"generics":["set1"],"name":"result"}}],[11,"fmt","","",419,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"insert","","",419,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"default","","",410,{"inputs":[],"output":{"name":"namedregionmap"}}],[11,"hash_stable","","",411,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"fmt","","",420,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",421,{"inputs":[{"name":"self"}],"output":{"name":"elide"}}],[11,"fmt","","",421,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",413,{"inputs":[{"name":"self"}],"output":{"name":"elisionfailureinfo"}}],[11,"fmt","","",413,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"nested_visit_map","","",412,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_item","","",412,{"inputs":[{"name":"self"},{"name":"itemid"}],"output":null}],[11,"visit_nested_body","","",412,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_item","","",412,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",412,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_ty","","",412,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_trait_item","","",412,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",412,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_lifetime","","",412,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_path","","",412,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_fn_decl","","",412,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":null}],[11,"visit_generics","","",412,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_poly_trait_ref","","",412,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"clone","","",422,{"inputs":[{"name":"self"}],"output":{"name":"shadowkind"}}],[11,"eq","","",422,{"inputs":[{"name":"self"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"desc","","",422,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"hack","","",412,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"with","","",412,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"f"}],"output":null}],[11,"visit_early_late","","Visits self by adding a scope and handling recursive walk over the contents with `walk`.",412,{"inputs":[{"name":"self"},{"generics":["nodeid"],"name":"option"},{"name":"fndecl"},{"name":"generics"},{"name":"f"}],"output":null}],[11,"next_early_index_helper","","",412,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"u32"}}],[11,"next_early_index","","Returns the next index one would use for an early-bound-region if extending the current scope.",412,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"next_early_index_for_abstract_type","","Returns the next index one would use for an `impl Trait` that is being converted into an `abstract type`. This will be the next early index from the enclosing item, for the most part. See the `abstract_type_parent` field for more info.",412,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"resolve_lifetime_ref","","",412,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_segment_parameters","","",412,{"inputs":[{"name":"self"},{"name":"def"},{"name":"usize"},{"name":"pathparameters"}],"output":null}],[11,"visit_fn_like_elision","","",412,null],[11,"resolve_elided_lifetimes","","",412,null],[11,"report_elision_failure","","",412,null],[11,"resolve_object_lifetime_default","","",412,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"check_lifetime_params","","",412,null],[11,"check_lifetime_def_for_shadowing","","",412,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"lifetime"}],"output":null}],[11,"insert_lifetime","","",412,{"inputs":[{"name":"self"},{"name":"lifetime"},{"name":"region"}],"output":null}],[0,"stability","rustc::middle","A pass that annotates every item and method with its stability level, propagating default levels lexically from parent to children ast nodes.",null,null],[3,"DeprecationEntry","rustc::middle::stability","An entry in the `depr_map`.",null,null],[12,"attr","","The metadata of the attribute associated with this entry.",423,null],[12,"origin","","The def id where the attr was originally attached. `None` for non-local `DefId`'s.",423,null],[3,"Index","","A stability index, giving the stability level for items and methods.",null,null],[12,"stab_map","","This is mostly a cache, except the stabilities of local items are filled by the annotator.",424,null],[12,"depr_map","","",424,null],[12,"staged_api","","Maps for each crate whether it is part of the staged API.",424,null],[12,"active_features","","Features enabled for this crate.",424,null],[3,"Annotator","","",null,null],[12,"tcx","","",425,null],[12,"index","","",425,null],[12,"parent_stab","","",425,null],[12,"parent_depr","","",425,null],[12,"in_trait_impl","","",425,null],[3,"MissingStabilityAnnotations","","",null,null],[12,"tcx","","",426,null],[12,"access_levels","","",426,null],[3,"Checker","","",null,null],[12,"tcx","","",427,null],[4,"StabilityLevel","","",null,null],[13,"Unstable","","",428,null],[13,"Stable","","",428,null],[4,"AnnotationKind","","",null,null],[13,"Required","","",429,null],[13,"Prohibited","","",429,null],[13,"Container","","",429,null],[4,"EvalResult","","Result of `TyCtxt::eval_stability`.",null,null],[13,"Allow","","We can use the item because it is stable or we provided the corresponding feature gate.",430,null],[13,"Deny","","We cannot use the item because it is unstable and we did not provide the corresponding feature gate.",430,null],[12,"feature","rustc::middle::stability::EvalResult","",430,null],[12,"reason","","",430,null],[12,"issue","","",430,null],[13,"Unmarked","rustc::middle::stability","The item does not have the `#[stable]` or `#[unstable]` marker assigned.",430,null],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled features and possibly prints errors.",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"deprecation_in_effect","","Check whether an item marked with `deprecated(since=\"X\")` is currently deprecated (i.e. whether X is not greater than the current rustc version).",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that were expected to be library features), and the list of features used from libraries, identify activated features that don't exist and error about them.",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"format_stable_since_msg","","",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"encode","","",428,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",428,{"inputs":[{"name":"__d"}],"output":{"generics":["stabilitylevel"],"name":"result"}}],[11,"eq","","",428,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",428,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"clone","","",428,{"inputs":[{"name":"self"}],"output":{"name":"stabilitylevel"}}],[11,"fmt","","",428,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",428,null],[11,"hash","","",428,null],[11,"from_attr_level","","",428,{"inputs":[{"name":"stabilitylevel"}],"output":{"name":"self"}}],[11,"eq","","",429,{"inputs":[{"name":"self"},{"name":"annotationkind"}],"output":{"name":"bool"}}],[11,"clone","","",423,{"inputs":[{"name":"self"}],"output":{"name":"deprecationentry"}}],[11,"hash_stable","","",423,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"local","","",423,{"inputs":[{"name":"deprecation"},{"name":"hirid"}],"output":{"name":"deprecationentry"}}],[11,"external","","",423,{"inputs":[{"name":"deprecation"}],"output":{"name":"deprecationentry"}}],[11,"same_origin","","",423,{"inputs":[{"name":"self"},{"name":"deprecationentry"}],"output":{"name":"bool"}}],[11,"hash_stable","","",424,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"annotate","","",425,null],[11,"nested_visit_map","","Because stability levels are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",425,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",425,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",425,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",425,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_variant","","",425,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",425,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_foreign_item","","",425,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_macro_def","","",425,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"check_missing_stability","","",426,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"nested_visit_map","","",426,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",426,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",426,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",426,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_variant","","",426,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",426,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_foreign_item","","",426,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_macro_def","","",426,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"new","","",424,{"inputs":[{"name":"tyctxt"}],"output":{"name":"index"}}],[11,"local_stability","","",424,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["stability"],"name":"option"}}],[11,"local_deprecation_entry","","",424,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["deprecationentry"],"name":"option"}}],[11,"nested_visit_map","","Because stability levels are scoped lexically, we want to walk nested items in the context of the outer item, so enable deep-walking.",427,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",427,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_path","","",427,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[0,"weak_lang_items","rustc::middle","Validity checking for weak lang items",null,null],[3,"Context","rustc::middle::weak_lang_items","",null,null],[12,"tcx","","",431,null],[12,"items","","",431,null],[5,"check_crate","","Checks the crate for usage of weak lang items, returning a vector of all the language items required by this crate, but not defined yet.",null,{"inputs":[{"name":"tyctxt"},{"name":"languageitems"}],"output":null}],[5,"link_name","","",null,null],[5,"whitelisted","","Returns whether the specified `lang_item` doesn't actually need to be present for this compilation.",null,{"inputs":[{"name":"tyctxt"},{"name":"langitem"}],"output":{"name":"bool"}}],[5,"verify","","",null,{"inputs":[{"name":"tyctxt"},{"name":"languageitems"}],"output":null}],[11,"register","","",431,{"inputs":[{"name":"self"},{"name":"str"},{"name":"span"}],"output":null}],[11,"nested_visit_map","","",431,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_foreign_item","","",431,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[0,"mir","rustc","MIR datatypes and passes. See the [rustc guide] for more info.",null,null],[3,"Mir","rustc::mir","Lowered representation of a single function.",null,null],[12,"basic_blocks","","List of basic blocks. References to basic block use a newtyped index type `BasicBlock` that indexes into this vector.",432,null],[12,"visibility_scopes","","List of visibility (lexical) scopes; these are referenced by statements and used (eventually) for debuginfo. Indexed by a `VisibilityScope`.",432,null],[12,"visibility_scope_info","","Crate-local information for each visibility scope, that can't (and needn't) be tracked across crates.",432,null],[12,"promoted","","Rvalues promoted from this function, such as borrows of constants. Each of them is the Mir of a constant with the fn's type parameters in scope, but a separate set of locals.",432,null],[12,"yield_ty","","Yield type of the function, if it is a generator.",432,null],[12,"generator_drop","","Generator drop glue",432,null],[12,"generator_layout","","The layout of a generator. Produced by the state transformation.",432,null],[12,"local_decls","","Declarations of locals.",432,null],[12,"arg_count","","Number of arguments this function takes.",432,null],[12,"upvar_decls","","Names and capture modes of all the closure upvars, assuming the first argument is either the closure or a reference to it.",432,null],[12,"spread_arg","","Mark an argument local (which must be a tuple) as getting passed as its individual components at the LLVM level.",432,null],[12,"span","","A span representing this MIR, for error reporting",432,null],[12,"cache","","A cache for various calculations",432,null],[3,"VisibilityScopeInfo","","",null,null],[12,"lint_root","","A NodeId with lint levels equivalent to this scope's lint levels.",433,null],[12,"safety","","The unsafe block that contains this node.",433,null],[3,"SourceInfo","","Grouped information about the source code origin of a MIR entity. Intended to be inspected by diagnostics and debuginfo. Most passes can work with it as a whole, within a single function.",null,null],[12,"span","","Source span for the AST pertaining to this MIR entity.",434,null],[12,"scope","","The lexical visibility scope, i.e. which bindings can be seen.",434,null],[3,"Local","","",null,null],[12,"0","","",435,null],[3,"LocalDecl","","A MIR local.",null,null],[12,"mutability","","`let mut x` vs `let x`.",436,null],[12,"is_user_variable","","True if this corresponds to a user-declared local variable.",436,null],[12,"internal","","True if this is an internal local",436,null],[12,"ty","","Type of this local.",436,null],[12,"name","","Name of the local, used in debuginfo and pretty-printing.",436,null],[12,"source_info","","Source info of the local.",436,null],[12,"syntactic_scope","","The syntactic visibility scope the local is defined in. If the local was defined in a let-statement, this is within the let-statement, rather than outside of it.",436,null],[3,"UpvarDecl","","A closure capture, with its name and mode.",null,null],[12,"debug_name","","",437,null],[12,"by_ref","","If true, the capture is behind a reference.",437,null],[12,"mutability","","",437,null],[3,"BasicBlock","","",null,null],[12,"0","","",438,null],[3,"BasicBlockData","","",null,null],[12,"statements","","List of statements in this block.",439,null],[12,"terminator","","Terminator for this block.",439,null],[12,"is_cleanup","","If true, this block lies on an unwind path. This is used during trans where distinct kinds of basic blocks may be generated (particularly for MSVC cleanup). Unwind blocks must only branch to other unwind blocks.",439,null],[3,"Terminator","","",null,null],[12,"source_info","","",440,null],[12,"kind","","",440,null],[3,"Statement","","",null,null],[12,"source_info","","",441,null],[12,"kind","","",441,null],[3,"ValidationOperand","","",null,null],[12,"place","","",442,null],[12,"ty","","",442,null],[12,"re","","",442,null],[12,"mutbl","","",442,null],[3,"Static","","The def-id of a static, along with its normalized type (which is stored to avoid requiring normalization when reading MIR).",null,null],[12,"def_id","","",443,null],[12,"ty","","",443,null],[3,"Projection","","The `Projection` data structure defines things of the form `B.x` or `*B` or `B[index]`. Note that it is parameterized because it is shared between `Constant` and `Place`. See the aliases `PlaceProjection` etc below.",null,null],[12,"base","","",444,null],[12,"elem","","",444,null],[3,"Field","","",null,null],[12,"0","","",445,null],[3,"VisibilityScope","","",null,null],[12,"0","","",446,null],[3,"VisibilityScopeData","","",null,null],[12,"span","","",447,null],[12,"parent_scope","","",447,null],[3,"Constant","","Constants",null,null],[12,"span","","",448,null],[12,"ty","","",448,null],[12,"literal","","",448,null],[3,"Promoted","","",null,null],[12,"0","","",449,null],[3,"Location","","",null,null],[12,"block","","the location is within this block",450,null],[12,"statement_index","","the location is the start of the statement; or, if `statement_index` == num-statements, then the start of the terminator.",450,null],[3,"UnsafetyViolation","","",null,null],[12,"source_info","","",451,null],[12,"description","","",451,null],[12,"kind","","",451,null],[3,"UnsafetyCheckResult","","",null,null],[12,"violations","","Violations that are propagated upwards from this function",452,null],[12,"unsafe_blocks","","unsafe blocks in this function, along with whether they are used. This is used for the \"unused_unsafe\" lint.",452,null],[3,"GeneratorLayout","","The layout of generator state",null,null],[12,"fields","","",453,null],[3,"BorrowCheckResult","","",null,null],[12,"closure_requirements","","",454,null],[12,"used_mut_upvars","","",454,null],[3,"ClosureRegionRequirements","","After we borrow check a closure, we are left with various requirements that we have inferred between the free regions that appear in the closure's signature or on its field types.  These requirements are then verified and proved by the closure's creating function. This struct encodes those requirements.",null,null],[12,"num_external_vids","","The number of external regions defined on the closure.  In our example above, it would be 3 -- one for `'static`, then `'1` and `'2`. This is just used for a sanity check later on, to make sure that the number of regions we see at the callsite matches.",455,null],[12,"outlives_requirements","","Requirements between the various free regions defined in indices.",455,null],[3,"ClosureOutlivesRequirement","","Indicates an outlives constraint between a type or between two free-regions declared on the closure.",null,null],[12,"subject","","",456,null],[12,"outlived_free_region","","",456,null],[12,"blame_span","","",456,null],[4,"Safety","","",null,null],[13,"Safe","","",457,null],[13,"BuiltinUnsafe","","Unsafe because of a PushUnsafeBlock",457,null],[13,"FnUnsafe","","Unsafe because of an unsafe fn",457,null],[13,"ExplicitUnsafe","","Unsafe because of an `unsafe` block",457,null],[4,"ClearCrossCrate","","",null,null],[13,"Clear","","",458,null],[13,"Set","","",458,null],[4,"Mutability","","",null,null],[13,"Mut","","",459,null],[13,"Not","","",459,null],[4,"BorrowKind","","",null,null],[13,"Shared","","Data must be immutable and is aliasable.",460,null],[13,"Unique","","Data must be immutable but not aliasable.  This kind of borrow cannot currently be expressed by the user and is used only in implicit closure bindings. It is needed when you the closure is borrowing or mutating a mutable referent, e.g.:",460,null],[13,"Mut","","Data is mutable and not aliasable.",460,null],[12,"allow_two_phase_borrow","rustc::mir::BorrowKind","True if this borrow arose from method-call auto-ref (i.e. `adjustment::Adjust::Borrow`)",460,null],[4,"LocalKind","rustc::mir","Classifies locals into categories. See `Mir::local_kind`.",null,null],[13,"Var","","User-declared variable binding",461,null],[13,"Temp","","Compiler-introduced temporary",461,null],[13,"Arg","","Function argument",461,null],[13,"ReturnPointer","","Location of function's return value",461,null],[4,"TerminatorKind","","",null,null],[13,"Goto","","block should have one successor in the graph; we jump there",462,null],[12,"target","rustc::mir::TerminatorKind","",462,null],[13,"SwitchInt","rustc::mir","operand evaluates to an integer; jump depending on its value to one of the targets, and otherwise fallback to `otherwise`",462,null],[12,"discr","rustc::mir::TerminatorKind","discriminant value being tested",462,null],[12,"switch_ty","","type of value being tested",462,null],[12,"values","","Possible values. The locations to branch to in each case are found in the corresponding indices from the `targets` vector.",462,null],[12,"targets","","Possible branch sites. The last element of this vector is used for the otherwise branch, so targets.len() == values.len() + 1 should hold.",462,null],[13,"Resume","rustc::mir","Indicates that the landing pad is finished and unwinding should continue. Emitted by build::scope::diverge_cleanup.",462,null],[13,"Abort","","Indicates that the landing pad is finished and that the process should abort. Used to prevent unwinding for foreign items.",462,null],[13,"Return","","Indicates a normal return. The return place should have been filled in by now. This should occur at most once.",462,null],[13,"Unreachable","","Indicates a terminator that can never be reached.",462,null],[13,"Drop","","Drop the Place",462,null],[12,"location","rustc::mir::TerminatorKind","",462,null],[12,"target","","",462,null],[12,"unwind","","",462,null],[13,"DropAndReplace","rustc::mir","Drop the Place and assign the new value over it. This ensures that the assignment to `P` occurs even if the destructor for place unwinds. Its semantics are best explained by by the elaboration:",462,null],[12,"location","rustc::mir::TerminatorKind","",462,null],[12,"value","","",462,null],[12,"target","","",462,null],[12,"unwind","","",462,null],[13,"Call","rustc::mir","Block ends with a call of a converging function",462,null],[12,"func","rustc::mir::TerminatorKind","The function that’s being called",462,null],[12,"args","","Arguments the function is called with. These are owned by the callee, which is free to modify them. This allows the memory occupied by \"by-value\" arguments to be reused across function calls without duplicating the contents.",462,null],[12,"destination","","Destination for the return value. If some, the call is converging.",462,null],[12,"cleanup","","Cleanups to be done if the call unwinds.",462,null],[13,"Assert","rustc::mir","Jump to the target if the condition has the expected value, otherwise panic with a message and a cleanup target.",462,null],[12,"cond","rustc::mir::TerminatorKind","",462,null],[12,"expected","","",462,null],[12,"msg","","",462,null],[12,"target","","",462,null],[12,"cleanup","","",462,null],[13,"Yield","rustc::mir","A suspend point",462,null],[12,"value","rustc::mir::TerminatorKind","The value to return",462,null],[12,"resume","","Where to resume to",462,null],[12,"drop","","Cleanup to be done if the generator is dropped at this suspend point",462,null],[13,"GeneratorDrop","rustc::mir","Indicates the end of the dropping of a generator",462,null],[13,"FalseEdges","","A block where control flow only ever takes one real path, but borrowck needs to be more conservative.",462,null],[12,"real_target","rustc::mir::TerminatorKind","The target normal control flow will take",462,null],[12,"imaginary_targets","","The list of blocks control flow could conceptually take, but won't in practice",462,null],[13,"FalseUnwind","rustc::mir","A terminator for blocks that only take one path in reality, but where we reserve the right to unwind in borrowck, even if it won't happen in practice. This can arise in infinite loops with no function calls for example.",462,null],[12,"real_target","rustc::mir::TerminatorKind","The target normal control flow will take",462,null],[12,"unwind","","The imaginary cleanup block link. This particular path will never be taken in practice, but in order to avoid fragility we want to always consider it in borrowck. We don't want to accept programs which pass borrowck only when panic=abort or some assertions are disabled due to release vs. debug mode builds. This needs to be an Option because of the remove_noop_landing_pads and no_landing_pads passes",462,null],[4,"StatementKind","rustc::mir","",null,null],[13,"Assign","","Write the RHS Rvalue to the LHS Place.",463,null],[13,"SetDiscriminant","","Write the discriminant for a variant to the enum Place.",463,null],[12,"place","rustc::mir::StatementKind","",463,null],[12,"variant_index","","",463,null],[13,"StorageLive","rustc::mir","Start a live range for the storage of the local.",463,null],[13,"StorageDead","","End the current live range for the storage of the local.",463,null],[13,"InlineAsm","","Execute a piece of inline Assembly.",463,null],[12,"asm","rustc::mir::StatementKind","",463,null],[12,"outputs","","",463,null],[12,"inputs","","",463,null],[13,"Validate","rustc::mir","Assert the given places to be valid inhabitants of their type.  These statements are currently only interpreted by miri and only generated when \"-Z mir-emit-validate\" is passed. See https://internals.rust-lang.org/t/types-as-contracts/5562/73 for more details.",463,null],[13,"EndRegion","","Mark one terminating point of a region scope (i.e. static region). (The starting point(s) arise implicitly from borrows.)",463,null],[13,"UserAssertTy","","Encodes a user's type assertion. These need to be preserved intact so that NLL can respect them. For example:",463,null],[13,"Nop","","No-op. Useful for deleting instructions without affecting statement indices.",463,null],[4,"ValidationOp","","The `ValidationOp` describes what happens with each of the operands of a `Validate` statement.",null,null],[13,"Acquire","","Recursively traverse the place following the type and validate that all type invariants are maintained.  Furthermore, acquire exclusive/read-only access to the memory reachable from the place.",464,null],[13,"Release","","Recursive traverse the mutable part of the type and relinquish all exclusive access.",464,null],[13,"Suspend","","Recursive traverse the mutable part of the type and relinquish all exclusive access until the given region ends.  Then, access will be recovered.",464,null],[4,"Place","","A path to a value; something that can be evaluated without changing or disturbing program state.",null,null],[13,"Local","","local variable",465,null],[13,"Static","","static or static mut variable",465,null],[13,"Projection","","projection out of a place (access a field, deref a pointer, etc)",465,null],[4,"ProjectionElem","","",null,null],[13,"Deref","","",466,null],[13,"Field","","",466,null],[13,"Index","","",466,null],[13,"ConstantIndex","","These indices are generated by slice patterns. Easiest to explain by example:",466,null],[12,"offset","rustc::mir::ProjectionElem","index or -index (in Python terms), depending on from_end",466,null],[12,"min_length","","thing being indexed must be at least this long",466,null],[12,"from_end","","counting backwards from end?",466,null],[13,"Subslice","rustc::mir","These indices are generated by slice patterns.",466,null],[12,"from","rustc::mir::ProjectionElem","",466,null],[12,"to","","",466,null],[13,"Downcast","rustc::mir","\"Downcast\" to a variant of an ADT. Currently, we only introduce this for ADTs with more than one variant. It may be better to just introduce it always, or always for enums.",466,null],[4,"Operand","","These are values that can appear inside an rvalue (or an index place). They are intentionally limited to prevent rvalues from being nested in one another.",null,null],[13,"Copy","","Copy: The value must be available for use afterwards.",467,null],[13,"Move","","Move: The value (including old borrows of it) will not be used again.",467,null],[13,"Constant","","",467,null],[4,"Rvalue","","Rvalues",null,null],[13,"Use","","x (either a move or copy, depending on type of x)",468,null],[13,"Repeat","","[x; 32]",468,null],[13,"Ref","","&x or &mut x",468,null],[13,"Len","","length of a [X] or [X;n] value",468,null],[13,"Cast","","",468,null],[13,"BinaryOp","","",468,null],[13,"CheckedBinaryOp","","",468,null],[13,"NullaryOp","","",468,null],[13,"UnaryOp","","",468,null],[13,"Discriminant","","Read the discriminant of an ADT.",468,null],[13,"Aggregate","","Create an aggregate value, like a tuple or struct.  This is only needed because we want to distinguish `dest = Foo { x: ..., y: ... }` from `dest.x = ...; dest.y = ...;` in the case that `Foo` has a destructor. These rvalues can be optimized away after type-checking and before lowering.",468,null],[4,"CastKind","","",null,null],[13,"Misc","","",469,null],[13,"ReifyFnPointer","","Convert unique, zero-sized type for a fn to fn()",469,null],[13,"ClosureFnPointer","","Convert non capturing closure to fn()",469,null],[13,"UnsafeFnPointer","","Convert safe fn() to unsafe fn()",469,null],[13,"Unsize","","\"Unsize\" -- convert a thin-or-fat pointer to a fat pointer. trans must figure out the details once full monomorphization is known. For example, this could be used to cast from a `&[i32;N]` to a `&[i32]`, or a `Box<T>` to a `Box<Trait>` (presuming `T: Trait`).",469,null],[4,"AggregateKind","","",null,null],[13,"Array","","The type is of the element",470,null],[13,"Tuple","","",470,null],[13,"Adt","","The second field is the variant index. It's equal to 0 for struct and union expressions. The fourth field is active field number and is present only for union expressions -- e.g. for a union expression `SomeUnion { c: .. }`, the active field index would identity the field `c`",470,null],[13,"Closure","","",470,null],[13,"Generator","","",470,null],[4,"BinOp","","",null,null],[13,"Add","","The `+` operator (addition)",471,null],[13,"Sub","","The `-` operator (subtraction)",471,null],[13,"Mul","","The `*` operator (multiplication)",471,null],[13,"Div","","The `/` operator (division)",471,null],[13,"Rem","","The `%` operator (modulus)",471,null],[13,"BitXor","","The `^` operator (bitwise xor)",471,null],[13,"BitAnd","","The `&` operator (bitwise and)",471,null],[13,"BitOr","","The `|` operator (bitwise or)",471,null],[13,"Shl","","The `<<` operator (shift left)",471,null],[13,"Shr","","The `>>` operator (shift right)",471,null],[13,"Eq","","The `==` operator (equality)",471,null],[13,"Lt","","The `<` operator (less than)",471,null],[13,"Le","","The `<=` operator (less than or equal to)",471,null],[13,"Ne","","The `!=` operator (not equal to)",471,null],[13,"Ge","","The `>=` operator (greater than or equal to)",471,null],[13,"Gt","","The `>` operator (greater than)",471,null],[13,"Offset","","The `ptr.offset` operator",471,null],[4,"NullOp","","",null,null],[13,"SizeOf","","Return the size of a value of that type",472,null],[13,"Box","","Create a new uninitialized box for a value of that type",472,null],[4,"UnOp","","",null,null],[13,"Not","","The `!` operator for logical inversion",473,null],[13,"Neg","","The `-` operator for negation",473,null],[4,"Literal","","",null,null],[13,"Value","","",474,null],[12,"value","rustc::mir::Literal","",474,null],[13,"Promoted","rustc::mir","",474,null],[12,"index","rustc::mir::Literal","",474,null],[4,"UnsafetyViolationKind","rustc::mir","",null,null],[13,"General","","",475,null],[13,"ExternStatic","","",475,null],[13,"BorrowPacked","","",475,null],[4,"ClosureOutlivesSubject","","The subject of a ClosureOutlivesRequirement -- that is, the thing that must outlive some region.",null,null],[13,"Ty","","Subject is a type, typically a type parameter, but could also be a projection. Indicates a requirement like `T: 'a` being passed to the caller, where the type here is `T`.",476,null],[13,"Region","","Subject is a free region from the closure. Indicates a requirement like `'a: 'b` being passed to the caller; the region here is `'a`.",476,null],[5,"fmt_const_val","","Write a `ConstVal` in a way closer to the original source code than the `Debug` output.",null,{"inputs":[{"name":"w"},{"name":"const"}],"output":{"name":"result"}}],[5,"print_miri_value","","",null,{"inputs":[{"name":"value"},{"name":"ty"},{"name":"w"}],"output":{"name":"result"}}],[5,"item_path_str","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"string"}}],[0,"cache","","",null,null],[3,"Cache","rustc::mir::cache","",null,null],[12,"predecessors","","",477,null],[5,"calculate_predecessors","","",null,{"inputs":[{"name":"mir"}],"output":{"generics":["basicblock","vec"],"name":"indexvec"}}],[11,"clone","","",477,{"inputs":[{"name":"self"}],"output":{"name":"cache"}}],[11,"fmt","","",477,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",477,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",477,{"inputs":[{"name":"d"}],"output":{"name":"result"}}],[11,"hash_stable","","",477,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",477,{"inputs":[],"output":{"name":"self"}}],[11,"invalidate","","",477,{"inputs":[{"name":"self"}],"output":null}],[11,"predecessors","","",477,{"inputs":[{"name":"self"},{"name":"mir"}],"output":{"generics":["indexvec"],"name":"readguard"}}],[11,"super_fold_with","","",477,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"cache"}}],[11,"super_visit_with","","",477,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",477,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[0,"tcx","rustc::mir","Methods for the various MIR types. These are intended for use after building is complete.",null,null],[4,"PlaceTy","rustc::mir::tcx","",null,null],[13,"Ty","","Normal type.",478,null],[12,"ty","rustc::mir::tcx::PlaceTy","",478,null],[13,"Downcast","rustc::mir::tcx","Downcast to a particular variant of an enum.",478,null],[12,"adt_def","rustc::mir::tcx::PlaceTy","",478,null],[12,"substs","","",478,null],[12,"variant_index","","",478,null],[4,"RvalueInitializationState","rustc::mir::tcx","",null,null],[13,"Shallow","","",479,null],[13,"Deep","","",479,null],[11,"clone","","",478,{"inputs":[{"name":"self"}],"output":{"name":"placety"}}],[11,"fmt","","",478,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_ty","","",478,{"inputs":[{"name":"ty"}],"output":{"name":"placety"}}],[11,"to_ty","","",478,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"projection_ty","","",478,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"placeelem"}],"output":{"name":"placety"}}],[11,"super_fold_with","","",478,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",478,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"ty","rustc::mir","",465,{"inputs":[{"name":"self"},{"name":"d"},{"name":"tyctxt"}],"output":{"name":"placety"}}],[11,"ty","","",468,{"inputs":[{"name":"self"},{"name":"d"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"initialization_state","","Returns whether this rvalue is deeply initialized (most rvalues) or whether its only shallowly initialized (`Rvalue::Box`).",468,{"inputs":[{"name":"self"}],"output":{"name":"rvalueinitializationstate"}}],[11,"ty","","",467,{"inputs":[{"name":"self"},{"name":"d"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"ty","","",471,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"to_mutbl_lossy","","",460,{"inputs":[{"name":"self"}],"output":{"name":"mutability"}}],[11,"to_hir_binop","","",471,{"inputs":[{"name":"self"}],"output":{"name":"binop_"}}],[0,"visit","","",null,null],[4,"TyContext","rustc::mir::visit","Extra information passed to `visit_ty` and friends to give context about where the type etc appears.",null,null],[13,"LocalDecl","","",480,null],[12,"local","rustc::mir::visit::TyContext","The index of the local variable we are visiting.",480,null],[12,"source_info","","The source location where this local variable was declared.",480,null],[13,"ReturnTy","rustc::mir::visit","The return type of the function.",480,null],[13,"YieldTy","","",480,null],[13,"Location","","A type found at some location.",480,null],[4,"PlaceContext","","",null,null],[13,"Store","","",481,null],[13,"AsmOutput","","",481,null],[13,"Call","","",481,null],[13,"Drop","","",481,null],[13,"Inspect","","",481,null],[13,"Borrow","","",481,null],[12,"region","rustc::mir::visit::PlaceContext","",481,null],[12,"kind","","",481,null],[13,"Projection","rustc::mir::visit","",481,null],[13,"Copy","","",481,null],[13,"Move","","",481,null],[13,"StorageLive","","",481,null],[13,"StorageDead","","",481,null],[13,"Validate","","",481,null],[8,"Visitor","","",null,null],[11,"visit_mir","","",482,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"visit_basic_block_data","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_visibility_scope_data","","",482,{"inputs":[{"name":"self"},{"name":"visibilityscopedata"}],"output":null}],[11,"visit_statement","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_assign","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_terminator","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"visit_terminator_kind","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"visit_assert_message","","",482,{"inputs":[{"name":"self"},{"name":"assertmessage"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",482,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_operand","","",482,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[11,"visit_user_assert_ty","","",482,{"inputs":[{"name":"self"},{"name":"canonicalty"},{"name":"local"},{"name":"location"}],"output":null}],[11,"visit_place","","",482,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_static","","",482,{"inputs":[{"name":"self"},{"name":"static"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_projection","","",482,{"inputs":[{"name":"self"},{"name":"placeprojection"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_projection_elem","","",482,{"inputs":[{"name":"self"},{"name":"placeelem"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_branch","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblock"}],"output":null}],[11,"visit_constant","","",482,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"visit_literal","","",482,{"inputs":[{"name":"self"},{"name":"literal"},{"name":"location"}],"output":null}],[11,"visit_def_id","","",482,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"location"}],"output":null}],[11,"visit_span","","",482,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"visit_source_info","","",482,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"visit_ty","","",482,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_region","","",482,{"inputs":[{"name":"self"},{"name":"region"},{"name":"location"}],"output":null}],[11,"visit_const","","",482,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_substs","","",482,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"location"}],"output":null}],[11,"visit_closure_substs","","",482,{"inputs":[{"name":"self"},{"name":"closuresubsts"},{"name":"location"}],"output":null}],[11,"visit_generator_interior","","",482,{"inputs":[{"name":"self"},{"name":"generatorinterior"},{"name":"location"}],"output":null}],[11,"visit_local_decl","","",482,{"inputs":[{"name":"self"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"visit_local","","",482,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_visibility_scope","","",482,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":null}],[11,"super_mir","","",482,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"super_basic_block_data","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"super_visibility_scope_data","","",482,{"inputs":[{"name":"self"},{"name":"visibilityscopedata"}],"output":null}],[11,"super_statement","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"super_assign","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"super_terminator","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"super_terminator_kind","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"super_assert_message","","",482,{"inputs":[{"name":"self"},{"name":"assertmessage"},{"name":"location"}],"output":null}],[11,"super_rvalue","","",482,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"super_operand","","",482,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[11,"super_user_assert_ty","","",482,{"inputs":[{"name":"self"},{"name":"canonicalty"},{"name":"local"},{"name":"location"}],"output":null}],[11,"super_place","","",482,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_static","","",482,{"inputs":[{"name":"self"},{"name":"static"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_projection","","",482,{"inputs":[{"name":"self"},{"name":"placeprojection"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_projection_elem","","",482,{"inputs":[{"name":"self"},{"name":"placeelem"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_local_decl","","",482,{"inputs":[{"name":"self"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"super_visibility_scope","","",482,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":null}],[11,"super_branch","","",482,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblock"}],"output":null}],[11,"super_constant","","",482,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"super_literal","","",482,{"inputs":[{"name":"self"},{"name":"literal"},{"name":"location"}],"output":null}],[11,"super_def_id","","",482,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"super_span","","",482,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"super_source_info","","",482,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"super_ty","","",482,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"super_region","","",482,{"inputs":[{"name":"self"},{"name":"region"}],"output":null}],[11,"super_const","","",482,{"inputs":[{"name":"self"},{"name":"const"}],"output":null}],[11,"super_substs","","",482,{"inputs":[{"name":"self"},{"name":"substs"}],"output":null}],[11,"super_generator_interior","","",482,{"inputs":[{"name":"self"},{"name":"generatorinterior"}],"output":null}],[11,"super_closure_substs","","",482,{"inputs":[{"name":"self"},{"name":"closuresubsts"}],"output":null}],[11,"visit_location","","",482,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"location"}],"output":null}],[8,"MutVisitor","","",null,null],[11,"visit_mir","","",483,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"visit_basic_block_data","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_visibility_scope_data","","",483,{"inputs":[{"name":"self"},{"name":"visibilityscopedata"}],"output":null}],[11,"visit_statement","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_assign","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_terminator","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"visit_terminator_kind","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"visit_assert_message","","",483,{"inputs":[{"name":"self"},{"name":"assertmessage"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",483,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_operand","","",483,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[11,"visit_user_assert_ty","","",483,{"inputs":[{"name":"self"},{"name":"canonicalty"},{"name":"local"},{"name":"location"}],"output":null}],[11,"visit_place","","",483,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_static","","",483,{"inputs":[{"name":"self"},{"name":"static"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_projection","","",483,{"inputs":[{"name":"self"},{"name":"placeprojection"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_projection_elem","","",483,{"inputs":[{"name":"self"},{"name":"placeelem"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_branch","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblock"}],"output":null}],[11,"visit_constant","","",483,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"visit_literal","","",483,{"inputs":[{"name":"self"},{"name":"literal"},{"name":"location"}],"output":null}],[11,"visit_def_id","","",483,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"location"}],"output":null}],[11,"visit_span","","",483,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"visit_source_info","","",483,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"visit_ty","","",483,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_region","","",483,{"inputs":[{"name":"self"},{"name":"region"},{"name":"location"}],"output":null}],[11,"visit_const","","",483,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_substs","","",483,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"location"}],"output":null}],[11,"visit_closure_substs","","",483,{"inputs":[{"name":"self"},{"name":"closuresubsts"},{"name":"location"}],"output":null}],[11,"visit_generator_interior","","",483,{"inputs":[{"name":"self"},{"name":"generatorinterior"},{"name":"location"}],"output":null}],[11,"visit_local_decl","","",483,{"inputs":[{"name":"self"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"visit_local","","",483,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_visibility_scope","","",483,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":null}],[11,"super_mir","","",483,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"super_basic_block_data","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"super_visibility_scope_data","","",483,{"inputs":[{"name":"self"},{"name":"visibilityscopedata"}],"output":null}],[11,"super_statement","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"super_assign","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"super_terminator","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"super_terminator_kind","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"super_assert_message","","",483,{"inputs":[{"name":"self"},{"name":"assertmessage"},{"name":"location"}],"output":null}],[11,"super_rvalue","","",483,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"super_operand","","",483,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[11,"super_user_assert_ty","","",483,{"inputs":[{"name":"self"},{"name":"canonicalty"},{"name":"local"},{"name":"location"}],"output":null}],[11,"super_place","","",483,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_static","","",483,{"inputs":[{"name":"self"},{"name":"static"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_projection","","",483,{"inputs":[{"name":"self"},{"name":"placeprojection"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_projection_elem","","",483,{"inputs":[{"name":"self"},{"name":"placeelem"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"super_local_decl","","",483,{"inputs":[{"name":"self"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"super_visibility_scope","","",483,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":null}],[11,"super_branch","","",483,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblock"}],"output":null}],[11,"super_constant","","",483,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"super_literal","","",483,{"inputs":[{"name":"self"},{"name":"literal"},{"name":"location"}],"output":null}],[11,"super_def_id","","",483,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"super_span","","",483,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"super_source_info","","",483,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"super_ty","","",483,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"super_region","","",483,{"inputs":[{"name":"self"},{"name":"region"}],"output":null}],[11,"super_const","","",483,{"inputs":[{"name":"self"},{"name":"const"}],"output":null}],[11,"super_substs","","",483,{"inputs":[{"name":"self"},{"name":"substs"}],"output":null}],[11,"super_generator_interior","","",483,{"inputs":[{"name":"self"},{"name":"generatorinterior"}],"output":null}],[11,"super_closure_substs","","",483,{"inputs":[{"name":"self"},{"name":"closuresubsts"}],"output":null}],[11,"visit_location","","",483,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"location"}],"output":null}],[8,"MirVisitable","","",null,null],[10,"apply","","",484,{"inputs":[{"name":"self"},{"name":"location"},{"name":"visitor"}],"output":null}],[11,"apply","rustc::mir","",441,{"inputs":[{"name":"self"},{"name":"location"},{"name":"visitor"}],"output":null}],[11,"apply","","",440,{"inputs":[{"name":"self"},{"name":"location"},{"name":"visitor"}],"output":null}],[11,"clone","rustc::mir::visit","",480,{"inputs":[{"name":"self"}],"output":{"name":"tycontext"}}],[11,"fmt","","",480,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",480,{"inputs":[{"name":"self"},{"name":"tycontext"}],"output":{"name":"bool"}}],[11,"ne","","",480,{"inputs":[{"name":"self"},{"name":"tycontext"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",480,null],[11,"hash","","",480,null],[11,"clone","","",481,{"inputs":[{"name":"self"}],"output":{"name":"placecontext"}}],[11,"fmt","","",481,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",481,{"inputs":[{"name":"self"},{"name":"placecontext"}],"output":{"name":"bool"}}],[11,"ne","","",481,{"inputs":[{"name":"self"},{"name":"placecontext"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",481,null],[11,"is_drop","","Returns true if this place context represents a drop.",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_storage_marker","","Returns true if this place context represents a storage live or storage dead marker.",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_storage_live_marker","","Returns true if this place context represents a storage live marker.",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_storage_dead_marker","","Returns true if this place context represents a storage dead marker.",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_mutating_use","","Returns true if this place context represents a use that potentially changes the value.",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_nonmutating_use","","Returns true if this place context represents a use that does not change the value.",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_use","","",481,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[0,"traversal","rustc::mir","",null,null],[3,"Preorder","rustc::mir::traversal","Preorder traversal of a graph.",null,null],[12,"mir","","",485,null],[12,"visited","","",485,null],[12,"worklist","","",485,null],[3,"Postorder","","Postorder traversal of a graph.",null,null],[12,"mir","","",486,null],[12,"visited","","",486,null],[12,"visit_stack","","",486,null],[3,"ReversePostorder","","Reverse postorder traversal of a graph",null,null],[12,"mir","","",487,null],[12,"blocks","","",487,null],[12,"idx","","",487,null],[5,"preorder","","",null,{"inputs":[{"name":"mir"}],"output":{"name":"preorder"}}],[5,"postorder","","",null,{"inputs":[{"name":"mir"}],"output":{"name":"postorder"}}],[5,"reverse_postorder","","",null,{"inputs":[{"name":"mir"}],"output":{"name":"reversepostorder"}}],[11,"clone","","",485,{"inputs":[{"name":"self"}],"output":{"name":"preorder"}}],[11,"new","","",485,{"inputs":[{"name":"mir"},{"name":"basicblock"}],"output":{"name":"preorder"}}],[11,"next","","",485,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",485,null],[11,"new","","",486,{"inputs":[{"name":"mir"},{"name":"basicblock"}],"output":{"name":"postorder"}}],[11,"traverse_successor","","",486,{"inputs":[{"name":"self"}],"output":null}],[11,"next","","",486,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",486,null],[11,"clone","","",487,{"inputs":[{"name":"self"}],"output":{"name":"reversepostorder"}}],[11,"new","","",487,{"inputs":[{"name":"mir"},{"name":"basicblock"}],"output":{"name":"reversepostorder"}}],[11,"reset","","",487,{"inputs":[{"name":"self"}],"output":null}],[11,"next","","",487,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",487,null],[0,"interpret","rustc::mir","An interpreter for MIR used in CTFE and by miri",null,null],[3,"EvalError","rustc::mir::interpret","",null,null],[12,"kind","","",488,null],[12,"backtrace","","",488,null],[3,"Pointer","","A wrapper type around `PrimVal` that cannot be turned back into a `PrimVal` accidentally. This type clears up a few APIs where having a `PrimVal` argument for something that is potentially an integer pointer or a pointer to an allocation was unclear.",null,null],[12,"primval","","",489,null],[3,"DynamicLifetime","","",null,null],[12,"frame","","",490,null],[12,"region","","",490,null],[3,"GlobalId","","Uniquely identifies a specific constant or static.",null,null],[12,"instance","","For a constant or static, the `Instance` of the item itself. For a promoted global, the `Instance` of the function they belong to.",491,null],[12,"promoted","","The index for promoted globals within their function's `Mir`.",491,null],[3,"MemoryPointer","","",null,null],[12,"alloc_id","","",492,null],[12,"offset","","",492,null],[3,"AllocId","","",null,null],[12,"0","","",493,null],[3,"Allocation","","",null,null],[12,"bytes","","The actual bytes of the allocation. Note that the bytes of a pointer represent the offset of the pointer",494,null],[12,"relocations","","Maps from byte addresses to allocations. Only the first byte of a pointer is inserted into the map.",494,null],[12,"undef_mask","","Denotes undefined memory. Reading from undefined memory is forbidden in miri",494,null],[12,"align","","The alignment of the allocation to detect unaligned reads.",494,null],[12,"runtime_mutability","","Whether the allocation (of a static) should be put into mutable memory when translating",494,null],[3,"UndefMask","","",null,null],[12,"blocks","","",495,null],[12,"len","","",495,null],[4,"EvalErrorKind","","",null,null],[13,"MachineError","","This variant is used by machines to signal their own errors that do not match an existing variant",496,null],[13,"FunctionPointerTyMismatch","","",496,null],[13,"NoMirFor","","",496,null],[13,"UnterminatedCString","","",496,null],[13,"DanglingPointerDeref","","",496,null],[13,"DoubleFree","","",496,null],[13,"InvalidMemoryAccess","","",496,null],[13,"InvalidFunctionPointer","","",496,null],[13,"InvalidBool","","",496,null],[13,"InvalidDiscriminant","","",496,null],[13,"PointerOutOfBounds","","",496,null],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"access","","",496,null],[12,"allocation_size","","",496,null],[13,"InvalidNullPointerUsage","rustc::mir::interpret","",496,null],[13,"ReadPointerAsBytes","","",496,null],[13,"ReadBytesAsPointer","","",496,null],[13,"InvalidPointerMath","","",496,null],[13,"ReadUndefBytes","","",496,null],[13,"DeadLocal","","",496,null],[13,"InvalidBoolOp","","",496,null],[13,"Unimplemented","","",496,null],[13,"DerefFunctionPointer","","",496,null],[13,"ExecuteMemory","","",496,null],[13,"BoundsCheck","","",496,null],[12,"len","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"index","","",496,null],[13,"Overflow","rustc::mir::interpret","",496,null],[13,"OverflowNeg","","",496,null],[13,"DivisionByZero","","",496,null],[13,"RemainderByZero","","",496,null],[13,"Intrinsic","","",496,null],[13,"InvalidChar","","",496,null],[13,"StackFrameLimitReached","","",496,null],[13,"OutOfTls","","",496,null],[13,"TlsOutOfBounds","","",496,null],[13,"AbiViolation","","",496,null],[13,"AlignmentCheckFailed","","",496,null],[12,"required","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"has","","",496,null],[13,"MemoryLockViolation","rustc::mir::interpret","",496,null],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"len","","",496,null],[12,"frame","","",496,null],[12,"access","","",496,null],[12,"lock","","",496,null],[13,"MemoryAcquireConflict","rustc::mir::interpret","",496,null],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"len","","",496,null],[12,"kind","","",496,null],[12,"lock","","",496,null],[13,"InvalidMemoryLockRelease","rustc::mir::interpret","",496,null],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"len","","",496,null],[12,"frame","","",496,null],[12,"lock","","",496,null],[13,"DeallocatedLockedMemory","rustc::mir::interpret","",496,null],[12,"ptr","rustc::mir::interpret::EvalErrorKind","",496,null],[12,"lock","","",496,null],[13,"ValidationFailure","rustc::mir::interpret","",496,null],[13,"CalledClosureAsFunction","","",496,null],[13,"VtableForArgumentlessMethod","","",496,null],[13,"ModifiedConstantMemory","","",496,null],[13,"AssumptionNotHeld","","",496,null],[13,"InlineAsm","","",496,null],[13,"TypeNotPrimitive","","",496,null],[13,"ReallocatedWrongMemoryKind","","",496,null],[13,"DeallocatedWrongMemoryKind","","",496,null],[13,"ReallocateNonBasePtr","","",496,null],[13,"DeallocateNonBasePtr","","",496,null],[13,"IncorrectAllocationInformation","","",496,null],[13,"Layout","","",496,null],[13,"HeapAllocZeroBytes","","",496,null],[13,"HeapAllocNonPowerOfTwoAlignment","","",496,null],[13,"Unreachable","","",496,null],[13,"Panic","","",496,null],[13,"ReadFromReturnPointer","","",496,null],[13,"PathNotFound","","",496,null],[13,"UnimplementedTraitSelection","","",496,null],[13,"TypeckError","","Abort in case type errors are reached",496,null],[13,"ReferencedConstant","","Cannot compute this constant because it depends on another one which already produced an error",496,null],[13,"GeneratorResumedAfterReturn","","",496,null],[13,"GeneratorResumedAfterPanic","","",496,null],[4,"PrimVal","","A `PrimVal` represents an immediate, primitive value existing outside of a `memory::Allocation`. It is in many ways like a small chunk of a `Allocation`, up to 8 bytes in size. Like a range of bytes in an `Allocation`, a `PrimVal` can either represent the raw bytes of a simple value, a pointer into another `Allocation`, or be undefined.",null,null],[13,"Bytes","","The raw bytes of a simple value.",497,null],[13,"Ptr","","A pointer into an `Allocation`. An `Allocation` in the `memory` module has a list of relocations, but a `PrimVal` is only large enough to contain one, so we just represent the relocation and its associated offset together as a `MemoryPointer` here.",497,null],[13,"Undef","","An undefined `PrimVal`, for representing values that aren't safe to examine, but are safe to copy around, just like undefined bytes in an `Allocation`.",497,null],[4,"PrimValKind","","",null,null],[13,"I8","","",498,null],[13,"I16","","",498,null],[13,"I32","","",498,null],[13,"I64","","",498,null],[13,"I128","","",498,null],[13,"U8","","",498,null],[13,"U16","","",498,null],[13,"U32","","",498,null],[13,"U64","","",498,null],[13,"U128","","",498,null],[13,"F32","","",498,null],[13,"F64","","",498,null],[13,"Ptr","","",498,null],[13,"FnPtr","","",498,null],[13,"Bool","","",498,null],[13,"Char","","",498,null],[4,"Value","","A `Value` represents a single self-contained Rust value.",null,null],[13,"ByRef","","",499,null],[13,"ByVal","","",499,null],[13,"ByValPair","","",499,null],[4,"Lock","","",null,null],[13,"NoLock","","",500,null],[13,"WriteLock","","",500,null],[13,"ReadLock","","This should never be empty -- that would be a read lock held and nobody there to release it...",500,null],[4,"AccessKind","","",null,null],[13,"Read","","",501,null],[13,"Write","","",501,null],[4,"AllocKind","","",null,null],[13,"Alloc","","",502,null],[13,"Fn","","",502,null],[13,"Static","","",502,null],[5,"specialized_encode_alloc_id","","",null,{"inputs":[{"name":"e"},{"name":"tyctxt"},{"name":"allocid"}],"output":{"name":"result"}}],[5,"specialized_decode_alloc_id","","",null,{"inputs":[{"name":"d"},{"name":"tyctxt"},{"name":"cache"}],"output":{"generics":["allocid"],"name":"result"}}],[5,"bit_index","","",null,null],[0,"error","","",null,null],[3,"EvalError","rustc::mir::interpret::error","",null,null],[12,"kind","","",488,null],[12,"backtrace","","",488,null],[4,"EvalErrorKind","","",null,null],[13,"MachineError","","This variant is used by machines to signal their own errors that do not match an existing variant",496,null],[13,"FunctionPointerTyMismatch","","",496,null],[13,"NoMirFor","","",496,null],[13,"UnterminatedCString","","",496,null],[13,"DanglingPointerDeref","","",496,null],[13,"DoubleFree","","",496,null],[13,"InvalidMemoryAccess","","",496,null],[13,"InvalidFunctionPointer","","",496,null],[13,"InvalidBool","","",496,null],[13,"InvalidDiscriminant","","",496,null],[13,"PointerOutOfBounds","","",496,null],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"access","","",496,null],[12,"allocation_size","","",496,null],[13,"InvalidNullPointerUsage","rustc::mir::interpret::error","",496,null],[13,"ReadPointerAsBytes","","",496,null],[13,"ReadBytesAsPointer","","",496,null],[13,"InvalidPointerMath","","",496,null],[13,"ReadUndefBytes","","",496,null],[13,"DeadLocal","","",496,null],[13,"InvalidBoolOp","","",496,null],[13,"Unimplemented","","",496,null],[13,"DerefFunctionPointer","","",496,null],[13,"ExecuteMemory","","",496,null],[13,"BoundsCheck","","",496,null],[12,"len","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"index","","",496,null],[13,"Overflow","rustc::mir::interpret::error","",496,null],[13,"OverflowNeg","","",496,null],[13,"DivisionByZero","","",496,null],[13,"RemainderByZero","","",496,null],[13,"Intrinsic","","",496,null],[13,"InvalidChar","","",496,null],[13,"StackFrameLimitReached","","",496,null],[13,"OutOfTls","","",496,null],[13,"TlsOutOfBounds","","",496,null],[13,"AbiViolation","","",496,null],[13,"AlignmentCheckFailed","","",496,null],[12,"required","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"has","","",496,null],[13,"MemoryLockViolation","rustc::mir::interpret::error","",496,null],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"len","","",496,null],[12,"frame","","",496,null],[12,"access","","",496,null],[12,"lock","","",496,null],[13,"MemoryAcquireConflict","rustc::mir::interpret::error","",496,null],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"len","","",496,null],[12,"kind","","",496,null],[12,"lock","","",496,null],[13,"InvalidMemoryLockRelease","rustc::mir::interpret::error","",496,null],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"len","","",496,null],[12,"frame","","",496,null],[12,"lock","","",496,null],[13,"DeallocatedLockedMemory","rustc::mir::interpret::error","",496,null],[12,"ptr","rustc::mir::interpret::error::EvalErrorKind","",496,null],[12,"lock","","",496,null],[13,"ValidationFailure","rustc::mir::interpret::error","",496,null],[13,"CalledClosureAsFunction","","",496,null],[13,"VtableForArgumentlessMethod","","",496,null],[13,"ModifiedConstantMemory","","",496,null],[13,"AssumptionNotHeld","","",496,null],[13,"InlineAsm","","",496,null],[13,"TypeNotPrimitive","","",496,null],[13,"ReallocatedWrongMemoryKind","","",496,null],[13,"DeallocatedWrongMemoryKind","","",496,null],[13,"ReallocateNonBasePtr","","",496,null],[13,"DeallocateNonBasePtr","","",496,null],[13,"IncorrectAllocationInformation","","",496,null],[13,"Layout","","",496,null],[13,"HeapAllocZeroBytes","","",496,null],[13,"HeapAllocNonPowerOfTwoAlignment","","",496,null],[13,"Unreachable","","",496,null],[13,"Panic","","",496,null],[13,"ReadFromReturnPointer","","",496,null],[13,"PathNotFound","","",496,null],[13,"UnimplementedTraitSelection","","",496,null],[13,"TypeckError","","Abort in case type errors are reached",496,null],[13,"ReferencedConstant","","Cannot compute this constant because it depends on another one which already produced an error",496,null],[13,"GeneratorResumedAfterReturn","","",496,null],[13,"GeneratorResumedAfterPanic","","",496,null],[6,"AssertMessage","","",null,null],[6,"EvalResult","","",null,null],[11,"fmt","rustc::mir::interpret","",488,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",488,{"inputs":[{"name":"self"}],"output":{"name":"evalerror"}}],[11,"from","","",488,{"inputs":[{"generics":["u64"],"name":"evalerrorkind"}],"output":{"name":"self"}}],[11,"clone","","",496,{"inputs":[{"name":"self"}],"output":{"name":"evalerrorkind"}}],[11,"encode","","",496,{"inputs":[{"name":"self"},{"name":"__so"}],"output":{"name":"result"}}],[11,"decode","","",496,{"inputs":[{"name":"__do"}],"output":{"generics":["evalerrorkind"],"name":"result"}}],[11,"description","","",496,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"fmt","","",488,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",496,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"value","","",null,null],[3,"Pointer","rustc::mir::interpret::value","A wrapper type around `PrimVal` that cannot be turned back into a `PrimVal` accidentally. This type clears up a few APIs where having a `PrimVal` argument for something that is potentially an integer pointer or a pointer to an allocation was unclear.",null,null],[12,"primval","","",489,null],[4,"Value","","A `Value` represents a single self-contained Rust value.",null,null],[13,"ByRef","","",499,null],[13,"ByVal","","",499,null],[13,"ByValPair","","",499,null],[4,"PrimVal","","A `PrimVal` represents an immediate, primitive value existing outside of a `memory::Allocation`. It is in many ways like a small chunk of a `Allocation`, up to 8 bytes in size. Like a range of bytes in an `Allocation`, a `PrimVal` can either represent the raw bytes of a simple value, a pointer into another `Allocation`, or be undefined.",null,null],[13,"Bytes","","The raw bytes of a simple value.",497,null],[13,"Ptr","","A pointer into an `Allocation`. An `Allocation` in the `memory` module has a list of relocations, but a `PrimVal` is only large enough to contain one, so we just represent the relocation and its associated offset together as a `MemoryPointer` here.",497,null],[13,"Undef","","An undefined `PrimVal`, for representing values that aren't safe to examine, but are safe to copy around, just like undefined bytes in an `Allocation`.",497,null],[4,"PrimValKind","","",null,null],[13,"I8","","",498,null],[13,"I16","","",498,null],[13,"I32","","",498,null],[13,"I64","","",498,null],[13,"I128","","",498,null],[13,"U8","","",498,null],[13,"U16","","",498,null],[13,"U32","","",498,null],[13,"U64","","",498,null],[13,"U128","","",498,null],[13,"F32","","",498,null],[13,"F64","","",498,null],[13,"Ptr","","",498,null],[13,"FnPtr","","",498,null],[13,"Bool","","",498,null],[13,"Char","","",498,null],[11,"clone","rustc::mir::interpret","",499,{"inputs":[{"name":"self"}],"output":{"name":"value"}}],[11,"fmt","","",499,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",499,null],[11,"eq","","",499,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"name":"bool"}}],[11,"ne","","",499,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"name":"bool"}}],[11,"encode","","",499,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",499,{"inputs":[{"name":"__d"}],"output":{"generics":["value"],"name":"result"}}],[11,"hash","","",499,null],[11,"super_fold_with","","",499,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",499,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"clone","","",489,{"inputs":[{"name":"self"}],"output":{"name":"pointer"}}],[11,"fmt","","",489,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",489,null],[11,"eq","","",489,{"inputs":[{"name":"self"},{"name":"pointer"}],"output":{"name":"bool"}}],[11,"ne","","",489,{"inputs":[{"name":"self"},{"name":"pointer"}],"output":{"name":"bool"}}],[11,"encode","","",489,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",489,{"inputs":[{"name":"__d"}],"output":{"generics":["pointer"],"name":"result"}}],[11,"hash","","",489,null],[11,"null","","",489,{"inputs":[],"output":{"name":"self"}}],[11,"to_ptr","","",489,{"inputs":[{"name":"self"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"into_inner_primval","","",489,{"inputs":[{"name":"self"}],"output":{"name":"primval"}}],[11,"signed_offset","","",489,{"inputs":[{"name":"self"},{"name":"i64"},{"name":"c"}],"output":{"name":"evalresult"}}],[11,"offset","","",489,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"c"}],"output":{"name":"evalresult"}}],[11,"wrapping_signed_offset","","",489,{"inputs":[{"name":"self"},{"name":"i64"},{"name":"c"}],"output":{"name":"evalresult"}}],[11,"is_null","","",489,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"evalresult"}}],[11,"to_value_with_len","","",489,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"value"}}],[11,"to_value_with_vtable","","",489,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"name":"value"}}],[11,"to_value","","",489,{"inputs":[{"name":"self"}],"output":{"name":"value"}}],[11,"from","","",489,{"inputs":[{"name":"primval"}],"output":{"name":"self"}}],[11,"from","","",489,{"inputs":[{"name":"memorypointer"}],"output":{"name":"self"}}],[11,"clone","","",497,{"inputs":[{"name":"self"}],"output":{"name":"primval"}}],[11,"fmt","","",497,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",497,null],[11,"eq","","",497,{"inputs":[{"name":"self"},{"name":"primval"}],"output":{"name":"bool"}}],[11,"ne","","",497,{"inputs":[{"name":"self"},{"name":"primval"}],"output":{"name":"bool"}}],[11,"encode","","",497,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",497,{"inputs":[{"name":"__d"}],"output":{"generics":["primval"],"name":"result"}}],[11,"hash","","",497,null],[11,"clone","","",498,{"inputs":[{"name":"self"}],"output":{"name":"primvalkind"}}],[11,"fmt","","",498,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",498,{"inputs":[{"name":"self"},{"name":"primvalkind"}],"output":{"name":"bool"}}],[11,"from_u128","","",497,{"inputs":[{"name":"u128"}],"output":{"name":"self"}}],[11,"from_i128","","",497,{"inputs":[{"name":"i128"}],"output":{"name":"self"}}],[11,"from_bool","","",497,{"inputs":[{"name":"bool"}],"output":{"name":"self"}}],[11,"from_char","","",497,{"inputs":[{"name":"char"}],"output":{"name":"self"}}],[11,"to_bytes","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"evalresult"}}],[11,"to_ptr","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"is_bytes","","",497,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ptr","","",497,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_undef","","",497,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"to_u128","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"evalresult"}}],[11,"to_u64","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"evalresult"}}],[11,"to_i32","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"evalresult"}}],[11,"to_i128","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"evalresult"}}],[11,"to_i64","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"evalresult"}}],[11,"to_bool","","",497,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"evalresult"}}],[11,"is_int","","",498,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_signed_int","","",498,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_float","","",498,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"from_uint_size","","",498,{"inputs":[{"name":"u64"}],"output":{"name":"self"}}],[11,"from_int_size","","",498,{"inputs":[{"name":"u64"}],"output":{"name":"self"}}],[11,"is_ptr","","",498,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[6,"EvalResult","","",null,null],[6,"AssertMessage","","",null,null],[6,"Block","","",null,null],[17,"BLOCK_SIZE","","",null,null],[8,"PointerArithmetic","","",null,null],[11,"truncate_to_ptr","","",503,null],[11,"overflowing_signed_offset","","",503,null],[11,"overflowing_offset","","",503,null],[11,"signed_offset","","",503,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"i64"}],"output":{"generics":["u64"],"name":"evalresult"}}],[11,"offset","","",503,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"u64"}],"output":{"generics":["u64"],"name":"evalresult"}}],[11,"wrapping_signed_offset","","",503,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"i64"}],"output":{"name":"u64"}}],[11,"clone","","",500,{"inputs":[{"name":"self"}],"output":{"name":"lock"}}],[11,"fmt","","",500,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",500,{"inputs":[{"name":"self"},{"name":"lock"}],"output":{"name":"bool"}}],[11,"ne","","",500,{"inputs":[{"name":"self"},{"name":"lock"}],"output":{"name":"bool"}}],[11,"encode","","",500,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",500,{"inputs":[{"name":"__d"}],"output":{"generics":["lock"],"name":"result"}}],[11,"clone","","",490,{"inputs":[{"name":"self"}],"output":{"name":"dynamiclifetime"}}],[11,"fmt","","",490,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",490,{"inputs":[{"name":"self"},{"name":"dynamiclifetime"}],"output":{"name":"bool"}}],[11,"ne","","",490,{"inputs":[{"name":"self"},{"name":"dynamiclifetime"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",490,null],[11,"hash","","",490,null],[11,"encode","","",490,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",490,{"inputs":[{"name":"__d"}],"output":{"generics":["dynamiclifetime"],"name":"result"}}],[11,"clone","","",501,{"inputs":[{"name":"self"}],"output":{"name":"accesskind"}}],[11,"fmt","","",501,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",501,{"inputs":[{"name":"self"},{"name":"accesskind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",501,null],[11,"encode","","",501,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",501,{"inputs":[{"name":"__d"}],"output":{"generics":["accesskind"],"name":"result"}}],[11,"clone","","",491,{"inputs":[{"name":"self"}],"output":{"name":"globalid"}}],[11,"fmt","","",491,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",491,null],[11,"eq","","",491,{"inputs":[{"name":"self"},{"name":"globalid"}],"output":{"name":"bool"}}],[11,"ne","","",491,{"inputs":[{"name":"self"},{"name":"globalid"}],"output":{"name":"bool"}}],[11,"hash","","",491,null],[11,"encode","","",491,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",491,{"inputs":[{"name":"__d"}],"output":{"generics":["globalid"],"name":"result"}}],[11,"clone","","",492,{"inputs":[{"name":"self"}],"output":{"name":"memorypointer"}}],[11,"fmt","","",492,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",492,null],[11,"eq","","",492,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"name":"bool"}}],[11,"ne","","",492,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"name":"bool"}}],[11,"encode","","",492,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",492,{"inputs":[{"name":"__d"}],"output":{"generics":["memorypointer"],"name":"result"}}],[11,"hash","","",492,null],[11,"new","","",492,{"inputs":[{"name":"allocid"},{"name":"u64"}],"output":{"name":"self"}}],[11,"wrapping_signed_offset","","",492,{"inputs":[{"name":"self"},{"name":"i64"},{"name":"c"}],"output":{"name":"self"}}],[11,"overflowing_signed_offset","","",492,null],[11,"signed_offset","","",492,{"inputs":[{"name":"self"},{"name":"i64"},{"name":"c"}],"output":{"name":"evalresult"}}],[11,"overflowing_offset","","",492,null],[11,"offset","","",492,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"c"}],"output":{"name":"evalresult"}}],[11,"clone","","",493,{"inputs":[{"name":"self"}],"output":{"name":"allocid"}}],[11,"default","","",493,{"inputs":[],"output":{"name":"allocid"}}],[11,"assert_receiver_is_total_eq","","",493,null],[11,"hash","","",493,null],[11,"cmp","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"ordering"}}],[11,"eq","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"bool"}}],[11,"ne","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"bool"}}],[11,"le","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"bool"}}],[11,"gt","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"bool"}}],[11,"ge","","",493,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"bool"}}],[11,"fmt","","",493,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",502,{"inputs":[{"name":"__d"}],"output":{"generics":["allockind"],"name":"result"}}],[11,"encode","","",502,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",493,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",494,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",494,null],[11,"eq","","",494,{"inputs":[{"name":"self"},{"name":"allocation"}],"output":{"name":"bool"}}],[11,"ne","","",494,{"inputs":[{"name":"self"},{"name":"allocation"}],"output":{"name":"bool"}}],[11,"hash","","",494,null],[11,"encode","","",494,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",494,{"inputs":[{"name":"__d"}],"output":{"generics":["allocation"],"name":"result"}}],[11,"from_bytes","","",494,null],[11,"clone","","",495,{"inputs":[{"name":"self"}],"output":{"name":"undefmask"}}],[11,"fmt","","",495,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",495,null],[11,"eq","","",495,{"inputs":[{"name":"self"},{"name":"undefmask"}],"output":{"name":"bool"}}],[11,"ne","","",495,{"inputs":[{"name":"self"},{"name":"undefmask"}],"output":{"name":"bool"}}],[11,"hash","","",495,null],[11,"encode","","",495,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",495,{"inputs":[{"name":"__d"}],"output":{"generics":["undefmask"],"name":"result"}}],[11,"hash_stable","","",495,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",495,{"inputs":[{"name":"u64"}],"output":{"name":"self"}}],[11,"is_range_defined","","Check whether the range `start..end` (end-exclusive) is entirely defined.",495,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"set_range","","",495,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"u64"},{"name":"bool"}],"output":null}],[11,"set_range_inbounds","","",495,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"u64"},{"name":"bool"}],"output":null}],[11,"get","","",495,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"bool"}}],[11,"set","","",495,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"bool"}],"output":null}],[11,"grow","","",495,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"bool"}],"output":null}],[0,"mono","rustc::mir","",null,null],[3,"CodegenUnit","rustc::mir::mono","",null,null],[12,"name","","A name for this CGU. Incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator.",504,null],[12,"items","","",504,null],[12,"size_estimate","","",504,null],[3,"Stats","","",null,null],[12,"n_glues_created","","",505,null],[12,"n_null_glues","","",505,null],[12,"n_real_glues","","",505,null],[12,"n_fns","","",505,null],[12,"n_inlines","","",505,null],[12,"n_closures","","",505,null],[12,"n_llvm_insns","","",505,null],[12,"llvm_insns","","",505,null],[12,"fn_stats","","",505,null],[4,"MonoItem","","",null,null],[13,"Fn","","",506,null],[13,"Static","","",506,null],[13,"GlobalAsm","","",506,null],[4,"Linkage","","",null,null],[13,"External","","",507,null],[13,"AvailableExternally","","",507,null],[13,"LinkOnceAny","","",507,null],[13,"LinkOnceODR","","",507,null],[13,"WeakAny","","",507,null],[13,"WeakODR","","",507,null],[13,"Appending","","",507,null],[13,"Internal","","",507,null],[13,"Private","","",507,null],[13,"ExternalWeak","","",507,null],[13,"Common","","",507,null],[4,"Visibility","","",null,null],[13,"Default","","",508,null],[13,"Hidden","","",508,null],[13,"Protected","","",508,null],[11,"eq","","",506,{"inputs":[{"name":"self"},{"name":"monoitem"}],"output":{"name":"bool"}}],[11,"ne","","",506,{"inputs":[{"name":"self"},{"name":"monoitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",506,null],[11,"clone","","",506,{"inputs":[{"name":"self"}],"output":{"name":"monoitem"}}],[11,"fmt","","",506,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",506,null],[11,"size_estimate","","",506,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"usize"}}],[11,"hash_stable","","",506,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",507,{"inputs":[{"name":"self"}],"output":{"name":"linkage"}}],[11,"eq","","",507,{"inputs":[{"name":"self"},{"name":"linkage"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",507,null],[11,"hash","","",507,null],[11,"fmt","","",507,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",507,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",507,{"inputs":[{"name":"__d"}],"output":{"generics":["linkage"],"name":"result"}}],[11,"hash_stable","","",507,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",508,{"inputs":[{"name":"self"}],"output":{"name":"visibility"}}],[11,"eq","","",508,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",508,null],[11,"hash","","",508,null],[11,"fmt","","",508,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash_stable","","",508,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",504,{"inputs":[{"name":"internedstring"}],"output":{"name":"codegenunit"}}],[11,"name","","",504,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"set_name","","",504,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":null}],[11,"items","","",504,{"inputs":[{"name":"self"}],"output":{"name":"fxhashmap"}}],[11,"items_mut","","",504,{"inputs":[{"name":"self"}],"output":{"name":"fxhashmap"}}],[11,"mangle_name","","",504,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"estimate_size","","",504,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":null}],[11,"size_estimate","","",504,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"modify_size_estimate","","",504,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"hash_stable","","",504,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",505,{"inputs":[{"name":"self"}],"output":{"name":"stats"}}],[11,"default","","",505,{"inputs":[],"output":{"name":"stats"}}],[11,"hash_stable","","",505,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"extend","","",505,{"inputs":[{"name":"self"},{"name":"stats"}],"output":null}],[6,"AssertMessage","rustc::mir","",null,null],[6,"LocalDecls","","Types for locals",null,null],[6,"Successors","","",null,null],[6,"SuccessorsMut","","",null,null],[6,"PlaceProjection","","Alias for projections as they appear in places, where the base is a place and the index is a local.",null,null],[6,"PlaceElem","","Alias for projections as they appear in places, where the base is a place and the index is a local.",null,null],[17,"START_BLOCK","","where execution begins",null,null],[17,"RETURN_PLACE","","",null,null],[17,"ARGUMENT_VISIBILITY_SCOPE","","",null,null],[8,"HasLocalDecls","","",null,null],[10,"local_decls","","",509,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"local_decls","","",432,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"clone","","",432,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"encode","","",432,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",432,{"inputs":[{"name":"__d"}],"output":{"generics":["mir"],"name":"result"}}],[11,"fmt","","",432,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",432,{"inputs":[{"generics":["basicblock","basicblockdata"],"name":"indexvec"},{"generics":["visibilityscope","visibilityscopedata"],"name":"indexvec"},{"generics":["indexvec"],"name":"clearcrosscrate"},{"generics":["promoted","mir"],"name":"indexvec"},{"generics":["ty"],"name":"option"},{"generics":["local","localdecl"],"name":"indexvec"},{"name":"usize"},{"generics":["upvardecl"],"name":"vec"},{"name":"span"}],"output":{"name":"self"}}],[11,"basic_blocks","","",432,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"basic_blocks_mut","","",432,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"basic_blocks_and_local_decls_mut","","",432,null],[11,"predecessors","","",432,{"inputs":[{"name":"self"}],"output":{"generics":["indexvec"],"name":"readguard"}}],[11,"predecessors_for","","",432,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"generics":["vec"],"name":"readguard"}}],[11,"dominators","","",432,{"inputs":[{"name":"self"}],"output":{"generics":["basicblock"],"name":"dominators"}}],[11,"local_kind","","",432,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"localkind"}}],[11,"temps_iter","","Returns an iterator over all temporaries.",432,null],[11,"vars_iter","","Returns an iterator over all user-declared locals.",432,null],[11,"mut_vars_and_args_iter","","Returns an iterator over all user-declared mutable arguments and locals.",432,null],[11,"args_iter","","Returns an iterator over all function arguments.",432,null],[11,"vars_and_temps_iter","","Returns an iterator over all user-defined variables and compiler-generated temporaries (all locals that are neither arguments nor the return place).",432,null],[11,"make_statement_nop","","Changes a statement to a nop. This is both faster than deleting instructions and avoids invalidating statement indices in `Location`s.",432,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"source_info","","Returns the source info associated with `location`.",432,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"sourceinfo"}}],[11,"return_ty","","Return the return type, it always return first element from `local_decls` array",432,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"clone","","",433,{"inputs":[{"name":"self"}],"output":{"name":"visibilityscopeinfo"}}],[11,"fmt","","",433,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",433,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",433,{"inputs":[{"name":"__d"}],"output":{"generics":["visibilityscopeinfo"],"name":"result"}}],[11,"clone","","",457,{"inputs":[{"name":"self"}],"output":{"name":"safety"}}],[11,"fmt","","",457,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",457,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",457,{"inputs":[{"name":"__d"}],"output":{"generics":["safety"],"name":"result"}}],[11,"hash_stable","","",432,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"index","","",432,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"basicblockdata"}}],[11,"index_mut","","",432,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"basicblockdata"}}],[11,"clone","","",458,{"inputs":[{"name":"self"}],"output":{"name":"clearcrosscrate"}}],[11,"fmt","","",458,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",434,{"inputs":[{"name":"self"}],"output":{"name":"sourceinfo"}}],[11,"fmt","","",434,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",434,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":{"name":"bool"}}],[11,"ne","","",434,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",434,null],[11,"encode","","",434,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",434,{"inputs":[{"name":"__d"}],"output":{"generics":["sourceinfo"],"name":"result"}}],[11,"hash","","",434,null],[11,"clone","","",459,{"inputs":[{"name":"self"}],"output":{"name":"mutability"}}],[11,"fmt","","",459,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",459,{"inputs":[{"name":"self"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",459,null],[11,"encode","","",459,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",459,{"inputs":[{"name":"__d"}],"output":{"generics":["mutability"],"name":"result"}}],[11,"clone","","",460,{"inputs":[{"name":"self"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",460,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",460,{"inputs":[{"name":"self"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",460,{"inputs":[{"name":"self"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",460,null],[11,"encode","","",460,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",460,{"inputs":[{"name":"__d"}],"output":{"generics":["borrowkind"],"name":"result"}}],[11,"allows_two_phase_borrow","","",460,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",435,{"inputs":[{"name":"self"}],"output":{"name":"local"}}],[11,"eq","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ne","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",435,null],[11,"hash","","",435,null],[11,"partial_cmp","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"le","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"gt","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ge","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"cmp","","",435,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"ordering"}}],[11,"decode","","",435,{"inputs":[{"name":"__d"}],"output":{"generics":["local"],"name":"result"}}],[11,"encode","","",435,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",435,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",435,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",435,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",461,{"inputs":[{"name":"self"},{"name":"localkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",461,null],[11,"fmt","","",461,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",436,{"inputs":[{"name":"self"}],"output":{"name":"localdecl"}}],[11,"fmt","","",436,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",436,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",436,{"inputs":[{"name":"__d"}],"output":{"generics":["localdecl"],"name":"result"}}],[11,"new_temp","","Create a new `LocalDecl` for a temporary.",436,{"inputs":[{"name":"ty"},{"name":"span"}],"output":{"name":"self"}}],[11,"new_internal","","Create a new `LocalDecl` for a internal temporary.",436,{"inputs":[{"name":"ty"},{"name":"span"}],"output":{"name":"self"}}],[11,"new_return_place","","Builds a `LocalDecl` for the return place.",436,{"inputs":[{"name":"ty"},{"name":"span"}],"output":{"name":"localdecl"}}],[11,"clone","","",437,{"inputs":[{"name":"self"}],"output":{"name":"upvardecl"}}],[11,"fmt","","",437,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",437,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",437,{"inputs":[{"name":"__d"}],"output":{"generics":["upvardecl"],"name":"result"}}],[11,"clone","","",438,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"eq","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"ne","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",438,null],[11,"hash","","",438,null],[11,"partial_cmp","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"le","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"gt","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"ge","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"cmp","","",438,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"ordering"}}],[11,"decode","","",438,{"inputs":[{"name":"__d"}],"output":{"generics":["basicblock"],"name":"result"}}],[11,"encode","","",438,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",438,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",438,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",438,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"start_location","","",438,{"inputs":[{"name":"self"}],"output":{"name":"location"}}],[11,"clone","","",439,{"inputs":[{"name":"self"}],"output":{"name":"basicblockdata"}}],[11,"fmt","","",439,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",439,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",439,{"inputs":[{"name":"__d"}],"output":{"generics":["basicblockdata"],"name":"result"}}],[11,"clone","","",440,{"inputs":[{"name":"self"}],"output":{"name":"terminator"}}],[11,"fmt","","",440,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",440,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",440,{"inputs":[{"name":"__d"}],"output":{"generics":["terminator"],"name":"result"}}],[11,"clone","","",462,{"inputs":[{"name":"self"}],"output":{"name":"terminatorkind"}}],[11,"encode","","",462,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",462,{"inputs":[{"name":"__d"}],"output":{"generics":["terminatorkind"],"name":"result"}}],[11,"successors","","",440,{"inputs":[{"name":"self"}],"output":{"name":"successors"}}],[11,"successors_mut","","",440,{"inputs":[{"name":"self"}],"output":{"name":"successorsmut"}}],[11,"unwind_mut","","",440,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"option"}}],[11,"if_","","",462,{"inputs":[{"name":"tyctxt"},{"name":"operand"},{"name":"basicblock"},{"name":"basicblock"}],"output":{"name":"terminatorkind"}}],[11,"successors","","",462,{"inputs":[{"name":"self"}],"output":{"name":"successors"}}],[11,"successors_mut","","",462,{"inputs":[{"name":"self"}],"output":{"name":"successorsmut"}}],[11,"unwind_mut","","",462,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"option"}}],[11,"new","","",439,{"inputs":[{"generics":["terminator"],"name":"option"}],"output":{"name":"basicblockdata"}}],[11,"terminator","","Accessor for terminator.",439,{"inputs":[{"name":"self"}],"output":{"name":"terminator"}}],[11,"terminator_mut","","",439,{"inputs":[{"name":"self"}],"output":{"name":"terminator"}}],[11,"retain_statements","","",439,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"expand_statements","","",439,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"visitable","","",439,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"mirvisitable"}}],[11,"fmt","","",462,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt_head","","Write the \"head\" part of the terminator; that is, its name and the data it uses to pick the successor basic block, if any. The only information not included is the list of possible successors, which may be rendered differently between the text and the graphviz format.",462,{"inputs":[{"name":"self"},{"name":"w"}],"output":{"name":"result"}}],[11,"fmt_successor_labels","","Return the list of labels for the edges to the successor basic blocks.",462,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"vec"}}],[11,"clone","","",441,{"inputs":[{"name":"self"}],"output":{"name":"statement"}}],[11,"encode","","",441,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",441,{"inputs":[{"name":"__d"}],"output":{"generics":["statement"],"name":"result"}}],[11,"make_nop","","Changes a statement to a nop. This is both faster than deleting instructions and avoids invalidating statement indices in `Location`s.",441,{"inputs":[{"name":"self"}],"output":null}],[11,"replace_nop","","Changes a statement to a nop and returns the original statement.",441,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"clone","","",463,{"inputs":[{"name":"self"}],"output":{"name":"statementkind"}}],[11,"fmt","","",463,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",463,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",463,{"inputs":[{"name":"__d"}],"output":{"generics":["statementkind"],"name":"result"}}],[11,"clone","","",464,{"inputs":[{"name":"self"}],"output":{"name":"validationop"}}],[11,"encode","","",464,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",464,{"inputs":[{"name":"__d"}],"output":{"generics":["validationop"],"name":"result"}}],[11,"eq","","",464,{"inputs":[{"name":"self"},{"name":"validationop"}],"output":{"name":"bool"}}],[11,"ne","","",464,{"inputs":[{"name":"self"},{"name":"validationop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",464,null],[11,"fmt","","",464,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",442,{"inputs":[{"name":"self"}],"output":{"name":"validationoperand"}}],[11,"encode","","",442,{"inputs":[{"name":"self"},{"name":"__st"}],"output":{"name":"result"}}],[11,"decode","","",442,{"inputs":[{"name":"__dt"}],"output":{"generics":["validationoperand"],"name":"result"}}],[11,"fmt","","",442,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",441,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",465,{"inputs":[{"name":"self"}],"output":{"name":"place"}}],[11,"eq","","",465,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"bool"}}],[11,"ne","","",465,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",465,null],[11,"hash","","",465,null],[11,"encode","","",465,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",465,{"inputs":[{"name":"__d"}],"output":{"generics":["place"],"name":"result"}}],[11,"clone","","",443,{"inputs":[{"name":"self"}],"output":{"name":"static"}}],[11,"eq","","",443,{"inputs":[{"name":"self"},{"name":"static"}],"output":{"name":"bool"}}],[11,"ne","","",443,{"inputs":[{"name":"self"},{"name":"static"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",443,null],[11,"hash","","",443,null],[11,"encode","","",443,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",443,{"inputs":[{"name":"__d"}],"output":{"generics":["static"],"name":"result"}}],[11,"hash_stable","","",443,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",444,{"inputs":[{"name":"self"}],"output":{"name":"projection"}}],[11,"fmt","","",444,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",444,{"inputs":[{"name":"self"},{"name":"projection"}],"output":{"name":"bool"}}],[11,"ne","","",444,{"inputs":[{"name":"self"},{"name":"projection"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",444,null],[11,"hash","","",444,null],[11,"encode","","",444,{"inputs":[{"name":"self"},{"name":"__sbvt"}],"output":{"name":"result"}}],[11,"decode","","",444,{"inputs":[{"name":"__dbvt"}],"output":{"generics":["projection"],"name":"result"}}],[11,"clone","","",466,{"inputs":[{"name":"self"}],"output":{"name":"projectionelem"}}],[11,"fmt","","",466,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",466,{"inputs":[{"name":"self"},{"name":"projectionelem"}],"output":{"name":"bool"}}],[11,"ne","","",466,{"inputs":[{"name":"self"},{"name":"projectionelem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",466,null],[11,"hash","","",466,null],[11,"encode","","",466,{"inputs":[{"name":"self"},{"name":"__svt"}],"output":{"name":"result"}}],[11,"decode","","",466,{"inputs":[{"name":"__dvt"}],"output":{"generics":["projectionelem"],"name":"result"}}],[11,"clone","","",445,{"inputs":[{"name":"self"}],"output":{"name":"field"}}],[11,"eq","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",445,null],[11,"hash","","",445,null],[11,"partial_cmp","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"le","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"gt","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ge","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"cmp","","",445,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"ordering"}}],[11,"decode","","",445,{"inputs":[{"name":"__d"}],"output":{"generics":["field"],"name":"result"}}],[11,"encode","","",445,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",445,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",445,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",445,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"field","","",465,{"inputs":[{"name":"self"},{"name":"field"},{"name":"ty"}],"output":{"name":"place"}}],[11,"deref","","",465,{"inputs":[{"name":"self"}],"output":{"name":"place"}}],[11,"downcast","","",465,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"usize"}],"output":{"name":"place"}}],[11,"index","","",465,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"place"}}],[11,"elem","","",465,{"inputs":[{"name":"self"},{"name":"placeelem"}],"output":{"name":"place"}}],[11,"fmt","","",465,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",446,{"inputs":[{"name":"self"}],"output":{"name":"visibilityscope"}}],[11,"eq","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"bool"}}],[11,"ne","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",446,null],[11,"hash","","",446,null],[11,"partial_cmp","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"bool"}}],[11,"le","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"bool"}}],[11,"gt","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"bool"}}],[11,"ge","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"bool"}}],[11,"cmp","","",446,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":{"name":"ordering"}}],[11,"decode","","",446,{"inputs":[{"name":"__d"}],"output":{"generics":["visibilityscope"],"name":"result"}}],[11,"encode","","",446,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",446,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",446,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",446,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",447,{"inputs":[{"name":"self"}],"output":{"name":"visibilityscopedata"}}],[11,"fmt","","",447,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",447,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",447,{"inputs":[{"name":"__d"}],"output":{"generics":["visibilityscopedata"],"name":"result"}}],[11,"clone","","",467,{"inputs":[{"name":"self"}],"output":{"name":"operand"}}],[11,"eq","","",467,{"inputs":[{"name":"self"},{"name":"operand"}],"output":{"name":"bool"}}],[11,"ne","","",467,{"inputs":[{"name":"self"},{"name":"operand"}],"output":{"name":"bool"}}],[11,"encode","","",467,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",467,{"inputs":[{"name":"__d"}],"output":{"generics":["operand"],"name":"result"}}],[11,"fmt","","",467,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"function_handle","","",467,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"substs"},{"name":"span"}],"output":{"name":"self"}}],[11,"to_copy","","",467,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"clone","","",468,{"inputs":[{"name":"self"}],"output":{"name":"rvalue"}}],[11,"encode","","",468,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",468,{"inputs":[{"name":"__d"}],"output":{"generics":["rvalue"],"name":"result"}}],[11,"clone","","",469,{"inputs":[{"name":"self"}],"output":{"name":"castkind"}}],[11,"fmt","","",469,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",469,{"inputs":[{"name":"self"},{"name":"castkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",469,null],[11,"encode","","",469,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",469,{"inputs":[{"name":"__d"}],"output":{"generics":["castkind"],"name":"result"}}],[11,"clone","","",470,{"inputs":[{"name":"self"}],"output":{"name":"aggregatekind"}}],[11,"fmt","","",470,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",470,{"inputs":[{"name":"self"},{"name":"aggregatekind"}],"output":{"name":"bool"}}],[11,"ne","","",470,{"inputs":[{"name":"self"},{"name":"aggregatekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",470,null],[11,"encode","","",470,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",470,{"inputs":[{"name":"__d"}],"output":{"generics":["aggregatekind"],"name":"result"}}],[11,"clone","","",471,{"inputs":[{"name":"self"}],"output":{"name":"binop"}}],[11,"fmt","","",471,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",471,{"inputs":[{"name":"self"},{"name":"binop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",471,null],[11,"encode","","",471,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",471,{"inputs":[{"name":"__d"}],"output":{"generics":["binop"],"name":"result"}}],[11,"is_checkable","","",471,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",472,{"inputs":[{"name":"self"}],"output":{"name":"nullop"}}],[11,"fmt","","",472,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",472,{"inputs":[{"name":"self"},{"name":"nullop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",472,null],[11,"encode","","",472,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",472,{"inputs":[{"name":"__d"}],"output":{"generics":["nullop"],"name":"result"}}],[11,"clone","","",473,{"inputs":[{"name":"self"}],"output":{"name":"unop"}}],[11,"fmt","","",473,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",473,{"inputs":[{"name":"self"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",473,null],[11,"encode","","",473,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",473,{"inputs":[{"name":"__d"}],"output":{"generics":["unop"],"name":"result"}}],[11,"fmt","","",468,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",448,{"inputs":[{"name":"self"}],"output":{"name":"constant"}}],[11,"eq","","",448,{"inputs":[{"name":"self"},{"name":"constant"}],"output":{"name":"bool"}}],[11,"ne","","",448,{"inputs":[{"name":"self"},{"name":"constant"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",448,null],[11,"hash","","",448,null],[11,"encode","","",448,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",448,{"inputs":[{"name":"__d"}],"output":{"generics":["constant"],"name":"result"}}],[11,"clone","","",449,{"inputs":[{"name":"self"}],"output":{"name":"promoted"}}],[11,"eq","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"bool"}}],[11,"ne","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",449,null],[11,"hash","","",449,null],[11,"partial_cmp","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"bool"}}],[11,"le","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"bool"}}],[11,"gt","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"bool"}}],[11,"ge","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"bool"}}],[11,"cmp","","",449,{"inputs":[{"name":"self"},{"name":"promoted"}],"output":{"name":"ordering"}}],[11,"decode","","",449,{"inputs":[{"name":"__d"}],"output":{"generics":["promoted"],"name":"result"}}],[11,"encode","","",449,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",449,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",449,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",449,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",474,{"inputs":[{"name":"self"}],"output":{"name":"literal"}}],[11,"eq","","",474,{"inputs":[{"name":"self"},{"name":"literal"}],"output":{"name":"bool"}}],[11,"ne","","",474,{"inputs":[{"name":"self"},{"name":"literal"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",474,null],[11,"hash","","",474,null],[11,"encode","","",474,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",474,{"inputs":[{"name":"__d"}],"output":{"generics":["literal"],"name":"result"}}],[11,"fmt","","",448,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",474,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"num_nodes","","",432,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_node","","",432,null],[11,"predecessors","","",432,null],[11,"successors","","",432,null],[11,"clone","","",450,{"inputs":[{"name":"self"}],"output":{"name":"location"}}],[11,"eq","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"bool"}}],[11,"ne","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",450,null],[11,"hash","","",450,null],[11,"cmp","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"bool"}}],[11,"le","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"bool"}}],[11,"gt","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"bool"}}],[11,"ge","","",450,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"bool"}}],[11,"fmt","","",450,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"START","","",450,null],[11,"successor_within_block","","Returns the location immediately after this one within the enclosing block.",450,{"inputs":[{"name":"self"}],"output":{"name":"location"}}],[11,"dominates","","",450,{"inputs":[{"name":"self"},{"name":"location"},{"name":"dominators"}],"output":{"name":"bool"}}],[11,"clone","","",475,{"inputs":[{"name":"self"}],"output":{"name":"unsafetyviolationkind"}}],[11,"fmt","","",475,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",475,{"inputs":[{"name":"self"},{"name":"unsafetyviolationkind"}],"output":{"name":"bool"}}],[11,"ne","","",475,{"inputs":[{"name":"self"},{"name":"unsafetyviolationkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",475,null],[11,"hash","","",475,null],[11,"encode","","",475,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",475,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafetyviolationkind"],"name":"result"}}],[11,"clone","","",451,{"inputs":[{"name":"self"}],"output":{"name":"unsafetyviolation"}}],[11,"fmt","","",451,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",451,{"inputs":[{"name":"self"},{"name":"unsafetyviolation"}],"output":{"name":"bool"}}],[11,"ne","","",451,{"inputs":[{"name":"self"},{"name":"unsafetyviolation"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",451,null],[11,"hash","","",451,null],[11,"encode","","",451,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",451,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafetyviolation"],"name":"result"}}],[11,"clone","","",452,{"inputs":[{"name":"self"}],"output":{"name":"unsafetycheckresult"}}],[11,"fmt","","",452,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",452,{"inputs":[{"name":"self"},{"name":"unsafetycheckresult"}],"output":{"name":"bool"}}],[11,"ne","","",452,{"inputs":[{"name":"self"},{"name":"unsafetycheckresult"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",452,null],[11,"hash","","",452,null],[11,"encode","","",452,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",452,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafetycheckresult"],"name":"result"}}],[11,"clone","","",453,{"inputs":[{"name":"self"}],"output":{"name":"generatorlayout"}}],[11,"fmt","","",453,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",453,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",453,{"inputs":[{"name":"__d"}],"output":{"generics":["generatorlayout"],"name":"result"}}],[11,"clone","","",454,{"inputs":[{"name":"self"}],"output":{"name":"borrowcheckresult"}}],[11,"fmt","","",454,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",454,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",454,{"inputs":[{"name":"__d"}],"output":{"generics":["borrowcheckresult"],"name":"result"}}],[11,"clone","","",455,{"inputs":[{"name":"self"}],"output":{"name":"closureregionrequirements"}}],[11,"fmt","","",455,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",455,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",455,{"inputs":[{"name":"__d"}],"output":{"generics":["closureregionrequirements"],"name":"result"}}],[11,"clone","","",456,{"inputs":[{"name":"self"}],"output":{"name":"closureoutlivesrequirement"}}],[11,"fmt","","",456,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",456,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",456,{"inputs":[{"name":"__d"}],"output":{"generics":["closureoutlivesrequirement"],"name":"result"}}],[11,"clone","","",476,{"inputs":[{"name":"self"}],"output":{"name":"closureoutlivessubject"}}],[11,"fmt","","",476,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",476,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",476,{"inputs":[{"name":"__d"}],"output":{"generics":["closureoutlivessubject"],"name":"result"}}],[11,"super_fold_with","","",459,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"mutability"}}],[11,"super_visit_with","","",459,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",434,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"sourceinfo"}}],[11,"super_visit_with","","",434,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",437,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"upvardecl"}}],[11,"super_visit_with","","",437,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",464,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"validationop"}}],[11,"super_visit_with","","",464,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",447,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"visibilityscopedata"}}],[11,"super_visit_with","","",447,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",446,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"visibilityscope"}}],[11,"super_visit_with","","",446,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",433,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"visibilityscopeinfo"}}],[11,"super_visit_with","","",433,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",459,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",434,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",437,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",464,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",447,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",446,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",433,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"super_fold_with","","",432,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",432,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",453,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",453,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",436,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",436,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",439,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",439,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",442,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",442,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",441,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",441,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",463,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",463,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",458,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",458,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",440,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",440,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",465,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",465,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",468,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",468,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",467,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",467,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",444,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",444,{"inputs":[{"name":"self"},{"name":"vs"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",445,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",445,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",448,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",448,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",474,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",474,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[0,"session","rustc","",null,null],[3,"CodeStats","rustc::session","",null,null],[12,"type_sizes","","",510,null],[3,"FieldInfo","","",null,null],[12,"name","","",511,null],[12,"offset","","",511,null],[12,"size","","",511,null],[12,"align","","",511,null],[3,"TypeSizeInfo","","",null,null],[12,"kind","","",512,null],[12,"type_description","","",512,null],[12,"align","","",512,null],[12,"overall_size","","",512,null],[12,"packed","","",512,null],[12,"opt_discr_size","","",512,null],[12,"variants","","",512,null],[3,"VariantInfo","","",null,null],[12,"name","","",513,null],[12,"kind","","",513,null],[12,"size","","",513,null],[12,"align","","",513,null],[12,"fields","","",513,null],[3,"Session","","Represents the data associated with a compilation session for a single crate.",null,null],[12,"target","","",514,null],[12,"host","","",514,null],[12,"opts","","",514,null],[12,"parse_sess","","",514,null],[12,"entry_fn","","For a library crate, this is always none",514,null],[12,"plugin_registrar_fn","","",514,null],[12,"derive_registrar_fn","","",514,null],[12,"default_sysroot","","",514,null],[12,"local_crate_source_file","","The name of the root source file of the crate, in the local file system. `None` means that there is no source file.",514,null],[12,"working_dir","","The directory the compiler has been executed in plus a flag indicating if the value stored here has been affected by path remapping.",514,null],[12,"lint_store","","",514,null],[12,"buffered_lints","","",514,null],[12,"one_time_diagnostics","","Set of (DiagnosticId, Option, message) tuples tracking (sub)diagnostics that have been set once, but should not be set again, in order to avoid redundantly verbose output (Issue #24690, #44953).",514,null],[12,"plugin_llvm_passes","","",514,null],[12,"plugin_attributes","","",514,null],[12,"crate_types","","",514,null],[12,"dependency_formats","","",514,null],[12,"crate_disambiguator","","The crate_disambiguator is constructed out of all the `-C metadata` arguments passed to the compiler. Its value together with the crate-name forms a unique global identifier for the crate. It is used to allow multiple crates with the same name to coexist. See the trans::back::symbol_names module for more information.",514,null],[12,"features","","",514,null],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive operations such as auto-dereference and monomorphization.",514,null],[12,"type_length_limit","","The maximum length of types during monomorphization.",514,null],[12,"const_eval_stack_frame_limit","","The maximum number of stackframes allowed in const eval",514,null],[12,"injected_allocator","","The metadata::creader module may inject an allocator/panic_runtime dependency if it didn't already find one, and this tracks what was injected.",514,null],[12,"allocator_kind","","",514,null],[12,"injected_panic_runtime","","",514,null],[12,"imported_macro_spans","","Map from imported macro spans (which consist of the localized span for the macro body) to the macro name and definition span in the source crate.",514,null],[12,"incr_comp_session","","",514,null],[12,"ignored_attr_names","","A cache of attributes ignored by StableHashingContext",514,null],[12,"profile_channel","","Used by -Z profile-queries in util::common",514,null],[12,"perf_stats","","Some measurements that are being gathered during compilation.",514,null],[12,"code_stats","","Data about code being compiled, gathered during compilation.",514,null],[12,"next_node_id","","",514,null],[12,"optimization_fuel_crate","","If -zfuel=crate=n is specified, Some(crate).",514,null],[12,"optimization_fuel_limit","","If -zfuel=crate=n is specified, initially set to n. Otherwise 0.",514,null],[12,"out_of_fuel","","We're rejecting all further optimizations.",514,null],[12,"print_fuel_crate","","If -zprint-fuel=crate, Some(crate).",514,null],[12,"print_fuel","","Always set to zero and incremented so that we can print fuel expended by a crate.",514,null],[12,"jobserver","","Loaded up early on in the initialization of this `Session` to avoid false positives about a job server in our environment.",514,null],[12,"has_global_allocator","","Metadata about the allocators for the current crate being compiled",514,null],[3,"PerfStats","","",null,null],[12,"symbol_hash_time","","The accumulated time spent on computing symbol hashes",515,null],[12,"decode_def_path_tables_time","","The accumulated time spent decoding def path tables from metadata",515,null],[12,"queries_canonicalized","","Total number of values canonicalized queries constructed.",515,null],[12,"normalize_ty_after_erasing_regions","","Number of times this query is invoked.",515,null],[12,"normalize_projection_ty","","Number of times this query is invoked.",515,null],[3,"CrateDisambiguator","","Hash value constructed out of all the `-C metadata` arguments passed to the compiler. Together with the crate-name forms a unique global identifier for the crate.",null,null],[12,"0","","",516,null],[4,"DataTypeKind","","",null,null],[13,"Struct","","",517,null],[13,"Union","","",517,null],[13,"Enum","","",517,null],[13,"Closure","","",517,null],[4,"SizeKind","","",null,null],[13,"Exact","","",518,null],[13,"Min","","",518,null],[4,"DiagnosticBuilderMethod","","Enum to support dispatch of one-time diagnostics (in Session.diag_once)",null,null],[13,"Note","","",519,null],[13,"SpanNote","","",519,null],[13,"SpanSuggestion","","",519,null],[4,"DiagnosticMessageId","","Diagnostic message ID—used by `Session.one_time_diagnostics` to avoid emitting the same message more than once",null,null],[13,"ErrorId","","",520,null],[13,"LintId","","",520,null],[13,"StabilityId","","",520,null],[4,"IncrCompSession","","Holds data on the current incremental compilation session, if there is one.",null,null],[13,"NotInitialized","","This is the state the session will be in until the incr. comp. dir is needed.",521,null],[13,"Active","","This is the state during which the session directory is private and can be modified.",521,null],[12,"session_directory","rustc::session::IncrCompSession","",521,null],[12,"lock_file","","",521,null],[12,"load_dep_graph","","",521,null],[13,"Finalized","rustc::session","This is the state after the session directory has been finalized. In this state, the contents of the directory must not be modified any more.",521,null],[12,"session_directory","rustc::session::IncrCompSession","",521,null],[13,"InvalidBecauseOfErrors","rustc::session","This is an error state that is reached when some compilation error has occurred. It indicates that the contents of the session directory must not be used, since they might be invalid.",521,null],[12,"session_directory","rustc::session::IncrCompSession","",521,null],[4,"CompileIncomplete","rustc::session","",null,null],[13,"Stopped","","",522,null],[13,"Errored","","",522,null],[5,"build_session","","",null,{"inputs":[{"name":"options"},{"generics":["pathbuf"],"name":"option"},{"name":"registry"}],"output":{"name":"session"}}],[5,"build_session_with_codemap","","",null,{"inputs":[{"name":"options"},{"generics":["pathbuf"],"name":"option"},{"name":"registry"},{"generics":["codemap"],"name":"lrc"},{"generics":["box"],"name":"option"}],"output":{"name":"session"}}],[5,"build_session_","","",null,{"inputs":[{"name":"options"},{"generics":["pathbuf"],"name":"option"},{"name":"handler"},{"generics":["codemap"],"name":"lrc"}],"output":{"name":"session"}}],[5,"early_error","","",null,null],[5,"early_warn","","",null,{"inputs":[{"name":"erroroutputtype"},{"name":"str"}],"output":null}],[5,"compile_result_from_err_count","","",null,{"inputs":[{"name":"usize"}],"output":{"name":"compileresult"}}],[5,"bug_fmt","","",null,null],[5,"span_bug_fmt","","",null,null],[5,"opt_span_bug_fmt","","",null,null],[0,"code_stats","","",null,null],[3,"VariantInfo","rustc::session::code_stats","",null,null],[12,"name","","",513,null],[12,"kind","","",513,null],[12,"size","","",513,null],[12,"align","","",513,null],[12,"fields","","",513,null],[3,"FieldInfo","","",null,null],[12,"name","","",511,null],[12,"offset","","",511,null],[12,"size","","",511,null],[12,"align","","",511,null],[3,"TypeSizeInfo","","",null,null],[12,"kind","","",512,null],[12,"type_description","","",512,null],[12,"align","","",512,null],[12,"overall_size","","",512,null],[12,"packed","","",512,null],[12,"opt_discr_size","","",512,null],[12,"variants","","",512,null],[3,"CodeStats","","",null,null],[12,"type_sizes","","",510,null],[4,"SizeKind","","",null,null],[13,"Exact","","",518,null],[13,"Min","","",518,null],[4,"DataTypeKind","","",null,null],[13,"Struct","","",517,null],[13,"Union","","",517,null],[13,"Enum","","",517,null],[13,"Closure","","",517,null],[11,"clone","rustc::session","",513,{"inputs":[{"name":"self"}],"output":{"name":"variantinfo"}}],[11,"eq","","",513,{"inputs":[{"name":"self"},{"name":"variantinfo"}],"output":{"name":"bool"}}],[11,"ne","","",513,{"inputs":[{"name":"self"},{"name":"variantinfo"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",513,null],[11,"hash","","",513,null],[11,"fmt","","",513,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",518,{"inputs":[{"name":"self"}],"output":{"name":"sizekind"}}],[11,"eq","","",518,{"inputs":[{"name":"self"},{"name":"sizekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",518,null],[11,"hash","","",518,null],[11,"fmt","","",518,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",511,{"inputs":[{"name":"self"}],"output":{"name":"fieldinfo"}}],[11,"eq","","",511,{"inputs":[{"name":"self"},{"name":"fieldinfo"}],"output":{"name":"bool"}}],[11,"ne","","",511,{"inputs":[{"name":"self"},{"name":"fieldinfo"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",511,null],[11,"hash","","",511,null],[11,"fmt","","",511,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",517,{"inputs":[{"name":"adtkind"}],"output":{"name":"self"}}],[11,"clone","","",517,{"inputs":[{"name":"self"}],"output":{"name":"datatypekind"}}],[11,"eq","","",517,{"inputs":[{"name":"self"},{"name":"datatypekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",517,null],[11,"hash","","",517,null],[11,"fmt","","",517,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",512,{"inputs":[{"name":"self"},{"name":"typesizeinfo"}],"output":{"name":"bool"}}],[11,"ne","","",512,{"inputs":[{"name":"self"},{"name":"typesizeinfo"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",512,null],[11,"hash","","",512,null],[11,"fmt","","",512,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",510,{"inputs":[{"name":"self"},{"name":"codestats"}],"output":{"name":"bool"}}],[11,"ne","","",510,{"inputs":[{"name":"self"},{"name":"codestats"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",510,null],[11,"fmt","","",510,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",510,{"inputs":[],"output":{"name":"self"}}],[11,"record_type_size","","",510,{"inputs":[{"name":"self"},{"name":"datatypekind"},{"name":"s"},{"name":"align"},{"name":"size"},{"name":"bool"},{"generics":["size"],"name":"option"},{"generics":["variantinfo"],"name":"vec"}],"output":null}],[11,"print_type_sizes","","",510,{"inputs":[{"name":"self"}],"output":null}],[0,"config","","Contains infrastructure for configuring the compiler, including parsing command line options.",null,null],[3,"Config","rustc::session::config","",null,null],[12,"target","","",523,null],[12,"isize_ty","","",523,null],[12,"usize_ty","","",523,null],[3,"OutputTypes","","",null,null],[12,"0","","",524,null],[3,"Externs","","",null,null],[12,"0","","",525,null],[3,"Options","","",null,null],[12,"crate_types","","",526,null],[12,"optimize","","",526,null],[12,"debug_assertions","","",526,null],[12,"debuginfo","","",526,null],[12,"lint_opts","","",526,null],[12,"lint_cap","","",526,null],[12,"describe_lints","","",526,null],[12,"output_types","","",526,null],[12,"search_paths","","",526,null],[12,"libs","","",526,null],[12,"maybe_sysroot","","",526,null],[12,"target_triple","","",526,null],[12,"test","","",526,null],[12,"error_format","","",526,null],[12,"incremental","","",526,null],[12,"debugging_opts","","",526,null],[12,"prints","","",526,null],[12,"borrowck_mode","","",526,null],[12,"cg","","",526,null],[12,"externs","","",526,null],[12,"crate_name","","",526,null],[12,"alt_std_name","","",526,null],[12,"unstable_features","","",526,null],[12,"actually_rustdoc","","",526,null],[12,"cli_forced_codegen_units","","",526,null],[12,"cli_forced_thinlto_off","","",526,null],[12,"remap_path_prefix","","",526,null],[12,"edition","","",526,null],[3,"OutputFilenames","","",null,null],[12,"out_directory","","",527,null],[12,"out_filestem","","",527,null],[12,"single_output_file","","",527,null],[12,"extra","","",527,null],[12,"outputs","","",527,null],[3,"CodegenOptions","","",null,null],[12,"ar","","",528,null],[12,"linker","","",528,null],[12,"link_arg","","",528,null],[12,"link_args","","",528,null],[12,"link_dead_code","","",528,null],[12,"lto","","",528,null],[12,"target_cpu","","",528,null],[12,"target_feature","","",528,null],[12,"passes","","",528,null],[12,"llvm_args","","",528,null],[12,"save_temps","","",528,null],[12,"rpath","","",528,null],[12,"overflow_checks","","",528,null],[12,"no_prepopulate_passes","","",528,null],[12,"no_vectorize_loops","","",528,null],[12,"no_vectorize_slp","","",528,null],[12,"soft_float","","",528,null],[12,"prefer_dynamic","","",528,null],[12,"no_integrated_as","","",528,null],[12,"no_redzone","","",528,null],[12,"relocation_model","","",528,null],[12,"code_model","","",528,null],[12,"metadata","","",528,null],[12,"extra_filename","","",528,null],[12,"codegen_units","","",528,null],[12,"remark","","",528,null],[12,"no_stack_check","","",528,null],[12,"debuginfo","","",528,null],[12,"opt_level","","",528,null],[12,"force_frame_pointers","","",528,null],[12,"debug_assertions","","",528,null],[12,"inline_threshold","","",528,null],[12,"panic","","",528,null],[12,"incremental","","",528,null],[3,"DebuggingOptions","","",null,null],[12,"codegen_backend","","",529,null],[12,"verbose","","",529,null],[12,"span_free_formats","","",529,null],[12,"identify_regions","","",529,null],[12,"emit_end_regions","","",529,null],[12,"borrowck","","",529,null],[12,"two_phase_borrows","","",529,null],[12,"two_phase_beyond_autoref","","",529,null],[12,"time_passes","","",529,null],[12,"count_llvm_insns","","",529,null],[12,"time_llvm_passes","","",529,null],[12,"input_stats","","",529,null],[12,"trans_stats","","",529,null],[12,"asm_comments","","",529,null],[12,"no_verify","","",529,null],[12,"borrowck_stats","","",529,null],[12,"no_landing_pads","","",529,null],[12,"fewer_names","","",529,null],[12,"meta_stats","","",529,null],[12,"print_link_args","","",529,null],[12,"print_llvm_passes","","",529,null],[12,"ast_json","","",529,null],[12,"query_threads","","",529,null],[12,"ast_json_noexpand","","",529,null],[12,"ls","","",529,null],[12,"save_analysis","","",529,null],[12,"flowgraph_print_loans","","",529,null],[12,"flowgraph_print_moves","","",529,null],[12,"flowgraph_print_assigns","","",529,null],[12,"flowgraph_print_all","","",529,null],[12,"print_region_graph","","",529,null],[12,"parse_only","","",529,null],[12,"no_trans","","",529,null],[12,"treat_err_as_bug","","",529,null],[12,"external_macro_backtrace","","",529,null],[12,"teach","","",529,null],[12,"continue_parse_after_error","","",529,null],[12,"incremental","","",529,null],[12,"incremental_queries","","",529,null],[12,"incremental_info","","",529,null],[12,"incremental_dump_hash","","",529,null],[12,"incremental_verify_ich","","",529,null],[12,"incremental_ignore_spans","","",529,null],[12,"dump_dep_graph","","",529,null],[12,"query_dep_graph","","",529,null],[12,"profile_queries","","",529,null],[12,"profile_queries_and_keys","","",529,null],[12,"no_analysis","","",529,null],[12,"extra_plugins","","",529,null],[12,"unstable_options","","",529,null],[12,"force_overflow_checks","","",529,null],[12,"trace_macros","","",529,null],[12,"debug_macros","","",529,null],[12,"enable_nonzeroing_move_hints","","",529,null],[12,"keep_hygiene_data","","",529,null],[12,"keep_ast","","",529,null],[12,"show_span","","",529,null],[12,"print_type_sizes","","",529,null],[12,"print_trans_items","","",529,null],[12,"mir_opt_level","","",529,null],[12,"mutable_noalias","","",529,null],[12,"arg_align_attributes","","",529,null],[12,"dump_mir","","",529,null],[12,"dump_mir_dir","","",529,null],[12,"dump_mir_graphviz","","",529,null],[12,"dump_mir_exclude_pass_number","","",529,null],[12,"mir_emit_validate","","",529,null],[12,"perf_stats","","",529,null],[12,"hir_stats","","",529,null],[12,"mir_stats","","",529,null],[12,"always_encode_mir","","",529,null],[12,"osx_rpath_install_name","","",529,null],[12,"sanitizer","","",529,null],[12,"linker_flavor","","",529,null],[12,"fuel","","",529,null],[12,"print_fuel","","",529,null],[12,"force_unstable_if_unmarked","","",529,null],[12,"pre_link_arg","","",529,null],[12,"pre_link_args","","",529,null],[12,"profile","","",529,null],[12,"pgo_gen","","",529,null],[12,"pgo_use","","",529,null],[12,"disable_instrumentation_preinliner","","",529,null],[12,"relro_level","","",529,null],[12,"nll_subminimal_causes","","",529,null],[12,"nll_facts","","",529,null],[12,"disable_nll_user_type_assert","","",529,null],[12,"trans_time_graph","","",529,null],[12,"thinlto","","",529,null],[12,"inline_in_all_cgus","","",529,null],[12,"tls_model","","",529,null],[12,"saturating_float_casts","","",529,null],[12,"lower_128bit_ops","","",529,null],[12,"human_readable_cgu_names","","",529,null],[12,"dep_info_omit_d_target","","",529,null],[12,"suggestion_applicability","","",529,null],[12,"unpretty","","",529,null],[12,"run_dsymutil","","",529,null],[12,"ui_testing","","",529,null],[12,"embed_bitcode","","",529,null],[12,"strip_debuginfo_if_disabled","","",529,null],[12,"share_generics","","",529,null],[12,"chalk","","",529,null],[12,"cross_lang_lto","","",529,null],[3,"RustcOptGroup","","",null,null],[12,"apply","","",530,null],[12,"name","","",530,null],[12,"stability","","",530,null],[4,"Sanitizer","","",null,null],[13,"Address","","",531,null],[13,"Leak","","",531,null],[13,"Memory","","",531,null],[13,"Thread","","",531,null],[4,"OptLevel","","",null,null],[13,"No","","",532,null],[13,"Less","","",532,null],[13,"Default","","",532,null],[13,"Aggressive","","",532,null],[13,"Size","","",532,null],[13,"SizeMin","","",532,null],[4,"Lto","","",null,null],[13,"No","","Don't do any LTO whatsoever",533,null],[13,"Yes","","Do a full crate graph LTO. The flavor is determined by the compiler (currently the default is \"fat\").",533,null],[13,"Thin","","Do a full crate graph LTO with ThinLTO",533,null],[13,"ThinLocal","","Do a local graph LTO with ThinLTO (only relevant for multiple codegen units).",533,null],[13,"Fat","","Do a full crate graph LTO with \"fat\" LTO",533,null],[4,"DebugInfoLevel","","",null,null],[13,"NoDebugInfo","","",534,null],[13,"LimitedDebugInfo","","",534,null],[13,"FullDebugInfo","","",534,null],[4,"OutputType","","",null,null],[13,"Bitcode","","",535,null],[13,"Assembly","","",535,null],[13,"LlvmAssembly","","",535,null],[13,"Mir","","",535,null],[13,"Metadata","","",535,null],[13,"Object","","",535,null],[13,"Exe","","",535,null],[13,"DepInfo","","",535,null],[4,"ErrorOutputType","","",null,null],[13,"HumanReadable","","",536,null],[13,"Json","","",536,null],[13,"Short","","",536,null],[4,"PrintRequest","","",null,null],[13,"FileNames","","",537,null],[13,"Sysroot","","",537,null],[13,"CrateName","","",537,null],[13,"Cfg","","",537,null],[13,"TargetList","","",537,null],[13,"TargetCPUs","","",537,null],[13,"TargetFeatures","","",537,null],[13,"RelocationModels","","",537,null],[13,"CodeModels","","",537,null],[13,"TlsModels","","",537,null],[13,"TargetSpec","","",537,null],[13,"NativeStaticLibs","","",537,null],[4,"BorrowckMode","","",null,null],[13,"Ast","","",538,null],[13,"Mir","","",538,null],[13,"Compare","","",538,null],[4,"Input","","",null,null],[13,"File","","Load source from file",539,null],[13,"Str","","",539,null],[12,"name","rustc::session::config::Input","String that is shown in place of a filename",539,null],[12,"input","","Anonymous source string",539,null],[4,"EntryFnType","rustc::session::config","",null,null],[13,"EntryMain","","",540,null],[13,"EntryStart","","",540,null],[4,"CrateType","","",null,null],[13,"CrateTypeExecutable","","",541,null],[13,"CrateTypeDylib","","",541,null],[13,"CrateTypeRlib","","",541,null],[13,"CrateTypeStaticlib","","",541,null],[13,"CrateTypeCdylib","","",541,null],[13,"CrateTypeProcMacro","","",541,null],[4,"Passes","","",null,null],[13,"SomePasses","","",542,null],[13,"AllPasses","","",542,null],[4,"OptionStability","","",null,null],[13,"Stable","","",543,null],[13,"Unstable","","",543,null],[5,"host_triple","","",null,{"inputs":[],"output":{"name":"str"}}],[5,"basic_options","","Some reasonable defaults",null,{"inputs":[],"output":{"name":"options"}}],[5,"basic_codegen_options","","",null,{"inputs":[],"output":{"name":"codegenoptions"}}],[5,"build_codegen_options","","",null,{"inputs":[{"name":"matches"},{"name":"erroroutputtype"}],"output":{"name":"codegenoptions"}}],[5,"basic_debugging_options","","",null,{"inputs":[],"output":{"name":"debuggingoptions"}}],[5,"build_debugging_options","","",null,{"inputs":[{"name":"matches"},{"name":"erroroutputtype"}],"output":{"name":"debuggingoptions"}}],[5,"default_lib_output","","",null,{"inputs":[],"output":{"name":"cratetype"}}],[5,"default_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"crateconfig"}}],[5,"build_configuration","","",null,{"inputs":[{"name":"session"},{"name":"crateconfig"}],"output":{"name":"crateconfig"}}],[5,"build_target_config","","",null,{"inputs":[{"name":"options"},{"name":"handler"}],"output":{"name":"config"}}],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options, including metadata for each option, such as whether the option is part of the stable long-term interface for rustc.",null,{"inputs":[],"output":{"generics":["rustcoptgroup"],"name":"vec"}}],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for each option, such as whether the option is part of the stable long-term interface for rustc.",null,{"inputs":[],"output":{"generics":["rustcoptgroup"],"name":"vec"}}],[5,"parse_cfgspecs","","",null,{"inputs":[{"generics":["string"],"name":"vec"}],"output":{"name":"crateconfig"}}],[5,"build_session_options_and_crate_config","","",null,null],[5,"parse_crate_types_from_list","","",null,{"inputs":[{"generics":["string"],"name":"vec"}],"output":{"generics":["vec","string"],"name":"result"}}],[0,"cg_type_desc","","",null,null],[17,"parse_bool","rustc::session::config::cg_type_desc","",null,null],[17,"parse_opt_bool","","",null,null],[17,"parse_string","","",null,null],[17,"parse_string_push","","",null,null],[17,"parse_pathbuf_push","","",null,null],[17,"parse_opt_string","","",null,null],[17,"parse_opt_pathbuf","","",null,null],[17,"parse_list","","",null,null],[17,"parse_opt_list","","",null,null],[17,"parse_uint","","",null,null],[17,"parse_passes","","",null,null],[17,"parse_opt_uint","","",null,null],[17,"parse_panic_strategy","","",null,null],[17,"parse_relro_level","","",null,null],[17,"parse_sanitizer","","",null,null],[17,"parse_linker_flavor","","",null,null],[17,"parse_optimization_fuel","","",null,null],[17,"parse_unpretty","","",null,null],[17,"parse_lto","","",null,null],[0,"cgsetters","rustc::session::config","",null,null],[5,"ar","rustc::session::config::cgsetters","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"linker","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"link_arg","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"link_args","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"link_dead_code","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"lto","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"target_cpu","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"target_feature","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"passes","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"llvm_args","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"save_temps","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"rpath","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"overflow_checks","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_prepopulate_passes","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_vectorize_loops","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_vectorize_slp","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"soft_float","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"prefer_dynamic","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_integrated_as","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_redzone","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"relocation_model","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"code_model","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"metadata","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"extra_filename","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"codegen_units","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"remark","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_stack_check","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"debuginfo","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"opt_level","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"force_frame_pointers","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"debug_assertions","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"inline_threshold","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"panic","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental","","",null,{"inputs":[{"name":"codegenoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_bool","","",null,{"inputs":[{"name":"bool"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_bool","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_string","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_pathbuf","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_string","","",null,{"inputs":[{"name":"string"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_string_push","","",null,{"inputs":[{"name":"vec"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_pathbuf_push","","",null,{"inputs":[{"name":"vec"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_list","","",null,{"inputs":[{"name":"vec"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_list","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_uint","","",null,{"inputs":[{"name":"usize"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_uint","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_passes","","",null,{"inputs":[{"name":"passes"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_panic_strategy","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_relro_level","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_sanitizer","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_linker_flavor","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_optimization_fuel","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_unpretty","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_lto","","",null,{"inputs":[{"name":"lto"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[0,"db_type_desc","rustc::session::config","",null,null],[17,"parse_bool","rustc::session::config::db_type_desc","",null,null],[17,"parse_opt_bool","","",null,null],[17,"parse_string","","",null,null],[17,"parse_string_push","","",null,null],[17,"parse_pathbuf_push","","",null,null],[17,"parse_opt_string","","",null,null],[17,"parse_opt_pathbuf","","",null,null],[17,"parse_list","","",null,null],[17,"parse_opt_list","","",null,null],[17,"parse_uint","","",null,null],[17,"parse_passes","","",null,null],[17,"parse_opt_uint","","",null,null],[17,"parse_panic_strategy","","",null,null],[17,"parse_relro_level","","",null,null],[17,"parse_sanitizer","","",null,null],[17,"parse_linker_flavor","","",null,null],[17,"parse_optimization_fuel","","",null,null],[17,"parse_unpretty","","",null,null],[17,"parse_lto","","",null,null],[0,"dbsetters","rustc::session::config","",null,null],[5,"codegen_backend","rustc::session::config::dbsetters","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"verbose","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"span_free_formats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"identify_regions","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"emit_end_regions","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"borrowck","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"two_phase_borrows","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"two_phase_beyond_autoref","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"time_passes","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"count_llvm_insns","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"time_llvm_passes","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"input_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"trans_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"asm_comments","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_verify","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"borrowck_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_landing_pads","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"fewer_names","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"meta_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"print_link_args","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"print_llvm_passes","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"ast_json","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"query_threads","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"ast_json_noexpand","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"ls","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"save_analysis","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"flowgraph_print_loans","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"flowgraph_print_moves","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"flowgraph_print_assigns","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"flowgraph_print_all","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"print_region_graph","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_only","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_trans","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"treat_err_as_bug","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"external_macro_backtrace","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"teach","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"continue_parse_after_error","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental_queries","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental_info","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental_dump_hash","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental_verify_ich","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"incremental_ignore_spans","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"dump_dep_graph","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"query_dep_graph","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"profile_queries","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"profile_queries_and_keys","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"no_analysis","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"extra_plugins","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"unstable_options","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"force_overflow_checks","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"trace_macros","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"debug_macros","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"enable_nonzeroing_move_hints","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"keep_hygiene_data","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"keep_ast","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"show_span","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"print_type_sizes","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"print_trans_items","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"mir_opt_level","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"mutable_noalias","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"arg_align_attributes","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"dump_mir","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"dump_mir_dir","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"dump_mir_graphviz","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"dump_mir_exclude_pass_number","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"mir_emit_validate","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"perf_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"hir_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"mir_stats","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"always_encode_mir","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"osx_rpath_install_name","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"sanitizer","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"linker_flavor","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"fuel","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"print_fuel","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"force_unstable_if_unmarked","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"pre_link_arg","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"pre_link_args","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"profile","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"pgo_gen","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"pgo_use","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"disable_instrumentation_preinliner","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"relro_level","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"nll_subminimal_causes","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"nll_facts","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"disable_nll_user_type_assert","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"trans_time_graph","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"thinlto","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"inline_in_all_cgus","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"tls_model","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"saturating_float_casts","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"lower_128bit_ops","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"human_readable_cgu_names","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"dep_info_omit_d_target","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"suggestion_applicability","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"unpretty","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"run_dsymutil","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"ui_testing","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"embed_bitcode","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"strip_debuginfo_if_disabled","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"share_generics","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"chalk","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"cross_lang_lto","","",null,{"inputs":[{"name":"debuggingoptions"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_bool","","",null,{"inputs":[{"name":"bool"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_bool","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_string","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_pathbuf","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_string","","",null,{"inputs":[{"name":"string"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_string_push","","",null,{"inputs":[{"name":"vec"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_pathbuf_push","","",null,{"inputs":[{"name":"vec"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_list","","",null,{"inputs":[{"name":"vec"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_list","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_uint","","",null,{"inputs":[{"name":"usize"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_opt_uint","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_passes","","",null,{"inputs":[{"name":"passes"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_panic_strategy","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_relro_level","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_sanitizer","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_linker_flavor","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_optimization_fuel","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_unpretty","","",null,{"inputs":[{"name":"option"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[5,"parse_lto","","",null,{"inputs":[{"name":"lto"},{"generics":["str"],"name":"option"}],"output":{"name":"bool"}}],[0,"opt","rustc::session::config","",null,null],[5,"stable","rustc::session::config::opt","",null,{"inputs":[{"name":"str"},{"name":"f"}],"output":{"name":"rustcoptgroup"}}],[5,"unstable","","",null,{"inputs":[{"name":"str"},{"name":"f"}],"output":{"name":"rustcoptgroup"}}],[5,"longer","","",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"str"}}],[5,"opt_s","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"multi_s","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"flag_s","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"flagopt_s","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"flagmulti_s","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"opt","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"multi","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"flag","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"flagopt","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[5,"flagmulti","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"rustcoptgroup"}}],[6,"R","","",null,null],[6,"S","","",null,null],[0,"nightly_options","rustc::session::config","",null,null],[5,"is_unstable_enabled","rustc::session::config::nightly_options","",null,{"inputs":[{"name":"matches"}],"output":{"name":"bool"}}],[5,"is_nightly_build","","",null,{"inputs":[],"output":{"name":"bool"}}],[5,"check_nightly_options","","",null,null],[0,"dep_tracking","rustc::session::config","Commandline arguments passed to the compiler have to be incorporated with the dependency tracking system for incremental compilation. This module provides some utilities to make this more convenient.",null,null],[5,"stable_hash","rustc::session::config::dep_tracking","",null,{"inputs":[{"generics":["str","deptrackinghash"],"name":"btreemap"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[8,"DepTrackingHash","","",null,null],[10,"hash","","",544,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","rustc::lint","",303,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","rustc::session::config","",541,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","","",542,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","","",532,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","","",533,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","","",534,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","","",524,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","rustc::middle::cstore","",344,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"hash","rustc::session::config","",531,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[6,"CodegenSetter","","",null,null],[6,"DebuggingSetter","","",null,null],[17,"RUST_CGU_EXT","","",null,null],[17,"CG_OPTIONS","","",null,null],[17,"DB_OPTIONS","","",null,null],[11,"clone","","",531,{"inputs":[{"name":"self"}],"output":{"name":"sanitizer"}}],[11,"hash","","",531,null],[11,"fmt","","",531,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",532,{"inputs":[{"name":"self"}],"output":{"name":"optlevel"}}],[11,"eq","","",532,{"inputs":[{"name":"self"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"hash","","",532,null],[11,"clone","","",533,{"inputs":[{"name":"self"}],"output":{"name":"lto"}}],[11,"eq","","",533,{"inputs":[{"name":"self"},{"name":"lto"}],"output":{"name":"bool"}}],[11,"hash","","",533,null],[11,"clone","","",534,{"inputs":[{"name":"self"}],"output":{"name":"debuginfolevel"}}],[11,"eq","","",534,{"inputs":[{"name":"self"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"hash","","",534,null],[11,"clone","","",535,{"inputs":[{"name":"self"}],"output":{"name":"outputtype"}}],[11,"eq","","",535,{"inputs":[{"name":"self"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",535,null],[11,"hash","","",535,null],[11,"fmt","","",535,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",535,{"inputs":[{"name":"self"},{"name":"outputtype"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",535,{"inputs":[{"name":"self"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"encode","","",535,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",535,{"inputs":[{"name":"__d"}],"output":{"generics":["outputtype"],"name":"result"}}],[11,"hash_stable","","",535,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",535,null],[11,"is_compatible_with_codegen_units_and_single_output_file","","",535,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"shorthand","","",535,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"from_shorthand","","",535,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[11,"shorthands_display","","",535,{"inputs":[],"output":{"name":"string"}}],[11,"extension","","",535,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",536,{"inputs":[{"name":"self"}],"output":{"name":"erroroutputtype"}}],[11,"fmt","","",536,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",536,{"inputs":[{"name":"self"},{"name":"erroroutputtype"}],"output":{"name":"bool"}}],[11,"ne","","",536,{"inputs":[{"name":"self"},{"name":"erroroutputtype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",536,null],[11,"default","","",536,{"inputs":[],"output":{"name":"erroroutputtype"}}],[11,"clone","","",524,{"inputs":[{"name":"self"}],"output":{"name":"outputtypes"}}],[11,"hash","","",524,null],[11,"hash_stable","","",524,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",524,null],[11,"get","","",524,{"inputs":[{"name":"self"},{"name":"outputtype"}],"output":{"generics":["option"],"name":"option"}}],[11,"contains_key","","",524,{"inputs":[{"name":"self"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"keys","","",524,{"inputs":[{"name":"self"}],"output":{"generics":["outputtype","option"],"name":"btreemapkeysiter"}}],[11,"values","","",524,{"inputs":[{"name":"self"}],"output":{"generics":["outputtype","option"],"name":"btreemapvaluesiter"}}],[11,"len","","",524,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"should_trans","","",524,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",525,{"inputs":[{"name":"self"}],"output":{"name":"externs"}}],[11,"hash","","",525,null],[11,"new","","",525,{"inputs":[{"generics":["string","btreeset"],"name":"btreemap"}],"output":{"name":"externs"}}],[11,"get","","",525,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["btreeset"],"name":"option"}}],[11,"iter","","",525,{"inputs":[{"name":"self"}],"output":{"generics":["string","btreeset"],"name":"btreemapiter"}}],[11,"clone","","",526,{"inputs":[{"name":"self"}],"output":{"name":"options"}}],[11,"dep_tracking_hash","","",526,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"clone","","",537,{"inputs":[{"name":"self"}],"output":{"name":"printrequest"}}],[11,"eq","","",537,{"inputs":[{"name":"self"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",537,null],[11,"fmt","","",537,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",538,{"inputs":[{"name":"self"}],"output":{"name":"borrowckmode"}}],[11,"fmt","","",538,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",538,{"inputs":[{"name":"self"},{"name":"borrowckmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",538,null],[11,"partial_cmp","","",538,{"inputs":[{"name":"self"},{"name":"borrowckmode"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",538,{"inputs":[{"name":"self"},{"name":"borrowckmode"}],"output":{"name":"ordering"}}],[11,"hash","","",538,null],[11,"use_ast","","Should we emit the AST-based borrow checker errors?",538,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"use_mir","","Should we emit the MIR-based borrow checker errors?",538,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"filestem","","",539,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"clone","","",527,{"inputs":[{"name":"self"}],"output":{"name":"outputfilenames"}}],[11,"hash_stable","","",527,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"path","","",527,{"inputs":[{"name":"self"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","Get the path where a compilation artifact of the given type for the given codegen unit should be placed on disk. If codegen_unit_name is None, a path distinct from those of any codegen unit will be generated.",527,{"inputs":[{"name":"self"},{"name":"outputtype"},{"generics":["str"],"name":"option"}],"output":{"name":"pathbuf"}}],[11,"temp_path_ext","","Like temp_path, but also supports things where there is no corresponding OutputType, like no-opt-bitcode or lto-bitcode.",527,{"inputs":[{"name":"self"},{"name":"str"},{"generics":["str"],"name":"option"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",527,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",527,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"build_dep_graph","","True if there is a reason to build the dep graph.",526,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_dep_node_debug_strs","","",526,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"file_path_mapping","","",526,{"inputs":[{"name":"self"}],"output":{"name":"filepathmapping"}}],[11,"will_create_output_file","","True if there will be an output file generated",526,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",540,{"inputs":[{"name":"self"}],"output":{"name":"entryfntype"}}],[11,"eq","","",540,{"inputs":[{"name":"self"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"eq","","",541,{"inputs":[{"name":"self"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",541,{"inputs":[{"name":"self"},{"name":"cratetype"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"clone","","",541,{"inputs":[{"name":"self"}],"output":{"name":"cratetype"}}],[11,"cmp","","",541,{"inputs":[{"name":"self"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"assert_receiver_is_total_eq","","",541,null],[11,"hash","","",541,null],[11,"fmt","","",541,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",542,{"inputs":[{"name":"self"}],"output":{"name":"passes"}}],[11,"hash","","",542,null],[11,"is_empty","","",542,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",528,{"inputs":[{"name":"self"}],"output":{"name":"codegenoptions"}}],[11,"hash","","",528,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"clone","","",529,{"inputs":[{"name":"self"}],"output":{"name":"debuggingoptions"}}],[11,"hash","","",529,{"inputs":[{"name":"self"},{"name":"defaulthasher"},{"name":"erroroutputtype"}],"output":null}],[11,"clone","","",543,{"inputs":[{"name":"self"}],"output":{"name":"optionstability"}}],[11,"eq","","",543,{"inputs":[{"name":"self"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",543,null],[11,"fmt","","",543,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_stable","","",530,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"stable","","",530,{"inputs":[{"name":"str"},{"name":"f"}],"output":{"name":"rustcoptgroup"}}],[11,"unstable","","",530,{"inputs":[{"name":"str"},{"name":"f"}],"output":{"name":"rustcoptgroup"}}],[11,"fmt","","",541,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"filesearch","rustc::session","",null,null],[3,"FileSearch","rustc::session::filesearch","",null,null],[12,"sysroot","","",545,null],[12,"search_paths","","",545,null],[12,"triple","","",545,null],[12,"kind","","",545,null],[4,"FileMatch","","",null,null],[13,"FileMatches","","",546,null],[13,"FileDoesntMatch","","",546,null],[5,"relative_target_lib_path","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"make_target_lib_path","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"get_or_default_sysroot","","",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"find_libdir","","",null,{"inputs":[{"name":"path"}],"output":{"generics":["str"],"name":"cow"}}],[17,"RUST_LIB_DIR","","",null,null],[11,"clone","","",546,{"inputs":[{"name":"self"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",545,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"get_lib_path","","",545,{"inputs":[{"name":"self"}],"output":{"name":"pathbuf"}}],[11,"search","","",545,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"new","","",545,{"inputs":[{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",545,{"inputs":[{"name":"self"}],"output":{"generics":["pathbuf"],"name":"vec"}}],[11,"get_tools_search_paths","","",545,{"inputs":[{"name":"self"}],"output":{"generics":["pathbuf"],"name":"vec"}}],[0,"search_paths","rustc::session","",null,null],[3,"SearchPaths","rustc::session::search_paths","",null,null],[12,"paths","","",547,null],[3,"Iter","","",null,null],[12,"kind","","",548,null],[12,"iter","","",548,null],[4,"PathKind","","",null,null],[13,"Native","","",549,null],[13,"Crate","","",549,null],[13,"Dependency","","",549,null],[13,"Framework","","",549,null],[13,"ExternFlag","","",549,null],[13,"All","","",549,null],[11,"clone","","",547,{"inputs":[{"name":"self"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",547,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",549,null],[11,"eq","","",549,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"clone","","",549,{"inputs":[{"name":"self"}],"output":{"name":"pathkind"}}],[11,"fmt","","",549,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",549,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",549,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"name":"ordering"}}],[11,"hash","","",549,null],[11,"new","","",547,{"inputs":[],"output":{"name":"searchpaths"}}],[11,"add_path","","",547,{"inputs":[{"name":"self"},{"name":"str"},{"name":"erroroutputtype"}],"output":null}],[11,"iter","","",547,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"name":"iter"}}],[11,"next","","",548,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",548,null],[6,"CompileResult","rustc::session","",null,null],[11,"clone","","",520,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticmessageid"}}],[11,"fmt","","",520,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",520,{"inputs":[{"name":"self"},{"name":"diagnosticmessageid"}],"output":{"name":"bool"}}],[11,"ne","","",520,{"inputs":[{"name":"self"},{"name":"diagnosticmessageid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",520,null],[11,"hash","","",520,null],[11,"from","","",520,{"inputs":[{"name":"lint"}],"output":{"name":"self"}}],[11,"local_crate_disambiguator","","",514,{"inputs":[{"name":"self"}],"output":{"name":"cratedisambiguator"}}],[11,"struct_span_warn","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_warn_with_code","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_warn","","",514,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_err","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_err_with_code","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_err","","",514,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_err_with_code","","",514,{"inputs":[{"name":"self"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_fatal","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_fatal_with_code","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_fatal","","",514,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_fatal","","",514,null],[11,"span_fatal_with_code","","",514,null],[11,"fatal","","",514,null],[11,"span_err_or_warn","","",514,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_err","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_err_with_code","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":null}],[11,"err","","",514,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"err_count","","",514,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"has_errors","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",514,{"inputs":[{"name":"self"}],"output":null}],[11,"compile_status","","",514,{"inputs":[{"name":"self"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[11,"track_errors","","",514,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"generics":["errorreported"],"name":"result"}}],[11,"span_warn","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_warn_with_code","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":null}],[11,"warn","","",514,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"opt_span_warn","","",514,{"inputs":[{"name":"self"},{"name":"option"},{"name":"str"}],"output":null}],[11,"delay_span_bug","","Delay a span_bug() call until abort_if_errors()",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"note_without_error","","",514,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"span_note_without_error","","",514,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_unimpl","","",514,null],[11,"unimpl","","",514,null],[11,"buffer_lint","","",514,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"s"},{"name":"str"}],"output":null}],[11,"buffer_lint_with_diagnostic","","",514,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"s"},{"name":"str"},{"name":"builtinlintdiagnostics"}],"output":null}],[11,"reserve_node_ids","","",514,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"nodeid"}}],[11,"next_node_id","","",514,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"diagnostic","","",514,{"inputs":[{"name":"self"}],"output":{"name":"handler"}}],[11,"diag_once","","Analogous to calling methods on the given `DiagnosticBuilder`, but deduplicates on lint ID, span (if any), and message for this `Session`",514,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"diagnosticbuildermethod"},{"name":"diagnosticmessageid"},{"name":"str"},{"generics":["span"],"name":"option"}],"output":null}],[11,"diag_span_note_once","","",514,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"diagnosticmessageid"},{"name":"span"},{"name":"str"}],"output":null}],[11,"diag_note_once","","",514,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"diagnosticmessageid"},{"name":"str"}],"output":null}],[11,"diag_span_suggestion_once","","",514,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"diagnosticmessageid"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":null}],[11,"codemap","","",514,{"inputs":[{"name":"self"}],"output":{"name":"codemap"}}],[11,"verbose","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"time_passes","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"profile_queries","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"profile_queries_and_keys","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"trans_stats","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"meta_stats","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"asm_comments","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"no_verify","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"features_untracked","","Get the features enabled for the current compilation session. DO NOT USE THIS METHOD if there is a TyCtxt available, as it circumvents dependency tracking. Use tcx.features() instead.",514,{"inputs":[{"name":"self"}],"output":{"name":"features"}}],[11,"init_features","","",514,{"inputs":[{"name":"self"},{"name":"features"}],"output":null}],[11,"lto","","Calculates the flavor of LTO to use for this compilation.",514,{"inputs":[{"name":"self"}],"output":{"name":"lto"}}],[11,"panic_strategy","","Returns the panic strategy for this compile session. If the user explicitly selected one using '-C panic', use that, otherwise use the panic strategy defined by the target.",514,{"inputs":[{"name":"self"}],"output":{"name":"panicstrategy"}}],[11,"linker_flavor","","",514,{"inputs":[{"name":"self"}],"output":{"name":"linkerflavor"}}],[11,"fewer_names","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"unstable_options","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"nonzeroing_move_hints","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"overflow_checks","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"crt_static","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"crt_static_feature","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"must_not_eliminate_frame_pointers","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"generate_plugin_registrar_symbol","","Returns the symbol name for the registrar function, given the crate Svh and the function DefIndex.",514,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"string"}}],[11,"generate_derive_registrar_symbol","","",514,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"string"}}],[11,"sysroot","","",514,{"inputs":[{"name":"self"}],"output":{"name":"path"}}],[11,"target_filesearch","","",514,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",514,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"set_incr_session_load_dep_graph","","",514,{"inputs":[{"name":"self"},{"name":"bool"}],"output":null}],[11,"incr_session_load_dep_graph","","",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"init_incr_comp_session","","",514,{"inputs":[{"name":"self"},{"name":"pathbuf"},{"name":"lock"},{"name":"bool"}],"output":null}],[11,"finalize_incr_comp_session","","",514,{"inputs":[{"name":"self"},{"name":"pathbuf"}],"output":null}],[11,"mark_incr_comp_session_as_invalid","","",514,{"inputs":[{"name":"self"}],"output":null}],[11,"incr_comp_session_dir","","",514,{"inputs":[{"name":"self"}],"output":{"generics":["pathbuf"],"name":"ref"}}],[11,"incr_comp_session_dir_opt","","",514,{"inputs":[{"name":"self"}],"output":{"generics":["ref"],"name":"option"}}],[11,"print_perf_stats","","",514,{"inputs":[{"name":"self"}],"output":null}],[11,"consider_optimizing","","We want to know if we're allowed to do an optimization for crate foo from -z fuel=foo=n. This expends fuel if applicable, and records fuel if applicable.",514,{"inputs":[{"name":"self"},{"name":"str"},{"name":"t"}],"output":{"name":"bool"}}],[11,"query_threads","","Returns the number of query threads that should be used for this compilation",514,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"codegen_units","","Returns the number of codegen units that should be used for this compilation",514,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"teach","","",514,{"inputs":[{"name":"self"},{"name":"diagnosticid"}],"output":{"name":"bool"}}],[11,"rust_2018","","Are we allowed to use features from the Rust 2018 edition?",514,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"edition","","",514,{"inputs":[{"name":"self"}],"output":{"name":"edition"}}],[11,"assert_receiver_is_total_eq","","",516,null],[11,"eq","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"bool"}}],[11,"ne","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"bool"}}],[11,"cmp","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"bool"}}],[11,"le","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"bool"}}],[11,"gt","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"bool"}}],[11,"ge","","",516,{"inputs":[{"name":"self"},{"name":"cratedisambiguator"}],"output":{"name":"bool"}}],[11,"hash","","",516,null],[11,"fmt","","",516,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",516,{"inputs":[{"name":"self"}],"output":{"name":"cratedisambiguator"}}],[11,"encode","","",516,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",516,{"inputs":[{"name":"__d"}],"output":{"generics":["cratedisambiguator"],"name":"result"}}],[11,"to_fingerprint","","",516,{"inputs":[{"name":"self"}],"output":{"name":"fingerprint"}}],[11,"from","","",516,{"inputs":[{"name":"fingerprint"}],"output":{"name":"cratedisambiguator"}}],[11,"hash_stable","","",516,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"fmt","","",521,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",522,{"inputs":[{"name":"self"}],"output":{"name":"compileincomplete"}}],[11,"fmt","","",522,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",522,{"inputs":[{"name":"errorreported"}],"output":{"name":"compileincomplete"}}],[0,"traits","rustc","Trait Resolution. See [rustc guide] for more info on how this works.",null,null],[3,"OverlapResult","rustc::traits","",null,null],[12,"impl_header","","",550,null],[12,"intercrate_ambiguity_causes","","",550,null],[3,"FulfillmentContext","","The fulfillment context is used to drive trait resolution.  It consists of a list of obligations that must be (eventually) satisfied. The job is to track which are satisfied, which yielded errors, and which are still pending. At any point, users can call `select_where_possible`, and the fulfillment context will try to do selection, retaining only those obligations that remain ambiguous. This may be helpful in pushing type inference along. Once all type inference constraints have been generated, the method `select_all_or_error` can be used to report any remaining ambiguous cases as errors.",null,null],[12,"predicates","","",551,null],[12,"register_region_obligations","","",551,null],[3,"PendingPredicateObligation","","",null,null],[12,"obligation","","",552,null],[12,"stalled_on","","",552,null],[3,"MismatchedProjectionTypes","","",null,null],[12,"err","","",553,null],[3,"ProjectionCache","","The projection cache. Unlike the standard caches, this can include infcx-dependent type variables - therefore, we have to roll the cache back each time we roll a snapshot back, to avoid assumptions on yet-unresolved inference variables. Types with skolemized regions also have to be removed when the respective snapshot ends.",null,null],[12,"map","","",554,null],[3,"ProjectionCacheSnapshot","","",null,null],[12,"snapshot","","",555,null],[3,"Normalized","","",null,null],[12,"value","","",556,null],[12,"obligations","","",556,null],[3,"OnUnimplementedDirective","","",null,null],[12,"condition","","",557,null],[12,"subcommands","","",557,null],[12,"message","","",557,null],[12,"label","","",557,null],[12,"note","","",557,null],[3,"OnUnimplementedNote","","",null,null],[12,"message","","",558,null],[12,"label","","",558,null],[12,"note","","",558,null],[3,"EvaluationCache","","",null,null],[12,"hashmap","","",559,null],[3,"SelectionContext","","",null,null],[12,"infcx","","",560,null],[12,"freshener","","Freshener used specifically for skolemizing entries on the obligation stack. This ensures that all entries on the stack at one time will have the same set of skolemized entries, which is important for checking for trait bounds that recursively require themselves.",560,null],[12,"intercrate","","If true, indicates that the evaluation should be conservative and consider the possibility of types outside this crate. This comes up primarily when resolving ambiguity. Imagine there is some trait reference `$0 : Bar` where `$0` is an inference variable. If `intercrate` is true, then we can never say for sure that this reference is not implemented, even if there are no impls at all for `Bar`, because `$0` could be bound to some type that in a downstream crate that implements `Bar`. This is the suitable mode for coherence. Elsewhere, though, we set this to false, because we are only interested in types that the user could actually have written --- in other words, we consider `$0 : Bar` to be unimplemented if there is no type that the user could actually name that would satisfy it. This avoids crippling inference, basically.",560,null],[12,"intercrate_ambiguity_causes","","",560,null],[12,"allow_negative_impls","","Controls whether or not to filter out negative impls when selecting. This is used in librustdoc to distinguish between the lack of an impl and a negative impl",560,null],[12,"query_mode","","The mode that trait queries run in, which informs our error handling policy. In essence, canonicalized queries need their errors propagated rather than immediately reported because we do not have accurate spans.",560,null],[3,"SelectionCache","","",null,null],[12,"hashmap","","",561,null],[3,"OverflowError","","Indicates that trait evaluation caused overflow.",null,null],[3,"OverlapError","","Information pertinent to an overlapping impl error.",null,null],[12,"with_impl","","",562,null],[12,"trait_desc","","",562,null],[12,"self_desc","","",562,null],[12,"intercrate_ambiguity_causes","","",562,null],[3,"SpecializesCache","","",null,null],[12,"map","","",563,null],[3,"SupertraitDefIds","","",null,null],[12,"tcx","","",564,null],[12,"stack","","",564,null],[12,"visited","","",564,null],[3,"Obligation","","An `Obligation` represents some trait reference (e.g. `int:Eq`) for which the vtable must be found.  The process of finding a vtable is called \"resolving\" the `Obligation`. This process consists of either identifying an `impl` (e.g., `impl Eq for int`) that provides the required vtable, or else finding a bound that is in scope. The eventual result is usually a `Selection` (defined below).",null,null],[12,"cause","","Why do we have to prove this thing?",565,null],[12,"param_env","","In which environment should we prove this thing?",565,null],[12,"predicate","","What are we trying to prove?",565,null],[12,"recursion_depth","","If we started proving this as a result of trying to prove something else, track the total depth to ensure termination. If this goes over a certain threshold, we abort compilation -- in such cases, we can not say whether or not the predicate holds for certain. Stupid halting problem. Such a drag.",565,null],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",null,null],[12,"span","","",566,null],[12,"body_id","","",566,null],[12,"code","","",566,null],[3,"DerivedObligationCause","","",null,null],[12,"parent_trait_ref","","The trait reference of the parent obligation that led to the current obligation. Note that only trait obligations lead to derived obligations, so we just store the trait reference here directly.",567,null],[12,"parent_code","","The parent trait had this cause",567,null],[3,"ProgramClause","","A \"program clause\" has the form `D :- G1, ..., Gn`. It is saying that the domain goal `D` is true if `G1...Gn` are provable. This is equivalent to the implication `G1..Gn => D`; we usually write it with the reverse implication operator `:-` to emphasize the way that programs are actually solved (via backchaining, which starts with the goal to solve and proceeds from there).",null,null],[12,"goal","","This goal will be considered true...",568,null],[12,"hypotheses","","...if we can prove these hypotheses (there may be no hypotheses at all):",568,null],[3,"FulfillmentError","","",null,null],[12,"obligation","","",569,null],[12,"code","","",569,null],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of substitutions from the impl's type/lifetime parameters. The `nested` vector corresponds to the nested obligations attached to the impl's type parameters.",null,null],[12,"impl_def_id","","",570,null],[12,"substs","","",570,null],[12,"nested","","",570,null],[3,"VtableGeneratorData","","",null,null],[12,"closure_def_id","","",571,null],[12,"substs","","",571,null],[12,"nested","","Nested obligations. This can be non-empty if the generator signature contains associated types.",571,null],[3,"VtableClosureData","","",null,null],[12,"closure_def_id","","",572,null],[12,"substs","","",572,null],[12,"nested","","Nested obligations. This can be non-empty if the closure signature contains associated types.",572,null],[3,"VtableAutoImplData","","",null,null],[12,"trait_def_id","","",573,null],[12,"nested","","",573,null],[3,"VtableBuiltinData","","",null,null],[12,"nested","","",574,null],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived for the object type `Foo`.",null,null],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",575,null],[12,"vtable_base","","The vtable is formed by concatenating together the method lists of the base object trait and all supertraits; this is the start of `upcast_trait_ref`'s methods in that vtable.",575,null],[12,"nested","","",575,null],[3,"VtableFnPointerData","","",null,null],[12,"fn_ty","","",576,null],[12,"nested","","",576,null],[4,"OrphanCheckErr","","",null,null],[13,"NoLocalInputType","","",577,null],[13,"UncoveredTy","","",577,null],[4,"Reveal","","Depending on the stage of compilation, we want projection to be more or less conservative.",null,null],[13,"UserFacing","","At type-checking time, we refuse to project any associated type that is marked `default`. Non-`default` (\"final\") types are always projected. This is necessary in general for soundness of specialization. However, we could allow projections in fully-monomorphic cases. We choose not to, because we prefer for `default type` to force the type definition to be treated abstractly by any consumers of the impl. Concretely, that means that the following example will fail to compile:",578,null],[13,"All","","At trans time, all monomorphic projections will succeed. Also, `impl Trait` is normalized to the concrete type, which has to be already collected by type-checking.",578,null],[4,"ObjectSafetyViolation","","",null,null],[13,"SizedSelf","","Self : Sized declared on the trait",579,null],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location (e.g. `trait Foo : Bar<Self>`)",579,null],[13,"Method","","Method has something illegal",579,null],[13,"AssociatedConst","","Associated const",579,null],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",null,null],[13,"StaticMethod","","e.g., `fn foo()`",580,null],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",580,null],[13,"Generic","","e.g., `fn foo<A>()`",580,null],[13,"NonStandardSelfType","","arbitrary `self` type, e.g. `self: Rc<Self>`",580,null],[4,"EvaluationResult","","The result of trait evaluation. The order is important here as the evaluation of a list is the maximum of the evaluations.",null,null],[13,"EvaluatedToOk","","Evaluation successful",581,null],[13,"EvaluatedToAmbig","","Evaluation is known to be ambiguous - it might hold for some assignment of inference variables, but it might not.",581,null],[13,"EvaluatedToUnknown","","Evaluation failed because of recursion involving inference variables. We are somewhat imprecise there, so we don't actually know the real result.",581,null],[13,"EvaluatedToRecur","","Evaluation failed because we encountered an obligation we are already trying to prove on this branch.",581,null],[13,"EvaluatedToErr","","Evaluation failed",581,null],[4,"IntercrateAmbiguityCause","","",null,null],[13,"DownstreamCrate","","",582,null],[12,"trait_desc","rustc::traits::IntercrateAmbiguityCause","",582,null],[12,"self_desc","","",582,null],[13,"UpstreamCrateUpdate","rustc::traits","",582,null],[12,"trait_desc","rustc::traits::IntercrateAmbiguityCause","",582,null],[12,"self_desc","","",582,null],[4,"IntercrateMode","rustc::traits","",null,null],[13,"Issue43355","","",583,null],[13,"Fixed","","",583,null],[4,"TraitQueryMode","","",null,null],[13,"Standard","","",584,null],[13,"Canonical","","",584,null],[4,"ObligationCauseCode","","",null,null],[13,"MiscObligation","","Not well classified or should be obvious from span.",585,null],[13,"SliceOrArrayElem","","A slice or array is WF only if `T: Sized`",585,null],[13,"TupleElem","","A tuple is WF only if its middle elements are Sized",585,null],[13,"ProjectionWf","","This is the trait reference from the given projection",585,null],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must also implement all supertraits of X.",585,null],[13,"ReferenceOutlivesReferent","","A type like `&'a T` is WF only if `T: 'a`.",585,null],[13,"ObjectTypeBound","","A type like `Box<Foo<'a> + 'b>` is WF only if `'b: 'a`.",585,null],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",585,null],[13,"AssignmentLhsSized","","L = X implies that L is Sized",585,null],[13,"TupleInitializerSized","","(x1, .., xn) must be Sized",585,null],[13,"StructInitializerSized","","S { ... } must be Sized",585,null],[13,"VariableType","","Type of each variable must be Sized",585,null],[13,"SizedReturnType","","Return type must be Sized",585,null],[13,"SizedYieldType","","Yield type must be Sized",585,null],[13,"RepeatVec","","[T,..n] --> T must be Copy",585,null],[13,"FieldSized","","Types of fields (other than the last) in a struct must be sized.",585,null],[13,"ConstSized","","Constant expressions must be sized.",585,null],[13,"SharedStatic","","static items must have `Sync` type",585,null],[13,"BuiltinDerivedObligation","","",585,null],[13,"ImplDerivedObligation","","",585,null],[13,"CompareImplMethodObligation","","error derived when matching traits/impls; see ObligationCause for more details",585,null],[12,"item_name","rustc::traits::ObligationCauseCode","",585,null],[12,"impl_item_def_id","","",585,null],[12,"trait_item_def_id","","",585,null],[13,"ExprAssignable","rustc::traits","Checking that this expression can be assigned where it needs to be",585,null],[13,"MatchExpressionArm","","Computing common supertype in the arms of a match expression",585,null],[12,"arm_span","rustc::traits::ObligationCauseCode","",585,null],[12,"source","","",585,null],[13,"IfExpression","rustc::traits","Computing common supertype in an if expression",585,null],[13,"IfExpressionWithNoElse","","Computing common supertype of an if expression with no else counter-part",585,null],[13,"MainFunctionType","","`main` has wrong type",585,null],[13,"StartFunctionType","","`start` has wrong type",585,null],[13,"IntrinsicType","","intrinsic has wrong type",585,null],[13,"MethodReceiver","","method receiver",585,null],[13,"ReturnNoExpression","","`return` with no expression",585,null],[13,"ReturnType","","`return` with an expression",585,null],[13,"BlockTailExpression","","Block implicit return",585,null],[4,"WhereClauseAtom","","The following types: * `WhereClauseAtom` * `DomainGoal` * `Goal` * `Clause` are used for representing the trait system in the form of logic programming clauses. They are part of the interface for the chalk SLG solver.",null,null],[13,"Implemented","","",586,null],[13,"ProjectionEq","","",586,null],[4,"DomainGoal","","",null,null],[13,"Holds","","",587,null],[13,"WellFormed","","",587,null],[13,"FromEnv","","",587,null],[13,"WellFormedTy","","",587,null],[13,"Normalize","","",587,null],[13,"FromEnvTy","","",587,null],[13,"RegionOutlives","","",587,null],[13,"TypeOutlives","","",587,null],[4,"QuantifierKind","","",null,null],[13,"Universal","","",588,null],[13,"Existential","","",588,null],[4,"Goal","","",null,null],[13,"Implies","","",589,null],[13,"And","","",589,null],[13,"Not","","",589,null],[13,"DomainGoal","","",589,null],[13,"Quantified","","",589,null],[13,"CannotProve","","",589,null],[4,"Clause","","This matches the definition from Page 7 of \"A Proof Procedure for the Logic of Hereditary Harrop Formulas\".",null,null],[13,"Implies","","",590,null],[13,"ForAll","","",590,null],[4,"SelectionError","","",null,null],[13,"Unimplemented","","",591,null],[13,"OutputTypeParameterMismatch","","",591,null],[13,"TraitNotObjectSafe","","",591,null],[13,"ConstEvalFailure","","",591,null],[13,"Overflow","","",591,null],[4,"FulfillmentErrorCode","","",null,null],[13,"CodeSelectionError","","",592,null],[13,"CodeProjectionError","","",592,null],[13,"CodeSubtypeError","","",592,null],[13,"CodeAmbiguity","","",592,null],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable` indicates where the vtable comes from. Note that while we call this a \"vtable\", it does not necessarily indicate dynamic dispatch at runtime. `Vtable` instances just tell the compiler where to find methods, but in generic code those methods are typically statically dispatched -- only when an object is constructed is a `Vtable` instance reified into an actual vtable.",null,null],[13,"VtableImpl","","Vtable identifying a particular impl.",593,null],[13,"VtableAutoImpl","","Vtable for auto trait implementations This carries the information and nested obligations with regards to an auto implementation for a trait `Trait`. The nested obligations ensure the trait implementation holds for all the constituent types.",593,null],[13,"VtableParam","","Successful resolution to an obligation provided by the caller for some type parameter. The `Vec<N>` represents the obligations incurred from normalizing the where-clause (if any).",593,null],[13,"VtableObject","","Virtual calls through an object",593,null],[13,"VtableBuiltin","","Successful resolution for a builtin trait.",593,null],[13,"VtableClosure","","Vtable automatically generated for a closure. The def ID is the ID of the closure expression. This is a `VtableImpl` in spirit, but the impl is generated by the compiler and does not appear in the source.",593,null],[13,"VtableFnPointer","","Same as above, but for a fn pointer type with the given signature.",593,null],[13,"VtableGenerator","","Vtable automatically generated for a generator",593,null],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the def-id of a trait impl. To pass, either the trait must be local, or else two conditions must be satisfied:",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["orphancheckerr"],"name":"result"}}],[5,"overlapping_impls","","If there are types that satisfy both impls, invokes `on_overlap` with a suitably-freshened `ImplHeader` with those types substituted. Otherwise, invokes `no_overlap`.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"},{"name":"intercratemode"},{"name":"f1"},{"name":"f2"}],"output":{"name":"r"}}],[5,"normalize","","Normalizes any associated type projections in `value`, replacing them with a fully resolved type where possible. The return value combines the normalized result and any additional obligations that were incurred as result.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). If ambiguity arises, which implies that there are unresolved type variables in the projection, we will substitute a fresh type variable `$X` and generate a new obligation `<T as Trait>::Item == $X` for later.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"},{"name":"usize"}],"output":{"generics":["ty"],"name":"normalized"}}],[5,"poly_project_and_unify_type","","Evaluates constraints of the form:",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"generics":["option","mismatchedprojectiontypes"],"name":"result"}}],[5,"translate_substs","","Given a subst for the requested impl, translate it to a subst appropriate for the actual item definition (whether it be in that impl, a parent impl, or the trait).",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"defid"},{"name":"substs"},{"name":"node"}],"output":{"name":"substs"}}],[5,"find_associated_item","","Given a selected impl described by `impl_data`, returns the definition and substitutions for the method with the name `name` the kind `kind`, and trait method substitutions `substs`, in that impl, a less specialized impl, or the trait default, whichever applies.",null,null],[5,"elaborate_predicates","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["predicate"],"name":"vec"}],"output":{"name":"elaborator"}}],[5,"supertraits","","",null,{"inputs":[{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"name":"supertraits"}}],[5,"supertrait_def_ids","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"supertraitdefids"}}],[5,"transitive_bounds","","",null,null],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",null,{"inputs":[{"name":"obligationcause"},{"name":"paramenv"},{"name":"instantiatedpredicates"}],"output":{"name":"predicateobligations"}}],[5,"type_known_to_meet_bound","","Determines whether the type `ty` is known to meet `bound` and returns true if so. Returns false if `ty` either does not meet `bound` or is not known to meet bound (note that this is conservative towards no impl, which is the opposite of the `evaluate` methods).",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"ty"},{"name":"defid"},{"name":"span"}],"output":{"name":"bool"}}],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"paramenv"},{"name":"obligationcause"}],"output":{"name":"paramenv"}}],[5,"fully_normalize","","",null,{"inputs":[{"name":"inferctxt"},{"name":"obligationcause"},{"name":"paramenv"},{"name":"t"}],"output":{"generics":["vec"],"name":"result"}}],[5,"fully_normalize_with_fulfillcx","","",null,{"inputs":[{"name":"inferctxt"},{"name":"fulfillmentcontext"},{"name":"obligationcause"},{"name":"paramenv"},{"name":"t"}],"output":{"generics":["vec"],"name":"result"}}],[5,"normalize_and_test_predicates","","Normalizes the predicates and checks whether they hold in an empty environment. If this returns false, then either normalize encountered an error or one of the predicates did not hold. Used when creating vtables to check for unsatisfiable methods.",null,{"inputs":[{"name":"tyctxt"},{"generics":["predicate"],"name":"vec"}],"output":{"name":"bool"}}],[5,"substitute_normalize_and_test_predicates","","",null,null],[5,"vtable_methods","","Given a trait `trait_ref`, iterates the vtable entries that come from `trait_ref`, including its supertraits.",null,{"inputs":[{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"generics":["vec"],"name":"lrc"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"specialization_graph","","",null,null],[3,"Graph","rustc::traits::specialization_graph","A per-trait graph of impls in specialization order. At the moment, this graph forms a tree rooted with the trait itself, with all other nodes representing impls, and parent-child relationships representing specializations.",null,null],[12,"parent","","",594,null],[12,"children","","",594,null],[3,"Ancestors","","",null,null],[12,"trait_def_id","","",595,null],[12,"specialization_graph","","",595,null],[12,"current_source","","",595,null],[3,"NodeItem","","",null,null],[12,"node","","",596,null],[12,"item","","",596,null],[4,"Node","","A node in the specialization graph is either an impl or a trait definition; either can serve as a source of item definitions. There is always exactly one trait definition node: the root.",null,null],[13,"Impl","","",597,null],[13,"Trait","","",597,null],[5,"ancestors","","Walk up the specialization ancestors of a given impl, starting with that impl itself.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"ancestors"}}],[0,"coherence","rustc::traits","See rustc guide chapters on [trait-resolution] and [trait-specialization] for more info on how this works.",null,null],[3,"OverlapResult","rustc::traits::coherence","",null,null],[12,"impl_header","","",550,null],[12,"intercrate_ambiguity_causes","","",550,null],[4,"InCrate","","Whether we do the orphan check relative to this crate or to some remote crate.",null,null],[13,"Local","","",598,null],[13,"Remote","","",598,null],[4,"Conflict","","",null,null],[13,"Upstream","","",599,null],[13,"Downstream","","",599,null],[12,"used_to_be_broken","rustc::traits::coherence::Conflict","",599,null],[4,"OrphanCheckErr","rustc::traits::coherence","",null,null],[13,"NoLocalInputType","","",577,null],[13,"UncoveredTy","","",577,null],[5,"overlapping_impls","","If there are types that satisfy both impls, invokes `on_overlap` with a suitably-freshened `ImplHeader` with those types substituted. Otherwise, invokes `no_overlap`.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"},{"name":"intercratemode"},{"name":"f1"},{"name":"f2"}],"output":{"name":"r"}}],[5,"with_fresh_ty_vars","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"defid"}],"output":{"name":"implheader"}}],[5,"overlap","","Can both impl `a` and impl `b` be satisfied by a common type (including `where` clauses)? If so, returns an `ImplHeader` that unifies the two impls.",null,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"defid"}],"output":{"generics":["overlapresult"],"name":"option"}}],[5,"trait_ref_is_knowable","","",null,{"inputs":[{"name":"tyctxt"},{"name":"traitref"}],"output":{"generics":["conflict"],"name":"option"}}],[5,"trait_ref_is_local_or_fundamental","","",null,{"inputs":[{"name":"tyctxt"},{"name":"traitref"}],"output":{"name":"bool"}}],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the def-id of a trait impl. To pass, either the trait must be local, or else two conditions must be satisfied:",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["orphancheckerr"],"name":"result"}}],[5,"orphan_check_trait_ref","","Check whether a trait-ref is potentially implementable by a crate.",null,{"inputs":[{"name":"tyctxt"},{"name":"traitref"},{"name":"incrate"}],"output":{"generics":["orphancheckerr"],"name":"result"}}],[5,"uncovered_tys","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"incrate"}],"output":{"generics":["ty"],"name":"vec"}}],[5,"is_possibly_remote_type","","",null,{"inputs":[{"name":"ty"},{"name":"incrate"}],"output":{"name":"bool"}}],[5,"ty_is_local","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"incrate"}],"output":{"name":"bool"}}],[5,"fundamental_ty","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"def_id_is_local","","",null,{"inputs":[{"name":"defid"},{"name":"incrate"}],"output":{"name":"bool"}}],[5,"ty_is_local_constructor","","",null,{"inputs":[{"name":"ty"},{"name":"incrate"}],"output":{"name":"bool"}}],[11,"clone","","",598,{"inputs":[{"name":"self"}],"output":{"name":"incrate"}}],[11,"fmt","","",598,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",599,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",599,{"inputs":[{"name":"self"}],"output":{"name":"conflict"}}],[0,"error_reporting","rustc::traits","",null,null],[4,"ArgKind","rustc::traits::error_reporting","Summarizes information",null,null],[13,"Arg","","An argument of non-tuple type. Parameters are (name, ty)",600,null],[13,"Tuple","","An argument of tuple type. For a \"found\" argument, the span is the locationo in the source of the pattern. For a \"expected\" argument, it will be None. The vector is a list of (name, ty) strings for the components of the tuple.",600,null],[11,"report_fulfillment_errors","rustc::infer","",203,{"inputs":[{"name":"self"},{"name":"vec"},{"generics":["bodyid"],"name":"option"},{"name":"bool"}],"output":null}],[11,"error_implies","","",203,{"inputs":[{"name":"self"},{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"report_fulfillment_error","","",203,{"inputs":[{"name":"self"},{"name":"fulfillmenterror"},{"generics":["bodyid"],"name":"option"},{"name":"bool"}],"output":null}],[11,"report_projection_error","","",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"},{"name":"mismatchedprojectiontypes"}],"output":null}],[11,"fuzzy_match_tys","","",203,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"impl_similar_to","","",203,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"predicateobligation"}],"output":{"generics":["defid"],"name":"option"}}],[11,"on_unimplemented_note","","",203,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"predicateobligation"}],"output":{"name":"onunimplementednote"}}],[11,"find_similar_impl_candidates","","",203,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"generics":["traitref"],"name":"vec"}}],[11,"report_similar_impl_candidates","","",203,{"inputs":[{"name":"self"},{"generics":["traitref"],"name":"vec"},{"name":"diagnosticbuilder"}],"output":null}],[11,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We halt compilation unconditionally because it is important that overflows never be masked -- they basically represent computations whose result could not be truly determined and thus we can't say if the program type checks or not -- and they are unusual occurrences in any case.",203,null],[11,"report_overflow_error_cycle","","Reports that a cycle was detected which led to overflow and halts compilation. This is equivalent to `report_overflow_error` except that we can give a more helpful error message (and, in particular, we do not suggest increasing the overflow limit, which is not going to help).",203,null],[11,"report_extra_impl_obligation","","",203,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"defid"},{"name":"defid"},{"name":"display"}],"output":{"name":"diagnosticbuilder"}}],[11,"get_parent_trait_ref","","Get the parent trait chain start",203,{"inputs":[{"name":"self"},{"name":"obligationcausecode"}],"output":{"generics":["string"],"name":"option"}}],[11,"report_selection_error","","",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"},{"name":"selectionerror"},{"name":"bool"}],"output":null}],[11,"suggest_borrow_on_unsized_slice","","When encountering an assignment of an unsized trait, like `let x = \"\"[..];`, provide a suggestion to borrow the initializer in order to use have a slice instead.",203,{"inputs":[{"name":"self"},{"name":"obligationcausecode"},{"name":"diagnosticbuilder"}],"output":null}],[11,"suggest_remove_reference","","Whenever references are used by mistake, like `for (i, e) in &vec.iter().enumerate()`, suggest removing these references until we reach a type that implements the trait.",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"},{"name":"diagnosticbuilder"},{"name":"binder"}],"output":null}],[11,"get_fn_like_arguments","","Given some node representing a fn-like thing in the HIR map, returns a span and `ArgKind` information that describes the arguments it expects. This can be supplied to `report_arg_count_mismatch`.",203,null],[11,"report_arg_count_mismatch","","Reports an error when the number of arguments needed by a trait match doesn't match the number that the expression provides.",203,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["span"],"name":"option"},{"generics":["argkind"],"name":"vec"},{"generics":["argkind"],"name":"vec"},{"name":"bool"}],"output":{"name":"diagnosticbuilder"}}],[11,"report_closure_arg_mismatch","","",203,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["span"],"name":"option"},{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"diagnosticbuilder"}}],[11,"maybe_report_ambiguity","","",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"},{"generics":["bodyid"],"name":"option"}],"output":null}],[11,"predicate_can_apply","","Returns whether the trait predicate may apply for some assignment to the type parameters.",203,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"note_obligation_cause","","",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"obligation"}],"output":null}],[11,"note_obligation_cause_code","","",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"t"},{"name":"obligationcausecode"},{"name":"vec"}],"output":null}],[11,"suggest_new_overflow_limit","","",203,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"is_recursive_obligation","","",203,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"empty","rustc::traits::error_reporting","",600,{"inputs":[],"output":{"name":"argkind"}}],[11,"from_expected_ty","","Creates an `ArgKind` from the expected type of an argument. This has no name (`_`) and no source spans..",600,{"inputs":[{"name":"ty"}],"output":{"name":"argkind"}}],[0,"engine","rustc::traits","",null,null],[8,"TraitEngine","rustc::traits::engine","",null,null],[10,"normalize_projection_type","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"ty"}}],[10,"register_bound","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"ty"},{"name":"defid"},{"name":"obligationcause"}],"output":null}],[10,"register_predicate_obligation","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"predicateobligation"}],"output":null}],[10,"select_all_or_error","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"}],"output":{"generics":["vec"],"name":"result"}}],[10,"select_where_possible","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"}],"output":{"generics":["vec"],"name":"result"}}],[10,"pending_obligations","","",601,{"inputs":[{"name":"self"}],"output":{"generics":["pendingpredicateobligation"],"name":"vec"}}],[11,"new","","",601,{"inputs":[{"name":"tyctxt"}],"output":{"name":"box"}}],[11,"register_predicate_obligations","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"i"}],"output":null}],[0,"fulfill","rustc::traits","",null,null],[3,"FulfillmentContext","rustc::traits::fulfill","The fulfillment context is used to drive trait resolution.  It consists of a list of obligations that must be (eventually) satisfied. The job is to track which are satisfied, which yielded errors, and which are still pending. At any point, users can call `select_where_possible`, and the fulfillment context will try to do selection, retaining only those obligations that remain ambiguous. This may be helpful in pushing type inference along. Once all type inference constraints have been generated, the method `select_all_or_error` can be used to report any remaining ambiguous cases as errors.",null,null],[12,"predicates","","",551,null],[12,"register_region_obligations","","",551,null],[3,"PendingPredicateObligation","","",null,null],[12,"obligation","","",552,null],[12,"stalled_on","","",552,null],[3,"FulfillProcessor","","",null,null],[12,"selcx","","",602,null],[12,"register_region_obligations","","",602,null],[5,"trait_ref_type_vars","","Return the set of type variables contained in a trait ref",null,{"inputs":[{"name":"selectioncontext"},{"name":"polytraitref"}],"output":{"generics":["ty"],"name":"vec"}}],[5,"process_predicate","","Processes a predicate obligation and returns either: - `Ok(Some(v))` if the predicate is true, presuming that `v` are also true - `Ok(None)` if we don't have enough info to be sure - `Err` if the predicate does not hold",null,{"inputs":[{"name":"selectioncontext"},{"name":"pendingpredicateobligation"},{"name":"bool"}],"output":{"generics":["option","fulfillmenterrorcode"],"name":"result"}}],[5,"to_fulfillment_error","","",null,{"inputs":[{"generics":["pendingpredicateobligation","fulfillmenterrorcode"],"name":"error"}],"output":{"name":"fulfillmenterror"}}],[11,"as_predicate","rustc::traits","",552,null],[11,"clone","","",552,{"inputs":[{"name":"self"}],"output":{"name":"pendingpredicateobligation"}}],[11,"fmt","","",552,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new fulfillment context.",551,{"inputs":[],"output":{"name":"fulfillmentcontext"}}],[11,"new_ignoring_regions","","",551,{"inputs":[],"output":{"name":"fulfillmentcontext"}}],[11,"register_predicate_obligations","","",551,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"i"}],"output":null}],[11,"select","","Attempts to select obligations using `selcx`. If `only_new_obligations` is true, then it only attempts to select obligations that haven't been seen before.",551,{"inputs":[{"name":"self"},{"name":"selectioncontext"}],"output":{"generics":["vec"],"name":"result"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by creating a fresh type variable `$0` as well as a projection predicate `<SomeType as SomeTrait>::X == $0`. When the inference engine runs, it will attempt to find an impl of `SomeTrait` or a where clause that lets us unify `$0` with something concrete. If this fails, we'll unify `$0` with `projection_ty` again.",551,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"ty"}}],[11,"register_bound","","Requires that `ty` must implement the trait with `def_id` in the given environment. This trait must not have any type parameters (except for `Self`).",551,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"ty"},{"name":"defid"},{"name":"obligationcause"}],"output":null}],[11,"register_predicate_obligation","","",551,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"predicateobligation"}],"output":null}],[11,"select_all_or_error","","",551,{"inputs":[{"name":"self"},{"name":"inferctxt"}],"output":{"generics":["vec"],"name":"result"}}],[11,"select_where_possible","","",551,{"inputs":[{"name":"self"},{"name":"inferctxt"}],"output":{"generics":["vec"],"name":"result"}}],[11,"pending_obligations","","",551,{"inputs":[{"name":"self"}],"output":{"generics":["pendingpredicateobligation"],"name":"vec"}}],[11,"process_obligation","rustc::traits::fulfill","",602,null],[11,"process_backedge","","",602,{"inputs":[{"name":"self"},{"name":"i"},{"generics":["pendingpredicateobligation"],"name":"phantomdata"}],"output":null}],[0,"project","rustc::traits","Code for projecting associated types out of trait references.",null,null],[3,"MismatchedProjectionTypes","rustc::traits::project","",null,null],[12,"err","","",553,null],[3,"AssociatedTypeNormalizer","","",null,null],[12,"selcx","","",603,null],[12,"param_env","","",603,null],[12,"cause","","",603,null],[12,"obligations","","",603,null],[12,"depth","","",603,null],[3,"Normalized","","",null,null],[12,"value","","",556,null],[12,"obligations","","",556,null],[3,"Progress","","",null,null],[12,"ty","","",604,null],[12,"obligations","","",604,null],[3,"ProjectionCache","","The projection cache. Unlike the standard caches, this can include infcx-dependent type variables - therefore, we have to roll the cache back each time we roll a snapshot back, to avoid assumptions on yet-unresolved inference variables. Types with skolemized regions also have to be removed when the respective snapshot ends.",null,null],[12,"map","","",554,null],[3,"ProjectionCacheKey","","",null,null],[12,"ty","","",605,null],[3,"ProjectionCacheSnapshot","","",null,null],[12,"snapshot","","",555,null],[4,"Reveal","","Depending on the stage of compilation, we want projection to be more or less conservative.",null,null],[13,"UserFacing","","At type-checking time, we refuse to project any associated type that is marked `default`. Non-`default` (\"final\") types are always projected. This is necessary in general for soundness of specialization. However, we could allow projections in fully-monomorphic cases. We choose not to, because we prefer for `default type` to force the type definition to be treated abstractly by any consumers of the impl. Concretely, that means that the following example will fail to compile:",578,null],[13,"All","","At trans time, all monomorphic projections will succeed. Also, `impl Trait` is normalized to the concrete type, which has to be already collected by type-checking.",578,null],[4,"ProjectionTyError","","When attempting to resolve `<T as TraitRef>::Name` ...",null,null],[13,"TooManyCandidates","","...we found multiple sources of information and couldn't resolve the ambiguity.",606,null],[13,"TraitSelectionError","","...an error occurred matching `T : TraitRef`",606,null],[4,"ProjectionTyCandidate","","",null,null],[13,"ParamEnv","","",607,null],[13,"TraitDef","","",607,null],[13,"Select","","",607,null],[4,"ProjectionTyCandidateSet","","",null,null],[13,"None","","",608,null],[13,"Single","","",608,null],[13,"Ambiguous","","",608,null],[13,"Error","","",608,null],[4,"ProjectedTy","","",null,null],[13,"Progress","","",609,null],[13,"NoProgress","","",609,null],[4,"ProjectionCacheEntry","","",null,null],[13,"InProgress","","",610,null],[13,"Ambiguous","","",610,null],[13,"Error","","",610,null],[13,"NormalizedTy","","",610,null],[5,"poly_project_and_unify_type","","Evaluates constraints of the form:",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"generics":["option","mismatchedprojectiontypes"],"name":"result"}}],[5,"project_and_unify_type","","Evaluates constraints of the form:",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"generics":["option","mismatchedprojectiontypes"],"name":"result"}}],[5,"normalize","","Normalizes any associated type projections in `value`, replacing them with a fully resolved type where possible. The return value combines the normalized result and any additional obligations that were incurred as result.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"normalize_with_depth","","As `normalize`, but with a custom depth.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"obligationcause"},{"name":"usize"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). If ambiguity arises, which implies that there are unresolved type variables in the projection, we will substitute a fresh type variable `$X` and generate a new obligation `<T as Trait>::Item == $X` for later.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"},{"name":"usize"}],"output":{"generics":["ty"],"name":"normalized"}}],[5,"opt_normalize_projection_type","","The guts of `normalize`: normalize a specific projection like `<T as Trait>::Item`. The result is always a type (and possibly additional obligations). Returns `None` in the case of ambiguity, which indicates that there are unbound type variables.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"},{"name":"usize"}],"output":{"generics":["normalized"],"name":"option"}}],[5,"prune_cache_value_obligations","","If there are unresolved type variables, then we need to include any subobligations that bind them, at least until those type variables are fully resolved.",null,{"inputs":[{"name":"inferctxt"},{"name":"normalized"}],"output":{"generics":["ty"],"name":"normalized"}}],[5,"push_paranoid_cache_value_obligation","","Whenever we give back a cache result for a projection like `<T as Trait>::Item ==> X`, we always include the obligation to prove that `T: Trait` (we may also include some other obligations). This may or may not be necessary -- in principle, all the obligations that must be proven to show that `T: Trait` were also returned when the cache was first populated. But there are some vague concerns, and so we take the precatuionary measure of including `T: Trait` in the result:",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"},{"name":"usize"},{"name":"normalized"}],"output":null}],[5,"normalize_to_error","","If we are projecting `<T as Trait>::Item`, but `T: Trait` does not hold. In various error cases, we cannot generate a valid normalized projection. Therefore, we create an inference variable return an associated obligation that, when fulfilled, will lead to an error.",null,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"},{"name":"usize"}],"output":{"generics":["ty"],"name":"normalized"}}],[5,"project_type","","Compute the result of a projection type (if we can).",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"generics":["projectedty","projectiontyerror"],"name":"result"}}],[5,"assemble_candidates_from_param_env","","The first thing we have to do is scan through the parameter environment to see whether there are any projection predicates there that can answer this question.",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"traitref"},{"name":"projectiontycandidateset"}],"output":null}],[5,"assemble_candidates_from_trait_def","","In the case of a nested projection like <::FooT as Bar>::BarT, we may find that the definition of `Foo` has some clues:",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"traitref"},{"name":"projectiontycandidateset"}],"output":null}],[5,"assemble_candidates_from_predicates","","",null,null],[5,"assemble_candidates_from_impls","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"traitref"},{"name":"projectiontycandidateset"}],"output":null}],[5,"confirm_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"traitref"},{"name":"projectiontycandidate"}],"output":{"name":"progress"}}],[5,"confirm_select_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"traitref"},{"name":"selection"}],"output":{"name":"progress"}}],[5,"confirm_object_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"traitref"}],"output":{"name":"progress"}}],[5,"confirm_generator_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"generics":["predicateobligation"],"name":"vtablegeneratordata"}],"output":{"name":"progress"}}],[5,"confirm_fn_pointer_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"generics":["predicateobligation"],"name":"vtablefnpointerdata"}],"output":{"name":"progress"}}],[5,"confirm_closure_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"generics":["predicateobligation"],"name":"vtableclosuredata"}],"output":{"name":"progress"}}],[5,"confirm_callable_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"polyfnsig"},{"name":"tupleargumentsflag"}],"output":{"name":"progress"}}],[5,"confirm_param_env_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"name":"polyprojectionpredicate"}],"output":{"name":"progress"}}],[5,"confirm_impl_candidate","","",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"},{"generics":["predicateobligation"],"name":"vtableimpldata"}],"output":{"name":"progress"}}],[5,"assoc_ty_def","","Locate the definition of an associated type in the specialization hierarchy, starting from the given impl.",null,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"defid"}],"output":{"generics":["associateditem"],"name":"nodeitem"}}],[6,"PolyProjectionObligation","","",null,null],[6,"ProjectionObligation","","",null,null],[6,"ProjectionTyObligation","","",null,null],[6,"NormalizedTy","","",null,null],[11,"fmt","rustc::traits","",578,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",578,{"inputs":[{"name":"self"}],"output":{"name":"reveal"}}],[11,"eq","","",578,{"inputs":[{"name":"self"},{"name":"reveal"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",578,null],[11,"hash","","",578,null],[11,"fmt","rustc::traits::project","",606,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","rustc::traits","",553,{"inputs":[{"name":"self"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"eq","rustc::traits::project","",607,{"inputs":[{"name":"self"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"ne","","",607,{"inputs":[{"name":"self"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",607,null],[11,"fmt","","",607,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"mark_ambiguous","","",608,{"inputs":[{"name":"self"}],"output":null}],[11,"mark_error","","",608,{"inputs":[{"name":"self"},{"name":"selectionerror"}],"output":null}],[11,"push_candidate","","",608,{"inputs":[{"name":"self"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"new","","",603,{"inputs":[{"name":"selectioncontext"},{"name":"paramenv"},{"name":"obligationcause"},{"name":"usize"}],"output":{"name":"associatedtypenormalizer"}}],[11,"fold","","",603,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"tcx","","",603,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",603,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_const","","",603,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"const"}}],[11,"clone","rustc::traits","",556,{"inputs":[{"name":"self"}],"output":{"name":"normalized"}}],[11,"with","","",556,{"inputs":[{"name":"self"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"error","rustc::traits::project","",604,{"inputs":[{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"with_addl_obligations","","",604,{"inputs":[{"name":"self"},{"generics":["predicateobligation"],"name":"vec"}],"output":{"name":"self"}}],[11,"clone","","",605,{"inputs":[{"name":"self"}],"output":{"name":"projectioncachekey"}}],[11,"fmt","","",605,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",605,null],[11,"eq","","",605,{"inputs":[{"name":"self"},{"name":"projectioncachekey"}],"output":{"name":"bool"}}],[11,"ne","","",605,{"inputs":[{"name":"self"},{"name":"projectioncachekey"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",605,null],[11,"from_poly_projection_predicate","","",605,{"inputs":[{"name":"selectioncontext"},{"name":"polyprojectionpredicate"}],"output":{"name":"option"}}],[11,"clone","","",610,{"inputs":[{"name":"self"}],"output":{"name":"projectioncacheentry"}}],[11,"fmt","","",610,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","rustc::traits","",554,{"inputs":[],"output":{"name":"self"}}],[11,"clear","","",554,{"inputs":[{"name":"self"}],"output":null}],[11,"snapshot","","",554,{"inputs":[{"name":"self"}],"output":{"name":"projectioncachesnapshot"}}],[11,"rollback_to","","",554,{"inputs":[{"name":"self"},{"name":"projectioncachesnapshot"}],"output":null}],[11,"rollback_skolemized","","",554,{"inputs":[{"name":"self"},{"name":"projectioncachesnapshot"}],"output":null}],[11,"commit","","",554,{"inputs":[{"name":"self"},{"name":"projectioncachesnapshot"}],"output":null}],[11,"try_start","","Try to start normalize `key`; returns an error if normalization already occurred (this error corresponds to a cache hit, so it's actually a good thing).",554,{"inputs":[{"name":"self"},{"name":"projectioncachekey"}],"output":{"generics":["projectioncacheentry"],"name":"result"}}],[11,"insert_ty","","Indicates that `key` was normalized to `value`.",554,{"inputs":[{"name":"self"},{"name":"projectioncachekey"},{"generics":["ty"],"name":"normalized"}],"output":null}],[11,"complete","","Mark the relevant projection cache key as having its derived obligations complete, so they won't have to be re-computed (this is OK to do in a snapshot - if the snapshot is rolled back, the obligations will be marked as incomplete again).",554,{"inputs":[{"name":"self"},{"name":"projectioncachekey"}],"output":null}],[11,"ambiguous","","Indicates that trying to normalize `key` resulted in ambiguity. No point in trying it again then until we gain more type information (in which case, the \"fully resolved\" key will be different).",554,{"inputs":[{"name":"self"},{"name":"projectioncachekey"}],"output":null}],[11,"error","","Indicates that trying to normalize `key` resulted in error.",554,{"inputs":[{"name":"self"},{"name":"projectioncachekey"}],"output":null}],[0,"object_safety","","\"Object safety\" refers to the ability for a trait to be converted to an object. In general, traits may only be converted to an object if all of their methods meet certain criteria. In particular, they must:",null,null],[4,"ObjectSafetyViolation","rustc::traits::object_safety","",null,null],[13,"SizedSelf","","Self : Sized declared on the trait",579,null],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location (e.g. `trait Foo : Bar<Self>`)",579,null],[13,"Method","","Method has something illegal",579,null],[13,"AssociatedConst","","Associated const",579,null],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",null,null],[13,"StaticMethod","","e.g., `fn foo()`",580,null],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",580,null],[13,"Generic","","e.g., `fn foo<A>()`",580,null],[13,"NonStandardSelfType","","arbitrary `self` type, e.g. `self: Rc<Self>`",580,null],[5,"is_object_safe_provider","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"clone","rustc::traits","",579,{"inputs":[{"name":"self"}],"output":{"name":"objectsafetyviolation"}}],[11,"fmt","","",579,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",579,{"inputs":[{"name":"self"},{"name":"objectsafetyviolation"}],"output":{"name":"bool"}}],[11,"ne","","",579,{"inputs":[{"name":"self"},{"name":"objectsafetyviolation"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",579,null],[11,"hash","","",579,null],[11,"error_msg","","",579,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"clone","","",580,{"inputs":[{"name":"self"}],"output":{"name":"methodviolationcode"}}],[11,"fmt","","",580,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",580,{"inputs":[{"name":"self"},{"name":"methodviolationcode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",580,null],[11,"hash","","",580,null],[0,"on_unimplemented","","",null,null],[3,"OnUnimplementedFormatString","rustc::traits::on_unimplemented","",null,null],[12,"0","","",611,null],[3,"OnUnimplementedDirective","","",null,null],[12,"condition","","",557,null],[12,"subcommands","","",557,null],[12,"message","","",557,null],[12,"label","","",557,null],[12,"note","","",557,null],[3,"OnUnimplementedNote","","",null,null],[12,"message","","",558,null],[12,"label","","",558,null],[12,"note","","",558,null],[5,"parse_error","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"str"},{"name":"str"},{"generics":["str"],"name":"option"}],"output":{"name":"errorreported"}}],[11,"clone","","",611,{"inputs":[{"name":"self"}],"output":{"name":"onunimplementedformatstring"}}],[11,"fmt","","",611,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::traits","",557,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",558,{"inputs":[],"output":{"name":"self"}}],[11,"parse","","",557,null],[11,"of_item","","",557,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":{"generics":["option","errorreported"],"name":"result"}}],[11,"evaluate","","",557,null],[11,"try_parse","rustc::traits::on_unimplemented","",611,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"localinternedstring"},{"name":"span"}],"output":{"generics":["errorreported"],"name":"result"}}],[11,"verify","","",611,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"},{"name":"span"}],"output":{"generics":["errorreported"],"name":"result"}}],[11,"format","","",611,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"traitref"}],"output":{"name":"string"}}],[0,"select","rustc::traits","See [rustc guide] for more info on how this works.",null,null],[3,"SelectionContext","rustc::traits::select","",null,null],[12,"infcx","","",560,null],[12,"freshener","","Freshener used specifically for skolemizing entries on the obligation stack. This ensures that all entries on the stack at one time will have the same set of skolemized entries, which is important for checking for trait bounds that recursively require themselves.",560,null],[12,"intercrate","","If true, indicates that the evaluation should be conservative and consider the possibility of types outside this crate. This comes up primarily when resolving ambiguity. Imagine there is some trait reference `$0 : Bar` where `$0` is an inference variable. If `intercrate` is true, then we can never say for sure that this reference is not implemented, even if there are no impls at all for `Bar`, because `$0` could be bound to some type that in a downstream crate that implements `Bar`. This is the suitable mode for coherence. Elsewhere, though, we set this to false, because we are only interested in types that the user could actually have written --- in other words, we consider `$0 : Bar` to be unimplemented if there is no type that the user could actually name that would satisfy it. This avoids crippling inference, basically.",560,null],[12,"intercrate_ambiguity_causes","","",560,null],[12,"allow_negative_impls","","Controls whether or not to filter out negative impls when selecting. This is used in librustdoc to distinguish between the lack of an impl and a negative impl",560,null],[12,"query_mode","","The mode that trait queries run in, which informs our error handling policy. In essence, canonicalized queries need their errors propagated rather than immediately reported because we do not have accurate spans.",560,null],[3,"TraitObligationStack","","",null,null],[12,"obligation","","",612,null],[12,"fresh_trait_ref","","Trait ref from `obligation` but skolemized with the selection-context's freshener. Used to check for recursion.",612,null],[12,"previous","","",612,null],[3,"SelectionCache","","",null,null],[12,"hashmap","","",561,null],[3,"SelectionCandidateSet","","",null,null],[12,"vec","","",613,null],[12,"ambiguous","","",613,null],[3,"EvaluatedCandidate","","",null,null],[12,"candidate","","",614,null],[12,"evaluation","","",614,null],[3,"OverflowError","","Indicates that trait evaluation caused overflow.",null,null],[3,"EvaluationCache","","",null,null],[12,"hashmap","","",559,null],[3,"TraitObligationStackList","","",null,null],[12,"head","","",615,null],[3,"WithDepNode","","",null,null],[12,"dep_node","","",616,null],[12,"cached_value","","",616,null],[4,"IntercrateAmbiguityCause","","",null,null],[13,"DownstreamCrate","","",582,null],[12,"trait_desc","rustc::traits::select::IntercrateAmbiguityCause","",582,null],[12,"self_desc","","",582,null],[13,"UpstreamCrateUpdate","rustc::traits::select","",582,null],[12,"trait_desc","rustc::traits::select::IntercrateAmbiguityCause","",582,null],[12,"self_desc","","",582,null],[4,"SelectionCandidate","rustc::traits::select","The selection process begins by considering all impls, where clauses, and so forth that might resolve an obligation.  Sometimes we'll be able to say definitively that (e.g.) an impl does not apply to the obligation: perhaps it is defined for `usize` but the obligation is for `int`. In that case, we drop the impl out of the list.  But the other cases are considered candidates.",null,null],[13,"BuiltinCandidate","","",617,null],[12,"has_nested","rustc::traits::select::SelectionCandidate","",617,null],[13,"ParamCandidate","rustc::traits::select","",617,null],[13,"ImplCandidate","","",617,null],[13,"AutoImplCandidate","","",617,null],[13,"ProjectionCandidate","","This is a trait matching with a projected type as `Self`, and we found an applicable bound in the trait definition.",617,null],[13,"ClosureCandidate","","Implementation of a `Fn`-family trait by one of the anonymous types generated for a `||` expression.",617,null],[13,"GeneratorCandidate","","Implementation of a `Generator` trait by one of the anonymous types generated for a generator.",617,null],[13,"FnPointerCandidate","","Implementation of a `Fn`-family trait by one of the anonymous types generated for a fn pointer type (e.g., `fn(int)->int`)",617,null],[13,"ObjectCandidate","","",617,null],[13,"BuiltinObjectCandidate","","",617,null],[13,"BuiltinUnsizeCandidate","","",617,null],[4,"BuiltinImplConditions","","When does the builtin impl for `T: Trait` apply?",null,null],[13,"Where","","The impl is conditional on T1,T2,.. : Trait",618,null],[13,"None","","There is no built-in impl. There may be some other candidate (a where-clause or user-defined impl).",618,null],[13,"Never","","There is no impl for this, builtin or not. Ignore all where-clauses.",618,null],[13,"Ambiguous","","It is unknown whether there is an impl.",618,null],[4,"EvaluationResult","","The result of trait evaluation. The order is important here as the evaluation of a list is the maximum of the evaluations.",null,null],[13,"EvaluatedToOk","","Evaluation successful",581,null],[13,"EvaluatedToAmbig","","Evaluation is known to be ambiguous - it might hold for some assignment of inference variables, but it might not.",581,null],[13,"EvaluatedToUnknown","","Evaluation failed because of recursion involving inference variables. We are somewhat imprecise there, so we don't actually know the real result.",581,null],[13,"EvaluatedToRecur","","Evaluation failed because we encountered an obligation we are already trying to prove on this branch.",581,null],[13,"EvaluatedToErr","","Evaluation failed",581,null],[11,"clone","rustc::traits","",582,{"inputs":[{"name":"self"}],"output":{"name":"intercrateambiguitycause"}}],[11,"fmt","","",582,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"add_intercrate_ambiguity_hint","","Emits notes when the overlap is caused by complex intercrate ambiguities. See #23980 for details.",582,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"intercrate_ambiguity_hint","","",582,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"clone","","",561,{"inputs":[{"name":"self"}],"output":{"name":"selectioncache"}}],[11,"eq","rustc::traits::select","",617,{"inputs":[{"name":"self"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"ne","","",617,{"inputs":[{"name":"self"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",617,null],[11,"fmt","","",617,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",617,{"inputs":[{"name":"self"}],"output":{"name":"selectioncandidate"}}],[11,"lift_to_tcx","","",617,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"eq","","",614,{"inputs":[{"name":"self"},{"name":"evaluatedcandidate"}],"output":{"name":"bool"}}],[11,"ne","","",614,{"inputs":[{"name":"self"},{"name":"evaluatedcandidate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",614,null],[11,"fmt","","",614,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",614,{"inputs":[{"name":"self"}],"output":{"name":"evaluatedcandidate"}}],[11,"clone","rustc::traits","",581,{"inputs":[{"name":"self"}],"output":{"name":"evaluationresult"}}],[11,"fmt","","",581,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",581,{"inputs":[{"name":"self"},{"name":"evaluationresult"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",581,{"inputs":[{"name":"self"},{"name":"evaluationresult"}],"output":{"name":"ordering"}}],[11,"eq","","",581,{"inputs":[{"name":"self"},{"name":"evaluationresult"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",581,null],[11,"may_apply","","",581,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_stack_dependent","","",581,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"hash_stable","","",581,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",619,{"inputs":[{"name":"self"}],"output":{"name":"overflowerror"}}],[11,"fmt","","",619,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",619,{"inputs":[{"name":"self"},{"name":"overflowerror"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",619,null],[11,"hash_stable","","",619,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"from","","",591,{"inputs":[{"name":"overflowerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",559,{"inputs":[{"name":"self"}],"output":{"name":"evaluationcache"}}],[11,"new","","",560,{"inputs":[{"name":"inferctxt"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",560,{"inputs":[{"name":"inferctxt"},{"name":"intercratemode"}],"output":{"name":"selectioncontext"}}],[11,"with_negative","","",560,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"selectioncontext"}}],[11,"with_query_mode","","",560,{"inputs":[{"name":"inferctxt"},{"name":"traitquerymode"}],"output":{"name":"selectioncontext"}}],[11,"enable_tracking_intercrate_ambiguity_causes","","Enables tracking of intercrate ambiguity causes. These are used in coherence to give improved diagnostics. We don't do this until we detect a coherence error because it can lead to false overflow results (#47139) and because it costs computation time.",560,{"inputs":[{"name":"self"}],"output":null}],[11,"take_intercrate_ambiguity_causes","","Gets the intercrate ambiguity causes collected since tracking was enabled and disables tracking at the same time. If tracking is not enabled, just returns an empty vector.",560,{"inputs":[{"name":"self"}],"output":{"generics":["intercrateambiguitycause"],"name":"vec"}}],[11,"infcx","","",560,{"inputs":[{"name":"self"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",560,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"closure_typer","","",560,{"inputs":[{"name":"self"}],"output":{"name":"inferctxt"}}],[11,"in_snapshot","","Wraps the inference context's in_snapshot s.t. snapshot handling is only from the selection context's self.",560,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"probe","","Wraps a probe s.t. obligations collected during it are ignored and old obligations are retained.",560,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Wraps a commit_if_ok s.t. obligations collected during it are not returned in selection if the transaction fails and s.t. old obligations are retained.",560,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding type environment by performing unification.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"generics":["selection"],"name":"selectionresult"}}],[11,"predicate_may_hold_fatal","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",560,{"inputs":[{"name":"self"},{"name":"predicateobligation"}],"output":{"name":"bool"}}],[11,"evaluate_obligation_recursively","","Evaluates whether the obligation `obligation` can be satisfied and returns an `EvaluationResult`.",560,{"inputs":[{"name":"self"},{"name":"predicateobligation"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"evaluate_predicates_recursively","","Evaluates the predicates in `predicates` recursively. Note that this applies projections in the predicates, and therefore is run within an inference probe.",560,{"inputs":[{"name":"self"},{"name":"traitobligationstacklist"},{"name":"i"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"evaluate_predicate_recursively","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstacklist"},{"name":"predicateobligation"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"evaluate_trait_predicate_recursively","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstacklist"},{"name":"traitobligation"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"evaluate_stack","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"coinductive_match","","For defaulted traits, we use a co-inductive strategy to solve, so that recursion is ok. This routine returns true if the top of the stack (`cycle[0]`):",560,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"bool"}}],[11,"coinductive_predicate","","",560,{"inputs":[{"name":"self"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"evaluate_candidate","","Further evaluate `candidate` to decide whether all type parameters match and whether nested obligations are met. Returns true if `candidate` remains viable after this further scrutiny.",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"},{"name":"selectioncandidate"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"check_evaluation_cache","","",560,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"polytraitref"}],"output":{"generics":["evaluationresult"],"name":"option"}}],[11,"insert_evaluation_cache","","",560,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"polytraitref"},{"name":"depnodeindex"},{"name":"evaluationresult"}],"output":null}],[11,"candidate_from_obligation","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"}],"output":{"generics":["selectioncandidate"],"name":"selectionresult"}}],[11,"in_task","","",560,null],[11,"filter_negative_impls","","",560,{"inputs":[{"name":"self"},{"name":"selectioncandidate"}],"output":{"generics":["selectioncandidate"],"name":"selectionresult"}}],[11,"candidate_from_obligation_no_cache","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"}],"output":{"generics":["selectioncandidate"],"name":"selectionresult"}}],[11,"is_knowable","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"}],"output":{"generics":["conflict"],"name":"option"}}],[11,"can_use_global_caches","","Returns true if the global caches can be used. Do note that if the type itself is not in the global tcx, the local caches will be used.",560,{"inputs":[{"name":"self"},{"name":"paramenv"}],"output":{"name":"bool"}}],[11,"check_candidate_cache","","",560,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"polytraitpredicate"}],"output":{"generics":["selectionresult"],"name":"option"}}],[11,"insert_candidate_cache","","",560,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"polytraitpredicate"},{"name":"depnodeindex"},{"generics":["selectioncandidate"],"name":"selectionresult"}],"output":null}],[11,"assemble_candidates","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"}],"output":{"generics":["selectioncandidateset","selectionerror"],"name":"result"}}],[11,"assemble_candidates_from_projected_tys","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":null}],[11,"match_projection_obligation_against_definition_bounds","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"combinedsnapshot"}],"output":{"name":"bool"}}],[11,"match_projection","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"polytraitref"},{"name":"traitref"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"}],"output":{"name":"bool"}}],[11,"assemble_candidates_from_caller_bounds","","Given an obligation like `<SomeTrait for T>`, search the obligations that the caller supplied to find out whether it is listed among them.",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"evaluate_where_clause","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstack"},{"name":"polytraitref"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"assemble_generator_candidates","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"assemble_closure_candidates","","Check for the artificial impl that the compiler will create for an obligation like `X : FnMut<..>` where `X` is a closure type.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"assemble_fn_pointer_candidates","","Implement one of the `Fn()` family for a fn pointer.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"assemble_candidates_from_impls","","Search for impls that might apply to `obligation`.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"assemble_candidates_from_auto_impls","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"assemble_candidates_from_object_ty","","Search for impls that might apply to `obligation`.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":null}],[11,"assemble_candidates_for_unsizing","","Search for unsizing that might apply to `obligation`.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidateset"}],"output":null}],[11,"candidate_should_be_dropped_in_favor_of","","Returns true if `candidate_i` should be dropped in favor of `candidate_j`.  Generally speaking we will drop duplicate candidates and prefer where-clause candidates. Returns true if `victim` should be dropped in favor of `other`.  Generally speaking we will drop duplicate candidates and prefer where-clause candidates.",560,{"inputs":[{"name":"self"},{"name":"evaluatedcandidate"},{"name":"evaluatedcandidate"}],"output":{"name":"bool"}}],[11,"assemble_builtin_bound_candidates","","",560,{"inputs":[{"name":"self"},{"name":"builtinimplconditions"},{"name":"selectioncandidateset"}],"output":{"generics":["selectionerror"],"name":"result"}}],[11,"sized_conditions","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"name":"builtinimplconditions"}}],[11,"copy_clone_conditions","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"name":"builtinimplconditions"}}],[11,"constituent_types_for_ty","","For default impls, we need to break apart a type into its \"constituent types\" -- meaning, the types that it contains.",560,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["ty"],"name":"vec"}}],[11,"collect_predicates_for_types","","",560,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"obligationcause"},{"name":"usize"},{"name":"defid"},{"generics":["vec"],"name":"binder"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[11,"confirm_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"selectioncandidate"}],"output":{"generics":["selection","selectionerror"],"name":"result"}}],[11,"confirm_projection_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":null}],[11,"confirm_param_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"polytraitref"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[11,"confirm_builtin_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"bool"}],"output":{"generics":["predicateobligation"],"name":"vtablebuiltindata"}}],[11,"confirm_auto_impl_candidate","","This handles the case where a `auto trait Foo` impl is being used. The idea is that the impl applies to `X : Foo` if the following conditions are met:",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"defid"}],"output":{"generics":["predicateobligation"],"name":"vtableautoimpldata"}}],[11,"vtable_auto_impl","","See `confirm_auto_impl_candidate`",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"defid"},{"generics":["vec"],"name":"binder"}],"output":{"generics":["predicateobligation"],"name":"vtableautoimpldata"}}],[11,"confirm_impl_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"defid"}],"output":{"generics":["predicateobligation"],"name":"vtableimpldata"}}],[11,"vtable_impl","","",560,{"inputs":[{"name":"self"},{"name":"defid"},{"generics":["substs"],"name":"normalized"},{"name":"obligationcause"},{"name":"usize"},{"name":"paramenv"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"}],"output":{"generics":["predicateobligation"],"name":"vtableimpldata"}}],[11,"confirm_object_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"generics":["predicateobligation"],"name":"vtableobjectdata"}}],[11,"confirm_fn_pointer_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"generics":["vtablefnpointerdata","selectionerror"],"name":"result"}}],[11,"confirm_generator_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"generics":["vtablegeneratordata","selectionerror"],"name":"result"}}],[11,"confirm_closure_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"generics":["vtableclosuredata","selectionerror"],"name":"result"}}],[11,"confirm_poly_trait_refs","","In the case of closure types and fn pointers, we currently treat the input type parameters on the trait as outputs. This means that when we have a match we have only considered the self type, so we have to go back and make sure to relate the argument types too.  This is kind of wrong, but since we control the full set of impls, also not that wrong, and it DOES yield better error messages (since we don't report errors as if there is no applicable impl, but rather report errors are about mismatched argument types.",560,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"paramenv"},{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"generics":["vec","selectionerror"],"name":"result"}}],[11,"confirm_builtin_unsize_candidate","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"}],"output":{"generics":["vtablebuiltindata","selectionerror"],"name":"result"}}],[11,"rematch_impl","","",560,null],[11,"match_impl","","",560,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"traitobligation"},{"name":"combinedsnapshot"}],"output":{"name":"result"}}],[11,"fast_reject_trait_refs","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"match_where_clause_trait_ref","","Normalize `where_clause_trait_ref` and try to match it against `obligation`.  If successful, return any predicates that result from the normalization. Normalization is necessary because where-clauses are stored in the parameter environment unnormalized.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"polytraitref"}],"output":{"generics":["vec"],"name":"result"}}],[11,"match_poly_trait_ref","","Returns `Ok` if `poly_trait_ref` being true implies that the obligation is satisfied.",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"polytraitref"}],"output":{"generics":["vec"],"name":"result"}}],[11,"match_fresh_trait_refs","","",560,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"push_stack","","",560,{"inputs":[{"name":"self"},{"name":"traitobligationstacklist"},{"name":"traitobligation"}],"output":{"name":"traitobligationstack"}}],[11,"closure_trait_ref_unnormalized","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"polytraitref"}}],[11,"generator_trait_ref_unnormalized","","",560,{"inputs":[{"name":"self"},{"name":"traitobligation"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"polytraitref"}}],[11,"impl_or_trait_obligations","","Returns the obligations that are implied by instantiating an impl or trait. The obligations are substituted and fully normalized. This is used when confirming an impl or default impl.",560,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"usize"},{"name":"paramenv"},{"name":"defid"},{"name":"substs"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[11,"new","","",561,{"inputs":[],"output":{"name":"selectioncache"}}],[11,"clear","","",561,{"inputs":[{"name":"self"}],"output":null}],[11,"new","","",559,{"inputs":[],"output":{"name":"evaluationcache"}}],[11,"clear","","",559,{"inputs":[{"name":"self"}],"output":null}],[11,"list","rustc::traits::select","",612,{"inputs":[{"name":"self"}],"output":{"name":"traitobligationstacklist"}}],[11,"iter","","",612,{"inputs":[{"name":"self"}],"output":{"name":"traitobligationstacklist"}}],[11,"clone","","",615,{"inputs":[{"name":"self"}],"output":{"name":"traitobligationstacklist"}}],[11,"empty","","",615,{"inputs":[],"output":{"name":"traitobligationstacklist"}}],[11,"with","","",615,{"inputs":[{"name":"traitobligationstack"}],"output":{"name":"traitobligationstacklist"}}],[11,"next","","",615,{"inputs":[{"name":"self"}],"output":{"generics":["traitobligationstack"],"name":"option"}}],[11,"fmt","","",612,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",616,{"inputs":[{"name":"self"}],"output":{"name":"withdepnode"}}],[11,"new","","",616,{"inputs":[{"name":"depnodeindex"},{"name":"t"}],"output":{"name":"self"}}],[11,"get","","",616,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"t"}}],[0,"specialize","rustc::traits","Logic and data structures related to impl specialization, explained in greater detail below.",null,null],[3,"OverlapError","rustc::traits::specialize","Information pertinent to an overlapping impl error.",null,null],[12,"with_impl","","",562,null],[12,"trait_desc","","",562,null],[12,"self_desc","","",562,null],[12,"intercrate_ambiguity_causes","","",562,null],[3,"SpecializesCache","","",null,null],[12,"map","","",563,null],[5,"translate_substs","","Given a subst for the requested impl, translate it to a subst appropriate for the actual item definition (whether it be in that impl, a parent impl, or the trait).",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"defid"},{"name":"substs"},{"name":"node"}],"output":{"name":"substs"}}],[5,"find_associated_item","","Given a selected impl described by `impl_data`, returns the definition and substitutions for the method with the name `name` the kind `kind`, and trait method substitutions `substs`, in that impl, a less specialized impl, or the trait default, whichever applies.",null,null],[5,"specializes","","Is impl1 a specialization of impl2?",null,null],[5,"fulfill_implication","","Attempt to fulfill all obligations of `target_impl` after unification with `source_trait_ref`. If successful, returns a substitution for all the generics of `target_impl`, including both those needed to unify with `source_trait_ref` and those whose identity is determined via a where clause in the impl.",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"traitref"},{"name":"defid"}],"output":{"generics":["substs"],"name":"result"}}],[5,"specialization_graph_provider","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["graph"],"name":"lrc"}}],[5,"to_pretty_impl_header","","Recovers the \"impl X for Y\" signature from `impl_def_id` and returns it as a string.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["string"],"name":"option"}}],[0,"specialization_graph","","",null,null],[3,"Graph","rustc::traits::specialize::specialization_graph","A per-trait graph of impls in specialization order. At the moment, this graph forms a tree rooted with the trait itself, with all other nodes representing impls, and parent-child relationships representing specializations.",null,null],[12,"parent","","",594,null],[12,"children","","",594,null],[3,"Children","","Children of a given impl, grouped into blanket/non-blanket varieties as is done in `TraitDef`.",null,null],[12,"nonblanket_impls","","Impls of the trait.",620,null],[12,"blanket_impls","","Blanket impls associated with the trait.",620,null],[3,"Ancestors","","",null,null],[12,"trait_def_id","","",595,null],[12,"specialization_graph","","",595,null],[12,"current_source","","",595,null],[3,"NodeItem","","",null,null],[12,"node","","",596,null],[12,"item","","",596,null],[4,"Inserted","","The result of attempting to insert an impl into a group of children.",null,null],[13,"BecameNewSibling","","The impl was inserted as a new child in this group of children.",621,null],[13,"Replaced","","The impl replaced an existing impl that specializes it.",621,null],[13,"ShouldRecurseOn","","The impl is a specialization of an existing child.",621,null],[4,"Node","","A node in the specialization graph is either an impl or a trait definition; either can serve as a source of item definitions. There is always exactly one trait definition node: the root.",null,null],[13,"Impl","","",597,null],[13,"Trait","","",597,null],[5,"ancestors","","Walk up the specialization ancestors of a given impl, starting with that impl itself.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"ancestors"}}],[11,"encode","rustc::traits::specialization_graph","",594,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",594,{"inputs":[{"name":"__d"}],"output":{"generics":["graph"],"name":"result"}}],[11,"encode","rustc::traits::specialize::specialization_graph","",620,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",620,{"inputs":[{"name":"__d"}],"output":{"generics":["children"],"name":"result"}}],[11,"new","","",620,{"inputs":[],"output":{"name":"children"}}],[11,"insert_blindly","","Insert an impl into this set of children without comparing to any existing impls",620,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"}],"output":null}],[11,"insert","","Attempt to insert an impl into this set of children, while comparing for specialization relationships.",620,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"},{"generics":["simplifiedtype"],"name":"option"}],"output":{"generics":["inserted","overlaperror"],"name":"result"}}],[11,"iter_mut","","",620,{"inputs":[{"name":"self"}],"output":{"generics":["iterator"],"name":"box"}}],[11,"filtered_mut","","",620,{"inputs":[{"name":"self"},{"name":"simplifiedtype"}],"output":{"generics":["iterator"],"name":"box"}}],[11,"new","rustc::traits::specialization_graph","",594,{"inputs":[],"output":{"name":"graph"}}],[11,"insert","","Insert a local impl into the specialization graph. If an existing impl conflicts with it (has overlap, but neither specializes the other), information about the area of overlap is returned in the `Err`.",594,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["option","overlaperror"],"name":"result"}}],[11,"record_impl_from_cstore","","Insert cached metadata mapping from a child impl back to its parent.",594,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":null}],[11,"parent","","The parent of a given impl, which is the def id of the trait when the impl is a \"specialization root\".",594,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"fmt","","",597,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",597,{"inputs":[{"name":"self"}],"output":{"name":"node"}}],[11,"is_from_trait","","",597,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"items","","Iterate over the items defined directly by the given (impl or trait) node.",597,null],[11,"def_id","","",597,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"next","","",595,{"inputs":[{"name":"self"}],"output":{"generics":["node"],"name":"option"}}],[11,"map","","",596,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"nodeitem"}}],[11,"defs","","Search the items from the given ancestors, returning each definition with the given name and the given kind.",595,null],[11,"hash_stable","rustc::traits::specialize::specialization_graph","",620,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::traits::specialization_graph","",594,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","rustc::traits","",563,{"inputs":[],"output":{"name":"self"}}],[11,"check","","",563,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"defid"}],"output":{"generics":["bool"],"name":"option"}}],[11,"insert","","",563,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"defid"},{"name":"bool"}],"output":null}],[0,"structural_impls","","",null,null],[11,"fmt","","",556,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",565,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",593,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",570,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",571,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",572,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",574,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",573,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",575,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",576,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",569,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",592,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",553,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"lift_to_tcx","","",591,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",585,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",567,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",566,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",593,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"super_fold_with","","",565,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",565,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",570,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",570,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",571,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",571,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",572,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",572,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",573,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",573,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",574,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",574,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",575,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",575,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",576,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",576,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",593,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",593,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",556,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",556,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"fmt","","",586,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",587,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",588,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",589,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",568,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",590,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"super_fold_with","","",586,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",586,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",587,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",587,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",588,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"quantifierkind"}}],[11,"super_visit_with","","",588,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",589,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",589,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",568,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",568,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",590,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",590,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[0,"trans","","",null,null],[3,"TraitSelectionCache","rustc::traits::trans","",null,null],[12,"data","","",622,null],[3,"ProjectionCache","","",null,null],[12,"data","","",623,null],[5,"trans_fulfill_obligation","","Attempts to resolve an obligation to a vtable.. The result is a shallow vtable resolution -- meaning that we do not (necessarily) resolve all nested obligations on the impl. Note that type check should guarantee to us that all nested obligations could be resolved if we wanted to. Assumes that this is run after the entire crate has been successfully type-checked.",null,null],[11,"to_dep_kind","","",622,{"inputs":[],"output":{"name":"depkind"}}],[11,"to_dep_kind","","",623,{"inputs":[],"output":{"name":"depkind"}}],[11,"drain_fulfillment_cx_or_panic","rustc::infer","Finishes processes any obligations that remain in the fulfillment context, and then returns the result with all type variables removed and regions erased. Because this is intended for use after type-check has completed, if any errors occur, it will panic. It is used during normalization and other cases where processing the obligations in `fulfill_cx` may cause type inference variables that appear in `result` to be unified, and hence we need to process those obligations to get the complete picture of the type.",203,null],[0,"util","rustc::traits","",null,null],[3,"PredicateSet","rustc::traits::util","",null,null],[12,"tcx","","",624,null],[12,"set","","",624,null],[3,"Elaborator","","\"Elaboration\" is the process of identifying all the predicates that are implied by a source predicate. Currently this basically means walking the \"supertraits\" and other similar assumptions. For example, if we know that `T : Ord`, the elaborator would deduce that `T : PartialOrd` holds as well. Similarly, if we have `trait Foo : 'static`, and we know that `T : Foo`, then we know that `T : 'static`.",null,null],[12,"stack","","",625,null],[12,"visited","","",625,null],[3,"SupertraitDefIds","","",null,null],[12,"tcx","","",564,null],[12,"stack","","",564,null],[12,"visited","","",564,null],[3,"FilterToTraits","","A filter around an iterator of predicates that makes it yield up just trait references.",null,null],[12,"base_iterator","","",626,null],[4,"TupleArgumentsFlag","","",null,null],[13,"Yes","","",627,null],[13,"No","","",627,null],[5,"anonymize_predicate","","",null,{"inputs":[{"name":"tyctxt"},{"name":"predicate"}],"output":{"name":"predicate"}}],[5,"elaborate_trait_ref","","",null,{"inputs":[{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"name":"elaborator"}}],[5,"elaborate_trait_refs","","",null,null],[5,"elaborate_predicates","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["predicate"],"name":"vec"}],"output":{"name":"elaborator"}}],[5,"supertraits","","",null,{"inputs":[{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"name":"supertraits"}}],[5,"transitive_bounds","","",null,null],[5,"supertrait_def_ids","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"supertraitdefids"}}],[5,"impl_trait_ref_and_oblig","","Instantiate all bound parameters of the impl with the given substs, returning the resulting trait ref and all obligations that arise. The obligations are closed under normalization.",null,null],[5,"predicates_for_generics","","See `super::obligations_for_generics`",null,{"inputs":[{"name":"obligationcause"},{"name":"usize"},{"name":"paramenv"},{"name":"instantiatedpredicates"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[5,"predicate_for_trait_ref","","",null,{"inputs":[{"name":"obligationcause"},{"name":"paramenv"},{"name":"traitref"},{"name":"usize"}],"output":{"name":"predicateobligation"}}],[6,"Supertraits","","",null,null],[11,"new","","",624,{"inputs":[{"name":"tyctxt"}],"output":{"name":"predicateset"}}],[11,"insert","","",624,{"inputs":[{"name":"self"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"filter_to_traits","","",625,{"inputs":[{"name":"self"}],"output":{"name":"filtertotraits"}}],[11,"push","","",625,{"inputs":[{"name":"self"},{"name":"predicate"}],"output":null}],[11,"next","","",625,{"inputs":[{"name":"self"}],"output":{"generics":["predicate"],"name":"option"}}],[11,"next","rustc::traits","",564,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"new","rustc::traits::util","",626,{"inputs":[{"name":"i"}],"output":{"name":"filtertotraits"}}],[11,"next","","",626,{"inputs":[{"name":"self"}],"output":{"generics":["polytraitref"],"name":"option"}}],[11,"size_hint","","",626,null],[0,"query","rustc::traits","Experimental types for the trait query interface. The methods defined in this module are all based on canonicalization, which makes a canonical query by replacing unbound inference variables and regions, so that results can be reused more broadly. The providers for the queries defined here can be found in `librustc_traits`.",null,null],[3,"NoSolution","rustc::traits::query","",null,null],[0,"dropck_outlives","","",null,null],[3,"DropckOutlivesResult","rustc::traits::query::dropck_outlives","",null,null],[12,"kinds","","",628,null],[12,"overflows","","",628,null],[3,"DtorckConstraint","","A set of constraints that need to be satisfied in order for a type to be valid for destruction.",null,null],[12,"outlives","","Types that are required to be alive in order for this type to be valid for destruction.",629,null],[12,"dtorck_types","","Types that could not be resolved: projections and params.",629,null],[12,"overflows","","If, during the computation of the dtorck constraint, we overflow, that gets recorded here. The caller is expected to report an error.",629,null],[5,"trivial_dropck_outlives","","This returns true if the type `ty` is \"trivial\" for dropck-outlives -- that is, if it doesn't require any types to outlive. This is similar but not quite the same as the `needs_drop` test in the compiler already -- that is, for every type T for which this function return true, needs-drop would return false. But the reverse does not hold: in particular, `needs_drop` returns false for `PhantomData`, but it is not trivial for dropck-outlives.",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"dropck_outlives","rustc::infer::at","Given a type `ty` of some value being dropped, computes a set of \"kinds\" (types, regions) that must be outlive the execution of the destructor. These basically correspond to data that the destructor might access. This is used during regionck to impose \"outlives\" constraints on any lifetimes referenced within.",218,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["vec"],"name":"inferok"}}],[11,"clone","rustc::traits::query::dropck_outlives","",628,{"inputs":[{"name":"self"}],"output":{"name":"dropckoutlivesresult"}}],[11,"fmt","","",628,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",629,{"inputs":[{"name":"self"}],"output":{"name":"dtorckconstraint"}}],[11,"fmt","","",629,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",629,{"inputs":[],"output":{"name":"dtorckconstraint"}}],[11,"from_iter","","",629,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"super_fold_with","","",628,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",628,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",628,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["dropckoutlivesresult"],"name":"option"}}],[11,"hash_stable","","",628,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"intern","rustc::infer::canonical","",224,null],[11,"hash_stable","rustc::traits::query::dropck_outlives","",629,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"evaluate_obligation","rustc::traits::query","",null,null],[11,"predicate_may_hold","rustc::infer","Evaluates whether the predicate can be satisfied (by any means) in the given `ParamEnv`.",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"}],"output":{"name":"bool"}}],[11,"predicate_must_hold","","Evaluates whether the predicate can be satisfied in the given `ParamEnv`, and returns `false` if not certain. However, this is not entirely accurate if inference variables are involved.",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"}],"output":{"name":"bool"}}],[11,"evaluate_obligation","","",203,{"inputs":[{"name":"self"},{"name":"predicateobligation"}],"output":{"name":"evaluationresult"}}],[0,"normalize","rustc::traits::query","Code for the 'normalization' query. This consists of a wrapper which folds deeply, invoking the underlying `normalize_projection_ty` query when it encounters projections.",null,null],[3,"NormalizationResult","rustc::traits::query::normalize","Result from the `normalize_projection_ty` query.",null,null],[12,"normalized_ty","","Result of normalization.",630,null],[3,"QueryNormalizer","","",null,null],[12,"infcx","","",631,null],[12,"cause","","",631,null],[12,"param_env","","",631,null],[12,"obligations","","",631,null],[12,"error","","",631,null],[12,"anon_depth","","",631,null],[11,"normalize","rustc::infer::at","Normalize `value` in the context of the inference context, yielding a resulting type, or an error if `value` cannot be normalized. If you don't care about regions, you should prefer `normalize_erasing_regions`, which is more efficient.",218,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"generics":["normalized","nosolution"],"name":"result"}}],[11,"clone","rustc::traits::query::normalize","",630,{"inputs":[{"name":"self"}],"output":{"name":"normalizationresult"}}],[11,"fmt","","",630,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"tcx","","",631,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",631,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_const","","",631,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"const"}}],[11,"super_fold_with","","",630,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",630,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","","",630,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["normalizationresult"],"name":"option"}}],[11,"intern","rustc::infer::canonical","",224,null],[11,"hash_stable","rustc::traits::query::normalize","",630,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"normalize_erasing_regions","rustc::traits::query","Methods for normalizing when you don't care about regions (and aren't doing type inference). If either of those things don't apply to you, use `infcx.normalize(...)`.",null,null],[3,"NormalizeAfterErasingRegionsFolder","rustc::traits::query::normalize_erasing_regions","",null,null],[12,"tcx","","",632,null],[12,"param_env","","",632,null],[11,"tcx","","",632,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",632,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[6,"CanonicalProjectionGoal","rustc::traits::query","",null,null],[6,"CanonicalTyGoal","","",null,null],[6,"CanonicalPredicateGoal","","",null,null],[6,"Fallible","","",null,null],[11,"clone","","",633,{"inputs":[{"name":"self"}],"output":{"name":"nosolution"}}],[11,"fmt","","",633,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",633,{"inputs":[{"name":"self"},{"name":"nosolution"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",633,null],[11,"hash","","",633,null],[11,"hash_stable","","",633,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[6,"Supertraits","rustc::traits","",null,null],[6,"PredicateObligation","","",null,null],[6,"TraitObligation","","",null,null],[6,"Obligations","","",null,null],[6,"PredicateObligations","","",null,null],[6,"TraitObligations","","",null,null],[6,"PolyDomainGoal","","",null,null],[6,"Goals","","",null,null],[6,"Clauses","","Multiple clauses.",null,null],[6,"Selection","","",null,null],[6,"SelectionResult","","When performing resolution, it is typically the case that there can be one of three outcomes:",null,null],[8,"TraitEngine","","",null,null],[10,"normalize_projection_type","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"ty"}}],[10,"register_bound","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"paramenv"},{"name":"ty"},{"name":"defid"},{"name":"obligationcause"}],"output":null}],[10,"register_predicate_obligation","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"predicateobligation"}],"output":null}],[10,"select_all_or_error","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"}],"output":{"generics":["vec"],"name":"result"}}],[10,"select_where_possible","","",601,{"inputs":[{"name":"self"},{"name":"inferctxt"}],"output":{"generics":["vec"],"name":"result"}}],[10,"pending_obligations","","",601,{"inputs":[{"name":"self"}],"output":{"generics":["pendingpredicateobligation"],"name":"vec"}}],[11,"clone","","",583,{"inputs":[{"name":"self"}],"output":{"name":"intercratemode"}}],[11,"eq","","",583,{"inputs":[{"name":"self"},{"name":"intercratemode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",583,null],[11,"fmt","","",583,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",584,{"inputs":[{"name":"self"}],"output":{"name":"traitquerymode"}}],[11,"eq","","",584,{"inputs":[{"name":"self"},{"name":"traitquerymode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",584,null],[11,"fmt","","",584,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",565,{"inputs":[{"name":"self"}],"output":{"name":"obligation"}}],[11,"eq","","",565,{"inputs":[{"name":"self"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",565,{"inputs":[{"name":"self"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",565,null],[11,"hash","","",565,null],[11,"clone","","",566,{"inputs":[{"name":"self"}],"output":{"name":"obligationcause"}}],[11,"fmt","","",566,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",566,{"inputs":[{"name":"self"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",566,{"inputs":[{"name":"self"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",566,null],[11,"hash","","",566,null],[11,"span","","",566,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"clone","","",585,{"inputs":[{"name":"self"}],"output":{"name":"obligationcausecode"}}],[11,"fmt","","",585,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",585,{"inputs":[{"name":"self"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",585,{"inputs":[{"name":"self"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",585,null],[11,"hash","","",585,null],[11,"clone","","",567,{"inputs":[{"name":"self"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",567,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",567,{"inputs":[{"name":"self"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",567,{"inputs":[{"name":"self"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",567,null],[11,"hash","","",567,null],[11,"clone","","",586,{"inputs":[{"name":"self"}],"output":{"name":"whereclauseatom"}}],[11,"eq","","",586,{"inputs":[{"name":"self"},{"name":"whereclauseatom"}],"output":{"name":"bool"}}],[11,"ne","","",586,{"inputs":[{"name":"self"},{"name":"whereclauseatom"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",586,null],[11,"hash","","",586,null],[11,"fmt","","",586,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",587,{"inputs":[{"name":"self"}],"output":{"name":"domaingoal"}}],[11,"eq","","",587,{"inputs":[{"name":"self"},{"name":"domaingoal"}],"output":{"name":"bool"}}],[11,"ne","","",587,{"inputs":[{"name":"self"},{"name":"domaingoal"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",587,null],[11,"hash","","",587,null],[11,"fmt","","",587,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",588,{"inputs":[{"name":"self"}],"output":{"name":"quantifierkind"}}],[11,"eq","","",588,{"inputs":[{"name":"self"},{"name":"quantifierkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",588,null],[11,"hash","","",588,null],[11,"fmt","","",588,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",589,{"inputs":[{"name":"self"}],"output":{"name":"goal"}}],[11,"eq","","",589,{"inputs":[{"name":"self"},{"name":"goal"}],"output":{"name":"bool"}}],[11,"ne","","",589,{"inputs":[{"name":"self"},{"name":"goal"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",589,null],[11,"hash","","",589,null],[11,"fmt","","",589,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_poly_domain_goal","","",589,{"inputs":[{"name":"polydomaingoal"},{"name":"tyctxt"}],"output":{"name":"goal"}}],[11,"from","","",589,{"inputs":[{"name":"domaingoal"}],"output":{"name":"self"}}],[11,"clone","","",590,{"inputs":[{"name":"self"}],"output":{"name":"clause"}}],[11,"eq","","",590,{"inputs":[{"name":"self"},{"name":"clause"}],"output":{"name":"bool"}}],[11,"ne","","",590,{"inputs":[{"name":"self"},{"name":"clause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",590,null],[11,"hash","","",590,null],[11,"fmt","","",590,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",568,{"inputs":[{"name":"self"}],"output":{"name":"programclause"}}],[11,"eq","","",568,{"inputs":[{"name":"self"},{"name":"programclause"}],"output":{"name":"bool"}}],[11,"ne","","",568,{"inputs":[{"name":"self"},{"name":"programclause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",568,null],[11,"hash","","",568,null],[11,"fmt","","",568,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",591,{"inputs":[{"name":"self"}],"output":{"name":"selectionerror"}}],[11,"fmt","","",591,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",592,{"inputs":[{"name":"self"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",593,{"inputs":[{"name":"self"}],"output":{"name":"vtable"}}],[11,"eq","","",593,{"inputs":[{"name":"self"},{"name":"vtable"}],"output":{"name":"bool"}}],[11,"ne","","",593,{"inputs":[{"name":"self"},{"name":"vtable"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",593,null],[11,"encode","","",593,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",593,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtable"],"name":"result"}}],[11,"clone","","",570,{"inputs":[{"name":"self"}],"output":{"name":"vtableimpldata"}}],[11,"eq","","",570,{"inputs":[{"name":"self"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",570,{"inputs":[{"name":"self"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",570,null],[11,"encode","","",570,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",570,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtableimpldata"],"name":"result"}}],[11,"clone","","",571,{"inputs":[{"name":"self"}],"output":{"name":"vtablegeneratordata"}}],[11,"eq","","",571,{"inputs":[{"name":"self"},{"name":"vtablegeneratordata"}],"output":{"name":"bool"}}],[11,"ne","","",571,{"inputs":[{"name":"self"},{"name":"vtablegeneratordata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",571,null],[11,"encode","","",571,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",571,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtablegeneratordata"],"name":"result"}}],[11,"clone","","",572,{"inputs":[{"name":"self"}],"output":{"name":"vtableclosuredata"}}],[11,"eq","","",572,{"inputs":[{"name":"self"},{"name":"vtableclosuredata"}],"output":{"name":"bool"}}],[11,"ne","","",572,{"inputs":[{"name":"self"},{"name":"vtableclosuredata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",572,null],[11,"encode","","",572,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",572,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtableclosuredata"],"name":"result"}}],[11,"clone","","",573,{"inputs":[{"name":"self"}],"output":{"name":"vtableautoimpldata"}}],[11,"eq","","",573,{"inputs":[{"name":"self"},{"name":"vtableautoimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",573,{"inputs":[{"name":"self"},{"name":"vtableautoimpldata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",573,null],[11,"encode","","",573,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",573,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtableautoimpldata"],"name":"result"}}],[11,"clone","","",574,{"inputs":[{"name":"self"}],"output":{"name":"vtablebuiltindata"}}],[11,"eq","","",574,{"inputs":[{"name":"self"},{"name":"vtablebuiltindata"}],"output":{"name":"bool"}}],[11,"ne","","",574,{"inputs":[{"name":"self"},{"name":"vtablebuiltindata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",574,null],[11,"encode","","",574,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",574,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtablebuiltindata"],"name":"result"}}],[11,"eq","","",575,{"inputs":[{"name":"self"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",575,{"inputs":[{"name":"self"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",575,null],[11,"clone","","",575,{"inputs":[{"name":"self"}],"output":{"name":"vtableobjectdata"}}],[11,"encode","","",575,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",575,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtableobjectdata"],"name":"result"}}],[11,"clone","","",576,{"inputs":[{"name":"self"}],"output":{"name":"vtablefnpointerdata"}}],[11,"eq","","",576,{"inputs":[{"name":"self"},{"name":"vtablefnpointerdata"}],"output":{"name":"bool"}}],[11,"ne","","",576,{"inputs":[{"name":"self"},{"name":"vtablefnpointerdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",576,null],[11,"encode","","",576,{"inputs":[{"name":"self"},{"name":"__sn"}],"output":{"name":"result"}}],[11,"decode","","",576,{"inputs":[{"name":"__dn"}],"output":{"generics":["vtablefnpointerdata"],"name":"result"}}],[11,"new","","",565,{"inputs":[{"name":"obligationcause"},{"name":"paramenv"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with_depth","","",565,{"inputs":[{"name":"obligationcause"},{"name":"usize"},{"name":"paramenv"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",565,{"inputs":[{"name":"span"},{"name":"nodeid"},{"name":"paramenv"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",565,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",566,{"inputs":[{"name":"span"},{"name":"nodeid"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",566,{"inputs":[{"name":"span"},{"name":"nodeid"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",566,{"inputs":[],"output":{"name":"obligationcause"}}],[11,"nested_obligations","","",593,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"map","","",593,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"new","","",569,{"inputs":[{"name":"predicateobligation"},{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterror"}}],[11,"self_ty","","",634,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"binder"}}],[0,"ty","rustc","",null,null],[3,"Binder","rustc::ty","Binder is a binder for higher-ranked lifetimes. It is part of the compiler's representation for things like `for<'a> Fn(&'a isize)` (which would be represented by the type `PolyTraitRef == Binder<TraitRef>`). Note that when we skolemize, instantiate, erase, or otherwise \"discharge\" these bound regions, we change the type from `Binder<T>` to just `T` (see e.g. `liberate_late_bound_regions`).",null,null],[12,"0","","",635,null],[3,"CanonicalVar","","",null,null],[12,"0","","",636,null],[3,"DebruijnIndex","","A [De Bruijn index][dbi] is a standard means of representing regions (and perhaps later types) in a higher-ranked setting. In particular, imagine a type like this:",null,null],[12,"depth","","We maintain the invariant that this is never 0. So 1 indicates the innermost binder. To ensure this, create with `DebruijnIndex::new`.",637,null],[3,"FnSig","","Signature of a function type, which I have arbitrarily decided to use to refer to the input/output types.",null,null],[12,"inputs_and_output","","",638,null],[12,"variadic","","",638,null],[12,"unsafety","","",638,null],[12,"abi","","",638,null],[3,"GenSig","","",null,null],[12,"yield_ty","","",639,null],[12,"return_ty","","",639,null],[3,"ParamTy","","",null,null],[12,"idx","","",640,null],[12,"name","","",640,null],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS form this would be written `<T as Trait<..>>::N`.",null,null],[12,"substs","","The parameters of the associated item.",641,null],[12,"item_def_id","","The DefId of the TraitItem for the associated type N.",641,null],[3,"ClosureSubsts","","A closure can be modeled as a struct that looks like:",null,null],[12,"substs","","Lifetime and type parameters from the enclosing function, concatenated with the types of the upvars.",642,null],[3,"GeneratorInterior","","This describes the types that can be contained in a generator. It will be a type variable initially and unified in the last stages of typeck of a body. It contains a tuple of all the types that could end up on a generator frame. The state transformation MIR pass may only produce layouts which mention types in this tuple. Upvars are not counted here.",null,null],[12,"witness","","",643,null],[12,"movable","","",643,null],[3,"TypeAndMut","","",null,null],[12,"ty","","",644,null],[12,"mutbl","","",644,null],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax, but perhaps the most recognizable form is in a where clause:",null,null],[12,"def_id","","",645,null],[12,"substs","","",645,null],[3,"ExistentialTraitRef","","An existential reference to a trait, where `Self` is erased. For example, the trait object `Trait<'a, 'b, X, Y>` is:",null,null],[12,"def_id","","",646,null],[12,"substs","","",646,null],[3,"ExistentialProjection","","A `ProjectionPredicate` for an `ExistentialTraitRef`.",null,null],[12,"item_def_id","","",647,null],[12,"substs","","",647,null],[12,"ty","","",647,null],[3,"Const","","Typed constant value.",null,null],[12,"ty","","",648,null],[12,"val","","",648,null],[3,"EarlyBoundRegion","","",null,null],[12,"def_id","","",649,null],[12,"index","","",649,null],[12,"name","","",649,null],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region at least as big as the scope `fr.scope`\".",null,null],[12,"scope","","",650,null],[12,"bound_region","","",650,null],[3,"TyVid","","",null,null],[12,"index","","",651,null],[3,"IntVid","","",null,null],[12,"index","","",652,null],[3,"FloatVid","","",null,null],[12,"index","","",653,null],[3,"RegionVid","","",null,null],[12,"0","","",654,null],[3,"TyCtxt","","The central data structure of the compiler. It stores references to the various arenas and also houses the results of the various compiler queries that have been performed. See the [rustc guide] for more details.",null,null],[12,"gcx","","",655,null],[12,"interners","","",655,null],[3,"GlobalArenas","","Internal storage",null,null],[12,"layout","","",656,null],[12,"generics","","",656,null],[12,"trait_def","","",656,null],[12,"adt_def","","",656,null],[12,"steal_mir","","",656,null],[12,"mir","","",656,null],[12,"tables","","",656,null],[12,"const_allocs","","miri allocations",656,null],[3,"AllArenas","","",null,null],[12,"global","","",657,null],[12,"interner","","",657,null],[3,"TypeckTables","","",null,null],[12,"local_id_root","","The HirId::owner all ItemLocalIds in this table are relative to.",658,null],[12,"type_dependent_defs","","Resolved definitions for `<T>::X` associated paths and method calls, including those of overloaded operators.",658,null],[12,"field_indices","","Resolved field indices for field accesses in expressions (`S { field }`, `obj.field`) or patterns (`S { field }`). The index is often useful by itself, but to learn more about the field you also need definition of the variant to which the field belongs, but it may not exist if it's a tuple field (`tuple.0`).",658,null],[12,"user_provided_tys","","Stores the canonicalized types provided by the user. See also `UserAssertTy` statement in MIR.",658,null],[12,"node_types","","Stores the types for various nodes in the AST.  Note that this table is not guaranteed to be populated until after typeck.  See typeck::check::fn_ctxt for details.",658,null],[12,"node_substs","","Stores the type parameters which were substituted to obtain the type of this node.  This only applies to nodes that refer to entities parameterized by type parameters, such as generic fns, types, or other items.",658,null],[12,"adjustments","","",658,null],[12,"pat_binding_modes","","Stores the actual binding mode for all instances of hir::BindingAnnotation.",658,null],[12,"pat_adjustments","","Stores the types which were implicitly dereferenced in pattern binding modes for later usage in HAIR lowering. For example,",658,null],[12,"upvar_capture_map","","Borrows",658,null],[12,"closure_kind_origins","","Records the reasons that we picked the kind of each closure; not all closures are present in the map.",658,null],[12,"liberated_fn_sigs","","For each fn, records the \"liberated\" types of its arguments and return type. Liberated means that all bound regions (including late-bound regions) are replaced with free equivalents. This table is not used in trans (since regions are erased there) and hence is not serialized to metadata.",658,null],[12,"fru_field_types","","For each FRU expression, record the normalized types of the fields of the struct - this is needed because it is non-trivial to normalize while preserving regions. This table is used only in MIR construction and hence is not serialized to metadata.",658,null],[12,"cast_kinds","","Maps a cast expression to its kind. This is keyed on the from expression of the cast, not the cast itself.",658,null],[12,"used_trait_imports","","Set of trait imports actually used in the method resolution. This is used for warning unused imports. During type checking, this `Lrc` should not be cloned: it must have a ref-count of 1 so that we can insert things into the set mutably.",658,null],[12,"tainted_by_errors","","If any errors occurred while type-checking this body, this field will be set to `true`.",658,null],[12,"free_region_map","","Stores the free-region relationships that were deduced from its where clauses and parameter types. These are then read-again by borrowck.",658,null],[3,"InterpretInterner","","Everything needed to efficiently work with interned allocations",null,null],[12,"inner","","",659,null],[3,"Instance","","",null,null],[12,"def","","",660,null],[12,"substs","","",660,null],[3,"CrateAnalysis","","The complete set of all analyses described in this module. This is produced by the driver and fed to trans and later passes.",null,null],[12,"access_levels","","",661,null],[12,"name","","",661,null],[12,"glob_map","","",661,null],[3,"Resolutions","","",null,null],[12,"freevars","","",662,null],[12,"trait_map","","",662,null],[12,"maybe_unused_trait_imports","","",662,null],[12,"maybe_unused_extern_crates","","",662,null],[12,"export_map","","",662,null],[3,"ImplHeader","","The \"header\" of an impl is everything outside the body: a Self type, a trait ref (in the case of a trait impl), and a set of predicates (from the bounds/where clauses).",null,null],[12,"impl_def_id","","",663,null],[12,"self_ty","","",663,null],[12,"trait_ref","","",663,null],[12,"predicates","","",663,null],[3,"AssociatedItem","","",null,null],[12,"def_id","","",664,null],[12,"name","","",664,null],[12,"kind","","",664,null],[12,"vis","","",664,null],[12,"defaultness","","",664,null],[12,"container","","",664,null],[12,"method_has_self_argument","","Whether this is a method with an explicit self as its first argument, allowing method calls.",664,null],[3,"CrateVariancesMap","","The crate variances map is computed during typeck and contains the variance of every item in the local crate. You should not use it directly, because to do so will make your pass dependent on the HIR of every item in the local crate. Instead, use `tcx.variances_of()` to get the variance for a particular item.",null,null],[12,"variances","","For each item with generics, maps to a vector of the variance of its generics.  If an item has no generics, it will have no entry.",665,null],[12,"empty_variance","","An empty vector, useful for cloning.",665,null],[3,"CReaderCacheKey","","",null,null],[12,"cnum","","",666,null],[12,"pos","","",666,null],[3,"TypeFlags","","",null,null],[12,"bits","","",667,null],[3,"TyS","","",null,null],[12,"sty","","",668,null],[12,"flags","","",668,null],[12,"region_depth","","",668,null],[3,"Slice","","A wrapper for slices with the additional invariant that the slice is interned and no other slice with the same contents can exist in the same context. This means we can use pointer + length for both equality comparisons and hashing.",null,null],[12,"0","","",669,null],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of the original var id (that is, the root variable that is referenced by the upvar) and the id of the closure expression.",null,null],[12,"var_id","","",670,null],[12,"closure_expr_id","","",670,null],[3,"UpvarBorrow","","",null,null],[12,"kind","","The kind of borrow: by-ref upvars have access to shared immutable borrows, which are not part of the normal language syntax.",671,null],[12,"region","","Region of the resulting reference.",671,null],[3,"ClosureUpvar","","",null,null],[12,"def","","",672,null],[12,"span","","",672,null],[12,"ty","","",672,null],[3,"FloatVarValue","","",null,null],[12,"0","","",673,null],[3,"TypeParameterDef","","",null,null],[12,"name","","",674,null],[12,"def_id","","",674,null],[12,"index","","",674,null],[12,"has_default","","",674,null],[12,"object_lifetime_default","","",674,null],[12,"pure_wrt_drop","","`pure_wrt_drop`, set by the (unsafe) `#[may_dangle]` attribute on generic parameter `T`, asserts data behind the parameter `T` won't be accessed during the parent type's `Drop` impl.",674,null],[12,"synthetic","","",674,null],[3,"RegionParameterDef","","",null,null],[12,"name","","",675,null],[12,"def_id","","",675,null],[12,"index","","",675,null],[12,"pure_wrt_drop","","`pure_wrt_drop`, set by the (unsafe) `#[may_dangle]` attribute on generic parameter `'a`, asserts data of lifetime `'a` won't be accessed during the parent type's `Drop` impl.",675,null],[3,"Generics","","Information about the formal type/lifetime parameters associated with an item or method. Analogous to hir::Generics.",null,null],[12,"parent","","",676,null],[12,"parent_regions","","",676,null],[12,"parent_types","","",676,null],[12,"regions","","",676,null],[12,"types","","",676,null],[12,"type_param_to_index","","Reverse map to each `TypeParameterDef`'s `index` field",676,null],[12,"has_self","","",676,null],[12,"has_late_bound_regions","","",676,null],[3,"GenericPredicates","","Bounds on generics.",null,null],[12,"parent","","",677,null],[12,"predicates","","",677,null],[3,"CratePredicatesMap","","The crate outlives map is computed during typeck and contains the outlives of every item in the local crate. You should not use it directly, because to do so will make your pass dependent on the HIR of every item in the local crate. Instead, use `tcx.inferred_outlives_of()` to get the outlives for a particular item.",null,null],[12,"predicates","","For each struct with outlive bounds, maps to a vector of the predicate of its outlive bounds. If an item has no outlives bounds, it will have no entry.",678,null],[12,"empty_predicate","","An empty vector, useful for cloning.",678,null],[3,"TraitPredicate","","",null,null],[12,"trait_ref","","",679,null],[3,"OutlivesPredicate","","",null,null],[12,"0","","",680,null],[12,"1","","",680,null],[3,"SubtypePredicate","","",null,null],[12,"a_is_expected","","",681,null],[12,"a","","",681,null],[12,"b","","",681,null],[3,"ProjectionPredicate","","This kind of predicate has no direct correspondent in the syntax, but it roughly corresponds to the syntactic forms:",null,null],[12,"projection_ty","","",682,null],[12,"ty","","",682,null],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type parameters.  Should eventually be generalized into a flag list of where clauses.  You can obtain a `InstantiatedPredicates` list from a `GenericPredicates` by using the `instantiate` method. Note that this method reflects an important semantic invariant of `InstantiatedPredicates`: while the `GenericPredicates` are expressed in terms of the bound type parameters of the impl/trait/whatever, an `InstantiatedPredicates` instance represented a set of bounds for some particular instantiation, meaning that the generic parameters have been substituted with their values.",null,null],[12,"predicates","","",683,null],[3,"UniverseIndex","","\"Universes\" are used during type- and trait-checking in the presence of `for<..>` binders to control what sets of names are visible. Universes are arranged into a tree: the root universe contains names that are always visible. But when you enter into some subuniverse, then it may add names that are only visible within that subtree (but it can still name the names of its ancestor universes).",null,null],[12,"0","","",684,null],[3,"ParamEnv","","When type checking, we use the `ParamEnv` to track details about the set of where-clauses that are in scope at this particular point.",null,null],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically the set of bounds on the in-scope type parameters, translated into Obligations, and elaborated and normalized.",685,null],[12,"reveal","","Typically, this is `Reveal::UserFacing`, but during trans we want `Reveal::All` -- note that this is always paired with an empty environment. To get that, use `ParamEnv::reveal()`.",685,null],[3,"ParamEnvAnd","","",null,null],[12,"param_env","","",686,null],[12,"value","","",686,null],[3,"Destructor","","",null,null],[12,"did","","The def-id of the destructor method",687,null],[3,"AdtFlags","","",null,null],[12,"bits","","",688,null],[3,"VariantDef","","",null,null],[12,"did","","The variant's DefId. If this is a tuple-like struct, this is the DefId of the struct's ctor.",689,null],[12,"name","","",689,null],[12,"discr","","",689,null],[12,"fields","","",689,null],[12,"ctor_kind","","",689,null],[3,"FieldDef","","",null,null],[12,"did","","",690,null],[12,"name","","",690,null],[12,"vis","","",690,null],[3,"AdtDef","","The definition of an abstract data type - a struct or enum.",null,null],[12,"did","","",691,null],[12,"variants","","",691,null],[12,"flags","","",691,null],[12,"repr","","",691,null],[3,"ReprFlags","","",null,null],[12,"bits","","",692,null],[3,"ReprOptions","","Represents the repr options provided by the user,",null,null],[12,"int","","",693,null],[12,"align","","",693,null],[12,"pack","","",693,null],[12,"flags","","",693,null],[3,"CrateInherentImpls","","A map for the local crate mapping each type to a vector of its inherent impls. This is not meant to be used outside of coherence; rather, you should request the vector for a specific type via `tcx.inherent_impls(def_id)` so as to minimize your dependencies (constructing this map requires touching the entire crate).",null,null],[12,"inherent_impls","","",694,null],[3,"SymbolName","","",null,null],[12,"name","","",695,null],[4,"InferTy","","",null,null],[13,"TyVar","","",696,null],[13,"IntVar","","",696,null],[13,"FloatVar","","",696,null],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an unbound type variable. This is convenient for caching etc. See `infer::freshen` for more details.",696,null],[13,"FreshIntTy","","",696,null],[13,"FreshFloatTy","","",696,null],[13,"CanonicalTy","","Canonicalized type variable, used only when preparing a trait query.",696,null],[4,"ExistentialPredicate","","",null,null],[13,"Trait","","e.g. Iterator",697,null],[13,"Projection","","e.g. Iterator::Item = T",697,null],[13,"AutoTrait","","e.g. Send",697,null],[4,"TypeVariants","","NB: If you change this, you'll probably want to change the corresponding AST structure in libsyntax/ast.rs as well.",null,null],[13,"TyBool","","The primitive boolean type. Written as `bool`.",698,null],[13,"TyChar","","The primitive character type; holds a Unicode scalar value (a non-surrogate code point).  Written as `char`.",698,null],[13,"TyInt","","A primitive signed integer type. For example, `i32`.",698,null],[13,"TyUint","","A primitive unsigned integer type. For example, `u32`.",698,null],[13,"TyFloat","","A primitive floating-point type. For example, `f64`.",698,null],[13,"TyAdt","","Structures, enumerations and unions.",698,null],[13,"TyForeign","","",698,null],[13,"TyStr","","The pointee of a string slice. Written as `str`.",698,null],[13,"TyArray","","An array with the given length. Written as `[T; n]`.",698,null],[13,"TySlice","","The pointee of an array slice.  Written as `[T]`.",698,null],[13,"TyRawPtr","","A raw pointer. Written as `*mut T` or `*const T`",698,null],[13,"TyRef","","A reference; a pointer with an associated lifetime. Written as `&'a mut T` or `&'a T`.",698,null],[13,"TyFnDef","","The anonymous type of a function declaration/definition. Each function has a unique type.",698,null],[13,"TyFnPtr","","A pointer to a function.  Written as `fn() -> i32`.",698,null],[13,"TyDynamic","","A trait, defined with `trait`.",698,null],[13,"TyClosure","","The anonymous type of a closure. Used to represent the type of `|a| a`.",698,null],[13,"TyGenerator","","The anonymous type of a generator. Used to represent the type of `|a| yield a`.",698,null],[13,"TyGeneratorWitness","","A type representin the types stored inside a generator. This should only appear in GeneratorInteriors.",698,null],[13,"TyNever","","The never type `!`",698,null],[13,"TyTuple","","A tuple type.  For example, `(i32, bool)`.",698,null],[13,"TyProjection","","The projection of an associated type.  For example, `<T as Trait<..>>::N`.",698,null],[13,"TyAnon","","Anonymized (`impl Trait`) type found in a return type. The DefId comes from the `impl Trait` ast::Ty node, and the substitutions are for the generics of the function in question. After typeck, the concrete type can be found in the `types` map.",698,null],[13,"TyParam","","A type parameter; for example, `T` in `fn f(x: T) {}",698,null],[13,"TyInfer","","A type variable used during type-checking.",698,null],[13,"TyError","","A placeholder for a type which could not be computed; this is propagated to avoid useless error messages.",698,null],[4,"BoundRegion","","",null,null],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",699,null],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",699,null],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",699,null],[13,"BrEnv","","Anonymous region for the implicit env pointer parameter to a closure",699,null],[4,"RegionKind","","Representation of regions.",null,null],[13,"ReEarlyBound","","",700,null],[13,"ReLateBound","","",700,null],[13,"ReFree","","When checking a function body, the types of all arguments and so forth that refer to bound region parameters are modified to refer to free region parameters.",700,null],[13,"ReScope","","A concrete region naming some statically determined scope (e.g. an expression or sequence of statements) within the current function.",700,null],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",700,null],[13,"ReVar","","A region variable.  Should not exist after typeck.",700,null],[13,"ReSkolemized","","A skolemized region - basically the higher-ranked version of ReFree. Should not exist after typeck.",700,null],[13,"ReEmpty","","Empty lifetime is for data that is never accessed. Bottom in the region lattice. We treat ReEmpty somewhat specially; at least right now, we do not generate instances of it during the GLB computations, but rather generate an error instead. This is to improve error messages. The only way to get an instance of ReEmpty is to have a region variable with no constraints.",700,null],[13,"ReErased","","Erased region, used by trait selection, in MIR and during trans.",700,null],[13,"ReClosureBound","","These are regions bound in the \"defining type\" for a closure. They are used ONLY as part of the `ClosureRegionRequirements` that are produced by MIR borrowck. See `ClosureRegionRequirements` for more details.",700,null],[13,"ReCanonical","","Canonicalized region, used only when preparing a trait query.",700,null],[4,"InstanceDef","","",null,null],[13,"Item","","",701,null],[13,"Intrinsic","","",701,null],[13,"FnPtrShim","","<fn() as FnTrait>::call_* def-id is FnTrait::call_*",701,null],[13,"Virtual","","::fn",701,null],[13,"ClosureOnceShim","","<[mut closure] as FnOnce>::call_once",701,null],[12,"call_once","rustc::ty::InstanceDef","",701,null],[13,"DropGlue","rustc::ty","drop_in_place::; None for empty drop glue.",701,null],[13,"CloneShim","","`<T as Clone>::clone` shim.",701,null],[4,"AssociatedItemContainer","","",null,null],[13,"TraitContainer","","",702,null],[13,"ImplContainer","","",702,null],[4,"AssociatedKind","","",null,null],[13,"Const","","",703,null],[13,"Method","","",703,null],[13,"Type","","",703,null],[4,"Visibility","","",null,null],[13,"Public","","Visible everywhere (including in other crates).",704,null],[13,"Restricted","","Visible only in the given crate-local module.",704,null],[13,"Invisible","","Not visible anywhere in the local crate. This is the visibility of private external items.",704,null],[4,"Variance","","",null,null],[13,"Covariant","","",705,null],[13,"Invariant","","",705,null],[13,"Contravariant","","",705,null],[13,"Bivariant","","",705,null],[4,"BorrowKind","","",null,null],[13,"ImmBorrow","","Data must be immutable and is aliasable.",706,null],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow cannot currently be expressed by the user and is used only in implicit closure bindings. It is needed when the closure is borrowing or mutating a mutable referent, e.g.:",706,null],[13,"MutBorrow","","Data is mutable and not aliasable.",706,null],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed during `typeck`, specifically by `regionck`.",null,null],[13,"ByValue","","Upvar is captured by value. This is always true when the closure is labeled `move`, but can also be true in other cases depending on inference.",707,null],[13,"ByRef","","Upvar is captured by reference.",707,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",708,null],[13,"UintType","","",708,null],[4,"Predicate","","",null,null],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be the `Self` type of the trait reference and `A`, `B`, and `C` would be the type parameters.",709,null],[13,"RegionOutlives","","where 'a : 'b",709,null],[13,"TypeOutlives","","where T : 'a",709,null],[13,"Projection","","where ::Name == X, approximately. See `ProjectionPredicate` struct for details.",709,null],[13,"WellFormed","","no syntax: T WF",709,null],[13,"ObjectSafe","","trait must be object-safe",709,null],[13,"ClosureKind","","No direct syntax. May be thought of as `where T : FnFoo<...>` for some substitutions `...` and T being a closure type. Satisfied (or refuted) once we know the closure's kind.",709,null],[13,"Subtype","","`T1 <: T2`",709,null],[13,"ConstEvaluatable","","Constant initializer must evaluate successfully.",709,null],[4,"VariantDiscr","","",null,null],[13,"Explicit","","Explicit value for this variant, i.e. `X = 123`. The `DefId` corresponds to the embedded constant.",710,null],[13,"Relative","","The previous variant's discriminant plus one. For efficiency reasons, the distance from the last `Explicit` discriminant is being stored, or `0` for the first variant, if it has none.",710,null],[4,"AdtKind","","",null,null],[13,"Struct","","",711,null],[13,"Union","","",711,null],[13,"Enum","","",711,null],[4,"ClosureKind","","Represents the various closure traits in the Rust language. This will determine the type of the environment (`self`, in the desuaring) argument that the closure expects.",null,null],[13,"Fn","","",712,null],[13,"FnMut","","",712,null],[13,"FnOnce","","",712,null],[4,"Attributes","","",null,null],[13,"Owned","","",713,null],[13,"Borrowed","","",713,null],[5,"keep_local","","",null,{"inputs":[{"name":"t"}],"output":{"name":"bool"}}],[5,"associated_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"associateditem"}}],[5,"adt_sized_constraint","","Calculates the Sized-constraint.",null,null],[5,"associated_item_def_ids","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[5,"def_span","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"span"}}],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait, return the ID of the trait that the trait item belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[5,"param_env","","See `ParamEnv` struct def'n for details.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"paramenv"}}],[5,"crate_disambiguator","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"cratedisambiguator"}}],[5,"original_crate_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[5,"crate_hash","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"svh"}}],[5,"instance_def_size_estimate","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instancedef"}],"output":{"name":"usize"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"tls","","",null,null],[3,"ImplicitCtxt","rustc::ty::tls","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module.",null,null],[12,"tcx","","The current TyCtxt. Initially created by `enter_global` and updated by `enter_local` with a new local interner",714,null],[12,"query","","The current query job, if any. This is updated by start_job in ty::maps::plumbing when executing a query",714,null],[12,"layout_depth","","Used to prevent layout from recursing too deeply.",714,null],[12,"task","","The current dep graph task. This is used to add dependencies to queries when executing them",714,null],[5,"with_thread_locals","","Sets up the callbacks from libsyntax on the current thread",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"enter_context","","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`",null,{"inputs":[{"name":"implicitctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"enter_global","","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function.",null,{"inputs":[{"name":"globalctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"with_context_opt","","Allows access to the current ImplicitCtxt in a closure if one is available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_context","","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field.",null,{"inputs":[{"name":"tyctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"with_fully_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field.",null,{"inputs":[{"name":"tyctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"with","","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_opt","","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[0,"adjustment","rustc::ty","",null,null],[3,"Adjustment","rustc::ty::adjustment","Represents coercing a value to a different type of value.",null,null],[12,"kind","","",715,null],[12,"target","","",715,null],[3,"OverloadedDeref","","An overloaded autoderef step, representing a `Deref(Mut)::deref(_mut)` call, with the signature `&'a T -> &'a U` or `&'a mut T -> &'a mut U`. The target type is `U` in both cases, with the region and mutability being those shared by both the receiver and the returned reference.",null,null],[12,"region","","",716,null],[12,"mutbl","","",716,null],[3,"CoerceUnsizedInfo","","Information for `CoerceUnsized` impls, storing information we have computed about the coercion.",null,null],[12,"custom_kind","","If this is a \"custom coerce\" impl, then what kind of custom coercion is it? This applies to impls of `CoerceUnsized` for structs, primarily, where we store a bit of info about which fields need to be coerced.",717,null],[4,"Adjust","","",null,null],[13,"NeverToAny","","Go from ! to any type.",718,null],[13,"ReifyFnPointer","","Go from a fn-item type to a fn-pointer type.",718,null],[13,"UnsafeFnPointer","","Go from a safe fn pointer to an unsafe fn pointer.",718,null],[13,"ClosureFnPointer","","Go from a non-capturing closure to an fn pointer.",718,null],[13,"MutToConstPointer","","Go from a mut raw pointer to a const raw pointer.",718,null],[13,"Deref","","Dereference once, producing a place.",718,null],[13,"Borrow","","Take the address and produce either a `&` or `*` pointer.",718,null],[13,"Unsize","","Unsize a pointer/reference value, e.g. `&[T; n]` to `&[T]`. Note that the source could be a thin or fat pointer. This will do things like convert thin pointers to fat pointers, or convert structs containing thin pointers to structs containing fat pointers, or convert between fat pointers.  We don't store the details of how the transform is done (in fact, we don't know that, because it might depend on the precise type parameters). We just store the target type. Trans figures out what has to be done at monomorphization time based on the precise source/target type at hand.",718,null],[4,"AllowTwoPhase","","At least for initial deployment, we want to limit two-phase borrows to only a few specific cases. Right now, those mostly \"things that desugar\" into method calls     - using x.some_method() syntax, where some_method takes &mut self     - using Foo::some_method(&mut x, ...) syntax     - binary assignment operators (+=, -=, *=, etc.) Anything else should be rejected until generalized two phase borrow support is implemented. Right now, dataflow can't handle the general case where there is more than one use of a mutable borrow, and we don't want to accept too much new code via two-phase borrows, so we try to limit where we create two-phase capable mutable borrows. See #49434 for tracking.",null,null],[13,"Yes","","",719,null],[13,"No","","",719,null],[4,"AutoBorrowMutability","","",null,null],[13,"Mutable","","",720,null],[12,"allow_two_phase_borrow","rustc::ty::adjustment::AutoBorrowMutability","",720,null],[13,"Immutable","rustc::ty::adjustment","",720,null],[4,"AutoBorrow","","",null,null],[13,"Ref","","Convert from T to &T.",721,null],[13,"RawPtr","","Convert from T to *T.",721,null],[4,"CustomCoerceUnsized","","",null,null],[13,"Struct","","Records the index of the field being coerced.",722,null],[11,"clone","","",715,{"inputs":[{"name":"self"}],"output":{"name":"adjustment"}}],[11,"encode","","",715,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",715,{"inputs":[{"name":"__d"}],"output":{"generics":["adjustment"],"name":"result"}}],[11,"clone","","",718,{"inputs":[{"name":"self"}],"output":{"name":"adjust"}}],[11,"fmt","","",718,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",718,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",718,{"inputs":[{"name":"__d"}],"output":{"generics":["adjust"],"name":"result"}}],[11,"clone","","",716,{"inputs":[{"name":"self"}],"output":{"name":"overloadedderef"}}],[11,"eq","","",716,{"inputs":[{"name":"self"},{"name":"overloadedderef"}],"output":{"name":"bool"}}],[11,"ne","","",716,{"inputs":[{"name":"self"},{"name":"overloadedderef"}],"output":{"name":"bool"}}],[11,"fmt","","",716,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",716,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",716,{"inputs":[{"name":"__d"}],"output":{"generics":["overloadedderef"],"name":"result"}}],[11,"method_call","","",716,null],[11,"clone","","",719,{"inputs":[{"name":"self"}],"output":{"name":"allowtwophase"}}],[11,"eq","","",719,{"inputs":[{"name":"self"},{"name":"allowtwophase"}],"output":{"name":"bool"}}],[11,"fmt","","",719,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",719,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",719,{"inputs":[{"name":"__d"}],"output":{"generics":["allowtwophase"],"name":"result"}}],[11,"clone","","",720,{"inputs":[{"name":"self"}],"output":{"name":"autoborrowmutability"}}],[11,"eq","","",720,{"inputs":[{"name":"self"},{"name":"autoborrowmutability"}],"output":{"name":"bool"}}],[11,"ne","","",720,{"inputs":[{"name":"self"},{"name":"autoborrowmutability"}],"output":{"name":"bool"}}],[11,"fmt","","",720,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",720,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",720,{"inputs":[{"name":"__d"}],"output":{"generics":["autoborrowmutability"],"name":"result"}}],[11,"from","rustc::hir","",100,{"inputs":[{"name":"autoborrowmutability"}],"output":{"name":"self"}}],[11,"clone","rustc::ty::adjustment","",721,{"inputs":[{"name":"self"}],"output":{"name":"autoborrow"}}],[11,"eq","","",721,{"inputs":[{"name":"self"},{"name":"autoborrow"}],"output":{"name":"bool"}}],[11,"ne","","",721,{"inputs":[{"name":"self"},{"name":"autoborrow"}],"output":{"name":"bool"}}],[11,"fmt","","",721,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",721,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",721,{"inputs":[{"name":"__d"}],"output":{"generics":["autoborrow"],"name":"result"}}],[11,"clone","","",717,{"inputs":[{"name":"self"}],"output":{"name":"coerceunsizedinfo"}}],[11,"encode","","",717,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",717,{"inputs":[{"name":"__d"}],"output":{"generics":["coerceunsizedinfo"],"name":"result"}}],[11,"fmt","","",717,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",722,{"inputs":[{"name":"self"}],"output":{"name":"customcoerceunsized"}}],[11,"encode","","",722,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",722,{"inputs":[{"name":"__d"}],"output":{"generics":["customcoerceunsized"],"name":"result"}}],[11,"fmt","","",722,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"binding","rustc::ty","",null,null],[4,"BindingMode","rustc::ty::binding","",null,null],[13,"BindByReference","","",723,null],[13,"BindByValue","","",723,null],[11,"clone","","",723,{"inputs":[{"name":"self"}],"output":{"name":"bindingmode"}}],[11,"eq","","",723,{"inputs":[{"name":"self"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"ne","","",723,{"inputs":[{"name":"self"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",723,null],[11,"encode","","",723,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",723,{"inputs":[{"name":"__d"}],"output":{"generics":["bindingmode"],"name":"result"}}],[11,"hash","","",723,null],[11,"fmt","","",723,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"convert","","",723,{"inputs":[{"name":"bindingannotation"}],"output":{"name":"bindingmode"}}],[11,"hash_stable","","",723,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"cast","rustc::ty","",null,null],[4,"IntTy","rustc::ty::cast","Types that are represented as ints.",null,null],[13,"U","","",724,null],[13,"I","","",724,null],[13,"CEnum","","",724,null],[13,"Bool","","",724,null],[13,"Char","","",724,null],[4,"CastTy","","",null,null],[13,"Int","","Various types that are represented as ints and handled mostly in the same way, merged for easier matching.",725,null],[13,"Float","","Floating-Point types",725,null],[13,"FnPtr","","Function Pointers",725,null],[13,"Ptr","","Raw pointers",725,null],[13,"RPtr","","References",725,null],[4,"CastKind","","Cast Kind. See RFC 401 (or librustc_typeck/check/cast.rs)",null,null],[13,"CoercionCast","","",726,null],[13,"PtrPtrCast","","",726,null],[13,"PtrAddrCast","","",726,null],[13,"AddrPtrCast","","",726,null],[13,"NumericCast","","",726,null],[13,"EnumCast","","",726,null],[13,"PrimIntCast","","",726,null],[13,"U8CharCast","","",726,null],[13,"ArrayPtrCast","","",726,null],[13,"FnPtrPtrCast","","",726,null],[13,"FnPtrAddrCast","","",726,null],[11,"clone","","",724,{"inputs":[{"name":"self"}],"output":{"name":"intty"}}],[11,"fmt","","",724,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",724,{"inputs":[{"name":"self"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",724,{"inputs":[{"name":"self"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",724,null],[11,"clone","","",725,{"inputs":[{"name":"self"}],"output":{"name":"castty"}}],[11,"fmt","","",725,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",725,{"inputs":[{"name":"self"},{"name":"castty"}],"output":{"name":"bool"}}],[11,"ne","","",725,{"inputs":[{"name":"self"},{"name":"castty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",725,null],[11,"clone","","",726,{"inputs":[{"name":"self"}],"output":{"name":"castkind"}}],[11,"fmt","","",726,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",726,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",726,{"inputs":[{"name":"__d"}],"output":{"generics":["castkind"],"name":"result"}}],[11,"from_ty","","",725,{"inputs":[{"name":"ty"}],"output":{"generics":["castty"],"name":"option"}}],[0,"codec","rustc::ty","",null,null],[5,"encode_with_shorthand","rustc::ty::codec","Encode the given value or a previously cached shorthand.",null,{"inputs":[{"name":"e"},{"name":"t"},{"name":"m"}],"output":{"name":"result"}}],[5,"encode_predicates","","",null,{"inputs":[{"name":"e"},{"name":"genericpredicates"},{"name":"c"}],"output":{"name":"result"}}],[5,"decode_cnum","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["cratenum"],"name":"result"}}],[5,"decode_ty","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["ty"],"name":"result"}}],[5,"decode_predicates","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["genericpredicates"],"name":"result"}}],[5,"decode_substs","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["substs"],"name":"result"}}],[5,"decode_region","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["region"],"name":"result"}}],[5,"decode_ty_slice","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["slice"],"name":"result"}}],[5,"decode_adt_def","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["adtdef"],"name":"result"}}],[5,"decode_existential_predicate_slice","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["slice"],"name":"result"}}],[5,"decode_canonical_var_infos","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["canonicalvarinfos"],"name":"result"}}],[5,"decode_const","","",null,{"inputs":[{"name":"d"}],"output":{"generics":["const"],"name":"result"}}],[17,"SHORTHAND_OFFSET","","The shorthand encoding uses an enum's variant index `usize` and is offset by this value so it never matches a real variant. This offset is also chosen so that the first byte is never < 0x80.",null,null],[8,"EncodableWithShorthand","","",null,null],[16,"Variant","","",727,null],[10,"variant","","",727,null],[8,"TyEncoder","","",null,null],[10,"position","","",728,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[8,"TyDecoder","","",null,null],[10,"tcx","","",729,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[10,"peek_byte","","",729,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[10,"position","","",729,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[10,"cached_ty_for_shorthand","","",729,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"generics":["ty"],"name":"result"}}],[10,"with_position","","",729,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[10,"map_encoded_cnum_to_current","","",729,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratenum"}}],[11,"positioned_at_shorthand","","",729,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"variant","rustc::ty","",709,null],[0,"error","","",null,null],[3,"ExpectedFound","rustc::ty::error","",null,null],[12,"expected","","",730,null],[12,"found","","",730,null],[4,"TypeError","","",null,null],[13,"Mismatch","","",731,null],[13,"UnsafetyMismatch","","",731,null],[13,"AbiMismatch","","",731,null],[13,"Mutability","","",731,null],[13,"TupleSize","","",731,null],[13,"FixedArraySize","","",731,null],[13,"ArgCount","","",731,null],[13,"RegionsDoesNotOutlive","","",731,null],[13,"RegionsInsufficientlyPolymorphic","","",731,null],[13,"RegionsOverlyPolymorphic","","",731,null],[13,"Sorts","","",731,null],[13,"IntMismatch","","",731,null],[13,"FloatMismatch","","",731,null],[13,"Traits","","",731,null],[13,"VariadicMismatch","","",731,null],[13,"CyclicTy","","Instantiating a type variable with the given type would have created a cycle (because it appears somewhere within that type).",731,null],[13,"ProjectionMismatched","","",731,null],[13,"ProjectionBoundsLength","","",731,null],[13,"ExistentialMismatch","","",731,null],[13,"OldStyleLUB","","",731,null],[4,"UnconstrainedNumeric","","",null,null],[13,"UnconstrainedFloat","","",732,null],[13,"UnconstrainedInt","","",732,null],[13,"Neither","","",732,null],[11,"clone","","",730,{"inputs":[{"name":"self"}],"output":{"name":"expectedfound"}}],[11,"fmt","","",730,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",731,{"inputs":[{"name":"self"}],"output":{"name":"typeerror"}}],[11,"fmt","","",731,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",732,{"inputs":[{"name":"self"}],"output":{"name":"unconstrainednumeric"}}],[11,"encode","","",732,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",732,{"inputs":[{"name":"__d"}],"output":{"generics":["unconstrainednumeric"],"name":"result"}}],[11,"eq","","",732,{"inputs":[{"name":"self"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",732,null],[11,"hash","","",732,null],[11,"fmt","","",732,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",731,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"sort_string","rustc::ty","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"note_and_explain_type_err","","",655,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"typeerror"},{"name":"span"}],"output":null}],[0,"erase_regions","","",null,null],[3,"RegionEraserVisitor","rustc::ty::erase_regions","",null,null],[12,"tcx","","",733,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"erase_regions_ty","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"erase_regions","rustc::ty","Returns an equivalent value with all free regions removed (note that late-bound regions remain, because they are important for subtyping, but they are anonymized and normalized as well)..",655,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"tcx","rustc::ty::erase_regions","",733,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",733,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_binder","","",733,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_region","","",733,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[0,"fast_reject","rustc::ty","",null,null],[4,"SimplifiedTypeGen","rustc::ty::fast_reject","See `simplify_type`",null,null],[13,"BoolSimplifiedType","","",734,null],[13,"CharSimplifiedType","","",734,null],[13,"IntSimplifiedType","","",734,null],[13,"UintSimplifiedType","","",734,null],[13,"FloatSimplifiedType","","",734,null],[13,"AdtSimplifiedType","","",734,null],[13,"StrSimplifiedType","","",734,null],[13,"ArraySimplifiedType","","",734,null],[13,"PtrSimplifiedType","","",734,null],[13,"NeverSimplifiedType","","",734,null],[13,"TupleSimplifiedType","","",734,null],[13,"TraitSimplifiedType","","",734,null],[13,"ClosureSimplifiedType","","",734,null],[13,"GeneratorSimplifiedType","","",734,null],[13,"GeneratorWitnessSimplifiedType","","",734,null],[13,"AnonSimplifiedType","","",734,null],[13,"FunctionSimplifiedType","","",734,null],[13,"ParameterSimplifiedType","","",734,null],[13,"ForeignSimplifiedType","","",734,null],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc. The idea is to get something simple that we can use to quickly decide if two types could unify during method lookup.",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"bool"}],"output":{"generics":["simplifiedtype"],"name":"option"}}],[6,"SimplifiedType","","",null,null],[11,"clone","","",734,{"inputs":[{"name":"self"}],"output":{"name":"simplifiedtypegen"}}],[11,"fmt","","",734,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"bool"}}],[11,"ne","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",734,null],[11,"hash","","",734,null],[11,"partial_cmp","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"bool"}}],[11,"le","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"bool"}}],[11,"gt","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"bool"}}],[11,"ge","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"bool"}}],[11,"cmp","","",734,{"inputs":[{"name":"self"},{"name":"simplifiedtypegen"}],"output":{"name":"ordering"}}],[11,"encode","","",734,{"inputs":[{"name":"self"},{"name":"__sd"}],"output":{"name":"result"}}],[11,"decode","","",734,{"inputs":[{"name":"__dd"}],"output":{"generics":["simplifiedtypegen"],"name":"result"}}],[11,"map_def","","",734,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"simplifiedtypegen"}}],[11,"hash_stable","","",734,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"fold","rustc::ty","Generalized type folding mechanism. The setup is a bit convoluted but allows for convenient usage. Let T be an instance of some \"foldable type\" (one which implements `TypeFoldable`) and F be an instance of a \"folder\" (a type which implements `TypeFolder`). Then the setup is intended to be:",null,null],[3,"BottomUpFolder","rustc::ty::fold","",null,null],[12,"tcx","","",735,null],[12,"fldop","","",735,null],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component types and all regions that occur free within it.",null,null],[12,"tcx","","",736,null],[12,"skipped_regions","","",736,null],[12,"current_depth","","",736,null],[12,"fld_r","","",736,null],[3,"RegionReplacer","","",null,null],[12,"tcx","","",737,null],[12,"current_depth","","",737,null],[12,"fld_r","","",737,null],[12,"map","","",737,null],[3,"HasEscapingRegionsVisitor","","An \"escaping region\" is a bound region whose binder is not part of `t`.",null,null],[12,"depth","","",738,null],[3,"HasTypeFlagsVisitor","","",null,null],[12,"flags","","",739,null],[3,"LateBoundRegionsCollector","","Collects all the late-bound regions it finds into a hash set.",null,null],[12,"current_depth","","",740,null],[12,"regions","","",740,null],[12,"just_constrained","","",740,null],[5,"shift_region","","",null,{"inputs":[{"name":"regionkind"},{"name":"u32"}],"output":{"name":"regionkind"}}],[5,"shift_region_ref","","",null,{"inputs":[{"name":"tyctxt"},{"name":"region"},{"name":"u32"}],"output":{"name":"region"}}],[5,"shift_regions","","",null,{"inputs":[{"name":"tyctxt"},{"name":"u32"},{"name":"t"}],"output":{"name":"t"}}],[8,"TypeFoldable","","The TypeFoldable trait is implemented for every type that can be folded. Basically, every type that has a corresponding method in TypeFolder.",null,null],[10,"super_fold_with","","",741,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fold_with","","",741,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[10,"super_visit_with","","",741,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"visit_with","","",741,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",741,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_escaping_regions","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_type_flags","","",741,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"has_projections","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"references_error","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_param_types","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_self_ty","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_infer_types","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"needs_infer","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_skol","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"needs_subst","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_re_skol","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_closure_types","","",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_free_regions","","\"Free\" regions in this context means that it has any region that is not (a) erased or (b) late-bound.",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_erasable_regions","","True if there any any un-erased free regions.",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_global","","Indicates whether this value references only 'global' types/lifetimes that are the same regardless of what fn we are in. This is used for caching. Errs on the side of returning false.",741,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[8,"TypeFolder","","The TypeFolder trait defines the actual folding. There is a method defined for every foldable type. Each of these has a default implementation that does an \"identity\" fold. Within each identity fold, it should invoke `foo.fold_with(self)` to fold each sub-item.",null,null],[10,"tcx","","",742,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_binder","","",742,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_ty","","",742,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",742,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_const","","",742,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"const"}}],[8,"TypeVisitor","","",null,null],[11,"visit_binder","","",743,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"visit_ty","","",743,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"visit_region","","",743,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"visit_const","","",743,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"bool"}}],[11,"tcx","","",735,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",735,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"collect_regions","rustc::ty","Collects the free and escaping regions in `value` into `region_set`. Returns whether any late-bound regions were skipped",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"fxhashset"}],"output":{"name":"bool"}}],[11,"fold_regions","","Folds the escaping and free regions in `value` using `f`, and sets `skipped_regions` to true if any late-bound region was found and skipped.",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"bool"},{"name":"f"}],"output":{"name":"t"}}],[11,"for_each_free_region","","",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"f"}],"output":null}],[11,"new","rustc::ty::fold","",736,{"inputs":[{"name":"tyctxt"},{"name":"bool"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",736,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_binder","","",736,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_region","","",736,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"replace_late_bound_regions","rustc::ty","Replace all regions bound by the given `Binder` with the results returned by the closure; the closure is expected to return a free region (relative to this binder), and hence the binder is removed in the return type. The closure is invoked once for each unique `BoundRegion`; multiple references to the same `BoundRegion` will reuse the previous result.  A map is returned at the end with each bound region and the free region that replaced it.",655,null],[11,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to `all_outlive_scope`.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"binder"}],"output":{"name":"t"}}],[11,"flatten_late_bound_regions","","Flattens two binding levels into one. So `for<'a> for<'b> Foo` becomes `for<'a,'b> Foo`.",655,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"collect_constrained_late_bound_regions","","Returns a set of all late-bound regions that are constrained by `value`, meaning that if we instantiate those LBR with variables and equate `value` with something else, those variables will also be equated.",655,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"generics":["boundregion"],"name":"fxhashset"}}],[11,"collect_referenced_late_bound_regions","","Returns a set of all late-bound regions that appear in `value` anywhere.",655,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"generics":["boundregion"],"name":"fxhashset"}}],[11,"collect_late_bound_regions","","",655,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"bool"}],"output":{"generics":["boundregion"],"name":"fxhashset"}}],[11,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'erased`. Useful in trans but also method lookup and a few other places where precise region relationships are not required.",655,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"t"}}],[11,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are assigned starting at 1 and increasing monotonically in the order traversed by the fold operation.",655,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"new","rustc::ty::fold","",737,{"inputs":[{"name":"tyctxt"},{"name":"f"}],"output":{"name":"regionreplacer"}}],[11,"tcx","","",737,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_binder","","",737,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_ty","","",737,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",737,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"visit_binder","","",738,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"visit_ty","","",738,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"visit_region","","",738,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"visit_ty","","",739,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"visit_region","","",739,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"visit_const","","",739,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"bool"}}],[11,"new","","",740,{"inputs":[{"name":"bool"}],"output":{"name":"self"}}],[11,"visit_binder","","",740,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"visit_ty","","",740,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"visit_region","","",740,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[0,"inhabitedness","rustc::ty","",null,null],[3,"DefIdForest","rustc::ty::inhabitedness","Represents a forest of DefIds closed under the ancestor relation. That is, if a DefId representing a module is contained in the forest then all DefIds defined in that module or submodules are also implicitly contained in the forest.",null,null],[12,"root_ids","","The minimal set of DefIds required to represent the whole set. If A and B are DefIds in the DefIdForest, and A is a descendant of B, then only B will be in root_ids. We use a SmallVec here because (for its use for caching inhabitedness) its rare that this will contain even two ids.",744,null],[0,"def_id_forest","","",null,null],[3,"DefIdForest","rustc::ty::inhabitedness::def_id_forest","Represents a forest of DefIds closed under the ancestor relation. That is, if a DefId representing a module is contained in the forest then all DefIds defined in that module or submodules are also implicitly contained in the forest.",null,null],[12,"root_ids","","The minimal set of DefIds required to represent the whole set. If A and B are DefIds in the DefIdForest, and A is a descendant of B, then only B will be in root_ids. We use a SmallVec here because (for its use for caching inhabitedness) its rare that this will contain even two ids.",744,null],[11,"clone","rustc::ty::inhabitedness","",744,{"inputs":[{"name":"self"}],"output":{"name":"defidforest"}}],[11,"empty","","Create an empty forest.",744,{"inputs":[],"output":{"name":"defidforest"}}],[11,"full","","Create a forest consisting of a single tree representing the entire crate.",744,{"inputs":[{"name":"tyctxt"}],"output":{"name":"defidforest"}}],[11,"from_id","","Create a forest containing a DefId and all its descendants.",744,{"inputs":[{"name":"defid"}],"output":{"name":"defidforest"}}],[11,"is_empty","","Test whether the forest is empty.",744,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"contains","","Test whether the forest contains a given DefId.",744,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"intersection","","Calculate the intersection of a collection of forests.",744,{"inputs":[{"name":"tyctxt"},{"name":"i"}],"output":{"name":"defidforest"}}],[11,"union","","Calculate the union of a collection of forests.",744,{"inputs":[{"name":"tyctxt"},{"name":"i"}],"output":{"name":"defidforest"}}],[11,"is_ty_uninhabited_from","rustc::ty","Checks whether a type is visibly uninhabited from a particular module. # Example ```rust enum Void {} mod a {     pub mod b {         pub struct SecretlyUninhabited {             _priv: !,         }     } }",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"is_ty_uninhabited_from_all_modules","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ty_inhabitedness_forest","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"defidforest"}}],[11,"is_enum_variant_uninhabited_from","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"variantdef"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"is_variant_uninhabited_from_all_modules","","",655,{"inputs":[{"name":"self"},{"name":"variantdef"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"variant_inhabitedness_forest","","",655,{"inputs":[{"name":"self"},{"name":"variantdef"},{"name":"substs"}],"output":{"name":"defidforest"}}],[11,"uninhabited_from","","Calculate the forest of DefIds from which this adt is visibly uninhabited.",691,{"inputs":[{"name":"self"},{"name":"fxhashmap"},{"name":"tyctxt"},{"name":"substs"}],"output":{"name":"defidforest"}}],[11,"uninhabited_from","","Calculate the forest of DefIds from which this variant is visibly uninhabited.",689,{"inputs":[{"name":"self"},{"name":"fxhashmap"},{"name":"tyctxt"},{"name":"substs"},{"name":"adtkind"}],"output":{"name":"defidforest"}}],[11,"uninhabited_from","","Calculate the forest of DefIds from which this field is visibly uninhabited.",690,{"inputs":[{"name":"self"},{"name":"fxhashmap"},{"name":"tyctxt"},{"name":"substs"},{"name":"bool"}],"output":{"name":"defidforest"}}],[11,"uninhabited_from","","Calculate the forest of DefIds from which this type is visibly uninhabited.",668,{"inputs":[{"name":"self"},{"name":"fxhashmap"},{"name":"tyctxt"}],"output":{"name":"defidforest"}}],[0,"item_path","","",null,null],[3,"LocalPathBuffer","rustc::ty::item_path","",null,null],[12,"root_mode","","",745,null],[12,"str","","",745,null],[4,"RootMode","","",null,null],[13,"Local","","Try to make a path relative to the local crate.  In particular, local paths have no prefix, and if the path comes from an extern crate, start with the path to the `extern crate` declaration.",746,null],[13,"Absolute","","Always prepend the crate name to the path, forming an absolute path from within a given set of crates.",746,null],[5,"with_forced_absolute_paths","","Enforces that item_path_str always returns an absolute path and also enables \"type-based\" impl paths. This is used when building symbols that contain types, where we want the crate name to be part of the symbol.",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_forced_impl_filename_line","","Force us to name impls with just the filename/line number. We normally try to use types. But at some points, notably while printing cycle errors, this can result in extra or suboptimal error output, so this variable disables that check.",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"characteristic_def_id_of_type","","As a heuristic, when we see an impl, if we see that the 'self-type' is a type defined in the same module as the impl, we can omit including the path to the impl itself. This function tries to find a \"characteristic def-id\" for a type. It's just a heuristic so it makes some questionable decisions and we may want to adjust it later.",null,{"inputs":[{"name":"ty"}],"output":{"generics":["defid"],"name":"option"}}],[17,"FORCE_ABSOLUTE","","",null,null],[17,"FORCE_IMPL_FILENAME_LINE","","",null,null],[8,"ItemPathBuffer","","Unifying Trait for different kinds of item paths we might construct. The basic interface is that components get pushed: the instance can also customize how we handle the root of a crate.",null,null],[10,"root_mode","","",747,{"inputs":[{"name":"self"}],"output":{"name":"rootmode"}}],[10,"push","","",747,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"item_path_str","rustc::ty","Returns a string identifying this def-id. This string is suitable for user output. It is relative to the current crate root, unless with_forced_absolute_paths was used.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"string"}}],[11,"node_path_str","","Returns a string identifying this local node-id.",655,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"string"}}],[11,"absolute_item_path_str","","Returns a string identifying this def-id. This string is suitable for user output. It always begins with a crate identifier.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"string"}}],[11,"push_krate_path","","Returns the \"path\" to a particular crate. This can proceed in various ways, depending on the `root_mode` of the `buffer`. (See `RootMode` enum for more details.)",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"cratenum"}],"output":null}],[11,"try_push_visible_item_path","","If possible, this pushes a global path resolving to `external_def_id` that is visible from at least one local module and returns true. If the crate defining `external_def_id` is declared with an `extern crate`, the path is guaranteed to use the `extern crate`.",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"push_item_path","","",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"defid"}],"output":null}],[11,"push_impl_path","","",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"defid"}],"output":null}],[11,"push_impl_path_fallback","","",655,{"inputs":[{"name":"self"},{"name":"t"},{"name":"defid"}],"output":null}],[11,"parent_def_id","","Returns the def-id of `def_id`'s parent in the def tree. If this returns `None`, then `def_id` represents a crate root or inlined root.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"fmt","rustc::ty::item_path","",746,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",745,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",745,{"inputs":[{"name":"rootmode"}],"output":{"name":"localpathbuffer"}}],[11,"into_string","","",745,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"root_mode","","",745,{"inputs":[{"name":"self"}],"output":{"name":"rootmode"}}],[11,"push","","",745,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[0,"layout","rustc::ty","",null,null],[3,"LayoutCx","rustc::ty::layout","",null,null],[12,"tcx","","",748,null],[12,"param_env","","",748,null],[4,"LayoutError","","",null,null],[13,"Unknown","","",749,null],[13,"SizeOverflow","","",749,null],[4,"SizeSkeleton","","Type size \"skeleton\", i.e. the only information determining a type's size. While this is conservative, (aside from constant sizes, only pointers, newtypes thereof and null pointer optimized enums are allowed), it is enough to statically check common usecases of transmute.",null,null],[13,"Known","","Any statically computable Layout.",750,null],[13,"Pointer","","A potentially-fat pointer.",750,null],[12,"non_zero","rustc::ty::layout::SizeSkeleton","If true, this pointer is never null.",750,null],[12,"tail","","The type which determines the unsized metadata, if any, of this pointer. Either a type parameter or a projection depending on one, with regions erased.",750,null],[5,"layout_raw","rustc::ty::layout","",null,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"generics":["layoutdetails","layouterror"],"name":"result"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[6,"TyLayout","","",null,null],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.",null,null],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.",null,null],[8,"IntegerExt","","",null,null],[10,"to_ty","","",751,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"bool"}],"output":{"name":"ty"}}],[10,"from_attr","","",751,{"inputs":[{"name":"c"},{"name":"inttype"}],"output":{"name":"integer"}}],[10,"repr_discr","","",751,null],[8,"PrimitiveExt","","",null,null],[10,"to_ty","","",752,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[8,"HasTyCtxt","","",null,null],[10,"tcx","","",753,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[8,"MaybeResult","","",null,null],[10,"from_ok","","",754,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[10,"map_same","","",754,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"clone","","",749,{"inputs":[{"name":"self"}],"output":{"name":"layouterror"}}],[11,"fmt","","",749,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",749,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",749,{"inputs":[{"name":"__d"}],"output":{"generics":["layouterror"],"name":"result"}}],[11,"fmt","","",749,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",748,{"inputs":[{"name":"self"}],"output":{"name":"layoutcx"}}],[11,"layout_raw_uncached","","",748,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["layoutdetails","layouterror"],"name":"result"}}],[11,"record_layout_for_printing","","This is invoked by the `layout_raw` query to record the final layout of each type.",748,{"inputs":[{"name":"self"},{"name":"tylayout"}],"output":null}],[11,"record_layout_for_printing_outlined","","",748,{"inputs":[{"name":"self"},{"name":"tylayout"}],"output":null}],[11,"clone","","",750,{"inputs":[{"name":"self"}],"output":{"name":"sizeskeleton"}}],[11,"fmt","","",750,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"compute","","",750,{"inputs":[{"name":"ty"},{"name":"tyctxt"},{"name":"paramenv"}],"output":{"generics":["sizeskeleton","layouterror"],"name":"result"}}],[11,"same_size","","",750,{"inputs":[{"name":"self"},{"name":"sizeskeleton"}],"output":{"name":"bool"}}],[11,"data_layout","rustc::ty","",655,{"inputs":[{"name":"self"}],"output":{"name":"targetdatalayout"}}],[11,"tcx","","",655,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"data_layout","rustc::ty::layout","",748,{"inputs":[{"name":"self"}],"output":{"name":"targetdatalayout"}}],[11,"tcx","","",748,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"layout_of","","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",748,null],[11,"layout_of","","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",748,null],[11,"layout_of","rustc::ty","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"generics":["tylayout","layouterror"],"name":"result"}}],[11,"find_niche","rustc::ty::layout","Find the offset of a niche leaf field, starting from the given type and recursing through aggregates, which has at least `count` consecutive invalid values. The tuple is `(offset, scalar, niche_value)`.",748,{"inputs":[{"name":"self"},{"name":"tylayout"},{"name":"u128"}],"output":{"generics":["option","layouterror"],"name":"result"}}],[11,"hash_stable","","",749,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"_match","rustc::ty","",null,null],[3,"Match","rustc::ty::_match","A type \"A\" matches \"B\" if the fresh types in B could be substituted with values so as to make it equal to A. Matching is intended to be used only on freshened types, and it basically indicates if the non-freshened versions of A and B could have been unified.",null,null],[12,"tcx","","",755,null],[11,"new","","",755,{"inputs":[{"name":"tyctxt"}],"output":{"name":"match"}}],[11,"tag","","",755,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"tcx","","",755,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"a_is_expected","","",755,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",755,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"regions","","",755,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[11,"tys","","",755,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"binders","","",755,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[0,"maps","rustc::ty","",null,null],[3,"QueryJob","rustc::ty::maps","A object representing an active query job.",null,null],[12,"info","","",756,null],[12,"parent","","The parent query job which created this job and is implicitly waiting on it.",756,null],[12,"diagnostics","","Diagnostic messages which are emitted while the query executes",756,null],[3,"QueryInfo","","A span and a query key",null,null],[12,"span","","The span for a reason this query was required",757,null],[12,"query","","",757,null],[3,"OnDiskCache","","`OnDiskCache` provides an interface to incr. comp. data cached from the previous compilation session. This data will eventually include the results of a few selected queries (like `typeck_tables_of` and `mir_optimized`) and any diagnostics that have been emitted during a query.",null,null],[12,"serialized_data","","",758,null],[12,"current_diagnostics","","",758,null],[12,"prev_cnums","","",758,null],[12,"cnum_map","","",758,null],[12,"codemap","","",758,null],[12,"file_index_to_stable_id","","",758,null],[12,"file_index_to_file","","",758,null],[12,"synthetic_expansion_infos","","",758,null],[12,"query_result_index","","",758,null],[12,"prev_diagnostics_index","","",758,null],[12,"prev_interpret_alloc_index","","",758,null],[12,"interpret_alloc_cache","","Deserialization: A cache to ensure we don't read allocations twice",758,null],[3,"Maps","","",null,null],[12,"providers","","",759,null],[12,"type_of","","Records the type of every item.",759,null],[12,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics and predicates.",759,null],[12,"predicates_of","","",759,null],[12,"explicit_predicates_of","","",759,null],[12,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",759,null],[12,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",759,null],[12,"trait_def","","",759,null],[12,"adt_def","","",759,null],[12,"adt_destructor","","",759,null],[12,"adt_sized_constraint","","",759,null],[12,"adt_dtorck_constraint","","",759,null],[12,"is_const_fn","","True if this is a const fn",759,null],[12,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",759,null],[12,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",759,null],[12,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",759,null],[12,"inferred_outlives_of","","Maps from def-id of a type to its (inferred) outlives.",759,null],[12,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",759,null],[12,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",759,null],[12,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",759,null],[12,"impl_trait_ref","","",759,null],[12,"impl_polarity","","",759,null],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",759,null],[12,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",759,null],[12,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",759,null],[12,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",759,null],[12,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",759,null],[12,"mir_validated","","",759,null],[12,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for trans. This is also the only query that can fetch non-local MIR, at present.",759,null],[12,"unsafety_check_result","","The result of unsafety-checking this def-id.",759,null],[12,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",759,null],[12,"fn_sig","","The signature of functions and closures.",759,null],[12,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",759,null],[12,"typeck_item_bodies","","",759,null],[12,"typeck_tables_of","","",759,null],[12,"used_trait_imports","","",759,null],[12,"has_typeck_tables","","",759,null],[12,"coherent_trait","","",759,null],[12,"borrowck","","",759,null],[12,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",759,null],[12,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",759,null],[12,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",759,null],[12,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",759,null],[12,"check_match","","",759,null],[12,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",759,null],[12,"reachable_set","","",759,null],[12,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",759,null],[12,"mir_shims","","",759,null],[12,"def_symbol_name","","",759,null],[12,"symbol_name","","",759,null],[12,"describe_def","","",759,null],[12,"def_span","","",759,null],[12,"lookup_stability","","",759,null],[12,"lookup_deprecation_entry","","",759,null],[12,"item_attrs","","",759,null],[12,"trans_fn_attrs","","",759,null],[12,"fn_arg_names","","",759,null],[12,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",759,null],[12,"impl_parent","","",759,null],[12,"trait_of_item","","",759,null],[12,"const_is_rvalue_promotable_to_static","","",759,null],[12,"rvalue_promotable_map","","",759,null],[12,"is_mir_available","","",759,null],[12,"vtable_methods","","",759,null],[12,"trans_fulfill_obligation","","",759,null],[12,"trait_impls_of","","",759,null],[12,"specialization_graph_of","","",759,null],[12,"is_object_safe","","",759,null],[12,"param_env","","",759,null],[12,"is_copy_raw","","",759,null],[12,"is_sized_raw","","",759,null],[12,"is_freeze_raw","","",759,null],[12,"needs_drop_raw","","",759,null],[12,"layout_raw","","",759,null],[12,"dylib_dependency_formats","","",759,null],[12,"is_panic_runtime","","",759,null],[12,"is_compiler_builtins","","",759,null],[12,"has_global_allocator","","",759,null],[12,"is_sanitizer_runtime","","",759,null],[12,"is_profiler_runtime","","",759,null],[12,"panic_strategy","","",759,null],[12,"is_no_builtins","","",759,null],[12,"extern_crate","","",759,null],[12,"specializes","","",759,null],[12,"in_scope_traits_map","","",759,null],[12,"module_exports","","",759,null],[12,"lint_levels","","",759,null],[12,"impl_defaultness","","",759,null],[12,"check_item_well_formed","","",759,null],[12,"check_trait_item_well_formed","","",759,null],[12,"check_impl_item_well_formed","","",759,null],[12,"reachable_non_generics","","",759,null],[12,"is_reachable_non_generic","","",759,null],[12,"is_unreachable_local_definition","","",759,null],[12,"upstream_monomorphizations","","",759,null],[12,"upstream_monomorphizations_for","","",759,null],[12,"native_libraries","","",759,null],[12,"foreign_modules","","",759,null],[12,"plugin_registrar_fn","","",759,null],[12,"derive_registrar_fn","","",759,null],[12,"crate_disambiguator","","",759,null],[12,"crate_hash","","",759,null],[12,"original_crate_name","","",759,null],[12,"extra_filename","","",759,null],[12,"implementations_of_trait","","",759,null],[12,"all_trait_implementations","","",759,null],[12,"dllimport_foreign_items","","",759,null],[12,"is_dllimport_foreign_item","","",759,null],[12,"is_statically_included_foreign_item","","",759,null],[12,"native_library_kind","","",759,null],[12,"link_args","","",759,null],[12,"resolve_lifetimes","","",759,null],[12,"named_region_map","","",759,null],[12,"is_late_bound_map","","",759,null],[12,"object_lifetime_defaults_map","","",759,null],[12,"visibility","","",759,null],[12,"dep_kind","","",759,null],[12,"crate_name","","",759,null],[12,"item_children","","",759,null],[12,"extern_mod_stmt_cnum","","",759,null],[12,"get_lang_items","","",759,null],[12,"defined_lang_items","","",759,null],[12,"missing_lang_items","","",759,null],[12,"visible_parent_map","","",759,null],[12,"missing_extern_crate_item","","",759,null],[12,"used_crate_source","","",759,null],[12,"postorder_cnums","","",759,null],[12,"freevars","","",759,null],[12,"maybe_unused_trait_import","","",759,null],[12,"maybe_unused_extern_crates","","",759,null],[12,"stability_index","","",759,null],[12,"all_crate_nums","","",759,null],[12,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",759,null],[12,"exported_symbols","","",759,null],[12,"collect_and_partition_translation_items","","",759,null],[12,"is_translated_item","","",759,null],[12,"codegen_unit","","",759,null],[12,"compile_codegen_unit","","",759,null],[12,"output_filenames","","",759,null],[12,"erase_regions_ty","","",759,null],[12,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",759,null],[12,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",759,null],[12,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",759,null],[12,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",759,null],[12,"substitute_normalize_and_test_predicates","","",759,null],[12,"target_features_whitelist","","",759,null],[12,"instance_def_size_estimate","","",759,null],[12,"features_query","","",759,null],[12,"program_clauses_for","","",759,null],[12,"program_clauses_for_env","","",759,null],[12,"wasm_custom_sections","","",759,null],[12,"wasm_import_module_map","","",759,null],[3,"TyCtxtAt","","",null,null],[12,"tcx","","",760,null],[12,"span","","",760,null],[3,"Providers","","",null,null],[12,"type_of","","",761,null],[12,"generics_of","","",761,null],[12,"predicates_of","","",761,null],[12,"explicit_predicates_of","","",761,null],[12,"super_predicates_of","","",761,null],[12,"type_param_predicates","","",761,null],[12,"trait_def","","",761,null],[12,"adt_def","","",761,null],[12,"adt_destructor","","",761,null],[12,"adt_sized_constraint","","",761,null],[12,"adt_dtorck_constraint","","",761,null],[12,"is_const_fn","","",761,null],[12,"is_foreign_item","","",761,null],[12,"crate_variances","","",761,null],[12,"variances_of","","",761,null],[12,"inferred_outlives_of","","",761,null],[12,"inferred_outlives_crate","","",761,null],[12,"associated_item_def_ids","","",761,null],[12,"associated_item","","",761,null],[12,"impl_trait_ref","","",761,null],[12,"impl_polarity","","",761,null],[12,"inherent_impls","","",761,null],[12,"mir_keys","","",761,null],[12,"mir_const_qualif","","",761,null],[12,"mir_built","","",761,null],[12,"mir_const","","",761,null],[12,"mir_validated","","",761,null],[12,"optimized_mir","","",761,null],[12,"unsafety_check_result","","",761,null],[12,"unsafe_derive_on_repr_packed","","",761,null],[12,"fn_sig","","",761,null],[12,"coerce_unsized_info","","",761,null],[12,"typeck_item_bodies","","",761,null],[12,"typeck_tables_of","","",761,null],[12,"used_trait_imports","","",761,null],[12,"has_typeck_tables","","",761,null],[12,"coherent_trait","","",761,null],[12,"borrowck","","",761,null],[12,"mir_borrowck","","",761,null],[12,"crate_inherent_impls","","",761,null],[12,"crate_inherent_impls_overlap_check","","",761,null],[12,"const_eval","","",761,null],[12,"check_match","","",761,null],[12,"privacy_access_levels","","",761,null],[12,"reachable_set","","",761,null],[12,"region_scope_tree","","",761,null],[12,"mir_shims","","",761,null],[12,"def_symbol_name","","",761,null],[12,"symbol_name","","",761,null],[12,"describe_def","","",761,null],[12,"def_span","","",761,null],[12,"lookup_stability","","",761,null],[12,"lookup_deprecation_entry","","",761,null],[12,"item_attrs","","",761,null],[12,"trans_fn_attrs","","",761,null],[12,"fn_arg_names","","",761,null],[12,"rendered_const","","",761,null],[12,"impl_parent","","",761,null],[12,"trait_of_item","","",761,null],[12,"const_is_rvalue_promotable_to_static","","",761,null],[12,"rvalue_promotable_map","","",761,null],[12,"is_mir_available","","",761,null],[12,"vtable_methods","","",761,null],[12,"trans_fulfill_obligation","","",761,null],[12,"trait_impls_of","","",761,null],[12,"specialization_graph_of","","",761,null],[12,"is_object_safe","","",761,null],[12,"param_env","","",761,null],[12,"is_copy_raw","","",761,null],[12,"is_sized_raw","","",761,null],[12,"is_freeze_raw","","",761,null],[12,"needs_drop_raw","","",761,null],[12,"layout_raw","","",761,null],[12,"dylib_dependency_formats","","",761,null],[12,"is_panic_runtime","","",761,null],[12,"is_compiler_builtins","","",761,null],[12,"has_global_allocator","","",761,null],[12,"is_sanitizer_runtime","","",761,null],[12,"is_profiler_runtime","","",761,null],[12,"panic_strategy","","",761,null],[12,"is_no_builtins","","",761,null],[12,"extern_crate","","",761,null],[12,"specializes","","",761,null],[12,"in_scope_traits_map","","",761,null],[12,"module_exports","","",761,null],[12,"lint_levels","","",761,null],[12,"impl_defaultness","","",761,null],[12,"check_item_well_formed","","",761,null],[12,"check_trait_item_well_formed","","",761,null],[12,"check_impl_item_well_formed","","",761,null],[12,"reachable_non_generics","","",761,null],[12,"is_reachable_non_generic","","",761,null],[12,"is_unreachable_local_definition","","",761,null],[12,"upstream_monomorphizations","","",761,null],[12,"upstream_monomorphizations_for","","",761,null],[12,"native_libraries","","",761,null],[12,"foreign_modules","","",761,null],[12,"plugin_registrar_fn","","",761,null],[12,"derive_registrar_fn","","",761,null],[12,"crate_disambiguator","","",761,null],[12,"crate_hash","","",761,null],[12,"original_crate_name","","",761,null],[12,"extra_filename","","",761,null],[12,"implementations_of_trait","","",761,null],[12,"all_trait_implementations","","",761,null],[12,"dllimport_foreign_items","","",761,null],[12,"is_dllimport_foreign_item","","",761,null],[12,"is_statically_included_foreign_item","","",761,null],[12,"native_library_kind","","",761,null],[12,"link_args","","",761,null],[12,"resolve_lifetimes","","",761,null],[12,"named_region_map","","",761,null],[12,"is_late_bound_map","","",761,null],[12,"object_lifetime_defaults_map","","",761,null],[12,"visibility","","",761,null],[12,"dep_kind","","",761,null],[12,"crate_name","","",761,null],[12,"item_children","","",761,null],[12,"extern_mod_stmt_cnum","","",761,null],[12,"get_lang_items","","",761,null],[12,"defined_lang_items","","",761,null],[12,"missing_lang_items","","",761,null],[12,"visible_parent_map","","",761,null],[12,"missing_extern_crate_item","","",761,null],[12,"used_crate_source","","",761,null],[12,"postorder_cnums","","",761,null],[12,"freevars","","",761,null],[12,"maybe_unused_trait_import","","",761,null],[12,"maybe_unused_extern_crates","","",761,null],[12,"stability_index","","",761,null],[12,"all_crate_nums","","",761,null],[12,"all_traits","","",761,null],[12,"exported_symbols","","",761,null],[12,"collect_and_partition_translation_items","","",761,null],[12,"is_translated_item","","",761,null],[12,"codegen_unit","","",761,null],[12,"compile_codegen_unit","","",761,null],[12,"output_filenames","","",761,null],[12,"erase_regions_ty","","",761,null],[12,"normalize_projection_ty","","",761,null],[12,"normalize_ty_after_erasing_regions","","",761,null],[12,"dropck_outlives","","",761,null],[12,"evaluate_obligation","","",761,null],[12,"substitute_normalize_and_test_predicates","","",761,null],[12,"target_features_whitelist","","",761,null],[12,"instance_def_size_estimate","","",761,null],[12,"features_query","","",761,null],[12,"program_clauses_for","","",761,null],[12,"program_clauses_for_env","","",761,null],[12,"wasm_custom_sections","","",761,null],[12,"wasm_import_module_map","","",761,null],[4,"Query","","",null,null],[13,"type_of","","Records the type of every item.",762,null],[13,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics and predicates.",762,null],[13,"predicates_of","","",762,null],[13,"explicit_predicates_of","","",762,null],[13,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",762,null],[13,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",762,null],[13,"trait_def","","",762,null],[13,"adt_def","","",762,null],[13,"adt_destructor","","",762,null],[13,"adt_sized_constraint","","",762,null],[13,"adt_dtorck_constraint","","",762,null],[13,"is_const_fn","","True if this is a const fn",762,null],[13,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",762,null],[13,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",762,null],[13,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",762,null],[13,"inferred_outlives_of","","Maps from def-id of a type to its (inferred) outlives.",762,null],[13,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",762,null],[13,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",762,null],[13,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",762,null],[13,"impl_trait_ref","","",762,null],[13,"impl_polarity","","",762,null],[13,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",762,null],[13,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",762,null],[13,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",762,null],[13,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",762,null],[13,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",762,null],[13,"mir_validated","","",762,null],[13,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for trans. This is also the only query that can fetch non-local MIR, at present.",762,null],[13,"unsafety_check_result","","The result of unsafety-checking this def-id.",762,null],[13,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",762,null],[13,"fn_sig","","The signature of functions and closures.",762,null],[13,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",762,null],[13,"typeck_item_bodies","","",762,null],[13,"typeck_tables_of","","",762,null],[13,"used_trait_imports","","",762,null],[13,"has_typeck_tables","","",762,null],[13,"coherent_trait","","",762,null],[13,"borrowck","","",762,null],[13,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",762,null],[13,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",762,null],[13,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",762,null],[13,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",762,null],[13,"check_match","","",762,null],[13,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",762,null],[13,"reachable_set","","",762,null],[13,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",762,null],[13,"mir_shims","","",762,null],[13,"def_symbol_name","","",762,null],[13,"symbol_name","","",762,null],[13,"describe_def","","",762,null],[13,"def_span","","",762,null],[13,"lookup_stability","","",762,null],[13,"lookup_deprecation_entry","","",762,null],[13,"item_attrs","","",762,null],[13,"trans_fn_attrs","","",762,null],[13,"fn_arg_names","","",762,null],[13,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",762,null],[13,"impl_parent","","",762,null],[13,"trait_of_item","","",762,null],[13,"const_is_rvalue_promotable_to_static","","",762,null],[13,"rvalue_promotable_map","","",762,null],[13,"is_mir_available","","",762,null],[13,"vtable_methods","","",762,null],[13,"trans_fulfill_obligation","","",762,null],[13,"trait_impls_of","","",762,null],[13,"specialization_graph_of","","",762,null],[13,"is_object_safe","","",762,null],[13,"param_env","","",762,null],[13,"is_copy_raw","","",762,null],[13,"is_sized_raw","","",762,null],[13,"is_freeze_raw","","",762,null],[13,"needs_drop_raw","","",762,null],[13,"layout_raw","","",762,null],[13,"dylib_dependency_formats","","",762,null],[13,"is_panic_runtime","","",762,null],[13,"is_compiler_builtins","","",762,null],[13,"has_global_allocator","","",762,null],[13,"is_sanitizer_runtime","","",762,null],[13,"is_profiler_runtime","","",762,null],[13,"panic_strategy","","",762,null],[13,"is_no_builtins","","",762,null],[13,"extern_crate","","",762,null],[13,"specializes","","",762,null],[13,"in_scope_traits_map","","",762,null],[13,"module_exports","","",762,null],[13,"lint_levels","","",762,null],[13,"impl_defaultness","","",762,null],[13,"check_item_well_formed","","",762,null],[13,"check_trait_item_well_formed","","",762,null],[13,"check_impl_item_well_formed","","",762,null],[13,"reachable_non_generics","","",762,null],[13,"is_reachable_non_generic","","",762,null],[13,"is_unreachable_local_definition","","",762,null],[13,"upstream_monomorphizations","","",762,null],[13,"upstream_monomorphizations_for","","",762,null],[13,"native_libraries","","",762,null],[13,"foreign_modules","","",762,null],[13,"plugin_registrar_fn","","",762,null],[13,"derive_registrar_fn","","",762,null],[13,"crate_disambiguator","","",762,null],[13,"crate_hash","","",762,null],[13,"original_crate_name","","",762,null],[13,"extra_filename","","",762,null],[13,"implementations_of_trait","","",762,null],[13,"all_trait_implementations","","",762,null],[13,"dllimport_foreign_items","","",762,null],[13,"is_dllimport_foreign_item","","",762,null],[13,"is_statically_included_foreign_item","","",762,null],[13,"native_library_kind","","",762,null],[13,"link_args","","",762,null],[13,"resolve_lifetimes","","",762,null],[13,"named_region_map","","",762,null],[13,"is_late_bound_map","","",762,null],[13,"object_lifetime_defaults_map","","",762,null],[13,"visibility","","",762,null],[13,"dep_kind","","",762,null],[13,"crate_name","","",762,null],[13,"item_children","","",762,null],[13,"extern_mod_stmt_cnum","","",762,null],[13,"get_lang_items","","",762,null],[13,"defined_lang_items","","",762,null],[13,"missing_lang_items","","",762,null],[13,"visible_parent_map","","",762,null],[13,"missing_extern_crate_item","","",762,null],[13,"used_crate_source","","",762,null],[13,"postorder_cnums","","",762,null],[13,"freevars","","",762,null],[13,"maybe_unused_trait_import","","",762,null],[13,"maybe_unused_extern_crates","","",762,null],[13,"stability_index","","",762,null],[13,"all_crate_nums","","",762,null],[13,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",762,null],[13,"exported_symbols","","",762,null],[13,"collect_and_partition_translation_items","","",762,null],[13,"is_translated_item","","",762,null],[13,"codegen_unit","","",762,null],[13,"compile_codegen_unit","","",762,null],[13,"output_filenames","","",762,null],[13,"erase_regions_ty","","",762,null],[13,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",762,null],[13,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",762,null],[13,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",762,null],[13,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",762,null],[13,"substitute_normalize_and_test_predicates","","",762,null],[13,"target_features_whitelist","","",762,null],[13,"instance_def_size_estimate","","",762,null],[13,"features_query","","",762,null],[13,"program_clauses_for","","",762,null],[13,"program_clauses_for_env","","",762,null],[13,"wasm_custom_sections","","",762,null],[13,"wasm_import_module_map","","",762,null],[5,"force_from_dep_node","","The red/green evaluation system will try to mark a specific DepNode in the dependency graph as green by recursively trying to mark the dependencies of that DepNode as green. While doing so, it will sometimes encounter a DepNode where we don't know if it is red or green and we therefore actually have to recompute its value in order to find out. Since the only piece of information that we have at that point is the DepNode we are trying to re-evaluate, we need some way to re-run a query from just that. This is what `force_from_dep_node()` implements.",null,{"inputs":[{"name":"tyctxt"},{"name":"depnode"}],"output":{"name":"bool"}}],[5,"features_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"trans_fn_attrs","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"depconstructor"}}],[5,"erase_regions_ty","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"depconstructor"}}],[5,"type_param_predicates","","",null,null],[5,"fulfill_obligation_dep_node","","",null,null],[5,"crate_inherent_impls_dep_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"inherent_impls_overlap_check_dep_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"reachability_dep_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"mir_shim_dep_node","","",null,{"inputs":[{"name":"instancedef"}],"output":{"name":"depconstructor"}}],[5,"symbol_name_dep_node","","",null,{"inputs":[{"name":"instance"}],"output":{"name":"depconstructor"}}],[5,"typeck_item_bodies_dep_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"const_eval_dep_node","","",null,{"inputs":[{"generics":["globalid"],"name":"paramenvand"}],"output":{"name":"depconstructor"}}],[5,"mir_keys","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"crate_variances","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"is_copy_dep_node","","",null,{"inputs":[{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"depconstructor"}}],[5,"is_sized_dep_node","","",null,{"inputs":[{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"depconstructor"}}],[5,"is_freeze_dep_node","","",null,{"inputs":[{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"depconstructor"}}],[5,"needs_drop_dep_node","","",null,{"inputs":[{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"depconstructor"}}],[5,"layout_dep_node","","",null,{"inputs":[{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"depconstructor"}}],[5,"lint_levels_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"specializes_node","","",null,null],[5,"implementations_of_trait_node","","",null,null],[5,"link_args_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"get_lang_items_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"visible_parent_map_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"postorder_cnums_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"maybe_unused_extern_crates_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"stability_index_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"all_crate_nums_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"all_traits_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"collect_and_partition_translation_items_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"output_filenames_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"vtable_methods_node","","",null,{"inputs":[{"name":"polytraitref"}],"output":{"name":"depconstructor"}}],[5,"substitute_normalize_and_test_predicates_node","","",null,null],[5,"target_features_whitelist_node","","",null,{"inputs":[{"name":"cratenum"}],"output":{"name":"depconstructor"}}],[5,"instance_def_size_estimate_dep_node","","",null,{"inputs":[{"name":"instancedef"}],"output":{"name":"depconstructor"}}],[0,"plumbing","","The implementation of the query system itself. Defines the macros that generate the actual methods on tcx which find and execute the provider, manage the caches, and so forth.",null,null],[3,"QueryMap","rustc::ty::maps::plumbing","",null,null],[12,"results","","",763,null],[12,"active","","",763,null],[3,"QueryValue","","",null,null],[12,"value","","",764,null],[12,"index","","",764,null],[3,"JobOwner","","A type representing the responsibility to execute the job in the `job` field. This will poison the relevant query if dropped.",null,null],[12,"map","","",765,null],[12,"key","","",765,null],[12,"job","","",765,null],[3,"CycleError","","",null,null],[12,"usage","","The query and related span which uses the cycle",766,null],[12,"cycle","","",766,null],[4,"TryGetJob","","The result of `try_get_lock`",null,null],[13,"NotYetStarted","","The query is not yet started. Contains a guard to the map eventually used to start it.",767,null],[13,"JobCompleted","","The query was already completed. Returns the result of the query and its dep node index if it succeeded or a cycle error if it failed",767,null],[5,"force_from_dep_node","","The red/green evaluation system will try to mark a specific DepNode in the dependency graph as green by recursively trying to mark the dependencies of that DepNode as green. While doing so, it will sometimes encounter a DepNode where we don't know if it is red or green and we therefore actually have to recompute its value in order to find out. Since the only piece of information that we have at that point is the DepNode we are trying to re-evaluate, we need some way to re-run a query from just that. This is what `force_from_dep_node()` implements.",null,{"inputs":[{"name":"tyctxt"},{"name":"depnode"}],"output":{"name":"bool"}}],[11,"new","","",764,{"inputs":[{"name":"t"},{"name":"depnodeindex"}],"output":{"name":"queryvalue"}}],[11,"new","","",763,{"inputs":[],"output":{"name":"querymap"}}],[11,"try_get","","Either gets a JobOwner corresponding the the query, allowing us to start executing the query, or it returns with the result of the query. If the query is executing elsewhere, this will wait for it. If the query panicked, this will silently panic.",765,null],[11,"complete","","Completes the query by updating the query map with the `result`, signals the waiter and forgets the JobOwner, so it won't poison the query",765,null],[11,"start","","Executes a job by changing the ImplicitCtxt to point to the new query job while it executes. It returns the diagnostics captured during execution and the actual result.",765,null],[11,"drop","","",765,{"inputs":[{"name":"self"}],"output":null}],[11,"clone","","",766,{"inputs":[{"name":"self"}],"output":{"name":"cycleerror"}}],[11,"report_cycle","rustc::ty","",655,{"inputs":[{"name":"self"},{"name":"cycleerror"}],"output":{"name":"diagnosticbuilder"}}],[11,"try_print_query_stack","","",655,{"inputs":[],"output":null}],[11,"try_mark_green_and_read","","Try to read a node index for the node dep_node. A node will have an index, when it's already been marked green, or when we can mark it green. This function will mark the current task as a reader of the specified node, when the a node index can be found for that node.",655,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"generics":["depnodeindex"],"name":"option"}}],[11,"try_get_with","","",655,null],[11,"load_from_disk_and_cache_in_memory","","",655,null],[11,"force_query_with_job","","",655,null],[11,"ensure_query","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",655,null],[11,"force_query","","",655,null],[11,"try_get_query","","",655,null],[11,"get_query","","",655,null],[11,"cache_on_disk","rustc::dep_graph","",9,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"bool"}}],[11,"load_from_on_disk_cache","","",9,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":null}],[0,"job","rustc::ty::maps","",null,null],[3,"QueryInfo","rustc::ty::maps::job","A span and a query key",null,null],[12,"span","","The span for a reason this query was required",757,null],[12,"query","","",757,null],[3,"QueryJob","","A object representing an active query job.",null,null],[12,"info","","",756,null],[12,"parent","","The parent query job which created this job and is implicitly waiting on it.",756,null],[12,"diagnostics","","Diagnostic messages which are emitted while the query executes",756,null],[4,"QueryResult","","Indicates the state of a query for a given key in a query map",null,null],[13,"Started","","An already executing query. The query job can be used to await for its completion",768,null],[13,"Poisoned","","The query panicked. Queries trying to wait on this will raise a fatal error / silently panic",768,null],[11,"clone","rustc::ty::maps","",757,{"inputs":[{"name":"self"}],"output":{"name":"queryinfo"}}],[11,"fmt","","",757,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new query job",756,{"inputs":[{"name":"queryinfo"},{"generics":["lrc"],"name":"option"}],"output":{"name":"self"}}],[11,"await","","Awaits for the query job to complete.",756,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"span"}],"output":{"generics":["cycleerror"],"name":"result"}}],[11,"signal_complete","","Signals to waiters that the query is complete.",756,{"inputs":[{"name":"self"}],"output":null}],[0,"keys","","Defines the set of legal keys that can be used in queries.",null,null],[8,"Key","rustc::ty::maps::keys","The `Key` trait controls what types can legally be used as the key for a query.",null,null],[10,"map_crate","","Given an instance of this key, what crate is it referring to? This is used to find the provider.",769,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[10,"default_span","","In the event that a cycle occurs, if no explicit span has been given for a query with key `self`, what span should we use?",769,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","rustc::ty","",701,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",701,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","","",660,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",660,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","rustc::mir::interpret","",491,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",491,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","rustc::hir::def_id","",141,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",141,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","","",142,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",142,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","","",143,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",143,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","rustc::ty","",685,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",685,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","","",686,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",686,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","rustc::ty::maps::keys","",770,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",770,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","","",771,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",771,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","","",772,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",772,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[0,"values","rustc::ty::maps","",null,null],[8,"Value","rustc::ty::maps::values","",null,null],[10,"from_cycle_error","","",773,{"inputs":[{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"from_cycle_error","rustc::ty","",695,{"inputs":[{"name":"tyctxt"}],"output":{"name":"self"}}],[0,"config","rustc::ty::maps","",null,null],[8,"QueryConfig","rustc::ty::maps::config","Query configuration and description traits.",null,null],[18,"NAME","","",774,null],[16,"Key","","",774,null],[16,"Value","","",774,null],[10,"query","","",774,null],[10,"query_map","","",774,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[10,"to_dep_node","","",774,null],[10,"compute","","",774,null],[10,"handle_cycle_error","","",774,null],[8,"QueryDescription","","",null,null],[10,"describe","","",775,null],[11,"cache_on_disk","","",775,null],[11,"try_load_from_disk","","",775,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[0,"on_disk_cache","rustc::ty::maps","",null,null],[3,"OnDiskCache","rustc::ty::maps::on_disk_cache","`OnDiskCache` provides an interface to incr. comp. data cached from the previous compilation session. This data will eventually include the results of a few selected queries (like `typeck_tables_of` and `mir_optimized`) and any diagnostics that have been emitted during a query.",null,null],[12,"serialized_data","","",758,null],[12,"current_diagnostics","","",758,null],[12,"prev_cnums","","",758,null],[12,"cnum_map","","",758,null],[12,"codemap","","",758,null],[12,"file_index_to_stable_id","","",758,null],[12,"file_index_to_file","","",758,null],[12,"synthetic_expansion_infos","","",758,null],[12,"query_result_index","","",758,null],[12,"prev_diagnostics_index","","",758,null],[12,"prev_interpret_alloc_index","","",758,null],[12,"interpret_alloc_cache","","Deserialization: A cache to ensure we don't read allocations twice",758,null],[3,"Footer","","",null,null],[12,"file_index_to_stable_id","","",776,null],[12,"prev_cnums","","",776,null],[12,"query_result_index","","",776,null],[12,"diagnostics_index","","",776,null],[12,"interpret_alloc_index","","",776,null],[3,"FileMapIndex","","",null,null],[12,"0","","",777,null],[3,"AbsoluteBytePos","","",null,null],[12,"0","","",778,null],[3,"CacheDecoder","","A decoder that can read the incr. comp. cache. It is similar to the one we use for crate metadata decoding in that it can rebase spans and eventually will also handle things that contain `Ty` instances.",null,null],[12,"tcx","","",779,null],[12,"opaque","","",779,null],[12,"codemap","","",779,null],[12,"cnum_map","","",779,null],[12,"synthetic_expansion_infos","","",779,null],[12,"file_index_to_file","","",779,null],[12,"file_index_to_stable_id","","",779,null],[12,"interpret_alloc_cache","","",779,null],[12,"prev_interpret_alloc_index","","maps from index in the cache file to location in the cache file",779,null],[3,"CacheEncoder","","",null,null],[12,"tcx","","",780,null],[12,"encoder","","",780,null],[12,"type_shorthands","","",780,null],[12,"predicate_shorthands","","",780,null],[12,"expn_info_shorthands","","",780,null],[12,"interpret_allocs","","",780,null],[12,"interpret_allocs_inverse","","",780,null],[12,"codemap","","",780,null],[12,"file_to_file_index","","",780,null],[3,"IntEncodedWithFixedSize","","",null,null],[12,"0","","",781,null],[5,"decode_tagged","","",null,{"inputs":[{"name":"d"},{"name":"t"}],"output":{"name":"result"}}],[5,"encode_query_results","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cacheencoder"},{"name":"vec"}],"output":{"name":"result"}}],[0,"__ty_decoder_impl","","",null,null],[11,"read_nil","","",779,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"read_u128","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"result"}}],[11,"read_u64","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"result"}}],[11,"read_u32","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["u32"],"name":"result"}}],[11,"read_u16","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["u16"],"name":"result"}}],[11,"read_u8","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"result"}}],[11,"read_usize","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"result"}}],[11,"read_i128","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"result"}}],[11,"read_i64","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"result"}}],[11,"read_i32","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"result"}}],[11,"read_i16","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["i16"],"name":"result"}}],[11,"read_i8","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["i8"],"name":"result"}}],[11,"read_isize","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["isize"],"name":"result"}}],[11,"read_bool","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[11,"read_f64","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"result"}}],[11,"read_f32","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["f32"],"name":"result"}}],[11,"read_char","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"result"}}],[11,"read_str","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"result"}}],[11,"error","","",779,null],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["genericpredicates"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["substs"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["region"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["slice"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["adtdef"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["slice"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["canonicalvarinfos"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["const"],"name":"result"}}],[6,"EncodedQueryResultIndex","","",null,null],[6,"EncodedDiagnosticsIndex","","",null,null],[6,"EncodedDiagnostics","","",null,null],[17,"TAG_FILE_FOOTER","","",null,null],[17,"TAG_CLEAR_CROSS_CRATE_CLEAR","","",null,null],[17,"TAG_CLEAR_CROSS_CRATE_SET","","",null,null],[17,"TAG_NO_EXPANSION_INFO","","",null,null],[17,"TAG_EXPANSION_INFO_SHORTHAND","","",null,null],[17,"TAG_EXPANSION_INFO_INLINE","","",null,null],[17,"TAG_VALID_SPAN","","",null,null],[17,"TAG_INVALID_SPAN","","",null,null],[8,"DecoderWithPosition","","",null,null],[10,"position","","",782,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"encode","","",776,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",776,{"inputs":[{"name":"__d"}],"output":{"generics":["footer"],"name":"result"}}],[11,"clone","","",777,{"inputs":[{"name":"self"}],"output":{"name":"filemapindex"}}],[11,"eq","","",777,{"inputs":[{"name":"self"},{"name":"filemapindex"}],"output":{"name":"bool"}}],[11,"ne","","",777,{"inputs":[{"name":"self"},{"name":"filemapindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",777,null],[11,"hash","","",777,null],[11,"fmt","","",777,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",777,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",777,{"inputs":[{"name":"__d"}],"output":{"generics":["filemapindex"],"name":"result"}}],[11,"clone","","",778,{"inputs":[{"name":"self"}],"output":{"name":"absolutebytepos"}}],[11,"fmt","","",778,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",778,null],[11,"assert_receiver_is_total_eq","","",778,null],[11,"eq","","",778,{"inputs":[{"name":"self"},{"name":"absolutebytepos"}],"output":{"name":"bool"}}],[11,"ne","","",778,{"inputs":[{"name":"self"},{"name":"absolutebytepos"}],"output":{"name":"bool"}}],[11,"encode","","",778,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",778,{"inputs":[{"name":"__d"}],"output":{"generics":["absolutebytepos"],"name":"result"}}],[11,"new","","",778,{"inputs":[{"name":"usize"}],"output":{"name":"absolutebytepos"}}],[11,"to_usize","","",778,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new","rustc::ty::maps","Create a new OnDiskCache instance from the serialized data in `data`.",758,{"inputs":[{"name":"session"},{"generics":["u8"],"name":"vec"},{"name":"usize"}],"output":{"name":"ondiskcache"}}],[11,"new_empty","","",758,{"inputs":[{"name":"codemap"}],"output":{"name":"ondiskcache"}}],[11,"serialize","","",758,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"e"}],"output":{"name":"result"}}],[11,"load_diagnostics","","Load a diagnostic emitted during the previous compilation session.",758,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"generics":["diagnostic"],"name":"vec"}}],[11,"store_diagnostics","","Store a diagnostic emitted during the current compilation session. Anything stored like this will be available via `load_diagnostics` in the next compilation session.",758,{"inputs":[{"name":"self"},{"name":"depnodeindex"},{"generics":["diagnostic"],"name":"vec"}],"output":null}],[11,"try_load_query_result","","Returns the cached query result if there is something in the cache for the given SerializedDepNodeIndex. Otherwise returns None.",758,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"store_diagnostics_for_anon_node","","Store a diagnostic emitted during computation of an anonymous query. Since many anonymous queries can share the same `DepNode`, we aggregate them -- as opposed to regular queries where we assume that there is a 1:1 relationship between query-key and `DepNode`.",758,{"inputs":[{"name":"self"},{"name":"depnodeindex"},{"generics":["diagnostic"],"name":"vec"}],"output":null}],[11,"load_indexed","","",758,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"serializeddepnodeindex"},{"name":"fxhashmap"},{"name":"str"}],"output":{"name":"option"}}],[11,"compute_cnum_map","","",758,null],[11,"file_index_to_file","rustc::ty::maps::on_disk_cache","",779,{"inputs":[{"name":"self"},{"name":"filemapindex"}],"output":{"generics":["filemap"],"name":"lrc"}}],[11,"position","","",779,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"tcx","","",779,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"position","","",779,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"peek_byte","","",779,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"cached_ty_for_shorthand","","",779,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"generics":["ty"],"name":"result"}}],[11,"with_position","","",779,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[11,"map_encoded_cnum_to_current","","",779,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratenum"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["allocid"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["defindex"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["localdefid"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["hirid"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["nodeid"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["fingerprint"],"name":"result"}}],[11,"specialized_decode","","",779,{"inputs":[{"name":"self"}],"output":{"generics":["clearcrosscrate"],"name":"result"}}],[11,"filemap_index","","",780,{"inputs":[{"name":"self"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"filemapindex"}}],[11,"encode_tagged","","Encode something with additional information that allows to do some sanity checks when decoding the data again. This method will first encode the specified tag, then the given value, then the number of bytes taken up by tag and value. On decoding, we can then verify that we get the expected tag and read the expected number of bytes.",780,{"inputs":[{"name":"self"},{"name":"t"},{"name":"v"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"result"}}],[11,"position","","",780,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"genericpredicates"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"result"}}],[11,"specialized_encode","","",780,{"inputs":[{"name":"self"},{"name":"clearcrosscrate"}],"output":{"name":"result"}}],[11,"emit_nil","","",780,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"emit_usize","","",780,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"emit_u128","","",780,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"result"}}],[11,"emit_u64","","",780,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"result"}}],[11,"emit_u32","","",780,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"result"}}],[11,"emit_u16","","",780,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"result"}}],[11,"emit_u8","","",780,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"result"}}],[11,"emit_isize","","",780,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"result"}}],[11,"emit_i128","","",780,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"result"}}],[11,"emit_i64","","",780,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"result"}}],[11,"emit_i32","","",780,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"result"}}],[11,"emit_i16","","",780,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"result"}}],[11,"emit_i8","","",780,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"result"}}],[11,"emit_bool","","",780,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"result"}}],[11,"emit_f64","","",780,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"result"}}],[11,"emit_f32","","",780,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"result"}}],[11,"emit_char","","",780,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"result"}}],[11,"emit_str","","",780,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[18,"ENCODED_SIZE","","",781,null],[0,"queries","rustc::ty::maps","",null,null],[3,"type_of","rustc::ty::maps::queries","",null,null],[12,"data","","",783,null],[3,"generics_of","","",null,null],[12,"data","","",784,null],[3,"predicates_of","","",null,null],[12,"data","","",785,null],[3,"explicit_predicates_of","","",null,null],[12,"data","","",786,null],[3,"super_predicates_of","","",null,null],[12,"data","","",787,null],[3,"type_param_predicates","","",null,null],[12,"data","","",788,null],[3,"trait_def","","",null,null],[12,"data","","",789,null],[3,"adt_def","","",null,null],[12,"data","","",790,null],[3,"adt_destructor","","",null,null],[12,"data","","",791,null],[3,"adt_sized_constraint","","",null,null],[12,"data","","",792,null],[3,"adt_dtorck_constraint","","",null,null],[12,"data","","",793,null],[3,"is_const_fn","","",null,null],[12,"data","","",794,null],[3,"is_foreign_item","","",null,null],[12,"data","","",795,null],[3,"crate_variances","","",null,null],[12,"data","","",796,null],[3,"variances_of","","",null,null],[12,"data","","",797,null],[3,"inferred_outlives_of","","",null,null],[12,"data","","",798,null],[3,"inferred_outlives_crate","","",null,null],[12,"data","","",799,null],[3,"associated_item_def_ids","","",null,null],[12,"data","","",800,null],[3,"associated_item","","",null,null],[12,"data","","",801,null],[3,"impl_trait_ref","","",null,null],[12,"data","","",802,null],[3,"impl_polarity","","",null,null],[12,"data","","",803,null],[3,"inherent_impls","","",null,null],[12,"data","","",804,null],[3,"mir_keys","","",null,null],[12,"data","","",805,null],[3,"mir_const_qualif","","",null,null],[12,"data","","",806,null],[3,"mir_built","","",null,null],[12,"data","","",807,null],[3,"mir_const","","",null,null],[12,"data","","",808,null],[3,"mir_validated","","",null,null],[12,"data","","",809,null],[3,"optimized_mir","","",null,null],[12,"data","","",810,null],[3,"unsafety_check_result","","",null,null],[12,"data","","",811,null],[3,"unsafe_derive_on_repr_packed","","",null,null],[12,"data","","",812,null],[3,"fn_sig","","",null,null],[12,"data","","",813,null],[3,"coerce_unsized_info","","",null,null],[12,"data","","",814,null],[3,"typeck_item_bodies","","",null,null],[12,"data","","",815,null],[3,"typeck_tables_of","","",null,null],[12,"data","","",816,null],[3,"used_trait_imports","","",null,null],[12,"data","","",817,null],[3,"has_typeck_tables","","",null,null],[12,"data","","",818,null],[3,"coherent_trait","","",null,null],[12,"data","","",819,null],[3,"borrowck","","",null,null],[12,"data","","",820,null],[3,"mir_borrowck","","",null,null],[12,"data","","",821,null],[3,"crate_inherent_impls","","",null,null],[12,"data","","",822,null],[3,"crate_inherent_impls_overlap_check","","",null,null],[12,"data","","",823,null],[3,"const_eval","","",null,null],[12,"data","","",824,null],[3,"check_match","","",null,null],[12,"data","","",825,null],[3,"privacy_access_levels","","",null,null],[12,"data","","",826,null],[3,"reachable_set","","",null,null],[12,"data","","",827,null],[3,"region_scope_tree","","",null,null],[12,"data","","",828,null],[3,"mir_shims","","",null,null],[12,"data","","",829,null],[3,"def_symbol_name","","",null,null],[12,"data","","",830,null],[3,"symbol_name","","",null,null],[12,"data","","",831,null],[3,"describe_def","","",null,null],[12,"data","","",832,null],[3,"def_span","","",null,null],[12,"data","","",833,null],[3,"lookup_stability","","",null,null],[12,"data","","",834,null],[3,"lookup_deprecation_entry","","",null,null],[12,"data","","",835,null],[3,"item_attrs","","",null,null],[12,"data","","",836,null],[3,"trans_fn_attrs","","",null,null],[12,"data","","",837,null],[3,"fn_arg_names","","",null,null],[12,"data","","",838,null],[3,"rendered_const","","",null,null],[12,"data","","",839,null],[3,"impl_parent","","",null,null],[12,"data","","",840,null],[3,"trait_of_item","","",null,null],[12,"data","","",841,null],[3,"const_is_rvalue_promotable_to_static","","",null,null],[12,"data","","",842,null],[3,"rvalue_promotable_map","","",null,null],[12,"data","","",843,null],[3,"is_mir_available","","",null,null],[12,"data","","",844,null],[3,"vtable_methods","","",null,null],[12,"data","","",845,null],[3,"trans_fulfill_obligation","","",null,null],[12,"data","","",846,null],[3,"trait_impls_of","","",null,null],[12,"data","","",847,null],[3,"specialization_graph_of","","",null,null],[12,"data","","",848,null],[3,"is_object_safe","","",null,null],[12,"data","","",849,null],[3,"param_env","","",null,null],[12,"data","","",850,null],[3,"is_copy_raw","","",null,null],[12,"data","","",851,null],[3,"is_sized_raw","","",null,null],[12,"data","","",852,null],[3,"is_freeze_raw","","",null,null],[12,"data","","",853,null],[3,"needs_drop_raw","","",null,null],[12,"data","","",854,null],[3,"layout_raw","","",null,null],[12,"data","","",855,null],[3,"dylib_dependency_formats","","",null,null],[12,"data","","",856,null],[3,"is_panic_runtime","","",null,null],[12,"data","","",857,null],[3,"is_compiler_builtins","","",null,null],[12,"data","","",858,null],[3,"has_global_allocator","","",null,null],[12,"data","","",859,null],[3,"is_sanitizer_runtime","","",null,null],[12,"data","","",860,null],[3,"is_profiler_runtime","","",null,null],[12,"data","","",861,null],[3,"panic_strategy","","",null,null],[12,"data","","",862,null],[3,"is_no_builtins","","",null,null],[12,"data","","",863,null],[3,"extern_crate","","",null,null],[12,"data","","",864,null],[3,"specializes","","",null,null],[12,"data","","",865,null],[3,"in_scope_traits_map","","",null,null],[12,"data","","",866,null],[3,"module_exports","","",null,null],[12,"data","","",867,null],[3,"lint_levels","","",null,null],[12,"data","","",868,null],[3,"impl_defaultness","","",null,null],[12,"data","","",869,null],[3,"check_item_well_formed","","",null,null],[12,"data","","",870,null],[3,"check_trait_item_well_formed","","",null,null],[12,"data","","",871,null],[3,"check_impl_item_well_formed","","",null,null],[12,"data","","",872,null],[3,"reachable_non_generics","","",null,null],[12,"data","","",873,null],[3,"is_reachable_non_generic","","",null,null],[12,"data","","",874,null],[3,"is_unreachable_local_definition","","",null,null],[12,"data","","",875,null],[3,"upstream_monomorphizations","","",null,null],[12,"data","","",876,null],[3,"upstream_monomorphizations_for","","",null,null],[12,"data","","",877,null],[3,"native_libraries","","",null,null],[12,"data","","",878,null],[3,"foreign_modules","","",null,null],[12,"data","","",879,null],[3,"plugin_registrar_fn","","",null,null],[12,"data","","",880,null],[3,"derive_registrar_fn","","",null,null],[12,"data","","",881,null],[3,"crate_disambiguator","","",null,null],[12,"data","","",882,null],[3,"crate_hash","","",null,null],[12,"data","","",883,null],[3,"original_crate_name","","",null,null],[12,"data","","",884,null],[3,"extra_filename","","",null,null],[12,"data","","",885,null],[3,"implementations_of_trait","","",null,null],[12,"data","","",886,null],[3,"all_trait_implementations","","",null,null],[12,"data","","",887,null],[3,"dllimport_foreign_items","","",null,null],[12,"data","","",888,null],[3,"is_dllimport_foreign_item","","",null,null],[12,"data","","",889,null],[3,"is_statically_included_foreign_item","","",null,null],[12,"data","","",890,null],[3,"native_library_kind","","",null,null],[12,"data","","",891,null],[3,"link_args","","",null,null],[12,"data","","",892,null],[3,"resolve_lifetimes","","",null,null],[12,"data","","",893,null],[3,"named_region_map","","",null,null],[12,"data","","",894,null],[3,"is_late_bound_map","","",null,null],[12,"data","","",895,null],[3,"object_lifetime_defaults_map","","",null,null],[12,"data","","",896,null],[3,"visibility","","",null,null],[12,"data","","",897,null],[3,"dep_kind","","",null,null],[12,"data","","",898,null],[3,"crate_name","","",null,null],[12,"data","","",899,null],[3,"item_children","","",null,null],[12,"data","","",900,null],[3,"extern_mod_stmt_cnum","","",null,null],[12,"data","","",901,null],[3,"get_lang_items","","",null,null],[12,"data","","",902,null],[3,"defined_lang_items","","",null,null],[12,"data","","",903,null],[3,"missing_lang_items","","",null,null],[12,"data","","",904,null],[3,"visible_parent_map","","",null,null],[12,"data","","",905,null],[3,"missing_extern_crate_item","","",null,null],[12,"data","","",906,null],[3,"used_crate_source","","",null,null],[12,"data","","",907,null],[3,"postorder_cnums","","",null,null],[12,"data","","",908,null],[3,"freevars","","",null,null],[12,"data","","",909,null],[3,"maybe_unused_trait_import","","",null,null],[12,"data","","",910,null],[3,"maybe_unused_extern_crates","","",null,null],[12,"data","","",911,null],[3,"stability_index","","",null,null],[12,"data","","",912,null],[3,"all_crate_nums","","",null,null],[12,"data","","",913,null],[3,"all_traits","","",null,null],[12,"data","","",914,null],[3,"exported_symbols","","",null,null],[12,"data","","",915,null],[3,"collect_and_partition_translation_items","","",null,null],[12,"data","","",916,null],[3,"is_translated_item","","",null,null],[12,"data","","",917,null],[3,"codegen_unit","","",null,null],[12,"data","","",918,null],[3,"compile_codegen_unit","","",null,null],[12,"data","","",919,null],[3,"output_filenames","","",null,null],[12,"data","","",920,null],[3,"erase_regions_ty","","",null,null],[12,"data","","",921,null],[3,"normalize_projection_ty","","",null,null],[12,"data","","",922,null],[3,"normalize_ty_after_erasing_regions","","",null,null],[12,"data","","",923,null],[3,"dropck_outlives","","",null,null],[12,"data","","",924,null],[3,"evaluate_obligation","","",null,null],[12,"data","","",925,null],[3,"substitute_normalize_and_test_predicates","","",null,null],[12,"data","","",926,null],[3,"target_features_whitelist","","",null,null],[12,"data","","",927,null],[3,"instance_def_size_estimate","","",null,null],[12,"data","","",928,null],[3,"features_query","","",null,null],[12,"data","","",929,null],[3,"program_clauses_for","","",null,null],[12,"data","","",930,null],[3,"program_clauses_for_env","","",null,null],[12,"data","","",931,null],[3,"wasm_custom_sections","","",null,null],[12,"data","","",932,null],[3,"wasm_import_module_map","","",null,null],[12,"data","","",933,null],[8,"Key","rustc::ty::maps","The `Key` trait controls what types can legally be used as the key for a query.",null,null],[10,"map_crate","","Given an instance of this key, what crate is it referring to? This is used to find the provider.",769,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[10,"default_span","","In the event that a cycle occurs, if no explicit span has been given for a query with key `self`, what span should we use?",769,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[8,"QueryConfig","","Query configuration and description traits.",null,null],[18,"NAME","rustc::ty::maps::config","",774,null],[16,"Key","rustc::ty::maps","",774,null],[16,"Value","","",774,null],[10,"query","","",774,null],[10,"query_map","","",774,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[10,"to_dep_node","","",774,null],[10,"compute","","",774,null],[10,"handle_cycle_error","","",774,null],[11,"new","","",759,{"inputs":[{"generics":["cratenum","providers"],"name":"indexvec"}],"output":{"name":"self"}}],[11,"clone","","",762,{"inputs":[{"name":"self"}],"output":{"name":"query"}}],[11,"fmt","","",762,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",762,{"inputs":[{"name":"self"},{"name":"query"}],"output":{"name":"bool"}}],[11,"ne","","",762,{"inputs":[{"name":"self"},{"name":"query"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",762,null],[11,"name","","",762,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"describe","","",762,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"default_span","","",762,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"span"}],"output":{"name":"span"}}],[11,"query","rustc::ty::maps::queries","",783,null],[11,"query_map","","",783,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",783,null],[11,"compute","","",783,null],[11,"handle_cycle_error","","",783,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",783,null],[11,"query","","",784,null],[11,"query_map","","",784,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",784,null],[11,"compute","","",784,null],[11,"handle_cycle_error","","",784,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",784,null],[11,"query","","",785,null],[11,"query_map","","",785,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",785,null],[11,"compute","","",785,null],[11,"handle_cycle_error","","",785,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",785,null],[11,"query","","",786,null],[11,"query_map","","",786,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",786,null],[11,"compute","","",786,null],[11,"handle_cycle_error","","",786,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",786,null],[11,"query","","",787,null],[11,"query_map","","",787,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",787,null],[11,"compute","","",787,null],[11,"handle_cycle_error","","",787,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",787,null],[11,"query","","",788,null],[11,"query_map","","",788,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",788,null],[11,"compute","","",788,null],[11,"handle_cycle_error","","",788,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",788,null],[11,"query","","",789,null],[11,"query_map","","",789,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",789,null],[11,"compute","","",789,null],[11,"handle_cycle_error","","",789,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",789,null],[11,"query","","",790,null],[11,"query_map","","",790,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",790,null],[11,"compute","","",790,null],[11,"handle_cycle_error","","",790,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",790,null],[11,"query","","",791,null],[11,"query_map","","",791,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",791,null],[11,"compute","","",791,null],[11,"handle_cycle_error","","",791,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",791,null],[11,"query","","",792,null],[11,"query_map","","",792,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",792,null],[11,"compute","","",792,null],[11,"handle_cycle_error","","",792,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",792,null],[11,"query","","",793,null],[11,"query_map","","",793,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",793,null],[11,"compute","","",793,null],[11,"handle_cycle_error","","",793,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",793,null],[11,"query","","",794,null],[11,"query_map","","",794,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",794,null],[11,"compute","","",794,null],[11,"handle_cycle_error","","",794,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",794,null],[11,"query","","",795,null],[11,"query_map","","",795,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",795,null],[11,"compute","","",795,null],[11,"handle_cycle_error","","",795,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",795,null],[11,"query","","",796,null],[11,"query_map","","",796,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",796,null],[11,"compute","","",796,null],[11,"handle_cycle_error","","",796,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",796,null],[11,"query","","",797,null],[11,"query_map","","",797,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",797,null],[11,"compute","","",797,null],[11,"handle_cycle_error","","",797,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",797,null],[11,"query","","",798,null],[11,"query_map","","",798,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",798,null],[11,"compute","","",798,null],[11,"handle_cycle_error","","",798,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",798,null],[11,"query","","",799,null],[11,"query_map","","",799,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",799,null],[11,"compute","","",799,null],[11,"handle_cycle_error","","",799,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",799,null],[11,"query","","",800,null],[11,"query_map","","",800,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",800,null],[11,"compute","","",800,null],[11,"handle_cycle_error","","",800,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",800,null],[11,"query","","",801,null],[11,"query_map","","",801,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",801,null],[11,"compute","","",801,null],[11,"handle_cycle_error","","",801,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",801,null],[11,"query","","",802,null],[11,"query_map","","",802,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",802,null],[11,"compute","","",802,null],[11,"handle_cycle_error","","",802,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",802,null],[11,"query","","",803,null],[11,"query_map","","",803,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",803,null],[11,"compute","","",803,null],[11,"handle_cycle_error","","",803,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",803,null],[11,"query","","",804,null],[11,"query_map","","",804,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",804,null],[11,"compute","","",804,null],[11,"handle_cycle_error","","",804,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",804,null],[11,"query","","",805,null],[11,"query_map","","",805,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",805,null],[11,"compute","","",805,null],[11,"handle_cycle_error","","",805,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",805,null],[11,"query","","",806,null],[11,"query_map","","",806,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",806,null],[11,"compute","","",806,null],[11,"handle_cycle_error","","",806,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",806,null],[11,"query","","",807,null],[11,"query_map","","",807,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",807,null],[11,"compute","","",807,null],[11,"handle_cycle_error","","",807,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",807,null],[11,"query","","",808,null],[11,"query_map","","",808,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",808,null],[11,"compute","","",808,null],[11,"handle_cycle_error","","",808,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",808,null],[11,"query","","",809,null],[11,"query_map","","",809,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",809,null],[11,"compute","","",809,null],[11,"handle_cycle_error","","",809,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",809,null],[11,"query","","",810,null],[11,"query_map","","",810,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",810,null],[11,"compute","","",810,null],[11,"handle_cycle_error","","",810,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",810,null],[11,"query","","",811,null],[11,"query_map","","",811,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",811,null],[11,"compute","","",811,null],[11,"handle_cycle_error","","",811,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",811,null],[11,"query","","",812,null],[11,"query_map","","",812,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",812,null],[11,"compute","","",812,null],[11,"handle_cycle_error","","",812,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",812,null],[11,"query","","",813,null],[11,"query_map","","",813,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",813,null],[11,"compute","","",813,null],[11,"handle_cycle_error","","",813,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",813,null],[11,"query","","",814,null],[11,"query_map","","",814,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",814,null],[11,"compute","","",814,null],[11,"handle_cycle_error","","",814,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",814,null],[11,"query","","",815,null],[11,"query_map","","",815,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",815,null],[11,"compute","","",815,null],[11,"handle_cycle_error","","",815,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",815,null],[11,"query","","",816,null],[11,"query_map","","",816,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",816,null],[11,"compute","","",816,null],[11,"handle_cycle_error","","",816,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",816,null],[11,"query","","",817,null],[11,"query_map","","",817,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",817,null],[11,"compute","","",817,null],[11,"handle_cycle_error","","",817,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",817,null],[11,"query","","",818,null],[11,"query_map","","",818,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",818,null],[11,"compute","","",818,null],[11,"handle_cycle_error","","",818,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",818,null],[11,"query","","",819,null],[11,"query_map","","",819,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",819,null],[11,"compute","","",819,null],[11,"handle_cycle_error","","",819,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",819,null],[11,"query","","",820,null],[11,"query_map","","",820,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",820,null],[11,"compute","","",820,null],[11,"handle_cycle_error","","",820,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",820,null],[11,"query","","",821,null],[11,"query_map","","",821,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",821,null],[11,"compute","","",821,null],[11,"handle_cycle_error","","",821,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",821,null],[11,"query","","",822,null],[11,"query_map","","",822,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",822,null],[11,"compute","","",822,null],[11,"handle_cycle_error","","",822,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",822,null],[11,"query","","",823,null],[11,"query_map","","",823,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",823,null],[11,"compute","","",823,null],[11,"handle_cycle_error","","",823,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",823,null],[11,"query","","",824,null],[11,"query_map","","",824,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",824,null],[11,"compute","","",824,null],[11,"handle_cycle_error","","",824,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",824,null],[11,"query","","",825,null],[11,"query_map","","",825,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",825,null],[11,"compute","","",825,null],[11,"handle_cycle_error","","",825,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",825,null],[11,"query","","",826,null],[11,"query_map","","",826,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",826,null],[11,"compute","","",826,null],[11,"handle_cycle_error","","",826,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",826,null],[11,"query","","",827,null],[11,"query_map","","",827,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",827,null],[11,"compute","","",827,null],[11,"handle_cycle_error","","",827,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",827,null],[11,"query","","",828,null],[11,"query_map","","",828,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",828,null],[11,"compute","","",828,null],[11,"handle_cycle_error","","",828,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",828,null],[11,"query","","",829,null],[11,"query_map","","",829,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",829,null],[11,"compute","","",829,null],[11,"handle_cycle_error","","",829,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",829,null],[11,"query","","",830,null],[11,"query_map","","",830,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",830,null],[11,"compute","","",830,null],[11,"handle_cycle_error","","",830,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",830,null],[11,"query","","",831,null],[11,"query_map","","",831,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",831,null],[11,"compute","","",831,null],[11,"handle_cycle_error","","",831,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",831,null],[11,"query","","",832,null],[11,"query_map","","",832,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",832,null],[11,"compute","","",832,null],[11,"handle_cycle_error","","",832,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",832,null],[11,"query","","",833,null],[11,"query_map","","",833,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",833,null],[11,"compute","","",833,null],[11,"handle_cycle_error","","",833,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",833,null],[11,"query","","",834,null],[11,"query_map","","",834,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",834,null],[11,"compute","","",834,null],[11,"handle_cycle_error","","",834,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",834,null],[11,"query","","",835,null],[11,"query_map","","",835,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",835,null],[11,"compute","","",835,null],[11,"handle_cycle_error","","",835,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",835,null],[11,"query","","",836,null],[11,"query_map","","",836,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",836,null],[11,"compute","","",836,null],[11,"handle_cycle_error","","",836,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",836,null],[11,"query","","",837,null],[11,"query_map","","",837,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",837,null],[11,"compute","","",837,null],[11,"handle_cycle_error","","",837,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",837,null],[11,"query","","",838,null],[11,"query_map","","",838,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",838,null],[11,"compute","","",838,null],[11,"handle_cycle_error","","",838,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",838,null],[11,"query","","",839,null],[11,"query_map","","",839,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",839,null],[11,"compute","","",839,null],[11,"handle_cycle_error","","",839,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",839,null],[11,"query","","",840,null],[11,"query_map","","",840,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",840,null],[11,"compute","","",840,null],[11,"handle_cycle_error","","",840,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",840,null],[11,"query","","",841,null],[11,"query_map","","",841,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",841,null],[11,"compute","","",841,null],[11,"handle_cycle_error","","",841,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",841,null],[11,"query","","",842,null],[11,"query_map","","",842,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",842,null],[11,"compute","","",842,null],[11,"handle_cycle_error","","",842,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",842,null],[11,"query","","",843,null],[11,"query_map","","",843,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",843,null],[11,"compute","","",843,null],[11,"handle_cycle_error","","",843,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",843,null],[11,"query","","",844,null],[11,"query_map","","",844,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",844,null],[11,"compute","","",844,null],[11,"handle_cycle_error","","",844,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",844,null],[11,"query","","",845,null],[11,"query_map","","",845,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",845,null],[11,"compute","","",845,null],[11,"handle_cycle_error","","",845,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",845,null],[11,"query","","",846,null],[11,"query_map","","",846,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",846,null],[11,"compute","","",846,null],[11,"handle_cycle_error","","",846,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",846,null],[11,"query","","",847,null],[11,"query_map","","",847,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",847,null],[11,"compute","","",847,null],[11,"handle_cycle_error","","",847,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",847,null],[11,"query","","",848,null],[11,"query_map","","",848,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",848,null],[11,"compute","","",848,null],[11,"handle_cycle_error","","",848,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",848,null],[11,"query","","",849,null],[11,"query_map","","",849,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",849,null],[11,"compute","","",849,null],[11,"handle_cycle_error","","",849,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",849,null],[11,"query","","",850,null],[11,"query_map","","",850,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",850,null],[11,"compute","","",850,null],[11,"handle_cycle_error","","",850,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",850,null],[11,"query","","",851,null],[11,"query_map","","",851,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",851,null],[11,"compute","","",851,null],[11,"handle_cycle_error","","",851,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",851,null],[11,"query","","",852,null],[11,"query_map","","",852,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",852,null],[11,"compute","","",852,null],[11,"handle_cycle_error","","",852,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",852,null],[11,"query","","",853,null],[11,"query_map","","",853,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",853,null],[11,"compute","","",853,null],[11,"handle_cycle_error","","",853,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",853,null],[11,"query","","",854,null],[11,"query_map","","",854,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",854,null],[11,"compute","","",854,null],[11,"handle_cycle_error","","",854,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",854,null],[11,"query","","",855,null],[11,"query_map","","",855,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",855,null],[11,"compute","","",855,null],[11,"handle_cycle_error","","",855,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",855,null],[11,"query","","",856,null],[11,"query_map","","",856,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",856,null],[11,"compute","","",856,null],[11,"handle_cycle_error","","",856,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",856,null],[11,"query","","",857,null],[11,"query_map","","",857,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",857,null],[11,"compute","","",857,null],[11,"handle_cycle_error","","",857,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",857,null],[11,"query","","",858,null],[11,"query_map","","",858,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",858,null],[11,"compute","","",858,null],[11,"handle_cycle_error","","",858,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",858,null],[11,"query","","",859,null],[11,"query_map","","",859,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",859,null],[11,"compute","","",859,null],[11,"handle_cycle_error","","",859,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",859,null],[11,"query","","",860,null],[11,"query_map","","",860,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",860,null],[11,"compute","","",860,null],[11,"handle_cycle_error","","",860,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",860,null],[11,"query","","",861,null],[11,"query_map","","",861,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",861,null],[11,"compute","","",861,null],[11,"handle_cycle_error","","",861,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",861,null],[11,"query","","",862,null],[11,"query_map","","",862,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",862,null],[11,"compute","","",862,null],[11,"handle_cycle_error","","",862,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",862,null],[11,"query","","",863,null],[11,"query_map","","",863,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",863,null],[11,"compute","","",863,null],[11,"handle_cycle_error","","",863,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",863,null],[11,"query","","",864,null],[11,"query_map","","",864,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",864,null],[11,"compute","","",864,null],[11,"handle_cycle_error","","",864,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",864,null],[11,"query","","",865,null],[11,"query_map","","",865,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",865,null],[11,"compute","","",865,null],[11,"handle_cycle_error","","",865,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",865,null],[11,"query","","",866,null],[11,"query_map","","",866,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",866,null],[11,"compute","","",866,null],[11,"handle_cycle_error","","",866,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",866,null],[11,"query","","",867,null],[11,"query_map","","",867,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",867,null],[11,"compute","","",867,null],[11,"handle_cycle_error","","",867,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",867,null],[11,"query","","",868,null],[11,"query_map","","",868,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",868,null],[11,"compute","","",868,null],[11,"handle_cycle_error","","",868,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",868,null],[11,"query","","",869,null],[11,"query_map","","",869,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",869,null],[11,"compute","","",869,null],[11,"handle_cycle_error","","",869,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",869,null],[11,"query","","",870,null],[11,"query_map","","",870,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",870,null],[11,"compute","","",870,null],[11,"handle_cycle_error","","",870,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",870,null],[11,"query","","",871,null],[11,"query_map","","",871,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",871,null],[11,"compute","","",871,null],[11,"handle_cycle_error","","",871,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",871,null],[11,"query","","",872,null],[11,"query_map","","",872,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",872,null],[11,"compute","","",872,null],[11,"handle_cycle_error","","",872,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",872,null],[11,"query","","",873,null],[11,"query_map","","",873,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",873,null],[11,"compute","","",873,null],[11,"handle_cycle_error","","",873,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",873,null],[11,"query","","",874,null],[11,"query_map","","",874,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",874,null],[11,"compute","","",874,null],[11,"handle_cycle_error","","",874,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",874,null],[11,"query","","",875,null],[11,"query_map","","",875,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",875,null],[11,"compute","","",875,null],[11,"handle_cycle_error","","",875,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",875,null],[11,"query","","",876,null],[11,"query_map","","",876,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",876,null],[11,"compute","","",876,null],[11,"handle_cycle_error","","",876,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",876,null],[11,"query","","",877,null],[11,"query_map","","",877,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",877,null],[11,"compute","","",877,null],[11,"handle_cycle_error","","",877,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",877,null],[11,"query","","",878,null],[11,"query_map","","",878,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",878,null],[11,"compute","","",878,null],[11,"handle_cycle_error","","",878,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",878,null],[11,"query","","",879,null],[11,"query_map","","",879,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",879,null],[11,"compute","","",879,null],[11,"handle_cycle_error","","",879,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",879,null],[11,"query","","",880,null],[11,"query_map","","",880,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",880,null],[11,"compute","","",880,null],[11,"handle_cycle_error","","",880,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",880,null],[11,"query","","",881,null],[11,"query_map","","",881,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",881,null],[11,"compute","","",881,null],[11,"handle_cycle_error","","",881,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",881,null],[11,"query","","",882,null],[11,"query_map","","",882,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",882,null],[11,"compute","","",882,null],[11,"handle_cycle_error","","",882,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",882,null],[11,"query","","",883,null],[11,"query_map","","",883,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",883,null],[11,"compute","","",883,null],[11,"handle_cycle_error","","",883,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",883,null],[11,"query","","",884,null],[11,"query_map","","",884,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",884,null],[11,"compute","","",884,null],[11,"handle_cycle_error","","",884,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",884,null],[11,"query","","",885,null],[11,"query_map","","",885,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",885,null],[11,"compute","","",885,null],[11,"handle_cycle_error","","",885,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",885,null],[11,"query","","",886,null],[11,"query_map","","",886,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",886,null],[11,"compute","","",886,null],[11,"handle_cycle_error","","",886,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",886,null],[11,"query","","",887,null],[11,"query_map","","",887,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",887,null],[11,"compute","","",887,null],[11,"handle_cycle_error","","",887,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",887,null],[11,"query","","",888,null],[11,"query_map","","",888,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",888,null],[11,"compute","","",888,null],[11,"handle_cycle_error","","",888,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",888,null],[11,"query","","",889,null],[11,"query_map","","",889,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",889,null],[11,"compute","","",889,null],[11,"handle_cycle_error","","",889,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",889,null],[11,"query","","",890,null],[11,"query_map","","",890,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",890,null],[11,"compute","","",890,null],[11,"handle_cycle_error","","",890,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",890,null],[11,"query","","",891,null],[11,"query_map","","",891,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",891,null],[11,"compute","","",891,null],[11,"handle_cycle_error","","",891,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",891,null],[11,"query","","",892,null],[11,"query_map","","",892,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",892,null],[11,"compute","","",892,null],[11,"handle_cycle_error","","",892,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",892,null],[11,"query","","",893,null],[11,"query_map","","",893,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",893,null],[11,"compute","","",893,null],[11,"handle_cycle_error","","",893,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",893,null],[11,"query","","",894,null],[11,"query_map","","",894,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",894,null],[11,"compute","","",894,null],[11,"handle_cycle_error","","",894,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",894,null],[11,"query","","",895,null],[11,"query_map","","",895,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",895,null],[11,"compute","","",895,null],[11,"handle_cycle_error","","",895,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",895,null],[11,"query","","",896,null],[11,"query_map","","",896,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",896,null],[11,"compute","","",896,null],[11,"handle_cycle_error","","",896,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",896,null],[11,"query","","",897,null],[11,"query_map","","",897,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",897,null],[11,"compute","","",897,null],[11,"handle_cycle_error","","",897,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",897,null],[11,"query","","",898,null],[11,"query_map","","",898,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",898,null],[11,"compute","","",898,null],[11,"handle_cycle_error","","",898,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",898,null],[11,"query","","",899,null],[11,"query_map","","",899,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",899,null],[11,"compute","","",899,null],[11,"handle_cycle_error","","",899,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",899,null],[11,"query","","",900,null],[11,"query_map","","",900,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",900,null],[11,"compute","","",900,null],[11,"handle_cycle_error","","",900,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",900,null],[11,"query","","",901,null],[11,"query_map","","",901,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",901,null],[11,"compute","","",901,null],[11,"handle_cycle_error","","",901,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",901,null],[11,"query","","",902,null],[11,"query_map","","",902,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",902,null],[11,"compute","","",902,null],[11,"handle_cycle_error","","",902,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",902,null],[11,"query","","",903,null],[11,"query_map","","",903,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",903,null],[11,"compute","","",903,null],[11,"handle_cycle_error","","",903,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",903,null],[11,"query","","",904,null],[11,"query_map","","",904,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",904,null],[11,"compute","","",904,null],[11,"handle_cycle_error","","",904,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",904,null],[11,"query","","",905,null],[11,"query_map","","",905,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",905,null],[11,"compute","","",905,null],[11,"handle_cycle_error","","",905,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",905,null],[11,"query","","",906,null],[11,"query_map","","",906,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",906,null],[11,"compute","","",906,null],[11,"handle_cycle_error","","",906,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",906,null],[11,"query","","",907,null],[11,"query_map","","",907,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",907,null],[11,"compute","","",907,null],[11,"handle_cycle_error","","",907,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",907,null],[11,"query","","",908,null],[11,"query_map","","",908,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",908,null],[11,"compute","","",908,null],[11,"handle_cycle_error","","",908,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",908,null],[11,"query","","",909,null],[11,"query_map","","",909,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",909,null],[11,"compute","","",909,null],[11,"handle_cycle_error","","",909,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",909,null],[11,"query","","",910,null],[11,"query_map","","",910,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",910,null],[11,"compute","","",910,null],[11,"handle_cycle_error","","",910,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",910,null],[11,"query","","",911,null],[11,"query_map","","",911,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",911,null],[11,"compute","","",911,null],[11,"handle_cycle_error","","",911,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",911,null],[11,"query","","",912,null],[11,"query_map","","",912,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",912,null],[11,"compute","","",912,null],[11,"handle_cycle_error","","",912,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",912,null],[11,"query","","",913,null],[11,"query_map","","",913,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",913,null],[11,"compute","","",913,null],[11,"handle_cycle_error","","",913,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",913,null],[11,"query","","",914,null],[11,"query_map","","",914,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",914,null],[11,"compute","","",914,null],[11,"handle_cycle_error","","",914,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",914,null],[11,"query","","",915,null],[11,"query_map","","",915,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",915,null],[11,"compute","","",915,null],[11,"handle_cycle_error","","",915,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",915,null],[11,"query","","",916,null],[11,"query_map","","",916,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",916,null],[11,"compute","","",916,null],[11,"handle_cycle_error","","",916,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",916,null],[11,"query","","",917,null],[11,"query_map","","",917,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",917,null],[11,"compute","","",917,null],[11,"handle_cycle_error","","",917,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",917,null],[11,"query","","",918,null],[11,"query_map","","",918,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",918,null],[11,"compute","","",918,null],[11,"handle_cycle_error","","",918,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",918,null],[11,"query","","",919,null],[11,"query_map","","",919,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",919,null],[11,"compute","","",919,null],[11,"handle_cycle_error","","",919,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",919,null],[11,"query","","",920,null],[11,"query_map","","",920,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",920,null],[11,"compute","","",920,null],[11,"handle_cycle_error","","",920,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",920,null],[11,"query","","",921,null],[11,"query_map","","",921,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",921,null],[11,"compute","","",921,null],[11,"handle_cycle_error","","",921,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",921,null],[11,"query","","",922,null],[11,"query_map","","",922,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",922,null],[11,"compute","","",922,null],[11,"handle_cycle_error","","",922,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",922,null],[11,"query","","",923,null],[11,"query_map","","",923,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",923,null],[11,"compute","","",923,null],[11,"handle_cycle_error","","",923,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",923,null],[11,"query","","",924,null],[11,"query_map","","",924,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",924,null],[11,"compute","","",924,null],[11,"handle_cycle_error","","",924,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",924,null],[11,"query","","",925,null],[11,"query_map","","",925,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",925,null],[11,"compute","","",925,null],[11,"handle_cycle_error","","",925,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",925,null],[11,"query","","",926,null],[11,"query_map","","",926,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",926,null],[11,"compute","","",926,null],[11,"handle_cycle_error","","",926,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",926,null],[11,"query","","",927,null],[11,"query_map","","",927,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",927,null],[11,"compute","","",927,null],[11,"handle_cycle_error","","",927,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",927,null],[11,"query","","",928,null],[11,"query_map","","",928,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",928,null],[11,"compute","","",928,null],[11,"handle_cycle_error","","",928,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",928,null],[11,"query","","",929,null],[11,"query_map","","",929,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",929,null],[11,"compute","","",929,null],[11,"handle_cycle_error","","",929,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",929,null],[11,"query","","",930,null],[11,"query_map","","",930,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",930,null],[11,"compute","","",930,null],[11,"handle_cycle_error","","",930,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",930,null],[11,"query","","",931,null],[11,"query_map","","",931,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",931,null],[11,"compute","","",931,null],[11,"handle_cycle_error","","",931,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",931,null],[11,"query","","",932,null],[11,"query_map","","",932,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",932,null],[11,"compute","","",932,null],[11,"handle_cycle_error","","",932,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",932,null],[11,"query","","",933,null],[11,"query_map","","",933,{"inputs":[{"name":"tyctxt"}],"output":{"name":"lock"}}],[11,"to_dep_node","","",933,null],[11,"compute","","",933,null],[11,"handle_cycle_error","","",933,null],[11,"ensure","","Ensure that either this query has all green inputs or been executed. Executing query::ensure(D) is considered a read of the dep-node D.",933,null],[11,"clone","rustc::ty::maps","",760,{"inputs":[{"name":"self"}],"output":{"name":"tyctxtat"}}],[11,"deref","","",760,null],[11,"at","rustc::ty","Return a transparent wrapper for `TyCtxt` which uses `span` as the location of queries performed through it.",655,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"tyctxtat"}}],[11,"type_of","","Records the type of every item.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"ty"}}],[11,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics and predicates.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"generics"}}],[11,"predicates_of","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"explicit_predicates_of","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",655,null],[11,"trait_def","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"traitdef"}}],[11,"adt_def","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"adtdef"}}],[11,"adt_destructor","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["destructor"],"name":"option"}}],[11,"adt_sized_constraint","","",655,null],[11,"adt_dtorck_constraint","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["dtorckconstraint","nosolution"],"name":"result"}}],[11,"is_const_fn","","True if this is a const fn",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratevariancesmap"],"name":"lrc"}}],[11,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"inferred_outlives_of","","Maps from def-id of a type to its (inferred) outlives.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratepredicatesmap"],"name":"lrc"}}],[11,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"associateditem"}}],[11,"impl_trait_ref","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["traitref"],"name":"option"}}],[11,"impl_polarity","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"implpolarity"}}],[11,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidset"],"name":"lrc"}}],[11,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",655,null],[11,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"steal"}}],[11,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"steal"}}],[11,"mir_validated","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"steal"}}],[11,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for trans. This is also the only query that can fetch non-local MIR, at present.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"mir"}}],[11,"unsafety_check_result","","The result of unsafety-checking this def-id.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"unsafetycheckresult"}}],[11,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",655,null],[11,"fn_sig","","The signature of functions and closures.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"polyfnsig"}}],[11,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"coerceunsizedinfo"}}],[11,"typeck_item_bodies","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"compileresult"}}],[11,"typeck_tables_of","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"typecktables"}}],[11,"used_trait_imports","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defidset"],"name":"lrc"}}],[11,"has_typeck_tables","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"coherent_trait","","",655,null],[11,"borrowck","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["borrowcheckresult"],"name":"lrc"}}],[11,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"borrowcheckresult"}}],[11,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"crateinherentimpls"}}],[11,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",655,null],[11,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",655,{"inputs":[{"name":"self"},{"generics":["globalid"],"name":"paramenvand"}],"output":{"name":"evalresult"}}],[11,"check_match","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["errorreported"],"name":"result"}}],[11,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["accesslevels"],"name":"lrc"}}],[11,"reachable_set","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"reachableset"}}],[11,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["scopetree"],"name":"lrc"}}],[11,"mir_shims","","",655,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"mir"}}],[11,"def_symbol_name","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"symbolname"}}],[11,"symbol_name","","",655,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"symbolname"}}],[11,"describe_def","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["def"],"name":"option"}}],[11,"def_span","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"span"}}],[11,"lookup_stability","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["stability"],"name":"option"}}],[11,"lookup_deprecation_entry","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["deprecationentry"],"name":"option"}}],[11,"item_attrs","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"lrc"}}],[11,"trans_fn_attrs","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"transfnattrs"}}],[11,"fn_arg_names","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["name"],"name":"vec"}}],[11,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"string"}}],[11,"impl_parent","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"trait_of_item","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"const_is_rvalue_promotable_to_static","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"rvalue_promotable_map","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["itemlocalset"],"name":"lrc"}}],[11,"is_mir_available","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"vtable_methods","","",655,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"trans_fulfill_obligation","","",655,null],[11,"trait_impls_of","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["traitimpls"],"name":"lrc"}}],[11,"specialization_graph_of","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["graph"],"name":"lrc"}}],[11,"is_object_safe","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"param_env","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"paramenv"}}],[11,"is_copy_raw","","",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"is_sized_raw","","",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"is_freeze_raw","","",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"needs_drop_raw","","",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"layout_raw","","",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"generics":["layoutdetails","layouterror"],"name":"result"}}],[11,"dylib_dependency_formats","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"is_panic_runtime","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"is_compiler_builtins","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"has_global_allocator","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"is_sanitizer_runtime","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"is_profiler_runtime","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"panic_strategy","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"panicstrategy"}}],[11,"is_no_builtins","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"extern_crate","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["option"],"name":"lrc"}}],[11,"specializes","","",655,null],[11,"in_scope_traits_map","","",655,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"module_exports","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"lint_levels","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["lintlevelmap"],"name":"lrc"}}],[11,"impl_defaultness","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defaultness"}}],[11,"check_item_well_formed","","",655,null],[11,"check_trait_item_well_formed","","",655,null],[11,"check_impl_item_well_formed","","",655,null],[11,"reachable_non_generics","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidmap"],"name":"lrc"}}],[11,"is_reachable_non_generic","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_unreachable_local_definition","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"upstream_monomorphizations","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidmap"],"name":"lrc"}}],[11,"upstream_monomorphizations_for","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"native_libraries","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"foreign_modules","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"plugin_registrar_fn","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defid"],"name":"option"}}],[11,"derive_registrar_fn","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defid"],"name":"option"}}],[11,"crate_disambiguator","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratedisambiguator"}}],[11,"crate_hash","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"svh"}}],[11,"original_crate_name","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[11,"extra_filename","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"implementations_of_trait","","",655,null],[11,"all_trait_implementations","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"dllimport_foreign_items","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["fxhashset"],"name":"lrc"}}],[11,"is_dllimport_foreign_item","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_statically_included_foreign_item","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"native_library_kind","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["nativelibrarykind"],"name":"option"}}],[11,"link_args","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"resolve_lifetimes","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["resolvelifetimes"],"name":"lrc"}}],[11,"named_region_map","","",655,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"is_late_bound_map","","",655,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"object_lifetime_defaults_map","","",655,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"visibility","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"visibility"}}],[11,"dep_kind","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"depkind"}}],[11,"crate_name","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[11,"item_children","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"extern_mod_stmt_cnum","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["cratenum"],"name":"option"}}],[11,"get_lang_items","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["languageitems"],"name":"lrc"}}],[11,"defined_lang_items","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"missing_lang_items","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"visible_parent_map","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidmap"],"name":"lrc"}}],[11,"missing_extern_crate_item","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"used_crate_source","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratesource"],"name":"lrc"}}],[11,"postorder_cnums","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"freevars","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"maybe_unused_trait_import","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"maybe_unused_extern_crates","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"stability_index","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["index"],"name":"lrc"}}],[11,"all_crate_nums","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"exported_symbols","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"arc"}}],[11,"collect_and_partition_translation_items","","",655,null],[11,"is_translated_item","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"codegen_unit","","",655,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"generics":["codegenunit"],"name":"arc"}}],[11,"compile_codegen_unit","","",655,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"stats"}}],[11,"output_filenames","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["outputfilenames"],"name":"arc"}}],[11,"erase_regions_ty","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",655,{"inputs":[{"name":"self"},{"name":"canonicalprojectiongoal"}],"output":{"generics":["lrc","nosolution"],"name":"result"}}],[11,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",655,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"ty"}}],[11,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",655,{"inputs":[{"name":"self"},{"name":"canonicaltygoal"}],"output":{"generics":["lrc","nosolution"],"name":"result"}}],[11,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",655,{"inputs":[{"name":"self"},{"name":"canonicalpredicategoal"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"substitute_normalize_and_test_predicates","","",655,null],[11,"target_features_whitelist","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["fxhashmap"],"name":"lrc"}}],[11,"instance_def_size_estimate","","",655,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"usize"}}],[11,"features_query","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["features"],"name":"lrc"}}],[11,"program_clauses_for","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"clauses"}}],[11,"program_clauses_for_env","","",655,{"inputs":[{"name":"self"},{"name":"paramenv"}],"output":{"name":"clauses"}}],[11,"wasm_custom_sections","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"wasm_import_module_map","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["fxhashmap"],"name":"lrc"}}],[11,"type_of","rustc::ty::maps","Records the type of every item.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"ty"}}],[11,"generics_of","","Maps from the def-id of an item (trait/struct/enum/fn) to its associated generics and predicates.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"generics"}}],[11,"predicates_of","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"explicit_predicates_of","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"super_predicates_of","","Maps from the def-id of a trait to the list of super-predicates. This is a subset of the full list of predicates. We store these in a separate map because we must evaluate them even during type conversion, often before the full predicates are available (note that supertraits have additional acyclicity requirements).",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"type_param_predicates","","To avoid cycles within the predicates of a single item we compute per-type-parameter predicates for resolving `T::AssocTy`.",760,null],[11,"trait_def","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"traitdef"}}],[11,"adt_def","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"adtdef"}}],[11,"adt_destructor","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["destructor"],"name":"option"}}],[11,"adt_sized_constraint","","",760,null],[11,"adt_dtorck_constraint","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["dtorckconstraint","nosolution"],"name":"result"}}],[11,"is_const_fn","","True if this is a const fn",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_foreign_item","","True if this is a foreign item (i.e., linked via `extern { ... }`).",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"crate_variances","","Get a map with the variance of every item; use `item_variance` instead.",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratevariancesmap"],"name":"lrc"}}],[11,"variances_of","","Maps from def-id of a type or region parameter to its (inferred) variance.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"inferred_outlives_of","","Maps from def-id of a type to its (inferred) outlives.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"inferred_outlives_crate","","Maps from def-id of a type to its (inferred) outlives.",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratepredicatesmap"],"name":"lrc"}}],[11,"associated_item_def_ids","","Maps from an impl/trait def-id to a list of the def-ids of its items",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"associated_item","","Maps from a trait item to the trait item \"descriptor\"",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"associateditem"}}],[11,"impl_trait_ref","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["traitref"],"name":"option"}}],[11,"impl_polarity","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"implpolarity"}}],[11,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls. Contains implementations of methods that are inherent to a type. Methods in these implementations don't need to be exported.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"mir_keys","","Set of all the def-ids in this crate that have MIR associated with them. This includes all the body owners, but also things like struct constructors.",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidset"],"name":"lrc"}}],[11,"mir_const_qualif","","Maps DefId's that have an associated Mir to the result of the MIR qualify_consts pass. The actual meaning of the value isn't known except to the pass itself.",760,null],[11,"mir_built","","Fetch the MIR for a given def-id right after it's built - this includes unreachable code.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"steal"}}],[11,"mir_const","","Fetch the MIR for a given def-id up till the point where it is ready for const evaluation.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"steal"}}],[11,"mir_validated","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"steal"}}],[11,"optimized_mir","","MIR after our optimization passes have run. This is MIR that is ready for trans. This is also the only query that can fetch non-local MIR, at present.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"mir"}}],[11,"unsafety_check_result","","The result of unsafety-checking this def-id.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"unsafetycheckresult"}}],[11,"unsafe_derive_on_repr_packed","","HACK: when evaluated, this reports a \"unsafe derive on repr(packed)\" error",760,null],[11,"fn_sig","","The signature of functions and closures.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"polyfnsig"}}],[11,"coerce_unsized_info","","Caches CoerceUnsized kinds for impls on custom types.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"coerceunsizedinfo"}}],[11,"typeck_item_bodies","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"compileresult"}}],[11,"typeck_tables_of","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"typecktables"}}],[11,"used_trait_imports","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defidset"],"name":"lrc"}}],[11,"has_typeck_tables","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"coherent_trait","","",760,null],[11,"borrowck","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["borrowcheckresult"],"name":"lrc"}}],[11,"mir_borrowck","","Borrow checks the function body. If this is a closure, returns additional requirements that the closure's creator must verify.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"borrowcheckresult"}}],[11,"crate_inherent_impls","","Gets a complete map from all types to their inherent impls. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"crateinherentimpls"}}],[11,"crate_inherent_impls_overlap_check","","Checks all types in the krate for overlap in their inherent impls. Reports errors. Not meant to be used directly outside of coherence. (Defined only for LOCAL_CRATE)",760,null],[11,"const_eval","","Results of evaluating const items or constants embedded in other items (such as enum variant explicit discriminants).",760,{"inputs":[{"name":"self"},{"generics":["globalid"],"name":"paramenvand"}],"output":{"name":"evalresult"}}],[11,"check_match","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["errorreported"],"name":"result"}}],[11,"privacy_access_levels","","Performs the privacy check and computes \"access levels\".",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["accesslevels"],"name":"lrc"}}],[11,"reachable_set","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"reachableset"}}],[11,"region_scope_tree","","Per-body `region::ScopeTree`. The `DefId` should be the owner-def-id for the body; in the case of closures, this will be redirected to the enclosing function.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["scopetree"],"name":"lrc"}}],[11,"mir_shims","","",760,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"mir"}}],[11,"def_symbol_name","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"symbolname"}}],[11,"symbol_name","","",760,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"symbolname"}}],[11,"describe_def","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["def"],"name":"option"}}],[11,"def_span","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"span"}}],[11,"lookup_stability","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["stability"],"name":"option"}}],[11,"lookup_deprecation_entry","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["deprecationentry"],"name":"option"}}],[11,"item_attrs","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"lrc"}}],[11,"trans_fn_attrs","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"transfnattrs"}}],[11,"fn_arg_names","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["name"],"name":"vec"}}],[11,"rendered_const","","Gets the rendered value of the specified constant or associated constant. Used by rustdoc.",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"string"}}],[11,"impl_parent","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"trait_of_item","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"const_is_rvalue_promotable_to_static","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"rvalue_promotable_map","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["itemlocalset"],"name":"lrc"}}],[11,"is_mir_available","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"vtable_methods","","",760,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"trans_fulfill_obligation","","",760,null],[11,"trait_impls_of","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["traitimpls"],"name":"lrc"}}],[11,"specialization_graph_of","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["graph"],"name":"lrc"}}],[11,"is_object_safe","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"param_env","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"paramenv"}}],[11,"is_copy_raw","","",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"is_sized_raw","","",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"is_freeze_raw","","",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"needs_drop_raw","","",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"layout_raw","","",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"generics":["layoutdetails","layouterror"],"name":"result"}}],[11,"dylib_dependency_formats","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"is_panic_runtime","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"is_compiler_builtins","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"has_global_allocator","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"is_sanitizer_runtime","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"is_profiler_runtime","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"panic_strategy","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"panicstrategy"}}],[11,"is_no_builtins","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"extern_crate","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["option"],"name":"lrc"}}],[11,"specializes","","",760,null],[11,"in_scope_traits_map","","",760,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"module_exports","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"lint_levels","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["lintlevelmap"],"name":"lrc"}}],[11,"impl_defaultness","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defaultness"}}],[11,"check_item_well_formed","","",760,null],[11,"check_trait_item_well_formed","","",760,null],[11,"check_impl_item_well_formed","","",760,null],[11,"reachable_non_generics","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidmap"],"name":"lrc"}}],[11,"is_reachable_non_generic","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_unreachable_local_definition","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"upstream_monomorphizations","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidmap"],"name":"lrc"}}],[11,"upstream_monomorphizations_for","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"native_libraries","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"foreign_modules","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"plugin_registrar_fn","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defid"],"name":"option"}}],[11,"derive_registrar_fn","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defid"],"name":"option"}}],[11,"crate_disambiguator","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratedisambiguator"}}],[11,"crate_hash","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"svh"}}],[11,"original_crate_name","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[11,"extra_filename","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"implementations_of_trait","","",760,null],[11,"all_trait_implementations","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"dllimport_foreign_items","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["fxhashset"],"name":"lrc"}}],[11,"is_dllimport_foreign_item","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"is_statically_included_foreign_item","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"native_library_kind","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["nativelibrarykind"],"name":"option"}}],[11,"link_args","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"resolve_lifetimes","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["resolvelifetimes"],"name":"lrc"}}],[11,"named_region_map","","",760,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"is_late_bound_map","","",760,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"object_lifetime_defaults_map","","",760,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"visibility","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"visibility"}}],[11,"dep_kind","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"depkind"}}],[11,"crate_name","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[11,"item_children","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"extern_mod_stmt_cnum","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["cratenum"],"name":"option"}}],[11,"get_lang_items","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["languageitems"],"name":"lrc"}}],[11,"defined_lang_items","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"missing_lang_items","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"visible_parent_map","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defidmap"],"name":"lrc"}}],[11,"missing_extern_crate_item","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"bool"}}],[11,"used_crate_source","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratesource"],"name":"lrc"}}],[11,"postorder_cnums","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"freevars","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"maybe_unused_trait_import","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"maybe_unused_extern_crates","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"stability_index","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["index"],"name":"lrc"}}],[11,"all_crate_nums","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"all_traits","","A vector of every trait accessible in the whole crate (i.e. including those from subcrates). This is used only for error reporting.",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"exported_symbols","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"arc"}}],[11,"collect_and_partition_translation_items","","",760,null],[11,"is_translated_item","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"codegen_unit","","",760,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"generics":["codegenunit"],"name":"arc"}}],[11,"compile_codegen_unit","","",760,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"stats"}}],[11,"output_filenames","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["outputfilenames"],"name":"arc"}}],[11,"erase_regions_ty","","",760,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"normalize_projection_ty","","Do not call this query directly: invoke `normalize` instead.",760,{"inputs":[{"name":"self"},{"name":"canonicalprojectiongoal"}],"output":{"generics":["lrc","nosolution"],"name":"result"}}],[11,"normalize_ty_after_erasing_regions","","Do not call this query directly: invoke `normalize_erasing_regions` instead.",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"ty"}}],[11,"dropck_outlives","","Do not call this query directly: invoke `infcx.at().dropck_outlives()` instead.",760,{"inputs":[{"name":"self"},{"name":"canonicaltygoal"}],"output":{"generics":["lrc","nosolution"],"name":"result"}}],[11,"evaluate_obligation","","Do not call this query directly: invoke `infcx.predicate_may_hold()` or `infcx.predicate_must_hold()` instead.",760,{"inputs":[{"name":"self"},{"name":"canonicalpredicategoal"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[11,"substitute_normalize_and_test_predicates","","",760,null],[11,"target_features_whitelist","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["fxhashmap"],"name":"lrc"}}],[11,"instance_def_size_estimate","","",760,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"usize"}}],[11,"features_query","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["features"],"name":"lrc"}}],[11,"program_clauses_for","","",760,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"clauses"}}],[11,"program_clauses_for_env","","",760,{"inputs":[{"name":"self"},{"name":"paramenv"}],"output":{"name":"clauses"}}],[11,"wasm_custom_sections","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"wasm_import_module_map","","",760,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["fxhashmap"],"name":"lrc"}}],[11,"default","","",761,{"inputs":[],"output":{"name":"self"}}],[11,"clone","","",761,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[0,"outlives","rustc::ty","",null,null],[4,"Component","rustc::ty::outlives","",null,null],[13,"Region","","",934,null],[13,"Param","","",934,null],[13,"UnresolvedInferenceVariable","","",934,null],[13,"Projection","","",934,null],[13,"EscapingProjection","","",934,null],[5,"push_region_constraints","","",null,{"inputs":[{"name":"vec"},{"generics":["region"],"name":"vec"}],"output":null}],[11,"fmt","","",934,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"outlives_components","rustc::ty","Returns all the things that must outlive `'a` for the condition `ty0: 'a` to hold. Note that `ty0` must be a fully resolved type.",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["component"],"name":"vec"}}],[11,"compute_components","","",655,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"vec"}],"output":null}],[11,"capture_components","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["component"],"name":"vec"}}],[0,"relate","","Generalized type relating mechanism. A type relation R relates a pair of values (A, B). A and B are usually types or regions but can be other things. Examples of type relations are subtyping, type equality, etc.",null,null],[3,"GeneratorWitness","rustc::ty::relate","",null,null],[12,"0","","",935,null],[4,"Cause","","",null,null],[13,"ExistentialRegionBound","","",936,null],[5,"relate_substs","","",null,{"inputs":[{"name":"r"},{"generics":["vec"],"name":"option"},{"name":"substs"},{"name":"substs"}],"output":{"generics":["substs"],"name":"relateresult"}}],[5,"super_relate_tys","","The main \"type relation\" routine. Note that this does not handle inference artifacts, so you should filter those out before calling it.",null,{"inputs":[{"name":"r"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[5,"expected_found","","",null,{"inputs":[{"name":"r"},{"name":"t"},{"name":"t"}],"output":{"name":"expectedfound"}}],[5,"expected_found_bool","","",null,{"inputs":[{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"expectedfound"}}],[6,"RelateResult","","",null,null],[8,"TypeRelation","","",null,null],[10,"tcx","","",937,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[10,"tag","","Returns a static string we can use for printouts.",937,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the relation. Just affects error messages.",937,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"with_cause","","",937,{"inputs":[{"name":"self"},{"name":"cause"},{"name":"f"}],"output":{"name":"r"}}],[11,"relate","","Generic relation routine suitable for most anything.",937,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"relate_item_substs","","Relate the two substitutions for the given item. The default is to look up the variance for the item and proceed accordingly.",937,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"},{"name":"substs"}],"output":{"generics":["substs"],"name":"relateresult"}}],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",937,{"inputs":[{"name":"self"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[10,"tys","","",937,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[10,"regions","","",937,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[10,"binders","","",937,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[8,"Relate","","",null,null],[10,"relate","","",938,{"inputs":[{"name":"r"},{"name":"self"},{"name":"self"}],"output":{"name":"relateresult"}}],[11,"clone","","",936,{"inputs":[{"name":"self"}],"output":{"name":"cause"}}],[11,"fmt","","",936,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"relate","rustc::ty","",644,{"inputs":[{"name":"r"},{"name":"typeandmut"},{"name":"typeandmut"}],"output":{"generics":["typeandmut"],"name":"relateresult"}}],[11,"relate","","",638,{"inputs":[{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"generics":["fnsig"],"name":"relateresult"}}],[11,"relate","rustc::hir","",124,{"inputs":[{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"generics":["unsafety"],"name":"relateresult"}}],[11,"relate","rustc::ty","",641,{"inputs":[{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"generics":["projectionty"],"name":"relateresult"}}],[11,"relate","","",647,{"inputs":[{"name":"r"},{"name":"existentialprojection"},{"name":"existentialprojection"}],"output":{"generics":["existentialprojection"],"name":"relateresult"}}],[11,"relate","","",645,{"inputs":[{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"generics":["traitref"],"name":"relateresult"}}],[11,"relate","","",646,{"inputs":[{"name":"r"},{"name":"existentialtraitref"},{"name":"existentialtraitref"}],"output":{"generics":["existentialtraitref"],"name":"relateresult"}}],[11,"fmt","rustc::ty::relate","",935,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",935,{"inputs":[{"name":"self"}],"output":{"name":"generatorwitness"}}],[11,"super_fold_with","","",935,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",935,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"relate","","",935,{"inputs":[{"name":"r"},{"name":"generatorwitness"},{"name":"generatorwitness"}],"output":{"generics":["generatorwitness"],"name":"relateresult"}}],[11,"relate","rustc::ty","",642,{"inputs":[{"name":"r"},{"name":"closuresubsts"},{"name":"closuresubsts"}],"output":{"generics":["closuresubsts"],"name":"relateresult"}}],[11,"relate","","",643,{"inputs":[{"name":"r"},{"name":"generatorinterior"},{"name":"generatorinterior"}],"output":{"generics":["generatorinterior"],"name":"relateresult"}}],[11,"relate","","",635,{"inputs":[{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"generics":["binder"],"name":"relateresult"}}],[0,"steal","","",null,null],[3,"Steal","rustc::ty::steal","The `Steal` struct is intended to used as the value for a query. Specifically, we sometimes have queries (cough MIR cough) where we create a large, complex value that we want to iteratively update (e.g., optimize). We could clone the value for each optimization, but that'd be expensive. And yet we don't just want to mutate it in place, because that would spoil the idea that queries are these pure functions that produce an immutable value (since if you did the query twice, you could observe the mutations). So instead we have the query produce a `&'tcx Steal<Mir<'tcx>>` (to be very specific). Now we can read from this as much as we want (using `borrow()`), but you can also `steal()`. Once you steal, any further attempt to read will panic. Therefore we know that -- assuming no ICE -- nobody is observing the fact that the MIR was updated.",null,null],[12,"value","","",939,null],[11,"new","","",939,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"borrow","","",939,{"inputs":[{"name":"self"}],"output":{"name":"readguard"}}],[11,"steal","","",939,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[0,"subst","rustc::ty","",null,null],[3,"Kind","rustc::ty::subst","An entity in the Rust typesystem, which can be one of several kinds (only types and lifetimes for now). To reduce memory usage, a `Kind` is a interned pointer, with the lowest 2 bits being reserved for a tag to indicate the type (`Ty` or `Region`) it points to.",null,null],[12,"ptr","","",940,null],[12,"marker","","",940,null],[3,"SubstFolder","","",null,null],[12,"tcx","","",941,null],[12,"substs","","",941,null],[12,"span","","",941,null],[12,"root_ty","","",941,null],[12,"ty_stack_depth","","",941,null],[12,"region_binders_passed","","",941,null],[4,"UnpackedKind","","",null,null],[13,"Lifetime","","",942,null],[13,"Type","","",942,null],[6,"Substs","","A substitution mapping type/region parameters to new values.",null,null],[17,"TAG_MASK","","",null,null],[17,"TYPE_TAG","","",null,null],[17,"REGION_TAG","","",null,null],[8,"Subst","","",null,null],[11,"subst","","",943,null],[10,"subst_spanned","","",943,null],[11,"clone","","",940,{"inputs":[{"name":"self"}],"output":{"name":"kind"}}],[11,"eq","","",940,{"inputs":[{"name":"self"},{"name":"kind"}],"output":{"name":"bool"}}],[11,"ne","","",940,{"inputs":[{"name":"self"},{"name":"kind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",940,null],[11,"hash","","",940,null],[11,"fmt","","",942,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pack","","",942,{"inputs":[{"name":"self"}],"output":{"name":"kind"}}],[11,"from","","",940,{"inputs":[{"name":"region"}],"output":{"name":"kind"}}],[11,"from","","",940,{"inputs":[{"name":"ty"}],"output":{"name":"kind"}}],[11,"unpack","","",940,{"inputs":[{"name":"self"}],"output":{"name":"unpackedkind"}}],[11,"fmt","","",940,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",940,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"lift_to_tcx","","",940,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"super_fold_with","","",940,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",940,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"encode","","",940,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",940,{"inputs":[{"name":"d"}],"output":{"generics":["kind"],"name":"result"}}],[11,"identity_for_item","","Creates a Substs that maps each generic parameter to itself.",944,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"substs"}}],[11,"for_item","","Creates a Substs for generic parameter definitions, by calling closures to obtain each region and type. The closures get to observe the Substs as they're being built, which can be used to correctly substitute defaults of type parameters.",944,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"fr"},{"name":"ft"}],"output":{"name":"substs"}}],[11,"extend_to","","",944,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"},{"name":"fr"},{"name":"ft"}],"output":{"name":"substs"}}],[11,"fill_item","","",944,{"inputs":[{"name":"vec"},{"name":"tyctxt"},{"name":"generics"},{"name":"fr"},{"name":"ft"}],"output":null}],[11,"fill_single","","",944,{"inputs":[{"name":"vec"},{"name":"generics"},{"name":"fr"},{"name":"ft"}],"output":null}],[11,"is_noop","","",944,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"types","","",944,null],[11,"regions","","",944,null],[11,"type_at","","",944,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"ty"}}],[11,"region_at","","",944,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"region"}}],[11,"type_for_def","","",944,{"inputs":[{"name":"self"},{"name":"typeparameterdef"}],"output":{"name":"ty"}}],[11,"region_for_def","","",944,{"inputs":[{"name":"self"},{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"rebase_onto","","Transform from substitutions for a child of `source_ancestor` (e.g. a trait or impl) to substitutions for the same child in a different item, with `target_substs` as the base for the target impl/trait, with the source child-specific parameters (e.g. method parameters) on top of that base.",944,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"truncate_to","","",944,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"tcx","","",941,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_binder","","",941,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_region","","",941,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",941,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"ty_for_param","","",941,{"inputs":[{"name":"self"},{"name":"paramty"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"shift_regions_through_binders","","It is sometimes necessary to adjust the debruijn indices during substitution. This occurs when we are substituting a type with escaping regions into a context where we have passed through region binders. That's quite a mouthful. Let's see an example:",941,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"shift_region_through_binders","","",941,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[11,"from_method","rustc::ty","",645,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"erase_self_ty","","",646,{"inputs":[{"name":"tyctxt"},{"name":"traitref"}],"output":{"name":"existentialtraitref"}}],[0,"trait_def","","",null,null],[3,"TraitDef","rustc::ty::trait_def","A trait's definition with type information.",null,null],[12,"def_id","","",945,null],[12,"unsafety","","",945,null],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]` attribute, indicating that it should be used with `Foo()` sugar. This is a temporary thing -- eventually any trait will be usable with the sugar (or without it).",945,null],[12,"has_auto_impl","","",945,null],[12,"def_path_hash","","The ICH of this trait's DefPath, cached here so it doesn't have to be recomputed all the time.",945,null],[3,"TraitImpls","","",null,null],[12,"blanket_impls","","",946,null],[12,"non_blanket_impls","","Impls indexed by their simplified self-type, for fast lookup.",946,null],[5,"trait_impls_of_provider","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["traitimpls"],"name":"lrc"}}],[11,"new","","",945,{"inputs":[{"name":"defid"},{"name":"unsafety"},{"name":"bool"},{"name":"bool"},{"name":"defpathhash"}],"output":{"name":"traitdef"}}],[11,"ancestors","","",945,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"ancestors"}}],[11,"for_each_impl","rustc::ty","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"f"}],"output":null}],[11,"for_each_relevant_impl","","Iterate over every impl that could possibly match the self-type `self_ty`.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"ty"},{"name":"f"}],"output":null}],[11,"hash_stable","rustc::ty::trait_def","",946,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[0,"walk","rustc::ty","An iterator over the type substructure. WARNING: this does not keep track of the region depth.",null,null],[3,"TypeWalker","rustc::ty::walk","",null,null],[12,"stack","","",947,null],[12,"last_subtree","","",947,null],[5,"walk_shallow","","",null,{"inputs":[{"name":"ty"}],"output":{"generics":["typewalkerarray"],"name":"accintoiter"}}],[5,"push_subtypes","","",null,{"inputs":[{"name":"typewalkerstack"},{"name":"ty"}],"output":null}],[5,"push_const","","",null,{"inputs":[{"name":"typewalkerstack"},{"name":"const"}],"output":null}],[6,"TypeWalkerArray","","",null,null],[6,"TypeWalkerStack","","",null,null],[11,"new","","",947,{"inputs":[{"name":"ty"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type returned by `next()`.",947,{"inputs":[{"name":"self"}],"output":null}],[11,"next","","",947,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"option"}}],[0,"wf","rustc::ty","",null,null],[3,"WfPredicates","rustc::ty::wf","",null,null],[12,"infcx","","",948,null],[12,"param_env","","",948,null],[12,"body_id","","",948,null],[12,"span","","",948,null],[12,"out","","",948,null],[4,"Elaborate","","Controls whether we \"elaborate\" supertraits and so forth on the WF predicates. This is a kind of hack to address #43784. The underlying problem in that issue was a trait structure like:",null,null],[13,"All","","",949,null],[13,"None","","",949,null],[5,"obligations","","Returns the set of obligations needed to make `ty` well-formed. If `ty` contains unresolved inference variables, this may include further WF obligations. However, if `ty` IS an unresolved inference variable, returns `None`, because we are not able to make any progress at all. This is to prevent \"livelock\" where we say \"$0 is WF if $0 is WF\".",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"nodeid"},{"name":"ty"},{"name":"span"}],"output":{"generics":["vec"],"name":"option"}}],[5,"trait_obligations","","Returns the obligations that make this trait reference well-formed.  For example, if there is a trait `Set` defined like `trait Set<K:Eq>`, then the trait reference `Foo: Set<Bar>` is WF if `Bar: Eq`.",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"nodeid"},{"name":"traitref"},{"name":"span"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[5,"predicate_obligations","","",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"nodeid"},{"name":"predicate"},{"name":"span"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime bounds that must hold on the elided self type. These are derived from the declarations of `SomeTrait`, `Send`, and friends -- if they declare `trait SomeTrait : 'static`, for example, then `'static` would appear in the list. The hard work is done by `ty::required_region_bounds`, see that for more information.",null,{"inputs":[{"name":"tyctxt"},{"generics":["slice"],"name":"binder"}],"output":{"generics":["region"],"name":"vec"}}],[11,"fmt","","",949,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",949,{"inputs":[{"name":"self"},{"name":"elaborate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",949,null],[11,"clone","","",949,{"inputs":[{"name":"self"}],"output":{"name":"elaborate"}}],[11,"cause","","",948,{"inputs":[{"name":"self"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"normalize","","",948,{"inputs":[{"name":"self"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[11,"compute_trait_ref","","Pushes the obligations required for `trait_ref` to be WF into `self.out`.",948,{"inputs":[{"name":"self"},{"name":"traitref"},{"name":"elaborate"}],"output":null}],[11,"compute_projection","","Pushes the obligations required for `trait_ref::Item` to be WF into `self.out`.",948,{"inputs":[{"name":"self"},{"name":"projectionty"}],"output":null}],[11,"compute_const","","Pushes the obligations required for a constant value to be WF into `self.out`.",948,{"inputs":[{"name":"self"},{"name":"const"}],"output":null}],[11,"require_sized","","",948,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"obligationcausecode"}],"output":null}],[11,"compute","","Push new obligations into `out`. Returns true if it was able to generate all the predicates needed to validate that `ty0` is WF. Returns false if `ty0` is an unresolved type variable, in which case we are not able to simplify at all.",948,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"nominal_obligations","","",948,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[11,"from_object_ty","","",948,{"inputs":[{"name":"self"},{"name":"ty"},{"generics":["slice"],"name":"binder"},{"name":"region"}],"output":null}],[0,"util","rustc::ty","misc. type-system utilities too small to deserve their own file",null,null],[3,"Discr","rustc::ty::util","",null,null],[12,"val","","bit representation of the discriminant, so `-128i8` is `0xFF_u128`",950,null],[12,"ty","","",950,null],[3,"TypeIdHasher","","",null,null],[12,"tcx","","",951,null],[12,"state","","",951,null],[4,"CopyImplementationError","","",null,null],[13,"InfrigingField","","",952,null],[13,"NotAnAdt","","",952,null],[13,"HasDestructor","","",952,null],[4,"Representability","","Describes whether a type is representable. For types that are not representable, 'SelfRecursive' and 'ContainsRecursive' are used to distinguish between types that are recursive with themselves and types that contain a different recursive type. These cases can therefore be treated differently when reporting errors.",null,null],[13,"Representable","","",953,null],[13,"ContainsRecursive","","",953,null],[13,"SelfRecursive","","",953,null],[4,"ExplicitSelf","","",null,null],[13,"ByValue","","",954,null],[13,"ByReference","","",954,null],[13,"ByRawPointer","","",954,null],[13,"ByBox","","",954,null],[13,"Other","","",954,null],[5,"is_copy_raw","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[5,"is_sized_raw","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[5,"is_freeze_raw","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[5,"needs_drop_raw","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"bool"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[8,"IntTypeExt","","",null,null],[10,"to_ty","","",955,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[10,"disr_incr","","",955,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["discr"],"name":"option"}],"output":{"generics":["discr"],"name":"option"}}],[10,"initial_discriminant","","",955,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"discr"}}],[11,"clone","","",950,{"inputs":[{"name":"self"}],"output":{"name":"discr"}}],[11,"fmt","","",950,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",950,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"wrap_incr","","Adds 1 to the value and wraps around if the maximum for the type is reached",950,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"checked_add","","",950,null],[11,"clone","","",952,{"inputs":[{"name":"self"}],"output":{"name":"copyimplementationerror"}}],[11,"clone","","",953,{"inputs":[{"name":"self"}],"output":{"name":"representability"}}],[11,"partial_cmp","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"assert_receiver_is_total_eq","","",953,null],[11,"eq","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",953,{"inputs":[{"name":"self"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"fmt","","",953,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"can_type_implement_copy","rustc::ty","",685,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"},{"name":"span"}],"output":{"generics":["copyimplementationerror"],"name":"result"}}],[11,"type_id_hash","","Creates a hash of the type `Ty` which will be the same no matter what crate context it's calculated within. This is used by the `type_id` intrinsic.",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"u64"}}],[11,"has_error_field","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"struct_tail","","Returns the deeply last field of nested structures, or the same type, if not a structure at all. Corresponds to the only possible unsized field, and its type can be used to determine unsizing strategy.",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only keeps going as long as the two types are instances of the same structure definitions. For `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`, whereas struct_tail produces `T`, and `Trait`, respectively.",655,null],[11,"required_region_bounds","","Given a set of predicates that apply to an object type, returns the region bounds that the (erased) `Self` type must outlive. Precisely because the `Self` type is erased, the parameter `erased_self_ty` must be supplied to indicate what type has been used to represent `Self` in the predicates themselves. This should really be a unique type; `FreshTy(0)` is a popular choice.",655,{"inputs":[{"name":"self"},{"name":"ty"},{"generics":["predicate"],"name":"vec"}],"output":{"generics":["region"],"name":"vec"}}],[11,"calculate_dtor","","Calculate the destructor of a given type.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"fnmut"}],"output":{"generics":["destructor"],"name":"option"}}],[11,"destructor_constraints","","Return the set of types that are required to be alive in order to run the destructor of `def` (see RFCs 769 and 1238).",655,{"inputs":[{"name":"self"},{"name":"adtdef"}],"output":{"generics":["kind"],"name":"vec"}}],[11,"is_closure","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"closure_base_def_id","","Given the `DefId` of a fn or closure, returns the `DefId` of the innermost fn item that the closure is contained within. This is a significant def-id because, when we do type-checking, we type-check this fn item and all of its (transitive) closures together.  Therefore, when we fetch the `typeck_tables_of` the closure, for example, we really wind up fetching the `typeck_tables_of` the enclosing fn item.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"closure_env_ty","","Given the def-id and substs a closure, creates the type of `self` argument that the closure expects. For example, for a `Fn` closure, this would return a reference type `&T` where `T=closure_ty`.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"generics":["binder"],"name":"option"}}],[11,"empty_substs_for_def_id","","Given the def-id of some item that has no type parameters, make a suitable \"empty substs\" for it.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"substs"}}],[11,"is_static","","Return whether the node pointed to by def_id is a static item, and its mutability",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["mutability"],"name":"option"}}],[11,"new","rustc::ty::util","",951,{"inputs":[{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"finish","","",951,{"inputs":[{"name":"self"}],"output":{"name":"w"}}],[11,"hash","","",951,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"hash_discriminant_u8","","",951,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"def_id","","",951,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"visit_ty","","",951,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"visit_region","","",951,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"visit_binder","","",951,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"moves_by_default","rustc::ty","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"paramenv"},{"name":"span"}],"output":{"name":"bool"}}],[11,"is_sized","","",668,{"inputs":[{"name":"self"},{"name":"tyctxtat"},{"name":"paramenv"}],"output":{"name":"bool"}}],[11,"is_freeze","","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"paramenv"},{"name":"span"}],"output":{"name":"bool"}}],[11,"needs_drop","","If `ty.needs_drop(...)` returns `true`, then `ty` is definitely non-copy and might have a destructor attached; if it returns `false`, then `ty` definitely has no destructor (i.e. no drop glue).",668,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"paramenv"}],"output":{"name":"bool"}}],[11,"is_representable","","Check whether a type is representable. This means it cannot contain unboxed structural recursion. This check is needed for structs and enums.",668,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"span"}],"output":{"name":"representability"}}],[11,"determine","rustc::ty::util","Categorizes an explicit self declaration like `self: SomeType` into either `self`, `&self`, `&mut self`, `Box<self>`, or `Other`. This is mainly used to require the arbitrary_self_types feature in the case of `Other`, to improve error messages in the common cases, and to make `Other` non-object-safe.",954,{"inputs":[{"name":"ty"},{"name":"p"}],"output":{"name":"explicitself"}}],[0,"context","rustc::ty","type context book-keeping",null,null],[3,"AllArenas","rustc::ty::context","",null,null],[12,"global","","",657,null],[12,"interner","","",657,null],[3,"GlobalArenas","","Internal storage",null,null],[12,"layout","","",656,null],[12,"generics","","",656,null],[12,"trait_def","","",656,null],[12,"adt_def","","",656,null],[12,"steal_mir","","",656,null],[12,"mir","","",656,null],[12,"tables","","",656,null],[12,"const_allocs","","miri allocations",656,null],[3,"CtxtInterners","","",null,null],[12,"arena","","The arena that types, regions, etc are allocated from",956,null],[12,"type_","","Specifically use a speedy hash algorithm for these hash sets, they're accessed quite often.",956,null],[12,"type_list","","",956,null],[12,"substs","","",956,null],[12,"canonical_var_infos","","",956,null],[12,"region","","",956,null],[12,"existential_predicates","","",956,null],[12,"predicates","","",956,null],[12,"const_","","",956,null],[12,"clauses","","",956,null],[12,"goals","","",956,null],[3,"CommonTypes","","",null,null],[12,"bool","","",957,null],[12,"char","","",957,null],[12,"isize","","",957,null],[12,"i8","","",957,null],[12,"i16","","",957,null],[12,"i32","","",957,null],[12,"i64","","",957,null],[12,"i128","","",957,null],[12,"usize","","",957,null],[12,"u8","","",957,null],[12,"u16","","",957,null],[12,"u32","","",957,null],[12,"u64","","",957,null],[12,"u128","","",957,null],[12,"f32","","",957,null],[12,"f64","","",957,null],[12,"never","","",957,null],[12,"err","","",957,null],[12,"re_empty","","",957,null],[12,"re_static","","",957,null],[12,"re_erased","","",957,null],[3,"LocalTableInContext","","",null,null],[12,"local_id_root","","",958,null],[12,"data","","",958,null],[3,"LocalTableInContextMut","","",null,null],[12,"local_id_root","","",959,null],[12,"data","","",959,null],[3,"TypeckTables","","",null,null],[12,"local_id_root","","The HirId::owner all ItemLocalIds in this table are relative to.",658,null],[12,"type_dependent_defs","","Resolved definitions for `<T>::X` associated paths and method calls, including those of overloaded operators.",658,null],[12,"field_indices","","Resolved field indices for field accesses in expressions (`S { field }`, `obj.field`) or patterns (`S { field }`). The index is often useful by itself, but to learn more about the field you also need definition of the variant to which the field belongs, but it may not exist if it's a tuple field (`tuple.0`).",658,null],[12,"user_provided_tys","","Stores the canonicalized types provided by the user. See also `UserAssertTy` statement in MIR.",658,null],[12,"node_types","","Stores the types for various nodes in the AST.  Note that this table is not guaranteed to be populated until after typeck.  See typeck::check::fn_ctxt for details.",658,null],[12,"node_substs","","Stores the type parameters which were substituted to obtain the type of this node.  This only applies to nodes that refer to entities parameterized by type parameters, such as generic fns, types, or other items.",658,null],[12,"adjustments","","",658,null],[12,"pat_binding_modes","","Stores the actual binding mode for all instances of hir::BindingAnnotation.",658,null],[12,"pat_adjustments","","Stores the types which were implicitly dereferenced in pattern binding modes for later usage in HAIR lowering. For example,",658,null],[12,"upvar_capture_map","","Borrows",658,null],[12,"closure_kind_origins","","Records the reasons that we picked the kind of each closure; not all closures are present in the map.",658,null],[12,"liberated_fn_sigs","","For each fn, records the \"liberated\" types of its arguments and return type. Liberated means that all bound regions (including late-bound regions) are replaced with free equivalents. This table is not used in trans (since regions are erased there) and hence is not serialized to metadata.",658,null],[12,"fru_field_types","","For each FRU expression, record the normalized types of the fields of the struct - this is needed because it is non-trivial to normalize while preserving regions. This table is used only in MIR construction and hence is not serialized to metadata.",658,null],[12,"cast_kinds","","Maps a cast expression to its kind. This is keyed on the from expression of the cast, not the cast itself.",658,null],[12,"used_trait_imports","","Set of trait imports actually used in the method resolution. This is used for warning unused imports. During type checking, this `Lrc` should not be cloned: it must have a ref-count of 1 so that we can insert things into the set mutably.",658,null],[12,"tainted_by_errors","","If any errors occurred while type-checking this body, this field will be set to `true`.",658,null],[12,"free_region_map","","Stores the free-region relationships that were deduced from its where clauses and parameter types. These are then read-again by borrowck.",658,null],[3,"TyCtxt","","The central data structure of the compiler. It stores references to the various arenas and also houses the results of the various compiler queries that have been performed. See the [rustc guide] for more details.",null,null],[12,"gcx","","",655,null],[12,"interners","","",655,null],[3,"GlobalCtxt","","",null,null],[12,"global_arenas","","",960,null],[12,"global_interners","","",960,null],[12,"cstore","","",960,null],[12,"sess","","",960,null],[12,"dep_graph","","",960,null],[12,"on_disk_query_result_cache","","This provides access to the incr. comp. on-disk cache for query results. Do not access this directly. It is only meant to be used by `DepGraph::try_mark_green()` and the query infrastructure in `ty::maps`.",960,null],[12,"types","","Common types, pre-interned for your convenience.",960,null],[12,"trait_map","","Map indicating what traits are in scope for places where this is relevant; generated by resolve.",960,null],[12,"export_map","","Export map produced by name resolution.",960,null],[12,"hir","","",960,null],[12,"def_path_hash_to_def_id","","A map from DefPathHash -> DefId. Includes DefIds from the local crate as well as all upstream crates. Only populated in incremental mode.",960,null],[12,"maps","","",960,null],[12,"freevars","","",960,null],[12,"maybe_unused_trait_imports","","",960,null],[12,"maybe_unused_extern_crates","","",960,null],[12,"rcache","","",960,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used for things that do not have to do with the parameters in scope.",960,null],[12,"evaluation_cache","","Caches the results of trait evaluation. This cache is used for things that do not have to do with the parameters in scope. Merge this with `selection_cache`?",960,null],[12,"crate_name","","The definite name of the current crate after taking into account attributes, commandline parameters, etc.",960,null],[12,"data_layout","","Data layout specification for the current target.",960,null],[12,"stability_interner","","",960,null],[12,"interpret_interner","","",960,null],[12,"layout_interner","","",960,null],[12,"tx_to_llvm_workers","","A general purpose channel to throw data out the back towards LLVM worker threads.",960,null],[12,"output_filenames","","",960,null],[3,"InterpretInterner","","Everything needed to efficiently work with interned allocations",null,null],[12,"inner","","",659,null],[3,"InterpretInternerInner","","",null,null],[12,"allocs","","Stores the value of constants (and deduplicates the actual memory)",961,null],[12,"functions","","Allows obtaining function instance handles via a unique identifier",961,null],[12,"function_cache","","Inverse map of `interpret_functions`. Used so we don't allocate a new pointer every time we need one",961,null],[12,"alloc_by_id","","Allows obtaining const allocs via a unique identifier",961,null],[12,"statics","","Allows obtaining static def ids via a unique id",961,null],[12,"next_id","","The AllocId to assign to the next new regular allocation. Always incremented, never gets smaller.",961,null],[12,"static_cache","","Inverse map of `statics` Used so we don't allocate a new pointer every time we need one",961,null],[12,"literal_alloc_cache","","A cache for basic byte allocations keyed by their contents. This is used to deduplicate allocations for string and bytestring literals.",961,null],[3,"Interned","","An entry in an interner.",null,null],[12,"0","","",962,null],[5,"validate_hir_id_for_typeck_tables","","Validate that the given HirId (respectively its `local_id` part) can be safely used as a key in the tables of a TypeckTable. For that to be the case, the HirId must have the same `owner` as all the other IDs in this table (signified by `local_id_root`). Otherwise the HirId would be in a different frame of reference and using its `local_id` would result in lookup errors, or worse, in silently wrong data being stored/returned.",null,{"inputs":[{"generics":["defid"],"name":"option"},{"name":"hirid"},{"name":"bool"}],"output":null}],[5,"keep_local","","",null,{"inputs":[{"name":"t"}],"output":{"name":"bool"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"tls","","",null,null],[3,"ImplicitCtxt","rustc::ty::context::tls","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module.",null,null],[12,"tcx","","The current TyCtxt. Initially created by `enter_global` and updated by `enter_local` with a new local interner",714,null],[12,"query","","The current query job, if any. This is updated by start_job in ty::maps::plumbing when executing a query",714,null],[12,"layout_depth","","Used to prevent layout from recursing too deeply.",714,null],[12,"task","","The current dep graph task. This is used to add dependencies to queries when executing them",714,null],[5,"set_tlv","","",null,{"inputs":[{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[5,"get_tlv","","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"span_debug","","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise",null,{"inputs":[{"name":"span"},{"name":"formatter"}],"output":{"name":"result"}}],[5,"track_diagnostic","","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise. It is used to when diagnostic messages are emitted and stores them in the current query, if there is one.",null,{"inputs":[{"name":"diagnostic"}],"output":null}],[5,"with_thread_locals","","Sets up the callbacks from libsyntax on the current thread",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"enter_context","","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`",null,{"inputs":[{"name":"implicitctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"enter_global","","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function.",null,{"inputs":[{"name":"globalctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"with_context_opt","","Allows access to the current ImplicitCtxt in a closure if one is available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_context","","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field.",null,{"inputs":[{"name":"tyctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"with_fully_related_context","","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field.",null,{"inputs":[{"name":"tyctxt"},{"name":"f"}],"output":{"name":"r"}}],[5,"with","","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"with_opt","","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[17,"TLV","","",null,null],[11,"clone","rustc::ty::tls","",714,{"inputs":[{"name":"self"}],"output":{"name":"implicitctxt"}}],[6,"InternedSet","rustc::ty::context","",null,null],[8,"Lift","","A trait implemented for all X<'a> types which can be safely and efficiently converted to X<'tcx> as long as they are part of the provided TyCtxt<'tcx>. This can be done, for example, for Ty<'tcx> or &'tcx Substs<'tcx> by looking them up in their respective interners.",null,null],[16,"Lifted","","",963,null],[10,"lift_to_tcx","","",963,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[8,"InternAs","","",null,null],[16,"Output","","",964,null],[10,"intern_with","","",964,null],[8,"InternIteratorElement","","",null,null],[16,"Output","","",965,null],[10,"intern_with","","",965,null],[11,"new","rustc::ty","",657,{"inputs":[],"output":{"name":"self"}}],[11,"new","","",656,{"inputs":[],"output":{"name":"globalarenas"}}],[11,"new","rustc::ty::context","",956,{"inputs":[{"name":"syncdroplessarena"}],"output":{"name":"ctxtinterners"}}],[11,"intern_ty","","Intern a type. global_interners is Some only if this is a local interner and global_interners is its counterpart.",956,{"inputs":[{"name":"self"},{"name":"typevariants"},{"generics":["ctxtinterners"],"name":"option"}],"output":{"name":"ty"}}],[11,"contains_key","","",958,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"get","","",958,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"option"}}],[11,"iter","","",958,{"inputs":[{"name":"self"}],"output":{"generics":["itemlocalid"],"name":"iter"}}],[11,"index","","",958,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"v"}}],[11,"get_mut","","",959,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"option"}}],[11,"entry","","",959,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["itemlocalid"],"name":"entry"}}],[11,"insert","","",959,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","",959,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"option"}}],[11,"encode","rustc::ty","",658,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",658,{"inputs":[{"name":"__d"}],"output":{"generics":["typecktables"],"name":"result"}}],[11,"fmt","","",658,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",658,{"inputs":[{"generics":["defid"],"name":"option"}],"output":{"name":"typecktables"}}],[11,"qpath_def","","Returns the final resolution of a `QPath` in an `Expr` or `Pat` node.",658,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"hirid"}],"output":{"name":"def"}}],[11,"type_dependent_defs","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["def"],"name":"localtableincontext"}}],[11,"type_dependent_defs_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["def"],"name":"localtableincontextmut"}}],[11,"field_indices","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"localtableincontext"}}],[11,"field_indices_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"localtableincontextmut"}}],[11,"user_provided_tys","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["canonicalty"],"name":"localtableincontext"}}],[11,"user_provided_tys_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["canonicalty"],"name":"localtableincontextmut"}}],[11,"node_types","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"localtableincontext"}}],[11,"node_types_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"localtableincontextmut"}}],[11,"node_id_to_type","","",658,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"ty"}}],[11,"node_id_to_type_opt","","",658,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["ty"],"name":"option"}}],[11,"node_substs_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["substs"],"name":"localtableincontextmut"}}],[11,"node_substs","","",658,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"substs"}}],[11,"node_substs_opt","","",658,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["substs"],"name":"option"}}],[11,"pat_ty","","",658,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"ty"}}],[11,"pat_ty_opt","","",658,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"generics":["ty"],"name":"option"}}],[11,"expr_ty","","",658,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"expr_ty_opt","","",658,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["ty"],"name":"option"}}],[11,"adjustments","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"localtableincontext"}}],[11,"adjustments_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"localtableincontextmut"}}],[11,"expr_adjustments","","",658,null],[11,"expr_ty_adjusted","","Returns the type of `expr`, considering any `Adjustment` entry recorded for that expression.",658,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"expr_ty_adjusted_opt","","",658,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["ty"],"name":"option"}}],[11,"is_method_call","","",658,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"pat_binding_modes","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["bindingmode"],"name":"localtableincontext"}}],[11,"pat_binding_modes_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["bindingmode"],"name":"localtableincontextmut"}}],[11,"pat_adjustments","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"localtableincontext"}}],[11,"pat_adjustments_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"localtableincontextmut"}}],[11,"upvar_capture","","",658,{"inputs":[{"name":"self"},{"name":"upvarid"}],"output":{"name":"upvarcapture"}}],[11,"closure_kind_origins","","",658,{"inputs":[{"name":"self"}],"output":{"name":"localtableincontext"}}],[11,"closure_kind_origins_mut","","",658,{"inputs":[{"name":"self"}],"output":{"name":"localtableincontextmut"}}],[11,"liberated_fn_sigs","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["fnsig"],"name":"localtableincontext"}}],[11,"liberated_fn_sigs_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["fnsig"],"name":"localtableincontextmut"}}],[11,"fru_field_types","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"localtableincontext"}}],[11,"fru_field_types_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"localtableincontextmut"}}],[11,"cast_kinds","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["castkind"],"name":"localtableincontext"}}],[11,"cast_kinds_mut","","",658,{"inputs":[{"name":"self"}],"output":{"generics":["castkind"],"name":"localtableincontextmut"}}],[11,"hash_stable","","",658,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","rustc::ty::context","",957,{"inputs":[{"name":"ctxtinterners"}],"output":{"name":"commontypes"}}],[11,"clone","rustc::ty","",655,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"deref","","",655,null],[11,"fmt","","",659,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",659,{"inputs":[],"output":{"name":"interpretinterner"}}],[11,"fmt","rustc::ty::context","",961,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",961,{"inputs":[],"output":{"name":"interpretinternerinner"}}],[11,"create_fn_alloc","rustc::ty","",659,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"allocid"}}],[11,"get_fn","","",659,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["instance"],"name":"option"}}],[11,"get_alloc","","",659,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["allocation"],"name":"option"}}],[11,"cache_static","","",659,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"allocid"}}],[11,"get_static","","",659,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"intern_at_reserved","","",659,{"inputs":[{"name":"self"},{"name":"allocid"},{"name":"allocation"}],"output":null}],[11,"reserve","","obtains a new allocation ID that can be referenced but does not yet have an allocation backing it.",659,{"inputs":[{"name":"self"}],"output":{"name":"allocid"}}],[11,"global_tcx","","Get the global TyCtxt.",655,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"alloc_generics","","",655,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"name":"generics"}}],[11,"alloc_steal_mir","","",655,{"inputs":[{"name":"self"},{"name":"mir"}],"output":{"name":"steal"}}],[11,"alloc_mir","","",655,{"inputs":[{"name":"self"},{"name":"mir"}],"output":{"name":"mir"}}],[11,"alloc_tables","","",655,{"inputs":[{"name":"self"},{"name":"typecktables"}],"output":{"name":"typecktables"}}],[11,"alloc_trait_def","","",655,{"inputs":[{"name":"self"},{"name":"traitdef"}],"output":{"name":"traitdef"}}],[11,"alloc_adt_def","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"adtkind"},{"generics":["variantdef"],"name":"vec"},{"name":"reproptions"}],"output":{"name":"adtdef"}}],[11,"alloc_byte_array","","",655,null],[11,"alloc_const_slice","","",655,null],[11,"alloc_name_const_slice","","",655,null],[11,"intern_const_alloc","","",655,{"inputs":[{"name":"self"},{"name":"allocation"}],"output":{"name":"allocation"}}],[11,"allocate_cached","","Allocates a byte or string literal for `mir::interpret`",655,null],[11,"intern_stability","","",655,{"inputs":[{"name":"self"},{"name":"stability"}],"output":{"name":"stability"}}],[11,"intern_layout","","",655,{"inputs":[{"name":"self"},{"name":"layoutdetails"}],"output":{"name":"layoutdetails"}}],[11,"lift","","",655,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"lift_to_global","","Like lift, but only tries in the global tcx.",655,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"is_global","","Returns true if self is the same as self.global_tcx().",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"create_and_enter","","Create a type context and call the closure with a `TyCtxt` reference to the context. The closure enforces that the type context and any interned value (types, substs, etc.) can only be used while `ty::tls` has a valid reference to the context, to allow formatting values that need it.",655,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"providers"},{"name":"providers"},{"name":"allarenas"},{"name":"resolutions"},{"name":"map"},{"name":"ondiskcache"},{"name":"str"},{"generics":["box"],"name":"sender"},{"name":"outputfilenames"},{"name":"f"}],"output":{"name":"r"}}],[11,"consider_optimizing","","",655,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"lang_items","","",655,{"inputs":[{"name":"self"}],"output":{"generics":["languageitems"],"name":"lrc"}}],[11,"is_binop_lang_item","","Due to missing llvm support for lowering 128 bit math to software emulation (on some targets), the lowering can be done in MIR.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"option"}}],[11,"stability","","",655,{"inputs":[{"name":"self"}],"output":{"generics":["index"],"name":"lrc"}}],[11,"crates","","",655,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"features","","",655,{"inputs":[{"name":"self"}],"output":{"generics":["features"],"name":"lrc"}}],[11,"def_key","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defkey"}}],[11,"def_path","","Convert a `DefId` into its fully expanded `DefPath` (every `DefId` is really just an interned def-path).",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpath"}}],[11,"def_path_hash","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpathhash"}}],[11,"def_path_debug_str","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"string"}}],[11,"metadata_encoding_version","","",655,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"vec"}}],[11,"crate_data_as_rc_any","","",655,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["any"],"name":"lrc"}}],[11,"create_stable_hashing_context","","",655,{"inputs":[{"name":"self"}],"output":{"name":"stablehashingcontext"}}],[11,"allocate_metadata_dep_nodes","","",655,{"inputs":[{"name":"self"}],"output":null}],[11,"precompute_in_scope_traits_hashes","","",655,{"inputs":[{"name":"self"}],"output":null}],[11,"serialize_query_result_cache","","",655,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"use_mir_borrowck","","If true, we should use the MIR-based borrowck (we may also use the AST-based borrowck).",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"all_pat_vars_are_implicit_refs_within_guards","","If true, pattern variables for use in guards on match arms will be bound as references to the data, and occurrences of those variables in the guard expression will implicitly dereference those bindings. (See rust-lang/rust#27282.)",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"two_phase_borrows","","If true, we should enable two-phase borrows checks. This is done with either `-Ztwo-phase-borrows` or with `#![feature(nll)]`.",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"borrowck_mode","","What mode(s) of borrowck should we run? AST? MIR? both? (Also considers the `#![feature(nll)]` setting.)",655,{"inputs":[{"name":"self"}],"output":{"name":"borrowckmode"}}],[11,"emit_end_regions","","Should we emit EndRegion MIR statements? These are consumed by MIR borrowck, but not when NLL is used. They are also consumed by the validation stuff.",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"share_generics","","",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"local_crate_exports_generics","","",655,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"encode_metadata","","",655,{"inputs":[{"name":"self"},{"name":"linkmeta"}],"output":{"name":"encodedmetadata"}}],[11,"enter_local","rustc::ty::context","Call the closure with a local `TyCtxt` using the given arena.",960,{"inputs":[{"name":"self"},{"name":"syncdroplessarena"},{"name":"f"}],"output":{"name":"r"}}],[11,"print_debug_stats","rustc::ty","",655,{"inputs":[{"name":"self"}],"output":null}],[11,"eq","rustc::ty::context","",962,{"inputs":[{"name":"self"},{"name":"interned"}],"output":{"name":"bool"}}],[11,"hash","","",962,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"borrow","","",962,{"inputs":[{"name":"self"}],"output":{"name":"typevariants"}}],[11,"eq","","",962,{"inputs":[{"name":"self"},{"name":"interned"}],"output":{"name":"bool"}}],[11,"hash","","",962,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"borrow","","",962,null],[11,"borrow","","",962,null],[11,"borrow","","",962,null],[11,"borrow","","",962,{"inputs":[{"name":"self"}],"output":{"name":"regionkind"}}],[11,"borrow","","",962,null],[11,"borrow","","",962,null],[11,"borrow","","",962,{"inputs":[{"name":"self"}],"output":{"name":"const"}}],[11,"borrow","","",962,null],[11,"borrow","","",962,null],[11,"eq","","",962,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"hash","","",962,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"mk_region","rustc::ty","",655,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"regionkind"}}],[11,"eq","rustc::ty::context","",962,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"hash","","",962,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"mk_const","rustc::ty","",655,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"const"}}],[11,"_intern_existential_predicates","","",655,null],[11,"_intern_predicates","","",655,null],[11,"_intern_type_list","","",655,null],[11,"_intern_substs","","",655,null],[11,"_intern_clauses","","",655,null],[11,"_intern_goals","","",655,null],[11,"_intern_canonical_var_infos","","",655,null],[11,"safe_to_unsafe_fn_ty","","Given a `fn` type, returns an equivalent `unsafe fn` type; that is, a `fn` type that is equivalent in every way for being unsafe.",655,{"inputs":[{"name":"self"},{"name":"polyfnsig"}],"output":{"name":"ty"}}],[11,"coerce_closure_fn_ty","","Given a closure signature `sig`, returns an equivalent `fn` type with the same signature. Detuples and so forth -- so e.g. if we have a sig with `Fn<(u32, i32)>` then you would get a `fn(u32, i32)`.",655,{"inputs":[{"name":"self"},{"name":"polyfnsig"}],"output":{"name":"ty"}}],[11,"mk_ty","","",655,{"inputs":[{"name":"self"},{"name":"typevariants"}],"output":{"name":"ty"}}],[11,"mk_mach_int","","",655,{"inputs":[{"name":"self"},{"name":"intty"}],"output":{"name":"ty"}}],[11,"mk_mach_uint","","",655,{"inputs":[{"name":"self"},{"name":"uintty"}],"output":{"name":"ty"}}],[11,"mk_mach_float","","",655,{"inputs":[{"name":"self"},{"name":"floatty"}],"output":{"name":"ty"}}],[11,"mk_str","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_static_str","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_adt","","",655,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"mk_foreign","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"ty"}}],[11,"mk_box","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"mk_ptr","","",655,{"inputs":[{"name":"self"},{"name":"typeandmut"}],"output":{"name":"ty"}}],[11,"mk_ref","","",655,{"inputs":[{"name":"self"},{"name":"region"},{"name":"typeandmut"}],"output":{"name":"ty"}}],[11,"mk_mut_ref","","",655,{"inputs":[{"name":"self"},{"name":"region"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"mk_imm_ref","","",655,{"inputs":[{"name":"self"},{"name":"region"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"mk_mut_ptr","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"mk_imm_ptr","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"mk_nil_ptr","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_array","","",655,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"u64"}],"output":{"name":"ty"}}],[11,"mk_slice","","",655,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"intern_tup","","",655,null],[11,"mk_tup","","",655,null],[11,"mk_nil","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_diverging_default","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_bool","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_fn_def","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"mk_fn_ptr","","",655,{"inputs":[{"name":"self"},{"name":"polyfnsig"}],"output":{"name":"ty"}}],[11,"mk_dynamic","","",655,{"inputs":[{"name":"self"},{"generics":["slice"],"name":"binder"},{"name":"region"}],"output":{"name":"ty"}}],[11,"mk_projection","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"mk_closure","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"ty"}}],[11,"mk_closure_from_closure_substs","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"ty"}}],[11,"mk_generator","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"closuresubsts"},{"name":"generatorinterior"}],"output":{"name":"ty"}}],[11,"mk_generator_witness","","",655,{"inputs":[{"name":"self"},{"generics":["slice"],"name":"binder"}],"output":{"name":"ty"}}],[11,"mk_var","","",655,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"ty"}}],[11,"mk_int_var","","",655,{"inputs":[{"name":"self"},{"name":"intvid"}],"output":{"name":"ty"}}],[11,"mk_float_var","","",655,{"inputs":[{"name":"self"},{"name":"floatvid"}],"output":{"name":"ty"}}],[11,"mk_infer","","",655,{"inputs":[{"name":"self"},{"name":"inferty"}],"output":{"name":"ty"}}],[11,"mk_param","","",655,{"inputs":[{"name":"self"},{"name":"u32"},{"name":"internedstring"}],"output":{"name":"ty"}}],[11,"mk_self_type","","",655,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"mk_param_from_def","","",655,{"inputs":[{"name":"self"},{"name":"typeparameterdef"}],"output":{"name":"ty"}}],[11,"mk_anon","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"intern_existential_predicates","","",655,null],[11,"intern_predicates","","",655,null],[11,"intern_type_list","","",655,null],[11,"intern_substs","","",655,null],[11,"intern_canonical_var_infos","","",655,null],[11,"intern_clauses","","",655,null],[11,"intern_goals","","",655,null],[11,"mk_fn_sig","","",655,null],[11,"mk_existential_predicates","","",655,null],[11,"mk_predicates","","",655,null],[11,"mk_type_list","","",655,null],[11,"mk_substs","","",655,null],[11,"mk_substs_trait","","",655,null],[11,"mk_clauses","","",655,null],[11,"mk_goals","","",655,null],[11,"mk_goal","","",655,{"inputs":[{"name":"self"},{"name":"goal"}],"output":{"name":"goal"}}],[11,"lint_node","","",655,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"s"},{"name":"str"}],"output":null}],[11,"lint_node_note","","",655,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"s"},{"name":"str"},{"name":"str"}],"output":null}],[11,"lint_level_at_node","","",655,null],[11,"struct_span_lint_node","","",655,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_lint_node","","",655,{"inputs":[{"name":"self"},{"name":"lint"},{"name":"nodeid"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"in_scope_traits","","",655,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"named_region","","",655,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["region"],"name":"option"}}],[11,"is_late_bound","","",655,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"bool"}}],[11,"object_lifetime_defaults","","",655,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"generics":["lrc"],"name":"option"}}],[0,"flags","","",null,null],[3,"FlagComputation","rustc::ty::flags","",null,null],[12,"flags","","",966,null],[12,"depth","","",966,null],[11,"fmt","","",966,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",966,{"inputs":[],"output":{"name":"flagcomputation"}}],[11,"for_sty","","",966,{"inputs":[{"name":"typevariants"}],"output":{"name":"flagcomputation"}}],[11,"add_flags","","",966,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"add_depth","","",966,{"inputs":[{"name":"self"},{"name":"u32"}],"output":null}],[11,"add_bound_computation","","Adds the flags/depth from a set of types that appear within the current type, but within a region binder.",966,{"inputs":[{"name":"self"},{"name":"flagcomputation"}],"output":null}],[11,"add_sty","","",966,{"inputs":[{"name":"self"},{"name":"typevariants"}],"output":null}],[11,"add_ty","","",966,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"add_tys","","",966,null],[11,"add_fn_sig","","",966,{"inputs":[{"name":"self"},{"name":"polyfnsig"}],"output":null}],[11,"add_region","","",966,{"inputs":[{"name":"self"},{"name":"region"}],"output":null}],[11,"add_const","","",966,{"inputs":[{"name":"self"},{"name":"const"}],"output":null}],[11,"add_existential_projection","","",966,{"inputs":[{"name":"self"},{"name":"existentialprojection"}],"output":null}],[11,"add_projection_ty","","",966,{"inputs":[{"name":"self"},{"name":"projectionty"}],"output":null}],[11,"add_substs","","",966,{"inputs":[{"name":"self"},{"name":"substs"}],"output":null}],[0,"instance","rustc::ty","",null,null],[3,"Instance","rustc::ty::instance","",null,null],[12,"def","","",660,null],[12,"substs","","",660,null],[4,"InstanceDef","","",null,null],[13,"Item","","",701,null],[13,"Intrinsic","","",701,null],[13,"FnPtrShim","","<fn() as FnTrait>::call_* def-id is FnTrait::call_*",701,null],[13,"Virtual","","::fn",701,null],[13,"ClosureOnceShim","","<[mut closure] as FnOnce>::call_once",701,null],[12,"call_once","rustc::ty::instance::InstanceDef","",701,null],[13,"DropGlue","rustc::ty::instance","drop_in_place::; None for empty drop glue.",701,null],[13,"CloneShim","","`<T as Clone>::clone` shim.",701,null],[5,"resolve_associated_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"paramenv"},{"name":"defid"},{"name":"substs"}],"output":{"generics":["instance"],"name":"option"}}],[5,"needs_fn_once_adapter_shim","","",null,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"generics":["bool"],"name":"result"}}],[5,"fn_once_adapter_instance","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"instance"}}],[11,"clone","rustc::ty","",660,{"inputs":[{"name":"self"}],"output":{"name":"instance"}}],[11,"eq","","",660,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"bool"}}],[11,"ne","","",660,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",660,null],[11,"hash","","",660,null],[11,"fmt","","",660,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",660,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",660,{"inputs":[{"name":"__d"}],"output":{"generics":["instance"],"name":"result"}}],[11,"clone","","",701,{"inputs":[{"name":"self"}],"output":{"name":"instancedef"}}],[11,"eq","","",701,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"bool"}}],[11,"ne","","",701,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",701,null],[11,"hash","","",701,null],[11,"fmt","","",701,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",701,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",701,{"inputs":[{"name":"__d"}],"output":{"generics":["instancedef"],"name":"result"}}],[11,"ty","","",660,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"def_id","","",701,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"attrs","","",701,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"attributes"}}],[11,"is_inline","","",701,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"bool"}}],[11,"requires_local","","",701,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"bool"}}],[11,"fmt","","",660,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",660,{"inputs":[{"name":"defid"},{"name":"substs"}],"output":{"name":"instance"}}],[11,"mono","","",660,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"instance"}}],[11,"def_id","","",660,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"resolve","","Resolve a (def_id, substs) pair to an (optional) instance -- most commonly, this is used to find the precise code that will run for a trait method invocation, if known.",660,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"defid"},{"name":"substs"}],"output":{"generics":["instance"],"name":"option"}}],[11,"resolve_closure","","",660,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"closuresubsts"},{"name":"closurekind"}],"output":{"name":"instance"}}],[0,"structural_impls","","This module contains implements of the `Lift` and `TypeFoldable` traits for various types in the Rust compiler. Most are written by hand, though we've recently added some macros (e.g., `BraceStructLiftImpl!`) to help with the tedium.",null,null],[11,"super_fold_with","rustc::middle::region","",402,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"scope"}}],[11,"super_visit_with","","",402,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::hir::def","",140,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"def"}}],[11,"super_visit_with","","",140,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::hir::def_id","",143,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"defid"}}],[11,"super_visit_with","","",143,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::hir","",70,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"inlineasm"}}],[11,"super_visit_with","","",70,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",111,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"matchsource"}}],[11,"super_visit_with","","",111,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",100,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"mutability"}}],[11,"super_visit_with","","",100,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",124,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"super_visit_with","","",124,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::mir","",435,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"local"}}],[11,"super_visit_with","","",435,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",449,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"promoted"}}],[11,"super_visit_with","","",449,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::traits","",578,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"reveal"}}],[11,"super_visit_with","","",578,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty::adjustment","",720,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"autoborrowmutability"}}],[11,"super_visit_with","","",720,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty","",711,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"adtkind"}}],[11,"super_visit_with","","",711,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",699,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"boundregion"}}],[11,"super_visit_with","","",699,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",712,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"closurekind"}}],[11,"super_visit_with","","",712,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",708,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"intvarvalue"}}],[11,"super_visit_with","","",708,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"lift_to_tcx","rustc::middle::region","",402,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::hir::def","",140,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::hir::def_id","",143,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::hir","",70,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",111,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",100,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",124,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::mir","",435,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",449,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::traits","",578,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty::adjustment","",720,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty","",711,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",699,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",712,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",708,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",645,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",646,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",679,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["traitpredicate"],"name":"option"}}],[11,"lift_to_tcx","","",681,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["subtypepredicate"],"name":"option"}}],[11,"lift_to_tcx","","",680,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",641,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["projectionty"],"name":"option"}}],[11,"lift_to_tcx","","",682,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["projectionpredicate"],"name":"option"}}],[11,"lift_to_tcx","","",647,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",709,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",635,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",685,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",686,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",642,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",643,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty::adjustment","",715,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",718,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",716,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",721,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty","",639,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",638,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty::error","",730,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",731,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::middle::const_val","",330,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::mir::interpret","",488,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",496,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::middle::const_val","",333,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty::layout","",749,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","rustc::ty","",701,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[11,"lift_to_tcx","","",660,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["instance"],"name":"option"}}],[11,"lift_to_tcx","rustc::mir::interpret","",491,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["globalid"],"name":"option"}}],[11,"super_fold_with","rustc::ty","",635,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fold_with","","",635,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",635,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"visit_with","","",635,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",685,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",685,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",697,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",697,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",660,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",660,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::mir::interpret","",491,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",491,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty","",644,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",644,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",639,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",639,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",638,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",638,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",645,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",645,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",646,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",646,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",663,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",663,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",642,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",642,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",643,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",643,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty::adjustment","",715,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",715,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",718,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",718,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",716,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",716,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",721,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",721,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty","",677,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",677,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",709,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",709,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",682,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",682,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",647,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",647,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",641,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",641,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",683,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",683,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",686,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",686,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",681,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",681,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",679,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",679,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",680,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",680,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",672,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",672,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty::error","",730,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",730,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",731,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"self"}}],[11,"super_visit_with","","",731,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::middle::const_val","",332,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",332,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[0,"sty","rustc::ty","This module contains TypeVariants and its major components",null,null],[3,"TypeAndMut","rustc::ty::sty","",null,null],[12,"ty","","",644,null],[12,"mutbl","","",644,null],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region at least as big as the scope `fr.scope`\".",null,null],[12,"scope","","",650,null],[12,"bound_region","","",650,null],[3,"ClosureSubsts","","A closure can be modeled as a struct that looks like:",null,null],[12,"substs","","Lifetime and type parameters from the enclosing function, concatenated with the types of the upvars.",642,null],[3,"SplitClosureSubsts","","Struct returned by `split()`. Note that these are subslices of the parent slice and not canonical substs themselves.",null,null],[12,"closure_kind_ty","","",967,null],[12,"closure_sig_ty","","",967,null],[12,"upvar_kinds","","",967,null],[3,"GeneratorInterior","","This describes the types that can be contained in a generator. It will be a type variable initially and unified in the last stages of typeck of a body. It contains a tuple of all the types that could end up on a generator frame. The state transformation MIR pass may only produce layouts which mention types in this tuple. Upvars are not counted here.",null,null],[12,"witness","","",643,null],[12,"movable","","",643,null],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax, but perhaps the most recognizable form is in a where clause:",null,null],[12,"def_id","","",645,null],[12,"substs","","",645,null],[3,"ExistentialTraitRef","","An existential reference to a trait, where `Self` is erased. For example, the trait object `Trait<'a, 'b, X, Y>` is:",null,null],[12,"def_id","","",646,null],[12,"substs","","",646,null],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the compiler's representation for things like `for<'a> Fn(&'a isize)` (which would be represented by the type `PolyTraitRef == Binder<TraitRef>`). Note that when we skolemize, instantiate, erase, or otherwise \"discharge\" these bound regions, we change the type from `Binder<T>` to just `T` (see e.g. `liberate_late_bound_regions`).",null,null],[12,"0","","",635,null],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS form this would be written `<T as Trait<..>>::N`.",null,null],[12,"substs","","The parameters of the associated item.",641,null],[12,"item_def_id","","The DefId of the TraitItem for the associated type N.",641,null],[3,"GenSig","","",null,null],[12,"yield_ty","","",639,null],[12,"return_ty","","",639,null],[3,"FnSig","","Signature of a function type, which I have arbitrarily decided to use to refer to the input/output types.",null,null],[12,"inputs_and_output","","",638,null],[12,"variadic","","",638,null],[12,"unsafety","","",638,null],[12,"abi","","",638,null],[3,"ParamTy","","",null,null],[12,"idx","","",640,null],[12,"name","","",640,null],[3,"DebruijnIndex","","A [De Bruijn index][dbi] is a standard means of representing regions (and perhaps later types) in a higher-ranked setting. In particular, imagine a type like this:",null,null],[12,"depth","","We maintain the invariant that this is never 0. So 1 indicates the innermost binder. To ensure this, create with `DebruijnIndex::new`.",637,null],[3,"EarlyBoundRegion","","",null,null],[12,"def_id","","",649,null],[12,"index","","",649,null],[12,"name","","",649,null],[3,"TyVid","","",null,null],[12,"index","","",651,null],[3,"IntVid","","",null,null],[12,"index","","",652,null],[3,"FloatVid","","",null,null],[12,"index","","",653,null],[3,"RegionVid","","",null,null],[12,"0","","",654,null],[3,"CanonicalVar","","",null,null],[12,"0","","",636,null],[3,"ExistentialProjection","","A `ProjectionPredicate` for an `ExistentialTraitRef`.",null,null],[12,"item_def_id","","",647,null],[12,"substs","","",647,null],[12,"ty","","",647,null],[3,"Const","","Typed constant value.",null,null],[12,"ty","","",648,null],[12,"val","","",648,null],[4,"BoundRegion","","",null,null],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",699,null],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",699,null],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",699,null],[13,"BrEnv","","Anonymous region for the implicit env pointer parameter to a closure",699,null],[4,"TypeVariants","","NB: If you change this, you'll probably want to change the corresponding AST structure in libsyntax/ast.rs as well.",null,null],[13,"TyBool","","The primitive boolean type. Written as `bool`.",698,null],[13,"TyChar","","The primitive character type; holds a Unicode scalar value (a non-surrogate code point).  Written as `char`.",698,null],[13,"TyInt","","A primitive signed integer type. For example, `i32`.",698,null],[13,"TyUint","","A primitive unsigned integer type. For example, `u32`.",698,null],[13,"TyFloat","","A primitive floating-point type. For example, `f64`.",698,null],[13,"TyAdt","","Structures, enumerations and unions.",698,null],[13,"TyForeign","","",698,null],[13,"TyStr","","The pointee of a string slice. Written as `str`.",698,null],[13,"TyArray","","An array with the given length. Written as `[T; n]`.",698,null],[13,"TySlice","","The pointee of an array slice.  Written as `[T]`.",698,null],[13,"TyRawPtr","","A raw pointer. Written as `*mut T` or `*const T`",698,null],[13,"TyRef","","A reference; a pointer with an associated lifetime. Written as `&'a mut T` or `&'a T`.",698,null],[13,"TyFnDef","","The anonymous type of a function declaration/definition. Each function has a unique type.",698,null],[13,"TyFnPtr","","A pointer to a function.  Written as `fn() -> i32`.",698,null],[13,"TyDynamic","","A trait, defined with `trait`.",698,null],[13,"TyClosure","","The anonymous type of a closure. Used to represent the type of `|a| a`.",698,null],[13,"TyGenerator","","The anonymous type of a generator. Used to represent the type of `|a| yield a`.",698,null],[13,"TyGeneratorWitness","","A type representin the types stored inside a generator. This should only appear in GeneratorInteriors.",698,null],[13,"TyNever","","The never type `!`",698,null],[13,"TyTuple","","A tuple type.  For example, `(i32, bool)`.",698,null],[13,"TyProjection","","The projection of an associated type.  For example, `<T as Trait<..>>::N`.",698,null],[13,"TyAnon","","Anonymized (`impl Trait`) type found in a return type. The DefId comes from the `impl Trait` ast::Ty node, and the substitutions are for the generics of the function in question. After typeck, the concrete type can be found in the `types` map.",698,null],[13,"TyParam","","A type parameter; for example, `T` in `fn f(x: T) {}",698,null],[13,"TyInfer","","A type variable used during type-checking.",698,null],[13,"TyError","","A placeholder for a type which could not be computed; this is propagated to avoid useless error messages.",698,null],[4,"ExistentialPredicate","","",null,null],[13,"Trait","","e.g. Iterator",697,null],[13,"Projection","","e.g. Iterator::Item = T",697,null],[13,"AutoTrait","","e.g. Send",697,null],[4,"RegionKind","","Representation of regions.",null,null],[13,"ReEarlyBound","","",700,null],[13,"ReLateBound","","",700,null],[13,"ReFree","","When checking a function body, the types of all arguments and so forth that refer to bound region parameters are modified to refer to free region parameters.",700,null],[13,"ReScope","","A concrete region naming some statically determined scope (e.g. an expression or sequence of statements) within the current function.",700,null],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",700,null],[13,"ReVar","","A region variable.  Should not exist after typeck.",700,null],[13,"ReSkolemized","","A skolemized region - basically the higher-ranked version of ReFree. Should not exist after typeck.",700,null],[13,"ReEmpty","","Empty lifetime is for data that is never accessed. Bottom in the region lattice. We treat ReEmpty somewhat specially; at least right now, we do not generate instances of it during the GLB computations, but rather generate an error instead. This is to improve error messages. The only way to get an instance of ReEmpty is to have a region variable with no constraints.",700,null],[13,"ReErased","","Erased region, used by trait selection, in MIR and during trans.",700,null],[13,"ReClosureBound","","These are regions bound in the \"defining type\" for a closure. They are used ONLY as part of the `ClosureRegionRequirements` that are produced by MIR borrowck. See `ClosureRegionRequirements` for more details.",700,null],[13,"ReCanonical","","Canonicalized region, used only when preparing a trait query.",700,null],[4,"InferTy","","",null,null],[13,"TyVar","","",696,null],[13,"IntVar","","",696,null],[13,"FloatVar","","",696,null],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an unbound type variable. This is convenient for caching etc. See `infer::freshen` for more details.",696,null],[13,"FreshIntTy","","",696,null],[13,"FreshFloatTy","","",696,null],[13,"CanonicalTy","","Canonicalized type variable, used only when preparing a trait query.",696,null],[6,"PolyTraitRef","","",null,null],[6,"PolyExistentialTraitRef","","",null,null],[6,"PolyGenSig","","",null,null],[6,"PolyFnSig","","",null,null],[6,"Region","","",null,null],[6,"PolyExistentialProjection","","",null,null],[11,"clone","rustc::ty","",644,{"inputs":[{"name":"self"}],"output":{"name":"typeandmut"}}],[11,"eq","","",644,{"inputs":[{"name":"self"},{"name":"typeandmut"}],"output":{"name":"bool"}}],[11,"ne","","",644,{"inputs":[{"name":"self"},{"name":"typeandmut"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",644,null],[11,"hash","","",644,null],[11,"fmt","","",644,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",644,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",644,{"inputs":[{"name":"__d"}],"output":{"generics":["typeandmut"],"name":"result"}}],[11,"clone","","",650,{"inputs":[{"name":"self"}],"output":{"name":"freeregion"}}],[11,"eq","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",650,null],[11,"cmp","","",650,{"inputs":[{"name":"self"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"hash","","",650,null],[11,"encode","","",650,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",650,{"inputs":[{"name":"__d"}],"output":{"generics":["freeregion"],"name":"result"}}],[11,"clone","","",699,{"inputs":[{"name":"self"}],"output":{"name":"boundregion"}}],[11,"eq","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",699,null],[11,"cmp","","",699,{"inputs":[{"name":"self"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"hash","","",699,null],[11,"encode","","",699,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",699,{"inputs":[{"name":"__d"}],"output":{"generics":["boundregion"],"name":"result"}}],[11,"is_named","","",699,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",698,{"inputs":[{"name":"self"}],"output":{"name":"typevariants"}}],[11,"eq","","",698,{"inputs":[{"name":"self"},{"name":"typevariants"}],"output":{"name":"bool"}}],[11,"ne","","",698,{"inputs":[{"name":"self"},{"name":"typevariants"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",698,null],[11,"hash","","",698,null],[11,"fmt","","",698,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",698,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",698,{"inputs":[{"name":"__d"}],"output":{"generics":["typevariants"],"name":"result"}}],[11,"clone","","",642,{"inputs":[{"name":"self"}],"output":{"name":"closuresubsts"}}],[11,"eq","","",642,{"inputs":[{"name":"self"},{"name":"closuresubsts"}],"output":{"name":"bool"}}],[11,"ne","","",642,{"inputs":[{"name":"self"},{"name":"closuresubsts"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",642,null],[11,"hash","","",642,null],[11,"fmt","","",642,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",642,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",642,{"inputs":[{"name":"__d"}],"output":{"generics":["closuresubsts"],"name":"result"}}],[11,"split","","Divides the closure substs into their respective components. Single source of truth with respect to the ordering.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"splitclosuresubsts"}}],[11,"upvar_tys","","",642,null],[11,"closure_kind_ty","","Returns the closure kind for this closure; may return a type variable during inference. To get the closure kind during inference, use `infcx.closure_kind(def_id, substs)`.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"closure_sig_ty","","Returns the type representing the closure signature for this closure; may contain type variables during inference. To get the closure signature during inference, use `infcx.fn_sig(def_id)`.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"generator_yield_ty","","Returns the type representing the yield type of the generator.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"generator_return_ty","","Returns the type representing the return type of the generator.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"generator_poly_sig","","Return the \"generator signature\", which consists of its yield and return types.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"polygensig"}}],[11,"generator_sig","","Return the \"generator signature\", which consists of its yield and return types.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"gensig"}}],[11,"closure_kind","","Returns the closure kind for this closure; only usable outside of an inference context, because in that context we know that there are no type variables.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"closurekind"}}],[11,"closure_sig","","Extracts the signature from the closure; only usable outside of an inference context, because in that context we know that there are no type variables.",642,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"tyctxt"}],"output":{"name":"polyfnsig"}}],[11,"state_tys","","This returns the types of the MIR locals which had to be stored across suspension points. It is calculated in rustc_mir::transform::generator::StateTransform. All the types here must be in the tuple in GeneratorInterior.",642,null],[11,"pre_transforms_tys","","This is the types of the fields of a generate which is available before the generator transformation. It includes the upvars and the state discriminant which is u32.",642,null],[11,"field_tys","","This is the types of all the fields stored in a generator. It includes the upvars, state types and the state discriminant which is u32.",642,null],[11,"clone","","",643,{"inputs":[{"name":"self"}],"output":{"name":"generatorinterior"}}],[11,"eq","","",643,{"inputs":[{"name":"self"},{"name":"generatorinterior"}],"output":{"name":"bool"}}],[11,"ne","","",643,{"inputs":[{"name":"self"},{"name":"generatorinterior"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",643,null],[11,"hash","","",643,null],[11,"fmt","","",643,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",643,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",643,{"inputs":[{"name":"__d"}],"output":{"generics":["generatorinterior"],"name":"result"}}],[11,"fmt","","",697,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",697,{"inputs":[{"name":"self"}],"output":{"name":"existentialpredicate"}}],[11,"eq","","",697,{"inputs":[{"name":"self"},{"name":"existentialpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",697,{"inputs":[{"name":"self"},{"name":"existentialpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",697,null],[11,"hash","","",697,null],[11,"encode","","",697,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",697,{"inputs":[{"name":"__d"}],"output":{"generics":["existentialpredicate"],"name":"result"}}],[11,"cmp","","",697,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"with_self_ty","","",635,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"predicate"}}],[11,"principal","","",669,{"inputs":[{"name":"self"}],"output":{"generics":["existentialtraitref"],"name":"option"}}],[11,"projection_bounds","","",669,null],[11,"auto_traits","","",669,null],[11,"principal","","",635,{"inputs":[{"name":"self"}],"output":{"generics":["polyexistentialtraitref"],"name":"option"}}],[11,"projection_bounds","","",635,null],[11,"auto_traits","","",635,null],[11,"iter","","",635,null],[11,"clone","","",645,{"inputs":[{"name":"self"}],"output":{"name":"traitref"}}],[11,"eq","","",645,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",645,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",645,null],[11,"hash","","",645,null],[11,"encode","","",645,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",645,{"inputs":[{"name":"__d"}],"output":{"generics":["traitref"],"name":"result"}}],[11,"new","","",645,{"inputs":[{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",645,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"input_types","","",645,null],[11,"self_ty","rustc::ty::sty","",968,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"def_id","","",968,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"to_poly_trait_predicate","","",968,{"inputs":[{"name":"self"}],"output":{"name":"polytraitpredicate"}}],[11,"clone","rustc::ty","",646,{"inputs":[{"name":"self"}],"output":{"name":"existentialtraitref"}}],[11,"eq","","",646,{"inputs":[{"name":"self"},{"name":"existentialtraitref"}],"output":{"name":"bool"}}],[11,"ne","","",646,{"inputs":[{"name":"self"},{"name":"existentialtraitref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",646,null],[11,"hash","","",646,null],[11,"encode","","",646,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",646,{"inputs":[{"name":"__d"}],"output":{"generics":["existentialtraitref"],"name":"result"}}],[11,"input_types","","",646,null],[11,"with_self_ty","","Object types don't have a self-type specified. Therefore, when we convert the principal trait-ref into a normal trait-ref, you must give some self-type. A common choice is `mk_err()` or some skolemized type.",646,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"traitref"}}],[11,"def_id","rustc::ty::sty","",969,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"clone","rustc::ty","",635,{"inputs":[{"name":"self"}],"output":{"name":"binder"}}],[11,"eq","","",635,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",635,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",635,null],[11,"hash","","",635,null],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",635,{"inputs":[{"name":"self"},{"name":"__st"}],"output":{"name":"result"}}],[11,"decode","","",635,{"inputs":[{"name":"__dt"}],"output":{"generics":["binder"],"name":"result"}}],[11,"dummy","","Wraps `value` in a binder, asserting that `value` does not contain any bound regions that would be bound by the binder. This is commonly used to 'inject' a value T into a different binding level.",635,{"inputs":[{"name":"t"}],"output":{"name":"binder"}}],[11,"bind","","Wraps `value` in a binder, binding late-bound regions (if any).",635,{"inputs":[{"name":"t"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a risky thing to do because it's easy to get confused about debruijn indices and the like. It is usually better to discharge the binder using `no_late_bound_regions` or `replace_late_bound_regions` or something like that. `skip_binder` is only valid when you are either extracting data that has nothing to do with bound regions, you are doing some sort of test that does not involve bound regions, or you are being very careful about your depth accounting.",635,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"as_ref","","",635,{"inputs":[{"name":"self"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",635,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",635,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"binder"}}],[11,"no_late_bound_regions","","Unwraps and returns the value within, but only if it contains no bound regions at all. (In other words, if this binder -- and indeed any enclosing binder -- doesn't bind anything at all.) Otherwise, returns `None`.",635,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"fuse","","Given two things that have the same binder level, and an operation that wraps on their contents, execute the operation and then wrap its result.",635,{"inputs":[{"name":"self"},{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"split","","Split the contents into two things that share the same binder level as the original, returning two distinct binders.",635,null],[11,"clone","","",641,{"inputs":[{"name":"self"}],"output":{"name":"projectionty"}}],[11,"eq","","",641,{"inputs":[{"name":"self"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",641,{"inputs":[{"name":"self"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",641,null],[11,"hash","","",641,null],[11,"fmt","","",641,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",641,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",641,{"inputs":[{"name":"__d"}],"output":{"generics":["projectionty"],"name":"result"}}],[11,"from_ref_and_name","","Construct a ProjectionTy by searching the trait from trait_ref for the associated item named item_name.",641,{"inputs":[{"name":"tyctxt"},{"name":"traitref"},{"name":"name"}],"output":{"name":"projectionty"}}],[11,"trait_ref","","Extracts the underlying trait reference from this projection. For example, if this is a projection of `<T as Iterator>::Item`, then this function would return a `T: Iterator` trait reference.",641,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"traitref"}}],[11,"self_ty","","",641,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"clone","","",639,{"inputs":[{"name":"self"}],"output":{"name":"gensig"}}],[11,"fmt","","",639,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",639,{"inputs":[{"name":"self"},{"name":"gensig"}],"output":{"name":"bool"}}],[11,"ne","","",639,{"inputs":[{"name":"self"},{"name":"gensig"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",639,null],[11,"hash","","",639,null],[11,"encode","","",639,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",639,{"inputs":[{"name":"__d"}],"output":{"generics":["gensig"],"name":"result"}}],[11,"yield_ty","rustc::ty::sty","",970,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"binder"}}],[11,"return_ty","","",970,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"binder"}}],[11,"clone","rustc::ty","",638,{"inputs":[{"name":"self"}],"output":{"name":"fnsig"}}],[11,"eq","","",638,{"inputs":[{"name":"self"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",638,{"inputs":[{"name":"self"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",638,null],[11,"hash","","",638,null],[11,"encode","","",638,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",638,{"inputs":[{"name":"__d"}],"output":{"generics":["fnsig"],"name":"result"}}],[11,"inputs","","",638,null],[11,"output","","",638,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"inputs","rustc::ty::sty","",971,{"inputs":[{"name":"self"}],"output":{"name":"binder"}}],[11,"input","","",971,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["ty"],"name":"binder"}}],[11,"inputs_and_output","","",971,{"inputs":[{"name":"self"}],"output":{"generics":["slice"],"name":"binder"}}],[11,"output","","",971,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"binder"}}],[11,"variadic","","",971,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"unsafety","","",971,{"inputs":[{"name":"self"}],"output":{"name":"unsafety"}}],[11,"abi","","",971,{"inputs":[{"name":"self"}],"output":{"name":"abi"}}],[11,"clone","rustc::ty","",640,{"inputs":[{"name":"self"}],"output":{"name":"paramty"}}],[11,"eq","","",640,{"inputs":[{"name":"self"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",640,{"inputs":[{"name":"self"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",640,null],[11,"hash","","",640,null],[11,"encode","","",640,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",640,{"inputs":[{"name":"__d"}],"output":{"generics":["paramty"],"name":"result"}}],[11,"new","","",640,{"inputs":[{"name":"u32"},{"name":"internedstring"}],"output":{"name":"paramty"}}],[11,"for_self","","",640,{"inputs":[],"output":{"name":"paramty"}}],[11,"for_def","","",640,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",640,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"is_self","","",640,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",637,{"inputs":[{"name":"self"}],"output":{"name":"debruijnindex"}}],[11,"eq","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",637,null],[11,"hash","","",637,null],[11,"encode","","",637,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",637,{"inputs":[{"name":"__d"}],"output":{"generics":["debruijnindex"],"name":"result"}}],[11,"fmt","","",637,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"le","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"gt","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ge","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"cmp","","",637,{"inputs":[{"name":"self"},{"name":"debruijnindex"}],"output":{"name":"ordering"}}],[11,"clone","","",700,{"inputs":[{"name":"self"}],"output":{"name":"regionkind"}}],[11,"eq","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"bool"}}],[11,"ne","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",700,null],[11,"hash","","",700,null],[11,"encode","","",700,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",700,{"inputs":[{"name":"__d"}],"output":{"generics":["regionkind"],"name":"result"}}],[11,"partial_cmp","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"bool"}}],[11,"le","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"bool"}}],[11,"gt","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"bool"}}],[11,"ge","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"bool"}}],[11,"cmp","","",700,{"inputs":[{"name":"self"},{"name":"regionkind"}],"output":{"name":"ordering"}}],[11,"clone","","",649,{"inputs":[{"name":"self"}],"output":{"name":"earlyboundregion"}}],[11,"eq","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",649,null],[11,"hash","","",649,null],[11,"encode","","",649,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",649,{"inputs":[{"name":"__d"}],"output":{"generics":["earlyboundregion"],"name":"result"}}],[11,"fmt","","",649,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"le","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"gt","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ge","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"cmp","","",649,{"inputs":[{"name":"self"},{"name":"earlyboundregion"}],"output":{"name":"ordering"}}],[11,"clone","","",651,{"inputs":[{"name":"self"}],"output":{"name":"tyvid"}}],[11,"eq","","",651,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",651,{"inputs":[{"name":"self"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",651,null],[11,"hash","","",651,null],[11,"encode","","",651,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",651,{"inputs":[{"name":"__d"}],"output":{"generics":["tyvid"],"name":"result"}}],[11,"clone","","",652,{"inputs":[{"name":"self"}],"output":{"name":"intvid"}}],[11,"eq","","",652,{"inputs":[{"name":"self"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",652,{"inputs":[{"name":"self"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",652,null],[11,"hash","","",652,null],[11,"encode","","",652,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",652,{"inputs":[{"name":"__d"}],"output":{"generics":["intvid"],"name":"result"}}],[11,"clone","","",653,{"inputs":[{"name":"self"}],"output":{"name":"floatvid"}}],[11,"eq","","",653,{"inputs":[{"name":"self"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",653,{"inputs":[{"name":"self"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",653,null],[11,"hash","","",653,null],[11,"encode","","",653,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",653,{"inputs":[{"name":"__d"}],"output":{"generics":["floatvid"],"name":"result"}}],[11,"clone","","",654,{"inputs":[{"name":"self"}],"output":{"name":"regionvid"}}],[11,"eq","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",654,null],[11,"hash","","",654,null],[11,"partial_cmp","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"le","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"gt","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ge","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"cmp","","",654,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"ordering"}}],[11,"decode","","",654,{"inputs":[{"name":"__d"}],"output":{"generics":["regionvid"],"name":"result"}}],[11,"encode","","",654,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",654,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",654,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",696,{"inputs":[{"name":"self"}],"output":{"name":"inferty"}}],[11,"eq","","",696,{"inputs":[{"name":"self"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",696,{"inputs":[{"name":"self"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",696,null],[11,"hash","","",696,null],[11,"encode","","",696,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",696,{"inputs":[{"name":"__d"}],"output":{"generics":["inferty"],"name":"result"}}],[11,"clone","","",636,{"inputs":[{"name":"self"}],"output":{"name":"canonicalvar"}}],[11,"eq","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"bool"}}],[11,"ne","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",636,null],[11,"hash","","",636,null],[11,"partial_cmp","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"bool"}}],[11,"le","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"bool"}}],[11,"gt","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"bool"}}],[11,"ge","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"bool"}}],[11,"cmp","","",636,{"inputs":[{"name":"self"},{"name":"canonicalvar"}],"output":{"name":"ordering"}}],[11,"decode","","",636,{"inputs":[{"name":"__d"}],"output":{"generics":["canonicalvar"],"name":"result"}}],[11,"encode","","",636,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",636,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",636,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",636,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",647,{"inputs":[{"name":"self"}],"output":{"name":"existentialprojection"}}],[11,"eq","","",647,{"inputs":[{"name":"self"},{"name":"existentialprojection"}],"output":{"name":"bool"}}],[11,"ne","","",647,{"inputs":[{"name":"self"},{"name":"existentialprojection"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",647,null],[11,"hash","","",647,null],[11,"fmt","","",647,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",647,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",647,{"inputs":[{"name":"__d"}],"output":{"generics":["existentialprojection"],"name":"result"}}],[11,"trait_ref","","Extracts the underlying existential trait reference from this projection. For example, if this is a projection of `exists T. <T as Iterator>::Item == X`, then this function would return a `exists T. T: Iterator` existential trait reference.",647,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"existentialtraitref"}}],[11,"with_self_ty","","",647,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"projectionpredicate"}}],[11,"with_self_ty","rustc::ty::sty","",972,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"polyprojectionpredicate"}}],[11,"item_def_id","","",972,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"new","rustc::ty","",637,{"inputs":[{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",637,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"is_late_bound","","",700,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",700,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"from_depth","","Returns the depth of `self` from the (1-based) binding level `depth`",700,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"regionkind"}}],[11,"keep_in_local_tcx","","",700,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"type_flags","","",700,{"inputs":[{"name":"self"}],"output":{"name":"typeflags"}}],[11,"free_region_binding_scope","","Given an early-bound or free region, returns the def-id where it was bound. For example, consider the regions in this snippet of code:",700,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"defid"}}],[11,"is_nil","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_never","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_primitive","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ty_var","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ty_infer","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_phantom_data","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_bool","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_param","","",668,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"is_self","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_slice","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_simd","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"sequence_element_type","","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"simd_type","","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"simd_size","","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"usize"}}],[11,"is_region_ptr","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_mutable_pointer","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_unsafe_ptr","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_box","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"boxed_ty","","panics if called on any type other than `Box<T>`",668,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"is_scalar","","A scalar type is one that denotes an atomic datum, with no sub-components. (A TyRawPtr is scalar because it represents a non-managed pointer, so its contents are abstract to rustc.)",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_floating_point","","Returns true if this type is a floating point type and false otherwise.",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_trait","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_enum","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_closure","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_generator","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_integral","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_fresh_ty","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_fresh","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_char","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_fp","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_numeric","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_signed","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_machine","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_concrete_skeleton","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"builtin_deref","","Returns the type and mutability of *ty.",668,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["typeandmut"],"name":"option"}}],[11,"builtin_index","","Returns the type of `ty[i]`.",668,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"option"}}],[11,"fn_sig","","",668,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"polyfnsig"}}],[11,"is_fn","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"ty_to_def_id","","",668,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"ty_adt_def","","",668,{"inputs":[{"name":"self"}],"output":{"generics":["adtdef"],"name":"option"}}],[11,"regions","","Returns the regions directly referenced from this type (but not types reachable from this type via `walk_tys`). This ignores late-bound regions binders.",668,{"inputs":[{"name":"self"}],"output":{"generics":["region"],"name":"vec"}}],[11,"to_opt_closure_kind","","When we create a closure, we record its kind (i.e., what trait it implements) into its `ClosureSubsts` using a type parameter. This is kind of a phantom type, except that the most convenient thing for us to are the integral types. This function converts such a special type into the closure kind. To go the other way, use `tcx.closure_kind_ty(closure_kind)`.",668,{"inputs":[{"name":"self"}],"output":{"generics":["closurekind"],"name":"option"}}],[11,"clone","","",648,{"inputs":[{"name":"self"}],"output":{"name":"const"}}],[11,"fmt","","",648,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",648,null],[11,"encode","","",648,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",648,{"inputs":[{"name":"__d"}],"output":{"generics":["const"],"name":"result"}}],[11,"assert_receiver_is_total_eq","","",648,null],[11,"eq","","",648,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"bool"}}],[11,"ne","","",648,{"inputs":[{"name":"self"},{"name":"const"}],"output":{"name":"bool"}}],[6,"PolyFnSig","","",null,null],[6,"PolyGenSig","","",null,null],[6,"PolyTraitRef","","",null,null],[6,"PolyExistentialTraitRef","","",null,null],[6,"PolyExistentialProjection","","",null,null],[6,"Region","","",null,null],[6,"Ty","","",null,null],[6,"CanonicalTy","","",null,null],[6,"UpvarCaptureMap","","",null,null],[6,"PolyTraitPredicate","","",null,null],[6,"PolyOutlivesPredicate","","",null,null],[6,"RegionOutlivesPredicate","","",null,null],[6,"TypeOutlivesPredicate","","",null,null],[6,"PolyRegionOutlivesPredicate","","",null,null],[6,"PolyTypeOutlivesPredicate","","",null,null],[6,"PolySubtypePredicate","","",null,null],[6,"PolyProjectionPredicate","","",null,null],[8,"Lift","","A trait implemented for all X<'a> types which can be safely and efficiently converted to X<'tcx> as long as they are part of the provided TyCtxt<'tcx>. This can be done, for example, for Ty<'tcx> or &'tcx Substs<'tcx> by looking them up in their respective interners.",null,null],[16,"Lifted","","",963,null],[10,"lift_to_tcx","","",963,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"option"}}],[8,"DefIdTree","","",null,null],[10,"parent","","",973,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"is_descendant_of","","",973,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[8,"ToPolyTraitRef","","",null,null],[10,"to_poly_trait_ref","","",974,{"inputs":[{"name":"self"}],"output":{"name":"polytraitref"}}],[8,"ToPredicate","","",null,null],[10,"to_predicate","","",975,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"clone","","",661,{"inputs":[{"name":"self"}],"output":{"name":"crateanalysis"}}],[11,"clone","","",662,{"inputs":[{"name":"self"}],"output":{"name":"resolutions"}}],[11,"clone","","",702,{"inputs":[{"name":"self"}],"output":{"name":"associateditemcontainer"}}],[11,"eq","","",702,{"inputs":[{"name":"self"},{"name":"associateditemcontainer"}],"output":{"name":"bool"}}],[11,"ne","","",702,{"inputs":[{"name":"self"},{"name":"associateditemcontainer"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",702,null],[11,"fmt","","",702,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_trait","","Asserts that this is the def-id of an associated item declared in a trait, and returns the trait def-id.",702,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"id","","",702,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"clone","","",663,{"inputs":[{"name":"self"}],"output":{"name":"implheader"}}],[11,"eq","","",663,{"inputs":[{"name":"self"},{"name":"implheader"}],"output":{"name":"bool"}}],[11,"ne","","",663,{"inputs":[{"name":"self"},{"name":"implheader"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",663,null],[11,"hash","","",663,null],[11,"fmt","","",663,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",664,{"inputs":[{"name":"self"}],"output":{"name":"associateditem"}}],[11,"fmt","","",664,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",664,{"inputs":[{"name":"self"},{"name":"associateditem"}],"output":{"name":"bool"}}],[11,"ne","","",664,{"inputs":[{"name":"self"},{"name":"associateditem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",664,null],[11,"clone","","",703,{"inputs":[{"name":"self"}],"output":{"name":"associatedkind"}}],[11,"eq","","",703,{"inputs":[{"name":"self"},{"name":"associatedkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",703,null],[11,"fmt","","",703,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",703,null],[11,"encode","","",703,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",703,{"inputs":[{"name":"__d"}],"output":{"generics":["associatedkind"],"name":"result"}}],[11,"def","","",664,{"inputs":[{"name":"self"}],"output":{"name":"def"}}],[11,"relevant_for_never","","Tests whether the associated item admits a non-trivial implementation for !",664,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"signature","","",664,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"clone","","",704,{"inputs":[{"name":"self"}],"output":{"name":"visibility"}}],[11,"fmt","","",704,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",704,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"ne","","",704,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",704,null],[11,"encode","","",704,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",704,{"inputs":[{"name":"__d"}],"output":{"generics":["visibility"],"name":"result"}}],[11,"parent","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"from_hir","","",704,{"inputs":[{"name":"visibility"},{"name":"nodeid"},{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"is_accessible_from","","Returns true if an item with this visibility is accessible from the given block.",704,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"t"}],"output":{"name":"bool"}}],[11,"is_at_least","","Returns true if this visibility is at least as accessible as the given visibility",704,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"t"}],"output":{"name":"bool"}}],[11,"is_visible_locally","","",704,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",705,{"inputs":[{"name":"self"}],"output":{"name":"variance"}}],[11,"eq","","",705,{"inputs":[{"name":"self"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"decode","","",705,{"inputs":[{"name":"__d"}],"output":{"generics":["variance"],"name":"result"}}],[11,"encode","","",705,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"xform","","`a.xform(b)` combines the variance of a context with the variance of a type with the following meaning.  If we are in a context with variance `a`, and we encounter a type argument in a position with variance `b`, then `a.xform(b)` is the new variance with which the argument appears.",705,{"inputs":[{"name":"self"},{"name":"variance"}],"output":{"name":"variance"}}],[11,"clone","","",666,{"inputs":[{"name":"self"}],"output":{"name":"creadercachekey"}}],[11,"eq","","",666,{"inputs":[{"name":"self"},{"name":"creadercachekey"}],"output":{"name":"bool"}}],[11,"ne","","",666,{"inputs":[{"name":"self"},{"name":"creadercachekey"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",666,null],[11,"hash","","",666,null],[11,"eq","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",667,null],[11,"clone","","",667,{"inputs":[{"name":"self"}],"output":{"name":"typeflags"}}],[11,"partial_cmp","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"cmp","","",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"hash","","",667,null],[11,"fmt","","",667,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",667,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",667,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",667,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",667,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"HAS_PARAMS","","",667,null],[18,"HAS_SELF","","",667,null],[18,"HAS_TY_INFER","","",667,null],[18,"HAS_RE_INFER","","",667,null],[18,"HAS_RE_SKOL","","",667,null],[18,"HAS_RE_EARLY_BOUND","","Does this have any `ReEarlyBound` regions? Used to determine whether substitition is required, since those represent regions that are bound in a `ty::Generics` and hence may be substituted.",667,null],[18,"HAS_FREE_REGIONS","","Does this have any region that \"appears free\" in the type? Basically anything but `ReLateBound` and `ReErased`.",667,null],[18,"HAS_TY_ERR","","Is an error type reachable?",667,null],[18,"HAS_PROJECTION","","",667,null],[18,"HAS_TY_CLOSURE","","",667,null],[18,"HAS_LOCAL_NAMES","","",667,null],[18,"KEEP_IN_LOCAL_TCX","","",667,null],[18,"HAS_NORMALIZABLE_PROJECTION","","",667,null],[18,"HAS_CANONICAL_VARS","","",667,null],[18,"NEEDS_SUBST","","",667,null],[18,"NOMINAL_FLAGS","","",667,null],[11,"empty","","Returns an empty set of flags.",667,{"inputs":[],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",667,{"inputs":[],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",667,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",667,{"inputs":[{"name":"u32"}],"output":{"generics":["typeflags"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",667,{"inputs":[{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",667,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",667,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",667,{"inputs":[{"name":"self"},{"name":"typeflags"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bitor_assign","","Adds the set of flags.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bitxor_assign","","Toggles the set of flags.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"sub_assign","","Disables all flags enabled in the set.",667,{"inputs":[{"name":"self"},{"name":"typeflags"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",667,{"inputs":[{"name":"self"}],"output":{"name":"typeflags"}}],[11,"extend","","",667,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",667,{"inputs":[{"name":"t"}],"output":{"name":"typeflags"}}],[11,"eq","","",668,{"inputs":[{"name":"self"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",668,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"is_primitive_ty","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_suggestable","","",668,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"hash_stable","","",668,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"intern","","",976,null],[11,"fmt","","",669,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",669,{"inputs":[{"name":"self"},{"name":"__st"}],"output":{"name":"result"}}],[11,"eq","","",669,{"inputs":[{"name":"self"},{"name":"slice"}],"output":{"name":"bool"}}],[11,"hash","","",669,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"deref","","",669,null],[11,"empty","","",669,{"inputs":[],"output":{"name":"slice"}}],[11,"clone","","",670,{"inputs":[{"name":"self"}],"output":{"name":"upvarid"}}],[11,"eq","","",670,{"inputs":[{"name":"self"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",670,{"inputs":[{"name":"self"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",670,null],[11,"hash","","",670,null],[11,"encode","","",670,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",670,{"inputs":[{"name":"__d"}],"output":{"generics":["upvarid"],"name":"result"}}],[11,"clone","","",706,{"inputs":[{"name":"self"}],"output":{"name":"borrowkind"}}],[11,"eq","","",706,{"inputs":[{"name":"self"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",706,null],[11,"hash","","",706,null],[11,"fmt","","",706,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",706,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",706,{"inputs":[{"name":"__d"}],"output":{"generics":["borrowkind"],"name":"result"}}],[11,"eq","","",707,{"inputs":[{"name":"self"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",707,{"inputs":[{"name":"self"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"clone","","",707,{"inputs":[{"name":"self"}],"output":{"name":"upvarcapture"}}],[11,"fmt","","",707,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",707,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",707,{"inputs":[{"name":"__d"}],"output":{"generics":["upvarcapture"],"name":"result"}}],[11,"eq","","",671,{"inputs":[{"name":"self"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",671,{"inputs":[{"name":"self"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"clone","","",671,{"inputs":[{"name":"self"}],"output":{"name":"upvarborrow"}}],[11,"encode","","",671,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",671,{"inputs":[{"name":"__d"}],"output":{"generics":["upvarborrow"],"name":"result"}}],[11,"clone","","",672,{"inputs":[{"name":"self"}],"output":{"name":"closureupvar"}}],[11,"clone","","",708,{"inputs":[{"name":"self"}],"output":{"name":"intvarvalue"}}],[11,"eq","","",708,{"inputs":[{"name":"self"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",708,{"inputs":[{"name":"self"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",708,null],[11,"clone","","",673,{"inputs":[{"name":"self"}],"output":{"name":"floatvarvalue"}}],[11,"eq","","",673,{"inputs":[{"name":"self"},{"name":"floatvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",673,{"inputs":[{"name":"self"},{"name":"floatvarvalue"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",673,null],[11,"clone","","",674,{"inputs":[{"name":"self"}],"output":{"name":"typeparameterdef"}}],[11,"encode","","",674,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",674,{"inputs":[{"name":"__d"}],"output":{"generics":["typeparameterdef"],"name":"result"}}],[11,"clone","","",675,{"inputs":[{"name":"self"}],"output":{"name":"regionparameterdef"}}],[11,"encode","","",675,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",675,{"inputs":[{"name":"__d"}],"output":{"generics":["regionparameterdef"],"name":"result"}}],[11,"to_early_bound_region_data","","",675,{"inputs":[{"name":"self"}],"output":{"name":"earlyboundregion"}}],[11,"to_bound_region","","",675,{"inputs":[{"name":"self"}],"output":{"name":"boundregion"}}],[11,"to_bound_region","","",649,{"inputs":[{"name":"self"}],"output":{"name":"boundregion"}}],[11,"clone","","",676,{"inputs":[{"name":"self"}],"output":{"name":"generics"}}],[11,"fmt","","",676,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",676,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",676,{"inputs":[{"name":"__d"}],"output":{"generics":["generics"],"name":"result"}}],[11,"parent_count","","",676,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"own_count","","",676,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"count","","",676,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"region_param","","",676,{"inputs":[{"name":"self"},{"name":"earlyboundregion"},{"name":"tyctxt"}],"output":{"name":"regionparameterdef"}}],[11,"type_param","","Returns the `TypeParameterDef` associated with this `ParamTy`.",676,{"inputs":[{"name":"self"},{"name":"paramty"},{"name":"tyctxt"}],"output":{"name":"typeparameterdef"}}],[11,"clone","","",677,{"inputs":[{"name":"self"}],"output":{"name":"genericpredicates"}}],[11,"default","","",677,{"inputs":[],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",677,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_own","","",677,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_into","","",677,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"instantiatedpredicates"},{"name":"substs"}],"output":null}],[11,"instantiate_identity","","",677,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_identity_into","","",677,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"instantiatedpredicates"}],"output":null}],[11,"instantiate_supertrait","","",677,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"name":"instantiatedpredicates"}}],[11,"clone","","",709,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"eq","","",709,{"inputs":[{"name":"self"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",709,{"inputs":[{"name":"self"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",709,null],[11,"hash","","",709,null],[11,"encode","","",709,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",709,{"inputs":[{"name":"__d"}],"output":{"generics":["predicate"],"name":"result"}}],[11,"as_ref","","",709,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substitution suitable for going from a poly-trait-ref to supertraits that must hold if that poly-trait-ref holds. This is slightly different from a normal substitution in terms of what happens with bound regions.  See lengthy comment below for details.",709,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"name":"predicate"}}],[11,"clone","","",679,{"inputs":[{"name":"self"}],"output":{"name":"traitpredicate"}}],[11,"eq","","",679,{"inputs":[{"name":"self"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",679,{"inputs":[{"name":"self"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",679,null],[11,"hash","","",679,null],[11,"encode","","",679,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",679,{"inputs":[{"name":"__d"}],"output":{"generics":["traitpredicate"],"name":"result"}}],[11,"def_id","","",679,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"input_types","","",679,null],[11,"self_ty","","",679,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"def_id","","",977,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"clone","","",680,{"inputs":[{"name":"self"}],"output":{"name":"outlivespredicate"}}],[11,"eq","","",680,{"inputs":[{"name":"self"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",680,{"inputs":[{"name":"self"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",680,null],[11,"hash","","",680,null],[11,"fmt","","",680,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",680,{"inputs":[{"name":"self"},{"name":"__sab"}],"output":{"name":"result"}}],[11,"decode","","",680,{"inputs":[{"name":"__dab"}],"output":{"generics":["outlivespredicate"],"name":"result"}}],[11,"clone","","",681,{"inputs":[{"name":"self"}],"output":{"name":"subtypepredicate"}}],[11,"eq","","",681,{"inputs":[{"name":"self"},{"name":"subtypepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",681,{"inputs":[{"name":"self"},{"name":"subtypepredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",681,null],[11,"hash","","",681,null],[11,"fmt","","",681,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",681,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",681,{"inputs":[{"name":"__d"}],"output":{"generics":["subtypepredicate"],"name":"result"}}],[11,"clone","","",682,{"inputs":[{"name":"self"}],"output":{"name":"projectionpredicate"}}],[11,"eq","","",682,{"inputs":[{"name":"self"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",682,{"inputs":[{"name":"self"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",682,null],[11,"hash","","",682,null],[11,"encode","","",682,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",682,{"inputs":[{"name":"__d"}],"output":{"generics":["projectionpredicate"],"name":"result"}}],[11,"item_def_id","","Returns the def-id of the associated item being projected.",978,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"to_poly_trait_ref","","",978,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"polytraitref"}}],[11,"ty","","",978,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"binder"}}],[11,"projection_def_id","","The DefId of the TraitItem for the associated type.",978,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"to_poly_trait_ref","","",645,{"inputs":[{"name":"self"}],"output":{"name":"polytraitref"}}],[11,"to_poly_trait_ref","","",977,{"inputs":[{"name":"self"}],"output":{"name":"polytraitref"}}],[11,"to_predicate","","",645,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"to_predicate","","",968,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"to_predicate","","",979,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"to_predicate","","",980,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"to_predicate","","",978,{"inputs":[{"name":"self"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all cases this is skipping over a binder, so late-bound regions with depth 0 are bound by the predicate.",709,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"intoiter"}}],[11,"to_opt_poly_trait_ref","","",709,{"inputs":[{"name":"self"}],"output":{"generics":["polytraitref"],"name":"option"}}],[11,"to_opt_type_outlives","","",709,{"inputs":[{"name":"self"}],"output":{"generics":["polytypeoutlivespredicate"],"name":"option"}}],[11,"clone","","",683,{"inputs":[{"name":"self"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",683,{"inputs":[],"output":{"name":"instantiatedpredicates"}}],[11,"is_empty","","",683,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",684,{"inputs":[{"name":"self"}],"output":{"name":"universeindex"}}],[11,"fmt","","",684,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"bool"}}],[11,"ne","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",684,null],[11,"partial_cmp","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"bool"}}],[11,"le","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"bool"}}],[11,"gt","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"bool"}}],[11,"ge","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"bool"}}],[11,"cmp","","",684,{"inputs":[{"name":"self"},{"name":"universeindex"}],"output":{"name":"ordering"}}],[11,"hash","","",684,null],[11,"encode","","",684,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",684,{"inputs":[{"name":"__d"}],"output":{"generics":["universeindex"],"name":"result"}}],[18,"ROOT","","The root universe, where things that the user defined are visible.",684,null],[11,"subuniverse","","A \"subuniverse\" corresponds to being inside a `forall` quantifier. So, for example, suppose we have this type in universe `U`:",684,{"inputs":[{"name":"self"}],"output":{"name":"universeindex"}}],[11,"as_u32","","",684,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"as_usize","","",684,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"from","","",684,{"inputs":[{"name":"u32"}],"output":{"name":"self"}}],[11,"clone","","",685,{"inputs":[{"name":"self"}],"output":{"name":"paramenv"}}],[11,"fmt","","",685,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",685,{"inputs":[{"name":"self"},{"name":"paramenv"}],"output":{"name":"bool"}}],[11,"ne","","",685,{"inputs":[{"name":"self"},{"name":"paramenv"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",685,null],[11,"hash","","",685,null],[11,"empty","","Construct a trait environment suitable for contexts where there are no where clauses in scope. Hidden types (like `impl Trait`) are left hidden, so this is suitable for ordinary type-checking.",685,{"inputs":[],"output":{"name":"self"}}],[11,"reveal_all","","Construct a trait environment with no where clauses in scope where the values of all `impl Trait` and other hidden types are revealed. This is suitable for monomorphized, post-typeck environments like trans or doing optimizations.",685,{"inputs":[],"output":{"name":"self"}}],[11,"new","","Construct a trait environment with the given set of predicates.",685,{"inputs":[{"name":"slice"},{"name":"reveal"}],"output":{"name":"self"}}],[11,"with_reveal_all","","Returns a new parameter environment with the same clauses, but which \"reveals\" the true results of projections in all cases (even for associated types that are specializable).  This is the desired behavior during trans and certain other special contexts; normally though we want to use `Reveal::UserFacing`, which is the default.",685,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"without_caller_bounds","","Returns this same environment but with no caller bounds.",685,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"and","","Creates a suitable environment in which to perform trait queries on the given value. When type-checking, this is simply the pair of the environment plus value. But when reveal is set to All, then if `value` does not reference any type parameters, we will pair it with the empty environment. This improves caching and is generally invisible.",685,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"paramenvand"}}],[11,"clone","","",686,{"inputs":[{"name":"self"}],"output":{"name":"paramenvand"}}],[11,"fmt","","",686,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",686,{"inputs":[{"name":"self"},{"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"ne","","",686,{"inputs":[{"name":"self"},{"name":"paramenvand"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",686,null],[11,"hash","","",686,null],[11,"into_parts","","",686,null],[11,"hash_stable","","",686,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",687,{"inputs":[{"name":"self"}],"output":{"name":"destructor"}}],[11,"fmt","","",687,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"ne","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",688,null],[11,"clone","","",688,{"inputs":[{"name":"self"}],"output":{"name":"adtflags"}}],[11,"partial_cmp","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"le","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"gt","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"ge","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"cmp","","",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"ordering"}}],[11,"hash","","",688,null],[11,"fmt","","",688,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",688,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",688,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",688,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",688,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"NO_ADT_FLAGS","","",688,null],[18,"IS_ENUM","","",688,null],[18,"IS_PHANTOM_DATA","","",688,null],[18,"IS_FUNDAMENTAL","","",688,null],[18,"IS_UNION","","",688,null],[18,"IS_BOX","","",688,null],[18,"IS_NON_EXHAUSTIVE","","Indicates whether this abstract data type will be expanded on in future (new fields/variants) and as such, whether downstream crates must match exhaustively on the fields/variants of this data type.",688,null],[11,"empty","","Returns an empty set of flags.",688,{"inputs":[],"output":{"name":"adtflags"}}],[11,"all","","Returns the set containing all flags.",688,{"inputs":[],"output":{"name":"adtflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",688,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",688,{"inputs":[{"name":"u32"}],"output":{"generics":["adtflags"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",688,{"inputs":[{"name":"u32"}],"output":{"name":"adtflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",688,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",688,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",688,{"inputs":[{"name":"self"},{"name":"adtflags"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"adtflags"}}],[11,"bitor_assign","","Adds the set of flags.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"adtflags"}}],[11,"bitxor_assign","","Toggles the set of flags.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"adtflags"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":{"name":"adtflags"}}],[11,"sub_assign","","Disables all flags enabled in the set.",688,{"inputs":[{"name":"self"},{"name":"adtflags"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",688,{"inputs":[{"name":"self"}],"output":{"name":"adtflags"}}],[11,"extend","","",688,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",688,{"inputs":[{"name":"t"}],"output":{"name":"adtflags"}}],[11,"fmt","","",689,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",710,{"inputs":[{"name":"self"}],"output":{"name":"variantdiscr"}}],[11,"fmt","","",710,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",710,{"inputs":[{"name":"self"},{"name":"variantdiscr"}],"output":{"name":"bool"}}],[11,"ne","","",710,{"inputs":[{"name":"self"},{"name":"variantdiscr"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",710,null],[11,"encode","","",710,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",710,{"inputs":[{"name":"__d"}],"output":{"generics":["variantdiscr"],"name":"result"}}],[11,"fmt","","",690,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",691,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"hash","","",691,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"hash_stable","","",691,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",711,{"inputs":[{"name":"self"}],"output":{"name":"adtkind"}}],[11,"fmt","","",711,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",711,null],[11,"eq","","",711,{"inputs":[{"name":"self"},{"name":"adtkind"}],"output":{"name":"bool"}}],[11,"hash","","",711,null],[11,"eq","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"ne","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",692,null],[11,"clone","","",692,{"inputs":[{"name":"self"}],"output":{"name":"reprflags"}}],[11,"partial_cmp","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"le","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"gt","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"ge","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"cmp","","",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"ordering"}}],[11,"hash","","",692,null],[11,"encode","","",692,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",692,{"inputs":[{"name":"__d"}],"output":{"generics":["reprflags"],"name":"result"}}],[11,"default","","",692,{"inputs":[],"output":{"name":"reprflags"}}],[11,"fmt","","",692,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",692,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",692,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",692,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",692,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"IS_C","","",692,null],[18,"IS_SIMD","","",692,null],[18,"IS_TRANSPARENT","","",692,null],[18,"IS_LINEAR","","",692,null],[18,"IS_UNOPTIMISABLE","","",692,null],[11,"empty","","Returns an empty set of flags.",692,{"inputs":[],"output":{"name":"reprflags"}}],[11,"all","","Returns the set containing all flags.",692,{"inputs":[],"output":{"name":"reprflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",692,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",692,{"inputs":[{"name":"u8"}],"output":{"generics":["reprflags"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",692,{"inputs":[{"name":"u8"}],"output":{"name":"reprflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",692,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",692,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",692,{"inputs":[{"name":"self"},{"name":"reprflags"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"reprflags"}}],[11,"bitor_assign","","Adds the set of flags.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"reprflags"}}],[11,"bitxor_assign","","Toggles the set of flags.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"reprflags"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":{"name":"reprflags"}}],[11,"sub_assign","","Disables all flags enabled in the set.",692,{"inputs":[{"name":"self"},{"name":"reprflags"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",692,{"inputs":[{"name":"self"}],"output":{"name":"reprflags"}}],[11,"extend","","",692,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",692,{"inputs":[{"name":"t"}],"output":{"name":"reprflags"}}],[11,"hash_stable","","",692,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",693,{"inputs":[{"name":"self"}],"output":{"name":"reproptions"}}],[11,"assert_receiver_is_total_eq","","",693,null],[11,"eq","","",693,{"inputs":[{"name":"self"},{"name":"reproptions"}],"output":{"name":"bool"}}],[11,"ne","","",693,{"inputs":[{"name":"self"},{"name":"reproptions"}],"output":{"name":"bool"}}],[11,"encode","","",693,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",693,{"inputs":[{"name":"__d"}],"output":{"generics":["reproptions"],"name":"result"}}],[11,"default","","",693,{"inputs":[],"output":{"name":"reproptions"}}],[11,"hash_stable","","",693,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",693,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"reproptions"}}],[11,"simd","","",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"c","","",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"packed","","",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"transparent","","",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"linear","","",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"discr_type","","",693,{"inputs":[{"name":"self"}],"output":{"name":"inttype"}}],[11,"inhibit_enum_layout_opt","","Returns true if this `#[repr()]` should inhabit \"smart enum layout\" optimizations, such as representing `Foo<&T>` as a single pointer.",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"inhibit_struct_field_reordering_opt","","Returns true if this `#[repr()]` should inhibit struct field reordering optimizations, such as with repr(C) or repr(packed(1)).",693,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"new","","",691,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"adtkind"},{"generics":["variantdef"],"name":"vec"},{"name":"reproptions"}],"output":{"name":"self"}}],[11,"is_struct","","",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_union","","",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_enum","","",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_non_exhaustive","","",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"adt_kind","","Returns the kind of the ADT - Struct or Enum.",691,{"inputs":[{"name":"self"}],"output":{"name":"adtkind"}}],[11,"descr","","",691,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"variant_descr","","",691,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"is_fundamental","","Returns whether this type is #[fundamental] for the purposes of coherence checking.",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_phantom_data","","Returns true if this is PhantomData.",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_box","","Returns true if this is Box.",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_dtor","","Returns whether this type has a destructor.",691,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"bool"}}],[11,"non_enum_variant","","Asserts this is a struct or union and returns its unique variant.",691,{"inputs":[{"name":"self"}],"output":{"name":"variantdef"}}],[11,"predicates","","",691,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"genericpredicates"}}],[11,"all_fields","","Returns an iterator over all fields contained by this ADT.",691,null],[11,"is_payloadfree","","",691,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"variant_with_id","","",691,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"variantdef"}}],[11,"variant_index_with_id","","",691,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"usize"}}],[11,"variant_of_def","","",691,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"name":"variantdef"}}],[11,"eval_explicit_discr","","",691,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["discr"],"name":"option"}}],[11,"discriminants","","",691,null],[11,"discriminant_for_variant","","Compute the discriminant value used by a specific variant. Unlike `discriminants`, this is (amortized) constant-time, only doing at most one query for evaluating an explicit discriminant (the last one before the requested variant), assuming there are no constant-evaluation errors there.",691,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"usize"}],"output":{"name":"discr"}}],[11,"discriminant_def_for_variant","","Yields a DefId for the discriminant and an offset to add to it Alternatively, if there is no explicit discriminant, returns the inferred discriminant directly",691,null],[11,"destructor","","",691,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["destructor"],"name":"option"}}],[11,"sized_constraint","","Returns a list of types such that `Self: Sized` if and only if that type is Sized, or `TyErr` if this type is recursive.",691,null],[11,"sized_constraint_for_ty","","",691,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"generics":["ty"],"name":"vec"}}],[11,"ty","","",690,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"clone","","",712,{"inputs":[{"name":"self"}],"output":{"name":"closurekind"}}],[11,"partial_cmp","","",712,{"inputs":[{"name":"self"},{"name":"closurekind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",712,{"inputs":[{"name":"self"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"eq","","",712,{"inputs":[{"name":"self"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",712,null],[11,"hash","","",712,null],[11,"fmt","","",712,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",712,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",712,{"inputs":[{"name":"__d"}],"output":{"generics":["closurekind"],"name":"result"}}],[18,"LATTICE_BOTTOM","","",712,null],[11,"trait_did","","",712,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind must also implement `other`.",712,{"inputs":[{"name":"self"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"to_ty","","Returns the representative scalar type for this closure kind. See `TyS::to_opt_closure_kind` for more details.",712,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"walk","","Iterator that walks `self` and any types reachable from `self`, in depth-first order. Note that just walks the types that appear in `self`, it does not descend into the fields of structs or variants. For example:",668,{"inputs":[{"name":"self"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence `Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]` (but not `i32`, like `walk`).",668,{"inputs":[{"name":"self"}],"output":{"generics":["typewalkerarray"],"name":"accintoiter"}}],[11,"maybe_walk","","Walks `ty` and any types appearing within `ty`, invoking the callback `f` on each type. If the callback returns false, then the children of the current type are ignored.",668,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"from_mutbl","","",706,{"inputs":[{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow kind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a mutability that is stronger than necessary so that it at least would permit the borrow in question.",706,{"inputs":[{"name":"self"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",706,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"fmt","","",713,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",713,{"inputs":[{"name":"self"}],"output":{"name":"attributes"}}],[11,"deref","","",713,null],[11,"body_tables","","",655,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"name":"typecktables"}}],[11,"body_owners","","Returns an iterator of the def-ids for all body-owners in this crate. If you would prefer to iterate over the bodies themselves, you can do `self.hir.krate().body_ids.iter()`.",655,null],[11,"expr_span","","",655,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"span"}}],[11,"provided_trait_methods","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["associateditem"],"name":"vec"}}],[11,"trait_relevant_for_never","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"opt_associated_item","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["associateditem"],"name":"option"}}],[11,"associated_item_from_trait_item_ref","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"visibility"},{"name":"traititemref"}],"output":{"name":"associateditem"}}],[11,"associated_item_from_impl_item_ref","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"implitemref"}],"output":{"name":"associateditem"}}],[11,"field_index","","",655,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"typecktables"}],"output":{"name":"usize"}}],[11,"find_field_index","","",655,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"variantdef"}],"output":{"generics":["usize"],"name":"option"}}],[11,"associated_items","","",655,null],[11,"impls_are_allowed_to_overlap","","Returns true if the impls are the same polarity and are implementing a trait which contains no items",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"expect_variant_def","","",655,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"name":"variantdef"}}],[11,"adt_def_id_of_variant","","Given a `VariantDef`, returns the def-id of the `AdtDef` of which it is a part.",655,{"inputs":[{"name":"self"},{"name":"variantdef"}],"output":{"name":"defid"}}],[11,"item_name","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"internedstring"}}],[11,"instance_mir","","Return the possibly-auto-generated MIR of a (DefId, Subst) pair.",655,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"name":"mir"}}],[11,"maybe_optimized_mir","","Given the DefId of an item, returns its MIR, borrowed immutably. Returns None if there is no MIR for the DefId",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["mir"],"name":"option"}}],[11,"get_attrs","","Get the attributes of a definition.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"attributes"}}],[11,"has_attr","","Determine whether an item is annotated with an attribute",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"str"}],"output":{"name":"bool"}}],[11,"trait_is_auto","","Returns true if this is an `auto trait`.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"generator_layout","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"generatorlayout"}}],[11,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements. If it implements no trait, return `None`.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the ID of the impl that the method belongs to. Otherwise, return `None`.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"span_of_impl","","Looks up the span of `impl_did` if the impl is local; otherwise returns `Err` with the name of the crate containing the impl.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["span","symbol"],"name":"result"}}],[11,"hygienic_eq","","",655,{"inputs":[{"name":"self"},{"name":"name"},{"name":"name"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"adjust","","",655,null],[11,"adjust_ident","","",655,null],[11,"with_freevars","","",655,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[11,"clone","","",694,{"inputs":[{"name":"self"}],"output":{"name":"crateinherentimpls"}}],[11,"fmt","","",694,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",695,{"inputs":[{"name":"self"}],"output":{"name":"symbolname"}}],[11,"eq","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"bool"}}],[11,"ne","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",695,null],[11,"partial_cmp","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"bool"}}],[11,"le","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"bool"}}],[11,"gt","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"bool"}}],[11,"ge","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"bool"}}],[11,"cmp","","",695,{"inputs":[{"name":"self"},{"name":"symbolname"}],"output":{"name":"ordering"}}],[11,"encode","","",695,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",695,{"inputs":[{"name":"__d"}],"output":{"generics":["symbolname"],"name":"result"}}],[11,"hash_stable","","",695,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"new","","",695,{"inputs":[{"name":"str"}],"output":{"name":"symbolname"}}],[11,"as_str","","",695,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"fmt","","",695,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",695,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"util","rustc","",null,null],[0,"captures","rustc::util","",null,null],[8,"Captures","rustc::util::captures","\"Signaling\" trait used in impl trait to tag lifetimes that you may need to capture but don't really need for other reasons. Basically a workaround; see [this comment] for details.",null,null],[0,"common","rustc::util","",null,null],[3,"ErrorReported","rustc::util::common","",null,null],[3,"DEFAULT_HOOK","","",null,null],[12,"__private_field","","",981,null],[3,"ProfQDumpParams","","Parameters to the `Dump` variant of type `ProfileQueriesMsg`.",null,null],[12,"path","","A base path for the files we will dump",982,null],[12,"ack","","To ensure that the compiler waits for us to finish our dumps",982,null],[12,"dump_profq_msg_log","","toggle dumping a log file with every `ProfileQueriesMsg`",982,null],[3,"QueryMsg","","",null,null],[12,"query","","",983,null],[12,"msg","","",983,null],[3,"Indenter","","",null,null],[12,"_cannot_construct_outside_of_this_module","","",984,null],[4,"ProfileQueriesMsg","","A sequence of these messages induce a trace of query-based incremental compilation. FIXME(matthewhammer): Determine whether we should include cycle detection here or not.",null,null],[13,"TimeBegin","","begin a timed pass",985,null],[13,"TimeEnd","","end a timed pass",985,null],[13,"TaskBegin","","begin a task (see dep_graph::graph::with_task)",985,null],[13,"TaskEnd","","end a task",985,null],[13,"QueryBegin","","begin a new query can't use `Span` because queries are sent to other thread",985,null],[13,"CacheHit","","query is satisfied by using an already-known value for the given key",985,null],[13,"ProviderBegin","","query requires running a provider; providers may nest, permitting queries to nest.",985,null],[13,"ProviderEnd","","query is satisfied by a provider terminating with a value",985,null],[13,"Dump","","dump a record of the queries to the given path",985,null],[13,"Halt","","halt the profiling/monitoring background thread",985,null],[5,"panic_hook","","",null,{"inputs":[{"name":"panicinfo"}],"output":null}],[5,"install_panic_hook","","",null,{"inputs":[],"output":null}],[5,"profq_msg","","If enabled, send a message to the profile-queries thread",null,{"inputs":[{"name":"session"},{"name":"profilequeriesmsg"}],"output":null}],[5,"profq_set_chan","","Set channel for profile queries channel",null,{"inputs":[{"name":"session"},{"generics":["profilequeriesmsg"],"name":"sender"}],"output":{"name":"bool"}}],[5,"time_depth","","Read the current depth of `time()` calls. This is used to encourage indentation across threads.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"set_time_depth","","Set the current depth of `time()` calls. The idea is to call `set_time_depth()` with the result from `time_depth()` in the parent thread.",null,{"inputs":[{"name":"usize"}],"output":null}],[5,"time","","",null,{"inputs":[{"name":"session"},{"name":"str"},{"name":"f"}],"output":{"name":"t"}}],[5,"time_ext","","",null,{"inputs":[{"name":"bool"},{"generics":["session"],"name":"option"},{"name":"str"},{"name":"f"}],"output":{"name":"t"}}],[5,"print_time_passes_entry","","",null,{"inputs":[{"name":"bool"},{"name":"str"},{"name":"duration"}],"output":null}],[5,"print_time_passes_entry_internal","","",null,{"inputs":[{"name":"str"},{"name":"duration"}],"output":null}],[5,"duration_to_secs_str","","",null,{"inputs":[{"name":"duration"}],"output":{"name":"string"}}],[5,"to_readable_str","","",null,{"inputs":[{"name":"usize"}],"output":{"name":"string"}}],[5,"record_time","","",null,{"inputs":[{"name":"lock"},{"name":"f"}],"output":{"name":"t"}}],[5,"get_resident","","",null,{"inputs":[],"output":{"generics":["usize"],"name":"option"}}],[5,"indent","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"indenter","","",null,{"inputs":[],"output":{"name":"indenter"}}],[5,"path2cstr","","",null,{"inputs":[{"name":"path"}],"output":{"name":"cstring"}}],[7,"DEFAULT_HOOK","","",null,null],[17,"FN_OUTPUT_NAME","","",null,null],[17,"TIME_DEPTH","","",null,null],[8,"MemoizationMap","","",null,null],[16,"Key","","",986,null],[16,"Value","","",986,null],[10,"memoize","","If `key` is present in the map, return the value, otherwise invoke `op` and store the value in the map.",986,null],[11,"clone","","",987,{"inputs":[{"name":"self"}],"output":{"name":"errorreported"}}],[11,"fmt","","",987,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",987,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",987,{"inputs":[{"name":"__d"}],"output":{"generics":["errorreported"],"name":"result"}}],[11,"deref","","",981,{"inputs":[{"name":"self"}],"output":{"name":"box"}}],[11,"initialize","","",981,{"inputs":[{"name":"self"}],"output":null}],[11,"clone","","",982,{"inputs":[{"name":"self"}],"output":{"name":"profqdumpparams"}}],[11,"fmt","","",982,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",983,{"inputs":[{"name":"self"}],"output":{"name":"querymsg"}}],[11,"fmt","","",983,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",983,{"inputs":[{"name":"self"},{"name":"querymsg"}],"output":{"name":"bool"}}],[11,"ne","","",983,{"inputs":[{"name":"self"},{"name":"querymsg"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",983,null],[11,"clone","","",985,{"inputs":[{"name":"self"}],"output":{"name":"profilequeriesmsg"}}],[11,"fmt","","",985,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"drop","","",984,{"inputs":[{"name":"self"}],"output":null}],[0,"ppaux","rustc::util","",null,null],[3,"LateBoundRegionNameCollector","rustc::util::ppaux","",null,null],[12,"0","","",988,null],[3,"PrintContext","","",null,null],[12,"is_debug","","",989,null],[12,"is_verbose","","",989,null],[12,"identify_regions","","",989,null],[12,"used_region_names","","",989,null],[12,"region_index","","",989,null],[12,"binder_depth","","",989,null],[5,"verbose","","",null,{"inputs":[],"output":{"name":"bool"}}],[5,"identify_regions","","",null,{"inputs":[],"output":{"name":"bool"}}],[5,"parameterized","","",null,null],[8,"Print","","",null,null],[10,"print","","",990,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"print_to_string","","",990,{"inputs":[{"name":"self"},{"name":"printcontext"}],"output":{"name":"string"}}],[11,"print_display","","",990,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"print_display_to_string","","",990,{"inputs":[{"name":"self"},{"name":"printcontext"}],"output":{"name":"string"}}],[11,"print_debug","","",990,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"print_debug_to_string","","",990,{"inputs":[{"name":"self"},{"name":"printcontext"}],"output":{"name":"string"}}],[11,"visit_region","","",988,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","","",989,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",989,{"inputs":[],"output":{"name":"self"}}],[11,"prepare_late_bound_region_info","","",989,{"inputs":[{"name":"self"},{"name":"binder"}],"output":null}],[11,"fn_sig","","",989,null],[11,"parameterized","","",989,null],[11,"in_binder","","",989,{"inputs":[{"name":"self"},{"name":"f"},{"name":"tyctxt"},{"name":"binder"},{"generics":["binder"],"name":"option"}],"output":{"name":"result"}}],[11,"is_name_used","","",989,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"fmt","rustc::ty","",674,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",675,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::ty::trait_def","",945,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::ty","",691,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",672,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",670,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",671,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",644,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",644,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",646,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",646,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","rustc::ty::adjustment","",715,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",715,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","rustc::ty","",699,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",699,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",699,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",700,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",700,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",700,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",650,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",650,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",705,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",705,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",677,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",677,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",683,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",683,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",638,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",638,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",638,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",651,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",652,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",653,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",654,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",696,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",696,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",696,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",708,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",673,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",635,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",645,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",645,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",645,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",643,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",643,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",698,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",698,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",668,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",668,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",668,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",640,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",640,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",640,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",680,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",680,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",681,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",681,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",679,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",679,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",679,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",682,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",682,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",682,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",641,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",641,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",712,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",712,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"print","","",709,{"inputs":[{"name":"self"},{"name":"f"},{"name":"printcontext"}],"output":{"name":"result"}}],[11,"fmt","","",709,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",709,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"nodemap","rustc::util","An efficient hash map for node IDs",null,null],[6,"FxHashMap","rustc::util::nodemap","",null,null],[6,"FxHashSet","","",null,null],[5,"NodeMap","","",null,{"inputs":[],"output":{"name":"nodemap"}}],[5,"DefIdMap","","",null,{"inputs":[],"output":{"name":"defidmap"}}],[5,"ItemLocalMap","","",null,{"inputs":[],"output":{"name":"itemlocalmap"}}],[5,"NodeSet","","",null,{"inputs":[],"output":{"name":"nodeset"}}],[5,"DefIdSet","","",null,{"inputs":[],"output":{"name":"defidset"}}],[5,"ItemLocalSet","","",null,{"inputs":[],"output":{"name":"itemlocalset"}}],[6,"NodeMap","","",null,null],[6,"DefIdMap","","",null,null],[6,"HirIdMap","","",null,null],[6,"ItemLocalMap","","",null,null],[6,"NodeSet","","",null,null],[6,"DefIdSet","","",null,null],[6,"HirIdSet","","",null,null],[6,"ItemLocalSet","","",null,null],[0,"fs","rustc::util","",null,null],[4,"LinkOrCopy","rustc::util::fs","",null,null],[13,"Link","","",991,null],[13,"Copy","","",991,null],[4,"RenameOrCopyRemove","","",null,null],[13,"Rename","","",992,null],[13,"CopyRemove","","",992,null],[5,"fix_windows_verbatim_for_gcc","","",null,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[5,"link_or_copy","","Copy `p` into `q`, preferring to use hard-linking if possible. If `q` already exists, it is removed first. The result indicates which of the two operations has been performed.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"generics":["linkorcopy"],"name":"result"}}],[5,"rename_or_copy_remove","","Rename `p` into `q`, preferring to use `rename` if possible. If `rename` fails (rename may fail for reasons such as crossing filesystem), fallback to copy & remove",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"generics":["renameorcopyremove"],"name":"result"}}],[11,"fmt","","",992,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"rustc","rustc","",null,null],[17,"DIAGNOSTICS","","",null,null],[14,"bug","","",null,null],[14,"span_bug","","",null,null],[14,"__impl_stable_hash_field","","",null,null],[14,"impl_stable_hash_for","","",null,null],[14,"impl_stable_hash_for_spanned","","",null,null],[14,"CloneLiftImpls","","",null,null],[14,"CloneTypeFoldableImpls","","Used for types that are `Copy` and which do not care arena allocated data (i.e., don't need to be folded).",null,null],[14,"CloneTypeFoldableAndLiftImpls","","",null,null],[14,"BraceStructLiftImpl","","",null,null],[14,"EnumLiftImpl","","",null,null],[14,"BraceStructTypeFoldableImpl","","",null,null],[14,"TupleStructTypeFoldableImpl","","",null,null],[14,"EnumTypeFoldableImpl","","",null,null],[14,"declare_lint","","Declare a static item of type `&'static Lint`.",null,null],[14,"lint_array","","Declare a static `LintArray` and return it as an expression.",null,null],[14,"err","","",null,null],[14,"__impl_decoder_methods","","",null,null],[14,"implement_ty_decoder","","",null,null],[11,"to_dep_node","rustc::hir::map::definitions","",179,{"inputs":[{"name":"self"},{"name":"depkind"}],"output":{"name":"depnode"}}],[11,"to_dep_node","rustc::hir::def_id","",143,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"depkind"}],"output":{"name":"depnode"}}],[11,"to_fingerprint","","",143,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"fingerprint"}}],[11,"to_debug_str","","",143,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"to_fingerprint","","",142,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"fingerprint"}}],[11,"to_debug_str","","",142,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"to_fingerprint","","",141,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"fingerprint"}}],[11,"to_debug_str","","",141,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"to_fingerprint","rustc::hir","",33,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"fingerprint"}}],[11,"print_node","rustc::hir::print","",187,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"result"}}],[11,"get_stable_hashing_context","rustc::ty","",655,{"inputs":[{"name":"self"}],"output":{"name":"stablehashingcontext"}}],[11,"hash_stable","rustc::middle::cstore","",341,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",344,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",337,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",338,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",343,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",339,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",346,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",336,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::lang_items","",371,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",369,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::mir","",453,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",434,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",459,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",461,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",436,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",437,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",439,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",451,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",452,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",460,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",475,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",440,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",458,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",435,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",438,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",445,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",446,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",449,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",462,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",441,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",463,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",442,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",464,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",465,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",444,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",466,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",447,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",433,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",457,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",467,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",468,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",469,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",470,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",471,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",473,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",472,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",448,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",474,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",450,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",454,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",455,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",456,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",476,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::mir::interpret","",491,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::session::search_paths","",549,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::subst","",940,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",942,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",700,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",654,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",636,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::adjustment","",721,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",718,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",715,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",716,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",671,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::adjustment","",719,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",720,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",670,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",706,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",707,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",639,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",638,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",635,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",712,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",704,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",645,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",679,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",681,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",680,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",682,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",641,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",709,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",688,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",689,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",710,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",690,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::const_val","",332,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::mir::interpret","",499,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",492,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",493,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",494,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",489,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",497,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",648,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::const_val","",330,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",331,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",333,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",642,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",643,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",677,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::mir::interpret","",488,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",496,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",500,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",490,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",501,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",705,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::adjustment","",722,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",676,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",675,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",674,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::resolve_lifetime","",419,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",416,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",418,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",637,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::cast","",726,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::region","",404,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",402,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_stable_hash_key","","",402,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"}],"output":{"name":"scope"}}],[11,"hash_stable","","",403,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::adjustment","",717,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",650,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",699,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",698,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",696,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",651,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",652,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",653,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",640,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",644,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",697,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",646,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",647,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",660,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",701,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::trait_def","",945,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",687,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",665,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",678,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",664,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",703,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",702,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty::steal","",939,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",685,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::traits","",578,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::privacy","",398,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",397,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::ty","",694,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::session","",522,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::util::common","",987,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::middle::reachable","",401,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::traits","",593,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",570,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",573,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",575,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",574,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",572,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",576,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",571,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::infer::canonical","",221,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",222,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",223,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",228,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",229,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",224,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",230,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc::traits","",586,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",587,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",589,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",568,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",590,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",588,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"to_trace","rustc::ty","",976,{"inputs":[{"name":"obligationcause"},{"name":"bool"},{"name":"self"},{"name":"self"}],"output":{"name":"typetrace"}}],[11,"to_trace","rustc::ty::sty","",993,{"inputs":[{"name":"obligationcause"},{"name":"bool"},{"name":"self"},{"name":"self"}],"output":{"name":"typetrace"}}],[11,"to_trace","rustc::ty","",645,{"inputs":[{"name":"obligationcause"},{"name":"bool"},{"name":"self"},{"name":"self"}],"output":{"name":"typetrace"}}],[11,"to_trace","rustc::ty::sty","",968,{"inputs":[{"name":"obligationcause"},{"name":"bool"},{"name":"self"},{"name":"self"}],"output":{"name":"typetrace"}}],[11,"compare","rustc::ty::relate","",994,{"inputs":[{"name":"self"},{"name":"t"},{"name":"f"}],"output":{"name":"relateresult"}}],[11,"note_and_explain_region","rustc::ty","",655,{"inputs":[{"name":"self"},{"name":"scopetree"},{"name":"diagnosticbuilder"},{"name":"str"},{"name":"region"},{"name":"str"}],"output":null}],[11,"note_and_explain_free_region","","",655,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"str"},{"name":"region"},{"name":"str"}],"output":null}],[11,"msg_span_from_free_region","","",655,null],[11,"msg_span_from_early_bound_and_free_regions","","",655,null],[11,"emit_msg_span","","",655,{"inputs":[{"name":"diagnosticbuilder"},{"name":"str"},{"name":"string"},{"generics":["span"],"name":"option"},{"name":"str"}],"output":null}],[11,"item_scope_tag","","",655,{"inputs":[{"name":"item"}],"output":{"name":"str"}}],[11,"trait_item_scope_tag","","",655,{"inputs":[{"name":"traititem"}],"output":{"name":"str"}}],[11,"impl_item_scope_tag","","",655,{"inputs":[{"name":"implitem"}],"output":{"name":"str"}}],[11,"explain_span","","",655,null],[11,"as_failure_code","rustc::traits","",566,{"inputs":[{"name":"self"},{"name":"typeerror"}],"output":{"name":"failurecode"}}],[11,"as_requirement_str","","",566,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"index","rustc::ty","",651,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_index","","",651,{"inputs":[{"name":"u32"}],"output":{"name":"tyvid"}}],[11,"tag","","",651,{"inputs":[],"output":{"name":"str"}}],[11,"index","","",652,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_index","","",652,{"inputs":[{"name":"u32"}],"output":{"name":"intvid"}}],[11,"tag","","",652,{"inputs":[],"output":{"name":"str"}}],[11,"index","","",654,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_index","","",654,{"inputs":[{"name":"u32"}],"output":{"name":"regionvid"}}],[11,"tag","","",654,{"inputs":[],"output":{"name":"str"}}],[11,"to_type","","",708,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"index","","",653,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_index","","",653,{"inputs":[{"name":"u32"}],"output":{"name":"floatvid"}}],[11,"tag","","",653,{"inputs":[],"output":{"name":"str"}}],[11,"to_type","","",673,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"infer_ctxt","","",655,{"inputs":[{"name":"self"}],"output":{"name":"inferctxtbuilder"}}],[11,"new","rustc::ty::error","",730,{"inputs":[{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"self"}}],[11,"take_passes","rustc::lint","",995,{"inputs":[{"name":"lintstore"}],"output":{"generics":["vec"],"name":"option"}}],[11,"restore_passes","","",995,{"inputs":[{"name":"lintstore"},{"generics":["vec"],"name":"option"}],"output":null}],[11,"take_passes","","",996,{"inputs":[{"name":"lintstore"}],"output":{"generics":["vec"],"name":"option"}}],[11,"restore_passes","","",996,{"inputs":[{"name":"lintstore"},{"generics":["vec"],"name":"option"}],"output":null}],[11,"require_lang_item","rustc::ty","",655,{"inputs":[{"name":"self"},{"name":"langitem"}],"output":{"name":"defid"}}],[11,"skip_stability_check_due_to_privacy","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"eval_stability","","Evaluates the stability of an item.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"generics":["nodeid"],"name":"option"},{"name":"span"}],"output":{"name":"evalresult"}}],[11,"check_stability","","Checks if an item is stable or error out.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"generics":["nodeid"],"name":"option"},{"name":"span"}],"output":null}],[11,"lookup_deprecation","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["deprecation"],"name":"option"}}],[11,"recursive_type_with_infinite_size_error","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"diagnosticbuilder"}}],[11,"report_object_safety_error","","",655,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"generics":["objectsafetyviolation"],"name":"vec"}],"output":{"name":"diagnosticbuilder"}}],[11,"astconv_object_safety_violations","","Returns the object safety violations that affect astconv - currently, Self in supertraits. This is needed because `object_safety_violations` can't be used during type collection.",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["objectsafetyviolation"],"name":"vec"}}],[11,"object_safety_violations","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["objectsafetyviolation"],"name":"vec"}}],[11,"object_safety_violations_for_trait","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["objectsafetyviolation"],"name":"vec"}}],[11,"predicates_reference_self","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"trait_has_sized_self","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"generics_require_sized_self","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"object_safety_violation_for_method","","Returns `Some(_)` if this method makes the containing trait not object safe.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"associateditem"}],"output":{"generics":["methodviolationcode"],"name":"option"}}],[11,"is_vtable_safe_method","","We say a method is vtable safe if it can be invoked on a trait object.  Note that object-safe traits can have some non-vtable-safe methods, so long as they require `Self:Sized` or otherwise ensure that they cannot be used when `Self=Trait`.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"associateditem"}],"output":{"name":"bool"}}],[11,"virtual_call_violation_for_method","","Returns `Some(_)` if this method cannot be called on a trait object; this does not necessarily imply that the enclosing trait is not object safe, because the method might have a where clause `Self:Sized`.",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"associateditem"}],"output":{"generics":["methodviolationcode"],"name":"option"}}],[11,"contains_illegal_self_type_reference","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"derived_cause","rustc::traits","Creates a cause for obligations that are derived from `obligation` by a recursive search (e.g., for a builtin bound, or eventually a `auto trait Foo`). If `obligation` is itself a derived obligation, this is just a clone, but otherwise we create a \"derived obligation\" cause so as to keep track of the original root obligation for error reporting.",634,null],[11,"subst_and_normalize_erasing_regions","rustc::ty","Monomorphizes a type from the AST by first applying the in-scope substitutions and then normalizing any associated types.",655,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"paramenv"},{"name":"t"}],"output":{"name":"t"}}],[11,"predicate_for_trait_def","","",655,null],[11,"upcast_choices","","Cast a trait reference into a reference to one of its super traits; returns `None` if `target_trait_def_id` is not a supertrait.",655,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"defid"}],"output":{"generics":["polytraitref"],"name":"vec"}}],[11,"count_own_vtable_entries","","Given a trait `trait_ref`, returns the number of vtable entries that come from `trait_ref`, excluding its supertraits. Used in computing the vtable base for an upcast trait of a trait object.",655,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"usize"}}],[11,"get_vtable_index_of_object_method","","Given an upcast trait object described by `object`, returns the index of the method `method_def_id` (which should be part of `object.upcast_trait_ref`) within the vtable for `object`.",655,{"inputs":[{"name":"self"},{"name":"vtableobjectdata"},{"name":"defid"}],"output":{"name":"usize"}}],[11,"closure_trait_ref_and_return_type","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"ty"},{"name":"polyfnsig"},{"name":"tupleargumentsflag"}],"output":{"name":"binder"}}],[11,"generator_trait_ref_and_outputs","","",655,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"ty"},{"name":"polygensig"}],"output":{"name":"binder"}}],[11,"impl_is_default","","",655,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"impl_item_is_final","","",655,{"inputs":[{"name":"self"},{"name":"nodeitem"}],"output":{"name":"bool"}}],[11,"intern","","",686,null],[11,"intern","","",686,null],[11,"intern","","",686,null],[11,"normalize_erasing_regions","","Erase the regions in `value` and then fully normalize all the types found within. The result will also have regions erased.",655,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"t"}],"output":{"name":"t"}}],[11,"normalize_erasing_late_bound_regions","","If you have a `Binder<T>`, you can do this to strip out the late-bound regions and then normalize the result, yielding up a `T` (with regions erased). This is appropriate when the binder is being instantiated at the call site.",655,{"inputs":[{"name":"self"},{"name":"paramenv"},{"name":"binder"}],"output":{"name":"t"}}],[11,"variant","","",976,null],[11,"layout_of","rustc::ty::maps","Computes the layout of a type. Note that this implicitly executes in \"reveal all\" mode.",760,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"paramenvand"}],"output":{"generics":["tylayout","layouterror"],"name":"result"}}],[11,"for_variant","rustc::ty","",976,{"inputs":[{"name":"tylayout"},{"name":"c"},{"name":"usize"}],"output":{"name":"tylayout"}}],[11,"field","","",976,null],[11,"map_crate","rustc::ty::sty","",968,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",968,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"map_crate","rustc::ty","",976,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",976,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"from_cycle_error","","",976,{"inputs":[{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"describe","rustc::ty::maps::queries","",922,{"inputs":[{"name":"tyctxt"},{"name":"canonicalprojectiongoal"}],"output":{"name":"string"}}],[11,"describe","","",924,{"inputs":[{"name":"tyctxt"},{"name":"canonicaltygoal"}],"output":{"name":"string"}}],[11,"describe","","",923,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"describe","","",925,{"inputs":[{"name":"tyctxt"},{"name":"canonicalpredicategoal"}],"output":{"name":"string"}}],[11,"describe","","",851,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"describe","","",852,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"describe","","",853,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"describe","","",854,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"describe","","",855,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"describe","","",787,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",921,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"string"}}],[11,"describe","","",788,null],[11,"describe","","",819,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",876,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",822,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",823,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",796,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",799,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",829,{"inputs":[{"name":"tyctxt"},{"name":"instancedef"}],"output":{"name":"string"}}],[11,"describe","","",826,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",815,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",827,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",824,{"inputs":[{"name":"tyctxt"},{"generics":["globalid"],"name":"paramenvand"}],"output":{"name":"string"}}],[11,"cache_on_disk","","",824,null],[11,"try_load_from_disk","","",824,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"describe","","",805,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",831,{"inputs":[{"name":"tyctxt"},{"name":"instance"}],"output":{"name":"string"}}],[11,"cache_on_disk","","",831,null],[11,"try_load_from_disk","","",831,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"describe","","",832,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",833,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",834,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",835,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",836,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",874,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",838,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",840,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",841,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",842,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"cache_on_disk","","",842,null],[11,"try_load_from_disk","","",842,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"describe","","",843,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",844,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",846,null],[11,"cache_on_disk","","",846,null],[11,"try_load_from_disk","","",846,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"describe","","",847,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",849,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",794,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",856,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",857,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",858,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",859,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",864,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",868,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",865,null],[11,"describe","","",866,{"inputs":[{"name":"tyctxt"},{"name":"defindex"}],"output":{"name":"string"}}],[11,"describe","","",863,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",862,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",861,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",860,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",873,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",878,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",879,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",880,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",881,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",882,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",883,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",884,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",885,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",886,null],[11,"describe","","",887,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",892,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",893,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",894,{"inputs":[{"name":"tyctxt"},{"name":"defindex"}],"output":{"name":"string"}}],[11,"describe","","",895,{"inputs":[{"name":"tyctxt"},{"name":"defindex"}],"output":{"name":"string"}}],[11,"describe","","",896,{"inputs":[{"name":"tyctxt"},{"name":"defindex"}],"output":{"name":"string"}}],[11,"describe","","",898,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",899,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",902,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",903,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",904,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",905,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",906,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",907,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",908,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",911,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",912,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",914,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",913,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",915,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",916,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",918,{"inputs":[{"name":"tyctxt"},{"name":"internedstring"}],"output":{"name":"string"}}],[11,"describe","","",919,{"inputs":[{"name":"tyctxt"},{"name":"internedstring"}],"output":{"name":"string"}}],[11,"describe","","",920,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",845,{"inputs":[{"name":"tyctxt"},{"name":"polytraitref"}],"output":{"name":"string"}}],[11,"describe","","",929,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"cache_on_disk","","",816,null],[11,"try_load_from_disk","","",816,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",810,null],[11,"try_load_from_disk","","",810,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"describe","","",926,null],[11,"describe","","",927,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",928,{"inputs":[{"name":"tyctxt"},{"name":"instancedef"}],"output":{"name":"string"}}],[11,"describe","","",932,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"cache_on_disk","","",784,null],[11,"try_load_from_disk","","",784,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"describe","","",930,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[11,"describe","","",931,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"}],"output":{"name":"string"}}],[11,"describe","","",933,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"describe","","",888,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"string"}}],[11,"cache_on_disk","","",811,null],[11,"try_load_from_disk","","",811,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",820,null],[11,"try_load_from_disk","","",820,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",821,null],[11,"try_load_from_disk","","",821,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",806,null],[11,"try_load_from_disk","","",806,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",825,null],[11,"try_load_from_disk","","",825,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",830,null],[11,"try_load_from_disk","","",830,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",783,null],[11,"try_load_from_disk","","",783,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",785,null],[11,"try_load_from_disk","","",785,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",817,null],[11,"try_load_from_disk","","",817,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",837,null],[11,"try_load_from_disk","","",837,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"cache_on_disk","","",848,null],[11,"try_load_from_disk","","",848,{"inputs":[{"name":"tyctxt"},{"name":"serializeddepnodeindex"}],"output":{"name":"option"}}],[11,"relate","rustc::ty","",976,{"inputs":[{"name":"r"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"relate","rustc::ty::sty","",993,{"inputs":[{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"generics":["region"],"name":"relateresult"}}],[11,"relate","rustc::ty::subst","",940,{"inputs":[{"name":"r"},{"name":"kind"},{"name":"kind"}],"output":{"generics":["kind"],"name":"relateresult"}}],[11,"with_self_ty","rustc::ty::sty","Object types don't have a self-type specified. Therefore, when we convert the principal trait-ref into a normal trait-ref, you must give some self-type. A common choice is `mk_err()` or some skolemized type.",969,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"polytraitref"}}],[11,"lift_to_tcx","rustc::ty","",976,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["ty"],"name":"option"}}],[11,"lift_to_tcx","rustc::ty::sty","",993,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["region"],"name":"option"}}],[11,"super_fold_with","rustc::ty","",976,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fold_with","","",976,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",976,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"visit_with","","",976,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"super_fold_with","rustc::ty::sty","",993,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fold_with","","",993,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_visit_with","","",993,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"visit_with","","",993,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}]],"paths":[[3,"CFG"],[3,"CFGEdgeData"],[4,"CFGNodeData"],[3,"CFGBuilder"],[3,"BlockScope"],[3,"LoopScope"],[4,"ScopeCfKind"],[3,"LabelledCFG"],[3,"DepTrackingMap"],[3,"DepNode"],[3,"WorkProductId"],[3,"DepGraph"],[3,"WorkProduct"],[3,"DepNodeIndex"],[3,"PreviousDepGraph"],[3,"DepGraphQuery"],[3,"AssertDepGraphSafe"],[3,"SerializedDepGraph"],[3,"SerializedDepNodeIndex"],[4,"DepKind"],[4,"DepConstructor"],[4,"DepNodeColor"],[4,"OpenTask"],[4,"WorkProductFileKind"],[3,"DepNodeFilter"],[3,"EdgeFilter"],[8,"DepNodeParams"],[8,"DepTrackingMapConfig"],[3,"DepGraphData"],[3,"CurrentDepGraph"],[3,"RegularOpenTask"],[3,"AnonOpenTask"],[3,"DepNodeColorMap"],[3,"HirId"],[3,"ItemLocalId"],[3,"Label"],[3,"Lifetime"],[3,"LifetimeDef"],[3,"Path"],[3,"PathSegment"],[3,"PathParameters"],[3,"TyParam"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"MacroDef"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"BodyId"],[3,"Body"],[3,"Expr"],[3,"Destination"],[3,"MutTy"],[3,"MethodSig"],[3,"TraitItemId"],[3,"TraitItem"],[3,"ImplItemId"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"ExistTy"],[3,"InlineAsmOutput"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"GlobalAsm"],[3,"EnumDef"],[3,"Variant_"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField"],[3,"ItemId"],[3,"Item"],[3,"TraitItemRef"],[3,"ImplItemRef"],[3,"ForeignItem"],[3,"Freevar"],[3,"TraitCandidate"],[3,"TransFnAttrs"],[3,"TransFnAttrFlags"],[4,"LifetimeName"],[4,"TyParamBound"],[4,"TraitBoundModifier"],[4,"GenericParam"],[4,"UnsafeGeneric"],[4,"SyntheticTyParamKind"],[4,"WherePredicate"],[4,"BindingAnnotation"],[4,"RangeEnd"],[4,"PatKind"],[4,"Mutability"],[4,"BinOp_"],[4,"UnOp"],[4,"Stmt_"],[4,"Decl_"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"BodyOwnerKind"],[4,"Expr_"],[4,"QPath"],[4,"LocalSource"],[4,"MatchSource"],[4,"LoopSource"],[4,"LoopIdError"],[4,"LoopIdResult"],[4,"ScopeTarget"],[4,"GeneratorMovability"],[4,"CaptureClause"],[4,"TraitMethod"],[4,"TraitItemKind"],[4,"ImplItemKind"],[4,"PrimTy"],[4,"Ty_"],[4,"IsAuto"],[4,"Unsafety"],[4,"Constness"],[4,"Defaultness"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"UseKind"],[4,"Visibility"],[4,"VariantData"],[4,"Item_"],[4,"AssociatedItemKind"],[4,"ForeignItem_"],[3,"CheckAttrVisitor"],[4,"Target"],[3,"PathResolution"],[3,"Export"],[4,"CtorKind"],[4,"Def"],[3,"CrateNum"],[3,"DefIndex"],[3,"DefId"],[3,"LocalDefId"],[4,"DefIndexAddressSpace"],[3,"IdRange"],[3,"IdRangeComputingVisitor"],[4,"FnKind"],[4,"NestedVisitorMap"],[8,"Visitor"],[3,"DeepVisitor"],[8,"ItemLikeVisitor"],[3,"LoweringContext"],[3,"LoweredNodeId"],[4,"ImplTraitContext"],[4,"ParamMode"],[4,"ParenthesizedGenericArgs"],[4,"AnonymousLifetimeMode"],[8,"Resolver"],[3,"DefCollector"],[3,"MacroInvocationData"],[3,"Forest"],[3,"Map"],[3,"NodesMatchingSuffix"],[4,"Node"],[4,"MapEntry"],[3,"FnLikeNode"],[3,"ItemFnParts"],[3,"ClosureParts"],[4,"Code"],[8,"MaybeFnLike"],[3,"NodeCollector"],[3,"HirItemLike"],[3,"DefPathTable"],[3,"Definitions"],[3,"DefKey"],[3,"DisambiguatedDefPathData"],[3,"DefPath"],[3,"DefPathHash"],[4,"DefPathData"],[4,"GlobalMetaDataKind"],[3,"HirIdValidator"],[3,"OuterVisitor"],[8,"Named"],[3,"EnumerateAndAdjust"],[8,"EnumerateAndAdjustIterator"],[3,"State"],[4,"AnnNode"],[4,"Nested"],[8,"PpAnn"],[3,"Svh"],[8,"GenericParamsExt"],[3,"Fingerprint"],[3,"CachingCodemapView"],[3,"StableHashingContext"],[4,"NodeIdHashingMode"],[3,"CacheEntry"],[3,"BodyResolver"],[8,"StableHashingContextProvider"],[4,"AllocDiscriminant"],[3,"TypeFreshener"],[3,"InferOk"],[3,"InferCtxt"],[3,"TypeTrace"],[3,"RegionObligation"],[3,"InferCtxtBuilder"],[3,"CombinedSnapshot"],[4,"ValuePairs"],[4,"SubregionOrigin"],[4,"ParameterOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"NLLRegionVariableOrigin"],[4,"FixupError"],[3,"AnonTypeDecl"],[3,"ReverseMapper"],[3,"Instantiator"],[3,"At"],[3,"Trace"],[8,"ToTrace"],[3,"Canonical"],[3,"CanonicalVarValues"],[3,"CanonicalVarInfo"],[3,"QueryResult"],[3,"CanonicalizeAllFreeRegions"],[3,"Canonicalizer"],[3,"CanonicalVarValuesSubst"],[4,"CanonicalVarKind"],[4,"CanonicalTyVarKind"],[4,"Certainty"],[8,"Canonicalize"],[6,"CanonicalVarInfos"],[3,"CombineFields"],[3,"Generalizer"],[3,"Generalization"],[4,"RelationDir"],[8,"RelateResultCompare"],[3,"Equate"],[4,"FailureCode"],[3,"FindLocalByTypeVisitor"],[3,"NiceRegionError"],[3,"FindNestedTypeVisitor"],[3,"TyPathVisitor"],[3,"AnonymousArgInfo"],[3,"FreeRegionInfo"],[3,"RegionFudger"],[3,"Glb"],[3,"HrMatchResult"],[8,"LatticeDir"],[3,"Lub"],[3,"RegionConstraintCollector"],[3,"RegionConstraintData"],[3,"Verify"],[3,"TwoRegions"],[3,"RegionVariableInfo"],[3,"RegionSnapshot"],[3,"TaintDirections"],[4,"Constraint"],[4,"GenericKind"],[4,"VerifyBound"],[4,"UndoLogEntry"],[4,"CombineMapType"],[3,"TaintSet"],[3,"LexicalRegionResolutions"],[3,"RegionAndOrigin"],[3,"LexicalResolver"],[4,"VarValue"],[4,"RegionResolutionError"],[3,"ConstraintGraph"],[4,"Node"],[4,"Edge"],[3,"OutlivesEnvironment"],[3,"FreeRegionMap"],[8,"FreeRegionRelations"],[4,"OutlivesBound"],[3,"TypeOutlives"],[3,"OpportunisticTypeResolver"],[3,"OpportunisticTypeAndRegionResolver"],[3,"UnresolvedTypeFinder"],[3,"FullTypeResolver"],[3,"Sub"],[3,"TypeVariableTable"],[3,"TypeVariableData"],[3,"Snapshot"],[3,"Instantiate"],[3,"TyVidEqKey"],[4,"TypeVariableOrigin"],[4,"TypeVariableValue"],[3,"Delegate"],[3,"RegionVidKey"],[8,"ToType"],[3,"LateContext"],[3,"EarlyContext"],[3,"LintStore"],[3,"FutureIncompatibleInfo"],[3,"BufferedEarlyLint"],[3,"Lint"],[3,"LintId"],[3,"LintLevelSets"],[3,"LintLevelMap"],[3,"LintBuffer"],[3,"LintLevelMapBuilder"],[4,"Level"],[4,"LintSource"],[4,"BuiltinLintDiagnostics"],[3,"HardwiredLints"],[3,"LintSession"],[4,"TargetLint"],[4,"FindLintError"],[4,"CheckLintNameResult"],[8,"LintPassObject"],[8,"LintContext"],[3,"LintLevelsBuilder"],[3,"BuilderPush"],[4,"LintSet"],[8,"LintPass"],[8,"LateLintPass"],[8,"EarlyLintPass"],[4,"AllocatorKind"],[3,"BorrowCheckResult"],[3,"ExprUseVisitor"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[8,"Delegate"],[3,"ConstEvalErr"],[3,"FrameInfo"],[4,"ConstVal"],[4,"ErrKind"],[4,"ConstEvalErrDescription"],[3,"LinkMeta"],[3,"CrateSource"],[3,"NativeLibrary"],[3,"ForeignModule"],[3,"ExternCrate"],[3,"EncodedMetadata"],[4,"DepKind"],[4,"LibSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[4,"LoadedMacro"],[4,"ExternCrateSource"],[8,"MetadataLoader"],[8,"CrateStore"],[8,"CrateLoader"],[3,"DummyCrateStore"],[3,"DataFlowContext"],[3,"PropagationContext"],[4,"EntryOrExit"],[4,"KillFrom"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[4,"Linkage"],[3,"EntryContext"],[4,"SymbolExportLevel"],[4,"ExportedSymbol"],[3,"RegionRelations"],[3,"ItemVisitor"],[3,"ExprVisitor"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[4,"LangItem"],[3,"Variable"],[3,"LiveNode"],[3,"CaptureInfo"],[3,"LocalInfo"],[3,"IrMaps"],[3,"Users"],[3,"Specials"],[3,"Liveness"],[4,"LoopKind"],[4,"LiveNodeKind"],[4,"VarKind"],[3,"Upvar"],[3,"FieldIndex"],[3,"cmt_"],[3,"MemCategorizationContext"],[4,"Categorization"],[4,"PointerKind"],[4,"InteriorKind"],[4,"InteriorOffsetKind"],[4,"MutabilityCategory"],[4,"Note"],[4,"ImmutabilityBlame"],[4,"Aliasability"],[4,"AliasableReason"],[8,"ast_node"],[3,"AccessLevels"],[4,"AccessLevel"],[3,"ReachableContext"],[3,"CollectPrivateImplItemsVisitor"],[3,"ReachableSet"],[3,"Scope"],[3,"BlockRemainder"],[3,"FirstStatementIndex"],[3,"ScopeTree"],[3,"Context"],[3,"RegionResolutionVisitor"],[3,"ExprLocatorVisitor"],[4,"ScopeData"],[3,"NamedRegionMap"],[3,"ResolveLifetimes"],[3,"LifetimeContext"],[3,"ElisionFailureInfo"],[3,"Original"],[3,"Shadower"],[4,"LifetimeDefOrigin"],[4,"LifetimeUseSet"],[4,"Region"],[4,"Set1"],[4,"Scope"],[4,"Elide"],[4,"ShadowKind"],[3,"DeprecationEntry"],[3,"Index"],[3,"Annotator"],[3,"MissingStabilityAnnotations"],[3,"Checker"],[4,"StabilityLevel"],[4,"AnnotationKind"],[4,"EvalResult"],[3,"Context"],[3,"Mir"],[3,"VisibilityScopeInfo"],[3,"SourceInfo"],[3,"Local"],[3,"LocalDecl"],[3,"UpvarDecl"],[3,"BasicBlock"],[3,"BasicBlockData"],[3,"Terminator"],[3,"Statement"],[3,"ValidationOperand"],[3,"Static"],[3,"Projection"],[3,"Field"],[3,"VisibilityScope"],[3,"VisibilityScopeData"],[3,"Constant"],[3,"Promoted"],[3,"Location"],[3,"UnsafetyViolation"],[3,"UnsafetyCheckResult"],[3,"GeneratorLayout"],[3,"BorrowCheckResult"],[3,"ClosureRegionRequirements"],[3,"ClosureOutlivesRequirement"],[4,"Safety"],[4,"ClearCrossCrate"],[4,"Mutability"],[4,"BorrowKind"],[4,"LocalKind"],[4,"TerminatorKind"],[4,"StatementKind"],[4,"ValidationOp"],[4,"Place"],[4,"ProjectionElem"],[4,"Operand"],[4,"Rvalue"],[4,"CastKind"],[4,"AggregateKind"],[4,"BinOp"],[4,"NullOp"],[4,"UnOp"],[4,"Literal"],[4,"UnsafetyViolationKind"],[4,"ClosureOutlivesSubject"],[3,"Cache"],[4,"PlaceTy"],[4,"RvalueInitializationState"],[4,"TyContext"],[4,"PlaceContext"],[8,"Visitor"],[8,"MutVisitor"],[8,"MirVisitable"],[3,"Preorder"],[3,"Postorder"],[3,"ReversePostorder"],[3,"EvalError"],[3,"Pointer"],[3,"DynamicLifetime"],[3,"GlobalId"],[3,"MemoryPointer"],[3,"AllocId"],[3,"Allocation"],[3,"UndefMask"],[4,"EvalErrorKind"],[4,"PrimVal"],[4,"PrimValKind"],[4,"Value"],[4,"Lock"],[4,"AccessKind"],[4,"AllocKind"],[8,"PointerArithmetic"],[3,"CodegenUnit"],[3,"Stats"],[4,"MonoItem"],[4,"Linkage"],[4,"Visibility"],[8,"HasLocalDecls"],[3,"CodeStats"],[3,"FieldInfo"],[3,"TypeSizeInfo"],[3,"VariantInfo"],[3,"Session"],[3,"PerfStats"],[3,"CrateDisambiguator"],[4,"DataTypeKind"],[4,"SizeKind"],[4,"DiagnosticBuilderMethod"],[4,"DiagnosticMessageId"],[4,"IncrCompSession"],[4,"CompileIncomplete"],[3,"Config"],[3,"OutputTypes"],[3,"Externs"],[3,"Options"],[3,"OutputFilenames"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[3,"RustcOptGroup"],[4,"Sanitizer"],[4,"OptLevel"],[4,"Lto"],[4,"DebugInfoLevel"],[4,"OutputType"],[4,"ErrorOutputType"],[4,"PrintRequest"],[4,"BorrowckMode"],[4,"Input"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[4,"OptionStability"],[8,"DepTrackingHash"],[3,"FileSearch"],[4,"FileMatch"],[3,"SearchPaths"],[3,"Iter"],[4,"PathKind"],[3,"OverlapResult"],[3,"FulfillmentContext"],[3,"PendingPredicateObligation"],[3,"MismatchedProjectionTypes"],[3,"ProjectionCache"],[3,"ProjectionCacheSnapshot"],[3,"Normalized"],[3,"OnUnimplementedDirective"],[3,"OnUnimplementedNote"],[3,"EvaluationCache"],[3,"SelectionContext"],[3,"SelectionCache"],[3,"OverlapError"],[3,"SpecializesCache"],[3,"SupertraitDefIds"],[3,"Obligation"],[3,"ObligationCause"],[3,"DerivedObligationCause"],[3,"ProgramClause"],[3,"FulfillmentError"],[3,"VtableImplData"],[3,"VtableGeneratorData"],[3,"VtableClosureData"],[3,"VtableAutoImplData"],[3,"VtableBuiltinData"],[3,"VtableObjectData"],[3,"VtableFnPointerData"],[4,"OrphanCheckErr"],[4,"Reveal"],[4,"ObjectSafetyViolation"],[4,"MethodViolationCode"],[4,"EvaluationResult"],[4,"IntercrateAmbiguityCause"],[4,"IntercrateMode"],[4,"TraitQueryMode"],[4,"ObligationCauseCode"],[4,"WhereClauseAtom"],[4,"DomainGoal"],[4,"QuantifierKind"],[4,"Goal"],[4,"Clause"],[4,"SelectionError"],[4,"FulfillmentErrorCode"],[4,"Vtable"],[3,"Graph"],[3,"Ancestors"],[3,"NodeItem"],[4,"Node"],[4,"InCrate"],[4,"Conflict"],[4,"ArgKind"],[8,"TraitEngine"],[3,"FulfillProcessor"],[3,"AssociatedTypeNormalizer"],[3,"Progress"],[3,"ProjectionCacheKey"],[4,"ProjectionTyError"],[4,"ProjectionTyCandidate"],[4,"ProjectionTyCandidateSet"],[4,"ProjectedTy"],[4,"ProjectionCacheEntry"],[3,"OnUnimplementedFormatString"],[3,"TraitObligationStack"],[3,"SelectionCandidateSet"],[3,"EvaluatedCandidate"],[3,"TraitObligationStackList"],[3,"WithDepNode"],[4,"SelectionCandidate"],[4,"BuiltinImplConditions"],[3,"OverflowError"],[3,"Children"],[4,"Inserted"],[3,"TraitSelectionCache"],[3,"ProjectionCache"],[3,"PredicateSet"],[3,"Elaborator"],[3,"FilterToTraits"],[4,"TupleArgumentsFlag"],[3,"DropckOutlivesResult"],[3,"DtorckConstraint"],[3,"NormalizationResult"],[3,"QueryNormalizer"],[3,"NormalizeAfterErasingRegionsFolder"],[3,"NoSolution"],[6,"TraitObligation"],[3,"Binder"],[3,"CanonicalVar"],[3,"DebruijnIndex"],[3,"FnSig"],[3,"GenSig"],[3,"ParamTy"],[3,"ProjectionTy"],[3,"ClosureSubsts"],[3,"GeneratorInterior"],[3,"TypeAndMut"],[3,"TraitRef"],[3,"ExistentialTraitRef"],[3,"ExistentialProjection"],[3,"Const"],[3,"EarlyBoundRegion"],[3,"FreeRegion"],[3,"TyVid"],[3,"IntVid"],[3,"FloatVid"],[3,"RegionVid"],[3,"TyCtxt"],[3,"GlobalArenas"],[3,"AllArenas"],[3,"TypeckTables"],[3,"InterpretInterner"],[3,"Instance"],[3,"CrateAnalysis"],[3,"Resolutions"],[3,"ImplHeader"],[3,"AssociatedItem"],[3,"CrateVariancesMap"],[3,"CReaderCacheKey"],[3,"TypeFlags"],[3,"TyS"],[3,"Slice"],[3,"UpvarId"],[3,"UpvarBorrow"],[3,"ClosureUpvar"],[3,"FloatVarValue"],[3,"TypeParameterDef"],[3,"RegionParameterDef"],[3,"Generics"],[3,"GenericPredicates"],[3,"CratePredicatesMap"],[3,"TraitPredicate"],[3,"OutlivesPredicate"],[3,"SubtypePredicate"],[3,"ProjectionPredicate"],[3,"InstantiatedPredicates"],[3,"UniverseIndex"],[3,"ParamEnv"],[3,"ParamEnvAnd"],[3,"Destructor"],[3,"AdtFlags"],[3,"VariantDef"],[3,"FieldDef"],[3,"AdtDef"],[3,"ReprFlags"],[3,"ReprOptions"],[3,"CrateInherentImpls"],[3,"SymbolName"],[4,"InferTy"],[4,"ExistentialPredicate"],[4,"TypeVariants"],[4,"BoundRegion"],[4,"RegionKind"],[4,"InstanceDef"],[4,"AssociatedItemContainer"],[4,"AssociatedKind"],[4,"Visibility"],[4,"Variance"],[4,"BorrowKind"],[4,"UpvarCapture"],[4,"IntVarValue"],[4,"Predicate"],[4,"VariantDiscr"],[4,"AdtKind"],[4,"ClosureKind"],[4,"Attributes"],[3,"ImplicitCtxt"],[3,"Adjustment"],[3,"OverloadedDeref"],[3,"CoerceUnsizedInfo"],[4,"Adjust"],[4,"AllowTwoPhase"],[4,"AutoBorrowMutability"],[4,"AutoBorrow"],[4,"CustomCoerceUnsized"],[4,"BindingMode"],[4,"IntTy"],[4,"CastTy"],[4,"CastKind"],[8,"EncodableWithShorthand"],[8,"TyEncoder"],[8,"TyDecoder"],[3,"ExpectedFound"],[4,"TypeError"],[4,"UnconstrainedNumeric"],[3,"RegionEraserVisitor"],[4,"SimplifiedTypeGen"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionReplacer"],[3,"HasEscapingRegionsVisitor"],[3,"HasTypeFlagsVisitor"],[3,"LateBoundRegionsCollector"],[8,"TypeFoldable"],[8,"TypeFolder"],[8,"TypeVisitor"],[3,"DefIdForest"],[3,"LocalPathBuffer"],[4,"RootMode"],[8,"ItemPathBuffer"],[3,"LayoutCx"],[4,"LayoutError"],[4,"SizeSkeleton"],[8,"IntegerExt"],[8,"PrimitiveExt"],[8,"HasTyCtxt"],[8,"MaybeResult"],[3,"Match"],[3,"QueryJob"],[3,"QueryInfo"],[3,"OnDiskCache"],[3,"Maps"],[3,"TyCtxtAt"],[3,"Providers"],[4,"Query"],[3,"QueryMap"],[3,"QueryValue"],[3,"JobOwner"],[3,"CycleError"],[4,"TryGetJob"],[4,"QueryResult"],[8,"Key"],[6,"CanonicalProjectionGoal"],[6,"CanonicalTyGoal"],[6,"CanonicalPredicateGoal"],[8,"Value"],[8,"QueryConfig"],[8,"QueryDescription"],[3,"Footer"],[3,"FileMapIndex"],[3,"AbsoluteBytePos"],[3,"CacheDecoder"],[3,"CacheEncoder"],[3,"IntEncodedWithFixedSize"],[8,"DecoderWithPosition"],[3,"type_of"],[3,"generics_of"],[3,"predicates_of"],[3,"explicit_predicates_of"],[3,"super_predicates_of"],[3,"type_param_predicates"],[3,"trait_def"],[3,"adt_def"],[3,"adt_destructor"],[3,"adt_sized_constraint"],[3,"adt_dtorck_constraint"],[3,"is_const_fn"],[3,"is_foreign_item"],[3,"crate_variances"],[3,"variances_of"],[3,"inferred_outlives_of"],[3,"inferred_outlives_crate"],[3,"associated_item_def_ids"],[3,"associated_item"],[3,"impl_trait_ref"],[3,"impl_polarity"],[3,"inherent_impls"],[3,"mir_keys"],[3,"mir_const_qualif"],[3,"mir_built"],[3,"mir_const"],[3,"mir_validated"],[3,"optimized_mir"],[3,"unsafety_check_result"],[3,"unsafe_derive_on_repr_packed"],[3,"fn_sig"],[3,"coerce_unsized_info"],[3,"typeck_item_bodies"],[3,"typeck_tables_of"],[3,"used_trait_imports"],[3,"has_typeck_tables"],[3,"coherent_trait"],[3,"borrowck"],[3,"mir_borrowck"],[3,"crate_inherent_impls"],[3,"crate_inherent_impls_overlap_check"],[3,"const_eval"],[3,"check_match"],[3,"privacy_access_levels"],[3,"reachable_set"],[3,"region_scope_tree"],[3,"mir_shims"],[3,"def_symbol_name"],[3,"symbol_name"],[3,"describe_def"],[3,"def_span"],[3,"lookup_stability"],[3,"lookup_deprecation_entry"],[3,"item_attrs"],[3,"trans_fn_attrs"],[3,"fn_arg_names"],[3,"rendered_const"],[3,"impl_parent"],[3,"trait_of_item"],[3,"const_is_rvalue_promotable_to_static"],[3,"rvalue_promotable_map"],[3,"is_mir_available"],[3,"vtable_methods"],[3,"trans_fulfill_obligation"],[3,"trait_impls_of"],[3,"specialization_graph_of"],[3,"is_object_safe"],[3,"param_env"],[3,"is_copy_raw"],[3,"is_sized_raw"],[3,"is_freeze_raw"],[3,"needs_drop_raw"],[3,"layout_raw"],[3,"dylib_dependency_formats"],[3,"is_panic_runtime"],[3,"is_compiler_builtins"],[3,"has_global_allocator"],[3,"is_sanitizer_runtime"],[3,"is_profiler_runtime"],[3,"panic_strategy"],[3,"is_no_builtins"],[3,"extern_crate"],[3,"specializes"],[3,"in_scope_traits_map"],[3,"module_exports"],[3,"lint_levels"],[3,"impl_defaultness"],[3,"check_item_well_formed"],[3,"check_trait_item_well_formed"],[3,"check_impl_item_well_formed"],[3,"reachable_non_generics"],[3,"is_reachable_non_generic"],[3,"is_unreachable_local_definition"],[3,"upstream_monomorphizations"],[3,"upstream_monomorphizations_for"],[3,"native_libraries"],[3,"foreign_modules"],[3,"plugin_registrar_fn"],[3,"derive_registrar_fn"],[3,"crate_disambiguator"],[3,"crate_hash"],[3,"original_crate_name"],[3,"extra_filename"],[3,"implementations_of_trait"],[3,"all_trait_implementations"],[3,"dllimport_foreign_items"],[3,"is_dllimport_foreign_item"],[3,"is_statically_included_foreign_item"],[3,"native_library_kind"],[3,"link_args"],[3,"resolve_lifetimes"],[3,"named_region_map"],[3,"is_late_bound_map"],[3,"object_lifetime_defaults_map"],[3,"visibility"],[3,"dep_kind"],[3,"crate_name"],[3,"item_children"],[3,"extern_mod_stmt_cnum"],[3,"get_lang_items"],[3,"defined_lang_items"],[3,"missing_lang_items"],[3,"visible_parent_map"],[3,"missing_extern_crate_item"],[3,"used_crate_source"],[3,"postorder_cnums"],[3,"freevars"],[3,"maybe_unused_trait_import"],[3,"maybe_unused_extern_crates"],[3,"stability_index"],[3,"all_crate_nums"],[3,"all_traits"],[3,"exported_symbols"],[3,"collect_and_partition_translation_items"],[3,"is_translated_item"],[3,"codegen_unit"],[3,"compile_codegen_unit"],[3,"output_filenames"],[3,"erase_regions_ty"],[3,"normalize_projection_ty"],[3,"normalize_ty_after_erasing_regions"],[3,"dropck_outlives"],[3,"evaluate_obligation"],[3,"substitute_normalize_and_test_predicates"],[3,"target_features_whitelist"],[3,"instance_def_size_estimate"],[3,"features_query"],[3,"program_clauses_for"],[3,"program_clauses_for_env"],[3,"wasm_custom_sections"],[3,"wasm_import_module_map"],[4,"Component"],[3,"GeneratorWitness"],[4,"Cause"],[8,"TypeRelation"],[8,"Relate"],[3,"Steal"],[3,"Kind"],[3,"SubstFolder"],[4,"UnpackedKind"],[8,"Subst"],[6,"Substs"],[3,"TraitDef"],[3,"TraitImpls"],[3,"TypeWalker"],[3,"WfPredicates"],[4,"Elaborate"],[3,"Discr"],[3,"TypeIdHasher"],[4,"CopyImplementationError"],[4,"Representability"],[4,"ExplicitSelf"],[8,"IntTypeExt"],[3,"CtxtInterners"],[3,"CommonTypes"],[3,"LocalTableInContext"],[3,"LocalTableInContextMut"],[3,"GlobalCtxt"],[3,"InterpretInternerInner"],[3,"Interned"],[8,"Lift"],[8,"InternAs"],[8,"InternIteratorElement"],[3,"FlagComputation"],[3,"SplitClosureSubsts"],[6,"PolyTraitRef"],[6,"PolyExistentialTraitRef"],[6,"PolyGenSig"],[6,"PolyFnSig"],[6,"PolyExistentialProjection"],[8,"DefIdTree"],[8,"ToPolyTraitRef"],[8,"ToPredicate"],[6,"Ty"],[6,"PolyTraitPredicate"],[6,"PolyProjectionPredicate"],[6,"PolyRegionOutlivesPredicate"],[6,"PolyTypeOutlivesPredicate"],[3,"DEFAULT_HOOK"],[3,"ProfQDumpParams"],[3,"QueryMsg"],[3,"Indenter"],[4,"ProfileQueriesMsg"],[8,"MemoizationMap"],[3,"ErrorReported"],[3,"LateBoundRegionNameCollector"],[3,"PrintContext"],[8,"Print"],[4,"LinkOrCopy"],[4,"RenameOrCopyRemove"],[6,"Region"],[6,"RelateResult"],[6,"EarlyLintPassObject"],[6,"LateLintPassObject"]]};
searchIndex["rustc_allocator"] = {"doc":"","items":[[3,"AllocatorMethod","rustc_allocator","",null,null],[12,"name","","",0,null],[12,"inputs","","",0,null],[12,"output","","",0,null],[4,"AllocatorTy","","",null,null],[13,"Layout","","",1,null],[13,"Ptr","","",1,null],[13,"ResultPtr","","",1,null],[13,"Unit","","",1,null],[13,"Usize","","",1,null],[0,"expand","","",null,null],[3,"ExpandAllocatorDirectives","rustc_allocator::expand","",null,null],[12,"found","","",2,null],[12,"handler","","",2,null],[12,"sess","","",2,null],[12,"resolver","","",2,null],[3,"AllocFnFactory","","",null,null],[12,"span","","",3,null],[12,"kind","","",3,null],[12,"global","","",3,null],[12,"core","","",3,null],[12,"cx","","",3,null],[5,"modify","","",null,{"inputs":[{"name":"parsesess"},{"name":"resolver"},{"name":"crate"},{"name":"handler"}],"output":{"name":"crate"}}],[11,"fold_item","","",2,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_mac","","",2,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"allocator_fn","","",3,{"inputs":[{"name":"self"},{"name":"allocatormethod"}],"output":{"generics":["item"],"name":"p"}}],[11,"call_allocator","","",3,{"inputs":[{"name":"self"},{"name":"str"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"attrs","","",3,{"inputs":[{"name":"self"}],"output":{"generics":["attribute"],"name":"vec"}}],[11,"arg_ty","","",3,{"inputs":[{"name":"self"},{"name":"allocatorty"},{"name":"vec"},{"name":"fnmut"}],"output":{"generics":["expr"],"name":"p"}}],[11,"ret_ty","","",3,null],[11,"usize","","",3,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ptr_u8","","",3,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ptr_opaque","","",3,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"p"}}],[7,"ALLOCATOR_METHODS","rustc_allocator","",null,null]],"paths":[[3,"AllocatorMethod"],[4,"AllocatorTy"],[3,"ExpandAllocatorDirectives"],[3,"AllocFnFactory"]]};
searchIndex["rustc_apfloat"] = {"doc":"Port of LLVM's APFloat software floating-point implementation from the following C++ sources (please update commit hash when backporting): https://github.com/llvm-mirror/llvm/tree/23efab2bbd424ed13495a420ad8641cb2c6c28f9","items":[[3,"Status","rustc_apfloat","IEEE-754R 7: Default exception handling.",null,null],[12,"bits","","",0,null],[3,"StatusAnd","","",null,null],[12,"status","","",1,null],[12,"value","","",1,null],[3,"ParseError","","",null,null],[12,"0","","",2,null],[4,"Category","","Category of internally-represented number.",null,null],[13,"Infinity","","",3,null],[13,"NaN","","",3,null],[13,"Normal","","",3,null],[13,"Zero","","",3,null],[4,"Round","","IEEE-754R 4.3: Rounding-direction attributes.",null,null],[13,"NearestTiesToEven","","",4,null],[13,"TowardPositive","","",4,null],[13,"TowardNegative","","",4,null],[13,"TowardZero","","",4,null],[13,"NearestTiesToAway","","",4,null],[0,"ieee","","",null,null],[3,"IeeeFloat","rustc_apfloat::ieee","",null,null],[12,"sig","","Absolute significand value (including the integer bit).",5,null],[12,"exp","","The signed unbiased exponent of the value.",5,null],[12,"category","","What kind of floating point number this is.",5,null],[12,"sign","","Sign bit of the number.",5,null],[12,"marker","","",5,null],[3,"HalfS","","",null,null],[3,"SingleS","","",null,null],[3,"DoubleS","","",null,null],[3,"QuadS","","",null,null],[3,"X87DoubleExtendedS","","",null,null],[4,"Loss","","Enum that represents what fraction of the LSB truncated bits of an fp number represent.",null,null],[13,"ExactlyZero","","",6,null],[13,"LessThanHalf","","",6,null],[13,"ExactlyHalf","","",6,null],[13,"MoreThanHalf","","",6,null],[5,"limbs_for_bits","","",null,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[0,"sig","","Implementation details of IeeeFloat significands, such as big integer arithmetic. As a rule of thumb, no functions in this module should dynamically allocate.",null,null],[5,"is_all_zeros","rustc_apfloat::ieee::sig","",null,null],[5,"olsb","","One, not zero, based LSB. That is, returns 0 for a zeroed significand.",null,null],[5,"omsb","","One, not zero, based MSB. That is, returns 0 for a zeroed significand.",null,null],[5,"cmp","","Comparison (unsigned) of two significands.",null,null],[5,"get_bit","","Extract the given bit.",null,null],[5,"set_bit","","Set the given bit.",null,null],[5,"clear_bit","","Clear the given bit.",null,null],[5,"shift_left","","Shift `dst` left `bits` bits, subtract `bits` from its exponent.",null,null],[5,"shift_right","","Shift `dst` right `bits` bits noting lost fraction.",null,null],[5,"extract","","Copy the bit vector of width `src_bits` from `src`, starting at bit SRC_LSB, to `dst`, such that the bit SRC_LSB becomes the least significant bit of `dst`. All high bits above `src_bits` in `dst` are zero-filled.",null,null],[5,"from_limbs","","We want the most significant PRECISION bits of `src`. There may not be that many; extract what we can.",null,null],[5,"each_chunk","","For every consecutive chunk of `bits` bits from `limbs`, going from most significant to the least significant bits, call `f` to transform those bits and store the result back.",null,null],[5,"increment","","Increment in-place, return the carry flag.",null,null],[5,"decrement","","Decrement in-place, return the borrow flag.",null,null],[5,"add","","`a += b + c` where `c` is zero or one. Returns the carry flag.",null,null],[5,"sub","","`a -= b + c` where `c` is zero or one. Returns the borrow flag.",null,null],[5,"add_or_sub","","`a += b` or `a -= b`. Does not preserve `b`.",null,null],[5,"widening_mul","","`[low, high] = a * b`.",null,null],[5,"mul","","`dst = a * b` (for normal `a` and `b`). Returns the lost fraction.",null,null],[5,"div","","`quotient = dividend / divisor`. Returns the lost fraction. Does not preserve `dividend` or `divisor`.",null,null],[6,"Limb","rustc_apfloat::ieee","Fundamental unit of big integer arithmetic, but also large to store the largest significands by itself.",null,null],[6,"Half","","",null,null],[6,"Single","","",null,null],[6,"Double","","",null,null],[6,"Quad","","",null,null],[6,"X87DoubleExtended","","",null,null],[17,"LIMB_BITS","","",null,null],[8,"Semantics","","Represents floating point arithmetic semantics.",null,null],[18,"BITS","","Total number of bits in the in-memory format.",7,null],[18,"PRECISION","","Number of bits in the significand. This includes the integer bit.",7,null],[18,"MAX_EXP","","The largest E such that 2E is representable; this matches the definition of IEEE 754.",7,null],[18,"MIN_EXP","","The smallest E such that 2E is a normalized number; this matches the definition of IEEE 754.",7,null],[18,"QNAN_BIT","","The significand bit that marks NaN as quiet.",7,null],[18,"QNAN_SIGNIFICAND","","The significand bitpattern to mark a NaN as quiet. NOTE: for X87DoubleExtended we need to set two bits instead of 2.",7,null],[11,"from_bits","","",7,{"inputs":[{"name":"u128"}],"output":{"name":"ieeefloat"}}],[11,"to_bits","","",7,{"inputs":[{"name":"ieeefloat"}],"output":{"name":"u128"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"loss"}}],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"loss"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",6,null],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"from_bits","","Integer bit is explicit in this format. Intel hardware (387 and later) does not support these bit patterns:  exponent = all 1's, integer bit 0, significand 0 (\"pseudoinfinity\")  exponent = all 1's, integer bit 0, significand nonzero (\"pseudoNaN\")  exponent = 0, integer bit 1 (\"pseudodenormal\")  exponent!=0 nor all 1's, integer bit 0 (\"unnormal\") At the moment, the first two are treated as NaNs, the second two as Normal.",8,{"inputs":[{"name":"u128"}],"output":{"name":"ieeefloat"}}],[11,"to_bits","","",8,{"inputs":[{"name":"ieeefloat"}],"output":{"name":"u128"}}],[11,"default","","",5,{"inputs":[],"output":{"name":"self"}}],[11,"from_str","","",5,{"inputs":[{"name":"str"}],"output":{"generics":["parseerror"],"name":"result"}}],[11,"add","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"sub","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"mul","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"div","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"rem","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"add_assign","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"sub_assign","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"mul_assign","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"div_assign","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"rem_assign","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"neg","","",5,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"qnan","","",5,{"inputs":[{"generics":["u128"],"name":"option"}],"output":{"name":"self"}}],[11,"snan","","",5,{"inputs":[{"generics":["u128"],"name":"option"}],"output":{"name":"self"}}],[11,"largest","","",5,{"inputs":[],"output":{"name":"self"}}],[11,"smallest_normalized","","",5,{"inputs":[],"output":{"name":"self"}}],[11,"add_r","","",5,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"mul_r","","",5,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"mul_add_r","","",5,{"inputs":[{"name":"self"},{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"div_r","","",5,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"c_fmod","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"round_to_integral","","",5,{"inputs":[{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"next_up","","",5,{"inputs":[{"name":"self"}],"output":{"name":"statusand"}}],[11,"from_bits","","",5,{"inputs":[{"name":"u128"}],"output":{"name":"self"}}],[11,"from_u128_r","","",5,{"inputs":[{"name":"u128"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"from_str_r","","",5,{"inputs":[{"name":"str"},{"name":"round"}],"output":{"generics":["statusand","parseerror"],"name":"result"}}],[11,"to_bits","","",5,{"inputs":[{"name":"self"}],"output":{"name":"u128"}}],[11,"to_u128_r","","",5,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"round"},{"name":"bool"}],"output":{"generics":["u128"],"name":"statusand"}}],[11,"cmp_abs_normal","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"bitwise_eq","","",5,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"is_negative","","",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_denormal","","",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_signaling","","",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"category","","",5,{"inputs":[{"name":"self"}],"output":{"name":"category"}}],[11,"get_exact_inverse","","",5,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"ilogb","","",5,{"inputs":[{"name":"self"}],"output":{"name":"expint"}}],[11,"scalbn_r","","",5,{"inputs":[{"name":"self"},{"name":"expint"},{"name":"round"}],"output":{"name":"self"}}],[11,"frexp_r","","",5,{"inputs":[{"name":"self"},{"name":"expint"},{"name":"round"}],"output":{"name":"self"}}],[11,"convert_r","","",5,{"inputs":[{"name":"self"},{"name":"round"},{"name":"bool"}],"output":{"generics":["ieeefloat"],"name":"statusand"}}],[11,"overflow_result","","Handle positive overflow. We either return infinity or the largest finite number. For negative overflow, negate the `round` argument before calling.",5,{"inputs":[{"name":"round"}],"output":{"name":"statusand"}}],[11,"round_away_from_zero","","Returns TRUE if, when truncating the current number, with BIT the new LSB, with the given lost fraction and rounding mode, the result would need to be rounded away from zero (i.e., by increasing the signficand). This routine must work for Category::Zero of both signs, and Category::Normal numbers.",5,{"inputs":[{"name":"self"},{"name":"round"},{"name":"loss"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"normalize","","",5,{"inputs":[{"name":"self"},{"name":"round"},{"name":"loss"}],"output":{"name":"statusand"}}],[11,"from_hexadecimal_string","","",5,{"inputs":[{"name":"str"},{"name":"round"}],"output":{"generics":["statusand","parseerror"],"name":"result"}}],[11,"from_decimal_string","","",5,{"inputs":[{"name":"str"},{"name":"round"}],"output":{"generics":["statusand","parseerror"],"name":"result"}}],[11,"combine","","Combine the effect of two lost fractions.",6,{"inputs":[{"name":"self"},{"name":"loss"}],"output":{"name":"loss"}}],[11,"through_truncation","","Return the fraction lost were a bignum truncated losing the least significant `bits` bits.",6,null],[0,"ppc","rustc_apfloat","",null,null],[3,"DoubleFloat","rustc_apfloat::ppc","",null,null],[12,"0","","",9,null],[12,"1","","",9,null],[3,"FallbackS","","",null,null],[12,"0","","",10,null],[3,"FallbackExtendedS","","",null,null],[12,"0","","",11,null],[6,"DoubleDouble","","",null,null],[6,"Fallback","","",null,null],[6,"FallbackExtended","","",null,null],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"doublefloat"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"name":"bool"}}],[11,"le","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"name":"bool"}}],[11,"gt","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"name":"bool"}}],[11,"ge","","",9,{"inputs":[{"name":"self"},{"name":"doublefloat"}],"output":{"name":"bool"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",9,{"inputs":[{"generics":["fallbacks"],"name":"ieeefloat"}],"output":{"name":"self"}}],[11,"from","rustc_apfloat::ieee","",5,{"inputs":[{"name":"doublefloat"}],"output":{"name":"self"}}],[11,"default","rustc_apfloat::ppc","",9,{"inputs":[],"output":{"name":"self"}}],[11,"from_str","","",9,{"inputs":[{"name":"str"}],"output":{"generics":["parseerror"],"name":"result"}}],[11,"add","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"sub","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"mul","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"div","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"rem","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"add_assign","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"sub_assign","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"mul_assign","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"div_assign","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"rem_assign","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"neg","","",9,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"qnan","","",9,{"inputs":[{"generics":["u128"],"name":"option"}],"output":{"name":"self"}}],[11,"snan","","",9,{"inputs":[{"generics":["u128"],"name":"option"}],"output":{"name":"self"}}],[11,"largest","","",9,{"inputs":[],"output":{"name":"self"}}],[11,"smallest_normalized","","",9,{"inputs":[],"output":{"name":"self"}}],[11,"add_r","","",9,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"mul_r","","",9,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"mul_add_r","","",9,{"inputs":[{"name":"self"},{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"div_r","","",9,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"c_fmod","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[11,"round_to_integral","","",9,{"inputs":[{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"next_up","","",9,{"inputs":[{"name":"self"}],"output":{"name":"statusand"}}],[11,"from_bits","","",9,{"inputs":[{"name":"u128"}],"output":{"name":"self"}}],[11,"from_u128_r","","",9,{"inputs":[{"name":"u128"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"from_str_r","","",9,{"inputs":[{"name":"str"},{"name":"round"}],"output":{"generics":["statusand","parseerror"],"name":"result"}}],[11,"to_bits","","",9,{"inputs":[{"name":"self"}],"output":{"name":"u128"}}],[11,"to_u128_r","","",9,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"round"},{"name":"bool"}],"output":{"generics":["u128"],"name":"statusand"}}],[11,"cmp_abs_normal","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"bitwise_eq","","",9,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"is_negative","","",9,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_denormal","","",9,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_signaling","","",9,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"category","","",9,{"inputs":[{"name":"self"}],"output":{"name":"category"}}],[11,"get_exact_inverse","","",9,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"ilogb","","",9,{"inputs":[{"name":"self"}],"output":{"name":"expint"}}],[11,"scalbn_r","","",9,{"inputs":[{"name":"self"},{"name":"expint"},{"name":"round"}],"output":{"name":"self"}}],[11,"frexp_r","","",9,{"inputs":[{"name":"self"},{"name":"expint"},{"name":"round"}],"output":{"name":"self"}}],[6,"ExpInt","rustc_apfloat","A signed type to represent a floating point number's unbiased exponent.",null,null],[17,"IEK_INF","","",null,null],[17,"IEK_NAN","","",null,null],[17,"IEK_ZERO","","",null,null],[8,"Float","","A self-contained host- and target-independent arbitrary-precision floating-point software implementation.",null,null],[18,"BITS","","Total number of bits in the in-memory format.",12,null],[18,"PRECISION","","Number of bits in the significand. This includes the integer bit.",12,null],[18,"MAX_EXP","","The largest E such that 2E is representable; this matches the definition of IEEE 754.",12,null],[18,"MIN_EXP","","The smallest E such that 2E is a normalized number; this matches the definition of IEEE 754.",12,null],[18,"ZERO","","Positive Zero.",12,null],[18,"INFINITY","","Positive Infinity.",12,null],[18,"NAN","","NaN (Not a Number).",12,null],[10,"qnan","","Factory for QNaN values.",12,{"inputs":[{"generics":["u128"],"name":"option"}],"output":{"name":"self"}}],[10,"snan","","Factory for SNaN values.",12,{"inputs":[{"generics":["u128"],"name":"option"}],"output":{"name":"self"}}],[10,"largest","","Largest finite number.",12,{"inputs":[],"output":{"name":"self"}}],[18,"SMALLEST","","Smallest (by magnitude) finite number. Might be denormalized, which implies a relative loss of precision.",12,null],[10,"smallest_normalized","","Smallest (by magnitude) normalized finite number.",12,{"inputs":[],"output":{"name":"self"}}],[10,"add_r","","",12,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"sub_r","","",12,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[10,"mul_r","","",12,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[10,"mul_add_r","","",12,{"inputs":[{"name":"self"},{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"mul_add","","",12,{"inputs":[{"name":"self"},{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[10,"div_r","","",12,{"inputs":[{"name":"self"},{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"ieee_rem","","IEEE remainder.",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[10,"c_fmod","","C fmod, or llvm frem.",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"statusand"}}],[10,"round_to_integral","","",12,{"inputs":[{"name":"self"},{"name":"round"}],"output":{"name":"statusand"}}],[10,"next_up","","IEEE-754R 2008 5.3.1: nextUp.",12,{"inputs":[{"name":"self"}],"output":{"name":"statusand"}}],[11,"next_down","","IEEE-754R 2008 5.3.1: nextDown.",12,{"inputs":[{"name":"self"}],"output":{"name":"statusand"}}],[11,"abs","","",12,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"copy_sign","","",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"self"}}],[10,"from_bits","","",12,{"inputs":[{"name":"u128"}],"output":{"name":"self"}}],[11,"from_i128_r","","",12,{"inputs":[{"name":"i128"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"from_i128","","",12,{"inputs":[{"name":"i128"}],"output":{"name":"statusand"}}],[10,"from_u128_r","","",12,{"inputs":[{"name":"u128"},{"name":"round"}],"output":{"name":"statusand"}}],[11,"from_u128","","",12,{"inputs":[{"name":"u128"}],"output":{"name":"statusand"}}],[10,"from_str_r","","",12,{"inputs":[{"name":"str"},{"name":"round"}],"output":{"generics":["statusand","parseerror"],"name":"result"}}],[10,"to_bits","","",12,{"inputs":[{"name":"self"}],"output":{"name":"u128"}}],[11,"to_i128_r","","Convert a floating point number to an integer according to the rounding mode. In case of an invalid operation exception, deterministic values are returned, namely zero for NaNs and the minimal or maximal value respectively for underflow or overflow. If the rounded value is in range but the floating point number is not the exact integer, the C standard doesn't require an inexact exception to be raised. IEEE-854 does require it so we do that.",12,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"round"},{"name":"bool"}],"output":{"generics":["i128"],"name":"statusand"}}],[11,"to_i128","","",12,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["i128"],"name":"statusand"}}],[10,"to_u128_r","","",12,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"round"},{"name":"bool"}],"output":{"generics":["u128"],"name":"statusand"}}],[11,"to_u128","","",12,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["u128"],"name":"statusand"}}],[10,"cmp_abs_normal","","",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[10,"bitwise_eq","","Bitwise comparison for equality (QNaNs compare equal, 0!=-0).",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"min","","Implements IEEE minNum semantics. Returns the smaller of the 2 arguments if both are not NaN. If either argument is a NaN, returns the other argument.",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"self"}}],[11,"max","","Implements IEEE maxNum semantics. Returns the larger of the 2 arguments if both are not NaN. If either argument is a NaN, returns the other argument.",12,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"self"}}],[10,"is_negative","","IEEE-754R isSignMinus: Returns true if and only if the current value is negative.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_normal","","IEEE-754R isNormal: Returns true if and only if the current value is normal.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_finite","","Returns true if and only if the current value is zero, subnormal, or normal.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_zero","","Returns true if and only if the float is plus or minus zero.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[10,"is_denormal","","IEEE-754R isSubnormal(): Returns true if and only if the float is a denormal.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_infinite","","IEEE-754R isInfinite(): Returns true if and only if the float is infinity.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_nan","","Returns true if and only if the float is a quiet or signaling NaN.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[10,"is_signaling","","Returns true if and only if the float is a signaling NaN.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[10,"category","","",12,{"inputs":[{"name":"self"}],"output":{"name":"category"}}],[11,"is_non_zero","","",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_finite_non_zero","","",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_pos_zero","","",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_neg_zero","","",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_smallest","","Returns true if and only if the number has the smallest possible non-zero magnitude in the current semantics.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_largest","","Returns true if and only if the number has the largest possible finite magnitude in the current semantics.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_integer","","Returns true if and only if the number is an exact integer.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[10,"get_exact_inverse","","If this value has an exact multiplicative inverse, return it.",12,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[10,"ilogb","","Returns the exponent of the internal representation of the Float.",12,{"inputs":[{"name":"self"}],"output":{"name":"expint"}}],[10,"scalbn_r","","Returns: self * 2exp for integral exponents.",12,{"inputs":[{"name":"self"},{"name":"expint"},{"name":"round"}],"output":{"name":"self"}}],[11,"scalbn","","",12,{"inputs":[{"name":"self"},{"name":"expint"}],"output":{"name":"self"}}],[10,"frexp_r","","Equivalent of C standard library function.",12,{"inputs":[{"name":"self"},{"name":"expint"},{"name":"round"}],"output":{"name":"self"}}],[11,"frexp","","",12,{"inputs":[{"name":"self"},{"name":"expint"}],"output":{"name":"self"}}],[8,"FloatConvert","","",null,null],[10,"convert_r","","Convert a value of one floating point type to another. The return value corresponds to the IEEE754 exceptions. *loses_info records whether the transformation lost information, i.e. whether converting the result back to the original type will produce the original value (this is almost the same as return value==Status::OK, but there are edge cases where this is not so).",13,{"inputs":[{"name":"self"},{"name":"round"},{"name":"bool"}],"output":{"name":"statusand"}}],[11,"convert","","",13,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"statusand"}}],[11,"eq","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",0,null],[11,"clone","","",0,{"inputs":[{"name":"self"}],"output":{"name":"status"}}],[11,"partial_cmp","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"le","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"gt","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"ge","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"cmp","","",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"ordering"}}],[11,"hash","","",0,null],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"OK","","",0,null],[18,"INVALID_OP","","",0,null],[18,"DIV_BY_ZERO","","",0,null],[18,"OVERFLOW","","",0,null],[18,"UNDERFLOW","","",0,null],[18,"INEXACT","","",0,null],[11,"empty","","Returns an empty set of flags.",0,{"inputs":[],"output":{"name":"status"}}],[11,"all","","Returns the set containing all flags.",0,{"inputs":[],"output":{"name":"status"}}],[11,"bits","","Returns the raw value of the flags currently stored.",0,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",0,{"inputs":[{"name":"u8"}],"output":{"generics":["status"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",0,{"inputs":[{"name":"u8"}],"output":{"name":"status"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",0,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",0,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",0,{"inputs":[{"name":"self"},{"name":"status"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"status"}}],[11,"bitor_assign","","Adds the set of flags.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"status"}}],[11,"bitxor_assign","","Toggles the set of flags.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"status"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":{"name":"status"}}],[11,"sub_assign","","Disables all flags enabled in the set.",0,{"inputs":[{"name":"self"},{"name":"status"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",0,{"inputs":[{"name":"self"}],"output":{"name":"status"}}],[11,"extend","","",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",0,{"inputs":[{"name":"t"}],"output":{"name":"status"}}],[11,"clone","","",1,{"inputs":[{"name":"self"}],"output":{"name":"statusand"}}],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",1,null],[11,"partial_cmp","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"bool"}}],[11,"le","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"bool"}}],[11,"gt","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"bool"}}],[11,"ge","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"bool"}}],[11,"cmp","","",1,{"inputs":[{"name":"self"},{"name":"statusand"}],"output":{"name":"ordering"}}],[11,"fmt","","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"and","","",0,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"statusand"}}],[11,"map","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"statusand"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"category"}}],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"category"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"round"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"round"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",4,null],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"neg","","",4,{"inputs":[{"name":"self"}],"output":{"name":"round"}}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"parseerror"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",2,null],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[14,"unpack","","",null,null]],"paths":[[3,"Status"],[3,"StatusAnd"],[3,"ParseError"],[4,"Category"],[4,"Round"],[3,"IeeeFloat"],[4,"Loss"],[8,"Semantics"],[3,"X87DoubleExtendedS"],[3,"DoubleFloat"],[3,"FallbackS"],[3,"FallbackExtendedS"],[8,"Float"],[8,"FloatConvert"]]};
searchIndex["rustc_borrowck"] = {"doc":"","items":[[5,"check_crate","rustc_borrowck","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and the `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",null,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"borrowck","","See The Book chapter on the borrow checker for more details.",null,null],[3,"LoanDataFlowOperator","rustc_borrowck::borrowck","",null,null],[3,"AnalysisData","","Collection of conclusions determined via borrow checker analyses.",null,null],[12,"all_loans","","",0,null],[12,"loans","","",0,null],[12,"move_data","","",0,null],[3,"BorrowckCtxt","","",null,null],[12,"tcx","","",1,null],[12,"tables","","",1,null],[12,"region_scope_tree","","",1,null],[12,"owner_def_id","","",1,null],[12,"body","","",1,null],[12,"used_mut_nodes","","",1,null],[3,"Loan","","Record of a loan that was issued.",null,null],[12,"index","","",2,null],[12,"loan_path","","",2,null],[12,"kind","","",2,null],[12,"restricted_paths","","",2,null],[12,"gen_scope","","gen_scope indicates where loan is introduced. Typically the loan is introduced at the point of the borrow, but in some cases, notably method arguments, the loan may be introduced only later, once it comes into scope.  See also `GatherLoanCtxt::compute_gen_scope`.",2,null],[12,"kill_scope","","kill_scope indicates when the loan goes out of scope.  This is either when the lifetime expires or when the local variable which roots the loan-path goes out of scope, whichever happens faster. See also `GatherLoanCtxt::compute_kill_scope`.",2,null],[12,"span","","",2,null],[12,"cause","","",2,null],[3,"LoanPath","","",null,null],[12,"kind","","",3,null],[12,"ty","","",3,null],[3,"BckError","","",null,null],[12,"span","","",4,null],[12,"cause","","",4,null],[12,"cmt","","",4,null],[12,"code","","",4,null],[4,"LoanPathKind","","",null,null],[13,"LpVar","","",5,null],[13,"LpUpvar","","",5,null],[13,"LpDowncast","","",5,null],[13,"LpExtend","","",5,null],[4,"InteriorKind","","",null,null],[13,"InteriorField","","",6,null],[13,"InteriorElement","","",6,null],[4,"LoanPathElem","","",null,null],[13,"LpDeref","","",7,null],[13,"LpInterior","","",7,null],[4,"bckerr_code","","",null,null],[13,"err_mutbl","","",8,null],[13,"err_out_of_scope","","superscope, subscope, loan cause",8,null],[13,"err_borrowed_pointer_too_short","","",8,null],[4,"AliasableViolationKind","","",null,null],[13,"MutabilityViolation","","",9,null],[13,"BorrowViolation","","",9,null],[4,"MovedValueUseKind","","",null,null],[13,"MovedInUse","","",10,null],[13,"MovedInCapture","","",10,null],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"borrowck","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["borrowcheckresult"],"name":"lrc"}}],[5,"build_borrowck_dataflow_data","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"bool"},{"name":"bodyid"},{"name":"f"}],"output":{"generics":["analysisdata"],"name":"option"}}],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and the `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",null,null],[5,"closure_to_block","","",null,{"inputs":[{"name":"localdefid"},{"name":"tyctxt"}],"output":{"name":"nodeid"}}],[5,"opt_loan_path_is_field","","",null,null],[5,"opt_loan_path","","Computes the `LoanPath` (if any) for a `cmt`. Note that this logic is somewhat duplicated in the method `compute()` found in `gather_loans::restrictions`, which allows it to share common loan path pieces as it traverses the CMT.",null,{"inputs":[{"name":"cmt_"}],"output":{"generics":["rc"],"name":"option"}}],[0,"check_loans","","",null,null],[3,"CheckLoanCtxt","rustc_borrowck::borrowck::check_loans","",null,null],[12,"bccx","","",11,null],[12,"dfcx_loans","","",11,null],[12,"move_data","","",11,null],[12,"all_loans","","",11,null],[12,"param_env","","",11,null],[12,"movable_generator","","",11,null],[4,"UseError","","",null,null],[13,"UseOk","","",12,null],[13,"UseWhileBorrowed","","",12,null],[5,"owned_ptr_base_path","","Returns the base of the leftmost dereference of an Unique in `loan_path`. If there is no dereference of an Unique in `loan_path`, then it just returns `loan_path` itself.",null,{"inputs":[{"name":"loanpath"}],"output":{"name":"loanpath"}}],[5,"owned_ptr_base_path_rc","","The equivalent of `owned_ptr_base_path` for an &Rc rather than a &LoanPath.",null,{"inputs":[{"name":"rc"}],"output":{"generics":["loanpath"],"name":"rc"}}],[5,"check_loans","","",null,null],[5,"compatible_borrow_kinds","","",null,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"consume","","",11,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"matched_pat","","",11,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"matchmode"}],"output":null}],[11,"consume_pat","","",11,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"borrow","","",11,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[11,"mutate","","",11,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[11,"decl_without_init","","",11,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"eq","","",12,{"inputs":[{"name":"self"},{"name":"useerror"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"self"},{"name":"useerror"}],"output":{"name":"bool"}}],[11,"tcx","","",11,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"each_issued_loan","","Iterates over each loan that has been issued on entrance to `node`, regardless of whether it is actually in scope at that point.  Sometimes loans are issued for future scopes and thus they may have been issued but not yet be in effect.",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_in_scope_loan","","Like `each_issued_loan()`, but only considers loans that are currently in scope.",11,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_in_scope_loan_affecting_path","","Iterates through all of the in-scope loans affecting `loan_path`, calling `op`, and ceasing iteration if `false` is returned.",11,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"loanpath"},{"name":"f"}],"output":{"name":"bool"}}],[11,"loans_generated_by","","Returns a vector of the loans that are generated as we enter `node`.",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":{"generics":["usize"],"name":"vec"}}],[11,"check_for_loans_across_yields","","",11,{"inputs":[{"name":"self"},{"name":"cmt_"},{"name":"region"},{"name":"span"}],"output":null}],[11,"check_for_conflicting_loans","","Checks to see whether any of the loans that are issued on entrance to `node` conflict with loans that have already been issued when we enter `node` (for example, we do not permit two `&mut` borrows of the same variable).",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"}],"output":null}],[11,"report_error_if_loans_conflict","","Checks whether `old_loan` and `new_loan` can safely be issued simultaneously.",11,{"inputs":[{"name":"self"},{"name":"loan"},{"name":"loan"}],"output":{"name":"bool"}}],[11,"report_error_if_loan_conflicts_with_restriction","","Checks whether the restrictions introduced by `loan1` would prohibit `loan2`. Returns false if an error is reported.",11,{"inputs":[{"name":"self"},{"name":"loan"},{"name":"loan"},{"name":"loan"},{"name":"loan"}],"output":{"generics":["diagnosticbuilder"],"name":"result"}}],[11,"consume_common","","",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"check_for_copy_of_frozen_path","","",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"loanpath"}],"output":null}],[11,"check_for_move_of_borrowed_path","","",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"loanpath"},{"name":"movekind"}],"output":null}],[11,"analyze_restrictions_on_use","","",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"loanpath"},{"name":"borrowkind"}],"output":{"name":"useerror"}}],[11,"check_if_path_is_moved","","Reports an error if `expr` (which should be a path) is using a moved/uninitialized value",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"movedvalueusekind"},{"name":"rc"}],"output":null}],[11,"check_if_assigned_path_is_moved","","Reports an error if assigning to `lp` will use a moved/uninitialized value. Mainly this is concerned with detecting derefs of uninitialized pointers.",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"movedvalueusekind"},{"name":"rc"}],"output":null}],[11,"check_assignment","","",11,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"cmt_"}],"output":null}],[11,"report_illegal_mutation","","",11,{"inputs":[{"name":"self"},{"name":"span"},{"name":"loanpath"},{"name":"loan"}],"output":null}],[0,"gather_loans","rustc_borrowck::borrowck","",null,null],[3,"GatherLoanCtxt","rustc_borrowck::borrowck::gather_loans","",null,null],[12,"bccx","","",13,null],[12,"move_data","","",13,null],[12,"move_error_collector","","",13,null],[12,"all_loans","","",13,null],[12,"item_ub","","`item_ub` is used as an upper-bound on the lifetime whenever we ask for the scope of an expression categorized as an upvar.",13,null],[5,"gather_loans_in_fn","","",null,null],[5,"check_aliasability","","Implements the A-* rules in README.md.",null,{"inputs":[{"name":"borrowckctxt"},{"name":"span"},{"name":"aliasableviolationkind"},{"name":"cmt_"},{"name":"borrowkind"}],"output":{"name":"result"}}],[5,"check_mutability","","Implements the M-* rules in README.md.",null,{"inputs":[{"name":"borrowckctxt"},{"name":"span"},{"name":"aliasableviolationkind"},{"name":"cmt_"},{"name":"borrowkind"}],"output":{"name":"result"}}],[0,"lifetime","","This module implements the check that the lifetime of a borrow does not exceed the lifetime of the value being borrowed.",null,null],[3,"GuaranteeLifetimeContext","rustc_borrowck::borrowck::gather_loans::lifetime","",null,null],[12,"bccx","","",14,null],[12,"item_scope","","",14,null],[12,"span","","",14,null],[12,"cause","","",14,null],[12,"loan_region","","",14,null],[12,"cmt_original","","",14,null],[5,"guarantee_lifetime","","Reports error if `loan_region` is larger than S where S is `item_scope` if `cmt` is an upvar, and is scope of `cmt` otherwise.",null,{"inputs":[{"name":"borrowckctxt"},{"name":"scope"},{"name":"span"},{"name":"loancause"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"}],"output":{"name":"result"}}],[6,"R","","",null,null],[11,"check","","Main routine. Walks down `cmt` until we find the \"guarantor\".  Reports an error if `self.loan_region` is larger than scope of `cmt`.",14,{"inputs":[{"name":"self"},{"name":"cmt_"},{"generics":["nodeid"],"name":"option"}],"output":{"name":"result"}}],[11,"check_scope","","Reports an error if `loan_region` is larger than `max_scope`",14,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"result"}}],[11,"scope","","Returns the maximal region scope for the which the place `cmt` is guaranteed to be valid without any rooting etc, and presuming `cmt` is not mutated.",14,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":{"name":"region"}}],[11,"report_error","","",14,{"inputs":[{"name":"self"},{"name":"bckerr_code"}],"output":null}],[0,"restrictions","rustc_borrowck::borrowck::gather_loans","Computes the restrictions that result from a borrow.",null,null],[3,"RestrictionsContext","rustc_borrowck::borrowck::gather_loans::restrictions","",null,null],[12,"bccx","","",15,null],[12,"span","","",15,null],[12,"loan_region","","",15,null],[12,"cause","","",15,null],[4,"RestrictionResult","","",null,null],[13,"Safe","","",16,null],[13,"SafeIf","","",16,null],[5,"compute_restrictions","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"span"},{"name":"loancause"},{"name":"cmt_"},{"name":"region"}],"output":{"name":"restrictionresult"}}],[11,"fmt","","",16,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"restrict","","",15,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":{"name":"restrictionresult"}}],[11,"extend","","",15,{"inputs":[{"name":"self"},{"name":"restrictionresult"},{"name":"cmt_"},{"name":"loanpathelem"}],"output":{"name":"restrictionresult"}}],[0,"gather_moves","rustc_borrowck::borrowck::gather_loans","Computes moves.",null,null],[3,"GatherMoveInfo","rustc_borrowck::borrowck::gather_loans::gather_moves","",null,null],[12,"id","","",17,null],[12,"kind","","",17,null],[12,"cmt","","",17,null],[12,"span_path_opt","","",17,null],[4,"PatternSource","","Represents the kind of pattern",null,null],[13,"MatchExpr","","",18,null],[13,"LetDecl","","",18,null],[13,"Other","","",18,null],[5,"get_pattern_source","","Analyzes the context where the pattern appears to determine the kind of hint we want to give. In particular, if the pattern is in a `match` or nested within other patterns, we want to suggest a `ref` binding:",null,{"inputs":[{"name":"tyctxt"},{"name":"pat"}],"output":{"name":"patternsource"}}],[5,"gather_decl","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"movedata"},{"name":"nodeid"},{"name":"ty"}],"output":null}],[5,"gather_move_from_expr","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"movedata"},{"name":"moveerrorcollector"},{"name":"itemlocalid"},{"name":"cmt_"},{"name":"movereason"}],"output":null}],[5,"gather_move_from_pat","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"movedata"},{"name":"moveerrorcollector"},{"name":"pat"},{"name":"cmt_"}],"output":null}],[5,"gather_move","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"movedata"},{"name":"moveerrorcollector"},{"name":"gathermoveinfo"}],"output":null}],[5,"gather_assignment","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"movedata"},{"name":"itemlocalid"},{"name":"span"},{"generics":["loanpath"],"name":"rc"},{"name":"itemlocalid"},{"name":"mutatemode"}],"output":null}],[5,"check_and_get_illegal_move_origin","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"cmt_"}],"output":{"generics":["cmt_"],"name":"option"}}],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",18,{"inputs":[{"name":"self"}],"output":{"name":"patternsource"}}],[0,"move_error","rustc_borrowck::borrowck::gather_loans","",null,null],[3,"MoveErrorCollector","rustc_borrowck::borrowck::gather_loans::move_error","",null,null],[12,"errors","","",19,null],[3,"MoveError","","",null,null],[12,"move_from","","",20,null],[12,"move_to","","",20,null],[3,"MovePlace","","",null,null],[12,"span","","",21,null],[12,"name","","",21,null],[12,"pat_source","","",21,null],[3,"GroupedMoveErrors","","",null,null],[12,"move_from","","",22,null],[12,"move_to_places","","",22,null],[5,"report_move_errors","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"vec"}],"output":null}],[5,"group_errors_with_same_origin","","",null,{"inputs":[{"name":"vec"}],"output":{"generics":["groupedmoveerrors"],"name":"vec"}}],[5,"report_cannot_move_out_of","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"cmt"}],"output":{"name":"diagnosticbuilder"}}],[5,"note_move_destination","","",null,{"inputs":[{"name":"diagnosticbuilder"},{"name":"span"},{"name":"name"},{"name":"bool"}],"output":{"name":"diagnosticbuilder"}}],[11,"new","","",19,{"inputs":[],"output":{"name":"moveerrorcollector"}}],[11,"add_error","","",19,{"inputs":[{"name":"self"},{"name":"moveerror"}],"output":null}],[11,"report_potential_errors","","",19,{"inputs":[{"name":"self"},{"name":"borrowckctxt"}],"output":null}],[11,"with_move_info","","",20,{"inputs":[{"name":"cmt"},{"generics":["moveplace"],"name":"option"}],"output":{"name":"moveerror"}}],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"moveplace"}}],[11,"consume","rustc_borrowck::borrowck::gather_loans","",13,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"matched_pat","","",13,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"matchmode"}],"output":null}],[11,"consume_pat","","",13,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"borrow","","",13,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[11,"mutate","","",13,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[11,"decl_without_init","","",13,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"tcx","","",13,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"guarantee_assignment_valid","","Guarantees that `cmt` is assignable, or reports an error.",13,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[11,"guarantee_valid","","Guarantees that `addr_of(cmt)` will be valid for the duration of `static_scope_r`, or reports an error.  This may entail taking out loans, which will be added to the `req_loan_map`.",13,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"span"},{"name":"cmt_"},{"name":"borrowkind"},{"name":"region"},{"name":"loancause"}],"output":null}],[11,"mark_loan_path_as_mutated","","For mutable loans of content whose mutability derives from a local variable, mark the mutability decl as necessary.",13,{"inputs":[{"name":"self"},{"name":"loanpath"}],"output":null}],[11,"compute_gen_scope","","Determine when to introduce the loan. Typically the loan is introduced at the point of the borrow, but in some cases, notably method arguments, the loan may be introduced only later, once it comes into scope.",13,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"scope"}],"output":{"name":"scope"}}],[11,"compute_kill_scope","","Determine when the loan restrictions go out of scope. This is either when the lifetime expires or when the local variable which roots the loan-path goes out of scope, whichever happens faster.",13,{"inputs":[{"name":"self"},{"name":"scope"},{"name":"loanpath"}],"output":{"name":"scope"}}],[11,"report_potential_errors","","",13,{"inputs":[{"name":"self"}],"output":null}],[0,"move_data","rustc_borrowck::borrowck","Data structures used for tracking moves. Please see the extensive comments in the section \"Moves and initialization\" in `README.md`.",null,null],[3,"MoveData","rustc_borrowck::borrowck::move_data","",null,null],[12,"paths","","Move paths. See section \"Move paths\" in `README.md`.",23,null],[12,"path_map","","Cache of loan path to move path index, for easy lookup.",23,null],[12,"moves","","Each move or uninitialized variable gets an entry here.",23,null],[12,"var_assignments","","Assignments to a variable, like `x = foo`. These are assigned bits for dataflow, since we must track them to ensure that immutable variables are assigned at most once along each path.",23,null],[12,"path_assignments","","Assignments to a path, like `x.f = foo`. These are not assigned dataflow bits, but we track them because they still kill move bits.",23,null],[12,"assignee_ids","","Assignments to a variable or path, like `x = foo`, but not `x += foo`.",23,null],[3,"FlowedMoveData","","",null,null],[12,"move_data","","",24,null],[12,"dfcx_moves","","",24,null],[12,"dfcx_assign","","",24,null],[3,"MovePathIndex","","Index into `MoveData.paths`, used like a pointer",null,null],[12,"0","","",25,null],[3,"MoveIndex","","Index into `MoveData.moves`, used like a pointer",null,null],[12,"0","","",26,null],[3,"MovePath","","",null,null],[12,"loan_path","","Loan path corresponding to this move path",27,null],[12,"parent","","Parent pointer, `InvalidMovePathIndex` if root",27,null],[12,"first_move","","Head of linked list of moves to this path, `InvalidMoveIndex` if not moved",27,null],[12,"first_child","","First node in linked list of children, `InvalidMovePathIndex` if leaf",27,null],[12,"next_sibling","","Next node in linked list of parent's children (siblings), `InvalidMovePathIndex` if none.",27,null],[3,"Move","","",null,null],[12,"path","","Path being moved.",28,null],[12,"id","","id of node that is doing the move.",28,null],[12,"kind","","Kind of move, for error messages.",28,null],[12,"next_move","","Next node in linked list of moves from `path`, or `InvalidMoveIndex`",28,null],[3,"Assignment","","",null,null],[12,"path","","Path being assigned.",29,null],[12,"id","","id where assignment occurs",29,null],[12,"span","","span of node where assignment occurs",29,null],[12,"assignee_id","","id for place expression on lhs of assignment",29,null],[3,"MoveDataFlowOperator","","",null,null],[3,"AssignDataFlowOperator","","",null,null],[4,"MoveKind","","",null,null],[13,"Declared","","",30,null],[13,"MoveExpr","","",30,null],[13,"MovePat","","",30,null],[13,"Captured","","",30,null],[5,"loan_path_is_precise","","",null,{"inputs":[{"name":"loanpath"}],"output":{"name":"bool"}}],[6,"MoveDataFlow","","",null,null],[6,"AssignDataFlow","","",null,null],[17,"InvalidMovePathIndex","","",null,null],[17,"InvalidMoveIndex","","",null,null],[11,"default","","",23,{"inputs":[],"output":{"name":"movedata"}}],[11,"eq","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",25,null],[11,"partial_cmp","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"le","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"gt","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"ge","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"cmp","","",25,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"ordering"}}],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"get","","",25,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"movepathindex"}}],[11,"clone","","",26,{"inputs":[{"name":"self"}],"output":{"name":"moveindex"}}],[11,"eq","","",26,{"inputs":[{"name":"self"},{"name":"moveindex"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"self"},{"name":"moveindex"}],"output":{"name":"bool"}}],[11,"get","","",26,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"movekind"}}],[11,"eq","","",30,{"inputs":[{"name":"self"},{"name":"movekind"}],"output":{"name":"bool"}}],[11,"fmt","","",30,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",28,{"inputs":[{"name":"self"}],"output":{"name":"move"}}],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"assignment"}}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"movedataflowoperator"}}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"assigndataflowoperator"}}],[11,"is_empty","","return true if there are no trackable assignments or moves in this move data - that means that there is nothing that could cause a borrow error.",23,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"path_loan_path","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"generics":["loanpath"],"name":"rc"}}],[11,"path_parent","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"movepathindex"}}],[11,"path_first_move","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"moveindex"}}],[11,"path_first_child","","Returns the index of first child, or `InvalidMovePathIndex` if `index` is leaf.",23,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"movepathindex"}}],[11,"path_next_sibling","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"movepathindex"}}],[11,"set_path_first_move","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"moveindex"}],"output":null}],[11,"set_path_first_child","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"movepathindex"}],"output":null}],[11,"move_next_move","","Type safe indexing operator",23,{"inputs":[{"name":"self"},{"name":"moveindex"}],"output":{"name":"moveindex"}}],[11,"is_var_path","","True if `index` refers to a variable",23,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"move_path","","Returns the existing move path index for `lp`, if any, and otherwise adds a new index for `lp` and any of its base paths that do not yet have an index.",23,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["loanpath"],"name":"rc"}],"output":{"name":"movepathindex"}}],[11,"existing_move_path","","",23,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"generics":["movepathindex"],"name":"option"}}],[11,"existing_base_paths","","",23,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"generics":["movepathindex"],"name":"vec"}}],[11,"add_existing_base_paths","","Adds any existing move path indices for `lp` and any base paths of `lp` to `result`, but does not add new move paths",23,{"inputs":[{"name":"self"},{"name":"rc"},{"name":"vec"}],"output":null}],[11,"add_move","","Adds a new move entry for a move of `lp` that occurs at location `id` with kind `kind`.",23,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["loanpath"],"name":"rc"},{"name":"itemlocalid"},{"name":"movekind"}],"output":null}],[11,"add_move_helper","","",23,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["loanpath"],"name":"rc"},{"name":"itemlocalid"},{"name":"movekind"}],"output":null}],[11,"add_assignment","","Adds a new record for an assignment to `lp` that occurs at location `id` with the given `span`.",23,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["loanpath"],"name":"rc"},{"name":"itemlocalid"},{"name":"span"},{"name":"itemlocalid"},{"name":"mutatemode"}],"output":null}],[11,"add_assignment_helper","","",23,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["loanpath"],"name":"rc"},{"name":"itemlocalid"},{"name":"span"},{"name":"itemlocalid"},{"name":"mutatemode"}],"output":null}],[11,"add_gen_kills","","Adds the gen/kills for the various moves and assignments into the provided data flow contexts. Moves are generated by moves and killed by assignments and scoping. Assignments are generated by assignment to variables and killed by scoping. See `README.md` for more details.",23,{"inputs":[{"name":"self"},{"name":"borrowckctxt"},{"name":"dataflowcontext"},{"name":"dataflowcontext"}],"output":null}],[11,"each_base_path","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_extending_path_","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_extending_path","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_applicable_move","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"kill_moves","","",23,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"itemlocalid"},{"name":"killfrom"},{"name":"dataflowcontext"}],"output":null}],[11,"new","","",24,{"inputs":[{"name":"movedata"},{"name":"borrowckctxt"},{"name":"cfg"},{"name":"idrange"},{"name":"body"}],"output":{"name":"flowedmovedata"}}],[11,"kind_of_move_of_path","","Returns the kind of a move of `loan_path` by `id`, if one exists.",24,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"rc"}],"output":{"generics":["movekind"],"name":"option"}}],[11,"each_move_of","","Iterates through each move of `loan_path` (or some base path of `loan_path`) that may have occurred on entry to `id` without an intervening assignment. In other words, any moves that would invalidate a reference to `loan_path` at location `id`.",24,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"rc"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_assignment_of","","Iterates through every assignment to `loan_path` that may have occurred on entry to `id`. `loan_path` must be a single variable.",24,{"inputs":[{"name":"self"},{"name":"itemlocalid"},{"name":"rc"},{"name":"f"}],"output":{"name":"bool"}}],[11,"join","","",31,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"initial_value","","",31,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"join","","",32,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"initial_value","","",32,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[0,"unused","rustc_borrowck::borrowck","",null,null],[3,"UsedMutFinder","rustc_borrowck::borrowck::unused","",null,null],[12,"bccx","","",33,null],[12,"set","","",33,null],[3,"UnusedMutCx","","",null,null],[12,"bccx","","",34,null],[12,"used_mut","","",34,null],[5,"check","","",null,{"inputs":[{"name":"borrowckctxt"},{"name":"body"}],"output":null}],[11,"check_unused_mut_pat","","",34,null],[11,"nested_visit_map","","",34,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_arm","","",34,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_local","","",34,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"nested_visit_map","","",33,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",33,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[6,"LoanDataFlow","rustc_borrowck::borrowck","",null,null],[17,"DOWNCAST_PRINTED_OPERATOR","","",null,null],[8,"ToInteriorKind","","",null,null],[10,"cleaned","","",35,{"inputs":[{"name":"self"}],"output":{"name":"interiorkind"}}],[11,"clone","","",36,{"inputs":[{"name":"self"}],"output":{"name":"loandataflowoperator"}}],[11,"loan_path","","",2,{"inputs":[{"name":"self"}],"output":{"generics":["loanpath"],"name":"rc"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"loanpath"}],"output":{"name":"bool"}}],[11,"hash","","",3,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"loanpathkind"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"self"},{"name":"loanpathkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",5,null],[11,"hash","","",5,null],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",3,{"inputs":[{"name":"loanpathkind"},{"name":"ty"}],"output":{"name":"loanpath"}}],[11,"to_type","","",3,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"has_downcast","","",3,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"interiorkind"}}],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"self"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",6,null],[11,"hash","","",6,null],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"loanpathelem"}}],[11,"eq","","",7,{"inputs":[{"name":"self"},{"name":"loanpathelem"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"self"},{"name":"loanpathelem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",7,null],[11,"hash","","",7,null],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"kill_scope","","",3,{"inputs":[{"name":"self"},{"name":"borrowckctxt"}],"output":{"name":"scope"}}],[11,"has_fork","","",3,{"inputs":[{"name":"self"},{"name":"loanpath"}],"output":{"name":"bool"}}],[11,"depth","","",3,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"common","","",3,{"inputs":[{"name":"self"},{"name":"loanpath"}],"output":{"generics":["loanpath"],"name":"option"}}],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",8,{"inputs":[{"name":"self"},{"name":"bckerr_code"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"bckerr_code"}],"output":{"name":"bool"}}],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"bckerror"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"self"},{"name":"bckerror"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"aliasableviolationkind"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"aliasableviolationkind"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"aliasableviolationkind"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"movedvalueusekind"}}],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_subregion_of","","",1,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"report","","",1,{"inputs":[{"name":"self"},{"name":"bckerror"}],"output":null}],[11,"report_use_of_moved_value","","",1,{"inputs":[{"name":"self"},{"name":"span"},{"name":"movedvalueusekind"},{"name":"loanpath"},{"name":"move"},{"name":"loanpath"},{"name":"paramenv"}],"output":null}],[11,"report_partial_reinitialization_of_uninitialized_structure","","",1,{"inputs":[{"name":"self"},{"name":"span"},{"name":"loanpath"}],"output":null}],[11,"report_reassigned_immutable_variable","","",1,{"inputs":[{"name":"self"},{"name":"span"},{"name":"loanpath"},{"name":"assignment"}],"output":null}],[11,"struct_span_err_with_code","","",1,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_err_with_code","","",1,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":null}],[11,"report_bckerr","","",1,{"inputs":[{"name":"self"},{"name":"bckerror"}],"output":null}],[11,"report_aliasability_violation","","",1,{"inputs":[{"name":"self"},{"name":"span"},{"name":"aliasableviolationkind"},{"name":"aliasablereason"},{"name":"cmt_"}],"output":null}],[11,"suggest_mut_for_immutable","","Given a type, if it is an immutable reference, return a suggestion to make it mutable",1,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"bool"}],"output":{"generics":["string"],"name":"option"}}],[11,"local_binding_mode","","",1,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bindingmode"}}],[11,"local_ty","","",1,null],[11,"note_immutability_blame","","",1,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"generics":["immutabilityblame"],"name":"option"}],"output":null}],[11,"report_out_of_scope_escaping_closure_capture","","",1,{"inputs":[{"name":"self"},{"name":"bckerror"},{"name":"span"}],"output":null}],[11,"region_end_span","","",1,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"generics":["span"],"name":"option"}}],[11,"note_and_explain_mutbl_error","","",1,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"bckerror"},{"name":"span"}],"output":null}],[11,"append_loan_path_to_string","","",1,{"inputs":[{"name":"self"},{"name":"loanpath"},{"name":"string"}],"output":null}],[11,"append_autoderefd_loan_path_to_string","","",1,{"inputs":[{"name":"self"},{"name":"loanpath"},{"name":"string"}],"output":null}],[11,"loan_path_to_string","","",1,{"inputs":[{"name":"self"},{"name":"loanpath"}],"output":{"name":"string"}}],[11,"cmt_to_string","","",1,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":{"name":"string"}}],[11,"cmt_to_path_or_string","","",1,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":{"name":"string"}}],[11,"join","","",36,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"initial_value","","",36,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"graphviz","rustc_borrowck","This module provides linkage between rustc::middle::graph and libgraphviz traits, specialized to attaching borrowck analysis data to rendered labels.",null,null],[6,"Node","rustc_borrowck::graphviz","",null,null],[6,"Edge","","",null,null],[3,"DataflowLabeller","","",null,null],[12,"inner","","",37,null],[12,"variants","","",37,null],[12,"borrowck_ctxt","","",37,null],[12,"analysis_data","","",37,null],[4,"Variant","","",null,null],[13,"Loans","","",38,null],[13,"Moves","","",38,null],[13,"Assigns","","",38,null],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"variant"}}],[11,"short_name","","",38,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"dataflow_for","","",37,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"node"}],"output":{"name":"string"}}],[11,"dataflow_for_variant","","",37,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"node"},{"name":"variant"}],"output":{"name":"string"}}],[11,"build_set","","",37,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"cfgindex"},{"name":"dataflowcontext"},{"name":"f"}],"output":{"name":"string"}}],[11,"dataflow_loans_for","","",37,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"cfgindex"}],"output":{"name":"string"}}],[11,"dataflow_moves_for","","",37,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"cfgindex"}],"output":{"name":"string"}}],[11,"dataflow_assigns_for","","",37,{"inputs":[{"name":"self"},{"name":"entryorexit"},{"name":"cfgindex"}],"output":{"name":"string"}}],[11,"graph_id","","",37,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"node_id","","",37,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",37,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",37,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",37,{"inputs":[{"name":"self"}],"output":{"generics":["node"],"name":"nodes"}}],[11,"edges","","",37,{"inputs":[{"name":"self"}],"output":{"generics":["edge"],"name":"edges"}}],[11,"source","","",37,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",37,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"node"}}]],"paths":[[3,"AnalysisData"],[3,"BorrowckCtxt"],[3,"Loan"],[3,"LoanPath"],[3,"BckError"],[4,"LoanPathKind"],[4,"InteriorKind"],[4,"LoanPathElem"],[4,"bckerr_code"],[4,"AliasableViolationKind"],[4,"MovedValueUseKind"],[3,"CheckLoanCtxt"],[4,"UseError"],[3,"GatherLoanCtxt"],[3,"GuaranteeLifetimeContext"],[3,"RestrictionsContext"],[4,"RestrictionResult"],[3,"GatherMoveInfo"],[4,"PatternSource"],[3,"MoveErrorCollector"],[3,"MoveError"],[3,"MovePlace"],[3,"GroupedMoveErrors"],[3,"MoveData"],[3,"FlowedMoveData"],[3,"MovePathIndex"],[3,"MoveIndex"],[3,"MovePath"],[3,"Move"],[3,"Assignment"],[4,"MoveKind"],[3,"MoveDataFlowOperator"],[3,"AssignDataFlowOperator"],[3,"UsedMutFinder"],[3,"UnusedMutCx"],[8,"ToInteriorKind"],[3,"LoanDataFlowOperator"],[3,"DataflowLabeller"],[4,"Variant"]]};
searchIndex["rustc_data_structures"] = {"doc":"Various data structures used by the Rust compiler. The intention is that code in here should be not be specific to rustc, so that it can be easily unit tested and so forth.","items":[[8,"ToHex","rustc_data_structures","A trait for converting a value to hexadecimal encoding",null,null],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned string.",0,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[0,"snapshot_vec","","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits you to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either to rollback to the start of the snapshot or commit those changes.",null,null],[4,"UndoLog","rustc_data_structures::snapshot_vec","",null,null],[13,"OpenSnapshot","","Indicates where a snapshot started.",1,null],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",1,null],[13,"NewElem","","New variable with given index was created.",1,null],[13,"SetElem","","Variable with given index was changed from the given value.",1,null],[13,"Other","","Extensible set of actions",1,null],[3,"SnapshotVec","","",null,null],[12,"values","","",2,null],[12,"undo_log","","",2,null],[3,"Snapshot","","",null,null],[12,"length","","",3,null],[8,"SnapshotVecDelegate","","",null,null],[16,"Value","","",4,null],[16,"Undo","","",4,null],[10,"reverse","","",4,null],[0,"unify","rustc_data_structures","Union-find implementation. The main type is `UnificationTable`.",null,null],[8,"UnifyKey","rustc_data_structures::unify","This trait is implemented by any type that can serve as a type variable. We call such variables unification keys. For example, this trait is implemented by `IntVid`, which represents integral variables.",null,null],[16,"Value","","",5,null],[10,"index","","",5,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[10,"from_index","","",5,{"inputs":[{"name":"u32"}],"output":{"name":"self"}}],[10,"tag","","",5,{"inputs":[],"output":{"name":"str"}}],[11,"order_roots","","If true, then `self` should be preferred as root to `other`. Note that we assume a consistent partial ordering, so returning true implies that `other.prefer_as_root_to(self)` would return false.  If there is no ordering between two keys (i.e., `a.prefer_as_root_to(b)` and `b.prefer_as_root_to(a)` both return false) then the rank will be used to determine the root in an optimal way.",5,null],[8,"UnifyValue","","Trait implemented for values associated with a unification key. This trait defines how to merge the values from two keys that are unioned together. This merging can be fallible. If you attempt to union two keys whose values cannot be merged, then the error is propagated up and the two keys are not unioned.",null,null],[16,"Error","","Defines the type to return when merging of two values fails. If merging is infallible, use the special struct `NoError` found in this crate, which unlocks various more convenient methods on the unification table.",6,null],[10,"unify_values","","Given two values, produce a new value that combines them. If that is not possible, produce an error.",6,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"result"}}],[8,"EqUnifyValue","","A convenient helper for unification values which must be equal or else an error occurs. For example, if you are unifying types in a simple functional language, this may be appropriate, since (e.g.) you can't unify a type variable bound to `int` with one bound to `float` (but you can unify two type variables both bound to `int`).",null,null],[3,"NoError","","A struct which can never be instantiated. Used for the error type for infallible cases.",null,null],[12,"_dummy","","",7,null],[3,"VarValue","","Value of a unification key. We implement Tarjan's union-find algorithm: when two keys are unified, one of them is converted into a \"redirect\" pointing at the other. These redirects form a DAG: the roots of the DAG (nodes that are not redirected) are each associated with a value of type `V` and a rank. The rank is used to keep the DAG relatively balanced, which helps keep the running time of the algorithm under control. For more information, see http://en.wikipedia.org/wiki/Disjoint-set_data_structure.",null,null],[12,"parent","","",8,null],[12,"value","","",8,null],[12,"rank","","",8,null],[3,"UnificationTable","","Table of unification keys and their values. You must define a key type K that implements the `UnifyKey` trait. Unification tables can be used in two-modes:",null,null],[12,"values","","Indicates the current value of each key.",9,null],[6,"InPlaceUnificationTable","","A unification table that uses an \"in-place\" vector.",null,null],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes made during the snapshot may either be committed or rolled back.",null,null],[12,"marker","","",10,null],[12,"snapshot","","",10,null],[3,"InPlace","","Backing store for an in-place unification table. Not typically used directly.",null,null],[12,"values","","",11,null],[8,"UnificationStore","","Largely internal trait implemented by the unification table backing store types. The most common such type is `InPlace`, which indicates a standard, mutable unification table.",null,null],[16,"Key","","",12,null],[16,"Value","","",12,null],[16,"Snapshot","","",12,null],[10,"new","","",12,{"inputs":[],"output":{"name":"self"}}],[10,"start_snapshot","","",12,null],[10,"rollback_to","","",12,null],[10,"commit","","",12,null],[10,"len","","",12,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[10,"push","","",12,null],[10,"update","","",12,null],[11,"tag","","",12,{"inputs":[],"output":{"name":"str"}}],[3,"OnDrop","rustc_data_structures","",null,null],[12,"0","","",13,null],[5,"__noop_fix_for_27438","","",null,{"inputs":[],"output":null}],[0,"array_vec","","A stack-allocated vector, allowing storage of N elements on the stack.",null,null],[3,"ArrayVec","rustc_data_structures::array_vec","",null,null],[12,"count","","",14,null],[12,"values","","",14,null],[3,"Iter","","",null,null],[12,"indices","","",15,null],[12,"store","","",15,null],[3,"Drain","","",null,null],[12,"tail_start","","",16,null],[12,"tail_len","","",16,null],[12,"iter","","",16,null],[12,"array_vec","","",16,null],[8,"Array","","",null,null],[16,"Element","","",17,null],[16,"PartialStorage","","",17,null],[18,"LEN","","",17,null],[11,"hash","","",14,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"clone","","",14,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"new","","",14,{"inputs":[],"output":{"name":"self"}}],[11,"len","","",14,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"set_len","","",14,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"push","","Panics when the stack vector is full.",14,null],[11,"pop","","",14,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"drain","","",14,{"inputs":[{"name":"self"},{"name":"r"}],"output":{"name":"drain"}}],[11,"default","","",14,{"inputs":[],"output":{"name":"self"}}],[11,"fmt","","",14,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"deref","","",14,null],[11,"deref_mut","","",14,null],[11,"drop","","",14,{"inputs":[{"name":"self"}],"output":null}],[11,"extend","","",14,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"drop","","",15,{"inputs":[{"name":"self"}],"output":null}],[11,"next","","",15,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",15,null],[11,"next","","",16,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",16,null],[11,"drop","","",16,{"inputs":[{"name":"self"}],"output":null}],[11,"into_iter","","",14,null],[0,"accumulate_vec","rustc_data_structures","A vector type intended to be used for collecting from iterators onto the stack.",null,null],[3,"IntoIter","rustc_data_structures::accumulate_vec","",null,null],[12,"repr","","",18,null],[4,"AccumulateVec","","",null,null],[13,"Array","","",19,null],[13,"Heap","","",19,null],[4,"IntoIterRepr","","",null,null],[13,"Array","","",20,null],[13,"Heap","","",20,null],[4,"Drain","","",null,null],[13,"Array","","",21,null],[13,"Heap","","",21,null],[11,"hash","","",19,null],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"new","","",19,{"inputs":[],"output":{"name":"accumulatevec"}}],[11,"one","","",19,null],[11,"many","","",19,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"len","","",19,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"is_empty","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"pop","","",19,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"drain","","",19,{"inputs":[{"name":"self"},{"name":"r"}],"output":{"name":"drain"}}],[11,"deref","","",19,null],[11,"deref_mut","","",19,null],[11,"from_iter","","",19,{"inputs":[{"name":"i"}],"output":{"name":"accumulatevec"}}],[11,"next","","",18,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",18,null],[11,"next","","",21,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",21,null],[11,"into_iter","","",19,null],[11,"from","","",19,{"inputs":[{"name":"vec"}],"output":{"name":"accumulatevec"}}],[11,"default","","",19,{"inputs":[],"output":{"name":"accumulatevec"}}],[11,"encode","","",19,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"d"}],"output":{"generics":["accumulatevec"],"name":"result"}}],[0,"small_vec","rustc_data_structures","A vector type intended to be used for collecting from iterators onto the stack.",null,null],[3,"SmallVec","rustc_data_structures::small_vec","",null,null],[12,"0","","",22,null],[11,"clone","","",22,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"fmt","","",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",22,{"inputs":[],"output":{"name":"self"}}],[11,"with_capacity","","",22,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"one","","",22,null],[11,"many","","",22,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"expect_one","","",22,null],[11,"push","","Will reallocate onto the heap if needed.",22,null],[11,"reserve","","",22,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"set_len","","",22,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"insert","","",22,null],[11,"truncate","","",22,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"deref","","",22,null],[11,"deref_mut","","",22,{"inputs":[{"name":"self"}],"output":{"name":"accumulatevec"}}],[11,"from_iter","","",22,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"extend","","",22,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"into_iter","","",22,null],[11,"default","","",22,{"inputs":[],"output":{"name":"smallvec"}}],[11,"encode","","",22,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",22,{"inputs":[{"name":"d"}],"output":{"generics":["smallvec"],"name":"result"}}],[0,"base_n","rustc_data_structures","",null,null],[5,"push_str","rustc_data_structures::base_n","",null,{"inputs":[{"name":"u128"},{"name":"usize"},{"name":"string"}],"output":null}],[5,"encode","","",null,{"inputs":[{"name":"u128"},{"name":"usize"}],"output":{"name":"string"}}],[17,"MAX_BASE","","",null,null],[17,"ALPHANUMERIC_ONLY","","",null,null],[17,"CASE_INSENSITIVE","","",null,null],[17,"BASE_64","","",null,null],[0,"bitslice","rustc_data_structures","",null,null],[3,"BitLookup","rustc_data_structures::bitslice","",null,null],[12,"word","","An index of the word holding the bit in original `[Word]` of query.",23,null],[12,"bit_in_word","","Index of the particular bit within the word holding the bit.",23,null],[12,"bit_mask","","Word with single 1-bit set corresponding to where the bit is located.",23,null],[3,"Intersect","","",null,null],[3,"Union","","",null,null],[3,"Subtract","","",null,null],[5,"bit_lookup","","",null,{"inputs":[{"name":"usize"}],"output":{"name":"bitlookup"}}],[5,"bit_str","","",null,{"inputs":[{"name":"word"}],"output":{"name":"string"}}],[5,"bits_to_string","","",null,null],[5,"bitwise","","",null,null],[6,"Word","","",null,null],[8,"BitSlice","","`BitSlice` provides helper methods for treating a `[Word]` as a bitvector.",null,null],[10,"clear_bit","","",24,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bool"}}],[10,"set_bit","","",24,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bool"}}],[10,"get_bit","","",24,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bool"}}],[8,"BitwiseOperator","","",null,null],[10,"join","","Applies some bit-operation pointwise to each of the bits in the two inputs.",25,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",27,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",28,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[0,"bitvec","rustc_data_structures","",null,null],[3,"BitVector","rustc_data_structures::bitvec","A very simple BitVector type.",null,null],[12,"data","","",29,null],[3,"BitVectorIter","","",null,null],[12,"iter","","",30,null],[12,"current","","",30,null],[12,"idx","","",30,null],[3,"BitMatrix","","A \"bit matrix\" is basically a matrix of booleans represented as one gigantic bitvector. In other words, it is as if you have `rows` bitvectors, each of length `columns`.",null,null],[12,"columns","","",31,null],[12,"vector","","",31,null],[3,"SparseBitMatrix","","",null,null],[12,"vector","","",32,null],[3,"SparseBitSet","","",null,null],[12,"chunk_bits","","",33,null],[12,"_marker","","",33,null],[3,"SparseChunk","","",null,null],[12,"key","","",34,null],[12,"bits","","",34,null],[12,"_marker","","",34,null],[5,"words","","",null,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[5,"word_mask","","",null,null],[6,"Word","","",null,null],[17,"WORD_BITS","","",null,null],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"bitvector"}}],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",29,{"inputs":[{"name":"self"},{"name":"bitvector"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"self"},{"name":"bitvector"}],"output":{"name":"bool"}}],[11,"new","","",29,{"inputs":[{"name":"usize"}],"output":{"name":"bitvector"}}],[11,"clear","","",29,{"inputs":[{"name":"self"}],"output":null}],[11,"count","","",29,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"contains","","",29,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"insert","","Returns true if the bit has changed.",29,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"remove","","Returns true if the bit has changed.",29,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"insert_all","","",29,{"inputs":[{"name":"self"},{"name":"bitvector"}],"output":{"name":"bool"}}],[11,"grow","","",29,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"iter","","Iterates over indexes of set bits in a sorted order",29,{"inputs":[{"name":"self"}],"output":{"name":"bitvectoriter"}}],[11,"next","","",30,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"option"}}],[11,"size_hint","","",30,null],[11,"from_iter","","",29,{"inputs":[{"name":"i"}],"output":{"name":"bitvector"}}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"bitmatrix"}}],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Create a new `rows x columns` matrix, initially empty.",31,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"bitmatrix"}}],[11,"range","","The range of bits for a given row.",31,null],[11,"add","","Sets the cell at `(row, column)` to true. Put another way, add `column` to the bitset for `row`.",31,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"contains","","Do the bits from `row` contain `column`? Put another way, is the matrix cell at `(row, column)` true?  Put yet another way, if the matrix represents (transitive) reachability, can `row` reach `column`?",31,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"intersection","","Returns those indices that are true in rows `a` and `b`.  This is an O(n) operation where `n` is the number of elements (somewhat independent from the actual size of the intersection, in particular).",31,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"generics":["usize"],"name":"vec"}}],[11,"merge","","Add the bits from row `read` to the bits from row `write`, return true if anything changed.",31,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"iter","","Iterates through all the columns set to true in a given row of the matrix.",31,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"bitvectoriter"}}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"sparsebitmatrix"}}],[11,"fmt","","",32,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Create a new `rows x columns` matrix, initially empty.",32,{"inputs":[{"name":"r"},{"name":"c"}],"output":{"name":"sparsebitmatrix"}}],[11,"add","","Sets the cell at `(row, column)` to true. Put another way, insert `column` to the bitset for `row`.",32,{"inputs":[{"name":"self"},{"name":"r"},{"name":"c"}],"output":{"name":"bool"}}],[11,"contains","","Do the bits from `row` contain `column`? Put another way, is the matrix cell at `(row, column)` true?  Put yet another way, if the matrix represents (transitive) reachability, can `row` reach `column`?",32,{"inputs":[{"name":"self"},{"name":"r"},{"name":"c"}],"output":{"name":"bool"}}],[11,"merge","","Add the bits from row `read` to the bits from row `write`, return true if anything changed.",32,{"inputs":[{"name":"self"},{"name":"r"},{"name":"r"}],"output":{"name":"bool"}}],[11,"iter","","Iterates through all the columns set to true in a given row of the matrix.",32,null],[11,"clone","","",33,{"inputs":[{"name":"self"}],"output":{"name":"sparsebitset"}}],[11,"fmt","","",33,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",34,{"inputs":[{"name":"self"}],"output":{"name":"sparsechunk"}}],[11,"one","","",34,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"any","","",34,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"iter","","",34,null],[11,"new","","",33,{"inputs":[],"output":{"name":"self"}}],[11,"capacity","","",33,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"contains_chunk","","",33,{"inputs":[{"name":"self"},{"name":"sparsechunk"}],"output":{"name":"sparsechunk"}}],[11,"insert_chunk","","",33,{"inputs":[{"name":"self"},{"name":"sparsechunk"}],"output":{"name":"sparsechunk"}}],[11,"remove_chunk","","",33,{"inputs":[{"name":"self"},{"name":"sparsechunk"}],"output":{"name":"sparsechunk"}}],[11,"clear","","",33,{"inputs":[{"name":"self"}],"output":null}],[11,"chunks","","",33,null],[11,"contains","","",33,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"bool"}}],[11,"insert","","",33,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"bool"}}],[11,"remove","","",33,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"bool"}}],[11,"iter","","",33,null],[0,"graph","rustc_data_structures","A graph module for use in dataflow, region resolution, and elsewhere.",null,null],[3,"Graph","rustc_data_structures::graph","",null,null],[12,"nodes","","",35,null],[12,"edges","","",35,null],[3,"Node","","",null,null],[12,"first_edge","","",36,null],[12,"data","","",36,null],[3,"Edge","","",null,null],[12,"next_edge","","",37,null],[12,"source","","",37,null],[12,"target","","",37,null],[12,"data","","",37,null],[3,"NodeIndex","","",null,null],[12,"0","","",38,null],[3,"EdgeIndex","","",null,null],[12,"0","","",39,null],[3,"Direction","","",null,null],[12,"repr","","",40,null],[3,"AdjacentEdges","","",null,null],[12,"graph","","",41,null],[12,"direction","","",41,null],[12,"next","","",41,null],[3,"DepthFirstTraversal","","",null,null],[12,"graph","","",42,null],[12,"stack","","",42,null],[12,"visited","","",42,null],[12,"direction","","",42,null],[17,"INVALID_EDGE_INDEX","","",null,null],[17,"OUTGOING","","",null,null],[17,"INCOMING","","",null,null],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"reverse","","",36,null],[11,"reverse","","",37,null],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"nodeindex"}}],[11,"eq","","",38,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",38,null],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",38,null],[11,"clone","","",39,{"inputs":[{"name":"self"}],"output":{"name":"edgeindex"}}],[11,"eq","","",39,{"inputs":[{"name":"self"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"self"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",39,null],[11,"fmt","","",39,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",39,null],[11,"clone","","",40,{"inputs":[{"name":"self"}],"output":{"name":"direction"}}],[11,"fmt","","",40,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",40,{"inputs":[{"name":"self"},{"name":"direction"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"self"},{"name":"direction"}],"output":{"name":"bool"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",38,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new","","",35,{"inputs":[],"output":{"name":"graph"}}],[11,"with_capacity","","",35,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",35,null],[11,"len_nodes","","",35,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"all_edges","","",35,null],[11,"len_edges","","",35,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"next_node_index","","",35,{"inputs":[{"name":"self"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",35,{"inputs":[{"name":"self"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",35,{"inputs":[{"name":"self"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"edge","","",35,{"inputs":[{"name":"self"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"enumerated_nodes","","",35,null],[11,"enumerated_edges","","",35,null],[11,"each_node","","Iterates over all edges defined in the graph.",35,null],[11,"each_edge","","Iterates over all edges defined in the graph",35,null],[11,"outgoing_edges","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"adjacentedges"}}],[11,"incoming_edges","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"adjacentedges"}}],[11,"adjacent_edges","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"adjacentedges"}}],[11,"successor_nodes","","",35,null],[11,"predecessor_nodes","","",35,null],[11,"depth_traverse","","",35,{"inputs":[{"name":"self"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"depthfirsttraversal"}}],[11,"nodes_in_postorder","","",35,{"inputs":[{"name":"self"},{"name":"direction"},{"name":"nodeindex"}],"output":{"generics":["nodeindex"],"name":"vec"}}],[11,"targets","","",41,null],[11,"sources","","",41,null],[11,"next","","",41,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",41,null],[11,"with_start_node","","",42,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"self"}}],[11,"visit","","",42,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":null}],[11,"next","","",42,{"inputs":[{"name":"self"}],"output":{"generics":["nodeindex"],"name":"option"}}],[11,"size_hint","","",42,null],[11,"source","","",37,{"inputs":[{"name":"self"}],"output":{"name":"nodeindex"}}],[11,"target","","",37,{"inputs":[{"name":"self"}],"output":{"name":"nodeindex"}}],[11,"source_or_target","","",37,{"inputs":[{"name":"self"},{"name":"direction"}],"output":{"name":"nodeindex"}}],[0,"indexed_set","rustc_data_structures","",null,null],[3,"IdxSetBuf","rustc_data_structures::indexed_set","Represents a set (or packed family of sets), of some element type E, where each E is identified by some unique index type `T`.",null,null],[12,"_pd","","",43,null],[12,"bits","","",43,null],[3,"IdxSet","","Represents a set (or packed family of sets), of some element type E, where each E is identified by some unique index type `T`.",null,null],[12,"_pd","","",44,null],[12,"bits","","",44,null],[3,"Iter","","",null,null],[12,"cur","","",45,null],[12,"iter","","",45,null],[12,"_pd","","",45,null],[11,"assert_receiver_is_total_eq","","",43,null],[11,"eq","","",43,{"inputs":[{"name":"self"},{"name":"idxsetbuf"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"self"},{"name":"idxsetbuf"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"encode","","",43,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",43,{"inputs":[{"name":"d"}],"output":{"generics":["idxsetbuf"],"name":"result"}}],[11,"borrow","","",43,{"inputs":[{"name":"self"}],"output":{"name":"idxset"}}],[11,"borrow_mut","","",43,{"inputs":[{"name":"self"}],"output":{"name":"idxset"}}],[11,"to_owned","","",44,null],[11,"fmt","","",43,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",44,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",43,{"inputs":[{"name":"word"},{"name":"usize"}],"output":{"name":"self"}}],[11,"new_filled","","Creates set holding every element whose index falls in range 0..universe_size.",43,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"new_empty","","Creates set holding no elements.",43,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"from_slice","","",44,null],[11,"from_slice_mut","","",44,null],[11,"deref","","",43,{"inputs":[{"name":"self"}],"output":{"name":"idxset"}}],[11,"deref_mut","","",43,{"inputs":[{"name":"self"}],"output":{"name":"idxset"}}],[11,"to_owned","","",44,{"inputs":[{"name":"self"}],"output":{"name":"idxsetbuf"}}],[11,"clear","","Removes all elements",44,{"inputs":[{"name":"self"}],"output":null}],[11,"set_up_to","","Sets all elements up to `universe_size`",44,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"trim_to","","Clear all elements above `universe_size`.",44,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"remove","","Removes `elem` from the set `self`; returns true iff this changed `self`.",44,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"add","","Adds `elem` to the set `self`; returns true iff this changed `self`.",44,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"range","","",44,{"inputs":[{"name":"self"},{"name":"range"}],"output":{"name":"self"}}],[11,"range_mut","","",44,{"inputs":[{"name":"self"},{"name":"range"}],"output":{"name":"self"}}],[11,"contains","","Returns true iff set `self` contains `elem`.",44,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"words","","",44,null],[11,"words_mut","","",44,null],[11,"clone_from","","",44,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"union","","",44,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":{"name":"bool"}}],[11,"subtract","","",44,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":{"name":"bool"}}],[11,"intersect","","",44,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":{"name":"bool"}}],[11,"iter","","",44,{"inputs":[{"name":"self"}],"output":{"name":"iter"}}],[11,"next","","",45,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[0,"indexed_vec","rustc_data_structures","",null,null],[3,"IndexVec","rustc_data_structures::indexed_vec","",null,null],[12,"raw","","",46,null],[12,"_marker","","",46,null],[3,"IntoIdx","","",null,null],[12,"_marker","","",47,null],[6,"Enumerated","","",null,null],[8,"Idx","","Represents some newtyped `usize` wrapper.",null,null],[10,"new","","",48,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[10,"index","","",48,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",46,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"eq","","",46,{"inputs":[{"name":"self"},{"name":"indexvec"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"self"},{"name":"indexvec"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",46,null],[11,"hash","","",46,null],[11,"encode","","",46,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",46,{"inputs":[{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",46,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",46,{"inputs":[],"output":{"name":"self"}}],[11,"with_capacity","","",46,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"from_elem","","",46,{"inputs":[{"name":"t"},{"name":"indexvec"}],"output":{"name":"self"}}],[11,"from_elem_n","","",46,{"inputs":[{"name":"t"},{"name":"usize"}],"output":{"name":"self"}}],[11,"push","","",46,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"i"}}],[11,"pop","","",46,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"len","","",46,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"is_empty","","",46,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"into_iter","","",46,{"inputs":[{"name":"self"}],"output":{"name":"intoiter"}}],[11,"into_iter_enumerated","","",46,{"inputs":[{"name":"self"}],"output":{"generics":["intoiter"],"name":"enumerated"}}],[11,"iter","","",46,{"inputs":[{"name":"self"}],"output":{"name":"iter"}}],[11,"iter_enumerated","","",46,{"inputs":[{"name":"self"}],"output":{"generics":["iter"],"name":"enumerated"}}],[11,"indices","","",46,{"inputs":[{"name":"self"}],"output":{"generics":["range","intoidx"],"name":"map"}}],[11,"iter_mut","","",46,{"inputs":[{"name":"self"}],"output":{"name":"itermut"}}],[11,"iter_enumerated_mut","","",46,{"inputs":[{"name":"self"}],"output":{"generics":["itermut"],"name":"enumerated"}}],[11,"drain","","",46,null],[11,"drain_enumerated","","",46,null],[11,"last","","",46,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"shrink_to_fit","","",46,{"inputs":[{"name":"self"}],"output":null}],[11,"swap","","",46,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":null}],[11,"truncate","","",46,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"get","","",46,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"option"}}],[11,"get_mut","","",46,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"option"}}],[11,"pick2_mut","","Return mutable references to two distinct elements, a and b. Panics if a == b.",46,null],[11,"convert_index_type","","",46,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"resize","","",46,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"binary_search","","",46,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"result"}}],[11,"index","","",46,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"t"}}],[11,"index_mut","","",46,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"t"}}],[11,"default","","",46,{"inputs":[],"output":{"name":"self"}}],[11,"extend","","",46,{"inputs":[{"name":"self"},{"name":"j"}],"output":null}],[11,"from_iter","","",46,{"inputs":[{"name":"j"}],"output":{"name":"self"}}],[11,"into_iter","","",46,{"inputs":[{"name":"self"}],"output":{"name":"intoiter"}}],[11,"call_once","","",47,null],[11,"call_mut","","",47,null],[11,"call_once","","",47,null],[11,"call_mut","","",47,null],[0,"lazy_btree_map","rustc_data_structures","",null,null],[3,"LazyBTreeMap","rustc_data_structures::lazy_btree_map","A thin wrapper around BTreeMap that avoids allocating upon creation.",null,null],[12,"0","","",49,null],[3,"Iter","","",null,null],[12,"0","","",50,null],[3,"Values","","",null,null],[12,"0","","",51,null],[11,"fmt","","",49,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",49,{"inputs":[],"output":{"name":"lazybtreemap"}}],[11,"iter","","",49,{"inputs":[{"name":"self"}],"output":{"name":"iter"}}],[11,"is_empty","","",49,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"instantiate","","",49,{"inputs":[{"name":"self"}],"output":{"name":"btreemap"}}],[11,"insert","","",49,{"inputs":[{"name":"self"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"entry","","",49,{"inputs":[{"name":"self"},{"name":"k"}],"output":{"name":"entry"}}],[11,"values","","",49,{"inputs":[{"name":"self"}],"output":{"name":"values"}}],[11,"default","","",49,{"inputs":[],"output":{"name":"lazybtreemap"}}],[11,"next","","",50,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",50,null],[11,"next","","",51,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",51,null],[0,"obligation_forest","rustc_data_structures","The `ObligationForest` is a utility data structure used in trait matching to track the set of outstanding obligations (those not yet resolved to success or error). It also tracks the \"backtrace\" of each pending obligation (why we are trying to figure this out in the first place). See README.md for a general overview of how to use this class.",null,null],[3,"ObligationForest","rustc_data_structures::obligation_forest","",null,null],[12,"nodes","","The list of obligations. In between calls to `process_obligations`, this list only contains nodes in the `Pending` or `Success` state (with a non-zero number of incomplete children). During processing, some of those nodes may be changed to the error state, or we may find that they are completed (That is, `num_incomplete_children` drops to 0). At the end of processing, those nodes will be removed by a call to `compress`.",52,null],[12,"done_cache","","A cache of predicates that have been successfully completed.",52,null],[12,"waiting_cache","","An cache of the nodes in `nodes`, indexed by predicate.",52,null],[12,"cache_list","","A list of the obligations added in snapshots, to allow for their removal.",52,null],[12,"scratch","","",52,null],[3,"Node","","",null,null],[12,"obligation","","",53,null],[12,"state","","",53,null],[12,"dependents","","Obligations that depend on this obligation for their completion. They must all be in a non-pending state.",53,null],[12,"parent","","The parent of a node - the original obligation of which it is a subobligation. Except for error reporting, this is just another member of `dependents`.",53,null],[3,"Outcome","","",null,null],[12,"completed","","Obligations that were completely evaluated, including all (transitive) subobligations.",54,null],[12,"errors","","Backtrace of obligations that were found to be in error.",54,null],[12,"stalled","","If true, then we saw no successful obligations, which means there is no point in further iteration. This is based on the assumption that when trait matching returns `Err` or `Ok(None)`, those results do not affect environmental inference state. (Note that if we invoke `process_obligations` with no pending obligations, stalled will be true.)",54,null],[3,"Error","","",null,null],[12,"error","","",55,null],[12,"backtrace","","",55,null],[3,"GetObligation","","",null,null],[12,"0","","",56,null],[4,"NodeState","","The state of one node in some tree within the forest. This represents the current state of processing for the obligation (of type `O`) associated with this node.",null,null],[13,"Pending","","Obligations for which selection had not yet returned a non-ambiguous result.",57,null],[13,"Success","","This obligation was selected successfully, but may or may not have subobligations.",57,null],[13,"Waiting","","This obligation was selected successfully, but it has a pending subobligation.",57,null],[13,"Done","","This obligation, along with its subobligations, are complete, and will be removed in the next collection.",57,null],[13,"Error","","This obligation was resolved to an error. Error nodes are removed from the vector by the compression step.",57,null],[13,"OnDfsStack","","This is a temporary state used in DFS loops to detect cycles, it should not exist outside of these DFSes.",57,null],[0,"node_index","","",null,null],[3,"NodeIndex","rustc_data_structures::obligation_forest::node_index","",null,null],[12,"index","","",58,null],[11,"clone","","",58,{"inputs":[{"name":"self"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",58,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",58,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"self"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",58,null],[11,"new","","",58,{"inputs":[{"name":"usize"}],"output":{"name":"nodeindex"}}],[11,"get","","",58,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[8,"ForestObligation","rustc_data_structures::obligation_forest","",null,null],[16,"Predicate","","",59,null],[10,"as_predicate","","",59,null],[8,"ObligationProcessor","","",null,null],[16,"Obligation","","",60,null],[16,"Error","","",60,null],[10,"process_obligation","","",60,null],[10,"process_backedge","","As we do the cycle check, we invoke this callback when we encounter an actual cycle. `cycle` is an iterator that starts at the start of the cycle in the stack and walks toward the top.",60,{"inputs":[{"name":"self"},{"name":"i"},{"name":"phantomdata"}],"output":null}],[11,"fmt","","",53,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",57,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",57,{"inputs":[{"name":"self"}],"output":{"name":"nodestate"}}],[11,"eq","","",57,{"inputs":[{"name":"self"},{"name":"nodestate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",57,null],[11,"fmt","","",54,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",55,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"self"},{"name":"error"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"self"},{"name":"error"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",55,null],[11,"new","","",52,{"inputs":[],"output":{"name":"obligationforest"}}],[11,"len","","Return the total number of nodes in the forest that have not yet been fully resolved.",52,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"register_obligation","","Registers an obligation",52,{"inputs":[{"name":"self"},{"name":"o"}],"output":null}],[11,"register_obligation_at","","",52,{"inputs":[{"name":"self"},{"name":"o"},{"generics":["nodeindex"],"name":"option"}],"output":{"name":"result"}}],[11,"to_errors","","Convert all remaining obligations to the given error.",52,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"generics":["error"],"name":"vec"}}],[11,"pending_obligations","","Returns the set of obligations that are in a pending state.",52,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"process_obligations","","Perform a pass through the obligation list. This must be called in a loop until `outcome.stalled` is false.",52,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"outcome"}}],[11,"process_cycles","","Mark all NodeState::Success nodes as NodeState::Done and report all cycles between them. This should be called after `mark_as_waiting` marks all nodes with pending subobligations as NodeState::Waiting.",52,{"inputs":[{"name":"self"},{"name":"p"}],"output":null}],[11,"find_cycles_from_node","","",52,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"p"},{"name":"usize"}],"output":null}],[11,"error_at","","Returns a vector of obligations for `p` and all of its ancestors, putting them into the error state in the process.",52,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"mark_neighbors_as_waiting_from","","",52,{"inputs":[{"name":"self"},{"name":"node"}],"output":null}],[11,"mark_as_waiting","","Marks all nodes that depend on a pending node as NodeState::Waiting.",52,{"inputs":[{"name":"self"}],"output":null}],[11,"mark_as_waiting_from","","",52,{"inputs":[{"name":"self"},{"name":"node"}],"output":null}],[11,"compress","","Compresses the vector, removing all popped nodes. This adjusts the indices and hence invalidates any outstanding indices. Cannot be used during a transaction.",52,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"apply_rewrites","","",52,null],[11,"new","","",53,{"inputs":[{"generics":["nodeindex"],"name":"option"},{"name":"o"}],"output":{"name":"node"}}],[11,"clone","","",56,{"inputs":[{"name":"self"}],"output":{"name":"getobligation"}}],[11,"call_once","","",56,null],[11,"call_mut","","",56,null],[0,"sip128","rustc_data_structures","This is a copy of `core::hash::sip` adapted to providing 128 bit hashes.",null,null],[3,"SipHasher128","rustc_data_structures::sip128","",null,null],[12,"k0","","",61,null],[12,"k1","","",61,null],[12,"length","","",61,null],[12,"state","","",61,null],[12,"tail","","",61,null],[12,"ntail","","",61,null],[3,"State","","",null,null],[12,"v0","","",62,null],[12,"v2","","",62,null],[12,"v1","","",62,null],[12,"v3","","",62,null],[3,"Sip24Rounds","","",null,null],[5,"u8to64_le","","Load an u64 using up to 7 bytes of a byte slice.",null,null],[11,"fmt","","",61,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",61,{"inputs":[{"name":"self"}],"output":{"name":"siphasher128"}}],[11,"fmt","","",62,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",62,{"inputs":[{"name":"self"}],"output":{"name":"state"}}],[11,"new_with_keys","","",61,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher128"}}],[11,"reset","","",61,{"inputs":[{"name":"self"}],"output":null}],[11,"short_write","","",61,null],[11,"short_write_gen","","",61,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"finish128","","",61,null],[11,"write_u8","","",61,{"inputs":[{"name":"self"},{"name":"u8"}],"output":null}],[11,"write_u16","","",61,{"inputs":[{"name":"self"},{"name":"u16"}],"output":null}],[11,"write_u32","","",61,{"inputs":[{"name":"self"},{"name":"u32"}],"output":null}],[11,"write_u64","","",61,{"inputs":[{"name":"self"},{"name":"u64"}],"output":null}],[11,"write_usize","","",61,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"write_i8","","",61,{"inputs":[{"name":"self"},{"name":"i8"}],"output":null}],[11,"write_i16","","",61,{"inputs":[{"name":"self"},{"name":"i16"}],"output":null}],[11,"write_i32","","",61,{"inputs":[{"name":"self"},{"name":"i32"}],"output":null}],[11,"write_i64","","",61,{"inputs":[{"name":"self"},{"name":"i64"}],"output":null}],[11,"write_isize","","",61,{"inputs":[{"name":"self"},{"name":"isize"}],"output":null}],[11,"write","","",61,null],[11,"finish","","",61,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"fmt","","",63,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",63,{"inputs":[{"name":"self"}],"output":{"name":"sip24rounds"}}],[11,"default","","",63,{"inputs":[],"output":{"name":"sip24rounds"}}],[11,"c_rounds","","",63,{"inputs":[{"name":"state"}],"output":null}],[11,"d_rounds","","",63,{"inputs":[{"name":"state"}],"output":null}],[0,"snapshot_map","rustc_data_structures","",null,null],[3,"SnapshotMap","rustc_data_structures::snapshot_map","",null,null],[12,"map","","",64,null],[12,"undo_log","","",64,null],[3,"Snapshot","","",null,null],[12,"len","","",65,null],[4,"UndoLog","","",null,null],[13,"OpenSnapshot","","",66,null],[13,"CommittedSnapshot","","",66,null],[13,"Inserted","","",66,null],[13,"Overwrite","","",66,null],[13,"Noop","","",66,null],[11,"new","","",64,{"inputs":[],"output":{"name":"self"}}],[11,"clear","","",64,{"inputs":[{"name":"self"}],"output":null}],[11,"insert","","",64,{"inputs":[{"name":"self"},{"name":"k"},{"name":"v"}],"output":{"name":"bool"}}],[11,"remove","","",64,{"inputs":[{"name":"self"},{"name":"k"}],"output":{"name":"bool"}}],[11,"get","","",64,{"inputs":[{"name":"self"},{"name":"k"}],"output":{"name":"option"}}],[11,"snapshot","","",64,{"inputs":[{"name":"self"}],"output":{"name":"snapshot"}}],[11,"assert_open_snapshot","","",64,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":null}],[11,"commit","","",64,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":null}],[11,"partial_rollback","","",64,{"inputs":[{"name":"self"},{"name":"snapshot"},{"name":"f"}],"output":null}],[11,"rollback_to","","",64,{"inputs":[{"name":"self"},{"name":"snapshot"}],"output":null}],[11,"reverse","","",64,{"inputs":[{"name":"self"},{"name":"undolog"}],"output":null}],[11,"index","","",64,{"inputs":[{"name":"self"},{"name":"k"}],"output":{"name":"v"}}],[0,"stable_hasher","rustc_data_structures","",null,null],[3,"StableHasher","rustc_data_structures::stable_hasher","When hashing something that ends up affecting properties like symbol names, we want these symbol names to be calculated independently of other factors like what architecture you're compiling from.",null,null],[12,"state","","",67,null],[12,"bytes_hashed","","",67,null],[12,"width","","",67,null],[3,"StableVec","","A vector container that makes sure that its items are hashed in a stable order.",null,null],[12,"0","","",68,null],[5,"hash_stable_hashmap","","",null,{"inputs":[{"name":"hcx"},{"name":"stablehasher"},{"name":"hashmap"},{"name":"f"}],"output":null}],[8,"StableHasherResult","","",null,null],[10,"finish","","",69,{"inputs":[{"name":"stablehasher"}],"output":{"name":"self"}}],[8,"HashStable","","Something that implements `HashStable<CTX>` can be hashed in a way that is stable across multiple compilation sessions.",null,null],[10,"hash_stable","","",70,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[8,"ToStableHashKey","","Implement this for types that can be turned into stable keys like, for example, for DefId that can be converted to a DefPathHash. This is used for bringing maps into a predictable order before hashing them.",null,null],[16,"KeyType","","",71,null],[10,"to_stable_hash_key","","",71,null],[11,"fmt","","",67,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",67,{"inputs":[],"output":{"name":"self"}}],[11,"finish","","",67,{"inputs":[{"name":"self"}],"output":{"name":"w"}}],[11,"finalize","","",67,null],[11,"bytes_hashed","","",67,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"finish","","",67,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"write","","",67,null],[11,"write_u8","","",67,{"inputs":[{"name":"self"},{"name":"u8"}],"output":null}],[11,"write_u16","","",67,{"inputs":[{"name":"self"},{"name":"u16"}],"output":null}],[11,"write_u32","","",67,{"inputs":[{"name":"self"},{"name":"u32"}],"output":null}],[11,"write_u64","","",67,{"inputs":[{"name":"self"},{"name":"u64"}],"output":null}],[11,"write_u128","","",67,{"inputs":[{"name":"self"},{"name":"u128"}],"output":null}],[11,"write_usize","","",67,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"write_i8","","",67,{"inputs":[{"name":"self"},{"name":"i8"}],"output":null}],[11,"write_i16","","",67,{"inputs":[{"name":"self"},{"name":"i16"}],"output":null}],[11,"write_i32","","",67,{"inputs":[{"name":"self"},{"name":"i32"}],"output":null}],[11,"write_i64","","",67,{"inputs":[{"name":"self"},{"name":"i64"}],"output":null}],[11,"write_i128","","",67,{"inputs":[{"name":"self"},{"name":"i128"}],"output":null}],[11,"write_isize","","",67,{"inputs":[{"name":"self"},{"name":"isize"}],"output":null}],[11,"hash_stable","rustc_data_structures::indexed_vec","",46,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","rustc_data_structures::indexed_set","",43,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"new","rustc_data_structures::stable_hasher","",68,{"inputs":[{"name":"vec"}],"output":{"name":"self"}}],[11,"deref","","",68,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"hash_stable","","",68,{"inputs":[{"name":"self"},{"name":"hcx"},{"name":"stablehasher"}],"output":null}],[0,"transitive_relation","rustc_data_structures","",null,null],[3,"TransitiveRelation","rustc_data_structures::transitive_relation","",null,null],[12,"elements","","",72,null],[12,"map","","",72,null],[12,"edges","","",72,null],[12,"closure","","",72,null],[3,"Index","","",null,null],[12,"0","","",73,null],[3,"Edge","","",null,null],[12,"source","","",74,null],[12,"target","","",74,null],[5,"pare_down","","Pare down is used as a step in the LUB computation. It edits the candidates array in place by removing any element j for which there exists an earlier element i<j such that i -> j. That is, after you run `pare_down`, you know that for all elements that remain in candidates, they cannot reach any of the elements that come after them.",null,{"inputs":[{"name":"vec"},{"name":"bitmatrix"}],"output":null}],[11,"clone","","",72,{"inputs":[{"name":"self"}],"output":{"name":"transitiverelation"}}],[11,"fmt","","",72,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",73,{"inputs":[{"name":"self"}],"output":{"name":"index"}}],[11,"eq","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",73,null],[11,"partial_cmp","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"bool"}}],[11,"le","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"bool"}}],[11,"gt","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"bool"}}],[11,"ge","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"bool"}}],[11,"cmp","","",73,{"inputs":[{"name":"self"},{"name":"index"}],"output":{"name":"ordering"}}],[11,"hash","","",73,null],[11,"encode","","",73,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",73,{"inputs":[{"name":"__d"}],"output":{"generics":["index"],"name":"result"}}],[11,"fmt","","",73,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",74,{"inputs":[{"name":"self"}],"output":{"name":"edge"}}],[11,"eq","","",74,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",74,null],[11,"encode","","",74,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",74,{"inputs":[{"name":"__d"}],"output":{"generics":["edge"],"name":"result"}}],[11,"fmt","","",74,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",72,{"inputs":[],"output":{"name":"transitiverelation"}}],[11,"is_empty","","",72,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"index","","",72,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"generics":["index"],"name":"option"}}],[11,"add_index","","",72,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"index"}}],[11,"maybe_map","","Applies the (partial) function to each edge and returns a new relation.  If `f` returns `None` for any end-point, returns `None`.",72,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"generics":["transitiverelation"],"name":"option"}}],[11,"add","","Indicate that `a < b` (where `<` is this relation)",72,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":null}],[11,"contains","","Check whether `a < target` (transitively)",72,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"bool"}}],[11,"reachable_from","","Thinking of `x R y` as an edge `x -> y` in a graph, this returns all things reachable from `a`.",72,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"vec"}}],[11,"postdom_upper_bound","","Picks what I am referring to as the \"postdominating\" upper-bound for `a` and `b`. This is usually the least upper bound, but in cases where there is no single least upper bound, it is the \"mutual immediate postdominator\", if you imagine a graph where `a < b` means `a -> b`.",72,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[11,"mutual_immediate_postdominator","","Viewing the relation as a graph, computes the \"mutual immediate postdominator\" of a set of points (if one exists). See `postdom_upper_bound` for details.",72,{"inputs":[{"name":"self"},{"name":"vec"}],"output":{"name":"option"}}],[11,"minimal_upper_bounds","","Returns the set of bounds `X` such that:",72,{"inputs":[{"name":"self"},{"name":"t"},{"name":"t"}],"output":{"name":"vec"}}],[11,"parents","","Given an element A, returns the maximal set {B} of elements B such that",72,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"vec"}}],[11,"postdom_parent","","A \"best\" parent in some sense. See `parents` and `postdom_upper_bound` for more details.",72,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"with_closure","","",72,{"inputs":[{"name":"self"},{"name":"op"}],"output":{"name":"r"}}],[11,"compute_closure","","",72,{"inputs":[{"name":"self"}],"output":{"name":"bitmatrix"}}],[11,"encode","","",72,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",72,{"inputs":[{"name":"d"}],"output":{"name":"result"}}],[11,"hash_stable","","",72,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",74,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"hash_stable","","",73,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[0,"fx","rustc_data_structures","",null,null],[3,"FxHasher","rustc_data_structures::fx","A speedy hash algorithm for use within rustc. The hashmap in liballoc by default uses SipHash which isn't quite as speedy as we want. In the compiler we're not really worried about DOS attempts, so we use a fast non-cryptographic hash.",null,null],[12,"hash","","",75,null],[5,"FxHashMap","","",null,{"inputs":[],"output":{"name":"fxhashmap"}}],[5,"FxHashSet","","",null,{"inputs":[],"output":{"name":"fxhashset"}}],[6,"FxHashMap","","",null,null],[6,"FxHashSet","","",null,null],[17,"K","","",null,null],[11,"default","","",75,{"inputs":[],"output":{"name":"fxhasher"}}],[11,"add_to_hash","","",75,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"write","","",75,null],[11,"write_u8","","",75,{"inputs":[{"name":"self"},{"name":"u8"}],"output":null}],[11,"write_u16","","",75,{"inputs":[{"name":"self"},{"name":"u16"}],"output":null}],[11,"write_u32","","",75,{"inputs":[{"name":"self"},{"name":"u32"}],"output":null}],[11,"write_u64","","",75,{"inputs":[{"name":"self"},{"name":"u64"}],"output":null}],[11,"write_usize","","",75,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"finish","","",75,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[0,"tuple_slice","rustc_data_structures","",null,null],[8,"TupleSlice","rustc_data_structures::tuple_slice","Allows to view uniform tuples as slices",null,null],[10,"as_slice","","",76,null],[10,"as_mut_slice","","",76,null],[0,"control_flow_graph","rustc_data_structures","",null,null],[0,"dominators","rustc_data_structures::control_flow_graph","Algorithm citation: A Simple, Fast Dominance Algorithm. Keith D. Cooper, Timothy J. Harvey, and Ken Kennedy Rice Computer Science TS-06-33870 https://www.cs.rice.edu/~keith/EMBED/dom.pdf",null,null],[3,"Dominators","rustc_data_structures::control_flow_graph::dominators","",null,null],[12,"post_order_rank","","",77,null],[12,"immediate_dominators","","",77,null],[3,"Iter","","",null,null],[12,"dominators","","",78,null],[12,"node","","",78,null],[3,"DominatorTree","","",null,null],[12,"root","","",79,null],[12,"children","","",79,null],[3,"DominatorTreeNode","","",null,null],[12,"tree","","",80,null],[12,"node","","",80,null],[5,"dominators","","",null,{"inputs":[{"name":"g"}],"output":{"name":"dominators"}}],[5,"dominators_given_rpo","","",null,null],[5,"intersect_opt","","",null,{"inputs":[{"name":"indexvec"},{"name":"indexvec"},{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[5,"intersect","","",null,{"inputs":[{"name":"indexvec"},{"name":"indexvec"},{"name":"node"},{"name":"node"}],"output":{"name":"node"}}],[11,"clone","","",77,{"inputs":[{"name":"self"}],"output":{"name":"dominators"}}],[11,"fmt","","",77,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_reachable","","",77,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"bool"}}],[11,"immediate_dominator","","",77,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"node"}}],[11,"dominators","","",77,{"inputs":[{"name":"self"},{"name":"node"}],"output":{"name":"iter"}}],[11,"is_dominated_by","","",77,{"inputs":[{"name":"self"},{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"next","","",78,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"children","","",79,null],[11,"fmt","","",79,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",80,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[0,"iterate","rustc_data_structures::control_flow_graph","",null,null],[5,"post_order_from","rustc_data_structures::control_flow_graph::iterate","",null,null],[5,"post_order_from_to","","",null,null],[5,"post_order_walk","","",null,null],[5,"reverse_post_order","","",null,null],[0,"reference","rustc_data_structures::control_flow_graph","",null,null],[8,"ControlFlowGraph","","",null,null],[16,"Node","","",81,null],[10,"num_nodes","","",81,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[10,"start_node","","",81,null],[10,"predecessors","","",81,null],[10,"successors","","",81,null],[8,"GraphPredecessors","","",null,null],[16,"Item","","",82,null],[16,"Iter","","",82,null],[8,"GraphSuccessors","","",null,null],[16,"Item","","",83,null],[16,"Iter","","",83,null],[0,"flock","rustc_data_structures","Simple file-locking apis for each OS.",null,null],[3,"Lock","rustc_data_structures::flock","",null,null],[12,"fd","","",84,null],[0,"imp","","",null,null],[3,"Lock","rustc_data_structures::flock::imp","",null,null],[12,"fd","","",84,null],[0,"os","","",null,null],[3,"flock","rustc_data_structures::flock::imp::os","",null,null],[12,"l_type","","",85,null],[12,"l_whence","","",85,null],[12,"l_start","","",85,null],[12,"l_len","","",85,null],[12,"l_pid","","",85,null],[12,"l_sysid","","",85,null],[17,"F_RDLCK","","",null,null],[17,"F_WRLCK","","",null,null],[17,"F_UNLCK","","",null,null],[17,"F_SETLK","","",null,null],[17,"F_SETLKW","","",null,null],[11,"fmt","rustc_data_structures::flock","",84,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",84,{"inputs":[{"name":"path"},{"name":"bool"},{"name":"bool"},{"name":"bool"}],"output":{"generics":["lock"],"name":"result"}}],[11,"drop","","",84,{"inputs":[{"name":"self"}],"output":null}],[11,"panicking_new","","",84,{"inputs":[{"name":"path"},{"name":"bool"},{"name":"bool"},{"name":"bool"}],"output":{"name":"lock"}}],[0,"sync","rustc_data_structures","This mdoule defines types which are thread safe if cfg!(parallel_queries) is true.",null,null],[3,"Lrc","rustc_data_structures::sync","A single-threaded reference-counting pointer. 'Rc' stands for 'Reference Counted'.",null,null],[12,"ptr","","",86,null],[12,"phantom","","",86,null],[3,"ReadGuard","","Wraps a borrowed reference to a value in a `RefCell` box. A wrapper type for an immutably borrowed value from a `RefCell<T>`.",null,null],[12,"value","","",87,null],[12,"borrow","","",87,null],[3,"WriteGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",null,null],[12,"value","","",88,null],[12,"borrow","","",88,null],[3,"LockGuard","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",null,null],[12,"value","","",88,null],[12,"borrow","","",88,null],[3,"MTLock","","",null,null],[12,"0","","",89,null],[3,"LockCell","","",null,null],[12,"0","","",90,null],[3,"Once","","A type whose inner value can be written once and then will stay read-only",null,null],[12,"0","","",91,null],[12,"1","","",91,null],[3,"Lock","","",null,null],[12,"0","","",92,null],[3,"RwLock","","",null,null],[12,"0","","",93,null],[3,"OneThread","","A type which only allows its inner value to be used in one thread. It will panic if it is used on multiple threads.",null,null],[12,"inner","","",94,null],[5,"assert_sync","","",null,{"inputs":[],"output":null}],[5,"assert_send_val","","",null,{"inputs":[{"name":"t"}],"output":null}],[5,"assert_send_sync_val","","",null,{"inputs":[{"name":"t"}],"output":null}],[6,"MetadataRef","","",null,null],[8,"Send","","",null,null],[8,"Sync","","",null,null],[8,"HashMapExt","","",null,null],[10,"insert_same","","Same as HashMap::insert, but it may panic if there's already an entry for `key` with a value not equal to `value`",95,{"inputs":[{"name":"self"},{"name":"k"},{"name":"v"}],"output":null}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",89,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"into_inner","","",89,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"get_mut","","",89,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"lock","","",89,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"borrow","","",89,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"borrow_mut","","",89,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"clone","","",89,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"new","","",90,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"into_inner","","",90,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"set","","",90,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"get","","",90,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"set_mut","","",90,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"get_mut","","",90,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"take","","",90,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"new","","Creates an Once value which is uninitialized",91,{"inputs":[],"output":{"name":"self"}}],[11,"into_inner","","Consumes the value and returns Some(T) if it was initialized",91,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"try_set","","Tries to initialize the inner value to `value`. Returns `None` if the inner value was uninitialized and `value` was consumed setting it otherwise if the inner value was already set it returns `value` back to the caller",91,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"try_set_same","","Tries to initialize the inner value to `value`. Returns `None` if the inner value was uninitialized and `value` was consumed setting it otherwise if the inner value was already set it asserts that `value` is equal to the inner value and then returns `value` back to the caller",91,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"set","","Tries to initialize the inner value to `value` and panics if it was already initialized",91,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"init_locking","","Tries to initialize the inner value by calling the closure while ensuring that no-one else can access the value in the mean time by holding a lock for the duration of the closure. If the value was already initialized the closure is not called and `false` is returned, otherwise if the value from the closure initializes the inner value, `true` is returned",91,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"init_nonlocking","","Tries to initialize the inner value by calling the closure without ensuring that no-one else can access it. This mean when this is called from multiple threads, multiple closures may concurrently be computing a value which the inner value should take. Only one of these closures are used to actually initialize the value. If some other closure already set the value, we return the value our closure computed wrapped in a `Option`. If our closure set the value, `None` is returned. If the value is already initialized, the closure is not called and `None` is returned.",91,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"option"}}],[11,"init_nonlocking_same","","Tries to initialize the inner value by calling the closure without ensuring that no-one else can access it. This mean when this is called from multiple threads, multiple closures may concurrently be computing a value which the inner value should take. Only one of these closures are used to actually initialize the value. If some other closure already set the value, we assert that it our closure computed a value equal to the value aready set and then we return the value our closure computed wrapped in a `Option`. If our closure set the value, `None` is returned. If the value is already initialized, the closure is not called and `None` is returned.",91,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"option"}}],[11,"try_get","","Tries to get a reference to the inner value, returns `None` if it is not yet initialized",91,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"get","","Gets reference to the inner value, panics if it is not yet initialized",91,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"borrow","","Gets reference to the inner value, panics if it is not yet initialized",91,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"fmt","","",90,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","Creates a `LockCell<T>`, with the `Default` value for T.",90,{"inputs":[],"output":{"name":"lockcell"}}],[11,"eq","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"name":"bool"}}],[11,"le","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"name":"bool"}}],[11,"gt","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"name":"bool"}}],[11,"ge","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"name":"bool"}}],[11,"cmp","","",90,{"inputs":[{"name":"self"},{"name":"lockcell"}],"output":{"name":"ordering"}}],[11,"fmt","","",92,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",92,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"into_inner","","",92,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"get_mut","","",92,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"lock","","",92,{"inputs":[{"name":"self"}],"output":{"name":"lockguard"}}],[11,"with_lock","","",92,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"borrow","","",92,{"inputs":[{"name":"self"}],"output":{"name":"lockguard"}}],[11,"borrow_mut","","",92,{"inputs":[{"name":"self"}],"output":{"name":"lockguard"}}],[11,"default","","",92,{"inputs":[],"output":{"name":"self"}}],[11,"clone","","",92,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"fmt","","",93,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",93,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"into_inner","","",93,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"get_mut","","",93,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"read","","",93,{"inputs":[{"name":"self"}],"output":{"name":"readguard"}}],[11,"with_read_lock","","",93,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"try_write","","",93,{"inputs":[{"name":"self"}],"output":{"generics":["writeguard"],"name":"result"}}],[11,"write","","",93,{"inputs":[{"name":"self"}],"output":{"name":"writeguard"}}],[11,"with_write_lock","","",93,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"borrow","","",93,{"inputs":[{"name":"self"}],"output":{"name":"readguard"}}],[11,"borrow_mut","","",93,{"inputs":[{"name":"self"}],"output":{"name":"writeguard"}}],[11,"clone","","",93,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"clone","","",94,{"inputs":[{"name":"self"}],"output":{"name":"onethread"}}],[11,"hash","","",94,null],[11,"fmt","","",94,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",94,null],[11,"eq","","",94,{"inputs":[{"name":"self"},{"name":"onethread"}],"output":{"name":"bool"}}],[11,"ne","","",94,{"inputs":[{"name":"self"},{"name":"onethread"}],"output":{"name":"bool"}}],[11,"check","","",94,{"inputs":[{"name":"self"}],"output":null}],[11,"new","","",94,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"into_inner","","",94,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"deref","","",94,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"deref_mut","","",94,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[0,"owning_ref","rustc_data_structures","An owning reference.",null,null],[8,"StableAddress","rustc_data_structures::owning_ref","An unsafe marker trait for types that deref to a stable address, even when moved. For example, this is implemented by Box, Vec, Rc, Arc and String, among others. Even when a Box is moved, the underlying storage remains at a fixed location.",null,null],[8,"CloneStableAddress","","An unsafe marker trait for types where clones deref to the same address. This has all the requirements of StableDeref, and additionally requires that after calling clone(), both the old and new value deref to the same address. For example, Rc and Arc implement CloneStableDeref, but Box and Vec do not.",null,null],[3,"OwningRef","","An owning reference.",null,null],[12,"owner","","",96,null],[12,"reference","","",96,null],[3,"OwningRefMut","","An mutable owning reference.",null,null],[12,"owner","","",97,null],[12,"reference","","",97,null],[3,"OwningHandle","","`OwningHandle` is a complement to `OwningRef`. Where `OwningRef` allows consumers to pass around an owned object and a dependent reference, `OwningHandle` contains an owned object and a dependent object.",null,null],[12,"handle","","",98,null],[12,"_owner","","",98,null],[6,"BoxRef","","Typedef of a owning reference that uses a `Box` as the owner.",null,null],[6,"VecRef","","Typedef of a owning reference that uses a `Vec` as the owner.",null,null],[6,"StringRef","","Typedef of a owning reference that uses a `String` as the owner.",null,null],[6,"RcRef","","Typedef of a owning reference that uses a `Rc` as the owner.",null,null],[6,"ArcRef","","Typedef of a owning reference that uses a `Arc` as the owner.",null,null],[6,"RefRef","","Typedef of a owning reference that uses a `Ref` as the owner.",null,null],[6,"RefMutRef","","Typedef of a owning reference that uses a `RefMut` as the owner.",null,null],[6,"MutexGuardRef","","Typedef of a owning reference that uses a `MutexGuard` as the owner.",null,null],[6,"RwLockReadGuardRef","","Typedef of a owning reference that uses a `RwLockReadGuard` as the owner.",null,null],[6,"RwLockWriteGuardRef","","Typedef of a owning reference that uses a `RwLockWriteGuard` as the owner.",null,null],[6,"BoxRefMut","","Typedef of a mutable owning reference that uses a `Box` as the owner.",null,null],[6,"VecRefMut","","Typedef of a mutable owning reference that uses a `Vec` as the owner.",null,null],[6,"StringRefMut","","Typedef of a mutable owning reference that uses a `String` as the owner.",null,null],[6,"RefMutRefMut","","Typedef of a mutable owning reference that uses a `RefMut` as the owner.",null,null],[6,"MutexGuardRefMut","","Typedef of a mutable owning reference that uses a `MutexGuard` as the owner.",null,null],[6,"RwLockWriteGuardRefMut","","Typedef of a mutable owning reference that uses a `RwLockWriteGuard` as the owner.",null,null],[6,"ErasedBoxRef","","Typedef of a owning reference that uses an erased `Box` as the owner.",null,null],[6,"ErasedRcRef","","Typedef of a owning reference that uses an erased `Rc` as the owner.",null,null],[6,"ErasedArcRef","","Typedef of a owning reference that uses an erased `Arc` as the owner.",null,null],[6,"ErasedBoxRefMut","","Typedef of a mutable owning reference that uses an erased `Box` as the owner.",null,null],[8,"Erased","","Helper trait for an erased concrete type an owner dereferences to. This is used in form of a trait object for keeping something around to (virtually) call the destructor.",null,null],[8,"IntoErased","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased>`. This would be unneeded with higher kinded types support in the language.",null,null],[16,"Erased","","Owner with the dereference type substituted to `Erased`.",99,null],[10,"into_erased","","Perform the type erasure.",99,null],[8,"IntoErasedSend","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased + Send>`. This would be unneeded with higher kinded types support in the language.",null,null],[16,"Erased","","Owner with the dereference type substituted to `Erased + Send`.",100,null],[10,"into_erased_send","","Perform the type erasure.",100,null],[8,"IntoErasedSendSync","","Helper trait for erasing the concrete type of what an owner dereferences to, for example `Box<T> -> Box<Erased + Send + Sync>`. This would be unneeded with higher kinded types support in the language.",null,null],[16,"Erased","","Owner with the dereference type substituted to `Erased + Send + Sync`.",101,null],[10,"into_erased_send_sync","","Perform the type erasure.",101,null],[8,"ToHandle","","Trait to implement the conversion of owner to handle for common types.",null,null],[16,"Handle","","The type of handle to be encapsulated by the OwningHandle.",102,null],[10,"to_handle","","Given an appropriately-long-lived pointer to ourselves, create a handle to be encapsulated by the `OwningHandle`.",102,null],[8,"ToHandleMut","","Trait to implement the conversion of owner to mutable handle for common types.",null,null],[16,"HandleMut","","The type of handle to be encapsulated by the OwningHandle.",103,null],[10,"to_handle_mut","","Given an appropriately-long-lived pointer to ourselves, create a mutable handle to be encapsulated by the `OwningHandle`.",103,null],[11,"new","","Creates a new owning reference from a owner initialized to the direct dereference of it.",96,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"new_assert_stable_address","","Like `new`, but doesn’t require `O` to implement the `StableAddress` trait. Instead, the caller is responsible to make the same promises as implementing the trait.",96,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"map","","Converts `self` into a new owning reference that points at something reachable from the previous one.",96,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"owningref"}}],[11,"try_map","","Tries to convert `self` into a new owning reference that points at something reachable from the previous one.",96,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"generics":["owningref"],"name":"result"}}],[11,"map_owner","","Converts `self` into a new owning reference with a different owner type.",96,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"owningref"}}],[11,"map_owner_box","","Converts `self` into a new owning reference where the owner is wrapped in an additional `Box<O>`.",96,{"inputs":[{"name":"self"}],"output":{"generics":["box"],"name":"owningref"}}],[11,"erase_owner","","Erases the concrete base type of the owner with a trait object.",96,{"inputs":[{"name":"self"}],"output":{"name":"owningref"}}],[11,"erase_send_owner","","Erases the concrete base type of the owner with a trait object which implements `Send`.",96,{"inputs":[{"name":"self"}],"output":{"name":"owningref"}}],[11,"erase_send_sync_owner","","Erases the concrete base type of the owner with a trait object which implements `Send` and `Sync`.",96,{"inputs":[{"name":"self"}],"output":{"name":"owningref"}}],[11,"owner","","A getter for the underlying owner.",96,{"inputs":[{"name":"self"}],"output":{"name":"o"}}],[11,"into_inner","","Discards the reference and retrieves the owner.",96,{"inputs":[{"name":"self"}],"output":{"name":"o"}}],[11,"new","","Creates a new owning reference from a owner initialized to the direct dereference of it.",97,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"new_assert_stable_address","","Like `new`, but doesn’t require `O` to implement the `StableAddress` trait. Instead, the caller is responsible to make the same promises as implementing the trait.",97,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"map","","Converts `self` into a new shared owning reference that points at something reachable from the previous one.",97,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"owningref"}}],[11,"map_mut","","Converts `self` into a new mutable owning reference that points at something reachable from the previous one.",97,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"owningrefmut"}}],[11,"try_map","","Tries to convert `self` into a new shared owning reference that points at something reachable from the previous one.",97,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"generics":["owningref"],"name":"result"}}],[11,"try_map_mut","","Tries to convert `self` into a new mutable owning reference that points at something reachable from the previous one.",97,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"generics":["owningrefmut"],"name":"result"}}],[11,"map_owner","","Converts `self` into a new owning reference with a different owner type.",97,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"owningrefmut"}}],[11,"map_owner_box","","Converts `self` into a new owning reference where the owner is wrapped in an additional `Box<O>`.",97,{"inputs":[{"name":"self"}],"output":{"generics":["box"],"name":"owningrefmut"}}],[11,"erase_owner","","Erases the concrete base type of the owner with a trait object.",97,{"inputs":[{"name":"self"}],"output":{"name":"owningrefmut"}}],[11,"owner","","A getter for the underlying owner.",97,{"inputs":[{"name":"self"}],"output":{"name":"o"}}],[11,"into_inner","","Discards the reference and retrieves the owner.",97,{"inputs":[{"name":"self"}],"output":{"name":"o"}}],[11,"deref","","",98,null],[11,"deref_mut","","",98,null],[11,"new","","Create a new `OwningHandle` for a type that implements `ToHandle`. For types that don't implement `ToHandle`, callers may invoke `new_with_fn`, which accepts a callback to perform the conversion.",98,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"new_mut","","Create a new mutable `OwningHandle` for a type that implements `ToHandleMut`.",98,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"new_with_fn","","Create a new OwningHandle. The provided callback will be invoked with a pointer to the object owned by `o`, and the returned value is stored as the object to which this `OwningHandle` will forward `Deref` and `DerefMut`.",98,{"inputs":[{"name":"o"},{"name":"f"}],"output":{"name":"self"}}],[11,"try_new","","Create a new OwningHandle. The provided callback will be invoked with a pointer to the object owned by `o`, and the returned value is stored as the object to which this `OwningHandle` will forward `Deref` and `DerefMut`.",98,{"inputs":[{"name":"o"},{"name":"f"}],"output":{"name":"result"}}],[11,"deref","","",96,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"deref","","",97,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"deref_mut","","",97,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"as_ref","","",96,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"as_ref","","",97,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"as_mut","","",97,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"borrow","","",96,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"from","","",96,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"from","","",97,{"inputs":[{"name":"o"}],"output":{"name":"self"}}],[11,"from","","",96,{"inputs":[{"name":"owningrefmut"}],"output":{"name":"self"}}],[11,"fmt","","",96,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",97,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"clone","","",96,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"fmt","","",104,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"eq","","",96,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",96,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",96,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"hash","","",96,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"eq","","",97,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",97,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",97,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"hash","","",97,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"into_erased","rustc_data_structures::sync","",86,null],[11,"drop","rustc_data_structures","",13,{"inputs":[{"name":"self"}],"output":null}],[14,"newtype_index","","",null,null],[14,"rustc_erase_owner","","",null,null],[11,"from","rustc_data_structures::sync","",86,{"inputs":[{"name":"osstring"}],"output":{"generics":["osstr"],"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"osstr"}],"output":{"generics":["osstr"],"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"cstring"}],"output":{"generics":["cstr"],"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"path"}],"output":{"generics":["path"],"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"pathbuf"}],"output":{"generics":["path"],"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"cstr"}],"output":{"generics":["cstr"],"name":"rc"}}],[11,"fmt","","",87,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",88,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"deref_mut","","",88,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"deref","","",87,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"deref","","",88,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"fmt","","",88,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",87,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"as_ref","","",86,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",86,{"inputs":[],"output":{"name":"rc"}}],[11,"fmt","","",86,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",86,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"from","","",86,{"inputs":[{"name":"t"}],"output":{"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"string"}],"output":{"generics":["str"],"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"str"}],"output":{"generics":["str"],"name":"rc"}}],[11,"from","","",86,null],[11,"from","","",86,{"inputs":[{"name":"vec"}],"output":{"name":"rc"}}],[11,"from","","",86,{"inputs":[{"name":"box"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less than or equal to' comparison for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater than or equal to' comparison for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"deref","","",86,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"hash","","",86,null],[11,"drop","","Drops the `Rc`.",86,null],[11,"fmt","","",86,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"borrow","","",86,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"cmp","","Comparison for two `Rc`s.",86,{"inputs":[{"name":"self"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"clone","","Makes a clone of the `Rc` pointer.",86,{"inputs":[{"name":"self"}],"output":{"name":"rc"}}],[11,"deref","rustc_data_structures::snapshot_vec","",2,null],[11,"new","rustc_data_structures::unify","",11,{"inputs":[],"output":{"name":"inplace"}}],[11,"start_snapshot","","",11,null],[11,"rollback_to","","",11,null],[11,"commit","","",11,null],[11,"len","","",11,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"push","","",11,null],[11,"update","","",11,null],[11,"extend","rustc_data_structures::snapshot_vec","",2,null],[11,"eq","rustc_data_structures::unify","",8,{"inputs":[{"name":"self"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","rustc_data_structures::snapshot_vec","",1,{"inputs":[{"name":"self"}],"output":{"name":"undolog"}}],[11,"clone","rustc_data_structures::unify","",8,{"inputs":[{"name":"self"}],"output":{"name":"varvalue"}}],[11,"clone","rustc_data_structures::snapshot_vec","",2,{"inputs":[{"name":"self"}],"output":{"name":"snapshotvec"}}],[11,"clone","rustc_data_structures::unify","",11,{"inputs":[{"name":"self"}],"output":{"name":"inplace"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"unificationtable"}}],[11,"deref_mut","rustc_data_structures::snapshot_vec","",2,null],[11,"fmt","rustc_data_structures::unify","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","rustc_data_structures::snapshot_vec","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"index_mut","","",2,null],[11,"index","","",2,null],[11,"index","rustc_data_structures::unify","",11,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"varvalue"}}],[11,"decode","rustc_data_structures::sync","",86,{"inputs":[{"name":"d"}],"output":{"generics":["rc"],"name":"result"}}],[11,"decode","","",86,{"inputs":[{"name":"d"}],"output":{"generics":["rc"],"name":"result"}}],[11,"encode","","",86,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"encode","","",86,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"into_erased","","",86,null],[11,"new","rustc_data_structures::snapshot_vec","",2,{"inputs":[],"output":{"name":"snapshotvec"}}],[11,"with_capacity","","",2,{"inputs":[{"name":"usize"}],"output":{"name":"snapshotvec"}}],[11,"record","","",2,null],[11,"len","","",2,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"push","","",2,null],[11,"get","","",2,null],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone automatically, so you should be sure call `record()` with some sort of suitable undo action.",2,null],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if a snapshot is active.",2,null],[11,"update","","",2,null],[11,"start_snapshot","","",2,{"inputs":[{"name":"self"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",2,null],[11,"rollback_to","","",2,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they can still be undone if there is a snapshot further out.",2,null],[11,"new","rustc_data_structures::unify","",9,{"inputs":[],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either rolled back or committed in a \"LIFO\" (stack) order.",9,{"inputs":[{"name":"self"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also removes any keys that have been created since then.",9,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they can still be undone if there is a snapshot further out.",9,null],[11,"new_key","","Creates a fresh key with the given value.",9,null],[11,"len","","Returns the number of keys created so far.",9,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"union","","Unions two keys without the possibility of failure; only applicable when unify values use `NoError` as their error type.",9,null],[11,"union_value","","Unions a key and a value without the possibility of failure; only applicable when unify values use `NoError` as their error type.",9,null],[11,"unioned","","Given two keys, indicates whether they have been unioned together.",9,{"inputs":[{"name":"self"},{"name":"k1"},{"name":"k2"}],"output":{"name":"bool"}}],[11,"find","","Given a key, returns the (current) root key.",9,{"inputs":[{"name":"self"},{"name":"k1"}],"output":{"name":"k"}}],[11,"unify_var_var","","Unions together two variables, merging their values. If merging the values fails, the error is propagated and this method has no effect.",9,{"inputs":[{"name":"self"},{"name":"k1"},{"name":"k2"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`, attempting to merge with the previous value.",9,{"inputs":[{"name":"self"},{"name":"k1"},{"name":"v"}],"output":{"name":"result"}}],[11,"probe_value","","Returns the current value for the given key. If the key has been union'd, this will give the value from the current root.",9,{"inputs":[{"name":"self"},{"name":"k1"}],"output":{"name":"v"}}],[11,"hash_stable","rustc_data_structures::sync","",86,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"new","","Constructs a new `Rc<T>`.",86,{"inputs":[{"name":"t"}],"output":{"name":"rc"}}],[11,"try_unwrap","","Returns the contained value, if the `Rc` has exactly one strong reference.",86,{"inputs":[{"name":"rc"}],"output":{"generics":["rc"],"name":"result"}}],[11,"into_raw","","Consumes the `Rc`, returning the wrapped pointer.",86,null],[11,"from_raw","","Constructs an `Rc` from a raw pointer.",86,null],[11,"downgrade","","Creates a new [`Weak`][weak] pointer to this value.",86,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"weak_count","","Gets the number of [`Weak`][weak] pointers to this value.",86,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[11,"strong_count","","Gets the number of strong (`Rc`) pointers to this value.",86,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[11,"get_mut","","Returns a mutable reference to the inner value, if there are no other `Rc` or [`Weak`][weak] pointers to the same value.",86,{"inputs":[{"name":"rc"}],"output":{"name":"option"}}],[11,"ptr_eq","","Returns true if the two `Rc`s point to the same value (not just values that compare as equal).",86,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"make_mut","","Makes a mutable reference into the given `Rc`.",86,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"downcast","","Attempt to downcast the `Rc<Any>` to a concrete type.",86,{"inputs":[{"name":"self"}],"output":{"generics":["rc","rc"],"name":"result"}}],[11,"clone","","Copies a `Ref`.",87,{"inputs":[{"name":"ref"}],"output":{"name":"ref"}}],[11,"map","","Make a new `Ref` for a component of the borrowed data.",87,{"inputs":[{"name":"ref"},{"name":"f"}],"output":{"name":"ref"}}],[11,"map","","Make a new `RefMut` for a component of the borrowed data, e.g. an enum variant.",88,{"inputs":[{"name":"refmut"},{"name":"f"}],"output":{"name":"refmut"}}]],"paths":[[8,"ToHex"],[4,"UndoLog"],[3,"SnapshotVec"],[3,"Snapshot"],[8,"SnapshotVecDelegate"],[8,"UnifyKey"],[8,"UnifyValue"],[3,"NoError"],[3,"VarValue"],[3,"UnificationTable"],[3,"Snapshot"],[3,"InPlace"],[8,"UnificationStore"],[3,"OnDrop"],[3,"ArrayVec"],[3,"Iter"],[3,"Drain"],[8,"Array"],[3,"IntoIter"],[4,"AccumulateVec"],[4,"IntoIterRepr"],[4,"Drain"],[3,"SmallVec"],[3,"BitLookup"],[8,"BitSlice"],[8,"BitwiseOperator"],[3,"Intersect"],[3,"Union"],[3,"Subtract"],[3,"BitVector"],[3,"BitVectorIter"],[3,"BitMatrix"],[3,"SparseBitMatrix"],[3,"SparseBitSet"],[3,"SparseChunk"],[3,"Graph"],[3,"Node"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"AdjacentEdges"],[3,"DepthFirstTraversal"],[3,"IdxSetBuf"],[3,"IdxSet"],[3,"Iter"],[3,"IndexVec"],[3,"IntoIdx"],[8,"Idx"],[3,"LazyBTreeMap"],[3,"Iter"],[3,"Values"],[3,"ObligationForest"],[3,"Node"],[3,"Outcome"],[3,"Error"],[3,"GetObligation"],[4,"NodeState"],[3,"NodeIndex"],[8,"ForestObligation"],[8,"ObligationProcessor"],[3,"SipHasher128"],[3,"State"],[3,"Sip24Rounds"],[3,"SnapshotMap"],[3,"Snapshot"],[4,"UndoLog"],[3,"StableHasher"],[3,"StableVec"],[8,"StableHasherResult"],[8,"HashStable"],[8,"ToStableHashKey"],[3,"TransitiveRelation"],[3,"Index"],[3,"Edge"],[3,"FxHasher"],[8,"TupleSlice"],[3,"Dominators"],[3,"Iter"],[3,"DominatorTree"],[3,"DominatorTreeNode"],[8,"ControlFlowGraph"],[8,"GraphPredecessors"],[8,"GraphSuccessors"],[3,"Lock"],[3,"flock"],[3,"Lrc"],[3,"ReadGuard"],[3,"LockGuard"],[3,"MTLock"],[3,"LockCell"],[3,"Once"],[3,"Lock"],[3,"RwLock"],[3,"OneThread"],[8,"HashMapExt"],[3,"OwningRef"],[3,"OwningRefMut"],[3,"OwningHandle"],[8,"IntoErased"],[8,"IntoErasedSend"],[8,"IntoErasedSendSync"],[8,"ToHandle"],[8,"ToHandleMut"],[8,"Erased"]]};
searchIndex["rustc_driver"] = {"doc":"The Rust compiler.","items":[[3,"RustcDefaultCalls","rustc_driver","",null,null],[4,"Compilation","","",null,null],[13,"Stop","","",0,null],[13,"Continue","","",0,null],[5,"abort_on_err","","",null,{"inputs":[{"generics":["compileincomplete"],"name":"result"},{"name":"session"}],"output":{"name":"t"}}],[5,"run","","",null,{"inputs":[{"name":"f"}],"output":{"name":"isize"}}],[5,"load_backend_from_dylib","","",null,null],[5,"get_trans","","",null,{"inputs":[{"name":"session"}],"output":{"generics":["transcrate"],"name":"box"}}],[5,"get_trans_sysroot","","",null,null],[5,"run_compiler","","",null,null],[5,"run_compiler_impl","","",null,null],[5,"set_sigpipe_handler","","",null,{"inputs":[],"output":null}],[5,"make_output","","",null,null],[5,"make_input","","",null,null],[5,"parse_pretty","","",null,{"inputs":[{"name":"session"},{"name":"matches"}],"output":{"name":"option"}}],[5,"stdout_isatty","","",null,{"inputs":[],"output":{"name":"bool"}}],[5,"handle_explain","","",null,{"inputs":[{"name":"str"},{"name":"registry"},{"name":"erroroutputtype"}],"output":null}],[5,"show_content_with_pager","","",null,{"inputs":[{"name":"string"}],"output":null}],[5,"enable_save_analysis","","",null,{"inputs":[{"name":"compilecontroller"}],"output":null}],[5,"release_str","","Returns a version string such as \"0.12.0-dev\".",null,{"inputs":[],"output":{"generics":["str"],"name":"option"}}],[5,"commit_hash_str","","Returns the full SHA1 hash of HEAD of the Git repo from which rustc was built.",null,{"inputs":[],"output":{"generics":["str"],"name":"option"}}],[5,"commit_date_str","","Returns the \"commit date\" of HEAD of the Git repo from which rustc was built as a static string.",null,{"inputs":[],"output":{"generics":["str"],"name":"option"}}],[5,"version","","Prints version information",null,{"inputs":[{"name":"str"},{"name":"matches"}],"output":null}],[5,"usage","","",null,{"inputs":[{"name":"bool"},{"name":"bool"}],"output":null}],[5,"print_wall_help","","",null,{"inputs":[],"output":null}],[5,"describe_lints","","",null,{"inputs":[{"name":"session"},{"name":"lintstore"},{"name":"bool"}],"output":null}],[5,"describe_debug_flags","","",null,{"inputs":[],"output":null}],[5,"describe_codegen_flags","","",null,{"inputs":[],"output":null}],[5,"print_flag_list","","",null,null],[5,"handle_options","","Process command line options. Emits messages as appropriate. If compilation should continue, returns a getopts::Matches object parsed from args, otherwise returns None.",null,null],[5,"parse_crate_attrs","","",null,{"inputs":[{"name":"session"},{"name":"input"}],"output":{"generics":["vec"],"name":"presult"}}],[5,"in_rustc_thread","","Runs `f` in a suitable thread for running `rustc`; returns a `Result` with either the return value of `f` or -- if a panic occurs -- the panic value.",null,{"inputs":[{"name":"f"}],"output":{"generics":["box"],"name":"result"}}],[5,"extra_compiler_flags","","Get a list of extra command-line flags provided by the user, as strings.",null,{"inputs":[],"output":{"name":"option"}}],[5,"monitor","","Run a procedure which will detect panics in the compiler and print nicer error messages rather than just failing the test.",null,{"inputs":[{"name":"f"}],"output":null}],[5,"diagnostics_registry","","",null,{"inputs":[],"output":{"name":"registry"}}],[5,"init_rustc_env_logger","","This allows tools to enable rust logging without having to magically match rustc's log crate version",null,{"inputs":[],"output":null}],[5,"main","","",null,{"inputs":[],"output":null}],[0,"profile","","",null,null],[3,"StackFrame","rustc_driver::profile","",null,null],[12,"parse_st","","",1,null],[12,"traces","","",1,null],[4,"ParseState","","",null,null],[13,"Clear","","",2,null],[13,"HaveQuery","","",2,null],[13,"HaveTimeBegin","","",2,null],[13,"HaveTaskBegin","","",2,null],[5,"begin","","begin a profile thread, if not already running",null,{"inputs":[{"name":"session"}],"output":null}],[5,"dump","","dump files with profiling information to the given base path, and wait for this dump to complete.",null,{"inputs":[{"name":"session"},{"name":"string"}],"output":null}],[5,"total_duration","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"duration"}}],[5,"profile_queries_thread","","",null,{"inputs":[{"generics":["profilequeriesmsg"],"name":"receiver"}],"output":null}],[0,"trace","","",null,null],[3,"Query","rustc_driver::profile::trace","",null,null],[12,"span","","",3,null],[12,"msg","","",3,null],[3,"Rec","","Recursive trace structure",null,null],[12,"effect","","",4,null],[12,"start","","",4,null],[12,"dur_self","","",4,null],[12,"dur_total","","",4,null],[12,"extent","","",4,null],[3,"QueryMetric","","",null,null],[12,"count","","",5,null],[12,"dur_self","","",5,null],[12,"dur_total","","",5,null],[4,"Effect","","",null,null],[13,"QueryBegin","","",6,null],[13,"TimeBegin","","",6,null],[13,"TaskBegin","","",6,null],[4,"CacheCase","","",null,null],[13,"Hit","","",7,null],[13,"Miss","","",7,null],[5,"cons_of_query_msg","","",null,{"inputs":[{"name":"query"}],"output":{"name":"string"}}],[5,"cons_of_key","","",null,{"inputs":[{"name":"depnode"}],"output":{"name":"string"}}],[5,"html_of_effect","","",null,null],[5,"html_of_duration","","",null,null],[5,"html_of_fraction","","",null,null],[5,"total_duration","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"duration"}}],[5,"duration_div","","",null,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"f64"}}],[5,"write_traces_rec","","",null,{"inputs":[{"name":"file"},{"name":"vec"},{"name":"duration"},{"name":"usize"}],"output":null}],[5,"compute_counts_rec","","",null,{"inputs":[{"name":"hashmap"},{"name":"vec"}],"output":null}],[5,"write_counts","","",null,{"inputs":[{"name":"file"},{"name":"hashmap"}],"output":null}],[5,"write_traces","","",null,{"inputs":[{"name":"file"},{"name":"file"},{"name":"vec"}],"output":null}],[5,"write_style","","",null,{"inputs":[{"name":"file"}],"output":null}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"query"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"query"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"query"}],"output":{"name":"bool"}}],[11,"clone","rustc_driver::profile","",2,{"inputs":[{"name":"self"}],"output":{"name":"parsestate"}}],[11,"assert_receiver_is_total_eq","","",2,null],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"parsestate"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"parsestate"}],"output":{"name":"bool"}}],[0,"driver","rustc_driver","",null,null],[3,"CompileController","rustc_driver::driver","CompileController is used to customize compilation, it allows compilation to be stopped and/or to call arbitrary code at various points in compilation. It also allows for various flags to be set to influence what information gets collected during compilation.",null,null],[12,"after_parse","","",8,null],[12,"after_expand","","",8,null],[12,"after_hir_lowering","","",8,null],[12,"after_analysis","","",8,null],[12,"compilation_done","","",8,null],[12,"make_glob_map","","",8,null],[12,"keep_ast","","",8,null],[12,"continue_parse_after_error","","",8,null],[12,"provide","","Allows overriding default rustc query providers, after `default_provide` has installed them.",8,null],[12,"provide_extern","","Same as `provide`, but only for non-local crates, applied after `default_provide_extern`.",8,null],[3,"PhaseController","","",null,null],[12,"stop","","",9,null],[12,"run_callback_on_error","","",9,null],[12,"callback","","",9,null],[3,"CompileState","","State that is passed to a callback. What state is available depends on when during compilation the callback is made. See the various constructor methods (`state_*`) in the impl to see which data is provided for any given entry point.",null,null],[12,"input","","",10,null],[12,"session","","",10,null],[12,"krate","","",10,null],[12,"registry","","",10,null],[12,"cstore","","",10,null],[12,"crate_name","","",10,null],[12,"output_filenames","","",10,null],[12,"out_dir","","",10,null],[12,"out_file","","",10,null],[12,"arenas","","",10,null],[12,"expanded_crate","","",10,null],[12,"hir_crate","","",10,null],[12,"hir_map","","",10,null],[12,"resolutions","","",10,null],[12,"analysis","","",10,null],[12,"tcx","","",10,null],[3,"ExpansionResult","","",null,null],[12,"expanded_crate","","",11,null],[12,"defs","","",11,null],[12,"analysis","","",11,null],[12,"resolutions","","",11,null],[12,"hir_forest","","",11,null],[3,"InnerExpansionResult","","",null,null],[12,"expanded_crate","","",12,null],[12,"resolver","","",12,null],[12,"hir_forest","","",12,null],[5,"compile_input","","",null,{"inputs":[{"generics":["transcrate"],"name":"box"},{"name":"session"},{"name":"cstore"},{"name":"option"},{"name":"input"},{"name":"option"},{"name":"option"},{"generics":["vec"],"name":"option"},{"name":"compilecontroller"}],"output":{"name":"compileresult"}}],[5,"source_name","","",null,{"inputs":[{"name":"input"}],"output":{"name":"filename"}}],[5,"phase_1_parse_input","","",null,{"inputs":[{"name":"compilecontroller"},{"name":"session"},{"name":"input"}],"output":{"generics":["crate"],"name":"presult"}}],[5,"count_nodes","","",null,{"inputs":[{"name":"crate"}],"output":{"name":"usize"}}],[5,"phase_2_configure_and_expand","","Run the \"early phases\" of the compiler: initial `cfg` processing, loading compiler plugins (including those from `addl_plugins`), syntax expansion, secondary `cfg` expansion, synthesis of a test harness if one is to be provided, injection of a dependency on the standard library and prelude, and name resolution.",null,{"inputs":[{"name":"session"},{"name":"cstore"},{"name":"crate"},{"generics":["registry"],"name":"option"},{"name":"str"},{"generics":["vec"],"name":"option"},{"name":"makeglobmap"},{"name":"f"}],"output":{"generics":["expansionresult","compileincomplete"],"name":"result"}}],[5,"phase_2_configure_and_expand_inner","","Same as phase_2_configure_and_expand, but doesn't let you keep the resolver around",null,{"inputs":[{"name":"session"},{"name":"cstore"},{"name":"crate"},{"generics":["registry"],"name":"option"},{"name":"str"},{"generics":["vec"],"name":"option"},{"name":"makeglobmap"},{"name":"resolverarenas"},{"name":"crateloader"},{"name":"f"}],"output":{"generics":["innerexpansionresult","compileincomplete"],"name":"result"}}],[5,"default_provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"default_provide_extern","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"phase_3_run_analysis_passes","","Run the resolution, typechecking, region checking and other miscellaneous analysis passes on the crate. Return various structures carrying the results of the analysis.",null,{"inputs":[{"name":"transcrate"},{"name":"compilecontroller"},{"name":"session"},{"name":"cratestore"},{"name":"map"},{"name":"crateanalysis"},{"name":"resolutions"},{"name":"allarenas"},{"name":"str"},{"name":"outputfilenames"},{"name":"f"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[5,"phase_4_translate_to_llvm","","Run the translation phase to LLVM, after which the AST and analysis can be discarded.",null,{"inputs":[{"name":"transcrate"},{"name":"tyctxt"},{"generics":["box"],"name":"receiver"}],"output":{"generics":["any"],"name":"box"}}],[5,"escape_dep_filename","","",null,{"inputs":[{"name":"filename"}],"output":{"name":"string"}}],[5,"generated_output_paths","","",null,{"inputs":[{"name":"session"},{"name":"outputfilenames"},{"name":"bool"},{"name":"str"}],"output":{"generics":["pathbuf"],"name":"vec"}}],[5,"check_output","","",null,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"option"}}],[5,"output_contains_path","","",null,{"inputs":[{"name":"vec"},{"name":"pathbuf"}],"output":{"name":"bool"}}],[5,"output_conflicts_with_dir","","",null,{"inputs":[{"name":"vec"}],"output":{"generics":["pathbuf"],"name":"option"}}],[5,"write_out_deps","","",null,{"inputs":[{"name":"session"},{"name":"outputfilenames"},{"name":"vec"}],"output":null}],[5,"collect_crate_types","","",null,null],[5,"compute_crate_disambiguator","","",null,{"inputs":[{"name":"session"}],"output":{"name":"cratedisambiguator"}}],[5,"build_output_filenames","","",null,null],[11,"basic","","",8,{"inputs":[],"output":{"name":"compilecontroller"}}],[11,"basic","","",9,{"inputs":[],"output":{"name":"phasecontroller"}}],[11,"empty","","",10,{"inputs":[{"name":"input"},{"name":"session"},{"name":"option"}],"output":{"name":"self"}}],[11,"state_after_parse","","",10,{"inputs":[{"name":"input"},{"name":"session"},{"name":"option"},{"name":"option"},{"name":"crate"},{"name":"cstore"}],"output":{"name":"self"}}],[11,"state_after_expand","","",10,{"inputs":[{"name":"input"},{"name":"session"},{"name":"option"},{"name":"option"},{"name":"cstore"},{"name":"crate"},{"name":"str"}],"output":{"name":"self"}}],[11,"state_after_hir_lowering","","",10,{"inputs":[{"name":"input"},{"name":"session"},{"name":"option"},{"name":"option"},{"name":"allarenas"},{"name":"cstore"},{"name":"map"},{"name":"crateanalysis"},{"name":"resolutions"},{"name":"crate"},{"name":"crate"},{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"self"}}],[11,"state_after_analysis","","",10,{"inputs":[{"name":"input"},{"name":"session"},{"name":"option"},{"name":"option"},{"generics":["crate"],"name":"option"},{"name":"crate"},{"name":"crateanalysis"},{"name":"tyctxt"},{"name":"str"}],"output":{"name":"self"}}],[11,"state_when_compilation_done","","",10,{"inputs":[{"name":"input"},{"name":"session"},{"name":"option"},{"name":"option"}],"output":{"name":"self"}}],[0,"pretty","rustc_driver","The various pretty print routines.",null,null],[3,"NoAnn","rustc_driver::pretty","",null,null],[12,"sess","","",13,null],[12,"hir_map","","",13,null],[3,"IdentifiedAnnotation","","",null,null],[12,"sess","","",14,null],[12,"hir_map","","",14,null],[3,"HygieneAnnotation","","",null,null],[12,"sess","","",15,null],[3,"TypedAnnotation","","",null,null],[12,"tcx","","",16,null],[12,"tables","","",16,null],[3,"ReplaceBodyWithLoop","","",null,null],[12,"within_static_or_const","","",17,null],[12,"sess","","",17,null],[4,"PpSourceMode","","",null,null],[13,"PpmNormal","","",18,null],[13,"PpmEveryBodyLoops","","",18,null],[13,"PpmExpanded","","",18,null],[13,"PpmIdentified","","",18,null],[13,"PpmExpandedIdentified","","",18,null],[13,"PpmExpandedHygiene","","",18,null],[13,"PpmTyped","","",18,null],[4,"PpFlowGraphMode","","",null,null],[13,"Default","","",19,null],[13,"UnlabelledEdges","","Drops the labels from the edges in the flowgraph output. This is mostly for use in the -Z unpretty flowgraph run-make tests, since the labels are largely uninteresting in those cases and have become a pain to maintain.",19,null],[4,"PpMode","","",null,null],[13,"PpmSource","","",20,null],[13,"PpmHir","","",20,null],[13,"PpmHirTree","","",20,null],[13,"PpmFlowGraph","","",20,null],[13,"PpmMir","","",20,null],[13,"PpmMirCFG","","",20,null],[4,"UserIdentifiedItem","","",null,null],[13,"ItemViaNode","","",21,null],[13,"ItemViaPath","","",21,null],[4,"NodesMatchingUII","","",null,null],[13,"NodesMatchingDirect","","",22,null],[13,"NodesMatchingSuffix","","",22,null],[5,"parse_pretty","","",null,null],[5,"gather_flowgraph_variants","","",null,{"inputs":[{"name":"session"}],"output":{"generics":["variant"],"name":"vec"}}],[5,"print_flowgraph","","",null,{"inputs":[{"generics":["variant"],"name":"vec"},{"name":"tyctxt"},{"name":"code"},{"name":"ppflowgraphmode"},{"name":"w"}],"output":{"name":"result"}}],[5,"fold_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"ppmode"}],"output":{"name":"crate"}}],[5,"get_source","","",null,null],[5,"write_output","","",null,{"inputs":[{"generics":["u8"],"name":"vec"},{"generics":["path"],"name":"option"}],"output":null}],[5,"print_after_parsing","","",null,{"inputs":[{"name":"session"},{"name":"input"},{"name":"crate"},{"name":"ppmode"},{"generics":["path"],"name":"option"}],"output":null}],[5,"print_after_hir_lowering","","",null,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"map"},{"name":"crateanalysis"},{"name":"resolutions"},{"name":"input"},{"name":"crate"},{"name":"str"},{"name":"ppmode"},{"name":"allarenas"},{"name":"outputfilenames"},{"generics":["useridentifieditem"],"name":"option"},{"generics":["path"],"name":"option"}],"output":null}],[5,"print_with_analysis","","",null,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"map"},{"name":"crateanalysis"},{"name":"resolutions"},{"name":"str"},{"name":"allarenas"},{"name":"outputfilenames"},{"name":"ppmode"},{"generics":["useridentifieditem"],"name":"option"},{"generics":["path"],"name":"option"}],"output":null}],[8,"PrinterSupport","","",null,null],[10,"sess","","Provides a uniform interface for re-extracting a reference to a `Session` from a value that now owns it.",23,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[10,"pp_ann","","Produces the pretty-print annotation object.",23,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[8,"HirPrinterSupport","","",null,null],[10,"sess","","Provides a uniform interface for re-extracting a reference to a `Session` from a value that now owns it.",24,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[10,"hir_map","","Provides a uniform interface for re-extracting a reference to an `hir_map::Map` from a value that now owns it.",24,{"inputs":[{"name":"self"}],"output":{"generics":["map"],"name":"option"}}],[10,"pp_ann","","Produces the pretty-print annotation object.",24,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"node_path","","Computes an user-readable representation of a path, if possible.",24,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["string"],"name":"option"}}],[11,"clone","","",18,{"inputs":[{"name":"self"}],"output":{"name":"ppsourcemode"}}],[11,"eq","","",18,{"inputs":[{"name":"self"},{"name":"ppsourcemode"}],"output":{"name":"bool"}}],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"ppflowgraphmode"}}],[11,"eq","","",19,{"inputs":[{"name":"self"},{"name":"ppflowgraphmode"}],"output":{"name":"bool"}}],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",20,{"inputs":[{"name":"self"}],"output":{"name":"ppmode"}}],[11,"eq","","",20,{"inputs":[{"name":"self"},{"name":"ppmode"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"self"},{"name":"ppmode"}],"output":{"name":"bool"}}],[11,"fmt","","",20,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"needs_ast_map","","",20,{"inputs":[{"name":"self"},{"name":"option"}],"output":{"name":"bool"}}],[11,"needs_analysis","","",20,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"call_with_pp_support","","Constructs a `PrinterSupport` object and passes it to `f`.",18,{"inputs":[{"name":"self"},{"name":"session"},{"generics":["map"],"name":"option"},{"name":"f"}],"output":{"name":"a"}}],[11,"call_with_pp_support_hir","","",18,{"inputs":[{"name":"self"},{"name":"session"},{"name":"cratestore"},{"name":"map"},{"name":"crateanalysis"},{"name":"resolutions"},{"name":"allarenas"},{"name":"outputfilenames"},{"name":"str"},{"name":"f"}],"output":{"name":"a"}}],[11,"sess","","",13,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"pp_ann","","",13,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"sess","","",13,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"hir_map","","",13,{"inputs":[{"name":"self"}],"output":{"generics":["map"],"name":"option"}}],[11,"pp_ann","","",13,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"nested","","",13,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[11,"sess","","",14,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"pp_ann","","",14,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"pre","","",14,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"post","","",14,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"sess","","",14,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"hir_map","","",14,{"inputs":[{"name":"self"}],"output":{"generics":["map"],"name":"option"}}],[11,"pp_ann","","",14,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"nested","","",14,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[11,"pre","","",14,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"post","","",14,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"sess","","",15,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"pp_ann","","",15,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"post","","",15,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"sess","","",16,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"hir_map","","",16,{"inputs":[{"name":"self"}],"output":{"generics":["map"],"name":"option"}}],[11,"pp_ann","","",16,{"inputs":[{"name":"self"}],"output":{"name":"ppann"}}],[11,"node_path","","",16,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["string"],"name":"option"}}],[11,"nested","","",16,{"inputs":[{"name":"self"},{"name":"state"},{"name":"nested"}],"output":{"name":"result"}}],[11,"pre","","",16,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"post","","",16,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"useridentifieditem"}}],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_str","","",21,{"inputs":[{"name":"str"}],"output":{"generics":["useridentifieditem"],"name":"result"}}],[11,"next","","",22,{"inputs":[{"name":"self"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"size_hint","","",22,null],[11,"reconstructed_input","","",21,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"all_matching_node_ids","","",21,{"inputs":[{"name":"self"},{"name":"map"}],"output":{"name":"nodesmatchinguii"}}],[11,"to_one_node_id","","",21,{"inputs":[{"name":"self"},{"name":"str"},{"name":"session"},{"name":"map"}],"output":{"name":"nodeid"}}],[11,"new","","",17,{"inputs":[{"name":"session"}],"output":{"name":"replacebodywithloop"}}],[11,"run","","",17,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"f"}],"output":{"name":"r"}}],[11,"should_ignore_fn","","",17,{"inputs":[{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"fold_item_kind","","",17,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"itemkind"}}],[11,"fold_trait_item","","",17,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"fold_impl_item","","",17,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"fold_block","","",17,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"}],"output":{"generics":["block"],"name":"p"}}],[11,"fold_mac","","",17,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[0,"derive_registrar","rustc_driver","",null,null],[3,"Finder","rustc_driver::derive_registrar","",null,null],[12,"registrar","","",25,null],[5,"find","","",null,{"inputs":[{"name":"map"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"visit_item","","",25,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",25,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",25,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"target_features","rustc_driver","",null,null],[5,"add_configuration","rustc_driver::target_features","Add `target_feature = \"...\"` cfgs for a variety of platform specific features (SSE, NEON etc.).",null,{"inputs":[{"name":"crateconfig"},{"name":"session"},{"name":"transcrate"}],"output":null}],[17,"BUG_REPORT_URL","rustc_driver","",null,null],[17,"ICE_REPORT_COMPILER_FLAGS","","",null,null],[17,"ICE_REPORT_COMPILER_FLAGS_EXCLUDE","","",null,null],[17,"ICE_REPORT_COMPILER_FLAGS_STRIP_VALUE","","",null,null],[8,"CompilerCalls","","",null,null],[11,"early_callback","","",26,{"inputs":[{"name":"self"},{"name":"matches"},{"name":"options"},{"name":"crateconfig"},{"name":"registry"},{"name":"erroroutputtype"}],"output":{"name":"compilation"}}],[11,"late_callback","","",26,{"inputs":[{"name":"self"},{"name":"transcrate"},{"name":"matches"},{"name":"session"},{"name":"cratestore"},{"name":"input"},{"name":"option"},{"name":"option"}],"output":{"name":"compilation"}}],[11,"some_input","","",26,null],[11,"no_input","","",26,{"inputs":[{"name":"self"},{"name":"matches"},{"name":"options"},{"name":"crateconfig"},{"name":"option"},{"name":"option"},{"name":"registry"}],"output":{"name":"option"}}],[10,"build_controller","","",26,{"inputs":[{"name":"self"},{"name":"session"},{"name":"matches"}],"output":{"name":"compilecontroller"}}],[11,"clone","","",0,{"inputs":[{"name":"self"}],"output":{"name":"compilation"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",0,null],[11,"eq","","",0,{"inputs":[{"name":"self"},{"name":"compilation"}],"output":{"name":"bool"}}],[11,"and_then","","",0,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"compilation"}}],[11,"clone","","",27,{"inputs":[{"name":"self"}],"output":{"name":"rustcdefaultcalls"}}],[11,"early_callback","","",27,{"inputs":[{"name":"self"},{"name":"matches"},{"name":"options"},{"name":"crateconfig"},{"name":"registry"},{"name":"erroroutputtype"}],"output":{"name":"compilation"}}],[11,"no_input","","",27,{"inputs":[{"name":"self"},{"name":"matches"},{"name":"options"},{"name":"crateconfig"},{"name":"option"},{"name":"option"},{"name":"registry"}],"output":{"name":"option"}}],[11,"late_callback","","",27,{"inputs":[{"name":"self"},{"name":"transcrate"},{"name":"matches"},{"name":"session"},{"name":"cratestore"},{"name":"input"},{"name":"option"},{"name":"option"}],"output":{"name":"compilation"}}],[11,"build_controller","","",27,{"inputs":[{"name":"self"},{"name":"session"},{"name":"matches"}],"output":{"name":"compilecontroller"}}],[11,"list_metadata","","",27,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"matches"},{"name":"input"}],"output":{"name":"compilation"}}],[11,"print_crate_info","","",27,{"inputs":[{"name":"transcrate"},{"name":"session"},{"generics":["input"],"name":"option"},{"name":"option"},{"name":"option"}],"output":{"name":"compilation"}}]],"paths":[[4,"Compilation"],[3,"StackFrame"],[4,"ParseState"],[3,"Query"],[3,"Rec"],[3,"QueryMetric"],[4,"Effect"],[4,"CacheCase"],[3,"CompileController"],[3,"PhaseController"],[3,"CompileState"],[3,"ExpansionResult"],[3,"InnerExpansionResult"],[3,"NoAnn"],[3,"IdentifiedAnnotation"],[3,"HygieneAnnotation"],[3,"TypedAnnotation"],[3,"ReplaceBodyWithLoop"],[4,"PpSourceMode"],[4,"PpFlowGraphMode"],[4,"PpMode"],[4,"UserIdentifiedItem"],[4,"NodesMatchingUII"],[8,"PrinterSupport"],[8,"HirPrinterSupport"],[3,"Finder"],[8,"CompilerCalls"],[3,"RustcDefaultCalls"]]};
searchIndex["rustc_errors"] = {"doc":"","items":[[3,"CodeSuggestion","rustc_errors","",null,null],[12,"substitutions","","Each substitute can have multiple variants due to multiple applicable suggestions",0,null],[12,"msg","","",0,null],[12,"show_code_when_inline","","",0,null],[12,"applicability","","Whether or not the suggestion is approximate",0,null],[3,"Substitution","","See the docs on `CodeSuggestion::substitutions`",null,null],[12,"parts","","",1,null],[3,"SubstitutionPart","","",null,null],[12,"span","","",2,null],[12,"snippet","","",2,null],[3,"FatalError","","Used as a return value to signify a fatal error occurred. (It is also used as the argument to panic at the moment, but that will eventually not be true.)",null,null],[3,"FatalErrorMarker","","",null,null],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug` or `.span_bug` rather than a failed assertion, etc.",null,null],[3,"Diagnostic","","",null,null],[12,"level","","",3,null],[12,"message","","",3,null],[12,"code","","",3,null],[12,"span","","",3,null],[12,"children","","",3,null],[12,"suggestions","","",3,null],[3,"SubDiagnostic","","For example a note attached to an error.",null,null],[12,"level","","",4,null],[12,"message","","",4,null],[12,"span","","",4,null],[12,"render_span","","",4,null],[3,"DiagnosticStyledString","","",null,null],[12,"0","","",5,null],[3,"DiagnosticBuilder","","Used for emitting structured error messages and other diagnostic information.",null,null],[12,"handler","","",6,null],[12,"diagnostic","","",6,null],[3,"Handler","","A handler deals with errors; certain errors (fatal, bug, unimpl) may cause immediate exit, others log errors for later reporting.",null,null],[12,"flags","","",7,null],[12,"err_count","","",7,null],[12,"emitter","","",7,null],[12,"continue_after_error","","",7,null],[12,"delayed_span_bug","","",7,null],[12,"taught_diagnostics","","",7,null],[12,"emitted_diagnostic_codes","","Used to suggest rustc --explain ",7,null],[12,"emitted_diagnostics","","",7,null],[3,"HandlerFlags","","",null,null],[12,"can_emit_warnings","","",8,null],[12,"treat_err_as_bug","","",8,null],[12,"external_macro_backtrace","","",8,null],[4,"Applicability","","",null,null],[13,"MachineApplicable","","",9,null],[13,"HasPlaceholders","","",9,null],[13,"MaybeIncorrect","","",9,null],[13,"Unspecified","","",9,null],[4,"DiagnosticId","","",null,null],[13,"Error","","",10,null],[13,"Lint","","",10,null],[4,"Level","","",null,null],[13,"Bug","","",11,null],[13,"Fatal","","",11,null],[13,"PhaseFatal","","",11,null],[13,"Error","","",11,null],[13,"Warning","","",11,null],[13,"Note","","",11,null],[13,"Help","","",11,null],[13,"Cancelled","","",11,null],[13,"FailureNote","","",11,null],[5,"default_track_diagnostic","","",null,{"inputs":[{"name":"diagnostic"}],"output":null}],[0,"diagnostic","","",null,null],[3,"Diagnostic","rustc_errors::diagnostic","",null,null],[12,"level","","",3,null],[12,"message","","",3,null],[12,"code","","",3,null],[12,"span","","",3,null],[12,"children","","",3,null],[12,"suggestions","","",3,null],[3,"SubDiagnostic","","For example a note attached to an error.",null,null],[12,"level","","",4,null],[12,"message","","",4,null],[12,"span","","",4,null],[12,"render_span","","",4,null],[3,"DiagnosticStyledString","","",null,null],[12,"0","","",5,null],[4,"DiagnosticId","","",null,null],[13,"Error","","",10,null],[13,"Lint","","",10,null],[4,"StringPart","","",null,null],[13,"Normal","","",12,null],[13,"Highlighted","","",12,null],[11,"clone","rustc_errors","",3,{"inputs":[{"name":"self"}],"output":{"name":"diagnostic"}}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"diagnostic"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"diagnostic"}],"output":{"name":"bool"}}],[11,"hash","","",3,null],[11,"encode","","",3,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",3,{"inputs":[{"name":"__d"}],"output":{"generics":["diagnostic"],"name":"result"}}],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticid"}}],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",10,{"inputs":[{"name":"self"},{"name":"diagnosticid"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"self"},{"name":"diagnosticid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",10,null],[11,"hash","","",10,null],[11,"encode","","",10,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",10,{"inputs":[{"name":"__d"}],"output":{"generics":["diagnosticid"],"name":"result"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"subdiagnostic"}}],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"subdiagnostic"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"self"},{"name":"subdiagnostic"}],"output":{"name":"bool"}}],[11,"hash","","",4,null],[11,"encode","","",4,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",4,{"inputs":[{"name":"__d"}],"output":{"generics":["subdiagnostic"],"name":"result"}}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"diagnosticstyledstring"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"self"},{"name":"diagnosticstyledstring"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",5,null],[11,"new","","",5,{"inputs":[],"output":{"name":"diagnosticstyledstring"}}],[11,"push_normal","","",5,{"inputs":[{"name":"self"},{"name":"s"}],"output":null}],[11,"push_highlighted","","",5,{"inputs":[{"name":"self"},{"name":"s"}],"output":null}],[11,"normal","","",5,{"inputs":[{"name":"s"}],"output":{"name":"diagnosticstyledstring"}}],[11,"highlighted","","",5,{"inputs":[{"name":"s"}],"output":{"name":"diagnosticstyledstring"}}],[11,"content","","",5,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"eq","rustc_errors::diagnostic","",12,{"inputs":[{"name":"self"},{"name":"stringpart"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"self"},{"name":"stringpart"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",12,null],[11,"content","","",12,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"new","rustc_errors","",3,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"self"}}],[11,"new_with_code","","",3,{"inputs":[{"name":"level"},{"generics":["diagnosticid"],"name":"option"},{"name":"str"}],"output":{"name":"self"}}],[11,"cancel","","Cancel the diagnostic (a structured diagnostic must either be emitted or canceled or it will panic when dropped).",3,{"inputs":[{"name":"self"}],"output":null}],[11,"cancelled","","",3,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"self"}}],[11,"note_expected_found","","",3,{"inputs":[{"name":"self"},{"name":"display"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"}],"output":{"name":"self"}}],[11,"note_expected_found_extra","","",3,{"inputs":[{"name":"self"},{"name":"display"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"},{"name":"display"},{"name":"display"}],"output":{"name":"self"}}],[11,"note_trait_signature","","",3,{"inputs":[{"name":"self"},{"name":"string"},{"name":"string"}],"output":{"name":"self"}}],[11,"note","","",3,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"self"}}],[11,"highlighted_note","","",3,{"inputs":[{"name":"self"},{"name":"vec"}],"output":{"name":"self"}}],[11,"span_note","","",3,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"self"}}],[11,"warn","","",3,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_warn","","",3,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"self"}}],[11,"help","","",3,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_help","","",3,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_suggestion_short","","Prints out a message with a suggested edit of the code. If the suggestion is presented inline it will only show the text message and not the text.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":{"name":"self"}}],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":{"name":"self"}}],[11,"span_suggestions","","Prints out a message with multiple suggested edits of the code.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"generics":["string"],"name":"vec"}],"output":{"name":"self"}}],[11,"span_suggestion_with_applicability","","This is a suggestion that may contain mistakes or fillers and should be read and understood by a human.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"string"},{"name":"applicability"}],"output":{"name":"self"}}],[11,"span_suggestions_with_applicability","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"generics":["string"],"name":"vec"},{"name":"applicability"}],"output":{"name":"self"}}],[11,"set_span","","",3,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"self"}}],[11,"code","","",3,{"inputs":[{"name":"self"},{"name":"diagnosticid"}],"output":{"name":"self"}}],[11,"get_code","","",3,{"inputs":[{"name":"self"}],"output":{"generics":["diagnosticid"],"name":"option"}}],[11,"message","","",3,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"styled_message","","",3,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"copy_details_not_message","","Used by a lint. Copies over all details but the \"main message\".",3,{"inputs":[{"name":"self"},{"name":"diagnostic"}],"output":null}],[11,"sub","","Convenience function for internal use, clients should use one of the public methods above.",3,{"inputs":[{"name":"self"},{"name":"level"},{"name":"str"},{"name":"multispan"},{"generics":["multispan"],"name":"option"}],"output":null}],[11,"sub_with_highlights","","Convenience function for internal use, clients should use one of the public methods above.",3,{"inputs":[{"name":"self"},{"name":"level"},{"name":"vec"},{"name":"multispan"},{"generics":["multispan"],"name":"option"}],"output":null}],[11,"message","","",4,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"styled_message","","",4,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[0,"diagnostic_builder","","",null,null],[3,"DiagnosticBuilder","rustc_errors::diagnostic_builder","Used for emitting structured error messages and other diagnostic information.",null,null],[12,"handler","","",6,null],[12,"diagnostic","","",6,null],[11,"clone","rustc_errors","",6,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"deref","","",6,{"inputs":[{"name":"self"}],"output":{"name":"diagnostic"}}],[11,"deref_mut","","",6,{"inputs":[{"name":"self"}],"output":{"name":"diagnostic"}}],[11,"emit","","Emit the diagnostic.",6,{"inputs":[{"name":"self"}],"output":null}],[11,"is_error","","",6,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"sub","","Convenience function for internal use, clients should use one of the span_* methods instead.",6,{"inputs":[{"name":"self"},{"name":"level"},{"name":"str"},{"name":"option"}],"output":{"name":"self"}}],[11,"delay_as_bug","","Delay emission of this diagnostic as a bug.",6,{"inputs":[{"name":"self"}],"output":null}],[11,"span_label","","Add a span/label to be included in the resulting snippet. This is pushed onto the `MultiSpan` that was created when the diagnostic was first built. If you don't call this function at all, and you just supplied a `Span` to create the diagnostic, then the snippet will just include that `Span`, which is called the primary span.",6,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"self"}}],[11,"note_expected_found","","",6,{"inputs":[{"name":"self"},{"name":"display"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"}],"output":{"name":"self"}}],[11,"note_expected_found_extra","","",6,{"inputs":[{"name":"self"},{"name":"display"},{"name":"diagnosticstyledstring"},{"name":"diagnosticstyledstring"},{"name":"display"},{"name":"display"}],"output":{"name":"self"}}],[11,"note","","",6,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_note","","",6,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"self"}}],[11,"warn","","",6,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_warn","","",6,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"self"}}],[11,"help","","",6,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_help","","",6,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"self"}}],[11,"span_suggestion_short","","",6,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":{"name":"self"}}],[11,"span_suggestion","","",6,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":{"name":"self"}}],[11,"span_suggestions","","",6,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"generics":["string"],"name":"vec"}],"output":{"name":"self"}}],[11,"span_suggestion_with_applicability","","",6,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"string"},{"name":"applicability"}],"output":{"name":"self"}}],[11,"span_suggestions_with_applicability","","",6,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"generics":["string"],"name":"vec"},{"name":"applicability"}],"output":{"name":"self"}}],[11,"set_span","","",6,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"self"}}],[11,"code","","",6,{"inputs":[{"name":"self"},{"name":"diagnosticid"}],"output":{"name":"self"}}],[11,"new","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",6,{"inputs":[{"name":"handler"},{"name":"level"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"new_with_code","","Convenience function for internal use, clients should use one of the struct_* methods on Handler.",6,{"inputs":[{"name":"handler"},{"name":"level"},{"generics":["diagnosticid"],"name":"option"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"new_diagnostic","","Creates a new `DiagnosticBuilder` with an already constructed diagnostic.",6,{"inputs":[{"name":"handler"},{"name":"diagnostic"}],"output":{"name":"diagnosticbuilder"}}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"drop","","",6,{"inputs":[{"name":"self"}],"output":null}],[0,"emitter","","",null,null],[3,"EmitterWriter","rustc_errors::emitter","",null,null],[12,"dst","","",13,null],[12,"cm","","",13,null],[12,"short_message","","",13,null],[12,"teach","","",13,null],[12,"ui_testing","","",13,null],[3,"FileWithAnnotatedLines","","",null,null],[12,"file","","",14,null],[12,"lines","","",14,null],[12,"multiline_depth","","",14,null],[4,"ColorConfig","","",null,null],[13,"Auto","","",15,null],[13,"Always","","",15,null],[13,"Never","","",15,null],[4,"Destination","","",null,null],[13,"Terminal","","",16,null],[13,"Buffered","","",16,null],[13,"Raw","","",16,null],[4,"WritableDst","","",null,null],[13,"Terminal","","",17,null],[13,"Buffered","","",17,null],[13,"Raw","","",17,null],[5,"draw_col_separator","","",null,{"inputs":[{"name":"styledbuffer"},{"name":"usize"},{"name":"usize"}],"output":null}],[5,"draw_col_separator_no_space","","",null,{"inputs":[{"name":"styledbuffer"},{"name":"usize"},{"name":"usize"}],"output":null}],[5,"draw_col_separator_no_space_with_style","","",null,{"inputs":[{"name":"styledbuffer"},{"name":"usize"},{"name":"usize"},{"name":"style"}],"output":null}],[5,"draw_range","","",null,{"inputs":[{"name":"styledbuffer"},{"name":"char"},{"name":"usize"},{"name":"usize"},{"name":"usize"},{"name":"style"}],"output":null}],[5,"draw_note_separator","","",null,{"inputs":[{"name":"styledbuffer"},{"name":"usize"},{"name":"usize"}],"output":null}],[5,"draw_multiline_line","","",null,{"inputs":[{"name":"styledbuffer"},{"name":"usize"},{"name":"usize"},{"name":"usize"},{"name":"style"}],"output":null}],[5,"num_overlap","","",null,{"inputs":[{"name":"usize"},{"name":"usize"},{"name":"usize"},{"name":"usize"},{"name":"bool"}],"output":{"name":"bool"}}],[5,"overlaps","","",null,{"inputs":[{"name":"annotation"},{"name":"annotation"},{"name":"usize"}],"output":{"name":"bool"}}],[5,"emit_to_destination","","",null,{"inputs":[{"name":"vec"},{"name":"level"},{"name":"destination"},{"name":"bool"}],"output":{"name":"result"}}],[17,"ANONYMIZED_LINE_NUM","","",null,null],[17,"MAX_HIGHLIGHT_LINES","","maximum number of lines we will print for each error; arbitrary.",null,null],[17,"MAX_SUGGESTIONS","","maximum number of suggestions to be shown",null,null],[8,"Emitter","","Emitter trait for emitting errors.",null,null],[10,"emit","","Emit a structured diagnostic.",18,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"should_show_explain","","Check if should show explanations about \"rustc --explain\"",18,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"emit","","",13,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"should_show_explain","","",13,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"self"}],"output":{"name":"colorconfig"}}],[11,"fmt","","",15,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"self"},{"name":"colorconfig"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",15,null],[11,"to_color_choice","","",15,{"inputs":[{"name":"self"}],"output":{"name":"colorchoice"}}],[11,"stderr","","",13,{"inputs":[{"name":"colorconfig"},{"generics":["lrc"],"name":"option"},{"name":"bool"},{"name":"bool"}],"output":{"name":"emitterwriter"}}],[11,"new","","",13,{"inputs":[{"generics":["write"],"name":"box"},{"generics":["lrc"],"name":"option"},{"name":"bool"},{"name":"bool"}],"output":{"name":"emitterwriter"}}],[11,"ui_testing","","",13,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"self"}}],[11,"maybe_anonymized","","",13,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"string"}}],[11,"preprocess_annotations","","",13,{"inputs":[{"name":"self"},{"name":"multispan"}],"output":{"generics":["filewithannotatedlines"],"name":"vec"}}],[11,"render_source_line","","",13,{"inputs":[{"name":"self"},{"name":"styledbuffer"},{"generics":["filemap"],"name":"lrc"},{"name":"line"},{"name":"usize"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"get_multispan_max_line_num","","",13,{"inputs":[{"name":"self"},{"name":"multispan"}],"output":{"name":"usize"}}],[11,"get_max_line_num","","",13,{"inputs":[{"name":"self"},{"name":"multispan"},{"name":"vec"}],"output":{"name":"usize"}}],[11,"fix_multispan_in_std_macros","","",13,{"inputs":[{"name":"self"},{"name":"multispan"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"fix_multispans_in_std_macros","","",13,{"inputs":[{"name":"self"},{"name":"multispan"},{"name":"vec"},{"name":"bool"}],"output":null}],[11,"msg_to_buffer","","Add a left margin to every line but the first, given a padding length and the label being displayed, keeping the provided highlighting.",13,null],[11,"emit_message_default","","",13,{"inputs":[{"name":"self"},{"name":"multispan"},{"name":"vec"},{"name":"option"},{"name":"level"},{"name":"usize"},{"name":"bool"}],"output":{"name":"result"}}],[11,"emit_suggestion_default","","",13,{"inputs":[{"name":"self"},{"name":"codesuggestion"},{"name":"level"},{"name":"usize"}],"output":{"name":"result"}}],[11,"emit_messages_default","","",13,null],[11,"from_stderr","","",16,{"inputs":[{"name":"colorconfig"}],"output":{"name":"destination"}}],[11,"writable","","",16,{"inputs":[{"name":"self"}],"output":{"name":"writabledst"}}],[11,"apply_style","","",17,{"inputs":[{"name":"self"},{"name":"level"},{"name":"style"}],"output":{"name":"result"}}],[11,"set_color","","",17,{"inputs":[{"name":"self"},{"name":"colorspec"}],"output":{"name":"result"}}],[11,"reset","","",17,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"write","","",17,null],[11,"flush","","",17,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"drop","","",17,{"inputs":[{"name":"self"}],"output":null}],[0,"snippet","rustc_errors","",null,null],[3,"Line","rustc_errors::snippet","",null,null],[12,"line_index","","",19,null],[12,"annotations","","",19,null],[3,"MultilineAnnotation","","",null,null],[12,"depth","","",20,null],[12,"line_start","","",20,null],[12,"line_end","","",20,null],[12,"start_col","","",20,null],[12,"end_col","","",20,null],[12,"is_primary","","",20,null],[12,"label","","",20,null],[3,"Annotation","","",null,null],[12,"start_col","","Start column, 0-based indexing -- counting characters, not utf-8 bytes. Note that it is important that this field goes first, so that when we sort, we sort orderings by start column.",21,null],[12,"end_col","","End column within the line (exclusive)",21,null],[12,"is_primary","","Is this annotation derived from primary span",21,null],[12,"label","","Optional label to display adjacent to the annotation.",21,null],[12,"annotation_type","","Is this a single line, multiline or multiline span minimized down to a smaller span.",21,null],[3,"StyledString","","",null,null],[12,"text","","",22,null],[12,"style","","",22,null],[4,"AnnotationType","","",null,null],[13,"Singleline","","Annotation under a single line of code",23,null],[13,"Multiline","","Annotation enclosing the first and last character of a multiline span",23,null],[13,"MultilineStart","","Annotation marking the first character of a fully shown multiline span",23,null],[13,"MultilineEnd","","Annotation marking the last character of a fully shown multiline span",23,null],[13,"MultilineLine","","Line at the left enclosing the lines of a fully shown multiline span",23,null],[4,"Style","","",null,null],[13,"HeaderMsg","","",24,null],[13,"LineAndColumn","","",24,null],[13,"LineNumber","","",24,null],[13,"Quotation","","",24,null],[13,"UnderlinePrimary","","",24,null],[13,"UnderlineSecondary","","",24,null],[13,"LabelPrimary","","",24,null],[13,"LabelSecondary","","",24,null],[13,"OldSchoolNoteText","","",24,null],[13,"NoStyle","","",24,null],[13,"Level","","",24,null],[13,"Highlight","","",24,null],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"line"}}],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"bool"}}],[11,"le","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"bool"}}],[11,"gt","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"bool"}}],[11,"ge","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"bool"}}],[11,"cmp","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"ordering"}}],[11,"eq","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"self"},{"name":"line"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",19,null],[11,"clone","","",20,{"inputs":[{"name":"self"}],"output":{"name":"multilineannotation"}}],[11,"fmt","","",20,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"bool"}}],[11,"le","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"bool"}}],[11,"gt","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"bool"}}],[11,"ge","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"bool"}}],[11,"cmp","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"ordering"}}],[11,"eq","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"self"},{"name":"multilineannotation"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",20,null],[11,"increase_depth","","",20,{"inputs":[{"name":"self"}],"output":null}],[11,"as_start","","",20,{"inputs":[{"name":"self"}],"output":{"name":"annotation"}}],[11,"as_end","","",20,{"inputs":[{"name":"self"}],"output":{"name":"annotation"}}],[11,"as_line","","",20,{"inputs":[{"name":"self"}],"output":{"name":"annotation"}}],[11,"clone","","",23,{"inputs":[{"name":"self"}],"output":{"name":"annotationtype"}}],[11,"fmt","","",23,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"bool"}}],[11,"le","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"bool"}}],[11,"gt","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"bool"}}],[11,"ge","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"bool"}}],[11,"cmp","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"ordering"}}],[11,"eq","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"self"},{"name":"annotationtype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",23,null],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"annotation"}}],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"bool"}}],[11,"le","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"bool"}}],[11,"gt","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"bool"}}],[11,"ge","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"bool"}}],[11,"cmp","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"ordering"}}],[11,"eq","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"self"},{"name":"annotation"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",21,null],[11,"is_line","","Whether this annotation is a vertical line placeholder.",21,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_multiline","","",21,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"len","","",21,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"has_label","","",21,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"takes_space","","",21,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"style"}}],[11,"fmt","","",24,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",24,{"inputs":[{"name":"self"},{"name":"style"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"self"},{"name":"style"}],"output":{"name":"bool"}}],[11,"hash","","",24,null],[11,"encode","","",24,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"__d"}],"output":{"generics":["style"],"name":"result"}}],[0,"registry","rustc_errors","",null,null],[3,"Registry","rustc_errors::registry","",null,null],[12,"descriptions","","",25,null],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"registry"}}],[11,"new","","",25,null],[11,"find_description","","",25,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["str"],"name":"option"}}],[0,"styled_buffer","rustc_errors","",null,null],[3,"StyledBuffer","rustc_errors::styled_buffer","",null,null],[12,"text","","",26,null],[12,"styles","","",26,null],[11,"fmt","","",26,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",26,{"inputs":[],"output":{"name":"styledbuffer"}}],[11,"replace_tabs","","",26,{"inputs":[{"name":"self"}],"output":null}],[11,"render","","",26,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"vec"}}],[11,"ensure_lines","","",26,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"putc","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"},{"name":"char"},{"name":"style"}],"output":null}],[11,"puts","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"},{"name":"str"},{"name":"style"}],"output":null}],[11,"prepend","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"str"},{"name":"style"}],"output":null}],[11,"append","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"str"},{"name":"style"}],"output":null}],[11,"num_lines","","",26,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"set_style_range","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"},{"name":"usize"},{"name":"style"},{"name":"bool"}],"output":null}],[11,"set_style","","",26,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"},{"name":"style"},{"name":"bool"}],"output":null}],[0,"lock","rustc_errors","Bindings to acquire a global named lock.",null,null],[5,"acquire_global_lock","rustc_errors::lock","",null,{"inputs":[{"name":"str"}],"output":{"generics":["any"],"name":"box"}}],[6,"CodeMapperDyn","rustc_errors","",null,null],[17,"TRACK_DIAGNOSTICS","","",null,null],[8,"CodeMapper","","",null,null],[10,"lookup_char_pos","","",27,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"loc"}}],[10,"span_to_lines","","",27,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filelinesresult"}}],[10,"span_to_string","","",27,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"string"}}],[10,"span_to_filename","","",27,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filename"}}],[10,"merge_spans","","",27,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[10,"call_span_if_macro","","",27,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[10,"ensure_filemap_source_present","","",27,{"inputs":[{"name":"self"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"bool"}}],[10,"doctest_offset_line","","",27,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"applicability"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"applicability"}],"output":{"name":"bool"}}],[11,"hash","","",9,null],[11,"encode","","",9,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",9,{"inputs":[{"name":"__d"}],"output":{"generics":["applicability"],"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"self"}],"output":{"name":"codesuggestion"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",0,{"inputs":[{"name":"self"},{"name":"codesuggestion"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"self"},{"name":"codesuggestion"}],"output":{"name":"bool"}}],[11,"hash","","",0,null],[11,"encode","","",0,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",0,{"inputs":[{"name":"__d"}],"output":{"generics":["codesuggestion"],"name":"result"}}],[11,"clone","","",1,{"inputs":[{"name":"self"}],"output":{"name":"substitution"}}],[11,"fmt","","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"substitution"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"self"},{"name":"substitution"}],"output":{"name":"bool"}}],[11,"hash","","",1,null],[11,"encode","","",1,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",1,{"inputs":[{"name":"__d"}],"output":{"generics":["substitution"],"name":"result"}}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"substitutionpart"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"substitutionpart"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"substitutionpart"}],"output":{"name":"bool"}}],[11,"hash","","",2,null],[11,"encode","","",2,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",2,{"inputs":[{"name":"__d"}],"output":{"generics":["substitutionpart"],"name":"result"}}],[11,"splice_lines","","Returns the assembled code suggestions and whether they should be shown with an underline.",0,{"inputs":[{"name":"self"},{"name":"codemapperdyn"}],"output":{"name":"vec"}}],[11,"clone","","",28,{"inputs":[{"name":"self"}],"output":{"name":"fatalerror"}}],[11,"fmt","","",28,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"raise","","",28,null],[11,"fmt","","",28,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"description","","",28,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"explicitbug"}}],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"description","","",29,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"default","","",8,{"inputs":[],"output":{"name":"handlerflags"}}],[11,"with_tty_emitter","","",7,{"inputs":[{"name":"colorconfig"},{"name":"bool"},{"name":"bool"},{"generics":["lrc"],"name":"option"}],"output":{"name":"handler"}}],[11,"with_tty_emitter_and_flags","","",7,{"inputs":[{"name":"colorconfig"},{"generics":["lrc"],"name":"option"},{"name":"handlerflags"}],"output":{"name":"handler"}}],[11,"with_emitter","","",7,{"inputs":[{"name":"bool"},{"name":"bool"},{"generics":["emitter"],"name":"box"}],"output":{"name":"handler"}}],[11,"with_emitter_and_flags","","",7,{"inputs":[{"generics":["emitter"],"name":"box"},{"name":"handlerflags"}],"output":{"name":"handler"}}],[11,"set_continue_after_error","","",7,{"inputs":[{"name":"self"},{"name":"bool"}],"output":null}],[11,"reset_err_count","","Resets the diagnostic error count as well as the cached emitted diagnostics.",7,{"inputs":[{"name":"self"}],"output":null}],[11,"struct_dummy","","",7,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_warn","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_warn_with_code","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_warn","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_err","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_err_with_code","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_err","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_err_with_code","","",7,{"inputs":[{"name":"self"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_fatal","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_fatal_with_code","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_fatal","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"cancel","","",7,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"panic_if_treat_err_as_bug","","",7,{"inputs":[{"name":"self"}],"output":null}],[11,"span_fatal","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_with_code","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"fatalerror"}}],[11,"span_err","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"mut_span_err","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_err_with_code","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":null}],[11,"span_warn","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_warn_with_code","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":null}],[11,"span_bug","","",7,null],[11,"delay_span_bug","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_bug_no_panic","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_note_without_error","","",7,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_note_diag","","",7,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_unimpl","","",7,null],[11,"failure","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"fatal","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"err","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"warn","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"note_without_error","","",7,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"bug","","",7,null],[11,"unimpl","","",7,null],[11,"bump_err_count","","",7,{"inputs":[{"name":"self"}],"output":null}],[11,"err_count","","",7,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"has_errors","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"print_error_count","","",7,{"inputs":[{"name":"self"}],"output":null}],[11,"abort_if_errors","","",7,{"inputs":[{"name":"self"}],"output":null}],[11,"emit","","",7,{"inputs":[{"name":"self"},{"name":"multispan"},{"name":"str"},{"name":"level"}],"output":null}],[11,"emit_with_code","","",7,{"inputs":[{"name":"self"},{"name":"multispan"},{"name":"str"},{"name":"diagnosticid"},{"name":"level"}],"output":null}],[11,"must_teach","","`true` if we haven't taught a diagnostic with this code already. The caller must then teach the user about such a diagnostic.",7,{"inputs":[{"name":"self"},{"name":"diagnosticid"}],"output":{"name":"bool"}}],[11,"force_print_db","","",7,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"emit_db","","",7,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"eq","","",11,{"inputs":[{"name":"self"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"self"}],"output":{"name":"level"}}],[11,"hash","","",11,null],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",11,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",11,{"inputs":[{"name":"__d"}],"output":{"generics":["level"],"name":"result"}}],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"color","","",11,{"inputs":[{"name":"self"}],"output":{"name":"colorspec"}}],[11,"to_str","","",11,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"is_failure_note","","",11,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}]],"paths":[[3,"CodeSuggestion"],[3,"Substitution"],[3,"SubstitutionPart"],[3,"Diagnostic"],[3,"SubDiagnostic"],[3,"DiagnosticStyledString"],[3,"DiagnosticBuilder"],[3,"Handler"],[3,"HandlerFlags"],[4,"Applicability"],[4,"DiagnosticId"],[4,"Level"],[4,"StringPart"],[3,"EmitterWriter"],[3,"FileWithAnnotatedLines"],[4,"ColorConfig"],[4,"Destination"],[4,"WritableDst"],[8,"Emitter"],[3,"Line"],[3,"MultilineAnnotation"],[3,"Annotation"],[3,"StyledString"],[4,"AnnotationType"],[4,"Style"],[3,"Registry"],[3,"StyledBuffer"],[8,"CodeMapper"],[3,"FatalError"],[3,"ExplicitBug"]]};
searchIndex["rustc_incremental"] = {"doc":"Support for serializing the dep-graph and reloading it.","items":[[4,"LoadResult","rustc_incremental","",null,null],[13,"Ok","","",0,null],[12,"data","rustc_incremental::LoadResult","",0,null],[13,"DataOutOfDate","rustc_incremental","",0,null],[13,"Error","","",0,null],[12,"message","rustc_incremental::LoadResult","",0,null],[5,"assert_dep_graph","rustc_incremental","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"dep_graph_tcx_init","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"load_dep_graph","","Launch a thread and load the dependency graph in the background.",null,{"inputs":[{"name":"session"}],"output":{"generics":["loadresult"],"name":"maybeasync"}}],[5,"load_query_result_cache","","",null,{"inputs":[{"name":"session"}],"output":{"name":"ondiskcache"}}],[5,"save_dep_graph","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"save_trans_partition","","",null,null],[5,"save_work_products","","",null,{"inputs":[{"name":"session"},{"name":"depgraph"}],"output":null}],[5,"in_incr_comp_dir","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"prepare_session_directory","","Allocates the private session directory. The boolean in the Ok() result indicates whether we should try loading a dep graph from the successfully initialized directory, or not. The post-condition of this fn is that we have a valid incremental compilation session directory, if the result is `Ok`. A valid session directory is one that contains a locked lock file. It may or may not contain a dep-graph and work products from a previous session. If the call fails, the fn may leave behind an invalid session directory. The garbage collection will take care of it.",null,{"inputs":[{"name":"session"},{"name":"str"},{"name":"cratedisambiguator"}],"output":null}],[5,"finalize_session_directory","","This function finalizes and thus 'publishes' the session directory by renaming it to `s-{timestamp}-{svh}` and releasing the file lock. If there have been compilation errors, however, this function will just delete the presumably invalid session directory.",null,{"inputs":[{"name":"session"},{"name":"svh"}],"output":null}],[5,"delete_workproduct_files","","",null,{"inputs":[{"name":"session"},{"name":"workproduct"}],"output":null}],[5,"garbage_collect_session_directories","","",null,{"inputs":[{"name":"session"}],"output":{"name":"result"}}],[0,"assert_dep_graph","","This pass is only used for the UNIT TESTS and DEBUGGING NEEDS around dependency graph construction. It serves two purposes; it will dump graphs in graphviz form to disk, and it searches for `#[rustc_if_this_changed]` and `#[rustc_then_this_would_need]` annotations. These annotations can be used to test whether paths exist in the graph. These checks run after trans, so they view the the final state of the dependency graph. Note that there are similar assertions found in `persist::dirty_clean` which check the initial state of the dependency graph, just after it has been loaded from disk.",null,null],[3,"IfThisChanged","rustc_incremental::assert_dep_graph","",null,null],[12,"tcx","","",1,null],[12,"if_this_changed","","",1,null],[12,"then_this_would_need","","",1,null],[3,"GraphvizDepGraph","","",null,null],[12,"0","","",2,null],[12,"1","","",2,null],[5,"assert_dep_graph","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"check_paths","","",null,{"inputs":[{"name":"tyctxt"},{"name":"vec"},{"name":"vec"}],"output":null}],[5,"dump_graph","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"node_set","","",null,{"inputs":[{"name":"depgraphquery"},{"name":"depnodefilter"}],"output":{"generics":["fxhashset"],"name":"option"}}],[5,"filter_nodes","","",null,{"inputs":[{"name":"depgraphquery"},{"name":"option"},{"name":"option"}],"output":{"generics":["depnode"],"name":"fxhashset"}}],[5,"walk_nodes","","",null,{"inputs":[{"name":"depgraphquery"},{"name":"fxhashset"},{"name":"direction"}],"output":{"generics":["depnode"],"name":"fxhashset"}}],[5,"walk_between","","",null,{"inputs":[{"name":"depgraphquery"},{"name":"fxhashset"},{"name":"fxhashset"}],"output":{"generics":["depnode"],"name":"fxhashset"}}],[5,"filter_edges","","",null,{"inputs":[{"name":"depgraphquery"},{"name":"fxhashset"}],"output":{"name":"vec"}}],[6,"Sources","","",null,null],[6,"Targets","","",null,null],[11,"argument","","",1,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"generics":["name"],"name":"option"}}],[11,"process_attrs","","",1,null],[11,"nested_visit_map","","",1,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",1,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",1,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",1,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_struct_field","","",1,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"nodes","","",2,{"inputs":[{"name":"self"}],"output":{"generics":["depnode"],"name":"nodes"}}],[11,"edges","","",2,{"inputs":[{"name":"self"}],"output":{"name":"edges"}}],[11,"source","","",2,null],[11,"target","","",2,null],[11,"graph_id","","",2,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"node_id","","",2,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"id"}}],[11,"node_label","","",2,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"labeltext"}}],[0,"assert_module_sources","rustc_incremental","This pass is only used for UNIT TESTS related to incremental compilation. It tests whether a particular `.o` file will be re-used from a previous compilation or whether it must be regenerated.",null,null],[3,"AssertModuleSource","rustc_incremental::assert_module_sources","",null,null],[12,"tcx","","",3,null],[4,"Disposition","","",null,null],[13,"Reused","","",4,null],[13,"Translated","","",4,null],[5,"assert_module_sources","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[17,"MODULE","","",null,null],[17,"CFG","","",null,null],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"disposition"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"disposition"}}],[11,"check_attr","","",3,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"field","","",3,{"inputs":[{"name":"self"},{"name":"attribute"},{"name":"str"}],"output":{"name":"name"}}],[11,"check_config","","Scan for a `cfg=\"foo\"` attribute and check whether we have a cfg flag called `foo`.",3,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"name":"bool"}}],[0,"persist","rustc_incremental","When in incremental mode, this pass dumps out the dependency graph into the given directory. At the same time, it also hashes the various HIR nodes.",null,null],[0,"data","rustc_incremental::persist","The data that we will serialize and deserialize.",null,null],[3,"SerializedWorkProduct","rustc_incremental::persist::data","",null,null],[12,"id","","node that produced the work-product",5,null],[12,"work_product","","work-product data itself",5,null],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",5,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",5,{"inputs":[{"name":"__d"}],"output":{"generics":["serializedworkproduct"],"name":"result"}}],[0,"dirty_clean","rustc_incremental::persist","Debugging code to test fingerprints computed for query results. For each node marked with `#[rustc_clean]` or `#[rustc_dirty]`, we will compare the fingerprint from the current and from the previous compilation session as appropriate:",null,null],[3,"Assertion","rustc_incremental::persist::dirty_clean","Represents the requested configuration by rustc_clean/dirty",null,null],[12,"clean","","",6,null],[12,"dirty","","",6,null],[3,"DirtyCleanVisitor","","",null,null],[12,"tcx","","",7,null],[12,"checked_attrs","","",7,null],[3,"FindAllAttrs","","",null,null],[12,"tcx","","",8,null],[12,"attr_names","","",8,null],[12,"found_attrs","","",8,null],[5,"check_dirty_clean_annotations","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"check_config","","Given a `#[rustc_dirty]` or `#[rustc_clean]` attribute, scan for a `cfg=\"foo\"` attribute and check whether we have a cfg flag called `foo`.",null,{"inputs":[{"name":"tyctxt"},{"name":"attribute"}],"output":{"name":"bool"}}],[5,"expect_associated_value","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nestedmetaitem"}],"output":{"name":"name"}}],[6,"Labels","","",null,null],[17,"EXCEPT","","",null,null],[17,"LABEL","","",null,null],[17,"CFG","","",null,null],[17,"BASE_CONST","","For typedef, constants, and statics",null,null],[17,"BASE_FN","","DepNodes for functions + methods",null,null],[17,"BASE_HIR","","DepNodes for Hir, which is pretty much everything",null,null],[17,"BASE_IMPL","","`impl` implementation of struct/trait",null,null],[17,"BASE_MIR","","DepNodes for MirValidated/Optimized, which is relevant in \"executable\" code, i.e. functions+methods",null,null],[17,"BASE_STRUCT","","Struct, Enum and Union DepNodes",null,null],[17,"BASE_TRAIT_DEF","","Trait Definition DepNodes",null,null],[17,"EXTRA_ASSOCIATED","","extra DepNodes for methods (+fn)",null,null],[17,"EXTRA_TRAIT","","",null,null],[17,"LABELS_CONST","","",null,null],[17,"LABELS_CONST_IN_IMPL","","Constant/Typedef in an impl",null,null],[17,"LABELS_CONST_IN_TRAIT","","Trait-Const/Typedef DepNodes",null,null],[17,"LABELS_FN","","Function DepNode",null,null],[17,"LABELS_FN_IN_IMPL","","Method DepNodes",null,null],[17,"LABELS_FN_IN_TRAIT","","Trait-Method DepNodes",null,null],[17,"LABELS_HIR_ONLY","","For generic cases like inline-assemply/mod/etc",null,null],[17,"LABELS_IMPL","","Impl DepNodes",null,null],[17,"LABELS_ADT","","Abstract Data Type (Struct, Enum, Unions) DepNodes",null,null],[17,"LABELS_TRAIT","","Trait Definition DepNodes",null,null],[11,"from_clean_labels","","",6,{"inputs":[{"generics":["string"],"name":"hashset"}],"output":{"name":"assertion"}}],[11,"from_dirty_labels","","",6,{"inputs":[{"generics":["string"],"name":"hashset"}],"output":{"name":"assertion"}}],[11,"assertion_maybe","","Possibly \"deserialize\" the attribute into a clean/dirty assertion",7,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"attribute"}],"output":{"generics":["assertion"],"name":"option"}}],[11,"assertion_auto","","Get the \"auto\" assertion on pre-validated attr, along with the `except` labels",7,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"attribute"},{"name":"bool"}],"output":{"name":"assertion"}}],[11,"labels","","",7,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"generics":["hashset"],"name":"option"}}],[11,"except","","`except=` attribute value",7,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"generics":["string"],"name":"hashset"}}],[11,"auto_labels","","Return all DepNode labels that should be asserted for this item. index=0 is the \"name\" used for error messages",7,null],[11,"resolve_labels","","",7,{"inputs":[{"name":"self"},{"name":"nestedmetaitem"},{"name":"str"}],"output":{"generics":["string"],"name":"hashset"}}],[11,"dep_nodes","","",7,{"inputs":[{"name":"self"},{"name":"hashset"},{"name":"defid"}],"output":{"generics":["depnode"],"name":"vec"}}],[11,"dep_node_str","","",7,{"inputs":[{"name":"self"},{"name":"depnode"}],"output":{"name":"string"}}],[11,"assert_dirty","","",7,{"inputs":[{"name":"self"},{"name":"span"},{"name":"depnode"}],"output":null}],[11,"assert_clean","","",7,{"inputs":[{"name":"self"},{"name":"span"},{"name":"depnode"}],"output":null}],[11,"check_item","","",7,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_item","","",7,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",7,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",7,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"is_active_attr","","",8,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"report_unchecked_attrs","","",8,{"inputs":[{"name":"self"},{"name":"fxhashset"}],"output":null}],[11,"nested_visit_map","","",8,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_attribute","","",8,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[0,"fs","rustc_incremental::persist","This module manages how the incremental compilation cache is represented in the file system.",null,null],[5,"dep_graph_path","rustc_incremental::persist::fs","",null,{"inputs":[{"name":"session"}],"output":{"name":"pathbuf"}}],[5,"dep_graph_path_from","","",null,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[5,"work_products_path","","",null,{"inputs":[{"name":"session"}],"output":{"name":"pathbuf"}}],[5,"query_cache_path","","",null,{"inputs":[{"name":"session"}],"output":{"name":"pathbuf"}}],[5,"lock_file_path","","",null,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[5,"in_incr_comp_dir_sess","","",null,{"inputs":[{"name":"session"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"in_incr_comp_dir","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"prepare_session_directory","","Allocates the private session directory. The boolean in the Ok() result indicates whether we should try loading a dep graph from the successfully initialized directory, or not. The post-condition of this fn is that we have a valid incremental compilation session directory, if the result is `Ok`. A valid session directory is one that contains a locked lock file. It may or may not contain a dep-graph and work products from a previous session. If the call fails, the fn may leave behind an invalid session directory. The garbage collection will take care of it.",null,{"inputs":[{"name":"session"},{"name":"str"},{"name":"cratedisambiguator"}],"output":null}],[5,"finalize_session_directory","","This function finalizes and thus 'publishes' the session directory by renaming it to `s-{timestamp}-{svh}` and releasing the file lock. If there have been compilation errors, however, this function will just delete the presumably invalid session directory.",null,{"inputs":[{"name":"session"},{"name":"svh"}],"output":null}],[5,"delete_all_session_dir_contents","","",null,{"inputs":[{"name":"session"}],"output":{"name":"result"}}],[5,"copy_files","","",null,{"inputs":[{"name":"session"},{"name":"path"},{"name":"path"}],"output":{"generics":["bool"],"name":"result"}}],[5,"generate_session_dir_path","","Generate unique directory path of the form: {crate_dir}/s-{timestamp}-{random-number}-working",null,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[5,"create_dir","","",null,{"inputs":[{"name":"session"},{"name":"path"},{"name":"str"}],"output":{"name":"result"}}],[5,"lock_directory","","Allocate a the lock-file and lock it.",null,{"inputs":[{"name":"session"},{"name":"path"}],"output":{"name":"result"}}],[5,"delete_session_dir_lock_file","","",null,{"inputs":[{"name":"session"},{"name":"path"}],"output":null}],[5,"find_source_directory","","Find the most recent published session directory that is not in the ignore-list.",null,{"inputs":[{"name":"path"},{"name":"fxhashset"}],"output":{"generics":["pathbuf"],"name":"option"}}],[5,"find_source_directory_in_iter","","",null,{"inputs":[{"name":"i"},{"name":"fxhashset"}],"output":{"generics":["pathbuf"],"name":"option"}}],[5,"is_finalized","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"is_session_directory","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"is_session_directory_lock_file","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"extract_timestamp_from_session_dir","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["systemtime"],"name":"result"}}],[5,"timestamp_to_string","","",null,{"inputs":[{"name":"systemtime"}],"output":{"name":"string"}}],[5,"string_to_timestamp","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["systemtime"],"name":"result"}}],[5,"crate_path","","",null,{"inputs":[{"name":"session"},{"name":"str"},{"name":"cratedisambiguator"}],"output":{"name":"pathbuf"}}],[5,"assert_no_characters_lost","","",null,{"inputs":[{"name":"str"}],"output":null}],[5,"is_old_enough_to_be_collected","","",null,{"inputs":[{"name":"systemtime"}],"output":{"name":"bool"}}],[5,"garbage_collect_session_directories","","",null,{"inputs":[{"name":"session"}],"output":{"name":"result"}}],[5,"all_except_most_recent","","",null,{"inputs":[{"name":"vec"}],"output":{"generics":["pathbuf","option"],"name":"fxhashmap"}}],[5,"safe_remove_dir_all","","Since paths of artifacts within session directories can get quite long, we need to support deleting files with very long paths. The regular WinApi functions only support paths up to 260 characters, however. In order to circumvent this limitation, we canonicalize the path of the directory before passing it to std::fs::remove_dir_all(). This will convert the path into the '\\?' format, which supports much longer paths.",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[5,"safe_remove_file","","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[17,"LOCK_FILE_EXT","","",null,null],[17,"DEP_GRAPH_FILENAME","","",null,null],[17,"WORK_PRODUCTS_FILENAME","","",null,null],[17,"QUERY_CACHE_FILENAME","","",null,null],[17,"INT_ENCODE_BASE","","",null,null],[0,"load","rustc_incremental::persist","Code to save/load the dep-graph from files.",null,null],[4,"LoadResult","rustc_incremental::persist::load","",null,null],[13,"Ok","","",0,null],[12,"data","rustc_incremental::persist::load::LoadResult","",0,null],[13,"DataOutOfDate","rustc_incremental::persist::load","",0,null],[13,"Error","","",0,null],[12,"message","rustc_incremental::persist::load::LoadResult","",0,null],[4,"MaybeAsync","rustc_incremental::persist::load","Either a result that has already be computed or a handle that will let us wait until it is computed by a background thread.",null,null],[13,"Sync","","",9,null],[13,"Async","","",9,null],[5,"dep_graph_tcx_init","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"load_data","","",null,{"inputs":[{"name":"bool"},{"name":"path"}],"output":{"name":"loadresult"}}],[5,"delete_dirty_work_product","","",null,{"inputs":[{"name":"tyctxt"},{"name":"serializedworkproduct"}],"output":null}],[5,"load_dep_graph","","Launch a thread and load the dependency graph in the background.",null,{"inputs":[{"name":"session"}],"output":{"generics":["loadresult"],"name":"maybeasync"}}],[5,"load_query_result_cache","","",null,{"inputs":[{"name":"session"}],"output":{"name":"ondiskcache"}}],[11,"open","rustc_incremental","",0,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"previousdepgraph"}}],[11,"open","rustc_incremental::persist::load","",9,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[0,"save","rustc_incremental::persist","",null,null],[5,"save_dep_graph","rustc_incremental::persist::save","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"save_work_products","","",null,{"inputs":[{"name":"session"},{"name":"depgraph"}],"output":null}],[5,"save_in","","",null,{"inputs":[{"name":"session"},{"name":"pathbuf"},{"name":"f"}],"output":null}],[5,"encode_dep_graph","","",null,{"inputs":[{"name":"tyctxt"},{"name":"encoder"}],"output":{"name":"result"}}],[5,"encode_work_products","","",null,{"inputs":[{"name":"depgraph"},{"name":"encoder"}],"output":{"name":"result"}}],[5,"encode_query_cache","","",null,{"inputs":[{"name":"tyctxt"},{"name":"encoder"}],"output":{"name":"result"}}],[0,"work_product","rustc_incremental::persist","This module contains files for saving intermediate work-products.",null,null],[5,"save_trans_partition","rustc_incremental::persist::work_product","",null,null],[5,"delete_workproduct_files","","",null,{"inputs":[{"name":"session"},{"name":"workproduct"}],"output":null}],[0,"file_format","rustc_incremental::persist","This module defines a generic file format that allows to check if a given file generated by incremental compilation was generated by a compatible compiler version. This file format is used for the on-disk version of the dependency graph and the exported metadata hashes.",null,null],[5,"write_file_header","rustc_incremental::persist::file_format","",null,{"inputs":[{"name":"w"}],"output":{"name":"result"}}],[5,"read_file","","Reads the contents of a file with a file header as defined in this module.",null,{"inputs":[{"name":"bool"},{"name":"path"}],"output":{"generics":["option"],"name":"result"}}],[5,"report_format_mismatch","","",null,{"inputs":[{"name":"bool"},{"name":"path"},{"name":"str"}],"output":null}],[5,"rustc_version","","",null,{"inputs":[],"output":{"name":"string"}}],[17,"FILE_MAGIC","","The first few bytes of files generated by incremental compilation",null,null],[17,"HEADER_FORMAT_VERSION","","Change this if the header format changes",null,null],[17,"RUSTC_VERSION","","A version string that hopefully is always different for compiler versions with different encodings of incremental compilation artifacts. Contains the git commit hash.",null,null]],"paths":[[4,"LoadResult"],[3,"IfThisChanged"],[3,"GraphvizDepGraph"],[3,"AssertModuleSource"],[4,"Disposition"],[3,"SerializedWorkProduct"],[3,"Assertion"],[3,"DirtyCleanVisitor"],[3,"FindAllAttrs"],[4,"MaybeAsync"]]};
searchIndex["rustc_lint"] = {"doc":"Lints in the Rust compiler.","items":[[5,"register_builtins","rustc_lint","Tell the `LintStore` about all the built-in lints (the ones defined in this crate and the ones defined in `rustc::lint::builtin`).",null,{"inputs":[{"name":"lintstore"},{"generics":["session"],"name":"option"}],"output":null}],[0,"bad_style","","",null,null],[3,"NonCamelCaseTypes","rustc_lint::bad_style","",null,null],[3,"NonSnakeCase","","",null,null],[3,"NonUpperCaseGlobals","","",null,null],[4,"MethodLateContext","","",null,null],[13,"TraitAutoImpl","","",0,null],[13,"TraitImpl","","",0,null],[13,"PlainImpl","","",0,null],[5,"method_context","","",null,{"inputs":[{"name":"latecontext"},{"name":"nodeid"}],"output":{"name":"methodlatecontext"}}],[7,"NON_CAMEL_CASE_TYPES","","",null,null],[7,"NON_SNAKE_CASE","","",null,null],[7,"NON_UPPER_CASE_GLOBALS","","",null,null],[11,"eq","","",0,{"inputs":[{"name":"self"},{"name":"methodlatecontext"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"self"}],"output":{"name":"noncamelcasetypes"}}],[11,"check_case","","",1,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"str"},{"name":"name"},{"name":"span"}],"output":null}],[11,"get_lints","","",1,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",1,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_variant","","",1,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_generic_param","","",1,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"genericparam"}],"output":null}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"nonsnakecase"}}],[11,"to_snake_case","","",2,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"check_snake_case","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"str"},{"name":"str"},{"generics":["span"],"name":"option"}],"output":null}],[11,"get_lints","","",2,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_crate","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"crate"}],"output":null}],[11,"check_generic_param","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"genericparam"}],"output":null}],[11,"check_fn","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"body"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_item","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_trait_item","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"traititem"}],"output":null}],[11,"check_pat","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"pat"}],"output":null}],[11,"check_struct_def","","",2,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variantdata"},{"name":"name"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"nonuppercaseglobals"}}],[11,"check_upper_case","","",3,{"inputs":[{"name":"latecontext"},{"name":"str"},{"name":"name"},{"name":"span"}],"output":null}],[11,"get_lints","","",3,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",3,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_trait_item","","",3,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"traititem"}],"output":null}],[11,"check_impl_item","","",3,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"implitem"}],"output":null}],[11,"check_pat","","",3,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"pat"}],"output":null}],[0,"builtin","rustc_lint","Lints in the Rust compiler.",null,null],[3,"WhileTrue","rustc_lint::builtin","",null,null],[3,"BoxPointers","","",null,null],[3,"NonShorthandFieldPatterns","","",null,null],[3,"UnsafeCode","","",null,null],[3,"MissingDoc","","",null,null],[12,"doc_hidden_stack","","Stack of whether #[doc(hidden)] is set at each level which has lint attributes.",4,null],[12,"private_traits","","Private traits or trait items that leaked through. Don't check their methods.",4,null],[3,"MissingCopyImplementations","","",null,null],[3,"MissingDebugImplementations","","",null,null],[12,"impling_types","","",5,null],[3,"AnonymousParameters","","Checks for use of anonymous parameters (RFC 1685)",null,null],[3,"DeprecatedAttr","","Checks for use of attributes which have been deprecated.",null,null],[12,"depr_attrs","","",6,null],[3,"UnusedDocComment","","",null,null],[3,"UnconditionalRecursion","","",null,null],[3,"PluginAsLibrary","","",null,null],[3,"InvalidNoMangleItems","","",null,null],[3,"MutableTransmutes","","",null,null],[3,"UnstableFeatures","","Forbids using the `#[feature(...)]` attribute",null,null],[3,"UnionsWithDropFields","","Lint for unions that contain fields with possibly non-trivial destructors.",null,null],[3,"UnreachablePub","","Lint for items marked `pub` that aren't reachable from other crates",null,null],[3,"TypeAliasBounds","","Lint for trait and lifetime bounds in type aliases being mostly ignored: They are relevant when using associated types, but otherwise neither checked at definition site nor enforced at use site.",null,null],[3,"UnusedBrokenConst","","Lint constants that are erroneous. Without this lint, we might not get any diagnostic if the constant is unused within this crate, even though downstream crates can't use it without producing an error.",null,null],[3,"UnusedBrokenConstVisitor","","",null,null],[12,"0","","",7,null],[5,"check_const","","",null,{"inputs":[{"name":"latecontext"},{"name":"bodyid"},{"name":"str"}],"output":null}],[7,"WHILE_TRUE","","",null,null],[7,"BOX_POINTERS","","",null,null],[7,"NON_SHORTHAND_FIELD_PATTERNS","","",null,null],[7,"UNSAFE_CODE","","",null,null],[7,"MISSING_DOCS","","",null,null],[7,"MISSING_COPY_IMPLEMENTATIONS","","",null,null],[7,"MISSING_DEBUG_IMPLEMENTATIONS","","",null,null],[7,"ANONYMOUS_PARAMETERS","","",null,null],[7,"UNUSED_DOC_COMMENTS","","",null,null],[7,"UNCONDITIONAL_RECURSION","","",null,null],[7,"PLUGIN_AS_LIBRARY","","",null,null],[7,"PRIVATE_NO_MANGLE_FNS","","",null,null],[7,"PRIVATE_NO_MANGLE_STATICS","","",null,null],[7,"NO_MANGLE_CONST_ITEMS","","",null,null],[7,"NO_MANGLE_GENERIC_ITEMS","","",null,null],[7,"MUTABLE_TRANSMUTES","","",null,null],[7,"UNSTABLE_FEATURES","","",null,null],[7,"UNIONS_WITH_DROP_FIELDS","","",null,null],[7,"UNREACHABLE_PUB","","",null,null],[7,"TYPE_ALIAS_BOUNDS","","",null,null],[11,"clone","","",8,{"inputs":[{"name":"self"}],"output":{"name":"whiletrue"}}],[11,"get_lints","","",8,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_expr","","",8,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"boxpointers"}}],[11,"check_heap_type","","",9,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"span"},{"name":"ty"}],"output":null}],[11,"get_lints","","",9,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",9,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_expr","","",9,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"nonshorthandfieldpatterns"}}],[11,"get_lints","","",10,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_pat","","",10,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"pat"}],"output":null}],[11,"clone","","",11,{"inputs":[{"name":"self"}],"output":{"name":"unsafecode"}}],[11,"get_lints","","",11,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"report_unsafe","","",11,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"span"},{"name":"str"}],"output":null}],[11,"check_expr","","",11,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"check_item","","",11,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_fn","","",11,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"body"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_trait_item","","",11,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"traititem"}],"output":null}],[11,"new","","",4,{"inputs":[],"output":{"name":"missingdoc"}}],[11,"doc_hidden","","",4,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"check_missing_docs_attrs","","",4,null],[11,"get_lints","","",4,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"enter_lint_attrs","","",4,null],[11,"exit_lint_attrs","","",4,null],[11,"check_crate","","",4,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"crate"}],"output":null}],[11,"check_item","","",4,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_trait_item","","",4,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"traititem"}],"output":null}],[11,"check_impl_item","","",4,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"implitem"}],"output":null}],[11,"check_struct_field","","",4,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"structfield"}],"output":null}],[11,"check_variant","","",4,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"clone","","",12,{"inputs":[{"name":"self"}],"output":{"name":"missingcopyimplementations"}}],[11,"get_lints","","",12,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",12,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"new","","",5,{"inputs":[],"output":{"name":"missingdebugimplementations"}}],[11,"get_lints","","",5,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",5,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"anonymousparameters"}}],[11,"get_lints","","",13,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_trait_item","","",13,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"traititem"}],"output":null}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"deprecatedattr"}}],[11,"new","","",6,{"inputs":[],"output":{"name":"deprecatedattr"}}],[11,"get_lints","","",6,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_attribute","","",6,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"attribute"}],"output":null}],[11,"clone","","",14,{"inputs":[{"name":"self"}],"output":{"name":"unuseddoccomment"}}],[11,"get_lints","","",14,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"warn_if_doc","","",14,{"inputs":[{"name":"self"},{"name":"i"},{"name":"c"}],"output":null}],[11,"check_local","","",14,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"local"}],"output":null}],[11,"check_arm","","",14,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"arm"}],"output":null}],[11,"check_expr","","",14,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"expr"}],"output":null}],[11,"clone","","",15,{"inputs":[{"name":"self"}],"output":{"name":"unconditionalrecursion"}}],[11,"get_lints","","",15,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_fn","","",15,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"fnkind"},{"name":"fndecl"},{"name":"body"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"clone","","",16,{"inputs":[{"name":"self"}],"output":{"name":"pluginaslibrary"}}],[11,"get_lints","","",16,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",16,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"clone","","",17,{"inputs":[{"name":"self"}],"output":{"name":"invalidnomangleitems"}}],[11,"get_lints","","",17,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",17,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"clone","","",18,{"inputs":[{"name":"self"}],"output":{"name":"mutabletransmutes"}}],[11,"get_lints","","",18,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_expr","","",18,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"unstablefeatures"}}],[11,"get_lints","","",19,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_attribute","","",19,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"attribute"}],"output":null}],[11,"get_lints","","",20,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",20,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"get_lints","","",21,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"perform_lint","","",21,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"str"},{"name":"nodeid"},{"name":"visibility"},{"name":"span"},{"name":"bool"}],"output":null}],[11,"check_item","","",21,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"check_foreign_item","","",21,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"foreignitem"}],"output":null}],[11,"check_struct_field","","",21,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"structfield"}],"output":null}],[11,"check_impl_item","","",21,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"implitem"}],"output":null}],[11,"get_lints","","",22,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"is_type_variable_assoc","","",22,{"inputs":[{"name":"qpath"}],"output":{"name":"bool"}}],[11,"suggest_changing_assoc_types","","",22,{"inputs":[{"name":"ty"},{"name":"diagnosticbuilder"}],"output":null}],[11,"check_item","","",22,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"get_lints","","",23,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"visit_nested_body","","",7,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"nested_visit_map","","",7,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"check_item","","",23,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[0,"types","rustc_lint","",null,null],[3,"TypeLimits","rustc_lint::types","",null,null],[12,"negated_expr_id","","Id of the last visited negated expression",24,null],[3,"ImproperCTypesVisitor","","",null,null],[12,"cx","","",25,null],[3,"ImproperCTypes","","",null,null],[3,"VariantSizeDifferences","","",null,null],[4,"FfiResult","","",null,null],[13,"FfiSafe","","",26,null],[13,"FfiPhantom","","",26,null],[13,"FfiUnsafe","","",26,null],[12,"ty","rustc_lint::types::FfiResult","",26,null],[12,"reason","","",26,null],[12,"help","","",26,null],[5,"is_repr_nullable_ptr","rustc_lint::types","Check if this enum can be safely exported based on the \"nullable pointer optimization\". Currently restricted to function pointers and references, but could be expanded to cover NonZero raw pointers and newtypes. FIXME: This duplicates code in trans.",null,{"inputs":[{"name":"tyctxt"},{"name":"adtdef"},{"name":"substs"}],"output":{"name":"bool"}}],[7,"UNUSED_COMPARISONS","","",null,null],[7,"OVERFLOWING_LITERALS","","",null,null],[7,"VARIANT_SIZE_DIFFERENCES","","",null,null],[7,"IMPROPER_CTYPES","","",null,null],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"typelimits"}}],[11,"new","","",24,{"inputs":[],"output":{"name":"typelimits"}}],[11,"get_lints","","",24,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_expr","","",24,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}],[11,"check_type_for_ffi","","Check if the given type is \"ffi-safe\" (has a stable, well-defined representation which can be exported to C code).",25,{"inputs":[{"name":"self"},{"name":"fxhashset"},{"name":"ty"}],"output":{"name":"ffiresult"}}],[11,"check_type_for_ffi_and_report_errors","","",25,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":null}],[11,"check_foreign_fn","","",25,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"fndecl"}],"output":null}],[11,"check_foreign_static","","",25,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"clone","","",27,{"inputs":[{"name":"self"}],"output":{"name":"improperctypes"}}],[11,"get_lints","","",27,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",27,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[11,"get_lints","","",28,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",28,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"item"}],"output":null}],[0,"unused","rustc_lint","",null,null],[3,"UnusedResults","rustc_lint::unused","",null,null],[3,"PathStatements","","",null,null],[3,"UnusedAttributes","","",null,null],[3,"UnusedParens","","",null,null],[3,"UnusedImportBraces","","",null,null],[3,"UnusedAllocation","","",null,null],[7,"UNUSED_MUST_USE","","",null,null],[7,"UNUSED_RESULTS","","",null,null],[7,"PATH_STATEMENTS","","",null,null],[7,"UNUSED_ATTRIBUTES","","",null,null],[7,"UNUSED_PARENS","","",null,null],[7,"UNUSED_IMPORT_BRACES","","",null,null],[7,"UNUSED_ALLOCATION","","",null,null],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"unusedresults"}}],[11,"get_lints","","",29,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_stmt","","",29,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"stmt"}],"output":null}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"pathstatements"}}],[11,"get_lints","","",30,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_stmt","","",30,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"stmt"}],"output":null}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"unusedattributes"}}],[11,"get_lints","","",31,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_attribute","","",31,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"attribute"}],"output":null}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"unusedparens"}}],[11,"check_unused_parens_core","","",32,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"expr"},{"name":"str"},{"name":"bool"}],"output":null}],[11,"get_lints","","",32,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_expr","","",32,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"expr"}],"output":null}],[11,"check_stmt","","",32,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"stmt"}],"output":null}],[11,"clone","","",33,{"inputs":[{"name":"self"}],"output":{"name":"unusedimportbraces"}}],[11,"check_use_tree","","",33,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"usetree"},{"name":"item"}],"output":null}],[11,"get_lints","","",33,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_item","","",33,{"inputs":[{"name":"self"},{"name":"earlycontext"},{"name":"item"}],"output":null}],[11,"clone","","",34,{"inputs":[{"name":"self"}],"output":{"name":"unusedallocation"}}],[11,"get_lints","","",34,{"inputs":[{"name":"self"}],"output":{"name":"lintarray"}}],[11,"check_expr","","",34,{"inputs":[{"name":"self"},{"name":"latecontext"},{"name":"expr"}],"output":null}]],"paths":[[4,"MethodLateContext"],[3,"NonCamelCaseTypes"],[3,"NonSnakeCase"],[3,"NonUpperCaseGlobals"],[3,"MissingDoc"],[3,"MissingDebugImplementations"],[3,"DeprecatedAttr"],[3,"UnusedBrokenConstVisitor"],[3,"WhileTrue"],[3,"BoxPointers"],[3,"NonShorthandFieldPatterns"],[3,"UnsafeCode"],[3,"MissingCopyImplementations"],[3,"AnonymousParameters"],[3,"UnusedDocComment"],[3,"UnconditionalRecursion"],[3,"PluginAsLibrary"],[3,"InvalidNoMangleItems"],[3,"MutableTransmutes"],[3,"UnstableFeatures"],[3,"UnionsWithDropFields"],[3,"UnreachablePub"],[3,"TypeAliasBounds"],[3,"UnusedBrokenConst"],[3,"TypeLimits"],[3,"ImproperCTypesVisitor"],[4,"FfiResult"],[3,"ImproperCTypes"],[3,"VariantSizeDifferences"],[3,"UnusedResults"],[3,"PathStatements"],[3,"UnusedAttributes"],[3,"UnusedParens"],[3,"UnusedImportBraces"],[3,"UnusedAllocation"]]};
searchIndex["rustc_metadata"] = {"doc":"","items":[[0,"diagnostics","rustc_metadata","",null,null],[0,"__register_diagnostic_E0454","rustc_metadata::diagnostics","",null,null],[0,"__register_diagnostic_E0455","","",null,null],[0,"__register_diagnostic_E0458","","",null,null],[0,"__register_diagnostic_E0459","","",null,null],[0,"__register_diagnostic_E0463","","",null,null],[0,"__register_diagnostic_E0456","","",null,null],[0,"__register_diagnostic_E0457","","",null,null],[0,"__register_diagnostic_E0514","","",null,null],[0,"__register_diagnostic_E0460","","",null,null],[0,"__register_diagnostic_E0461","","",null,null],[0,"__register_diagnostic_E0462","","",null,null],[0,"__register_diagnostic_E0464","","",null,null],[0,"__register_diagnostic_E0465","","",null,null],[0,"__register_diagnostic_E0519","","",null,null],[0,"__register_diagnostic_E0523","","",null,null],[0,"index_builder","rustc_metadata","Builder types for generating the \"item data\" section of the metadata. This section winds up looking like this:",null,null],[3,"IndexBuilder","rustc_metadata::index_builder","Builder that can encode new items, adding them into the index. Item encoding cannot be nested.",null,null],[12,"items","","",0,null],[12,"ecx","","",0,null],[3,"Untracked","","Leaks access to a value of type T without any tracking. This is suitable for ambiguous types like `usize`, which could represent tracked data (e.g., if you read it out of a HIR node) or might not (e.g., if it's an index). Adding in an `Untracked` is an assertion, essentially, that the data does not need to be tracked (or that read edges will be added by some other way).",null,null],[12,"0","","",1,null],[3,"FromId","","Newtype that can be used to package up misc data extracted from a HIR node that doesn't carry its own id. This will allow an arbitrary `T` to be passed in, but register a read on the given node-id.",null,null],[12,"0","","",2,null],[12,"1","","",2,null],[8,"DepGraphRead","","Trait used for data that can be passed from outside a dep-graph task.  The data must either be of some safe type, such as a `DefId` index, or implement the `read` method so that it can add a read of whatever dep-graph nodes are appropriate.",null,null],[10,"read","","",3,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":null}],[11,"deref","","",0,null],[11,"deref_mut","","",0,null],[11,"new","","",0,{"inputs":[{"name":"encodecontext"}],"output":{"name":"self"}}],[11,"record","","Emit the data for a def-id to the metadata. The function to emit the data is `op`, and it will be given `data` as arguments. This `record` function will call `op` to generate the `Entry` (which may point to other encoded information) and will then record the `Lazy<Entry>` for use in the index.",0,null],[11,"into_items","","",0,{"inputs":[{"name":"self"}],"output":{"name":"index"}}],[11,"read","","",1,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":null}],[11,"read","","",2,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":null}],[0,"index","rustc_metadata","",null,null],[3,"Index","rustc_metadata::index","While we are generating the metadata, we also track the position of each DefIndex. It is not required that all definitions appear in the metadata, nor that they are serialized in order, and therefore we first allocate the vector here and fill it with `u32::MAX`. Whenever an index is visited, we fill in the appropriate spot by calling `record_position`. We should never visit the same index twice.",null,null],[12,"positions","","",4,null],[3,"Unaligned","","",null,null],[12,"0","","",5,null],[5,"bytes_to_words","","",null,null],[5,"words_to_bytes","","",null,null],[11,"new","","",4,null],[11,"record","","",4,{"inputs":[{"name":"self"},{"name":"defid"},{"generics":["entry"],"name":"lazy"}],"output":null}],[11,"record_index","","",4,{"inputs":[{"name":"self"},{"name":"defindex"},{"generics":["entry"],"name":"lazy"}],"output":null}],[11,"write_index","","",4,{"inputs":[{"name":"self"},{"name":"cursor"}],"output":{"generics":["index"],"name":"lazyseq"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"get","","",5,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[0,"encoder","rustc_metadata","",null,null],[3,"EncodeContext","rustc_metadata::encoder","",null,null],[12,"opaque","","",6,null],[12,"tcx","","",6,null],[12,"link_meta","","",6,null],[12,"lazy_state","","",6,null],[12,"type_shorthands","","",6,null],[12,"predicate_shorthands","","",6,null],[12,"interpret_allocs","","",6,null],[12,"interpret_allocs_inverse","","",6,null],[12,"filemap_cache","","",6,null],[3,"EncodeVisitor","","",null,null],[12,"index","","",7,null],[3,"ImplVisitor","","",null,null],[12,"tcx","","",8,null],[12,"impls","","",8,null],[5,"encode_metadata","","",null,{"inputs":[{"name":"tyctxt"},{"name":"linkmeta"}],"output":{"name":"encodedmetadata"}}],[5,"get_repr_options","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"reproptions"}}],[11,"emit_nil","","",6,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"emit_usize","","",6,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"emit_u128","","",6,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"result"}}],[11,"emit_u64","","",6,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"result"}}],[11,"emit_u32","","",6,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"result"}}],[11,"emit_u16","","",6,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"result"}}],[11,"emit_u8","","",6,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"result"}}],[11,"emit_isize","","",6,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"result"}}],[11,"emit_i128","","",6,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"result"}}],[11,"emit_i64","","",6,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"result"}}],[11,"emit_i32","","",6,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"result"}}],[11,"emit_i16","","",6,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"result"}}],[11,"emit_i8","","",6,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"result"}}],[11,"emit_bool","","",6,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"result"}}],[11,"emit_f64","","",6,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"result"}}],[11,"emit_f32","","",6,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"result"}}],[11,"emit_char","","",6,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"result"}}],[11,"emit_str","","",6,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"lazy"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"lazyseq"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"localdefid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"genericpredicates"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"fingerprint"}],"output":{"name":"result"}}],[11,"specialized_encode","","",6,{"inputs":[{"name":"self"},{"name":"clearcrosscrate"}],"output":{"name":"result"}}],[11,"position","","",6,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"emit_node","","",6,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"emit_lazy_distance","","",6,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"result"}}],[11,"lazy","","",6,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"lazy"}}],[11,"lazy_seq","","",6,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"lazyseq"}}],[11,"lazy_seq_ref","","",6,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"lazyseq"}}],[11,"tracked","","",6,null],[11,"encode_info_for_items","","",6,{"inputs":[{"name":"self"}],"output":{"name":"index"}}],[11,"encode_def_path_table","","",6,{"inputs":[{"name":"self"}],"output":{"generics":["defpathtable"],"name":"lazy"}}],[11,"encode_codemap","","",6,{"inputs":[{"name":"self"}],"output":{"generics":["filemap"],"name":"lazyseq"}}],[11,"encode_crate_root","","",6,{"inputs":[{"name":"self"}],"output":{"generics":["crateroot"],"name":"lazy"}}],[11,"nested_visit_map","","",7,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_expr","","",7,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_item","","",7,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",7,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_variant","","",7,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_generics","","",7,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_ty","","",7,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_macro_def","","",7,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"encode_fields","rustc_metadata::index_builder","",0,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"encode_info_for_generics","","",0,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"encode_info_for_ty","","",0,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"encode_info_for_expr","","",0,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"encode_addl_info_for_item","","In some cases, along with the item itself, we also encode some sub-items. Usually we want some info from the item so it's easier to do that here then to wait until we would encounter normally in the visitor walk.",0,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_item","rustc_metadata::encoder","",8,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",8,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",8,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"decoder","rustc_metadata","",null,null],[3,"DecodeContext","rustc_metadata::decoder","",null,null],[12,"opaque","","",9,null],[12,"cdata","","",9,null],[12,"sess","","",9,null],[12,"tcx","","",9,null],[12,"last_filemap_index","","",9,null],[12,"lazy_state","","",9,null],[12,"interpret_alloc_cache","","",9,null],[12,"interpret_alloc_index","","",9,null],[0,"__ty_decoder_impl","","",null,null],[11,"read_nil","","",9,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"read_u128","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"result"}}],[11,"read_u64","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"result"}}],[11,"read_u32","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["u32"],"name":"result"}}],[11,"read_u16","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["u16"],"name":"result"}}],[11,"read_u8","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"result"}}],[11,"read_usize","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"result"}}],[11,"read_i128","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"result"}}],[11,"read_i64","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"result"}}],[11,"read_i32","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"result"}}],[11,"read_i16","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["i16"],"name":"result"}}],[11,"read_i8","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["i8"],"name":"result"}}],[11,"read_isize","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["isize"],"name":"result"}}],[11,"read_bool","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[11,"read_f64","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"result"}}],[11,"read_f32","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["f32"],"name":"result"}}],[11,"read_char","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"result"}}],[11,"read_str","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"result"}}],[11,"error","","",9,null],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["genericpredicates"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["substs"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["region"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["slice"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["adtdef"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["slice"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["canonicalvarinfos"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["const"],"name":"result"}}],[8,"Metadata","","Abstract over the various ways one can create metadata decoders.",null,null],[10,"raw_bytes","","",10,null],[11,"cdata","","",10,{"inputs":[{"name":"self"}],"output":{"generics":["cratemetadata"],"name":"option"}}],[11,"sess","","",10,{"inputs":[{"name":"self"}],"output":{"generics":["session"],"name":"option"}}],[11,"tcx","","",10,{"inputs":[{"name":"self"}],"output":{"generics":["tyctxt"],"name":"option"}}],[11,"decoder","","",10,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"decodecontext"}}],[11,"tcx","","",9,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"cdata","","",9,{"inputs":[{"name":"self"}],"output":{"name":"cratemetadata"}}],[11,"read_lazy_distance","","",9,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["usize"],"name":"result"}}],[11,"interpret_alloc","","",9,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"tcx","","",9,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"peek_byte","","",9,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"position","","",9,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"cached_ty_for_shorthand","","",9,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"generics":["ty"],"name":"result"}}],[11,"with_position","","",9,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[11,"map_encoded_cnum_to_current","","",9,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratenum"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["lazy"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["lazyseq"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["defindex"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["localdefid"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["allocid"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["fingerprint"],"name":"result"}}],[11,"specialized_decode","","",9,{"inputs":[{"name":"self"}],"output":{"generics":["clearcrosscrate"],"name":"result"}}],[0,"cstore_impl","rustc_metadata","",null,null],[5,"provide_extern","rustc_metadata::cstore_impl","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[8,"IntoArgs","","",null,null],[10,"into_args","","",11,null],[0,"isolated_encoder","rustc_metadata","",null,null],[3,"IsolatedEncoder","rustc_metadata::isolated_encoder","The IsolatedEncoder provides facilities to write to crate metadata while making sure that anything going through it is also feed into an ICH hasher.",null,null],[12,"tcx","","",12,null],[12,"ecx","","",12,null],[11,"new","","",12,{"inputs":[{"name":"encodecontext"}],"output":{"name":"self"}}],[11,"lazy","","",12,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"lazy"}}],[11,"lazy_seq","","",12,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"lazyseq"}}],[11,"lazy_seq_ref","","",12,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"lazyseq"}}],[11,"lazy_seq_from_slice","","",12,null],[0,"schema","rustc_metadata","",null,null],[3,"Lazy","rustc_metadata::schema","A value of type T referred to by its absolute position in the metadata, and which can be decoded lazily.",null,null],[12,"position","","",13,null],[12,"_marker","","",13,null],[3,"LazySeq","","A sequence of type T referred to by its absolute position in the metadata and length, and which can be decoded lazily. The sequence is a single node for the purposes of `Lazy`.",null,null],[12,"len","","",14,null],[12,"position","","",14,null],[12,"_marker","","",14,null],[3,"CrateRoot","","",null,null],[12,"name","","",15,null],[12,"triple","","",15,null],[12,"extra_filename","","",15,null],[12,"hash","","",15,null],[12,"disambiguator","","",15,null],[12,"panic_strategy","","",15,null],[12,"has_global_allocator","","",15,null],[12,"has_default_lib_allocator","","",15,null],[12,"plugin_registrar_fn","","",15,null],[12,"macro_derive_registrar","","",15,null],[12,"crate_deps","","",15,null],[12,"dylib_dependency_formats","","",15,null],[12,"lang_items","","",15,null],[12,"lang_items_missing","","",15,null],[12,"native_libraries","","",15,null],[12,"foreign_modules","","",15,null],[12,"codemap","","",15,null],[12,"def_path_table","","",15,null],[12,"impls","","",15,null],[12,"exported_symbols","","",15,null],[12,"wasm_custom_sections","","",15,null],[12,"interpret_alloc_index","","",15,null],[12,"index","","",15,null],[3,"CrateDep","","",null,null],[12,"name","","",16,null],[12,"hash","","",16,null],[12,"kind","","",16,null],[12,"extra_filename","","",16,null],[3,"TraitImpls","","",null,null],[12,"trait_id","","",17,null],[12,"impls","","",17,null],[3,"Entry","","",null,null],[12,"kind","","",18,null],[12,"visibility","","",18,null],[12,"span","","",18,null],[12,"attributes","","",18,null],[12,"children","","",18,null],[12,"stability","","",18,null],[12,"deprecation","","",18,null],[12,"ty","","",18,null],[12,"inherent_impls","","",18,null],[12,"variances","","",18,null],[12,"generics","","",18,null],[12,"predicates","","",18,null],[12,"mir","","",18,null],[3,"ConstQualif","","Additional data for EntryKind::Const and EntryKind::AssociatedConst",null,null],[12,"mir","","",19,null],[12,"ast_promotable","","",19,null],[3,"RenderedConst","","Contains a constant which has been rendered to a String. Used by rustdoc.",null,null],[12,"0","","",20,null],[3,"ModData","","",null,null],[12,"reexports","","",21,null],[3,"MacroDef","","",null,null],[12,"body","","",22,null],[12,"legacy","","",22,null],[3,"FnData","","",null,null],[12,"constness","","",23,null],[12,"arg_names","","",23,null],[12,"sig","","",23,null],[3,"VariantData","","",null,null],[12,"ctor_kind","","",24,null],[12,"discr","","",24,null],[12,"struct_ctor","","If this is a struct's only variant, this is the index of the \"struct ctor\" item.",24,null],[12,"ctor_sig","","If this is a tuple struct or variant ctor, this is its \"function\" signature.",24,null],[3,"TraitData","","",null,null],[12,"unsafety","","",25,null],[12,"paren_sugar","","",25,null],[12,"has_auto_impl","","",25,null],[12,"super_predicates","","",25,null],[3,"ImplData","","",null,null],[12,"polarity","","",26,null],[12,"defaultness","","",26,null],[12,"parent_impl","","",26,null],[12,"coerce_unsized_info","","This is `Some` only for impls of `CoerceUnsized`.",26,null],[12,"trait_ref","","",26,null],[3,"MethodData","","",null,null],[12,"fn_data","","",27,null],[12,"container","","",27,null],[12,"has_self","","",27,null],[3,"ClosureData","","",null,null],[12,"sig","","",28,null],[3,"GeneratorData","","",null,null],[12,"layout","","",29,null],[3,"EncodedExportedSymbols","","",null,null],[12,"position","","",30,null],[12,"len","","",30,null],[4,"LazyState","","Encoding / decoding state for `Lazy` and `LazySeq`.",null,null],[13,"NoNode","","Outside of a metadata node.",31,null],[13,"NodeStart","","Inside a metadata node, and before any `Lazy` or `LazySeq`. The position is that of the node itself.",31,null],[13,"Previous","","Inside a metadata node, with a previous `Lazy` or `LazySeq`. The position is a conservative estimate of where that previous `Lazy` / `LazySeq` would end (see their comments).",31,null],[4,"EntryKind","","",null,null],[13,"Const","","",32,null],[13,"ImmStatic","","",32,null],[13,"MutStatic","","",32,null],[13,"ForeignImmStatic","","",32,null],[13,"ForeignMutStatic","","",32,null],[13,"ForeignMod","","",32,null],[13,"ForeignType","","",32,null],[13,"GlobalAsm","","",32,null],[13,"Type","","",32,null],[13,"Enum","","",32,null],[13,"Field","","",32,null],[13,"Variant","","",32,null],[13,"Struct","","",32,null],[13,"Union","","",32,null],[13,"Fn","","",32,null],[13,"ForeignFn","","",32,null],[13,"Mod","","",32,null],[13,"MacroDef","","",32,null],[13,"Closure","","",32,null],[13,"Generator","","",32,null],[13,"Trait","","",32,null],[13,"Impl","","",32,null],[13,"Method","","",32,null],[13,"AssociatedType","","",32,null],[13,"AssociatedConst","","",32,null],[4,"AssociatedContainer","","Describes whether the container of an associated item is a trait or an impl and whether, in a trait, it has a default, or an in impl, whether it's marked \"default\".",null,null],[13,"TraitRequired","","",33,null],[13,"TraitWithDefault","","",33,null],[13,"ImplDefault","","",33,null],[13,"ImplFinal","","",33,null],[5,"rustc_version","","",null,{"inputs":[],"output":{"name":"string"}}],[17,"METADATA_VERSION","","Metadata encoding version. NB: increment this if you change the format of metadata such that the rustc version can't be found to compare with `rustc_version()`.",null,null],[17,"METADATA_HEADER","","Metadata header which includes `METADATA_VERSION`. To get older versions of rustc to ignore this metadata, there are 4 zero bytes at the start, which are treated as a length of 0 by old compilers.",null,null],[17,"TAG_VALID_SPAN","","",null,null],[17,"TAG_INVALID_SPAN","","",null,null],[11,"with_position","","",13,{"inputs":[{"name":"usize"}],"output":{"name":"lazy"}}],[11,"min_size","","Returns the minimum encoded size of a value of type `T`.",13,{"inputs":[],"output":{"name":"usize"}}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"hash_stable","","",13,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"empty","","",14,{"inputs":[],"output":{"name":"lazyseq"}}],[11,"with_position_and_length","","",14,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"lazyseq"}}],[11,"min_size","","Returns the minimum encoded size of `length` values of type `T`.",14,{"inputs":[{"name":"usize"}],"output":{"name":"usize"}}],[11,"clone","","",14,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"hash_stable","","",14,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"lazystate"}}],[11,"eq","","",31,{"inputs":[{"name":"self"},{"name":"lazystate"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"self"},{"name":"lazystate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",31,null],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",15,{"inputs":[{"name":"__d"}],"output":{"generics":["crateroot"],"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"__d"}],"output":{"generics":["cratedep"],"name":"result"}}],[11,"hash_stable","","",16,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",17,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"__d"}],"output":{"generics":["traitimpls"],"name":"result"}}],[11,"hash_stable","","",17,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",18,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",18,{"inputs":[{"name":"__d"}],"output":{"generics":["entry"],"name":"result"}}],[11,"hash_stable","","",18,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"entrykind"}}],[11,"encode","","",32,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",32,{"inputs":[{"name":"__d"}],"output":{"generics":["entrykind"],"name":"result"}}],[11,"hash_stable","","",32,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"constqualif"}}],[11,"encode","","",19,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"__d"}],"output":{"generics":["constqualif"],"name":"result"}}],[11,"hash_stable","","",19,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",20,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",20,{"inputs":[{"name":"__d"}],"output":{"generics":["renderedconst"],"name":"result"}}],[11,"hash_stable","","",20,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",21,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",21,{"inputs":[{"name":"__d"}],"output":{"generics":["moddata"],"name":"result"}}],[11,"hash_stable","","",21,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",22,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",22,{"inputs":[{"name":"__d"}],"output":{"generics":["macrodef"],"name":"result"}}],[11,"hash_stable","","",22,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",23,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"__d"}],"output":{"generics":["fndata"],"name":"result"}}],[11,"hash_stable","","",23,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",24,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"__d"}],"output":{"generics":["variantdata"],"name":"result"}}],[11,"hash_stable","","",24,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",25,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",25,{"inputs":[{"name":"__d"}],"output":{"generics":["traitdata"],"name":"result"}}],[11,"hash_stable","","",25,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",26,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",26,{"inputs":[{"name":"__d"}],"output":{"generics":["impldata"],"name":"result"}}],[11,"hash_stable","","",26,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"clone","","",33,{"inputs":[{"name":"self"}],"output":{"name":"associatedcontainer"}}],[11,"encode","","",33,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",33,{"inputs":[{"name":"__d"}],"output":{"generics":["associatedcontainer"],"name":"result"}}],[11,"hash_stable","","",33,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"with_def_id","","",33,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"associateditemcontainer"}}],[11,"defaultness","","",33,{"inputs":[{"name":"self"}],"output":{"name":"defaultness"}}],[11,"encode","","",27,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",27,{"inputs":[{"name":"__d"}],"output":{"generics":["methoddata"],"name":"result"}}],[11,"hash_stable","","",27,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",28,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",28,{"inputs":[{"name":"__d"}],"output":{"generics":["closuredata"],"name":"result"}}],[11,"hash_stable","","",28,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",29,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",29,{"inputs":[{"name":"__d"}],"output":{"generics":["generatordata"],"name":"result"}}],[11,"hash_stable","","",29,{"inputs":[{"name":"self"},{"name":"stablehashingcontext"},{"name":"stablehasher"}],"output":null}],[11,"encode","","",30,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",30,{"inputs":[{"name":"__d"}],"output":{"generics":["encodedexportedsymbols"],"name":"result"}}],[0,"native_libs","rustc_metadata","",null,null],[3,"Collector","rustc_metadata::native_libs","",null,null],[12,"tcx","","",34,null],[12,"libs","","",34,null],[5,"collect","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["nativelibrary"],"name":"vec"}}],[5,"relevant_lib","","",null,{"inputs":[{"name":"session"},{"name":"nativelibrary"}],"output":{"name":"bool"}}],[11,"visit_item","","",34,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",34,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",34,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"register_native_lib","","",34,{"inputs":[{"name":"self"},{"generics":["span"],"name":"option"},{"name":"nativelibrary"}],"output":null}],[11,"process_command_line","","",34,{"inputs":[{"name":"self"}],"output":null}],[0,"link_args","rustc_metadata","",null,null],[3,"Collector","rustc_metadata::link_args","",null,null],[12,"args","","",35,null],[5,"collect","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["string"],"name":"vec"}}],[11,"visit_item","","",35,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",35,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",35,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"add_link_args","","",35,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[0,"foreign_modules","rustc_metadata","",null,null],[3,"Collector","rustc_metadata::foreign_modules","",null,null],[12,"tcx","","",36,null],[12,"modules","","",36,null],[5,"collect","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["foreignmodule"],"name":"vec"}}],[11,"visit_item","","",36,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",36,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",36,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"creader","rustc_metadata","Validates all used crates and extern libraries and loads their metadata",null,null],[3,"Library","rustc_metadata::creader","",null,null],[12,"dylib","","",37,null],[12,"rlib","","",37,null],[12,"rmeta","","",37,null],[12,"metadata","","",37,null],[3,"CrateLoader","","",null,null],[12,"sess","","",38,null],[12,"cstore","","",38,null],[12,"next_crate_num","","",38,null],[12,"local_crate_name","","",38,null],[3,"ExtensionCrate","","",null,null],[12,"metadata","","",39,null],[12,"dylib","","",39,null],[12,"target_only","","",39,null],[4,"PMDSource","","",null,null],[13,"Registered","","",40,null],[13,"Owned","","",40,null],[4,"LoadResult","","",null,null],[13,"Previous","","",41,null],[13,"Loaded","","",41,null],[5,"dump_crates","","",null,{"inputs":[{"name":"cstore"}],"output":null}],[11,"deref","","",40,{"inputs":[{"name":"self"}],"output":{"name":"metadatablob"}}],[11,"new","","",38,{"inputs":[{"name":"session"},{"name":"cstore"},{"name":"str"}],"output":{"name":"self"}}],[11,"existing_match","","",38,{"inputs":[{"name":"self"},{"name":"symbol"},{"generics":["svh"],"name":"option"},{"name":"pathkind"}],"output":{"generics":["cratenum"],"name":"option"}}],[11,"verify_no_symbol_conflicts","","",38,{"inputs":[{"name":"self"},{"name":"span"},{"name":"crateroot"}],"output":null}],[11,"register_crate","","",38,null],[11,"resolve_crate","","",38,null],[11,"load","","",38,{"inputs":[{"name":"self"},{"name":"context"}],"output":{"generics":["loadresult"],"name":"option"}}],[11,"update_extern_crate","","",38,{"inputs":[{"name":"self"},{"name":"cratenum"},{"name":"externcrate"},{"name":"fxhashset"}],"output":null}],[11,"resolve_crate_deps","","",38,{"inputs":[{"name":"self"},{"name":"option"},{"name":"crateroot"},{"name":"metadatablob"},{"name":"cratenum"},{"name":"span"},{"name":"depkind"}],"output":{"name":"cratenummap"}}],[11,"read_extension_crate","","",38,{"inputs":[{"name":"self"},{"name":"span"},{"name":"symbol"},{"name":"symbol"}],"output":{"name":"extensioncrate"}}],[11,"load_derive_macros","","Load custom derive macros.",38,{"inputs":[{"name":"self"},{"name":"crateroot"},{"generics":["pathbuf"],"name":"option"},{"name":"span"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path, crate SVH and DefIndex of the registrar function.",38,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[11,"inject_panic_runtime","","",38,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"inject_sanitizer_runtime","","",38,{"inputs":[{"name":"self"}],"output":null}],[11,"inject_profiler_runtime","","",38,{"inputs":[{"name":"self"}],"output":null}],[11,"inject_allocator_crate","","",38,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"inject_dependency_if","","",38,{"inputs":[{"name":"self"},{"name":"cratenum"},{"name":"str"},{"name":"fn"}],"output":null}],[11,"postprocess","","",38,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"process_extern_crate","","",38,{"inputs":[{"name":"self"},{"name":"item"},{"name":"definitions"}],"output":{"name":"cratenum"}}],[11,"process_path_extern","","",38,{"inputs":[{"name":"self"},{"name":"symbol"},{"name":"span"}],"output":{"name":"cratenum"}}],[11,"process_use_extern","","",38,{"inputs":[{"name":"self"},{"name":"symbol"},{"name":"span"},{"name":"nodeid"},{"name":"definitions"}],"output":{"name":"cratenum"}}],[0,"cstore","rustc_metadata","",null,null],[3,"NativeLibrary","rustc_metadata::cstore","",null,null],[12,"kind","","",42,null],[12,"name","","",42,null],[12,"cfg","","",42,null],[12,"foreign_module","","",42,null],[4,"NativeLibraryKind","","",null,null],[13,"NativeStatic","","native static library (.a archive)",43,null],[13,"NativeStaticNobundle","","native static library, which doesn't get bundled into .rlibs",43,null],[13,"NativeFramework","","macOS-specific",43,null],[13,"NativeUnknown","","default way to specify a dynamic library",43,null],[4,"LinkagePreference","","",null,null],[13,"RequireDynamic","","",44,null],[13,"RequireStatic","","",44,null],[3,"CrateSource","","Where a crate came from on the local filesystem. One of these three options must be non-None.",null,null],[12,"dylib","","",45,null],[12,"rlib","","",45,null],[12,"rmeta","","",45,null],[4,"LibSource","","",null,null],[13,"Some","","",46,null],[13,"MetadataOnly","","",46,null],[13,"None","","",46,null],[3,"ForeignModule","","",null,null],[12,"foreign_items","","",47,null],[12,"def_id","","",47,null],[6,"MetadataRef","","",null,null],[3,"MetadataBlob","","",null,null],[12,"0","","",48,null],[3,"ImportedFileMap","","Holds information about a syntax_pos::FileMap imported from another crate. See `imported_filemaps()` for more information.",null,null],[12,"original_start_pos","","This FileMap's byte-offset within the codemap of its original crate",49,null],[12,"original_end_pos","","The end of this FileMap within the codemap of its original crate",49,null],[12,"translated_filemap","","The imported FileMap's representation within the local codemap",49,null],[3,"CrateMetadata","","",null,null],[12,"name","","",50,null],[12,"extern_crate","","Information about the extern crate that caused this crate to be loaded. If this is `None`, then the crate was injected (e.g., by the allocator)",50,null],[12,"blob","","",50,null],[12,"cnum_map","","",50,null],[12,"cnum","","",50,null],[12,"codemap_import_info","","",50,null],[12,"attribute_cache","","",50,null],[12,"root","","",50,null],[12,"def_path_table","","For each public item in this crate, we encode a key.  When the crate is loaded, we read all the keys and put them in this hashmap, which gives the reverse mapping.  This allows us to quickly retrace a `DefPath`, which is needed for incremental compilation support.",50,null],[12,"trait_impls","","",50,null],[12,"dep_kind","","",50,null],[12,"source","","",50,null],[12,"proc_macros","","",50,null],[3,"CStore","","",null,null],[12,"metas","","",51,null],[12,"extern_mod_crate_map","","Map from NodeId's of local extern crate statements to crate numbers",51,null],[12,"metadata_loader","","",51,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"provide_extern","","",null,{"inputs":[{"name":"providers"}],"output":null}],[6,"CrateNumMap","","",null,null],[11,"new","","",51,{"inputs":[{"generics":["metadataloader"],"name":"box"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","You cannot use this function to allocate a CrateNum in a thread-safe manner. It is currently only used in CrateLoader which is single-threaded code.",51,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"get_crate_data","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratemetadata"],"name":"lrc"}}],[11,"set_crate_data","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"},{"generics":["cratemetadata"],"name":"lrc"}],"output":null}],[11,"iter_crate_data","","",51,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"crate_dependencies_in_rpo","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["cratenum"],"name":"vec"}}],[11,"push_dependencies_in_postorder","","",51,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"cratenum"}],"output":null}],[11,"do_postorder_cnums_untracked","","",51,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[11,"add_extern_mod_stmt_cnum","","",51,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"cratenum"}],"output":null}],[11,"do_extern_mod_stmt_cnum","","",51,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["cratenum"],"name":"option"}}],[11,"name","","",50,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"hash","","",50,{"inputs":[{"name":"self"}],"output":{"name":"svh"}}],[11,"disambiguator","","",50,{"inputs":[{"name":"self"}],"output":{"name":"cratedisambiguator"}}],[11,"needs_allocator","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"has_global_allocator","","",50,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"has_default_lib_allocator","","",50,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_panic_runtime","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"needs_panic_runtime","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"is_compiler_builtins","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"is_sanitizer_runtime","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"is_profiler_runtime","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"is_no_builtins","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"name":"bool"}}],[11,"panic_strategy","","",50,{"inputs":[{"name":"self"}],"output":{"name":"panicstrategy"}}],[0,"dynamic_lib","rustc_metadata","Dynamic library facilities.",null,null],[3,"DynamicLibrary","rustc_metadata::dynamic_lib","",null,null],[12,"handle","","",52,null],[0,"dl","","",null,null],[5,"open","rustc_metadata::dynamic_lib::dl","",null,{"inputs":[{"generics":["osstr"],"name":"option"}],"output":{"generics":["string"],"name":"result"}}],[5,"open_global_now","","",null,{"inputs":[{"name":"osstr"}],"output":{"generics":["string"],"name":"result"}}],[5,"open_external","","",null,null],[5,"open_internal","","",null,null],[5,"check_for_errors_in","","",null,{"inputs":[{"name":"f"}],"output":{"generics":["string"],"name":"result"}}],[5,"symbol","","",null,null],[5,"close","","",null,null],[11,"drop","rustc_metadata::dynamic_lib","",52,{"inputs":[{"name":"self"}],"output":null}],[11,"open","","Lazily open a dynamic library. When passed None it gives a handle to the calling process",52,{"inputs":[{"generics":["path"],"name":"option"}],"output":{"generics":["dynamiclibrary","string"],"name":"result"}}],[11,"open_global_now","","Load a dynamic library into the global namespace (RTLD_GLOBAL on Unix) and do it now (don't use RTLD_LAZY on Unix).",52,{"inputs":[{"name":"path"}],"output":{"generics":["dynamiclibrary","string"],"name":"result"}}],[11,"envvar","","Returns the environment variable for this process's dynamic library search path",52,{"inputs":[],"output":{"name":"str"}}],[11,"symbol","","Accesses the value at the symbol of the dynamic library.",52,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["string"],"name":"result"}}],[0,"locator","rustc_metadata","Finds crate binaries and loads their metadata",null,null],[3,"CrateMismatch","rustc_metadata::locator","",null,null],[12,"path","","",53,null],[12,"got","","",53,null],[3,"Context","","",null,null],[12,"sess","","",54,null],[12,"span","","",54,null],[12,"ident","","",54,null],[12,"crate_name","","",54,null],[12,"hash","","",54,null],[12,"extra_filename","","",54,null],[12,"target","","",54,null],[12,"triple","","",54,null],[12,"filesearch","","",54,null],[12,"root","","",54,null],[12,"rejected_via_hash","","",54,null],[12,"rejected_via_triple","","",54,null],[12,"rejected_via_kind","","",54,null],[12,"rejected_via_version","","",54,null],[12,"rejected_via_filename","","",54,null],[12,"should_match_name","","",54,null],[12,"is_proc_macro","","",54,null],[12,"metadata_loader","","",54,null],[3,"CratePaths","","",null,null],[12,"ident","","",55,null],[12,"dylib","","",55,null],[12,"rlib","","",55,null],[12,"rmeta","","",55,null],[4,"CrateFlavor","","",null,null],[13,"Rlib","","",56,null],[13,"Rmeta","","",56,null],[13,"Dylib","","",56,null],[5,"get_metadata_section","","",null,{"inputs":[{"name":"target"},{"name":"crateflavor"},{"name":"path"},{"name":"metadataloader"}],"output":{"generics":["metadatablob","string"],"name":"result"}}],[5,"get_metadata_section_imp","","",null,{"inputs":[{"name":"target"},{"name":"crateflavor"},{"name":"path"},{"name":"metadataloader"}],"output":{"generics":["metadatablob","string"],"name":"result"}}],[5,"list_file_metadata","","",null,{"inputs":[{"name":"target"},{"name":"path"},{"name":"metadataloader"},{"name":"write"}],"output":{"name":"result"}}],[11,"clone","","",56,{"inputs":[{"name":"self"}],"output":{"name":"crateflavor"}}],[11,"eq","","",56,{"inputs":[{"name":"self"},{"name":"crateflavor"}],"output":{"name":"bool"}}],[11,"fmt","","",56,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"paths","","",55,{"inputs":[{"name":"self"}],"output":{"generics":["pathbuf"],"name":"vec"}}],[11,"maybe_load_library_crate","","",54,{"inputs":[{"name":"self"}],"output":{"generics":["library"],"name":"option"}}],[11,"report_errs","","",54,null],[11,"find_library_crate","","",54,{"inputs":[{"name":"self"},{"name":"str"},{"name":"hashset"}],"output":{"generics":["library"],"name":"option"}}],[11,"extract_one","","",54,{"inputs":[{"name":"self"},{"generics":["pathbuf","pathkind"],"name":"fxhashmap"},{"name":"crateflavor"},{"name":"option"}],"output":{"name":"option"}}],[11,"crate_matches","","",54,{"inputs":[{"name":"self"},{"name":"metadatablob"},{"name":"path"}],"output":{"generics":["svh"],"name":"option"}}],[11,"dylibname","","",54,null],[11,"staticlibname","","",54,null],[11,"find_commandline_library","","",54,{"inputs":[{"name":"self"},{"name":"locs"}],"output":{"generics":["library"],"name":"option"}}],[17,"DIAGNOSTICS","rustc_metadata","",null,null],[11,"lookup","rustc_metadata::schema","Given the metadata, extract out the offset of a particular DefIndex (if any).",14,null],[11,"encode_variances_of","rustc_metadata::isolated_encoder","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["variance"],"name":"lazyseq"}}],[11,"encode_item_type","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["ty"],"name":"lazy"}}],[11,"encode_enum_variant_info","","Encode data for the given variant of the given ADT. The index of the variant is untracked: this is ok because we will have to lookup the adt-def by its id, and that gives us the right to access any information in the adt-def (including, e.g., the length of the various vectors).",12,null],[11,"encode_info_for_mod","","",12,{"inputs":[{"name":"self"},{"name":"fromid"}],"output":{"name":"entry"}}],[11,"encode_field","","Encode data for the given field of the given variant of the given ADT. The indices of the variant/field are untracked: this is ok because we will have to lookup the adt-def by its id, and that gives us the right to access any information in the adt-def (including, e.g., the length of the various vectors).",12,null],[11,"encode_struct_ctor","","",12,null],[11,"encode_generics","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["generics"],"name":"lazy"}}],[11,"encode_predicates","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["genericpredicates"],"name":"lazy"}}],[11,"encode_info_for_trait_item","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"entry"}}],[11,"metadata_output_only","","",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"const_qualif","","",12,{"inputs":[{"name":"self"},{"name":"u8"},{"name":"bodyid"}],"output":{"name":"constqualif"}}],[11,"encode_info_for_impl_item","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"entry"}}],[11,"encode_fn_arg_names_for_body","","",12,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"generics":["name"],"name":"lazyseq"}}],[11,"encode_fn_arg_names","","",12,null],[11,"encode_optimized_mir","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lazy"],"name":"option"}}],[11,"encode_inherent_implementations","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defindex"],"name":"lazyseq"}}],[11,"encode_stability","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lazy"],"name":"option"}}],[11,"encode_deprecation","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["lazy"],"name":"option"}}],[11,"encode_rendered_const_for_body","","",12,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":{"generics":["renderedconst"],"name":"lazy"}}],[11,"encode_info_for_item","","",12,null],[11,"encode_info_for_macro_def","","Serialize the text of exported macros",12,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":{"name":"entry"}}],[11,"encode_info_for_ty_param","","",12,null],[11,"encode_info_for_anon_ty","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"entry"}}],[11,"encode_info_for_closure","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"entry"}}],[11,"encode_info_for_embedded_const","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"entry"}}],[11,"encode_attributes","","",12,null],[11,"encode_native_libraries","","",12,null],[11,"encode_foreign_modules","","",12,null],[11,"encode_crate_deps","","",12,null],[11,"encode_lang_items","","",12,null],[11,"encode_lang_items_missing","","",12,null],[11,"encode_impls","","Encodes an index, mapping each trait to its (local) implementations.",12,null],[11,"encode_exported_symbols","","",12,null],[11,"encode_wasm_custom_sections","","",12,null],[11,"encode_dylib_dependency_formats","","",12,null],[11,"encode_info_for_foreign_item","","",12,null],[11,"decode","rustc_metadata::schema","",13,{"inputs":[{"name":"self"},{"name":"m"}],"output":{"name":"t"}}],[11,"decode","","",14,null],[11,"is_compatible","rustc_metadata::cstore","",48,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"get_rustc_version","","",48,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"get_root","","",48,{"inputs":[{"name":"self"}],"output":{"name":"crateroot"}}],[11,"list_crate_metadata","","",48,{"inputs":[{"name":"self"},{"name":"write"}],"output":{"name":"result"}}],[11,"to_def","rustc_metadata::schema","",32,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["def"],"name":"option"}}],[11,"is_proc_macro","rustc_metadata::cstore","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"maybe_entry","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["lazy"],"name":"option"}}],[11,"entry","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"entry"}}],[11,"local_def_id","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defid"}}],[11,"item_name","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"internedstring"}}],[11,"get_def","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["def"],"name":"option"}}],[11,"get_span","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"session"}],"output":{"name":"span"}}],[11,"get_trait_def","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"session"}],"output":{"name":"traitdef"}}],[11,"get_variant","","",50,{"inputs":[{"name":"self"},{"name":"entry"},{"name":"defindex"}],"output":{"name":"variantdef"}}],[11,"get_adt_def","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"tyctxt"}],"output":{"name":"adtdef"}}],[11,"get_predicates","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"tyctxt"}],"output":{"name":"genericpredicates"}}],[11,"get_super_predicates","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"tyctxt"}],"output":{"name":"genericpredicates"}}],[11,"get_generics","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"session"}],"output":{"name":"generics"}}],[11,"get_type","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"tyctxt"}],"output":{"name":"ty"}}],[11,"get_stability","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["stability"],"name":"option"}}],[11,"get_deprecation","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["deprecation"],"name":"option"}}],[11,"get_visibility","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"visibility"}}],[11,"get_impl_data","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"impldata"}}],[11,"get_parent_impl","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["defid"],"name":"option"}}],[11,"get_impl_polarity","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"implpolarity"}}],[11,"get_impl_defaultness","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defaultness"}}],[11,"get_coerce_unsized_info","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["coerceunsizedinfo"],"name":"option"}}],[11,"get_impl_trait","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"tyctxt"}],"output":{"generics":["traitref"],"name":"option"}}],[11,"get_lang_items","","Iterates over the language items in the given crate.",50,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"each_child_of_item","","Iterates over each child of the given item.",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"f"},{"name":"session"}],"output":null}],[11,"const_is_rvalue_promotable_to_static","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"is_item_mir_available","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"maybe_get_optimized_mir","","",50,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"defindex"}],"output":{"generics":["mir"],"name":"option"}}],[11,"mir_const_qualif","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"u8"}}],[11,"get_associated_item","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"associateditem"}}],[11,"get_item_variances","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["variance"],"name":"vec"}}],[11,"get_ctor_kind","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"ctorkind"}}],[11,"get_struct_ctor_def_id","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["defid"],"name":"option"}}],[11,"get_item_attrs","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"session"}],"output":{"name":"lrc"}}],[11,"get_struct_field_names","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["name"],"name":"vec"}}],[11,"get_attributes","","",50,{"inputs":[{"name":"self"},{"name":"entry"},{"name":"session"}],"output":{"generics":["attribute"],"name":"vec"}}],[11,"reverse_translate_def_id","","",50,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"get_inherent_implementations_for_type","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["defid"],"name":"vec"}}],[11,"get_implementations_for_trait","","",50,{"inputs":[{"name":"self"},{"generics":["defid"],"name":"option"},{"name":"vec"}],"output":null}],[11,"get_trait_of_item","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["defid"],"name":"option"}}],[11,"get_native_libraries","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"generics":["nativelibrary"],"name":"vec"}}],[11,"get_foreign_modules","","",50,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"generics":["foreignmodule"],"name":"vec"}}],[11,"get_dylib_dependency_formats","","",50,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"get_missing_lang_items","","",50,{"inputs":[{"name":"self"}],"output":{"generics":["langitem"],"name":"vec"}}],[11,"get_fn_arg_names","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"generics":["name"],"name":"vec"}}],[11,"exported_symbols","","",50,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"vec"}}],[11,"get_rendered_const","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"string"}}],[11,"wasm_custom_sections","","",50,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"vec"}}],[11,"get_macro","","",50,null],[11,"is_const_fn","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"is_foreign_item","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"bool"}}],[11,"fn_sig","","",50,{"inputs":[{"name":"self"},{"name":"defindex"},{"name":"tyctxt"}],"output":{"name":"polyfnsig"}}],[11,"def_key","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defkey"}}],[11,"def_path","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defpath"}}],[11,"def_path_hash","","",50,{"inputs":[{"name":"self"},{"name":"defindex"}],"output":{"name":"defpathhash"}}],[11,"imported_filemaps","","Imports the codemap from an external crate into the codemap of the crate currently being compiled (the \"local crate\").",50,{"inputs":[{"name":"self"},{"name":"codemap"}],"output":{"generics":["vec"],"name":"readguard"}}],[11,"crate_data_as_rc_any","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["any"],"name":"lrc"}}],[11,"metadata_loader","","",51,{"inputs":[{"name":"self"}],"output":{"name":"metadataloader"}}],[11,"visibility_untracked","","",51,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"visibility"}}],[11,"item_generics_cloned_untracked","","",51,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"name":"generics"}}],[11,"associated_item_cloned_untracked","","",51,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"associateditem"}}],[11,"dep_kind_untracked","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"depkind"}}],[11,"export_macros_untracked","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":null}],[11,"crate_name_untracked","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"symbol"}}],[11,"crate_disambiguator_untracked","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"cratedisambiguator"}}],[11,"crate_hash_untracked","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"name":"svh"}}],[11,"def_key","","Returns the `DefKey` for a given `DefId`. This indicates the parent `DefId` as well as some idea of what kind of data the `DefId` refers to.",51,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defkey"}}],[11,"def_path","","",51,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpath"}}],[11,"def_path_hash","","",51,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"defpathhash"}}],[11,"def_path_table","","",51,{"inputs":[{"name":"self"},{"name":"cratenum"}],"output":{"generics":["defpathtable"],"name":"lrc"}}],[11,"struct_field_names_untracked","","",51,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["name"],"name":"vec"}}],[11,"item_children_untracked","","",51,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"generics":["export"],"name":"vec"}}],[11,"load_macro_untracked","","",51,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"session"}],"output":{"name":"loadedmacro"}}],[11,"crates_untracked","","",51,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[11,"extern_mod_stmt_cnum_untracked","","",51,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["cratenum"],"name":"option"}}],[11,"postorder_cnums_untracked","","",51,{"inputs":[{"name":"self"}],"output":{"generics":["cratenum"],"name":"vec"}}],[11,"encode_metadata","","",51,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"linkmeta"}],"output":{"name":"encodedmetadata"}}],[11,"metadata_encoding_version","","",51,null],[11,"partial_cmp","","",43,{"inputs":[{"name":"self"},{"name":"nativelibrarykind"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"eq","","",45,{"inputs":[{"name":"self"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",45,{"inputs":[{"name":"self"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"eq","","",44,{"inputs":[{"name":"self"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"eq","","",46,{"inputs":[{"name":"self"},{"name":"libsource"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"self"},{"name":"libsource"}],"output":{"name":"bool"}}],[11,"eq","","",43,{"inputs":[{"name":"self"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"fmt","","",44,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",46,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",45,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"clone","","",45,{"inputs":[{"name":"self"}],"output":{"name":"cratesource"}}],[11,"clone","","",46,{"inputs":[{"name":"self"}],"output":{"name":"libsource"}}],[11,"clone","","",47,{"inputs":[{"name":"self"}],"output":{"name":"foreignmodule"}}],[11,"clone","","",42,{"inputs":[{"name":"self"}],"output":{"name":"nativelibrary"}}],[11,"clone","","",43,{"inputs":[{"name":"self"}],"output":{"name":"nativelibrarykind"}}],[11,"clone","","",44,{"inputs":[{"name":"self"}],"output":{"name":"linkagepreference"}}],[11,"encode","","",43,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",44,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",47,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",42,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"cmp","","",43,{"inputs":[{"name":"self"},{"name":"nativelibrarykind"}],"output":{"name":"ordering"}}],[11,"hash_stable","","",43,null],[11,"hash_stable","","",47,null],[11,"hash_stable","","",45,null],[11,"hash_stable","","",44,null],[11,"hash_stable","","",42,null],[11,"decode","","",47,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignmodule"],"name":"result"}}],[11,"decode","","",42,{"inputs":[{"name":"__d"}],"output":{"generics":["nativelibrary"],"name":"result"}}],[11,"decode","","",44,{"inputs":[{"name":"__d"}],"output":{"generics":["linkagepreference"],"name":"result"}}],[11,"decode","","",43,{"inputs":[{"name":"__d"}],"output":{"generics":["nativelibrarykind"],"name":"result"}}],[11,"hash","","",42,null],[11,"hash","","",43,null],[11,"hash","","",47,null],[11,"assert_receiver_is_total_eq","","",43,null],[11,"is_some","","",46,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"option","","",46,{"inputs":[{"name":"self"}],"output":{"generics":["pathbuf"],"name":"option"}}]],"paths":[[3,"IndexBuilder"],[3,"Untracked"],[3,"FromId"],[8,"DepGraphRead"],[3,"Index"],[3,"Unaligned"],[3,"EncodeContext"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[3,"DecodeContext"],[8,"Metadata"],[8,"IntoArgs"],[3,"IsolatedEncoder"],[3,"Lazy"],[3,"LazySeq"],[3,"CrateRoot"],[3,"CrateDep"],[3,"TraitImpls"],[3,"Entry"],[3,"ConstQualif"],[3,"RenderedConst"],[3,"ModData"],[3,"MacroDef"],[3,"FnData"],[3,"VariantData"],[3,"TraitData"],[3,"ImplData"],[3,"MethodData"],[3,"ClosureData"],[3,"GeneratorData"],[3,"EncodedExportedSymbols"],[4,"LazyState"],[4,"EntryKind"],[4,"AssociatedContainer"],[3,"Collector"],[3,"Collector"],[3,"Collector"],[3,"Library"],[3,"CrateLoader"],[3,"ExtensionCrate"],[4,"PMDSource"],[4,"LoadResult"],[3,"NativeLibrary"],[4,"NativeLibraryKind"],[4,"LinkagePreference"],[3,"CrateSource"],[4,"LibSource"],[3,"ForeignModule"],[3,"MetadataBlob"],[3,"ImportedFileMap"],[3,"CrateMetadata"],[3,"CStore"],[3,"DynamicLibrary"],[3,"CrateMismatch"],[3,"Context"],[3,"CratePaths"],[4,"CrateFlavor"]]};
searchIndex["rustc_mir"] = {"doc":"Rust MIR: a lowered representation of Rust. Also: an experiment!","items":[[5,"provide","rustc_mir","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0001","rustc_mir::diagnostics","",null,null],[0,"__register_diagnostic_E0002","","",null,null],[0,"__register_diagnostic_E0004","","",null,null],[0,"__register_diagnostic_E0005","","",null,null],[0,"__register_diagnostic_E0007","","",null,null],[0,"__register_diagnostic_E0008","","",null,null],[0,"__register_diagnostic_E0009","","",null,null],[0,"__register_diagnostic_E0030","","",null,null],[0,"__register_diagnostic_E0158","","",null,null],[0,"__register_diagnostic_E0162","","",null,null],[0,"__register_diagnostic_E0165","","",null,null],[0,"__register_diagnostic_E0170","","",null,null],[0,"__register_diagnostic_E0297","","",null,null],[0,"__register_diagnostic_E0301","","",null,null],[0,"__register_diagnostic_E0302","","",null,null],[0,"__register_diagnostic_E0303","","",null,null],[0,"__register_diagnostic_E0010","","",null,null],[0,"__register_diagnostic_E0013","","",null,null],[0,"__register_diagnostic_E0015","","",null,null],[0,"__register_diagnostic_E0016","","",null,null],[0,"__register_diagnostic_E0017","","",null,null],[0,"__register_diagnostic_E0018","","",null,null],[0,"__register_diagnostic_E0019","","",null,null],[0,"__register_diagnostic_E0022","","",null,null],[0,"__register_diagnostic_E0133","","",null,null],[0,"__register_diagnostic_E0373","","",null,null],[0,"__register_diagnostic_E0381","","",null,null],[0,"__register_diagnostic_E0382","","",null,null],[0,"__register_diagnostic_E0383","","",null,null],[0,"__register_diagnostic_E0384","","",null,null],[0,"__register_diagnostic_E0387","","",null,null],[0,"__register_diagnostic_E0388","","",null,null],[0,"__register_diagnostic_E0389","","",null,null],[0,"__register_diagnostic_E0394","","",null,null],[0,"__register_diagnostic_E0395","","",null,null],[0,"__register_diagnostic_E0161","","",null,null],[0,"__register_diagnostic_E0396","","",null,null],[0,"__register_diagnostic_E0492","","",null,null],[0,"__register_diagnostic_E0494","","",null,null],[0,"__register_diagnostic_E0499","","",null,null],[0,"__register_diagnostic_E0500","","",null,null],[0,"__register_diagnostic_E0501","","",null,null],[0,"__register_diagnostic_E0502","","",null,null],[0,"__register_diagnostic_E0503","","",null,null],[0,"__register_diagnostic_E0504","","",null,null],[0,"__register_diagnostic_E0505","","",null,null],[0,"__register_diagnostic_E0506","","",null,null],[0,"__register_diagnostic_E0507","","",null,null],[0,"__register_diagnostic_E0508","","",null,null],[0,"__register_diagnostic_E0509","","",null,null],[0,"__register_diagnostic_E0579","","",null,null],[0,"__register_diagnostic_E0595","","",null,null],[0,"__register_diagnostic_E0596","","",null,null],[0,"__register_diagnostic_E0597","","",null,null],[0,"__register_diagnostic_E0626","","",null,null],[0,"__register_diagnostic_E0493","","",null,null],[0,"__register_diagnostic_E0524","","",null,null],[0,"__register_diagnostic_E0526","","",null,null],[0,"__register_diagnostic_E0594","","",null,null],[0,"__register_diagnostic_E0598","","",null,null],[0,"__register_diagnostic_E0625","","",null,null],[0,"borrow_check","rustc_mir","This query borrow-checks the MIR to (further) ensure it is not broken.",null,null],[3,"MirBorrowckCtxt","rustc_mir::borrow_check","",null,null],[12,"tcx","","",0,null],[12,"mir","","",0,null],[12,"mir_def_id","","",0,null],[12,"move_data","","",0,null],[12,"param_env","","",0,null],[12,"movable_generator","","",0,null],[12,"locals_are_invalidated_at_exit","","This keeps track of whether local variables are free-ed when the function exits even without a `StorageDead`, which appears to be the case for constants.",0,null],[12,"access_place_error_reported","","This field keeps track of when borrow errors are reported in the access_place function so that there is no duplicate reporting. This field cannot also be used for the conflicting borrow errors that is handled by the `reservation_error_reported` field as the inclusion of the `Span` type (while required to mute some errors) stops the muting of the reservation errors.",0,null],[12,"reservation_error_reported","","This field keeps track of when borrow conflict errors are reported for reservations, so that we don't report seemingly duplicate errors for corresponding activations",0,null],[12,"moved_error_reported","","This field keeps track of errors reported in the checking of moved variables, so that we don't report report seemingly duplicate errors.",0,null],[12,"used_mut","","This field keeps track of all the local variables that are declared mut and are mutated. Used for the warning issued by an unused mutable local variable.",0,null],[12,"used_mut_upvars","","If the function we're checking is a closure, then we'll need to report back the list of mutable upvars that have been used. This field keeps track of them.",0,null],[12,"nonlexical_regioncx","","Non-lexical region inference context, if NLL is enabled.  This contains the results from region inference and lets us e.g. find out which CFG points are contained in each borrow region.",0,null],[12,"nonlexical_cause_info","","",0,null],[12,"borrow_set","","The set of borrows extracted from the MIR",0,null],[12,"dominators","","Dominators for MIR",0,null],[3,"AccessErrorsReported","","",null,null],[12,"mutability_error","","",1,null],[12,"conflict_error","","",1,null],[3,"RootPlace","","",null,null],[12,"place","","",2,null],[12,"is_local_mutation_allowed","","",2,null],[3,"Context","","",null,null],[12,"kind","","",3,null],[12,"loc","","",3,null],[4,"MutateMode","","",null,null],[13,"JustWrite","","",4,null],[13,"WriteAndRead","","",4,null],[4,"Control","","",null,null],[13,"Continue","","",5,null],[13,"Break","","",5,null],[4,"ArtificialField","","",null,null],[13,"Discriminant","","",6,null],[13,"ArrayLength","","",6,null],[4,"ShallowOrDeep","","",null,null],[13,"Shallow","","From the RFC: \"A shallow access means that the immediate fields reached at P are accessed, but references or pointers found within are not dereferenced. Right now, the only access that is shallow is an assignment like `x = ...;`, which would be a shallow write of `x`.\"",7,null],[13,"Deep","","From the RFC: \"A deep access means that all data reachable through the given place may be invalidated or accesses by this action.\"",7,null],[4,"ReadOrWrite","","Kind of access to a value: read or write (For informational purposes only)",null,null],[13,"Read","","From the RFC: \"A read means that the existing data may be read, but will not be changed.\"",8,null],[13,"Write","","From the RFC: \"A write means that the data may be mutated to new values or otherwise invalidated (for example, it could be de-initialized, as in a move operation).",8,null],[13,"Reservation","","For two-phase borrows, we distinguish a reservation (which is treated like a Read) from an activation (which is treated like a write), and each of those is furthermore distinguished from Reads/Writes above.",8,null],[13,"Activation","","",8,null],[4,"ReadKind","","Kind of read access to a value (For informational purposes only)",null,null],[13,"Borrow","","",9,null],[13,"Copy","","",9,null],[4,"WriteKind","","Kind of write access to a value (For informational purposes only)",null,null],[13,"StorageDeadOrDrop","","",10,null],[13,"MutableBorrow","","",10,null],[13,"Mutate","","",10,null],[13,"Move","","",10,null],[4,"LocalMutationIsAllowed","","When checking permissions for a place access, this flag is used to indicate that an immutable local place can be mutated.",null,null],[13,"Yes","","",11,null],[13,"ExceptUpvars","","We want use of immutable upvars to cause a \"write to immutable upvar\" error, not an \"reassignment\" error.",11,null],[13,"No","","",11,null],[4,"InitializationRequiringAction","","",null,null],[13,"Update","","",12,null],[13,"Borrow","","",12,null],[13,"Use","","",12,null],[13,"Assignment","","",12,null],[4,"NoMovePathFound","","",null,null],[13,"ReachedStatic","","",13,null],[4,"Overlap","","The degree of overlap between 2 places for borrow-checking.",null,null],[13,"Arbitrary","","The places might partially overlap - in this case, we give up and say that they might conflict. This occurs when different fields of a union are borrowed. For example, if `u` is a union, we have no way of telling how disjoint `u.a.x` and `a.b.y` are.",14,null],[13,"EqualOrDisjoint","","The places have the same type, and are either completely disjoint or equal - i.e. they can't \"partially\" overlap as can occur with unions. This is the \"base case\" on which we recur for extensions of the place.",14,null],[13,"Disjoint","","The places are disjoint, so we know all extensions of them will also be disjoint.",14,null],[4,"ContextKind","","",null,null],[13,"Activation","","",15,null],[13,"AssignLhs","","",15,null],[13,"AssignRhs","","",15,null],[13,"SetDiscrim","","",15,null],[13,"InlineAsm","","",15,null],[13,"SwitchInt","","",15,null],[13,"Drop","","",15,null],[13,"DropAndReplace","","",15,null],[13,"CallOperator","","",15,null],[13,"CallOperand","","",15,null],[13,"CallDest","","",15,null],[13,"Assert","","",15,null],[13,"Yield","","",15,null],[13,"StorageDead","","",15,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"mir_borrowck","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"borrowcheckresult"}}],[5,"do_mir_borrowck","","",null,{"inputs":[{"name":"inferctxt"},{"name":"mir"},{"name":"defid"}],"output":{"name":"borrowcheckresult"}}],[0,"borrow_set","","",null,null],[3,"BorrowSet","rustc_mir::borrow_check::borrow_set","",null,null],[12,"borrows","","The fundamental map relating bitvector indexes to the borrows in the MIR.",16,null],[12,"location_map","","Each borrow is also uniquely identified in the MIR by the `Location` of the assignment statement in which it appears on the right hand side; we map each such location to the corresponding `BorrowIndex`.",16,null],[12,"activation_map","","Locations which activate borrows. NOTE: A given location may activate more than one borrow in the future when more general two-phase borrow support is introduced, but for now we only need to store one borrow index",16,null],[12,"region_map","","Every borrow has a region; this maps each such regions back to its borrow-indexes.",16,null],[12,"local_map","","Map from local to all the borrows on that local",16,null],[3,"BorrowData","","",null,null],[12,"reserve_location","","Location where the borrow reservation starts. In many cases, this will be equal to the activation location but not always.",17,null],[12,"activation_location","","Location where the borrow is activated. None if this is not a 2-phase borrow.",17,null],[12,"kind","","What kind of borrow this is",17,null],[12,"region","","The region for which this borrow is live",17,null],[12,"borrowed_place","","Place from which we are borrowing",17,null],[12,"assigned_place","","Place to which the borrow was stored",17,null],[3,"GatherBorrows","","",null,null],[12,"tcx","","",18,null],[12,"mir","","",18,null],[12,"idx_vec","","",18,null],[12,"location_map","","",18,null],[12,"activation_map","","",18,null],[12,"region_map","","",18,null],[12,"local_map","","",18,null],[12,"pending_activations","","When we encounter a 2-phase borrow statement, it will always be assigning into a temporary TEMP:",18,null],[11,"index","","",16,{"inputs":[{"name":"self"},{"name":"borrowindex"}],"output":{"name":"borrowdata"}}],[11,"fmt","","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"build","","",16,{"inputs":[{"name":"tyctxt"},{"name":"mir"}],"output":{"name":"self"}}],[11,"activations_at_location","","",16,null],[11,"visit_assign","","",18,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_place","","",18,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",18,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_statement","","",18,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"allow_two_phase_borrow","","Returns true if the borrow represented by `kind` is allowed to be split into separate Reservation and Activation phases.",18,{"inputs":[{"name":"self"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"insert_as_pending_if_two_phase","","If this is a two-phase borrow, then we will record it as \"pending\" until we find the activating use.",18,{"inputs":[{"name":"self"},{"name":"location"},{"name":"place"},{"name":"region"},{"name":"borrowkind"},{"name":"borrowindex"}],"output":null}],[0,"error_reporting","rustc_mir::borrow_check","",null,null],[11,"report_use_of_moved_or_uninitialized","","",0,null],[11,"report_move_out_while_borrowed","","",0,null],[11,"report_use_while_mutably_borrowed","","",0,null],[11,"find_closure_span","","Finds the span of arguments of a closure (within `maybe_closure_span`) and its usage of the local assigned at `location`. This is done by searching in statements succeeding `location` and originating from `maybe_closure_span`.",0,{"inputs":[{"name":"self"},{"name":"span"},{"name":"location"}],"output":{"name":"option"}}],[11,"report_conflicting_borrow","","",0,null],[11,"report_borrowed_value_does_not_live_long_enough","","",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"borrowdata"},{"name":"span"}],"output":null}],[11,"report_scoped_local_value_does_not_live_long_enough","","",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"string"},{"name":"lrc"},{"name":"borrowdata"},{"name":"span"},{"name":"span"},{"name":"span"}],"output":null}],[11,"report_scoped_temporary_value_does_not_live_long_enough","","",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"lrc"},{"name":"borrowdata"},{"name":"span"},{"name":"span"},{"name":"span"}],"output":null}],[11,"report_unscoped_local_value_does_not_live_long_enough","","",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"string"},{"name":"lrc"},{"name":"borrowdata"},{"name":"span"},{"name":"span"},{"name":"span"}],"output":null}],[11,"report_unscoped_temporary_value_does_not_live_long_enough","","",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"lrc"},{"name":"borrowdata"},{"name":"span"},{"name":"span"},{"name":"span"}],"output":null}],[11,"report_illegal_mutation_of_borrowed","","",0,null],[11,"report_illegal_reassignment","","",0,null],[11,"describe_place","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["string"],"name":"option"}}],[11,"append_place_to_string","","",0,{"inputs":[{"name":"self"},{"name":"place"},{"name":"string"},{"name":"bool"}],"output":{"name":"result"}}],[11,"append_local_to_string","","",0,{"inputs":[{"name":"self"},{"name":"local"},{"name":"string"}],"output":{"name":"result"}}],[11,"describe_field","","",0,{"inputs":[{"name":"self"},{"name":"place"},{"name":"field"}],"output":{"name":"string"}}],[11,"describe_field_from_ty","","",0,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"field"}],"output":{"name":"string"}}],[11,"retrieve_borrow_span","","",0,{"inputs":[{"name":"self"},{"name":"borrowdata"}],"output":{"name":"span"}}],[11,"retrieve_type_for_place","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["ty"],"name":"option"}}],[0,"flows","","Manages the dataflow bits required for borrowck.",null,null],[3,"Flows","rustc_mir::borrow_check::flows","",null,null],[12,"borrows","","",19,null],[12,"inits","","",19,null],[12,"uninits","","",19,null],[12,"move_outs","","",19,null],[12,"ever_inits","","",19,null],[11,"new","","",19,{"inputs":[{"generics":["borrows"],"name":"flowatlocation"},{"generics":["maybeinitializedplaces"],"name":"flowatlocation"},{"generics":["maybeuninitializedplaces"],"name":"flowatlocation"},{"generics":["movingoutstatements"],"name":"flowatlocation"},{"generics":["everinitializedplaces"],"name":"flowatlocation"}],"output":{"name":"self"}}],[11,"borrows_in_scope","","",19,null],[11,"with_outgoing_borrows","","",19,null],[11,"reset_to_entry_of","","",19,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":null}],[11,"reconstruct_statement_effect","","",19,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"reconstruct_terminator_effect","","",19,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"apply_local_effect","","",19,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"location","rustc_mir::borrow_check","",null,null],[3,"LocationTable","rustc_mir::borrow_check::location","Maps between a MIR Location, which identifies the a particular statement within a basic block, to a \"rich location\", which identifies at a finer granularity. In particular, we distinguish the start of a statement and the mid-point. The mid-point is the point just before the statement takes effect; in particular, for an assignment `A = B`, it is the point where B is about to be written into A. This mid-point is a kind of hack to work around our inability to track the position information at sufficient granularity through outlives relations; however, the rich location table serves another purpose: it compresses locations from multiple words into a single u32.",null,null],[12,"num_points","","",20,null],[12,"statements_before_block","","",20,null],[3,"LocationIndex","","",null,null],[12,"0","","",21,null],[4,"RichLocation","","",null,null],[13,"Start","","",22,null],[13,"Mid","","",22,null],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"locationindex"}}],[11,"eq","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",21,null],[11,"hash","","",21,null],[11,"partial_cmp","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"bool"}}],[11,"le","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"bool"}}],[11,"gt","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"bool"}}],[11,"ge","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"bool"}}],[11,"cmp","","",21,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"ordering"}}],[11,"decode","","",21,{"inputs":[{"name":"__d"}],"output":{"generics":["locationindex"],"name":"result"}}],[11,"encode","","",21,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",21,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",21,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"self"}],"output":{"name":"richlocation"}}],[11,"fmt","","",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",20,{"inputs":[{"name":"mir"}],"output":{"name":"self"}}],[11,"all_points","","",20,null],[11,"start_index","","",20,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"locationindex"}}],[11,"mid_index","","",20,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"locationindex"}}],[11,"to_location","","",20,{"inputs":[{"name":"self"},{"name":"locationindex"}],"output":{"name":"richlocation"}}],[11,"is_start","","",21,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[0,"place_ext","rustc_mir::borrow_check","",null,null],[8,"PlaceExt","rustc_mir::borrow_check::place_ext","Extension methods for the `Place` type.",null,null],[10,"is_unsafe_place","","True if this is a deref of a raw pointer.",23,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mir"}],"output":{"name":"bool"}}],[10,"root_local","","If this is a place like `x.f.g`, returns the local `x`. Returns `None` if this is based in a static.",23,{"inputs":[{"name":"self"}],"output":{"generics":["local"],"name":"option"}}],[0,"prefixes","rustc_mir::borrow_check","From the NLL RFC: \"The deep [aka 'supporting'] prefixes for an place are formed by stripping away fields and derefs, except that we stop when we reach the deref of a shared reference. [...] \"",null,null],[3,"Prefixes","rustc_mir::borrow_check::prefixes","",null,null],[12,"mir","","",24,null],[12,"tcx","","",24,null],[12,"kind","","",24,null],[12,"next","","",24,null],[4,"PrefixSet","","",null,null],[13,"All","","Doesn't stop until it returns the base case (a Local or Static prefix).",25,null],[13,"Shallow","","Stops at any dereference.",25,null],[13,"Supporting","","Stops at the deref of a shared reference.",25,null],[8,"IsPrefixOf","","",null,null],[10,"is_prefix_of","","",26,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"bool"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"prefixset"}}],[11,"eq","","",25,{"inputs":[{"name":"self"},{"name":"prefixset"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",25,null],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"prefixes","rustc_mir::borrow_check","Returns an iterator over the prefixes of `place` (inclusive) from longest to smallest, potentially terminating the iteration early based on `kind`.",0,{"inputs":[{"name":"self"},{"name":"place"},{"name":"prefixset"}],"output":{"name":"prefixes"}}],[11,"next","rustc_mir::borrow_check::prefixes","",24,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[0,"nll","rustc_mir::borrow_check","",null,null],[5,"replace_regions_in_mir","rustc_mir::borrow_check::nll","Rewrites the regions in the MIR to use NLL variables, also scraping out the set of universal regions (e.g., region parameters) declared on the function. That set will need to be given to `compute_regions`.",null,{"inputs":[{"name":"inferctxt"},{"name":"defid"},{"name":"paramenv"},{"name":"mir"}],"output":{"name":"universalregions"}}],[5,"compute_regions","","Computes the (non-lexical) regions from the input MIR.",null,null],[5,"dump_mir_results","","",null,{"inputs":[{"name":"inferctxt"},{"name":"livenessresults"},{"name":"mirsource"},{"name":"mir"},{"name":"regioninferencecontext"},{"name":"option"}],"output":null}],[5,"dump_annotation","","",null,{"inputs":[{"name":"inferctxt"},{"name":"mir"},{"name":"defid"},{"name":"regioninferencecontext"},{"name":"option"}],"output":null}],[5,"for_each_region_constraint","","",null,{"inputs":[{"name":"closureregionrequirements"},{"name":"fnmut"}],"output":{"name":"result"}}],[5,"live_variable_set","","",null,{"inputs":[{"name":"localset"},{"name":"localset"}],"output":{"name":"string"}}],[0,"constraint_generation","","",null,null],[3,"ConstraintGeneration","rustc_mir::borrow_check::nll::constraint_generation","'cg = the duration of the constraint generation process itself.",null,null],[12,"infcx","","",27,null],[12,"all_facts","","",27,null],[12,"location_table","","",27,null],[12,"regioncx","","",27,null],[12,"mir","","",27,null],[12,"borrow_set","","",27,null],[5,"generate_constraints","","",null,{"inputs":[{"name":"inferctxt"},{"name":"regioninferencecontext"},{"name":"option"},{"name":"locationtable"},{"name":"mir"},{"name":"borrowset"}],"output":null}],[11,"visit_basic_block_data","","",27,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_substs","","We sometimes have `substs` within an rvalue, or within a call. Make them live at the location where they appear.",27,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"location"}],"output":null}],[11,"visit_region","","We sometimes have `region` within an rvalue, or within a call. Make them live at the location where they appear.",27,{"inputs":[{"name":"self"},{"name":"region"},{"name":"location"}],"output":null}],[11,"visit_ty","","We sometimes have `ty` within an rvalue, or within a call. Make them live at the location where they appear.",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_closure_substs","","We sometimes have `closure_substs` within an rvalue, or within a call. Make them live at the location where they appear.",27,{"inputs":[{"name":"self"},{"name":"closuresubsts"},{"name":"location"}],"output":null}],[11,"visit_statement","","",27,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_assign","","",27,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_terminator","","",27,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",27,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_user_assert_ty","","",27,{"inputs":[{"name":"self"},{"name":"canonicalty"},{"name":"local"},{"name":"location"}],"output":null}],[11,"add_regular_live_constraint","","Some variable with type `live_ty` is \"regular live\" at `location` -- i.e., it may be used later. This means that all regions appearing in the type `live_ty` must be live at `location`.",27,{"inputs":[{"name":"self"},{"name":"t"},{"name":"location"},{"name":"cause"}],"output":null}],[11,"add_reborrow_constraint","","",27,{"inputs":[{"name":"self"},{"name":"location"},{"name":"region"},{"name":"place"}],"output":null}],[0,"explain_borrow","rustc_mir::borrow_check::nll","",null,null],[3,"UseFinder","rustc_mir::borrow_check::nll::explain_borrow","",null,null],[12,"mir","","",28,null],[12,"regioncx","","",28,null],[12,"borrow","","",28,null],[12,"start_point","","",28,null],[12,"local","","",28,null],[12,"liveness_mode","","",28,null],[3,"DefUseVisitor","","",null,null],[12,"defined","","",29,null],[12,"used","","",29,null],[12,"local","","",29,null],[12,"liveness_mode","","",29,null],[5,"find_regular_use","","",null,{"inputs":[{"name":"mir"},{"name":"regioninferencecontext"},{"name":"borrowdata"},{"name":"location"},{"name":"local"}],"output":{"generics":["location"],"name":"option"}}],[5,"find_drop_use","","",null,{"inputs":[{"name":"mir"},{"name":"regioninferencecontext"},{"name":"borrowdata"},{"name":"location"},{"name":"local"}],"output":{"generics":["location"],"name":"option"}}],[11,"explain_why_borrow_contains_point","rustc_mir::borrow_check","Adds annotations to `err` explaining why the borrow contains the point from `context`. This is key for the \"3-point errors\" [described in the NLL RFC][d].",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"borrowdata"},{"name":"diagnosticbuilder"}],"output":null}],[11,"find","rustc_mir::borrow_check::nll::explain_borrow","",28,{"inputs":[{"name":"self"}],"output":{"generics":["location"],"name":"option"}}],[11,"def_use","","",28,null],[11,"visit_local","","",29,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[0,"facts","rustc_mir::borrow_check::nll","",null,null],[3,"AllFacts","rustc_mir::borrow_check::nll::facts","The \"facts\" which are the basis of the NLL borrow analysis.",null,null],[12,"borrow_region","","",30,null],[12,"universal_region","","",30,null],[12,"cfg_edge","","",30,null],[12,"killed","","",30,null],[12,"outlives","","",30,null],[12,"region_live_at","","",30,null],[3,"FactWriter","","",null,null],[12,"location_table","","",31,null],[12,"dir","","",31,null],[5,"write_row","","",null,null],[8,"FactRow","","",null,null],[10,"write","","",32,{"inputs":[{"name":"self"},{"name":"file"},{"name":"locationtable"}],"output":{"generics":["box"],"name":"result"}}],[8,"FactCell","","",null,null],[10,"to_string","","",33,{"inputs":[{"name":"self"},{"name":"locationtable"}],"output":{"name":"string"}}],[11,"default","","",30,{"inputs":[],"output":{"name":"allfacts"}}],[11,"write_to_dir","","",30,null],[11,"write_facts_to_path","","",31,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"str"}],"output":{"generics":["box"],"name":"result"}}],[11,"to_string","rustc_mir::borrow_check::location","",21,{"inputs":[{"name":"self"},{"name":"locationtable"}],"output":{"name":"string"}}],[0,"region_infer","rustc_mir::borrow_check::nll","",null,null],[3,"RegionInferenceContext","rustc_mir::borrow_check::nll::region_infer","",null,null],[12,"definitions","","Contains the definition for every region variable.  Region variables are identified by their index (`RegionVid`). The definition contains information about where the region came from as well as its final inferred value.",34,null],[12,"elements","","Maps from points/universal-regions to a `RegionElementIndex`.",34,null],[12,"liveness_constraints","","The liveness constraints added to each region. For most regions, these start out empty and steadily grow, though for each universally quantified region R they start out containing the entire CFG and `end(R)`.",34,null],[12,"inferred_values","","The final inferred values of the inference variables; `None` until `solve` is invoked.",34,null],[12,"dependency_map","","For each variable, stores the index of the first constraint where that variable appears on the RHS. This is the start of a 'linked list' threaded by the `next` field in `Constraint`.",34,null],[12,"constraints","","The constraints we have accumulated and used during solving.",34,null],[12,"type_tests","","Type constraints that we check after solving.",34,null],[12,"universal_regions","","Information about the universally quantified regions in scope on this function and their (known) relations to one another.",34,null],[3,"TrackCauses","","",null,null],[12,"0","","",35,null],[3,"RegionDefinition","","",null,null],[12,"origin","","Why we created this variable. Mostly these will be `RegionVariableOrigin::NLL`, but some variables get created elsewhere in the code with other causes (e.g., instantiation late-bound-regions).",36,null],[12,"is_universal","","True if this is a universally quantified region. This means a lifetime parameter that appears in the function signature (or, in the case of a closure, in the closure environment, which of course is also in the function signature).",36,null],[12,"external_name","","If this is 'static or an early-bound region, then this is `Some(X)` where `X` is the name of the region.",36,null],[3,"RegionCausalInfo","","",null,null],[12,"inferred_values","","",37,null],[3,"Constraint","","",null,null],[12,"sup","","The region SUP must outlive SUB...",38,null],[12,"sub","","Region that must be outlived.",38,null],[12,"point","","At this location.",38,null],[12,"next","","Later on, we thread the constraints onto a linked list grouped by their `sub` field. So if you had:",38,null],[12,"span","","Where did this constraint arise?",38,null],[3,"ConstraintIndex","","",null,null],[12,"0","","",39,null],[3,"TypeTest","","A \"type test\" corresponds to an outlives constraint between a type and a lifetime, like `T: 'x` or `<T as Foo>::Bar: 'x`.  They are translated from the `Verify` region constraints in the ordinary inference context.",null,null],[12,"generic_kind","","The type `T` that must outlive the region.",40,null],[12,"lower_bound","","The region `'x` that the type must outlive.",40,null],[12,"point","","The point where the outlives relation must hold.",40,null],[12,"span","","Where did this constraint arise?",40,null],[12,"test","","A test which, if met by the region `'x`, proves that this type constraint is satisfied.",40,null],[4,"Cause","","NB: The variants in `Cause` are intentionally ordered. Lower values are preferred when it comes to error messages. Do not reorder willy nilly.",null,null],[13,"LiveVar","","point inserted because Local was live at the given Location",41,null],[13,"DropVar","","point inserted because Local was dropped at the given Location",41,null],[13,"LiveOther","","point inserted because the type was live at the given Location, but not as part of some local variable",41,null],[13,"UniversalRegion","","part of the initial set of values for a universally quantified region",41,null],[13,"Outlives","","Element E was added to R because there was some outlives obligation `R: R1 @ P` and `R1` contained `E`.",41,null],[12,"original_cause","rustc_mir::borrow_check::nll::region_infer::Cause","the reason that R1 had E",41,null],[12,"constraint_location","","the point P from the relation",41,null],[12,"constraint_span","","The span indicating why we added the outlives constraint.",41,null],[4,"RegionTest","rustc_mir::borrow_check::nll::region_infer","A \"test\" that can be applied to some \"subject region\" `'x`. These are used to describe type constraints. Tests do not presently affect the region values that get inferred for each variable; they only examine the results after inference.  This means they can conveniently include disjuction (\"a or b must be true\").",null,null],[13,"IsOutlivedByAnyRegionIn","","The subject region `'x` must by outlived by some region in the given set of regions.",42,null],[13,"IsOutlivedByAllRegionsIn","","The subject region `'x` must by outlived by all regions in the given set of regions.",42,null],[13,"Any","","Any of the given tests are true.",42,null],[13,"All","","All of the given tests are true.",42,null],[0,"annotation","","As part of the NLL unit tests, you can annotate a function with `#[rustc_regions]`, and we will emit information about the region inference context and -- in particular -- the external constraints that this region imposes on others. The methods in this file handle the part about dumping the inference context internal state.",null,null],[11,"annotate","","Write out our state into the `.mir` files.",34,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[0,"dfs","","Module defining the `dfs` method on `RegionInferenceContext`, along with its associated helper traits.",null,null],[3,"DfsStorage","rustc_mir::borrow_check::nll::region_infer::dfs","",null,null],[12,"stack","","",43,null],[12,"visited","","",43,null],[3,"CopyFromSourceToTarget","","Used during inference to enforce a `R1: R2 @ P` constraint.  For each point Q we reach along the DFS, we check if Q is in R2 (the \"source region\"). If not, we stop the walk. Otherwise, we add Q to R1 (the \"target region\") and continue to Q's successors. If we reach the end of the graph, then we add any universal regions from R2 into R1.",null,null],[12,"source_region","","",44,null],[12,"target_region","","",44,null],[12,"inferred_values","","",44,null],[12,"constraint_point","","",44,null],[12,"constraint_span","","",44,null],[3,"TestTargetOutlivesSource","","Used after inference to test a `R1: R2 @ P` constraint.  For each point Q we reach along the DFS, we check if Q in R2 is also contained in R1. If not, we abort the walk early with an `Err` condition. Similarly, if we reach the end of the graph and find that R1 contains some universal region that R2 does not contain, we abort the walk early.",null,null],[12,"source_region","","",45,null],[12,"target_region","","",45,null],[12,"elements","","",45,null],[12,"universal_regions","","",45,null],[12,"inferred_values","","",45,null],[12,"constraint_point","","",45,null],[8,"DfsOp","","Customizes the operation of the `dfs` function. This function is used during inference to satisfy a `R1: R2 @ P` constraint.",null,null],[16,"Early","","If this op stops the walk early, what type does it propagate?",46,null],[10,"start_point","","Returns the point from which to start the DFS.",46,{"inputs":[{"name":"self"}],"output":{"name":"location"}}],[10,"source_region_contains","","Returns true if the source region contains the given point.",46,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[10,"add_to_target_region","","Adds the given point to the target region, returning true if something has changed. Returns `Err` if we should abort the walk early.",46,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"generics":["bool"],"name":"result"}}],[10,"add_universal_regions_outlived_by_source_to_target","","Adds all universal regions in the source region to the target region, returning true if something has changed.",46,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[11,"new_dfs_storage","rustc_mir::borrow_check::nll::region_infer","Creates dfs storage for use by dfs; this should be shared across as many calls to dfs as possible to amortize allocation costs.",34,{"inputs":[{"name":"self"}],"output":{"name":"dfsstorage"}}],[11,"dfs","","Function used to satisfy or test a `R1: R2 @ P` constraint. The core idea is that it performs a DFS starting from `P`. The precise actions during that DFS depend on the `op` supplied, so see (e.g.) `CopyFromSourceToTarget` for more details.",34,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"dfsstorage"},{"name":"c"}],"output":{"generics":["bool"],"name":"result"}}],[11,"start_point","rustc_mir::borrow_check::nll::region_infer::dfs","",44,{"inputs":[{"name":"self"}],"output":{"name":"location"}}],[11,"source_region_contains","","",44,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"add_to_target_region","","",44,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"generics":["bool"],"name":"result"}}],[11,"add_universal_regions_outlived_by_source_to_target","","",44,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[11,"start_point","","",45,{"inputs":[{"name":"self"}],"output":{"name":"location"}}],[11,"source_region_contains","","",45,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"add_to_target_region","","",45,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"generics":["bool","regionelementindex"],"name":"result"}}],[11,"add_universal_regions_outlived_by_source_to_target","","",45,{"inputs":[{"name":"self"}],"output":{"generics":["bool","regionelementindex"],"name":"result"}}],[0,"dump_mir","rustc_mir::borrow_check::nll::region_infer","As part of generating the regions, if you enable `-Zdump-mir=nll`, we will generate an annotated copy of the MIR that includes the state of region inference. This code handles emitting the region context internal state.",null,null],[17,"REGION_WIDTH","rustc_mir::borrow_check::nll::region_infer::dump_mir","",null,null],[11,"dump_mir","rustc_mir::borrow_check::nll::region_infer","Write out our state into the `.mir` files.",34,{"inputs":[{"name":"self"},{"name":"write"}],"output":{"name":"result"}}],[11,"for_each_constraint","","Debugging aid: Invokes the `with_msg` callback repeatedly with our internal region constraints.  These are dumped into the -Zdump-mir file so that we can figure out why the region inference resulted in the values that it did when debugging.",34,{"inputs":[{"name":"self"},{"name":"fnmut"}],"output":{"name":"result"}}],[0,"graphviz","","This module provides linkage between RegionInferenceContext and libgraphviz traits, specialized to attaching borrowck analysis data to rendered labels.",null,null],[11,"dump_graphviz","","Write out the region constraint graph.",34,{"inputs":[{"name":"self"},{"name":"write"}],"output":{"name":"result"}}],[11,"graph_id","","",34,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"node_id","","",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"id"}}],[11,"node_shape","","",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["labeltext"],"name":"option"}}],[11,"node_label","","",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",34,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"labeltext"}}],[11,"nodes","","",34,{"inputs":[{"name":"self"}],"output":{"generics":["regionvid"],"name":"nodes"}}],[11,"edges","","",34,{"inputs":[{"name":"self"}],"output":{"generics":["constraint"],"name":"edges"}}],[11,"source","","",34,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"regionvid"}}],[11,"target","","",34,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"regionvid"}}],[0,"values","","",null,null],[3,"RegionValueElements","rustc_mir::borrow_check::nll::region_infer::values","Maps between the various kinds of elements of a region value to the internal indices that w use.",null,null],[12,"statements_before_block","","For each basic block, how many points are contained within?",47,null],[12,"num_points","","",47,null],[12,"num_universal_regions","","",47,null],[3,"RegionElementIndex","","",null,null],[12,"0","","",48,null],[3,"RegionValues","","Stores the values for a set of regions. These are stored in a compact `SparseBitMatrix` representation, with one row per region variable. The columns consist of either universal regions or points in the CFG.",null,null],[12,"elements","","",49,null],[12,"matrix","","",49,null],[12,"causes","","If cause tracking is enabled, maps from a pair (r, e) consisting of a region `r` that contains some element `e` to the reason that the element is contained. There should be an entry for every bit set to 1 in `SparseBitMatrix`.",49,null],[4,"RegionElement","","An individual element in a region value -- the value of a particular region variable consists of a set of these elements.",null,null],[13,"Location","","A point in the control-flow graph.",50,null],[13,"UniversalRegion","","An in-scope, universally quantified region (e.g., a lifetime parameter).",50,null],[6,"CauseMap","","",null,null],[8,"ToElementIndex","","",null,null],[10,"to_element_index","","",51,{"inputs":[{"name":"self"},{"name":"regionvalueelements"}],"output":{"name":"regionelementindex"}}],[11,"new","","",47,{"inputs":[{"name":"mir"},{"name":"usize"}],"output":{"name":"self"}}],[11,"num_elements","","Total number of element indices that exist.",47,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"index","","Converts an element of a region value into a `RegionElementIndex`.",47,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"regionelementindex"}}],[11,"all_point_indices","","Iterates over the `RegionElementIndex` for all points in the CFG.",47,null],[11,"all_universal_region_indices","","Iterates over the `RegionElementIndex` for all points in the CFG.",47,null],[11,"to_element","","Converts a particular `RegionElementIndex` to the `RegionElement` it represents.",47,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"regionelement"}}],[11,"to_universal_region","","Converts a particular `RegionElementIndex` to a universal region, if that is what it represents. Returns `None` otherwise.",47,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"generics":["regionvid"],"name":"option"}}],[11,"clone","","",48,{"inputs":[{"name":"self"}],"output":{"name":"regionelementindex"}}],[11,"eq","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",48,null],[11,"hash","","",48,null],[11,"partial_cmp","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"le","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"gt","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"ge","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"bool"}}],[11,"cmp","","",48,{"inputs":[{"name":"self"},{"name":"regionelementindex"}],"output":{"name":"ordering"}}],[11,"decode","","",48,{"inputs":[{"name":"__d"}],"output":{"generics":["regionelementindex"],"name":"result"}}],[11,"encode","","",48,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",48,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",48,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",48,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",50,{"inputs":[{"name":"self"}],"output":{"name":"regionelement"}}],[11,"fmt","","",50,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",50,{"inputs":[{"name":"self"},{"name":"regionelement"}],"output":{"name":"bool"}}],[11,"ne","","",50,{"inputs":[{"name":"self"},{"name":"regionelement"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",50,null],[11,"hash","","",50,null],[11,"to_element_index","","",48,{"inputs":[{"name":"self"},{"name":"regionvalueelements"}],"output":{"name":"regionelementindex"}}],[11,"new","","Creates a new set of \"region values\" that tracks causal information. Each of the regions in num_region_variables will be initialized with an empty set of points and no causal information.",49,{"inputs":[{"name":"rc"},{"name":"usize"}],"output":{"name":"self"}}],[11,"duplicate","","Duplicates the region values. If track_causes is false, then the resulting value will not track causal information (and any existing causal information is dropped). Otherwise, the causal information is preserved and maintained. Tracking the causal information makes region propagation significantly slower, so we prefer not to do it until an error is reported.",49,{"inputs":[{"name":"self"},{"name":"trackcauses"}],"output":{"name":"self"}}],[11,"add","","Adds the given element to the value for the given region. Returns true if the element is newly added (i.e., was not already present).",49,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"e"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"add_internal","","Internal method to add an element to a region.",49,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionelementindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_due_to_outlives","","Adds `elem` to `to_region` because of a relation:",49,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionvid"},{"name":"t"},{"name":"location"},{"name":"span"}],"output":{"name":"bool"}}],[11,"add_universal_regions_outlived_by","","Adds all the universal regions outlived by `from_region` to `to_region`.",49,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionvid"},{"name":"location"},{"name":"span"}],"output":{"name":"bool"}}],[11,"contains","","True if the region `r` contains the given element.",49,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"e"}],"output":{"name":"bool"}}],[11,"element_indices_contained_in","","Iterate over the value of the region `r`, yielding up element indices. You may prefer `universal_regions_outlived_by` or `elements_contained_in`.",49,null],[11,"universal_regions_outlived_by","","Returns just the universal regions that are contained in a given region's value.",49,null],[11,"elements_contained_in","","Returns all the elements contained in a given region's value.",49,null],[11,"region_value_str","","Returns a \"pretty\" string value of the region. Meant for debugging.",49,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"string"}}],[11,"push_location_range","","",49,{"inputs":[{"name":"string"},{"name":"location"},{"name":"location"}],"output":null}],[11,"cause","","Given a region `r` that contains the element `elem`, returns the `Cause` that tells us why `elem` is found in that region.",49,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"t"}],"output":{"generics":["rc"],"name":"option"}}],[8,"ClosureRegionRequirementsExt","rustc_mir::borrow_check::nll::region_infer","",null,null],[10,"apply_requirements","","",52,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"nodeid"},{"name":"location"},{"name":"defid"},{"name":"closuresubsts"}],"output":null}],[10,"subst_closure_mapping","","",52,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"indexvec"},{"name":"t"}],"output":{"name":"t"}}],[8,"CauseExt","","",null,null],[10,"outlives","","",53,{"inputs":[{"name":"self"},{"name":"location"},{"name":"span"}],"output":{"name":"cause"}}],[11,"clone","","",41,{"inputs":[{"name":"self"}],"output":{"name":"cause"}}],[11,"fmt","","",41,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"le","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"gt","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"ge","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"cmp","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"ordering"}}],[11,"eq","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"self"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",41,null],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"constraint"}}],[11,"eq","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",38,null],[11,"partial_cmp","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"le","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"gt","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ge","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"cmp","","",38,{"inputs":[{"name":"self"},{"name":"constraint"}],"output":{"name":"ordering"}}],[11,"hash","","",38,null],[11,"clone","","",39,{"inputs":[{"name":"self"}],"output":{"name":"constraintindex"}}],[11,"eq","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",39,null],[11,"hash","","",39,null],[11,"partial_cmp","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"bool"}}],[11,"le","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"bool"}}],[11,"gt","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"bool"}}],[11,"ge","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"bool"}}],[11,"cmp","","",39,{"inputs":[{"name":"self"},{"name":"constraintindex"}],"output":{"name":"ordering"}}],[11,"decode","","",39,{"inputs":[{"name":"__d"}],"output":{"generics":["constraintindex"],"name":"result"}}],[11,"encode","","",39,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",39,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",39,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",39,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",40,{"inputs":[{"name":"self"}],"output":{"name":"typetest"}}],[11,"fmt","","",40,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",42,{"inputs":[{"name":"self"}],"output":{"name":"regiontest"}}],[11,"fmt","","",42,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new region inference context with a total of `num_region_variables` valid inference variables; the first N of those will be constant regions representing the free regions defined in `universal_regions`.",34,{"inputs":[{"name":"varinfos"},{"name":"universalregions"},{"name":"mir"}],"output":{"name":"self"}}],[11,"init_universal_regions","","Initializes the region variables for each universally quantified region (lifetime parameter). The first N variables always correspond to the regions appearing in the function signature (both named and anonymous) and where clauses. This function iterates over those regions and initializes them with minimum values.",34,{"inputs":[{"name":"self"}],"output":null}],[11,"regions","","Returns an iterator over all the region indices.",34,null],[11,"to_region_vid","","Given a universal region in scope on the MIR, returns the corresponding index.",34,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"regionvid"}}],[11,"region_contains_point","","Returns true if the region `r` contains the point `p`.",34,{"inputs":[{"name":"self"},{"name":"r"},{"name":"location"}],"output":{"name":"bool"}}],[11,"region_value_str","","Returns access to the value of `r` for debugging purposes.",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"string"}}],[11,"add_live_point","","Indicates that the region variable `v` is live at the point `point`.",34,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"location"},{"name":"cause"}],"output":{"name":"bool"}}],[11,"add_outlives","","Indicates that the region variable `sup` must outlive `sub` is live at the point `point`.",34,{"inputs":[{"name":"self"},{"name":"span"},{"name":"regionvid"},{"name":"regionvid"},{"name":"location"}],"output":null}],[11,"add_type_test","","Add a \"type test\" that must be satisfied.",34,{"inputs":[{"name":"self"},{"name":"typetest"}],"output":null}],[11,"solve","","Perform region inference and report errors if we see any unsatisfiable constraints. If this is a closure, returns the region requirements to propagate to our creator, if any.",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"mir"},{"name":"defid"}],"output":{"generics":["closureregionrequirements"],"name":"option"}}],[11,"solve_inner","","",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"mir"},{"name":"defid"}],"output":{"generics":["closureregionrequirements"],"name":"option"}}],[11,"compute_causal_info","","Re-execute the region inference, this time tracking causal information. This is significantly slower, so it is done only when an error is being reported.",34,{"inputs":[{"name":"self"},{"name":"mir"}],"output":{"name":"regioncausalinfo"}}],[11,"propagate_constraints","","Propagate the region constraints: this will grow the values for each region variable until all the constraints are satisfied. Note that some values may grow too large to be feasible, but we check this later.",34,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"dfsstorage"}],"output":null}],[11,"compute_region_values","","",34,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"dfsstorage"},{"name":"trackcauses"}],"output":{"name":"regionvalues"}}],[11,"build_dependency_map","","Builds up a map from each region variable X to a vector with the indices of constraints that need to be re-evaluated when X changes. These are constraints like Y: X @ P -- so if X changed, we may need to grow Y.",34,{"inputs":[{"name":"self"}],"output":{"generics":["regionvid","option"],"name":"indexvec"}}],[11,"check_type_tests","","Once regions have been propagated, this method is used to see whether the \"type tests\" produced by typeck were satisfied; type tests encode type-outlives relationships like `T: 'a`. See `TypeTest` for more details.",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"mir"},{"name":"dfsstorage"},{"name":"defid"},{"generics":["vec"],"name":"option"}],"output":null}],[11,"to_error_region","","Converts a region inference variable into a `ty::Region` that we can use for error reporting. If `r` is universally bound, then we use the name that we have on record for it. If `r` is existentially bound, then we check its inferred value and try to find a good name from that. Returns `None` if we can't find one (e.g., this is just some random part of the CFG).",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["region"],"name":"option"}}],[11,"try_promote_type_test","","",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"typetest"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"try_promote_type_test_subject","","When we promote a type test `T: 'r`, we have to convert the type `T` into something we can store in a query result (so something allocated for `'gcx`). This is problematic if `ty` contains regions. During the course of NLL region checking, we will have replaced all of those regions with fresh inference variables. To create a test subject, we want to replace those inference variables with some region from the closure signature -- this is not always possible, so this is a fallible process. Presuming we do find a suitable region, we will represent it with a `ReClosureBound`, which is a `RegionKind` variant that can be allocated in the gcx.",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"ty"}],"output":{"generics":["closureoutlivessubject"],"name":"option"}}],[11,"non_local_universal_upper_bound","","Given some universal or existential region `r`, finds a non-local, universal region `r+` that outlives `r` at entry to (and exit from) the closure. In the worst case, this will be `'static`.",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"universal_upper_bound","","Returns a universally quantified region that outlives the value of `r` (`r` may be existentially or universally quantified).",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"eval_region_test","","Test if `test` is true when applied to `lower_bound` at `point`, and returns true or false.",34,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"dfsstorage"},{"name":"location"},{"name":"regionvid"},{"name":"regiontest"}],"output":{"name":"bool"}}],[11,"eval_outlives","","",34,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"dfsstorage"},{"name":"regionvid"},{"name":"regionvid"},{"name":"location"}],"output":{"name":"bool"}}],[11,"check_universal_regions","","Once regions have been propagated, this method is used to see whether any of the constraints were too strong. In particular, we want to check for a case where a universally quantified region exceeded its bounds.  Consider:",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"defid"},{"generics":["vec"],"name":"option"}],"output":null}],[11,"check_universal_region","","Check the final value for the free region `fr` to see if it grew too large. In particular, examine what `end(X)` points wound up in `fr`'s final value; for each `end(X)` where `X != fr`, we want to check that `fr: X`. If not, that's either an error, or something we have to propagate to our creator.",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"defid"},{"name":"regionvid"},{"name":"option"}],"output":null}],[11,"report_error","","Report an error because the universal region `fr` was required to outlive `outlived_fr` but it is not known to do so. For example:",34,{"inputs":[{"name":"self"},{"name":"inferctxt"},{"name":"defid"},{"name":"regionvid"},{"name":"regionvid"},{"name":"span"}],"output":null}],[11,"blame_span","","Tries to finds a good span to blame for the fact that `fr1` contains `fr2`.",34,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"span"}}],[11,"dependencies","","Finds all regions whose values `'a` may depend on in some way. For each region, returns either `None` (does not influence `'a`) or `Some(d)` which indicates that it influences `'a` with distinct `d` (minimum number of edges that must be traversed).",34,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["regionvid","option"],"name":"indexvec"}}],[11,"why_region_contains_point","","Returns the reason that the region `r` contains the given point.",37,{"inputs":[{"name":"self"},{"name":"r"},{"name":"location"}],"output":{"generics":["rc"],"name":"option"}}],[11,"new","","",36,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"self"}}],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"root_cause","","",41,{"inputs":[{"name":"self"}],"output":{"name":"cause"}}],[0,"renumber","rustc_mir::borrow_check::nll","",null,null],[3,"NLLVisitor","rustc_mir::borrow_check::nll::renumber","",null,null],[12,"infcx","","",54,null],[5,"renumber_mir","","Replaces all free regions appearing in the MIR with fresh inference variables, returning the number of variables created.",null,{"inputs":[{"name":"inferctxt"},{"name":"mir"}],"output":null}],[5,"renumber_regions","","Replaces all regions appearing in `value` with fresh inference variables.",null,{"inputs":[{"name":"inferctxt"},{"name":"tycontext"},{"name":"t"}],"output":{"name":"t"}}],[11,"renumber_regions","","",54,{"inputs":[{"name":"self"},{"name":"tycontext"},{"name":"t"}],"output":{"name":"t"}}],[11,"visit_ty","","",54,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_substs","","",54,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"location"}],"output":null}],[11,"visit_region","","",54,{"inputs":[{"name":"self"},{"name":"region"},{"name":"location"}],"output":null}],[11,"visit_const","","",54,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_generator_interior","","",54,{"inputs":[{"name":"self"},{"name":"generatorinterior"},{"name":"location"}],"output":null}],[11,"visit_closure_substs","","",54,{"inputs":[{"name":"self"},{"name":"closuresubsts"},{"name":"location"}],"output":null}],[11,"visit_user_assert_ty","","",54,{"inputs":[{"name":"self"},{"name":"canonicalty"},{"name":"local"},{"name":"location"}],"output":null}],[11,"visit_statement","","",54,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[0,"subtype_constraint_generation","rustc_mir::borrow_check::nll","",null,null],[3,"SubtypeConstraintGenerator","rustc_mir::borrow_check::nll::subtype_constraint_generation","",null,null],[12,"regioncx","","",55,null],[12,"location_table","","",55,null],[12,"mir","","",55,null],[5,"generate","","When the MIR type-checker executes, it validates all the types in the MIR, and in the process generates a set of constraints that must hold regarding the regions in the MIR, along with locations where they must hold. This code takes those constriants and adds them into the NLL `RegionInferenceContext`.",null,{"inputs":[{"name":"regioninferencecontext"},{"name":"option"},{"name":"locationtable"},{"name":"mir"},{"name":"mirtypeckregionconstraints"}],"output":null}],[11,"generate","","",55,{"inputs":[{"name":"self"},{"name":"mirtypeckregionconstraints"},{"name":"option"}],"output":null}],[11,"verify_to_type_test","","",55,{"inputs":[{"name":"self"},{"name":"verify"},{"name":"span"},{"name":"locations"}],"output":{"name":"typetest"}}],[11,"verify_bound_to_region_test","","",55,{"inputs":[{"name":"self"},{"name":"verifybound"}],"output":{"name":"regiontest"}}],[11,"to_region_vid","","",55,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"regionvid"}}],[0,"type_check","rustc_mir::borrow_check::nll","This pass type-checks the MIR to ensure it is not broken.",null,null],[3,"TypeVerifier","rustc_mir::borrow_check::nll::type_check","Verifies that MIR types are sane to not crash further checks.",null,null],[12,"cx","","",56,null],[12,"mir","","",56,null],[12,"last_span","","",56,null],[12,"body_id","","",56,null],[12,"errors_reported","","",56,null],[3,"TypeChecker","","The MIR type checker. Visits the MIR and enforces all the constraints needed for it to be valid and well-typed. Along the way, it accrues region constraints -- these can later be used by NLL region checking.",null,null],[12,"infcx","","",57,null],[12,"param_env","","",57,null],[12,"last_span","","",57,null],[12,"body_id","","",57,null],[12,"region_bound_pairs","","",57,null],[12,"implicit_region_bound","","",57,null],[12,"reported_errors","","",57,null],[12,"constraints","","",57,null],[3,"MirTypeckRegionConstraints","","A collection of region constraints that must be satisfied for the program to be considered well-typed.",null,null],[12,"liveness_set","","In general, the type-checker is not responsible for enforcing liveness constraints; this job falls to the region inferencer, which performs a liveness analysis. However, in some limited cases, the MIR type-checker creates temporary regions that do not otherwise appear in the MIR -- in particular, the late-bound regions that it instantiates at call-sites -- and hence it must report on their liveness constraints.",58,null],[12,"outlives_sets","","During the course of type-checking, we will accumulate region constraints due to performing subtyping operations or solving traits. These are accumulated into this vector for later use.",58,null],[3,"OutlivesSet","","Outlives relationships between regions and types created at a particular point within the control-flow graph.",null,null],[12,"locations","","The locations associated with these constraints.",59,null],[12,"data","","Constraints generated. In terms of the NLL RFC, when you have a constraint `R1: R2 @ P`, the data in there specifies things like `R1: R2`.",59,null],[3,"TypeckMir","","",null,null],[4,"FieldAccessError","","",null,null],[13,"OutOfRange","","",60,null],[12,"field_count","rustc_mir::borrow_check::nll::type_check::FieldAccessError","",60,null],[4,"Locations","rustc_mir::borrow_check::nll::type_check","The `Locations` type summarizes where region constraints are required to hold. Normally, this is at a particular point which created the obligation, but for constraints that the user gave, we want the constraint to hold at all points.",null,null],[13,"All","","Indicates that a type constraint should always be true. This is particularly important in the new borrowck analysis for things like the type of the return slot. Consider this example:",61,null],[13,"Pair","","",61,null],[12,"from_location","rustc_mir::borrow_check::nll::type_check::Locations","The location in the MIR that generated these constraints. This is intended for error reporting and diagnosis; the constraints may take effect at a distinct spot.",61,null],[12,"at_location","","The constraints must be met at this location. In terms of the NLL RFC, when you have a constraint `R1: R2 @ P`, this field is the `P` value.",61,null],[5,"type_check","rustc_mir::borrow_check::nll::type_check","Type checks the given `mir` in the context of the inference context `infcx`. Returns any region constraints that have yet to be proven. This result is includes liveness constraints that ensure that regions appearing in the types of all local variables are live at all points where that local variable may later be used.",null,{"inputs":[{"name":"inferctxt"},{"name":"paramenv"},{"name":"mir"},{"name":"defid"},{"name":"universalregions"},{"name":"livenessresults"},{"name":"flowatlocation"},{"name":"movedata"}],"output":{"name":"mirtypeckregionconstraints"}}],[5,"type_check_internal","","",null,null],[5,"mirbug","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"str"}],"output":null}],[0,"input_output","","This module contains code to equate the input/output types appearing in the MIR with the expected input/output types from the function signature. This requires a bit of processing, as the expected types are supplied to us before normalization and may contain existential `impl Trait` instances. In contrast, the input/output types found in the MIR (specifically, in the special local variables for the `RETURN_PLACE` the MIR arguments) are always fully normalize (and contain revealed `impl Trait` values).",null,null],[3,"ObligationAccumulator","rustc_mir::borrow_check::nll::type_check::input_output","",null,null],[12,"obligations","","",62,null],[11,"equate_inputs_and_outputs","rustc_mir::borrow_check::nll::type_check","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"defid"},{"name":"universalregions"}],"output":null}],[11,"equate_normalized_input_or_output","","",57,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":null}],[11,"fmt","rustc_mir::borrow_check::nll::type_check::input_output","",62,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",62,{"inputs":[],"output":{"name":"obligationaccumulator"}}],[11,"add","","",62,{"inputs":[{"name":"self"},{"name":"inferok"}],"output":{"name":"t"}}],[11,"into_vec","","",62,{"inputs":[{"name":"self"}],"output":{"name":"predicateobligations"}}],[0,"liveness","rustc_mir::borrow_check::nll::type_check","",null,null],[3,"TypeLivenessGenerator","rustc_mir::borrow_check::nll::type_check::liveness","",null,null],[12,"cx","","",63,null],[12,"tcx","","",63,null],[12,"mir","","",63,null],[12,"liveness","","",63,null],[12,"flow_inits","","",63,null],[12,"move_data","","",63,null],[5,"generate","","Combines liveness analysis with initialization analysis to determine which variables are live at which points, both due to ordinary uses and drops. Returns a set of (ty, location) pairs that indicate which types must be live at which point in the CFG. This vector is consumed by `constraint_generation`.",null,{"inputs":[{"name":"typechecker"},{"name":"mir"},{"name":"livenessresults"},{"name":"flowatlocation"},{"name":"movedata"}],"output":null}],[11,"add_liveness_constraints","","Liveness constraints:",63,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":null}],[11,"push_type_live_constraint","","Some variable with type `live_ty` is \"regular live\" at `location` -- i.e., it may be used later. This means that all regions appearing in the type `live_ty` must be live at `location`.",63,{"inputs":[{"name":"self"},{"name":"t"},{"name":"location"},{"name":"cause"}],"output":null}],[11,"add_drop_live_constraint","","Some variable with type `live_ty` is \"drop live\" at `location` -- i.e., it may be dropped later. This means that some of the regions in its type must be live at `location`. The precise set will depend on the dropck constraints, and in particular this takes `#[may_dangle]` into account.",63,{"inputs":[{"name":"self"},{"name":"local"},{"name":"ty"},{"name":"location"}],"output":null}],[8,"AtLocation","rustc_mir::borrow_check::nll::type_check","",null,null],[10,"at_self","","Creates a `Locations` where `self` is both the from-location and the at-location. This means that any required region relationships must hold upon entering the statement/terminator indicated by `self`. This is typically used when processing \"inputs\" to the given location.",64,{"inputs":[{"name":"self"}],"output":{"name":"locations"}}],[10,"at_successor_within_block","","Creates a `Locations` where `self` is the from-location and its successor within the block is the at-location. This means that any required region relationships must hold only upon exiting the statement/terminator indicated by `self`. This is for example used when you have a `place = rv` statement: it indicates that the `typeof(rv) <: typeof(place)` as of the next statement.",64,{"inputs":[{"name":"self"}],"output":{"name":"locations"}}],[8,"ToLocations","","",null,null],[10,"to_locations","","",65,{"inputs":[{"name":"self"}],"output":{"name":"locations"}}],[11,"visit_span","","",56,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"visit_place","","",56,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_constant","","",56,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",56,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_local_decl","","",56,{"inputs":[{"name":"self"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"visit_mir","","",56,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"new","","",56,{"inputs":[{"name":"typechecker"},{"name":"mir"}],"output":{"name":"self"}}],[11,"tcx","","",56,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"sanitize_type","","",56,{"inputs":[{"name":"self"},{"name":"debug"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"sanitize_constant","","Checks that the constant's `ty` field matches up with what would be expected from its literal.",56,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"sanitize_place","","Checks that the types internal to the `place` match up with what would be expected.",56,{"inputs":[{"name":"self"},{"name":"place"},{"name":"location"},{"name":"placecontext"}],"output":{"name":"placety"}}],[11,"sanitize_projection","","",56,{"inputs":[{"name":"self"},{"name":"placety"},{"name":"placeelem"},{"name":"place"},{"name":"location"}],"output":{"name":"placety"}}],[11,"error","","",56,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"field_ty","","",56,{"inputs":[{"name":"self"},{"name":"debug"},{"name":"placety"},{"name":"field"},{"name":"location"}],"output":{"generics":["ty","fieldaccesserror"],"name":"result"}}],[11,"default","","",58,{"inputs":[],"output":{"name":"mirtypeckregionconstraints"}}],[11,"clone","","",61,{"inputs":[{"name":"self"}],"output":{"name":"locations"}}],[11,"fmt","","",61,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_location","","",61,{"inputs":[{"name":"self"}],"output":{"generics":["location"],"name":"option"}}],[11,"at_location","","",61,{"inputs":[{"name":"self"}],"output":{"generics":["location"],"name":"option"}}],[11,"new","","",57,null],[11,"misc","","",57,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"obligationcause"}}],[11,"fully_perform_op","","",57,{"inputs":[{"name":"self"},{"name":"locations"},{"name":"op"}],"output":{"generics":["typeerror"],"name":"result"}}],[11,"sub_types","","",57,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"locations"}],"output":{"name":"unitresult"}}],[11,"eq_types","","",57,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"locations"}],"output":{"name":"unitresult"}}],[11,"tcx","","",57,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"check_stmt","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"check_terminator","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"check_call_dest","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"terminator"},{"name":"fnsig"},{"name":"option"},{"name":"location"}],"output":null}],[11,"check_call_inputs","","",57,null],[11,"check_iscleanup","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"basicblockdata"}],"output":null}],[11,"assert_iscleanup","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"debug"},{"name":"basicblock"},{"name":"bool"}],"output":null}],[11,"check_local","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"aggregate_field_ty","","",57,{"inputs":[{"name":"self"},{"name":"aggregatekind"},{"name":"usize"},{"name":"location"}],"output":{"generics":["ty","fieldaccesserror"],"name":"result"}}],[11,"check_rvalue","","",57,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"check_aggregate_rvalue","","",57,null],[11,"prove_aggregate_predicates","","",57,{"inputs":[{"name":"self"},{"name":"aggregatekind"},{"name":"location"}],"output":null}],[11,"prove_trait_ref","","",57,{"inputs":[{"name":"self"},{"name":"traitref"},{"name":"location"}],"output":null}],[11,"prove_predicates","","",57,{"inputs":[{"name":"self"},{"name":"t"},{"name":"location"}],"output":null}],[11,"typeck_mir","","",57,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"normalize","","",57,null],[11,"run_pass","","",66,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"to_locations","","",61,{"inputs":[{"name":"self"}],"output":{"name":"locations"}}],[0,"universal_regions","rustc_mir::borrow_check::nll","Code to extract the universally quantified regions declared on a function and the relationships between them. For example:",null,null],[3,"UniversalRegions","rustc_mir::borrow_check::nll::universal_regions","",null,null],[12,"indices","","",67,null],[12,"fr_static","","The vid assigned to `'static`",67,null],[12,"fr_fn_body","","A special region vid created to represent the current MIR fn body.  It will outlive the entire CFG but it will not outlive any other universal regions.",67,null],[12,"first_extern_index","","We create region variables such that they are ordered by their `RegionClassification`. The first block are globals, then externals, then locals. So things from: - `FIRST_GLOBAL_INDEX..first_extern_index` are global; - `first_extern_index..first_local_index` are external; and - first_local_index..num_universals` are local.",67,null],[12,"first_local_index","","See `first_extern_index`.",67,null],[12,"num_universals","","The total number of universal region variables instantiated.",67,null],[12,"defining_ty","","The \"defining\" type for this function, with all universal regions instantiated.  For a closure or generator, this is the closure type, but for a top-level function it's the `TyFnDef`.",67,null],[12,"unnormalized_output_ty","","The return type of this function, with all regions replaced by their universal `RegionVid` equivalents.",67,null],[12,"unnormalized_input_tys","","The fully liberated input types of this function, with all regions replaced by their universal `RegionVid` equivalents.",67,null],[12,"region_bound_pairs","","Each RBP `('a, GK)` indicates that `GK: 'a` can be assumed to be true. These encode relationships like `T: 'a` that are added via implicit bounds.",67,null],[12,"yield_ty","","",67,null],[12,"relations","","",67,null],[3,"UniversalRegionIndices","","",null,null],[12,"indices","","For those regions that may appear in the parameter environment ('static and early-bound regions), we maintain a map from the `ty::Region` to the internal `RegionVid` we are using. This is used because trait matching and type-checking will feed us region constraints that reference those regions and we need to be able to map them our internal `RegionVid`. This is basically equivalent to a `Substs`, except that it also contains an entry for `ReStatic` -- it might be nice to just use a substs, and then handle `ReStatic` another way.",68,null],[3,"UniversalRegionRelations","","",null,null],[12,"outlives","","Stores the outlives relations that are known to hold from the implied bounds, in-scope where clauses, and that sort of thing.",69,null],[12,"inverse_outlives","","This is the `<=` relation; that is, if `a: b`, then `b <= a`, and we store that here. This is useful when figuring out how to express some local region in terms of external regions our caller will understand.",69,null],[3,"UniversalRegionsBuilder","","",null,null],[12,"infcx","","",70,null],[12,"mir_def_id","","",70,null],[12,"mir_hir_id","","",70,null],[12,"mir_node_id","","",70,null],[12,"param_env","","",70,null],[12,"region_bound_pairs","","",70,null],[12,"relations","","",70,null],[4,"DefiningTy","","The \"defining type\" for this MIR. The key feature of the \"defining type\" is that it contains the information needed to derive all the universal regions that are in scope as well as the types of the inputs/output from the MIR. In general, early-bound universal regions appear free in the defining type and late-bound regions appear bound in the signature.",null,null],[13,"Closure","","The MIR is a closure. The signature is found via `ClosureSubsts::closure_sig_ty`.",71,null],[13,"Generator","","The MIR is a generator. The signature is that generators take no parameters and return the result of `ClosureSubsts::generator_return_ty`.",71,null],[13,"FnDef","","The MIR is a fn item with the given def-id and substs. The signature of the function can be bound then with the `fn_sig` query.",71,null],[13,"Const","","The MIR represents some form of constant. The signature then is that it has no inputs and a single return value, which is the value of the constant.",71,null],[4,"RegionClassification","","",null,null],[13,"Global","","A global region is one that can be named from anywhere. There is only one, `'static`.",72,null],[13,"External","","An external region is only relevant for closures. In that case, it refers to regions that are free in the closure type -- basically, something bound in the surrounding context.",72,null],[13,"Local","","A local lifetime is one about which we know the full set of relevant constraints (that is, relationships to other named regions).  For a closure, this includes any region bound in the closure's signature.  For a fn item, this includes all regions other than global ones.",72,null],[17,"FIRST_GLOBAL_INDEX","","",null,null],[17,"FR","","",null,null],[8,"InferCtxtExt","","",null,null],[10,"replace_free_regions_with_nll_infer_vars","","",73,{"inputs":[{"name":"self"},{"name":"nllregionvariableorigin"},{"name":"t"}],"output":{"name":"t"}}],[10,"replace_bound_regions_with_nll_infer_vars","","",73,{"inputs":[{"name":"self"},{"name":"nllregionvariableorigin"},{"name":"defid"},{"name":"binder"},{"name":"universalregionindices"}],"output":{"name":"t"}}],[11,"fmt","","",67,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",71,{"inputs":[{"name":"self"}],"output":{"name":"definingty"}}],[11,"fmt","","",71,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",68,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",69,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",72,{"inputs":[{"name":"self"}],"output":{"name":"regionclassification"}}],[11,"fmt","","",72,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"self"},{"name":"regionclassification"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",72,null],[11,"hash","","",72,null],[11,"new","","Creates a new and fully initialized `UniversalRegions` that contains indices for all the free regions found in the given MIR -- that is, all the regions that appear in the function's signature. This will also compute the relationships that are known between those regions.",67,{"inputs":[{"name":"inferctxt"},{"name":"defid"},{"name":"paramenv"}],"output":{"name":"self"}}],[11,"closure_mapping","","Given a reference to a closure type, extracts all the values from its free regions and returns a vector with them. This is used when the closure's creator checks that the `ClosureRegionRequirements` are met. The requirements from `ClosureRegionRequirements` are expressed in terms of `RegionVid` entries that map into the returned vector `V`: so if the `ClosureRegionRequirements` contains something like `'1: '2`, then the caller would impose the constraint that `V[1]: V[2]`.",67,{"inputs":[{"name":"inferctxt"},{"name":"ty"},{"name":"usize"}],"output":{"generics":["regionvid","region"],"name":"indexvec"}}],[11,"is_universal_region","","True if `r` is a member of this set of universal regions.",67,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"region_classification","","Classifies `r` as a universal region, returning `None` if this is not a member of this set of universal regions.",67,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["regionclassification"],"name":"option"}}],[11,"universal_regions","","Returns an iterator over all the RegionVids corresponding to universally quantified free regions.",67,null],[11,"is_local_free_region","","True if `r` is classified as an local region.",67,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"len","","Returns the number of universal regions created in any category.",67,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"postdom_upper_bound","","Given two universal regions, returns the postdominating upper-bound (effectively the least upper bound).",67,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"non_local_upper_bound","","Finds an \"upper bound\" for `fr` that is not local. In other words, returns the smallest (*) known region `fr1` that (a) outlives `fr` and (b) is not local. This cannot fail, because we will always find `'static` at worst.",67,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"non_local_lower_bound","","Finds a \"lower bound\" for `fr` that is not local. In other words, returns the largest (*) known region `fr1` that (a) is outlived by `fr` and (b) is not local. This cannot fail, because we will always find `'static` at worst.",67,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["regionvid"],"name":"option"}}],[11,"num_global_and_external_regions","","Returns the number of global plus external universal regions. For closures, these are the regions that appear free in the closure type (versus those bound in the closure signature). They are therefore the regions between which the closure may impose constraints that its creator must verify.",67,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"non_local_bound","","Helper for `non_local_upper_bound` and `non_local_lower_bound`.  Repeatedly invokes `postdom_parent` until we find something that is not local. Returns None if we never do so.",67,{"inputs":[{"name":"self"},{"name":"transitiverelation"},{"name":"regionvid"}],"output":{"generics":["regionvid"],"name":"option"}}],[11,"outlives","","True if fr1 is known to outlive fr2.",67,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"regions_outlived_by","","Returns a vector of free regions `x` such that `fr1: x` is known to hold.",67,{"inputs":[{"name":"self"},{"name":"regionvid"}],"output":{"generics":["regionvid"],"name":"vec"}}],[11,"named_universal_regions","","Get an iterator over all the early-bound regions that have names.",67,null],[11,"to_region_vid","","See `UniversalRegionIndices::to_region_vid`.",67,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"regionvid"}}],[11,"build","","",70,{"inputs":[{"name":"self"}],"output":{"name":"universalregions"}}],[11,"defining_ty","","Returns the \"defining type\" of the current MIR; see `DefiningTy` for details.",70,{"inputs":[{"name":"self"}],"output":{"name":"definingty"}}],[11,"compute_indices","","Builds a hashmap that maps from the universal regions that are in scope (as a `ty::Region<'tcx>`) to their indices (as a `RegionVid`). The map returned by this function contains only the early-bound regions.",70,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"definingty"}],"output":{"name":"universalregionindices"}}],[11,"compute_inputs_and_output","","",70,{"inputs":[{"name":"self"},{"name":"universalregionindices"},{"name":"definingty"}],"output":{"generics":["slice"],"name":"binder"}}],[11,"add_implied_bounds","","Update the type of a single local, which should represent either the return type of the MIR or one of its arguments. At the same time, compute and add any implied bounds that come from this local.",70,{"inputs":[{"name":"self"},{"name":"universalregionindices"},{"name":"ty"}],"output":null}],[11,"add_outlives_bounds","","Registers the `OutlivesBound` items from `outlives_bounds` in the outlives relation as well as the region-bound pairs listing.",70,{"inputs":[{"name":"self"},{"name":"universalregionindices"},{"name":"i"}],"output":null}],[11,"relate_universal_regions","","Records in the `outlives_relation` (and `inverse_outlives_relation`) that `fr_a: fr_b`.",69,{"inputs":[{"name":"self"},{"name":"regionvid"},{"name":"regionvid"}],"output":null}],[11,"insert_late_bound_region","","Initially, the `UniversalRegionIndices` map contains only the early-bound regions in scope. Once that is all setup, we come in later and instantiate the late-bound regions, and then we insert the `ReFree` version of those into the map as well. These are used for error reporting.",68,{"inputs":[{"name":"self"},{"name":"region"},{"name":"regionvid"}],"output":null}],[11,"to_region_vid","","Converts `r` into a local inference variable: `r` can either by a `ReVar` (i.e., already a reference to an inference variable) or it can be `'static` or some early-bound region. This is useful when taking the results from type-checking and trait-matching, which may sometimes reference those regions from the `ParamEnv`. It is also used during initialization. Relies on the `indices` map having been fully initialized.",68,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"regionvid"}}],[11,"fold_to_region_vids","","Replace all free regions in `value` with region vids, as returned by `to_region_vid`.",68,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"sub_free_regions","","",67,{"inputs":[{"name":"self"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[8,"ToRegionVid","rustc_mir::borrow_check::nll","Right now, we piggy back on the `ReVar` to store our NLL inference regions. These are indexed with `RegionVid`. This method will assert that the region is a `ReVar` and extract its internal index. This is reasonable because in our MIR we replace all universal regions with inference variables.",null,null],[10,"to_region_vid","","",74,{"inputs":[{"name":"self"}],"output":{"name":"regionvid"}}],[11,"mir","rustc_mir::borrow_check","",0,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"visit_block_entry","","",0,null],[11,"visit_statement_entry","","",0,null],[11,"visit_terminator_entry","","",0,null],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"mutatemode"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",4,null],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"control"}}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"control"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",5,null],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"artificialfield"}}],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"artificialfield"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",6,null],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"shallowordeep"}}],[11,"eq","","",7,{"inputs":[{"name":"self"},{"name":"shallowordeep"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"self"},{"name":"shallowordeep"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",7,null],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",8,{"inputs":[{"name":"self"}],"output":{"name":"readorwrite"}}],[11,"eq","","",8,{"inputs":[{"name":"self"},{"name":"readorwrite"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"readorwrite"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",8,null],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"readkind"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"readkind"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"readkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",9,null],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"writekind"}}],[11,"eq","","",10,{"inputs":[{"name":"self"},{"name":"writekind"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"self"},{"name":"writekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",10,null],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",11,{"inputs":[{"name":"self"}],"output":{"name":"localmutationisallowed"}}],[11,"eq","","",11,{"inputs":[{"name":"self"},{"name":"localmutationisallowed"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",11,null],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",12,{"inputs":[{"name":"self"}],"output":{"name":"initializationrequiringaction"}}],[11,"as_noun","","",12,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"as_verb_in_past_tense","","",12,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"allow_two_phase_borrow","","Returns true if the borrow represented by `kind` is allowed to be split into separate Reservation and Activation phases.",0,{"inputs":[{"name":"self"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"visit_terminator_drop","","Invokes `access_place` as appropriate for dropping the value at `drop_place`. Note that the actual `Drop` in the MIR is always for a variable (e.g., `Drop(x)`) -- but we recursively break this variable down into subpaths (e.g., `Drop(x.foo)`) to indicate more precisely which fields might actually be accessed by a destructor.",0,{"inputs":[{"name":"self"},{"name":"location"},{"name":"terminator"},{"name":"flows"},{"name":"place"},{"name":"ty"},{"name":"span"}],"output":null}],[11,"access_place","","Checks an access to the given place to see if it is allowed. Examines the set of borrows that are in scope, as well as which paths have been initialized, to ensure that (a) the place is initialized and (b) it is not borrowed in some way that would prevent this access.",0,null],[11,"check_access_for_conflict","","",0,null],[11,"mutate_place","","",0,null],[11,"consume_rvalue","","",0,null],[11,"consume_operand","","",0,null],[11,"check_for_invalidation_at_exit","","Returns whether a borrow of this place is invalidated when the function exits",0,{"inputs":[{"name":"self"},{"name":"context"},{"name":"borrowdata"},{"name":"span"}],"output":null}],[11,"check_for_local_borrow","","Reports an error if this is a borrow of local data. This is called for all Yield statements on movable generators",0,{"inputs":[{"name":"self"},{"name":"borrowdata"},{"name":"span"}],"output":null}],[11,"check_activations","","",0,{"inputs":[{"name":"self"},{"name":"location"},{"name":"span"},{"name":"flows"}],"output":null}],[11,"check_if_reassignment_to_immutable_state","","",0,null],[11,"check_if_full_path_is_moved","","",0,null],[11,"check_if_path_or_subpath_is_moved","","",0,null],[11,"move_path_closest_to","","Currently MoveData does not store entries for all places in the input MIR. For example it will currently filter out places that are Copy; thus we do not track places of shared reference type. This routine will walk up a place along its prefixes, searching for a foundational place that is tracked in the MoveData.",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["movepathindex","nomovepathfound"],"name":"result"}}],[11,"move_path_for_place","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["movepathindex"],"name":"option"}}],[11,"check_if_assigned_path_is_moved","","",0,null],[11,"specialized_description","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["string"],"name":"option"}}],[11,"get_default_err_msg","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"string"}}],[11,"get_secondary_err_msg","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"string"}}],[11,"get_primary_err_msg","","",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"string"}}],[11,"check_access_permissions","","Check the permissions for the given place and read or write kind",0,null],[11,"add_used_mut","","Adds the place into the used mutable variables set",0,{"inputs":[{"name":"self"},{"name":"rootplace"},{"name":"flows"}],"output":null}],[11,"is_mutable","","Whether this value be written or borrowed mutably. Returns the root place if the place passed in is a projection.",0,{"inputs":[{"name":"self"},{"name":"place"},{"name":"localmutationisallowed"}],"output":{"generics":["rootplace","place"],"name":"result"}}],[11,"is_upvar_field_projection","","If this is a field projection, and the field is being projected from a closure type, then returns the index of the field being projected. Note that this closure will always be `self` in the current MIR, because that is the only time we directly access the fields of a closure type.",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["field"],"name":"option"}}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"nomovepathfound"}}],[11,"eq","","",13,{"inputs":[{"name":"self"},{"name":"nomovepathfound"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",13,null],[11,"fmt","","",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"place_element_conflict","","",0,{"inputs":[{"name":"self"},{"name":"place"},{"name":"place"}],"output":{"name":"overlap"}}],[11,"places_conflict","","Returns whether an access of kind `access` to `access_place` conflicts with a borrow/full access to `borrow_place` (for deep accesses to mutable locations, this function is symmetric between `borrow_place` & `access_place`).",0,{"inputs":[{"name":"self"},{"name":"place"},{"name":"place"},{"name":"shallowordeep"}],"output":{"name":"bool"}}],[11,"each_borrow_involving_path","","This function iterates over all of the in-scope borrows that conflict with an access to a place, invoking the `op` callback for each one.",0,null],[11,"is_active","","",0,{"inputs":[{"name":"self"},{"name":"borrowdata"},{"name":"location"}],"output":{"name":"bool"}}],[11,"base_path","","Returns the base of the leftmost (deepest) dereference of an Box in `place`. If there is no dereference of an Box in `place`, then it just returns `place` itself.",0,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"place"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"context"}}],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"context"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",15,{"inputs":[{"name":"self"}],"output":{"name":"contextkind"}}],[11,"eq","","",15,{"inputs":[{"name":"self"},{"name":"contextkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",15,null],[11,"fmt","","",15,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",15,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"context"}}],[0,"build","rustc_mir","",null,null],[3,"GlobalizeMir","rustc_mir::build","A pass to lift all the types and substitutions in a Mir to the global tcx. Sadly, we don't have a \"folder\" that can change 'tcx so we have to transmute afterwards.",null,null],[12,"tcx","","",75,null],[12,"span","","",75,null],[3,"Builder","","",null,null],[12,"hir","","",76,null],[12,"cfg","","",76,null],[12,"fn_span","","",76,null],[12,"arg_count","","",76,null],[12,"scopes","","the current set of scopes, updated as we traverse; see the `scope` module for more details",76,null],[12,"unpushed_unsafe","","The current unsafe block in scope, even if it is hidden by a PushUnsafeBlock",76,null],[12,"push_unsafe_count","","The number of `push_unsafe_block` levels in scope",76,null],[12,"breakable_scopes","","the current set of breakables; see the `scope` module for more details",76,null],[12,"visibility_scopes","","the vector of all scopes that we have created thus far; we track this for debuginfo later",76,null],[12,"visibility_scope_info","","",76,null],[12,"visibility_scope","","",76,null],[12,"guard_context","","the guard-context: each time we build the guard expression for a match arm, we push onto this stack, and then pop when we finish building it.",76,null],[12,"var_indices","","Maps node ids of variable bindings to the `Local`s created for them. (A match binding can have two locals; the 2nd is for the arm's guard.)",76,null],[12,"local_decls","","",76,null],[12,"unit_temp","","",76,null],[12,"cached_resume_block","","cached block with the RESUME terminator; this is created when first set of cleanups are built.",76,null],[12,"cached_return_block","","cached block with the RETURN terminator",76,null],[12,"cached_unreachable_block","","cached block with the UNREACHABLE terminator",76,null],[3,"GuardFrameLocal","","",null,null],[12,"id","","",77,null],[3,"GuardFrame","","",null,null],[12,"locals","","These are the id's of names that are bound by patterns of the arm of this guard.",78,null],[3,"CFG","","",null,null],[12,"basic_blocks","","",79,null],[3,"ScopeId","","",null,null],[12,"0","","",80,null],[3,"BlockAnd","","The `BlockAnd` \"monad\" packages up the new basic block along with a produced value (sometimes just unit, of course). The `unpack!` macro (and methods below) makes working with `BlockAnd` much more convenient.",null,null],[12,"0","","",81,null],[12,"1","","",81,null],[4,"LocalsForNode","","",null,null],[13,"One","","",82,null],[13,"Two","","",82,null],[12,"for_guard","rustc_mir::build::LocalsForNode","",82,null],[12,"for_arm_body","","",82,null],[4,"ForGuard","rustc_mir::build","ForGuard is isomorphic to a boolean flag. It indicates whether we are talking about the temp for a local binding for a use within a guard expression, or a temp for use outside of a guard expressions.",null,null],[13,"WithinGuard","","",83,null],[13,"OutsideGuard","","",83,null],[5,"mir_build","","Construct the MIR for a given def-id.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"mir"}}],[5,"create_constructor_shim","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"variantdata"}],"output":{"name":"mir"}}],[5,"liberated_closure_env_ty","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"bodyid"}],"output":{"name":"ty"}}],[5,"should_abort_on_panic","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"abi"}],"output":{"name":"bool"}}],[5,"construct_fn","","the main entry point for building MIR for a function",null,{"inputs":[{"name":"cx"},{"name":"nodeid"},{"name":"a"},{"name":"safety"},{"name":"abi"},{"name":"ty"},{"generics":["ty"],"name":"option"},{"name":"body"}],"output":{"name":"mir"}}],[5,"construct_const","","",null,{"inputs":[{"name":"cx"},{"name":"bodyid"}],"output":{"name":"mir"}}],[5,"construct_error","","",null,{"inputs":[{"name":"cx"},{"name":"bodyid"}],"output":{"name":"mir"}}],[0,"block","","",null,null],[11,"ast_block","","",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"basicblock"},{"name":"block"},{"name":"sourceinfo"}],"output":{"name":"blockand"}}],[11,"ast_block_stmts","","",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"basicblock"},{"name":"span"},{"generics":["stmtref"],"name":"vec"},{"generics":["exprref"],"name":"option"},{"name":"blocksafety"}],"output":{"name":"blockand"}}],[11,"update_visibility_scope_for_safety_mode","","If we are changing the safety mode, create a new visibility scope",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"blocksafety"}],"output":null}],[0,"cfg","","Routines for manipulating the control-flow graph.",null,null],[11,"block_data","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"basicblockdata"}}],[11,"block_data_mut","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"basicblockdata"}}],[11,"start_new_block","","",79,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"start_new_cleanup_block","","",79,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"push","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"}],"output":null}],[11,"push_end_region","","",79,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"basicblock"},{"name":"sourceinfo"},{"name":"scope"}],"output":null}],[11,"push_assign","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"sourceinfo"},{"name":"place"},{"name":"rvalue"}],"output":null}],[11,"push_assign_constant","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"sourceinfo"},{"name":"place"},{"name":"constant"}],"output":null}],[11,"push_assign_unit","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"sourceinfo"},{"name":"place"}],"output":null}],[11,"terminate","","",79,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"sourceinfo"},{"name":"terminatorkind"}],"output":null}],[0,"expr","","Translates expressions into MIR. As a caller into this module, you have many options, but the first thing you have to decide is whether you are evaluating this expression for its value, its location, or as a constant.",null,null],[0,"as_constant","rustc_mir::build::expr","See docs in build/expr/mod.rs",null,null],[11,"as_constant","rustc_mir::build","Compile `expr`, yielding a compile-time constant. Assumes that `expr` is a valid compile-time constant!",76,{"inputs":[{"name":"self"},{"name":"m"}],"output":{"name":"constant"}}],[11,"expr_as_constant","","",76,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"constant"}}],[0,"as_place","rustc_mir::build::expr","See docs in build/expr/mod.rs",null,null],[11,"as_place","rustc_mir::build","Compile `expr`, yielding a place that we can move from etc.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"m"}],"output":{"generics":["place"],"name":"blockand"}}],[11,"expr_as_place","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"expr"}],"output":{"generics":["place"],"name":"blockand"}}],[0,"as_rvalue","rustc_mir::build::expr","See docs in build/expr/mod.rs",null,null],[11,"as_local_rvalue","rustc_mir::build","See comment on `as_local_operand`",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"m"}],"output":{"generics":["rvalue"],"name":"blockand"}}],[11,"as_rvalue","","Compile `expr`, yielding an rvalue.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["scope"],"name":"option"},{"name":"m"}],"output":{"generics":["rvalue"],"name":"blockand"}}],[11,"expr_as_rvalue","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["scope"],"name":"option"},{"name":"expr"}],"output":{"generics":["rvalue"],"name":"blockand"}}],[11,"build_binary_op","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"binop"},{"name":"span"},{"name":"ty"},{"name":"operand"},{"name":"operand"}],"output":{"generics":["rvalue"],"name":"blockand"}}],[11,"neg_1_literal","","",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"operand"}}],[11,"minval_literal","","",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"operand"}}],[0,"as_operand","rustc_mir::build::expr","See docs in build/expr/mod.rs",null,null],[11,"as_local_operand","rustc_mir::build","Returns an operand suitable for use until the end of the current scope expression.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"m"}],"output":{"generics":["operand"],"name":"blockand"}}],[11,"as_operand","","Compile `expr` into a value that can be used as an operand. If `expr` is a place like `x`, this will introduce a temporary `tmp = x`, so that we capture the value of `x` at this time.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["scope"],"name":"option"},{"name":"m"}],"output":{"generics":["operand"],"name":"blockand"}}],[11,"expr_as_operand","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["scope"],"name":"option"},{"name":"expr"}],"output":{"generics":["operand"],"name":"blockand"}}],[0,"as_temp","rustc_mir::build::expr","See docs in build/expr/mod.rs",null,null],[11,"as_temp","rustc_mir::build","Compile `expr` into a fresh temporary. This is used when building up rvalues so as to freeze the value that will be consumed.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["scope"],"name":"option"},{"name":"m"}],"output":{"generics":["local"],"name":"blockand"}}],[11,"expr_as_temp","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["scope"],"name":"option"},{"name":"expr"}],"output":{"generics":["local"],"name":"blockand"}}],[0,"category","rustc_mir::build::expr","",null,null],[4,"Category","rustc_mir::build::expr::category","",null,null],[13,"Place","","",84,null],[13,"Constant","","",84,null],[13,"Rvalue","","",84,null],[4,"RvalueFunc","","",null,null],[13,"Into","","",85,null],[13,"AsRvalue","","",85,null],[11,"fmt","","",84,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",84,{"inputs":[{"name":"self"},{"name":"category"}],"output":{"name":"bool"}}],[11,"ne","","",84,{"inputs":[{"name":"self"},{"name":"category"}],"output":{"name":"bool"}}],[11,"fmt","","",85,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",85,{"inputs":[{"name":"self"},{"name":"rvaluefunc"}],"output":{"name":"bool"}}],[11,"of","","",84,{"inputs":[{"name":"exprkind"}],"output":{"generics":["category"],"name":"option"}}],[0,"into","rustc_mir::build::expr","See docs in build/expr/mod.rs",null,null],[11,"into_expr","rustc_mir::build","Compile `expr`, storing the result into `destination`, which is assumed to be uninitialized.",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"basicblock"},{"name":"expr"}],"output":{"name":"blockand"}}],[0,"stmt","rustc_mir::build::expr","",null,null],[11,"stmt_expr","rustc_mir::build","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"expr"}],"output":{"name":"blockand"}}],[0,"into","","In general, there are a number of things for which it's convenient to just call `builder.into` and have it emit its result into a given location. This is basically for expressions or things that can be wrapped up as expressions (e.g. blocks). To make this ergonomic, we use this latter `EvalInto` trait.",null,null],[8,"EvalInto","rustc_mir::build::into","",null,null],[10,"eval_into","","",86,{"inputs":[{"name":"self"},{"name":"builder"},{"name":"place"},{"name":"basicblock"}],"output":{"name":"blockand"}}],[11,"into","rustc_mir::build","",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"basicblock"},{"name":"e"}],"output":{"name":"blockand"}}],[0,"matches","","Code related to match expressions. These are sufficiently complex to warrant their own module and submodules. :) This main module includes the high-level algorithm, the submodules contain the details.",null,null],[3,"ArmHasGuard","rustc_mir::build::matches","ArmHasGuard is isomorphic to a boolean flag. It indicates whether a match arm has a guard expression attached to it.",null,null],[12,"0","","",87,null],[3,"ArmBlocks","","List of blocks for each arm (and potentially other metadata in the future).",null,null],[12,"blocks","","",88,null],[3,"Candidate","","",null,null],[12,"span","","",89,null],[12,"match_pairs","","",89,null],[12,"bindings","","",89,null],[12,"guard","","",89,null],[12,"arm_index","","",89,null],[12,"pre_binding_block","","",89,null],[12,"next_candidate_pre_binding_block","","",89,null],[3,"Binding","","",null,null],[12,"span","","",90,null],[12,"source","","",90,null],[12,"name","","",90,null],[12,"var_id","","",90,null],[12,"var_ty","","",90,null],[12,"mutability","","",90,null],[12,"binding_mode","","",90,null],[3,"MatchPair","","",null,null],[12,"place","","",91,null],[12,"pattern","","",91,null],[12,"slice_len_checked","","",91,null],[3,"Test","","",null,null],[12,"span","","",92,null],[12,"kind","","",92,null],[4,"TestKind","","",null,null],[13,"Switch","","",93,null],[12,"adt_def","rustc_mir::build::matches::TestKind","",93,null],[12,"variants","","",93,null],[13,"SwitchInt","rustc_mir::build::matches","",93,null],[12,"switch_ty","rustc_mir::build::matches::TestKind","",93,null],[12,"options","","",93,null],[12,"indices","","",93,null],[13,"Eq","rustc_mir::build::matches","",93,null],[12,"value","rustc_mir::build::matches::TestKind","",93,null],[12,"ty","","",93,null],[13,"Range","rustc_mir::build::matches","",93,null],[12,"lo","rustc_mir::build::matches::TestKind","",93,null],[12,"hi","","",93,null],[12,"ty","","",93,null],[12,"end","","",93,null],[13,"Len","rustc_mir::build::matches","",93,null],[12,"len","rustc_mir::build::matches::TestKind","",93,null],[12,"op","","",93,null],[0,"simplify","rustc_mir::build::matches","Simplifying Candidates",null,null],[11,"simplify_candidate","rustc_mir::build","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"candidate"}],"output":{"name":"blockand"}}],[11,"simplify_match_pair","","Tries to simplify `match_pair`, returning true if successful. If successful, new match pairs and bindings will have been pushed into the candidate. If no simplification is possible, Err is returned and no changes are made to candidate.",76,{"inputs":[{"name":"self"},{"name":"matchpair"},{"name":"candidate"}],"output":{"generics":["matchpair"],"name":"result"}}],[0,"test","rustc_mir::build::matches","",null,null],[5,"is_switch_ty","rustc_mir::build::matches::test","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[11,"test","rustc_mir::build","Identifies what test is needed to decide if `match_pair` is applicable.",76,{"inputs":[{"name":"self"},{"name":"matchpair"}],"output":{"name":"test"}}],[11,"add_cases_to_switch","","",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"candidate"},{"name":"ty"},{"name":"vec"},{"name":"fxhashmap"}],"output":{"name":"bool"}}],[11,"add_variants_to_switch","","",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"candidate"},{"name":"bitvector"}],"output":{"name":"bool"}}],[11,"perform_test","","Generates the code to perform a test.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"test"}],"output":{"generics":["basicblock"],"name":"vec"}}],[11,"compare","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblock"},{"name":"span"},{"name":"binop"},{"name":"operand"},{"name":"operand"}],"output":{"name":"basicblock"}}],[11,"sort_candidate","","Given that we are performing `test` against `test_place`, this job sorts out what the status of `candidate` will be after the test. The `resulting_candidates` vector stores, for each possible outcome of `test`, a vector of the candidates that will result. This fn should add a (possibly modified) clone of candidate into `resulting_candidates` wherever appropriate.",76,null],[11,"candidate_without_match_pair","","",76,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"candidate"}],"output":{"name":"candidate"}}],[11,"candidate_after_slice_test","","",76,null],[11,"candidate_after_variant_switch","","",76,null],[11,"error_simplifyable","","",76,null],[0,"util","rustc_mir::build::matches","",null,null],[11,"field_match_pairs","rustc_mir::build","",76,null],[11,"prefix_slice_suffix","","",76,null],[11,"new","rustc_mir::build::matches","",91,{"inputs":[{"name":"place"},{"name":"pattern"}],"output":{"name":"matchpair"}}],[11,"clone","","",87,{"inputs":[{"name":"self"}],"output":{"name":"armhasguard"}}],[11,"fmt","","",87,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"match_expr","rustc_mir::build","",76,{"inputs":[{"name":"self"},{"name":"place"},{"name":"span"},{"name":"basicblock"},{"name":"exprref"},{"generics":["arm"],"name":"vec"}],"output":{"name":"blockand"}}],[11,"user_assert_ty","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"hirid"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"expr_into_pattern","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"generics":["hirid"],"name":"option"},{"name":"pattern"},{"name":"exprref"}],"output":{"name":"blockand"}}],[11,"place_into_pattern","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"pattern"},{"name":"place"}],"output":{"name":"blockand"}}],[11,"declare_bindings","","Declares the bindings of the given pattern and returns the visibility scope for the bindings in this patterns, if such a scope had to be created. NOTE: Declaring the bindings should always be done in their drop scope.",76,{"inputs":[{"name":"self"},{"generics":["visibilityscope"],"name":"option"},{"name":"span"},{"name":"lintlevel"},{"name":"pattern"},{"name":"armhasguard"}],"output":{"generics":["visibilityscope"],"name":"option"}}],[11,"storage_live_binding","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"nodeid"},{"name":"span"},{"name":"forguard"}],"output":{"name":"place"}}],[11,"schedule_drop_for_binding","","",76,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"forguard"}],"output":null}],[11,"visit_bindings","","",76,{"inputs":[{"name":"self"},{"name":"pattern"},{"name":"f"}],"output":null}],[11,"clone","rustc_mir::build::matches","",89,{"inputs":[{"name":"self"}],"output":{"name":"candidate"}}],[11,"fmt","","",89,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",90,{"inputs":[{"name":"self"}],"output":{"name":"binding"}}],[11,"fmt","","",90,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",91,{"inputs":[{"name":"self"}],"output":{"name":"matchpair"}}],[11,"fmt","","",91,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",93,{"inputs":[{"name":"self"}],"output":{"name":"testkind"}}],[11,"fmt","","",93,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",93,{"inputs":[{"name":"self"},{"name":"testkind"}],"output":{"name":"bool"}}],[11,"ne","","",93,{"inputs":[{"name":"self"},{"name":"testkind"}],"output":{"name":"bool"}}],[11,"fmt","","",92,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"match_candidates","rustc_mir::build","The main match algorithm. It begins with a set of candidates `candidates` and has the job of generating code to determine which of these candidates, if any, is the correct one. The candidates are sorted such that the first item in the list has the highest priority. When a candidate is found to match the value, we will generate a branch to the appropriate block found in `arm_blocks`.",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"armblocks"},{"generics":["candidate"],"name":"vec"},{"name":"basicblock"}],"output":{"generics":["basicblock"],"name":"vec"}}],[11,"join_otherwise_blocks","","",76,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["basicblock"],"name":"vec"}],"output":{"name":"basicblock"}}],[11,"test_candidates","","This is the most subtle part of the matching algorithm.  At this point, the input candidates have been fully simplified, and so we know that all remaining match-pairs require some sort of test. To decide what test to do, we take the highest priority candidate (last one in the list) and extract the first match-pair from the list. From this we decide what kind of test is needed using `test`, defined in the `test` module.",76,null],[11,"bind_and_guard_matched_candidate","","Initializes each of the bindings from the candidate by moving/copying/ref'ing the source as appropriate. Tests the guard, if any, and then branches to the arm. Returns the block for the case where the guard fails.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"armblocks"},{"name":"candidate"}],"output":{"generics":["basicblock"],"name":"option"}}],[11,"bind_matched_candidate_for_guard","","",76,null],[11,"bind_matched_candidate_for_arm_body","","",76,null],[11,"declare_binding","","Each binding (`ref mut var`/`ref var`/`mut var`/`var`, where the bound `var` has type `T` in the arm body) in a pattern maps to two locals. The first local is a binding for occurrences of `var` in the guard, which will all have type `&T`. The second local is a binding for occurrences of `var` in the arm body, which will have type `T`.",76,{"inputs":[{"name":"self"},{"name":"sourceinfo"},{"name":"visibilityscope"},{"name":"mutability"},{"name":"name"},{"name":"nodeid"},{"name":"ty"},{"name":"armhasguard"}],"output":null}],[0,"misc","","Miscellaneous builder routines that are not specific to building any particular kind of thing.",null,null],[11,"temp","","Add a new temporary value of type `ty` storing the result of evaluating `expr`.",76,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"name":"place"}}],[11,"literal_operand","","",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"literal"}],"output":{"name":"operand"}}],[11,"unit_rvalue","","",76,{"inputs":[{"name":"self"}],"output":{"name":"rvalue"}}],[11,"zero_literal","","",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"operand"}}],[11,"push_usize","","",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"sourceinfo"},{"name":"u64"}],"output":{"name":"place"}}],[11,"consume_by_copy_or_move","","",76,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"operand"}}],[0,"scope","","Managing the scope stack. The scopes are tied to lexical scopes, so as we descend the HAIR, we push a scope on the stack, translate ite contents, and then pop it off. Every scope is named by a `region::Scope`.",null,null],[3,"Scope","rustc_mir::build::scope","",null,null],[12,"visibility_scope","","The visibility scope this scope was created in.",94,null],[12,"region_scope","","the region span of this scope within source code.",94,null],[12,"region_scope_span","","the span of that region_scope",94,null],[12,"needs_cleanup","","Whether there's anything to do for the cleanup path, that is, when unwinding through this scope. This includes destructors, but not StorageDead statements, which don't get emitted at all for unwinding, for several reasons:  * clang doesn't emit llvm.lifetime.end for C++ unwinding  * LLVM's memory dependency analysis can't handle it atm  * polluting the cleanup MIR with StorageDead creates    landing pads even though there's no actual destructors  * freeing up stack space has no effect during unwinding",94,null],[12,"drops","","set of places to drop when exiting this scope. This starts out empty but grows as variables are declared during the building process. This is a stack, so we always drop from the end of the vector (top of the stack) first.",94,null],[12,"cached_exits","","The cache for drop chain on “normal” exit into a particular BasicBlock.",94,null],[12,"cached_generator_drop","","The cache for drop chain on \"generator drop\" exit.",94,null],[12,"cached_unwind","","The cache for drop chain on \"unwind\" exit.",94,null],[3,"DropData","","",null,null],[12,"span","","span where drop obligation was incurred (typically where place was declared)",95,null],[12,"location","","place to drop",95,null],[12,"kind","","Whether this is a full value Drop, or just a StorageDead.",95,null],[3,"CachedBlock","","",null,null],[12,"unwind","","The cached block for the cleanups-on-diverge path. This block contains code to run the current drop and all the preceding drops (i.e. those having lower index in Drop’s Scope drop array)",96,null],[12,"generator_drop","","The cached block for unwinds during cleanups-on-generator-drop path",96,null],[3,"BreakableScope","","",null,null],[12,"region_scope","","Region scope of the loop",97,null],[12,"continue_block","","Where the body of the loop begins. `None` if block",97,null],[12,"break_block","","Block to branch into when the loop or block terminates (either by being `break`-en out from, or by having its condition to become false)",97,null],[12,"break_destination","","The destination of the loop/block expression itself (i.e. where to put the result of a `break` expression)",97,null],[4,"DropKind","","",null,null],[13,"Value","","",98,null],[12,"cached_block","rustc_mir::build::scope::DropKind","",98,null],[13,"Storage","rustc_mir::build::scope","",98,null],[5,"build_scope_drops","","Builds drops for pop_scope and exit_scope.",null,null],[5,"build_diverge_scope","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cfg"},{"name":"span"},{"name":"scope"},{"name":"basicblock"},{"name":"bool"}],"output":{"name":"basicblock"}}],[11,"fmt","","",94,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",95,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",96,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",96,{"inputs":[],"output":{"name":"cachedblock"}}],[11,"clone","","",96,{"inputs":[{"name":"self"}],"output":{"name":"cachedblock"}}],[11,"fmt","","",98,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",97,{"inputs":[{"name":"self"}],"output":{"name":"breakablescope"}}],[11,"fmt","","",97,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"invalidate","","",96,{"inputs":[{"name":"self"}],"output":null}],[11,"get","","",96,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["basicblock"],"name":"option"}}],[11,"ref_mut","","",96,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"option"}}],[11,"may_panic","","",98,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"invalidate_cache","","Invalidate all the cached blocks in the scope.",94,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"bool"}],"output":null}],[11,"source_info","","Given a span and this scope's visibility scope, make a SourceInfo.",94,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"sourceinfo"}}],[11,"in_breakable_scope","rustc_mir::build","Start a breakable scope, which tracks where `continue` and `break` should branch to. See module comment for more details.",76,{"inputs":[{"name":"self"},{"generics":["basicblock"],"name":"option"},{"name":"basicblock"},{"name":"place"},{"name":"f"}],"output":{"name":"r"}}],[11,"in_opt_scope","","",76,{"inputs":[{"name":"self"},{"name":"option"},{"name":"basicblock"},{"name":"f"}],"output":{"name":"blockand"}}],[11,"in_scope","","Convenience wrapper that pushes a scope and then executes `f` to build its contents, popping the scope afterwards.",76,null],[11,"push_scope","","Push a scope onto the stack. You can then build code in this scope and call `pop_scope` afterwards. Note that these two calls must be paired; using `in_scope` as a convenience wrapper maybe preferable.",76,null],[11,"pop_scope","","Pops a scope, which should have region scope `region_scope`, adding any drops onto the end of `block` that are needed. This must match 1-to-1 with `push_scope`.",76,null],[11,"exit_scope","","Branch out of `block` to `target`, exiting all scopes up to and including `region_scope`.  This will insert whatever drops are needed, as well as tracking this exit for the SEME region. See module comment for details.",76,null],[11,"generator_drop_cleanup","","Creates a path that performs all required cleanup for dropping a generator.",76,{"inputs":[{"name":"self"}],"output":{"generics":["basicblock"],"name":"option"}}],[11,"new_visibility_scope","","Creates a new visibility scope, nested in the current one.",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"lintlevel"},{"generics":["safety"],"name":"option"}],"output":{"name":"visibilityscope"}}],[11,"find_breakable_scope","","Finds the breakable scope for a given label. This is used for resolving `break` and `continue`.",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"scope"}],"output":{"name":"breakablescope"}}],[11,"source_info","","Given a span and the current visibility scope, make a SourceInfo.",76,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"sourceinfo"}}],[11,"region_scope_of_return_scope","","Returns the `region::Scope` of the scope which should be exited by a return.",76,{"inputs":[{"name":"self"}],"output":{"name":"scope"}}],[11,"topmost_scope","","Returns the topmost active scope, which is known to be alive until the next scope expression.",76,{"inputs":[{"name":"self"}],"output":{"name":"scope"}}],[11,"local_scope","","Returns the scope that we should use as the lifetime of an operand. Basically, an operand must live until it is consumed. This is similar to, but not quite the same as, the temporary scope (which can be larger or smaller).",76,{"inputs":[{"name":"self"}],"output":{"generics":["scope"],"name":"option"}}],[11,"schedule_abort","","",76,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"schedule_drop","","Indicates that `place` should be dropped on exit from `region_scope`.",76,{"inputs":[{"name":"self"},{"name":"span"},{"name":"scope"},{"name":"place"},{"name":"ty"}],"output":null}],[11,"diverge_cleanup","","Creates a path that performs all required cleanup for unwinding.",76,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"resume_block","","",76,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"diverge_cleanup_gen","","",76,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"basicblock"}}],[11,"build_drop","","Utility function for non-scope code to build their own drops",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"span"},{"name":"place"},{"name":"ty"}],"output":{"name":"blockand"}}],[11,"build_drop_and_replace","","Utility function for non-scope code to build their own drops",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"span"},{"name":"place"},{"name":"operand"}],"output":{"name":"blockand"}}],[11,"assert","","Create an Assert terminator and return the success block. If the boolean condition operand is not the expected value, a runtime panic will be caused with the given message.",76,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"operand"},{"name":"bool"},{"name":"assertmessage"},{"name":"span"}],"output":{"name":"basicblock"}}],[8,"BlockAndExtension","","",null,null],[10,"and","","",99,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"blockand"}}],[10,"unit","","",99,{"inputs":[{"name":"self"}],"output":{"name":"blockand"}}],[11,"visit_ty","","",75,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_region","","",75,{"inputs":[{"name":"self"},{"name":"region"},{"name":"location"}],"output":null}],[11,"visit_const","","",75,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_substs","","",75,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"location"}],"output":null}],[11,"is_bound_var_in_guard","","",76,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"var_local_id","","",76,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"forguard"}],"output":{"name":"local"}}],[11,"fmt","","",82,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",77,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",77,{"inputs":[{"name":"nodeid"},{"name":"bindingmode"}],"output":{"name":"self"}}],[11,"fmt","","",78,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",83,{"inputs":[{"name":"self"}],"output":{"name":"forguard"}}],[11,"fmt","","",83,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",83,{"inputs":[{"name":"self"},{"name":"forguard"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",83,null],[11,"local_id","","",82,{"inputs":[{"name":"self"},{"name":"forguard"}],"output":{"name":"local"}}],[11,"clone","","",80,{"inputs":[{"name":"self"}],"output":{"name":"scopeid"}}],[11,"eq","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"bool"}}],[11,"ne","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",80,null],[11,"hash","","",80,null],[11,"partial_cmp","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"bool"}}],[11,"le","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"bool"}}],[11,"gt","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"bool"}}],[11,"ge","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"bool"}}],[11,"cmp","","",80,{"inputs":[{"name":"self"},{"name":"scopeid"}],"output":{"name":"ordering"}}],[11,"decode","","",80,{"inputs":[{"name":"__d"}],"output":{"generics":["scopeid"],"name":"result"}}],[11,"encode","","",80,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"new","","",80,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",80,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",80,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",76,{"inputs":[{"name":"cx"},{"name":"span"},{"name":"usize"},{"name":"safety"},{"name":"ty"}],"output":{"name":"builder"}}],[11,"finish","","",76,{"inputs":[{"name":"self"},{"generics":["upvardecl"],"name":"vec"},{"generics":["ty"],"name":"option"}],"output":{"name":"mir"}}],[11,"args_and_body","","",76,null],[11,"get_unit_temp","","",76,{"inputs":[{"name":"self"}],"output":{"name":"place"}}],[11,"return_block","","",76,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"unreachable_block","","",76,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[0,"dataflow","rustc_mir","",null,null],[3,"DataflowBuilder","rustc_mir::dataflow","",null,null],[12,"node_id","","",100,null],[12,"flow_state","","",100,null],[12,"print_preflow_to","","",100,null],[12,"print_postflow_to","","",100,null],[3,"DebugFormatted","","`DebugFormatted` encapsulates the \"{:?}\" rendering of some arbitrary value. This way: you pay cost of allocating an extra string (as well as that of rendering up-front); in exchange, you don't have to hand over ownership of your value or deal with borrowing it.",null,null],[12,"0","","",101,null],[3,"MoveDataParamEnv","","",null,null],[12,"move_data","","",102,null],[12,"param_env","","",102,null],[3,"PropagationContext","","",null,null],[12,"builder","","",103,null],[12,"changed","","",103,null],[3,"Bits","","Maps each block to a set of bits",null,null],[12,"bits","","",104,null],[3,"DataflowAnalysis","","",null,null],[12,"flow_state","","",105,null],[12,"dead_unwinds","","",105,null],[12,"mir","","",105,null],[3,"DataflowResults","","",null,null],[12,"0","","",106,null],[3,"DataflowState","","State of a dataflow analysis; couples a collection of bit sets with operator used to initialize and merge bits during analysis.",null,null],[12,"sets","","All the sets for the analysis. (Factored into its own structure so that we can borrow it mutably on its own separate from other fields.)",107,null],[12,"operator","","operator used to initialize, combine, and interpret bits.",107,null],[3,"AllSets","","",null,null],[12,"bits_per_block","","Analysis bitwidth for each block.",108,null],[12,"words_per_block","","Number of words associated with each block entry equal to bits_per_block / usize::BITS, rounded up.",108,null],[12,"gen_sets","","For each block, bits generated by executing the statements in the block. (For comparison, the Terminator for each block is handled in a flow-specific manner during propagation.)",108,null],[12,"kill_sets","","For each block, bits killed by executing the statements in the block. (For comparison, the Terminator for each block is handled in a flow-specific manner during propagation.)",108,null],[12,"on_entry_sets","","For each block, bits valid on entry to the block.",108,null],[3,"BlockSets","","Triple of sets associated with a given block.",null,null],[12,"on_entry","","Dataflow state immediately before control flow enters the given block.",109,null],[12,"gen_set","","Bits that are set to 1 by the time we exit the given block.",109,null],[12,"kill_set","","Bits that are set to 0 by the time we exit the given block.",109,null],[5,"has_rustc_mir_with","","",null,null],[5,"do_dataflow","","",null,null],[5,"dataflow_path","","",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"state_for_location","","",null,{"inputs":[{"name":"location"},{"name":"t"},{"name":"dataflowresults"},{"name":"mir"}],"output":{"name":"idxsetbuf"}}],[0,"at_location","","A nice wrapper to consume dataflow results at several CFG locations.",null,null],[3,"FlowAtLocation","rustc_mir::dataflow::at_location","Represents the state of dataflow at a particular CFG location, both before and after it is executed.",null,null],[12,"base_results","","",110,null],[12,"curr_state","","",110,null],[12,"stmt_gen","","",110,null],[12,"stmt_kill","","",110,null],[8,"FlowsAtLocation","","A trait for \"cartesian products\" of multiple FlowAtLocation.",null,null],[10,"reset_to_entry_of","","Reset the state bitvector to represent the entry to block `bb`.",111,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":null}],[10,"reconstruct_statement_effect","","Build gen + kill sets for statement at `loc`.",111,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[10,"reconstruct_terminator_effect","","Build gen + kill sets for terminator for `loc`.",111,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[10,"apply_local_effect","","Apply current gen + kill sets to `flow_state`.",111,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"each_state_bit","","Iterate over each bit set in the current state.",110,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"each_gen_bit","","Iterate over each `gen` bit in the current effect (invoke `reconstruct_statement_effect` or `reconstruct_terminator_effect` first).",110,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"new","","",110,{"inputs":[{"name":"dataflowresults"}],"output":{"name":"self"}}],[11,"operator","","Access the underlying operator.",110,{"inputs":[{"name":"self"}],"output":{"name":"bd"}}],[11,"contains","","",110,null],[11,"iter_incoming","","Returns an iterator over the elements present in the current state.",110,{"inputs":[{"name":"self"}],"output":{"generics":["iter"],"name":"peekable"}}],[11,"with_iter_outgoing","","Creates a clone of the current state and applies the local effects to the clone (leaving the state of self intact). Invokes `f` with an iterator over the resulting state.",110,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"reset_to_entry_of","","",110,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":null}],[11,"reconstruct_statement_effect","","",110,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"reconstruct_terminator_effect","","",110,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"apply_local_effect","","",110,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"has_any_child_of","","",110,null],[0,"drop_flag_effects","rustc_mir::dataflow","",null,null],[5,"move_path_children_matching","rustc_mir::dataflow::drop_flag_effects","",null,{"inputs":[{"name":"movedata"},{"name":"movepathindex"},{"name":"f"}],"output":{"generics":["movepathindex"],"name":"option"}}],[5,"place_contents_drop_state_cannot_differ","","When enumerating the child fragments of a path, don't recurse into paths (1.) past arrays, slices, and pointers, nor (2.) into a type that implements `Drop`.",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"place"}],"output":{"name":"bool"}}],[5,"on_lookup_result_bits","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedata"},{"name":"lookupresult"},{"name":"f"}],"output":null}],[5,"on_all_children_bits","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedata"},{"name":"movepathindex"},{"name":"f"}],"output":null}],[5,"on_all_drop_children_bits","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"},{"name":"movepathindex"},{"name":"f"}],"output":null}],[5,"drop_flag_effects_for_function_entry","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"},{"name":"f"}],"output":null}],[5,"drop_flag_effects_for_location","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"},{"name":"location"},{"name":"f"}],"output":null}],[5,"for_location_inits","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedata"},{"name":"location"},{"name":"f"}],"output":null}],[0,"graphviz","rustc_mir::dataflow","Hook into libgraphviz for rendering dataflow graphs for MIR.",null,null],[3,"Graph","rustc_mir::dataflow::graphviz","",null,null],[12,"mbcx","","",112,null],[12,"phantom","","",112,null],[12,"render_idx","","",112,null],[3,"Edge","","",null,null],[12,"source","","",113,null],[12,"index","","",113,null],[5,"print_borrowck_graph_to","","",null,{"inputs":[{"name":"dataflowbuilder"},{"name":"path"},{"name":"p"}],"output":{"name":"result"}}],[5,"outgoing","","",null,{"inputs":[{"name":"mir"},{"name":"basicblock"}],"output":{"generics":["edge"],"name":"vec"}}],[6,"Node","","",null,null],[8,"MirWithFlowState","","",null,null],[16,"BD","","",114,null],[10,"node_id","","",114,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[10,"mir","","",114,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[10,"flow_state","","",114,{"inputs":[{"name":"self"}],"output":{"name":"dataflowstate"}}],[11,"node_id","rustc_mir::dataflow","",100,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"mir","","",100,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"flow_state","","",100,{"inputs":[{"name":"self"}],"output":{"name":"dataflowstate"}}],[11,"clone","rustc_mir::dataflow::graphviz","",113,{"inputs":[{"name":"self"}],"output":{"name":"edge"}}],[11,"eq","","",113,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",113,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",113,null],[11,"fmt","","",113,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"graph_id","","",112,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"node_id","","",112,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"id"}}],[11,"node_label","","",112,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"labeltext"}}],[11,"node_shape","","",112,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"generics":["labeltext"],"name":"option"}}],[11,"edge_label","","",112,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"node_label_internal","","Generate the node label",112,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"w"},{"name":"basicblock"},{"name":"mir"}],"output":{"name":"result"}}],[11,"node_label_verbose_row","","Build the verbose row: full MIR data, and detailed gen/kill/entry sets",112,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"w"},{"name":"basicblock"},{"name":"mir"}],"output":{"name":"result"}}],[11,"node_label_final_row","","Build the summary row: terminator, gen/kill/entry bit sets",112,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"w"},{"name":"basicblock"},{"name":"mir"}],"output":{"name":"result"}}],[11,"nodes","","",112,{"inputs":[{"name":"self"}],"output":{"generics":["basicblock"],"name":"nodes"}}],[11,"edges","","",112,{"inputs":[{"name":"self"}],"output":{"generics":["edge"],"name":"edges"}}],[11,"source","","",112,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"basicblock"}}],[11,"target","","",112,{"inputs":[{"name":"self"},{"name":"edge"}],"output":{"name":"basicblock"}}],[0,"impls","rustc_mir::dataflow","Dataflow analyses are built upon some interpretation of the bitvectors attached to each basic block, represented via a zero-sized structure.",null,null],[3,"MaybeInitializedPlaces","rustc_mir::dataflow::impls","`MaybeInitializedPlaces` tracks all places that might be initialized upon reaching a particular point in the control flow for a function.",null,null],[12,"tcx","","",115,null],[12,"mir","","",115,null],[12,"mdpe","","",115,null],[3,"MaybeUninitializedPlaces","","`MaybeUninitializedPlaces` tracks all places that might be uninitialized upon reaching a particular point in the control flow for a function.",null,null],[12,"tcx","","",116,null],[12,"mir","","",116,null],[12,"mdpe","","",116,null],[3,"DefinitelyInitializedPlaces","","`DefinitelyInitializedPlaces` tracks all places that are definitely initialized upon reaching a particular point in the control flow for a function.",null,null],[12,"tcx","","",117,null],[12,"mir","","",117,null],[12,"mdpe","","",117,null],[3,"MovingOutStatements","","`MovingOutStatements` tracks the statements that perform moves out of particular places. More precisely, it tracks whether the effect of such moves (namely, the uninitialization of the place in question) can reach some point in the control-flow of the function, or if that effect is \"killed\" by some intervening operation reinitializing that place.",null,null],[12,"tcx","","",118,null],[12,"mir","","",118,null],[12,"mdpe","","",118,null],[3,"EverInitializedPlaces","","`EverInitializedPlaces` tracks all places that might have ever been initialized upon reaching a particular point in the control flow for a function, without an intervening `Storage Dead`.",null,null],[12,"tcx","","",119,null],[12,"mir","","",119,null],[12,"mdpe","","",119,null],[0,"storage_liveness","","",null,null],[3,"MaybeStorageLive","rustc_mir::dataflow::impls::storage_liveness","",null,null],[12,"mir","","",120,null],[11,"clone","","",120,{"inputs":[{"name":"self"}],"output":{"name":"maybestoragelive"}}],[11,"new","","",120,{"inputs":[{"name":"mir"}],"output":{"name":"self"}}],[11,"mir","","",120,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"name","","",120,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",120,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",120,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",120,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",120,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",120,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"join","","",120,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bottom_value","","",120,{"inputs":[],"output":{"name":"bool"}}],[0,"borrowed_locals","rustc_mir::dataflow::impls","",null,null],[3,"HaveBeenBorrowedLocals","rustc_mir::dataflow::impls::borrowed_locals","This calculates if any part of a MIR local could have previously been borrowed. This means that once a local has been borrowed, its bit will always be set from that point and onwards, even if the borrow ends. You could also think of this as computing the lifetimes of infinite borrows. This is used to compute which locals are live during a yield expression for immovable generators.",null,null],[12,"mir","","",121,null],[3,"BorrowedLocalsVisitor","","",null,null],[12,"sets","","",122,null],[5,"find_local","","",null,{"inputs":[{"name":"place"}],"output":{"generics":["local"],"name":"option"}}],[11,"clone","","",121,{"inputs":[{"name":"self"}],"output":{"name":"havebeenborrowedlocals"}}],[11,"new","","",121,{"inputs":[{"name":"mir"}],"output":{"name":"self"}}],[11,"mir","","",121,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"name","","",121,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",121,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",121,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",121,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",121,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",121,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"join","","",121,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bottom_value","","",121,{"inputs":[],"output":{"name":"bool"}}],[11,"visit_rvalue","","",122,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[0,"borrows","rustc_mir::dataflow::impls","",null,null],[3,"Borrows","rustc_mir::dataflow::impls::borrows","`Borrows` stores the data used in the analyses that track the flow of borrows.",null,null],[12,"tcx","","",123,null],[12,"mir","","",123,null],[12,"scope_tree","","",123,null],[12,"root_scope","","",123,null],[12,"borrow_set","","",123,null],[12,"nonlexical_regioncx","","NLL region inference context with which NLL queries should be resolved",123,null],[11,"new","","",123,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"generics":["regioninferencecontext"],"name":"rc"},{"name":"defid"},{"generics":["bodyid"],"name":"option"},{"name":"rc"}],"output":{"name":"self"}}],[11,"borrows","","",123,{"inputs":[{"name":"self"}],"output":{"name":"indexvec"}}],[11,"scope_tree","","",123,{"inputs":[{"name":"self"}],"output":{"name":"lrc"}}],[11,"location","","",123,{"inputs":[{"name":"self"},{"name":"borrowindex"}],"output":{"name":"location"}}],[11,"kill_loans_out_of_scope_at_location","","Add all borrows to the kill set, if those borrows are out of scope at `location`. That means either they went out of either a nonlexical scope, if we care about those at the moment, or the location represents a lexical EndRegion",123,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"kill_borrows_on_local","","",123,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"local"}],"output":null}],[11,"name","","",123,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",123,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",123,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"before_statement_effect","","",123,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"statement_effect","","",123,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"before_terminator_effect","","",123,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",123,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",123,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"join","","",123,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bottom_value","","",123,{"inputs":[],"output":{"name":"bool"}}],[11,"new","rustc_mir::dataflow::impls","",115,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"}],"output":{"name":"self"}}],[11,"move_data","","",115,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"new","","",116,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"}],"output":{"name":"self"}}],[11,"move_data","","",116,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"new","","",117,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"}],"output":{"name":"self"}}],[11,"move_data","","",117,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"new","","",118,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"}],"output":{"name":"self"}}],[11,"move_data","","",118,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"new","","",119,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"}],"output":{"name":"self"}}],[11,"move_data","","",119,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"update_bits","","",115,{"inputs":[{"name":"blocksets"},{"name":"movepathindex"},{"name":"dropflagstate"}],"output":null}],[11,"update_bits","","",116,{"inputs":[{"name":"blocksets"},{"name":"movepathindex"},{"name":"dropflagstate"}],"output":null}],[11,"update_bits","","",117,{"inputs":[{"name":"blocksets"},{"name":"movepathindex"},{"name":"dropflagstate"}],"output":null}],[11,"name","","",115,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",115,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",115,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",115,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",115,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",115,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"name","","",116,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",116,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",116,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",116,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",116,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",116,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"name","","",117,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",117,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",117,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",117,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",117,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",117,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"name","","",118,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",118,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",118,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",118,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",118,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",118,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"name","","",119,{"inputs":[],"output":{"name":"str"}}],[11,"bits_per_block","","",119,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"start_block_effect","","",119,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"statement_effect","","",119,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"terminator_effect","","",119,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"propagate_call_return","","",119,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"join","","",115,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",116,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",117,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",118,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",119,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"bottom_value","","",115,{"inputs":[],"output":{"name":"bool"}}],[11,"bottom_value","","",116,{"inputs":[],"output":{"name":"bool"}}],[11,"bottom_value","","",117,{"inputs":[],"output":{"name":"bool"}}],[11,"bottom_value","","",118,{"inputs":[],"output":{"name":"bool"}}],[11,"bottom_value","","",119,{"inputs":[],"output":{"name":"bool"}}],[0,"move_paths","rustc_mir::dataflow","",null,null],[3,"MovePath","rustc_mir::dataflow::move_paths","`MovePath` is a canonicalized representation of a path that is moved or assigned to.",null,null],[12,"next_sibling","","",124,null],[12,"first_child","","",124,null],[12,"parent","","",124,null],[12,"place","","",124,null],[3,"MoveData","","",null,null],[12,"move_paths","","",125,null],[12,"moves","","",125,null],[12,"loc_map","","Each Location `l` is mapped to the MoveOut's that are effects of executing the code at `l`. (There can be multiple MoveOut's for a given `l` because each MoveOut is associated with one particular path being moved.)",125,null],[12,"path_map","","",125,null],[12,"rev_lookup","","",125,null],[12,"inits","","",125,null],[12,"init_loc_map","","Each Location `l` is mapped to the Inits that are effects of executing the code at `l`.",125,null],[12,"init_path_map","","",125,null],[3,"LocationMap","","",null,null],[12,"map","","Location-indexed (BasicBlock for outer index, index within BB for inner index) map.",126,null],[3,"MoveOut","","`MoveOut` represents a point in a program that moves out of some L-value; i.e., \"creates\" uninitialized memory.",null,null],[12,"path","","path being moved",127,null],[12,"source","","location of move",127,null],[3,"Init","","`Init` represents a point in a program that initializes some L-value;",null,null],[12,"path","","path being initialized",128,null],[12,"span","","span of initialization",128,null],[12,"kind","","Extra information about this initialization",128,null],[3,"MovePathLookup","","Tables mapping from a place to its MovePathIndex.",null,null],[12,"locals","","",129,null],[12,"projections","","projections are made from a base-place and a projection elem. The base-place will have a unique MovePathIndex; we use the latter as the index into the outer vector (narrowing subsequent search so that it is solely relative to that base-place). For the remaining lookup, we map the projection elem to the associated MovePathIndex.",129,null],[3,"IllegalMoveOrigin","","",null,null],[12,"span","","",130,null],[12,"kind","","",130,null],[4,"InitKind","","Additional information about the initialization.",null,null],[13,"Deep","","Deep init, even on panic",131,null],[13,"Shallow","","Only does a shallow init",131,null],[13,"NonPanicPathOnly","","This doesn't initialize the variabe on panic (and a panic is possible).",131,null],[4,"LookupResult","","",null,null],[13,"Exact","","",132,null],[13,"Parent","","",132,null],[4,"IllegalMoveOriginKind","","",null,null],[13,"Static","","",133,null],[13,"BorrowedContent","","",133,null],[13,"InteriorOfTypeWithDestructor","","",133,null],[12,"container_ty","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","",133,null],[13,"InteriorOfSliceOrArray","rustc_mir::dataflow::move_paths","",133,null],[12,"ty","rustc_mir::dataflow::move_paths::IllegalMoveOriginKind","",133,null],[12,"is_index","","",133,null],[4,"MoveError","rustc_mir::dataflow::move_paths","",null,null],[13,"IllegalMove","","",134,null],[12,"cannot_move_out_of","rustc_mir::dataflow::move_paths::MoveError","",134,null],[13,"UnionMove","rustc_mir::dataflow::move_paths","",134,null],[12,"path","rustc_mir::dataflow::move_paths::MoveError","",134,null],[0,"abs_domain","rustc_mir::dataflow::move_paths","The move-analysis portion of borrowck needs to work in an abstract domain of lifted Places.  Most of the Place variants fall into a one-to-one mapping between the concrete and abstract (e.g. a field-deref on a local-variable, `x.field`, has the same meaning in both domains). Indexed-Projections are the exception: `a[x]` needs to be treated as mapping to the same move path as `a[y]` as well as `a[13]`, et cetera.",null,null],[3,"AbstractOperand","rustc_mir::dataflow::move_paths::abs_domain","",null,null],[3,"AbstractType","","",null,null],[6,"AbstractElem","","",null,null],[8,"Lift","","",null,null],[16,"Abstract","","",135,null],[10,"lift","","",135,null],[11,"clone","","",136,{"inputs":[{"name":"self"}],"output":{"name":"abstractoperand"}}],[11,"eq","","",136,{"inputs":[{"name":"self"},{"name":"abstractoperand"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",136,null],[11,"hash","","",136,null],[11,"fmt","","",136,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",137,{"inputs":[{"name":"self"}],"output":{"name":"abstracttype"}}],[11,"eq","","",137,{"inputs":[{"name":"self"},{"name":"abstracttype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",137,null],[11,"hash","","",137,null],[11,"fmt","","",137,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"indexes","rustc_mir::dataflow::move_paths","",null,null],[3,"MovePathIndex","rustc_mir::dataflow::move_paths::indexes","",null,null],[12,"0","","",138,null],[3,"MoveOutIndex","","",null,null],[12,"0","","",139,null],[3,"InitIndex","","",null,null],[12,"0","","",140,null],[3,"BorrowIndex","","",null,null],[12,"0","","",141,null],[11,"clone","","",138,{"inputs":[{"name":"self"}],"output":{"name":"movepathindex"}}],[11,"eq","","",138,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",138,null],[11,"hash","","",138,null],[11,"new","","",138,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",138,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",138,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",139,{"inputs":[{"name":"self"}],"output":{"name":"moveoutindex"}}],[11,"eq","","",139,{"inputs":[{"name":"self"},{"name":"moveoutindex"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"self"},{"name":"moveoutindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",139,null],[11,"hash","","",139,null],[11,"new","","",139,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",139,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",139,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",140,{"inputs":[{"name":"self"}],"output":{"name":"initindex"}}],[11,"eq","","",140,{"inputs":[{"name":"self"},{"name":"initindex"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"self"},{"name":"initindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",140,null],[11,"hash","","",140,null],[11,"new","","",140,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",140,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",140,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",141,{"inputs":[{"name":"self"}],"output":{"name":"borrowindex"}}],[11,"eq","","",141,{"inputs":[{"name":"self"},{"name":"borrowindex"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"self"},{"name":"borrowindex"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",141,null],[11,"hash","","",141,null],[11,"new","","",141,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",141,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fmt","","",141,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"builder","rustc_mir::dataflow::move_paths","",null,null],[3,"MoveDataBuilder","rustc_mir::dataflow::move_paths::builder","",null,null],[12,"mir","","",142,null],[12,"tcx","","",142,null],[12,"data","","",142,null],[12,"errors","","",142,null],[3,"Gatherer","","",null,null],[12,"builder","","",143,null],[12,"loc","","",143,null],[5,"gather_moves","","",null,{"inputs":[{"name":"mir"},{"name":"tyctxt"}],"output":{"generics":["movedata"],"name":"result"}}],[11,"new","","",142,{"inputs":[{"name":"mir"},{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"new_move_path","","",142,{"inputs":[{"name":"indexvec"},{"name":"indexvec"},{"name":"indexvec"},{"generics":["movepathindex"],"name":"option"},{"name":"place"}],"output":{"name":"movepathindex"}}],[11,"move_path_for","","This creates a MovePath for a given place, returning an `MovePathError` if that place can't be moved from.",143,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["movepathindex","moveerror"],"name":"result"}}],[11,"create_move_path","","",143,{"inputs":[{"name":"self"},{"name":"place"}],"output":null}],[11,"move_path_for_projection","","",143,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placeprojection"}],"output":{"generics":["movepathindex","moveerror"],"name":"result"}}],[11,"finalize","","",142,{"inputs":[{"name":"self"}],"output":{"generics":["movedata"],"name":"result"}}],[11,"gather_args","","",142,{"inputs":[{"name":"self"}],"output":null}],[11,"gather_statement","","",142,{"inputs":[{"name":"self"},{"name":"location"},{"name":"statement"}],"output":null}],[11,"gather_terminator","","",142,{"inputs":[{"name":"self"},{"name":"location"},{"name":"terminator"}],"output":null}],[11,"gather_statement","","",143,{"inputs":[{"name":"self"},{"name":"statement"}],"output":null}],[11,"gather_rvalue","","",143,{"inputs":[{"name":"self"},{"name":"rvalue"}],"output":null}],[11,"gather_terminator","","",143,{"inputs":[{"name":"self"},{"name":"terminator"}],"output":null}],[11,"gather_operand","","",143,{"inputs":[{"name":"self"},{"name":"operand"}],"output":null}],[11,"gather_move","","",143,{"inputs":[{"name":"self"},{"name":"place"}],"output":null}],[11,"gather_init","","",143,{"inputs":[{"name":"self"},{"name":"place"},{"name":"initkind"}],"output":null}],[8,"HasMoveData","rustc_mir::dataflow::move_paths","",null,null],[10,"move_data","","",144,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"move_path_index","rustc_mir::dataflow::move_paths::indexes","",139,{"inputs":[{"name":"self"},{"name":"movedata"}],"output":{"name":"movepathindex"}}],[11,"clone","rustc_mir::dataflow::move_paths","",124,{"inputs":[{"name":"self"}],"output":{"name":"movepath"}}],[11,"fmt","","",124,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",124,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",125,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",126,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"index","","",126,null],[11,"index_mut","","",126,null],[11,"new","","",126,{"inputs":[{"name":"mir"}],"output":{"name":"self"}}],[11,"clone","","",127,{"inputs":[{"name":"self"}],"output":{"name":"moveout"}}],[11,"fmt","","",127,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",128,{"inputs":[{"name":"self"}],"output":{"name":"init"}}],[11,"clone","","",131,{"inputs":[{"name":"self"}],"output":{"name":"initkind"}}],[11,"fmt","","",131,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",131,{"inputs":[{"name":"self"},{"name":"initkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",131,null],[11,"fmt","","",128,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",129,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"self"}],"output":{"name":"lookupresult"}}],[11,"fmt","","",132,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"find","","",129,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"lookupresult"}}],[11,"find_local","","",129,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"movepathindex"}}],[11,"fmt","","",130,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",134,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cannot_move_out_of","","",134,{"inputs":[{"name":"span"},{"name":"illegalmoveoriginkind"}],"output":{"name":"self"}}],[11,"gather_moves","","",125,{"inputs":[{"name":"mir"},{"name":"tyctxt"}],"output":{"name":"result"}}],[8,"Dataflow","rustc_mir::dataflow","",null,null],[11,"dataflow","","Sets up and runs the dataflow problem, using `p` to render results if implementation so chooses.",145,{"inputs":[{"name":"self"},{"name":"p"}],"output":null}],[10,"build_sets","","Sets up the entry, gen, and kill sets for this instance of a dataflow problem.",145,{"inputs":[{"name":"self"}],"output":null}],[10,"propagate","","Finds a fixed-point solution to this instance of a dataflow problem.",145,{"inputs":[{"name":"self"}],"output":null}],[8,"DataflowResultsConsumer","","DataflowResultsConsumer abstracts over walking the MIR with some already constructed dataflow results.",null,null],[16,"FlowState","","",146,null],[11,"visit_block_entry","","",146,null],[11,"visit_statement_entry","","",146,null],[11,"visit_terminator_entry","","",146,null],[11,"analyze_results","","",146,null],[11,"process_basic_block","","",146,null],[10,"mir","","",146,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[8,"InitialFlow","","Parameterization for the precise form of data flow that is used. `InitialFlow` handles initializing the bitvectors before any code is inspected by the analysis. Analyses that need more nuanced initialization (e.g. they need to consult the results of some other dataflow analysis to set up the initial bitvectors) should not implement this.",null,null],[10,"bottom_value","","Specifies the initial value for each bit in the `on_entry` set",147,{"inputs":[],"output":{"name":"bool"}}],[8,"BitDenotation","","",null,null],[16,"Idx","","Specifies what index type is used to access the bitvector.",148,null],[11,"accumulates_intrablock_state","","Some analyses want to accumulate knowledge within a block when analyzing its statements for building the gen/kill sets. Override this method to return true in such cases.",148,{"inputs":[],"output":{"name":"bool"}}],[10,"name","","A name describing the dataflow analysis that this BitDenotation is supporting.  The name should be something suitable for plugging in as part of a filename e.g. avoid space-characters or other things that tend to look bad on a file system, like slashes or periods. It is also better for the name to be reasonably short, again because it will be plugged into a filename.",148,{"inputs":[],"output":{"name":"str"}}],[10,"bits_per_block","","Size of each bitvector allocated for each block in the analysis.",148,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[10,"start_block_effect","","Mutates the entry set according to the effects that have been established prior to entering the start block. This can't access the gen/kill sets, because these won't be accounted for correctly.",148,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"before_statement_effect","","Similar to `statement_effect`, except it applies just before the statement rather than just after it.",148,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[10,"statement_effect","","Mutates the block-sets (the flow sets for the given basic block) according to the effects of evaluating statement.",148,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[11,"before_terminator_effect","","Similar to `terminator_effect`, except it applies just before the terminator rather than just after it.",148,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[10,"terminator_effect","","Mutates the block-sets (the flow sets for the given basic block) according to the effects of evaluating the terminator.",148,{"inputs":[{"name":"self"},{"name":"blocksets"},{"name":"location"}],"output":null}],[10,"propagate_call_return","","Mutates the block-sets according to the (flow-dependent) effect of a successful return from a Call terminator.",148,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"basicblock"},{"name":"basicblock"},{"name":"place"}],"output":null}],[11,"new","","",101,{"inputs":[{"name":"debug"}],"output":{"name":"debugformatted"}}],[11,"fmt","","",101,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"dataflow","","",100,{"inputs":[{"name":"self"},{"name":"p"}],"output":null}],[11,"build_sets","","",100,{"inputs":[{"name":"self"}],"output":null}],[11,"propagate","","",100,{"inputs":[{"name":"self"}],"output":null}],[11,"run","","",105,null],[11,"propagate","","",105,{"inputs":[{"name":"self"}],"output":null}],[11,"build_sets","","",105,{"inputs":[{"name":"self"}],"output":null}],[11,"walk_cfg","","",103,{"inputs":[{"name":"self"},{"name":"idxset"}],"output":null}],[11,"pre_dataflow_instrumentation","","",100,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"result"}}],[11,"post_dataflow_instrumentation","","",100,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"result"}}],[11,"fmt","","",104,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",104,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"new","","",104,{"inputs":[{"name":"idxsetbuf"}],"output":{"name":"self"}}],[11,"results","","",105,{"inputs":[{"name":"self"}],"output":{"name":"dataflowresults"}}],[11,"mir","","",105,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"sets","","",106,{"inputs":[{"name":"self"}],"output":{"name":"allsets"}}],[11,"operator","","",106,{"inputs":[{"name":"self"}],"output":{"name":"o"}}],[11,"each_bit","","",107,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"f"}],"output":null}],[11,"interpret_set","","",107,{"inputs":[{"name":"self"},{"name":"o"},{"name":"idxset"},{"name":"p"}],"output":{"generics":["debugformatted"],"name":"vec"}}],[11,"fmt","","",108,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",109,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"gen","","",109,{"inputs":[{"name":"self"},{"name":"e"}],"output":null}],[11,"gen_all","","",109,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"gen_all_and_assert_dead","","",109,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"kill","","",109,{"inputs":[{"name":"self"},{"name":"e"}],"output":null}],[11,"kill_all","","",109,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"apply_local_effect","","",109,{"inputs":[{"name":"self"}],"output":null}],[11,"bits_per_block","","",108,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"for_block","","",108,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"blocksets"}}],[11,"lookup_set_for","","",108,{"inputs":[{"name":"self"},{"name":"bits"},{"name":"usize"}],"output":{"name":"idxset"}}],[11,"gen_set_for","","",108,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"idxset"}}],[11,"kill_set_for","","",108,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"idxset"}}],[11,"on_entry_set_for","","",108,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"idxset"}}],[11,"new","","",105,{"inputs":[{"name":"mir"},{"name":"idxset"},{"name":"d"}],"output":{"name":"self"}}],[11,"new_from_sets","","",105,{"inputs":[{"name":"mir"},{"name":"idxset"},{"name":"allsets"},{"name":"d"}],"output":{"name":"self"}}],[11,"num_bits_overall","","",105,{"inputs":[{"name":"mir"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"propagate_bits_into_graph_successors_of","","Propagates the bits of `in_out` into all the successors of `bb`, using bitwise operator denoted by `self.operator`.",105,null],[11,"propagate_bits_into_entry_set_for","","",105,{"inputs":[{"name":"self"},{"name":"idxset"},{"name":"bool"},{"name":"basicblock"}],"output":null}],[0,"hair","rustc_mir","The MIR is translated from some high-level abstract IR (HAIR). This section defines the HAIR along with a trait for accessing it. The intention is to allow MIR construction to be unit-tested and separated from the Rust source and compiler data structures.",null,null],[3,"Block","rustc_mir::hair","",null,null],[12,"targeted_by_break","","",149,null],[12,"region_scope","","",149,null],[12,"opt_destruction_scope","","",149,null],[12,"span","","",149,null],[12,"stmts","","",149,null],[12,"expr","","",149,null],[12,"safety_mode","","",149,null],[3,"Stmt","","",null,null],[12,"kind","","",150,null],[12,"opt_destruction_scope","","",150,null],[3,"Expr","","The Hair trait implementor translates their expressions (`&'tcx H::Expr`) into instances of this `Expr` enum. This translation can be done basically as lazily or as eagerly as desired: every recursive reference to an expression in this enum is an `ExprRef<'tcx>`, which may in turn be another instance of this enum (boxed), or else an untranslated `&'tcx H::Expr`. Note that instances of `Expr` are very shortlived. They are created by `Hair::to_expr`, analyzed and converted into MIR, and then discarded.",null,null],[12,"ty","","type of this expression",151,null],[12,"temp_lifetime","","lifetime of this expression if it should be spilled into a temporary; should be None only if in a constant context",151,null],[12,"span","","span of the expression in the source",151,null],[12,"kind","","kind of expression",151,null],[3,"FieldExprRef","","",null,null],[12,"name","","",152,null],[12,"expr","","",152,null],[3,"FruInfo","","",null,null],[12,"base","","",153,null],[12,"field_types","","",153,null],[3,"Arm","","",null,null],[12,"patterns","","",154,null],[12,"guard","","",154,null],[12,"body","","",154,null],[12,"lint_level","","",154,null],[4,"LintLevel","","",null,null],[13,"Inherited","","",155,null],[13,"Explicit","","",155,null],[4,"BlockSafety","","",null,null],[13,"Safe","","",156,null],[13,"ExplicitUnsafe","","",156,null],[13,"PushUnsafe","","",156,null],[13,"PopUnsafe","","",156,null],[4,"StmtRef","","",null,null],[13,"Mirror","","",157,null],[4,"StmtKind","","",null,null],[13,"Expr","","",158,null],[12,"scope","rustc_mir::hair::StmtKind","scope for this statement; may be used as lifetime of temporaries",158,null],[12,"expr","","expression being evaluated in this statement",158,null],[13,"Let","rustc_mir::hair","",158,null],[12,"remainder_scope","rustc_mir::hair::StmtKind","scope for variables bound in this let; covers this and remaining statements in block",158,null],[12,"init_scope","","scope for the initialization itself; might be used as lifetime of temporaries",158,null],[12,"pattern","","let : ty = ...",158,null],[12,"ty","","let pat:  = init ...",158,null],[12,"initializer","","let pat: ty =  ...",158,null],[12,"lint_level","","the lint level for this let-statement",158,null],[4,"ExprKind","rustc_mir::hair","",null,null],[13,"Scope","","",159,null],[12,"region_scope","rustc_mir::hair::ExprKind","",159,null],[12,"lint_level","","",159,null],[12,"value","","",159,null],[13,"Box","rustc_mir::hair","",159,null],[12,"value","rustc_mir::hair::ExprKind","",159,null],[13,"Call","rustc_mir::hair","",159,null],[12,"ty","rustc_mir::hair::ExprKind","",159,null],[12,"fun","","",159,null],[12,"args","","",159,null],[13,"Deref","rustc_mir::hair","",159,null],[12,"arg","rustc_mir::hair::ExprKind","",159,null],[13,"Binary","rustc_mir::hair","",159,null],[12,"op","rustc_mir::hair::ExprKind","",159,null],[12,"lhs","","",159,null],[12,"rhs","","",159,null],[13,"LogicalOp","rustc_mir::hair","",159,null],[12,"op","rustc_mir::hair::ExprKind","",159,null],[12,"lhs","","",159,null],[12,"rhs","","",159,null],[13,"Unary","rustc_mir::hair","",159,null],[12,"op","rustc_mir::hair::ExprKind","",159,null],[12,"arg","","",159,null],[13,"Cast","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"Use","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"NeverToAny","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"ReifyFnPointer","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"ClosureFnPointer","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"UnsafeFnPointer","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"Unsize","rustc_mir::hair","",159,null],[12,"source","rustc_mir::hair::ExprKind","",159,null],[13,"If","rustc_mir::hair","",159,null],[12,"condition","rustc_mir::hair::ExprKind","",159,null],[12,"then","","",159,null],[12,"otherwise","","",159,null],[13,"Loop","rustc_mir::hair","",159,null],[12,"condition","rustc_mir::hair::ExprKind","",159,null],[12,"body","","",159,null],[13,"Match","rustc_mir::hair","",159,null],[12,"discriminant","rustc_mir::hair::ExprKind","",159,null],[12,"arms","","",159,null],[13,"Block","rustc_mir::hair","",159,null],[12,"body","rustc_mir::hair::ExprKind","",159,null],[13,"Assign","rustc_mir::hair","",159,null],[12,"lhs","rustc_mir::hair::ExprKind","",159,null],[12,"rhs","","",159,null],[13,"AssignOp","rustc_mir::hair","",159,null],[12,"op","rustc_mir::hair::ExprKind","",159,null],[12,"lhs","","",159,null],[12,"rhs","","",159,null],[13,"Field","rustc_mir::hair","",159,null],[12,"lhs","rustc_mir::hair::ExprKind","",159,null],[12,"name","","",159,null],[13,"Index","rustc_mir::hair","",159,null],[12,"lhs","rustc_mir::hair::ExprKind","",159,null],[12,"index","","",159,null],[13,"VarRef","rustc_mir::hair","",159,null],[12,"id","rustc_mir::hair::ExprKind","",159,null],[13,"SelfRef","rustc_mir::hair","first argument, used for self in a closure",159,null],[13,"StaticRef","","",159,null],[12,"id","rustc_mir::hair::ExprKind","",159,null],[13,"Borrow","rustc_mir::hair","",159,null],[12,"region","rustc_mir::hair::ExprKind","",159,null],[12,"borrow_kind","","",159,null],[12,"arg","","",159,null],[13,"Break","rustc_mir::hair","",159,null],[12,"label","rustc_mir::hair::ExprKind","",159,null],[12,"value","","",159,null],[13,"Continue","rustc_mir::hair","",159,null],[12,"label","rustc_mir::hair::ExprKind","",159,null],[13,"Return","rustc_mir::hair","",159,null],[12,"value","rustc_mir::hair::ExprKind","",159,null],[13,"Repeat","rustc_mir::hair","",159,null],[12,"value","rustc_mir::hair::ExprKind","",159,null],[12,"count","","",159,null],[13,"Array","rustc_mir::hair","",159,null],[12,"fields","rustc_mir::hair::ExprKind","",159,null],[13,"Tuple","rustc_mir::hair","",159,null],[12,"fields","rustc_mir::hair::ExprKind","",159,null],[13,"Adt","rustc_mir::hair","",159,null],[12,"adt_def","rustc_mir::hair::ExprKind","",159,null],[12,"variant_index","","",159,null],[12,"substs","","",159,null],[12,"fields","","",159,null],[12,"base","","",159,null],[13,"Closure","rustc_mir::hair","",159,null],[12,"closure_id","rustc_mir::hair::ExprKind","",159,null],[12,"substs","","",159,null],[12,"upvars","","",159,null],[12,"interior","","",159,null],[13,"Literal","rustc_mir::hair","",159,null],[12,"literal","rustc_mir::hair::ExprKind","",159,null],[13,"InlineAsm","rustc_mir::hair","",159,null],[12,"asm","rustc_mir::hair::ExprKind","",159,null],[12,"outputs","","",159,null],[12,"inputs","","",159,null],[13,"Yield","rustc_mir::hair","",159,null],[12,"value","rustc_mir::hair::ExprKind","",159,null],[4,"ExprRef","rustc_mir::hair","",null,null],[13,"Hair","","",160,null],[13,"Mirror","","",160,null],[4,"LogicalOp","","",null,null],[13,"And","","",161,null],[13,"Or","","",161,null],[0,"cx","","This module contains the code to convert from the wacky tcx data structures into the hair. The `builder` is generally ignorant of the tcx etc, and instead goes through the `Cx` for most of its work.",null,null],[3,"Cx","rustc_mir::hair::cx","",null,null],[12,"tcx","","",162,null],[12,"infcx","","",162,null],[12,"root_lint_level","","",162,null],[12,"param_env","","",162,null],[12,"identity_substs","","Identity `Substs` for use with const-evaluation.",162,null],[12,"region_scope_tree","","",162,null],[12,"tables","","",162,null],[12,"constness","","This is `Constness::Const` if we are compiling a `static`, `const`, or the body of a `const fn`.",162,null],[12,"body_owner_kind","","What kind of body is being compiled.",162,null],[12,"check_overflow","","True if this constant/function needs overflow checks.",162,null],[5,"lint_level_for_hir_id","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[0,"block","","",null,null],[5,"mirror_stmts","rustc_mir::hair::cx::block","",null,null],[5,"to_expr_ref","","",null,{"inputs":[{"name":"cx"},{"name":"block"}],"output":{"name":"exprref"}}],[0,"expr","rustc_mir::hair::cx","",null,null],[5,"apply_adjustment","rustc_mir::hair::cx::expr","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"name":"expr"},{"name":"adjustment"}],"output":{"name":"expr"}}],[5,"make_mirror_unadjusted","","",null,{"inputs":[{"name":"cx"},{"name":"expr"}],"output":{"name":"expr"}}],[5,"method_callee","","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"name":"option"}],"output":{"name":"expr"}}],[5,"convert_arm","","",null,{"inputs":[{"name":"cx"},{"name":"arm"}],"output":{"name":"arm"}}],[5,"convert_path_expr","","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"name":"def"}],"output":{"name":"exprkind"}}],[5,"convert_var","","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"name":"def"}],"output":{"name":"exprkind"}}],[5,"bin_op","","",null,{"inputs":[{"name":"binop_"}],"output":{"name":"binop"}}],[5,"overloaded_operator","","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"generics":["exprref"],"name":"vec"}],"output":{"name":"exprkind"}}],[5,"overloaded_place","","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"name":"ty"},{"name":"option"},{"generics":["exprref"],"name":"vec"}],"output":{"name":"exprkind"}}],[5,"capture_freevar","","",null,{"inputs":[{"name":"cx"},{"name":"expr"},{"name":"freevar"},{"name":"ty"}],"output":{"name":"exprref"}}],[5,"field_refs","","Converts a list of named fields (i.e. for struct-like struct/enum ADTs) into FieldExprRef.",null,null],[8,"ToBorrowKind","","",null,null],[10,"to_borrow_kind","","",163,{"inputs":[{"name":"self"}],"output":{"name":"borrowkind"}}],[0,"to_ref","rustc_mir::hair::cx","",null,null],[8,"ToRef","rustc_mir::hair::cx::to_ref","",null,null],[16,"Output","","",164,null],[10,"to_ref","","",164,null],[11,"to_ref","rustc_mir::hair","",151,{"inputs":[{"name":"self"}],"output":{"name":"exprref"}}],[11,"clone","rustc_mir::hair::cx","",162,{"inputs":[{"name":"self"}],"output":{"name":"cx"}}],[11,"new","","",162,{"inputs":[{"name":"inferctxt"},{"name":"nodeid"}],"output":{"name":"cx"}}],[11,"mirror","","Normalizes `ast` into the appropriate `mirror` type.",162,null],[11,"usize_ty","","",162,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"usize_literal","","",162,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"literal"}}],[11,"bool_ty","","",162,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"unit_ty","","",162,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"true_literal","","",162,{"inputs":[{"name":"self"}],"output":{"name":"literal"}}],[11,"false_literal","","",162,{"inputs":[{"name":"self"}],"output":{"name":"literal"}}],[11,"integer_bit_width","","",162,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"u64"}}],[11,"const_eval_literal","","",162,{"inputs":[{"name":"self"},{"name":"litkind"},{"name":"ty"},{"name":"span"},{"name":"bool"}],"output":{"name":"literal"}}],[11,"pattern_from_hir","","",162,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"pattern"}}],[11,"trait_method","","",162,null],[11,"all_fields","","",162,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"usize"}],"output":{"generics":["field"],"name":"vec"}}],[11,"needs_drop","","",162,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"lint_level_of","","",162,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"lintlevel"}}],[11,"tcx","","",162,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"tables","","",162,{"inputs":[{"name":"self"}],"output":{"name":"typecktables"}}],[11,"check_overflow","","",162,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"type_moves_by_default","","",162,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"name":"bool"}}],[0,"pattern","rustc_mir::hair","Code to validate patterns/matches",null,null],[3,"FieldPattern","rustc_mir::hair::pattern","",null,null],[12,"field","","",165,null],[12,"pattern","","",165,null],[3,"Pattern","","",null,null],[12,"ty","","",166,null],[12,"span","","",166,null],[12,"kind","","",166,null],[3,"PatternContext","","",null,null],[12,"tcx","","",167,null],[12,"param_env","","",167,null],[12,"tables","","",167,null],[12,"substs","","",167,null],[12,"errors","","",167,null],[4,"PatternError","","",null,null],[13,"AssociatedConstInPattern","","",168,null],[13,"StaticInPattern","","",168,null],[13,"FloatBug","","",168,null],[13,"NonConstPath","","",168,null],[4,"BindingMode","","",null,null],[13,"ByValue","","",169,null],[13,"ByRef","","",169,null],[4,"PatternKind","","",null,null],[13,"Wild","","",170,null],[13,"Binding","","x, ref x, x @ P, etc",170,null],[12,"mutability","rustc_mir::hair::pattern::PatternKind","",170,null],[12,"name","","",170,null],[12,"mode","","",170,null],[12,"var","","",170,null],[12,"ty","","",170,null],[12,"subpattern","","",170,null],[13,"Variant","rustc_mir::hair::pattern","Foo(...) or Foo{...} or Foo, where `Foo` is a variant name from an adt with >1 variants",170,null],[12,"adt_def","rustc_mir::hair::pattern::PatternKind","",170,null],[12,"substs","","",170,null],[12,"variant_index","","",170,null],[12,"subpatterns","","",170,null],[13,"Leaf","rustc_mir::hair::pattern","(...), Foo(...), Foo{...}, or Foo, where `Foo` is a variant name from an adt with 1 variant",170,null],[12,"subpatterns","rustc_mir::hair::pattern::PatternKind","",170,null],[13,"Deref","rustc_mir::hair::pattern","box P, &P, &mut P, etc",170,null],[12,"subpattern","rustc_mir::hair::pattern::PatternKind","",170,null],[13,"Constant","rustc_mir::hair::pattern","",170,null],[12,"value","rustc_mir::hair::pattern::PatternKind","",170,null],[13,"Range","rustc_mir::hair::pattern","",170,null],[12,"lo","rustc_mir::hair::pattern::PatternKind","",170,null],[12,"hi","","",170,null],[12,"end","","",170,null],[13,"Slice","rustc_mir::hair::pattern","matches against a slice, checking the length and extracting elements. irrefutable when there is a slice pattern and both `prefix` and `suffix` are empty. e.g. `&[ref xs..]`.",170,null],[12,"prefix","rustc_mir::hair::pattern::PatternKind","",170,null],[12,"slice","","",170,null],[12,"suffix","","",170,null],[13,"Array","rustc_mir::hair::pattern","fixed match against an array, irrefutable",170,null],[12,"prefix","rustc_mir::hair::pattern::PatternKind","",170,null],[12,"slice","","",170,null],[12,"suffix","","",170,null],[5,"print_const_val","rustc_mir::hair::pattern","",null,{"inputs":[{"name":"const"},{"name":"formatter"}],"output":{"name":"result"}}],[5,"print_miri_value","","",null,{"inputs":[{"name":"value"},{"name":"ty"},{"name":"formatter"}],"output":{"name":"result"}}],[5,"compare_const_vals","","",null,{"inputs":[{"name":"tyctxt"},{"name":"constval"},{"name":"constval"},{"name":"ty"}],"output":{"generics":["ordering"],"name":"option"}}],[5,"lit_to_const","","",null,{"inputs":[{"name":"litkind"},{"name":"tyctxt"},{"name":"ty"},{"name":"bool"}],"output":{"generics":["constval"],"name":"result"}}],[5,"parse_float","","",null,{"inputs":[{"name":"symbol"},{"name":"floatty"},{"name":"bool"}],"output":{"generics":["value"],"name":"result"}}],[0,"_match","","",null,null],[3,"LiteralExpander","rustc_mir::hair::pattern::_match","",null,null],[3,"Matrix","","",null,null],[12,"0","","",171,null],[3,"MatchCheckCtxt","","",null,null],[12,"tcx","","",172,null],[12,"module","","The module in which the match occurs. This is necessary for checking inhabited-ness of types because whether a type is (visibly) inhabited can depend on whether it was defined in the current module or not. eg. `struct Foo { _private: ! }` cannot be seen to be empty outside it's module and should not be matchable with an empty match statement.",172,null],[12,"pattern_arena","","",172,null],[12,"byte_array_map","","",172,null],[3,"PatternContext","","",null,null],[12,"ty","","",173,null],[12,"max_slice_length","","",173,null],[3,"Witness","","A stack of patterns in reverse order of construction",null,null],[12,"0","","",174,null],[4,"Constructor","","",null,null],[13,"Single","","The constructor of all patterns that don't vary by constructor, e.g. struct patterns and fixed-length arrays.",175,null],[13,"Variant","","Enum variants.",175,null],[13,"ConstantValue","","Literal values.",175,null],[13,"ConstantRange","","Ranges of literal values (`2...5` and `2..5`).",175,null],[13,"Slice","","Array patterns of length n.",175,null],[4,"Usefulness","","",null,null],[13,"Useful","","",176,null],[13,"UsefulWithWitness","","",176,null],[13,"NotUseful","","",176,null],[4,"WitnessPreference","","",null,null],[13,"ConstructWitness","","",177,null],[13,"LeaveOutWitness","","",177,null],[5,"expand_pattern","","",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"pattern"}],"output":{"name":"pattern"}}],[5,"all_constructors","","This determines the set of all possible constructors of a pattern matching values of type `left_ty`. For vectors, this would normally be an infinite set but is instead bounded by the maximum fixed length of slice patterns in the column of patterns being analyzed.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"patterncontext"}],"output":{"generics":["constructor"],"name":"vec"}}],[5,"max_slice_length","","",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"i"}],"output":{"name":"u64"}}],[5,"is_useful","","Algorithm from http://moscova.inria.fr/~maranget/papers/warn/index.html The algorithm from the paper has been modified to correctly handle empty types. The changes are:   (0) We don't exit early if the pattern matrix has zero rows. We just       continue to recurse over columns.   (1) all_constructors will only return constructors that are statically       possible. eg. it will only return Ok for Result<T, !>",null,null],[5,"is_useful_specialized","","",null,null],[5,"pat_constructors","","Determines the constructors that the given pattern can be specialized to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"pattern"},{"name":"patterncontext"}],"output":{"generics":["vec"],"name":"option"}}],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor is how many subpattern patterns of that constructor should be expanded to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"ty"}],"output":{"name":"u64"}}],[5,"constructor_sub_pattern_tys","","This computes the types of the sub patterns that a constructor should be expanded to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"ty"}],"output":{"generics":["ty"],"name":"vec"}}],[5,"slice_pat_covered_by_constructor","","",null,null],[5,"constructor_covered_by_range","","",null,{"inputs":[{"name":"tyctxt"},{"name":"constructor"},{"name":"constval"},{"name":"constval"},{"name":"rangeend"},{"name":"ty"}],"output":{"generics":["bool","errorreported"],"name":"result"}}],[5,"patterns_for_variant","","",null,null],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row into `arity` patterns based on the constructor. For most patterns, the step is trivial, for instance tuple patterns are flattened and box patterns expand into their inner pattern.",null,null],[11,"fold_pattern","","",178,{"inputs":[{"name":"self"},{"name":"pattern"}],"output":{"name":"pattern"}}],[11,"is_wildcard","rustc_mir::hair::pattern","",166,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"empty","rustc_mir::hair::pattern::_match","",171,{"inputs":[],"output":{"name":"self"}}],[11,"push","","",171,{"inputs":[{"name":"self"},{"generics":["pattern"],"name":"vec"}],"output":null}],[11,"fmt","","",171,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",171,{"inputs":[{"name":"t"}],"output":{"name":"self"}}],[11,"create_and_enter","","",172,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"f"}],"output":{"name":"r"}}],[11,"lower_byte_str_pattern","","",172,{"inputs":[{"name":"self"},{"name":"pattern"}],"output":{"generics":["pattern"],"name":"vec"}}],[11,"is_uninhabited","","",172,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"is_non_exhaustive_enum","","",172,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"is_local","","",172,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"is_variant_uninhabited","","",172,{"inputs":[{"name":"self"},{"name":"variantdef"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",175,{"inputs":[{"name":"self"}],"output":{"name":"constructor"}}],[11,"fmt","","",175,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",175,{"inputs":[{"name":"self"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",175,{"inputs":[{"name":"self"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"variant_index_for_adt","","",175,{"inputs":[{"name":"self"},{"name":"adtdef"}],"output":{"name":"usize"}}],[11,"clone","","",176,{"inputs":[{"name":"self"}],"output":{"name":"usefulness"}}],[11,"is_useful","","",176,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",177,{"inputs":[{"name":"self"}],"output":{"name":"witnesspreference"}}],[11,"clone","","",173,{"inputs":[{"name":"self"}],"output":{"name":"patterncontext"}}],[11,"fmt","","",173,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",174,{"inputs":[{"name":"self"}],"output":{"name":"witness"}}],[11,"single_pattern","","",174,{"inputs":[{"name":"self"}],"output":{"name":"pattern"}}],[11,"push_wild_constructor","","",174,{"inputs":[{"name":"self"},{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"ty"}],"output":{"name":"self"}}],[11,"apply_constructor","","Constructs a partial witness for a pattern given a list of patterns expanded by the specialization step.",174,{"inputs":[{"name":"self"},{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"ty"}],"output":{"name":"self"}}],[0,"check_match","rustc_mir::hair::pattern","",null,null],[3,"OuterVisitor","rustc_mir::hair::pattern::check_match","",null,null],[12,"tcx","","",179,null],[3,"MatchVisitor","","",null,null],[12,"tcx","","",180,null],[12,"tables","","",180,null],[12,"param_env","","",180,null],[12,"identity_substs","","",180,null],[12,"region_scope_tree","","",180,null],[3,"MutationChecker","","",null,null],[12,"cx","","",181,null],[3,"AtBindingPatternVisitor","","",null,null],[12,"cx","","",182,null],[12,"bindings_allowed","","",182,null],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"check_match","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"create_e0004","","",null,{"inputs":[{"name":"session"},{"name":"span"},{"name":"string"}],"output":{"name":"diagnosticbuilder"}}],[5,"check_for_bindings_named_the_same_as_variants","","",null,{"inputs":[{"name":"matchvisitor"},{"name":"pat"}],"output":null}],[5,"pat_is_catchall","","Checks for common cases of \"catchall\" patterns that may not be intended as such.",null,{"inputs":[{"name":"pat"}],"output":{"name":"bool"}}],[5,"check_arms","","",null,null],[5,"check_exhaustive","","",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"ty"},{"name":"span"},{"name":"matrix"}],"output":null}],[5,"check_legality_of_move_bindings","","",null,null],[5,"check_for_mutation_in_guard","","Ensures that a pattern guard doesn't borrow by mutable reference or assign.",null,{"inputs":[{"name":"matchvisitor"},{"name":"expr"}],"output":null}],[5,"check_legality_of_bindings_in_at_patterns","","Forbids bindings in `@` patterns. This is necessary for memory safety, because of the way rvalues are handled in the borrow check. (See issue #14587.)",null,{"inputs":[{"name":"matchvisitor"},{"name":"pat"}],"output":null}],[11,"nested_visit_map","","",179,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_body","","",179,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"nested_visit_map","","",180,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_expr","","",180,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_local","","",180,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_body","","",180,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"report_inlining_errors","rustc_mir::hair::pattern","",167,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"span_e0158","","",167,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"}],"output":null}],[11,"check_patterns","rustc_mir::hair::pattern::check_match","",180,null],[11,"check_match","","",180,null],[11,"conservative_is_uninhabited","","",180,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"check_irrefutable","","",180,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"str"}],"output":null}],[11,"matched_pat","","",181,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"matchmode"}],"output":null}],[11,"consume","","",181,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"consume_pat","","",181,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"borrow","","",181,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[11,"decl_without_init","","",181,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"mutate","","",181,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[11,"nested_visit_map","","",182,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_pat","","",182,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[8,"PatternFoldable","rustc_mir::hair::pattern","",null,null],[11,"fold_with","","",183,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[10,"super_fold_with","","",183,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[8,"PatternFolder","","",null,null],[11,"fold_pattern","","",184,{"inputs":[{"name":"self"},{"name":"pattern"}],"output":{"name":"pattern"}}],[11,"fold_pattern_kind","","",184,{"inputs":[{"name":"self"},{"name":"patternkind"}],"output":{"name":"patternkind"}}],[11,"clone","","",168,{"inputs":[{"name":"self"}],"output":{"name":"patternerror"}}],[11,"fmt","","",168,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",169,{"inputs":[{"name":"self"}],"output":{"name":"bindingmode"}}],[11,"fmt","","",169,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",165,{"inputs":[{"name":"self"}],"output":{"name":"fieldpattern"}}],[11,"fmt","","",165,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",166,{"inputs":[{"name":"self"}],"output":{"name":"pattern"}}],[11,"fmt","","",166,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",170,{"inputs":[{"name":"self"}],"output":{"name":"patternkind"}}],[11,"fmt","","",170,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",166,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_hir","","",166,{"inputs":[{"name":"tyctxt"},{"generics":["substs"],"name":"paramenvand"},{"name":"typecktables"},{"name":"pat"}],"output":{"name":"self"}}],[11,"new","","",167,{"inputs":[{"name":"tyctxt"},{"generics":["substs"],"name":"paramenvand"},{"name":"typecktables"}],"output":{"name":"self"}}],[11,"lower_pattern","","",167,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"pattern"}}],[11,"lower_pattern_unadjusted","","",167,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"pattern"}}],[11,"lower_patterns","","",167,null],[11,"lower_opt_pattern","","",167,{"inputs":[{"name":"self"},{"name":"option"}],"output":{"generics":["pattern"],"name":"option"}}],[11,"flatten_nested_slice_patterns","","",167,null],[11,"slice_or_array_pattern","","",167,null],[11,"lower_variant_or_leaf","","",167,{"inputs":[{"name":"self"},{"name":"def"},{"name":"span"},{"name":"ty"},{"generics":["fieldpattern"],"name":"vec"}],"output":{"name":"patternkind"}}],[11,"lower_path","","Takes a HIR Path. If the path is a constant, evaluates it and feeds it to `const_to_pat`. Any other path (like enum variants without fields) is converted to the corresponding pattern via `lower_variant_or_leaf`",167,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"hirid"},{"name":"span"}],"output":{"name":"pattern"}}],[11,"lower_lit","","Converts literals, paths and negation of literals to patterns. The special case for negation exists to allow things like -128i8 which would overflow if we tried to evaluate 128i8 and then negate afterwards.",167,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"patternkind"}}],[11,"const_to_pat","","Converts an evaluated constant to a pattern (if possible). This means aggregate values (like structs and enums) are converted to a pattern that matches the value (as if you'd compare via eq).",167,{"inputs":[{"name":"self"},{"name":"instance"},{"name":"const"},{"name":"hirid"},{"name":"span"}],"output":{"name":"pattern"}}],[11,"super_fold_with","","",169,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_fold_with","","",165,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fold_with","","",166,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_fold_with","","",166,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fold_with","","",170,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"super_fold_with","","",170,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[8,"Mirror","rustc_mir::hair","\"Mirroring\" is the process of converting from a HIR type into one of the HAIR types defined in this file. This is basically a \"on the fly\" desugaring step that hides a lot of the messiness in the tcx. For example, the mirror of a `&'tcx hir::Expr` is an `Expr<'tcx>`.",null,null],[16,"Output","","",185,null],[10,"make_mirror","","",185,null],[11,"clone","","",155,{"inputs":[{"name":"self"}],"output":{"name":"lintlevel"}}],[11,"fmt","","",155,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_explicit","","",155,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",149,{"inputs":[{"name":"self"}],"output":{"name":"block"}}],[11,"fmt","","",149,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",156,{"inputs":[{"name":"self"}],"output":{"name":"blocksafety"}}],[11,"fmt","","",156,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",157,{"inputs":[{"name":"self"}],"output":{"name":"stmtref"}}],[11,"fmt","","",157,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",150,{"inputs":[{"name":"self"}],"output":{"name":"stmt"}}],[11,"fmt","","",150,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",158,{"inputs":[{"name":"self"}],"output":{"name":"stmtkind"}}],[11,"fmt","","",158,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",151,{"inputs":[{"name":"self"}],"output":{"name":"expr"}}],[11,"fmt","","",151,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",159,{"inputs":[{"name":"self"}],"output":{"name":"exprkind"}}],[11,"fmt","","",159,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",160,{"inputs":[{"name":"self"}],"output":{"name":"exprref"}}],[11,"fmt","","",160,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",152,{"inputs":[{"name":"self"}],"output":{"name":"fieldexprref"}}],[11,"fmt","","",152,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",153,{"inputs":[{"name":"self"}],"output":{"name":"fruinfo"}}],[11,"fmt","","",153,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",154,{"inputs":[{"name":"self"}],"output":{"name":"arm"}}],[11,"fmt","","",154,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",161,{"inputs":[{"name":"self"}],"output":{"name":"logicalop"}}],[11,"fmt","","",161,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"make_mirror","","",151,{"inputs":[{"name":"self"},{"name":"cx"}],"output":{"name":"expr"}}],[11,"make_mirror","","",160,{"inputs":[{"name":"self"},{"name":"cx"}],"output":{"name":"expr"}}],[11,"make_mirror","","",150,{"inputs":[{"name":"self"},{"name":"cx"}],"output":{"name":"stmt"}}],[11,"make_mirror","","",157,{"inputs":[{"name":"self"},{"name":"cx"}],"output":{"name":"stmt"}}],[11,"make_mirror","","",149,{"inputs":[{"name":"self"},{"name":"cx"}],"output":{"name":"block"}}],[0,"shim","rustc_mir","",null,null],[3,"DropShimElaborator","rustc_mir::shim","",null,null],[12,"mir","","",186,null],[12,"patch","","",186,null],[12,"tcx","","",186,null],[12,"param_env","","",186,null],[3,"CloneShimBuilder","","",null,null],[12,"tcx","","",187,null],[12,"def_id","","",187,null],[12,"local_decls","","",187,null],[12,"blocks","","",187,null],[12,"span","","",187,null],[12,"sig","","",187,null],[4,"Adjustment","","",null,null],[13,"Identity","","",188,null],[13,"Deref","","",188,null],[13,"RefMut","","",188,null],[4,"CallKind","","",null,null],[13,"Indirect","","",189,null],[13,"Direct","","",189,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"make_shim","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instancedef"}],"output":{"name":"mir"}}],[5,"temp_decl","","",null,{"inputs":[{"name":"mutability"},{"name":"ty"},{"name":"span"}],"output":{"name":"localdecl"}}],[5,"local_decls_for_sig","","",null,{"inputs":[{"name":"fnsig"},{"name":"span"}],"output":{"generics":["local","localdecl"],"name":"indexvec"}}],[5,"build_drop_shim","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"generics":["ty"],"name":"option"}],"output":{"name":"mir"}}],[5,"build_clone_shim","","Build a `Clone::clone` shim for `self_ty`. Here, `def_id` is `Clone::clone`.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"ty"}],"output":{"name":"mir"}}],[5,"build_call_shim","","Build a \"call\" shim for `def_id`. The shim calls the function specified by `call_kind`, first adjusting its first argument according to `rcvr_adjustment`.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"adjustment"},{"name":"callkind"},{"name":"option"}],"output":{"name":"mir"}}],[5,"build_adt_ctor","","",null,null],[11,"clone","","",188,{"inputs":[{"name":"self"}],"output":{"name":"adjustment"}}],[11,"fmt","","",188,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",188,{"inputs":[{"name":"self"},{"name":"adjustment"}],"output":{"name":"bool"}}],[11,"clone","","",189,{"inputs":[{"name":"self"}],"output":{"name":"callkind"}}],[11,"fmt","","",189,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",189,{"inputs":[{"name":"self"},{"name":"callkind"}],"output":{"name":"bool"}}],[11,"ne","","",189,{"inputs":[{"name":"self"},{"name":"callkind"}],"output":{"name":"bool"}}],[11,"fmt","","",186,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"patch","","",186,{"inputs":[{"name":"self"}],"output":{"name":"mirpatch"}}],[11,"mir","","",186,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"tcx","","",186,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"param_env","","",186,{"inputs":[{"name":"self"}],"output":{"name":"paramenv"}}],[11,"drop_style","","",186,null],[11,"get_drop_flag","","",186,null],[11,"clear_drop_flag","","",186,null],[11,"field_subpath","","",186,null],[11,"deref_subpath","","",186,null],[11,"downcast_subpath","","",186,null],[11,"array_subpath","","",186,null],[11,"new","","",187,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"ty"}],"output":{"name":"self"}}],[11,"into_mir","","",187,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"source_info","","",187,{"inputs":[{"name":"self"}],"output":{"name":"sourceinfo"}}],[11,"block","","",187,{"inputs":[{"name":"self"},{"generics":["statement"],"name":"vec"},{"name":"terminatorkind"},{"name":"bool"}],"output":{"name":"basicblock"}}],[11,"block_index_offset","","Gives the index of an upcoming BasicBlock, with an offset. offset=0 will give you the index of the next BasicBlock, offset=1 will give the index of the next-to-next block, offset=-1 will give you the index of the last-created block",187,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"basicblock"}}],[11,"make_statement","","",187,{"inputs":[{"name":"self"},{"name":"statementkind"}],"output":{"name":"statement"}}],[11,"copy_shim","","",187,{"inputs":[{"name":"self"}],"output":null}],[11,"make_place","","",187,{"inputs":[{"name":"self"},{"name":"mutability"},{"name":"ty"}],"output":{"name":"place"}}],[11,"make_clone_call","","",187,{"inputs":[{"name":"self"},{"name":"place"},{"name":"place"},{"name":"ty"},{"name":"basicblock"},{"name":"basicblock"}],"output":null}],[11,"loop_header","","",187,{"inputs":[{"name":"self"},{"name":"place"},{"name":"place"},{"name":"basicblock"},{"name":"basicblock"},{"name":"bool"}],"output":null}],[11,"make_usize","","",187,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"generics":["constant"],"name":"box"}}],[11,"array_shim","","",187,{"inputs":[{"name":"self"},{"name":"place"},{"name":"place"},{"name":"ty"},{"name":"u64"}],"output":null}],[11,"tuple_like_shim","","",187,{"inputs":[{"name":"self"},{"name":"place"},{"name":"place"},{"name":"i"}],"output":null}],[0,"transform","rustc_mir","",null,null],[3,"MirSource","rustc_mir::transform","Where a specific Mir comes from.",null,null],[12,"def_id","","",190,null],[12,"promoted","","If `Some`, this is a promoted rvalue within the parent function.",190,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"is_mir_available","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"mir_keys","","Finds the full set of def-ids within the current crate that have MIR associated with them.",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["defidset"],"name":"lrc"}}],[5,"mir_built","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"steal"}}],[5,"default_name","","Generates a default name for the pass based on the name of the type `T`.",null,{"inputs":[],"output":{"generics":["str"],"name":"cow"}}],[5,"mir_const","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"steal"}}],[5,"mir_validated","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"steal"}}],[5,"optimized_mir","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"mir"}}],[0,"add_validation","","This pass adds validation calls (AcquireValid, ReleaseValid) where appropriate. It has to be run really early, before transformations like inlining, because introducing these calls adds UB -- so, conceptually, this pass is actually part of MIR building, and only after this pass we think of the program has having the normal MIR semantics.",null,null],[3,"AddValidation","rustc_mir::transform::add_validation","",null,null],[5,"place_context","","Determine the \"context\" of the place: Mutability and region.",null,null],[5,"fn_contains_unsafe","","Check if this function contains an unsafe block or is an unsafe function.",null,{"inputs":[{"name":"tyctxt"},{"name":"mirsource"}],"output":{"name":"bool"}}],[11,"run_pass","","",191,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"add_moves_for_packed_drops","rustc_mir::transform","",null,null],[3,"AddMovesForPackedDrops","rustc_mir::transform::add_moves_for_packed_drops","",null,null],[5,"add_moves_for_packed_drops","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"defid"}],"output":null}],[5,"add_moves_for_packed_drops_patch","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"defid"}],"output":{"name":"mirpatch"}}],[5,"add_move_for_packed_drop","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"mirpatch"},{"name":"terminator"},{"name":"location"},{"name":"bool"}],"output":null}],[11,"run_pass","","",192,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"cleanup_post_borrowck","rustc_mir::transform","This module provides two passes:",null,null],[3,"CleanEndRegions","rustc_mir::transform::cleanup_post_borrowck","",null,null],[3,"GatherBorrowedRegions","","",null,null],[12,"seen_regions","","",193,null],[3,"DeleteTrivialEndRegions","","",null,null],[12,"seen_regions","","",194,null],[3,"CleanUserAssertTy","","",null,null],[3,"DeleteUserAssertTy","","",null,null],[11,"run_pass","","",195,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"visit_rvalue","","",193,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_ty","","",193,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_statement","","",194,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"run_pass","","",196,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"visit_statement","","",197,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[0,"check_unsafety","rustc_mir::transform","",null,null],[3,"UnsafetyChecker","rustc_mir::transform::check_unsafety","",null,null],[12,"mir","","",198,null],[12,"visibility_scope_info","","",198,null],[12,"violations","","",198,null],[12,"source_info","","",198,null],[12,"tcx","","",198,null],[12,"param_env","","",198,null],[12,"used_unsafe","","",198,null],[12,"inherited_blocks","","",198,null],[3,"UnusedUnsafeVisitor","","",null,null],[12,"used_unsafe","","",199,null],[12,"unsafe_blocks","","",199,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"check_unused_unsafe","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"fxhashset"},{"name":"vec"}],"output":null}],[5,"unsafety_check_result","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"unsafetycheckresult"}}],[5,"unsafe_derive_on_repr_packed","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"is_enclosed","","Return the NodeId for an enclosing scope that is also `unsafe`",null,{"inputs":[{"name":"tyctxt"},{"name":"fxhashset"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"report_unused_unsafe","","",null,{"inputs":[{"name":"tyctxt"},{"name":"fxhashset"},{"name":"nodeid"}],"output":null}],[5,"builtin_derive_def_id","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["defid"],"name":"option"}}],[5,"check_unsafety","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[11,"new","","",198,{"inputs":[{"name":"mir"},{"name":"indexvec"},{"name":"tyctxt"},{"name":"paramenv"}],"output":{"name":"self"}}],[11,"visit_terminator","","",198,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"visit_statement","","",198,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",198,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_place","","",198,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"require_unsafe","","",198,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"register_violations","","",198,null],[11,"nested_visit_map","","",199,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_block","","",199,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[0,"simplify_branches","rustc_mir::transform","A pass that simplifies branches when their condition is known.",null,null],[3,"SimplifyBranches","rustc_mir::transform::simplify_branches","",null,null],[12,"label","","",200,null],[11,"new","","",200,{"inputs":[{"name":"str"}],"output":{"name":"self"}}],[11,"name","","",200,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"run_pass","","",200,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"simplify","rustc_mir::transform","A number of passes which remove various redundancies in the CFG.",null,null],[3,"SimplifyCfg","rustc_mir::transform::simplify","",null,null],[12,"label","","",201,null],[3,"CfgSimplifier","","",null,null],[12,"basic_blocks","","",202,null],[12,"pred_count","","",202,null],[3,"SimplifyLocals","","",null,null],[3,"DeclMarker","","",null,null],[12,"locals","","",203,null],[3,"LocalUpdater","","",null,null],[12,"map","","",204,null],[5,"simplify_cfg","","",null,{"inputs":[{"name":"mir"}],"output":null}],[5,"remove_dead_blocks","","",null,{"inputs":[{"name":"mir"}],"output":null}],[5,"make_local_map","","Construct the mapping while swapping out unused stuff out from the `vec`.",null,{"inputs":[{"name":"indexvec"},{"name":"bitvector"}],"output":{"generics":["usize"],"name":"vec"}}],[11,"new","","",201,{"inputs":[{"name":"str"}],"output":{"name":"self"}}],[11,"name","","",201,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"run_pass","","",201,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"new","","",202,{"inputs":[{"name":"mir"}],"output":{"name":"self"}}],[11,"simplify","","",202,{"inputs":[{"name":"self"}],"output":null}],[11,"collapse_goto_chain","","",202,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"bool"}],"output":null}],[11,"merge_successor","","",202,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"terminator"}],"output":{"name":"bool"}}],[11,"simplify_branch","","",202,{"inputs":[{"name":"self"},{"name":"terminator"}],"output":{"name":"bool"}}],[11,"strip_nops","","",202,{"inputs":[{"name":"self"}],"output":null}],[11,"run_pass","","",205,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"visit_local","","",203,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_basic_block_data","","",204,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_local","","",204,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[0,"erase_regions","rustc_mir::transform","This pass erases all early-bound regions from the types occurring in the MIR. We want to do this once just before trans, so trans does not have to take care erasing regions all over the place. NOTE:  We do NOT erase regions of statements that are relevant for \"types-as-contracts\"-validation, namely, AcquireValid, ReleaseValid, and EndRegion.",null,null],[3,"EraseRegionsVisitor","rustc_mir::transform::erase_regions","",null,null],[12,"tcx","","",206,null],[12,"in_validation_statement","","",206,null],[3,"EraseRegions","","",null,null],[11,"new","","",206,{"inputs":[{"name":"tyctxt"}],"output":{"name":"self"}}],[11,"visit_ty","","",206,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tycontext"}],"output":null}],[11,"visit_region","","",206,{"inputs":[{"name":"self"},{"name":"region"},{"name":"location"}],"output":null}],[11,"visit_const","","",206,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_substs","","",206,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"location"}],"output":null}],[11,"visit_closure_substs","","",206,{"inputs":[{"name":"self"},{"name":"closuresubsts"},{"name":"location"}],"output":null}],[11,"visit_statement","","",206,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"run_pass","","",207,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"no_landing_pads","rustc_mir::transform","This pass removes the unwind branch of all the terminators when the no-landing-pads option is specified.",null,null],[3,"NoLandingPads","rustc_mir::transform::no_landing_pads","",null,null],[5,"no_landing_pads","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"}],"output":null}],[11,"run_pass","","",208,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"visit_terminator","","",208,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[0,"rustc_peek","rustc_mir::transform","",null,null],[3,"SanityCheck","rustc_mir::transform::rustc_peek","",null,null],[5,"sanity_check_via_rustc_peek","","This function scans `mir` for all calls to the intrinsic `rustc_peek` that have the expression form `rustc_peek(&expr)`.",null,null],[5,"each_block","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"dataflowresults"},{"name":"basicblock"}],"output":null}],[5,"is_rustc_peek","","",null,{"inputs":[{"name":"tyctxt"},{"name":"option"}],"output":{"name":"option"}}],[11,"run_pass","","",209,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"elaborate_drops","rustc_mir::transform","",null,null],[3,"ElaborateDrops","rustc_mir::transform::elaborate_drops","",null,null],[3,"InitializationData","","",null,null],[12,"live","","",210,null],[12,"dead","","",210,null],[3,"Elaborator","","",null,null],[12,"init_data","","",211,null],[12,"ctxt","","",211,null],[3,"ElaborateDropsCtxt","","",null,null],[12,"tcx","","",212,null],[12,"mir","","",212,null],[12,"env","","",212,null],[12,"flow_inits","","",212,null],[12,"flow_uninits","","",212,null],[12,"drop_flags","","",212,null],[12,"patch","","",212,null],[5,"find_dead_unwinds","","Return the set of basic blocks whose unwind edges are known to not be reachable, because they are `drop` terminators that can't drop anything.",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"nodeid"},{"name":"movedataparamenv"}],"output":{"generics":["basicblock"],"name":"idxsetbuf"}}],[11,"run_pass","","",213,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"apply_location","","",210,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mir"},{"name":"movedataparamenv"},{"name":"location"}],"output":null}],[11,"state","","",210,null],[11,"fmt","","",211,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"patch","","",211,{"inputs":[{"name":"self"}],"output":{"name":"mirpatch"}}],[11,"mir","","",211,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"tcx","","",211,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"param_env","","",211,{"inputs":[{"name":"self"}],"output":{"name":"paramenv"}}],[11,"drop_style","","",211,null],[11,"clear_drop_flag","","",211,null],[11,"field_subpath","","",211,null],[11,"array_subpath","","",211,null],[11,"deref_subpath","","",211,null],[11,"downcast_subpath","","",211,null],[11,"get_drop_flag","","",211,null],[11,"move_data","","",212,{"inputs":[{"name":"self"}],"output":{"name":"movedata"}}],[11,"param_env","","",212,{"inputs":[{"name":"self"}],"output":{"name":"paramenv"}}],[11,"initialization_data_at","","",212,{"inputs":[{"name":"self"},{"name":"location"}],"output":{"name":"initializationdata"}}],[11,"create_drop_flag","","",212,{"inputs":[{"name":"self"},{"name":"movepathindex"},{"name":"span"}],"output":null}],[11,"drop_flag","","",212,{"inputs":[{"name":"self"},{"name":"movepathindex"}],"output":{"generics":["place"],"name":"option"}}],[11,"elaborate","","create a patch that elaborates all drops in the input MIR.",212,{"inputs":[{"name":"self"}],"output":{"name":"mirpatch"}}],[11,"collect_drop_flags","","",212,{"inputs":[{"name":"self"}],"output":null}],[11,"elaborate_drops","","",212,{"inputs":[{"name":"self"}],"output":null}],[11,"elaborate_replace","","Elaborate a MIR `replace` terminator. This instruction is not directly handled by translation, and therefore must be desugared.",212,{"inputs":[{"name":"self"},{"name":"location"},{"name":"place"},{"name":"operand"},{"name":"basicblock"},{"generics":["basicblock"],"name":"option"}],"output":null}],[11,"constant_bool","","",212,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"}],"output":{"name":"rvalue"}}],[11,"set_drop_flag","","",212,{"inputs":[{"name":"self"},{"name":"location"},{"name":"movepathindex"},{"name":"dropflagstate"}],"output":null}],[11,"drop_flags_on_init","","",212,{"inputs":[{"name":"self"}],"output":null}],[11,"drop_flags_for_fn_rets","","",212,{"inputs":[{"name":"self"}],"output":null}],[11,"drop_flags_for_args","","",212,{"inputs":[{"name":"self"}],"output":null}],[11,"drop_flags_for_locs","","",212,{"inputs":[{"name":"self"}],"output":null}],[0,"add_call_guards","rustc_mir::transform","",null,null],[4,"AddCallGuards","rustc_mir::transform::add_call_guards","",null,null],[13,"AllCallEdges","","",214,null],[13,"CriticalCallEdges","","",214,null],[11,"eq","","",214,{"inputs":[{"name":"self"},{"name":"addcallguards"}],"output":{"name":"bool"}}],[11,"run_pass","","",214,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"add_call_guards","","",214,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[0,"promote_consts","rustc_mir::transform","A pass that promotes borrows of constant rvalues.",null,null],[3,"TempCollector","rustc_mir::transform::promote_consts","",null,null],[12,"temps","","",215,null],[12,"span","","",215,null],[12,"mir","","",215,null],[3,"Promoter","","",null,null],[12,"source","","",216,null],[12,"promoted","","",216,null],[12,"temps","","",216,null],[12,"keep_original","","If true, all nested temps are also kept in the source MIR, not moved to the promoted MIR.",216,null],[4,"TempState","","State of a temporary during collection and promotion.",null,null],[13,"Undefined","","No references to this temp.",217,null],[13,"Defined","","One direct assignment and any number of direct uses. A borrow of this temp is promotable if the assigned value is qualified as constant.",217,null],[12,"location","rustc_mir::transform::promote_consts::TempState","",217,null],[12,"uses","","",217,null],[13,"Unpromotable","rustc_mir::transform::promote_consts","Any other combination of assignments/uses.",217,null],[13,"PromotedOut","","This temp was part of an rvalue which got extracted during promotion and needs cleanup.",217,null],[4,"Candidate","","A \"root candidate\" for promotion, which will become the returned value in a promoted MIR, unless it's a subset of a larger candidate.",null,null],[13,"Ref","","Borrow of a constant temporary.",218,null],[13,"Argument","","Currently applied to function calls where the callee has the unstable `#[rustc_args_required_const]` attribute as well as the SIMD shuffle intrinsic. The intrinsic requires the arguments are indeed constant and the attribute currently provides the semantic requirement that arguments must be constant.",218,null],[12,"bb","rustc_mir::transform::promote_consts::Candidate","",218,null],[12,"index","","",218,null],[5,"collect_temps","rustc_mir::transform::promote_consts","",null,{"inputs":[{"name":"mir"},{"name":"reversepostorder"}],"output":{"generics":["local","tempstate"],"name":"indexvec"}}],[5,"promote_candidates","","",null,{"inputs":[{"name":"mir"},{"name":"tyctxt"},{"generics":["local","tempstate"],"name":"indexvec"},{"generics":["candidate"],"name":"vec"}],"output":null}],[11,"clone","","",217,{"inputs":[{"name":"self"}],"output":{"name":"tempstate"}}],[11,"eq","","",217,{"inputs":[{"name":"self"},{"name":"tempstate"}],"output":{"name":"bool"}}],[11,"ne","","",217,{"inputs":[{"name":"self"},{"name":"tempstate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",217,null],[11,"fmt","","",217,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_promotable","","",217,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",218,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"visit_local","","",215,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_source_info","","",215,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"new_block","","",216,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"assign","","",216,{"inputs":[{"name":"self"},{"name":"local"},{"name":"rvalue"},{"name":"span"}],"output":null}],[11,"promote_temp","","Copy the initialization of this temp to the promoted MIR, recursing through temps.",216,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"local"}}],[11,"promote_candidate","","",216,{"inputs":[{"name":"self"},{"name":"candidate"}],"output":null}],[11,"visit_local","","",216,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[0,"qualify_consts","rustc_mir::transform","A pass that qualifies constness of temporaries in constants, static initializers and functions and also drives promotion.",null,null],[3,"Qualif","rustc_mir::transform::qualify_consts","",null,null],[12,"bits","","",219,null],[3,"Qualifier","","",null,null],[12,"mode","","",220,null],[12,"span","","",220,null],[12,"def_id","","",220,null],[12,"mir","","",220,null],[12,"rpo","","",220,null],[12,"tcx","","",220,null],[12,"param_env","","",220,null],[12,"temp_qualif","","",220,null],[12,"return_qualif","","",220,null],[12,"qualif","","",220,null],[12,"const_fn_arg_vars","","",220,null],[12,"temp_promotion_state","","",220,null],[12,"promotion_candidates","","",220,null],[3,"QualifyAndPromoteConstants","","",null,null],[4,"Mode","","What kind of item we are in.",null,null],[13,"Const","","",221,null],[13,"Static","","",221,null],[13,"StaticMut","","",221,null],[13,"ConstFn","","",221,null],[13,"Fn","","",221,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"mir_const_qualif","","",null,null],[5,"args_required_const","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["fxhashset"],"name":"option"}}],[11,"eq","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"ne","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",219,null],[11,"clone","","",219,{"inputs":[{"name":"self"}],"output":{"name":"qualif"}}],[11,"partial_cmp","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"le","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"gt","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"ge","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"cmp","","",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"ordering"}}],[11,"hash","","",219,null],[11,"fmt","","",219,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",219,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",219,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",219,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",219,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"MUTABLE_INTERIOR","","",219,null],[18,"NEEDS_DROP","","",219,null],[18,"FN_ARGUMENT","","",219,null],[18,"STATIC","","",219,null],[18,"STATIC_REF","","",219,null],[18,"NOT_CONST","","",219,null],[18,"NOT_PROMOTABLE","","",219,null],[18,"CONST_ERROR","","",219,null],[11,"empty","","Returns an empty set of flags.",219,{"inputs":[],"output":{"name":"qualif"}}],[11,"all","","Returns the set containing all flags.",219,{"inputs":[],"output":{"name":"qualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",219,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",219,{"inputs":[{"name":"u8"}],"output":{"generics":["qualif"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",219,{"inputs":[{"name":"u8"}],"output":{"name":"qualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",219,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",219,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",219,{"inputs":[{"name":"self"},{"name":"qualif"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"qualif"}}],[11,"bitor_assign","","Adds the set of flags.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"qualif"}}],[11,"bitxor_assign","","Toggles the set of flags.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"qualif"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":{"name":"qualif"}}],[11,"sub_assign","","Disables all flags enabled in the set.",219,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",219,{"inputs":[{"name":"self"}],"output":{"name":"qualif"}}],[11,"extend","","",219,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",219,{"inputs":[{"name":"t"}],"output":{"name":"qualif"}}],[11,"restrict","","Remove flags which are impossible for the given type.",219,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"tyctxt"},{"name":"paramenv"}],"output":null}],[11,"clone","","",221,{"inputs":[{"name":"self"}],"output":{"name":"mode"}}],[11,"eq","","",221,{"inputs":[{"name":"self"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",221,null],[11,"fmt","","",221,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",220,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"mir"},{"name":"mode"}],"output":{"name":"qualifier"}}],[11,"not_const","","",220,{"inputs":[{"name":"self"}],"output":null}],[11,"statement_like","","Error about extra statements in a constant.",220,{"inputs":[{"name":"self"}],"output":null}],[11,"add","","Add the given qualification to self.qualif.",220,{"inputs":[{"name":"self"},{"name":"qualif"}],"output":null}],[11,"add_type","","Add the given type's qualification to self.qualif.",220,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"nest","","Within the provided closure, self.qualif will start out empty, and its value after the closure returns will be combined with the value before the call to nest.",220,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"can_promote","","Check if a Local with the current qualifications is promotable.",220,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"try_consume","","Check if a Place with the current qualifications could be consumed, by either an operand or a Deref projection.",220,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"assign","","Assign the current qualification to the given destination.",220,{"inputs":[{"name":"self"},{"name":"place"},{"name":"location"}],"output":null}],[11,"qualify_const","","Qualify a whole const, static initializer or const fn.",220,null],[11,"visit_local","","",220,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_place","","",220,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_operand","","",220,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",220,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_terminator_kind","","",220,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"visit_assign","","",220,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_source_info","","",220,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"visit_statement","","",220,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_terminator","","",220,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"run_pass","","",222,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"remove_noop_landing_pads","rustc_mir::transform","",null,null],[3,"RemoveNoopLandingPads","rustc_mir::transform::remove_noop_landing_pads","A pass that removes no-op landing pads and replaces jumps to them with `None`. This is important because otherwise LLVM generates terrible code for these.",null,null],[5,"remove_noop_landing_pads","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"}],"output":null}],[11,"run_pass","","",223,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"is_nop_landing_pad","","",223,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"mir"},{"name":"bitvector"}],"output":{"name":"bool"}}],[11,"remove_nop_landing_pads","","",223,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[0,"dump_mir","rustc_mir::transform","This pass just dumps MIR at a specified point.",null,null],[3,"Marker","rustc_mir::transform::dump_mir","",null,null],[12,"0","","",224,null],[3,"Disambiguator","","",null,null],[12,"is_after","","",225,null],[5,"on_mir_pass","","",null,{"inputs":[{"name":"tyctxt"},{"name":"display"},{"name":"str"},{"name":"mirsource"},{"name":"mir"},{"name":"bool"}],"output":null}],[5,"emit_mir","","",null,{"inputs":[{"name":"tyctxt"},{"name":"outputfilenames"}],"output":{"name":"result"}}],[11,"name","","",224,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[11,"run_pass","","",224,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"fmt","","",225,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"deaggregator","rustc_mir::transform","",null,null],[3,"Deaggregator","rustc_mir::transform::deaggregator","",null,null],[11,"run_pass","","",226,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"instcombine","rustc_mir::transform","Performs various peephole optimizations.",null,null],[3,"InstCombine","rustc_mir::transform::instcombine","",null,null],[3,"InstCombineVisitor","","",null,null],[12,"optimizations","","",227,null],[3,"OptimizationFinder","","Finds optimization opportunities on the MIR.",null,null],[12,"mir","","",228,null],[12,"tcx","","",228,null],[12,"optimizations","","",228,null],[3,"OptimizationList","","",null,null],[12,"and_stars","","",229,null],[12,"arrays_lengths","","",229,null],[11,"run_pass","","",230,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"visit_rvalue","","",227,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"new","","",228,{"inputs":[{"name":"mir"},{"name":"tyctxt"}],"output":{"name":"optimizationfinder"}}],[11,"visit_rvalue","","",228,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"default","","",229,{"inputs":[],"output":{"name":"optimizationlist"}}],[0,"copy_prop","rustc_mir::transform","Trivial copy propagation pass.",null,null],[3,"CopyPropagation","rustc_mir::transform::copy_prop","",null,null],[3,"ConstantPropagationVisitor","","",null,null],[12,"dest_local","","",231,null],[12,"constant","","",231,null],[12,"uses_replaced","","",231,null],[4,"Action","","",null,null],[13,"PropagateLocalCopy","","",232,null],[13,"PropagateConstant","","",232,null],[5,"eliminate_self_assignments","","",null,{"inputs":[{"name":"mir"},{"name":"defuseanalysis"}],"output":{"name":"bool"}}],[11,"run_pass","","",233,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"local_copy","","",232,{"inputs":[{"name":"mir"},{"name":"defuseanalysis"},{"name":"place"}],"output":{"generics":["action"],"name":"option"}}],[11,"constant","","",232,{"inputs":[{"name":"constant"}],"output":{"generics":["action"],"name":"option"}}],[11,"perform","","",232,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"defuseanalysis"},{"name":"local"},{"name":"location"}],"output":{"name":"bool"}}],[11,"new","","",231,{"inputs":[{"name":"local"},{"name":"constant"}],"output":{"name":"constantpropagationvisitor"}}],[11,"visit_operand","","",231,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[0,"const_prop","rustc_mir::transform","Propagates constants for early reporting of statically known assertion failures",null,null],[3,"ConstProp","rustc_mir::transform::const_prop","",null,null],[3,"ConstPropagator","","Finds optimization opportunities on the MIR.",null,null],[12,"mir","","",234,null],[12,"tcx","","",234,null],[12,"source","","",234,null],[12,"places","","",234,null],[12,"can_const_prop","","",234,null],[12,"param_env","","",234,null],[3,"CanConstProp","","",null,null],[12,"can_const_prop","","",235,null],[12,"found_assignment","","",235,null],[5,"type_size_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"ty"}],"output":{"generics":["u64"],"name":"option"}}],[6,"Const","","",null,null],[11,"run_pass","","",236,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"new","","",234,{"inputs":[{"name":"mir"},{"name":"tyctxt"},{"name":"mirsource"}],"output":{"name":"constpropagator"}}],[11,"const_eval","","",234,{"inputs":[{"name":"self"},{"name":"globalid"},{"name":"span"}],"output":{"name":"option"}}],[11,"eval_constant","","",234,{"inputs":[{"name":"self"},{"name":"constant"}],"output":{"name":"option"}}],[11,"eval_place","","",234,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"option"}}],[11,"eval_operand","","",234,{"inputs":[{"name":"self"},{"name":"operand"}],"output":{"name":"option"}}],[11,"const_prop","","",234,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"ty"},{"name":"sourceinfo"}],"output":{"name":"option"}}],[11,"check","","returns true if `local` can be propagated",235,{"inputs":[{"name":"mir"}],"output":{"generics":["local","bool"],"name":"indexvec"}}],[11,"visit_local","","",235,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_constant","","",234,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"visit_statement","","",234,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_terminator_kind","","",234,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[0,"generator","rustc_mir::transform","This is the implementation of the pass which transforms generators into state machines.",null,null],[3,"StateTransform","rustc_mir::transform::generator","",null,null],[3,"RenameLocalVisitor","","",null,null],[12,"from","","",237,null],[12,"to","","",237,null],[3,"DerefArgVisitor","","",null,null],[3,"SuspensionPoint","","",null,null],[12,"state","","",238,null],[12,"resume","","",238,null],[12,"drop","","",238,null],[12,"storage_liveness","","",238,null],[3,"TransformVisitor","","",null,null],[12,"tcx","","",239,null],[12,"state_adt_ref","","",239,null],[12,"state_substs","","",239,null],[12,"state_field","","",239,null],[12,"remap","","",239,null],[12,"storage_liveness","","",239,null],[12,"suspension_points","","",239,null],[12,"new_ret_local","","",239,null],[3,"StorageIgnored","","",null,null],[12,"0","","",240,null],[3,"BorrowedLocals","","",null,null],[12,"0","","",241,null],[5,"self_arg","","",null,{"inputs":[],"output":{"name":"local"}}],[5,"make_generator_state_argument_indirect","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"mir"}],"output":null}],[5,"replace_result_variable","","",null,{"inputs":[{"name":"ty"},{"name":"mir"}],"output":{"name":"local"}}],[5,"mark_as_borrowed","","",null,{"inputs":[{"name":"place"},{"name":"borrowedlocals"}],"output":null}],[5,"locals_live_across_suspend_points","","",null,null],[5,"compute_layout","","",null,null],[5,"insert_switch","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"vec"},{"name":"transformvisitor"},{"name":"terminatorkind"}],"output":null}],[5,"elaborate_generator_drops","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"mir"}],"output":null}],[5,"create_generator_drop_shim","","",null,{"inputs":[{"name":"tyctxt"},{"name":"transformvisitor"},{"name":"defid"},{"name":"mirsource"},{"name":"ty"},{"name":"mir"},{"name":"basicblock"}],"output":{"name":"mir"}}],[5,"insert_term_block","","",null,{"inputs":[{"name":"mir"},{"name":"terminatorkind"}],"output":{"name":"basicblock"}}],[5,"insert_panic_block","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"assertmessage"}],"output":{"name":"basicblock"}}],[5,"create_generator_resume_function","","",null,{"inputs":[{"name":"tyctxt"},{"name":"transformvisitor"},{"name":"defid"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[5,"source_info","","",null,{"inputs":[{"name":"mir"}],"output":{"name":"sourceinfo"}}],[5,"insert_clean_drop","","",null,{"inputs":[{"name":"mir"}],"output":{"name":"basicblock"}}],[5,"create_cases","","",null,{"inputs":[{"name":"mir"},{"name":"transformvisitor"},{"name":"f"}],"output":{"name":"vec"}}],[11,"visit_local","","",237,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_local","","",242,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_place","","",242,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"make_state","","",239,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"operand"}],"output":{"name":"rvalue"}}],[11,"make_field","","",239,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"ty"}],"output":{"name":"place"}}],[11,"set_state","","",239,{"inputs":[{"name":"self"},{"name":"u32"},{"name":"sourceinfo"}],"output":{"name":"statement"}}],[11,"visit_local","","",239,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_place","","",239,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_basic_block_data","","",239,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_statement","","",240,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",241,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"run_pass","","",243,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[0,"inline","rustc_mir::transform","Inlining pass for MIR functions",null,null],[3,"Inline","rustc_mir::transform::inline","",null,null],[3,"CallSite","","",null,null],[12,"callee","","",244,null],[12,"substs","","",244,null],[12,"bb","","",244,null],[12,"location","","",244,null],[3,"Inliner","","",null,null],[12,"tcx","","",245,null],[12,"source","","",245,null],[3,"Integrator","","Integrator.",null,null],[12,"block_idx","","",246,null],[12,"args","","",246,null],[12,"local_map","","",246,null],[12,"scope_map","","",246,null],[12,"promoted_map","","",246,null],[12,"_callsite","","",246,null],[12,"destination","","",246,null],[12,"return_block","","",246,null],[12,"cleanup_block","","",246,null],[12,"in_cleanup_block","","",246,null],[5,"type_size_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"ty"}],"output":{"generics":["u64"],"name":"option"}}],[17,"DEFAULT_THRESHOLD","","",null,null],[17,"HINT_THRESHOLD","","",null,null],[17,"INSTR_COST","","",null,null],[17,"CALL_PENALTY","","",null,null],[17,"UNKNOWN_SIZE_COST","","",null,null],[11,"clone","","",244,{"inputs":[{"name":"self"}],"output":{"name":"callsite"}}],[11,"fmt","","",244,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"run_pass","","",247,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"run_pass","","",245,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"should_inline","","",245,{"inputs":[{"name":"self"},{"name":"callsite"},{"name":"mir"}],"output":{"name":"bool"}}],[11,"inline_call","","",245,{"inputs":[{"name":"self"},{"name":"callsite"},{"name":"mir"},{"name":"mir"}],"output":{"name":"bool"}}],[11,"make_call_args","","",245,{"inputs":[{"name":"self"},{"generics":["operand"],"name":"vec"},{"name":"callsite"},{"name":"mir"}],"output":{"generics":["local"],"name":"vec"}}],[11,"create_temp_if_necessary","","If `arg` is already a temporary, returns it. Otherwise, introduces a fresh temporary `T` and an instruction `T = arg`, and returns `T`.",245,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"callsite"},{"name":"mir"}],"output":{"name":"local"}}],[11,"update_target","","",246,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"basicblock"}}],[11,"visit_local","","",246,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_place","","",246,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_basic_block_data","","",246,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_terminator_kind","","",246,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"visit_visibility_scope","","",246,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":null}],[11,"visit_literal","","",246,{"inputs":[{"name":"self"},{"name":"literal"},{"name":"location"}],"output":null}],[0,"lower_128bit","rustc_mir::transform","Replaces 128-bit operators with lang item calls",null,null],[3,"Lower128Bit","rustc_mir::transform::lower_128bit","",null,null],[4,"RhsKind","","",null,null],[13,"Unchanged","","",248,null],[13,"ForceU128","","",248,null],[13,"ForceU32","","",248,null],[5,"check_lang_item_type","","",null,{"inputs":[{"name":"langitem"},{"name":"place"},{"name":"operand"},{"name":"operand"},{"name":"d"},{"name":"tyctxt"}],"output":{"name":"defid"}}],[5,"lower_to","","",null,{"inputs":[{"name":"statement"},{"name":"d"},{"name":"tyctxt"}],"output":{"name":"option"}}],[5,"sign_of_128bit","","",null,{"inputs":[{"name":"ty"}],"output":{"generics":["bool"],"name":"option"}}],[5,"item_for_op","","",null,{"inputs":[{"name":"binop"},{"name":"bool"}],"output":{"name":"option"}}],[5,"item_for_checked_op","","",null,{"inputs":[{"name":"binop"},{"name":"bool"}],"output":{"name":"option"}}],[11,"run_pass","","",249,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"lower_128bit_ops","","",249,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mir"}],"output":null}],[11,"clone","","",248,{"inputs":[{"name":"self"}],"output":{"name":"rhskind"}}],[11,"ty","","",248,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["ty"],"name":"option"}}],[0,"uniform_array_move_out","rustc_mir::transform","",null,null],[3,"UniformArrayMoveOut","rustc_mir::transform::uniform_array_move_out","",null,null],[3,"UniformArrayMoveOutVisitor","","",null,null],[12,"mir","","",250,null],[12,"patch","","",250,null],[12,"tcx","","",250,null],[3,"RestoreSubsliceArrayMoveOut","","",null,null],[3,"LocalUse","","",null,null],[12,"alive","","",251,null],[12,"dead","","",251,null],[12,"use_count","","",251,null],[12,"first_use","","",251,null],[3,"RestoreDataCollector","","",null,null],[12,"locals_use","","",252,null],[12,"candidates","","",252,null],[11,"run_pass","","",253,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"visit_assign","","",250,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"uniform","","",250,{"inputs":[{"name":"self"},{"name":"location"},{"name":"place"},{"name":"placeprojection"},{"name":"tys"},{"name":"u32"}],"output":null}],[11,"run_pass","","",254,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"check_and_patch","","",254,{"inputs":[{"name":"location"},{"name":"vec"},{"generics":["u64"],"name":"option"},{"name":"mirpatch"},{"name":"place"}],"output":null}],[11,"try_get_item_source","","",254,{"inputs":[{"name":"localuse"},{"name":"mir"}],"output":{"name":"option"}}],[11,"clone","","",251,{"inputs":[{"name":"self"}],"output":{"name":"localuse"}}],[11,"fmt","","",251,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",251,{"inputs":[],"output":{"name":"self"}}],[11,"visit_assign","","",252,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"place"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_local","","",252,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[8,"MirPass","rustc_mir::transform","A streamlined trait that you can implement to create a pass; the pass will be named after the type, and it will consist of a main loop that goes over each available MIR and applies `run_pass`.",null,null],[11,"name","","",255,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"cow"}}],[10,"run_pass","","",255,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"}],"output":null}],[11,"fmt","","",190,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",190,{"inputs":[{"name":"self"}],"output":{"name":"mirsource"}}],[11,"item","","",190,{"inputs":[{"name":"defid"}],"output":{"name":"self"}}],[0,"util","rustc_mir","",null,null],[4,"PassWhere","rustc_mir::util","An indication of where we are in the control flow graph. Used for printing extra information in `dump_mir`",null,null],[13,"BeforeCFG","","We have not started dumping the control flow graph, but we are about to.",256,null],[13,"AfterCFG","","We just finished dumping the control flow graph. This is right before EOF",256,null],[13,"BeforeBlock","","We are about to start dumping the given basic block.",256,null],[13,"BeforeLocation","","We are just about to dump the given statement or terminator.",256,null],[13,"AfterLocation","","We just dumped the given statement or terminator.",256,null],[5,"is_disaligned","","Return `true` if this place is allowed to be less aligned than its containing struct (because it is within a packed struct).",null,{"inputs":[{"name":"tyctxt"},{"name":"l"},{"name":"paramenv"},{"name":"place"}],"output":{"name":"bool"}}],[5,"dump_enabled","","",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"name":"mirsource"}],"output":{"name":"bool"}}],[5,"dump_mir","","If the session is properly configured, dumps a human-readable representation of the mir into:",null,{"inputs":[{"name":"tyctxt"},{"generics":["display"],"name":"option"},{"name":"str"},{"name":"display"},{"name":"mirsource"},{"name":"mir"},{"name":"f"}],"output":null}],[5,"write_mir_pretty","","Write out a human-readable textual representation for the given MIR.",null,{"inputs":[{"name":"tyctxt"},{"generics":["defid"],"name":"option"},{"name":"write"}],"output":{"name":"result"}}],[5,"write_mir_graphviz","","Write a graphviz DOT graph of a list of MIRs.",null,{"inputs":[{"name":"tyctxt"},{"generics":["defid"],"name":"option"},{"name":"w"}],"output":{"name":"result"}}],[5,"write_graphviz_node_label","","Write a graphviz HTML-styled label for the given basic block, with all necessary escaping already performed. (This is suitable for emitting directly, as is done in this module, or for use with the LabelText::HtmlStr from libgraphviz.)",null,{"inputs":[{"name":"basicblock"},{"name":"mir"},{"name":"w"},{"name":"u32"},{"name":"init"},{"name":"fini"}],"output":{"name":"result"}}],[0,"borrowck_errors","","",null,null],[4,"Origin","rustc_mir::util::borrowck_errors","",null,null],[13,"Ast","","",257,null],[13,"Mir","","",257,null],[8,"BorrowckErrors","","",null,null],[10,"struct_span_err_with_code","","",258,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":{"name":"diagnosticbuilder"}}],[10,"struct_span_err","","",258,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[10,"cancel_if_wrong_origin","","Cancels the given error if we shouldn't emit errors for a given origin in the current mode.",258,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_move_when_borrowed","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_use_when_mutably_borrowed","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_act_on_uninitialized_variable","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_mutably_borrow_multiply","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"span"},{"name":"str"},{"generics":["span"],"name":"option"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_uniquely_borrow_by_two_closures","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"span"},{"generics":["span"],"name":"option"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_uniquely_borrow_by_one_closure","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"span"},{"name":"str"},{"name":"str"},{"generics":["span"],"name":"option"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_reborrow_already_uniquely_borrowed","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"str"},{"name":"span"},{"name":"str"},{"generics":["span"],"name":"option"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_reborrow_already_borrowed","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"str"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"str"},{"generics":["span"],"name":"option"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_assign_to_borrowed","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_move_into_closure","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_reassign_immutable","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"bool"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_assign","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_assign_static","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_move_out_of","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_move_out_of_interior_noncopy","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"bool"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_move_out_of_interior_of_drop","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_act_on_moved_value","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_partially_reinit_an_uninit_struct","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"closure_cannot_assign_to_borrowed","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_borrow_path_as_mutable","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_borrow_across_generator_yield","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"path_does_not_live_long_enough","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"lifetime_too_short_for_reborrow","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_act_on_capture_in_sharable_fn","","",258,null],[11,"cannot_assign_into_immutable_reference","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"cannot_capture_in_long_lived_closure","","",258,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"span"},{"name":"origin"}],"output":{"name":"diagnosticbuilder"}}],[11,"clone","","",257,{"inputs":[{"name":"self"}],"output":{"name":"origin"}}],[11,"eq","","",257,{"inputs":[{"name":"self"},{"name":"origin"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",257,null],[11,"fmt","","",257,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",257,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"should_emit_errors","","Whether we should emit errors for the origin in the given mode",257,{"inputs":[{"name":"self"},{"name":"borrowckmode"}],"output":{"name":"bool"}}],[0,"elaborate_drops","rustc_mir::util","",null,null],[3,"DropCtxt","rustc_mir::util::elaborate_drops","",null,null],[12,"elaborator","","",259,null],[12,"source_info","","",259,null],[12,"place","","",259,null],[12,"path","","",259,null],[12,"succ","","",259,null],[12,"unwind","","",259,null],[4,"DropFlagState","","",null,null],[13,"Present","","",260,null],[13,"Absent","","",260,null],[4,"DropStyle","","",null,null],[13,"Dead","","",261,null],[13,"Static","","",261,null],[13,"Conditional","","",261,null],[13,"Open","","",261,null],[4,"DropFlagMode","","",null,null],[13,"Shallow","","",262,null],[13,"Deep","","",262,null],[4,"Unwind","","",null,null],[13,"To","","",263,null],[13,"InCleanup","","",263,null],[5,"elaborate_drop","","",null,null],[8,"DropElaborator","","",null,null],[16,"Path","","",264,null],[10,"patch","","",264,{"inputs":[{"name":"self"}],"output":{"name":"mirpatch"}}],[10,"mir","","",264,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[10,"tcx","","",264,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[10,"param_env","","",264,{"inputs":[{"name":"self"}],"output":{"name":"paramenv"}}],[10,"drop_style","","",264,null],[10,"get_drop_flag","","",264,null],[10,"clear_drop_flag","","",264,null],[10,"field_subpath","","",264,null],[10,"deref_subpath","","",264,null],[10,"downcast_subpath","","",264,null],[10,"array_subpath","","",264,null],[11,"fmt","","",260,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",260,{"inputs":[{"name":"self"},{"name":"dropflagstate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",260,null],[11,"clone","","",260,{"inputs":[{"name":"self"}],"output":{"name":"dropflagstate"}}],[11,"value","","",260,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",261,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",262,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",263,{"inputs":[{"name":"self"}],"output":{"name":"unwind"}}],[11,"fmt","","",263,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_cleanup","","",263,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"into_option","","",263,{"inputs":[{"name":"self"}],"output":{"generics":["basicblock"],"name":"option"}}],[11,"map","","",263,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"fmt","","",259,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"place_ty","","",259,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"ty"}}],[11,"tcx","","",259,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"elaborate_drop","","This elaborates a single drop instruction, located at `bb`, and patches over it.",259,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":null}],[11,"move_paths_for_fields","","Return the place and move path for each field of `variant`, (the move path is `None` if the field is a rest field).",259,null],[11,"drop_subpath","","",259,{"inputs":[{"name":"self"},{"name":"place"},{"name":"option"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"drop_halfladder","","Create one-half of the drop ladder for a list of fields, and return the list of steps in it in reverse order, with the first step dropping 0 fields and so on.",259,null],[11,"drop_ladder_bottom","","",259,null],[11,"drop_ladder","","Create a full drop ladder, consisting of 2 connected half-drop-ladders",259,null],[11,"open_drop_for_tuple","","",259,null],[11,"open_drop_for_box","","",259,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"substs"}],"output":{"name":"basicblock"}}],[11,"open_drop_for_adt","","",259,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"substs"}],"output":{"name":"basicblock"}}],[11,"open_drop_for_adt_contents","","",259,null],[11,"open_drop_for_multivariant","","",259,null],[11,"adt_switch_block","","",259,null],[11,"destructor_call_block","","",259,null],[11,"drop_loop","","create a loop that drops an array:",259,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"local"},{"name":"place"},{"name":"ty"},{"name":"unwind"},{"name":"bool"}],"output":{"name":"basicblock"}}],[11,"open_drop_for_array","","",259,{"inputs":[{"name":"self"},{"name":"ty"},{"generics":["u64"],"name":"option"}],"output":{"name":"basicblock"}}],[11,"drop_loop_pair","","",259,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"bool"}],"output":{"name":"basicblock"}}],[11,"open_drop","","The slow-path - create an \"open\", elaborated drop for a type which is moved-out-of only partially, and patch `bb` to a jump to it. This must not be called on ADTs with a destructor, as these can't be moved-out-of, except for `Box<T>`, which is special-cased.",259,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"complete_drop","","Return a basic block that drop a place using the context and path in `c`. If `mode` is something, also clear `c` according to it.",259,{"inputs":[{"name":"self"},{"generics":["dropflagmode"],"name":"option"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"drop_flag_reset_block","","",259,{"inputs":[{"name":"self"},{"name":"dropflagmode"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"elaborated_drop_block","","",259,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"box_free_block","","",259,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"substs"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"unelaborated_free_block","","",259,{"inputs":[{"name":"self"},{"name":"adtdef"},{"name":"substs"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"drop_block","","",259,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"drop_flag_test_block","","",259,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblock"},{"name":"unwind"}],"output":{"name":"basicblock"}}],[11,"new_block","","",259,{"inputs":[{"name":"self"},{"name":"unwind"},{"name":"terminatorkind"}],"output":{"name":"basicblock"}}],[11,"new_temp","","",259,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"local"}}],[11,"terminator_loc","","",259,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"location"}}],[11,"constant_usize","","",259,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"operand"}}],[11,"assign","","",259,{"inputs":[{"name":"self"},{"name":"place"},{"name":"rvalue"}],"output":{"name":"statement"}}],[0,"def_use","rustc_mir::util","Def-use analysis.",null,null],[3,"DefUseAnalysis","rustc_mir::util::def_use","",null,null],[12,"info","","",265,null],[3,"Info","","",null,null],[12,"defs_and_uses","","",266,null],[3,"Use","","",null,null],[12,"context","","",267,null],[12,"location","","",267,null],[3,"DefUseFinder","","",null,null],[12,"info","","",268,null],[3,"MutateUseVisitor","","",null,null],[12,"query","","",269,null],[12,"callback","","",269,null],[12,"phantom","","",269,null],[11,"clone","","",266,{"inputs":[{"name":"self"}],"output":{"name":"info"}}],[11,"clone","","",267,{"inputs":[{"name":"self"}],"output":{"name":"use"}}],[11,"new","","",265,{"inputs":[{"name":"mir"}],"output":{"name":"defuseanalysis"}}],[11,"analyze","","",265,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"clear","","",265,{"inputs":[{"name":"self"}],"output":null}],[11,"local_info","","",265,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"info"}}],[11,"mutate_defs_and_uses","","",265,{"inputs":[{"name":"self"},{"name":"local"},{"name":"mir"},{"name":"f"}],"output":null}],[11,"replace_all_defs_and_uses_with","","FIXME(pcwalton): This should update the def-use chains.",265,{"inputs":[{"name":"self"},{"name":"local"},{"name":"mir"},{"name":"local"}],"output":null}],[11,"visit_local","","",268,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"new","","",266,{"inputs":[],"output":{"name":"info"}}],[11,"clear","","",266,{"inputs":[{"name":"self"}],"output":null}],[11,"def_count","","",266,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"def_count_not_including_drop","","",266,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"defs_not_including_drop","","",266,{"inputs":[{"name":"self"}],"output":{"generics":["iter"],"name":"filter"}}],[11,"use_count","","",266,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new","","",269,{"inputs":[{"name":"local"},{"name":"f"},{"name":"mir"}],"output":{"name":"mutateusevisitor"}}],[11,"visit_local","","",269,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[0,"patch","rustc_mir::util","",null,null],[3,"MirPatch","rustc_mir::util::patch","This struct represents a patch to MIR, which can add new statements and basic blocks and patch over block terminators.",null,null],[12,"patch_map","","",270,null],[12,"new_blocks","","",270,null],[12,"new_statements","","",270,null],[12,"new_locals","","",270,null],[12,"resume_block","","",270,null],[12,"next_local","","",270,null],[12,"make_nop","","",270,null],[11,"new","","",270,{"inputs":[{"name":"mir"}],"output":{"name":"self"}}],[11,"resume_block","","",270,{"inputs":[{"name":"self"}],"output":{"name":"basicblock"}}],[11,"is_patched","","",270,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":{"name":"bool"}}],[11,"terminator_loc","","",270,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"basicblock"}],"output":{"name":"location"}}],[11,"new_temp","","",270,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"name":"local"}}],[11,"new_internal","","",270,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"name":"local"}}],[11,"new_block","","",270,{"inputs":[{"name":"self"},{"name":"basicblockdata"}],"output":{"name":"basicblock"}}],[11,"patch_terminator","","",270,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"}],"output":null}],[11,"add_statement","","",270,{"inputs":[{"name":"self"},{"name":"location"},{"name":"statementkind"}],"output":null}],[11,"add_assign","","",270,{"inputs":[{"name":"self"},{"name":"location"},{"name":"place"},{"name":"rvalue"}],"output":null}],[11,"make_nop","","",270,{"inputs":[{"name":"self"},{"name":"location"}],"output":null}],[11,"apply","","",270,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"source_info_for_index","","",270,{"inputs":[{"name":"basicblockdata"},{"name":"location"}],"output":{"name":"sourceinfo"}}],[11,"source_info_for_location","","",270,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"location"}],"output":{"name":"sourceinfo"}}],[0,"alignment","rustc_mir::util","",null,null],[5,"is_disaligned","rustc_mir::util::alignment","Return `true` if this place is allowed to be less aligned than its containing struct (because it is within a packed struct).",null,{"inputs":[{"name":"tyctxt"},{"name":"l"},{"name":"paramenv"},{"name":"place"}],"output":{"name":"bool"}}],[5,"is_within_packed","","",null,{"inputs":[{"name":"tyctxt"},{"name":"l"},{"name":"place"}],"output":{"name":"bool"}}],[0,"graphviz","rustc_mir::util","",null,null],[5,"write_mir_graphviz","rustc_mir::util::graphviz","Write a graphviz DOT graph of a list of MIRs.",null,{"inputs":[{"name":"tyctxt"},{"generics":["defid"],"name":"option"},{"name":"w"}],"output":{"name":"result"}}],[5,"write_mir_fn_graphviz","","Write a graphviz DOT graph of the MIR.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"mir"},{"name":"w"}],"output":{"name":"result"}}],[5,"write_node_label","","Write a graphviz HTML-styled label for the given basic block, with all necessary escaping already performed. (This is suitable for emitting directly, as is done in this module, or for use with the LabelText::HtmlStr from libgraphviz.)",null,{"inputs":[{"name":"basicblock"},{"name":"mir"},{"name":"w"},{"name":"u32"},{"name":"init"},{"name":"fini"}],"output":{"name":"result"}}],[5,"write_node","","Write a graphviz DOT node for the given basic block.",null,{"inputs":[{"name":"basicblock"},{"name":"mir"},{"name":"w"}],"output":{"name":"result"}}],[5,"write_edges","","Write graphviz DOT edges with labels between the given basic block and all of its successors.",null,{"inputs":[{"name":"basicblock"},{"name":"mir"},{"name":"w"}],"output":{"name":"result"}}],[5,"write_graph_label","","Write the graphviz DOT label for the overall graph. This is essentially a block of text that will appear below the graph, showing the type of the `fn` this MIR represents and the types of all the variables and temporaries.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"mir"},{"name":"w"}],"output":{"name":"result"}}],[5,"node","","",null,{"inputs":[{"name":"basicblock"}],"output":{"name":"string"}}],[5,"escape","","",null,{"inputs":[{"name":"t"}],"output":{"name":"string"}}],[0,"pretty","rustc_mir::util","",null,null],[3,"ExtraComments","rustc_mir::util::pretty","",null,null],[12,"_tcx","","",271,null],[12,"comments","","",271,null],[4,"PassWhere","","An indication of where we are in the control flow graph. Used for printing extra information in `dump_mir`",null,null],[13,"BeforeCFG","","We have not started dumping the control flow graph, but we are about to.",256,null],[13,"AfterCFG","","We just finished dumping the control flow graph. This is right before EOF",256,null],[13,"BeforeBlock","","We are about to start dumping the given basic block.",256,null],[13,"BeforeLocation","","We are just about to dump the given statement or terminator.",256,null],[13,"AfterLocation","","We just dumped the given statement or terminator.",256,null],[5,"dump_mir","","If the session is properly configured, dumps a human-readable representation of the mir into:",null,{"inputs":[{"name":"tyctxt"},{"generics":["display"],"name":"option"},{"name":"str"},{"name":"display"},{"name":"mirsource"},{"name":"mir"},{"name":"f"}],"output":null}],[5,"dump_enabled","","",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"name":"mirsource"}],"output":{"name":"bool"}}],[5,"dump_matched_mir_node","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["display"],"name":"option"},{"name":"str"},{"name":"str"},{"name":"display"},{"name":"mirsource"},{"name":"mir"},{"name":"f"}],"output":null}],[5,"dump_path","","Returns the path to the filename where we should dump a given MIR. Also used by other bits of code (e.g., NLL inference) that dump graphviz data or other things.",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"generics":["display"],"name":"option"},{"name":"str"},{"name":"display"},{"name":"mirsource"}],"output":{"name":"pathbuf"}}],[5,"create_dump_file","","Attempts to open a file where we should dump a given MIR or other bit of MIR-related data. Used by `mir-dump`, but also by other bits of code (e.g., NLL inference) that dump graphviz data or other things, and hence takes the extension as an argument.",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"generics":["display"],"name":"option"},{"name":"str"},{"name":"display"},{"name":"mirsource"}],"output":{"generics":["file"],"name":"result"}}],[5,"write_mir_pretty","","Write out a human-readable textual representation for the given MIR.",null,{"inputs":[{"name":"tyctxt"},{"generics":["defid"],"name":"option"},{"name":"write"}],"output":{"name":"result"}}],[5,"write_mir_fn","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"},{"name":"f"},{"name":"write"}],"output":{"name":"result"}}],[5,"write_basic_block","","Write out a human-readable textual representation for the given basic block.",null,{"inputs":[{"name":"tyctxt"},{"name":"basicblock"},{"name":"mir"},{"name":"f"},{"name":"write"}],"output":{"name":"result"}}],[5,"write_extra","","After we print the main statement, we sometimes dump extra information. There's often a lot of little things \"nuzzled up\" in a statement.",null,{"inputs":[{"name":"tyctxt"},{"name":"write"},{"name":"f"}],"output":{"name":"result"}}],[5,"comment","","",null,{"inputs":[{"name":"tyctxt"},{"name":"sourceinfo"}],"output":{"name":"string"}}],[5,"write_scope_tree","","Prints user-defined variables in a scope tree.",null,{"inputs":[{"name":"tyctxt"},{"name":"mir"},{"name":"fxhashmap"},{"name":"write"},{"name":"visibilityscope"},{"name":"usize"}],"output":{"name":"result"}}],[5,"write_mir_intro","","Write out a human-readable textual representation of the MIR's `fn` type and the types of its local variables (both user-defined bindings and compiler temporaries).",null,{"inputs":[{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"},{"name":"write"}],"output":{"name":"result"}}],[5,"write_mir_sig","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"},{"name":"write"}],"output":{"name":"result"}}],[5,"write_temp_decls","","",null,{"inputs":[{"name":"mir"},{"name":"write"}],"output":{"name":"result"}}],[5,"dump_mir_def_ids","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["defid"],"name":"option"}],"output":{"generics":["defid"],"name":"vec"}}],[17,"INDENT","","",null,null],[17,"ALIGN","","Alignment for lining up comments following MIR statements",null,null],[11,"push","","",271,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"visit_constant","","",271,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"visit_const","","",271,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",271,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[0,"liveness","rustc_mir::util","Liveness analysis which computes liveness of MIR local variables at the boundary of basic blocks",null,null],[3,"LivenessResult","rustc_mir::util::liveness","This gives the result of the liveness analysis at the boundary of basic blocks. You can use `simulate_block` to obtain the intra-block results.",null,null],[12,"mode","","Liveness mode in use when these results were computed.",272,null],[12,"ins","","Live variables on entry to each basic block.",272,null],[12,"outs","","Live variables on exit to each basic block. This is equal to the union of the `ins` for each successor.",272,null],[3,"LivenessMode","","",null,null],[12,"include_regular_use","","If true, then we will consider \"regular uses\" of a variable to be live. For example, if the user writes `foo(x)`, then this is a regular use of the variable `x`.",273,null],[12,"include_drops","","If true, then we will consider (implicit) drops of a variable to be live.  For example, if the user writes `{ let x = vec![...]; .. }`, then the drop at the end of the block is an implicit drop.",273,null],[3,"LivenessResults","","A combination of liveness results, used in NLL.",null,null],[12,"regular","","Liveness results where a regular use makes a variable X live, but not a drop.",274,null],[12,"drop","","Liveness results where a drop makes a variable X live, but not a regular use.",274,null],[3,"DefsUsesVisitor","","",null,null],[12,"mode","","",275,null],[12,"defs_uses","","",275,null],[3,"DefsUses","","",null,null],[12,"defs","","",276,null],[12,"uses","","",276,null],[4,"DefUse","","",null,null],[13,"Def","","",277,null],[13,"Use","","",277,null],[5,"liveness_of_locals","","Compute which local variables are live within the given function `mir`. The liveness mode `mode` determines what sorts of uses are considered to make a variable live (e.g., do drops count?).",null,{"inputs":[{"name":"mir"},{"name":"livenessmode"}],"output":{"name":"livenessresult"}}],[5,"categorize","","",null,{"inputs":[{"name":"placecontext"},{"name":"livenessmode"}],"output":{"generics":["defuse"],"name":"option"}}],[5,"block","","",null,{"inputs":[{"name":"livenessmode"},{"name":"basicblockdata"},{"name":"usize"}],"output":{"name":"defsuses"}}],[5,"dump_mir","","",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"name":"mirsource"},{"name":"mir"},{"name":"livenessresult"}],"output":null}],[5,"dump_matched_mir_node","","",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"name":"str"},{"name":"mirsource"},{"name":"mir"},{"name":"livenessresult"}],"output":null}],[5,"write_mir_fn","","",null,{"inputs":[{"name":"tyctxt"},{"name":"mirsource"},{"name":"mir"},{"name":"write"},{"name":"livenessresult"}],"output":{"name":"result"}}],[6,"LocalSet","","",null,null],[11,"clone","","",273,{"inputs":[{"name":"self"}],"output":{"name":"livenessmode"}}],[11,"fmt","","",273,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"compute","","",274,{"inputs":[{"name":"mir"}],"output":{"name":"livenessresults"}}],[11,"simulate_block","","Walks backwards through the statements/terminator in the given basic block `block`.  At each point within `block`, invokes the callback `op` with the current location and the set of variables that are live on entry to that location.",272,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"basicblock"},{"name":"op"}],"output":null}],[11,"defs_uses","","",272,{"inputs":[{"name":"self"},{"name":"mir"},{"name":"location"},{"name":"v"}],"output":{"name":"defsuses"}}],[11,"assert_receiver_is_total_eq","","",277,null],[11,"eq","","",277,{"inputs":[{"name":"self"},{"name":"defuse"}],"output":{"name":"bool"}}],[11,"clone","","",277,{"inputs":[{"name":"self"}],"output":{"name":"defuse"}}],[11,"assert_receiver_is_total_eq","","",276,null],[11,"eq","","",276,{"inputs":[{"name":"self"},{"name":"defsuses"}],"output":{"name":"bool"}}],[11,"ne","","",276,{"inputs":[{"name":"self"},{"name":"defsuses"}],"output":{"name":"bool"}}],[11,"clone","","",276,{"inputs":[{"name":"self"}],"output":{"name":"defsuses"}}],[11,"apply","","",276,{"inputs":[{"name":"self"},{"name":"localset"}],"output":{"name":"bool"}}],[11,"add_def","","",276,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"add_use","","",276,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_local","","",275,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[0,"collect_writes","rustc_mir::util","",null,null],[3,"FindLocalAssignmentVisitor","rustc_mir::util::collect_writes","",null,null],[12,"needle","","",278,null],[12,"locations","","",278,null],[8,"FindAssignments","","",null,null],[10,"find_assignments","","",279,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"generics":["location"],"name":"vec"}}],[11,"visit_local","","",278,{"inputs":[{"name":"self"},{"name":"local"},{"name":"placecontext"},{"name":"location"}],"output":null}],[0,"interpret","rustc_mir","An interpreter for MIR used in CTFE and by miri",null,null],[3,"EvalContext","rustc_mir::interpret","",null,null],[12,"machine","","Stores the `Machine` instance.",280,null],[12,"tcx","","The results of the type checker, from rustc.",280,null],[12,"param_env","","Bounds in scope for polymorphic evaluations.",280,null],[12,"memory","","The virtual memory system.",280,null],[12,"stack","","The virtual call stack.",280,null],[12,"stack_limit","","The maximum number of stack frames allowed",280,null],[12,"terminators_remaining","","The maximum number of terminators that may be evaluated. This prevents infinite loops and huge computations from freezing up const eval. Remove once halting problem is solved.",280,null],[3,"Frame","","A stack frame.",null,null],[12,"mir","","The MIR for the function called on this frame.",281,null],[12,"instance","","The def_id and substs of the current function",281,null],[12,"span","","The span of the call site.",281,null],[12,"return_to_block","","The block to return to when returning from the current stack frame",281,null],[12,"return_place","","The location where the result of the current stack frame should be written to.",281,null],[12,"locals","","The list of locals for this stack frame, stored in order as `[return_ptr, arguments..., variables..., temporaries...]`. The locals are stored as `Option<Value>`s. `None` represents a local that is currently dead, while a live local can either directly contain `PrimVal` or refer to some part of an `Allocation`.",281,null],[12,"block","","The block that is currently executed (or will be executed after the above call stacks return).",281,null],[12,"stmt","","The index of the currently evaluated statement.",281,null],[3,"TyAndPacked","","",null,null],[12,"ty","","",282,null],[12,"packed","","",282,null],[3,"ValTy","","",null,null],[12,"value","","",283,null],[12,"ty","","",283,null],[3,"Memory","","",null,null],[12,"data","","Additional data required by the Machine",284,null],[12,"alloc_kind","","Helps guarantee that stack allocations aren't deallocated via `rust_deallocate`",284,null],[12,"alloc_map","","Actual memory allocations (arbitrary bytes, may contain pointers into other allocations).",284,null],[12,"uninitialized_statics","","Actual memory allocations (arbitrary bytes, may contain pointers into other allocations).",284,null],[12,"cur_frame","","The current stack frame.  Used to check accesses against locks.",284,null],[12,"tcx","","",284,null],[3,"CompileTimeEvaluator","","",null,null],[4,"StackPopCleanup","","",null,null],[13,"MarkStatic","","The stackframe existed to compute the initial value of a static/constant, make sure it isn't modifyable afterwards in case of constants. In case of `static mut`, mark the memory to ensure it's never marked as immutable through references or deallocated",285,null],[13,"Goto","","A regular stackframe added due to a function call will need to get forwarded to the next block",285,null],[13,"None","","The main function and diverging functions have nowhere to return to",285,null],[4,"Place","","",null,null],[13,"Ptr","","A place referring to a value allocated in the `Memory` system.",286,null],[12,"ptr","rustc_mir::interpret::Place","A place may have an invalid (integral or undef) pointer, since it might be turned back into a reference before ever being dereferenced.",286,null],[12,"align","","",286,null],[12,"extra","","",286,null],[13,"Local","rustc_mir::interpret","A place referring to a value on the stack. Represented by a stack frame index paired with a Mir local index.",286,null],[12,"frame","rustc_mir::interpret::Place","",286,null],[12,"local","","",286,null],[4,"PlaceExtra","rustc_mir::interpret","",null,null],[13,"None","","",287,null],[13,"Length","","",287,null],[13,"Vtable","","",287,null],[13,"DowncastVariant","","",287,null],[4,"MemoryKind","","",null,null],[13,"Stack","","Error if deallocated except during a stack pop",288,null],[13,"Machine","","Additional memory kinds a machine wishes to distinguish from the builtin ones",288,null],[5,"eval_promoted","","",null,{"inputs":[{"name":"tyctxt"},{"name":"globalid"},{"name":"mir"},{"name":"paramenv"}],"output":{"name":"option"}}],[5,"mk_borrowck_eval_cx","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"},{"name":"mir"},{"name":"span"}],"output":{"generics":["evalcontext"],"name":"evalresult"}}],[5,"eval_body","","",null,{"inputs":[{"name":"tyctxt"},{"name":"globalid"},{"name":"paramenv"}],"output":{"name":"option"}}],[5,"const_eval_provider","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["globalid"],"name":"paramenvand"}],"output":{"name":"evalresult"}}],[5,"const_val_field","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"instance"},{"generics":["usize"],"name":"option"},{"name":"field"},{"name":"value"},{"name":"ty"}],"output":{"name":"evalresult"}}],[5,"const_variant_index","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"instance"},{"name":"value"},{"name":"ty"}],"output":{"generics":["usize"],"name":"evalresult"}}],[5,"write_target_uint","","",null,null],[5,"write_target_int","","",null,null],[5,"read_target_uint","","",null,null],[5,"sign_extend","","",null,{"inputs":[{"name":"tyctxt"},{"name":"u128"},{"name":"ty"}],"output":{"generics":["u128"],"name":"evalresult"}}],[5,"truncate","","",null,{"inputs":[{"name":"tyctxt"},{"name":"u128"},{"name":"ty"}],"output":{"generics":["u128"],"name":"evalresult"}}],[0,"cast","","",null,null],[11,"cast_primval","","",280,{"inputs":[{"name":"self"},{"name":"primval"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"cast_from_int","","",280,{"inputs":[{"name":"self"},{"name":"u128"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"cast_from_float","","",280,{"inputs":[{"name":"self"},{"name":"u128"},{"name":"floatty"},{"name":"ty"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"cast_from_ptr","","",280,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"ty"}],"output":{"generics":["primval"],"name":"evalresult"}}],[0,"const_eval","","",null,null],[3,"CompileTimeEvaluator","rustc_mir::interpret::const_eval","",null,null],[4,"ConstEvalError","","",null,null],[13,"NeedsRfc","","",289,null],[13,"NotConst","","",289,null],[5,"mk_borrowck_eval_cx","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"},{"name":"mir"},{"name":"span"}],"output":{"generics":["evalcontext"],"name":"evalresult"}}],[5,"mk_eval_cx","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"},{"name":"paramenv"}],"output":{"generics":["evalcontext"],"name":"evalresult"}}],[5,"eval_promoted","","",null,{"inputs":[{"name":"tyctxt"},{"name":"globalid"},{"name":"mir"},{"name":"paramenv"}],"output":{"name":"option"}}],[5,"eval_body","","",null,{"inputs":[{"name":"tyctxt"},{"name":"globalid"},{"name":"paramenv"}],"output":{"name":"option"}}],[5,"eval_body_and_ecx","","",null,null],[5,"const_val_field","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"instance"},{"generics":["usize"],"name":"option"},{"name":"field"},{"name":"value"},{"name":"ty"}],"output":{"name":"evalresult"}}],[5,"const_variant_index","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"instance"},{"name":"value"},{"name":"ty"}],"output":{"generics":["usize"],"name":"evalresult"}}],[5,"const_eval_provider","","",null,{"inputs":[{"name":"tyctxt"},{"generics":["globalid"],"name":"paramenvand"}],"output":{"name":"evalresult"}}],[11,"into","","",289,{"inputs":[{"name":"self"}],"output":{"name":"evalerror"}}],[11,"clone","","",289,{"inputs":[{"name":"self"}],"output":{"name":"constevalerror"}}],[11,"fmt","","",289,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",289,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",289,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"cause","","",289,{"inputs":[{"name":"self"}],"output":{"generics":["error"],"name":"option"}}],[11,"eval_fn_call","rustc_mir::interpret","",290,null],[11,"call_intrinsic","","",290,null],[11,"try_ptr_op","","",290,{"inputs":[{"name":"evalcontext"},{"name":"binop"},{"name":"primval"},{"name":"ty"},{"name":"primval"},{"name":"ty"}],"output":{"generics":["option"],"name":"evalresult"}}],[11,"mark_static_initialized","","",290,{"inputs":[{"name":"memory"},{"name":"allocid"},{"name":"mutability"}],"output":{"generics":["bool"],"name":"evalresult"}}],[11,"init_static","","",290,{"inputs":[{"name":"evalcontext"},{"name":"globalid"}],"output":{"generics":["allocid"],"name":"evalresult"}}],[11,"box_alloc","","",290,{"inputs":[{"name":"evalcontext"},{"name":"ty"},{"name":"place"}],"output":{"name":"evalresult"}}],[11,"global_item_with_linkage","","",290,{"inputs":[{"name":"evalcontext"},{"name":"instance"},{"name":"mutability"}],"output":{"name":"evalresult"}}],[0,"eval_context","","",null,null],[3,"EvalContext","rustc_mir::interpret::eval_context","",null,null],[12,"machine","","Stores the `Machine` instance.",280,null],[12,"tcx","","The results of the type checker, from rustc.",280,null],[12,"param_env","","Bounds in scope for polymorphic evaluations.",280,null],[12,"memory","","The virtual memory system.",280,null],[12,"stack","","The virtual call stack.",280,null],[12,"stack_limit","","The maximum number of stack frames allowed",280,null],[12,"terminators_remaining","","The maximum number of terminators that may be evaluated. This prevents infinite loops and huge computations from freezing up const eval. Remove once halting problem is solved.",280,null],[3,"Frame","","A stack frame.",null,null],[12,"mir","","The MIR for the function called on this frame.",281,null],[12,"instance","","The def_id and substs of the current function",281,null],[12,"span","","The span of the call site.",281,null],[12,"return_to_block","","The block to return to when returning from the current stack frame",281,null],[12,"return_place","","The location where the result of the current stack frame should be written to.",281,null],[12,"locals","","The list of locals for this stack frame, stored in order as `[return_ptr, arguments..., variables..., temporaries...]`. The locals are stored as `Option<Value>`s. `None` represents a local that is currently dead, while a live local can either directly contain `PrimVal` or refer to some part of an `Allocation`.",281,null],[12,"block","","The block that is currently executed (or will be executed after the above call stacks return).",281,null],[12,"stmt","","The index of the currently evaluated statement.",281,null],[3,"TyAndPacked","","",null,null],[12,"ty","","",282,null],[12,"packed","","",282,null],[3,"ValTy","","",null,null],[12,"value","","",283,null],[12,"ty","","",283,null],[4,"StackPopCleanup","","",null,null],[13,"MarkStatic","","The stackframe existed to compute the initial value of a static/constant, make sure it isn't modifyable afterwards in case of constants. In case of `static mut`, mark the memory to ensure it's never marked as immutable through references or deallocated",285,null],[13,"Goto","","A regular stackframe added due to a function call will need to get forwarded to the next block",285,null],[13,"None","","The main function and diverging functions have nowhere to return to",285,null],[11,"clone","rustc_mir::interpret","",285,{"inputs":[{"name":"self"}],"output":{"name":"stackpopcleanup"}}],[11,"fmt","","",285,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",285,null],[11,"eq","","",285,{"inputs":[{"name":"self"},{"name":"stackpopcleanup"}],"output":{"name":"bool"}}],[11,"ne","","",285,{"inputs":[{"name":"self"},{"name":"stackpopcleanup"}],"output":{"name":"bool"}}],[11,"hash","","",285,null],[11,"clone","","",282,{"inputs":[{"name":"self"}],"output":{"name":"tyandpacked"}}],[11,"fmt","","",282,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",283,{"inputs":[{"name":"self"}],"output":{"name":"valty"}}],[11,"fmt","","",283,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",283,{"inputs":[{"name":"const"}],"output":{"name":"option"}}],[11,"deref","","",283,{"inputs":[{"name":"self"}],"output":{"name":"value"}}],[11,"new","","",280,null],[11,"alloc_ptr","","",280,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"memory","","",280,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"memory_mut","","",280,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"stack","","",280,null],[11,"cur_frame","","",280,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"str_to_value","","",280,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"const_to_value","","",280,{"inputs":[{"name":"self"},{"name":"constval"},{"name":"ty"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"resolve","","",280,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"}],"output":{"generics":["instance"],"name":"evalresult"}}],[11,"type_is_sized","","",280,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"load_mir","","",280,{"inputs":[{"name":"self"},{"name":"instancedef"}],"output":{"generics":["mir"],"name":"evalresult"}}],[11,"monomorphize","","",280,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"size_and_align_of_dst","","Return the size and aligment of the value at the given type. Note that the value does not matter if the type is sized. For unsized types, the value has to be a fat pointer, and we only care about the \"extra\" data in it.",280,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"value"}],"output":{"name":"evalresult"}}],[11,"push_stack_frame","","",280,{"inputs":[{"name":"self"},{"name":"instance"},{"name":"span"},{"name":"mir"},{"name":"place"},{"name":"stackpopcleanup"}],"output":{"name":"evalresult"}}],[11,"pop_stack_frame","","",280,{"inputs":[{"name":"self"}],"output":{"name":"evalresult"}}],[11,"deallocate_local","","",280,{"inputs":[{"name":"self"},{"generics":["value"],"name":"option"}],"output":{"name":"evalresult"}}],[11,"eval_rvalue_into_place","","Evaluate an assignment statement.",280,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"place"}],"output":{"name":"evalresult"}}],[11,"type_is_fat_ptr","","",280,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"eval_operand_to_primval","","",280,{"inputs":[{"name":"self"},{"name":"operand"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"operands_to_args","","",280,null],[11,"eval_operand","","",280,{"inputs":[{"name":"self"},{"name":"operand"}],"output":{"generics":["valty"],"name":"evalresult"}}],[11,"read_discriminant_as_variant_index","","reads a tag and produces the corresponding variant index",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"ty"}],"output":{"generics":["usize"],"name":"evalresult"}}],[11,"read_discriminant_value","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"ty"}],"output":{"generics":["u128"],"name":"evalresult"}}],[11,"write_discriminant_value","","",280,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"place"},{"name":"usize"}],"output":{"name":"evalresult"}}],[11,"read_global_as_value","","",280,{"inputs":[{"name":"self"},{"name":"globalid"},{"name":"ty"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"const_eval","","",280,{"inputs":[{"name":"self"},{"name":"globalid"}],"output":{"generics":["const"],"name":"evalresult"}}],[11,"force_allocation","","",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["place"],"name":"evalresult"}}],[11,"follow_by_ref_value","","ensures this Value is not a ByRef",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"ty"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"value_to_primval","","",280,{"inputs":[{"name":"self"},{"name":"valty"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"write_ptr","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"pointer"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"write_primval","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"primval"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"write_value","","",280,{"inputs":[{"name":"self"},{"name":"valty"},{"name":"place"}],"output":{"name":"evalresult"}}],[11,"write_value_possibly_by_val","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"f"},{"name":"value"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"write_value_to_ptr","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"pointer"},{"name":"align"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"ty_to_primval_kind","","",280,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["primvalkind"],"name":"evalresult"}}],[11,"ensure_valid_value","","",280,{"inputs":[{"name":"self"},{"name":"primval"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"read_value","","",280,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"align"},{"name":"ty"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"read_ptr","","",280,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"align"},{"name":"ty"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"try_read_value","","",280,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"align"},{"name":"ty"}],"output":{"generics":["option"],"name":"evalresult"}}],[11,"frame","","",280,{"inputs":[{"name":"self"}],"output":{"name":"frame"}}],[11,"frame_mut","","",280,{"inputs":[{"name":"self"}],"output":{"name":"frame"}}],[11,"mir","","",280,{"inputs":[{"name":"self"}],"output":{"name":"mir"}}],[11,"substs","","",280,{"inputs":[{"name":"self"}],"output":{"name":"substs"}}],[11,"unsize_into_ptr","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"ty"},{"name":"place"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"unsize_into","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"tylayout"},{"name":"place"},{"name":"tylayout"}],"output":{"name":"evalresult"}}],[11,"dump_local","","",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":null}],[11,"modify_local","","Convenience function to ensure correct usage of locals",280,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"local"},{"name":"f"}],"output":{"name":"evalresult"}}],[11,"generate_stacktrace","","",280,null],[11,"report","","",280,{"inputs":[{"name":"self"},{"name":"evalerror"},{"name":"bool"},{"generics":["span"],"name":"option"}],"output":null}],[11,"sign_extend","","",280,{"inputs":[{"name":"self"},{"name":"u128"},{"name":"ty"}],"output":{"generics":["u128"],"name":"evalresult"}}],[11,"truncate","","",280,{"inputs":[{"name":"self"},{"name":"u128"},{"name":"ty"}],"output":{"generics":["u128"],"name":"evalresult"}}],[11,"get_local","","",281,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"set_local","","",281,{"inputs":[{"name":"self"},{"name":"local"},{"name":"value"}],"output":{"name":"evalresult"}}],[11,"storage_live","","",281,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"generics":["value"],"name":"option"}}],[11,"storage_dead","","Returns the old value of the local",281,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"generics":["value"],"name":"option"}}],[0,"place","","",null,null],[4,"Place","rustc_mir::interpret::place","",null,null],[13,"Ptr","","A place referring to a value allocated in the `Memory` system.",286,null],[12,"ptr","rustc_mir::interpret::place::Place","A place may have an invalid (integral or undef) pointer, since it might be turned back into a reference before ever being dereferenced.",286,null],[12,"align","","",286,null],[12,"extra","","",286,null],[13,"Local","rustc_mir::interpret::place","A place referring to a value on the stack. Represented by a stack frame index paired with a Mir local index.",286,null],[12,"frame","rustc_mir::interpret::place::Place","",286,null],[12,"local","","",286,null],[4,"PlaceExtra","rustc_mir::interpret::place","",null,null],[13,"None","","",287,null],[13,"Length","","",287,null],[13,"Vtable","","",287,null],[13,"DowncastVariant","","",287,null],[11,"clone","rustc_mir::interpret","",286,{"inputs":[{"name":"self"}],"output":{"name":"place"}}],[11,"fmt","","",286,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",287,{"inputs":[{"name":"self"}],"output":{"name":"placeextra"}}],[11,"fmt","","",287,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",287,null],[11,"eq","","",287,{"inputs":[{"name":"self"},{"name":"placeextra"}],"output":{"name":"bool"}}],[11,"ne","","",287,{"inputs":[{"name":"self"},{"name":"placeextra"}],"output":{"name":"bool"}}],[11,"undef","","Produces a Place that will error if attempted to be read from",286,{"inputs":[],"output":{"name":"self"}}],[11,"from_primval_ptr","","",286,{"inputs":[{"name":"pointer"},{"name":"align"}],"output":{"name":"self"}}],[11,"from_ptr","","",286,{"inputs":[{"name":"memorypointer"},{"name":"align"}],"output":{"name":"self"}}],[11,"to_ptr_align_extra","","",286,null],[11,"to_ptr_align","","",286,null],[11,"to_ptr","","",286,{"inputs":[{"name":"self"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"elem_ty_and_len","","",286,null],[11,"try_read_place","","Reads a value from the place without going through the intermediate step of obtaining a `miri::Place`",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["option"],"name":"evalresult"}}],[11,"read_field","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"generics":["usize"],"name":"option"},{"name":"field"},{"name":"ty"}],"output":{"generics":["option"],"name":"evalresult"}}],[11,"try_read_place_projection","","",280,{"inputs":[{"name":"self"},{"name":"placeprojection"}],"output":{"generics":["option"],"name":"evalresult"}}],[11,"eval_and_read_place","","Returns a value and (in case of a ByRef) if we are supposed to use aligned accesses.",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"read_place","","",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["value"],"name":"evalresult"}}],[11,"eval_place","","",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"generics":["place"],"name":"evalresult"}}],[11,"place_field","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"field"},{"name":"tylayout"}],"output":{"name":"evalresult"}}],[11,"val_to_place","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"ty"}],"output":{"generics":["place"],"name":"evalresult"}}],[11,"place_index","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"ty"},{"name":"u64"}],"output":{"generics":["place"],"name":"evalresult"}}],[11,"place_downcast","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"usize"}],"output":{"generics":["place"],"name":"evalresult"}}],[11,"eval_place_projection","","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"ty"},{"name":"projectionelem"}],"output":{"generics":["place"],"name":"evalresult"}}],[11,"place_ty","","",280,{"inputs":[{"name":"self"},{"name":"place"}],"output":{"name":"ty"}}],[0,"machine","","This module contains everything needed to instantiate an interpreter. This separation exists to ensure that no fancy miri features like interpreting common C functions leak into CTFE.",null,null],[8,"Machine","rustc_mir::interpret::machine","Methods of this trait signifies a point where CTFE evaluation would fail and some use case dependent behaviour can instead be applied",null,null],[16,"MemoryData","","Additional data that can be accessed via the Memory",291,null],[16,"MemoryKinds","","Additional memory kinds a machine wishes to distinguish from the builtin ones",291,null],[10,"eval_fn_call","","Entry point to all function calls.",291,null],[10,"call_intrinsic","","directly process an intrinsic without pushing a stack frame.",291,null],[10,"try_ptr_op","","Called for all binary operations except on float types.",291,{"inputs":[{"name":"evalcontext"},{"name":"binop"},{"name":"primval"},{"name":"ty"},{"name":"primval"},{"name":"ty"}],"output":{"generics":["option"],"name":"evalresult"}}],[10,"mark_static_initialized","","Called when trying to mark machine defined `MemoryKinds` as static",291,{"inputs":[{"name":"memory"},{"name":"allocid"},{"name":"mutability"}],"output":{"generics":["bool"],"name":"evalresult"}}],[10,"init_static","","Called when requiring a pointer to a static. Non const eval can create a mutable memory location for `static mut`",291,{"inputs":[{"name":"evalcontext"},{"name":"globalid"}],"output":{"generics":["allocid"],"name":"evalresult"}}],[10,"box_alloc","","Heap allocations via the `box` keyword",291,{"inputs":[{"name":"evalcontext"},{"name":"ty"},{"name":"place"}],"output":{"name":"evalresult"}}],[10,"global_item_with_linkage","","Called when trying to access a global declared with a `linkage` attribute",291,{"inputs":[{"name":"evalcontext"},{"name":"instance"},{"name":"mutability"}],"output":{"name":"evalresult"}}],[11,"check_locks","","",291,{"inputs":[{"name":"memory"},{"name":"memorypointer"},{"name":"u64"},{"name":"accesskind"}],"output":{"name":"evalresult"}}],[11,"add_lock","","",291,{"inputs":[{"name":"memory"},{"name":"allocid"}],"output":null}],[11,"free_lock","","",291,{"inputs":[{"name":"memory"},{"name":"allocid"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"end_region","","",291,{"inputs":[{"name":"evalcontext"},{"generics":["scope"],"name":"option"}],"output":{"name":"evalresult"}}],[11,"validation_op","","",291,{"inputs":[{"name":"evalcontext"},{"name":"validationop"},{"name":"validationoperand"}],"output":{"name":"evalresult"}}],[0,"memory","rustc_mir::interpret","",null,null],[3,"Memory","rustc_mir::interpret::memory","",null,null],[12,"data","","Additional data required by the Machine",284,null],[12,"alloc_kind","","Helps guarantee that stack allocations aren't deallocated via `rust_deallocate`",284,null],[12,"alloc_map","","Actual memory allocations (arbitrary bytes, may contain pointers into other allocations).",284,null],[12,"uninitialized_statics","","Actual memory allocations (arbitrary bytes, may contain pointers into other allocations).",284,null],[12,"cur_frame","","The current stack frame.  Used to check accesses against locks.",284,null],[12,"tcx","","",284,null],[4,"MemoryKind","","",null,null],[13,"Stack","","Error if deallocated except during a stack pop",288,null],[13,"Machine","","Additional memory kinds a machine wishes to distinguish from the builtin ones",288,null],[5,"write_target_uint","","",null,null],[5,"write_target_int","","",null,null],[5,"read_target_uint","","",null,null],[8,"HasMemory","","",null,null],[10,"memory_mut","","",292,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[10,"memory","","",292,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"into_ptr","","Convert the value into a pointer (or a pointer-sized integer).  If the value is a ByRef, this may have to perform a load.",292,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"generics":["pointer"],"name":"evalresult"}}],[11,"into_ptr_vtable_pair","","",292,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"name":"evalresult"}}],[11,"into_slice","","",292,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"name":"evalresult"}}],[11,"fmt","rustc_mir::interpret","",288,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",288,{"inputs":[{"name":"self"},{"name":"memorykind"}],"output":{"name":"bool"}}],[11,"ne","","",288,{"inputs":[{"name":"self"},{"name":"memorykind"}],"output":{"name":"bool"}}],[11,"clone","","",288,{"inputs":[{"name":"self"}],"output":{"name":"memorykind"}}],[11,"new","","",284,null],[11,"allocations","","",284,null],[11,"create_fn_alloc","","",284,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"memorypointer"}}],[11,"allocate_cached","","",284,null],[11,"allocate","","kind is `None` for statics",284,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"align"},{"generics":["memorykind"],"name":"option"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"reallocate","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"},{"name":"align"},{"name":"u64"},{"name":"align"},{"name":"memorykind"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"deallocate_local","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"name":"evalresult"}}],[11,"deallocate","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"option"},{"name":"memorykind"}],"output":{"name":"evalresult"}}],[11,"pointer_size","","",284,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"endianness","","",284,{"inputs":[{"name":"self"}],"output":{"name":"endian"}}],[11,"check_align","","Check that the pointer is aligned AND non-NULL.",284,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"align"}],"output":{"name":"evalresult"}}],[11,"check_bounds","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"bool"}],"output":{"name":"evalresult"}}],[11,"get","","",284,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["allocation"],"name":"evalresult"}}],[11,"get_mut","","",284,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["allocation"],"name":"evalresult"}}],[11,"get_fn","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"generics":["instance"],"name":"evalresult"}}],[11,"get_alloc_kind","","",284,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":{"generics":["memorykind"],"name":"option"}}],[11,"dump_alloc","","For debugging, print an allocation and all allocations it points to, recursively.",284,{"inputs":[{"name":"self"},{"name":"allocid"}],"output":null}],[11,"dump_allocs","","For debugging, print a list of allocations and all allocations they point to, recursively.",284,{"inputs":[{"name":"self"},{"generics":["allocid"],"name":"vec"}],"output":null}],[11,"leak_report","","",284,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"get_bytes_unchecked","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"},{"name":"align"}],"output":{"name":"evalresult"}}],[11,"get_bytes_unchecked_mut","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"},{"name":"align"}],"output":{"name":"evalresult"}}],[11,"get_bytes","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"},{"name":"align"}],"output":{"name":"evalresult"}}],[11,"get_bytes_mut","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"},{"name":"align"}],"output":{"name":"evalresult"}}],[11,"mark_inner_allocation_initialized","","mark an allocation pointed to by a static as static and initialized",284,{"inputs":[{"name":"self"},{"name":"allocid"},{"name":"mutability"}],"output":{"name":"evalresult"}}],[11,"mark_static_initialized","","mark an allocation as static and initialized, either mutable or not",284,{"inputs":[{"name":"self"},{"name":"allocid"},{"name":"mutability"}],"output":{"name":"evalresult"}}],[11,"copy","","",284,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"align"},{"name":"pointer"},{"name":"align"},{"name":"u64"},{"name":"bool"}],"output":{"name":"evalresult"}}],[11,"read_c_str","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"name":"evalresult"}}],[11,"read_bytes","","",284,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"write_bytes","","",284,null],[11,"write_repeat","","",284,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"u8"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"read_primval","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"align"},{"name":"u64"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"read_ptr_sized","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"align"}],"output":{"generics":["primval"],"name":"evalresult"}}],[11,"write_primval","","",284,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"align"},{"name":"primval"},{"name":"u64"},{"name":"bool"}],"output":{"name":"evalresult"}}],[11,"write_ptr_sized_unsigned","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"align"},{"name":"primval"}],"output":{"name":"evalresult"}}],[11,"int_align","","",284,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"align"}}],[11,"relocations","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"}],"output":{"generics":["range"],"name":"evalresult"}}],[11,"clear_relocations","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"check_relocation_edges","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"copy_undef_mask","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"memorypointer"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"check_defined","","",284,{"inputs":[{"name":"self"},{"name":"memorypointer"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"mark_definedness","","",284,{"inputs":[{"name":"self"},{"name":"pointer"},{"name":"u64"},{"name":"bool"}],"output":{"name":"evalresult"}}],[11,"memory_mut","","",284,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"memory","","",284,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"memory_mut","","",280,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"memory","","",280,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[0,"operator","","",null,null],[11,"binop_with_overflow","","",280,{"inputs":[{"name":"self"},{"name":"binop"},{"name":"valty"},{"name":"valty"}],"output":{"name":"evalresult"}}],[11,"intrinsic_with_overflow","","Applies the binary operation `op` to the two operands and writes a tuple of the result and a boolean signifying the potential overflow to the destination.",280,{"inputs":[{"name":"self"},{"name":"binop"},{"name":"valty"},{"name":"valty"},{"name":"place"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"intrinsic_overflowing","","Applies the binary operation `op` to the arguments and writes the result to the destination. Returns `true` if the operation overflowed.",280,{"inputs":[{"name":"self"},{"name":"binop"},{"name":"valty"},{"name":"valty"},{"name":"place"},{"name":"ty"}],"output":{"generics":["bool"],"name":"evalresult"}}],[11,"binary_op","","Returns the result of the specified operation and whether it overflowed.",280,{"inputs":[{"name":"self"},{"name":"binop"},{"name":"primval"},{"name":"ty"},{"name":"primval"},{"name":"ty"}],"output":{"name":"evalresult"}}],[11,"unary_op","","",280,{"inputs":[{"name":"self"},{"name":"unop"},{"name":"primval"},{"name":"ty"}],"output":{"generics":["primval"],"name":"evalresult"}}],[0,"step","","This module contains the `EvalContext` methods for executing a single step of the interpreter.",null,null],[11,"inc_step_counter_and_check_limit","","",280,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"step","","Returns true as long as there are more things to do.",280,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"evalresult"}}],[11,"statement","","",280,{"inputs":[{"name":"self"},{"name":"statement"}],"output":{"name":"evalresult"}}],[11,"terminator","","",280,{"inputs":[{"name":"self"},{"name":"terminator"}],"output":{"name":"evalresult"}}],[0,"terminator","","",null,null],[0,"drop","rustc_mir::interpret::terminator","",null,null],[11,"drop_place","rustc_mir::interpret","",280,{"inputs":[{"name":"self"},{"name":"place"},{"name":"instance"},{"name":"ty"},{"name":"span"},{"name":"basicblock"}],"output":{"name":"evalresult"}}],[11,"drop","","",280,{"inputs":[{"name":"self"},{"name":"value"},{"name":"instance"},{"name":"ty"},{"name":"span"},{"name":"basicblock"}],"output":{"name":"evalresult"}}],[11,"goto_block","","",280,{"inputs":[{"name":"self"},{"name":"basicblock"}],"output":null}],[11,"eval_terminator","","",280,{"inputs":[{"name":"self"},{"name":"terminator"}],"output":{"name":"evalresult"}}],[11,"check_sig_compat","","Decides whether it is okay to call the method with signature `real_sig` using signature `sig`. FIXME: This should take into account the platform-dependent ABI description.",280,{"inputs":[{"name":"self"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"generics":["bool"],"name":"evalresult"}}],[11,"eval_fn_call","","",280,null],[0,"traits","","",null,null],[11,"get_vtable","","Creates a dynamic vtable for the given type and vtable origin. This is used only for objects.",280,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"polytraitref"}],"output":{"generics":["memorypointer"],"name":"evalresult"}}],[11,"read_drop_type_from_vtable","","",280,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"generics":["option"],"name":"evalresult"}}],[11,"read_size_and_align_from_vtable","","",280,{"inputs":[{"name":"self"},{"name":"memorypointer"}],"output":{"name":"evalresult"}}],[8,"HasMemory","","",null,null],[10,"memory_mut","","",292,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[10,"memory","","",292,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"into_ptr","rustc_mir::interpret::memory","Convert the value into a pointer (or a pointer-sized integer).  If the value is a ByRef, this may have to perform a load.",292,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"generics":["pointer"],"name":"evalresult"}}],[11,"into_ptr_vtable_pair","","",292,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"name":"evalresult"}}],[11,"into_slice","","",292,{"inputs":[{"name":"self"},{"name":"value"}],"output":{"name":"evalresult"}}],[8,"Machine","rustc_mir::interpret","Methods of this trait signifies a point where CTFE evaluation would fail and some use case dependent behaviour can instead be applied",null,null],[16,"MemoryData","","Additional data that can be accessed via the Memory",291,null],[16,"MemoryKinds","","Additional memory kinds a machine wishes to distinguish from the builtin ones",291,null],[10,"eval_fn_call","","Entry point to all function calls.",291,null],[10,"call_intrinsic","","directly process an intrinsic without pushing a stack frame.",291,null],[10,"try_ptr_op","","Called for all binary operations except on float types.",291,{"inputs":[{"name":"evalcontext"},{"name":"binop"},{"name":"primval"},{"name":"ty"},{"name":"primval"},{"name":"ty"}],"output":{"generics":["option"],"name":"evalresult"}}],[10,"mark_static_initialized","","Called when trying to mark machine defined `MemoryKinds` as static",291,{"inputs":[{"name":"memory"},{"name":"allocid"},{"name":"mutability"}],"output":{"generics":["bool"],"name":"evalresult"}}],[10,"init_static","","Called when requiring a pointer to a static. Non const eval can create a mutable memory location for `static mut`",291,{"inputs":[{"name":"evalcontext"},{"name":"globalid"}],"output":{"generics":["allocid"],"name":"evalresult"}}],[10,"box_alloc","","Heap allocations via the `box` keyword",291,{"inputs":[{"name":"evalcontext"},{"name":"ty"},{"name":"place"}],"output":{"name":"evalresult"}}],[10,"global_item_with_linkage","","Called when trying to access a global declared with a `linkage` attribute",291,{"inputs":[{"name":"evalcontext"},{"name":"instance"},{"name":"mutability"}],"output":{"name":"evalresult"}}],[11,"check_locks","rustc_mir::interpret::machine","",291,{"inputs":[{"name":"memory"},{"name":"memorypointer"},{"name":"u64"},{"name":"accesskind"}],"output":{"name":"evalresult"}}],[11,"add_lock","","",291,{"inputs":[{"name":"memory"},{"name":"allocid"}],"output":null}],[11,"free_lock","","",291,{"inputs":[{"name":"memory"},{"name":"allocid"},{"name":"u64"}],"output":{"name":"evalresult"}}],[11,"end_region","","",291,{"inputs":[{"name":"evalcontext"},{"generics":["scope"],"name":"option"}],"output":{"name":"evalresult"}}],[11,"validation_op","","",291,{"inputs":[{"name":"evalcontext"},{"name":"validationop"},{"name":"validationoperand"}],"output":{"name":"evalresult"}}],[0,"monomorphize","rustc_mir","",null,null],[3,"Instance","rustc_mir::monomorphize","",null,null],[12,"def","","",293,null],[12,"substs","","",293,null],[4,"MonoItem","","",null,null],[13,"Fn","","",294,null],[13,"Static","","",294,null],[13,"GlobalAsm","","",294,null],[5,"assert_symbols_are_distinct","","",null,{"inputs":[{"name":"tyctxt"},{"name":"i"}],"output":null}],[5,"fn_once_adapter_instance","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"closuresubsts"}],"output":{"name":"instance"}}],[5,"needs_fn_once_adapter_shim","","",null,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"generics":["bool"],"name":"result"}}],[5,"resolve_closure","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"closuresubsts"},{"name":"closurekind"}],"output":{"name":"instance"}}],[5,"resolve_drop_in_place","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"instance"}}],[5,"custom_coerce_unsize_info","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"ty"}],"output":{"name":"customcoerceunsized"}}],[0,"collector","","Mono Item Collection ===========================",null,null],[3,"InliningMap","rustc_mir::monomorphize::collector","Maps every mono item to all mono items it references in its body.",null,null],[12,"index","","",295,null],[12,"targets","","",295,null],[12,"inlines","","",295,null],[3,"MirNeighborCollector","","",null,null],[12,"tcx","","",296,null],[12,"mir","","",296,null],[12,"output","","",296,null],[12,"param_substs","","",296,null],[3,"RootCollector","","",null,null],[12,"tcx","","",297,null],[12,"mode","","",297,null],[12,"output","","",297,null],[12,"entry_fn","","",297,null],[4,"MonoItemCollectionMode","","",null,null],[13,"Eager","","",298,null],[13,"Lazy","","",298,null],[5,"collect_crate_mono_items","","",null,null],[5,"collect_roots","","",null,{"inputs":[{"name":"tyctxt"},{"name":"monoitemcollectionmode"}],"output":{"generics":["monoitem"],"name":"vec"}}],[5,"collect_items_rec","","",null,{"inputs":[{"name":"tyctxt"},{"name":"monoitem"},{"name":"fxhashset"},{"name":"defidmap"},{"name":"inliningmap"}],"output":null}],[5,"record_accesses","","",null,null],[5,"check_recursion_limit","","",null,null],[5,"check_type_length_limit","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"}],"output":null}],[5,"visit_drop_use","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"bool"},{"name":"vec"}],"output":null}],[5,"visit_fn_use","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"bool"},{"name":"vec"}],"output":null}],[5,"visit_instance_use","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"},{"name":"bool"},{"name":"vec"}],"output":null}],[5,"should_monomorphize_locally","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"}],"output":{"name":"bool"}}],[5,"find_vtable_types_for_unsizing","","For given pair of source and target type that occur in an unsizing coercion, this function finds the pair of types that determines the vtable linking them.",null,null],[5,"create_fn_mono_item","","",null,{"inputs":[{"name":"instance"}],"output":{"name":"monoitem"}}],[5,"create_mono_items_for_vtable_methods","","Creates a `MonoItem` for each method that is referenced by the vtable for the given trait/impl pair.",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"ty"},{"name":"vec"}],"output":null}],[5,"item_has_type_parameters","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"create_mono_items_for_default_impls","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"},{"name":"vec"}],"output":null}],[5,"collect_miri","","Scan the miri alloc in order to find function calls, closures, and drop-glue",null,{"inputs":[{"name":"tyctxt"},{"name":"allocid"},{"name":"vec"}],"output":null}],[5,"collect_neighbours","","Scan the MIR in order to find function calls, closures, and drop-glue",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"},{"name":"vec"}],"output":null}],[5,"def_id_to_string","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"string"}}],[5,"collect_const","","",null,{"inputs":[{"name":"tyctxt"},{"name":"const"},{"name":"substs"},{"name":"vec"}],"output":null}],[11,"eq","","",298,{"inputs":[{"name":"self"},{"name":"monoitemcollectionmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",298,null],[11,"hash","","",298,null],[11,"clone","","",298,{"inputs":[{"name":"self"}],"output":{"name":"monoitemcollectionmode"}}],[11,"fmt","","",298,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",295,{"inputs":[],"output":{"name":"inliningmap"}}],[11,"record_accesses","","",295,{"inputs":[{"name":"self"},{"name":"monoitem"},{"name":"i"}],"output":null}],[11,"with_inlining_candidates","","",295,{"inputs":[{"name":"self"},{"name":"monoitem"},{"name":"f"}],"output":null}],[11,"iter_accesses","","",295,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"visit_rvalue","","",296,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_const","","",296,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_terminator_kind","","",296,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"visit_static","","",296,{"inputs":[{"name":"self"},{"name":"static"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_item","","",297,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",297,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",297,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"is_root","","",297,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"push_if_root","","If `def_id` represents a root, then push it onto the list of outputs. (Note that all roots must be monomorphic.)",297,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"push_extra_entry_roots","","As a special case, when/if we encounter the `main()` function, we also have to generate a monomorphized copy of the start lang item based on the return type of `main`. This is not needed when the user writes their own `start` manually.",297,{"inputs":[{"name":"self"}],"output":null}],[0,"item","rustc_mir::monomorphize","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",null,null],[4,"MonoItem","rustc_mir::monomorphize::item","",null,null],[13,"Fn","","",294,null],[13,"Static","","",294,null],[13,"GlobalAsm","","",294,null],[3,"DefPathBasedNames","","Same as `unique_type_name()` but with the result pushed onto the given `output` parameter.",null,null],[12,"tcx","","",299,null],[12,"omit_disambiguators","","",299,null],[12,"omit_local_crate_name","","",299,null],[4,"InstantiationMode","","Describes how a translation item will be instantiated in object files.",null,null],[13,"GloballyShared","","There will be exactly one instance of the given MonoItem. It will have external linkage so that it can be linked to from other codegen units.",300,null],[12,"may_conflict","rustc_mir::monomorphize::item::InstantiationMode","In some compilation scenarios we may decide to take functions that are typically `LocalCopy` and instead move them to `GloballyShared` to avoid translating them a bunch of times. In this situation, however, our local copy may conflict with other crates also inlining the same function.",300,null],[13,"LocalCopy","rustc_mir::monomorphize::item","Each codegen unit containing a reference to the given MonoItem will have its own private copy of the function (with internal linkage).",300,null],[8,"MonoItemExt","","",null,null],[10,"as_mono_item","","",301,{"inputs":[{"name":"self"}],"output":{"name":"monoitem"}}],[11,"is_generic_fn","","",301,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"symbol_name","","",301,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"symbolname"}}],[11,"instantiation_mode","","",301,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"instantiationmode"}}],[11,"explicit_linkage","","",301,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["linkage"],"name":"option"}}],[11,"is_instantiable","","Returns whether this instance is instantiable - whether it has no unsatisfied predicates.",301,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"bool"}}],[11,"to_string","","",301,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"string"}}],[11,"local_span","","",301,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["span"],"name":"option"}}],[11,"eq","","",300,{"inputs":[{"name":"self"},{"name":"instantiationmode"}],"output":{"name":"bool"}}],[11,"ne","","",300,{"inputs":[{"name":"self"},{"name":"instantiationmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",300,null],[11,"clone","","",300,{"inputs":[{"name":"self"}],"output":{"name":"instantiationmode"}}],[11,"fmt","","",300,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",300,null],[11,"as_mono_item","","",294,{"inputs":[{"name":"self"}],"output":{"name":"monoitem"}}],[11,"new","","",299,{"inputs":[{"name":"tyctxt"},{"name":"bool"},{"name":"bool"}],"output":{"name":"self"}}],[11,"push_type_name","","",299,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"string"}],"output":null}],[11,"push_def_path","","",299,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"string"}],"output":null}],[11,"push_type_params","","",299,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"i"},{"name":"string"}],"output":null}],[11,"push_instance_as_string","","",299,{"inputs":[{"name":"self"},{"name":"instance"},{"name":"string"}],"output":null}],[0,"partitioning","rustc_mir::monomorphize","Partitioning Codegen Units for Incremental Compilation ======================================================",null,null],[3,"CodegenUnit","rustc_mir::monomorphize::partitioning","",null,null],[12,"name","","A name for this CGU. Incremental compilation requires that name be unique amongst all crates.  Therefore, it should contain something unique to this crate (e.g., a module path) as well as the crate name and disambiguator.",302,null],[12,"items","","",302,null],[12,"size_estimate","","",302,null],[3,"PreInliningPartitioning","","",null,null],[12,"codegen_units","","",303,null],[12,"roots","","",303,null],[12,"internalization_candidates","","",303,null],[3,"PostInliningPartitioning","","",null,null],[12,"codegen_units","","",304,null],[12,"trans_item_placements","","",304,null],[12,"internalization_candidates","","",304,null],[4,"PartitioningStrategy","","",null,null],[13,"PerModule","","Generate one codegen unit per source-level module.",305,null],[13,"FixedUnitCount","","Partition the whole crate into a fixed number of codegen units.",305,null],[4,"TransItemPlacement","","For symbol internalization, we need to know whether a symbol/trans-item is accessed from outside the codegen unit it is defined in. This type is used to keep track of that.",null,null],[13,"SingleCgu","","",306,null],[12,"cgu_name","rustc_mir::monomorphize::partitioning::TransItemPlacement","",306,null],[13,"MultipleCgus","rustc_mir::monomorphize::partitioning","",306,null],[5,"fallback_cgu_name","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"name":"internedstring"}}],[5,"partition","","",null,{"inputs":[{"name":"tyctxt"},{"name":"i"},{"name":"partitioningstrategy"},{"name":"inliningmap"}],"output":{"generics":["codegenunit"],"name":"vec"}}],[5,"place_root_translation_items","","",null,{"inputs":[{"name":"tyctxt"},{"name":"i"}],"output":{"name":"preinliningpartitioning"}}],[5,"merge_codegen_units","","",null,{"inputs":[{"name":"preinliningpartitioning"},{"name":"usize"},{"name":"str"}],"output":null}],[5,"place_inlined_translation_items","","",null,{"inputs":[{"name":"preinliningpartitioning"},{"name":"inliningmap"}],"output":{"name":"postinliningpartitioning"}}],[5,"internalize_symbols","","",null,{"inputs":[{"name":"tyctxt"},{"name":"postinliningpartitioning"},{"name":"inliningmap"}],"output":null}],[5,"characteristic_def_id_of_trans_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"monoitem"}],"output":{"generics":["defid"],"name":"option"}}],[5,"compute_codegen_unit_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"bool"}],"output":{"name":"internedstring"}}],[5,"numbered_codegen_unit_name","","",null,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"internedstring"}}],[5,"debug_dump","","",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"name":"i"}],"output":null}],[8,"CodegenUnitExt","","",null,null],[10,"as_codegen_unit","","",307,{"inputs":[{"name":"self"}],"output":{"name":"codegenunit"}}],[11,"contains_item","","",307,{"inputs":[{"name":"self"},{"name":"monoitem"}],"output":{"name":"bool"}}],[11,"name","","",307,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"items","","",307,{"inputs":[{"name":"self"}],"output":{"name":"fxhashmap"}}],[11,"work_product_id","","",307,{"inputs":[{"name":"self"}],"output":{"name":"workproductid"}}],[11,"items_in_deterministic_order","","",307,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"vec"}}],[11,"as_codegen_unit","","",302,{"inputs":[{"name":"self"}],"output":{"name":"codegenunit"}}],[11,"clone","","",306,{"inputs":[{"name":"self"}],"output":{"name":"transitemplacement"}}],[11,"eq","","",306,{"inputs":[{"name":"self"},{"name":"transitemplacement"}],"output":{"name":"bool"}}],[11,"ne","","",306,{"inputs":[{"name":"self"},{"name":"transitemplacement"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",306,null],[11,"fmt","","",306,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[17,"DIAGNOSTICS","rustc_mir","",null,null],[14,"run_passes","","",null,null],[11,"eval_into","rustc_mir::hair","",160,{"inputs":[{"name":"self"},{"name":"builder"},{"name":"place"},{"name":"basicblock"}],"output":{"name":"blockand"}}],[11,"eval_into","","",151,{"inputs":[{"name":"self"},{"name":"builder"},{"name":"place"},{"name":"basicblock"}],"output":{"name":"blockand"}}],[11,"eq","rustc_mir::monomorphize::item","",294,{"inputs":[{"name":"self"},{"name":"monoitem"}],"output":{"name":"bool"}}],[11,"ne","","",294,{"inputs":[{"name":"self"},{"name":"monoitem"}],"output":{"name":"bool"}}],[11,"eq","rustc_mir::monomorphize","",293,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"bool"}}],[11,"ne","","",293,{"inputs":[{"name":"self"},{"name":"instance"}],"output":{"name":"bool"}}],[11,"super_fold_with","","",293,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"instance"}}],[11,"super_visit_with","","",293,{"inputs":[{"name":"self"},{"name":"v"}],"output":{"name":"bool"}}],[11,"fmt","","",293,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","rustc_mir::monomorphize::item","",294,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"map_crate","rustc_mir::monomorphize","",293,{"inputs":[{"name":"self"}],"output":{"name":"cratenum"}}],[11,"default_span","","",293,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"clone","rustc_mir::monomorphize::item","",294,{"inputs":[{"name":"self"}],"output":{"name":"monoitem"}}],[11,"clone","rustc_mir::monomorphize","",293,{"inputs":[{"name":"self"}],"output":{"name":"instance"}}],[11,"encode","","",293,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash_stable","rustc_mir::monomorphize::partitioning","",302,null],[11,"hash_stable","rustc_mir::monomorphize","",293,null],[11,"hash_stable","rustc_mir::monomorphize::item","",294,null],[11,"fmt","rustc_mir::monomorphize","",293,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"decode","","",293,{"inputs":[{"name":"__d"}],"output":{"generics":["instance"],"name":"result"}}],[11,"hash","rustc_mir::monomorphize::item","",294,null],[11,"hash","rustc_mir::monomorphize","",293,null],[11,"assert_receiver_is_total_eq","","",293,null],[11,"assert_receiver_is_total_eq","rustc_mir::monomorphize::item","",294,null],[11,"lift_to_tcx","rustc_mir::monomorphize","",293,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"generics":["instance"],"name":"option"}}],[11,"ty","","",293,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"tys"}}],[11,"new","","",293,{"inputs":[{"name":"defid"},{"name":"slice"}],"output":{"name":"instance"}}],[11,"mono","","",293,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"instance"}}],[11,"def_id","","",293,{"inputs":[{"name":"self"}],"output":{"name":"defid"}}],[11,"resolve","","Resolve a (def_id, substs) pair to an (optional) instance -- most commonly, this is used to find the precise code that will run for a trait method invocation, if known.",293,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"},{"name":"defid"},{"name":"slice"}],"output":{"generics":["instance"],"name":"option"}}],[11,"resolve_closure","","",293,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"closuresubsts"},{"name":"closurekind"}],"output":{"name":"instance"}}],[11,"size_estimate","rustc_mir::monomorphize::item","",294,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"usize"}}],[11,"new","rustc_mir::monomorphize::partitioning","",302,{"inputs":[{"name":"internedstring"}],"output":{"name":"codegenunit"}}],[11,"name","","",302,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"set_name","","",302,null],[11,"items","","",302,{"inputs":[{"name":"self"}],"output":{"name":"hashmap"}}],[11,"items_mut","","",302,{"inputs":[{"name":"self"}],"output":{"name":"hashmap"}}],[11,"mangle_name","","",302,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[11,"estimate_size","","",302,null],[11,"size_estimate","","",302,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"modify_size_estimate","","",302,null]],"paths":[[3,"MirBorrowckCtxt"],[3,"AccessErrorsReported"],[3,"RootPlace"],[3,"Context"],[4,"MutateMode"],[4,"Control"],[4,"ArtificialField"],[4,"ShallowOrDeep"],[4,"ReadOrWrite"],[4,"ReadKind"],[4,"WriteKind"],[4,"LocalMutationIsAllowed"],[4,"InitializationRequiringAction"],[4,"NoMovePathFound"],[4,"Overlap"],[4,"ContextKind"],[3,"BorrowSet"],[3,"BorrowData"],[3,"GatherBorrows"],[3,"Flows"],[3,"LocationTable"],[3,"LocationIndex"],[4,"RichLocation"],[8,"PlaceExt"],[3,"Prefixes"],[4,"PrefixSet"],[8,"IsPrefixOf"],[3,"ConstraintGeneration"],[3,"UseFinder"],[3,"DefUseVisitor"],[3,"AllFacts"],[3,"FactWriter"],[8,"FactRow"],[8,"FactCell"],[3,"RegionInferenceContext"],[3,"TrackCauses"],[3,"RegionDefinition"],[3,"RegionCausalInfo"],[3,"Constraint"],[3,"ConstraintIndex"],[3,"TypeTest"],[4,"Cause"],[4,"RegionTest"],[3,"DfsStorage"],[3,"CopyFromSourceToTarget"],[3,"TestTargetOutlivesSource"],[8,"DfsOp"],[3,"RegionValueElements"],[3,"RegionElementIndex"],[3,"RegionValues"],[4,"RegionElement"],[8,"ToElementIndex"],[8,"ClosureRegionRequirementsExt"],[8,"CauseExt"],[3,"NLLVisitor"],[3,"SubtypeConstraintGenerator"],[3,"TypeVerifier"],[3,"TypeChecker"],[3,"MirTypeckRegionConstraints"],[3,"OutlivesSet"],[4,"FieldAccessError"],[4,"Locations"],[3,"ObligationAccumulator"],[3,"TypeLivenessGenerator"],[8,"AtLocation"],[8,"ToLocations"],[3,"TypeckMir"],[3,"UniversalRegions"],[3,"UniversalRegionIndices"],[3,"UniversalRegionRelations"],[3,"UniversalRegionsBuilder"],[4,"DefiningTy"],[4,"RegionClassification"],[8,"InferCtxtExt"],[8,"ToRegionVid"],[3,"GlobalizeMir"],[3,"Builder"],[3,"GuardFrameLocal"],[3,"GuardFrame"],[3,"CFG"],[3,"ScopeId"],[3,"BlockAnd"],[4,"LocalsForNode"],[4,"ForGuard"],[4,"Category"],[4,"RvalueFunc"],[8,"EvalInto"],[3,"ArmHasGuard"],[3,"ArmBlocks"],[3,"Candidate"],[3,"Binding"],[3,"MatchPair"],[3,"Test"],[4,"TestKind"],[3,"Scope"],[3,"DropData"],[3,"CachedBlock"],[3,"BreakableScope"],[4,"DropKind"],[8,"BlockAndExtension"],[3,"DataflowBuilder"],[3,"DebugFormatted"],[3,"MoveDataParamEnv"],[3,"PropagationContext"],[3,"Bits"],[3,"DataflowAnalysis"],[3,"DataflowResults"],[3,"DataflowState"],[3,"AllSets"],[3,"BlockSets"],[3,"FlowAtLocation"],[8,"FlowsAtLocation"],[3,"Graph"],[3,"Edge"],[8,"MirWithFlowState"],[3,"MaybeInitializedPlaces"],[3,"MaybeUninitializedPlaces"],[3,"DefinitelyInitializedPlaces"],[3,"MovingOutStatements"],[3,"EverInitializedPlaces"],[3,"MaybeStorageLive"],[3,"HaveBeenBorrowedLocals"],[3,"BorrowedLocalsVisitor"],[3,"Borrows"],[3,"MovePath"],[3,"MoveData"],[3,"LocationMap"],[3,"MoveOut"],[3,"Init"],[3,"MovePathLookup"],[3,"IllegalMoveOrigin"],[4,"InitKind"],[4,"LookupResult"],[4,"IllegalMoveOriginKind"],[4,"MoveError"],[8,"Lift"],[3,"AbstractOperand"],[3,"AbstractType"],[3,"MovePathIndex"],[3,"MoveOutIndex"],[3,"InitIndex"],[3,"BorrowIndex"],[3,"MoveDataBuilder"],[3,"Gatherer"],[8,"HasMoveData"],[8,"Dataflow"],[8,"DataflowResultsConsumer"],[8,"InitialFlow"],[8,"BitDenotation"],[3,"Block"],[3,"Stmt"],[3,"Expr"],[3,"FieldExprRef"],[3,"FruInfo"],[3,"Arm"],[4,"LintLevel"],[4,"BlockSafety"],[4,"StmtRef"],[4,"StmtKind"],[4,"ExprKind"],[4,"ExprRef"],[4,"LogicalOp"],[3,"Cx"],[8,"ToBorrowKind"],[8,"ToRef"],[3,"FieldPattern"],[3,"Pattern"],[3,"PatternContext"],[4,"PatternError"],[4,"BindingMode"],[4,"PatternKind"],[3,"Matrix"],[3,"MatchCheckCtxt"],[3,"PatternContext"],[3,"Witness"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"LiteralExpander"],[3,"OuterVisitor"],[3,"MatchVisitor"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[8,"PatternFoldable"],[8,"PatternFolder"],[8,"Mirror"],[3,"DropShimElaborator"],[3,"CloneShimBuilder"],[4,"Adjustment"],[4,"CallKind"],[3,"MirSource"],[3,"AddValidation"],[3,"AddMovesForPackedDrops"],[3,"GatherBorrowedRegions"],[3,"DeleteTrivialEndRegions"],[3,"CleanEndRegions"],[3,"CleanUserAssertTy"],[3,"DeleteUserAssertTy"],[3,"UnsafetyChecker"],[3,"UnusedUnsafeVisitor"],[3,"SimplifyBranches"],[3,"SimplifyCfg"],[3,"CfgSimplifier"],[3,"DeclMarker"],[3,"LocalUpdater"],[3,"SimplifyLocals"],[3,"EraseRegionsVisitor"],[3,"EraseRegions"],[3,"NoLandingPads"],[3,"SanityCheck"],[3,"InitializationData"],[3,"Elaborator"],[3,"ElaborateDropsCtxt"],[3,"ElaborateDrops"],[4,"AddCallGuards"],[3,"TempCollector"],[3,"Promoter"],[4,"TempState"],[4,"Candidate"],[3,"Qualif"],[3,"Qualifier"],[4,"Mode"],[3,"QualifyAndPromoteConstants"],[3,"RemoveNoopLandingPads"],[3,"Marker"],[3,"Disambiguator"],[3,"Deaggregator"],[3,"InstCombineVisitor"],[3,"OptimizationFinder"],[3,"OptimizationList"],[3,"InstCombine"],[3,"ConstantPropagationVisitor"],[4,"Action"],[3,"CopyPropagation"],[3,"ConstPropagator"],[3,"CanConstProp"],[3,"ConstProp"],[3,"RenameLocalVisitor"],[3,"SuspensionPoint"],[3,"TransformVisitor"],[3,"StorageIgnored"],[3,"BorrowedLocals"],[3,"DerefArgVisitor"],[3,"StateTransform"],[3,"CallSite"],[3,"Inliner"],[3,"Integrator"],[3,"Inline"],[4,"RhsKind"],[3,"Lower128Bit"],[3,"UniformArrayMoveOutVisitor"],[3,"LocalUse"],[3,"RestoreDataCollector"],[3,"UniformArrayMoveOut"],[3,"RestoreSubsliceArrayMoveOut"],[8,"MirPass"],[4,"PassWhere"],[4,"Origin"],[8,"BorrowckErrors"],[3,"DropCtxt"],[4,"DropFlagState"],[4,"DropStyle"],[4,"DropFlagMode"],[4,"Unwind"],[8,"DropElaborator"],[3,"DefUseAnalysis"],[3,"Info"],[3,"Use"],[3,"DefUseFinder"],[3,"MutateUseVisitor"],[3,"MirPatch"],[3,"ExtraComments"],[3,"LivenessResult"],[3,"LivenessMode"],[3,"LivenessResults"],[3,"DefsUsesVisitor"],[3,"DefsUses"],[4,"DefUse"],[3,"FindLocalAssignmentVisitor"],[8,"FindAssignments"],[3,"EvalContext"],[3,"Frame"],[3,"TyAndPacked"],[3,"ValTy"],[3,"Memory"],[4,"StackPopCleanup"],[4,"Place"],[4,"PlaceExtra"],[4,"MemoryKind"],[4,"ConstEvalError"],[3,"CompileTimeEvaluator"],[8,"Machine"],[8,"HasMemory"],[3,"Instance"],[4,"MonoItem"],[3,"InliningMap"],[3,"MirNeighborCollector"],[3,"RootCollector"],[4,"MonoItemCollectionMode"],[3,"DefPathBasedNames"],[4,"InstantiationMode"],[8,"MonoItemExt"],[3,"CodegenUnit"],[3,"PreInliningPartitioning"],[3,"PostInliningPartitioning"],[4,"PartitioningStrategy"],[4,"TransItemPlacement"],[8,"CodegenUnitExt"]]};
searchIndex["rustc_passes"] = {"doc":"Various checks","items":[[5,"provide","rustc_passes","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0130","rustc_passes::diagnostics","",null,null],[0,"__register_diagnostic_E0197","","",null,null],[0,"__register_diagnostic_E0198","","",null,null],[0,"__register_diagnostic_E0267","","",null,null],[0,"__register_diagnostic_E0268","","",null,null],[0,"__register_diagnostic_E0379","","",null,null],[0,"__register_diagnostic_E0380","","",null,null],[0,"__register_diagnostic_E0449","","",null,null],[0,"__register_diagnostic_E0590","","",null,null],[0,"__register_diagnostic_E0571","","",null,null],[0,"__register_diagnostic_E0226","","",null,null],[0,"__register_diagnostic_E0472","","",null,null],[0,"__register_diagnostic_E0561","","",null,null],[0,"__register_diagnostic_E0567","","",null,null],[0,"__register_diagnostic_E0568","","",null,null],[0,"__register_diagnostic_E0642","","",null,null],[0,"__register_diagnostic_E0666","","",null,null],[0,"__register_diagnostic_E0667","","",null,null],[0,"ast_validation","rustc_passes","",null,null],[3,"AstValidator","rustc_passes::ast_validation","",null,null],[12,"session","","",0,null],[3,"NestedImplTraitVisitor","","",null,null],[12,"session","","",1,null],[12,"outer_impl_trait","","",1,null],[3,"ImplTraitProjectionVisitor","","",null,null],[12,"session","","",2,null],[12,"is_banned","","",2,null],[5,"check_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":null}],[11,"err_handler","","",0,{"inputs":[{"name":"self"}],"output":{"name":"handler"}}],[11,"check_lifetime","","",0,{"inputs":[{"name":"self"},{"name":"ident"}],"output":null}],[11,"check_label","","",0,{"inputs":[{"name":"self"},{"name":"ident"}],"output":null}],[11,"invalid_non_exhaustive_attribute","","",0,{"inputs":[{"name":"self"},{"name":"variant"}],"output":null}],[11,"invalid_visibility","","",0,{"inputs":[{"name":"self"},{"name":"visibility"},{"generics":["str"],"name":"option"}],"output":null}],[11,"check_decl_no_pat","","",0,{"inputs":[{"name":"self"},{"name":"fndecl"},{"name":"reportfn"}],"output":null}],[11,"check_trait_fn_not_const","","",0,{"inputs":[{"name":"self"},{"generics":["constness"],"name":"spanned"}],"output":null}],[11,"no_questions_in_bounds","","",0,{"inputs":[{"name":"self"},{"name":"typarambounds"},{"name":"str"},{"name":"bool"}],"output":null}],[11,"check_expr_within_pat","","matches '-' lit | lit (cf. parser::Parser::parse_pat_literal_maybe_minus), or path for ranges.",0,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"bool"}],"output":null}],[11,"check_late_bound_lifetime_defs","","",0,{"inputs":[{"name":"self"},{"name":"vec"}],"output":null}],[11,"visit_expr","","",0,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",0,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_use_tree","","",0,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"visit_label","","",0,{"inputs":[{"name":"self"},{"name":"label"}],"output":null}],[11,"visit_lifetime","","",0,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_item","","",0,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",0,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_vis","","",0,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":null}],[11,"visit_generics","","",0,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_pat","","",0,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_where_predicate","","",0,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":null}],[11,"visit_poly_trait_ref","","",0,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_mac","","",0,{"inputs":[{"name":"self"},{"name":"spanned"}],"output":null}],[11,"with_impl_trait","","",1,{"inputs":[{"name":"self"},{"generics":["span"],"name":"option"},{"name":"f"}],"output":null}],[11,"visit_ty","","",1,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_path_parameters","","",1,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[11,"visit_mac","","",1,{"inputs":[{"name":"self"},{"name":"spanned"}],"output":null}],[11,"with_ban","","",2,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"visit_ty","","",2,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_mac","","",2,{"inputs":[{"name":"self"},{"name":"spanned"}],"output":null}],[0,"rvalue_promotion","rustc_passes","",null,null],[3,"CheckCrateVisitor","rustc_passes::rvalue_promotion","",null,null],[12,"tcx","","",3,null],[12,"in_fn","","",3,null],[12,"in_static","","",3,null],[12,"promotable","","",3,null],[12,"mut_rvalue_borrows","","",3,null],[12,"param_env","","",3,null],[12,"identity_substs","","",3,null],[12,"tables","","",3,null],[12,"result","","",3,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"const_is_rvalue_promotable_to_static","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"rvalue_promotable_map","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["itemlocalset"],"name":"lrc"}}],[5,"check_expr","","This function is used to enforce the constraints on const/static items. It walks through the value of the item walking down the expression and evaluating every nested expression. If the expression is not part of a const/static item, it is qualified for promotion instead of producing errors.",null,{"inputs":[{"name":"checkcratevisitor"},{"name":"expr"},{"name":"ty"}],"output":null}],[5,"check_adjustments","","Check the adjustments of an expression",null,{"inputs":[{"name":"checkcratevisitor"},{"name":"expr"}],"output":null}],[11,"type_has_only_promotable_values","","",3,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"handle_const_fn_call","","",3,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"ty"},{"name":"span"}],"output":null}],[11,"nested_visit_map","","",3,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",3,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_stmt","","",3,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_expr","","",3,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"consume","","",3,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"borrow","","",3,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[11,"decl_without_init","","",3,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"mutate","","",3,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[11,"matched_pat","","",3,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"matchmode"}],"output":null}],[11,"consume_pat","","",3,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[0,"hir_stats","rustc_passes","",null,null],[3,"NodeData","rustc_passes::hir_stats","",null,null],[12,"count","","",4,null],[12,"size","","",4,null],[3,"StatCollector","","",null,null],[12,"krate","","",5,null],[12,"data","","",5,null],[12,"seen","","",5,null],[4,"Id","","",null,null],[13,"Node","","",6,null],[13,"Attr","","",6,null],[13,"None","","",6,null],[5,"print_hir_stats","","",null,{"inputs":[{"name":"crate"}],"output":null}],[5,"print_ast_stats","","",null,{"inputs":[{"name":"crate"},{"name":"str"}],"output":null}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"id"}}],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"id"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"self"},{"name":"id"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",6,null],[11,"hash","","",6,null],[11,"record","","",5,{"inputs":[{"name":"self"},{"name":"str"},{"name":"id"},{"name":"t"}],"output":null}],[11,"print","","",5,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"nested_visit_map","","",5,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_item","","",5,{"inputs":[{"name":"self"},{"name":"itemid"}],"output":null}],[11,"visit_nested_trait_item","","",5,{"inputs":[{"name":"self"},{"name":"traititemid"}],"output":null}],[11,"visit_nested_impl_item","","",5,{"inputs":[{"name":"self"},{"name":"implitemid"}],"output":null}],[11,"visit_nested_body","","",5,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_item","","",5,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_mod","","",5,{"inputs":[{"name":"self"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_foreign_item","","",5,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_local","","",5,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",5,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",5,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_arm","","",5,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",5,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_decl","","",5,{"inputs":[{"name":"self"},{"name":"decl"}],"output":null}],[11,"visit_expr","","",5,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",5,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_fn","","",5,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_where_predicate","","",5,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":null}],[11,"visit_trait_item","","",5,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",5,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_ty_param_bound","","",5,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":null}],[11,"visit_struct_field","","",5,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",5,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_lifetime","","",5,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_qpath","","",5,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_path","","",5,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_path_segment","","",5,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[11,"visit_assoc_type_binding","","",5,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":null}],[11,"visit_attribute","","",5,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_macro_def","","",5,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"visit_mod","","",5,null],[11,"visit_foreign_item","","",5,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_item","","",5,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_local","","",5,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",5,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",5,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_arm","","",5,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",5,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",5,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",5,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_fn","","",5,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",5,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",5,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_ty_param_bound","","",5,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":null}],[11,"visit_struct_field","","",5,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",5,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_lifetime","","",5,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_mac","","",5,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[11,"visit_path_segment","","",5,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[11,"visit_assoc_type_binding","","",5,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":null}],[11,"visit_attribute","","",5,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[0,"loops","rustc_passes","",null,null],[3,"CheckLoopVisitor","rustc_passes::loops","",null,null],[12,"sess","","",7,null],[12,"hir_map","","",7,null],[12,"cx","","",7,null],[4,"LoopKind","","",null,null],[13,"Loop","","",8,null],[13,"WhileLoop","","",8,null],[4,"Context","","",null,null],[13,"Normal","","",9,null],[13,"Loop","","",9,null],[13,"Closure","","",9,null],[5,"check_crate","","",null,{"inputs":[{"name":"session"},{"name":"map"}],"output":null}],[11,"clone","","",8,{"inputs":[{"name":"self"}],"output":{"name":"loopkind"}}],[11,"eq","","",8,{"inputs":[{"name":"self"},{"name":"loopkind"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"loopkind"}],"output":{"name":"bool"}}],[11,"name","","",8,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"context"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"context"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"checkloopvisitor"}}],[11,"nested_visit_map","","",7,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",7,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_impl_item","","",7,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_expr","","",7,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"with_context","","",7,{"inputs":[{"name":"self"},{"name":"context"},{"name":"f"}],"output":null}],[11,"require_loop","","",7,{"inputs":[{"name":"self"},{"name":"str"},{"name":"span"}],"output":null}],[11,"emit_unlabled_cf_in_while_condition","","",7,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"}],"output":null}],[0,"mir_stats","rustc_passes","",null,null],[3,"NodeData","rustc_passes::mir_stats","",null,null],[12,"count","","",10,null],[12,"size","","",10,null],[3,"StatCollector","","",null,null],[12,"_tcx","","",11,null],[12,"data","","",11,null],[11,"record_with_size","","",11,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"}],"output":null}],[11,"record","","",11,{"inputs":[{"name":"self"},{"name":"str"},{"name":"t"}],"output":null}],[11,"visit_mir","","",11,{"inputs":[{"name":"self"},{"name":"mir"}],"output":null}],[11,"visit_basic_block_data","","",11,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"basicblockdata"}],"output":null}],[11,"visit_visibility_scope_data","","",11,{"inputs":[{"name":"self"},{"name":"visibilityscopedata"}],"output":null}],[11,"visit_statement","","",11,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"statement"},{"name":"location"}],"output":null}],[11,"visit_terminator","","",11,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminator"},{"name":"location"}],"output":null}],[11,"visit_terminator_kind","","",11,{"inputs":[{"name":"self"},{"name":"basicblock"},{"name":"terminatorkind"},{"name":"location"}],"output":null}],[11,"visit_assert_message","","",11,{"inputs":[{"name":"self"},{"name":"assertmessage"},{"name":"location"}],"output":null}],[11,"visit_rvalue","","",11,{"inputs":[{"name":"self"},{"name":"rvalue"},{"name":"location"}],"output":null}],[11,"visit_operand","","",11,{"inputs":[{"name":"self"},{"name":"operand"},{"name":"location"}],"output":null}],[11,"visit_place","","",11,{"inputs":[{"name":"self"},{"name":"place"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_projection","","",11,{"inputs":[{"name":"self"},{"name":"placeprojection"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_projection_elem","","",11,{"inputs":[{"name":"self"},{"name":"placeelem"},{"name":"placecontext"},{"name":"location"}],"output":null}],[11,"visit_constant","","",11,{"inputs":[{"name":"self"},{"name":"constant"},{"name":"location"}],"output":null}],[11,"visit_literal","","",11,{"inputs":[{"name":"self"},{"name":"literal"},{"name":"location"}],"output":null}],[11,"visit_source_info","","",11,{"inputs":[{"name":"self"},{"name":"sourceinfo"}],"output":null}],[11,"visit_closure_substs","","",11,{"inputs":[{"name":"self"},{"name":"closuresubsts"},{"name":"location"}],"output":null}],[11,"visit_const","","",11,{"inputs":[{"name":"self"},{"name":"const"},{"name":"location"}],"output":null}],[11,"visit_local_decl","","",11,{"inputs":[{"name":"self"},{"name":"local"},{"name":"localdecl"}],"output":null}],[11,"visit_visibility_scope","","",11,{"inputs":[{"name":"self"},{"name":"visibilityscope"}],"output":null}],[17,"DIAGNOSTICS","rustc_passes","",null,null]],"paths":[[3,"AstValidator"],[3,"NestedImplTraitVisitor"],[3,"ImplTraitProjectionVisitor"],[3,"CheckCrateVisitor"],[3,"NodeData"],[3,"StatCollector"],[4,"Id"],[3,"CheckLoopVisitor"],[4,"LoopKind"],[4,"Context"],[3,"NodeData"],[3,"StatCollector"]]};
searchIndex["rustc_platform_intrinsics"] = {"doc":"","items":[[3,"Intrinsic","rustc_platform_intrinsics","",null,null],[12,"inputs","","",0,null],[12,"output","","",0,null],[12,"definition","","",0,null],[4,"Type","","",null,null],[13,"Void","","",1,null],[13,"Integer","","",1,null],[13,"Float","","",1,null],[13,"Pointer","","",1,null],[13,"Vector","","",1,null],[13,"Aggregate","","",1,null],[4,"IntrinsicDef","","",null,null],[13,"Named","","",2,null],[0,"x86","","",null,null],[5,"find","rustc_platform_intrinsics::x86","",null,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}],[0,"arm","rustc_platform_intrinsics","",null,null],[5,"find","rustc_platform_intrinsics::arm","",null,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}],[0,"aarch64","rustc_platform_intrinsics","",null,null],[5,"find","rustc_platform_intrinsics::aarch64","",null,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}],[0,"nvptx","rustc_platform_intrinsics","",null,null],[5,"find","rustc_platform_intrinsics::nvptx","",null,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}],[0,"hexagon","rustc_platform_intrinsics","",null,null],[5,"find","rustc_platform_intrinsics::hexagon","",null,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}],[0,"powerpc","rustc_platform_intrinsics","",null,null],[5,"find","rustc_platform_intrinsics::powerpc","",null,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}],[7,"I8","rustc_platform_intrinsics","",null,null],[7,"I16","","",null,null],[7,"I32","","",null,null],[7,"I64","","",null,null],[7,"U8","","",null,null],[7,"U16","","",null,null],[7,"U32","","",null,null],[7,"U64","","",null,null],[7,"F32","","",null,null],[7,"F64","","",null,null],[7,"I32_8","","",null,null],[7,"I8x8","","",null,null],[7,"U8x8","","",null,null],[7,"I8x16","","",null,null],[7,"U8x16","","",null,null],[7,"I8x32","","",null,null],[7,"U8x32","","",null,null],[7,"I8x64","","",null,null],[7,"U8x64","","",null,null],[7,"I8x128","","",null,null],[7,"U8x128","","",null,null],[7,"I8x256","","",null,null],[7,"U8x256","","",null,null],[7,"I16x4","","",null,null],[7,"U16x4","","",null,null],[7,"I16x8","","",null,null],[7,"U16x8","","",null,null],[7,"I16x16","","",null,null],[7,"U16x16","","",null,null],[7,"I16x32","","",null,null],[7,"U16x32","","",null,null],[7,"I16x64","","",null,null],[7,"U16x64","","",null,null],[7,"I16x128","","",null,null],[7,"U16x128","","",null,null],[7,"I32x2","","",null,null],[7,"U32x2","","",null,null],[7,"I32x4","","",null,null],[7,"U32x4","","",null,null],[7,"I32x8","","",null,null],[7,"U32x8","","",null,null],[7,"I32x16","","",null,null],[7,"U32x16","","",null,null],[7,"I32x32","","",null,null],[7,"U32x32","","",null,null],[7,"I32x64","","",null,null],[7,"U32x64","","",null,null],[7,"I64x1","","",null,null],[7,"U64x1","","",null,null],[7,"I64x2","","",null,null],[7,"U64x2","","",null,null],[7,"I64x4","","",null,null],[7,"U64x4","","",null,null],[7,"F32x2","","",null,null],[7,"F32x4","","",null,null],[7,"F32x8","","",null,null],[7,"F64x1","","",null,null],[7,"F64x2","","",null,null],[7,"F64x4","","",null,null],[7,"I32x4_F32","","",null,null],[7,"I32x8_F32","","",null,null],[7,"I64x2_F64","","",null,null],[7,"I64x4_F64","","",null,null],[7,"VOID","","",null,null],[11,"clone","","",1,{"inputs":[{"name":"self"}],"output":{"name":"type"}}],[11,"hash","","",1,null],[11,"assert_receiver_is_total_eq","","",1,null],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"type"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"self"},{"name":"type"}],"output":{"name":"bool"}}],[11,"find","","",0,{"inputs":[{"name":"str"}],"output":{"generics":["intrinsic"],"name":"option"}}]],"paths":[[3,"Intrinsic"],[4,"Type"],[4,"IntrinsicDef"]]};
searchIndex["rustc_plugin"] = {"doc":"Infrastructure for compiler plugins.","items":[[0,"diagnostics","rustc_plugin","",null,null],[0,"__register_diagnostic_E0498","rustc_plugin::diagnostics","",null,null],[0,"registry","rustc_plugin","Used by plugin crates to tell `rustc` about the plugins they provide.",null,null],[3,"Registry","rustc_plugin::registry","Structure used to register plugins.",null,null],[12,"sess","","Compiler session. Useful if you want to emit diagnostic messages from the plugin registrar.",0,null],[12,"args_hidden","","",0,null],[12,"krate_span","","",0,null],[12,"syntax_exts","","",0,null],[12,"early_lint_passes","","",0,null],[12,"late_lint_passes","","",0,null],[12,"lint_groups","","",0,null],[12,"llvm_passes","","",0,null],[12,"attributes","","",0,null],[12,"whitelisted_custom_derives","","",0,null],[11,"new","","",0,{"inputs":[{"name":"session"},{"name":"span"}],"output":{"name":"registry"}}],[11,"args","","Get the plugin's arguments, if any.",0,null],[11,"register_syntax_extension","","Register a syntax extension of any kind.",0,{"inputs":[{"name":"self"},{"name":"name"},{"name":"syntaxextension"}],"output":null}],[11,"register_custom_derive","","This can be used in place of `register_syntax_extension` to register legacy custom derives (i.e. attribute syntax extensions whose name begins with `derive_`). Legacy custom derives defined by this function do not trigger deprecation warnings when used.",0,{"inputs":[{"name":"self"},{"name":"name"},{"name":"syntaxextension"}],"output":null}],[11,"take_whitelisted_custom_derives","","",0,{"inputs":[{"name":"self"}],"output":{"generics":["name"],"name":"vec"}}],[11,"register_macro","","Register a macro of the usual kind.",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"macroexpanderfn"}],"output":null}],[11,"register_early_lint_pass","","Register a compiler lint pass.",0,{"inputs":[{"name":"self"},{"name":"earlylintpassobject"}],"output":null}],[11,"register_late_lint_pass","","Register a compiler lint pass.",0,{"inputs":[{"name":"self"},{"name":"latelintpassobject"}],"output":null}],[11,"register_lint_group","","Register a lint group.",0,{"inputs":[{"name":"self"},{"name":"str"},{"generics":["lint"],"name":"vec"}],"output":null}],[11,"register_llvm_pass","","Register an LLVM pass.",0,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"register_attribute","","Register an attribute with an attribute type.",0,{"inputs":[{"name":"self"},{"name":"string"},{"name":"attributetype"}],"output":null}],[0,"load","rustc_plugin","Used by `rustc` when loading a plugin.",null,null],[3,"PluginRegistrar","rustc_plugin::load","",null,null],[12,"fun","","",1,null],[12,"args","","",1,null],[3,"PluginLoader","","",null,null],[12,"sess","","",2,null],[12,"reader","","",2,null],[12,"plugins","","",2,null],[5,"call_malformed_plugin_attribute","","",null,{"inputs":[{"name":"session"},{"name":"span"}],"output":null}],[5,"load_plugins","","Read plugin metadata and dynamically load registrar functions.",null,{"inputs":[{"name":"session"},{"name":"cstore"},{"name":"crate"},{"name":"str"},{"generics":["vec"],"name":"option"}],"output":{"generics":["pluginregistrar"],"name":"vec"}}],[6,"PluginRegistrarFun","","Pointer to a registrar function.",null,null],[11,"new","","",2,{"inputs":[{"name":"session"},{"name":"cstore"},{"name":"str"}],"output":{"name":"self"}}],[11,"load_plugin","","",2,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"generics":["nestedmetaitem"],"name":"vec"}],"output":null}],[11,"dylink_registrar","","",2,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathbuf"},{"name":"string"}],"output":{"name":"pluginregistrarfun"}}],[0,"build","rustc_plugin","Used by `rustc` when compiling a plugin crate.",null,null],[3,"RegistrarFinder","rustc_plugin::build","",null,null],[12,"registrars","","",3,null],[5,"find_plugin_registrar","","Find the function marked with `#[plugin_registrar]`, if any.",null,{"inputs":[{"name":"handler"},{"name":"map"}],"output":{"generics":["nodeid"],"name":"option"}}],[11,"visit_item","","",3,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",3,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",3,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[17,"DIAGNOSTICS","rustc_plugin","",null,null]],"paths":[[3,"Registry"],[3,"PluginRegistrar"],[3,"PluginLoader"],[3,"RegistrarFinder"]]};
searchIndex["rustc_privacy"] = {"doc":"","items":[[3,"PubRestrictedVisitor","rustc_privacy","Visitor used to determine if pub(restricted) is used anywhere in the crate.",null,null],[12,"tcx","","",0,null],[12,"has_pub_restricted","","",0,null],[3,"EmbargoVisitor","","The embargo visitor, used to determine the exports of the ast",null,null],[12,"tcx","","",1,null],[12,"access_levels","","",1,null],[12,"prev_level","","",1,null],[12,"changed","","",1,null],[3,"ReachEverythingInTheInterfaceVisitor","","",null,null],[12,"item_def_id","","",2,null],[12,"ev","","",2,null],[3,"NamePrivacyVisitor","","Name privacy visitor, checks privacy and reports violations. Most of name privacy checks are performed during the main resolution phase, or later in type checking when field accesses and associated items are resolved. This pass performs remaining checks for fields in struct expressions and patterns.",null,null],[12,"tcx","","",3,null],[12,"tables","","",3,null],[12,"current_item","","",3,null],[12,"empty_tables","","",3,null],[3,"TypePrivacyVisitor","","Type privacy visitor, checks types for privacy and reports violations. Both explicitly written types and inferred types of expressions and patters are checked. Checks are performed on \"semantic\" types regardless of names and their hygiene.",null,null],[12,"tcx","","",4,null],[12,"tables","","",4,null],[12,"current_item","","",4,null],[12,"in_body","","",4,null],[12,"span","","",4,null],[12,"empty_tables","","",4,null],[12,"visited_anon_tys","","",4,null],[3,"ObsoleteVisiblePrivateTypesVisitor","","Obsolete visitors for checking for private items in public interfaces. These visitors are supposed to be kept in frozen state and produce an \"old error node set\". For backward compatibility the new visitor reports warnings instead of hard errors when the erroneous node is not in this old set.",null,null],[12,"tcx","","",5,null],[12,"access_levels","","",5,null],[12,"in_variant","","",5,null],[12,"old_error_set","","",5,null],[3,"ObsoleteCheckTypeForPrivatenessVisitor","","",null,null],[12,"inner","","",6,null],[12,"contains_private","","whether the type refers to private types.",6,null],[12,"at_outer_type","","whether we've recurred at all (i.e. if we're pointing at the first type on which visit_ty was called).",6,null],[12,"outer_type_is_public_path","","",6,null],[3,"SearchInterfaceForPrivateItemsVisitor","","SearchInterfaceForPrivateItemsVisitor traverses an item's interface and finds any private components in it. PrivateItemsInPublicInterfacesVisitor ensures there are no private types and traits in public interfaces.",null,null],[12,"tcx","","",7,null],[12,"item_def_id","","",7,null],[12,"span","","",7,null],[12,"required_visibility","","The visitor checks that each component type is at least this visible",7,null],[12,"min_visibility","","The visibility of the least visible component that has been visited",7,null],[12,"has_pub_restricted","","",7,null],[12,"has_old_errors","","",7,null],[12,"in_assoc_ty","","",7,null],[3,"PrivateItemsInPublicInterfacesVisitor","","",null,null],[12,"tcx","","",8,null],[12,"has_pub_restricted","","",8,null],[12,"old_error_set","","",8,null],[12,"inner_visibility","","",8,null],[5,"update_tables","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"typecktables"},{"name":"typecktables"}],"output":{"name":"typecktables"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["accesslevels"],"name":"lrc"}}],[5,"privacy_access_levels","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["accesslevels"],"name":"lrc"}}],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0445","rustc_privacy::diagnostics","",null,null],[0,"__register_diagnostic_E0446","","",null,null],[0,"__register_diagnostic_E0447","","",null,null],[0,"__register_diagnostic_E0448","","",null,null],[0,"__register_diagnostic_E0451","","",null,null],[17,"DIAGNOSTICS","rustc_privacy","",null,null],[11,"nested_visit_map","","",0,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_vis","","",0,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":null}],[11,"item_ty_level","","",1,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["accesslevel"],"name":"option"}}],[11,"impl_trait_level","","",1,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["accesslevel"],"name":"option"}}],[11,"get","","",1,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["accesslevel"],"name":"option"}}],[11,"update","","",1,{"inputs":[{"name":"self"},{"name":"nodeid"},{"generics":["accesslevel"],"name":"option"}],"output":{"generics":["accesslevel"],"name":"option"}}],[11,"reach","","",1,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"reacheverythingintheinterfacevisitor"}}],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",1,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",1,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_block","","",1,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_mod","","",1,{"inputs":[{"name":"self"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_macro_def","","",1,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":null}],[11,"visit_ty","","",1,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"generics","","",2,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"predicates","","",2,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"ty","","",2,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"impl_trait_ref","","",2,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"check_trait_ref","","",2,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_ty","","",2,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"check_field","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"},{"name":"adtdef"},{"name":"fielddef"}],"output":null}],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",3,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",3,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_item","","",3,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",3,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",3,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_expr","","",3,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_pat","","",3,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"def_id_visibility","","",4,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"visibility"}}],[11,"item_is_accessible","","",4,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"check_expr_pat_type","","",4,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"span"}],"output":{"name":"bool"}}],[11,"check_trait_ref","","",4,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",4,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_nested_body","","",4,{"inputs":[{"name":"self"},{"name":"bodyid"}],"output":null}],[11,"visit_ty","","",4,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_trait_ref","","",4,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_expr","","",4,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_qpath","","",4,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_pat","","",4,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_local","","",4,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_item","","",4,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",4,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",4,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_ty","","",4,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"path_is_private_type","","",5,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"trait_is_public","","",5,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"check_ty_param_bound","","",5,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":null}],[11,"item_is_public","","",5,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"nested_visit_map","","",6,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_ty","","",6,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_expr","","",6,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"nested_visit_map","","We want to visit items in the context of their containing module and so forth, so supply a crate for doing a deep walk.",5,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",5,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_generics","","",5,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_foreign_item","","",5,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_ty","","",5,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_variant","","",5,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",5,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_block","","",5,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_expr","","",5,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"generics","","",7,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"predicates","","",7,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"ty","","",7,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"impl_trait_ref","","",7,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"check_trait_ref","","",7,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_ty","","",7,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"check","","",8,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"visibility"}],"output":{"name":"searchinterfaceforprivateitemsvisitor"}}],[11,"nested_visit_map","","",8,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",8,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_impl_item","","",8,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_ty","","",8,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_expr","","",8,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_pat","","",8,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}]],"paths":[[3,"PubRestrictedVisitor"],[3,"EmbargoVisitor"],[3,"ReachEverythingInTheInterfaceVisitor"],[3,"NamePrivacyVisitor"],[3,"TypePrivacyVisitor"],[3,"ObsoleteVisiblePrivateTypesVisitor"],[3,"ObsoleteCheckTypeForPrivatenessVisitor"],[3,"SearchInterfaceForPrivateItemsVisitor"],[3,"PrivateItemsInPublicInterfacesVisitor"]]};
searchIndex["rustc_resolve"] = {"doc":"","items":[[3,"ImportSuggestion","rustc_resolve","A free importable items suggested in case of resolution failure.",null,null],[12,"path","","",0,null],[3,"BindingError","","",null,null],[12,"name","","",1,null],[12,"origin","","",1,null],[12,"target","","",1,null],[3,"BindingInfo","","",null,null],[12,"span","","",2,null],[12,"binding_mode","","",2,null],[3,"PerNS","","Just a helper ‒ separate structure for each namespace.",null,null],[12,"value_ns","","",3,null],[12,"type_ns","","",3,null],[12,"macro_ns","","",3,null],[3,"UsePlacementFinder","","",null,null],[12,"target_module","","",4,null],[12,"span","","",4,null],[12,"found_use","","",4,null],[3,"Rib","","One local scope.",null,null],[12,"bindings","","",5,null],[12,"kind","","",5,null],[3,"ModuleData","","One node in the tree of modules.",null,null],[12,"parent","","",6,null],[12,"kind","","",6,null],[12,"normal_ancestor_id","","",6,null],[12,"resolutions","","",6,null],[12,"legacy_macro_resolutions","","",6,null],[12,"macro_resolutions","","",6,null],[12,"unresolved_invocations","","",6,null],[12,"no_implicit_prelude","","",6,null],[12,"glob_importers","","",6,null],[12,"globs","","",6,null],[12,"traits","","",6,null],[12,"populated","","",6,null],[12,"span","","Span of the module itself. Used for error reporting.",6,null],[12,"expansion","","",6,null],[3,"NameBinding","","Records a possibly-private value, type, or module definition.",null,null],[12,"kind","","",7,null],[12,"expansion","","",7,null],[12,"span","","",7,null],[12,"vis","","",7,null],[3,"PrivacyError","","",null,null],[12,"0","","",8,null],[12,"1","","",8,null],[12,"2","","",8,null],[3,"UseError","","",null,null],[12,"err","","",9,null],[12,"candidates","","Attach `use` statements for these candidates",9,null],[12,"node_id","","The node id of the module to place the use statements in",9,null],[12,"better","","Whether the diagnostic should state that it's \"better\"",9,null],[3,"AmbiguityError","","",null,null],[12,"span","","",10,null],[12,"name","","",10,null],[12,"lexical","","",10,null],[12,"b1","","",10,null],[12,"b2","","",10,null],[12,"legacy","","",10,null],[3,"PrimitiveTypeTable","","Interns the names of the primitive types.",null,null],[12,"primitive_types","","",11,null],[3,"Resolver","","The main resolver class.",null,null],[12,"session","","",12,null],[12,"cstore","","",12,null],[12,"definitions","","",12,null],[12,"graph_root","","",12,null],[12,"prelude","","",12,null],[12,"extern_prelude","","",12,null],[12,"has_self","","n.b. This is used only for better diagnostics, not name resolution itself.",12,null],[12,"field_names","","Names of fields of an item `DefId` accessible with dot syntax. Used for hints during error reporting.",12,null],[12,"determined_imports","","All imports known to succeed or fail.",12,null],[12,"indeterminate_imports","","All non-determined imports.",12,null],[12,"current_module","","The module that represents the current item scope.",12,null],[12,"ribs","","The current set of local scopes for types and values. FIXME #4948: Reuse ribs to avoid allocation.",12,null],[12,"label_ribs","","The current set of local scopes, for labels.",12,null],[12,"current_trait_ref","","The trait that the current context can refer to.",12,null],[12,"current_self_type","","The current self type if inside an impl (used for better errors).",12,null],[12,"primitive_type_table","","The idents for the primitive types.",12,null],[12,"def_map","","",12,null],[12,"freevars","","",12,null],[12,"freevars_seen","","",12,null],[12,"export_map","","",12,null],[12,"trait_map","","",12,null],[12,"block_map","","A map from nodes to anonymous modules. Anonymous modules are pseudo-modules that are implicitly created around items contained within blocks.",12,null],[12,"module_map","","",12,null],[12,"extern_module_map","","",12,null],[12,"make_glob_map","","",12,null],[12,"glob_map","","Maps imports to the names of items actually imported (this actually maps all imports, but only glob imports are actually interesting).",12,null],[12,"used_imports","","",12,null],[12,"maybe_unused_trait_imports","","",12,null],[12,"maybe_unused_extern_crates","","",12,null],[12,"privacy_errors","","privacy errors are delayed until the end in order to deduplicate them",12,null],[12,"ambiguity_errors","","ambiguity errors are delayed for deduplication",12,null],[12,"use_injections","","`use` injections are delayed for better placement and deduplication",12,null],[12,"proc_mac_errors","","`use` injections for proc macros wrongly imported with #[macro_use]",12,null],[12,"gated_errors","","",12,null],[12,"disallowed_shadowing","","",12,null],[12,"arenas","","",12,null],[12,"dummy_binding","","",12,null],[12,"use_extern_macros","","true if `#![feature(use_extern_macros)]`",12,null],[12,"crate_loader","","",12,null],[12,"macro_names","","",12,null],[12,"global_macros","","",12,null],[12,"all_macros","","",12,null],[12,"lexical_macro_resolutions","","",12,null],[12,"macro_map","","",12,null],[12,"macro_defs","","",12,null],[12,"local_macro_def_scopes","","",12,null],[12,"macro_exports","","",12,null],[12,"whitelisted_legacy_custom_derives","","",12,null],[12,"found_unresolved_macro","","",12,null],[12,"unused_macros","","List of crate local macros that we need to warn about as being unused. Right now this only includes macro_rules! macros, and macros 2.0.",12,null],[12,"invocations","","Maps the `Mark` of an expansion to its containing module or block.",12,null],[12,"name_already_seen","","Avoid duplicated errors for \"name already defined\".",12,null],[12,"proc_macro_enabled","","If `#![feature(proc_macro)]` is set",12,null],[12,"warned_proc_macros","","A set of procedural macros imported by `#[macro_use]` that have already been warned about",12,null],[12,"potentially_unused_imports","","",12,null],[12,"struct_constructors","","This table maps struct IDs into struct constructor IDs, it's not used during normal resolution, only for better error reporting.",12,null],[12,"current_type_ascription","","Only used for better errors on `fn(): fn()`",12,null],[12,"injected_crate","","",12,null],[3,"ResolverArenas","","Nothing really interesting here, it just provides memory for the rest of the crate.",null,null],[12,"modules","","",13,null],[12,"local_modules","","",13,null],[12,"name_bindings","","",13,null],[12,"import_directives","","",13,null],[12,"name_resolutions","","",13,null],[12,"invocation_data","","",13,null],[12,"legacy_bindings","","",13,null],[4,"AssocSuggestion","","A field or associated item from self type suggested in case of resolution failure.",null,null],[13,"Field","","",14,null],[13,"MethodWithSelf","","",14,null],[13,"AssocItem","","",14,null],[4,"ResolutionError","","",null,null],[13,"TypeParametersFromOuterFunction","","error E0401: can't use type parameters from outer function",15,null],[13,"NameAlreadyUsedInTypeParameterList","","error E0403: the name is already used for a type parameter in this type parameter list",15,null],[13,"MethodNotMemberOfTrait","","error E0407: method is not a member of trait",15,null],[13,"TypeNotMemberOfTrait","","error E0437: type is not a member of trait",15,null],[13,"ConstNotMemberOfTrait","","error E0438: const is not a member of trait",15,null],[13,"VariableNotBoundInPattern","","error E0408: variable `{}` is not bound in all patterns",15,null],[13,"VariableBoundWithDifferentMode","","error E0409: variable `{}` is bound in inconsistent ways within the same match arm",15,null],[13,"IdentifierBoundMoreThanOnceInParameterList","","error E0415: identifier is bound more than once in this parameter list",15,null],[13,"IdentifierBoundMoreThanOnceInSamePattern","","error E0416: identifier is bound more than once in the same pattern",15,null],[13,"UndeclaredLabel","","error E0426: use of undeclared label",15,null],[13,"SelfImportsOnlyAllowedWithin","","error E0429: `self` imports are only allowed within a { } list",15,null],[13,"SelfImportCanOnlyAppearOnceInTheList","","error E0430: `self` import can only appear once in the list",15,null],[13,"SelfImportOnlyInImportListWithNonEmptyPrefix","","error E0431: `self` import can only appear in an import list with a non-empty prefix",15,null],[13,"UnresolvedImport","","error E0432: unresolved import",15,null],[13,"FailedToResolve","","error E0433: failed to resolve",15,null],[13,"CannotCaptureDynamicEnvironmentInFnItem","","error E0434: can't capture dynamic environment in a fn item",15,null],[13,"AttemptToUseNonConstantValueInConstant","","error E0435: attempt to use a non-constant value in a constant",15,null],[13,"BindingShadowsSomethingUnacceptable","","error E0530: X bindings cannot shadow Ys",15,null],[13,"ForwardDeclaredTyParam","","error E0128: type parameters with a default cannot use forward declared identifiers",15,null],[4,"PatternSource","","",null,null],[13,"Match","","",16,null],[13,"IfLet","","",16,null],[13,"WhileLet","","",16,null],[13,"Let","","",16,null],[13,"For","","",16,null],[13,"FnParam","","",16,null],[4,"AliasPossibility","","",null,null],[13,"No","","",17,null],[13,"Maybe","","",17,null],[4,"PathSource","","",null,null],[13,"Type","","",18,null],[13,"Trait","","",18,null],[13,"Expr","","",18,null],[13,"Pat","","",18,null],[13,"Struct","","",18,null],[13,"TupleStruct","","",18,null],[13,"TraitItem","","",18,null],[13,"Visibility","","",18,null],[13,"ImportPrefix","","",18,null],[4,"Namespace","","Different kinds of symbols don't influence each other.",null,null],[13,"TypeNS","","",19,null],[13,"ValueNS","","",19,null],[13,"MacroNS","","",19,null],[4,"TypeParameters","","",null,null],[13,"NoTypeParameters","","",20,null],[13,"HasTypeParameters","","",20,null],[4,"RibKind","","The rib kind controls the translation of local definitions (`Def::Local`) to upvars (`Def::Upvar`).",null,null],[13,"NormalRibKind","","No translation needs to be applied.",21,null],[13,"ClosureRibKind","","We passed through a closure scope at the given node ID. Translate upvars as appropriate.",21,null],[13,"TraitOrImplItemRibKind","","We passed through an impl or trait and are now in one of its methods or associated types. Allow references to ty params that impl or trait binds. Disallow any other upvars (including other ty params that are upvars).",21,null],[13,"ItemRibKind","","We passed through an item scope. Disallow upvars.",21,null],[13,"ConstantItemRibKind","","We're in a constant item. Can't refer to dynamic stuff.",21,null],[13,"ModuleRibKind","","We passed through a module.",21,null],[13,"MacroDefinition","","We passed through a `macro_rules!` statement",21,null],[13,"ForwardTyParamBanRibKind","","All bindings in this rib are type parameters that can't be used from the default of a type parameter because they're not declared before said type parameter. Also see the `visit_generics` override.",21,null],[4,"LexicalScopeBinding","","An intermediate resolution result.",null,null],[13,"Item","","",22,null],[13,"Def","","",22,null],[4,"PathResult","","",null,null],[13,"Module","","",23,null],[13,"NonModule","","",23,null],[13,"Indeterminate","","",23,null],[13,"Failed","","",23,null],[4,"ModuleKind","","",null,null],[13,"Block","","An anonymous module, eg. just a block.",24,null],[13,"Def","","Any module with a name.",24,null],[4,"NameBindingKind","","",null,null],[13,"Def","","",25,null],[13,"Module","","",25,null],[13,"Import","","",25,null],[12,"binding","rustc_resolve::NameBindingKind","",25,null],[12,"directive","","",25,null],[12,"used","","",25,null],[12,"legacy_self_import","","",25,null],[13,"Ambiguity","rustc_resolve","",25,null],[12,"b1","rustc_resolve::NameBindingKind","",25,null],[12,"b2","","",25,null],[12,"legacy","","",25,null],[4,"MakeGlobMap","rustc_resolve","",null,null],[13,"Yes","","",26,null],[13,"No","","",26,null],[5,"resolve_error","","Combines an error with provided span and emits it",null,{"inputs":[{"name":"resolver"},{"name":"span"},{"name":"resolutionerror"}],"output":null}],[5,"resolve_struct_error","","",null,{"inputs":[{"name":"resolver"},{"name":"span"},{"name":"resolutionerror"}],"output":{"name":"diagnosticbuilder"}}],[5,"reduce_impl_span_to_impl_keyword","","Adjust the impl span so that just the `impl` keyword is taken by removing everything after `<` (`\"impl<T> Iterator for A<T> {}\" -> \"impl\"`) and everything after the first whitespace (`\"impl Iterator for A\" -> \"impl\"`)",null,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"span"}}],[5,"generate_fn_name_span","","",null,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[5,"generate_local_type_param_snippet","","Take the span of a type parameter in a function signature and try to generate a span for the function name (with generics) and a new snippet for this span with the pointed type parameter as a new local type parameter.",null,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"option"}}],[5,"is_self_type","","",null,null],[5,"is_self_value","","",null,null],[5,"names_to_string","","",null,null],[5,"path_names_to_string","","",null,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[5,"import_candidate_to_paths","","Get the path for an enum and the variant from an `ImportSuggestion` for an enum variant.",null,null],[5,"show_candidates","","When an entity with a given name is not available in scope, we search for entities with that name in all crates. This method allows outputting the results of this search in a programmer-friendly way",null,null],[5,"module_to_string","","A somewhat inefficient routine to obtain the name of a module.",null,{"inputs":[{"name":"moduledata"}],"output":{"generics":["string"],"name":"option"}}],[5,"err_path_resolution","","",null,{"inputs":[],"output":{"name":"pathresolution"}}],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0128","rustc_resolve::diagnostics","",null,null],[0,"__register_diagnostic_E0154","","",null,null],[0,"__register_diagnostic_E0251","","",null,null],[0,"__register_diagnostic_E0252","","",null,null],[0,"__register_diagnostic_E0253","","",null,null],[0,"__register_diagnostic_E0254","","",null,null],[0,"__register_diagnostic_E0255","","",null,null],[0,"__register_diagnostic_E0256","","",null,null],[0,"__register_diagnostic_E0259","","",null,null],[0,"__register_diagnostic_E0260","","",null,null],[0,"__register_diagnostic_E0364","","",null,null],[0,"__register_diagnostic_E0365","","",null,null],[0,"__register_diagnostic_E0401","","",null,null],[0,"__register_diagnostic_E0403","","",null,null],[0,"__register_diagnostic_E0404","","",null,null],[0,"__register_diagnostic_E0405","","",null,null],[0,"__register_diagnostic_E0407","","",null,null],[0,"__register_diagnostic_E0408","","",null,null],[0,"__register_diagnostic_E0409","","",null,null],[0,"__register_diagnostic_E0411","","",null,null],[0,"__register_diagnostic_E0412","","",null,null],[0,"__register_diagnostic_E0415","","",null,null],[0,"__register_diagnostic_E0416","","",null,null],[0,"__register_diagnostic_E0422","","",null,null],[0,"__register_diagnostic_E0423","","",null,null],[0,"__register_diagnostic_E0424","","",null,null],[0,"__register_diagnostic_E0425","","",null,null],[0,"__register_diagnostic_E0426","","",null,null],[0,"__register_diagnostic_E0428","","",null,null],[0,"__register_diagnostic_E0429","","",null,null],[0,"__register_diagnostic_E0430","","",null,null],[0,"__register_diagnostic_E0431","","",null,null],[0,"__register_diagnostic_E0432","","",null,null],[0,"__register_diagnostic_E0433","","",null,null],[0,"__register_diagnostic_E0434","","",null,null],[0,"__register_diagnostic_E0435","","",null,null],[0,"__register_diagnostic_E0437","","",null,null],[0,"__register_diagnostic_E0438","","",null,null],[0,"__register_diagnostic_E0466","","",null,null],[0,"__register_diagnostic_E0468","","",null,null],[0,"__register_diagnostic_E0469","","",null,null],[0,"__register_diagnostic_E0530","","",null,null],[0,"__register_diagnostic_E0532","","",null,null],[0,"__register_diagnostic_E0603","","",null,null],[0,"__register_diagnostic_E0659","","",null,null],[0,"__register_diagnostic_E0531","","",null,null],[0,"__register_diagnostic_E0573","","",null,null],[0,"__register_diagnostic_E0574","","",null,null],[0,"__register_diagnostic_E0575","","",null,null],[0,"__register_diagnostic_E0576","","",null,null],[0,"__register_diagnostic_E0577","","",null,null],[0,"__register_diagnostic_E0578","","",null,null],[0,"macros","rustc_resolve","",null,null],[3,"InvocationData","rustc_resolve::macros","",null,null],[12,"module","","",27,null],[12,"def_index","","",27,null],[12,"const_expr","","",27,null],[12,"legacy_scope","","",27,null],[12,"expansion","","",27,null],[3,"LegacyBinding","","",null,null],[12,"parent","","",28,null],[12,"ident","","",28,null],[12,"def_id","","",28,null],[12,"span","","",28,null],[3,"ProcMacError","","",null,null],[12,"crate_name","","",29,null],[12,"name","","",29,null],[12,"module","","",29,null],[12,"use_span","","",29,null],[12,"warn_msg","","",29,null],[4,"LegacyScope","","",null,null],[13,"Empty","","",30,null],[13,"Invocation","","",30,null],[13,"Expansion","","",30,null],[13,"Binding","","",30,null],[4,"MacroBinding","","",null,null],[13,"Legacy","","",31,null],[13,"Global","","",31,null],[13,"Modern","","",31,null],[11,"clone","","",27,{"inputs":[{"name":"self"}],"output":{"name":"invocationdata"}}],[11,"root","","",27,{"inputs":[{"name":"moduledata"}],"output":{"name":"self"}}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"legacyscope"}}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"macrobinding"}}],[11,"span","","",31,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"binding","","",31,{"inputs":[{"name":"self"}],"output":{"name":"namebinding"}}],[11,"next_node_id","rustc_resolve","",12,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"get_module_scope","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"mark"}}],[11,"eliminate_crate_var","","",12,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"is_whitelisted_legacy_custom_derive","","",12,{"inputs":[{"name":"self"},{"name":"name"}],"output":{"name":"bool"}}],[11,"visit_expansion","","",12,null],[11,"add_builtin","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"generics":["syntaxextension"],"name":"lrc"}],"output":null}],[11,"resolve_imports","","",12,{"inputs":[{"name":"self"}],"output":null}],[11,"find_legacy_attr_invoc","","",12,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"bool"}],"output":{"generics":["attribute"],"name":"option"}}],[11,"resolve_invoc","","",12,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"mark"},{"name":"bool"}],"output":{"generics":["option","determinacy"],"name":"result"}}],[11,"resolve_macro","","",12,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"path"},{"name":"macrokind"},{"name":"bool"}],"output":{"generics":["lrc","determinacy"],"name":"result"}}],[11,"check_unused_macros","","",12,{"inputs":[{"name":"self"}],"output":null}],[11,"resolve_invoc_to_def","","",12,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"mark"},{"name":"bool"}],"output":{"generics":["def","determinacy"],"name":"result"}}],[11,"resolve_macro_to_def","","",12,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"path"},{"name":"macrokind"},{"name":"bool"}],"output":{"generics":["def","determinacy"],"name":"result"}}],[11,"resolve_macro_to_def_inner","","",12,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"path"},{"name":"macrokind"},{"name":"bool"}],"output":{"generics":["def","determinacy"],"name":"result"}}],[11,"resolve_lexical_macro_path_segment","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"},{"name":"bool"},{"name":"span"}],"output":{"generics":["macrobinding","determinacy"],"name":"result"}}],[11,"resolve_legacy_scope","","",12,{"inputs":[{"name":"self"},{"name":"cell"},{"name":"ident"},{"name":"bool"}],"output":{"generics":["macrobinding"],"name":"option"}}],[11,"finalize_current_module_macro_resolutions","","",12,{"inputs":[{"name":"self"}],"output":null}],[11,"suggest_macro_name","","",12,{"inputs":[{"name":"self"},{"name":"str"},{"name":"macrokind"},{"name":"diagnosticbuilder"},{"name":"span"}],"output":null}],[11,"collect_def_ids","","",12,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"invocationdata"},{"name":"expansion"}],"output":null}],[11,"define_macro","","",12,{"inputs":[{"name":"self"},{"name":"item"},{"name":"mark"},{"name":"legacyscope"}],"output":null}],[11,"err_if_macro_use_proc_macro","","Error if `ext` is a Macros 1.1 procedural macro being imported by `#[macro_use]`",12,{"inputs":[{"name":"self"},{"name":"name"},{"name":"span"},{"name":"namebinding"}],"output":null}],[11,"report_proc_macro_import","","",12,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"gate_legacy_custom_derive","","",12,{"inputs":[{"name":"self"},{"name":"symbol"},{"name":"span"}],"output":null}],[0,"check_unused","","",null,null],[3,"UnusedImportCheckVisitor","rustc_resolve::check_unused","",null,null],[12,"resolver","","",32,null],[12,"unused_imports","","All the (so far) unused imports, grouped path list",32,null],[12,"base_id","","",32,null],[12,"item_span","","",32,null],[5,"check_crate","","",null,{"inputs":[{"name":"resolver"},{"name":"crate"}],"output":null}],[11,"deref","","",32,{"inputs":[{"name":"self"}],"output":{"name":"resolver"}}],[11,"deref_mut","","",32,{"inputs":[{"name":"self"}],"output":{"name":"resolver"}}],[11,"check_import","","",32,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_item","","",32,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_use_tree","","",32,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[0,"build_reduced_graph","rustc_resolve","Reduced graph building",null,null],[3,"LegacyMacroImports","rustc_resolve::build_reduced_graph","",null,null],[12,"import_all","","",33,null],[12,"imports","","",33,null],[3,"BuildReducedGraphVisitor","","",null,null],[12,"resolver","","",34,null],[12,"legacy_scope","","",34,null],[12,"expansion","","",34,null],[11,"default","","",33,{"inputs":[],"output":{"name":"legacymacroimports"}}],[11,"eq","","",33,{"inputs":[{"name":"self"},{"name":"legacymacroimports"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"self"},{"name":"legacymacroimports"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",33,null],[11,"define","rustc_resolve","Defines `name` in namespace `ns` of module `parent` to be `def` if it is not yet defined; otherwise, reports an error.",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"},{"name":"t"}],"output":null}],[11,"block_needs_anonymous_module","","",12,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"bool"}}],[11,"insert_field_names","","",12,{"inputs":[{"name":"self"},{"name":"defid"},{"generics":["name"],"name":"vec"}],"output":null}],[11,"build_reduced_graph_for_use_tree","","",12,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"visibility"},{"name":"path"},{"name":"bool"},{"name":"item"},{"name":"mark"}],"output":null}],[11,"build_reduced_graph_for_item","","Constructs the reduced graph for one item.",12,{"inputs":[{"name":"self"},{"name":"item"},{"name":"mark"}],"output":null}],[11,"build_reduced_graph_for_variant","","",12,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"moduledata"},{"name":"visibility"},{"name":"mark"}],"output":null}],[11,"build_reduced_graph_for_foreign_item","","Constructs the reduced graph for one foreign item.",12,{"inputs":[{"name":"self"},{"name":"foreignitem"},{"name":"mark"}],"output":null}],[11,"build_reduced_graph_for_block","","",12,{"inputs":[{"name":"self"},{"name":"block"},{"name":"mark"}],"output":null}],[11,"build_reduced_graph_for_external_crate_def","","Builds the reduced graph for a single item in an external crate.",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"export"}],"output":null}],[11,"get_module","","",12,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"moduledata"}}],[11,"macro_def_scope","","",12,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"moduledata"}}],[11,"get_macro","","",12,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"generics":["syntaxextension"],"name":"lrc"}}],[11,"populate_module_if_necessary","","Ensures that the reduced graph rooted at the given external module is built, building it if it is not.",12,{"inputs":[{"name":"self"},{"name":"moduledata"}],"output":null}],[11,"legacy_import_macro","","",12,{"inputs":[{"name":"self"},{"name":"name"},{"name":"namebinding"},{"name":"span"},{"name":"bool"}],"output":null}],[11,"process_legacy_macro_imports","","",12,{"inputs":[{"name":"self"},{"name":"item"},{"name":"moduledata"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"contains_macro_use","","",12,null],[11,"legacy_macro_imports","","",12,null],[11,"visit_invoc","rustc_resolve::build_reduced_graph","",34,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"invocationdata"}}],[11,"visit_impl_item","","",34,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_expr","","",34,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_pat","","",34,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_ty","","",34,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_item","","",34,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_stmt","","",34,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_foreign_item","","",34,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_block","","",34,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_trait_item","","",34,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_token","","",34,{"inputs":[{"name":"self"},{"name":"token"}],"output":null}],[0,"resolve_imports","rustc_resolve","",null,null],[3,"ImportDirective","rustc_resolve::resolve_imports","One import directive.",null,null],[12,"id","","",35,null],[12,"parent","","",35,null],[12,"module_path","","",35,null],[12,"imported_module","","",35,null],[12,"subclass","","",35,null],[12,"span","","",35,null],[12,"vis","","",35,null],[12,"expansion","","",35,null],[12,"used","","",35,null],[3,"NameResolution","","Records information about the resolution of a name in a namespace of a module.",null,null],[12,"single_imports","","The single imports that define the name in the namespace.",36,null],[12,"binding","","The least shadowable known binding for this name, or None if there are no known bindings.",36,null],[12,"shadows_glob","","",36,null],[3,"ImportResolver","","",null,null],[12,"resolver","","",37,null],[4,"ImportDirectiveSubclass","","Contains data for specific types of import directives.",null,null],[13,"SingleImport","","",38,null],[12,"target","rustc_resolve::resolve_imports::ImportDirectiveSubclass","",38,null],[12,"source","","",38,null],[12,"result","","",38,null],[12,"type_ns_only","","",38,null],[13,"GlobImport","rustc_resolve::resolve_imports","",38,null],[12,"is_prelude","rustc_resolve::resolve_imports::ImportDirectiveSubclass","",38,null],[12,"max_vis","","",38,null],[13,"ExternCrate","rustc_resolve::resolve_imports","",38,null],[13,"MacroUse","","",38,null],[4,"SingleImports","","",null,null],[13,"None","","No single imports can define the name in the namespace.",39,null],[13,"MaybeOne","","Only the given single import can define the name in the namespace.",39,null],[13,"MaybeTwo","","Only one of these two single imports can define the name in the namespace.",39,null],[13,"AtLeastOne","","At least one single import will define the name in the namespace.",39,null],[5,"import_path_to_string","","",null,null],[5,"import_directive_subclass_to_string","","",null,{"inputs":[{"name":"importdirectivesubclass"}],"output":{"name":"string"}}],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"importdirectivesubclass"}}],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",35,{"inputs":[{"name":"self"}],"output":{"name":"importdirective"}}],[11,"is_glob","","",35,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"self"}],"output":{"name":"nameresolution"}}],[11,"default","","",36,{"inputs":[],"output":{"name":"nameresolution"}}],[11,"fmt","","",36,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",39,{"inputs":[{"name":"self"}],"output":{"name":"singleimports"}}],[11,"fmt","","",39,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","Creates a `SingleImports<'a>` of None type.",39,{"inputs":[],"output":{"name":"self"}}],[11,"add_directive","","",39,{"inputs":[{"name":"self"},{"name":"importdirective"},{"name":"bool"}],"output":null}],[11,"directive_failed","","",39,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":null}],[11,"binding","","",36,{"inputs":[{"name":"self"}],"output":{"generics":["namebinding"],"name":"option"}}],[11,"resolution","rustc_resolve","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"}],"output":{"name":"refcell"}}],[11,"resolve_ident_in_module_unadjusted","","Attempts to resolve `ident` in namespaces `ns` of `module`. Invariant: if `record_used` is `Some`, import resolution must be complete.",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"},{"name":"bool"},{"name":"bool"},{"name":"span"}],"output":{"generics":["namebinding","determinacy"],"name":"result"}}],[11,"add_import_directive","","",12,{"inputs":[{"name":"self"},{"generics":["ident"],"name":"vec"},{"name":"importdirectivesubclass"},{"name":"span"},{"name":"nodeid"},{"name":"visibility"},{"name":"mark"}],"output":null}],[11,"import","","",12,{"inputs":[{"name":"self"},{"name":"namebinding"},{"name":"importdirective"}],"output":{"name":"namebinding"}}],[11,"try_define","","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"},{"name":"namebinding"}],"output":{"generics":["namebinding"],"name":"result"}}],[11,"ambiguity","","",12,{"inputs":[{"name":"self"},{"name":"namebinding"},{"name":"namebinding"}],"output":{"name":"namebinding"}}],[11,"update_resolution","","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"},{"name":"f"}],"output":{"name":"t"}}],[11,"import_dummy_binding","","",12,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":null}],[11,"deref","rustc_resolve::resolve_imports","",37,{"inputs":[{"name":"self"}],"output":{"name":"resolver"}}],[11,"deref_mut","","",37,{"inputs":[{"name":"self"}],"output":{"name":"resolver"}}],[11,"resolve_imports","","Resolves all imports for the crate. This method performs the fixed- point iteration.",37,{"inputs":[{"name":"self"}],"output":null}],[11,"finalize_imports","","",37,{"inputs":[{"name":"self"}],"output":null}],[11,"resolve_import","","Attempts to resolve the given import, returning true if its resolution is determined. If successful, the resolved bindings are written into the module.",37,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":{"name":"bool"}}],[11,"finalize_import","","",37,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":{"name":"option"}}],[11,"resolve_glob_import","","",37,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":null}],[11,"finalize_resolutions_in","","",37,{"inputs":[{"name":"self"},{"name":"moduledata"}],"output":null}],[6,"BindingMap","rustc_resolve","Map from the name in a pattern to its binding mode.",null,null],[6,"Module","","",null,null],[17,"DIAGNOSTICS","","",null,null],[8,"ToNameBinding","","",null,null],[10,"to_name_binding","","",40,{"inputs":[{"name":"self"},{"name":"resolverarenas"}],"output":{"name":"namebinding"}}],[11,"assert_receiver_is_total_eq","","",1,null],[11,"partial_cmp","","",1,{"inputs":[{"name":"self"},{"name":"bindingerror"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"bindingerror"}],"output":{"name":"bool"}}],[11,"cmp","","",1,{"inputs":[{"name":"self"},{"name":"bindingerror"}],"output":{"name":"ordering"}}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"bindinginfo"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",16,{"inputs":[{"name":"self"}],"output":{"name":"patternsource"}}],[11,"eq","","",16,{"inputs":[{"name":"self"},{"name":"patternsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",16,null],[11,"fmt","","",16,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"descr","","",16,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",17,{"inputs":[{"name":"self"}],"output":{"name":"aliaspossibility"}}],[11,"eq","","",17,{"inputs":[{"name":"self"},{"name":"aliaspossibility"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",17,null],[11,"fmt","","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",18,{"inputs":[{"name":"self"}],"output":{"name":"pathsource"}}],[11,"eq","","",18,{"inputs":[{"name":"self"},{"name":"pathsource"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"self"},{"name":"pathsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",18,null],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"namespace","","",18,{"inputs":[{"name":"self"}],"output":{"name":"namespace"}}],[11,"global_by_default","","",18,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"defer_to_typeck","","",18,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"descr_expected","","",18,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"is_expected","","",18,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"name":"bool"}}],[11,"error_code","","",18,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"str"}}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"namespace"}}],[11,"eq","","",19,{"inputs":[{"name":"self"},{"name":"namespace"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",19,null],[11,"partial_cmp","","",19,{"inputs":[{"name":"self"},{"name":"namespace"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",19,{"inputs":[{"name":"self"},{"name":"namespace"}],"output":{"name":"ordering"}}],[11,"hash","","",19,null],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"perns"}}],[11,"default","","",3,{"inputs":[],"output":{"name":"perns"}}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"index","","",3,{"inputs":[{"name":"self"},{"name":"namespace"}],"output":{"name":"t"}}],[11,"index_mut","","",3,{"inputs":[{"name":"self"},{"name":"namespace"}],"output":{"name":"t"}}],[11,"check","","",4,null],[11,"visit_mod","","",4,null],[11,"visit_item","","",12,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_arm","","",12,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_block","","",12,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_expr","","",12,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_local","","",12,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_ty","","",12,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_poly_trait_ref","","",12,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_variant","","",12,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_foreign_item","","",12,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_fn","","",12,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_generics","","",12,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"clone","","",20,{"inputs":[{"name":"self"}],"output":{"name":"typeparameters"}}],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"ribkind"}}],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",5,{"inputs":[{"name":"ribkind"}],"output":{"name":"rib"}}],[11,"item","","",22,{"inputs":[{"name":"self"}],"output":{"generics":["namebinding"],"name":"option"}}],[11,"def","","",22,{"inputs":[{"name":"self"}],"output":{"name":"def"}}],[11,"clone","","",23,{"inputs":[{"name":"self"}],"output":{"name":"pathresult"}}],[11,"fmt","","",23,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",6,{"inputs":[{"generics":["moduledata"],"name":"option"},{"name":"modulekind"},{"name":"defid"},{"name":"mark"},{"name":"span"}],"output":{"name":"self"}}],[11,"for_each_child","","",6,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"for_each_child_stable","","",6,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"def","","",6,{"inputs":[{"name":"self"}],"output":{"generics":["def"],"name":"option"}}],[11,"def_id","","",6,{"inputs":[{"name":"self"}],"output":{"generics":["defid"],"name":"option"}}],[11,"is_normal","","",6,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_trait","","",6,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_local","","",6,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"nearest_item_scope","","",6,{"inputs":[{"name":"self"}],"output":{"name":"moduledata"}}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"namebinding"}}],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"namebindingkind"}}],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"module","","",7,{"inputs":[{"name":"self"}],"output":{"generics":["moduledata"],"name":"option"}}],[11,"def","","",7,{"inputs":[{"name":"self"}],"output":{"name":"def"}}],[11,"def_ignoring_ambiguity","","",7,{"inputs":[{"name":"self"}],"output":{"name":"def"}}],[11,"get_macro","","",7,{"inputs":[{"name":"self"},{"name":"resolver"}],"output":{"generics":["syntaxextension"],"name":"lrc"}}],[11,"pseudo_vis","","",7,{"inputs":[{"name":"self"}],"output":{"name":"visibility"}}],[11,"is_variant","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_extern_crate","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_import","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_renamed_extern_crate","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_glob_import","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_importable","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_macro_def","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"descr","","",7,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"new","","",11,{"inputs":[],"output":{"name":"primitivetypetable"}}],[11,"intern","","",11,{"inputs":[{"name":"self"},{"name":"str"},{"name":"primty"}],"output":null}],[11,"alloc_module","","",13,{"inputs":[{"name":"self"},{"name":"moduledata"}],"output":{"name":"moduledata"}}],[11,"local_modules","","",13,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"ref"}}],[11,"alloc_name_binding","","",13,{"inputs":[{"name":"self"},{"name":"namebinding"}],"output":{"name":"namebinding"}}],[11,"alloc_import_directive","","",13,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":{"name":"importdirective"}}],[11,"alloc_name_resolution","","",13,{"inputs":[{"name":"self"}],"output":{"name":"refcell"}}],[11,"alloc_invocation_data","","",13,{"inputs":[{"name":"self"},{"name":"invocationdata"}],"output":{"name":"invocationdata"}}],[11,"alloc_legacy_binding","","",13,{"inputs":[{"name":"self"},{"name":"legacybinding"}],"output":{"name":"legacybinding"}}],[11,"resolve_hir_path","","",12,{"inputs":[{"name":"self"},{"name":"path"},{"name":"bool"}],"output":null}],[11,"resolve_str_path","","",12,null],[11,"get_resolution","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["pathresolution"],"name":"option"}}],[11,"definitions","","",12,{"inputs":[{"name":"self"}],"output":{"name":"definitions"}}],[11,"resolve_str_path_error","","Rustdoc uses this to resolve things in a recoverable way. ResolutionError<'a> isn't something that can be returned because it can't be made to live that long, and also it's a private type. Fortunately rustdoc doesn't need to know the error, just that an error occurred.",12,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"bool"}],"output":{"generics":["path"],"name":"result"}}],[11,"resolve_hir_path_cb","","resolve_hir_path, but takes a callback in case there was an error",12,{"inputs":[{"name":"self"},{"name":"path"},{"name":"bool"},{"name":"f"}],"output":null}],[11,"new","","",12,{"inputs":[{"name":"session"},{"name":"cratestore"},{"name":"crate"},{"name":"str"},{"name":"makeglobmap"},{"name":"crateloader"},{"name":"resolverarenas"}],"output":{"name":"resolver"}}],[11,"arenas","","",12,{"inputs":[],"output":{"name":"resolverarenas"}}],[11,"per_ns","","Runs the function on each namespace.",12,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"macro_def","","",12,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"defid"}}],[11,"resolve_crate","","Entry point to crate resolution.",12,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"new_module","","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"modulekind"},{"name":"defid"},{"name":"mark"},{"name":"span"}],"output":{"name":"moduledata"}}],[11,"record_use","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"},{"name":"namebinding"},{"name":"span"}],"output":{"name":"bool"}}],[11,"add_to_glob_map","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"ident"}],"output":null}],[11,"resolve_ident_in_lexical_scope","","This resolves the identifier `ident` in the namespace `ns` in the current lexical scope. More specifically, we proceed up the hierarchy of scopes and return the binding for `ident` in the first scope that defines it (or None if no scopes define it).",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"},{"name":"bool"},{"name":"span"}],"output":{"generics":["lexicalscopebinding"],"name":"option"}}],[11,"hygienic_lexical_parent","","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"span"}],"output":{"generics":["moduledata"],"name":"option"}}],[11,"resolve_ident_in_module","","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"},{"name":"bool"},{"name":"bool"},{"name":"span"}],"output":{"generics":["namebinding","determinacy"],"name":"result"}}],[11,"resolve_crate_root","","",12,{"inputs":[{"name":"self"},{"name":"syntaxcontext"},{"name":"bool"}],"output":{"name":"moduledata"}}],[11,"resolve_self","","",12,{"inputs":[{"name":"self"},{"name":"syntaxcontext"},{"name":"moduledata"}],"output":{"name":"moduledata"}}],[11,"with_scope","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[11,"search_label","","Searches the current set of local scopes for labels. Returns the first non-None label that is returned by the given predicate function",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"p"}],"output":{"name":"option"}}],[11,"resolve_item","","",12,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"resolve_use_tree","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"usetree"},{"name":"path"}],"output":null}],[11,"with_type_parameter_rib","","",12,{"inputs":[{"name":"self"},{"name":"typeparameters"},{"name":"f"}],"output":null}],[11,"with_label_rib","","",12,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"with_item_rib","","",12,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"with_constant_rib","","",12,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"with_current_self_type","","",12,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"f"}],"output":{"name":"t"}}],[11,"with_optional_trait_ref","","This is called to resolve a trait reference from an `impl` (i.e. `impl Trait for Foo`)",12,{"inputs":[{"name":"self"},{"generics":["traitref"],"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"with_self_rib","","",12,{"inputs":[{"name":"self"},{"name":"def"},{"name":"f"}],"output":null}],[11,"resolve_implementation","","",12,null],[11,"check_trait_item","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"},{"name":"span"},{"name":"f"}],"output":null}],[11,"resolve_local","","",12,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"binding_mode_map","","",12,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"generics":["ident","bindinginfo"],"name":"fxhashmap"}}],[11,"check_consistent_bindings","","",12,null],[11,"resolve_arm","","",12,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"resolve_block","","",12,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"fresh_binding","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"nodeid"},{"name":"nodeid"},{"name":"patternsource"},{"name":"fxhashmap"}],"output":{"name":"pathresolution"}}],[11,"resolve_pattern","","",12,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"patternsource"},{"name":"fxhashmap"}],"output":null}],[11,"smart_resolve_path","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"},{"generics":["qself"],"name":"option"},{"name":"path"},{"name":"pathsource"}],"output":{"name":"pathresolution"}}],[11,"smart_resolve_path_fragment","","",12,null],[11,"type_ascription_suggestion","","",12,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"span"}],"output":null}],[11,"self_type_is_available","","",12,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"self_value_is_available","","",12,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"resolve_qpath_anywhere","","",12,null],[11,"resolve_qpath","","Handles paths that may refer to associated items.",12,null],[11,"resolve_path","","",12,null],[11,"adjust_local_def","","",12,{"inputs":[{"name":"self"},{"name":"namespace"},{"name":"usize"},{"name":"def"},{"name":"bool"},{"name":"span"}],"output":{"name":"def"}}],[11,"lookup_assoc_candidate","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"},{"name":"filterfn"}],"output":{"generics":["assocsuggestion"],"name":"option"}}],[11,"lookup_typo_candidate","","",12,null],[11,"with_resolved_label","","",12,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"resolve_labeled_block","","",12,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"},{"name":"nodeid"},{"name":"block"}],"output":null}],[11,"resolve_expr","","",12,{"inputs":[{"name":"self"},{"name":"expr"},{"generics":["expr"],"name":"option"}],"output":null}],[11,"record_candidate_traits_for_expr_if_necessary","","",12,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"get_traits_containing_item","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"}],"output":{"generics":["traitcandidate"],"name":"vec"}}],[11,"get_traits_in_module_containing_item","","",12,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"namespace"},{"name":"moduledata"},{"name":"vec"}],"output":null}],[11,"lookup_import_candidates","","When name resolution fails, this method can be used to look up candidate entities with the expected name. It allows filtering them using the supplied predicate (which should be used to only accept the types of definitions expected e.g. traits). The lookup spans across all crates.",12,{"inputs":[{"name":"self"},{"name":"name"},{"name":"namespace"},{"name":"filterfn"}],"output":{"generics":["importsuggestion"],"name":"vec"}}],[11,"find_module","","",12,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"name":"option"}}],[11,"collect_enum_variants","","",12,{"inputs":[{"name":"self"},{"name":"def"}],"output":{"generics":["vec"],"name":"option"}}],[11,"record_def","","",12,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"pathresolution"}],"output":null}],[11,"resolve_visibility","","",12,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"is_accessible","","",12,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"is_accessible_from","","",12,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"moduledata"}],"output":{"name":"bool"}}],[11,"report_errors","","",12,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"report_with_use_injections","","",12,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"report_shadowing_errors","","",12,{"inputs":[{"name":"self"}],"output":null}],[11,"report_conflict","","",12,{"inputs":[{"name":"self"},{"name":"moduledata"},{"name":"ident"},{"name":"namespace"},{"name":"namebinding"},{"name":"namebinding"}],"output":null}],[11,"warn_legacy_self_import","","",12,{"inputs":[{"name":"self"},{"name":"importdirective"}],"output":null}],[11,"check_proc_macro_attrs","","",12,null],[11,"eq","","",26,{"inputs":[{"name":"self"},{"name":"makeglobmap"}],"output":{"name":"bool"}}],[11,"clone","","",26,{"inputs":[{"name":"self"}],"output":{"name":"makeglobmap"}}]],"paths":[[3,"ImportSuggestion"],[3,"BindingError"],[3,"BindingInfo"],[3,"PerNS"],[3,"UsePlacementFinder"],[3,"Rib"],[3,"ModuleData"],[3,"NameBinding"],[3,"PrivacyError"],[3,"UseError"],[3,"AmbiguityError"],[3,"PrimitiveTypeTable"],[3,"Resolver"],[3,"ResolverArenas"],[4,"AssocSuggestion"],[4,"ResolutionError"],[4,"PatternSource"],[4,"AliasPossibility"],[4,"PathSource"],[4,"Namespace"],[4,"TypeParameters"],[4,"RibKind"],[4,"LexicalScopeBinding"],[4,"PathResult"],[4,"ModuleKind"],[4,"NameBindingKind"],[4,"MakeGlobMap"],[3,"InvocationData"],[3,"LegacyBinding"],[3,"ProcMacError"],[4,"LegacyScope"],[4,"MacroBinding"],[3,"UnusedImportCheckVisitor"],[3,"LegacyMacroImports"],[3,"BuildReducedGraphVisitor"],[3,"ImportDirective"],[3,"NameResolution"],[3,"ImportResolver"],[4,"ImportDirectiveSubclass"],[4,"SingleImports"],[8,"ToNameBinding"]]};
searchIndex["rustc_save_analysis"] = {"doc":"","items":[[3,"SaveContext","rustc_save_analysis","",null,null],[12,"tcx","","",0,null],[12,"tables","","",0,null],[12,"analysis","","",0,null],[12,"span_utils","","",0,null],[12,"config","","",0,null],[12,"impl_counter","","",0,null],[3,"PathCollector","","",null,null],[12,"collected_paths","","",1,null],[12,"collected_idents","","",1,null],[3,"DumpHandler","","Dump the save-analysis results to a file.",null,null],[12,"odir","","",2,null],[12,"cratename","","",2,null],[3,"CallbackHandler","","Call a callback with the results of save-analysis.",null,null],[12,"callback","","",3,null],[4,"Data","","",null,null],[13,"RefData","","",4,null],[13,"DefData","","",4,null],[13,"RelationData","","",4,null],[5,"make_signature","","",null,{"inputs":[{"name":"fndecl"},{"name":"generics"}],"output":{"name":"string"}}],[5,"process_crate","","",null,{"inputs":[{"name":"tyctxt"},{"name":"crate"},{"name":"crateanalysis"},{"name":"str"},{"generics":["config"],"name":"option"},{"name":"h"}],"output":null}],[5,"find_config","","",null,{"inputs":[{"generics":["config"],"name":"option"}],"output":{"name":"config"}}],[5,"escape","","",null,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[5,"generated_code","","",null,{"inputs":[{"name":"span"}],"output":{"name":"bool"}}],[5,"id_from_def_id","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"id"}}],[5,"id_from_node_id","","",null,{"inputs":[{"name":"nodeid"},{"name":"savecontext"}],"output":{"name":"id"}}],[5,"null_id","","",null,{"inputs":[],"output":{"name":"id"}}],[5,"lower_attributes","","",null,{"inputs":[{"generics":["attribute"],"name":"vec"},{"name":"savecontext"}],"output":{"generics":["attribute"],"name":"vec"}}],[0,"json_dumper","","",null,null],[3,"Access","rustc_save_analysis::json_dumper","",null,null],[12,"reachable","","",5,null],[12,"public","","",5,null],[3,"JsonDumper","","",null,null],[12,"result","","",6,null],[12,"config","","",6,null],[12,"output","","",6,null],[3,"WriteOutput","","",null,null],[12,"output","","",7,null],[3,"CallbackOutput","","",null,null],[12,"callback","","",8,null],[8,"DumpOutput","","",null,null],[10,"dump","","",9,{"inputs":[{"name":"self"},{"name":"analysis"}],"output":null}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"dump","","",7,{"inputs":[{"name":"self"},{"name":"analysis"}],"output":null}],[11,"dump","","",8,{"inputs":[{"name":"self"},{"name":"analysis"}],"output":null}],[11,"new","","",6,{"inputs":[{"name":"w"},{"name":"config"}],"output":{"generics":["writeoutput"],"name":"jsondumper"}}],[11,"with_callback","","",6,{"inputs":[{"name":"fnmut"},{"name":"config"}],"output":{"generics":["callbackoutput"],"name":"jsondumper"}}],[11,"drop","","",6,{"inputs":[{"name":"self"}],"output":null}],[11,"crate_prelude","","",6,{"inputs":[{"name":"self"},{"name":"cratepreludedata"}],"output":null}],[11,"macro_use","","",6,{"inputs":[{"name":"self"},{"name":"macroref"}],"output":null}],[11,"import","","",6,{"inputs":[{"name":"self"},{"name":"access"},{"name":"import"}],"output":null}],[11,"dump_ref","","",6,{"inputs":[{"name":"self"},{"name":"ref"}],"output":null}],[11,"dump_def","","",6,{"inputs":[{"name":"self"},{"name":"access"},{"name":"def"}],"output":null}],[11,"dump_relation","","",6,{"inputs":[{"name":"self"},{"name":"relation"}],"output":null}],[11,"dump_impl","","",6,{"inputs":[{"name":"self"},{"name":"impl"}],"output":null}],[0,"dump_visitor","rustc_save_analysis","Write the output of rustc's analysis to an implementor of Dump.",null,null],[3,"DumpVisitor","rustc_save_analysis::dump_visitor","",null,null],[12,"save_ctxt","","",10,null],[12,"tcx","","",10,null],[12,"dumper","","",10,null],[12,"span","","",10,null],[12,"cur_scope","","",10,null],[12,"macro_calls","","",10,null],[11,"new","","",10,{"inputs":[{"name":"savecontext"},{"name":"jsondumper"}],"output":{"name":"dumpvisitor"}}],[11,"nest_scope","","",10,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"nest_tables","","",10,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"f"}],"output":null}],[11,"span_from_span","","",10,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"spandata"}}],[11,"dump_crate_info","","",10,{"inputs":[{"name":"self"},{"name":"str"},{"name":"crate"}],"output":null}],[11,"process_path_prefixes","","",10,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"vec"}}],[11,"write_sub_paths","","",10,{"inputs":[{"name":"self"},{"name":"path"}],"output":null}],[11,"write_sub_paths_truncated","","",10,{"inputs":[{"name":"self"},{"name":"path"}],"output":null}],[11,"write_sub_path_trait_truncated","","",10,{"inputs":[{"name":"self"},{"name":"path"}],"output":null}],[11,"lookup_def_id","","",10,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"process_def_kind","","",10,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"generics":["span"],"name":"option"},{"name":"defid"}],"output":null}],[11,"process_formals","","",10,null],[11,"process_method","","",10,{"inputs":[{"name":"self"},{"name":"methodsig"},{"generics":["block"],"name":"option"},{"name":"nodeid"},{"name":"ident"},{"name":"generics"},{"name":"visibility"},{"name":"span"}],"output":null}],[11,"process_struct_field_def","","",10,{"inputs":[{"name":"self"},{"name":"structfield"},{"name":"nodeid"}],"output":null}],[11,"process_generic_params","","",10,{"inputs":[{"name":"self"},{"name":"generics"},{"name":"span"},{"name":"str"},{"name":"nodeid"}],"output":null}],[11,"process_fn","","",10,{"inputs":[{"name":"self"},{"name":"item"},{"name":"fndecl"},{"name":"generics"},{"name":"block"}],"output":null}],[11,"process_static_or_const_item","","",10,{"inputs":[{"name":"self"},{"name":"item"},{"name":"ty"},{"name":"expr"}],"output":null}],[11,"process_assoc_const","","",10,null],[11,"process_struct","","",10,{"inputs":[{"name":"self"},{"name":"item"},{"name":"variantdata"},{"name":"generics"}],"output":null}],[11,"process_enum","","",10,{"inputs":[{"name":"self"},{"name":"item"},{"name":"enumdef"},{"name":"generics"}],"output":null}],[11,"process_impl","","",10,null],[11,"process_trait","","",10,null],[11,"process_mod","","",10,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"dump_path_ref","","",10,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"path"}],"output":null}],[11,"process_path","","",10,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"path"}],"output":null}],[11,"process_struct_lit","","",10,null],[11,"process_method_call","","",10,null],[11,"process_pat","","",10,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"process_var_decl_multi","","",10,null],[11,"process_var_decl","","",10,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"string"}],"output":null}],[11,"process_macro_use","","Extract macro use and definition information from the AST node defined by the given NodeId, using the expansion information from the node's span.",10,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"process_trait_item","","",10,{"inputs":[{"name":"self"},{"name":"traititem"},{"name":"defid"}],"output":null}],[11,"process_impl_item","","",10,{"inputs":[{"name":"self"},{"name":"implitem"},{"name":"defid"}],"output":null}],[11,"process_use_tree","","Dumps imports in a use tree recursively.",10,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"item"},{"name":"path"}],"output":null}],[11,"visit_mod","","",10,null],[11,"visit_item","","",10,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_generics","","",10,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_ty","","",10,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_expr","","",10,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_mac","","",10,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[11,"visit_pat","","",10,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_arm","","",10,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_path","","",10,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_stmt","","",10,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_local","","",10,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_foreign_item","","",10,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[0,"span_utils","rustc_save_analysis","",null,null],[3,"SpanUtils","rustc_save_analysis::span_utils","",null,null],[12,"sess","","",11,null],[12,"err_count","","",11,null],[11,"clone","","",11,{"inputs":[{"name":"self"}],"output":{"name":"spanutils"}}],[11,"new","","",11,{"inputs":[{"name":"session"}],"output":{"name":"spanutils"}}],[11,"make_path_string","","",11,{"inputs":[{"name":"filename"}],"output":{"name":"string"}}],[11,"snippet","","",11,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"string"}}],[11,"retokenise_span","","",11,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"stringreader"}}],[11,"span_for_last_ident","","",11,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"span_for_first_ident","","",11,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"sub_span_for_type_name","","",11,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"sub_span_before_token","","",11,{"inputs":[{"name":"self"},{"name":"span"},{"name":"token"}],"output":{"generics":["span"],"name":"option"}}],[11,"sub_span_of_token","","",11,{"inputs":[{"name":"self"},{"name":"span"},{"name":"token"}],"output":{"generics":["span"],"name":"option"}}],[11,"sub_span_after_keyword","","",11,{"inputs":[{"name":"self"},{"name":"span"},{"name":"keyword"}],"output":{"generics":["span"],"name":"option"}}],[11,"sub_span_after","","",11,{"inputs":[{"name":"self"},{"name":"span"},{"name":"f"}],"output":{"generics":["span"],"name":"option"}}],[11,"filter_generated","","Return true if the span is generated code, and it is not a subspan of the root callsite.",11,{"inputs":[{"name":"self"},{"generics":["span"],"name":"option"},{"name":"span"}],"output":{"name":"bool"}}],[0,"sig","rustc_save_analysis","",null,null],[5,"item_signature","rustc_save_analysis::sig","",null,{"inputs":[{"name":"item"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"foreign_item_signature","","",null,{"inputs":[{"name":"foreignitem"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"field_signature","","Signature for a struct or tuple field declaration. Does not include a trailing comma.",null,{"inputs":[{"name":"structfield"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"variant_signature","","Does not include a trailing comma.",null,{"inputs":[{"name":"variant"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"method_signature","","",null,{"inputs":[{"name":"nodeid"},{"name":"ident"},{"name":"generics"},{"name":"methodsig"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"assoc_const_signature","","",null,{"inputs":[{"name":"nodeid"},{"name":"name"},{"name":"ty"},{"generics":["expr"],"name":"option"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"assoc_type_signature","","",null,{"inputs":[{"name":"nodeid"},{"name":"ident"},{"generics":["typarambounds"],"name":"option"},{"generics":["ty"],"name":"option"},{"name":"savecontext"}],"output":{"generics":["signature"],"name":"option"}}],[5,"extend_sig","","",null,{"inputs":[{"name":"signature"},{"name":"string"},{"generics":["sigelement"],"name":"vec"},{"generics":["sigelement"],"name":"vec"}],"output":{"name":"signature"}}],[5,"replace_text","","",null,{"inputs":[{"name":"signature"},{"name":"string"}],"output":{"name":"signature"}}],[5,"merge_sigs","","",null,{"inputs":[{"name":"string"},{"generics":["signature"],"name":"vec"}],"output":{"name":"signature"}}],[5,"text_sig","","",null,{"inputs":[{"name":"string"}],"output":{"name":"signature"}}],[5,"name_and_generics","","",null,{"inputs":[{"name":"string"},{"name":"usize"},{"name":"generics"},{"name":"nodeid"},{"name":"ident"},{"name":"savecontext"}],"output":{"generics":["signature","str"],"name":"result"}}],[5,"make_assoc_type_signature","","",null,{"inputs":[{"name":"nodeid"},{"name":"ident"},{"generics":["typarambounds"],"name":"option"},{"generics":["ty"],"name":"option"},{"name":"savecontext"}],"output":{"generics":["signature","str"],"name":"result"}}],[5,"make_assoc_const_signature","","",null,{"inputs":[{"name":"nodeid"},{"name":"name"},{"name":"ty"},{"generics":["expr"],"name":"option"},{"name":"savecontext"}],"output":{"generics":["signature","str"],"name":"result"}}],[5,"make_method_signature","","",null,{"inputs":[{"name":"nodeid"},{"name":"ident"},{"name":"generics"},{"name":"methodsig"},{"name":"savecontext"}],"output":{"generics":["signature","str"],"name":"result"}}],[6,"Result","","",null,null],[8,"Sig","","",null,null],[10,"make","","",12,{"inputs":[{"name":"self"},{"name":"usize"},{"generics":["nodeid"],"name":"option"},{"name":"savecontext"}],"output":{"generics":["signature","str"],"name":"result"}}],[8,"SaveHandler","rustc_save_analysis","Defines what to do with the results of saving the analysis.",null,null],[10,"save","","",13,{"inputs":[{"name":"self"},{"name":"savecontext"},{"name":"crate"},{"name":"str"}],"output":null}],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span_from_span","","",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"spandata"}}],[11,"get_external_crates","","",0,{"inputs":[{"name":"self"}],"output":{"generics":["externalcratedata"],"name":"vec"}}],[11,"get_extern_item_data","","",0,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"generics":["data"],"name":"option"}}],[11,"get_item_data","","",0,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"generics":["data"],"name":"option"}}],[11,"get_field_data","","",0,{"inputs":[{"name":"self"},{"name":"structfield"},{"name":"nodeid"}],"output":{"generics":["def"],"name":"option"}}],[11,"get_method_data","","",0,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"name"},{"name":"span"}],"output":{"generics":["def"],"name":"option"}}],[11,"get_trait_ref_data","","",0,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"generics":["ref"],"name":"option"}}],[11,"get_expr_data","","",0,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["data"],"name":"option"}}],[11,"get_path_def","","",0,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"hirdef"}}],[11,"get_path_data","","",0,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"path"}],"output":{"generics":["ref"],"name":"option"}}],[11,"get_field_ref_data","","",0,{"inputs":[{"name":"self"},{"name":"field"},{"name":"variantdef"}],"output":{"generics":["ref"],"name":"option"}}],[11,"get_macro_use_data","","Attempt to return MacroRef for any AST node.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["macroref"],"name":"option"}}],[11,"lookup_ref_id","","",0,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["defid"],"name":"option"}}],[11,"docs_for_attrs","","",0,null],[11,"next_impl_id","","",0,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"new","","",1,{"inputs":[],"output":{"name":"pathcollector"}}],[11,"visit_pat","","",1,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"new","","",2,{"inputs":[{"generics":["path"],"name":"option"},{"name":"str"}],"output":{"name":"dumphandler"}}],[11,"output_file","","",2,{"inputs":[{"name":"self"},{"name":"savecontext"}],"output":{"name":"file"}}],[11,"save","","",2,{"inputs":[{"name":"self"},{"name":"savecontext"},{"name":"crate"},{"name":"str"}],"output":null}],[11,"save","","",3,{"inputs":[{"name":"self"},{"name":"savecontext"},{"name":"crate"},{"name":"str"}],"output":null}]],"paths":[[3,"SaveContext"],[3,"PathCollector"],[3,"DumpHandler"],[3,"CallbackHandler"],[4,"Data"],[3,"Access"],[3,"JsonDumper"],[3,"WriteOutput"],[3,"CallbackOutput"],[8,"DumpOutput"],[3,"DumpVisitor"],[3,"SpanUtils"],[8,"Sig"],[8,"SaveHandler"]]};
searchIndex["rustc_target"] = {"doc":"Some stuff used by rustc that doesn't have many dependencies","items":[[0,"abi","rustc_target","",null,null],[3,"TargetDataLayout","rustc_target::abi","Parsed Data layout for a target, which contains everything needed to compute layouts.",null,null],[12,"endian","","",0,null],[12,"i1_align","","",0,null],[12,"i8_align","","",0,null],[12,"i16_align","","",0,null],[12,"i32_align","","",0,null],[12,"i64_align","","",0,null],[12,"i128_align","","",0,null],[12,"f32_align","","",0,null],[12,"f64_align","","",0,null],[12,"pointer_size","","",0,null],[12,"pointer_align","","",0,null],[12,"aggregate_align","","",0,null],[12,"vector_align","","Alignments for vector types.",0,null],[3,"Size","","Size of a type in bytes.",null,null],[12,"raw","","",1,null],[3,"Align","","Alignment of a type in bytes, both ABI-mandated and preferred. Each field is a power of two, giving the alignment a maximum value of 2(28 - 1), which is limited by LLVM to a maximum capacity of 229 or 536870912.",null,null],[12,"abi_pow2","","",2,null],[12,"pref_pow2","","",2,null],[3,"Scalar","","Information about one scalar component of a Rust type.",null,null],[12,"value","","",3,null],[12,"valid_range","","Inclusive wrap-around range of valid values, that is, if min > max, it represents min..=u128::MAX followed by 0..=max.",3,null],[3,"LayoutDetails","","",null,null],[12,"variants","","",4,null],[12,"fields","","",4,null],[12,"abi","","",4,null],[12,"align","","",4,null],[12,"size","","",4,null],[3,"TyLayout","","The details of the layout of a type, alongside the type itself. Provides various type traversal APIs (e.g. recursing into fields).",null,null],[12,"ty","","",5,null],[12,"details","","",5,null],[4,"Endian","","Endianness of the target, which must match cfg(target-endian).",null,null],[13,"Little","","",6,null],[13,"Big","","",6,null],[4,"Integer","","Integers, also used for enum discriminants.",null,null],[13,"I8","","",7,null],[13,"I16","","",7,null],[13,"I32","","",7,null],[13,"I64","","",7,null],[13,"I128","","",7,null],[4,"Primitive","","Fundamental unit of memory access and layout.",null,null],[13,"Int","","The `bool` is the signedness of the `Integer` type.",8,null],[13,"F32","","",8,null],[13,"F64","","",8,null],[13,"Pointer","","",8,null],[4,"FieldPlacement","","Describes how the fields of a type are located in memory.",null,null],[13,"Union","","All fields start at no offset. The `usize` is the field count.",9,null],[13,"Array","","Array/vector-like placement, with all fields of identical types.",9,null],[12,"stride","rustc_target::abi::FieldPlacement","",9,null],[12,"count","","",9,null],[13,"Arbitrary","rustc_target::abi","Struct-like placement, with precomputed offsets.",9,null],[12,"offsets","rustc_target::abi::FieldPlacement","Offsets for the first byte of each field, ordered to match the source definition order. This vector does not go in increasing order.",9,null],[12,"memory_index","","Maps source order field indices to memory order indices, depending how fields were permuted.",9,null],[4,"Abi","rustc_target::abi","Describes how values of the type are passed by target ABIs, in terms of categories of C types there are ABI rules for.",null,null],[13,"Uninhabited","","",10,null],[13,"Scalar","","",10,null],[13,"ScalarPair","","",10,null],[13,"Vector","","",10,null],[12,"element","rustc_target::abi::Abi","",10,null],[12,"count","","",10,null],[13,"Aggregate","rustc_target::abi","",10,null],[12,"sized","rustc_target::abi::Abi","If true, the size is exact, otherwise it's only a lower bound.",10,null],[4,"Variants","rustc_target::abi","",null,null],[13,"Single","","Single enum variants, structs/tuples, unions, and all non-ADTs.",11,null],[12,"index","rustc_target::abi::Variants","",11,null],[13,"Tagged","rustc_target::abi","General-case enums: for each case there is a struct, and they all have all space reserved for the tag, and their first field starts at a non-0 offset, after where the tag would go.",11,null],[12,"tag","rustc_target::abi::Variants","",11,null],[12,"variants","","",11,null],[13,"NicheFilling","rustc_target::abi","Multiple cases distinguished by a niche (values invalid for a type): the variant `dataful_variant` contains a niche at an arbitrary offset (field 0 of the enum), which for a variant with discriminant `d` is set to `(d - niche_variants.start).wrapping_add(niche_start)`.",11,null],[12,"dataful_variant","rustc_target::abi::Variants","",11,null],[12,"niche_variants","","",11,null],[12,"niche","","",11,null],[12,"niche_start","","",11,null],[12,"variants","","",11,null],[0,"call","rustc_target::abi","",null,null],[3,"ArgAttribute","rustc_target::abi::call","",null,null],[12,"bits","","",12,null],[3,"ArgAttributes","","A compact representation of LLVM attributes (at least those relevant for this module) that can be manipulated without interacting with LLVM's Attribute machinery.",null,null],[12,"regular","","",13,null],[12,"pointee_size","","",13,null],[12,"pointee_align","","",13,null],[3,"Reg","","",null,null],[12,"kind","","",14,null],[12,"size","","",14,null],[3,"Uniform","","An argument passed entirely registers with the same kind (e.g. HFA / HVA on PPC64 and AArch64).",null,null],[12,"unit","","",15,null],[12,"total","","The total size of the argument, which can be: * equal to `unit.size` (one scalar/vector) * a multiple of `unit.size` (an array of scalar/vectors) * if `unit.kind` is `Integer`, the last element   can be shorter, i.e. `{ i64, i64, i32 }` for   64-bit integers with a total size of 20 bytes",15,null],[3,"CastTarget","","",null,null],[12,"prefix","","",16,null],[12,"prefix_chunk","","",16,null],[12,"rest","","",16,null],[3,"ArgType","","Information about how to pass an argument to, or return a value from, a function, under some ABI.",null,null],[12,"layout","","",17,null],[12,"pad","","Dummy argument, which is emitted before the real argument.",17,null],[12,"mode","","",17,null],[3,"FnType","","Metadata describing how the arguments to a native function should be passed in order to respect the native ABI.",null,null],[12,"args","","The LLVM types of each argument.",18,null],[12,"ret","","LLVM return type.",18,null],[12,"variadic","","",18,null],[12,"conv","","",18,null],[4,"PassMode","","",null,null],[13,"Ignore","","Ignore the argument (useful for empty struct).",19,null],[13,"Direct","","Pass the argument directly.",19,null],[13,"Pair","","Pass a pair's elements directly in two arguments.",19,null],[13,"Cast","","Pass the argument after casting it, to either a single uniform or a pair of registers.",19,null],[13,"Indirect","","Pass the argument indirectly via a hidden pointer.",19,null],[4,"RegKind","","",null,null],[13,"Integer","","",20,null],[13,"Float","","",20,null],[13,"Vector","","",20,null],[4,"Conv","","",null,null],[13,"C","","",21,null],[13,"ArmAapcs","","",21,null],[13,"Msp430Intr","","",21,null],[13,"PtxKernel","","",21,null],[13,"X86Fastcall","","",21,null],[13,"X86Intr","","",21,null],[13,"X86Stdcall","","",21,null],[13,"X86ThisCall","","",21,null],[13,"X86VectorCall","","",21,null],[13,"X86_64SysV","","",21,null],[13,"X86_64Win64","","",21,null],[0,"aarch64","","",null,null],[5,"is_homogeneous_aggregate","rustc_target::abi::call::aarch64","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":{"generics":["uniform"],"name":"option"}}],[5,"classify_ret_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"arm","rustc_target::abi::call","",null,null],[5,"is_homogeneous_aggregate","rustc_target::abi::call::arm","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":{"generics":["uniform"],"name":"option"}}],[5,"classify_ret_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"bool"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"bool"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"asmjs","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::asmjs","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"hexagon","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::hexagon","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"fntype"}],"output":null}],[0,"mips","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::mips","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"size"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"size"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"mips64","rustc_target::abi::call","",null,null],[5,"extend_integer_width_mips","rustc_target::abi::call::mips64","",null,{"inputs":[{"name":"argtype"},{"name":"u64"}],"output":null}],[5,"float_reg","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"usize"}],"output":{"generics":["reg"],"name":"option"}}],[5,"classify_ret_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"msp430","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::msp430","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"fntype"}],"output":null}],[0,"nvptx","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::nvptx","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"fntype"}],"output":null}],[0,"nvptx64","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::nvptx64","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"fntype"}],"output":null}],[0,"powerpc","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::powerpc","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"size"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"size"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"powerpc64","rustc_target::abi::call","",null,null],[4,"ABI","rustc_target::abi::call::powerpc64","",null,null],[13,"ELFv1","","",22,null],[13,"ELFv2","","",22,null],[5,"is_homogeneous_aggregate","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"abi"}],"output":{"generics":["uniform"],"name":"option"}}],[5,"classify_ret_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"abi"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"abi"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[11,"fmt","","",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"self"}],"output":{"name":"abi"}}],[11,"eq","","",22,{"inputs":[{"name":"self"},{"name":"abi"}],"output":{"name":"bool"}}],[0,"s390x","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::s390x","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"is_single_fp_element","","",null,{"inputs":[{"name":"c"},{"name":"tylayout"}],"output":{"name":"bool"}}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"sparc","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::sparc","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"size"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"},{"name":"size"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"sparc64","rustc_target::abi::call","",null,null],[5,"is_homogeneous_aggregate","rustc_target::abi::call::sparc64","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":{"generics":["uniform"],"name":"option"}}],[5,"classify_ret_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[0,"x86","rustc_target::abi::call","",null,null],[4,"Flavor","rustc_target::abi::call::x86","",null,null],[13,"General","","",23,null],[13,"Fastcall","","",23,null],[5,"is_single_fp_element","","",null,{"inputs":[{"name":"c"},{"name":"tylayout"}],"output":{"name":"bool"}}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"},{"name":"flavor"}],"output":null}],[11,"eq","","",23,{"inputs":[{"name":"self"},{"name":"flavor"}],"output":{"name":"bool"}}],[0,"x86_64","rustc_target::abi::call","",null,null],[3,"Memory","rustc_target::abi::call::x86_64","",null,null],[4,"Class","","Classification of \"eightbyte\" components.",null,null],[13,"Int","","",24,null],[13,"Sse","","",24,null],[13,"SseUp","","",24,null],[5,"classify_arg","","",null,{"inputs":[{"name":"c"},{"name":"argtype"}],"output":{"generics":["memory"],"name":"result"}}],[5,"reg_component","","",null,null],[5,"cast_target","","",null,null],[5,"compute_abi_info","","",null,{"inputs":[{"name":"c"},{"name":"fntype"}],"output":null}],[17,"LARGEST_VECTOR_SIZE","","",null,null],[17,"MAX_EIGHTBYTES","","",null,null],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"class"}}],[11,"eq","","",24,{"inputs":[{"name":"self"},{"name":"class"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",24,null],[11,"partial_cmp","","",24,{"inputs":[{"name":"self"},{"name":"class"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",24,{"inputs":[{"name":"self"},{"name":"class"}],"output":{"name":"ordering"}}],[11,"fmt","","",24,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"memory"}}],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"x86_win64","rustc_target::abi::call","",null,null],[5,"compute_abi_info","rustc_target::abi::call::x86_win64","",null,{"inputs":[{"name":"fntype"}],"output":null}],[0,"wasm32","rustc_target::abi::call","",null,null],[5,"classify_ret_ty","rustc_target::abi::call::wasm32","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"classify_arg_ty","","",null,{"inputs":[{"name":"argtype"}],"output":null}],[5,"compute_abi_info","","",null,{"inputs":[{"name":"fntype"}],"output":null}],[0,"attr_impl","rustc_target::abi::call","",null,null],[3,"ArgAttribute","rustc_target::abi::call::attr_impl","",null,null],[12,"bits","","",12,null],[11,"eq","rustc_target::abi::call","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",12,null],[11,"clone","","",12,{"inputs":[{"name":"self"}],"output":{"name":"argattribute"}}],[11,"partial_cmp","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"le","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"gt","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"ge","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"cmp","","",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"ordering"}}],[11,"hash","","",12,null],[11,"default","","",12,{"inputs":[],"output":{"name":"argattribute"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"ByVal","","",12,null],[18,"NoAlias","","",12,null],[18,"NoCapture","","",12,null],[18,"NonNull","","",12,null],[18,"ReadOnly","","",12,null],[18,"SExt","","",12,null],[18,"StructRet","","",12,null],[18,"ZExt","","",12,null],[18,"InReg","","",12,null],[11,"empty","","Returns an empty set of flags.",12,{"inputs":[],"output":{"name":"argattribute"}}],[11,"all","","Returns the set containing all flags.",12,{"inputs":[],"output":{"name":"argattribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",12,{"inputs":[{"name":"self"}],"output":{"name":"u16"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",12,{"inputs":[{"name":"u16"}],"output":{"generics":["argattribute"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",12,{"inputs":[{"name":"u16"}],"output":{"name":"argattribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",12,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",12,{"inputs":[{"name":"self"},{"name":"argattribute"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"argattribute"}}],[11,"bitor_assign","","Adds the set of flags.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"argattribute"}}],[11,"bitxor_assign","","Toggles the set of flags.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"argattribute"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"argattribute"}}],[11,"sub_assign","","Disables all flags enabled in the set.",12,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",12,{"inputs":[{"name":"self"}],"output":{"name":"argattribute"}}],[11,"extend","","",12,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",12,{"inputs":[{"name":"t"}],"output":{"name":"argattribute"}}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"passmode"}}],[11,"eq","","",19,{"inputs":[{"name":"self"},{"name":"passmode"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"self"},{"name":"passmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",19,null],[11,"fmt","","",19,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"argattributes"}}],[11,"eq","","",13,{"inputs":[{"name":"self"},{"name":"argattributes"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"self"},{"name":"argattributes"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",13,null],[11,"fmt","","",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",13,{"inputs":[],"output":{"name":"self"}}],[11,"set","","",13,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"self"}}],[11,"contains","","",13,{"inputs":[{"name":"self"},{"name":"argattribute"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"self"}],"output":{"name":"regkind"}}],[11,"eq","","",20,{"inputs":[{"name":"self"},{"name":"regkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",20,null],[11,"fmt","","",20,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",14,{"inputs":[{"name":"self"}],"output":{"name":"reg"}}],[11,"eq","","",14,{"inputs":[{"name":"self"},{"name":"reg"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"self"},{"name":"reg"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",14,null],[11,"fmt","","",14,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"i8","","",14,{"inputs":[],"output":{"name":"reg"}}],[11,"i16","","",14,{"inputs":[],"output":{"name":"reg"}}],[11,"i32","","",14,{"inputs":[],"output":{"name":"reg"}}],[11,"i64","","",14,{"inputs":[],"output":{"name":"reg"}}],[11,"f32","","",14,{"inputs":[],"output":{"name":"reg"}}],[11,"f64","","",14,{"inputs":[],"output":{"name":"reg"}}],[11,"align","","",14,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"align"}}],[11,"clone","","",15,{"inputs":[{"name":"self"}],"output":{"name":"uniform"}}],[11,"eq","","",15,{"inputs":[{"name":"self"},{"name":"uniform"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"self"},{"name":"uniform"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",15,null],[11,"fmt","","",15,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",15,{"inputs":[{"name":"reg"}],"output":{"name":"uniform"}}],[11,"align","","",15,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"align"}}],[11,"clone","","",16,{"inputs":[{"name":"self"}],"output":{"name":"casttarget"}}],[11,"eq","","",16,{"inputs":[{"name":"self"},{"name":"casttarget"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"self"},{"name":"casttarget"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",16,null],[11,"fmt","","",16,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",16,{"inputs":[{"name":"reg"}],"output":{"name":"casttarget"}}],[11,"from","","",16,{"inputs":[{"name":"uniform"}],"output":{"name":"casttarget"}}],[11,"pair","","",16,{"inputs":[{"name":"reg"},{"name":"reg"}],"output":{"name":"casttarget"}}],[11,"size","","",16,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"size"}}],[11,"align","","",16,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"align"}}],[11,"is_aggregate","rustc_target::abi","",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"homogeneous_aggregate","","",5,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"generics":["reg"],"name":"option"}}],[11,"fmt","rustc_target::abi::call","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",17,{"inputs":[{"name":"tylayout"}],"output":{"name":"self"}}],[11,"make_indirect","","",17,{"inputs":[{"name":"self"}],"output":null}],[11,"make_indirect_byval","","",17,{"inputs":[{"name":"self"}],"output":null}],[11,"extend_integer_width_to","","",17,{"inputs":[{"name":"self"},{"name":"u64"}],"output":null}],[11,"cast_to","","",17,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"pad_with","","",17,{"inputs":[{"name":"self"},{"name":"reg"}],"output":null}],[11,"is_indirect","","",17,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ignore","","",17,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"conv"}}],[11,"eq","","",21,{"inputs":[{"name":"self"},{"name":"conv"}],"output":{"name":"bool"}}],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"adjust_for_cabi","","",18,{"inputs":[{"name":"self"},{"name":"c"},{"name":"abi"}],"output":{"generics":["string"],"name":"result"}}],[8,"HasDataLayout","rustc_target::abi","",null,null],[10,"data_layout","","",26,{"inputs":[{"name":"self"}],"output":{"name":"targetdatalayout"}}],[8,"LayoutOf","","",null,null],[16,"Ty","","",27,null],[16,"TyLayout","","",27,null],[10,"layout_of","","",27,null],[8,"TyLayoutMethods","","",null,null],[10,"for_variant","","",28,{"inputs":[{"name":"tylayout"},{"name":"c"},{"name":"usize"}],"output":{"name":"tylayout"}}],[10,"field","","",28,null],[11,"default","","Creates an instance of `TargetDataLayout`.",0,{"inputs":[],"output":{"name":"targetdatalayout"}}],[11,"parse","","",0,{"inputs":[{"name":"target"}],"output":{"generics":["targetdatalayout","string"],"name":"result"}}],[11,"obj_size_bound","","Return exclusive upper bound on object size.",0,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"ptr_sized_integer","","",0,{"inputs":[{"name":"self"}],"output":{"name":"integer"}}],[11,"vector_align","","",0,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"align"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"endian"}}],[11,"clone","","",1,{"inputs":[{"name":"self"}],"output":{"name":"size"}}],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",1,null],[11,"partial_cmp","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"bool"}}],[11,"le","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"bool"}}],[11,"gt","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"bool"}}],[11,"ge","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"bool"}}],[11,"cmp","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"ordering"}}],[11,"hash","","",1,null],[11,"fmt","","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_bits","","",1,{"inputs":[{"name":"u64"}],"output":{"name":"size"}}],[11,"from_bytes","","",1,{"inputs":[{"name":"u64"}],"output":{"name":"size"}}],[11,"bytes","","",1,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"bits","","",1,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"abi_align","","",1,{"inputs":[{"name":"self"},{"name":"align"}],"output":{"name":"size"}}],[11,"is_abi_aligned","","",1,{"inputs":[{"name":"self"},{"name":"align"}],"output":{"name":"bool"}}],[11,"checked_add","","",1,{"inputs":[{"name":"self"},{"name":"size"},{"name":"c"}],"output":{"generics":["size"],"name":"option"}}],[11,"checked_mul","","",1,{"inputs":[{"name":"self"},{"name":"u64"},{"name":"c"}],"output":{"generics":["size"],"name":"option"}}],[11,"add","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"size"}}],[11,"sub","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":{"name":"size"}}],[11,"mul","","",1,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"size"}}],[11,"add_assign","","",1,{"inputs":[{"name":"self"},{"name":"size"}],"output":null}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"align"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"align"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"align"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",2,null],[11,"hash","","",2,null],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",2,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",2,{"inputs":[{"name":"__d"}],"output":{"generics":["align"],"name":"result"}}],[11,"from_bits","","",2,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"generics":["align","string"],"name":"result"}}],[11,"from_bytes","","",2,{"inputs":[{"name":"u64"},{"name":"u64"}],"output":{"generics":["align","string"],"name":"result"}}],[11,"abi","","",2,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"pref","","",2,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"abi_bits","","",2,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"pref_bits","","",2,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"min","","",2,{"inputs":[{"name":"self"},{"name":"align"}],"output":{"name":"align"}}],[11,"max","","",2,{"inputs":[{"name":"self"},{"name":"align"}],"output":{"name":"align"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"integer"}}],[11,"eq","","",7,{"inputs":[{"name":"self"},{"name":"integer"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",7,null],[11,"partial_cmp","","",7,{"inputs":[{"name":"self"},{"name":"integer"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",7,{"inputs":[{"name":"self"},{"name":"integer"}],"output":{"name":"ordering"}}],[11,"hash","","",7,null],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"size","","",7,{"inputs":[{"name":"self"}],"output":{"name":"size"}}],[11,"align","","",7,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"align"}}],[11,"fit_signed","","Find the smallest Integer type which can represent the signed value.",7,{"inputs":[{"name":"i128"}],"output":{"name":"integer"}}],[11,"fit_unsigned","","Find the smallest Integer type which can represent the unsigned value.",7,{"inputs":[{"name":"u128"}],"output":{"name":"integer"}}],[11,"for_abi_align","","Find the smallest integer with the given alignment.",7,{"inputs":[{"name":"c"},{"name":"align"}],"output":{"generics":["integer"],"name":"option"}}],[11,"approximate_abi_align","","Find the largest integer with the given alignment or less.",7,{"inputs":[{"name":"c"},{"name":"align"}],"output":{"name":"integer"}}],[11,"clone","","",8,{"inputs":[{"name":"self"}],"output":{"name":"primitive"}}],[11,"eq","","",8,{"inputs":[{"name":"self"},{"name":"primitive"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"primitive"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",8,null],[11,"hash","","",8,null],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"size","","",8,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"size"}}],[11,"align","","",8,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"name":"align"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"scalar"}}],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"scalar"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"scalar"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"hash","","",3,null],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_bool","","",3,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"valid_range_exclusive","","Returns the valid range as a `x..y` range.",3,{"inputs":[{"name":"self"},{"name":"c"}],"output":{"generics":["u128"],"name":"range"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"fieldplacement"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"fieldplacement"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",9,null],[11,"hash","","",9,null],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"count","","",9,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"offset","","",9,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"size"}}],[11,"memory_index","","",9,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"index_by_increasing_offset","","Get source indices of the fields by increasing offsets.",9,null],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"abi"}}],[11,"eq","","",10,{"inputs":[{"name":"self"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"self"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",10,null],[11,"hash","","",10,null],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",10,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_signed","","Returns true if this is a single signed integer scalar",10,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"eq","","",11,{"inputs":[{"name":"self"},{"name":"variants"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"self"},{"name":"variants"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",11,null],[11,"hash","","",11,null],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"layoutdetails"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"self"},{"name":"layoutdetails"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",4,null],[11,"hash","","",4,null],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"scalar","","",4,{"inputs":[{"name":"c"},{"name":"scalar"}],"output":{"name":"self"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"tylayout"}}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"deref","","",5,{"inputs":[{"name":"self"}],"output":{"name":"layoutdetails"}}],[11,"for_variant","","",5,{"inputs":[{"name":"self"},{"name":"c"},{"name":"usize"}],"output":{"name":"self"}}],[11,"field","","",5,null],[11,"is_unsized","","Returns true if the layout corresponds to an unsized type.",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_zst","","Returns true if the type is a ZST and not unsized.",5,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"size_and_align","","",5,null],[0,"spec","rustc_target","Flexible target specification.",null,null],[3,"Target","rustc_target::spec","Everything `rustc` knows about how to compile for a specific target.",null,null],[12,"llvm_target","","Target triple to pass to LLVM.",29,null],[12,"target_endian","","String to use as the `target_endian` `cfg` variable.",29,null],[12,"target_pointer_width","","String to use as the `target_pointer_width` `cfg` variable.",29,null],[12,"target_c_int_width","","Width of c_int type",29,null],[12,"target_os","","OS name to use for conditional compilation.",29,null],[12,"target_env","","Environment name to use for conditional compilation.",29,null],[12,"target_vendor","","Vendor name to use for conditional compilation.",29,null],[12,"arch","","Architecture to use for ABI considerations. Valid options: \"x86\", \"x86_64\", \"arm\", \"aarch64\", \"mips\", \"powerpc\", and \"powerpc64\".",29,null],[12,"data_layout","","Data layout to pass to LLVM.",29,null],[12,"linker_flavor","","Linker flavor",29,null],[12,"options","","Optional settings with defaults.",29,null],[3,"TargetOptions","","Optional aspects of a target specification.",null,null],[12,"is_builtin","","Whether the target is built-in or loaded from a custom target specification.",30,null],[12,"linker","","Linker to invoke",30,null],[12,"pre_link_args","","Linker arguments that are unconditionally passed before any user-defined libraries.",30,null],[12,"pre_link_objects_exe","","Objects to link before all others, always found within the sysroot folder.",30,null],[12,"pre_link_objects_dll","","",30,null],[12,"late_link_args","","Linker arguments that are unconditionally passed after any user-defined but before post_link_objects.  Standard platform libraries that should be always be linked to, usually go here.",30,null],[12,"post_link_objects","","Objects to link after all others, always found within the sysroot folder.",30,null],[12,"post_link_args","","Linker arguments that are unconditionally passed after any user-defined libraries.",30,null],[12,"link_env","","Environment variables to be set before invoking the linker.",30,null],[12,"asm_args","","Extra arguments to pass to the external assembler (when used)",30,null],[12,"cpu","","Default CPU to pass to LLVM. Corresponds to `llc -mcpu=$cpu`. Defaults to \"generic\".",30,null],[12,"features","","Default target features to pass to LLVM. These features will always be passed, and cannot be disabled even via `-C`. Corresponds to `llc -mattr=$features`.",30,null],[12,"dynamic_linking","","Whether dynamic linking is available on this target. Defaults to false.",30,null],[12,"only_cdylib","","If dynamic linking is available, whether only cdylibs are supported.",30,null],[12,"executables","","Whether executables are available on this target. iOS, for example, only allows static libraries. Defaults to false.",30,null],[12,"relocation_model","","Relocation model to use in object file. Corresponds to `llc -relocation-model=$relocation_model`. Defaults to \"pic\".",30,null],[12,"code_model","","Code model to use. Corresponds to `llc -code-model=$code_model`.",30,null],[12,"tls_model","","TLS model to use. Options are \"global-dynamic\" (default), \"local-dynamic\", \"initial-exec\" and \"local-exec\". This is similar to the -ftls-model option in GCC/Clang.",30,null],[12,"disable_redzone","","Do not emit code that uses the \"red zone\", if the ABI has one. Defaults to false.",30,null],[12,"eliminate_frame_pointer","","Eliminate frame pointers from stack frames if possible. Defaults to true.",30,null],[12,"function_sections","","Emit each function in its own section. Defaults to true.",30,null],[12,"dll_prefix","","String to prepend to the name of every dynamic library. Defaults to \"lib\".",30,null],[12,"dll_suffix","","String to append to the name of every dynamic library. Defaults to \".so\".",30,null],[12,"exe_suffix","","String to append to the name of every executable.",30,null],[12,"staticlib_prefix","","String to prepend to the name of every static library. Defaults to \"lib\".",30,null],[12,"staticlib_suffix","","String to append to the name of every static library. Defaults to \".a\".",30,null],[12,"target_family","","OS family to use for conditional compilation. Valid options: \"unix\", \"windows\".",30,null],[12,"abi_return_struct_as_int","","Whether the target toolchain's ABI supports returning small structs as an integer.",30,null],[12,"is_like_osx","","Whether the target toolchain is like macOS's. Only useful for compiling against iOS/macOS, in particular running dsymutil and some other stuff like `-dead_strip`. Defaults to false.",30,null],[12,"is_like_solaris","","Whether the target toolchain is like Solaris's. Only useful for compiling against Illumos/Solaris, as they have a different set of linker flags. Defaults to false.",30,null],[12,"is_like_windows","","Whether the target toolchain is like Windows'. Only useful for compiling against Windows, only really used for figuring out how to find libraries, since Windows uses its own library naming convention. Defaults to false.",30,null],[12,"is_like_msvc","","",30,null],[12,"is_like_android","","Whether the target toolchain is like Android's. Only useful for compiling against Android. Defaults to false.",30,null],[12,"is_like_emscripten","","Whether the target toolchain is like Emscripten's. Only useful for compiling with Emscripten toolchain. Defaults to false.",30,null],[12,"linker_is_gnu","","Whether the linker support GNU-like arguments such as -O. Defaults to false.",30,null],[12,"allows_weak_linkage","","The MinGW toolchain has a known issue that prevents it from correctly handling COFF object files with more than 215 sections. Since each weak symbol needs its own COMDAT section, weak linkage implies a large number sections that easily exceeds the given limit for larger codebases. Consequently we want a way to disallow weak linkage on some platforms.",30,null],[12,"has_rpath","","Whether the linker support rpaths or not. Defaults to false.",30,null],[12,"no_default_libraries","","Whether to disable linking to the default libraries, typically corresponds to `-nodefaultlibs`. Defaults to true.",30,null],[12,"position_independent_executables","","Dynamically linked executables can be compiled as position independent if the default relocation model of position independent code is not changed. This is a requirement to take advantage of ASLR, as otherwise the functions in the executable are not randomized and can be used during an exploit of a vulnerability in any code.",30,null],[12,"relro_level","","Either partial, full, or off. Full RELRO makes the dynamic linker resolve all symbols at startup and marks the GOT read-only before starting the program, preventing overwriting the GOT.",30,null],[12,"archive_format","","Format that archives should be emitted in. This affects whether we use LLVM to assemble an archive or fall back to the system linker, and currently only \"gnu\" is used to fall into LLVM. Unknown strings cause the system linker to be used.",30,null],[12,"allow_asm","","Is asm!() allowed? Defaults to true.",30,null],[12,"custom_unwind_resume","","Whether the target uses a custom unwind resumption routine. By default LLVM lowers `resume` instructions into calls to `_Unwind_Resume` defined in libgcc.  If this option is enabled, the target must provide `eh_unwind_resume` lang item.",30,null],[12,"exe_allocation_crate","","If necessary, a different crate to link exe allocators by default",30,null],[12,"has_elf_tls","","Flag indicating whether ELF TLS (e.g. #[thread_local]) is available for this target.",30,null],[12,"obj_is_bitcode","","",30,null],[12,"no_integrated_as","","",30,null],[12,"min_atomic_width","","Don't use this field; instead use the `.min_atomic_width()` method.",30,null],[12,"max_atomic_width","","Don't use this field; instead use the `.max_atomic_width()` method.",30,null],[12,"panic_strategy","","Panic strategy: \"unwind\" or \"abort\"",30,null],[12,"abi_blacklist","","A blacklist of ABIs unsupported by the current target. Note that generic ABIs are considered to be supported on all platforms and cannot be blacklisted.",30,null],[12,"crt_static_allows_dylibs","","Whether or not linking dylibs to a static CRT is allowed.",30,null],[12,"crt_static_default","","Whether or not the CRT is statically linked by default.",30,null],[12,"crt_static_respected","","Whether or not crt-static is respected by the compiler (or is a no-op).",30,null],[12,"stack_probes","","Whether or not stack probes (__rust_probestack) are enabled",30,null],[12,"min_global_align","","The minimum alignment for global symbols.",30,null],[12,"default_codegen_units","","Default number of codegen units to use in debug mode",30,null],[12,"trap_unreachable","","Whether to generate trap instructions in places where optimization would otherwise produce control flow that falls through into unrelated memory.",30,null],[12,"requires_lto","","This target requires everything to be compiled with LTO to emit a final executable, aka there is no native linker for this target.",30,null],[12,"singlethread","","This target has no support for threads.",30,null],[12,"no_builtins","","Whether library functions call lowering/optimization is disabled in LLVM for this target unconditionally.",30,null],[12,"i128_lowering","","Whether to lower 128-bit operations to compiler_builtins calls.  Use if your backend only supports 64-bit and smaller math.",30,null],[12,"codegen_backend","","The codegen backend to use for this target, typically \"llvm\"",30,null],[12,"default_hidden_visibility","","The default visibility for symbols in this target should be \"hidden\" rather than \"default\"",30,null],[12,"embed_bitcode","","Whether or not bitcode is embedded in object files",30,null],[12,"emit_debug_gdb_scripts","","Whether a .debug_gdb_scripts section will be added to the output object file",30,null],[12,"requires_uwtable","","Whether or not to unconditionally `uwtable` attributes on functions, typically because the platform needs to unwind for things like stack unwinders.",30,null],[4,"LinkerFlavor","","",null,null],[13,"Em","","",31,null],[13,"Gcc","","",31,null],[13,"Ld","","",31,null],[13,"Msvc","","",31,null],[13,"Lld","","",31,null],[4,"LldFlavor","","",null,null],[13,"Wasm","","",32,null],[13,"Ld64","","",32,null],[13,"Ld","","",32,null],[13,"Link","","",32,null],[4,"PanicStrategy","","",null,null],[13,"Unwind","","",33,null],[13,"Abort","","",33,null],[4,"RelroLevel","","",null,null],[13,"Full","","",34,null],[13,"Partial","","",34,null],[13,"Off","","",34,null],[13,"None","","",34,null],[4,"TargetTriple","","Either a target triple string or a path to a JSON file.",null,null],[13,"TargetTriple","","",35,null],[13,"TargetPath","","",35,null],[5,"load_specific","","",null,{"inputs":[{"name":"str"}],"output":{"name":"targetresult"}}],[5,"get_targets","","",null,{"inputs":[],"output":{"generics":["iterator"],"name":"box"}}],[5,"maybe_jemalloc","","",null,{"inputs":[],"output":{"generics":["string"],"name":"option"}}],[0,"abi","","",null,null],[3,"AbiData","rustc_target::spec::abi","",null,null],[12,"abi","","",36,null],[12,"name","","Name of this ABI as we like it called.",36,null],[12,"generic","","A generic ABI is supported on all platforms.",36,null],[4,"Abi","","",null,null],[13,"Cdecl","","",37,null],[13,"Stdcall","","",37,null],[13,"Fastcall","","",37,null],[13,"Vectorcall","","",37,null],[13,"Thiscall","","",37,null],[13,"Aapcs","","",37,null],[13,"Win64","","",37,null],[13,"SysV64","","",37,null],[13,"PtxKernel","","",37,null],[13,"Msp430Interrupt","","",37,null],[13,"X86Interrupt","","",37,null],[13,"Rust","","",37,null],[13,"C","","",37,null],[13,"System","","",37,null],[13,"RustIntrinsic","","",37,null],[13,"RustCall","","",37,null],[13,"PlatformIntrinsic","","",37,null],[13,"Unadjusted","","",37,null],[5,"lookup","","Returns the ABI with the given name (if any).",null,{"inputs":[{"name":"str"}],"output":{"generics":["abi"],"name":"option"}}],[5,"all_names","","",null,{"inputs":[],"output":{"generics":["str"],"name":"vec"}}],[17,"AbiDatas","","",null,null],[11,"eq","","",37,{"inputs":[{"name":"self"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",37,null],[11,"hash","","",37,null],[11,"encode","","",37,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",37,{"inputs":[{"name":"__d"}],"output":{"generics":["abi"],"name":"result"}}],[11,"clone","","",37,{"inputs":[{"name":"self"}],"output":{"name":"abi"}}],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",36,{"inputs":[{"name":"self"}],"output":{"name":"abidata"}}],[11,"index","","",37,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"data","","",37,{"inputs":[{"name":"self"}],"output":{"name":"abidata"}}],[11,"name","","",37,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"generic","","",37,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"android_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::android_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"apple_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::apple_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"apple_ios_base","rustc_target::spec","",null,null],[4,"Arch","rustc_target::spec::apple_ios_base","",null,null],[13,"Armv7","","",38,null],[13,"Armv7s","","",38,null],[13,"Arm64","","",38,null],[13,"I386","","",38,null],[13,"X86_64","","",38,null],[5,"get_sdk_root","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["string","string"],"name":"result"}}],[5,"build_pre_link_args","","",null,{"inputs":[{"name":"arch"}],"output":{"generics":["linkargs","string"],"name":"result"}}],[5,"target_cpu","","",null,{"inputs":[{"name":"arch"}],"output":{"name":"string"}}],[5,"opts","","",null,{"inputs":[{"name":"arch"}],"output":{"generics":["targetoptions","string"],"name":"result"}}],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"arch"}}],[11,"to_string","","",38,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[0,"arm_base","rustc_target::spec","",null,null],[5,"abi_blacklist","rustc_target::spec::arm_base","",null,{"inputs":[],"output":{"generics":["abi"],"name":"vec"}}],[0,"bitrig_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::bitrig_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"cloudabi_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::cloudabi_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"dragonfly_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::dragonfly_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"freebsd_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::freebsd_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"haiku_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::haiku_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"linux_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::linux_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"linux_musl_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::linux_musl_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"openbsd_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::openbsd_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"netbsd_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::netbsd_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"solaris_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::solaris_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"windows_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::windows_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"windows_msvc_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::windows_msvc_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"thumb_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::thumb_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"l4re_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::l4re_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"fuchsia_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::fuchsia_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"redox_base","rustc_target::spec","",null,null],[5,"opts","rustc_target::spec::redox_base","",null,{"inputs":[],"output":{"name":"targetoptions"}}],[0,"x86_64_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_linux_gnux32","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_linux_gnux32","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i586_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i586_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mips_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mips_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mips64_unknown_linux_gnuabi64","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mips64_unknown_linux_gnuabi64","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mips64el_unknown_linux_gnuabi64","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mips64el_unknown_linux_gnuabi64","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mipsel_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mipsel_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"powerpc_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::powerpc_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"powerpc_unknown_linux_gnuspe","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::powerpc_unknown_linux_gnuspe","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"powerpc64_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::powerpc64_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"powerpc64le_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::powerpc64le_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"s390x_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::s390x_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"sparc_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::sparc_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"sparc64_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::sparc64_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"arm_unknown_linux_gnueabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::arm_unknown_linux_gnueabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"arm_unknown_linux_gnueabihf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::arm_unknown_linux_gnueabihf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"arm_unknown_linux_musleabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::arm_unknown_linux_musleabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"arm_unknown_linux_musleabihf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::arm_unknown_linux_musleabihf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv4t_unknown_linux_gnueabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv4t_unknown_linux_gnueabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv5te_unknown_linux_gnueabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv5te_unknown_linux_gnueabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv5te_unknown_linux_musleabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv5te_unknown_linux_musleabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv7_unknown_linux_gnueabihf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv7_unknown_linux_gnueabihf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv7_unknown_linux_musleabihf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv7_unknown_linux_musleabihf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_unknown_linux_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_unknown_linux_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_unknown_linux_musl","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_unknown_linux_musl","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_linux_musl","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_linux_musl","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_linux_musl","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_linux_musl","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i586_unknown_linux_musl","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i586_unknown_linux_musl","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mips_unknown_linux_musl","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mips_unknown_linux_musl","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mipsel_unknown_linux_musl","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mipsel_unknown_linux_musl","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mips_unknown_linux_uclibc","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mips_unknown_linux_uclibc","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"mipsel_unknown_linux_uclibc","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::mipsel_unknown_linux_uclibc","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_linux_android","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_linux_android","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_linux_android","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_linux_android","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"arm_linux_androideabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::arm_linux_androideabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv7_linux_androideabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv7_linux_androideabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_linux_android","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_linux_android","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_unknown_freebsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_unknown_freebsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_freebsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_freebsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_freebsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_freebsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_dragonfly","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_dragonfly","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_dragonfly","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_dragonfly","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_bitrig","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_bitrig","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_openbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_openbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_openbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_openbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_netbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_netbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"powerpc_unknown_netbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::powerpc_unknown_netbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"sparc64_unknown_netbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::sparc64_unknown_netbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_netbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_netbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_rumprun_netbsd","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_rumprun_netbsd","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_haiku","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_haiku","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_haiku","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_haiku","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_apple_darwin","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_apple_darwin","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_apple_darwin","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_apple_darwin","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_unknown_fuchsia","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_unknown_fuchsia","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_fuchsia","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_fuchsia","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_l4re_uclibc","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_l4re_uclibc","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_redox","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_redox","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i386_apple_ios","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i386_apple_ios","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_apple_ios","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_apple_ios","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_apple_ios","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_apple_ios","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv7_apple_ios","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv7_apple_ios","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv7s_apple_ios","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv7s_apple_ios","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_sun_solaris","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_sun_solaris","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"sparcv9_sun_solaris","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::sparcv9_sun_solaris","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_pc_windows_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_pc_windows_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_pc_windows_gnu","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_pc_windows_gnu","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_pc_windows_msvc","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_pc_windows_msvc","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_pc_windows_msvc","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_pc_windows_msvc","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i586_pc_windows_msvc","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i586_pc_windows_msvc","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"asmjs_unknown_emscripten","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::asmjs_unknown_emscripten","",null,{"inputs":[],"output":{"generics":["target","string"],"name":"result"}}],[0,"wasm32_unknown_emscripten","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::wasm32_unknown_emscripten","",null,{"inputs":[],"output":{"generics":["target","string"],"name":"result"}}],[0,"wasm32_unknown_unknown","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::wasm32_unknown_unknown","",null,{"inputs":[],"output":{"generics":["target","string"],"name":"result"}}],[0,"wasm32_experimental_emscripten","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::wasm32_experimental_emscripten","",null,{"inputs":[],"output":{"generics":["target","string"],"name":"result"}}],[0,"thumbv6m_none_eabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::thumbv6m_none_eabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"thumbv7m_none_eabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::thumbv7m_none_eabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"thumbv7em_none_eabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::thumbv7em_none_eabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"thumbv7em_none_eabihf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::thumbv7em_none_eabihf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"msp430_none_elf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::msp430_none_elf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"aarch64_unknown_cloudabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::aarch64_unknown_cloudabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"armv7_unknown_cloudabi_eabihf","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::armv7_unknown_cloudabi_eabihf","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"i686_unknown_cloudabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::i686_unknown_cloudabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[0,"x86_64_unknown_cloudabi","rustc_target::spec","",null,null],[5,"target","rustc_target::spec::x86_64_unknown_cloudabi","",null,{"inputs":[],"output":{"name":"targetresult"}}],[6,"LinkArgs","rustc_target::spec","",null,null],[6,"TargetResult","","",null,null],[17,"TARGETS","","List of supported targets",null,null],[8,"HasTargetSpec","","",null,null],[10,"target_spec","","",39,{"inputs":[{"name":"self"}],"output":{"name":"target"}}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"linkerflavor"}}],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",31,null],[11,"cmp","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"ordering"}}],[11,"eq","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"bool"}}],[11,"le","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"bool"}}],[11,"gt","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"bool"}}],[11,"ge","","",31,{"inputs":[{"name":"self"},{"name":"linkerflavor"}],"output":{"name":"bool"}}],[11,"hash","","",31,null],[11,"encode","","",31,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",31,{"inputs":[{"name":"__d"}],"output":{"generics":["linkerflavor"],"name":"result"}}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"lldflavor"}}],[11,"fmt","","",32,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",32,null],[11,"cmp","","",32,{"inputs":[{"name":"self"},{"name":"lldflavor"}],"output":{"name":"ordering"}}],[11,"eq","","",32,{"inputs":[{"name":"self"},{"name":"lldflavor"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",32,{"inputs":[{"name":"self"},{"name":"lldflavor"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"hash","","",32,null],[11,"encode","","",32,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",32,{"inputs":[{"name":"__d"}],"output":{"generics":["lldflavor"],"name":"result"}}],[11,"to_json","","",31,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"one_of","","",31,{"inputs":[],"output":{"name":"str"}}],[11,"from_str","","",31,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[11,"desc","","",31,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",33,{"inputs":[{"name":"self"}],"output":{"name":"panicstrategy"}}],[11,"fmt","","",33,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",33,{"inputs":[{"name":"self"},{"name":"panicstrategy"}],"output":{"name":"bool"}}],[11,"hash","","",33,null],[11,"encode","","",33,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",33,{"inputs":[{"name":"__d"}],"output":{"generics":["panicstrategy"],"name":"result"}}],[11,"desc","","",33,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"to_json","","",33,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"clone","","",34,{"inputs":[{"name":"self"}],"output":{"name":"relrolevel"}}],[11,"fmt","","",34,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",34,{"inputs":[{"name":"self"},{"name":"relrolevel"}],"output":{"name":"bool"}}],[11,"hash","","",34,null],[11,"encode","","",34,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",34,{"inputs":[{"name":"__d"}],"output":{"generics":["relrolevel"],"name":"result"}}],[11,"desc","","",34,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"from_str","","",34,{"inputs":[{"name":"str"}],"output":{"generics":["relrolevel"],"name":"result"}}],[11,"to_json","","",34,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"eq","","",29,{"inputs":[{"name":"self"},{"name":"target"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"self"},{"name":"target"}],"output":{"name":"bool"}}],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"target"}}],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",30,{"inputs":[{"name":"self"},{"name":"targetoptions"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"self"},{"name":"targetoptions"}],"output":{"name":"bool"}}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"targetoptions"}}],[11,"fmt","","",30,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for compilation, will certainly not work.",30,{"inputs":[],"output":{"name":"targetoptions"}}],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",29,{"inputs":[{"name":"self"},{"name":"abi"}],"output":{"name":"abi"}}],[11,"min_atomic_width","","Minimum integer size in bits that this target can perform atomic operations on.",29,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"max_atomic_width","","Maximum integer size in bits that this target can perform atomic operations on.",29,{"inputs":[{"name":"self"}],"output":{"name":"u64"}}],[11,"is_abi_supported","","",29,{"inputs":[{"name":"self"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"from_json","","Load a target descriptor from a JSON object.",29,{"inputs":[{"name":"json"}],"output":{"name":"targetresult"}}],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target triple. Note that it could also just be a bare filename already, so also check for that. If one of the hardcoded targets we know about, just return it directly.",29,{"inputs":[{"name":"targettriple"}],"output":{"generics":["target","string"],"name":"result"}}],[11,"to_json","","",29,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"eq","","",35,{"inputs":[{"name":"self"},{"name":"targettriple"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"self"},{"name":"targettriple"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"self"}],"output":{"name":"targettriple"}}],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",35,null],[11,"encode","","",35,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",35,{"inputs":[{"name":"__d"}],"output":{"generics":["targettriple"],"name":"result"}}],[11,"from_triple","","Creates a target triple from the passed target triple string.",35,{"inputs":[{"name":"str"}],"output":{"name":"self"}}],[11,"from_path","","Creates a target triple from the passed target path.",35,{"inputs":[{"name":"path"}],"output":{"generics":["error"],"name":"result"}}],[11,"triple","","Returns a string triple for this target.",35,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"debug_triple","","Returns an extended string triple for this target.",35,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}]],"paths":[[3,"TargetDataLayout"],[3,"Size"],[3,"Align"],[3,"Scalar"],[3,"LayoutDetails"],[3,"TyLayout"],[4,"Endian"],[4,"Integer"],[4,"Primitive"],[4,"FieldPlacement"],[4,"Abi"],[4,"Variants"],[3,"ArgAttribute"],[3,"ArgAttributes"],[3,"Reg"],[3,"Uniform"],[3,"CastTarget"],[3,"ArgType"],[3,"FnType"],[4,"PassMode"],[4,"RegKind"],[4,"Conv"],[4,"ABI"],[4,"Flavor"],[4,"Class"],[3,"Memory"],[8,"HasDataLayout"],[8,"LayoutOf"],[8,"TyLayoutMethods"],[3,"Target"],[3,"TargetOptions"],[4,"LinkerFlavor"],[4,"LldFlavor"],[4,"PanicStrategy"],[4,"RelroLevel"],[4,"TargetTriple"],[3,"AbiData"],[4,"Abi"],[4,"Arch"],[8,"HasTargetSpec"]]};
searchIndex["rustc_traits"] = {"doc":"New recursive solver modeled on Chalk's recursive solver. Most of the guts are broken up into modules; see the comments in those modules.","items":[[5,"provide","rustc_traits","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"dropck_outlives","","",null,null],[5,"dropck_outlives","rustc_traits::dropck_outlives","",null,{"inputs":[{"name":"tyctxt"},{"name":"canonicaltygoal"}],"output":{"generics":["lrc","nosolution"],"name":"result"}}],[5,"dtorck_constraint_for_ty","","Return a set of constraints that needs to be satisfied in order for `ty` to be valid for destruction.",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"ty"},{"name":"usize"},{"name":"ty"}],"output":{"generics":["dtorckconstraint","nosolution"],"name":"result"}}],[5,"adt_dtorck_constraint","","Calculates the dtorck constraint for a type.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["dtorckconstraint","nosolution"],"name":"result"}}],[5,"dedup_dtorck_constraint","","",null,{"inputs":[{"name":"dtorckconstraint"}],"output":null}],[0,"evaluate_obligation","rustc_traits","",null,null],[5,"evaluate_obligation","rustc_traits::evaluate_obligation","",null,{"inputs":[{"name":"tyctxt"},{"name":"canonicalpredicategoal"}],"output":{"generics":["evaluationresult","overflowerror"],"name":"result"}}],[0,"normalize_projection_ty","rustc_traits","",null,null],[5,"normalize_projection_ty","rustc_traits::normalize_projection_ty","",null,{"inputs":[{"name":"tyctxt"},{"name":"canonicalprojectiongoal"}],"output":{"generics":["lrc","nosolution"],"name":"result"}}],[0,"normalize_erasing_regions","rustc_traits","",null,null],[5,"normalize_ty_after_erasing_regions","rustc_traits::normalize_erasing_regions","",null,{"inputs":[{"name":"tyctxt"},{"generics":["ty"],"name":"paramenvand"}],"output":{"name":"ty"}}],[5,"not_outlives_predicate","","",null,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[0,"util","rustc_traits","",null,null],[5,"make_query_response","rustc_traits::util","",null,{"inputs":[{"name":"inferctxt"},{"name":"canonicalvarvalues"},{"name":"t"},{"name":"fulfillmentcontext"}],"output":{"generics":["nosolution"],"name":"result"}}],[6,"CanonicalizedQueryResult","","The canonicalization form of `QueryResult<'tcx, T>`.",null,null],[0,"lowering","rustc_traits","",null,null],[3,"ClauseDumper","rustc_traits::lowering","",null,null],[12,"tcx","","",0,null],[5,"program_clauses_for","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"clauses"}}],[5,"program_clauses_for_env","","",null,{"inputs":[{"name":"tyctxt"},{"name":"paramenv"}],"output":{"name":"clauses"}}],[5,"program_clauses_for_trait","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"clauses"}}],[5,"implied_bound_from_trait","","For a given `where_clause`, returns a clause `FromEnv(WC) :- FromEnv(Self: Trait<P1..Pn>)`.",null,{"inputs":[{"name":"tyctxt"},{"name":"traitpredicate"},{"name":"predicate"}],"output":{"name":"clause"}}],[5,"program_clauses_for_impl","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"clauses"}}],[5,"program_clauses_for_associated_type_value","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"clauses"}}],[5,"dump_program_clauses","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[8,"Lower","","",null,null],[10,"lower","","Lower a rustc construction (e.g. `ty::TraitPredicate`) to a chalk-like type.",1,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[8,"IntoFromEnvGoal","","Transforms an existing goal into a FromEnv goal.",null,null],[10,"into_from_env_goal","","",2,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"process_attrs","","",0,null],[11,"nested_visit_map","","",0,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",0,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",0,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",0,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_struct_field","","",0,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}]],"paths":[[3,"ClauseDumper"],[8,"Lower"],[8,"IntoFromEnvGoal"]]};
searchIndex["rustc_trans_utils"] = {"doc":"Note","items":[[5,"check_for_rustc_errors_attr","rustc_trans_utils","check for the #[rustc_error] annotation, which forces an error in trans. This is used to write compile-fail tests that actually test that compilation succeeds without reporting an error.",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[0,"link","","",null,null],[5,"out_filename","rustc_trans_utils::link","",null,{"inputs":[{"name":"session"},{"name":"cratetype"},{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"check_file_is_writeable","","",null,{"inputs":[{"name":"path"},{"name":"session"}],"output":null}],[5,"is_writeable","","",null,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[5,"build_link_meta","","",null,{"inputs":[{"name":"svh"}],"output":{"name":"linkmeta"}}],[5,"find_crate_name","","",null,null],[5,"filename_for_input","","",null,{"inputs":[{"name":"session"},{"name":"cratetype"},{"name":"str"},{"name":"outputfilenames"}],"output":{"name":"pathbuf"}}],[5,"default_output_for_target","","Returns default crate type for target",null,{"inputs":[{"name":"session"}],"output":{"name":"cratetype"}}],[5,"invalid_output_for_target","","Checks if target supports crate_type as output",null,{"inputs":[{"name":"session"},{"name":"cratetype"}],"output":{"name":"bool"}}],[0,"trans_crate","rustc_trans_utils","The Rust compiler.",null,null],[6,"MetadataRef","rustc_trans_utils::trans_crate","",null,null],[3,"DummyTransCrate","","",null,null],[3,"DummyMetadataLoader","","",null,null],[12,"0","","",0,null],[3,"NoLlvmMetadataLoader","","",null,null],[3,"MetadataOnlyTransCrate","","",null,null],[12,"0","","",1,null],[3,"OngoingCrateTranslation","","",null,null],[12,"metadata","","",2,null],[12,"metadata_version","","",2,null],[12,"crate_name","","",2,null],[8,"TransCrate","","",null,null],[11,"init","","",3,{"inputs":[{"name":"self"},{"name":"session"}],"output":null}],[11,"print","","",3,{"inputs":[{"name":"self"},{"name":"printrequest"},{"name":"session"}],"output":null}],[11,"target_features","","",3,{"inputs":[{"name":"self"},{"name":"session"}],"output":{"generics":["symbol"],"name":"vec"}}],[11,"print_passes","","",3,{"inputs":[{"name":"self"}],"output":null}],[11,"print_version","","",3,{"inputs":[{"name":"self"}],"output":null}],[11,"diagnostics","","",3,null],[10,"metadata_loader","","",3,{"inputs":[{"name":"self"}],"output":{"generics":["metadataloader"],"name":"box"}}],[10,"provide","","",3,{"inputs":[{"name":"self"},{"name":"providers"}],"output":null}],[10,"provide_extern","","",3,{"inputs":[{"name":"self"},{"name":"providers"}],"output":null}],[10,"trans_crate","","",3,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["box"],"name":"receiver"}],"output":{"generics":["any"],"name":"box"}}],[10,"join_trans_and_link","","This is called on the returned `Box<Any>` from `trans_crate`",3,{"inputs":[{"name":"self"},{"generics":["any"],"name":"box"},{"name":"session"},{"name":"depgraph"},{"name":"outputfilenames"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[11,"metadata_loader","","",4,{"inputs":[{"name":"self"}],"output":{"generics":["metadataloader"],"name":"box"}}],[11,"provide","","",4,{"inputs":[{"name":"self"},{"name":"providers"}],"output":null}],[11,"provide_extern","","",4,{"inputs":[{"name":"self"},{"name":"providers"}],"output":null}],[11,"trans_crate","","",4,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["box"],"name":"receiver"}],"output":{"generics":["any"],"name":"box"}}],[11,"join_trans_and_link","","",4,{"inputs":[{"name":"self"},{"generics":["any"],"name":"box"},{"name":"session"},{"name":"depgraph"},{"name":"outputfilenames"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[11,"get_rlib_metadata","","",0,{"inputs":[{"name":"self"},{"name":"target"},{"name":"path"}],"output":{"generics":["metadataref","string"],"name":"result"}}],[11,"get_dylib_metadata","","",0,{"inputs":[{"name":"self"},{"name":"target"},{"name":"path"}],"output":{"generics":["metadataref","string"],"name":"result"}}],[11,"get_rlib_metadata","","",5,{"inputs":[{"name":"self"},{"name":"target"},{"name":"path"}],"output":{"generics":["metadataref","string"],"name":"result"}}],[11,"get_dylib_metadata","","",5,{"inputs":[{"name":"self"},{"name":"target"},{"name":"path"}],"output":{"generics":["metadataref","string"],"name":"result"}}],[11,"new","","",1,{"inputs":[],"output":{"generics":["transcrate"],"name":"box"}}],[11,"init","","",1,{"inputs":[{"name":"self"},{"name":"session"}],"output":null}],[11,"metadata_loader","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["metadataloader"],"name":"box"}}],[11,"provide","","",1,{"inputs":[{"name":"self"},{"name":"providers"}],"output":null}],[11,"provide_extern","","",1,{"inputs":[{"name":"self"},{"name":"providers"}],"output":null}],[11,"trans_crate","","",1,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"generics":["box"],"name":"receiver"}],"output":{"generics":["any"],"name":"box"}}],[11,"join_trans_and_link","","",1,{"inputs":[{"name":"self"},{"generics":["any"],"name":"box"},{"name":"session"},{"name":"depgraph"},{"name":"outputfilenames"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[0,"symbol_names","rustc_trans_utils","The Rust Linkage Model and Symbol Names =======================================",null,null],[3,"SymbolPathBuffer","rustc_trans_utils::symbol_names","",null,null],[12,"result","","",6,null],[12,"temp_buf","","",6,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"get_symbol_hash","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"instance"},{"name":"ty"},{"name":"substs"}],"output":{"name":"u64"}}],[5,"def_symbol_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"symbolname"}}],[5,"symbol_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"}],"output":{"name":"symbolname"}}],[5,"compute_symbol_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"instance"}],"output":{"name":"string"}}],[5,"sanitize","","",null,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"new","","",6,{"inputs":[],"output":{"name":"self"}}],[11,"from_interned","","",6,{"inputs":[{"name":"symbolname"}],"output":{"name":"self"}}],[11,"into_interned","","",6,{"inputs":[{"name":"self"}],"output":{"name":"symbolname"}}],[11,"finish","","",6,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"string"}}],[11,"root_mode","","",6,{"inputs":[{"name":"self"}],"output":{"name":"rootmode"}}],[11,"push","","",6,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[0,"symbol_names_test","rustc_trans_utils","Walks the crate looking for items/impl-items/trait-items that have either a `rustc_symbol_name` or `rustc_item_path` attribute and generates an error giving, respectively, the symbol name or item-path. This is used for unit testing the code that generates paths etc in all kinds of annoying scenarios.",null,null],[3,"SymbolNamesTest","rustc_trans_utils::symbol_names_test","",null,null],[12,"tcx","","",7,null],[5,"report_symbol_names","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[17,"SYMBOL_NAME","","",null,null],[17,"ITEM_PATH","","",null,null],[11,"process_attrs","","",7,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"visit_item","","",7,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",7,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",7,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[17,"DIAGNOSTICS","rustc_trans_utils","",null,null]],"paths":[[3,"DummyMetadataLoader"],[3,"MetadataOnlyTransCrate"],[3,"OngoingCrateTranslation"],[8,"TransCrate"],[3,"DummyTransCrate"],[3,"NoLlvmMetadataLoader"],[3,"SymbolPathBuffer"],[3,"SymbolNamesTest"]]};
searchIndex["rustc_typeck"] = {"doc":"typeck.rs, an introduction","items":[[3,"TypeAndSubsts","rustc_typeck","",null,null],[12,"substs","","",0,null],[12,"ty","","",0,null],[5,"require_c_abi_if_variadic","","",null,{"inputs":[{"name":"tyctxt"},{"name":"fndecl"},{"name":"abi"},{"name":"span"}],"output":null}],[5,"require_same_types","","",null,{"inputs":[{"name":"tyctxt"},{"name":"obligationcause"},{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"check_main_fn_ty","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"span"}],"output":null}],[5,"check_start_fn_ty","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"span"}],"output":null}],[5,"check_for_entry_fn","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[5,"hir_ty_to_ty","","A quasi-deprecated helper used in rustdoc and save-analysis to get the type from a HIR node.",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"hir_trait_to_predicates","","",null,null],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0023","rustc_typeck::diagnostics","",null,null],[0,"__register_diagnostic_E0025","","",null,null],[0,"__register_diagnostic_E0026","","",null,null],[0,"__register_diagnostic_E0027","","",null,null],[0,"__register_diagnostic_E0029","","",null,null],[0,"__register_diagnostic_E0033","","",null,null],[0,"__register_diagnostic_E0034","","",null,null],[0,"__register_diagnostic_E0040","","",null,null],[0,"__register_diagnostic_E0044","","",null,null],[0,"__register_diagnostic_E0045","","",null,null],[0,"__register_diagnostic_E0046","","",null,null],[0,"__register_diagnostic_E0049","","",null,null],[0,"__register_diagnostic_E0050","","",null,null],[0,"__register_diagnostic_E0053","","",null,null],[0,"__register_diagnostic_E0054","","",null,null],[0,"__register_diagnostic_E0055","","",null,null],[0,"__register_diagnostic_E0057","","",null,null],[0,"__register_diagnostic_E0059","","",null,null],[0,"__register_diagnostic_E0060","","",null,null],[0,"__register_diagnostic_E0061","","",null,null],[0,"__register_diagnostic_E0062","","",null,null],[0,"__register_diagnostic_E0063","","",null,null],[0,"__register_diagnostic_E0067","","",null,null],[0,"__register_diagnostic_E0069","","",null,null],[0,"__register_diagnostic_E0070","","",null,null],[0,"__register_diagnostic_E0071","","",null,null],[0,"__register_diagnostic_E0073","","",null,null],[0,"__register_diagnostic_E0074","","",null,null],[0,"__register_diagnostic_E0075","","",null,null],[0,"__register_diagnostic_E0076","","",null,null],[0,"__register_diagnostic_E0077","","",null,null],[0,"__register_diagnostic_E0081","","",null,null],[0,"__register_diagnostic_E0084","","",null,null],[0,"__register_diagnostic_E0087","","",null,null],[0,"__register_diagnostic_E0088","","",null,null],[0,"__register_diagnostic_E0089","","",null,null],[0,"__register_diagnostic_E0090","","",null,null],[0,"__register_diagnostic_E0091","","",null,null],[0,"__register_diagnostic_E0092","","",null,null],[0,"__register_diagnostic_E0093","","",null,null],[0,"__register_diagnostic_E0094","","",null,null],[0,"__register_diagnostic_E0107","","",null,null],[0,"__register_diagnostic_E0109","","",null,null],[0,"__register_diagnostic_E0110","","",null,null],[0,"__register_diagnostic_E0116","","",null,null],[0,"__register_diagnostic_E0117","","",null,null],[0,"__register_diagnostic_E0118","","",null,null],[0,"__register_diagnostic_E0120","","",null,null],[0,"__register_diagnostic_E0121","","",null,null],[0,"__register_diagnostic_E0124","","",null,null],[0,"__register_diagnostic_E0131","","",null,null],[0,"__register_diagnostic_E0132","","",null,null],[0,"__register_diagnostic_E0164","","",null,null],[0,"__register_diagnostic_E0184","","",null,null],[0,"__register_diagnostic_E0185","","",null,null],[0,"__register_diagnostic_E0186","","",null,null],[0,"__register_diagnostic_E0191","","",null,null],[0,"__register_diagnostic_E0192","","",null,null],[0,"__register_diagnostic_E0193","","",null,null],[0,"__register_diagnostic_E0194","","",null,null],[0,"__register_diagnostic_E0195","","",null,null],[0,"__register_diagnostic_E0199","","",null,null],[0,"__register_diagnostic_E0200","","",null,null],[0,"__register_diagnostic_E0201","","",null,null],[0,"__register_diagnostic_E0202","","",null,null],[0,"__register_diagnostic_E0204","","",null,null],[0,"__register_diagnostic_E0206","","",null,null],[0,"__register_diagnostic_E0207","","",null,null],[0,"__register_diagnostic_E0210","","",null,null],[0,"__register_diagnostic_E0220","","",null,null],[0,"__register_diagnostic_E0221","","",null,null],[0,"__register_diagnostic_E0223","","",null,null],[0,"__register_diagnostic_E0225","","",null,null],[0,"__register_diagnostic_E0229","","",null,null],[0,"__register_diagnostic_E0243","","",null,null],[0,"__register_diagnostic_E0244","","",null,null],[0,"__register_diagnostic_E0321","","",null,null],[0,"__register_diagnostic_E0322","","",null,null],[0,"__register_diagnostic_E0323","","",null,null],[0,"__register_diagnostic_E0324","","",null,null],[0,"__register_diagnostic_E0325","","",null,null],[0,"__register_diagnostic_E0326","","",null,null],[0,"__register_diagnostic_E0328","","",null,null],[0,"__register_diagnostic_E0366","","",null,null],[0,"__register_diagnostic_E0367","","",null,null],[0,"__register_diagnostic_E0368","","",null,null],[0,"__register_diagnostic_E0369","","",null,null],[0,"__register_diagnostic_E0370","","",null,null],[0,"__register_diagnostic_E0371","","",null,null],[0,"__register_diagnostic_E0374","","",null,null],[0,"__register_diagnostic_E0375","","",null,null],[0,"__register_diagnostic_E0376","","",null,null],[0,"__register_diagnostic_E0390","","",null,null],[0,"__register_diagnostic_E0392","","",null,null],[0,"__register_diagnostic_E0393","","",null,null],[0,"__register_diagnostic_E0399","","",null,null],[0,"__register_diagnostic_E0436","","",null,null],[0,"__register_diagnostic_E0439","","",null,null],[0,"__register_diagnostic_E0440","","",null,null],[0,"__register_diagnostic_E0441","","",null,null],[0,"__register_diagnostic_E0442","","",null,null],[0,"__register_diagnostic_E0443","","",null,null],[0,"__register_diagnostic_E0444","","",null,null],[0,"__register_diagnostic_E0516","","",null,null],[0,"__register_diagnostic_E0520","","",null,null],[0,"__register_diagnostic_E0527","","",null,null],[0,"__register_diagnostic_E0528","","",null,null],[0,"__register_diagnostic_E0529","","",null,null],[0,"__register_diagnostic_E0534","","",null,null],[0,"__register_diagnostic_E0535","","",null,null],[0,"__register_diagnostic_E0558","","",null,null],[0,"__register_diagnostic_E0559","","",null,null],[0,"__register_diagnostic_E0560","","",null,null],[0,"__register_diagnostic_E0569","","",null,null],[0,"__register_diagnostic_E0570","","",null,null],[0,"__register_diagnostic_E0572","","",null,null],[0,"__register_diagnostic_E0581","","",null,null],[0,"__register_diagnostic_E0582","","",null,null],[0,"__register_diagnostic_E0599","","",null,null],[0,"__register_diagnostic_E0600","","",null,null],[0,"__register_diagnostic_E0608","","",null,null],[0,"__register_diagnostic_E0604","","",null,null],[0,"__register_diagnostic_E0605","","",null,null],[0,"__register_diagnostic_E0606","","",null,null],[0,"__register_diagnostic_E0607","","",null,null],[0,"__register_diagnostic_E0609","","",null,null],[0,"__register_diagnostic_E0610","","",null,null],[0,"__register_diagnostic_E0614","","",null,null],[0,"__register_diagnostic_E0615","","",null,null],[0,"__register_diagnostic_E0616","","",null,null],[0,"__register_diagnostic_E0617","","",null,null],[0,"__register_diagnostic_E0618","","",null,null],[0,"__register_diagnostic_E0619","","",null,null],[0,"__register_diagnostic_E0620","","",null,null],[0,"__register_diagnostic_E0622","","",null,null],[0,"__register_diagnostic_E0624","","",null,null],[0,"__register_diagnostic_E0638","","",null,null],[0,"__register_diagnostic_E0639","","",null,null],[0,"__register_diagnostic_E0643","","",null,null],[0,"__register_diagnostic_E0689","","",null,null],[0,"__register_diagnostic_E0690","","",null,null],[0,"__register_diagnostic_E0691","","",null,null],[0,"__register_diagnostic_E0908","","",null,null],[0,"__register_diagnostic_E0183","","",null,null],[0,"__register_diagnostic_E0203","","",null,null],[0,"__register_diagnostic_E0208","","",null,null],[0,"__register_diagnostic_E0212","","",null,null],[0,"__register_diagnostic_E0224","","",null,null],[0,"__register_diagnostic_E0227","","",null,null],[0,"__register_diagnostic_E0228","","",null,null],[0,"__register_diagnostic_E0307","","",null,null],[0,"__register_diagnostic_E0377","","",null,null],[0,"__register_diagnostic_E0533","","",null,null],[0,"__register_diagnostic_E0564","","",null,null],[0,"__register_diagnostic_E0587","","",null,null],[0,"__register_diagnostic_E0588","","",null,null],[0,"__register_diagnostic_E0592","","",null,null],[0,"__register_diagnostic_E0627","","",null,null],[0,"__register_diagnostic_E0632","","",null,null],[0,"__register_diagnostic_E0634","","",null,null],[0,"__register_diagnostic_E0640","","",null,null],[0,"__register_diagnostic_E0641","","",null,null],[0,"__register_diagnostic_E0645","","",null,null],[0,"__register_diagnostic_E0907","","",null,null],[0,"astconv","rustc_typeck","Conversion from AST representation of types to the ty.rs representation.  The main routine here is `ast_ty_to_ty()`: each use is parameterized by an instance of `AstConv`.",null,null],[3,"ConvertedBinding","rustc_typeck::astconv","",null,null],[12,"item_name","","",1,null],[12,"ty","","",1,null],[12,"span","","",1,null],[3,"Bounds","","",null,null],[12,"region_bounds","","",2,null],[12,"implicitly_sized","","",2,null],[12,"trait_bounds","","",2,null],[12,"projection_bounds","","",2,null],[5,"split_auto_traits","","Divides a list of general trait bounds into two groups: builtin bounds (Sync/Send) and the remaining general trait bounds.",null,null],[5,"check_type_argument_count","","",null,null],[5,"report_lifetime_number_error","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"usize"},{"name":"usize"}],"output":null}],[17,"TRAIT_OBJECT_DUMMY_SELF","","Dummy type used for the `Self` of a `TraitRef` created for converting a trait object, and which gets removed in `ExistentialTraitRef`. This type must not appear anywhere in other converted types.",null,null],[8,"AstConv","","",null,null],[10,"tcx","","",3,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[10,"get_type_parameter_bounds","","Returns the set of bounds in scope for the type parameter with the given id.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[10,"re_infer","","What lifetime should we use when a lifetime is omitted (and not elided)?",3,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["regionparameterdef"],"name":"option"}],"output":{"generics":["region"],"name":"option"}}],[10,"ty_infer","","What type should we use when a type is omitted?",3,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"ty"}}],[11,"ty_infer_for_def","","Same as ty_infer, but with a known type parameter definition.",3,{"inputs":[{"name":"self"},{"name":"typeparameterdef"},{"name":"span"}],"output":{"name":"ty"}}],[10,"projected_ty_from_poly_trait_ref","","Projecting an associated type from a (potentially) higher-ranked trait reference is more complicated, because of the possibility of late-bound regions appearing in the associated type binding. This is not legal in function signatures for that reason. In a function body, we can always handle it because we can use inference variables to remove the late-bound regions.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"polytraitref"}],"output":{"name":"ty"}}],[10,"normalize_ty","","Normalize an associated type coming from the user.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"ty"}}],[10,"set_tainted_by_errors","","Invoked when we encounter an error from some prior pass (e.g. resolve) that is translated into a ty-error. This is used to help suppress derived errors typeck might otherwise report.",3,{"inputs":[{"name":"self"}],"output":null}],[10,"record_ty","","",3,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"ty"},{"name":"span"}],"output":null}],[11,"ast_region_to_region","","",3,{"inputs":[{"name":"self"},{"name":"lifetime"},{"generics":["regionparameterdef"],"name":"option"}],"output":{"name":"region"}}],[11,"ast_path_substs_for_ty","","Given a path `path` that refers to an item `I` with the declared generics `decl_generics`, returns an appropriate set of substitutions for this particular reference to `I`.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"pathsegment"}],"output":{"name":"substs"}}],[11,"create_substs_for_ast_path","","Given the type/region arguments provided to some path (along with an implicit Self, if this is a trait reference) returns the complete set of substitutions. This may involve applying defaulted type parameters.",3,null],[11,"instantiate_mono_trait_ref","","Instantiates the path for the given trait reference, assuming that it's bound to a valid trait type. Returns the def_id for the defining trait. The type cannot be a type other than a trait type.",3,{"inputs":[{"name":"self"},{"name":"traitref"},{"name":"ty"}],"output":{"name":"traitref"}}],[11,"trait_def_id","","Get the DefId of the given trait ref. It must actually be a trait.",3,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"defid"}}],[11,"instantiate_poly_trait_ref_inner","","The given `trait_ref` must actually be trait.",3,{"inputs":[{"name":"self"},{"name":"traitref"},{"name":"ty"},{"name":"vec"},{"name":"bool"}],"output":{"name":"polytraitref"}}],[11,"instantiate_poly_trait_ref","","",3,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"ty"},{"name":"vec"}],"output":{"name":"polytraitref"}}],[11,"ast_path_to_mono_trait_ref","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"ty"},{"name":"pathsegment"}],"output":{"name":"traitref"}}],[11,"create_substs_for_ast_trait_ref","","",3,null],[11,"trait_defines_associated_type_named","","",3,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ast_type_binding_to_poly_projection_predicate","","",3,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"polytraitref"},{"name":"convertedbinding"},{"name":"bool"}],"output":{"generics":["polyprojectionpredicate","errorreported"],"name":"result"}}],[11,"ast_path_to_ty","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"pathsegment"}],"output":{"name":"ty"}}],[11,"trait_ref_to_existential","","Transform a PolyTraitRef into a PolyExistentialTraitRef by removing the dummy Self type (TRAIT_OBJECT_DUMMY_SELF).",3,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"existentialtraitref"}}],[11,"conv_object_ty_poly_trait_ref","","",3,null],[11,"report_ambiguous_associated_type","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":null}],[11,"find_bound_for_assoc_item","","",3,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"name"},{"name":"span"}],"output":{"generics":["polytraitref","errorreported"],"name":"result"}}],[11,"one_bound_for_assoc_type","","",3,{"inputs":[{"name":"self"},{"name":"i"},{"name":"str"},{"name":"name"},{"name":"span"}],"output":{"generics":["polytraitref","errorreported"],"name":"result"}}],[11,"associated_path_def_to_ty","","",3,null],[11,"qpath_to_ty","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"option"},{"name":"defid"},{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"ty"}}],[11,"prohibit_type_params","","",3,null],[11,"prohibit_projection","","",3,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"def_to_ty","","",3,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"option"},{"name":"path"},{"name":"bool"}],"output":{"name":"ty"}}],[11,"ast_ty_to_ty","","Parses the programmer's textual representation of a type into our internal notion of a type.",3,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"impl_trait_ty_to_ty","","",3,null],[11,"ty_of_arg","","",3,{"inputs":[{"name":"self"},{"name":"ty"},{"generics":["ty"],"name":"option"}],"output":{"name":"ty"}}],[11,"ty_of_fn","","",3,{"inputs":[{"name":"self"},{"name":"unsafety"},{"name":"abi"},{"name":"fndecl"}],"output":{"name":"polyfnsig"}}],[11,"compute_object_lifetime_bound","","Given the bounds on an object, determines what single region bound (if any) we can use to summarize this type. The basic idea is that we will use the bound the user provided, if they provided one, and otherwise search the supertypes of trait bounds for region bounds. It may be that we can derive no bound at all, in which case we return `None`.",3,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["slice"],"name":"binder"}],"output":{"generics":["region"],"name":"option"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"bounds"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"bounds"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",2,null],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"bounds"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"predicates","","",2,{"inputs":[{"name":"self"},{"name":"tyctxt"},{"name":"ty"}],"output":{"generics":["predicate"],"name":"vec"}}],[0,"check","rustc_typeck","",null,null],[3,"MaybeInProgressTables","rustc_typeck::check","A wrapper for InferCtxt's `in_progress_tables` field.",null,null],[12,"maybe_tables","","",4,null],[3,"Inherited","","closures defined within the function.  For example:",null,null],[12,"infcx","","",5,null],[12,"tables","","",5,null],[12,"locals","","",5,null],[12,"fulfillment_cx","","",5,null],[12,"deferred_call_resolutions","","",5,null],[12,"deferred_cast_checks","","",5,null],[12,"deferred_generator_interiors","","",5,null],[12,"anon_types","","",5,null],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that indicates it must outlive at least the function body (the user may specify stronger requirements). This field indicates the region of the callee. If it is `None`, then the parameter environment is for an item or something where the \"callee\" is not clear.",5,null],[12,"body_id","","",5,null],[3,"UnsafetyState","","",null,null],[12,"def","","",6,null],[12,"unsafety","","",6,null],[12,"unsafe_push_count","","",6,null],[12,"from_fn","","",6,null],[3,"BreakableCtxt","","",null,null],[12,"may_break","","",7,null],[12,"coerce","","",7,null],[3,"EnclosingBreakables","","",null,null],[12,"stack","","",8,null],[12,"by_id","","",8,null],[3,"FnCtxt","","",null,null],[12,"body_id","","",9,null],[12,"param_env","","The parameter environment used for proving trait obligations in this function. This can change when we descend into closures (as they bring new things into scope), hence it is not part of `Inherited` (as of the time of this writing, closures do not yet change the environment, but they will eventually).",9,null],[12,"err_count_on_creation","","",9,null],[12,"ret_coercion","","",9,null],[12,"yield_ty","","",9,null],[12,"ps","","",9,null],[12,"diverges","","Whether the last checked node generates a divergence (e.g., `return` will set this to Always). In general, when entering an expression or other node in the tree, the initial value indicates whether prior parts of the containing expression may have diverged. It is then typically set to `Maybe` (and the old value remembered) for processing the subparts of the current expression. As each subpart is processed, they may set the flag to `Always` etc.  Finally, at the end, we take the result and \"union\" it with the original value, so that when we return the flag indicates if any subpart of the the parent expression (up to and including this part) has diverged.  So, if you read it after evaluating a subexpression `X`, the value you get indicates whether any subexpression that was evaluating up to and including `X` diverged.",9,null],[12,"has_errors","","Whether any child nodes have any type errors.",9,null],[12,"enclosing_breakables","","",9,null],[12,"inh","","",9,null],[3,"InheritedBuilder","","Helper type of a temporary returned by Inherited::build(...). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(Inherited<'b, 'gcx, 'tcx>).",null,null],[12,"infcx","","",10,null],[12,"def_id","","",10,null],[3,"CheckItemTypesVisitor","","",null,null],[12,"tcx","","",11,null],[3,"GatherLocalsVisitor","","",null,null],[12,"fcx","","",12,null],[3,"GeneratorTypes","","When `check_fn` is invoked on a generator (i.e., a body that includes yield), it returns back some information about the yield points.",null,null],[12,"yield_ty","","Type of value that is yielded.",13,null],[12,"interior","","Types that are captured (see `GeneratorInterior` for more).",13,null],[4,"Expectation","","When type-checking an expression, we propagate downward whatever type hint we are able in the form of an `Expectation`.",null,null],[13,"NoExpectation","","We know nothing about what type this expression should have.",14,null],[13,"ExpectIfCondition","","This expression is an `if` condition, it must resolve to `bool`.",14,null],[13,"ExpectHasType","","This expression should have the type given (or some subtype)",14,null],[13,"ExpectCastableToType","","This expression will be cast to the `Ty`",14,null],[13,"ExpectRvalueLikeUnsized","","This rvalue expression will be wrapped in `&` or `Box` and coerced to `&Ty` or `Box<Ty>`, respectively. `Ty` is `[A]` or `Trait`.",14,null],[4,"Needs","","",null,null],[13,"MutPlace","","",15,null],[13,"None","","",15,null],[4,"PlaceOp","","",null,null],[13,"Deref","","",16,null],[13,"Index","","",16,null],[4,"Diverges","","Tracks whether executing a node may exit normally (versus return/break/panic, which \"diverge\", leaving dead code in their wake). Tracked semi-automatically (through type variables marked as diverging), with some manual adjustments for control-flow primitives (approximating a CFG).",null,null],[13,"Maybe","","Potentially unknown, some cases converge, others require a CFG to determine them.",17,null],[13,"Always","","Definitely known to diverge and therefore not reach the next sibling or its parent.",17,null],[13,"WarnedAlways","","Same as `Always` but with a reachability warning already emitted",17,null],[4,"TupleArgumentsFlag","","Controls whether the arguments are tupled. This is used for the call operator.",null,null],[13,"DontTupleArguments","","",18,null],[13,"TupleArguments","","",18,null],[5,"check_wf_new","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"check_item_types","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"check_item_bodies","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[5,"typeck_item_bodies","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["compileincomplete"],"name":"result"}}],[5,"check_item_well_formed","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"check_trait_item_well_formed","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"check_impl_item_well_formed","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"adt_destructor","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["destructor"],"name":"option"}}],[5,"primary_body_of","","If this def-id is a \"primary tables entry\", returns `Some((body_id, decl))` with information about it's body-id and fn-decl (if any). Otherwise, returns `None`.",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"has_typeck_tables","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"used_trait_imports","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["defidset"],"name":"lrc"}}],[5,"typeck_tables_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"typecktables"}}],[5,"check_abi","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"abi"}],"output":null}],[5,"check_fn","","Helper used for fns and closures. Does the grungy work of checking a function body and returns the function context used for that purpose, since in the case of a fn item there is still a bit more to do.",null,null],[5,"check_struct","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"span"}],"output":null}],[5,"check_union","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"span"}],"output":null}],[5,"check_item_type","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"}],"output":null}],[5,"check_const_is_u8_array","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"span"}],"output":null}],[5,"check_on_unimplemented","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"item"}],"output":null}],[5,"report_forbidden_specialization","","",null,{"inputs":[{"name":"tyctxt"},{"name":"implitem"},{"name":"defid"}],"output":null}],[5,"check_specialization_validity","","",null,{"inputs":[{"name":"tyctxt"},{"name":"traitdef"},{"name":"associateditem"},{"name":"defid"},{"name":"implitem"}],"output":null}],[5,"check_impl_items_against_trait","","",null,null],[5,"check_representable","","Checks whether a type can be represented in memory. In particular, it identifies types that contain themselves without indirection through a pointer, which would mean their size is unbounded.",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"check_simd","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"defid"}],"output":null}],[5,"check_packed","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"defid"}],"output":null}],[5,"check_packed_inner","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"vec"}],"output":{"name":"bool"}}],[5,"check_transparent","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"defid"}],"output":null}],[5,"check_enum","","",null,null],[5,"check_bounds_are_used","","",null,{"inputs":[{"name":"tyctxt"},{"name":"generics"},{"name":"ty"}],"output":null}],[5,"fatally_break_rust","","",null,{"inputs":[{"name":"session"}],"output":null}],[0,"autoderef","","",null,null],[3,"Autoderef","rustc_typeck::check::autoderef","",null,null],[12,"fcx","","",19,null],[12,"steps","","",19,null],[12,"cur_ty","","",19,null],[12,"obligations","","",19,null],[12,"at_start","","",19,null],[12,"include_raw_pointers","","",19,null],[12,"span","","",19,null],[4,"AutoderefKind","","",null,null],[13,"Builtin","","",20,null],[13,"Overloaded","","",20,null],[11,"clone","","",20,{"inputs":[{"name":"self"}],"output":{"name":"autoderefkind"}}],[11,"fmt","","",20,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"next","","",19,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"overloaded_deref_ty","","",19,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["ty"],"name":"option"}}],[11,"unambiguous_final_ty","","Returns the final type, generating an error if it is an unresolved inference variable.",19,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"maybe_ambiguous_final_ty","","Returns the final type we ended up with, which may well be an inference variable (we will resolve it first, if possible).",19,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"step_count","","",19,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"adjust_steps","","Returns the adjustment steps.",19,{"inputs":[{"name":"self"},{"name":"needs"}],"output":{"generics":["adjustment"],"name":"vec"}}],[11,"adjust_steps_as_infer_ok","","",19,{"inputs":[{"name":"self"},{"name":"needs"}],"output":{"generics":["vec"],"name":"inferok"}}],[11,"include_raw_pointers","","also dereference through raw pointer types e.g. assuming ptr_to_Foo is the type `*const Foo` fcx.autoderef(span, ptr_to_Foo)  => [*const Foo] fcx.autoderef(span, ptr_to_Foo).include_raw_ptrs() => [*const Foo, Foo]",19,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"finalize","","",19,{"inputs":[{"name":"self"}],"output":null}],[11,"into_obligations","","",19,{"inputs":[{"name":"self"}],"output":{"generics":["predicateobligation"],"name":"vec"}}],[11,"autoderef","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"autoderef"}}],[11,"try_overloaded_deref","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"needs"}],"output":{"generics":["inferok"],"name":"option"}}],[0,"dropck","","",null,null],[5,"check_drop_impl","rustc_typeck::check::dropck","check_drop_impl confirms that the Drop implementation identified by `drop_impl_did` is not any more specialized than the type it is attached to (Issue #8142).",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"ensure_drop_params_and_item_params_correspond","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"ty"},{"name":"defid"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"ensure_drop_predicates_are_implied_by_item_defn","","Confirms that every predicate imposed by dtor_predicates is implied by assuming the predicates attached to self_type_did.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"genericpredicates"},{"name":"defid"},{"name":"substs"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"check_safety_of_destructor_if_necessary","","check_safety_of_destructor_if_necessary confirms that the type expression `typ` conforms to the \"Drop Check Rule\" from the Sound Generic Drop (RFC 769).",null,{"inputs":[{"name":"regionctxt"},{"name":"ty"},{"name":"span"},{"name":"nodeid"},{"name":"scope"}],"output":{"generics":["errorreported"],"name":"result"}}],[0,"_match","rustc_typeck::check","",null,null],[11,"check_pat_walk","","The `is_arg` argument indicates whether this pattern is the outermost pattern in an argument (e.g., in `fn foo(&x: &u32)`, it is true for the `&x` pattern but not `x`). This is used to tailor error reporting.",9,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"ty"},{"name":"bindingmode"},{"name":"bool"}],"output":null}],[11,"check_dereferencable","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"check_match","","",9,null],[11,"check_pat_struct","","",9,null],[11,"check_pat_path","","",9,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"qpath"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"check_pat_tuple_struct","","",9,null],[11,"check_struct_pat_fields","","",9,null],[0,"writeback","","",null,null],[3,"WritebackCx","rustc_typeck::check::writeback","",null,null],[12,"fcx","","",21,null],[12,"tables","","",21,null],[12,"body","","",21,null],[3,"Resolver","","",null,null],[12,"tcx","","",22,null],[12,"infcx","","",22,null],[12,"span","","",22,null],[12,"body","","",22,null],[8,"Locatable","","",null,null],[10,"to_span","","",23,{"inputs":[{"name":"self"},{"name":"tyctxt"}],"output":{"name":"span"}}],[11,"resolve_type_vars_in_body","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"body"}],"output":{"name":"typecktables"}}],[11,"new","rustc_typeck::check::writeback","",21,{"inputs":[{"name":"fnctxt"},{"name":"body"}],"output":{"name":"writebackcx"}}],[11,"tcx","","",21,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"write_ty_to_tables","","",21,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"ty"}],"output":null}],[11,"fix_scalar_builtin_expr","","",21,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"fix_index_builtin_expr","","",21,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"nested_visit_map","","",21,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_expr","","",21,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_block","","",21,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_pat","","",21,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_local","","",21,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_ty","","",21,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_upvar_borrow_map","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_closures","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_cast_types","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_free_region_map","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_user_provided_tys","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_anon_types","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_field_id","","",21,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"visit_node_id","","",21,{"inputs":[{"name":"self"},{"name":"span"},{"name":"hirid"}],"output":null}],[11,"visit_adjustments","","",21,{"inputs":[{"name":"self"},{"name":"span"},{"name":"hirid"}],"output":null}],[11,"visit_pat_adjustments","","",21,{"inputs":[{"name":"self"},{"name":"span"},{"name":"hirid"}],"output":null}],[11,"visit_liberated_fn_sigs","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"visit_fru_field_types","","",21,{"inputs":[{"name":"self"}],"output":null}],[11,"resolve","","",21,null],[11,"new","","",22,{"inputs":[{"name":"fnctxt"},{"name":"locatable"},{"name":"body"}],"output":{"name":"resolver"}}],[11,"report_error","","",22,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"tcx","","",22,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"fold_ty","","",22,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_region","","",22,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"region"}}],[0,"regionck","rustc_typeck::check","The region check is a final pass that runs over the AST after we have inferred the type constraints but before we have actually finalized the types.  Its purpose is to embed a variety of region constraints. Inserting these constraints as a separate pass is good because (1) it localizes the code that has to do with region inference and (2) often we cannot know what constraints are needed until the basic types have been inferred.",null,null],[3,"RegionCtxt","rustc_typeck::check::regionck","",null,null],[12,"fcx","","",24,null],[12,"region_scope_tree","","",24,null],[12,"outlives_environment","","",24,null],[12,"body_id","","",24,null],[12,"call_site_scope","","",24,null],[12,"repeating_scope","","",24,null],[12,"subject_def_id","","",24,null],[3,"RepeatingScope","","",null,null],[12,"0","","",25,null],[3,"Subject","","",null,null],[12,"0","","",26,null],[11,"regionck_expr","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"regionck_item","","Region checking during the WF phase for items. `wf_tys` are the types from which we should derive implied bounds, if any.",9,null],[11,"regionck_fn","","Region check a function body. Not invoked on closures, but only on the \"root\" fn item (in which closures may be embedded). Walks the function body and adds various add'l constraints that are needed for region inference. This is separated both to isolate \"pure\" region constraints from the rest of type check and because sometimes we need type inference to have completed before we can determine which constraints to add.",9,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"body"}],"output":null}],[11,"deref","rustc_typeck::check::regionck","",24,null],[11,"new","","",24,{"inputs":[{"name":"fnctxt"},{"name":"repeatingscope"},{"name":"nodeid"},{"name":"subject"},{"name":"paramenv"}],"output":{"name":"regionctxt"}}],[11,"set_repeating_scope","","",24,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"resolve_type","","Try to resolve the type for the given node, returning t_err if an error results.  Note that we never care about the details of the error, the same error will be detected and reported in the writeback phase.",24,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"resolve_node_type","","Try to resolve the type for the given node.",24,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"ty"}}],[11,"resolve_expr_type_adjusted","","Try to resolve the type for the given node.",24,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"visit_fn_body","","This is the \"main\" function when region-checking a function item or a closure within a function item. It begins by updating various fields (e.g., `call_site_scope` and `outlives_environment`) to be appropriate to the function and then adds constraints derived from the function body.",24,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"body"},{"name":"span"}],"output":null}],[11,"visit_region_obligations","","",24,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"resolve_regions_and_report_errors","","",24,{"inputs":[{"name":"self"}],"output":null}],[11,"resolve_regions_and_report_errors_unless_nll","","",24,{"inputs":[{"name":"self"}],"output":null}],[11,"constrain_bindings_in_pat","","",24,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"nested_visit_map","","",24,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_fn","","",24,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_arm","","",24,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_local","","",24,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_expr","","",24,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"constrain_cast","","",24,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"}],"output":null}],[11,"walk_cast","","",24,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"},{"name":"ty"}],"output":null}],[11,"check_expr_fn_block","","",24,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"bodyid"}],"output":null}],[11,"constrain_callee","","",24,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"constrain_call","","Invoked on every call site (i.e., normal calls, method calls, and overloaded operators). Constrains the regions which appear in the type of the function. Also constrains the regions that appear in the arguments appropriately.",24,{"inputs":[{"name":"self"},{"name":"expr"},{"generics":["expr"],"name":"option"},{"name":"i"}],"output":null}],[11,"with_mc","","Create a temporary `MemCategorizationContext` and pass it to the closure.",24,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"constrain_adjustments","","Invoked on any adjustments that occur. Checks that if this is a region pointer being dereferenced, the lifetime of the pointer includes the deref expr.",24,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"generics":["cmt_"],"name":"mcresult"}}],[11,"mk_subregion_due_to_dereference","","",24,{"inputs":[{"name":"self"},{"name":"span"},{"name":"region"},{"name":"region"}],"output":null}],[11,"check_safety_of_rvalue_destructor_if_necessary","","",24,{"inputs":[{"name":"self"},{"name":"cmt_"},{"name":"span"}],"output":null}],[11,"constrain_index","","Invoked on any index expression that occurs. Checks that if this is a slice being indexed, the lifetime of the pointer includes the deref expr.",24,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"}],"output":null}],[11,"type_of_node_must_outlive","","Guarantees that any lifetimes which appear in the type of the node `id` (after applying adjustments) are valid for at least `minimum_lifetime`",24,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"hirid"},{"name":"region"}],"output":null}],[11,"type_must_outlive","","Adds constraints to inference such that `T: 'a` holds (or reports an error if it cannot).",24,{"inputs":[{"name":"self"},{"name":"subregionorigin"},{"name":"ty"},{"name":"region"}],"output":null}],[11,"link_addr_of","","Computes the guarantor for an expression `&base` and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",24,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"mutability"},{"name":"expr"}],"output":null}],[11,"link_local","","Computes the guarantors for any ref bindings in a `let` and then ensures that the lifetime of the resulting pointer is linked to the lifetime of the initialization expression.",24,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"link_match","","Computes the guarantors for any ref bindings in a match and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",24,null],[11,"link_fn_args","","Computes the guarantors for any ref bindings in a match and then ensures that the lifetime of the resulting pointer is linked to the lifetime of its guarantor (if any).",24,null],[11,"link_pattern","","Link lifetimes of any ref bindings in `root_pat` to the pointers found in the discriminant, if needed.",24,{"inputs":[{"name":"self"},{"name":"cmt"},{"name":"pat"}],"output":null}],[11,"link_autoref","","Link lifetime of borrowed pointer resulting from autoref to lifetimes in the value being autoref'd.",24,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"cmt_"},{"name":"autoborrow"}],"output":null}],[11,"link_region_from_node_type","","Like `link_region()`, except that the region is extracted from the type of `id`, which must be some reference (`&T`, `&str`, etc).",24,{"inputs":[{"name":"self"},{"name":"span"},{"name":"hirid"},{"name":"mutability"},{"name":"cmt_"}],"output":null}],[11,"link_region","","Informs the inference engine that `borrow_cmt` is being borrowed with kind `borrow_kind` and lifetime `borrow_region`. In order to ensure borrowck is satisfied, this may create constraints between regions, as explained in `link_reborrowed_region()`.",24,{"inputs":[{"name":"self"},{"name":"span"},{"name":"region"},{"name":"borrowkind"},{"name":"cmt_"}],"output":null}],[11,"link_reborrowed_region","","This is the most complicated case: the path being borrowed is itself the referent of a borrowed pointer. Let me give an example fragment of code to make clear(er) the situation:",24,{"inputs":[{"name":"self"},{"name":"span"},{"name":"region"},{"name":"borrowkind"},{"name":"cmt"},{"name":"region"},{"name":"borrowkind"},{"name":"note"}],"output":{"name":"option"}}],[11,"substs_wf_in_scope","","Checks that the values provided for type/region arguments in a given expression are well-formed and in-scope.",24,{"inputs":[{"name":"self"},{"name":"parameterorigin"},{"name":"substs"},{"name":"span"},{"name":"region"}],"output":null}],[0,"coercion","rustc_typeck::check","Type Coercion",null,null],[3,"Coerce","rustc_typeck::check::coercion","",null,null],[12,"fcx","","",27,null],[12,"cause","","",27,null],[12,"use_lub","","",27,null],[12,"allow_two_phase","","Determines whether or not allow_two_phase_borrow is set on any autoref adjustments we create while coercing. We don't want to allow deref coercions to create two-phase borrows, at least initially, but we do need two-phase borrows for function argument reborrows. See #47489 and #48598 See docs on the \"AllowTwoPhase\" type for a more detailed discussion",27,null],[3,"CoerceMany","","CoerceMany encapsulates the pattern you should use when you have many expressions that are all getting coerced to a common type. This arises, for example, when you have a match (the result of each arm is coerced to a common type). It also arises in less obvious places, such as when you have many `break foo` expressions that target the same loop, or the various `return` expressions in a function.",null,null],[12,"expected_ty","","",28,null],[12,"final_ty","","",28,null],[12,"expressions","","",28,null],[12,"pushed","","",28,null],[4,"Expressions","","",null,null],[13,"Dynamic","","",29,null],[13,"UpFront","","",29,null],[5,"coerce_mutbls","","",null,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"relateresult"}}],[5,"identity","","",null,{"inputs":[{"name":"ty"}],"output":{"generics":["adjustment"],"name":"vec"}}],[5,"simple","","",null,null],[5,"success","","",null,{"inputs":[{"generics":["adjustment"],"name":"vec"},{"name":"ty"},{"name":"predicateobligations"}],"output":{"name":"inferresult"}}],[6,"CoerceResult","","",null,null],[6,"DynamicCoerceMany","","The type of a `CoerceMany` that is storing up the expressions into a buffer. We use this in `check/mod.rs` for things like `break`.",null,null],[8,"AsCoercionSite","","Something that can be converted into an expression to which we can apply a coercion.",null,null],[10,"as_coercion_site","","",30,{"inputs":[{"name":"self"}],"output":{"name":"expr"}}],[11,"deref","","",27,null],[11,"new","","",27,{"inputs":[{"name":"fnctxt"},{"name":"obligationcause"},{"name":"allowtwophase"}],"output":{"name":"self"}}],[11,"unify","","",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["ty"],"name":"inferresult"}}],[11,"unify_and","","Unify two types (using sub or lub) and produce a specific coercion.",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"f"}],"output":{"name":"inferresult"}}],[11,"coerce","","",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"name":"inferresult"}}],[11,"coerce_borrowed_pointer","","Reborrows `&mut A` to `&mut B` and `&(mut) A` to `&B`. To match `A` with `B`, autoderef will be performed, calling `deref`/`deref_mut` where necessary.",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"region"},{"name":"typeandmut"}],"output":{"name":"inferresult"}}],[11,"coerce_unsized","","",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"name":"inferresult"}}],[11,"coerce_from_safe_fn","","",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"polyfnsig"},{"name":"ty"},{"name":"f"},{"name":"g"}],"output":{"name":"inferresult"}}],[11,"coerce_from_fn_pointer","","Attempts to coerce from the type of a Rust function item into a closure or a `proc`.",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"polyfnsig"},{"name":"ty"}],"output":{"name":"inferresult"}}],[11,"coerce_from_fn_item","","Attempts to coerce from the type of a Rust function item into a closure or a `proc`.",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"name":"inferresult"}}],[11,"coerce_closure_to_fn","","Attempts to coerce from the type of a non-capturing closure into a function pointer.",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"defid"},{"name":"closuresubsts"},{"name":"ty"}],"output":{"name":"inferresult"}}],[11,"coerce_unsafe_ptr","","",27,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"},{"name":"mutability"}],"output":{"name":"inferresult"}}],[11,"try_coerce","rustc_typeck::check","Attempt to coerce an expression to a type, and return the adjusted type of the expression, if successful. Adjustments are only recorded if the coercion succeeded. The expressions must not have any pre-existing adjustments.",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"},{"name":"ty"},{"name":"allowtwophase"}],"output":{"generics":["ty"],"name":"relateresult"}}],[11,"can_coerce","","Same as `try_coerce()`, but without side-effects.",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"try_find_coercion_lub","","Given some expressions, their known unified type and another expression, tries to unify the types, potentially inserting coercions on any of the provided expressions and returns their LUB (aka \"common supertype\").",9,null],[11,"new","rustc_typeck::check::coercion","The usual case; collect the set of expressions dynamically. If the full set of coercion sites is known before hand, consider `with_coercion_sites()` instead to avoid allocation.",28,{"inputs":[{"name":"ty"}],"output":{"name":"self"}}],[11,"with_coercion_sites","","As an optimization, you can create a `CoerceMany` with a pre-existing slice of expressions. In this case, you are expected to pass each element in the slice to `coerce(...)` in order. This is used with arrays in particular to avoid needlessly cloning the slice.",28,null],[11,"make","","",28,{"inputs":[{"name":"ty"},{"name":"expressions"}],"output":{"name":"self"}}],[11,"expected_ty","","Return the \"expected type\" with which this coercion was constructed.  This represents the \"downward propagated\" type that was given to us at the start of typing whatever construct we are typing (e.g., the match expression).",28,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"merged_ty","","Returns the current \"merged type\", representing our best-guess at the LUB of the expressions we've seen so far (if any). This isn't final until you call `self.final()`, which will return the merged type.",28,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"coerce","","Indicates that the value generated by `expression`, which is of type `expression_ty`, is one of the possibility that we could coerce from. This will record `expression` and later calls to `coerce` may come back and add adjustments and things if necessary.",28,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"obligationcause"},{"name":"expr"},{"name":"ty"},{"name":"diverges"}],"output":null}],[11,"coerce_forced_unit","","Indicates that one of the inputs is a \"forced unit\". This occurs in a case like `if foo { ... };`, where the missing else generates a \"forced unit\". Another example is a `loop { break; }`, where the `break` has no argument expression. We treat these cases slightly differently for error-reporting purposes. Note that these tend to correspond to cases where the `()` expression is implicit in the source, and hence we do not take an expression argument.",28,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"obligationcause"},{"name":"fnmut"},{"name":"bool"}],"output":null}],[11,"coerce_inner","","The inner coercion \"engine\". If `expression` is `None`, this is a forced-unit case, and hence `expression_ty` must be `Nil`.",28,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"obligationcause"},{"generics":["expr"],"name":"option"},{"name":"ty"},{"name":"diverges"},{"generics":["fnmut"],"name":"option"},{"name":"bool"}],"output":null}],[11,"complete","","",28,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"name":"ty"}}],[0,"demand","rustc_typeck::check","",null,null],[11,"demand_suptype","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"ty"}],"output":null}],[11,"demand_suptype_diag","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["diagnosticbuilder"],"name":"option"}}],[11,"demand_eqtype","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"ty"}],"output":null}],[11,"demand_eqtype_diag","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["diagnosticbuilder"],"name":"option"}}],[11,"demand_eqtype_with_origin","","",9,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["diagnosticbuilder"],"name":"option"}}],[11,"demand_coerce","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"},{"name":"ty"},{"name":"allowtwophase"}],"output":{"name":"ty"}}],[11,"demand_coerce_diag","","",9,null],[11,"get_conversion_methods","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"ty"}],"output":{"generics":["associateditem"],"name":"vec"}}],[11,"has_no_input_arg","","",9,{"inputs":[{"name":"self"},{"name":"associateditem"}],"output":{"name":"bool"}}],[11,"check_ref","","This function is used to determine potential \"simple\" improvements or users' errors and provide them useful help. For example:",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"},{"name":"ty"}],"output":{"name":"option"}}],[11,"check_for_cast","","",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"expr"},{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[0,"method","","Method lookup: the secret sauce of Rust. See the [rustc guide] chapter.",null,null],[3,"MethodCallee","rustc_typeck::check::method","",null,null],[12,"def_id","","Impl method ID, for inherent methods, or trait method ID, otherwise.",31,null],[12,"substs","","",31,null],[12,"sig","","Instantiated method signature, i.e. it has been substituted, normalized, and has had late-bound lifetimes replaced with inference variables.",31,null],[3,"NoMatchData","","",null,null],[12,"static_candidates","","",32,null],[12,"unsatisfied_predicates","","",32,null],[12,"out_of_scope_traits","","",32,null],[12,"lev_candidate","","",32,null],[12,"mode","","",32,null],[4,"MethodError","","",null,null],[13,"NoMatch","","",33,null],[13,"Ambiguity","","",33,null],[13,"PrivateMatch","","",33,null],[13,"IllegalSizedBound","","",33,null],[13,"BadReturnType","","",33,null],[4,"CandidateSource","","",null,null],[13,"ImplSource","","",34,null],[13,"TraitSource","","",34,null],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[0,"confirm","","",null,null],[3,"ConfirmContext","rustc_typeck::check::method::confirm","",null,null],[12,"fcx","","",35,null],[12,"span","","",35,null],[12,"self_expr","","",35,null],[12,"call_expr","","",35,null],[3,"ConfirmResult","","",null,null],[12,"callee","","",36,null],[12,"illegal_sized_bound","","",36,null],[11,"deref","","",35,null],[11,"confirm_method","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"expr"},{"name":"expr"},{"name":"ty"},{"name":"pick"},{"name":"pathsegment"}],"output":{"name":"confirmresult"}}],[11,"new","rustc_typeck::check::method::confirm","",35,{"inputs":[{"name":"fnctxt"},{"name":"span"},{"name":"expr"},{"name":"expr"}],"output":{"name":"confirmcontext"}}],[11,"confirm","","",35,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"pick"},{"name":"pathsegment"}],"output":{"name":"confirmresult"}}],[11,"adjust_self_ty","","",35,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"pick"}],"output":{"name":"ty"}}],[11,"fresh_receiver_substs","","Returns a set of substitutions for the method receiver where all type and region parameters are instantiated with fresh variables. This substitution does not include any parameters declared on the method itself.",35,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"pick"}],"output":{"name":"substs"}}],[11,"extract_existential_trait_ref","","",35,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"f"}],"output":{"name":"r"}}],[11,"instantiate_method_substs","","",35,{"inputs":[{"name":"self"},{"name":"pick"},{"name":"pathsegment"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"unify_receivers","","",35,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"ty"}],"output":null}],[11,"instantiate_method_sig","","",35,null],[11,"add_obligations","","",35,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"substs"},{"name":"instantiatedpredicates"}],"output":null}],[11,"convert_place_derefs_to_mutable","","When we select a method with a mutable autoref, we have to go convert any auto-derefs, indices, etc from `Deref` and `Index` into `DerefMut` and `IndexMut` respectively.",35,{"inputs":[{"name":"self"}],"output":null}],[11,"convert_place_op_to_mutable","","",35,null],[11,"predicates_require_illegal_sized_bound","","",35,{"inputs":[{"name":"self"},{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"enforce_illegal_method_limitations","","",35,{"inputs":[{"name":"self"},{"name":"pick"}],"output":null}],[11,"upcast","","",35,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"defid"}],"output":{"name":"polytraitref"}}],[11,"replace_late_bound_regions_with_fresh_var","","",35,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"t"}}],[0,"probe","rustc_typeck::check::method","",null,null],[3,"IsSuggestion","rustc_typeck::check::method::probe","Boolean flag used to indicate if this search is for a suggestion or not.  If true, we can allow ambiguity and so forth.",null,null],[12,"0","","",37,null],[3,"ProbeContext","","",null,null],[12,"fcx","","",38,null],[12,"span","","",38,null],[12,"mode","","",38,null],[12,"method_name","","",38,null],[12,"return_type","","",38,null],[12,"steps","","",38,null],[12,"inherent_candidates","","",38,null],[12,"extension_candidates","","",38,null],[12,"impl_dups","","",38,null],[12,"static_candidates","","Collects near misses when the candidate functions are missing a `self` keyword and is only used for error reporting",38,null],[12,"allow_similar_names","","When probing for names, include names that are close to the requested name (by Levensthein distance)",38,null],[12,"private_candidate","","Some(candidate) if there is a private candidate",38,null],[12,"unsatisfied_predicates","","Collects near misses when trait bounds for type parameters are unsatisfied and is only used for error reporting",38,null],[12,"is_suggestion","","",38,null],[3,"CandidateStep","","",null,null],[12,"self_ty","","",39,null],[12,"autoderefs","","",39,null],[12,"from_unsafe_deref","","",39,null],[12,"unsize","","",39,null],[3,"Candidate","","",null,null],[12,"xform_self_ty","","",40,null],[12,"xform_ret_ty","","",40,null],[12,"item","","",40,null],[12,"kind","","",40,null],[12,"import_id","","",40,null],[3,"Pick","","",null,null],[12,"item","","",41,null],[12,"kind","","",41,null],[12,"import_id","","",41,null],[12,"autoderefs","","",41,null],[12,"autoref","","",41,null],[12,"unsize","","",41,null],[4,"CandidateKind","","",null,null],[13,"InherentImplCandidate","","",42,null],[13,"ObjectCandidate","","",42,null],[13,"TraitCandidate","","",42,null],[13,"WhereClauseCandidate","","",42,null],[4,"ProbeResult","","",null,null],[13,"NoMatch","","",43,null],[13,"BadReturnType","","",43,null],[13,"Match","","",43,null],[4,"PickKind","","",null,null],[13,"InherentImplPick","","",44,null],[13,"ObjectPick","","",44,null],[13,"TraitPick","","",44,null],[13,"WhereClausePick","","",44,null],[4,"Mode","","",null,null],[13,"MethodCall","","",45,null],[13,"Path","","",45,null],[4,"ProbeScope","","",null,null],[13,"TraitsInScope","","",46,null],[13,"AllTraits","","",46,null],[6,"PickResult","","",null,null],[11,"clone","","",37,{"inputs":[{"name":"self"}],"output":{"name":"issuggestion"}}],[11,"deref","","",38,null],[11,"fmt","","",39,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",40,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",42,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",43,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",43,{"inputs":[{"name":"self"},{"name":"proberesult"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",43,null],[11,"clone","","",43,{"inputs":[{"name":"self"}],"output":{"name":"proberesult"}}],[11,"fmt","","",41,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",41,{"inputs":[{"name":"self"},{"name":"pick"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"self"},{"name":"pick"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",41,null],[11,"clone","","",41,{"inputs":[{"name":"self"}],"output":{"name":"pick"}}],[11,"clone","","",44,{"inputs":[{"name":"self"}],"output":{"name":"pickkind"}}],[11,"fmt","","",44,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",44,{"inputs":[{"name":"self"},{"name":"pickkind"}],"output":{"name":"bool"}}],[11,"ne","","",44,{"inputs":[{"name":"self"},{"name":"pickkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",44,null],[11,"eq","","",45,{"inputs":[{"name":"self"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",45,null],[11,"clone","","",45,{"inputs":[{"name":"self"}],"output":{"name":"mode"}}],[11,"fmt","","",45,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",46,{"inputs":[{"name":"self"},{"name":"probescope"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",46,null],[11,"clone","","",46,{"inputs":[{"name":"self"}],"output":{"name":"probescope"}}],[11,"fmt","","",46,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"probe_for_return_type","rustc_typeck::check","This is used to offer suggestions to users. It returns methods that could have been called which have the desired return type. Some effort is made to rule out methods that, if called, would result in an error (basically, the same criteria we would use to decide if a method is a plausible fit for ambiguity purposes).",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"mode"},{"name":"ty"},{"name":"ty"},{"name":"nodeid"}],"output":{"generics":["associateditem"],"name":"vec"}}],[11,"probe_for_name","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"mode"},{"name":"name"},{"name":"issuggestion"},{"name":"ty"},{"name":"nodeid"},{"name":"probescope"}],"output":{"generics":["pick","methoderror"],"name":"result"}}],[11,"probe_op","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"mode"},{"generics":["name"],"name":"option"},{"generics":["ty"],"name":"option"},{"name":"issuggestion"},{"name":"ty"},{"name":"nodeid"},{"name":"probescope"},{"name":"op"}],"output":{"generics":["methoderror"],"name":"result"}}],[11,"create_steps","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"name":"ty"},{"name":"issuggestion"}],"output":{"generics":["vec"],"name":"option"}}],[11,"new","rustc_typeck::check::method::probe","",38,{"inputs":[{"name":"fnctxt"},{"name":"span"},{"name":"mode"},{"generics":["name"],"name":"option"},{"generics":["ty"],"name":"option"},{"generics":["vec"],"name":"rc"},{"name":"issuggestion"}],"output":{"name":"probecontext"}}],[11,"reset","","",38,{"inputs":[{"name":"self"}],"output":null}],[11,"push_candidate","","",38,{"inputs":[{"name":"self"},{"name":"candidate"},{"name":"bool"}],"output":null}],[11,"assemble_inherent_candidates","","",38,{"inputs":[{"name":"self"}],"output":null}],[11,"assemble_probe","","",38,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"assemble_inherent_impl_for_primitive","","",38,{"inputs":[{"name":"self"},{"generics":["defid"],"name":"option"}],"output":null}],[11,"assemble_inherent_impl_candidates_for_type","","",38,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"assemble_inherent_impl_probe","","",38,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"assemble_inherent_candidates_from_object","","",38,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"polyexistentialtraitref"}],"output":null}],[11,"assemble_inherent_candidates_from_param","","",38,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"paramty"}],"output":null}],[11,"elaborate_bounds","","",38,null],[11,"assemble_extension_candidates_for_traits_in_scope","","",38,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["methoderror"],"name":"result"}}],[11,"assemble_extension_candidates_for_all_traits","","",38,{"inputs":[{"name":"self"}],"output":{"generics":["methoderror"],"name":"result"}}],[11,"matches_return_type","","",38,{"inputs":[{"name":"self"},{"name":"associateditem"},{"generics":["ty"],"name":"option"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"assemble_extension_candidates_for_trait","","",38,{"inputs":[{"name":"self"},{"generics":["nodeid"],"name":"option"},{"name":"defid"}],"output":{"generics":["methoderror"],"name":"result"}}],[11,"candidate_method_names","","",38,{"inputs":[{"name":"self"}],"output":{"generics":["name"],"name":"vec"}}],[11,"pick","","",38,{"inputs":[{"name":"self"}],"output":{"generics":["pick","methoderror"],"name":"result"}}],[11,"pick_core","","",38,{"inputs":[{"name":"self"}],"output":{"generics":["result"],"name":"option"}}],[11,"pick_by_value_method","","For each type `T` in the step list, this attempts to find a method where the (transformed) self type is exactly `T`. We do however do one transformation on the adjustment: if we are passing a region pointer in, we will potentially reborrow it to a shorter lifetime. This allows us to transparently pass `&mut` pointers, in particular, without consuming them for their entire lifetime.",38,{"inputs":[{"name":"self"},{"name":"candidatestep"}],"output":{"generics":["result"],"name":"option"}}],[11,"pick_autorefd_method","","",38,{"inputs":[{"name":"self"},{"name":"candidatestep"},{"name":"mutability"}],"output":{"generics":["result"],"name":"option"}}],[11,"pick_method","","",38,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"generics":["result"],"name":"option"}}],[11,"consider_candidates","","",38,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"probesiter"},{"name":"vec"},{"generics":["vec"],"name":"option"}],"output":{"generics":["result"],"name":"option"}}],[11,"emit_unstable_name_collision_hint","","",38,null],[11,"select_trait_candidate","","",38,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"generics":["selection"],"name":"selectionresult"}}],[11,"candidate_source","","",38,{"inputs":[{"name":"self"},{"name":"candidate"},{"name":"ty"}],"output":{"name":"candidatesource"}}],[11,"consider_probe","","",38,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"candidate"},{"name":"vec"}],"output":{"name":"proberesult"}}],[11,"collapse_candidates_to_trait_pick","","Sometimes we get in a situation where we have multiple probes that are all impls of the same trait, but we don't know which impl to use. In this case, since in all cases the external interface of the method can be determined from the trait, it's ok not to decide. We can basically just collapse all of the probes for various impls into one where-clause probe. This will result in a pending obligation so when more type-info is available we can make the final decision.",38,null],[11,"probe_for_lev_candidate","","Similarly to `probe_for_return_type`, this method attempts to find the best matching candidate method where the method name may have been misspelt. Similarly to other Levenshtein based suggestions, we provide at most one such suggestion.",38,{"inputs":[{"name":"self"}],"output":{"generics":["option","methoderror"],"name":"result"}}],[11,"has_applicable_self","","",38,{"inputs":[{"name":"self"},{"name":"associateditem"}],"output":{"name":"bool"}}],[11,"record_static_candidate","","",38,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":null}],[11,"xform_self_ty","","",38,null],[11,"xform_method_sig","","",38,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"substs"}],"output":{"name":"fnsig"}}],[11,"impl_ty_and_substs","","Get the type of an impl and generate substitutions with placeholders.",38,null],[11,"fresh_item_substs","","",38,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"name":"substs"}}],[11,"erase_late_bound_regions","","Replace late-bound-regions bound by `value` with `'static` using `ty::erase_late_bound_regions`.",38,{"inputs":[{"name":"self"},{"name":"binder"}],"output":{"name":"t"}}],[11,"impl_or_trait_item","","Find the method with the appropriate name (or return type, as the case may be). If `allow_similar_names` is set, find methods with close-matching names.",38,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["associateditem"],"name":"vec"}}],[11,"to_unadjusted_pick","","",40,{"inputs":[{"name":"self"}],"output":{"name":"pick"}}],[0,"suggest","rustc_typeck::check::method","Give useful errors and suggestions to users when an item can't be found or is otherwise invalid.",null,null],[3,"TraitInfo","rustc_typeck::check::method::suggest","",null,null],[12,"def_id","","",47,null],[3,"UsePlacementFinder","","",null,null],[12,"target_module","","",48,null],[12,"span","","",48,null],[12,"found_use","","",48,null],[12,"tcx","","",48,null],[5,"all_traits","","Retrieve all traits in this crate and any dependent crates.",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["traitinfo"],"name":"vec"}}],[5,"compute_all_traits","","Compute all traits in this crate and any dependent crates.",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["defid"],"name":"vec"}}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[11,"is_fn_ty","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"name":"bool"}}],[11,"report_method_error","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"name":"name"},{"generics":["expr"],"name":"option"},{"name":"methoderror"},{"name":"option"}],"output":null}],[11,"suggest_use_candidates","","",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"string"},{"generics":["defid"],"name":"vec"}],"output":null}],[11,"suggest_valid_traits","","",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"generics":["defid"],"name":"vec"}],"output":{"name":"bool"}}],[11,"suggest_traits_to_import","","",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"span"},{"name":"ty"},{"name":"name"},{"generics":["expr"],"name":"option"},{"generics":["defid"],"name":"vec"}],"output":null}],[11,"type_derefs_to_local","","Checks whether there is a local type somewhere in the chain of autoderefs of `rcvr_ty`.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"},{"generics":["expr"],"name":"option"}],"output":{"name":"bool"}}],[11,"clone","rustc_typeck::check::method::suggest","",47,{"inputs":[{"name":"self"}],"output":{"name":"traitinfo"}}],[11,"eq","","",47,{"inputs":[{"name":"self"},{"name":"traitinfo"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",47,{"inputs":[{"name":"self"},{"name":"traitinfo"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",47,{"inputs":[{"name":"self"},{"name":"traitinfo"}],"output":{"name":"ordering"}}],[11,"check","","",48,null],[11,"visit_mod","","",48,{"inputs":[{"name":"self"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"nested_visit_map","","",48,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"clone","rustc_typeck::check::method","",31,{"inputs":[{"name":"self"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",32,{"inputs":[{"generics":["candidatesource"],"name":"vec"},{"generics":["traitref"],"name":"vec"},{"generics":["defid"],"name":"vec"},{"generics":["associateditem"],"name":"option"},{"name":"mode"}],"output":{"name":"self"}}],[11,"clone","","",34,{"inputs":[{"name":"self"}],"output":{"name":"candidatesource"}}],[11,"fmt","","",34,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",34,null],[11,"cmp","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"ordering"}}],[11,"eq","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"bool"}}],[11,"le","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"bool"}}],[11,"gt","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"bool"}}],[11,"ge","","",34,{"inputs":[{"name":"self"},{"name":"candidatesource"}],"output":{"name":"bool"}}],[11,"method_exists","rustc_typeck::check","Determines whether the type `self_ty` supports a method name `method_name` or not.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"ty"},{"name":"nodeid"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"lookup_method","","Performs method lookup. If lookup is successful, it will return the callee and store an appropriate adjustment for the self-expr. In some cases it may report an error (e.g., invoking the `drop` method).",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"pathsegment"},{"name":"span"},{"name":"expr"},{"name":"expr"}],"output":{"generics":["methodcallee","methoderror"],"name":"result"}}],[11,"lookup_probe","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"ty"},{"name":"expr"},{"name":"probescope"}],"output":{"generics":["pick","methoderror"],"name":"result"}}],[11,"lookup_method_in_trait","","`lookup_method_in_trait` is used for overloaded operators. It does a very narrow slice of what the normal probe/confirm path does. In particular, it doesn't really do any probing: it simply constructs an obligation for a particular trait with the given self-type and checks whether that trait is implemented.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"defid"},{"name":"ty"},{"name":"option"}],"output":{"generics":["inferok"],"name":"option"}}],[11,"resolve_ufcs","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"ty"},{"name":"nodeid"}],"output":{"generics":["def","methoderror"],"name":"result"}}],[11,"associated_item","","Find item with name `item_name` defined in impl/trait `def_id` and return it, or `None`, if no such item was defined there.",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"name"},{"name":"namespace"}],"output":{"generics":["associateditem"],"name":"option"}}],[0,"upvar","","Inferring borrow kinds for upvars",null,null],[3,"InferBorrowKindVisitor","rustc_typeck::check::upvar","",null,null],[12,"fcx","","",49,null],[3,"InferBorrowKind","","",null,null],[12,"fcx","","",50,null],[12,"closure_def_id","","",50,null],[12,"current_closure_kind","","",50,null],[12,"current_origin","","",50,null],[12,"adjust_upvar_captures","","",50,null],[5,"var_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"hirid"}],"output":{"name":"name"}}],[11,"closure_analyze","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"body"}],"output":null}],[11,"nested_visit_map","rustc_typeck::check::upvar","",49,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_expr","","",49,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"analyze_closure","rustc_typeck::check","Analysis starting point.",9,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"hirid"},{"name":"span"},{"name":"body"},{"name":"captureclause"},{"generics":["generatormovability"],"name":"option"}],"output":null}],[11,"final_upvar_tys","","",9,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["ty"],"name":"vec"}}],[11,"adjust_upvar_borrow_kind_for_consume","rustc_typeck::check::upvar","",50,{"inputs":[{"name":"self"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"adjust_upvar_borrow_kind_for_mut","","Indicates that `cmt` is being directly mutated (e.g., assigned to). If cmt contains any by-ref upvars, this implies that those upvars must be borrowed using an `&mut` borrow.",50,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":null}],[11,"adjust_upvar_borrow_kind_for_unique","","",50,{"inputs":[{"name":"self"},{"name":"cmt_"}],"output":null}],[11,"try_adjust_upvar_deref","","",50,{"inputs":[{"name":"self"},{"name":"cmt_"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"adjust_upvar_borrow_kind","","We infer the borrow_kind with which to borrow upvars in a stack closure. The borrow_kind basically follows a lattice of `imm < unique-imm < mut`, moving from left to right as needed (but never right to left). Here the argument `mutbl` is the borrow_kind that is required by some particular use.",50,{"inputs":[{"name":"self"},{"name":"upvarid"},{"name":"borrowkind"}],"output":null}],[11,"adjust_closure_kind","","",50,{"inputs":[{"name":"self"},{"name":"localdefid"},{"name":"closurekind"},{"name":"span"},{"name":"name"}],"output":null}],[11,"consume","","",50,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"matched_pat","","",50,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"matchmode"}],"output":null}],[11,"consume_pat","","",50,{"inputs":[{"name":"self"},{"name":"pat"},{"name":"cmt_"},{"name":"consumemode"}],"output":null}],[11,"borrow","","",50,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[11,"decl_without_init","","",50,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"mutate","","",50,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"cmt_"},{"name":"mutatemode"}],"output":null}],[0,"wfcheck","rustc_typeck::check","",null,null],[3,"CheckWfFcxBuilder","rustc_typeck::check::wfcheck","Helper type of a temporary returned by .for_item(...). Necessary because we can't write the following bound: F: for<'b, 'tcx> where 'gcx: 'tcx FnOnce(FnCtxt<'b, 'gcx, 'tcx>).",null,null],[12,"inherited","","",51,null],[12,"id","","",51,null],[12,"span","","",51,null],[12,"param_env","","",51,null],[3,"CheckTypeWellFormedVisitor","","",null,null],[12,"tcx","","",52,null],[3,"AdtVariant","","",null,null],[12,"fields","","",53,null],[3,"AdtField","","",null,null],[12,"ty","","",54,null],[12,"span","","",54,null],[5,"check_item_well_formed","","Checks that the field types (in a struct def'n) or argument types (in an enum def'n) are well-formed, meaning that they do not require any constraints not declared in the struct definition itself. For example, this definition would be illegal:",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"check_trait_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"check_impl_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"check_associated_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"span"},{"generics":["methodsig"],"name":"option"}],"output":null}],[5,"for_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"}],"output":{"name":"checkwffcxbuilder"}}],[5,"for_id","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"},{"name":"span"}],"output":{"name":"checkwffcxbuilder"}}],[5,"check_type_defn","","In a type definition, we check that to ensure that the types of the fields are well-formed.",null,{"inputs":[{"name":"tyctxt"},{"name":"item"},{"name":"bool"},{"name":"f"}],"output":null}],[5,"check_trait","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"}],"output":null}],[5,"check_item_fn","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"}],"output":null}],[5,"check_item_type","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"}],"output":null}],[5,"check_impl","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"},{"name":"ty"},{"name":"option"}],"output":null}],[5,"check_where_clauses","","Checks where clauses and inline bounds that are declared on def_id.",null,{"inputs":[{"name":"tyctxt"},{"name":"fnctxt"},{"name":"span"},{"name":"defid"}],"output":null}],[5,"check_fn_or_method","","",null,{"inputs":[{"name":"tyctxt"},{"name":"fnctxt"},{"name":"span"},{"name":"polyfnsig"},{"name":"defid"},{"name":"vec"}],"output":null}],[5,"check_method_receiver","","",null,{"inputs":[{"name":"fnctxt"},{"name":"methodsig"},{"name":"associateditem"},{"name":"ty"}],"output":null}],[5,"check_variances_for_type_defn","","",null,{"inputs":[{"name":"tyctxt"},{"name":"item"},{"name":"generics"}],"output":null}],[5,"report_bivariance","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"name"}],"output":null}],[5,"reject_shadowing_type_parameters","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"error_392","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"name"}],"output":{"name":"diagnosticbuilder"}}],[5,"error_194","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"span"},{"name":"str"}],"output":null}],[11,"with_fcx","","",51,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"new","","",52,{"inputs":[{"name":"tyctxt"}],"output":{"name":"checktypewellformedvisitor"}}],[11,"nested_visit_map","","",52,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",52,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",52,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",52,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"non_enum_variant","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"adtvariant"}}],[11,"enum_variants","","",9,{"inputs":[{"name":"self"},{"name":"enumdef"}],"output":{"generics":["adtvariant"],"name":"vec"}}],[11,"impl_implied_bounds","","",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"span"}],"output":{"generics":["ty"],"name":"vec"}}],[0,"cast","","Code for type-checking cast expressions.",null,null],[3,"CastCheck","rustc_typeck::check::cast","Reifies a cast check to be checked once we have full type information for a function context.",null,null],[12,"expr","","",55,null],[12,"expr_ty","","",55,null],[12,"cast_ty","","",55,null],[12,"cast_span","","",55,null],[12,"span","","",55,null],[4,"PointerKind","","The kind of pointer and associated metadata (thin, length or vtable) - we only allow casts between fat pointers if their metadata have the same kind.",null,null],[13,"Thin","","No metadata attached, ie pointer to sized type or foreign type",56,null],[13,"Vtable","","A trait object",56,null],[13,"Length","","Slice",56,null],[13,"OfProjection","","The unsize info of this projection",56,null],[13,"OfAnon","","The unsize info of this anon ty",56,null],[13,"OfParam","","The unsize info of this parameter",56,null],[4,"CastError","","",null,null],[13,"ErrorReported","","",57,null],[13,"CastToBool","","",57,null],[13,"CastToChar","","",57,null],[13,"DifferingKinds","","",57,null],[13,"SizedUnsizedCast","","Cast of thin to fat raw ptr (eg. `*const () as *const [u8]`)",57,null],[13,"IllegalCast","","",57,null],[13,"NeedDeref","","",57,null],[13,"NeedViaPtr","","",57,null],[13,"NeedViaThinPtr","","",57,null],[13,"NeedViaInt","","",57,null],[13,"NonScalar","","",57,null],[13,"UnknownExprPtrKind","","",57,null],[13,"UnknownCastPtrKind","","",57,null],[5,"make_invalid_casting_error","","",null,{"inputs":[{"name":"session"},{"name":"span"},{"name":"ty"},{"name":"ty"},{"name":"fnctxt"}],"output":{"name":"diagnosticbuilder"}}],[11,"clone","","",56,{"inputs":[{"name":"self"}],"output":{"name":"pointerkind"}}],[11,"eq","","",56,{"inputs":[{"name":"self"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"self"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",56,null],[11,"pointer_kind","rustc_typeck::check","Returns the kind of unsize information of t, or None if t is unknown.",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"generics":["option","errorreported"],"name":"result"}}],[11,"clone","rustc_typeck::check::cast","",57,{"inputs":[{"name":"self"}],"output":{"name":"casterror"}}],[11,"from","","",57,{"inputs":[{"name":"errorreported"}],"output":{"name":"self"}}],[11,"new","","",55,{"inputs":[{"name":"fnctxt"},{"name":"expr"},{"name":"ty"},{"name":"ty"},{"name":"span"},{"name":"span"}],"output":{"generics":["castcheck","errorreported"],"name":"result"}}],[11,"report_cast_error","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"casterror"}],"output":null}],[11,"report_cast_to_unsized_type","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":null}],[11,"trivial_cast_lint","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":null}],[11,"check","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":null}],[11,"do_check","","Check a cast, and report an error if one exists. In some cases, this can return Ok and create type errors in the fcx rather than returning directly. coercion-cast is handled in check instead of here.",55,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"generics":["castkind","casterror"],"name":"result"}}],[11,"check_ptr_ptr_cast","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"typeandmut"},{"name":"typeandmut"}],"output":{"generics":["castkind","casterror"],"name":"result"}}],[11,"check_fptr_ptr_cast","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"typeandmut"}],"output":{"generics":["castkind","casterror"],"name":"result"}}],[11,"check_ptr_addr_cast","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"typeandmut"}],"output":{"generics":["castkind","casterror"],"name":"result"}}],[11,"check_ref_cast","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"typeandmut"},{"name":"typeandmut"}],"output":{"generics":["castkind","casterror"],"name":"result"}}],[11,"check_addr_ptr_cast","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"typeandmut"}],"output":{"generics":["castkind","casterror"],"name":"result"}}],[11,"try_coercion_cast","","",55,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"name":"bool"}}],[11,"type_is_known_to_be_sized","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"}],"output":{"name":"bool"}}],[0,"closure","","Code for type-checking closure expressions.",null,null],[3,"ExpectedSig","rustc_typeck::check::closure","What signature do we expect the closure to have from context?",null,null],[12,"cause_span","","Span that gave us this expectation, if we know that.",58,null],[12,"sig","","",58,null],[3,"ClosureSignatures","","",null,null],[12,"bound_sig","","",59,null],[12,"liberated_sig","","",59,null],[11,"fmt","","",58,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"check_expr_closure","rustc_typeck::check","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"captureclause"},{"name":"fndecl"},{"name":"bodyid"},{"generics":["generatormovability"],"name":"option"},{"name":"expectation"}],"output":{"name":"ty"}}],[11,"check_closure","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"generics":["closurekind"],"name":"option"},{"name":"fndecl"},{"name":"body"},{"generics":["generatormovability"],"name":"option"},{"generics":["expectedsig"],"name":"option"}],"output":{"name":"ty"}}],[11,"deduce_expectations_from_expected_type","","Given the expected type, figures out what it can about this closure we are about to type check:",9,null],[11,"deduce_expectations_from_obligations","","",9,null],[11,"deduce_sig_from_projection","","Given a projection like \"<F as Fn(X)>::Result == Y\", we can deduce everything we need to know about a closure.",9,{"inputs":[{"name":"self"},{"generics":["span"],"name":"option"},{"name":"polyprojectionpredicate"}],"output":{"generics":["expectedsig"],"name":"option"}}],[11,"self_type_matches_expected_vid","","",9,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"tyvid"}],"output":{"generics":["polytraitref"],"name":"option"}}],[11,"sig_of_closure","","",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"fndecl"},{"name":"body"},{"generics":["expectedsig"],"name":"option"}],"output":{"name":"closuresignatures"}}],[11,"sig_of_closure_no_expectation","","If there is no expected signature, then we will convert the types that the user gave into a signature.",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"fndecl"},{"name":"body"}],"output":{"name":"closuresignatures"}}],[11,"sig_of_closure_with_expectation","","Invoked to compute the signature of a closure expression. This combines any user-provided type annotations (e.g., `|x: u32| -> u32 { .. }`) with the expected signature.",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"fndecl"},{"name":"body"},{"name":"expectedsig"}],"output":{"name":"closuresignatures"}}],[11,"sig_of_closure_with_mismatched_number_of_arguments","","",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"fndecl"},{"name":"body"},{"name":"expectedsig"}],"output":{"name":"closuresignatures"}}],[11,"check_supplied_sig_against_expectation","","Enforce the user's types against the expectation.  See `sig_of_closure_with_expectation` for details on the overall strategy.",9,{"inputs":[{"name":"self"},{"name":"fndecl"},{"name":"closuresignatures"}],"output":{"name":"inferresult"}}],[11,"supplied_sig_of_closure","","If there is no expected signature, then we will convert the types that the user gave into a signature.",9,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"polyfnsig"}}],[11,"error_sig_of_closure","","Converts the types that the user supplied, in case that doing so should yield an error, but returns back a signature where all parameters are of type `TyErr`.",9,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"polyfnsig"}}],[11,"closure_sigs","","",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"body"},{"name":"polyfnsig"}],"output":{"name":"closuresignatures"}}],[0,"callee","","",null,null],[3,"DeferredCallResolution","rustc_typeck::check::callee","",null,null],[12,"call_expr","","",60,null],[12,"callee_expr","","",60,null],[12,"adjusted_ty","","",60,null],[12,"adjustments","","",60,null],[12,"fn_sig","","",60,null],[12,"closure_def_id","","",60,null],[12,"closure_substs","","",60,null],[4,"CallStep","","",null,null],[13,"Builtin","","",61,null],[13,"DeferredClosure","","",61,null],[13,"Overloaded","","e.g. enum variant constructors",61,null],[5,"check_legal_trait_for_method_call","","Check that it is legal to call methods of the trait corresponding to `trait_id` (this only cares about the trait, not the specific method that is called)",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"defid"}],"output":null}],[11,"check_call","rustc_typeck::check","",9,null],[11,"try_overloaded_call_step","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"name":"autoderef"}],"output":{"generics":["callstep"],"name":"option"}}],[11,"try_overloaded_call_traits","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"}],"output":{"name":"option"}}],[11,"confirm_builtin_call","","",9,null],[11,"confirm_deferred_closure_call","","",9,null],[11,"confirm_overloaded_call","","",9,null],[11,"fmt","rustc_typeck::check::callee","",60,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"resolve","","",60,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":null}],[0,"compare_method","rustc_typeck::check","",null,null],[5,"compare_impl_method","rustc_typeck::check::compare_method","Checks that a method from an impl conforms to the signature of the same method as declared in the trait.",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"name":"traitref"},{"generics":["span"],"name":"option"}],"output":null}],[5,"compare_predicate_entailment","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"name":"traitref"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"check_region_bounds_on_impl_method","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"associateditem"},{"name":"associateditem"},{"name":"generics"},{"name":"generics"},{"name":"substs"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"extract_spans_for_error_reporting","","",null,null],[5,"compare_self_type","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"name":"traitref"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"compare_number_of_generics","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"generics":["span"],"name":"option"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"compare_number_of_method_arguments","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"generics":["span"],"name":"option"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"compare_synthetic_generics","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"generics":["span"],"name":"option"}],"output":{"generics":["errorreported"],"name":"result"}}],[5,"compare_const_impl","","",null,{"inputs":[{"name":"tyctxt"},{"name":"associateditem"},{"name":"span"},{"name":"associateditem"},{"name":"traitref"}],"output":null}],[0,"generator_interior","rustc_typeck::check","This calculates the types which has storage which lives across a suspension point in a generator from the perspective of typeck. The actual types used at runtime is calculated in `rustc_mir::transform::generator` and may be a subset of the types computed here.",null,null],[3,"InteriorVisitor","rustc_typeck::check::generator_interior","",null,null],[12,"fcx","","",62,null],[12,"types","","",62,null],[12,"region_scope_tree","","",62,null],[12,"expr_count","","",62,null],[5,"resolve_interior","","",null,{"inputs":[{"name":"fnctxt"},{"name":"defid"},{"name":"bodyid"},{"name":"generatorinterior"}],"output":null}],[11,"record","","",62,{"inputs":[{"name":"self"},{"name":"ty"},{"generics":["scope"],"name":"option"},{"generics":["expr"],"name":"option"},{"name":"span"}],"output":null}],[11,"nested_visit_map","","",62,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_pat","","",62,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",62,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[0,"intrinsic","rustc_typeck::check","Type-checking for the rust-intrinsic and platform-intrinsic intrinsics that the compiler exposes.",null,null],[5,"equate_intrinsic_type","rustc_typeck::check::intrinsic","",null,{"inputs":[{"name":"tyctxt"},{"name":"foreignitem"},{"name":"usize"},{"name":"abi"},{"generics":["ty"],"name":"vec"},{"name":"ty"}],"output":null}],[5,"check_intrinsic_type","","Remember to add all intrinsics here, in librustc_trans/trans/intrinsic.rs, and in libcore/intrinsics.rs",null,{"inputs":[{"name":"tyctxt"},{"name":"foreignitem"}],"output":null}],[5,"check_platform_intrinsic_type","","Type-check `extern \"platform-intrinsic\" { ... }` functions.",null,{"inputs":[{"name":"tyctxt"},{"name":"foreignitem"}],"output":null}],[5,"match_intrinsic_type_to_type","","",null,{"inputs":[{"name":"tyctxt"},{"name":"str"},{"name":"span"},{"name":"fxhashmap"},{"name":"type"},{"name":"ty"}],"output":null}],[0,"op","rustc_typeck::check","Code related to processing overloaded binary and unary operators.",null,null],[4,"BinOpCategory","rustc_typeck::check::op","",null,null],[13,"Shortcircuit","","&&, || -- cannot be overridden",63,null],[13,"Shift","","<<, >> -- when shifting a single integer, rhs can be any integer type. For simd, types must match.",63,null],[13,"Math","","+, -, etc -- takes equal types, produces same type as input, applicable to ints/floats/simd",63,null],[13,"Bitwise","","&, |, ^ -- takes equal types, produces same type as input, applicable to ints/floats/simd/bool",63,null],[13,"Comparison","","==, !=, etc -- takes equal types, produces bools, except for simd, which produce the input type",63,null],[4,"IsAssign","","Whether the binary operation is an assignment (`a += b`), or not (`a + b`)",null,null],[13,"No","","",64,null],[13,"Yes","","",64,null],[4,"Op","","",null,null],[13,"Binary","","",65,null],[13,"Unary","","",65,null],[5,"is_builtin_binop","","Returns true if this is a built-in arithmetic operation (e.g. u32 + u32, i16x4 == i16x4) and false if these types would have to be overloaded to be legal. There are two reasons that we distinguish builtin operations from overloaded ones (vs trying to drive everything uniformly through the trait system and intrinsics or something like that):",null,{"inputs":[{"name":"ty"},{"name":"ty"},{"name":"binop"}],"output":{"name":"bool"}}],[11,"check_binop_assign","rustc_typeck::check","Check a `a <op>= b`",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"binop"},{"name":"expr"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"check_binop","","Check a potentially overloaded binary operator.",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"binop"},{"name":"expr"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"enforce_builtin_binop_types","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"},{"name":"expr"},{"name":"ty"},{"name":"binop"}],"output":{"name":"ty"}}],[11,"check_overloaded_binop","","",9,null],[11,"check_str_addition","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"name":"expr"},{"name":"ty"},{"name":"ty"},{"name":"diagnosticbuilder"}],"output":{"name":"bool"}}],[11,"check_user_unop","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"},{"name":"unop"}],"output":{"name":"ty"}}],[11,"lookup_op_method","","",9,null],[11,"from","rustc_typeck::check::op","",63,{"inputs":[{"name":"binop"}],"output":{"name":"binopcategory"}}],[11,"clone","","",64,{"inputs":[{"name":"self"}],"output":{"name":"isassign"}}],[11,"fmt","","",64,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",64,{"inputs":[{"name":"self"},{"name":"isassign"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"self"}],"output":{"name":"op"}}],[11,"fmt","","",65,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","rustc_typeck::check","",4,{"inputs":[{"name":"self"}],"output":{"name":"maybeinprogresstables"}}],[11,"borrow","","",4,{"inputs":[{"name":"self"}],"output":{"generics":["typecktables"],"name":"ref"}}],[11,"borrow_mut","","",4,{"inputs":[{"name":"self"}],"output":{"generics":["typecktables"],"name":"refmut"}}],[11,"deref","","",5,null],[11,"clone","","",14,{"inputs":[{"name":"self"}],"output":{"name":"expectation"}}],[11,"fmt","","",14,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"adjust_for_branches","","",14,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"name":"expectation"}}],[11,"rvalue_hint","","Provide an expectation for an rvalue expression given an optional hint, which is not required for type safety (the resulting type might be checked higher up, as is the case with `&expr` and `box expr`), but is useful in determining the concrete type.",14,{"inputs":[{"name":"fnctxt"},{"name":"ty"}],"output":{"name":"expectation"}}],[11,"resolve","","",14,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"name":"expectation"}}],[11,"to_option","","",14,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"generics":["ty"],"name":"option"}}],[11,"only_has_type","","It sometimes happens that we want to turn an expectation into a hard constraint (i.e., something that must be satisfied for the program to type-check). `only_has_type` will return such a constraint, if it exists.",14,{"inputs":[{"name":"self"},{"name":"fnctxt"}],"output":{"generics":["ty"],"name":"option"}}],[11,"coercion_target_type","","Like `only_has_type`, but instead of returning `None` if no hard constraint exists, creates a fresh type variable.",14,{"inputs":[{"name":"self"},{"name":"fnctxt"},{"name":"span"}],"output":{"name":"ty"}}],[11,"clone","","",15,{"inputs":[{"name":"self"}],"output":{"name":"needs"}}],[11,"fmt","","",15,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"self"},{"name":"needs"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",15,null],[11,"maybe_mut_place","","",15,{"inputs":[{"name":"mutability"}],"output":{"name":"self"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"unsafetystate"}}],[11,"function","","",6,{"inputs":[{"name":"unsafety"},{"name":"nodeid"}],"output":{"name":"unsafetystate"}}],[11,"recurse","","",6,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"unsafetystate"}}],[11,"fmt","","",16,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",16,{"inputs":[{"name":"self"}],"output":{"name":"placeop"}}],[11,"clone","","",17,{"inputs":[{"name":"self"}],"output":{"name":"diverges"}}],[11,"fmt","","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",17,{"inputs":[{"name":"self"},{"name":"diverges"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",17,null],[11,"partial_cmp","","",17,{"inputs":[{"name":"self"},{"name":"diverges"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",17,{"inputs":[{"name":"self"},{"name":"diverges"}],"output":{"name":"ordering"}}],[11,"bitand","","",17,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"self"}}],[11,"bitor","","",17,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"self"}}],[11,"bitand_assign","","",17,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"bitor_assign","","",17,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[11,"always","","",17,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"find_breakable","","",8,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"breakablectxt"}}],[11,"deref","","",9,null],[11,"build","","",5,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"inheritedbuilder"}}],[11,"enter","","",10,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"new","","",5,{"inputs":[{"name":"inferctxt"},{"name":"defid"}],"output":{"name":"self"}}],[11,"register_predicate","","",5,{"inputs":[{"name":"self"},{"name":"predicateobligation"}],"output":null}],[11,"register_predicates","","",5,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[11,"register_infer_ok_obligations","","",5,{"inputs":[{"name":"self"},{"name":"inferok"}],"output":{"name":"t"}}],[11,"normalize_associated_types_in","","",5,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"name":"paramenv"},{"name":"t"}],"output":{"name":"t"}}],[11,"visit_item","","",11,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",11,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",11,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"assign","","",12,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"},{"generics":["ty"],"name":"option"}],"output":{"name":"ty"}}],[11,"nested_visit_map","","",12,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_local","","",12,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_pat","","",12,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_fn","","",12,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"bodyid"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"tcx","","",9,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"get_type_parameter_bounds","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"re_infer","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["regionparameterdef"],"name":"option"}],"output":{"generics":["region"],"name":"option"}}],[11,"ty_infer","","",9,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"ty"}}],[11,"ty_infer_for_def","","",9,{"inputs":[{"name":"self"},{"name":"typeparameterdef"},{"name":"span"}],"output":{"name":"ty"}}],[11,"projected_ty_from_poly_trait_ref","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"polytraitref"}],"output":{"name":"ty"}}],[11,"normalize_ty","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"set_tainted_by_errors","","",9,{"inputs":[{"name":"self"}],"output":null}],[11,"record_ty","","",9,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"ty"},{"name":"span"}],"output":null}],[11,"clone","","",18,{"inputs":[{"name":"self"}],"output":{"name":"tupleargumentsflag"}}],[11,"assert_receiver_is_total_eq","","",18,null],[11,"eq","","",18,{"inputs":[{"name":"self"},{"name":"tupleargumentsflag"}],"output":{"name":"bool"}}],[11,"new","","",9,{"inputs":[{"name":"inherited"},{"name":"paramenv"},{"name":"nodeid"}],"output":{"name":"fnctxt"}}],[11,"sess","","",9,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"err_count_since_creation","","",9,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"warn_if_unreachable","","Produce warning on the given node, if the current point in the function is unreachable, and there hasn't been another warning.",9,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"},{"name":"str"}],"output":null}],[11,"cause","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",9,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"obligationcause"}}],[11,"resolve_type_vars_with_obligations","","Resolves type variables in `ty` if possible. Unlike the infcx version (resolve_type_vars_if_possible), this version will also select obligations if it seems useful, in an effort to get more type information.",9,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"record_deferred_call_resolution","","",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"deferredcallresolution"}],"output":null}],[11,"remove_deferred_call_resolutions","","",9,{"inputs":[{"name":"self"},{"name":"defid"}],"output":{"generics":["deferredcallresolution"],"name":"vec"}}],[11,"tag","","",9,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"local_ty","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"nodeid"}],"output":{"name":"ty"}}],[11,"write_ty","","",9,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"ty"}],"output":null}],[11,"write_field_index","","",9,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"usize"}],"output":null}],[11,"write_method_call","","",9,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"methodcallee"}],"output":null}],[11,"write_substs","","",9,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"substs"}],"output":null}],[11,"apply_adjustments","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"generics":["adjustment"],"name":"vec"}],"output":null}],[11,"instantiate_type_scheme","","Basically whenever we are converting from a type scheme into the fn body space, we always want to normalize associated types as well. This function combines the two.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"substs"},{"name":"t"}],"output":{"name":"t"}}],[11,"instantiate_bounds","","As `instantiate_type_scheme`, but for the bounds found in a generic type scheme.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_anon_types_from_return_value","","Replace the anonymized types from the return value of the function with type variables and records the `AnonTypeMap` for later use during writeback. See `InferCtxt::instantiate_anon_types` for more details.",9,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"t"}],"output":{"name":"t"}}],[11,"normalize_associated_types_in","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"t"}}],[11,"normalize_associated_types_in_as_infer_ok","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"}],"output":{"name":"inferok"}}],[11,"require_type_meets","","",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"},{"name":"obligationcausecode"},{"name":"defid"}],"output":null}],[11,"require_type_is_sized","","",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"},{"name":"obligationcausecode"}],"output":null}],[11,"register_bound","","",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"defid"},{"name":"obligationcause"}],"output":null}],[11,"to_ty","","",9,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"node_ty","","",9,{"inputs":[{"name":"self"},{"name":"hirid"}],"output":{"name":"ty"}}],[11,"register_wf_obligation","","Registers an obligation for checking later, during regionck, that the type `ty` must outlive the region `r`.",9,{"inputs":[{"name":"self"},{"name":"ty"},{"name":"span"},{"name":"obligationcausecode"}],"output":null}],[11,"add_wf_bounds","","Registers obligations that all types appearing in `substs` are well-formed.",9,{"inputs":[{"name":"self"},{"name":"substs"},{"name":"expr"}],"output":null}],[11,"add_obligations_for_parameters","","Given a fully substituted set of bounds (`generic_bounds`), and the values with which each type/region parameter was instantiated (`substs`), creates and registers suitable trait/region obligations.",9,{"inputs":[{"name":"self"},{"name":"obligationcause"},{"name":"instantiatedpredicates"}],"output":null}],[11,"field_ty","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"fielddef"},{"name":"substs"}],"output":{"name":"ty"}}],[11,"check_casts","","",9,{"inputs":[{"name":"self"}],"output":null}],[11,"resolve_generator_interiors","","",9,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"fallback_if_possible","","",9,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"select_all_obligations_or_error","","",9,{"inputs":[{"name":"self"}],"output":null}],[11,"select_obligations_where_possible","","Select as many obligations as we can at present.",9,{"inputs":[{"name":"self"},{"name":"bool"}],"output":null}],[11,"is_place_expr","","",9,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"make_overloaded_place_return_type","","For the overloaded place expressions (`*x`, `x[3]`), the trait returns a type of `&T`, but the actual type we assign to the expression is `T`. So this function just peels off the return type by one layer to yield `T`.",9,{"inputs":[{"name":"self"},{"name":"methodcallee"}],"output":{"name":"typeandmut"}}],[11,"lookup_indexing","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"name":"ty"},{"name":"ty"},{"name":"needs"}],"output":{"name":"option"}}],[11,"try_index_step","","To type-check `base_expr[index_expr]`, we progressively autoderef (and otherwise adjust) `base_expr`, looking for a type which either supports builtin indexing or overloaded indexing. This loop implements one step in that search; the autoderef loop is implemented by `lookup_indexing`.",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"name":"autoderef"},{"name":"needs"},{"name":"ty"}],"output":{"name":"option"}}],[11,"resolve_place_op","","",9,null],[11,"try_overloaded_place_op","","",9,null],[11,"check_method_argument_types","","",9,null],[11,"check_argument_types","","Generic function that factors out common logic from function calls, method calls and overloaded operators.",9,null],[11,"err_args","","",9,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["ty"],"name":"vec"}}],[11,"check_lit","","",9,{"inputs":[{"name":"self"},{"name":"lit"},{"name":"expectation"}],"output":{"name":"ty"}}],[11,"check_expr_eq_type","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"}],"output":null}],[11,"check_expr_has_type_or_error","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"check_expr_meets_expectation_or_error","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expectation"}],"output":{"name":"ty"}}],[11,"check_expr_coercable_to_type","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"check_expr_with_hint","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"check_expr_with_expectation","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expectation"}],"output":{"name":"ty"}}],[11,"check_expr","","",9,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"check_expr_with_needs","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"needs"}],"output":{"name":"ty"}}],[11,"impl_self_ty","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"}],"output":{"name":"typeandsubsts"}}],[11,"expected_inputs_for_expected_output","","Unifies the output type with the expected type early, for more coercions and forward type information on the input expressions.",9,null],[11,"check_method_call","","",9,null],[11,"check_return_expr","","",9,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"check_then_else","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expr"},{"generics":["expr"],"name":"option"},{"name":"span"},{"name":"expectation"}],"output":{"name":"ty"}}],[11,"check_field","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"needs"},{"name":"expr"},{"name":"spanned"}],"output":{"name":"ty"}}],[11,"suggest_field_name","","",9,{"inputs":[{"name":"variantdef"},{"name":"spanned"},{"generics":["localinternedstring"],"name":"vec"}],"output":{"generics":["symbol"],"name":"option"}}],[11,"available_field_names","","",9,{"inputs":[{"name":"self"},{"name":"variantdef"}],"output":{"generics":["name"],"name":"vec"}}],[11,"name_series_display","","",9,{"inputs":[{"name":"self"},{"generics":["name"],"name":"vec"}],"output":{"name":"string"}}],[11,"no_such_field_err","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"t"},{"name":"tys"}],"output":{"name":"diagnosticbuilder"}}],[11,"report_unknown_field","","",9,null],[11,"check_expr_struct_fields","","",9,null],[11,"check_struct_fields_on_error","","",9,null],[11,"check_struct_path","","",9,{"inputs":[{"name":"self"},{"name":"qpath"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"check_expr_struct","","",9,null],[11,"check_expr_with_expectation_and_needs","","Invariant: If an expression has any sub-expressions that result in a type error, inspecting that expression's type with `ty.references_error()` will return true. Likewise, if an expression is known to diverge, inspecting its type with `ty::type_is_bot` will return true (n.b.: since Rust is strict, | can appear in the type of an expression that does not, itself, diverge: for example, fn() -> |.) Note that inspecting a type's structure directly may expose the fact that there are actually multiple representations for `TyError`, so avoid that when err needs to be handled differently.",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expectation"},{"name":"needs"}],"output":{"name":"ty"}}],[11,"check_expr_kind","","",9,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"expectation"},{"name":"needs"}],"output":{"name":"ty"}}],[11,"finish_resolving_struct_path","","",9,null],[11,"resolve_ty_and_def_ufcs","","",9,null],[11,"check_decl_initializer","","",9,{"inputs":[{"name":"self"},{"name":"local"},{"name":"expr"}],"output":{"name":"ty"}}],[11,"check_decl_local","","",9,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"check_stmt","","",9,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"check_block_no_value","","",9,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"check_block_with_expected","","",9,{"inputs":[{"name":"self"},{"name":"block"},{"name":"expectation"}],"output":{"name":"ty"}}],[11,"get_fn_decl","","Given a `NodeId`, return the `FnDecl` of the method it is enclosed by and whether a suggestion can be made, `None` otherwise.",9,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"suggest_mismatched_types_on_tail","","On implicit return expressions with mismatched types, provide the following suggestions:",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"expr"},{"name":"ty"},{"name":"ty"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"suggest_missing_semicolon","","A common error is to forget to add a semicolon at the end of a block:",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"expr"},{"name":"ty"},{"name":"span"}],"output":null}],[11,"suggest_missing_return_type","","A possible error is to forget to add a return type that is needed:",9,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"},{"name":"fndecl"},{"name":"ty"},{"name":"ty"},{"name":"bool"}],"output":null}],[11,"consider_hint_about_removing_semicolon","","A common error is to add an extra semicolon:",9,{"inputs":[{"name":"self"},{"name":"block"},{"name":"ty"},{"name":"diagnosticbuilder"}],"output":null}],[11,"instantiate_value_path","","",9,null],[11,"check_rustc_args_require_const","","",9,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"check_path_parameter_count","","Report errors if the provided parameters are too few or too many.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"option"},{"name":"bool"},{"name":"bool"}],"output":null}],[11,"check_impl_trait","","Report error if there is an explicit type parameter when using `impl Trait`.",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"option"}],"output":{"name":"bool"}}],[11,"structurally_resolved_type","","",9,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"with_breakable_ctxt","","",9,null],[0,"check_unused","rustc_typeck","",null,null],[3,"CheckVisitor","rustc_typeck::check_unused","",null,null],[12,"tcx","","",66,null],[12,"used_trait_imports","","",66,null],[5,"check_crate","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[11,"check_import","","",66,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_item","","",66,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",66,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",66,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"coherence","rustc_typeck","",null,null],[5,"check_impl","rustc_typeck::coherence","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":null}],[5,"enforce_trait_manually_implementable","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":null}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"coherent_trait","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"check_coherence","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"check_impl_overlap","","Overlap: No two impls for the same trait are implemented for the same type. Likewise, no two inherent impls for a given type constructor provide a method with the same name.",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":null}],[0,"builtin","","Check properties that are required by built-in traits and set up data structures required by type-checking/translation.",null,null],[3,"Checker","rustc_typeck::coherence::builtin","",null,null],[12,"tcx","","",67,null],[12,"trait_def_id","","",67,null],[5,"check_trait","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":null}],[5,"visit_implementation_of_drop","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":null}],[5,"visit_implementation_of_copy","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":null}],[5,"visit_implementation_of_coerce_unsized","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"defid"}],"output":null}],[5,"coerce_unsized_info","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"coerceunsizedinfo"}}],[11,"check","","",67,{"inputs":[{"name":"self"},{"generics":["defid"],"name":"option"},{"name":"f"}],"output":{"name":"self"}}],[0,"inherent_impls","rustc_typeck::coherence","The code in this module gathers up all of the inherent impls in the current crate and organizes them in a map. It winds up touching the whole crate and thus must be recomputed completely for any change, but it is very cheap to compute. In practice, most code in the compiler never directly requests this map. Instead, it requests the inherent impls specific to some type (via `tcx.inherent_impls(def_id)`). That value, however, is computed by selecting an idea from this table.",null,null],[3,"InherentCollect","rustc_typeck::coherence::inherent_impls","",null,null],[12,"tcx","","",68,null],[12,"impls_map","","",68,null],[5,"crate_inherent_impls","","On-demand query: yields a map containing all types mapped to their inherent impls.",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"name":"crateinherentimpls"}}],[5,"inherent_impls","","On-demand query: yields a vector of the inherent impls for a specific type.",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[11,"visit_item","","",68,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",68,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",68,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"check_def_id","","",68,{"inputs":[{"name":"self"},{"name":"item"},{"name":"defid"}],"output":null}],[11,"check_primitive_impl","","",68,{"inputs":[{"name":"self"},{"name":"defid"},{"generics":["defid"],"name":"option"},{"generics":["defid"],"name":"option"},{"name":"str"},{"name":"str"},{"name":"span"}],"output":null}],[0,"inherent_impls_overlap","rustc_typeck::coherence","",null,null],[3,"InherentOverlapChecker","rustc_typeck::coherence::inherent_impls_overlap","",null,null],[12,"tcx","","",69,null],[5,"crate_inherent_impls_overlap_check","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":null}],[11,"check_for_common_items_in_impls","","",69,{"inputs":[{"name":"self"},{"name":"defid"},{"name":"defid"},{"name":"overlapresult"},{"name":"bool"}],"output":null}],[11,"check_for_overlapping_inherent_impls","","",69,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"visit_item","","",69,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",69,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",69,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"orphan","rustc_typeck::coherence","Orphan checker: every impl either implements a trait defined in this crate or pertains to a type defined in this crate.",null,null],[3,"OrphanChecker","rustc_typeck::coherence::orphan","",null,null],[12,"tcx","","",70,null],[5,"check","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[11,"visit_item","","Checks exactly one impl for orphan rules and other such restrictions.  In this fn, it can happen that multiple errors apply to a specific impl, so just return after reporting one to prevent inundating the user with a bunch of similar error reports.",70,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",70,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",70,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"unsafety","rustc_typeck::coherence","Unsafety checker: every impl either implements a trait defined in this crate or pertains to a type defined in this crate.",null,null],[3,"UnsafetyChecker","rustc_typeck::coherence::unsafety","",null,null],[12,"tcx","","",71,null],[5,"check","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[11,"check_unsafety_coherence","","",71,{"inputs":[{"name":"self"},{"name":"item"},{"generics":["generics"],"name":"option"},{"name":"unsafety"},{"name":"implpolarity"}],"output":null}],[11,"visit_item","","",71,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",71,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",71,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"collect","rustc_typeck","\"Collection\" is the process of determining the type and other external details of each item in Rust. Collection is specifically concerned with interprocedural things -- for example, for a function definition, collection will figure out the type and signature of the function, but it will not visit the body of the function in any way, nor examine type annotations on local variables (that's the job of type checking).",null,null],[3,"ItemCtxt","rustc_typeck::collect","Context specific to some particular item. This is what implements AstConv. It has information about the predicates that are defined on the trait. Unfortunately, this predicate information is available in various different forms at various points in the process. So we can't just store a pointer to e.g. the AST or the parsed ty form, we have to be more flexible. To this end, the `ItemCtxt` is parameterized by a `DefId` that it uses to satisfy `get_type_parameter_bounds` requests, drawing the information from the AST (`hir::Generics`), recursively.",null,null],[12,"tcx","","",72,null],[12,"item_def_id","","",72,null],[3,"CollectItemTypesVisitor","","",null,null],[12,"tcx","","",73,null],[4,"SizedByDefault","","",null,null],[13,"Yes","","",74,null],[13,"No","","",74,null],[5,"collect_item_types","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"provide","","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"type_param_predicates","","",null,null],[5,"is_param","","Tests whether this is the AST for a reference to the type parameter with id `param_id`. We use this so as to avoid running `ast_ty_to_ty`, because we want to avoid triggering an all-out conversion of the type to avoid inducing unnecessary cycles.",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"convert_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":null}],[5,"convert_trait_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":null}],[5,"convert_impl_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":null}],[5,"convert_variant_ctor","","",null,{"inputs":[{"name":"tyctxt"},{"name":"nodeid"}],"output":null}],[5,"convert_enum_variant_types","","",null,null],[5,"convert_struct_variant","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"name"},{"name":"variantdiscr"},{"name":"variantdata"}],"output":{"name":"variantdef"}}],[5,"adt_def","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"adtdef"}}],[5,"super_predicates_of","","Ensures that the super-predicates of the trait with def-id trait_def_id are converted and stored. This also ensures that the transitive super-predicates are converted;",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"trait_def","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"traitdef"}}],[5,"has_late_bound_regions","","",null,{"inputs":[{"name":"tyctxt"},{"name":"node"}],"output":{"generics":["span"],"name":"option"}}],[5,"generics_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"generics"}}],[5,"type_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"ty"}}],[5,"fn_sig","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"polyfnsig"}}],[5,"impl_trait_ref","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["traitref"],"name":"option"}}],[5,"impl_polarity","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"implpolarity"}}],[5,"is_unsized","","",null,null],[5,"early_bound_lifetimes_from_generics","","Returns the early-bound lifetimes declared in this generics listing.  For anything other than fns/methods, this is just all the lifetimes that are declared. For fns or methods, we have to screen out those that do not appear in any where-clauses etc using `resolve_lifetime::early_bound_lifetimes`.",null,null],[5,"predicates_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"explicit_predicates_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"compute_bounds","","Translate the AST's notion of ty param bounds (which are an enum consisting of a newtyped Ty or a region) to ty's notion of ty param bounds, which can either be user-defined traits, or the built-in trait (formerly known as kind): Send.",null,null],[5,"predicates_from_bound","","Converts a specific TyParamBound from the AST into a set of predicates that apply to the self-type. A vector is returned because this can be anywhere from 0 predicates (`T:?Sized` adds no predicates) to 1 (`T:Foo`) to many (`T:Bar<X=i32>` adds `T:Bar` and `<T as Bar>::X == i32`).",null,{"inputs":[{"name":"astconv"},{"name":"ty"},{"name":"typarambound"}],"output":{"generics":["predicate"],"name":"vec"}}],[5,"compute_sig_of_foreign_fn_decl","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"fndecl"},{"name":"abi"}],"output":{"name":"polyfnsig"}}],[5,"is_foreign_item","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"from_target_feature","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"attribute"},{"name":"fxhashmap"},{"name":"vec"}],"output":null}],[5,"linkage_by_name","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"},{"name":"str"}],"output":{"name":"linkage"}}],[5,"trans_fn_attrs","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"transfnattrs"}}],[11,"nested_visit_map","","",73,{"inputs":[{"name":"self"}],"output":{"name":"nestedvisitormap"}}],[11,"visit_item","","",73,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_generics","","",73,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_expr","","",73,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",73,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_trait_item","","",73,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",73,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"new","","",72,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"name":"itemctxt"}}],[11,"to_ty","","",72,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"tcx","","",72,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"get_type_parameter_bounds","","",72,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[11,"re_infer","","",72,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["regionparameterdef"],"name":"option"}],"output":{"generics":["region"],"name":"option"}}],[11,"ty_infer","","",72,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"ty"}}],[11,"projected_ty_from_poly_trait_ref","","",72,{"inputs":[{"name":"self"},{"name":"span"},{"name":"defid"},{"name":"polytraitref"}],"output":{"name":"ty"}}],[11,"normalize_ty","","",72,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"set_tainted_by_errors","","",72,{"inputs":[{"name":"self"}],"output":null}],[11,"record_ty","","",72,{"inputs":[{"name":"self"},{"name":"hirid"},{"name":"ty"},{"name":"span"}],"output":null}],[11,"type_parameter_bounds_in_generics","","Find bounds from hir::Generics. This requires scanning through the AST. We do this to avoid having to convert all the bounds, which would create artificial cycles. Instead we can only convert the bounds for a type parameter `X` if `X::Foo` is used.",72,{"inputs":[{"name":"self"},{"name":"generics"},{"name":"nodeid"},{"name":"ty"}],"output":{"generics":["predicate"],"name":"vec"}}],[0,"constrained_type_params","rustc_typeck","",null,null],[3,"Parameter","rustc_typeck::constrained_type_params","",null,null],[12,"0","","",75,null],[3,"ParameterCollector","","",null,null],[12,"parameters","","",76,null],[12,"include_nonconstraining","","",76,null],[5,"parameters_for_impl","","Return the set of parameters constrained by the impl header.",null,{"inputs":[{"name":"ty"},{"generics":["traitref"],"name":"option"}],"output":{"generics":["parameter"],"name":"fxhashset"}}],[5,"parameters_for","","If `include_projections` is false, returns the list of parameters that are constrained by `t` - i.e. the value of each parameter in the list is uniquely determined by `t` (see RFC 447). If it is true, return the list of parameters whose values are needed in order to constrain `ty` - these differ, with the latter being a superset, in the presence of projections.",null,{"inputs":[{"name":"t"},{"name":"bool"}],"output":{"generics":["parameter"],"name":"vec"}}],[5,"identify_constrained_type_params","","",null,null],[5,"setup_constraining_predicates","","Order the predicates in `predicates` such that each parameter is constrained before it is used, if that is possible, and add the parameters so constrained to `input_parameters`. For example, imagine the following impl:",null,null],[11,"clone","","",75,{"inputs":[{"name":"self"}],"output":{"name":"parameter"}}],[11,"eq","","",75,{"inputs":[{"name":"self"},{"name":"parameter"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"self"},{"name":"parameter"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",75,null],[11,"hash","","",75,null],[11,"fmt","","",75,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",75,{"inputs":[{"name":"paramty"}],"output":{"name":"self"}}],[11,"from","","",75,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"self"}}],[11,"visit_ty","","",76,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"visit_region","","",76,{"inputs":[{"name":"self"},{"name":"region"}],"output":{"name":"bool"}}],[0,"structured_errors","rustc_typeck","",null,null],[3,"VariadicError","rustc_typeck::structured_errors","",null,null],[12,"sess","","",77,null],[12,"span","","",77,null],[12,"t","","",77,null],[12,"cast_ty","","",77,null],[3,"SizedUnsizedCastError","","",null,null],[12,"sess","","",78,null],[12,"span","","",78,null],[12,"expr_ty","","",78,null],[12,"cast_ty","","",78,null],[8,"StructuredDiagnostic","","",null,null],[10,"session","","",79,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[10,"code","","",79,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticid"}}],[10,"common","","",79,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"diagnostic","","",79,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"regular","","",79,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":{"name":"diagnosticbuilder"}}],[11,"extended","","",79,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":{"name":"diagnosticbuilder"}}],[11,"new","","",77,{"inputs":[{"name":"session"},{"name":"span"},{"name":"ty"},{"name":"str"}],"output":{"name":"variadicerror"}}],[11,"session","","",77,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"code","","",77,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticid"}}],[11,"common","","",77,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"extended","","",77,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":{"name":"diagnosticbuilder"}}],[11,"new","","",78,{"inputs":[{"name":"session"},{"name":"span"},{"name":"ty"},{"name":"string"}],"output":{"name":"sizedunsizedcasterror"}}],[11,"session","","",78,{"inputs":[{"name":"self"}],"output":{"name":"session"}}],[11,"code","","",78,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticid"}}],[11,"common","","",78,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"extended","","",78,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":{"name":"diagnosticbuilder"}}],[0,"impl_wf_check","rustc_typeck","This pass enforces various \"well-formedness constraints\" on impls. Logically, it is part of wfcheck -- but we do it early so that we can stop compilation afterwards, since part of the trait matching infrastructure gets very grumpy if these conditions don't hold. In particular, if there are type parameters that are not part of the impl, then coherence will report strange inference ambiguity errors; if impls have duplicate items, we get misleading specialization errors. These things can (and probably should) be fixed, but for the moment it's easier to do these checks early.",null,null],[3,"ImplWfCheck","rustc_typeck::impl_wf_check","",null,null],[12,"tcx","","",80,null],[5,"impl_wf_check","","Checks that all the type/lifetime parameters on an impl also appear in the trait ref or self-type (or are constrained by a where-clause). These rules are needed to ensure that, given a trait ref like `<T as Trait<U>>`, we can derive the values of all parameters on the impl (which is needed to make specialization possible).",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[5,"enforce_impl_params_are_constrained","","",null,null],[5,"report_unused_parameter","","",null,{"inputs":[{"name":"tyctxt"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[5,"enforce_impl_items_are_distinct","","Enforce that we do not have two items in an impl with the same name.",null,null],[11,"visit_item","","",80,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",80,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",80,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"namespace","rustc_typeck","",null,null],[4,"Namespace","rustc_typeck::namespace","",null,null],[13,"Type","","",81,null],[13,"Value","","",81,null],[11,"clone","","",81,{"inputs":[{"name":"self"}],"output":{"name":"namespace"}}],[11,"eq","","",81,{"inputs":[{"name":"self"},{"name":"namespace"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",81,null],[11,"fmt","","",81,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",81,{"inputs":[{"name":"associatedkind"}],"output":{"name":"self"}}],[11,"from","","",81,{"inputs":[{"name":"implitemkind"}],"output":{"name":"self"}}],[0,"outlives","rustc_typeck","",null,null],[5,"provide","rustc_typeck::outlives","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"inferred_outlives_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[5,"inferred_outlives_crate","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["cratepredicatesmap"],"name":"lrc"}}],[0,"explicit","","",null,null],[3,"ExplicitVisitor","rustc_typeck::outlives::explicit","",null,null],[12,"tcx","","",82,null],[12,"explicit_predicates","","",82,null],[12,"crate_num","","",82,null],[5,"explicit_predicates","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["defid","lrc"],"name":"fxhashmap"}}],[11,"visit_item","","",82,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",82,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",82,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"implicit_empty","rustc_typeck::outlives","",null,null],[3,"EmptyImplicitVisitor","rustc_typeck::outlives::implicit_empty","",null,null],[12,"tcx","","",83,null],[12,"predicates","","",83,null],[5,"empty_predicate_map","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"generics":["defid","lrc"],"name":"fxhashmap"}}],[11,"visit_item","","",83,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",83,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",83,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"implicit_infer","rustc_typeck::outlives","",null,null],[3,"InferVisitor","rustc_typeck::outlives::implicit_infer","",null,null],[12,"tcx","","",84,null],[12,"global_inferred_outlives","","",84,null],[12,"predicates_added","","",84,null],[12,"explicit_map","","",84,null],[5,"infer_predicates","","Infer predicates for the items in the crate.",null,{"inputs":[{"name":"tyctxt"},{"name":"fxhashmap"}],"output":{"generics":["defid","fxhashset"],"name":"fxhashmap"}}],[5,"insert_required_predicates_to_be_wf","","",null,{"inputs":[{"name":"tyctxt"},{"name":"ty"},{"name":"fxhashmap"},{"name":"fxhashset"},{"name":"fxhashmap"}],"output":null}],[5,"check_explicit_predicates","","We also have to check the explicit predicates declared on the type.",null,null],[5,"insert_outlives_predicate","","Given a requirement `T: 'a` or `'b: 'a`, deduce the outlives_component and add it to `required_predicates`",null,{"inputs":[{"name":"tyctxt"},{"name":"kind"},{"name":"region"},{"name":"fxhashset"}],"output":null}],[5,"is_free_region","","",null,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[6,"RequiredPredicates","","Tracks the `T: 'a` or `'a: 'a` predicates that we have inferred must be added to the struct header.",null,null],[11,"visit_item","","",84,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",84,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",84,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"test","rustc_typeck::outlives","Code to write unit test for outlives.",null,null],[3,"OutlivesTest","rustc_typeck::outlives::test","",null,null],[12,"tcx","","",85,null],[5,"test_inferred_outlives","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[11,"visit_item","","",85,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",85,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",85,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"variance","rustc_typeck","Module for inferring the variance of type and lifetime parameters. See the [rustc guide] chapter for more info.",null,null],[5,"provide","rustc_typeck::variance","",null,{"inputs":[{"name":"providers"}],"output":null}],[5,"crate_variances","","",null,{"inputs":[{"name":"tyctxt"},{"name":"cratenum"}],"output":{"generics":["cratevariancesmap"],"name":"lrc"}}],[5,"variances_of","","",null,{"inputs":[{"name":"tyctxt"},{"name":"defid"}],"output":{"generics":["vec"],"name":"lrc"}}],[0,"terms","","Defines the `TermsContext` basically houses an arena where we can allocate terms.",null,null],[3,"InferredIndex","rustc_typeck::variance::terms","",null,null],[12,"0","","",86,null],[3,"TermsContext","","",null,null],[12,"tcx","","",87,null],[12,"arena","","",87,null],[12,"lang_items","","",87,null],[12,"inferred_starts","","",87,null],[12,"inferred_terms","","",87,null],[4,"VarianceTerm","","",null,null],[13,"ConstantTerm","","",88,null],[13,"TransformTerm","","",88,null],[13,"InferredTerm","","",88,null],[5,"determine_parameters_to_be_inferred","","",null,{"inputs":[{"name":"tyctxt"},{"name":"typedarena"}],"output":{"name":"termscontext"}}],[5,"lang_items","","",null,{"inputs":[{"name":"tyctxt"}],"output":{"name":"vec"}}],[6,"VarianceTermPtr","","",null,null],[11,"clone","","",86,{"inputs":[{"name":"self"}],"output":{"name":"inferredindex"}}],[11,"fmt","","",86,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",88,{"inputs":[{"name":"self"}],"output":{"name":"varianceterm"}}],[11,"fmt","","",88,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"add_inferreds_for_item","","",87,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"visit_item","","",87,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",87,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",87,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"constraints","rustc_typeck::variance","Code to gather up constraints. Constraint construction and representation",null,null],[3,"ConstraintContext","rustc_typeck::variance::constraints","",null,null],[12,"terms_cx","","",89,null],[12,"covariant","","",89,null],[12,"contravariant","","",89,null],[12,"invariant","","",89,null],[12,"bivariant","","",89,null],[12,"constraints","","",89,null],[3,"Constraint","","Declares that the variable `decl_id` appears in a location with variance `variance`.",null,null],[12,"inferred","","",90,null],[12,"variance","","",90,null],[3,"CurrentItem","","To build constraints, we visit one item (type, trait) at a time and look at its contents. So e.g. if we have",null,null],[12,"inferred_start","","",91,null],[5,"add_constraints_from_crate","","",null,{"inputs":[{"name":"termscontext"}],"output":{"name":"constraintcontext"}}],[11,"clone","","",90,{"inputs":[{"name":"self"}],"output":{"name":"constraint"}}],[11,"visit_item","","",89,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",89,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",89,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_node_helper","","",89,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":null}],[11,"tcx","","",89,{"inputs":[{"name":"self"}],"output":{"name":"tyctxt"}}],[11,"build_constraints_for_item","","",89,{"inputs":[{"name":"self"},{"name":"defid"}],"output":null}],[11,"add_constraint","","",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"u32"},{"name":"varianceterm"}],"output":null}],[11,"contravariant","","",89,{"inputs":[{"name":"self"},{"name":"varianceterm"}],"output":{"name":"varianceterm"}}],[11,"invariant","","",89,{"inputs":[{"name":"self"},{"name":"varianceterm"}],"output":{"name":"varianceterm"}}],[11,"constant_term","","",89,{"inputs":[{"name":"self"},{"name":"variance"}],"output":{"name":"varianceterm"}}],[11,"xform","","",89,{"inputs":[{"name":"self"},{"name":"varianceterm"},{"name":"varianceterm"}],"output":{"name":"varianceterm"}}],[11,"add_constraints_from_trait_ref","","",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"traitref"},{"name":"varianceterm"}],"output":null}],[11,"add_constraints_from_invariant_substs","","",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"substs"},{"name":"varianceterm"}],"output":null}],[11,"add_constraints_from_ty","","Adds constraints appropriate for an instance of `ty` appearing in a context with the generics defined in `generics` and ambient variance `variance`",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"ty"},{"name":"varianceterm"}],"output":null}],[11,"add_constraints_from_substs","","Adds constraints appropriate for a nominal type (enum, struct, object, etc) appearing in a context with ambient variance `variance`",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"defid"},{"name":"substs"},{"name":"varianceterm"}],"output":null}],[11,"add_constraints_from_sig","","Adds constraints appropriate for a function with signature `sig` appearing in a context with ambient variance `variance`",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"polyfnsig"},{"name":"varianceterm"}],"output":null}],[11,"add_constraints_from_region","","Adds constraints appropriate for a region appearing in a context with ambient variance `variance`",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"region"},{"name":"varianceterm"}],"output":null}],[11,"add_constraints_from_mt","","Adds constraints appropriate for a mutability-type pair appearing in a context with ambient variance `variance`",89,{"inputs":[{"name":"self"},{"name":"currentitem"},{"name":"typeandmut"},{"name":"varianceterm"}],"output":null}],[0,"solve","rustc_typeck::variance","Code to solve constraints and write out the results. Constraint solving",null,null],[3,"SolveContext","rustc_typeck::variance::solve","",null,null],[12,"terms_cx","","",92,null],[12,"constraints","","",92,null],[12,"solutions","","",92,null],[5,"solve_constraints","","",null,{"inputs":[{"name":"constraintcontext"}],"output":{"name":"cratevariancesmap"}}],[11,"solve","","",92,{"inputs":[{"name":"self"}],"output":null}],[11,"create_map","","",92,{"inputs":[{"name":"self"}],"output":{"generics":["defid","lrc"],"name":"fxhashmap"}}],[11,"evaluate","","",92,{"inputs":[{"name":"self"},{"name":"varianceterm"}],"output":{"name":"variance"}}],[0,"test","rustc_typeck::variance","Code to write unit tests of variance.",null,null],[3,"VarianceTest","rustc_typeck::variance::test","",null,null],[12,"tcx","","",93,null],[5,"test_variance","","",null,{"inputs":[{"name":"tyctxt"}],"output":null}],[11,"visit_item","","",93,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_trait_item","","",93,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",93,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[0,"xform","rustc_typeck::variance","Code for transforming variances.",null,null],[5,"glb","rustc_typeck::variance::xform","",null,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"variance"}}],[17,"DIAGNOSTICS","rustc_typeck","",null,null]],"paths":[[3,"TypeAndSubsts"],[3,"ConvertedBinding"],[3,"Bounds"],[8,"AstConv"],[3,"MaybeInProgressTables"],[3,"Inherited"],[3,"UnsafetyState"],[3,"BreakableCtxt"],[3,"EnclosingBreakables"],[3,"FnCtxt"],[3,"InheritedBuilder"],[3,"CheckItemTypesVisitor"],[3,"GatherLocalsVisitor"],[3,"GeneratorTypes"],[4,"Expectation"],[4,"Needs"],[4,"PlaceOp"],[4,"Diverges"],[4,"TupleArgumentsFlag"],[3,"Autoderef"],[4,"AutoderefKind"],[3,"WritebackCx"],[3,"Resolver"],[8,"Locatable"],[3,"RegionCtxt"],[3,"RepeatingScope"],[3,"Subject"],[3,"Coerce"],[3,"CoerceMany"],[4,"Expressions"],[8,"AsCoercionSite"],[3,"MethodCallee"],[3,"NoMatchData"],[4,"MethodError"],[4,"CandidateSource"],[3,"ConfirmContext"],[3,"ConfirmResult"],[3,"IsSuggestion"],[3,"ProbeContext"],[3,"CandidateStep"],[3,"Candidate"],[3,"Pick"],[4,"CandidateKind"],[4,"ProbeResult"],[4,"PickKind"],[4,"Mode"],[4,"ProbeScope"],[3,"TraitInfo"],[3,"UsePlacementFinder"],[3,"InferBorrowKindVisitor"],[3,"InferBorrowKind"],[3,"CheckWfFcxBuilder"],[3,"CheckTypeWellFormedVisitor"],[3,"AdtVariant"],[3,"AdtField"],[3,"CastCheck"],[4,"PointerKind"],[4,"CastError"],[3,"ExpectedSig"],[3,"ClosureSignatures"],[3,"DeferredCallResolution"],[4,"CallStep"],[3,"InteriorVisitor"],[4,"BinOpCategory"],[4,"IsAssign"],[4,"Op"],[3,"CheckVisitor"],[3,"Checker"],[3,"InherentCollect"],[3,"InherentOverlapChecker"],[3,"OrphanChecker"],[3,"UnsafetyChecker"],[3,"ItemCtxt"],[3,"CollectItemTypesVisitor"],[4,"SizedByDefault"],[3,"Parameter"],[3,"ParameterCollector"],[3,"VariadicError"],[3,"SizedUnsizedCastError"],[8,"StructuredDiagnostic"],[3,"ImplWfCheck"],[4,"Namespace"],[3,"ExplicitVisitor"],[3,"EmptyImplicitVisitor"],[3,"InferVisitor"],[3,"OutlivesTest"],[3,"InferredIndex"],[3,"TermsContext"],[4,"VarianceTerm"],[3,"ConstraintContext"],[3,"Constraint"],[3,"CurrentItem"],[3,"SolveContext"],[3,"VarianceTest"]]};
searchIndex["serialize"] = {"doc":"Support code for encoding and decoding types.","items":[[0,"serialize","serialize","Support code for encoding and decoding types.",null,null],[8,"Encoder","serialize::serialize","",null,null],[16,"Error","","",0,null],[10,"emit_nil","","",0,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[10,"emit_usize","","",0,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[10,"emit_u128","","",0,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"result"}}],[10,"emit_u64","","",0,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"result"}}],[10,"emit_u32","","",0,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"result"}}],[10,"emit_u16","","",0,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"result"}}],[10,"emit_u8","","",0,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"result"}}],[10,"emit_isize","","",0,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"result"}}],[10,"emit_i128","","",0,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"result"}}],[10,"emit_i64","","",0,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"result"}}],[10,"emit_i32","","",0,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"result"}}],[10,"emit_i16","","",0,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"result"}}],[10,"emit_i8","","",0,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"result"}}],[10,"emit_bool","","",0,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"result"}}],[10,"emit_f64","","",0,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"result"}}],[10,"emit_f32","","",0,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"result"}}],[10,"emit_char","","",0,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"result"}}],[10,"emit_str","","",0,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"emit_enum","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_variant","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_variant_arg","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_struct_variant","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_struct_variant_field","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_struct","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_struct_field","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple_arg","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple_struct","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple_struct_arg","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_option","","",0,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_option_none","","",0,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"emit_option_some","","",0,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_seq","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_seq_elt","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_map","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_map_elt_key","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_map_elt_val","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[8,"Decoder","","",null,null],[16,"Error","","",1,null],[10,"read_nil","","",1,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[10,"read_usize","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"result"}}],[10,"read_u128","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"result"}}],[10,"read_u64","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"result"}}],[10,"read_u32","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u32"],"name":"result"}}],[10,"read_u16","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u16"],"name":"result"}}],[10,"read_u8","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"result"}}],[10,"read_isize","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["isize"],"name":"result"}}],[10,"read_i128","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"result"}}],[10,"read_i64","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"result"}}],[10,"read_i32","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"result"}}],[10,"read_i16","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i16"],"name":"result"}}],[10,"read_i8","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i8"],"name":"result"}}],[10,"read_bool","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[10,"read_f64","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"result"}}],[10,"read_f32","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["f32"],"name":"result"}}],[10,"read_char","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"result"}}],[10,"read_str","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"result"}}],[11,"read_enum","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_enum_variant","","",1,null],[11,"read_enum_variant_arg","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_enum_struct_variant","","",1,null],[11,"read_enum_struct_variant_field","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_struct","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_struct_field","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple_arg","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple_struct","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple_struct_arg","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_option","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_seq","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_seq_elt","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_map","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_map_elt_key","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_map_elt_val","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"error","","",1,null],[8,"Encodable","","",null,null],[10,"encode","","",2,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[8,"Decodable","","",null,null],[10,"decode","","",3,{"inputs":[{"name":"d"}],"output":{"name":"result"}}],[8,"SpecializationError","","Implement this trait on your `{Encodable,Decodable}::Error` types to override the default panic behavior for missing specializations.",null,null],[10,"not_found","","Create an error for a missing method specialization. Defaults to panicking with type, trait & method names. `S` is the encoder/decoder state type, `T` is the type being encoded/decoded, and the arguments are the names of the trait and method that should've been overridden.",4,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"self"}}],[8,"SpecializedEncoder","","Implement this trait on encoders, with `T` being the type you want to encode (employing `UseSpecializedEncodable`), using a strategy specific to the encoder.",null,null],[10,"specialized_encode","","Encode the value in a manner specific to this encoder state.",5,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"result"}}],[8,"SpecializedDecoder","","Implement this trait on decoders, with `T` being the type you want to decode (employing `UseSpecializedDecodable`), using a strategy specific to the decoder.",null,null],[10,"specialized_decode","","Decode a value in a manner specific to this decoder state.",6,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[8,"UseSpecializedEncodable","","Implement this trait on your type to get an `Encodable` implementation which goes through `SpecializedEncoder`.",null,null],[11,"default_encode","","Defaults to returning an error (see `SpecializationError`).",7,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[8,"UseSpecializedDecodable","","Implement this trait on your type to get an `Decodable` implementation which goes through `SpecializedDecoder`.",null,null],[11,"default_decode","","Defaults to returning an error (see `SpecializationError`).",8,{"inputs":[{"name":"d"}],"output":{"name":"result"}}],[0,"collection_impls","serialize","Implementations of serialization for structures found in liballoc",null,null],[0,"hex","","Hex binary-to-text encoding",null,null],[4,"FromHexError","serialize::hex","Errors that can occur when decoding a hex encoded string",null,null],[13,"InvalidHexCharacter","","The input contained a character not part of the hex format",9,null],[13,"InvalidHexLength","","The input had an invalid length",9,null],[17,"CHARS","","",null,null],[8,"ToHex","","A trait for converting a value to hexadecimal encoding",null,null],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned string.",10,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[8,"FromHex","","A trait for converting hexadecimal encoded values",null,null],[10,"from_hex","","Converts the value of `self`, interpreted as hexadecimal encoded data, into an owned vector of bytes, returning the vector.",11,{"inputs":[{"name":"self"}],"output":{"generics":["vec","fromhexerror"],"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"fromhexerror"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",9,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[0,"json","serialize","JSON parsing and serialization",null,null],[3,"PrettyJson","serialize::json","",null,null],[12,"inner","","",12,null],[3,"AsJson","","",null,null],[12,"inner","","",13,null],[3,"AsPrettyJson","","",null,null],[12,"inner","","",14,null],[12,"indent","","",14,null],[3,"Encoder","","A structure for implementing serialization to JSON.",null,null],[12,"writer","","",15,null],[12,"is_emitting_map_key","","",15,null],[3,"PrettyEncoder","","Another encoder for JSON, but prints out human-readable JSON instead of compact data",null,null],[12,"writer","","",16,null],[12,"curr_indent","","",16,null],[12,"indent","","",16,null],[12,"is_emitting_map_key","","",16,null],[3,"Stack","","A Stack represents the current position of the parser in the logical structure of the JSON stream. For example foo.bar[3].x",null,null],[12,"stack","","",17,null],[12,"str_buffer","","",17,null],[3,"Parser","","A streaming JSON parser implemented as an iterator of JsonEvent, consuming an iterator of char.",null,null],[12,"rdr","","",18,null],[12,"ch","","",18,null],[12,"line","","",18,null],[12,"col","","",18,null],[12,"stack","","",18,null],[12,"state","","",18,null],[3,"Builder","","A Builder consumes a json::Parser to create a generic Json structure.",null,null],[12,"parser","","",19,null],[12,"token","","",19,null],[3,"Decoder","","A structure to decode JSON to values in rust.",null,null],[12,"stack","","",20,null],[3,"FormatShim","","",null,null],[12,"inner","","",21,null],[4,"Json","","Represents a json value",null,null],[13,"I64","","",22,null],[13,"U64","","",22,null],[13,"F64","","",22,null],[13,"String","","",22,null],[13,"Boolean","","",22,null],[13,"Array","","",22,null],[13,"Object","","",22,null],[13,"Null","","",22,null],[4,"ErrorCode","","The errors that can arise while parsing a JSON stream.",null,null],[13,"InvalidSyntax","","",23,null],[13,"InvalidNumber","","",23,null],[13,"EOFWhileParsingObject","","",23,null],[13,"EOFWhileParsingArray","","",23,null],[13,"EOFWhileParsingValue","","",23,null],[13,"EOFWhileParsingString","","",23,null],[13,"KeyMustBeAString","","",23,null],[13,"ExpectedColon","","",23,null],[13,"TrailingCharacters","","",23,null],[13,"TrailingComma","","",23,null],[13,"InvalidEscape","","",23,null],[13,"InvalidUnicodeCodePoint","","",23,null],[13,"LoneLeadingSurrogateInHexEscape","","",23,null],[13,"UnexpectedEndOfHexEscape","","",23,null],[13,"UnrecognizedHex","","",23,null],[13,"NotFourDigit","","",23,null],[13,"NotUtf8","","",23,null],[4,"ParserError","","",null,null],[13,"SyntaxError","","msg, line, col",24,null],[13,"IoError","","",24,null],[4,"DecoderError","","",null,null],[13,"ParseError","","",25,null],[13,"ExpectedError","","",25,null],[13,"MissingFieldError","","",25,null],[13,"UnknownVariantError","","",25,null],[13,"ApplicationError","","",25,null],[4,"EncoderError","","",null,null],[13,"FmtError","","",26,null],[13,"BadHashmapKey","","",26,null],[4,"JsonEvent","","The output of the streaming parser.",null,null],[13,"ObjectStart","","",27,null],[13,"ObjectEnd","","",27,null],[13,"ArrayStart","","",27,null],[13,"ArrayEnd","","",27,null],[13,"BooleanValue","","",27,null],[13,"I64Value","","",27,null],[13,"U64Value","","",27,null],[13,"F64Value","","",27,null],[13,"StringValue","","",27,null],[13,"NullValue","","",27,null],[13,"Error","","",27,null],[4,"ParserState","","",null,null],[13,"ParseArray","","",28,null],[13,"ParseArrayComma","","",28,null],[13,"ParseObject","","",28,null],[13,"ParseObjectComma","","",28,null],[13,"ParseStart","","",28,null],[13,"ParseBeforeFinish","","",28,null],[13,"ParseFinished","","",28,null],[4,"StackElement","","StackElements compose a Stack. For example, StackElement::Key(\"foo\"), StackElement::Key(\"bar\"), StackElement::Index(3) and StackElement::Key(\"x\") are the StackElements compositing the stack that represents foo.bar[3].x",null,null],[13,"Index","","",29,null],[13,"Key","","",29,null],[4,"InternalStackElement","","",null,null],[13,"InternalIndex","","",30,null],[13,"InternalKey","","",30,null],[5,"error_str","","Returns a readable error string for a given error code.",null,{"inputs":[{"name":"errorcode"}],"output":{"name":"str"}}],[5,"decode","","Shortcut function to decode a JSON `&str` into an object",null,{"inputs":[{"name":"str"}],"output":{"name":"decoderesult"}}],[5,"encode","","Shortcut function to encode a `T` into a JSON `String`",null,{"inputs":[{"name":"t"}],"output":{"generics":["string","encodererror"],"name":"result"}}],[5,"io_error_to_error","","",null,{"inputs":[{"name":"error"}],"output":{"name":"parsererror"}}],[5,"escape_str","","",null,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"encoderesult"}}],[5,"escape_char","","",null,{"inputs":[{"name":"write"},{"name":"char"}],"output":{"name":"encoderesult"}}],[5,"spaces","","",null,{"inputs":[{"name":"write"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[5,"fmt_number_or_null","","",null,{"inputs":[{"name":"f64"}],"output":{"name":"string"}}],[5,"as_json","","Create an `AsJson` wrapper which can be used to print a value as JSON on-the-fly via `write!`",null,{"inputs":[{"name":"t"}],"output":{"name":"asjson"}}],[5,"as_pretty_json","","Create an `AsPrettyJson` wrapper which can be used to print a value as JSON on-the-fly via `write!`",null,{"inputs":[{"name":"t"}],"output":{"name":"asprettyjson"}}],[5,"from_reader","","Decodes a json value from an `&mut io::Read`",null,{"inputs":[{"name":"read"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[5,"from_str","","Decodes a json value from a string",null,{"inputs":[{"name":"str"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[6,"Array","","",null,null],[6,"Object","","",null,null],[6,"BuilderError","","",null,null],[6,"EncodeResult","","",null,null],[6,"DecodeResult","","",null,null],[8,"ToJson","","A trait for converting values to JSON",null,null],[10,"to_json","","Converts the value of `self` to an instance of JSON",31,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"clone","","",22,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"eq","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"name":"bool"}}],[11,"le","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"name":"bool"}}],[11,"gt","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"name":"bool"}}],[11,"ge","","",22,{"inputs":[{"name":"self"},{"name":"json"}],"output":{"name":"bool"}}],[11,"fmt","","",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"self"}],"output":{"name":"errorcode"}}],[11,"eq","","",23,{"inputs":[{"name":"self"},{"name":"errorcode"}],"output":{"name":"bool"}}],[11,"fmt","","",23,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"parsererror"}}],[11,"eq","","",24,{"inputs":[{"name":"self"},{"name":"parsererror"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"self"},{"name":"parsererror"}],"output":{"name":"bool"}}],[11,"fmt","","",24,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"decodererror"}}],[11,"eq","","",25,{"inputs":[{"name":"self"},{"name":"decodererror"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"self"},{"name":"decodererror"}],"output":{"name":"bool"}}],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",26,{"inputs":[{"name":"self"}],"output":{"name":"encodererror"}}],[11,"fmt","","",26,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",23,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",24,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",25,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"fmt","","",26,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",26,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"from","","",26,{"inputs":[{"name":"error"}],"output":{"name":"encodererror"}}],[11,"new","","Creates a new JSON encoder whose output will be written to the writer specified.",15,{"inputs":[{"name":"write"}],"output":{"name":"encoder"}}],[11,"emit_nil","","",15,{"inputs":[{"name":"self"}],"output":{"name":"encoderesult"}}],[11,"emit_usize","","",15,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"emit_u128","","",15,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"encoderesult"}}],[11,"emit_u64","","",15,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"emit_u32","","",15,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"emit_u16","","",15,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"emit_u8","","",15,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"emit_isize","","",15,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"encoderesult"}}],[11,"emit_i128","","",15,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"encoderesult"}}],[11,"emit_i64","","",15,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"emit_i32","","",15,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"emit_i16","","",15,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"emit_i8","","",15,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"emit_bool","","",15,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"encoderesult"}}],[11,"emit_f64","","",15,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"encoderesult"}}],[11,"emit_f32","","",15,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"encoderesult"}}],[11,"emit_char","","",15,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"encoderesult"}}],[11,"emit_str","","",15,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"emit_enum","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant_arg","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant_field","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct_field","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_arg","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct","","",15,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct_arg","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option","","",15,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option_none","","",15,{"inputs":[{"name":"self"}],"output":{"name":"encoderesult"}}],[11,"emit_option_some","","",15,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq_elt","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_key","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_val","","",15,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"new","","Creates a new encoder whose output will be written to the specified writer",16,{"inputs":[{"name":"write"}],"output":{"name":"prettyencoder"}}],[11,"set_indent","","Set the number of spaces to indent for each level. This is safe to set during encoding.",16,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"emit_nil","","",16,{"inputs":[{"name":"self"}],"output":{"name":"encoderesult"}}],[11,"emit_usize","","",16,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"emit_u128","","",16,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"encoderesult"}}],[11,"emit_u64","","",16,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"emit_u32","","",16,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"emit_u16","","",16,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"emit_u8","","",16,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"emit_isize","","",16,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"encoderesult"}}],[11,"emit_i128","","",16,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"encoderesult"}}],[11,"emit_i64","","",16,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"emit_i32","","",16,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"emit_i16","","",16,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"emit_i8","","",16,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"emit_bool","","",16,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"encoderesult"}}],[11,"emit_f64","","",16,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"encoderesult"}}],[11,"emit_f32","","",16,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"encoderesult"}}],[11,"emit_char","","",16,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"encoderesult"}}],[11,"emit_str","","",16,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"emit_enum","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant_arg","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant_field","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct_field","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_arg","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct","","",16,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct_arg","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option","","",16,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option_none","","",16,{"inputs":[{"name":"self"}],"output":{"name":"encoderesult"}}],[11,"emit_option_some","","",16,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq_elt","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_key","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_val","","",16,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"encode","","",22,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"pretty","","Borrow this json object as a pretty object to generate a pretty representation for it via `Display`.",22,{"inputs":[{"name":"self"}],"output":{"name":"prettyjson"}}],[11,"find","","If the Json value is an Object, returns the value associated with the provided key. Otherwise, returns None.",22,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["json"],"name":"option"}}],[11,"find_path","","Attempts to get a nested Json Object for each key in `keys`. If any key is found not to exist, find_path will return None. Otherwise, it will return the Json value associated with the final key.",22,null],[11,"search","","If the Json value is an Object, performs a depth-first search until a value associated with the provided key is found. If no value is found or the Json value is not an Object, returns None.",22,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["json"],"name":"option"}}],[11,"is_object","","Returns true if the Json value is an Object. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_object","","If the Json value is an Object, returns the associated BTreeMap. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["object"],"name":"option"}}],[11,"is_array","","Returns true if the Json value is an Array. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_array","","If the Json value is an Array, returns the associated vector. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["array"],"name":"option"}}],[11,"is_string","","Returns true if the Json value is a String. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_string","","If the Json value is a String, returns the associated str. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"option"}}],[11,"is_number","","Returns true if the Json value is a Number. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_i64","","Returns true if the Json value is a i64. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_u64","","Returns true if the Json value is a u64. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_f64","","Returns true if the Json value is a f64. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_i64","","If the Json value is a number, return or cast it to a i64. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"option"}}],[11,"as_u64","","If the Json value is a number, return or cast it to a u64. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"option"}}],[11,"as_f64","","If the Json value is a number, return or cast it to a f64. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"option"}}],[11,"is_boolean","","Returns true if the Json value is a Boolean. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_boolean","","If the Json value is a Boolean, returns the associated bool. Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"option"}}],[11,"is_null","","Returns true if the Json value is a Null. Returns false otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"as_null","","If the Json value is a Null, returns (). Returns None otherwise.",22,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"index","","",22,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"json"}}],[11,"index","","",22,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"json"}}],[11,"eq","","",27,{"inputs":[{"name":"self"},{"name":"jsonevent"}],"output":{"name":"bool"}}],[11,"ne","","",27,{"inputs":[{"name":"self"},{"name":"jsonevent"}],"output":{"name":"bool"}}],[11,"clone","","",27,{"inputs":[{"name":"self"}],"output":{"name":"jsonevent"}}],[11,"fmt","","",27,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",28,{"inputs":[{"name":"self"},{"name":"parserstate"}],"output":{"name":"bool"}}],[11,"ne","","",28,{"inputs":[{"name":"self"},{"name":"parserstate"}],"output":{"name":"bool"}}],[11,"fmt","","",28,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",29,{"inputs":[{"name":"self"},{"name":"stackelement"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"self"},{"name":"stackelement"}],"output":{"name":"bool"}}],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"stackelement"}}],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",30,{"inputs":[{"name":"self"},{"name":"internalstackelement"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"self"},{"name":"internalstackelement"}],"output":{"name":"bool"}}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"internalstackelement"}}],[11,"fmt","","",30,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",17,{"inputs":[],"output":{"name":"stack"}}],[11,"len","","Returns The number of elements in the Stack.",17,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the stack is empty.",17,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"get","","Provides access to the StackElement at a given index. lower indices are at the bottom of the stack while higher indices are at the top.",17,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"stackelement"}}],[11,"is_equal_to","","Compares this stack with an array of StackElements.",17,null],[11,"starts_with","","Returns true if the bottom-most elements of this stack are the same as the ones passed as parameter.",17,null],[11,"ends_with","","Returns true if the top-most elements of this stack are the same as the ones passed as parameter.",17,null],[11,"top","","Returns the top-most element (if any).",17,{"inputs":[{"name":"self"}],"output":{"generics":["stackelement"],"name":"option"}}],[11,"push_key","","",17,{"inputs":[{"name":"self"},{"name":"string"}],"output":null}],[11,"push_index","","",17,{"inputs":[{"name":"self"},{"name":"u32"}],"output":null}],[11,"pop","","",17,{"inputs":[{"name":"self"}],"output":null}],[11,"last_is_index","","",17,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"bump_index","","",17,{"inputs":[{"name":"self"}],"output":null}],[11,"next","","",18,{"inputs":[{"name":"self"}],"output":{"generics":["jsonevent"],"name":"option"}}],[11,"new","","Creates the JSON parser.",18,{"inputs":[{"name":"t"}],"output":{"name":"parser"}}],[11,"stack","","Provides access to the current position in the logical structure of the JSON stream.",18,{"inputs":[{"name":"self"}],"output":{"name":"stack"}}],[11,"eof","","",18,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"ch_or_null","","",18,{"inputs":[{"name":"self"}],"output":{"name":"char"}}],[11,"bump","","",18,{"inputs":[{"name":"self"}],"output":null}],[11,"next_char","","",18,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"option"}}],[11,"ch_is","","",18,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"bool"}}],[11,"error","","",18,{"inputs":[{"name":"self"},{"name":"errorcode"}],"output":{"generics":["parsererror"],"name":"result"}}],[11,"parse_whitespace","","",18,{"inputs":[{"name":"self"}],"output":null}],[11,"parse_number","","",18,{"inputs":[{"name":"self"}],"output":{"name":"jsonevent"}}],[11,"parse_u64","","",18,{"inputs":[{"name":"self"}],"output":{"generics":["u64","parsererror"],"name":"result"}}],[11,"parse_decimal","","",18,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"generics":["f64","parsererror"],"name":"result"}}],[11,"parse_exponent","","",18,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"generics":["f64","parsererror"],"name":"result"}}],[11,"decode_hex_escape","","",18,{"inputs":[{"name":"self"}],"output":{"generics":["u16","parsererror"],"name":"result"}}],[11,"parse_str","","",18,{"inputs":[{"name":"self"}],"output":{"generics":["string","parsererror"],"name":"result"}}],[11,"parse","","",18,{"inputs":[{"name":"self"}],"output":{"name":"jsonevent"}}],[11,"parse_start","","",18,{"inputs":[{"name":"self"}],"output":{"name":"jsonevent"}}],[11,"parse_array","","",18,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"jsonevent"}}],[11,"parse_array_comma_or_end","","",18,{"inputs":[{"name":"self"}],"output":{"generics":["jsonevent"],"name":"option"}}],[11,"parse_object","","",18,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"jsonevent"}}],[11,"parse_object_end","","",18,{"inputs":[{"name":"self"}],"output":{"name":"jsonevent"}}],[11,"parse_value","","",18,{"inputs":[{"name":"self"}],"output":{"name":"jsonevent"}}],[11,"parse_ident","","",18,{"inputs":[{"name":"self"},{"name":"str"},{"name":"jsonevent"}],"output":{"name":"jsonevent"}}],[11,"error_event","","",18,{"inputs":[{"name":"self"},{"name":"errorcode"}],"output":{"name":"jsonevent"}}],[11,"new","","Create a JSON Builder.",19,{"inputs":[{"name":"t"}],"output":{"name":"builder"}}],[11,"build","","",19,{"inputs":[{"name":"self"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[11,"bump","","",19,{"inputs":[{"name":"self"}],"output":null}],[11,"build_value","","",19,{"inputs":[{"name":"self"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[11,"build_array","","",19,{"inputs":[{"name":"self"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[11,"build_object","","",19,{"inputs":[{"name":"self"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[11,"new","","Creates a new decoder instance for decoding the specified JSON value.",20,{"inputs":[{"name":"json"}],"output":{"name":"decoder"}}],[11,"pop","","",20,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"read_nil","","",20,{"inputs":[{"name":"self"}],"output":{"name":"decoderesult"}}],[11,"read_usize","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"decoderesult"}}],[11,"read_u8","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"decoderesult"}}],[11,"read_u16","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["u16"],"name":"decoderesult"}}],[11,"read_u32","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["u32"],"name":"decoderesult"}}],[11,"read_u64","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"decoderesult"}}],[11,"read_u128","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"decoderesult"}}],[11,"read_isize","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["isize"],"name":"decoderesult"}}],[11,"read_i8","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["i8"],"name":"decoderesult"}}],[11,"read_i16","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["i16"],"name":"decoderesult"}}],[11,"read_i32","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"decoderesult"}}],[11,"read_i64","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"decoderesult"}}],[11,"read_i128","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"decoderesult"}}],[11,"read_f32","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["f32"],"name":"decoderesult"}}],[11,"read_f64","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"decoderesult"}}],[11,"read_bool","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"decoderesult"}}],[11,"read_char","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"decoderesult"}}],[11,"read_str","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"decoderesult"}}],[11,"read_enum","","",20,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_enum_variant","","",20,null],[11,"read_enum_variant_arg","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_enum_struct_variant","","",20,null],[11,"read_enum_struct_variant_field","","",20,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_struct","","",20,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_struct_field","","",20,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_arg","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_struct","","",20,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_struct_arg","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_option","","",20,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_seq","","",20,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_seq_elt","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map","","",20,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map_elt_key","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map_elt_val","","",20,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"error","","",20,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"decodererror"}}],[11,"to_json","","",22,{"inputs":[{"name":"self"}],"output":{"name":"json"}}],[11,"write_str","","",21,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"fmt","","Encodes a json value into a string",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","Encodes a json value into a string",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","Encodes a json value into a string",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"indent","","Set the indentation level for the emitted JSON",14,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"asprettyjson"}}],[11,"fmt","","Encodes a json value into a string",14,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_str","","",22,{"inputs":[{"name":"str"}],"output":{"generics":["json","buildererror"],"name":"result"}}],[0,"opaque","serialize","",null,null],[3,"Encoder","serialize::opaque","",null,null],[12,"cursor","","",32,null],[3,"Decoder","","",null,null],[12,"data","","",33,null],[12,"position","","",33,null],[6,"EncodeResult","","",null,null],[11,"new","","",32,{"inputs":[{"name":"cursor"}],"output":{"name":"encoder"}}],[11,"emit_raw_bytes","","",32,null],[11,"emit_nil","","",32,{"inputs":[{"name":"self"}],"output":{"name":"encoderesult"}}],[11,"emit_usize","","",32,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"emit_u128","","",32,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"encoderesult"}}],[11,"emit_u64","","",32,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"emit_u32","","",32,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"emit_u16","","",32,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"emit_u8","","",32,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"emit_isize","","",32,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"encoderesult"}}],[11,"emit_i128","","",32,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"encoderesult"}}],[11,"emit_i64","","",32,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"emit_i32","","",32,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"emit_i16","","",32,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"emit_i8","","",32,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"emit_bool","","",32,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"encoderesult"}}],[11,"emit_f64","","",32,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"encoderesult"}}],[11,"emit_f32","","",32,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"encoderesult"}}],[11,"emit_char","","",32,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"encoderesult"}}],[11,"emit_str","","",32,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"position","","",32,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new","","",33,null],[11,"position","","",33,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"set_position","","",33,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"advance","","",33,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"read_raw_bytes","","",33,null],[11,"read_nil","","",33,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"read_u128","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"result"}}],[11,"read_u64","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"result"}}],[11,"read_u32","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["u32"],"name":"result"}}],[11,"read_u16","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["u16"],"name":"result"}}],[11,"read_u8","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"result"}}],[11,"read_usize","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"result"}}],[11,"read_i128","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"result"}}],[11,"read_i64","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"result"}}],[11,"read_i32","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"result"}}],[11,"read_i16","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["i16"],"name":"result"}}],[11,"read_i8","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["i8"],"name":"result"}}],[11,"read_isize","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["isize"],"name":"result"}}],[11,"read_bool","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[11,"read_f64","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"result"}}],[11,"read_f32","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["f32"],"name":"result"}}],[11,"read_char","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"result"}}],[11,"read_str","","",33,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"result"}}],[11,"error","","",33,null],[0,"leb128","serialize","",null,null],[5,"write_to_vec","serialize::leb128","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"u8"}],"output":null}],[5,"write_u16_leb128","","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"u16"}],"output":{"name":"usize"}}],[5,"write_u32_leb128","","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"u32"}],"output":{"name":"usize"}}],[5,"write_u64_leb128","","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"u64"}],"output":{"name":"usize"}}],[5,"write_u128_leb128","","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"u128"}],"output":{"name":"usize"}}],[5,"write_usize_leb128","","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[5,"read_u16_leb128","","",null,null],[5,"read_u32_leb128","","",null,null],[5,"read_u64_leb128","","",null,null],[5,"read_u128_leb128","","",null,null],[5,"read_usize_leb128","","",null,null],[5,"write_signed_leb128_to","","encodes an integer using signed leb128 encoding and stores the result using a callback function.",null,{"inputs":[{"name":"i128"},{"name":"w"}],"output":{"name":"usize"}}],[5,"write_signed_leb128","","",null,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"i128"}],"output":{"name":"usize"}}],[5,"read_signed_leb128","","",null,null],[17,"USIZE_LEB128_SIZE","","",null,null],[0,"rustc_serialize","serialize","",null,null],[8,"Decoder","","",null,null],[16,"Error","","",1,null],[10,"read_nil","","",1,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[10,"read_usize","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"result"}}],[10,"read_u128","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u128"],"name":"result"}}],[10,"read_u64","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u64"],"name":"result"}}],[10,"read_u32","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u32"],"name":"result"}}],[10,"read_u16","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u16"],"name":"result"}}],[10,"read_u8","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["u8"],"name":"result"}}],[10,"read_isize","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["isize"],"name":"result"}}],[10,"read_i128","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i128"],"name":"result"}}],[10,"read_i64","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i64"],"name":"result"}}],[10,"read_i32","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i32"],"name":"result"}}],[10,"read_i16","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i16"],"name":"result"}}],[10,"read_i8","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["i8"],"name":"result"}}],[10,"read_bool","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["bool"],"name":"result"}}],[10,"read_f64","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["f64"],"name":"result"}}],[10,"read_f32","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["f32"],"name":"result"}}],[10,"read_char","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"result"}}],[10,"read_str","","",1,{"inputs":[{"name":"self"}],"output":{"generics":["cow"],"name":"result"}}],[11,"read_enum","serialize::serialize","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_enum_variant","","",1,null],[11,"read_enum_variant_arg","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_enum_struct_variant","","",1,null],[11,"read_enum_struct_variant_field","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_struct","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_struct_field","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple_arg","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple_struct","","",1,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_tuple_struct_arg","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_option","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_seq","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_seq_elt","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_map","","",1,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_map_elt_key","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"read_map_elt_val","","",1,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"error","serialize","",1,null],[8,"Encoder","","",null,null],[16,"Error","","",0,null],[10,"emit_nil","","",0,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[10,"emit_usize","","",0,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[10,"emit_u128","","",0,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"result"}}],[10,"emit_u64","","",0,{"inputs":[{"name":"self"},{"name":"u64"}],"output":{"name":"result"}}],[10,"emit_u32","","",0,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"result"}}],[10,"emit_u16","","",0,{"inputs":[{"name":"self"},{"name":"u16"}],"output":{"name":"result"}}],[10,"emit_u8","","",0,{"inputs":[{"name":"self"},{"name":"u8"}],"output":{"name":"result"}}],[10,"emit_isize","","",0,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"result"}}],[10,"emit_i128","","",0,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"result"}}],[10,"emit_i64","","",0,{"inputs":[{"name":"self"},{"name":"i64"}],"output":{"name":"result"}}],[10,"emit_i32","","",0,{"inputs":[{"name":"self"},{"name":"i32"}],"output":{"name":"result"}}],[10,"emit_i16","","",0,{"inputs":[{"name":"self"},{"name":"i16"}],"output":{"name":"result"}}],[10,"emit_i8","","",0,{"inputs":[{"name":"self"},{"name":"i8"}],"output":{"name":"result"}}],[10,"emit_bool","","",0,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"result"}}],[10,"emit_f64","","",0,{"inputs":[{"name":"self"},{"name":"f64"}],"output":{"name":"result"}}],[10,"emit_f32","","",0,{"inputs":[{"name":"self"},{"name":"f32"}],"output":{"name":"result"}}],[10,"emit_char","","",0,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"result"}}],[10,"emit_str","","",0,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"emit_enum","serialize::serialize","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_variant","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_variant_arg","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_struct_variant","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_enum_struct_variant_field","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_struct","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_struct_field","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple_arg","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple_struct","","",0,{"inputs":[{"name":"self"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_tuple_struct_arg","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_option","","",0,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_option_none","","",0,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"emit_option_some","","",0,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_seq","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_seq_elt","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_map","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_map_elt_key","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[11,"emit_map_elt_val","","",0,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[8,"Decodable","serialize","",null,null],[10,"decode","","",3,{"inputs":[{"name":"d"}],"output":{"name":"result"}}],[8,"Encodable","","",null,null],[10,"encode","","",2,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[8,"SpecializationError","","Implement this trait on your `{Encodable,Decodable}::Error` types to override the default panic behavior for missing specializations.",null,null],[10,"not_found","","Create an error for a missing method specialization. Defaults to panicking with type, trait & method names. `S` is the encoder/decoder state type, `T` is the type being encoded/decoded, and the arguments are the names of the trait and method that should've been overridden.",4,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"self"}}],[8,"SpecializedEncoder","","Implement this trait on encoders, with `T` being the type you want to encode (employing `UseSpecializedEncodable`), using a strategy specific to the encoder.",null,null],[10,"specialized_encode","","Encode the value in a manner specific to this encoder state.",5,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"result"}}],[8,"SpecializedDecoder","","Implement this trait on decoders, with `T` being the type you want to decode (employing `UseSpecializedDecodable`), using a strategy specific to the decoder.",null,null],[10,"specialized_decode","","Decode a value in a manner specific to this decoder state.",6,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[8,"UseSpecializedEncodable","","Implement this trait on your type to get an `Encodable` implementation which goes through `SpecializedEncoder`.",null,null],[11,"default_encode","serialize::serialize","Defaults to returning an error (see `SpecializationError`).",7,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[8,"UseSpecializedDecodable","serialize","Implement this trait on your type to get an `Decodable` implementation which goes through `SpecializedDecoder`.",null,null],[11,"default_decode","serialize::serialize","Defaults to returning an error (see `SpecializationError`).",8,{"inputs":[{"name":"d"}],"output":{"name":"result"}}]],"paths":[[8,"Encoder"],[8,"Decoder"],[8,"Encodable"],[8,"Decodable"],[8,"SpecializationError"],[8,"SpecializedEncoder"],[8,"SpecializedDecoder"],[8,"UseSpecializedEncodable"],[8,"UseSpecializedDecodable"],[4,"FromHexError"],[8,"ToHex"],[8,"FromHex"],[3,"PrettyJson"],[3,"AsJson"],[3,"AsPrettyJson"],[3,"Encoder"],[3,"PrettyEncoder"],[3,"Stack"],[3,"Parser"],[3,"Builder"],[3,"Decoder"],[3,"FormatShim"],[4,"Json"],[4,"ErrorCode"],[4,"ParserError"],[4,"DecoderError"],[4,"EncoderError"],[4,"JsonEvent"],[4,"ParserState"],[4,"StackElement"],[4,"InternalStackElement"],[8,"ToJson"],[3,"Encoder"],[3,"Decoder"]]};
searchIndex["syntax"] = {"doc":"The Rust parser and macro expander.","items":[[0,"symbol","syntax","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",null,null],[3,"Ident","syntax::symbol","",null,null],[12,"name","","",0,null],[12,"span","","",0,null],[3,"Symbol","","A symbol is an interned or gensymed string.",null,null],[12,"0","","",1,null],[3,"Interner","","",null,null],[12,"names","","",2,null],[12,"strings","","",2,null],[12,"gensyms","","",2,null],[0,"keywords","","",null,null],[3,"Keyword","syntax::symbol::keywords","",null,null],[12,"ident","","",3,null],[17,"Invalid","","",null,null],[17,"CrateRoot","","",null,null],[17,"DollarCrate","","",null,null],[17,"Underscore","","",null,null],[17,"As","","",null,null],[17,"Box","","",null,null],[17,"Break","","",null,null],[17,"Const","","",null,null],[17,"Continue","","",null,null],[17,"Crate","","",null,null],[17,"Else","","",null,null],[17,"Enum","","",null,null],[17,"Extern","","",null,null],[17,"False","","",null,null],[17,"Fn","","",null,null],[17,"For","","",null,null],[17,"If","","",null,null],[17,"Impl","","",null,null],[17,"In","","",null,null],[17,"Let","","",null,null],[17,"Loop","","",null,null],[17,"Match","","",null,null],[17,"Mod","","",null,null],[17,"Move","","",null,null],[17,"Mut","","",null,null],[17,"Pub","","",null,null],[17,"Ref","","",null,null],[17,"Return","","",null,null],[17,"SelfValue","","",null,null],[17,"SelfType","","",null,null],[17,"Static","","",null,null],[17,"Struct","","",null,null],[17,"Super","","",null,null],[17,"Trait","","",null,null],[17,"True","","",null,null],[17,"Type","","",null,null],[17,"Unsafe","","",null,null],[17,"Use","","",null,null],[17,"Where","","",null,null],[17,"While","","",null,null],[17,"Abstract","","",null,null],[17,"Alignof","","",null,null],[17,"Become","","",null,null],[17,"Do","","",null,null],[17,"Final","","",null,null],[17,"Macro","","",null,null],[17,"Offsetof","","",null,null],[17,"Override","","",null,null],[17,"Priv","","",null,null],[17,"Pure","","",null,null],[17,"Sizeof","","",null,null],[17,"Typeof","","",null,null],[17,"Unsized","","",null,null],[17,"Virtual","","",null,null],[17,"Yield","","",null,null],[17,"UnderscoreLifetime","","",null,null],[17,"StaticLifetime","","",null,null],[17,"Auto","","",null,null],[17,"Catch","","",null,null],[17,"Default","","",null,null],[17,"Dyn","","",null,null],[17,"Union","","",null,null],[3,"LocalInternedString","syntax::symbol","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",null,null],[12,"string","","",4,null],[3,"InternedString","","Represents a string stored in the string interner",null,null],[12,"symbol","","",5,null],[3,"Globals","syntax","",null,null],[12,"used_attrs","","",6,null],[12,"known_attrs","","",6,null],[12,"syntax_pos_globals","","",6,null],[5,"with_globals","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[0,"diagnostics","","",null,null],[0,"macros","syntax::diagnostics","",null,null],[0,"plugin","","",null,null],[3,"ErrorInfo","syntax::diagnostics::plugin","Error information type.",null,null],[12,"description","","",7,null],[12,"use_site","","",7,null],[5,"expand_diagnostic_used","","",null,null],[5,"expand_register_diagnostic","","",null,null],[5,"expand_build_diagnostic_array","","",null,null],[6,"ErrorMap","","Mapping from error codes to metadata.",null,null],[17,"MAX_DESCRIPTION_WIDTH","","",null,null],[0,"metadata","syntax::diagnostics","This module contains utilities for outputting metadata for diagnostic errors.",null,null],[3,"ErrorMetadata","syntax::diagnostics::metadata","JSON encodable/decodable version of `ErrorInfo`.",null,null],[12,"description","","",8,null],[12,"use_site","","",8,null],[3,"ErrorLocation","","JSON encodable error location type with filename and line number.",null,null],[12,"filename","","",9,null],[12,"line","","",9,null],[5,"get_metadata_dir","","Get the directory where metadata for a given `prefix` should be stored.",null,{"inputs":[{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"get_metadata_path","","Map `name` to a path in the given directory: /.json",null,{"inputs":[{"name":"pathbuf"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"output_metadata","","Write metadata for the errors in `err_map` to disk, to a file corresponding to `prefix/name`.",null,{"inputs":[{"name":"extctxt"},{"name":"str"},{"name":"str"},{"name":"errormap"}],"output":{"generics":["box"],"name":"result"}}],[6,"ErrorMetadataMap","","Mapping from error codes to metadata that can be (de)serialized.",null,null],[11,"eq","","",8,{"inputs":[{"name":"self"},{"name":"errormetadata"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"errormetadata"}],"output":{"name":"bool"}}],[11,"decode","","",8,{"inputs":[{"name":"__d"}],"output":{"generics":["errormetadata"],"name":"result"}}],[11,"encode","","",8,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",9,{"inputs":[{"name":"self"},{"name":"errorlocation"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"self"},{"name":"errorlocation"}],"output":{"name":"bool"}}],[11,"decode","","",9,{"inputs":[{"name":"__d"}],"output":{"generics":["errorlocation"],"name":"result"}}],[11,"encode","","",9,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"from_span","","Create an error location from a span.",9,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"errorlocation"}}],[0,"diagnostic_list","syntax","",null,null],[0,"__register_diagnostic_E0178","syntax::diagnostic_list","",null,null],[0,"__register_diagnostic_E0536","","",null,null],[0,"__register_diagnostic_E0537","","",null,null],[0,"__register_diagnostic_E0552","","",null,null],[0,"__register_diagnostic_E0554","","",null,null],[0,"__register_diagnostic_E0557","","",null,null],[0,"__register_diagnostic_E0565","","",null,null],[0,"__register_diagnostic_E0583","","",null,null],[0,"__register_diagnostic_E0585","","",null,null],[0,"__register_diagnostic_E0586","","",null,null],[0,"__register_diagnostic_E0589","","",null,null],[0,"__register_diagnostic_E0658","","",null,null],[0,"__register_diagnostic_E0633","","",null,null],[0,"__register_diagnostic_E0538","","",null,null],[0,"__register_diagnostic_E0539","","",null,null],[0,"__register_diagnostic_E0540","","",null,null],[0,"__register_diagnostic_E0541","","",null,null],[0,"__register_diagnostic_E0542","","",null,null],[0,"__register_diagnostic_E0543","","",null,null],[0,"__register_diagnostic_E0544","","",null,null],[0,"__register_diagnostic_E0545","","",null,null],[0,"__register_diagnostic_E0546","","",null,null],[0,"__register_diagnostic_E0547","","",null,null],[0,"__register_diagnostic_E0548","","",null,null],[0,"__register_diagnostic_E0549","","",null,null],[0,"__register_diagnostic_E0550","","",null,null],[0,"__register_diagnostic_E0551","","",null,null],[0,"__register_diagnostic_E0553","","",null,null],[0,"__register_diagnostic_E0555","","",null,null],[0,"__register_diagnostic_E0556","","",null,null],[0,"__register_diagnostic_E0584","","",null,null],[0,"__register_diagnostic_E0629","","",null,null],[0,"__register_diagnostic_E0630","","",null,null],[0,"__register_diagnostic_E0693","","",null,null],[0,"__register_diagnostic_E0694","","",null,null],[0,"util","syntax","",null,null],[3,"ThinVec","syntax::util","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",null,null],[12,"0","","",10,null],[3,"RcSlice","","",null,null],[12,"data","","",11,null],[12,"offset","","",11,null],[12,"len","","",11,null],[0,"lev_distance","","",null,null],[5,"lev_distance","syntax::util::lev_distance","To find the Levenshtein distance between two strings",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"usize"}}],[5,"find_best_match_for_name","","To find the best match for a given string from an iterator of names As a loose rule to avoid the obviously incorrect suggestions, it takes an optional limit for the maximum allowable edit distance, which defaults to one-third of the given word. Besides Levenshtein, we use case insensitive comparison to improve accuracy on an edge case with a lower(upper)case letters mismatch.",null,{"inputs":[{"name":"t"},{"name":"str"},{"generics":["usize"],"name":"option"}],"output":{"generics":["symbol"],"name":"option"}}],[0,"node_count","syntax::util","",null,null],[3,"NodeCounter","syntax::util::node_count","",null,null],[12,"count","","",12,null],[11,"new","","",12,{"inputs":[],"output":{"name":"nodecounter"}}],[11,"visit_ident","","",12,{"inputs":[{"name":"self"},{"name":"ident"}],"output":null}],[11,"visit_mod","","",12,null],[11,"visit_foreign_item","","",12,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_item","","",12,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_local","","",12,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",12,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",12,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_arm","","",12,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",12,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",12,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",12,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_generic_param","","",12,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"visit_generics","","",12,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_fn","","",12,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",12,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",12,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_trait_ref","","",12,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_ty_param_bound","","",12,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":null}],[11,"visit_poly_trait_ref","","",12,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_variant_data","","",12,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_struct_field","","",12,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_enum_def","","",12,{"inputs":[{"name":"self"},{"name":"enumdef"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_variant","","",12,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_lifetime","","",12,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_mac","","",12,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[11,"visit_path","","",12,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_use_tree","","",12,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"visit_path_parameters","","",12,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[11,"visit_assoc_type_binding","","",12,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":null}],[11,"visit_attribute","","",12,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[0,"parser","syntax::util","",null,null],[4,"AssocOp","syntax::util::parser","Associative operator with precedence.",null,null],[13,"Add","","`+`",13,null],[13,"Subtract","","`-`",13,null],[13,"Multiply","","`*`",13,null],[13,"Divide","","`/`",13,null],[13,"Modulus","","`%`",13,null],[13,"LAnd","","`&&`",13,null],[13,"LOr","","`||`",13,null],[13,"BitXor","","`^`",13,null],[13,"BitAnd","","`&`",13,null],[13,"BitOr","","`|`",13,null],[13,"ShiftLeft","","`<<`",13,null],[13,"ShiftRight","","`>>`",13,null],[13,"Equal","","`==`",13,null],[13,"Less","","`<`",13,null],[13,"LessEqual","","`<=`",13,null],[13,"NotEqual","","`!=`",13,null],[13,"Greater","","`>`",13,null],[13,"GreaterEqual","","`>=`",13,null],[13,"Assign","","`=`",13,null],[13,"ObsoleteInPlace","","`<-`",13,null],[13,"AssignOp","","`?=` where ? is one of the BinOpToken",13,null],[13,"As","","`as`",13,null],[13,"DotDot","","`..` range",13,null],[13,"DotDotEq","","`..=` range",13,null],[13,"Colon","","`:`",13,null],[4,"Fixity","","",null,null],[13,"Left","","The operator is left-associative",14,null],[13,"Right","","The operator is right-associative",14,null],[13,"None","","The operator is not associative",14,null],[4,"ExprPrecedence","","",null,null],[13,"Closure","","",15,null],[13,"Break","","",15,null],[13,"Continue","","",15,null],[13,"Ret","","",15,null],[13,"Yield","","",15,null],[13,"Range","","",15,null],[13,"Binary","","",15,null],[13,"ObsoleteInPlace","","",15,null],[13,"Cast","","",15,null],[13,"Type","","",15,null],[13,"Assign","","",15,null],[13,"AssignOp","","",15,null],[13,"Box","","",15,null],[13,"AddrOf","","",15,null],[13,"Unary","","",15,null],[13,"Call","","",15,null],[13,"MethodCall","","",15,null],[13,"Field","","",15,null],[13,"Index","","",15,null],[13,"Try","","",15,null],[13,"InlineAsm","","",15,null],[13,"Mac","","",15,null],[13,"Array","","",15,null],[13,"Repeat","","",15,null],[13,"Tup","","",15,null],[13,"Lit","","",15,null],[13,"Path","","",15,null],[13,"Paren","","",15,null],[13,"If","","",15,null],[13,"IfLet","","",15,null],[13,"While","","",15,null],[13,"WhileLet","","",15,null],[13,"ForLoop","","",15,null],[13,"Loop","","",15,null],[13,"Match","","",15,null],[13,"Block","","",15,null],[13,"Catch","","",15,null],[13,"Struct","","",15,null],[5,"contains_exterior_struct_lit","","Expressions that syntactically contain an \"exterior\" struct literal i.e. not surrounded by any parens or other delimiters, e.g. `X { y: 1 }`, `X { y: 1 }.method()`, `foo == X { y: 1 }` and `X { y: 1 } == foo` all do, but `(X { y: 1 }) == foo` does not.",null,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[17,"PREC_RESET","","",null,null],[17,"PREC_CLOSURE","","",null,null],[17,"PREC_JUMP","","",null,null],[17,"PREC_RANGE","","",null,null],[17,"PREC_PREFIX","","",null,null],[17,"PREC_POSTFIX","","",null,null],[17,"PREC_PAREN","","",null,null],[17,"PREC_FORCE_PAREN","","",null,null],[11,"fmt","","",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"self"},{"name":"assocop"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"self"},{"name":"assocop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",13,null],[11,"fmt","","",14,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"self"},{"name":"fixity"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",14,null],[11,"from_token","","Create a new AssocOP from a token",13,{"inputs":[{"name":"token"}],"output":{"generics":["assocop"],"name":"option"}}],[11,"from_ast_binop","","Create a new AssocOp from ast::BinOpKind.",13,{"inputs":[{"name":"binopkind"}],"output":{"name":"self"}}],[11,"precedence","","Gets the precedence of this operator",13,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"fixity","","Gets the fixity of this operator",13,{"inputs":[{"name":"self"}],"output":{"name":"fixity"}}],[11,"is_comparison","","",13,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_assign_like","","",13,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"to_ast_binop","","",13,{"inputs":[{"name":"self"}],"output":{"generics":["binopkind"],"name":"option"}}],[11,"fmt","","",15,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",15,{"inputs":[{"name":"self"}],"output":{"name":"exprprecedence"}}],[11,"eq","","",15,{"inputs":[{"name":"self"},{"name":"exprprecedence"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"self"},{"name":"exprprecedence"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",15,null],[11,"partial_cmp","","",15,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",15,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"order","","",15,{"inputs":[{"name":"self"}],"output":{"name":"i8"}}],[0,"small_vector","syntax::util","",null,null],[6,"SmallVector","syntax::util::small_vector","",null,null],[0,"move_map","syntax::util","",null,null],[8,"MoveMap","syntax::util::move_map","",null,null],[11,"move_map","","",16,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[10,"move_flat_map","","",16,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"move_flat_map","","",17,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[0,"thin_vec","syntax::util","",null,null],[3,"ThinVec","syntax::util::thin_vec","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",null,null],[12,"0","","",10,null],[11,"clone","syntax::util","",10,{"inputs":[{"name":"self"}],"output":{"name":"thinvec"}}],[11,"eq","","",10,{"inputs":[{"name":"self"},{"name":"thinvec"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"self"},{"name":"thinvec"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",10,null],[11,"encode","","",10,{"inputs":[{"name":"self"},{"name":"__st"}],"output":{"name":"result"}}],[11,"decode","","",10,{"inputs":[{"name":"__dt"}],"output":{"generics":["thinvec"],"name":"result"}}],[11,"hash","","",10,null],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",10,{"inputs":[],"output":{"name":"self"}}],[11,"from","","",10,{"inputs":[{"name":"vec"}],"output":{"name":"self"}}],[11,"into","","",10,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"deref","","",10,null],[11,"extend","","",10,{"inputs":[{"name":"self"},{"name":"i"}],"output":null}],[0,"rc_slice","","",null,null],[3,"RcSlice","syntax::util::rc_slice","",null,null],[12,"data","","",11,null],[12,"offset","","",11,null],[12,"len","","",11,null],[11,"clone","syntax::util","",11,{"inputs":[{"name":"self"}],"output":{"name":"rcslice"}}],[11,"new","","",11,{"inputs":[{"name":"vec"}],"output":{"name":"self"}}],[11,"sub_slice","","",11,{"inputs":[{"name":"self"},{"generics":["usize"],"name":"range"}],"output":{"name":"self"}}],[11,"deref","","",11,null],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash_stable","","",11,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[0,"json","syntax","A JSON emitter for errors.",null,null],[3,"JsonEmitter","syntax::json","",null,null],[12,"dst","","",18,null],[12,"registry","","",18,null],[12,"cm","","",18,null],[12,"pretty","","",18,null],[12,"suggestion_applicability","","Whether \"approximate suggestions\" are enabled in the config",18,null],[12,"ui_testing","","",18,null],[3,"Diagnostic","","",null,null],[12,"message","","The primary error message.",19,null],[12,"code","","",19,null],[12,"level","","\"error: internal compiler error\", \"error\", \"warning\", \"note\", \"help\".",19,null],[12,"spans","","",19,null],[12,"children","","Associated diagnostic messages.",19,null],[12,"rendered","","The message as rustc would render it.",19,null],[3,"DiagnosticSpan","","",null,null],[12,"file_name","","",20,null],[12,"byte_start","","",20,null],[12,"byte_end","","",20,null],[12,"line_start","","1-based.",20,null],[12,"line_end","","",20,null],[12,"column_start","","1-based, character offset.",20,null],[12,"column_end","","",20,null],[12,"is_primary","","Is this a \"primary\" span -- meaning the point, or one of the points, where the error occurred?",20,null],[12,"text","","Source text from the start of line_start to the end of line_end.",20,null],[12,"label","","Label that should be placed at this location (if any)",20,null],[12,"suggested_replacement","","If we are suggesting a replacement, this will contain text that should be sliced in atop this span.",20,null],[12,"suggestion_applicability","","If the suggestion is approximate",20,null],[12,"expansion","","Macro invocations that created the code at this span, if any.",20,null],[3,"DiagnosticSpanLine","","",null,null],[12,"text","","",21,null],[12,"highlight_start","","1-based, character offset in self.text.",21,null],[12,"highlight_end","","",21,null],[3,"DiagnosticSpanMacroExpansion","","",null,null],[12,"span","","span where macro was applied to generate this code; note that this may itself derive from a macro (if `span.expansion.is_some()`)",22,null],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",22,null],[12,"def_site_span","","span where macro was defined (if known)",22,null],[3,"DiagnosticCode","","",null,null],[12,"code","","The code itself.",23,null],[12,"explanation","","An explanation for the code.",23,null],[11,"stderr","","",18,{"inputs":[{"generics":["registry"],"name":"option"},{"generics":["codemap"],"name":"lrc"},{"name":"bool"},{"name":"bool"}],"output":{"name":"jsonemitter"}}],[11,"basic","","",18,{"inputs":[{"name":"bool"}],"output":{"name":"jsonemitter"}}],[11,"new","","",18,{"inputs":[{"generics":["write"],"name":"box"},{"generics":["registry"],"name":"option"},{"generics":["codemap"],"name":"lrc"},{"name":"bool"},{"name":"bool"}],"output":{"name":"jsonemitter"}}],[11,"ui_testing","","",18,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"name":"self"}}],[11,"emit","","",18,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"encode","","",19,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",20,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",21,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"from_diagnostic_builder","","",19,{"inputs":[{"name":"diagnosticbuilder"},{"name":"jsonemitter"}],"output":{"name":"diagnostic"}}],[11,"from_sub_diagnostic","","",19,{"inputs":[{"name":"subdiagnostic"},{"name":"jsonemitter"}],"output":{"name":"diagnostic"}}],[11,"from_span_label","","",20,{"inputs":[{"name":"spanlabel"},{"name":"option"},{"name":"jsonemitter"}],"output":{"name":"diagnosticspan"}}],[11,"from_span_etc","","",20,{"inputs":[{"name":"span"},{"name":"bool"},{"generics":["string"],"name":"option"},{"name":"option"},{"name":"jsonemitter"}],"output":{"name":"diagnosticspan"}}],[11,"from_span_full","","",20,{"inputs":[{"name":"span"},{"name":"bool"},{"generics":["string"],"name":"option"},{"name":"option"},{"generics":["macrobacktrace"],"name":"intoiter"},{"name":"jsonemitter"}],"output":{"name":"diagnosticspan"}}],[11,"from_multispan","","",20,{"inputs":[{"name":"multispan"},{"name":"jsonemitter"}],"output":{"generics":["diagnosticspan"],"name":"vec"}}],[11,"from_suggestion","","",20,{"inputs":[{"name":"codesuggestion"},{"name":"jsonemitter"}],"output":{"generics":["diagnosticspan"],"name":"vec"}}],[11,"line_from_filemap","","",21,{"inputs":[{"name":"filemap"},{"name":"usize"},{"name":"usize"},{"name":"usize"}],"output":{"name":"diagnosticspanline"}}],[11,"from_span","","Create a list of DiagnosticSpanLines from span - each line with any part of `span` gets a DiagnosticSpanLine, with the highlight indicating the `span` within the line.",21,{"inputs":[{"name":"span"},{"name":"jsonemitter"}],"output":{"generics":["diagnosticspanline"],"name":"vec"}}],[11,"map_opt_string","","",23,{"inputs":[{"generics":["diagnosticid"],"name":"option"},{"name":"jsonemitter"}],"output":{"generics":["diagnosticcode"],"name":"option"}}],[0,"syntax","syntax","",null,null],[0,"ast","","",null,null],[3,"Ident","syntax::ast","",null,null],[12,"name","","",0,null],[12,"span","","",0,null],[3,"Name","","A symbol is an interned or gensymed string.",null,null],[12,"0","","",1,null],[3,"ThinVec","","A vector type optimized for cases where this size is usually 0 (c.f. `SmallVector`). The `Option<Box<..>>` wrapping allows us to represent a zero sized vector with `None`, which uses only a single (null) pointer.",null,null],[12,"0","","",10,null],[3,"Label","","",null,null],[12,"ident","","",24,null],[3,"Lifetime","","",null,null],[12,"id","","",25,null],[12,"ident","","",25,null],[3,"LifetimeDef","","A lifetime definition, e.g. `'a: 'b+'c+'d`",null,null],[12,"attrs","","",26,null],[12,"lifetime","","",26,null],[12,"bounds","","",26,null],[3,"Path","","A \"Path\" is essentially Rust's notion of a name.",null,null],[12,"span","","",27,null],[12,"segments","","The segments in the path: the things separated by `::`. Global paths begin with `keywords::CrateRoot`.",27,null],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of types.",null,null],[12,"ident","","The identifier portion of this path segment.",28,null],[12,"parameters","","Type/lifetime parameters attached to this path. They come in two flavors: `Path<A,B,C>` and `Path(A,B) -> C`. `None` means that no parameter list is supplied (`Path`), `Some` means that parameter list is supplied (`Path<X, Y>`) but it can be empty (`Path<>`). `P` is used as a size optimization for the common case with no parameters.",28,null],[3,"AngleBracketedParameterData","","A path like `Foo<'a, T>`",null,null],[12,"span","","Overall span",29,null],[12,"lifetimes","","The lifetime parameters for this path segment.",29,null],[12,"types","","The type parameters for this path segment, if present.",29,null],[12,"bindings","","Bindings (equality constraints) on associated types, if present.",29,null],[3,"ParenthesizedParameterData","","A path like `Foo(A,B) -> C`",null,null],[12,"span","","Overall span",30,null],[12,"inputs","","`(A,B)`",30,null],[12,"output","","`C`",30,null],[3,"NodeId","","",null,null],[12,"0","","",31,null],[3,"TyParam","","",null,null],[12,"attrs","","",32,null],[12,"ident","","",32,null],[12,"id","","",32,null],[12,"bounds","","",32,null],[12,"default","","",32,null],[3,"Generics","","Represents lifetime, type and const parameters attached to a declaration of a function, enum, trait, etc.",null,null],[12,"params","","",33,null],[12,"where_clause","","",33,null],[12,"span","","",33,null],[3,"WhereClause","","A `where` clause in a definition",null,null],[12,"id","","",34,null],[12,"predicates","","",34,null],[12,"span","","",34,null],[3,"WhereBoundPredicate","","A type bound.",null,null],[12,"span","","",35,null],[12,"bound_generic_params","","Any generics from a `for` binding",35,null],[12,"bounded_ty","","The type being bounded",35,null],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",35,null],[3,"WhereRegionPredicate","","A lifetime predicate.",null,null],[12,"span","","",36,null],[12,"lifetime","","",36,null],[12,"bounds","","",36,null],[3,"WhereEqPredicate","","An equality predicate (unsupported).",null,null],[12,"id","","",37,null],[12,"span","","",37,null],[12,"lhs_ty","","",37,null],[12,"rhs_ty","","",37,null],[3,"Crate","","",null,null],[12,"module","","",38,null],[12,"attrs","","",38,null],[12,"span","","",38,null],[3,"MetaItem","","A spanned compile-time attribute item.",null,null],[12,"ident","","",39,null],[12,"node","","",39,null],[12,"span","","",39,null],[3,"Block","","A Block (`{ .. }`).",null,null],[12,"stmts","","Statements in a block",40,null],[12,"id","","",40,null],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",40,null],[12,"span","","",40,null],[12,"recovered","","",40,null],[3,"Pat","","",null,null],[12,"id","","",41,null],[12,"node","","",41,null],[12,"span","","",41,null],[3,"FieldPat","","A single field in a struct pattern",null,null],[12,"ident","","The identifier for the field",42,null],[12,"pat","","The pattern the field is destructured to",42,null],[12,"is_shorthand","","",42,null],[12,"attrs","","",42,null],[3,"Stmt","","A statement",null,null],[12,"id","","",43,null],[12,"node","","",43,null],[12,"span","","",43,null],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",null,null],[12,"pat","","",44,null],[12,"ty","","",44,null],[12,"init","","Initializer expression to set the value, if any",44,null],[12,"id","","",44,null],[12,"span","","",44,null],[12,"attrs","","",44,null],[3,"Arm","","An arm of a 'match'.",null,null],[12,"attrs","","",45,null],[12,"pats","","",45,null],[12,"guard","","",45,null],[12,"body","","",45,null],[3,"Field","","",null,null],[12,"ident","","",46,null],[12,"expr","","",46,null],[12,"span","","",46,null],[12,"is_shorthand","","",46,null],[12,"attrs","","",46,null],[3,"Expr","","An expression",null,null],[12,"id","","",47,null],[12,"node","","",47,null],[12,"span","","",47,null],[12,"attrs","","",47,null],[3,"QSelf","","The explicit Self type in a \"qualified path\". The actual path, including the trait and the associated item, is stored separately. `position` represents the index of the associated item qualified with this Self type.",null,null],[12,"ty","","",48,null],[12,"position","","",48,null],[3,"Mac_","","Represents a macro invocation. The Path indicates which macro is being invoked, and the vector of token-trees contains the source of the macro invocation.",null,null],[12,"path","","",49,null],[12,"tts","","",49,null],[3,"MacroDef","","",null,null],[12,"tokens","","",50,null],[12,"legacy","","",50,null],[3,"MutTy","","",null,null],[12,"ty","","",51,null],[12,"mutbl","","",51,null],[3,"MethodSig","","Represents a method's signature in a trait declaration, or in an implementation.",null,null],[12,"unsafety","","",52,null],[12,"constness","","",52,null],[12,"abi","","",52,null],[12,"decl","","",52,null],[3,"TraitItem","","Represents an item declaration within a trait declaration, possibly including a default implementation. A trait item is either required (meaning it doesn't have an implementation, just a signature) or provided (meaning it has a default implementation).",null,null],[12,"id","","",53,null],[12,"ident","","",53,null],[12,"attrs","","",53,null],[12,"generics","","",53,null],[12,"node","","",53,null],[12,"span","","",53,null],[12,"tokens","","See `Item::tokens` for what this is",53,null],[3,"ImplItem","","",null,null],[12,"id","","",54,null],[12,"ident","","",54,null],[12,"vis","","",54,null],[12,"defaultness","","",54,null],[12,"attrs","","",54,null],[12,"generics","","",54,null],[12,"node","","",54,null],[12,"span","","",54,null],[12,"tokens","","See `Item::tokens` for what this is",54,null],[3,"TypeBinding","","",null,null],[12,"id","","",55,null],[12,"ident","","",55,null],[12,"ty","","",55,null],[12,"span","","",55,null],[3,"Ty","","",null,null],[12,"id","","",56,null],[12,"node","","",56,null],[12,"span","","",56,null],[3,"BareFnTy","","",null,null],[12,"unsafety","","",57,null],[12,"abi","","",57,null],[12,"generic_params","","",57,null],[12,"decl","","",57,null],[3,"InlineAsmOutput","","Inline assembly.",null,null],[12,"constraint","","",58,null],[12,"expr","","",58,null],[12,"is_rw","","",58,null],[12,"is_indirect","","",58,null],[3,"InlineAsm","","Inline assembly.",null,null],[12,"asm","","",59,null],[12,"asm_str_style","","",59,null],[12,"outputs","","",59,null],[12,"inputs","","",59,null],[12,"clobbers","","",59,null],[12,"volatile","","",59,null],[12,"alignstack","","",59,null],[12,"dialect","","",59,null],[12,"ctxt","","",59,null],[3,"Arg","","An argument in a function header.",null,null],[12,"ty","","",60,null],[12,"pat","","",60,null],[12,"id","","",60,null],[3,"FnDecl","","Header (not the body) of a function declaration.",null,null],[12,"inputs","","",61,null],[12,"output","","",61,null],[12,"variadic","","",61,null],[3,"Mod","","Module declaration.",null,null],[12,"inner","","A span from the first token past `{` to the last token until `}`. For `mod foo;`, the inner span ranges from the first token to the last token in the external file.",62,null],[12,"items","","",62,null],[3,"ForeignMod","","Foreign module declaration.",null,null],[12,"abi","","",63,null],[12,"items","","",63,null],[3,"GlobalAsm","","Global inline assembly",null,null],[12,"asm","","",64,null],[12,"ctxt","","",64,null],[3,"EnumDef","","",null,null],[12,"variants","","",65,null],[3,"Variant_","","",null,null],[12,"ident","","",66,null],[12,"attrs","","",66,null],[12,"data","","",66,null],[12,"disr_expr","","Explicit discriminant, e.g. `Foo = 1`",66,null],[3,"UseTree","","A tree of paths sharing common prefixes. Used in `use` items both at top-level and inside of braces in import groups.",null,null],[12,"prefix","","",67,null],[12,"kind","","",67,null],[12,"span","","",67,null],[3,"AttrId","","",null,null],[12,"0","","",68,null],[3,"Attribute","","Meta-data associated with an item Doc-comments are promoted to attributes that have is_sugared_doc = true",null,null],[12,"id","","",69,null],[12,"style","","",69,null],[12,"path","","",69,null],[12,"tokens","","",69,null],[12,"is_sugared_doc","","",69,null],[12,"span","","",69,null],[3,"TraitRef","","TraitRef's appear in impls.",null,null],[12,"path","","",70,null],[12,"ref_id","","",70,null],[3,"PolyTraitRef","","",null,null],[12,"bound_generic_params","","The `'a` in `<'a> Foo<&'a T>`",71,null],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",71,null],[12,"span","","",71,null],[3,"StructField","","Field of a struct.",null,null],[12,"span","","",72,null],[12,"ident","","",72,null],[12,"vis","","",72,null],[12,"id","","",72,null],[12,"ty","","",72,null],[12,"attrs","","",72,null],[3,"Item","","An item",null,null],[12,"ident","","",73,null],[12,"attrs","","",73,null],[12,"id","","",73,null],[12,"node","","",73,null],[12,"vis","","",73,null],[12,"span","","",73,null],[12,"tokens","","Original tokens this item was parsed from. This isn't necessarily available for all items, although over time more and more items should have this be `Some`. Right now this is primarily used for procedural macros, notably custom attributes.",73,null],[3,"ForeignItem","","",null,null],[12,"ident","","",74,null],[12,"attrs","","",74,null],[12,"node","","",74,null],[12,"id","","",74,null],[12,"span","","",74,null],[12,"vis","","",74,null],[4,"PathParameters","","Parameters of a path segment.",null,null],[13,"AngleBracketed","","The `<'a, A,B,C>` in `foo::bar::baz::<'a, A,B,C>`",75,null],[13,"Parenthesized","","The `(A,B)` and `C` in `Foo(A,B) -> C`",75,null],[4,"TyParamBound","","The AST represents all type param bounds as types. typeck::collect::compute_bounds matches these against the \"special\" built-in traits (see middle::lang_items) and detects Copy, Send and Sync.",null,null],[13,"TraitTyParamBound","","",76,null],[13,"RegionTyParamBound","","",76,null],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the modifier is `Maybe`. Negative bounds should also be handled here.",null,null],[13,"None","","",77,null],[13,"Maybe","","",77,null],[4,"GenericParam","","",null,null],[13,"Lifetime","","",78,null],[13,"Type","","",78,null],[4,"WherePredicate","","A single predicate in a `where` clause",null,null],[13,"BoundPredicate","","A type binding, e.g. `for<'c> Foo: Send+Clone+'c`",79,null],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",79,null],[13,"EqPredicate","","An equality predicate (unsupported)",79,null],[4,"NestedMetaItemKind","","Possible values inside of compile-time attribute lists.",null,null],[13,"MetaItem","","A full MetaItem, for recursive meta items.",80,null],[13,"Literal","","A literal.",80,null],[4,"MetaItemKind","","A compile-time attribute item.",null,null],[13,"Word","","Word meta item.",81,null],[13,"List","","List meta item.",81,null],[13,"NameValue","","Name value meta item.",81,null],[4,"BindingMode","","",null,null],[13,"ByRef","","",82,null],[13,"ByValue","","",82,null],[4,"RangeEnd","","",null,null],[13,"Included","","",83,null],[13,"Excluded","","",83,null],[4,"RangeSyntax","","",null,null],[13,"DotDotDot","","",84,null],[13,"DotDotEq","","",84,null],[4,"PatKind","","",null,null],[13,"Wild","","Represents a wildcard pattern (`_`)",85,null],[13,"Ident","","A `PatKind::Ident` may either be a new bound variable (`ref mut binding @ OPT_SUBPATTERN`), or a unit struct/variant pattern, or a const pattern (in the last two cases the third field must be `None`). Disambiguation cannot be done with parser alone, so it happens during name resolution.",85,null],[13,"Struct","","A struct or struct variant pattern, e.g. `Variant {x, y, ..}`. The `bool` is `true` in the presence of a `..`.",85,null],[13,"TupleStruct","","A tuple struct/variant pattern `Variant(x, y, .., z)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",85,null],[13,"Path","","A possibly qualified path pattern. Unqualified path patterns `A::B::C` can legally refer to variants, structs, constants or associated constants. Qualified path patterns `<A>::B::C`/`<A as Trait>::B::C` can only legally refer to associated constants.",85,null],[13,"Tuple","","A tuple pattern `(a, b)`. If the `..` pattern fragment is present, then `Option<usize>` denotes its position. 0 <= position <= subpats.len()",85,null],[13,"Box","","A `box` pattern",85,null],[13,"Ref","","A reference pattern, e.g. `&mut (a, b)`",85,null],[13,"Lit","","A literal",85,null],[13,"Range","","A range pattern, e.g. `1...2`, `1..=2` or `1..2`",85,null],[13,"Slice","","`[a, b, ..i, y, z]` is represented as: `PatKind::Slice(box [a, b], Some(i), box [y, z])`",85,null],[13,"Paren","","Parentheses in patters used for grouping, i.e. `(PAT)`.",85,null],[13,"Mac","","A macro pattern; pre-expansion",85,null],[4,"Mutability","","",null,null],[13,"Mutable","","",86,null],[13,"Immutable","","",86,null],[4,"BinOpKind","","",null,null],[13,"Add","","The `+` operator (addition)",87,null],[13,"Sub","","The `-` operator (subtraction)",87,null],[13,"Mul","","The `*` operator (multiplication)",87,null],[13,"Div","","The `/` operator (division)",87,null],[13,"Rem","","The `%` operator (modulus)",87,null],[13,"And","","The `&&` operator (logical and)",87,null],[13,"Or","","The `||` operator (logical or)",87,null],[13,"BitXor","","The `^` operator (bitwise xor)",87,null],[13,"BitAnd","","The `&` operator (bitwise and)",87,null],[13,"BitOr","","The `|` operator (bitwise or)",87,null],[13,"Shl","","The `<<` operator (shift left)",87,null],[13,"Shr","","The `>>` operator (shift right)",87,null],[13,"Eq","","The `==` operator (equality)",87,null],[13,"Lt","","The `<` operator (less than)",87,null],[13,"Le","","The `<=` operator (less than or equal to)",87,null],[13,"Ne","","The `!=` operator (not equal to)",87,null],[13,"Ge","","The `>=` operator (greater than or equal to)",87,null],[13,"Gt","","The `>` operator (greater than)",87,null],[4,"UnOp","","",null,null],[13,"Deref","","The `*` operator for dereferencing",88,null],[13,"Not","","The `!` operator for logical inversion",88,null],[13,"Neg","","The `-` operator for negation",88,null],[4,"StmtKind","","",null,null],[13,"Local","","A local (let) binding.",89,null],[13,"Item","","An item definition.",89,null],[13,"Expr","","Expr without trailing semi-colon.",89,null],[13,"Semi","","Expr with a trailing semi-colon.",89,null],[13,"Mac","","Macro.",89,null],[4,"MacStmtStyle","","",null,null],[13,"Semicolon","","The macro statement had a trailing semicolon, e.g. `foo! { ... };` `foo!(...);`, `foo![...];`",90,null],[13,"Braces","","The macro statement had braces; e.g. foo! { ... }",90,null],[13,"NoBraces","","The macro statement had parentheses or brackets and no semicolon; e.g. `foo!(...)`. All of these will end up being converted into macro expressions.",90,null],[4,"BlockCheckMode","","",null,null],[13,"Default","","",91,null],[13,"Unsafe","","",91,null],[4,"UnsafeSource","","",null,null],[13,"CompilerGenerated","","",92,null],[13,"UserProvided","","",92,null],[4,"RangeLimits","","Limit types of a range (inclusive or exclusive)",null,null],[13,"HalfOpen","","Inclusive at the beginning, exclusive at the end",93,null],[13,"Closed","","Inclusive at the beginning and end",93,null],[4,"ExprKind","","",null,null],[13,"Box","","A `box x` expression.",94,null],[13,"ObsoleteInPlace","","First expr is the place; second expr is the value.",94,null],[13,"Array","","An array (`[a, b, c, d]`)",94,null],[13,"Call","","A function call",94,null],[13,"MethodCall","","A method call (`x.foo::<'static, Bar, Baz>(a, b, c, d)`)",94,null],[13,"Tup","","A tuple (`(a, b, c ,d)`)",94,null],[13,"Binary","","A binary operation (For example: `a + b`, `a * b`)",94,null],[13,"Unary","","A unary operation (For example: `!x`, `*x`)",94,null],[13,"Lit","","A literal (For example: `1`, `\"foo\"`)",94,null],[13,"Cast","","A cast (`foo as f64`)",94,null],[13,"Type","","",94,null],[13,"If","","An `if` block, with an optional else block",94,null],[13,"IfLet","","An `if let` expression with an optional else block",94,null],[13,"While","","A while loop, with an optional label",94,null],[13,"WhileLet","","A while-let loop, with an optional label",94,null],[13,"ForLoop","","A for loop, with an optional label",94,null],[13,"Loop","","Conditionless loop (can be exited with break, continue, or return)",94,null],[13,"Match","","A `match` block.",94,null],[13,"Closure","","A closure (for example, `move |a, b, c| a + b + c`)",94,null],[13,"Block","","A block (`{ ... }`)",94,null],[13,"Catch","","A catch block (`catch { ... }`)",94,null],[13,"Assign","","An assignment (`a = foo()`)",94,null],[13,"AssignOp","","An assignment with an operator",94,null],[13,"Field","","Access of a named (`obj.foo`) or unnamed (`obj.0`) struct field",94,null],[13,"Index","","An indexing operation (`foo[2]`)",94,null],[13,"Range","","A range (`1..2`, `1..`, `..2`, `1...2`, `1...`, `...2`)",94,null],[13,"Path","","Variable reference, possibly containing `::` and/or type parameters, e.g. foo::bar::.",94,null],[13,"AddrOf","","A referencing operation (`&a` or `&mut a`)",94,null],[13,"Break","","A `break`, with an optional label to break, and an optional expression",94,null],[13,"Continue","","A `continue`, with an optional label",94,null],[13,"Ret","","A `return`, with an optional value to be returned",94,null],[13,"InlineAsm","","Output of the `asm!()` macro",94,null],[13,"Mac","","A macro invocation; pre-expansion",94,null],[13,"Struct","","A struct literal expression.",94,null],[13,"Repeat","","An array literal constructed from one repeated element.",94,null],[13,"Paren","","No-op: used solely so we can pretty-print faithfully",94,null],[13,"Try","","`expr?`",94,null],[13,"Yield","","A `yield`, with an optional value to be yielded",94,null],[4,"CaptureBy","","A capture clause",null,null],[13,"Value","","",95,null],[13,"Ref","","",95,null],[4,"Movability","","The movability of a generator / closure literal",null,null],[13,"Static","","",96,null],[13,"Movable","","",96,null],[4,"StrStyle","","",null,null],[13,"Cooked","","A regular string, like `\"foo\"`",97,null],[13,"Raw","","A raw string, like `r##\"foo\"##`",97,null],[4,"LitIntType","","",null,null],[13,"Signed","","",98,null],[13,"Unsigned","","",98,null],[13,"Unsuffixed","","",98,null],[4,"LitKind","","Literal kind.",null,null],[13,"Str","","A string literal (`\"foo\"`)",99,null],[13,"ByteStr","","A byte string (`b\"foo\"`)",99,null],[13,"Byte","","A byte char (`b'f'`)",99,null],[13,"Char","","A character literal (`'a'`)",99,null],[13,"Int","","An integer literal (`1`)",99,null],[13,"Float","","A float literal (`1f64` or `1E10f64`)",99,null],[13,"FloatUnsuffixed","","A float literal without a suffix (`1.0 or 1.0E10`)",99,null],[13,"Bool","","A boolean literal",99,null],[4,"TraitItemKind","","",null,null],[13,"Const","","",100,null],[13,"Method","","",100,null],[13,"Type","","",100,null],[13,"Macro","","",100,null],[4,"ImplItemKind","","",null,null],[13,"Const","","",101,null],[13,"Method","","",101,null],[13,"Type","","",101,null],[13,"Macro","","",101,null],[4,"IntTy","","",null,null],[13,"Isize","","",102,null],[13,"I8","","",102,null],[13,"I16","","",102,null],[13,"I32","","",102,null],[13,"I64","","",102,null],[13,"I128","","",102,null],[4,"UintTy","","",null,null],[13,"Usize","","",103,null],[13,"U8","","",103,null],[13,"U16","","",103,null],[13,"U32","","",103,null],[13,"U64","","",103,null],[13,"U128","","",103,null],[4,"FloatTy","","",null,null],[13,"F32","","",104,null],[13,"F64","","",104,null],[4,"TyKind","","The different kinds of types recognized by the compiler",null,null],[13,"Slice","","A variable-length slice (`[T]`)",105,null],[13,"Array","","A fixed length array (`[T; n]`)",105,null],[13,"Ptr","","A raw pointer (`*const T` or `*mut T`)",105,null],[13,"Rptr","","A reference (`&'a T` or `&'a mut T`)",105,null],[13,"BareFn","","A bare function (e.g. `fn(usize) -> bool`)",105,null],[13,"Never","","The never type (`!`)",105,null],[13,"Tup","","A tuple (`(A, B, C, D,...)`)",105,null],[13,"Path","","A path (`module::module::...::Type`), optionally \"qualified\", e.g. `<Vec<T> as SomeTrait>::SomeType`.",105,null],[13,"TraitObject","","A trait object type `Bound1 + Bound2 + Bound3` where `Bound` is a trait or a lifetime.",105,null],[13,"ImplTrait","","An `impl Bound1 + Bound2 + Bound3` type where `Bound` is a trait or a lifetime.",105,null],[13,"Paren","","No-op; kept solely so that we can pretty-print faithfully",105,null],[13,"Typeof","","Unused for now",105,null],[13,"Infer","","TyKind::Infer means the type should be inferred instead of it having been specified. This can appear anywhere in a type.",105,null],[13,"ImplicitSelf","","Inferred type of a `self` or `&self` argument in a method.",105,null],[13,"Mac","","",105,null],[13,"Err","","Placeholder for a kind that has failed to be defined.",105,null],[4,"TraitObjectSyntax","","Syntax used to declare a trait object.",null,null],[13,"Dyn","","",106,null],[13,"None","","",106,null],[4,"AsmDialect","","Inline assembly dialect.",null,null],[13,"Att","","",107,null],[13,"Intel","","",107,null],[4,"SelfKind","","Alternative representation for `Arg`s describing `self` parameter of methods.",null,null],[13,"Value","","`self`, `mut self`",108,null],[13,"Region","","`&'lt self`, `&'lt mut self`",108,null],[13,"Explicit","","`self: TYPE`, `mut self: TYPE`",108,null],[4,"IsAuto","","Is the trait definition an auto trait?",null,null],[13,"Yes","","",109,null],[13,"No","","",109,null],[4,"Unsafety","","",null,null],[13,"Unsafe","","",110,null],[13,"Normal","","",110,null],[4,"Constness","","",null,null],[13,"Const","","",111,null],[13,"NotConst","","",111,null],[4,"Defaultness","","",null,null],[13,"Default","","",112,null],[13,"Final","","",112,null],[4,"ImplPolarity","","",null,null],[13,"Positive","","`impl Trait for Type`",113,null],[13,"Negative","","`impl !Trait for Type`",113,null],[4,"FunctionRetTy","","",null,null],[13,"Default","","Return type is not specified.",114,null],[13,"Ty","","Everything else",114,null],[4,"UseTreeKind","","Part of `use` item to the right of its prefix.",null,null],[13,"Simple","","`use prefix` or `use prefix as rename`",115,null],[13,"Nested","","`use prefix::{...}`",115,null],[13,"Glob","","`use prefix::*`",115,null],[4,"AttrStyle","","Distinguishes between Attributes that decorate items and Attributes that are contained as statements within items. These two cases need to be distinguished for pretty-printing.",null,null],[13,"Outer","","",116,null],[13,"Inner","","",116,null],[4,"CrateSugar","","",null,null],[13,"PubCrate","","Source is `pub(crate)`",117,null],[13,"JustCrate","","Source is (just) `crate`",117,null],[4,"VisibilityKind","","",null,null],[13,"Public","","",118,null],[13,"Crate","","",118,null],[13,"Restricted","","",118,null],[12,"path","syntax::ast::VisibilityKind","",118,null],[12,"id","","",118,null],[13,"Inherited","syntax::ast","",118,null],[4,"VariantData","","Fields and Ids of enum variants and structs",null,null],[13,"Struct","","Struct variant.",119,null],[13,"Tuple","","Tuple variant.",119,null],[13,"Unit","","Unit variant.",119,null],[4,"ItemKind","","",null,null],[13,"ExternCrate","","An `extern crate` item, with optional original crate name if the crate was renamed.",120,null],[13,"Use","","A use declaration (`use` or `pub use`) item.",120,null],[13,"Static","","A static item (`static` or `pub static`).",120,null],[13,"Const","","A constant item (`const` or `pub const`).",120,null],[13,"Fn","","A function declaration (`fn` or `pub fn`).",120,null],[13,"Mod","","A module declaration (`mod` or `pub mod`).",120,null],[13,"ForeignMod","","An external module (`extern` or `pub extern`).",120,null],[13,"GlobalAsm","","Module-level inline assembly (from `global_asm!()`)",120,null],[13,"Ty","","A type alias (`type` or `pub type`).",120,null],[13,"Enum","","An enum definition (`enum` or `pub enum`).",120,null],[13,"Struct","","A struct definition (`struct` or `pub struct`).",120,null],[13,"Union","","A union definition (`union` or `pub union`).",120,null],[13,"Trait","","A Trait declaration (`trait` or `pub trait`).",120,null],[13,"TraitAlias","","Trait alias",120,null],[13,"Impl","","An implementation.",120,null],[13,"Mac","","A macro invocation.",120,null],[13,"MacroDef","","A macro definition.",120,null],[4,"ForeignItemKind","","An item within an `extern` block",null,null],[13,"Fn","","A foreign function",121,null],[13,"Static","","A foreign static item (`static ext: u8`), with optional mutability (the boolean is true when mutable)",121,null],[13,"Ty","","A foreign type",121,null],[13,"Macro","","A macro invocation",121,null],[6,"TyParamBounds","","",null,null],[6,"CrateConfig","","The set of MetaItems that define the compilation environment of the crate, used to drive conditional compilation",null,null],[6,"NestedMetaItem","","A spanned compile-time attribute list item.",null,null],[6,"BinOp","","",null,null],[6,"Mac","","",null,null],[6,"Lit","","A literal",null,null],[6,"ExplicitSelf","","",null,null],[6,"Variant","","",null,null],[6,"Visibility","","",null,null],[17,"CRATE_NODE_ID","","Node id used to represent the root of the crate.",null,null],[17,"DUMMY_NODE_ID","","When parsing and doing expansions, we initially give all AST nodes this AST node value. Then later, in the renumber pass, we renumber them to have small, positive ids.",null,null],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"label"}}],[11,"eq","","",24,{"inputs":[{"name":"self"},{"name":"label"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"self"},{"name":"label"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",24,null],[11,"encode","","",24,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"__d"}],"output":{"generics":["label"],"name":"result"}}],[11,"hash","","",24,null],[11,"fmt","","",24,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"lifetime"}}],[11,"eq","","",25,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",25,null],[11,"encode","","",25,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",25,{"inputs":[{"name":"__d"}],"output":{"generics":["lifetime"],"name":"result"}}],[11,"hash","","",25,null],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",26,{"inputs":[{"name":"self"}],"output":{"name":"lifetimedef"}}],[11,"eq","","",26,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",26,null],[11,"encode","","",26,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",26,{"inputs":[{"name":"__d"}],"output":{"generics":["lifetimedef"],"name":"result"}}],[11,"hash","","",26,null],[11,"fmt","","",26,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",27,{"inputs":[{"name":"self"}],"output":{"name":"path"}}],[11,"eq","","",27,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",27,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",27,null],[11,"encode","","",27,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",27,{"inputs":[{"name":"__d"}],"output":{"generics":["path"],"name":"result"}}],[11,"hash","","",27,null],[11,"eq","","",27,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"bool"}}],[11,"fmt","","",27,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",27,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_ident","","",27,{"inputs":[{"name":"ident"}],"output":{"name":"path"}}],[11,"make_root","","",27,{"inputs":[{"name":"self"}],"output":{"generics":["pathsegment"],"name":"option"}}],[11,"is_global","","",27,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",28,{"inputs":[{"name":"self"}],"output":{"name":"pathsegment"}}],[11,"eq","","",28,{"inputs":[{"name":"self"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"ne","","",28,{"inputs":[{"name":"self"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",28,null],[11,"encode","","",28,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",28,{"inputs":[{"name":"__d"}],"output":{"generics":["pathsegment"],"name":"result"}}],[11,"hash","","",28,null],[11,"fmt","","",28,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_ident","","",28,{"inputs":[{"name":"ident"}],"output":{"name":"self"}}],[11,"crate_root","","",28,{"inputs":[{"name":"span"}],"output":{"name":"self"}}],[11,"clone","","",75,{"inputs":[{"name":"self"}],"output":{"name":"pathparameters"}}],[11,"eq","","",75,{"inputs":[{"name":"self"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"self"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",75,null],[11,"encode","","",75,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",75,{"inputs":[{"name":"__d"}],"output":{"generics":["pathparameters"],"name":"result"}}],[11,"hash","","",75,null],[11,"fmt","","",75,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",75,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"anglebracketedparameterdata"}}],[11,"eq","","",29,{"inputs":[{"name":"self"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"self"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",29,null],[11,"encode","","",29,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",29,{"inputs":[{"name":"__d"}],"output":{"generics":["anglebracketedparameterdata"],"name":"result"}}],[11,"hash","","",29,null],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",29,{"inputs":[],"output":{"name":"anglebracketedparameterdata"}}],[11,"into","","",29,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"into","","",30,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"parenthesizedparameterdata"}}],[11,"eq","","",30,{"inputs":[{"name":"self"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"self"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",30,null],[11,"encode","","",30,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",30,{"inputs":[{"name":"__d"}],"output":{"generics":["parenthesizedparameterdata"],"name":"result"}}],[11,"hash","","",30,null],[11,"fmt","","",30,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"eq","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"le","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"gt","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"ge","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",31,null],[11,"cmp","","",31,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"ordering"}}],[11,"hash","","",31,null],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",31,{"inputs":[{"name":"usize"}],"output":{"name":"nodeid"}}],[11,"from_u32","","",31,{"inputs":[{"name":"u32"}],"output":{"name":"nodeid"}}],[11,"as_usize","","",31,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"as_u32","","",31,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"placeholder_from_mark","","",31,{"inputs":[{"name":"mark"}],"output":{"name":"self"}}],[11,"placeholder_to_mark","","",31,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default_encode","","",31,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"default_decode","","",31,{"inputs":[{"name":"d"}],"output":{"generics":["nodeid"],"name":"result"}}],[11,"new","","",31,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[11,"index","","",31,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",76,{"inputs":[{"name":"self"}],"output":{"name":"typarambound"}}],[11,"eq","","",76,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",76,null],[11,"encode","","",76,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",76,{"inputs":[{"name":"__d"}],"output":{"generics":["typarambound"],"name":"result"}}],[11,"hash","","",76,null],[11,"fmt","","",76,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",76,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",77,{"inputs":[{"name":"self"}],"output":{"name":"traitboundmodifier"}}],[11,"eq","","",77,{"inputs":[{"name":"self"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",77,null],[11,"encode","","",77,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",77,{"inputs":[{"name":"__d"}],"output":{"generics":["traitboundmodifier"],"name":"result"}}],[11,"hash","","",77,null],[11,"fmt","","",77,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"typaram"}}],[11,"eq","","",32,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",32,null],[11,"encode","","",32,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",32,{"inputs":[{"name":"__d"}],"output":{"generics":["typaram"],"name":"result"}}],[11,"hash","","",32,null],[11,"fmt","","",32,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",78,{"inputs":[{"name":"self"}],"output":{"name":"genericparam"}}],[11,"eq","","",78,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":{"name":"bool"}}],[11,"ne","","",78,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",78,null],[11,"encode","","",78,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",78,{"inputs":[{"name":"__d"}],"output":{"generics":["genericparam"],"name":"result"}}],[11,"hash","","",78,null],[11,"fmt","","",78,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_lifetime_param","","",78,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_type_param","","",78,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",33,{"inputs":[{"name":"self"}],"output":{"name":"generics"}}],[11,"eq","","",33,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",33,null],[11,"encode","","",33,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",33,{"inputs":[{"name":"__d"}],"output":{"generics":["generics"],"name":"result"}}],[11,"hash","","",33,null],[11,"fmt","","",33,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_lt_parameterized","","",33,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_type_parameterized","","",33,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_parameterized","","",33,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"span_for_name","","",33,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"generics":["span"],"name":"option"}}],[11,"default","","Creates an instance of `Generics`.",33,{"inputs":[],"output":{"name":"generics"}}],[11,"clone","","",34,{"inputs":[{"name":"self"}],"output":{"name":"whereclause"}}],[11,"eq","","",34,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",34,null],[11,"encode","","",34,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",34,{"inputs":[{"name":"__d"}],"output":{"generics":["whereclause"],"name":"result"}}],[11,"hash","","",34,null],[11,"fmt","","",34,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",79,{"inputs":[{"name":"self"}],"output":{"name":"wherepredicate"}}],[11,"eq","","",79,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",79,null],[11,"encode","","",79,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",79,{"inputs":[{"name":"__d"}],"output":{"generics":["wherepredicate"],"name":"result"}}],[11,"hash","","",79,null],[11,"fmt","","",79,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",79,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",35,{"inputs":[{"name":"self"}],"output":{"name":"whereboundpredicate"}}],[11,"eq","","",35,{"inputs":[{"name":"self"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"self"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",35,null],[11,"encode","","",35,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",35,{"inputs":[{"name":"__d"}],"output":{"generics":["whereboundpredicate"],"name":"result"}}],[11,"hash","","",35,null],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",36,{"inputs":[{"name":"self"}],"output":{"name":"whereregionpredicate"}}],[11,"eq","","",36,{"inputs":[{"name":"self"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"self"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",36,null],[11,"encode","","",36,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",36,{"inputs":[{"name":"__d"}],"output":{"generics":["whereregionpredicate"],"name":"result"}}],[11,"hash","","",36,null],[11,"fmt","","",36,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",37,{"inputs":[{"name":"self"}],"output":{"name":"whereeqpredicate"}}],[11,"eq","","",37,{"inputs":[{"name":"self"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"self"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",37,null],[11,"encode","","",37,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",37,{"inputs":[{"name":"__d"}],"output":{"generics":["whereeqpredicate"],"name":"result"}}],[11,"hash","","",37,null],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"crate"}}],[11,"eq","","",38,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",38,null],[11,"encode","","",38,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",38,{"inputs":[{"name":"__d"}],"output":{"generics":["crate"],"name":"result"}}],[11,"hash","","",38,null],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",80,{"inputs":[{"name":"self"}],"output":{"name":"nestedmetaitemkind"}}],[11,"assert_receiver_is_total_eq","","",80,null],[11,"encode","","",80,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",80,{"inputs":[{"name":"__d"}],"output":{"generics":["nestedmetaitemkind"],"name":"result"}}],[11,"hash","","",80,null],[11,"fmt","","",80,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",80,{"inputs":[{"name":"self"},{"name":"nestedmetaitemkind"}],"output":{"name":"bool"}}],[11,"ne","","",80,{"inputs":[{"name":"self"},{"name":"nestedmetaitemkind"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"self"}],"output":{"name":"metaitem"}}],[11,"eq","","",39,{"inputs":[{"name":"self"},{"name":"metaitem"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"self"},{"name":"metaitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",39,null],[11,"encode","","",39,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",39,{"inputs":[{"name":"__d"}],"output":{"generics":["metaitem"],"name":"result"}}],[11,"hash","","",39,null],[11,"fmt","","",39,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",81,{"inputs":[{"name":"self"}],"output":{"name":"metaitemkind"}}],[11,"eq","","",81,{"inputs":[{"name":"self"},{"name":"metaitemkind"}],"output":{"name":"bool"}}],[11,"ne","","",81,{"inputs":[{"name":"self"},{"name":"metaitemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",81,null],[11,"encode","","",81,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",81,{"inputs":[{"name":"__d"}],"output":{"generics":["metaitemkind"],"name":"result"}}],[11,"hash","","",81,null],[11,"fmt","","",81,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",40,{"inputs":[{"name":"self"}],"output":{"name":"block"}}],[11,"eq","","",40,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",40,null],[11,"encode","","",40,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",40,{"inputs":[{"name":"__d"}],"output":{"generics":["block"],"name":"result"}}],[11,"hash","","",40,null],[11,"fmt","","",40,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",41,{"inputs":[{"name":"self"}],"output":{"name":"pat"}}],[11,"eq","","",41,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",41,null],[11,"encode","","",41,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",41,{"inputs":[{"name":"__d"}],"output":{"generics":["pat"],"name":"result"}}],[11,"hash","","",41,null],[11,"fmt","","",41,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"to_ty","","",41,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"walk","","",41,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"self"}],"output":{"name":"fieldpat"}}],[11,"eq","","",42,{"inputs":[{"name":"self"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"self"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",42,null],[11,"encode","","",42,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",42,{"inputs":[{"name":"__d"}],"output":{"generics":["fieldpat"],"name":"result"}}],[11,"hash","","",42,null],[11,"fmt","","",42,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",82,{"inputs":[{"name":"self"}],"output":{"name":"bindingmode"}}],[11,"eq","","",82,{"inputs":[{"name":"self"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"self"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",82,null],[11,"encode","","",82,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",82,{"inputs":[{"name":"__d"}],"output":{"generics":["bindingmode"],"name":"result"}}],[11,"hash","","",82,null],[11,"fmt","","",82,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",83,{"inputs":[{"name":"self"}],"output":{"name":"rangeend"}}],[11,"eq","","",83,{"inputs":[{"name":"self"},{"name":"rangeend"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"self"},{"name":"rangeend"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",83,null],[11,"encode","","",83,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",83,{"inputs":[{"name":"__d"}],"output":{"generics":["rangeend"],"name":"result"}}],[11,"hash","","",83,null],[11,"fmt","","",83,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",84,{"inputs":[{"name":"self"}],"output":{"name":"rangesyntax"}}],[11,"eq","","",84,{"inputs":[{"name":"self"},{"name":"rangesyntax"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",84,null],[11,"encode","","",84,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",84,{"inputs":[{"name":"__d"}],"output":{"generics":["rangesyntax"],"name":"result"}}],[11,"hash","","",84,null],[11,"fmt","","",84,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",85,{"inputs":[{"name":"self"}],"output":{"name":"patkind"}}],[11,"eq","","",85,{"inputs":[{"name":"self"},{"name":"patkind"}],"output":{"name":"bool"}}],[11,"ne","","",85,{"inputs":[{"name":"self"},{"name":"patkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",85,null],[11,"encode","","",85,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",85,{"inputs":[{"name":"__d"}],"output":{"generics":["patkind"],"name":"result"}}],[11,"hash","","",85,null],[11,"fmt","","",85,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",86,{"inputs":[{"name":"self"}],"output":{"name":"mutability"}}],[11,"eq","","",86,{"inputs":[{"name":"self"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",86,null],[11,"encode","","",86,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",86,{"inputs":[{"name":"__d"}],"output":{"generics":["mutability"],"name":"result"}}],[11,"hash","","",86,null],[11,"fmt","","",86,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",87,{"inputs":[{"name":"self"}],"output":{"name":"binopkind"}}],[11,"eq","","",87,{"inputs":[{"name":"self"},{"name":"binopkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",87,null],[11,"encode","","",87,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",87,{"inputs":[{"name":"__d"}],"output":{"generics":["binopkind"],"name":"result"}}],[11,"hash","","",87,null],[11,"fmt","","",87,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"to_string","","",87,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"lazy","","",87,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_shift","","",87,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_comparison","","",87,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_by_value","","Returns `true` if the binary operator takes its arguments by value",87,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",88,{"inputs":[{"name":"self"}],"output":{"name":"unop"}}],[11,"eq","","",88,{"inputs":[{"name":"self"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",88,null],[11,"encode","","",88,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",88,{"inputs":[{"name":"__d"}],"output":{"generics":["unop"],"name":"result"}}],[11,"hash","","",88,null],[11,"fmt","","",88,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_by_value","","Returns `true` if the unary operator takes its argument by value",88,{"inputs":[{"name":"unop"}],"output":{"name":"bool"}}],[11,"to_string","","",88,{"inputs":[{"name":"unop"}],"output":{"name":"str"}}],[11,"clone","","",43,{"inputs":[{"name":"self"}],"output":{"name":"stmt"}}],[11,"eq","","",43,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",43,null],[11,"encode","","",43,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",43,{"inputs":[{"name":"__d"}],"output":{"generics":["stmt"],"name":"result"}}],[11,"hash","","",43,null],[11,"add_trailing_semicolon","","",43,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"is_item","","",43,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_expr","","",43,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",43,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",89,{"inputs":[{"name":"self"}],"output":{"name":"stmtkind"}}],[11,"eq","","",89,{"inputs":[{"name":"self"},{"name":"stmtkind"}],"output":{"name":"bool"}}],[11,"ne","","",89,{"inputs":[{"name":"self"},{"name":"stmtkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",89,null],[11,"encode","","",89,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",89,{"inputs":[{"name":"__d"}],"output":{"generics":["stmtkind"],"name":"result"}}],[11,"hash","","",89,null],[11,"clone","","",90,{"inputs":[{"name":"self"}],"output":{"name":"macstmtstyle"}}],[11,"eq","","",90,{"inputs":[{"name":"self"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",90,null],[11,"encode","","",90,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",90,{"inputs":[{"name":"__d"}],"output":{"generics":["macstmtstyle"],"name":"result"}}],[11,"hash","","",90,null],[11,"fmt","","",90,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",44,{"inputs":[{"name":"self"}],"output":{"name":"local"}}],[11,"eq","","",44,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ne","","",44,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",44,null],[11,"encode","","",44,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",44,{"inputs":[{"name":"__d"}],"output":{"generics":["local"],"name":"result"}}],[11,"hash","","",44,null],[11,"fmt","","",44,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",45,{"inputs":[{"name":"self"}],"output":{"name":"arm"}}],[11,"eq","","",45,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"ne","","",45,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",45,null],[11,"encode","","",45,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",45,{"inputs":[{"name":"__d"}],"output":{"generics":["arm"],"name":"result"}}],[11,"hash","","",45,null],[11,"fmt","","",45,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",46,{"inputs":[{"name":"self"}],"output":{"name":"field"}}],[11,"eq","","",46,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",46,null],[11,"encode","","",46,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",46,{"inputs":[{"name":"__d"}],"output":{"generics":["field"],"name":"result"}}],[11,"hash","","",46,null],[11,"fmt","","",46,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",91,{"inputs":[{"name":"self"}],"output":{"name":"blockcheckmode"}}],[11,"eq","","",91,{"inputs":[{"name":"self"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"ne","","",91,{"inputs":[{"name":"self"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",91,null],[11,"encode","","",91,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",91,{"inputs":[{"name":"__d"}],"output":{"generics":["blockcheckmode"],"name":"result"}}],[11,"hash","","",91,null],[11,"fmt","","",91,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",92,{"inputs":[{"name":"self"}],"output":{"name":"unsafesource"}}],[11,"eq","","",92,{"inputs":[{"name":"self"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",92,null],[11,"encode","","",92,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",92,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafesource"],"name":"result"}}],[11,"hash","","",92,null],[11,"fmt","","",92,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",47,{"inputs":[{"name":"self"}],"output":{"name":"expr"}}],[11,"eq","","",47,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"ne","","",47,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",47,null],[11,"encode","","",47,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",47,{"inputs":[{"name":"__d"}],"output":{"generics":["expr"],"name":"result"}}],[11,"hash","","",47,null],[11,"returns","","Whether this expression would be valid somewhere that expects a value, for example, an `if` condition.",47,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"to_bound","","",47,{"inputs":[{"name":"self"}],"output":{"generics":["typarambound"],"name":"option"}}],[11,"to_ty","","",47,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"precedence","","",47,{"inputs":[{"name":"self"}],"output":{"name":"exprprecedence"}}],[11,"fmt","","",47,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",93,{"inputs":[{"name":"self"}],"output":{"name":"rangelimits"}}],[11,"eq","","",93,{"inputs":[{"name":"self"},{"name":"rangelimits"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",93,null],[11,"encode","","",93,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",93,{"inputs":[{"name":"__d"}],"output":{"generics":["rangelimits"],"name":"result"}}],[11,"hash","","",93,null],[11,"fmt","","",93,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",94,{"inputs":[{"name":"self"}],"output":{"name":"exprkind"}}],[11,"eq","","",94,{"inputs":[{"name":"self"},{"name":"exprkind"}],"output":{"name":"bool"}}],[11,"ne","","",94,{"inputs":[{"name":"self"},{"name":"exprkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",94,null],[11,"encode","","",94,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",94,{"inputs":[{"name":"__d"}],"output":{"generics":["exprkind"],"name":"result"}}],[11,"hash","","",94,null],[11,"fmt","","",94,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",48,{"inputs":[{"name":"self"}],"output":{"name":"qself"}}],[11,"eq","","",48,{"inputs":[{"name":"self"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"self"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",48,null],[11,"encode","","",48,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",48,{"inputs":[{"name":"__d"}],"output":{"generics":["qself"],"name":"result"}}],[11,"hash","","",48,null],[11,"fmt","","",48,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",95,{"inputs":[{"name":"self"}],"output":{"name":"captureby"}}],[11,"eq","","",95,{"inputs":[{"name":"self"},{"name":"captureby"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",95,null],[11,"encode","","",95,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",95,{"inputs":[{"name":"__d"}],"output":{"generics":["captureby"],"name":"result"}}],[11,"hash","","",95,null],[11,"fmt","","",95,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",96,{"inputs":[{"name":"self"}],"output":{"name":"movability"}}],[11,"eq","","",96,{"inputs":[{"name":"self"},{"name":"movability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",96,null],[11,"encode","","",96,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",96,{"inputs":[{"name":"__d"}],"output":{"generics":["movability"],"name":"result"}}],[11,"hash","","",96,null],[11,"fmt","","",96,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",49,{"inputs":[{"name":"self"}],"output":{"name":"mac_"}}],[11,"eq","","",49,{"inputs":[{"name":"self"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"ne","","",49,{"inputs":[{"name":"self"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",49,null],[11,"encode","","",49,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",49,{"inputs":[{"name":"__d"}],"output":{"generics":["mac_"],"name":"result"}}],[11,"hash","","",49,null],[11,"fmt","","",49,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"stream","","",49,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"clone","","",50,{"inputs":[{"name":"self"}],"output":{"name":"macrodef"}}],[11,"eq","","",50,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"ne","","",50,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",50,null],[11,"encode","","",50,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",50,{"inputs":[{"name":"__d"}],"output":{"generics":["macrodef"],"name":"result"}}],[11,"hash","","",50,null],[11,"fmt","","",50,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"stream","","",50,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"clone","","",97,{"inputs":[{"name":"self"}],"output":{"name":"strstyle"}}],[11,"eq","","",97,{"inputs":[{"name":"self"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"ne","","",97,{"inputs":[{"name":"self"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",97,null],[11,"encode","","",97,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",97,{"inputs":[{"name":"__d"}],"output":{"generics":["strstyle"],"name":"result"}}],[11,"hash","","",97,null],[11,"fmt","","",97,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",98,{"inputs":[{"name":"self"}],"output":{"name":"litinttype"}}],[11,"eq","","",98,{"inputs":[{"name":"self"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"ne","","",98,{"inputs":[{"name":"self"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",98,null],[11,"encode","","",98,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",98,{"inputs":[{"name":"__d"}],"output":{"generics":["litinttype"],"name":"result"}}],[11,"hash","","",98,null],[11,"fmt","","",98,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",99,{"inputs":[{"name":"self"}],"output":{"name":"litkind"}}],[11,"eq","","",99,{"inputs":[{"name":"self"},{"name":"litkind"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"self"},{"name":"litkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",99,null],[11,"encode","","",99,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",99,{"inputs":[{"name":"__d"}],"output":{"generics":["litkind"],"name":"result"}}],[11,"hash","","",99,null],[11,"fmt","","",99,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_str","","Returns true if this literal is a string and false otherwise.",99,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_unsuffixed","","Returns true if this literal has no suffix. Note: this will return true for literals with prefixes such as raw strings and byte strings.",99,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_suffixed","","Returns true if this literal has a suffix.",99,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"self"}],"output":{"name":"mutty"}}],[11,"eq","","",51,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",51,null],[11,"encode","","",51,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",51,{"inputs":[{"name":"__d"}],"output":{"generics":["mutty"],"name":"result"}}],[11,"hash","","",51,null],[11,"fmt","","",51,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",52,{"inputs":[{"name":"self"}],"output":{"name":"methodsig"}}],[11,"eq","","",52,{"inputs":[{"name":"self"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"self"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",52,null],[11,"encode","","",52,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",52,{"inputs":[{"name":"__d"}],"output":{"generics":["methodsig"],"name":"result"}}],[11,"hash","","",52,null],[11,"fmt","","",52,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",53,{"inputs":[{"name":"self"}],"output":{"name":"traititem"}}],[11,"eq","","",53,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"ne","","",53,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",53,null],[11,"encode","","",53,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",53,{"inputs":[{"name":"__d"}],"output":{"generics":["traititem"],"name":"result"}}],[11,"hash","","",53,null],[11,"fmt","","",53,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",100,{"inputs":[{"name":"self"}],"output":{"name":"traititemkind"}}],[11,"eq","","",100,{"inputs":[{"name":"self"},{"name":"traititemkind"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"self"},{"name":"traititemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",100,null],[11,"encode","","",100,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",100,{"inputs":[{"name":"__d"}],"output":{"generics":["traititemkind"],"name":"result"}}],[11,"hash","","",100,null],[11,"fmt","","",100,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",54,{"inputs":[{"name":"self"}],"output":{"name":"implitem"}}],[11,"eq","","",54,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"ne","","",54,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",54,null],[11,"encode","","",54,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",54,{"inputs":[{"name":"__d"}],"output":{"generics":["implitem"],"name":"result"}}],[11,"hash","","",54,null],[11,"fmt","","",54,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",101,{"inputs":[{"name":"self"}],"output":{"name":"implitemkind"}}],[11,"eq","","",101,{"inputs":[{"name":"self"},{"name":"implitemkind"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"self"},{"name":"implitemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",101,null],[11,"encode","","",101,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",101,{"inputs":[{"name":"__d"}],"output":{"generics":["implitemkind"],"name":"result"}}],[11,"hash","","",101,null],[11,"fmt","","",101,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",102,{"inputs":[{"name":"self"}],"output":{"name":"intty"}}],[11,"eq","","",102,{"inputs":[{"name":"self"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",102,null],[11,"encode","","",102,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",102,{"inputs":[{"name":"__d"}],"output":{"generics":["intty"],"name":"result"}}],[11,"hash","","",102,null],[11,"partial_cmp","","",102,{"inputs":[{"name":"self"},{"name":"intty"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",102,{"inputs":[{"name":"self"},{"name":"intty"}],"output":{"name":"ordering"}}],[11,"fmt","","",102,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",102,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"ty_to_string","","",102,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"val_to_string","","",102,{"inputs":[{"name":"self"},{"name":"i128"}],"output":{"name":"string"}}],[11,"bit_width","","",102,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"option"}}],[11,"clone","","",103,{"inputs":[{"name":"self"}],"output":{"name":"uintty"}}],[11,"eq","","",103,{"inputs":[{"name":"self"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",103,null],[11,"encode","","",103,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",103,{"inputs":[{"name":"__d"}],"output":{"generics":["uintty"],"name":"result"}}],[11,"hash","","",103,null],[11,"partial_cmp","","",103,{"inputs":[{"name":"self"},{"name":"uintty"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",103,{"inputs":[{"name":"self"},{"name":"uintty"}],"output":{"name":"ordering"}}],[11,"ty_to_string","","",103,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"val_to_string","","",103,{"inputs":[{"name":"self"},{"name":"u128"}],"output":{"name":"string"}}],[11,"bit_width","","",103,{"inputs":[{"name":"self"}],"output":{"generics":["usize"],"name":"option"}}],[11,"fmt","","",103,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",103,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",104,{"inputs":[{"name":"self"}],"output":{"name":"floatty"}}],[11,"eq","","",104,{"inputs":[{"name":"self"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",104,null],[11,"encode","","",104,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",104,{"inputs":[{"name":"__d"}],"output":{"generics":["floatty"],"name":"result"}}],[11,"hash","","",104,null],[11,"partial_cmp","","",104,{"inputs":[{"name":"self"},{"name":"floatty"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",104,{"inputs":[{"name":"self"},{"name":"floatty"}],"output":{"name":"ordering"}}],[11,"fmt","","",104,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",104,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"ty_to_string","","",104,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"bit_width","","",104,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"clone","","",55,{"inputs":[{"name":"self"}],"output":{"name":"typebinding"}}],[11,"eq","","",55,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",55,null],[11,"encode","","",55,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",55,{"inputs":[{"name":"__d"}],"output":{"generics":["typebinding"],"name":"result"}}],[11,"hash","","",55,null],[11,"fmt","","",55,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",56,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"eq","","",56,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",56,null],[11,"encode","","",56,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",56,{"inputs":[{"name":"__d"}],"output":{"generics":["ty"],"name":"result"}}],[11,"hash","","",56,null],[11,"fmt","","",56,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",57,{"inputs":[{"name":"self"}],"output":{"name":"barefnty"}}],[11,"eq","","",57,{"inputs":[{"name":"self"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",57,{"inputs":[{"name":"self"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",57,null],[11,"encode","","",57,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",57,{"inputs":[{"name":"__d"}],"output":{"generics":["barefnty"],"name":"result"}}],[11,"hash","","",57,null],[11,"fmt","","",57,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",105,{"inputs":[{"name":"self"}],"output":{"name":"tykind"}}],[11,"eq","","",105,{"inputs":[{"name":"self"},{"name":"tykind"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"self"},{"name":"tykind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",105,null],[11,"encode","","",105,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",105,{"inputs":[{"name":"__d"}],"output":{"generics":["tykind"],"name":"result"}}],[11,"hash","","",105,null],[11,"fmt","","",105,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"self"}],"output":{"name":"traitobjectsyntax"}}],[11,"eq","","",106,{"inputs":[{"name":"self"},{"name":"traitobjectsyntax"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",106,null],[11,"encode","","",106,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",106,{"inputs":[{"name":"__d"}],"output":{"generics":["traitobjectsyntax"],"name":"result"}}],[11,"hash","","",106,null],[11,"fmt","","",106,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"self"}],"output":{"name":"asmdialect"}}],[11,"eq","","",107,{"inputs":[{"name":"self"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",107,null],[11,"encode","","",107,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",107,{"inputs":[{"name":"__d"}],"output":{"generics":["asmdialect"],"name":"result"}}],[11,"hash","","",107,null],[11,"fmt","","",107,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",58,{"inputs":[{"name":"self"}],"output":{"name":"inlineasmoutput"}}],[11,"eq","","",58,{"inputs":[{"name":"self"},{"name":"inlineasmoutput"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"self"},{"name":"inlineasmoutput"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",58,null],[11,"encode","","",58,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",58,{"inputs":[{"name":"__d"}],"output":{"generics":["inlineasmoutput"],"name":"result"}}],[11,"hash","","",58,null],[11,"fmt","","",58,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",59,{"inputs":[{"name":"self"}],"output":{"name":"inlineasm"}}],[11,"eq","","",59,{"inputs":[{"name":"self"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"self"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",59,null],[11,"encode","","",59,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",59,{"inputs":[{"name":"__d"}],"output":{"generics":["inlineasm"],"name":"result"}}],[11,"hash","","",59,null],[11,"fmt","","",59,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",60,{"inputs":[{"name":"self"}],"output":{"name":"arg"}}],[11,"eq","","",60,{"inputs":[{"name":"self"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"ne","","",60,{"inputs":[{"name":"self"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",60,null],[11,"encode","","",60,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",60,{"inputs":[{"name":"__d"}],"output":{"generics":["arg"],"name":"result"}}],[11,"hash","","",60,null],[11,"fmt","","",60,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"self"}],"output":{"name":"selfkind"}}],[11,"eq","","",108,{"inputs":[{"name":"self"},{"name":"selfkind"}],"output":{"name":"bool"}}],[11,"ne","","",108,{"inputs":[{"name":"self"},{"name":"selfkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",108,null],[11,"encode","","",108,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",108,{"inputs":[{"name":"__d"}],"output":{"generics":["selfkind"],"name":"result"}}],[11,"hash","","",108,null],[11,"fmt","","",108,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"to_self","","",60,{"inputs":[{"name":"self"}],"output":{"generics":["explicitself"],"name":"option"}}],[11,"is_self","","",60,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"from_self","","",60,{"inputs":[{"name":"explicitself"},{"name":"ident"}],"output":{"name":"arg"}}],[11,"clone","","",61,{"inputs":[{"name":"self"}],"output":{"name":"fndecl"}}],[11,"eq","","",61,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"ne","","",61,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",61,null],[11,"encode","","",61,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",61,{"inputs":[{"name":"__d"}],"output":{"generics":["fndecl"],"name":"result"}}],[11,"hash","","",61,null],[11,"fmt","","",61,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"get_self","","",61,{"inputs":[{"name":"self"}],"output":{"generics":["explicitself"],"name":"option"}}],[11,"has_self","","",61,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",109,{"inputs":[{"name":"self"}],"output":{"name":"isauto"}}],[11,"eq","","",109,{"inputs":[{"name":"self"},{"name":"isauto"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",109,null],[11,"encode","","",109,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",109,{"inputs":[{"name":"__d"}],"output":{"generics":["isauto"],"name":"result"}}],[11,"hash","","",109,null],[11,"fmt","","",109,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",110,{"inputs":[{"name":"self"}],"output":{"name":"unsafety"}}],[11,"eq","","",110,{"inputs":[{"name":"self"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",110,null],[11,"encode","","",110,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",110,{"inputs":[{"name":"__d"}],"output":{"generics":["unsafety"],"name":"result"}}],[11,"hash","","",110,null],[11,"fmt","","",110,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",111,{"inputs":[{"name":"self"}],"output":{"name":"constness"}}],[11,"eq","","",111,{"inputs":[{"name":"self"},{"name":"constness"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",111,null],[11,"encode","","",111,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",111,{"inputs":[{"name":"__d"}],"output":{"generics":["constness"],"name":"result"}}],[11,"hash","","",111,null],[11,"fmt","","",111,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"self"}],"output":{"name":"defaultness"}}],[11,"eq","","",112,{"inputs":[{"name":"self"},{"name":"defaultness"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",112,null],[11,"encode","","",112,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",112,{"inputs":[{"name":"__d"}],"output":{"generics":["defaultness"],"name":"result"}}],[11,"hash","","",112,null],[11,"fmt","","",112,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",110,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"self"}],"output":{"name":"implpolarity"}}],[11,"eq","","",113,{"inputs":[{"name":"self"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",113,null],[11,"encode","","",113,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",113,{"inputs":[{"name":"__d"}],"output":{"generics":["implpolarity"],"name":"result"}}],[11,"hash","","",113,null],[11,"fmt","","",113,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"self"}],"output":{"name":"functionretty"}}],[11,"eq","","",114,{"inputs":[{"name":"self"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"ne","","",114,{"inputs":[{"name":"self"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",114,null],[11,"encode","","",114,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",114,{"inputs":[{"name":"__d"}],"output":{"generics":["functionretty"],"name":"result"}}],[11,"hash","","",114,null],[11,"fmt","","",114,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"span","","",114,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",62,{"inputs":[{"name":"self"}],"output":{"name":"mod"}}],[11,"eq","","",62,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"ne","","",62,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",62,null],[11,"encode","","",62,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",62,{"inputs":[{"name":"__d"}],"output":{"generics":["mod"],"name":"result"}}],[11,"hash","","",62,null],[11,"fmt","","",62,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",63,{"inputs":[{"name":"self"}],"output":{"name":"foreignmod"}}],[11,"eq","","",63,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"ne","","",63,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",63,null],[11,"encode","","",63,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",63,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignmod"],"name":"result"}}],[11,"hash","","",63,null],[11,"fmt","","",63,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",64,{"inputs":[{"name":"self"}],"output":{"name":"globalasm"}}],[11,"eq","","",64,{"inputs":[{"name":"self"},{"name":"globalasm"}],"output":{"name":"bool"}}],[11,"ne","","",64,{"inputs":[{"name":"self"},{"name":"globalasm"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",64,null],[11,"encode","","",64,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",64,{"inputs":[{"name":"__d"}],"output":{"generics":["globalasm"],"name":"result"}}],[11,"hash","","",64,null],[11,"fmt","","",64,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",65,{"inputs":[{"name":"self"}],"output":{"name":"enumdef"}}],[11,"eq","","",65,{"inputs":[{"name":"self"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"self"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",65,null],[11,"encode","","",65,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",65,{"inputs":[{"name":"__d"}],"output":{"generics":["enumdef"],"name":"result"}}],[11,"hash","","",65,null],[11,"fmt","","",65,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",66,{"inputs":[{"name":"self"}],"output":{"name":"variant_"}}],[11,"eq","","",66,{"inputs":[{"name":"self"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"ne","","",66,{"inputs":[{"name":"self"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",66,null],[11,"encode","","",66,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",66,{"inputs":[{"name":"__d"}],"output":{"generics":["variant_"],"name":"result"}}],[11,"hash","","",66,null],[11,"fmt","","",66,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",115,{"inputs":[{"name":"self"}],"output":{"name":"usetreekind"}}],[11,"eq","","",115,{"inputs":[{"name":"self"},{"name":"usetreekind"}],"output":{"name":"bool"}}],[11,"ne","","",115,{"inputs":[{"name":"self"},{"name":"usetreekind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",115,null],[11,"encode","","",115,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",115,{"inputs":[{"name":"__d"}],"output":{"generics":["usetreekind"],"name":"result"}}],[11,"hash","","",115,null],[11,"fmt","","",115,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",67,{"inputs":[{"name":"self"}],"output":{"name":"usetree"}}],[11,"eq","","",67,{"inputs":[{"name":"self"},{"name":"usetree"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"self"},{"name":"usetree"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",67,null],[11,"encode","","",67,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",67,{"inputs":[{"name":"__d"}],"output":{"generics":["usetree"],"name":"result"}}],[11,"hash","","",67,null],[11,"fmt","","",67,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"ident","","",67,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"clone","","",116,{"inputs":[{"name":"self"}],"output":{"name":"attrstyle"}}],[11,"eq","","",116,{"inputs":[{"name":"self"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",116,null],[11,"encode","","",116,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",116,{"inputs":[{"name":"__d"}],"output":{"generics":["attrstyle"],"name":"result"}}],[11,"hash","","",116,null],[11,"fmt","","",116,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",68,{"inputs":[{"name":"self"}],"output":{"name":"attrid"}}],[11,"eq","","",68,{"inputs":[{"name":"self"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"self"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",68,null],[11,"encode","","",68,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",68,{"inputs":[{"name":"__d"}],"output":{"generics":["attrid"],"name":"result"}}],[11,"hash","","",68,null],[11,"fmt","","",68,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",69,{"inputs":[{"name":"self"}],"output":{"name":"attribute"}}],[11,"eq","","",69,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",69,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",69,null],[11,"encode","","",69,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",69,{"inputs":[{"name":"__d"}],"output":{"generics":["attribute"],"name":"result"}}],[11,"hash","","",69,null],[11,"fmt","","",69,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",70,{"inputs":[{"name":"self"}],"output":{"name":"traitref"}}],[11,"eq","","",70,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",70,null],[11,"encode","","",70,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",70,{"inputs":[{"name":"__d"}],"output":{"generics":["traitref"],"name":"result"}}],[11,"hash","","",70,null],[11,"fmt","","",70,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",71,{"inputs":[{"name":"self"}],"output":{"name":"polytraitref"}}],[11,"eq","","",71,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",71,null],[11,"encode","","",71,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",71,{"inputs":[{"name":"__d"}],"output":{"generics":["polytraitref"],"name":"result"}}],[11,"hash","","",71,null],[11,"fmt","","",71,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",71,{"inputs":[{"generics":["genericparam"],"name":"vec"},{"name":"path"},{"name":"span"}],"output":{"name":"self"}}],[11,"clone","","",117,{"inputs":[{"name":"self"}],"output":{"name":"cratesugar"}}],[11,"eq","","",117,{"inputs":[{"name":"self"},{"name":"cratesugar"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",117,null],[11,"encode","","",117,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",117,{"inputs":[{"name":"__d"}],"output":{"generics":["cratesugar"],"name":"result"}}],[11,"hash","","",117,null],[11,"fmt","","",117,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",118,{"inputs":[{"name":"self"}],"output":{"name":"visibilitykind"}}],[11,"eq","","",118,{"inputs":[{"name":"self"},{"name":"visibilitykind"}],"output":{"name":"bool"}}],[11,"ne","","",118,{"inputs":[{"name":"self"},{"name":"visibilitykind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",118,null],[11,"encode","","",118,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",118,{"inputs":[{"name":"__d"}],"output":{"generics":["visibilitykind"],"name":"result"}}],[11,"hash","","",118,null],[11,"fmt","","",118,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",72,{"inputs":[{"name":"self"}],"output":{"name":"structfield"}}],[11,"eq","","",72,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",72,null],[11,"encode","","",72,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",72,{"inputs":[{"name":"__d"}],"output":{"generics":["structfield"],"name":"result"}}],[11,"hash","","",72,null],[11,"fmt","","",72,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",119,{"inputs":[{"name":"self"}],"output":{"name":"variantdata"}}],[11,"eq","","",119,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"bool"}}],[11,"ne","","",119,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",119,null],[11,"encode","","",119,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",119,{"inputs":[{"name":"__d"}],"output":{"generics":["variantdata"],"name":"result"}}],[11,"hash","","",119,null],[11,"fmt","","",119,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fields","","",119,null],[11,"id","","",119,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"is_struct","","",119,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_tuple","","",119,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_unit","","",119,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"self"}],"output":{"name":"item"}}],[11,"eq","","",73,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",73,null],[11,"encode","","",73,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",73,{"inputs":[{"name":"__d"}],"output":{"generics":["item"],"name":"result"}}],[11,"hash","","",73,null],[11,"fmt","","",73,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",120,{"inputs":[{"name":"self"}],"output":{"name":"itemkind"}}],[11,"eq","","",120,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"bool"}}],[11,"ne","","",120,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",120,null],[11,"encode","","",120,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",120,{"inputs":[{"name":"__d"}],"output":{"generics":["itemkind"],"name":"result"}}],[11,"hash","","",120,null],[11,"fmt","","",120,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"descriptive_variant","","",120,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"clone","","",74,{"inputs":[{"name":"self"}],"output":{"name":"foreignitem"}}],[11,"eq","","",74,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",74,null],[11,"encode","","",74,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",74,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignitem"],"name":"result"}}],[11,"hash","","",74,null],[11,"fmt","","",74,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",121,{"inputs":[{"name":"self"}],"output":{"name":"foreignitemkind"}}],[11,"eq","","",121,{"inputs":[{"name":"self"},{"name":"foreignitemkind"}],"output":{"name":"bool"}}],[11,"ne","","",121,{"inputs":[{"name":"self"},{"name":"foreignitemkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",121,null],[11,"encode","","",121,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",121,{"inputs":[{"name":"__d"}],"output":{"generics":["foreignitemkind"],"name":"result"}}],[11,"hash","","",121,null],[11,"fmt","","",121,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"descriptive_variant","","",121,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[0,"attr","syntax","",null,null],[3,"Stability","syntax::attr","Represents the #[stable], #[unstable], #[rustc_{deprecated,const_unstable}] attributes.",null,null],[12,"level","","",122,null],[12,"feature","","",122,null],[12,"rustc_depr","","",122,null],[12,"rustc_const_unstable","","",122,null],[3,"RustcDeprecation","","",null,null],[12,"since","","",123,null],[12,"reason","","",123,null],[3,"RustcConstUnstable","","",null,null],[12,"feature","","",124,null],[3,"Deprecation","","",null,null],[12,"since","","",125,null],[12,"note","","",125,null],[4,"AttrError","","",null,null],[13,"MultipleItem","","",126,null],[13,"UnknownMetaItem","","",126,null],[13,"MissingSince","","",126,null],[13,"MissingFeature","","",126,null],[13,"MultipleStabilityLevels","","",126,null],[13,"UnsupportedLiteral","","",126,null],[4,"InlineAttr","","",null,null],[13,"None","","",127,null],[13,"Hint","","",127,null],[13,"Always","","",127,null],[13,"Never","","",127,null],[4,"UnwindAttr","","",null,null],[13,"Allowed","","",128,null],[13,"Aborts","","",128,null],[4,"StabilityLevel","","The available stability levels.",null,null],[13,"Unstable","","",129,null],[12,"reason","syntax::attr::StabilityLevel","",129,null],[12,"issue","","",129,null],[13,"Stable","syntax::attr","",129,null],[12,"since","syntax::attr::StabilityLevel","",129,null],[4,"ReprAttr","syntax::attr","",null,null],[13,"ReprInt","","",130,null],[13,"ReprC","","",130,null],[13,"ReprPacked","","",130,null],[13,"ReprSimd","","",130,null],[13,"ReprTransparent","","",130,null],[13,"ReprAlign","","",130,null],[4,"IntType","","",null,null],[13,"SignedInt","","",131,null],[13,"UnsignedInt","","",131,null],[5,"handle_errors","","",null,{"inputs":[{"name":"handler"},{"name":"span"},{"name":"attrerror"}],"output":null}],[5,"mark_used","","",null,{"inputs":[{"name":"attribute"}],"output":null}],[5,"is_used","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"mark_known","","",null,{"inputs":[{"name":"attribute"}],"output":null}],[5,"is_known","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"is_known_tool","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"name_from_path","","",null,{"inputs":[{"name":"path"}],"output":{"name":"name"}}],[5,"mk_name_value_item_str","","",null,{"inputs":[{"name":"ident"},{"generics":["symbol"],"name":"spanned"}],"output":{"name":"metaitem"}}],[5,"mk_name_value_item","","",null,{"inputs":[{"name":"span"},{"name":"ident"},{"name":"lit"}],"output":{"name":"metaitem"}}],[5,"mk_list_item","","",null,{"inputs":[{"name":"span"},{"name":"ident"},{"generics":["nestedmetaitem"],"name":"vec"}],"output":{"name":"metaitem"}}],[5,"mk_word_item","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"metaitem"}}],[5,"mk_nested_word_item","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"nestedmetaitem"}}],[5,"mk_attr_id","","",null,{"inputs":[],"output":{"name":"attrid"}}],[5,"mk_attr_inner","","Returns an inner attribute with the given value.",null,{"inputs":[{"name":"span"},{"name":"attrid"},{"name":"metaitem"}],"output":{"name":"attribute"}}],[5,"mk_spanned_attr_inner","","Returns an inner attribute with the given value and span.",null,{"inputs":[{"name":"span"},{"name":"attrid"},{"name":"metaitem"}],"output":{"name":"attribute"}}],[5,"mk_attr_outer","","Returns an outer attribute with the given value.",null,{"inputs":[{"name":"span"},{"name":"attrid"},{"name":"metaitem"}],"output":{"name":"attribute"}}],[5,"mk_spanned_attr_outer","","Returns an outer attribute with the given value and span.",null,{"inputs":[{"name":"span"},{"name":"attrid"},{"name":"metaitem"}],"output":{"name":"attribute"}}],[5,"mk_sugared_doc_attr","","",null,{"inputs":[{"name":"attrid"},{"name":"symbol"},{"name":"span"}],"output":{"name":"attribute"}}],[5,"list_contains_name","","",null,null],[5,"contains_name","","",null,null],[5,"find_by_name","","",null,null],[5,"first_attr_value_str_by_name","","",null,null],[5,"contains_feature_attr","","Check if `attrs` contains an attribute like `#![feature(feature_name)]`. This will not perform any \"sanity checks\" on the form of the attributes.",null,null],[5,"find_crate_name","","",null,null],[5,"find_unwind_attr","","Determine what `#[unwind]` attribute is present in `attrs`, if any.",null,null],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",null,{"inputs":[{"name":"metaitem"},{"name":"parsesess"},{"generics":["features"],"name":"option"}],"output":{"name":"bool"}}],[5,"eval_condition","","Evaluate a cfg-like condition (with `any` and `all`), using `eval` to evaluate individual items.",null,{"inputs":[{"name":"metaitem"},{"name":"parsesess"},{"name":"f"}],"output":{"name":"bool"}}],[5,"find_stability_generic","","",null,{"inputs":[{"name":"handler"},{"name":"i"},{"name":"span"}],"output":{"generics":["stability"],"name":"option"}}],[5,"find_deprecation_generic","","",null,{"inputs":[{"name":"handler"},{"name":"i"},{"name":"span"}],"output":{"generics":["deprecation"],"name":"option"}}],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",null,null],[5,"find_deprecation","","Find the deprecation attribute. `None` if none exists.",null,null],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",null,{"inputs":[{"name":"handler"},{"name":"attribute"}],"output":{"generics":["reprattr"],"name":"vec"}}],[5,"int_type_of_word","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["inttype"],"name":"option"}}],[17,"RUST_KNOWN_TOOL","","",null,null],[8,"HasAttrs","","",null,null],[10,"attrs","","",132,null],[10,"map_attrs","","",132,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"meta_item","","Returns the MetaItem if self is a NestedMetaItemKind::MetaItem.",133,{"inputs":[{"name":"self"}],"output":{"generics":["metaitem"],"name":"option"}}],[11,"literal","","Returns the Lit if self is a NestedMetaItemKind::Literal.",133,{"inputs":[{"name":"self"}],"output":{"generics":["lit"],"name":"option"}}],[11,"span","","Returns the Span for `self`.",133,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"check_name","","Returns true if this list item is a MetaItem with a name of `name`.",133,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"bool"}}],[11,"name","","Returns the name of the meta item, e.g. `foo` in `#[foo]`, `#[foo=\"bar\"]` and `#[foo(bar)]`, if self is a MetaItem",133,{"inputs":[{"name":"self"}],"output":{"generics":["name"],"name":"option"}}],[11,"value_str","","Gets the string value if self is a MetaItem and the MetaItem is a MetaItemKind::NameValue variant containing a string, otherwise None.",133,{"inputs":[{"name":"self"}],"output":{"generics":["symbol"],"name":"option"}}],[11,"name_value_literal","","Returns a name and single literal value tuple of the MetaItem.",133,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"word","","Returns a MetaItem if self is a MetaItem with Kind Word.",133,{"inputs":[{"name":"self"}],"output":{"generics":["metaitem"],"name":"option"}}],[11,"meta_item_list","","Gets a list of inner meta items from a list MetaItem type.",133,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"is_meta_item","","Returns `true` if the variant is MetaItem.",133,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_literal","","Returns `true` if the variant is Literal.",133,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_word","","Returns `true` if self is a MetaItem and the meta item is a word.",133,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_value_str","","Returns `true` if self is a MetaItem and the meta item is a ValueString.",133,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_meta_item_list","","Returns `true` if self is a MetaItem and the meta item is a list.",133,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"check_name","syntax::ast","",69,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"bool"}}],[11,"name","","Returns the last segment of the name of this attribute. E.g. `foo` for `#[foo]`, `skip` for `#[rustfmt::skip]`.",69,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"value_str","","",69,{"inputs":[{"name":"self"}],"output":{"generics":["symbol"],"name":"option"}}],[11,"meta_item_list","","",69,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"option"}}],[11,"is_word","","",69,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"span","","",69,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"is_meta_item_list","","",69,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_value_str","","Indicates if the attribute is a Value String.",69,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_scoped","","",69,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"name","","",39,{"inputs":[{"name":"self"}],"output":{"name":"name"}}],[11,"value_str","","",39,{"inputs":[{"name":"self"}],"output":{"generics":["symbol"],"name":"option"}}],[11,"meta_item_list","","",39,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"is_word","","",39,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"span","","",39,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"check_name","","",39,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_value_str","","",39,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_meta_item_list","","",39,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"meta","","Extract the MetaItem from inside this Attribute.",69,{"inputs":[{"name":"self"}],"output":{"generics":["metaitem"],"name":"option"}}],[11,"parse","","",69,{"inputs":[{"name":"self"},{"name":"parsesess"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_list","","",69,{"inputs":[{"name":"self"},{"name":"parsesess"},{"name":"f"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_meta","","",69,{"inputs":[{"name":"self"},{"name":"parsesess"}],"output":{"generics":["metaitem"],"name":"presult"}}],[11,"with_desugared_doc","","Convert self to a normal #[doc=\"foo\"] comment, if it is a comment like `///` or `/** */`. (Returns self unchanged for non-sugared doc attributes.)",69,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"t"}}],[11,"clone","syntax::attr","",127,{"inputs":[{"name":"self"}],"output":{"name":"inlineattr"}}],[11,"hash","","",127,null],[11,"eq","","",127,{"inputs":[{"name":"self"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"encode","","",127,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",127,{"inputs":[{"name":"__d"}],"output":{"generics":["inlineattr"],"name":"result"}}],[11,"clone","","",128,{"inputs":[{"name":"self"}],"output":{"name":"unwindattr"}}],[11,"eq","","",128,{"inputs":[{"name":"self"},{"name":"unwindattr"}],"output":{"name":"bool"}}],[11,"encode","","",122,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",122,{"inputs":[{"name":"__d"}],"output":{"generics":["stability"],"name":"result"}}],[11,"clone","","",122,{"inputs":[{"name":"self"}],"output":{"name":"stability"}}],[11,"fmt","","",122,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",122,{"inputs":[{"name":"self"},{"name":"stability"}],"output":{"name":"bool"}}],[11,"ne","","",122,{"inputs":[{"name":"self"},{"name":"stability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",122,null],[11,"hash","","",122,null],[11,"encode","","",129,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",129,{"inputs":[{"name":"__d"}],"output":{"generics":["stabilitylevel"],"name":"result"}}],[11,"eq","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"le","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"gt","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ge","","",129,{"inputs":[{"name":"self"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"clone","","",129,{"inputs":[{"name":"self"}],"output":{"name":"stabilitylevel"}}],[11,"fmt","","",129,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",129,null],[11,"hash","","",129,null],[11,"encode","","",123,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",123,{"inputs":[{"name":"__d"}],"output":{"generics":["rustcdeprecation"],"name":"result"}}],[11,"eq","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"name":"bool"}}],[11,"ne","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"name":"bool"}}],[11,"le","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"name":"bool"}}],[11,"gt","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"name":"bool"}}],[11,"ge","","",123,{"inputs":[{"name":"self"},{"name":"rustcdeprecation"}],"output":{"name":"bool"}}],[11,"clone","","",123,{"inputs":[{"name":"self"}],"output":{"name":"rustcdeprecation"}}],[11,"fmt","","",123,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",123,null],[11,"hash","","",123,null],[11,"encode","","",124,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",124,{"inputs":[{"name":"__d"}],"output":{"generics":["rustcconstunstable"],"name":"result"}}],[11,"eq","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"name":"bool"}}],[11,"ne","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"name":"bool"}}],[11,"le","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"name":"bool"}}],[11,"gt","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"name":"bool"}}],[11,"ge","","",124,{"inputs":[{"name":"self"},{"name":"rustcconstunstable"}],"output":{"name":"bool"}}],[11,"clone","","",124,{"inputs":[{"name":"self"}],"output":{"name":"rustcconstunstable"}}],[11,"fmt","","",124,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",124,null],[11,"hash","","",124,null],[11,"encode","","",125,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",125,{"inputs":[{"name":"__d"}],"output":{"generics":["deprecation"],"name":"result"}}],[11,"eq","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"name":"bool"}}],[11,"le","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"name":"bool"}}],[11,"gt","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"name":"bool"}}],[11,"ge","","",125,{"inputs":[{"name":"self"},{"name":"deprecation"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"self"}],"output":{"name":"deprecation"}}],[11,"fmt","","",125,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",125,null],[11,"hash","","",125,null],[11,"is_unstable","","",129,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_stable","","",129,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"eq","","",130,{"inputs":[{"name":"self"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"ne","","",130,{"inputs":[{"name":"self"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"fmt","","",130,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",130,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",130,{"inputs":[{"name":"__d"}],"output":{"generics":["reprattr"],"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"self"}],"output":{"name":"reprattr"}}],[11,"assert_receiver_is_total_eq","","",131,null],[11,"hash","","",131,null],[11,"eq","","",131,{"inputs":[{"name":"self"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"ne","","",131,{"inputs":[{"name":"self"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"fmt","","",131,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",131,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",131,{"inputs":[{"name":"__d"}],"output":{"generics":["inttype"],"name":"result"}}],[11,"clone","","",131,{"inputs":[{"name":"self"}],"output":{"name":"inttype"}}],[11,"is_signed","","",131,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"tokens","syntax::ast","",39,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"from_tokens","","",39,{"inputs":[{"name":"peekable"}],"output":{"generics":["metaitem"],"name":"option"}}],[11,"tokens","","",81,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"tokenstream"}}],[11,"from_tokens","","",81,{"inputs":[{"name":"peekable"}],"output":{"generics":["metaitemkind"],"name":"option"}}],[11,"span","","",80,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"tokens","","",80,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"from_tokens","","",80,{"inputs":[{"name":"peekable"}],"output":{"generics":["nestedmetaitemkind"],"name":"option"}}],[11,"tokens","syntax::attr","",134,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"token","syntax::ast","",99,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"from_token","","",99,{"inputs":[{"name":"token"}],"output":{"generics":["litkind"],"name":"option"}}],[11,"attrs","syntax::util","",10,null],[11,"map_attrs","","",10,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","syntax::ast","",89,null],[11,"map_attrs","","",89,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",43,null],[11,"map_attrs","","",43,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",78,null],[11,"map_attrs","","",78,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",73,null],[11,"map_attrs","","",73,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",47,null],[11,"map_attrs","","",47,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",44,null],[11,"map_attrs","","",44,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",74,null],[11,"map_attrs","","",74,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",72,null],[11,"map_attrs","","",72,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",54,null],[11,"map_attrs","","",54,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",53,null],[11,"map_attrs","","",53,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",45,null],[11,"map_attrs","","",45,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",46,null],[11,"map_attrs","","",46,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",42,null],[11,"map_attrs","","",42,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",66,null],[11,"map_attrs","","",66,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",26,null],[11,"map_attrs","","",26,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","","",32,null],[11,"map_attrs","","",32,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[0,"codemap","syntax","The CodeMap tracks all the source code used within a single crate, mapping from integer byte positions to the original source code location. Each bit of source parsed during crate parsing (typically files, in-memory strings, or various bits of macro expansion) cover a continuous range of bytes in the CodeMap and are represented by FileMaps. Byte positions are stored in `spans` and used pervasively in the compiler. They are absolute positions within the CodeMap, which upon request can be converted to line and column information, source code snippets, etc.",null,null],[4,"ExpnFormat","syntax::codemap","The source of expansion.",null,null],[13,"MacroAttribute","","e.g. #[derive(...)] ",135,null],[13,"MacroBang","","e.g. `format!()`",135,null],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",135,null],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",null,null],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",136,null],[12,"callee","","Information about the expansion.",136,null],[3,"NameAndSpan","","",null,null],[12,"format","","The format with which the macro was invoked.",137,null],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",137,null],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",137,null],[12,"span","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None.",137,null],[3,"Spanned","","",null,null],[12,"node","","",138,null],[12,"span","","",138,null],[3,"RealFileLoader","","A FileLoader that uses std::fs to load real files.",null,null],[3,"StableFilemapId","","",null,null],[12,"0","","",139,null],[3,"CodeMapFiles","","",null,null],[12,"file_maps","","",140,null],[12,"stable_id_to_filemap","","",140,null],[3,"CodeMap","","",null,null],[12,"files","","",141,null],[12,"file_loader","","",141,null],[12,"path_mapping","","",141,null],[12,"doctest_offset","","In case we are in a doctest, replace all file names with the PathBuf, and add the given offsets to the line info",141,null],[3,"FilePathMapping","","",null,null],[12,"mapping","","",142,null],[5,"original_sp","","Return the span itself if it doesn't come from a macro expansion, otherwise return the call site span up to the `enclosing_sp` by following the `expn_info` chain.",null,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"span"}}],[5,"respan","","",null,{"inputs":[{"name":"span"},{"name":"t"}],"output":{"name":"spanned"}}],[5,"dummy_spanned","","",null,{"inputs":[{"name":"t"}],"output":{"name":"spanned"}}],[8,"FileLoader","","An abstraction over the fs operations used by the Parser.",null,null],[10,"file_exists","","Query the existence of a file.",143,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[10,"abs_path","","Return an absolute path to a file, if possible.",143,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["pathbuf"],"name":"option"}}],[10,"read_file","","Read the contents of an UTF-8 file into memory.",143,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["string"],"name":"result"}}],[11,"clone","","",138,{"inputs":[{"name":"self"}],"output":{"name":"spanned"}}],[11,"eq","","",138,{"inputs":[{"name":"self"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"self"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",138,null],[11,"encode","","",138,{"inputs":[{"name":"self"},{"name":"__st"}],"output":{"name":"result"}}],[11,"decode","","",138,{"inputs":[{"name":"__dt"}],"output":{"generics":["spanned"],"name":"result"}}],[11,"hash","","",138,null],[11,"fmt","","",138,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"file_exists","","",144,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"abs_path","","",144,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["pathbuf"],"name":"option"}}],[11,"read_file","","",144,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["string"],"name":"result"}}],[11,"clone","","",139,{"inputs":[{"name":"self"}],"output":{"name":"stablefilemapid"}}],[11,"eq","","",139,{"inputs":[{"name":"self"},{"name":"stablefilemapid"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"self"},{"name":"stablefilemapid"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",139,null],[11,"hash","","",139,null],[11,"encode","","",139,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",139,{"inputs":[{"name":"__d"}],"output":{"generics":["stablefilemapid"],"name":"result"}}],[11,"fmt","","",139,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",139,{"inputs":[{"name":"filemap"}],"output":{"name":"stablefilemapid"}}],[11,"new","","",141,{"inputs":[{"name":"filepathmapping"}],"output":{"name":"codemap"}}],[11,"new_doctest","","",141,{"inputs":[{"name":"filepathmapping"},{"name":"filename"},{"name":"isize"}],"output":{"name":"codemap"}}],[11,"with_file_loader","","",141,{"inputs":[{"generics":["fileloader"],"name":"box"},{"name":"filepathmapping"}],"output":{"name":"codemap"}}],[11,"path_mapping","","",141,{"inputs":[{"name":"self"}],"output":{"name":"filepathmapping"}}],[11,"file_exists","","",141,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"load_file","","",141,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["lrc"],"name":"result"}}],[11,"files","","",141,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"lockguard"}}],[11,"filemap_by_stable_id","","",141,{"inputs":[{"name":"self"},{"name":"stablefilemapid"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"next_start_pos","","",141,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new_filemap","","Creates a new filemap without setting its line information. If you don't intend to set the line information yourself, you should use new_filemap_and_lines. This does not ensure that only one FileMap exists per file name.",141,{"inputs":[{"name":"self"},{"name":"filename"},{"name":"string"}],"output":{"generics":["filemap"],"name":"lrc"}}],[11,"new_filemap_and_lines","","Creates a new filemap and sets its line information. This does not ensure that only one FileMap exists per file name.",141,{"inputs":[{"name":"self"},{"name":"path"},{"name":"str"}],"output":{"generics":["filemap"],"name":"lrc"}}],[11,"new_imported_filemap","","Allocates a new FileMap representing a source file from an external crate. The source code of such an \"imported filemap\" is not available, but we still know enough to generate accurate debuginfo location information for things inlined from other crates.",141,{"inputs":[{"name":"self"},{"name":"filename"},{"name":"bool"},{"name":"u32"},{"name":"u128"},{"name":"u128"},{"name":"usize"},{"generics":["bytepos"],"name":"vec"},{"generics":["multibytechar"],"name":"vec"},{"generics":["nonnarrowchar"],"name":"vec"}],"output":{"generics":["filemap"],"name":"lrc"}}],[11,"mk_substr_filename","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"string"}}],[11,"doctest_offset_line","","",141,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"lookup_char_pos","","Lookup source information about a BytePos",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"loc"}}],[11,"lookup_line","","",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"generics":["filemapandline","lrc"],"name":"result"}}],[11,"lookup_char_pos_adj","","",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"locwithopt"}}],[11,"merge_spans","","Returns `Some(span)`, a union of the lhs and rhs span.  The lhs must precede the rhs. If there are gaps between lhs and rhs, the resulting union will cross these gaps. For this to work, the spans have to be:",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"span_to_string","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_filename","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filename"}}],[11,"span_to_unmapped_path","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filename"}}],[11,"is_multiline","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"span_to_lines","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filelinesresult"}}],[11,"span_to_source","","Extract the source surrounding the given `Span` using the `extract_source` function. The extract function takes three arguments: a string slice containing the source, an index in the slice for the beginning of the span and an index in the slice for the end of the span.",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"f"}],"output":{"generics":["string","spansnippeterror"],"name":"result"}}],[11,"span_to_snippet","","Return the source snippet as `String` corresponding to the given `Span`",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["string","spansnippeterror"],"name":"result"}}],[11,"span_to_prev_source","","Return the source snippet as `String` before the given `Span`",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["string","spansnippeterror"],"name":"result"}}],[11,"span_extend_to_prev_char","","Extend the given `Span` to just after the previous occurrence of `c`. Return the same span if no character could be found or if an error occurred while retrieving the code snippet.",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"char"}],"output":{"name":"span"}}],[11,"span_extend_to_prev_str","","Extend the given `Span` to just after the previous occurrence of `pat` when surrounded by whitespace. Return the same span if no character could be found or if an error occurred while retrieving the code snippet.",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"name":"bool"}],"output":{"name":"span"}}],[11,"span_until_char","","Given a `Span`, try to get a shorter span ending before the first occurrence of `c` `char`",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"char"}],"output":{"name":"span"}}],[11,"span_through_char","","Given a `Span`, try to get a shorter span ending just after the first occurrence of `char` `c`.",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"char"}],"output":{"name":"span"}}],[11,"span_until_non_whitespace","","Given a `Span`, get a new `Span` covering the first token and all its trailing whitespace or the original `Span`.",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"span_until_whitespace","","Given a `Span`, get a new `Span` covering the first token without its trailing whitespace or the original `Span` in case of error.",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"span_take_while","","Given a `Span`, get a shorter one until `predicate` yields false.",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"p"}],"output":{"name":"span"}}],[11,"def_span","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"end_point","","Returns a new span representing just the end-point of this span",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"next_point","","Returns a new span representing the next character after the end-point of this span",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"find_width_of_character_at_span","","Finds the width of a character, either before or after the provided span.",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"}],"output":{"name":"u32"}}],[11,"get_filemap","","",141,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"generics":["lrc"],"name":"option"}}],[11,"lookup_byte_offset","","For a global BytePos compute the local offset within the containing FileMap",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"filemapandbytepos"}}],[11,"bytepos_to_file_charpos","","Converts an absolute BytePos to a CharPos relative to the filemap.",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"charpos"}}],[11,"lookup_filemap_idx","","",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"usize"}}],[11,"count_lines","","",141,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"lookup_char_pos","","",141,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"loc"}}],[11,"span_to_lines","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filelinesresult"}}],[11,"span_to_string","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_filename","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"filename"}}],[11,"merge_spans","","",141,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"call_span_if_macro","","",141,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"ensure_filemap_source_present","","",141,{"inputs":[{"name":"self"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"bool"}}],[11,"doctest_offset_line","","",141,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"clone","","",142,{"inputs":[{"name":"self"}],"output":{"name":"filepathmapping"}}],[11,"empty","","",142,{"inputs":[],"output":{"name":"filepathmapping"}}],[11,"new","","",142,{"inputs":[{"name":"vec"}],"output":{"name":"filepathmapping"}}],[11,"map_prefix","","Applies any path prefix substitution as defined by the mapping. The return value is the remapped path and a boolean indicating whether the path was affected by the mapping.",142,null],[0,"config","syntax","",null,null],[3,"StripUnconfigured","syntax::config","A folder that strips out items that do not belong in the current configuration.",null,null],[12,"should_test","","",145,null],[12,"sess","","",145,null],[12,"features","","",145,null],[5,"features","","",null,null],[5,"is_cfg","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"is_test_or_bench","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"configure","","",145,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"process_cfg_attrs","","",145,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"t"}}],[11,"process_cfg_attr","","",145,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"generics":["attribute"],"name":"option"}}],[11,"in_cfg","","",145,null],[11,"visit_expr_attrs","","",145,null],[11,"maybe_emit_expr_attr_err","","If attributes are not allowed on expressions, emit an error for `attr`",145,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"configure_foreign_mod","","",145,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"configure_variant_data","","",145,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"variantdata"}}],[11,"configure_item_kind","","",145,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"itemkind"}}],[11,"configure_expr_kind","","",145,{"inputs":[{"name":"self"},{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"configure_expr","","",145,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"configure_stmt","","",145,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"option"}}],[11,"configure_struct_expr_field","","",145,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"generics":["field"],"name":"option"}}],[11,"configure_pat","","",145,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"disallow_cfg_on_generic_param","","",145,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"fold_foreign_mod","","",145,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fold_item_kind","","",145,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"itemkind"}}],[11,"fold_expr","","",145,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"fold_opt_expr","","",145,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["p"],"name":"option"}}],[11,"fold_stmt","","",145,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"fold_item","","",145,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_impl_item","","",145,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"fold_trait_item","","",145,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"fold_mac","","",145,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"fold_pat","","",145,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[0,"entry","syntax","",null,null],[4,"EntryPointType","syntax::entry","",null,null],[13,"None","","",146,null],[13,"MainNamed","","",146,null],[13,"MainAttr","","",146,null],[13,"Start","","",146,null],[13,"OtherMain","","",146,null],[5,"entry_point_type","","",null,{"inputs":[{"name":"item"},{"name":"usize"}],"output":{"name":"entrypointtype"}}],[0,"edition","syntax","",null,null],[4,"Edition","syntax::edition","The edition of the compiler (RFC 2052)",null,null],[13,"Edition2015","","The 2015 edition",147,null],[13,"Edition2018","","The 2018 edition",147,null],[17,"ALL_EDITIONS","","",null,null],[17,"EDITION_NAME_LIST","","",null,null],[17,"DEFAULT_EDITION","","",null,null],[11,"clone","","",147,{"inputs":[{"name":"self"}],"output":{"name":"edition"}}],[11,"hash","","",147,null],[11,"partial_cmp","","",147,{"inputs":[{"name":"self"},{"name":"edition"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",147,{"inputs":[{"name":"self"},{"name":"edition"}],"output":{"name":"ordering"}}],[11,"assert_receiver_is_total_eq","","",147,null],[11,"eq","","",147,{"inputs":[{"name":"self"},{"name":"edition"}],"output":{"name":"bool"}}],[11,"fmt","","",147,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",147,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"lint_name","","",147,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"feature_name","","",147,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"is_stable","","",147,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"from_str","","",147,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[0,"feature_gate","syntax","Feature gating",null,null],[3,"Features","syntax::feature_gate","A set of features to be used by later passes.",null,null],[12,"declared_stable_lang_features","","`#![feature]` attrs for stable language features, for error reporting",148,null],[12,"declared_lib_features","","`#![feature]` attrs for non-language (library) features",148,null],[12,"asm","","",148,null],[12,"concat_idents","","",148,null],[12,"link_args","","",148,null],[12,"log_syntax","","",148,null],[12,"non_ascii_idents","","",148,null],[12,"plugin_registrar","","",148,null],[12,"thread_local","","",148,null],[12,"trace_macros","","",148,null],[12,"intrinsics","","",148,null],[12,"lang_items","","",148,null],[12,"link_llvm_intrinsics","","",148,null],[12,"linkage","","",148,null],[12,"quote","","",148,null],[12,"rustc_diagnostic_macros","","",148,null],[12,"rustc_const_unstable","","",148,null],[12,"box_syntax","","",148,null],[12,"unboxed_closures","","",148,null],[12,"fundamental","","",148,null],[12,"main","","",148,null],[12,"needs_allocator","","",148,null],[12,"on_unimplemented","","",148,null],[12,"plugin","","",148,null],[12,"simd_ffi","","",148,null],[12,"start","","",148,null],[12,"structural_match","","",148,null],[12,"panic_runtime","","",148,null],[12,"needs_panic_runtime","","",148,null],[12,"optin_builtin_traits","","",148,null],[12,"staged_api","","",148,null],[12,"no_core","","",148,null],[12,"box_patterns","","",148,null],[12,"dropck_parametricity","","",148,null],[12,"dropck_eyepatch","","",148,null],[12,"custom_attribute","","",148,null],[12,"custom_derive","","",148,null],[12,"rustc_attrs","","",148,null],[12,"nll","","",148,null],[12,"allow_internal_unstable","","",148,null],[12,"allow_internal_unsafe","","",148,null],[12,"slice_patterns","","",148,null],[12,"const_fn","","",148,null],[12,"prelude_import","","",148,null],[12,"default_type_parameter_fallback","","",148,null],[12,"associated_type_defaults","","",148,null],[12,"repr_simd","","",148,null],[12,"platform_intrinsics","","",148,null],[12,"unwind_attributes","","",148,null],[12,"naked_functions","","",148,null],[12,"no_debug","","",148,null],[12,"omit_gdb_pretty_printer_section","","",148,null],[12,"cfg_target_vendor","","",148,null],[12,"stmt_expr_attributes","","",148,null],[12,"type_ascription","","",148,null],[12,"cfg_target_thread_local","","",148,null],[12,"abi_vectorcall","","",148,null],[12,"exclusive_range_pattern","","",148,null],[12,"specialization","","",148,null],[12,"cfg_target_has_atomic","","",148,null],[12,"never_type","","",148,null],[12,"exhaustive_patterns","","",148,null],[12,"attr_literals","","",148,null],[12,"untagged_unions","","",148,null],[12,"compiler_builtins","","",148,null],[12,"link_cfg","","",148,null],[12,"use_extern_macros","","",148,null],[12,"abi_ptx","","",148,null],[12,"repr128","","",148,null],[12,"abi_unadjusted","","",148,null],[12,"proc_macro","","",148,null],[12,"decl_macro","","",148,null],[12,"static_nobundle","","",148,null],[12,"abi_msp430_interrupt","","",148,null],[12,"sanitizer_runtime","","",148,null],[12,"profiler_runtime","","",148,null],[12,"abi_x86_interrupt","","",148,null],[12,"catch_expr","","",148,null],[12,"used","","",148,null],[12,"global_asm","","",148,null],[12,"overlapping_marker_traits","","",148,null],[12,"macro_vis_matcher","","",148,null],[12,"abi_thiscall","","",148,null],[12,"allow_fail","","",148,null],[12,"unsized_tuple_coercion","","",148,null],[12,"generators","","",148,null],[12,"trait_alias","","",148,null],[12,"global_allocator","","",148,null],[12,"allocator_internals","","",148,null],[12,"doc_cfg","","",148,null],[12,"doc_masked","","",148,null],[12,"doc_spotlight","","",148,null],[12,"external_doc","","",148,null],[12,"non_exhaustive","","",148,null],[12,"crate_visibility_modifier","","",148,null],[12,"extern_types","","",148,null],[12,"arbitrary_self_types","","",148,null],[12,"crate_in_paths","","",148,null],[12,"in_band_lifetimes","","",148,null],[12,"generic_associated_types","","",148,null],[12,"extern_absolute_paths","","",148,null],[12,"non_modrs_mods","","",148,null],[12,"termination_trait_test","","",148,null],[12,"macro_lifetime_matcher","","",148,null],[12,"extern_in_paths","","",148,null],[12,"repr_transparent","","",148,null],[12,"macro_at_most_once_rep","","",148,null],[12,"infer_outlives_requirements","","",148,null],[12,"if_while_or_patterns","","",148,null],[12,"pattern_parentheses","","",148,null],[12,"repr_packed","","",148,null],[12,"underscore_imports","","",148,null],[12,"wasm_custom_section","","",148,null],[12,"wasm_import_module","","",148,null],[12,"raw_identifiers","","",148,null],[12,"macros_in_extern","","",148,null],[12,"arm_target_feature","","",148,null],[12,"aarch64_target_feature","","",148,null],[12,"hexagon_target_feature","","",148,null],[12,"powerpc_target_feature","","",148,null],[12,"mips_target_feature","","",148,null],[12,"avx512_target_feature","","",148,null],[12,"mmx_target_feature","","",148,null],[12,"sse4a_target_feature","","",148,null],[12,"tbm_target_feature","","",148,null],[12,"proc_macro_path_invoc","","",148,null],[12,"proc_macro_mod","","",148,null],[12,"proc_macro_expr","","",148,null],[12,"proc_macro_non_items","","",148,null],[12,"doc_alias","","",148,null],[12,"extern_prelude","","",148,null],[12,"tool_attributes","","",148,null],[3,"GatedCfg","","",null,null],[12,"span","","",149,null],[12,"index","","",149,null],[3,"Context","","",null,null],[12,"features","","",150,null],[12,"parse_sess","","",150,null],[12,"plugin_attributes","","",150,null],[3,"PostExpansionVisitor","","",null,null],[12,"context","","",151,null],[3,"FeatureChecker","","A collector for mutually exclusive and interdependent features and their flag spans.",null,null],[12,"proc_macro","","",152,null],[12,"custom_attribute","","",152,null],[4,"AttributeType","","",null,null],[13,"Normal","","Normal, builtin attribute that is consumed by the compiler before the unused_attribute check",153,null],[13,"Whitelisted","","Builtin attribute that may not be consumed by the compiler before the unused_attribute check. These attributes will be ignored by the unused_attribute lint",153,null],[13,"CrateLevel","","Builtin attribute that is only allowed at the crate level",153,null],[4,"AttributeGate","","",null,null],[13,"Gated","","Is gated by a given feature gate, reason and function to check if enabled",154,null],[13,"Ungated","","Ungated attribute, can be used on all release channels",154,null],[4,"Stability","","",null,null],[13,"Unstable","","",155,null],[13,"Deprecated","","",155,null],[4,"GateIssue","","",null,null],[13,"Language","","",156,null],[13,"Library","","",156,null],[4,"GateStrength","","",null,null],[13,"Hard","","A hard error. (Most feature gates should use this.)",157,null],[13,"Soft","","Only a warning. (Use this only as backwards-compatibility demands.)",157,null],[4,"UnstableFeatures","","",null,null],[13,"Disallow","","Hard errors for unstable features are active, as on beta/stable channels.",158,null],[13,"Allow","","Allow features to be activated, as on nightly.",158,null],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time during the build that feature-related lints are set to warn or above because the build turns on warnings-as-errors and uses lots of unstable features. As a result, this is always required for building Rust itself.",158,null],[5,"deprecated_attributes","","",null,{"inputs":[],"output":{"name":"vec"}}],[5,"is_builtin_attr","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"check_attribute","","",null,{"inputs":[{"name":"attribute"},{"name":"parsesess"},{"name":"features"}],"output":null}],[5,"find_lang_feature_accepted_version","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["str"],"name":"option"}}],[5,"find_lang_feature_issue","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["u32"],"name":"option"}}],[5,"emit_feature_err","","",null,{"inputs":[{"name":"parsesess"},{"name":"str"},{"name":"span"},{"name":"gateissue"},{"name":"str"}],"output":null}],[5,"feature_err","","",null,{"inputs":[{"name":"parsesess"},{"name":"str"},{"name":"span"},{"name":"gateissue"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[5,"leveled_feature_err","","",null,{"inputs":[{"name":"parsesess"},{"name":"str"},{"name":"span"},{"name":"gateissue"},{"name":"str"},{"name":"gatestrength"}],"output":{"name":"diagnosticbuilder"}}],[5,"contains_novel_literal","","",null,{"inputs":[{"name":"metaitem"}],"output":{"name":"bool"}}],[5,"get_features","","",null,null],[5,"check_crate","","",null,null],[5,"maybe_stage_features","","",null,{"inputs":[{"name":"handler"},{"name":"crate"},{"name":"unstablefeatures"}],"output":null}],[17,"ACTIVE_FEATURES","","Represents active features that are currently being implemented or currently being considered for addition/removal.",null,null],[17,"REMOVED_FEATURES","","Represents unstable features which have since been removed (it was once Active)",null,null],[17,"STABLE_REMOVED_FEATURES","","Represents stable features which have since been removed (it was once Accepted)",null,null],[17,"ACCEPTED_FEATURES","","Those language feature has since been Accepted (it was once Active)",null,null],[17,"BUILTIN_ATTRIBUTES","","",null,null],[17,"GATED_CFGS","","",null,null],[17,"EXPLAIN_BOX_SYNTAX","","",null,null],[17,"EXPLAIN_STMT_ATTR_SYNTAX","","",null,null],[17,"EXPLAIN_ASM","","",null,null],[17,"EXPLAIN_GLOBAL_ASM","","",null,null],[17,"EXPLAIN_LOG_SYNTAX","","",null,null],[17,"EXPLAIN_CONCAT_IDENTS","","",null,null],[17,"EXPLAIN_TRACE_MACROS","","",null,null],[17,"EXPLAIN_ALLOW_INTERNAL_UNSTABLE","","",null,null],[17,"EXPLAIN_ALLOW_INTERNAL_UNSAFE","","",null,null],[17,"EXPLAIN_CUSTOM_DERIVE","","",null,null],[17,"EXPLAIN_DEPR_CUSTOM_DERIVE","","",null,null],[17,"EXPLAIN_DERIVE_UNDERSCORE","","",null,null],[17,"EXPLAIN_VIS_MATCHER","","",null,null],[17,"EXPLAIN_LIFETIME_MATCHER","","",null,null],[17,"EXPLAIN_UNSIZED_TUPLE_COERCION","","",null,null],[17,"EXPLAIN_MACRO_AT_MOST_ONCE_REP","","",null,null],[17,"EXPLAIN_MACROS_IN_EXTERN","","",null,null],[17,"EXPLAIN_PROC_MACROS_IN_EXTERN","","",null,null],[11,"clone","","",148,{"inputs":[{"name":"self"}],"output":{"name":"features"}}],[11,"new","","",148,{"inputs":[],"output":{"name":"features"}}],[11,"walk_feature_fields","","",148,{"inputs":[{"name":"self"},{"name":"f"}],"output":null}],[11,"eq","","",153,{"inputs":[{"name":"self"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"self"}],"output":{"name":"attributetype"}}],[11,"fmt","","",153,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is_deprecated","","",154,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"self"}],"output":{"name":"stability"}}],[11,"eq","","",155,{"inputs":[{"name":"self"},{"name":"stability"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"self"},{"name":"stability"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",155,null],[11,"fmt","","",155,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",154,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",149,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",149,null],[11,"eq","","",149,{"inputs":[{"name":"self"},{"name":"gatedcfg"}],"output":{"name":"bool"}}],[11,"ne","","",149,{"inputs":[{"name":"self"},{"name":"gatedcfg"}],"output":{"name":"bool"}}],[11,"gate","","",149,{"inputs":[{"name":"metaitem"}],"output":{"generics":["gatedcfg"],"name":"option"}}],[11,"check_and_emit","","",149,{"inputs":[{"name":"self"},{"name":"parsesess"},{"name":"features"}],"output":null}],[11,"check_attribute","","",150,{"inputs":[{"name":"self"},{"name":"attribute"},{"name":"bool"}],"output":null}],[11,"fmt","","",157,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",157,{"inputs":[{"name":"self"}],"output":{"name":"gatestrength"}}],[11,"eq","","",157,{"inputs":[{"name":"self"},{"name":"gatestrength"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",157,null],[11,"check_abi","","",151,{"inputs":[{"name":"self"},{"name":"abi"},{"name":"span"}],"output":null}],[11,"whole_crate_feature_gates","","",151,{"inputs":[{"name":"self"},{"name":"crate"}],"output":null}],[11,"visit_attribute","","",151,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_name","","",151,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":null}],[11,"visit_use_tree","","",151,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"visit_item","","",151,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",151,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_ty","","",151,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_fn_ret_ty","","",151,{"inputs":[{"name":"self"},{"name":"functionretty"}],"output":null}],[11,"visit_expr","","",151,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_arm","","",151,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",151,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_fn","","",151,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",151,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",151,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_path","","",151,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_vis","","",151,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":null}],[11,"default","","",152,{"inputs":[],"output":{"name":"featurechecker"}}],[11,"collect","","",152,{"inputs":[{"name":"self"},{"name":"features"},{"name":"span"}],"output":null}],[11,"check","","",152,{"inputs":[{"name":"self"},{"name":"handler"}],"output":null}],[11,"clone","","",158,{"inputs":[{"name":"self"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",158,{"inputs":[{"name":"self"},{"name":"unstablefeatures"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",158,null],[11,"hash","","",158,null],[11,"from_environment","","",158,{"inputs":[],"output":{"name":"unstablefeatures"}}],[11,"is_nightly_build","","",158,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[0,"fold","syntax","A Folder represents an AST->AST fold; it accepts an AST piece, and returns a piece of the same type. So, for instance, macro expansion is a Folder that walks over an AST and produces another AST.",null,null],[5,"noop_fold_meta_items","syntax::fold","",null,{"inputs":[{"generics":["metaitem"],"name":"vec"},{"name":"t"}],"output":{"generics":["metaitem"],"name":"vec"}}],[5,"noop_fold_use_tree","","",null,{"inputs":[{"name":"usetree"},{"name":"t"}],"output":{"name":"usetree"}}],[5,"fold_attrs","","",null,{"inputs":[{"generics":["attribute"],"name":"vec"},{"name":"t"}],"output":{"generics":["attribute"],"name":"vec"}}],[5,"fold_thin_attrs","","",null,{"inputs":[{"generics":["attribute"],"name":"thinvec"},{"name":"t"}],"output":{"generics":["attribute"],"name":"thinvec"}}],[5,"noop_fold_arm","","",null,{"inputs":[{"name":"arm"},{"name":"t"}],"output":{"name":"arm"}}],[5,"noop_fold_ty_binding","","",null,{"inputs":[{"name":"typebinding"},{"name":"t"}],"output":{"name":"typebinding"}}],[5,"noop_fold_ty","","",null,{"inputs":[{"generics":["ty"],"name":"p"},{"name":"t"}],"output":{"generics":["ty"],"name":"p"}}],[5,"noop_fold_foreign_mod","","",null,{"inputs":[{"name":"foreignmod"},{"name":"t"}],"output":{"name":"foreignmod"}}],[5,"noop_fold_global_asm","","",null,{"inputs":[{"generics":["globalasm"],"name":"p"},{"name":"t"}],"output":{"generics":["globalasm"],"name":"p"}}],[5,"noop_fold_variant","","",null,{"inputs":[{"name":"variant"},{"name":"t"}],"output":{"name":"variant"}}],[5,"noop_fold_ident","","",null,{"inputs":[{"name":"ident"},{"name":"t"}],"output":{"name":"ident"}}],[5,"noop_fold_usize","","",null,{"inputs":[{"name":"usize"},{"name":"t"}],"output":{"name":"usize"}}],[5,"noop_fold_path","","",null,{"inputs":[{"name":"path"},{"name":"t"}],"output":{"name":"path"}}],[5,"noop_fold_path_parameters","","",null,{"inputs":[{"name":"pathparameters"},{"name":"t"}],"output":{"name":"pathparameters"}}],[5,"noop_fold_angle_bracketed_parameter_data","","",null,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"t"}],"output":{"name":"anglebracketedparameterdata"}}],[5,"noop_fold_parenthesized_parameter_data","","",null,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"t"}],"output":{"name":"parenthesizedparameterdata"}}],[5,"noop_fold_local","","",null,{"inputs":[{"generics":["local"],"name":"p"},{"name":"t"}],"output":{"generics":["local"],"name":"p"}}],[5,"noop_fold_attribute","","",null,{"inputs":[{"name":"attribute"},{"name":"t"}],"output":{"generics":["attribute"],"name":"option"}}],[5,"noop_fold_mac","","",null,{"inputs":[{"name":"mac"},{"name":"t"}],"output":{"name":"mac"}}],[5,"noop_fold_macro_def","","",null,{"inputs":[{"name":"macrodef"},{"name":"t"}],"output":{"name":"macrodef"}}],[5,"noop_fold_meta_list_item","","",null,{"inputs":[{"name":"nestedmetaitem"},{"name":"t"}],"output":{"name":"nestedmetaitem"}}],[5,"noop_fold_meta_item","","",null,{"inputs":[{"name":"metaitem"},{"name":"t"}],"output":{"name":"metaitem"}}],[5,"noop_fold_arg","","",null,{"inputs":[{"name":"arg"},{"name":"t"}],"output":{"name":"arg"}}],[5,"noop_fold_tt","","",null,{"inputs":[{"name":"tokentree"},{"name":"t"}],"output":{"name":"tokentree"}}],[5,"noop_fold_tts","","",null,{"inputs":[{"name":"tokenstream"},{"name":"t"}],"output":{"name":"tokenstream"}}],[5,"noop_fold_token","","",null,{"inputs":[{"name":"token"},{"name":"t"}],"output":{"name":"token"}}],[5,"noop_fold_interpolated","","apply folder to elements of interpolated nodes",null,{"inputs":[{"name":"nonterminal"},{"name":"t"}],"output":{"name":"nonterminal"}}],[5,"noop_fold_fn_decl","","",null,{"inputs":[{"generics":["fndecl"],"name":"p"},{"name":"t"}],"output":{"generics":["fndecl"],"name":"p"}}],[5,"noop_fold_ty_param_bound","","",null,{"inputs":[{"name":"typarambound"},{"name":"t"}],"output":{"name":"typarambound"}}],[5,"noop_fold_ty_param","","",null,{"inputs":[{"name":"typaram"},{"name":"t"}],"output":{"name":"typaram"}}],[5,"noop_fold_generic_param","","",null,{"inputs":[{"name":"genericparam"},{"name":"t"}],"output":{"name":"genericparam"}}],[5,"noop_fold_generic_params","","",null,{"inputs":[{"generics":["genericparam"],"name":"vec"},{"name":"t"}],"output":{"generics":["genericparam"],"name":"vec"}}],[5,"noop_fold_label","","",null,{"inputs":[{"name":"label"},{"name":"t"}],"output":{"name":"label"}}],[5,"noop_fold_lifetime","","",null,{"inputs":[{"name":"lifetime"},{"name":"t"}],"output":{"name":"lifetime"}}],[5,"noop_fold_lifetime_def","","",null,{"inputs":[{"name":"lifetimedef"},{"name":"t"}],"output":{"name":"lifetimedef"}}],[5,"noop_fold_lifetimes","","",null,{"inputs":[{"generics":["lifetime"],"name":"vec"},{"name":"t"}],"output":{"generics":["lifetime"],"name":"vec"}}],[5,"noop_fold_lifetime_defs","","",null,{"inputs":[{"generics":["lifetimedef"],"name":"vec"},{"name":"t"}],"output":{"generics":["lifetimedef"],"name":"vec"}}],[5,"noop_fold_opt_lifetime","","",null,{"inputs":[{"generics":["lifetime"],"name":"option"},{"name":"t"}],"output":{"generics":["lifetime"],"name":"option"}}],[5,"noop_fold_generics","","",null,{"inputs":[{"name":"generics"},{"name":"t"}],"output":{"name":"generics"}}],[5,"noop_fold_where_clause","","",null,{"inputs":[{"name":"whereclause"},{"name":"t"}],"output":{"name":"whereclause"}}],[5,"noop_fold_where_predicate","","",null,{"inputs":[{"name":"wherepredicate"},{"name":"t"}],"output":{"name":"wherepredicate"}}],[5,"noop_fold_variant_data","","",null,{"inputs":[{"name":"variantdata"},{"name":"t"}],"output":{"name":"variantdata"}}],[5,"noop_fold_trait_ref","","",null,{"inputs":[{"name":"traitref"},{"name":"t"}],"output":{"name":"traitref"}}],[5,"noop_fold_poly_trait_ref","","",null,{"inputs":[{"name":"polytraitref"},{"name":"t"}],"output":{"name":"polytraitref"}}],[5,"noop_fold_struct_field","","",null,{"inputs":[{"name":"structfield"},{"name":"t"}],"output":{"name":"structfield"}}],[5,"noop_fold_field","","",null,{"inputs":[{"name":"field"},{"name":"t"}],"output":{"name":"field"}}],[5,"noop_fold_mt","","",null,{"inputs":[{"name":"mutty"},{"name":"t"}],"output":{"name":"mutty"}}],[5,"noop_fold_opt_bounds","","",null,{"inputs":[{"generics":["typarambounds"],"name":"option"},{"name":"t"}],"output":{"generics":["typarambounds"],"name":"option"}}],[5,"noop_fold_bounds","","",null,{"inputs":[{"name":"typarambounds"},{"name":"t"}],"output":{"name":"typarambounds"}}],[5,"noop_fold_block","","",null,{"inputs":[{"generics":["block"],"name":"p"},{"name":"t"}],"output":{"generics":["block"],"name":"p"}}],[5,"noop_fold_item_kind","","",null,{"inputs":[{"name":"itemkind"},{"name":"t"}],"output":{"name":"itemkind"}}],[5,"noop_fold_trait_item","","",null,{"inputs":[{"name":"traititem"},{"name":"t"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[5,"noop_fold_impl_item","","",null,{"inputs":[{"name":"implitem"},{"name":"t"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[5,"noop_fold_mod","","",null,{"inputs":[{"name":"mod"},{"name":"t"}],"output":{"name":"mod"}}],[5,"noop_fold_crate","","",null,{"inputs":[{"name":"crate"},{"name":"t"}],"output":{"name":"crate"}}],[5,"noop_fold_item","","",null,{"inputs":[{"generics":["item"],"name":"p"},{"name":"t"}],"output":{"generics":["p"],"name":"smallvector"}}],[5,"noop_fold_item_simple","","",null,{"inputs":[{"name":"item"},{"name":"t"}],"output":{"name":"item"}}],[5,"noop_fold_foreign_item","","",null,{"inputs":[{"name":"foreignitem"},{"name":"t"}],"output":{"generics":["foreignitem"],"name":"smallvector"}}],[5,"noop_fold_foreign_item_simple","","",null,{"inputs":[{"name":"foreignitem"},{"name":"t"}],"output":{"name":"foreignitem"}}],[5,"noop_fold_method_sig","","",null,{"inputs":[{"name":"methodsig"},{"name":"t"}],"output":{"name":"methodsig"}}],[5,"noop_fold_pat","","",null,{"inputs":[{"generics":["pat"],"name":"p"},{"name":"t"}],"output":{"generics":["pat"],"name":"p"}}],[5,"noop_fold_range_end","","",null,{"inputs":[{"name":"rangeend"},{"name":"t"}],"output":{"name":"rangeend"}}],[5,"noop_fold_expr","","",null,{"inputs":[{"name":"expr"},{"name":"t"}],"output":{"name":"expr"}}],[5,"noop_fold_opt_expr","","",null,{"inputs":[{"generics":["expr"],"name":"p"},{"name":"t"}],"output":{"generics":["p"],"name":"option"}}],[5,"noop_fold_exprs","","",null,{"inputs":[{"generics":["p"],"name":"vec"},{"name":"t"}],"output":{"generics":["p"],"name":"vec"}}],[5,"noop_fold_stmt","","",null,{"inputs":[{"name":"stmt"},{"name":"t"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[5,"noop_fold_stmt_kind","","",null,{"inputs":[{"name":"stmtkind"},{"name":"t"}],"output":{"generics":["stmtkind"],"name":"smallvector"}}],[5,"noop_fold_vis","","",null,{"inputs":[{"name":"visibility"},{"name":"t"}],"output":{"name":"visibility"}}],[8,"Folder","","",null,null],[11,"fold_crate","","",159,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_meta_items","","",159,{"inputs":[{"name":"self"},{"generics":["metaitem"],"name":"vec"}],"output":{"generics":["metaitem"],"name":"vec"}}],[11,"fold_meta_list_item","","",159,{"inputs":[{"name":"self"},{"name":"nestedmetaitem"}],"output":{"name":"nestedmetaitem"}}],[11,"fold_meta_item","","",159,{"inputs":[{"name":"self"},{"name":"metaitem"}],"output":{"name":"metaitem"}}],[11,"fold_use_tree","","",159,{"inputs":[{"name":"self"},{"name":"usetree"}],"output":{"name":"usetree"}}],[11,"fold_foreign_item","","",159,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"generics":["foreignitem"],"name":"smallvector"}}],[11,"fold_foreign_item_simple","","",159,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"foreignitem"}}],[11,"fold_item","","",159,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_item_simple","","",159,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"item"}}],[11,"fold_struct_field","","",159,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":{"name":"structfield"}}],[11,"fold_item_kind","","",159,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"itemkind"}}],[11,"fold_trait_item","","",159,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"fold_impl_item","","",159,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"fold_fn_decl","","",159,{"inputs":[{"name":"self"},{"generics":["fndecl"],"name":"p"}],"output":{"generics":["fndecl"],"name":"p"}}],[11,"fold_block","","",159,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"}],"output":{"generics":["block"],"name":"p"}}],[11,"fold_stmt","","",159,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"fold_arm","","",159,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"arm"}}],[11,"fold_pat","","",159,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"fold_expr","","",159,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"fold_range_end","","",159,{"inputs":[{"name":"self"},{"name":"rangeend"}],"output":{"name":"rangeend"}}],[11,"fold_opt_expr","","",159,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["p"],"name":"option"}}],[11,"fold_exprs","","",159,{"inputs":[{"name":"self"},{"generics":["p"],"name":"vec"}],"output":{"generics":["p"],"name":"vec"}}],[11,"fold_ty","","",159,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"}],"output":{"generics":["ty"],"name":"p"}}],[11,"fold_ty_binding","","",159,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":{"name":"typebinding"}}],[11,"fold_mod","","",159,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_foreign_mod","","",159,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fold_global_asm","","",159,{"inputs":[{"name":"self"},{"generics":["globalasm"],"name":"p"}],"output":{"generics":["globalasm"],"name":"p"}}],[11,"fold_variant","","",159,{"inputs":[{"name":"self"},{"name":"variant"}],"output":{"name":"variant"}}],[11,"fold_ident","","",159,{"inputs":[{"name":"self"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_usize","","",159,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"fold_path","","",159,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"path"}}],[11,"fold_path_parameters","","",159,{"inputs":[{"name":"self"},{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"fold_angle_bracketed_parameter_data","","",159,{"inputs":[{"name":"self"},{"name":"anglebracketedparameterdata"}],"output":{"name":"anglebracketedparameterdata"}}],[11,"fold_parenthesized_parameter_data","","",159,{"inputs":[{"name":"self"},{"name":"parenthesizedparameterdata"}],"output":{"name":"parenthesizedparameterdata"}}],[11,"fold_local","","",159,{"inputs":[{"name":"self"},{"generics":["local"],"name":"p"}],"output":{"generics":["local"],"name":"p"}}],[11,"fold_mac","","",159,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"fold_macro_def","","",159,{"inputs":[{"name":"self"},{"name":"macrodef"}],"output":{"name":"macrodef"}}],[11,"fold_label","","",159,{"inputs":[{"name":"self"},{"name":"label"}],"output":{"name":"label"}}],[11,"fold_lifetime","","",159,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"fold_lifetime_def","","",159,{"inputs":[{"name":"self"},{"name":"lifetimedef"}],"output":{"name":"lifetimedef"}}],[11,"fold_attribute","","",159,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"generics":["attribute"],"name":"option"}}],[11,"fold_arg","","",159,{"inputs":[{"name":"self"},{"name":"arg"}],"output":{"name":"arg"}}],[11,"fold_generics","","",159,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"name":"generics"}}],[11,"fold_trait_ref","","",159,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fold_poly_trait_ref","","",159,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"polytraitref"}}],[11,"fold_variant_data","","",159,{"inputs":[{"name":"self"},{"name":"variantdata"}],"output":{"name":"variantdata"}}],[11,"fold_lifetimes","","",159,{"inputs":[{"name":"self"},{"generics":["lifetime"],"name":"vec"}],"output":{"generics":["lifetime"],"name":"vec"}}],[11,"fold_lifetime_defs","","",159,{"inputs":[{"name":"self"},{"generics":["lifetimedef"],"name":"vec"}],"output":{"generics":["lifetimedef"],"name":"vec"}}],[11,"fold_ty_param","","",159,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"typaram"}}],[11,"fold_generic_param","","",159,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":{"name":"genericparam"}}],[11,"fold_generic_params","","",159,{"inputs":[{"name":"self"},{"generics":["genericparam"],"name":"vec"}],"output":{"generics":["genericparam"],"name":"vec"}}],[11,"fold_tt","","",159,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"tokentree"}}],[11,"fold_tts","","",159,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[11,"fold_token","","",159,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"token"}}],[11,"fold_interpolated","","",159,{"inputs":[{"name":"self"},{"name":"nonterminal"}],"output":{"name":"nonterminal"}}],[11,"fold_opt_lifetime","","",159,{"inputs":[{"name":"self"},{"generics":["lifetime"],"name":"option"}],"output":{"generics":["lifetime"],"name":"option"}}],[11,"fold_opt_bounds","","",159,{"inputs":[{"name":"self"},{"generics":["typarambounds"],"name":"option"}],"output":{"generics":["typarambounds"],"name":"option"}}],[11,"fold_bounds","","",159,{"inputs":[{"name":"self"},{"name":"typarambounds"}],"output":{"name":"typarambounds"}}],[11,"fold_ty_param_bound","","",159,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":{"name":"typarambound"}}],[11,"fold_mt","","",159,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"mutty"}}],[11,"fold_field","","",159,{"inputs":[{"name":"self"},{"name":"field"}],"output":{"name":"field"}}],[11,"fold_where_clause","","",159,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"whereclause"}}],[11,"fold_where_predicate","","",159,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"fold_vis","","",159,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"new_id","","",159,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"new_span","","",159,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[0,"parse","syntax","The main parser interface",null,null],[3,"ParseSess","syntax::parse","Info about a parsing session.",null,null],[12,"span_diagnostic","","",160,null],[12,"unstable_features","","",160,null],[12,"config","","",160,null],[12,"missing_fragment_specifiers","","",160,null],[12,"raw_identifier_spans","","Places where raw identifiers were used. This is used for feature gating raw identifiers",160,null],[12,"registered_diagnostics","","The registered diagnostics codes",160,null],[12,"non_modrs_mods","","",160,null],[12,"included_mod_stack","","Used to determine and report recursive mod inclusions",160,null],[12,"code_map","","",160,null],[3,"Directory","","",null,null],[12,"path","","",161,null],[12,"ownership","","",161,null],[4,"DirectoryOwnership","","",null,null],[13,"Owned","","",162,null],[12,"relative","syntax::parse::DirectoryOwnership","",162,null],[13,"UnownedViaBlock","syntax::parse","",162,null],[13,"UnownedViaMod","","",162,null],[5,"parse_crate_from_file","","",null,{"inputs":[{"name":"path"},{"name":"parsesess"}],"output":{"generics":["crate"],"name":"presult"}}],[5,"parse_crate_attrs_from_file","","",null,{"inputs":[{"name":"path"},{"name":"parsesess"}],"output":{"generics":["vec"],"name":"presult"}}],[5,"parse_crate_from_source_str","","",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"}],"output":{"generics":["crate"],"name":"presult"}}],[5,"parse_crate_attrs_from_source_str","","",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"}],"output":{"generics":["vec"],"name":"presult"}}],[5,"parse_expr_from_source_str","","",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"}],"output":{"generics":["p"],"name":"presult"}}],[5,"parse_item_from_source_str","","Parses an item.",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"}],"output":{"generics":["option"],"name":"presult"}}],[5,"parse_meta_from_source_str","","",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"}],"output":{"generics":["metaitem"],"name":"presult"}}],[5,"parse_stmt_from_source_str","","",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"}],"output":{"generics":["option"],"name":"presult"}}],[5,"parse_stream_from_source_str","","",null,{"inputs":[{"name":"filename"},{"name":"string"},{"name":"parsesess"},{"generics":["span"],"name":"option"}],"output":{"name":"tokenstream"}}],[5,"new_parser_from_source_str","","",null,{"inputs":[{"name":"parsesess"},{"name":"filename"},{"name":"string"}],"output":{"name":"parser"}}],[5,"new_parser_from_file","","Create a new parser, handling errors as appropriate if the file doesn't exist",null,{"inputs":[{"name":"parsesess"},{"name":"path"}],"output":{"name":"parser"}}],[5,"new_sub_parser_from_file","","Given a session, a crate config, a path, and a span, add the file at the given path to the codemap, and return a parser. On an error, use the given span as the source of the problem.",null,{"inputs":[{"name":"parsesess"},{"name":"path"},{"name":"directoryownership"},{"generics":["string"],"name":"option"},{"name":"span"}],"output":{"name":"parser"}}],[5,"filemap_to_parser","","Given a filemap and config, return a parser",null,{"inputs":[{"name":"parsesess"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"parser"}}],[5,"new_parser_from_tts","","",null,{"inputs":[{"name":"parsesess"},{"generics":["tokentree"],"name":"vec"}],"output":{"name":"parser"}}],[5,"file_to_filemap","","Given a session and a path and an optional span (for error reporting), add the path to the session's codemap and return the new filemap.",null,{"inputs":[{"name":"parsesess"},{"name":"path"},{"generics":["span"],"name":"option"}],"output":{"generics":["filemap"],"name":"lrc"}}],[5,"filemap_to_stream","","Given a filemap, produce a sequence of token-trees",null,{"inputs":[{"name":"parsesess"},{"generics":["filemap"],"name":"lrc"},{"generics":["span"],"name":"option"}],"output":{"name":"tokenstream"}}],[5,"stream_to_parser","","Given stream and the `ParseSess`, produce a parser",null,{"inputs":[{"name":"parsesess"},{"name":"tokenstream"}],"output":{"name":"parser"}}],[5,"char_lit","","Parse a string representing a character literal into its final form. Rather than just accepting/rejecting a given literal, unescapes it as well. Can take any slice prefixed by a character escape. Returns the character and the number of characters consumed.",null,null],[5,"str_lit","","Parse a string representing a string literal into its final form. Does unescaping.",null,{"inputs":[{"name":"str"},{"name":"option"}],"output":{"name":"string"}}],[5,"raw_str_lit","","Parse a string representing a raw string literal into its final form. The only operation this does is convert embedded CRLF into a single LF.",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"looks_like_width_suffix","","",null,null],[5,"lit_token","","",null,null],[5,"filtered_float_lit","","",null,{"inputs":[{"name":"symbol"},{"generics":["symbol"],"name":"option"},{"name":"option"}],"output":{"generics":["litkind"],"name":"option"}}],[5,"float_lit","","",null,{"inputs":[{"name":"str"},{"generics":["symbol"],"name":"option"},{"name":"option"}],"output":{"generics":["litkind"],"name":"option"}}],[5,"byte_lit","","Parse a string representing a byte literal into its final form. Similar to `char_lit`",null,null],[5,"byte_str_lit","","",null,{"inputs":[{"name":"str"}],"output":{"generics":["vec"],"name":"lrc"}}],[5,"integer_lit","","",null,{"inputs":[{"name":"str"},{"generics":["symbol"],"name":"option"},{"name":"option"}],"output":{"generics":["litkind"],"name":"option"}}],[0,"parser","","",null,null],[3,"Restrictions","syntax::parse::parser","",null,null],[12,"bits","","",163,null],[3,"Parser","","",null,null],[12,"sess","","",164,null],[12,"token","","the current token:",164,null],[12,"span","","the span of the current token:",164,null],[12,"meta_var_span","","the span of the previous token:",164,null],[12,"prev_span","","",164,null],[12,"prev_token_kind","","the previous token kind",164,null],[12,"restrictions","","",164,null],[12,"directory","","Used to determine the path to externally loaded source files",164,null],[12,"recurse_into_file_modules","","Whether to parse sub-modules in other files.",164,null],[12,"root_module_name","","Name of the root module this parser originated from. If `None`, then the name is not known. This does not change while the parser is descending into modules, and sub-parsers have new values for this name.",164,null],[12,"expected_tokens","","",164,null],[12,"token_cursor","","",164,null],[12,"desugar_doc_comments","","",164,null],[12,"cfg_mods","","Whether we should configure out of line modules as we parse.",164,null],[3,"TokenCursor","","",null,null],[12,"frame","","",165,null],[12,"stack","","",165,null],[3,"TokenCursorFrame","","",null,null],[12,"delim","","",166,null],[12,"span","","",166,null],[12,"open_delim","","",166,null],[12,"tree_cursor","","",166,null],[12,"close_delim","","",166,null],[12,"last_token","","",166,null],[3,"ModulePath","","Information about the path to a module.",null,null],[12,"name","","",167,null],[12,"path_exists","","",167,null],[12,"result","","",167,null],[3,"ModulePathSuccess","","",null,null],[12,"path","","",168,null],[12,"directory_ownership","","",168,null],[12,"warn","","",168,null],[3,"ModulePathError","","",null,null],[12,"err_msg","","",169,null],[12,"help_msg","","",169,null],[4,"PathStyle","","How to parse a path.",null,null],[13,"Expr","","In some contexts, notably in expressions, paths with generic arguments are ambiguous with something else. For example, in expressions `segment < ....` can be interpreted as a comparison and `segment ( ....` can be interpreted as a function call. In all such contexts the non-path interpretation is preferred by default for practical reasons, but the path interpretation can be forced by the disambiguator `::`, e.g. `x<y>` - comparisons, `x::<y>` - unambiguously a path.",170,null],[13,"Type","","In other contexts, notably in types, no ambiguity exists and paths can be written without the disambiguator, e.g. `x<y>` - unambiguously a path. Paths with disambiguators are still accepted, `x::<Y>` - unambiguously a path too.",170,null],[13,"Mod","","A path with generic arguments disallowed, e.g. `foo::bar::Baz`, used in imports, visibilities or attributes. Technically, this variant is unnecessary and e.g. `Expr` can be used instead (paths in \"mod\" contexts have to be checked later for absence of generic arguments anyway, due to macros), but it is used to avoid weird suggestions about expected tokens when something goes wrong.",170,null],[4,"SemiColonMode","","",null,null],[13,"Break","","",171,null],[13,"Ignore","","",171,null],[4,"BlockMode","","",null,null],[13,"Break","","",172,null],[13,"Ignore","","",172,null],[4,"PrevTokenKind","","",null,null],[13,"DocComment","","",173,null],[13,"Comma","","",173,null],[13,"Plus","","",173,null],[13,"Interpolated","","",173,null],[13,"Eof","","",173,null],[13,"Ident","","",173,null],[13,"Other","","",173,null],[4,"LastToken","","This is used in `TokenCursorFrame` above to track tokens that are consumed by the parser, and then that's transitively used to record the tokens that each parse AST item is created with.",null,null],[13,"Collecting","","",174,null],[13,"Was","","",174,null],[4,"TokenType","","",null,null],[13,"Token","","",175,null],[13,"Keyword","","",175,null],[13,"Operator","","",175,null],[13,"Lifetime","","",175,null],[13,"Ident","","",175,null],[13,"Path","","",175,null],[13,"Type","","",175,null],[4,"Error","","",null,null],[13,"FileNotFoundForModule","","",176,null],[12,"mod_name","syntax::parse::parser::Error","",176,null],[12,"default_path","","",176,null],[12,"secondary_path","","",176,null],[12,"dir_path","","",176,null],[13,"DuplicatePaths","syntax::parse::parser","",176,null],[12,"mod_name","syntax::parse::parser::Error","",176,null],[12,"default_path","","",176,null],[12,"secondary_path","","",176,null],[13,"UselessDocComment","syntax::parse::parser","",176,null],[13,"InclusiveRangeWithNoEnd","","",176,null],[4,"LhsExpr","","",null,null],[13,"NotYetParsed","","",177,null],[13,"AttributesParsed","","",177,null],[13,"AlreadyParsed","","",177,null],[4,"TokenExpectType","","",null,null],[13,"Expect","","",178,null],[13,"NoExpect","","",178,null],[5,"maybe_append","","",null,{"inputs":[{"generics":["attribute"],"name":"vec"},{"generics":["vec"],"name":"option"}],"output":{"generics":["attribute"],"name":"vec"}}],[5,"can_continue_type_after_non_fn_ident","","Returns true if `IDENT t` can start a type - `IDENT::a::b`, `IDENT<u8, u8>`, `IDENT<<u8 as Trait>::AssocTy>`.",null,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[5,"dummy_arg","","Create a placeholder argument.",null,{"inputs":[{"name":"span"}],"output":{"name":"arg"}}],[6,"ItemInfo","","",null,null],[8,"RecoverQPath","","",null,null],[18,"PATH_STYLE","","",179,null],[10,"to_ty","","",179,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[10,"to_recovered","","",179,{"inputs":[{"name":"self"},{"generics":["qself"],"name":"option"},{"name":"path"}],"output":{"name":"self"}}],[10,"to_string","","",179,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"eq","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ne","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",163,null],[11,"clone","","",163,{"inputs":[{"name":"self"}],"output":{"name":"restrictions"}}],[11,"partial_cmp","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"le","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"gt","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ge","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"cmp","","",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"ordering"}}],[11,"hash","","",163,null],[11,"fmt","","",163,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",163,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",163,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",163,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",163,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[18,"STMT_EXPR","","",163,null],[18,"NO_STRUCT_LITERAL","","",163,null],[11,"empty","","Returns an empty set of flags.",163,{"inputs":[],"output":{"name":"restrictions"}}],[11,"all","","Returns the set containing all flags.",163,{"inputs":[],"output":{"name":"restrictions"}}],[11,"bits","","Returns the raw value of the flags currently stored.",163,{"inputs":[{"name":"self"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that representation contains bits that do not correspond to a flag.",163,{"inputs":[{"name":"u8"}],"output":{"generics":["restrictions"],"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits that do not correspond to flags.",163,{"inputs":[{"name":"u8"}],"output":{"name":"restrictions"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",163,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",163,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"set","","Inserts or removes the specified flags depending on the passed value.",163,{"inputs":[{"name":"self"},{"name":"restrictions"},{"name":"bool"}],"output":null}],[11,"bitor","","Returns the union of the two sets of flags.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bitor_assign","","Adds the set of flags.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bitxor_assign","","Toggles the set of flags.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"bitand","","Returns the intersection between the two sets of flags.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bitand_assign","","Disables all flags disabled in the set.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"sub","","Returns the set difference of the two sets of flags.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"sub_assign","","Disables all flags enabled in the set.",163,{"inputs":[{"name":"self"},{"name":"restrictions"}],"output":null}],[11,"not","","Returns the complement of this set of flags.",163,{"inputs":[{"name":"self"}],"output":{"name":"restrictions"}}],[11,"extend","","",163,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"from_iter","","",163,{"inputs":[{"name":"t"}],"output":{"name":"restrictions"}}],[11,"clone","","",170,{"inputs":[{"name":"self"}],"output":{"name":"pathstyle"}}],[11,"eq","","",170,{"inputs":[{"name":"self"},{"name":"pathstyle"}],"output":{"name":"bool"}}],[11,"clone","","",171,{"inputs":[{"name":"self"}],"output":{"name":"semicolonmode"}}],[11,"fmt","","",171,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",171,{"inputs":[{"name":"self"},{"name":"semicolonmode"}],"output":{"name":"bool"}}],[11,"clone","","",172,{"inputs":[{"name":"self"}],"output":{"name":"blockmode"}}],[11,"fmt","","",172,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",172,{"inputs":[{"name":"self"},{"name":"blockmode"}],"output":{"name":"bool"}}],[11,"fmt","","",173,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",173,{"inputs":[{"name":"self"}],"output":{"name":"prevtokenkind"}}],[11,"eq","","",173,{"inputs":[{"name":"self"},{"name":"prevtokenkind"}],"output":{"name":"bool"}}],[11,"to_ty","syntax::ast","",56,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"to_recovered","","",56,{"inputs":[{"name":"self"},{"generics":["qself"],"name":"option"},{"name":"path"}],"output":{"name":"self"}}],[11,"to_string","","",56,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"to_ty","","",41,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"to_recovered","","",41,{"inputs":[{"name":"self"},{"generics":["qself"],"name":"option"},{"name":"path"}],"output":{"name":"self"}}],[11,"to_string","","",41,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"to_ty","","",47,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"to_recovered","","",47,{"inputs":[{"name":"self"},{"generics":["qself"],"name":"option"},{"name":"path"}],"output":{"name":"self"}}],[11,"to_string","","",47,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"clone","syntax::parse::parser","",164,{"inputs":[{"name":"self"}],"output":{"name":"parser"}}],[11,"clone","","",165,{"inputs":[{"name":"self"}],"output":{"name":"tokencursor"}}],[11,"clone","","",166,{"inputs":[{"name":"self"}],"output":{"name":"tokencursorframe"}}],[11,"clone","","",174,{"inputs":[{"name":"self"}],"output":{"name":"lasttoken"}}],[11,"new","","",166,{"inputs":[{"name":"span"},{"name":"delimited"}],"output":{"name":"self"}}],[11,"next","","",165,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"next_desugared","","",165,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"eq","","",175,{"inputs":[{"name":"self"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"ne","","",175,{"inputs":[{"name":"self"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",175,null],[11,"clone","","",175,{"inputs":[{"name":"self"}],"output":{"name":"tokentype"}}],[11,"to_string","","",175,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"span_err","","",176,{"inputs":[{"name":"self"},{"name":"s"},{"name":"handler"}],"output":{"name":"diagnosticbuilder"}}],[11,"fmt","","",177,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",177,{"inputs":[{"generics":["thinvec"],"name":"option"}],"output":{"name":"self"}}],[11,"from","","",177,{"inputs":[{"generics":["expr"],"name":"p"}],"output":{"name":"self"}}],[11,"clone","","",178,{"inputs":[{"name":"self"}],"output":{"name":"tokenexpecttype"}}],[11,"fmt","","",178,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",178,{"inputs":[{"name":"self"},{"name":"tokenexpecttype"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",178,null],[11,"new","","",164,{"inputs":[{"name":"parsesess"},{"name":"tokenstream"},{"generics":["directory"],"name":"option"},{"name":"bool"},{"name":"bool"}],"output":{"name":"self"}}],[11,"next_tok","","",164,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"token_to_string","","Convert a token to a string using self's reader",164,{"inputs":[{"name":"token"}],"output":{"name":"string"}}],[11,"this_token_to_string","","Convert the current token to a string using self's reader",164,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"token_descr","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"option"}}],[11,"this_token_descr","","",164,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"unexpected_last","","",164,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"presult"}}],[11,"unexpected","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"expect","","Expect and consume the token t. Signal an error if the next token is not t.",164,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"presult"}}],[11,"expect_one_of","","Expect next token to be edible or inedible token.  If edible, then consume it; if inedible, then return without consuming anything.  Signal a fatal error if next token is unexpected.",164,null],[11,"interpolated_or_expr_span","","returns the span of expr, if it was not interpolated or the span of the interpolated token",164,{"inputs":[{"name":"self"},{"generics":["p"],"name":"presult"}],"output":{"name":"presult"}}],[11,"expected_ident_found","","",164,{"inputs":[{"name":"self"}],"output":{"name":"diagnosticbuilder"}}],[11,"parse_ident","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["ident"],"name":"presult"}}],[11,"parse_ident_common","","",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["ident"],"name":"presult"}}],[11,"check","","Check if the next token is `tok`, and return `true` if so.",164,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"bool"}}],[11,"eat","","Consume token 'tok' if it exists. Returns true if the given token was present, false otherwise.",164,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"bool"}}],[11,"check_keyword","","",164,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"eat_keyword","","If the next token is the given keyword, eat it and return true. Otherwise, return false.",164,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"eat_keyword_noexpect","","",164,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"expect_keyword","","If the given word is not a keyword, signal an error. If the next token is not the given word, signal an error. Otherwise, eat it.",164,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"presult"}}],[11,"check_ident","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"check_path","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"check_type","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"expect_and","","Expect and consume an `&`. If `&&` is seen, replace it with a single `&` and continue. If an `&` is not seen, signal an error.",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"expect_or","","Expect and consume an `|`. If `||` is seen, replace it with a single `|` and continue. If an `|` is not seen, signal an error.",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"expect_no_suffix","","",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"},{"generics":["name"],"name":"option"}],"output":null}],[11,"eat_lt","","Attempt to consume a `<`. If `<<` is seen, replace it with a single `<` and continue. If a `<` is not seen, return false.",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"expect_lt","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"expect_gt","","Expect and consume a GT. if a >> is seen, replace it with a single > and continue. If a GT is not seen, signal an error.",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_seq_to_before_gt_or_return","","",164,{"inputs":[{"name":"self"},{"generics":["token"],"name":"option"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq_to_before_gt","","Parse a sequence bracketed by '<' and '>', stopping before the '>'.",164,{"inputs":[{"name":"self"},{"generics":["token"],"name":"option"},{"name":"f"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_seq_to_gt","","",164,{"inputs":[{"name":"self"},{"generics":["token"],"name":"option"},{"name":"f"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_seq_to_gt_or_return","","",164,{"inputs":[{"name":"self"},{"generics":["token"],"name":"option"},{"name":"f"}],"output":{"name":"presult"}}],[11,"eat_to_tokens","","Eat and discard tokens until one of `kets` is encountered. Respects token trees, passes through any errors encountered. Used for error recovery.",164,null],[11,"parse_seq_to_end","","Parse a sequence, including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",164,{"inputs":[{"name":"self"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_seq_to_before_end","","Parse a sequence, not including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",164,{"inputs":[{"name":"self"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_seq_to_before_tokens","","",164,null],[11,"parse_unspanned_seq","","Parse a sequence, including the closing delimiter. The function f must consume tokens until reaching the next separator or closing bracket.",164,{"inputs":[{"name":"self"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_seq","","",164,{"inputs":[{"name":"self"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"generics":["spanned"],"name":"presult"}}],[11,"bump","","Advance the parser by one token",164,{"inputs":[{"name":"self"}],"output":null}],[11,"bump_with","","Advance the parser using provided token as a next one. Use this when consuming a part of a token. For example a single `<` from `<<`.",164,{"inputs":[{"name":"self"},{"name":"token"},{"name":"span"}],"output":null}],[11,"look_ahead","","",164,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[11,"look_ahead_span","","",164,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"span"}}],[11,"fatal","","",164,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_fatal","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_fatal_err","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"error"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_fatal_help","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"bug","","",164,null],[11,"warn","","",164,{"inputs":[{"name":"self"},{"name":"str"}],"output":null}],[11,"span_warn","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_err","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"struct_span_err","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_err_help","","",164,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"str"}],"output":null}],[11,"span_bug","","",164,null],[11,"abort_if_errors","","",164,{"inputs":[{"name":"self"}],"output":null}],[11,"cancel","","",164,{"inputs":[{"name":"self"},{"name":"diagnosticbuilder"}],"output":null}],[11,"diagnostic","","",164,{"inputs":[{"name":"self"}],"output":{"name":"handler"}}],[11,"token_is_bare_fn_keyword","","Is the current token one of the keywords that signals a bare function type?",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_ty_bare_fn","","parse a TyKind::BareFn type:",164,{"inputs":[{"name":"self"},{"generics":["genericparam"],"name":"vec"}],"output":{"generics":["tykind"],"name":"presult"}}],[11,"parse_unsafety","","Parse unsafety: `unsafe` or nothing.",164,{"inputs":[{"name":"self"}],"output":{"name":"unsafety"}}],[11,"parse_trait_item","","Parse the items in a trait declaration",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["traititem"],"name":"presult"}}],[11,"parse_trait_item_","","",164,{"inputs":[{"name":"self"},{"name":"bool"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["traititem"],"name":"presult"}}],[11,"parse_ret_ty","","Parse optional return type [ -> TY ] in function decl",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["functionretty"],"name":"presult"}}],[11,"parse_ty","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_ty_no_plus","","Parse a type in restricted contexts where `+` is not permitted. Example 1: `&'a TYPE`     `+` is prohibited to maintain operator priority (P(+) < P(&)). Example 2: `value1 as TYPE + value2`     `+` is prohibited to avoid interactions with expression grammar.",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_ty_common","","",164,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"bool"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_remaining_bounds","","",164,{"inputs":[{"name":"self"},{"generics":["genericparam"],"name":"vec"},{"name":"path"},{"name":"span"},{"name":"bool"}],"output":{"generics":["tykind"],"name":"presult"}}],[11,"maybe_report_ambiguous_plus","","",164,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"bool"},{"name":"ty"}],"output":null}],[11,"maybe_recover_from_bad_type_plus","","",164,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"ty"}],"output":{"name":"presult"}}],[11,"maybe_recover_from_bad_qpath","","",164,{"inputs":[{"name":"self"},{"name":"t"},{"name":"bool"}],"output":{"name":"presult"}}],[11,"parse_borrowed_pointee","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["tykind"],"name":"presult"}}],[11,"parse_ptr","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["mutty"],"name":"presult"}}],[11,"is_named_argument","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_arg_general","","This version of parse arg doesn't necessarily require identifier names.",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["arg"],"name":"presult"}}],[11,"parse_arg","","Parse a single function argument",164,{"inputs":[{"name":"self"}],"output":{"generics":["arg"],"name":"presult"}}],[11,"parse_fn_block_arg","","Parse an argument in a lambda header e.g. |arg, arg|",164,{"inputs":[{"name":"self"}],"output":{"generics":["arg"],"name":"presult"}}],[11,"maybe_parse_fixed_length_of_vec","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_lit_token","","Matches token_lit = LIT_INTEGER | ...",164,{"inputs":[{"name":"self"}],"output":{"generics":["litkind"],"name":"presult"}}],[11,"parse_lit","","Matches lit = true | false | token_lit",164,{"inputs":[{"name":"self"}],"output":{"generics":["lit"],"name":"presult"}}],[11,"parse_pat_literal_maybe_minus","","matches '-' lit | lit (cf. ast_validation::AstValidator::check_expr_within_pat)",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_path_segment_ident","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["ident"],"name":"presult"}}],[11,"parse_qpath","","Parses qualified path. Assumes that the leading `<` has been parsed already.",164,{"inputs":[{"name":"self"},{"name":"pathstyle"}],"output":{"name":"presult"}}],[11,"parse_path","","Parses simple paths.",164,{"inputs":[{"name":"self"},{"name":"pathstyle"}],"output":{"generics":["path"],"name":"presult"}}],[11,"parse_path_common","","",164,{"inputs":[{"name":"self"},{"name":"pathstyle"},{"name":"bool"}],"output":{"generics":["path"],"name":"presult"}}],[11,"parse_path_allowing_meta","","Like `parse_path`, but also supports parsing `Word` meta items into paths for back-compat. This is used when parsing derive macro paths in `#[derive]` attributes.",164,{"inputs":[{"name":"self"},{"name":"pathstyle"}],"output":{"generics":["path"],"name":"presult"}}],[11,"parse_path_segments","","",164,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"pathstyle"},{"name":"bool"}],"output":{"name":"presult"}}],[11,"parse_path_segment","","",164,{"inputs":[{"name":"self"},{"name":"pathstyle"},{"name":"bool"}],"output":{"generics":["pathsegment"],"name":"presult"}}],[11,"check_lifetime","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"expect_lifetime","","Parse single lifetime 'a or panic.",164,{"inputs":[{"name":"self"}],"output":{"name":"lifetime"}}],[11,"eat_label","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["label"],"name":"option"}}],[11,"parse_mutability","","Parse mutability (`mut` or nothing).",164,{"inputs":[{"name":"self"}],"output":{"name":"mutability"}}],[11,"parse_field_name","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["ident"],"name":"presult"}}],[11,"parse_field","","Parse ident (COLON expr)?",164,{"inputs":[{"name":"self"}],"output":{"generics":["field"],"name":"presult"}}],[11,"mk_expr","","",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"exprkind"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"mk_unary","","",164,{"inputs":[{"name":"self"},{"name":"unop"},{"generics":["expr"],"name":"p"}],"output":{"name":"exprkind"}}],[11,"mk_binary","","",164,{"inputs":[{"name":"self"},{"name":"binop"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"name":"exprkind"}}],[11,"mk_call","","",164,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"},{"generics":["p"],"name":"vec"}],"output":{"name":"exprkind"}}],[11,"mk_index","","",164,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"name":"exprkind"}}],[11,"mk_range","","",164,{"inputs":[{"name":"self"},{"generics":["p"],"name":"option"},{"generics":["p"],"name":"option"},{"name":"rangelimits"}],"output":{"generics":["exprkind"],"name":"presult"}}],[11,"mk_assign_op","","",164,{"inputs":[{"name":"self"},{"name":"binop"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"name":"exprkind"}}],[11,"mk_mac_expr","","",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"mac_"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"mk_lit_u32","","",164,{"inputs":[{"name":"self"},{"name":"u32"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expect_delimited_token_tree","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_bottom_expr","","At the bottom (top?) of the precedence hierarchy, parse things like parenthesized exprs, macros, return, etc.",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_struct_expr","","",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_or_use_outer_attributes","","",164,{"inputs":[{"name":"self"},{"generics":["thinvec"],"name":"option"}],"output":{"generics":["thinvec"],"name":"presult"}}],[11,"parse_block_expr","","Parse a block or unsafe block",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"blockcheckmode"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_dot_or_call_expr","","parse a.b or a(13) or a[4] or just a",164,{"inputs":[{"name":"self"},{"generics":["thinvec"],"name":"option"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_dot_or_call_expr_with","","",164,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_dot_suffix","","",164,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"},{"name":"span"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_dot_or_call_expr_with_","","",164,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"},{"name":"span"}],"output":{"generics":["p"],"name":"presult"}}],[11,"process_potential_macro_variable","","",164,{"inputs":[{"name":"self"}],"output":null}],[11,"parse_token_tree","","parse a single token tree from the input.",164,{"inputs":[{"name":"self"}],"output":{"name":"tokentree"}}],[11,"parse_all_token_trees","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_tokens","","",164,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"parse_prefix_expr","","Parse a prefix-unary-operator expr",164,{"inputs":[{"name":"self"},{"generics":["thinvec"],"name":"option"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_assoc_expr","","Parse an associative expression",164,{"inputs":[{"name":"self"},{"generics":["thinvec"],"name":"option"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_assoc_expr_with","","Parse an associative expression with operators of at least `min_prec` precedence",164,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"lhsexpr"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_assoc_op_cast","","",164,null],[11,"check_no_chained_comparison","","Produce an error if comparison operators are chained (RFC #558). We only need to check lhs, not rhs, because all comparison ops have same precedence and are left-associative",164,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"assocop"}],"output":null}],[11,"parse_prefix_range_expr","","Parse prefix-forms of range notation: `..expr`, `..`, `..=expr`",164,{"inputs":[{"name":"self"},{"generics":["thinvec"],"name":"option"}],"output":{"generics":["p"],"name":"presult"}}],[11,"is_at_start_of_range_notation_rhs","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_if_expr","","Parse an 'if' or 'if let' expression ('if' token already eaten)",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_if_let_expr","","Parse an 'if let' expression ('if' token already eaten)",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_lambda_expr","","",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_else_expr","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_for_expr","","Parse a 'for' .. 'in' expression ('for' token already eaten)",164,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_while_expr","","Parse a 'while' or 'while let' expression ('while' token already eaten)",164,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_while_let_expr","","Parse a 'while let' expression ('while' token already eaten)",164,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_loop_expr","","",164,{"inputs":[{"name":"self"},{"generics":["label"],"name":"option"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_catch_expr","","Parse a `do catch {...}` expression (`do catch` token already eaten)",164,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_match_expr","","",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_arm","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["arm"],"name":"presult"}}],[11,"parse_expr","","Parse an expression",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"with_res","","Evaluate the closure with restrictions in place.",164,{"inputs":[{"name":"self"},{"name":"restrictions"},{"name":"f"}],"output":{"name":"t"}}],[11,"parse_expr_res","","Parse an expression, subject to the given restrictions",164,{"inputs":[{"name":"self"},{"name":"restrictions"},{"generics":["thinvec"],"name":"option"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_initializer","","Parse the RHS of a local variable declaration (e.g. '= 14;')",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_pats","","Parse patterns, separated by '|' s",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_parenthesized_pat_list","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_pat_list","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_pat_vec_elements","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_pat_fields","","Parse the fields of a struct-like pattern",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_pat_range_end","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_as_ident","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_top_level_pat","","A wrapper around `parse_pat` with some special error handling for the \"top-level\" patterns in a match arm, `for` loop, `let`, &c. (in contast to subpatterns within such).",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_pat","","Parse a pattern.",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_pat_with_range_pat","","Parse a pattern, with a setting whether modern range patterns e.g. `a..=b`, `a..b` are allowed.",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_pat_ident","","Parse ident or ident @ pat used by the copy foo and ref foo patterns to give a good error message when parsing mistakes like ref foo(a,b)",164,{"inputs":[{"name":"self"},{"name":"bindingmode"}],"output":{"generics":["patkind"],"name":"presult"}}],[11,"parse_local","","Parse a local variable declaration",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"thinvec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_name_and_ty","","Parse a structure field",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["structfield"],"name":"presult"}}],[11,"expected_item_err","","Emit an expected item after attributes error.",164,null],[11,"parse_stmt","","Parse a statement. This stops just before trailing semicolons on everything but items. e.g. a `StmtKind::Semi` parses to a `StmtKind::Expr`, leaving the trailing `;` unconsumed.",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"recover_stmt","","",164,{"inputs":[{"name":"self"}],"output":null}],[11,"recover_stmt_","","",164,{"inputs":[{"name":"self"},{"name":"semicolonmode"},{"name":"blockmode"}],"output":null}],[11,"parse_stmt_","","",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["stmt"],"name":"option"}}],[11,"is_catch_expr","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_union_item","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_crate_vis","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_extern_non_path","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_auto_trait_item","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"eat_macro_def","","",164,null],[11,"parse_stmt_without_recovery","","",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["option"],"name":"presult"}}],[11,"expr_is_complete","","Is this expression a successfully-parsed statement?",164,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"parse_block","","Parse a block. No inner attrs are allowed.",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_inner_attrs_and_block","","Parse a block. Inner attrs are allowed.",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_block_tail","","Parse the rest of a block expression or function body Precondition: already parsed the '{'.",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"blockcheckmode"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_full_stmt","","Parse a statement, including the trailing semicolon.",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["option"],"name":"presult"}}],[11,"warn_missing_semicolon","","",164,{"inputs":[{"name":"self"}],"output":null}],[11,"err_dotdotdot_syntax","","",164,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"parse_ty_param_bounds_common","","",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["typarambounds"],"name":"presult"}}],[11,"parse_ty_param_bounds","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["typarambounds"],"name":"presult"}}],[11,"parse_lt_param_bounds","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["lifetime"],"name":"vec"}}],[11,"parse_ty_param","","Matches typaram = IDENT (`?` unbound)? optbounds ( EQ ty )?",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["typaram"],"name":"presult"}}],[11,"parse_trait_item_assoc_ty","","Parses the following grammar: TraitItemAssocTy = Ident [\"<\"...\">\"] [\":\" [TyParamBounds]] [\"where\" ...] [\"=\" Ty]",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"vec"}],"output":{"name":"presult"}}],[11,"parse_generic_params","","Parses (possibly empty) list of lifetime and type parameters, possibly including trailing comma and erroneous trailing attributes.",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_generics","","Parse a set of optional generic type parameter declarations. Where clauses are not parsed here, and must be added later via `parse_where_clause()`.",164,{"inputs":[{"name":"self"}],"output":{"generics":["generics"],"name":"presult"}}],[11,"parse_generic_args","","Parses (possibly empty) list of lifetime and type arguments and associated type bindings, possibly including trailing comma.",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_where_clause","","Parses an optional `where` clause and places it in `generics`.",164,{"inputs":[{"name":"self"}],"output":{"generics":["whereclause"],"name":"presult"}}],[11,"parse_fn_args","","",164,{"inputs":[{"name":"self"},{"name":"bool"},{"name":"bool"}],"output":{"name":"presult"}}],[11,"parse_fn_decl","","Parse the argument list and result type of a function declaration",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_self_arg","","Returns the parsed optional self argument and whether a self shortcut was used.",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_fn_decl_with_self","","Parse the parameter list and result type of a function that may have a `self` parameter.",164,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_fn_block_decl","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_fn_header","","Parse the name and optional generic types of a function header.",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"mk_item","","",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"itemkind"},{"name":"visibility"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["item"],"name":"p"}}],[11,"parse_item_fn","","Parse an item-position function declaration.",164,{"inputs":[{"name":"self"},{"name":"unsafety"},{"generics":["constness"],"name":"spanned"},{"name":"abi"}],"output":{"name":"presult"}}],[11,"is_const_item","","true if we are looking at `const ID`, false for things like `const fn` etc",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_fn_front_matter","","parses all the \"front matter\" for a `fn` declaration, up to and including the `fn` keyword:",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_impl_item","","Parse an impl item.",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["implitem"],"name":"presult"}}],[11,"parse_impl_item_","","",164,{"inputs":[{"name":"self"},{"name":"bool"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["implitem"],"name":"presult"}}],[11,"complain_if_pub_macro","","",164,{"inputs":[{"name":"self"},{"name":"visibilitykind"},{"name":"span"}],"output":null}],[11,"complain_if_pub_macro_diag","","",164,{"inputs":[{"name":"self"},{"name":"visibilitykind"},{"name":"span"}],"output":{"name":"presult"}}],[11,"missing_assoc_item_kind_err","","",164,{"inputs":[{"name":"self"},{"name":"str"},{"name":"span"}],"output":{"name":"diagnosticbuilder"}}],[11,"parse_impl_method","","Parse a method or a macro invocation in a trait impl.",164,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"bool"}],"output":{"name":"presult"}}],[11,"parse_item_trait","","Parse `trait Foo { ... }` or `trait Foo = Bar;`",164,{"inputs":[{"name":"self"},{"name":"isauto"},{"name":"unsafety"}],"output":{"name":"presult"}}],[11,"choose_generics_over_qpath","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_impl_body","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_item_impl","","Parses an implementation item, `impl` keyword is already parsed.    impl<'a, T> TYPE { /* impl items / }    impl<'a, T> TRAIT for TYPE { / impl items / }    impl<'a, T> !TRAIT for TYPE { / impl items */ } We actually parse slightly more relaxed grammar for better error reporting and recovery.     `impl` GENERICS `!`? TYPE `for`? (TYPE | `..`) (`where` PREDICATES)? `{` BODY `}`     `impl` GENERICS `!`? TYPE (`where` PREDICATES)? `{` BODY `}`",164,{"inputs":[{"name":"self"},{"name":"unsafety"},{"name":"defaultness"}],"output":{"name":"presult"}}],[11,"parse_late_bound_lifetime_defs","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_item_struct","","Parse struct Foo { ... }",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_item_union","","Parse union Foo { ... }",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"consume_block","","",164,{"inputs":[{"name":"self"},{"name":"delimtoken"}],"output":null}],[11,"parse_record_struct_body","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_tuple_struct_body","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_single_struct_field","","Parse a structure field declaration",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["structfield"],"name":"presult"}}],[11,"parse_struct_decl_field","","Parse an element of a struct definition",164,{"inputs":[{"name":"self"}],"output":{"generics":["structfield"],"name":"presult"}}],[11,"parse_visibility","","Parse `pub`, `pub(crate)` and `pub(in path)` plus shortcuts `pub(self)` for `pub(in self)` and `pub(super)` for `pub(in super)`.  If the following element can't be a tuple (i.e. it's a function definition, it's not a tuple struct field) and the contents within the parens isn't valid, emit a proper diagnostic.",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["visibility"],"name":"presult"}}],[11,"parse_defaultness","","Parse defaultness: `default` or nothing.",164,{"inputs":[{"name":"self"}],"output":{"name":"defaultness"}}],[11,"parse_mod_items","","Given a termination token, parse all of the items in a module",164,{"inputs":[{"name":"self"},{"name":"token"},{"name":"span"}],"output":{"generics":["mod"],"name":"presult"}}],[11,"parse_item_const","","",164,{"inputs":[{"name":"self"},{"generics":["mutability"],"name":"option"}],"output":{"name":"presult"}}],[11,"parse_item_mod","","Parse a `mod <foo> { ... }` or `mod <foo>;` item",164,null],[11,"push_directory","","",164,null],[11,"submod_path_from_attr","","",164,null],[11,"default_submod_path","","Returns either a path to a module, or .",164,{"inputs":[{"name":"ident"},{"generics":["ident"],"name":"option"},{"name":"path"},{"name":"codemap"}],"output":{"name":"modulepath"}}],[11,"submod_path","","",164,null],[11,"eval_src_mod","","Read a module from a source file.",164,{"inputs":[{"name":"self"},{"name":"pathbuf"},{"name":"directoryownership"},{"name":"string"},{"name":"span"}],"output":{"name":"presult"}}],[11,"parse_item_foreign_fn","","Parse a function declaration from a foreign module",164,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"span"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["foreignitem"],"name":"presult"}}],[11,"parse_item_foreign_static","","Parse a static item from a foreign module. Assumes that the `static` keyword is already parsed.",164,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"span"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["foreignitem"],"name":"presult"}}],[11,"parse_item_foreign_type","","Parse a type from a foreign module",164,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"span"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["foreignitem"],"name":"presult"}}],[11,"parse_item_extern_crate","","Parse extern crate links",164,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_item_foreign_mod","","Parse `extern` for foreign ABIs modules.",164,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["abi"],"name":"option"},{"name":"visibility"},{"generics":["attribute"],"name":"vec"}],"output":{"generics":["p"],"name":"presult"}}],[11,"parse_item_type","","Parse type Foo = Bar;",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_enum_def","","Parse the part of an \"enum\" decl following the '{'",164,{"inputs":[{"name":"self"},{"name":"generics"}],"output":{"generics":["enumdef"],"name":"presult"}}],[11,"parse_item_enum","","Parse an \"enum\" declaration",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_opt_abi","","Parses a string as an ABI spec on an extern type or module. Consumes the `extern` keyword, if one is found.",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"is_static_global","","",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_item_","","Parse one of the items allowed by the flags. NB: this function no longer parses the items inside an extern crate.",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"vec"},{"name":"bool"},{"name":"bool"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_foreign_item","","Parse a foreign item.",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_macro_use_or_failure","","This is the fall-through for parsing items.",164,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"vec"},{"name":"bool"},{"name":"bool"},{"name":"span"},{"name":"visibility"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_assoc_macro_invoc","","Parse a macro invocation inside a `trait`, `impl` or `extern` block",164,{"inputs":[{"name":"self"},{"name":"str"},{"generics":["visibility"],"name":"option"},{"name":"bool"}],"output":{"generics":["option"],"name":"presult"}}],[11,"collect_tokens","","",164,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_item","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"is_import_coupler","","`::{` or `::*`",164,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"parse_use_tree","","Parse UseTree",164,{"inputs":[{"name":"self"}],"output":{"generics":["usetree"],"name":"presult"}}],[11,"parse_use_tree_list","","Parse UseTreeKind::Nested(list)",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_rename","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["option"],"name":"presult"}}],[11,"parse_crate_mod","","Parses a source module as a crate. This is the main entry point for the parser.",164,{"inputs":[{"name":"self"}],"output":{"generics":["crate"],"name":"presult"}}],[11,"parse_optional_str","","",164,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"parse_str","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[0,"lexer","syntax::parse","",null,null],[3,"TokenAndSpan","syntax::parse::lexer","",null,null],[12,"tok","","",180,null],[12,"sp","","",180,null],[3,"StringReader","","",null,null],[12,"sess","","",181,null],[12,"next_pos","","The absolute offset within the codemap of the next character to read",181,null],[12,"pos","","The absolute offset within the codemap of the current character",181,null],[12,"col","","The column of the next character to read",181,null],[12,"ch","","The current character (which has been read from self.pos)",181,null],[12,"filemap","","",181,null],[12,"terminator","","If Some, stop reading the source at this position (inclusive).",181,null],[12,"save_new_lines_and_multibyte","","Whether to record new-lines and multibyte chars in filemap. This is only necessary the first time a filemap is lexed. If part of a filemap is being re-lexed, this should be set to false.",181,null],[12,"peek_tok","","",181,null],[12,"peek_span","","",181,null],[12,"fatal_errs","","",181,null],[12,"source_text","","",181,null],[12,"token","","Stack of open delimiters and their spans. Used for error message.",181,null],[12,"span","","",181,null],[12,"open_braces","","",181,null],[12,"override_span","","",181,null],[5,"is_pattern_whitespace","","",null,{"inputs":[{"generics":["char"],"name":"option"}],"output":{"name":"bool"}}],[5,"in_range","","",null,{"inputs":[{"generics":["char"],"name":"option"},{"name":"char"},{"name":"char"}],"output":{"name":"bool"}}],[5,"is_dec_digit","","",null,{"inputs":[{"generics":["char"],"name":"option"}],"output":{"name":"bool"}}],[5,"is_doc_comment","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"is_block_doc_comment","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"ident_start","","",null,{"inputs":[{"generics":["char"],"name":"option"}],"output":{"name":"bool"}}],[5,"ident_continue","","",null,{"inputs":[{"generics":["char"],"name":"option"}],"output":{"name":"bool"}}],[0,"comments","","",null,null],[3,"Comment","syntax::parse::lexer::comments","",null,null],[12,"style","","",182,null],[12,"lines","","",182,null],[12,"pos","","",182,null],[3,"Literal","","",null,null],[12,"lit","","",183,null],[12,"pos","","",183,null],[4,"CommentStyle","","",null,null],[13,"Isolated","","No code on either side of each line of the comment",184,null],[13,"Trailing","","Code exists to the left of the comment",184,null],[13,"Mixed","","Code before /* foo */ and after the comment",184,null],[13,"BlankLine","","Just a manual blank line \"\\n\\n\", for layout",184,null],[5,"is_doc_comment","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"doc_comment_style","","",null,{"inputs":[{"name":"str"}],"output":{"name":"attrstyle"}}],[5,"strip_doc_comment_decoration","","",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"push_blank_line_comment","","",null,{"inputs":[{"name":"stringreader"},{"name":"vec"}],"output":null}],[5,"consume_whitespace_counting_blank_lines","","",null,{"inputs":[{"name":"stringreader"},{"name":"vec"}],"output":null}],[5,"read_shebang_comment","","",null,{"inputs":[{"name":"stringreader"},{"name":"bool"},{"name":"vec"}],"output":null}],[5,"read_line_comments","","",null,{"inputs":[{"name":"stringreader"},{"name":"bool"},{"name":"vec"}],"output":null}],[5,"all_whitespace","","Returns None if the first col chars of s contain a non-whitespace char. Otherwise returns Some(k) where k is first char offset after that leading whitespace.  Note k may be outside bounds of s.",null,{"inputs":[{"name":"str"},{"name":"charpos"}],"output":{"generics":["usize"],"name":"option"}}],[5,"trim_whitespace_prefix_and_push_line","","",null,{"inputs":[{"name":"vec"},{"name":"string"},{"name":"charpos"}],"output":null}],[5,"read_block_comment","","",null,{"inputs":[{"name":"stringreader"},{"name":"bool"},{"name":"vec"}],"output":null}],[5,"consume_comment","","",null,{"inputs":[{"name":"stringreader"},{"name":"vec"},{"name":"bool"},{"name":"bool"}],"output":null}],[5,"gather_comments_and_literals","","",null,null],[11,"clone","","",184,{"inputs":[{"name":"self"}],"output":{"name":"commentstyle"}}],[11,"eq","","",184,{"inputs":[{"name":"self"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"fmt","","",184,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",182,{"inputs":[{"name":"self"}],"output":{"name":"comment"}}],[11,"clone","","",183,{"inputs":[{"name":"self"}],"output":{"name":"literal"}}],[0,"tokentrees","syntax::parse::lexer","",null,null],[11,"parse_all_token_trees","","",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokenstream"],"name":"presult"}}],[11,"parse_token_trees_until_close_delim","","",181,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"parse_token_tree","","",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokentree"],"name":"presult"}}],[0,"unicode_chars","","",null,null],[5,"check_for_substitution","syntax::parse::lexer::unicode_chars","",null,{"inputs":[{"name":"stringreader"},{"name":"char"},{"name":"diagnosticbuilder"}],"output":null}],[17,"UNICODE_ARRAY","","",null,null],[17,"ASCII_ARRAY","","",null,null],[11,"clone","syntax::parse::lexer","",180,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"eq","","",180,{"inputs":[{"name":"self"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"ne","","",180,{"inputs":[{"name":"self"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",180,null],[11,"fmt","","",180,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",180,{"inputs":[],"output":{"name":"self"}}],[11,"mk_sp","","",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"mk_ident","","",181,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"ident"}}],[11,"next_token","","",181,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"unwrap_or_abort","","",181,{"inputs":[{"name":"self"},{"generics":["tokenandspan"],"name":"result"}],"output":{"name":"tokenandspan"}}],[11,"try_real_token","","",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokenandspan"],"name":"result"}}],[11,"real_token","","",181,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"is_eof","","",181,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"try_next_token","","Return the next token. EFFECT: advances the string_reader.",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokenandspan"],"name":"result"}}],[11,"fail_unterminated_raw_string","","",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"u16"}],"output":null}],[11,"fatal","","",181,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"emit_fatal_errors","","",181,{"inputs":[{"name":"self"}],"output":null}],[11,"peek","","",181,{"inputs":[{"name":"self"}],"output":{"name":"tokenandspan"}}],[11,"new_raw","","For comments.rs, which hackily pokes into next_pos and ch",181,{"inputs":[{"name":"parsesess"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"self"}}],[11,"new_raw_internal","","",181,{"inputs":[{"name":"parsesess"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"self"}}],[11,"new","","",181,{"inputs":[{"name":"parsesess"},{"generics":["filemap"],"name":"lrc"}],"output":{"name":"self"}}],[11,"retokenize","","",181,{"inputs":[{"name":"parsesess"},{"name":"span"}],"output":{"name":"self"}}],[11,"ch_is","","",181,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"bool"}}],[11,"fatal_span","","Report a fatal lexical error with a given span.",181,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"err_span","","Report a lexical error with a given span.",181,{"inputs":[{"name":"self"},{"name":"span"},{"name":"str"}],"output":null}],[11,"fatal_span_","","Report a fatal error spanning [`from_pos`, `to_pos`).",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"err_span_","","Report a lexical error spanning [`from_pos`, `to_pos`).",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"}],"output":null}],[11,"push_escaped_char_for_msg","","Pushes a character to a message string for error reporting",181,{"inputs":[{"name":"string"},{"name":"char"}],"output":null}],[11,"fatal_span_char","","Report a lexical error spanning [`from_pos`, `to_pos`), appending an escaped character to the error message",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"},{"name":"char"}],"output":{"name":"fatalerror"}}],[11,"struct_span_fatal","","",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_fatal_span_char","","",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"},{"name":"char"}],"output":{"name":"diagnosticbuilder"}}],[11,"err_span_char","","Report a lexical error spanning [`from_pos`, `to_pos`), appending an escaped character to the error message",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"},{"name":"char"}],"output":null}],[11,"struct_err_span_char","","",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"str"},{"name":"char"}],"output":{"name":"diagnosticbuilder"}}],[11,"fatal_span_verbose","","Report a lexical error spanning [`from_pos`, `to_pos`), appending the offending string to the error message",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"string"}],"output":{"name":"fatalerror"}}],[11,"advance_token","","Advance peek_tok and peek_span to refer to the next token, and possibly update the interner.",181,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"byte_offset","","",181,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"with_str_from","","Calls `f` with a string slice of the source text spanning from `start` up to but excluding `self.pos`, meaning the slice does not include the character `self.ch`.",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"f"}],"output":{"name":"t"}}],[11,"name_from","","Create a Name from a given offset to the current offset, each adjusted 1 towards each other (assumes that on either side there is a single-byte delimiter).",181,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"name_from_to","","As name_from, with an explicit endpoint.",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"with_str_from_to","","Calls `f` with a string slice of the source text spanning from `start` up to but excluding `end`.",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"f"}],"output":{"name":"t"}}],[11,"translate_crlf","","Converts CRLF to LF in the given string, raising an error on bare CR.",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"str"},{"name":"str"}],"output":{"generics":["str"],"name":"cow"}}],[11,"bump","","Advance the StringReader by one character. If a newline is discovered, add it to the FileMap's list of line start offsets.",181,{"inputs":[{"name":"self"}],"output":null}],[11,"nextch","","",181,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"option"}}],[11,"nextch_is","","",181,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"bool"}}],[11,"nextnextch","","",181,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"option"}}],[11,"nextnextch_is","","",181,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"bool"}}],[11,"scan_optional_raw_name","","Eats <XID_start><XID_continue>*, if possible.",181,{"inputs":[{"name":"self"}],"output":{"generics":["name"],"name":"option"}}],[11,"scan_comment","","PRECONDITION: self.ch is not whitespace Eats any kind of comment.",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokenandspan"],"name":"option"}}],[11,"scan_whitespace_or_comment","","If there is whitespace, shebang, or a comment, scan it. Otherwise, return None.",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokenandspan"],"name":"option"}}],[11,"scan_block_comment","","Might return a sugared-doc-attr",181,{"inputs":[{"name":"self"}],"output":{"generics":["tokenandspan"],"name":"option"}}],[11,"scan_digits","","Scan through any digits (base `scan_radix`) or underscores, and return how many digits there were.",181,{"inputs":[{"name":"self"},{"name":"u32"},{"name":"u32"}],"output":{"name":"usize"}}],[11,"scan_number","","Lex a LIT_INTEGER or a LIT_FLOAT",181,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"lit"}}],[11,"scan_hex_digits","","Scan over `n_digits` hex digits, stopping at `delim`, reporting an error if too many or too few digits are encountered.",181,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"char"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"scan_char_or_byte","","Scan for a single (possibly escaped) byte or char in a byte, (non-raw) byte string, char, or (non-raw) string literal. `start` is the position of `first_source_char`, which is already consumed.",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"char"},{"name":"bool"},{"name":"char"}],"output":{"name":"bool"}}],[11,"scan_unicode_escape","","Scan over a `\\u{...}` escape",181,{"inputs":[{"name":"self"},{"name":"char"}],"output":{"name":"bool"}}],[11,"scan_float_exponent","","Scan over a float exponent.",181,{"inputs":[{"name":"self"}],"output":null}],[11,"check_float_base","","Check that a base is valid for a floating literal, emitting a nice error if it isn't.",181,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"bytepos"},{"name":"usize"}],"output":null}],[11,"binop","","",181,{"inputs":[{"name":"self"},{"name":"binoptoken"}],"output":{"name":"token"}}],[11,"next_token_inner","","Return the next token from the string, advances the input past that token, and updates the interner",181,{"inputs":[{"name":"self"}],"output":{"generics":["token"],"name":"result"}}],[11,"consume_whitespace","","",181,{"inputs":[{"name":"self"}],"output":null}],[11,"read_to_eol","","",181,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"read_one_line_comment","","",181,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"consume_non_eol_whitespace","","",181,{"inputs":[{"name":"self"}],"output":null}],[11,"peeking_at_comment","","",181,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"scan_byte","","",181,{"inputs":[{"name":"self"}],"output":{"name":"lit"}}],[11,"scan_byte_escape","","",181,{"inputs":[{"name":"self"},{"name":"char"},{"name":"bool"}],"output":{"name":"bool"}}],[11,"scan_byte_string","","",181,{"inputs":[{"name":"self"}],"output":{"name":"lit"}}],[11,"scan_raw_byte_string","","",181,{"inputs":[{"name":"self"}],"output":{"name":"lit"}}],[0,"token","syntax::parse","",null,null],[3,"LazyTokenStream","syntax::parse::token","",null,null],[12,"0","","",185,null],[4,"BinOpToken","","",null,null],[13,"Plus","","",186,null],[13,"Minus","","",186,null],[13,"Star","","",186,null],[13,"Slash","","",186,null],[13,"Percent","","",186,null],[13,"Caret","","",186,null],[13,"And","","",186,null],[13,"Or","","",186,null],[13,"Shl","","",186,null],[13,"Shr","","",186,null],[4,"DelimToken","","A delimiter token",null,null],[13,"Paren","","A round parenthesis: `(` or `)`",187,null],[13,"Bracket","","A square bracket: `[` or `]`",187,null],[13,"Brace","","A curly brace: `{` or `}`",187,null],[13,"NoDelim","","An empty delimiter",187,null],[4,"Lit","","",null,null],[13,"Byte","","",188,null],[13,"Char","","",188,null],[13,"Integer","","",188,null],[13,"Float","","",188,null],[13,"Str_","","",188,null],[13,"StrRaw","","",188,null],[13,"ByteStr","","",188,null],[13,"ByteStrRaw","","",188,null],[4,"Token","","",null,null],[13,"Eq","","",189,null],[13,"Lt","","",189,null],[13,"Le","","",189,null],[13,"EqEq","","",189,null],[13,"Ne","","",189,null],[13,"Ge","","",189,null],[13,"Gt","","",189,null],[13,"AndAnd","","",189,null],[13,"OrOr","","",189,null],[13,"Not","","",189,null],[13,"Tilde","","",189,null],[13,"BinOp","","",189,null],[13,"BinOpEq","","",189,null],[13,"At","","",189,null],[13,"Dot","","",189,null],[13,"DotDot","","",189,null],[13,"DotDotDot","","",189,null],[13,"DotDotEq","","",189,null],[13,"DotEq","","",189,null],[13,"Comma","","",189,null],[13,"Semi","","",189,null],[13,"Colon","","",189,null],[13,"ModSep","","",189,null],[13,"RArrow","","",189,null],[13,"LArrow","","",189,null],[13,"FatArrow","","",189,null],[13,"Pound","","",189,null],[13,"Dollar","","",189,null],[13,"Question","","",189,null],[13,"OpenDelim","","An opening delimiter, eg. `{`",189,null],[13,"CloseDelim","","A closing delimiter, eg. `}`",189,null],[13,"Literal","","",189,null],[13,"Ident","","",189,null],[13,"Lifetime","","",189,null],[13,"Interpolated","","",189,null],[13,"DocComment","","Doc comment",189,null],[13,"Whitespace","","Whitespace",189,null],[13,"Comment","","Comment",189,null],[13,"Shebang","","",189,null],[13,"Eof","","",189,null],[4,"Nonterminal","","For interpolation during macro expansion.",null,null],[13,"NtItem","","",190,null],[13,"NtBlock","","",190,null],[13,"NtStmt","","",190,null],[13,"NtPat","","",190,null],[13,"NtExpr","","",190,null],[13,"NtTy","","",190,null],[13,"NtIdent","","",190,null],[13,"NtLifetime","","",190,null],[13,"NtMeta","","Stuff inside brackets for attributes",190,null],[13,"NtPath","","",190,null],[13,"NtVis","","",190,null],[13,"NtTT","","",190,null],[13,"NtArm","","",190,null],[13,"NtImplItem","","",190,null],[13,"NtTraitItem","","",190,null],[13,"NtForeignItem","","",190,null],[13,"NtGenerics","","",190,null],[13,"NtWhereClause","","",190,null],[13,"NtArg","","",190,null],[5,"ident_can_begin_expr","","",null,{"inputs":[{"name":"ident"},{"name":"bool"}],"output":{"name":"bool"}}],[5,"ident_can_begin_type","","",null,{"inputs":[{"name":"ident"},{"name":"bool"}],"output":{"name":"bool"}}],[5,"is_path_segment_keyword","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"bool"}}],[5,"is_raw_guess","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"bool"}}],[5,"is_special_ident","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"bool"}}],[5,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",null,{"inputs":[{"name":"ident"}],"output":{"name":"bool"}}],[5,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",null,{"inputs":[{"name":"ident"}],"output":{"name":"bool"}}],[5,"is_reserved_ident","","Returns `true` if the token is either a special identifier or a keyword.",null,{"inputs":[{"name":"ident"}],"output":{"name":"bool"}}],[5,"is_op","","",null,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[5,"prepend_attrs","","",null,null],[11,"clone","","",186,{"inputs":[{"name":"self"}],"output":{"name":"binoptoken"}}],[11,"encode","","",186,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",186,{"inputs":[{"name":"__d"}],"output":{"generics":["binoptoken"],"name":"result"}}],[11,"eq","","",186,{"inputs":[{"name":"self"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",186,null],[11,"hash","","",186,null],[11,"fmt","","",186,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",187,{"inputs":[{"name":"self"}],"output":{"name":"delimtoken"}}],[11,"encode","","",187,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",187,{"inputs":[{"name":"__d"}],"output":{"generics":["delimtoken"],"name":"result"}}],[11,"eq","","",187,{"inputs":[{"name":"self"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",187,null],[11,"hash","","",187,null],[11,"fmt","","",187,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"len","","",187,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"is_empty","","",187,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",188,{"inputs":[{"name":"self"}],"output":{"name":"lit"}}],[11,"encode","","",188,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",188,{"inputs":[{"name":"__d"}],"output":{"generics":["lit"],"name":"result"}}],[11,"eq","","",188,{"inputs":[{"name":"self"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"ne","","",188,{"inputs":[{"name":"self"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",188,null],[11,"hash","","",188,null],[11,"fmt","","",188,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"short_name","","",188,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"probably_equal_for_proc_macro","","",188,{"inputs":[{"name":"self"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"clone","","",189,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"encode","","",189,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",189,{"inputs":[{"name":"__d"}],"output":{"generics":["token"],"name":"result"}}],[11,"eq","","",189,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"bool"}}],[11,"ne","","",189,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",189,null],[11,"hash","","",189,null],[11,"fmt","","",189,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"interpolated","","",189,{"inputs":[{"name":"nonterminal"}],"output":{"name":"token"}}],[11,"from_ast_ident","","Recovers a `Token` from an `ast::Ident`. This creates a raw identifier if necessary.",189,{"inputs":[{"name":"ident"}],"output":{"name":"token"}}],[11,"is_like_gt","","Returns `true` if the token starts with '>'.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"can_begin_expr","","Returns `true` if the token can appear at the start of an expression.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"can_begin_type","","Returns `true` if the token can appear at the start of a type.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"can_begin_bound","","Returns `true` if the token can appear at the start of a generic bound.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_lit","","Returns `true` if the token is any literal",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"ident","","Returns an identifier if this token is an identifier.",189,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"lifetime","","Returns a lifetime identifier if this token is a lifetime.",189,{"inputs":[{"name":"self"}],"output":{"generics":["ident"],"name":"option"}}],[11,"is_ident","","Returns `true` if the token is an identifier.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_lifetime","","Returns `true` if the token is a lifetime.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_ident_named","","Returns `true` if the token is a identifier whose name is the given string slice.",189,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_doc_comment","","Returns `true` if the token is a documentation comment.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_interpolated","","Returns `true` if the token is interpolated.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_path","","Returns `true` if the token is an interpolated path.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_mutability","","Returns `true` if the token is either the `mut` or `const` keyword.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_qpath_start","","",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_path_start","","",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_keyword","","Returns `true` if the token is a given keyword, `kw`.",189,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_path_segment_keyword","","",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_special_ident","","",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_used_keyword","","Returns `true` if the token is a keyword used in the language.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_unused_keyword","","Returns `true` if the token is a keyword reserved for possible future use.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_reserved_ident","","Returns `true` if the token is either a special identifier or a keyword.",189,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"glue","","",189,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"generics":["token"],"name":"option"}}],[11,"similar_tokens","","Returns tokens that are likely to be typed accidentally instead of the current token. Enables better error recovery when the wrong token is found.",189,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"option"}}],[11,"interpolated_to_tokenstream","","",189,{"inputs":[{"name":"self"},{"name":"parsesess"},{"name":"span"}],"output":{"name":"tokenstream"}}],[11,"probably_equal_for_proc_macro","","",189,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"bool"}}],[11,"clone","","",190,{"inputs":[{"name":"self"}],"output":{"name":"nonterminal"}}],[11,"encode","","",190,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",190,{"inputs":[{"name":"__d"}],"output":{"generics":["nonterminal"],"name":"result"}}],[11,"assert_receiver_is_total_eq","","",190,null],[11,"hash","","",190,null],[11,"eq","","",190,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",190,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",185,{"inputs":[{"name":"self"}],"output":{"name":"lazytokenstream"}}],[11,"eq","","",185,{"inputs":[{"name":"self"},{"name":"lazytokenstream"}],"output":{"name":"bool"}}],[11,"fmt","","",185,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",185,{"inputs":[],"output":{"name":"self"}}],[11,"force","","",185,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"tokenstream"}}],[11,"encode","","",185,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",185,{"inputs":[{"name":"d"}],"output":{"generics":["lazytokenstream"],"name":"result"}}],[11,"hash","","",185,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[0,"attr","syntax::parse","",null,null],[4,"InnerAttributeParsePolicy","syntax::parse::attr","",null,null],[13,"Permitted","","",191,null],[13,"NotPermitted","","",191,null],[12,"reason","syntax::parse::attr::InnerAttributeParsePolicy","",191,null],[17,"DEFAULT_UNEXPECTED_INNER_ATTR_ERR_MSG","syntax::parse::attr","",null,null],[11,"eq","","",191,{"inputs":[{"name":"self"},{"name":"innerattributeparsepolicy"}],"output":{"name":"bool"}}],[11,"ne","","",191,{"inputs":[{"name":"self"},{"name":"innerattributeparsepolicy"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",191,null],[11,"fmt","","",191,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"parse_outer_attributes","syntax::parse::parser","Parse attributes that appear before an item",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_attribute","","Matches `attribute = # ! [ meta_item ]`",164,{"inputs":[{"name":"self"},{"name":"bool"}],"output":{"generics":["attribute"],"name":"presult"}}],[11,"parse_attribute_with_inner_parse_policy","","The same as `parse_attribute`, except it takes in an `InnerAttributeParsePolicy` that prescribes how to handle inner attributes.",164,{"inputs":[{"name":"self"},{"name":"innerattributeparsepolicy"}],"output":{"generics":["attribute"],"name":"presult"}}],[11,"parse_path_and_tokens","","",164,{"inputs":[{"name":"self"}],"output":{"name":"presult"}}],[11,"parse_inner_attributes","","Parse attributes that appear after the opening of an item. These should be preceded by an exclamation mark, but we accept and warn about one terminated by a semicolon. matches inner_attrs*",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[11,"parse_unsuffixed_lit","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["lit"],"name":"presult"}}],[11,"parse_meta_item","","Per RFC#1559, matches the following grammar:",164,{"inputs":[{"name":"self"}],"output":{"generics":["metaitem"],"name":"presult"}}],[11,"parse_meta_item_kind","","",164,{"inputs":[{"name":"self"}],"output":{"generics":["metaitemkind"],"name":"presult"}}],[11,"parse_meta_item_inner","","matches meta_item_inner : (meta_item | UNSUFFIXED_LIT) ;",164,{"inputs":[{"name":"self"}],"output":{"generics":["nestedmetaitem"],"name":"presult"}}],[11,"parse_meta_seq","","matches meta_seq = ( COMMASEP(meta_item_inner) )",164,{"inputs":[{"name":"self"}],"output":{"generics":["vec"],"name":"presult"}}],[0,"common","syntax::parse","Common routines shared by parser mods",null,null],[3,"SeqSep","syntax::parse::common","`SeqSep` : a sequence separator (token) and whether a trailing separator is allowed.",null,null],[12,"sep","","",192,null],[12,"trailing_sep_allowed","","",192,null],[11,"trailing_allowed","","",192,{"inputs":[{"name":"token"}],"output":{"name":"seqsep"}}],[11,"none","","",192,{"inputs":[],"output":{"name":"seqsep"}}],[0,"classify","syntax::parse","Routines the parser uses to classify AST nodes",null,null],[5,"expr_requires_semi_to_be_stmt","syntax::parse::classify","Does this expression require a semicolon to be treated as a statement? The negation of this: 'can this expression be used as a statement without a semicolon' -- is used as an early-bail-out in the parser so that, for instance,     if true {...} else {...}      |x| 5 isn't parsed as (if true {...} else {...} | x) | 5",null,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it. note that in one case (`stmt_semi`), we've already seen the semicolon, and thus don't need another.",null,{"inputs":[{"name":"stmtkind"}],"output":{"name":"bool"}}],[6,"PResult","syntax::parse","",null,null],[11,"new","","",160,{"inputs":[{"name":"filepathmapping"}],"output":{"name":"self"}}],[11,"with_span_handler","","",160,{"inputs":[{"name":"handler"},{"generics":["codemap"],"name":"lrc"}],"output":{"name":"parsesess"}}],[11,"codemap","","",160,{"inputs":[{"name":"self"}],"output":{"name":"codemap"}}],[11,"clone","","",161,{"inputs":[{"name":"self"}],"output":{"name":"directory"}}],[11,"clone","","",162,{"inputs":[{"name":"self"}],"output":{"name":"directoryownership"}}],[0,"ptr","syntax","The AST pointer",null,null],[3,"P","syntax::ptr","An owned smart pointer.",null,null],[12,"ptr","","",193,null],[5,"P","","Construct a `P<T>` from a `T` value.",null,{"inputs":[{"name":"t"}],"output":{"name":"p"}}],[11,"hash","","",193,null],[11,"eq","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"bool"}}],[11,"ne","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",193,null],[11,"partial_cmp","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"bool"}}],[11,"le","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"bool"}}],[11,"gt","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"bool"}}],[11,"ge","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"bool"}}],[11,"cmp","","",193,{"inputs":[{"name":"self"},{"name":"p"}],"output":{"name":"ordering"}}],[11,"and_then","","Move out of the pointer. Intended for chaining transformations not covered by `map`.",193,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"u"}}],[11,"into_inner","","Equivalent to and_then(|x| x)",193,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"map","","Transform the inner value, consuming `self` and producing a new `P<T>`.",193,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"p"}}],[11,"deref","","",193,{"inputs":[{"name":"self"}],"output":{"name":"t"}}],[11,"clone","","",193,{"inputs":[{"name":"self"}],"output":{"name":"p"}}],[11,"fmt","","",193,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",193,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",193,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",193,{"inputs":[{"name":"d"}],"output":{"generics":["p"],"name":"result"}}],[11,"encode","","",193,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"new","","",193,{"inputs":[],"output":{"name":"p"}}],[11,"from_vec","","",193,{"inputs":[{"name":"vec"}],"output":{"name":"p"}}],[11,"into_vec","","",193,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"default","","Creates an empty `P<[T]>`.",193,{"inputs":[],"output":{"name":"p"}}],[11,"clone","","",193,{"inputs":[{"name":"self"}],"output":{"name":"p"}}],[11,"from","","",193,{"inputs":[{"name":"vec"}],"output":{"name":"self"}}],[11,"into","","",193,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"from_iter","","",193,{"inputs":[{"name":"i"}],"output":{"name":"p"}}],[11,"into_iter","","",193,null],[11,"encode","","",193,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",193,{"inputs":[{"name":"d"}],"output":{"generics":["p"],"name":"result"}}],[11,"hash_stable","","",193,{"inputs":[{"name":"self"},{"name":"ctx"},{"name":"stablehasher"}],"output":null}],[0,"show_span","syntax","Span debugger",null,null],[3,"ShowSpanVisitor","syntax::show_span","",null,null],[12,"span_diagnostic","","",194,null],[12,"mode","","",194,null],[4,"Mode","","",null,null],[13,"Expression","","",195,null],[13,"Pattern","","",195,null],[13,"Type","","",195,null],[5,"run","","",null,{"inputs":[{"name":"handler"},{"name":"str"},{"name":"crate"}],"output":null}],[11,"from_str","","",195,{"inputs":[{"name":"str"}],"output":{"generics":["mode"],"name":"result"}}],[11,"visit_expr","","",194,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_pat","","",194,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_ty","","",194,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_mac","","",194,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[0,"std_inject","syntax","",null,null],[5,"ignored_span","syntax::std_inject","Craft a span that will be ignored by the stability lint's call to codemap's `is_internal` check. The expanded code uses the unstable `#[prelude_import]` attribute.",null,{"inputs":[{"name":"span"}],"output":{"name":"span"}}],[5,"injected_crate_name","","",null,{"inputs":[],"output":{"generics":["str"],"name":"option"}}],[5,"maybe_inject_crates_ref","","",null,{"inputs":[{"name":"crate"},{"generics":["str"],"name":"option"}],"output":{"name":"crate"}}],[17,"INJECTED_CRATE_NAME","","",null,null],[0,"str","syntax","",null,null],[5,"char_at","syntax::str","",null,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"char"}}],[0,"test","syntax","",null,null],[3,"Test","syntax::test","",null,null],[12,"span","","",196,null],[12,"path","","",196,null],[12,"bench","","",196,null],[12,"ignore","","",196,null],[12,"should_panic","","",196,null],[12,"allow_fail","","",196,null],[3,"TestCtxt","","",null,null],[12,"span_diagnostic","","",197,null],[12,"path","","",197,null],[12,"ext_cx","","",197,null],[12,"testfns","","",197,null],[12,"reexport_test_harness_main","","",197,null],[12,"is_libtest","","",197,null],[12,"ctxt","","",197,null],[12,"features","","",197,null],[12,"toplevel_reexport","","",197,null],[3,"TestHarnessGenerator","","",null,null],[12,"cx","","",198,null],[12,"tests","","",198,null],[12,"tested_submods","","",198,null],[3,"EntryPointCleaner","","",null,null],[12,"depth","","",199,null],[4,"ShouldPanic","","",null,null],[13,"No","","",200,null],[13,"Yes","","",200,null],[4,"HasTestSignature","","",null,null],[13,"Yes","","",201,null],[13,"No","","",201,null],[4,"BadTestSignature","","",null,null],[13,"NotEvenAFunction","","",202,null],[13,"WrongTypeSignature","","",202,null],[13,"NoArgumentsAllowed","","",202,null],[13,"ShouldPanicOnlyWithNoArgs","","",202,null],[5,"modify_for_testing","","",null,{"inputs":[{"name":"parsesess"},{"name":"resolver"},{"name":"bool"},{"name":"crate"},{"name":"handler"},{"name":"features"}],"output":{"name":"crate"}}],[5,"mk_reexport_mod","","",null,null],[5,"generate_test_harness","","",null,{"inputs":[{"name":"parsesess"},{"name":"resolver"},{"generics":["symbol"],"name":"option"},{"name":"crate"},{"name":"handler"},{"name":"features"}],"output":{"name":"crate"}}],[5,"ignored_span","","Craft a span that will be ignored by the stability lint's call to codemap's `is_internal` check. The expanded code calls some unstable functions in the test crate.",null,{"inputs":[{"name":"testctxt"},{"name":"span"}],"output":{"name":"span"}}],[5,"is_test_fn","","",null,{"inputs":[{"name":"testctxt"},{"name":"item"}],"output":{"name":"bool"}}],[5,"is_bench_fn","","",null,{"inputs":[{"name":"testctxt"},{"name":"item"}],"output":{"name":"bool"}}],[5,"is_ignored","","",null,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[5,"is_allowed_fail","","",null,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[5,"should_panic","","",null,{"inputs":[{"name":"item"},{"name":"testctxt"}],"output":{"name":"shouldpanic"}}],[5,"mk_std","","",null,{"inputs":[{"name":"testctxt"}],"output":{"generics":["item"],"name":"p"}}],[5,"mk_main","","",null,{"inputs":[{"name":"testctxt"}],"output":{"generics":["item"],"name":"p"}}],[5,"mk_test_module","","",null,null],[5,"nospan","","",null,{"inputs":[{"name":"t"}],"output":{"name":"spanned"}}],[5,"path_node","","",null,{"inputs":[{"generics":["ident"],"name":"vec"}],"output":{"name":"path"}}],[5,"path_name_i","","",null,null],[5,"mk_tests","","",null,{"inputs":[{"name":"testctxt"}],"output":{"generics":["item"],"name":"p"}}],[5,"mk_test_descs","","",null,{"inputs":[{"name":"testctxt"}],"output":{"generics":["expr"],"name":"p"}}],[5,"mk_test_desc_and_fn_rec","","",null,{"inputs":[{"name":"testctxt"},{"name":"test"}],"output":{"generics":["expr"],"name":"p"}}],[11,"fold_crate","","",198,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_item","","",198,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_mac","","",198,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"fold_item","","",199,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_mac","","",199,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"eq","","",201,{"inputs":[{"name":"self"},{"name":"hastestsignature"}],"output":{"name":"bool"}}],[11,"ne","","",201,{"inputs":[{"name":"self"},{"name":"hastestsignature"}],"output":{"name":"bool"}}],[11,"eq","","",202,{"inputs":[{"name":"self"},{"name":"badtestsignature"}],"output":{"name":"bool"}}],[0,"tokenstream","syntax","Token Streams",null,null],[3,"Delimited","syntax::tokenstream","A delimited sequence of token trees",null,null],[12,"delim","","The type of delimiter",203,null],[12,"tts","","The delimited sequence of token trees",203,null],[3,"TokenStream","","Token Streams",null,null],[12,"kind","","",204,null],[3,"TokenStreamBuilder","","",null,null],[12,"0","","",205,null],[3,"Cursor","","",null,null],[12,"0","","",206,null],[3,"StreamCursor","","",null,null],[12,"stream","","",207,null],[12,"index","","",207,null],[12,"stack","","",207,null],[3,"ThinTokenStream","","The `TokenStream` type is large enough to represent a single `TokenTree` without allocation. `ThinTokenStream` is smaller, but needs to allocate to represent a single `TokenTree`. We must use `ThinTokenStream` in `TokenTree::Delimited` to avoid infinite size due to recursion.",null,null],[12,"0","","",208,null],[4,"TokenTree","","When the main rust parser encounters a syntax-extension invocation, it parses the arguments to the invocation as a token-tree. This is a very loose structure, such that all sorts of different AST-fragments can be passed to syntax extensions using a uniform type.",null,null],[13,"Token","","A single token",209,null],[13,"Delimited","","A delimited sequence of token trees",209,null],[4,"TokenStreamKind","","",null,null],[13,"Empty","","",210,null],[13,"Tree","","",210,null],[13,"JointTree","","",210,null],[13,"Stream","","",210,null],[4,"CursorKind","","",null,null],[13,"Empty","","",211,null],[13,"Tree","","",211,null],[13,"JointTree","","",211,null],[13,"Stream","","",211,null],[11,"clone","","",203,{"inputs":[{"name":"self"}],"output":{"name":"delimited"}}],[11,"eq","","",203,{"inputs":[{"name":"self"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"ne","","",203,{"inputs":[{"name":"self"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",203,null],[11,"encode","","",203,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",203,{"inputs":[{"name":"__d"}],"output":{"generics":["delimited"],"name":"result"}}],[11,"hash","","",203,null],[11,"fmt","","",203,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"open_token","","Returns the opening delimiter as a token.",203,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"close_token","","Returns the closing delimiter as a token.",203,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"open_tt","","Returns the opening delimiter as a token tree.",203,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"tokentree"}}],[11,"close_tt","","Returns the closing delimiter as a token tree.",203,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"tokentree"}}],[11,"stream","","Returns the token trees inside the delimiters.",203,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"fmt","","",209,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",209,{"inputs":[{"name":"self"}],"output":{"name":"tokentree"}}],[11,"eq","","",209,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"ne","","",209,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",209,null],[11,"encode","","",209,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",209,{"inputs":[{"name":"__d"}],"output":{"generics":["tokentree"],"name":"result"}}],[11,"hash","","",209,null],[11,"parse","","Use this token tree as a matcher to parse given tts.",209,null],[11,"eq_unspanned","","Check if this TokenTree is equal to the other, regardless of span information.",209,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"probably_equal_for_proc_macro","","",209,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"span","","Retrieve the TokenTree's span.",209,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"set_span","","Modify the `TokenTree`'s span inplace.",209,{"inputs":[{"name":"self"},{"name":"span"}],"output":null}],[11,"eq_token","","Indicates if the stream is a token that is equal to the provided token.",209,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"bool"}}],[11,"joint","","",209,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"clone","","",204,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"fmt","","",204,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",210,{"inputs":[{"name":"self"}],"output":{"name":"tokenstreamkind"}}],[11,"fmt","","",210,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",204,{"inputs":[{"name":"tokentree"}],"output":{"name":"tokenstream"}}],[11,"from","","",204,{"inputs":[{"name":"token"}],"output":{"name":"tokenstream"}}],[11,"from_iter","","",204,{"inputs":[{"name":"i"}],"output":{"name":"self"}}],[11,"eq","","",204,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":{"name":"bool"}}],[11,"len","","",204,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"empty","","",204,{"inputs":[],"output":{"name":"tokenstream"}}],[11,"is_empty","","",204,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"concat","","",204,{"inputs":[{"generics":["tokenstream"],"name":"vec"}],"output":{"name":"tokenstream"}}],[11,"concat_rc_slice","","",204,{"inputs":[{"generics":["tokenstream"],"name":"rcslice"}],"output":{"name":"tokenstream"}}],[11,"trees","","",204,{"inputs":[{"name":"self"}],"output":{"name":"cursor"}}],[11,"into_trees","","",204,{"inputs":[{"name":"self"}],"output":{"name":"cursor"}}],[11,"eq_unspanned","","Compares two TokenStreams, checking equality without regarding span information.",204,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":{"name":"bool"}}],[11,"probably_equal_for_proc_macro","","",204,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":{"name":"bool"}}],[11,"as_tree","","Precondition: `self` consists of a single token tree. Returns true if the token tree is a joint operation w.r.t. `proc_macro::TokenNode`.",204,null],[11,"map_enumerated","","",204,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"tokenstream"}}],[11,"map","","",204,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"tokenstream"}}],[11,"first_tree_and_joint","","",204,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"last_tree_if_joint","","",204,{"inputs":[{"name":"self"}],"output":{"generics":["tokentree"],"name":"option"}}],[11,"new","","",205,{"inputs":[],"output":{"name":"tokenstreambuilder"}}],[11,"push","","",205,{"inputs":[{"name":"self"},{"name":"t"}],"output":null}],[11,"add","","",205,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"self"}}],[11,"build","","",205,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"push_all_but_last_tree","","",205,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":null}],[11,"push_all_but_first_tree","","",205,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":null}],[11,"clone","","",206,{"inputs":[{"name":"self"}],"output":{"name":"cursor"}}],[11,"clone","","",211,{"inputs":[{"name":"self"}],"output":{"name":"cursorkind"}}],[11,"clone","","",207,{"inputs":[{"name":"self"}],"output":{"name":"streamcursor"}}],[11,"new","","",207,{"inputs":[{"generics":["tokenstream"],"name":"rcslice"}],"output":{"name":"self"}}],[11,"next_as_stream","","",207,{"inputs":[{"name":"self"}],"output":{"generics":["tokenstream"],"name":"option"}}],[11,"insert","","",207,{"inputs":[{"name":"self"},{"generics":["tokenstream"],"name":"rcslice"}],"output":null}],[11,"next","","",206,{"inputs":[{"name":"self"}],"output":{"generics":["tokentree"],"name":"option"}}],[11,"new","","",206,{"inputs":[{"name":"tokenstream"}],"output":{"name":"self"}}],[11,"next_as_stream","","",206,{"inputs":[{"name":"self"}],"output":{"generics":["tokenstream"],"name":"option"}}],[11,"insert","","",206,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":null}],[11,"original_stream","","",206,{"inputs":[{"name":"self"}],"output":{"name":"tokenstream"}}],[11,"look_ahead","","",206,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["tokentree"],"name":"option"}}],[11,"fmt","","",208,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",208,{"inputs":[{"name":"self"}],"output":{"name":"thintokenstream"}}],[11,"from","","",208,{"inputs":[{"name":"tokenstream"}],"output":{"name":"thintokenstream"}}],[11,"from","","",204,{"inputs":[{"name":"thintokenstream"}],"output":{"name":"tokenstream"}}],[11,"eq","","",208,{"inputs":[{"name":"self"},{"name":"thintokenstream"}],"output":{"name":"bool"}}],[11,"fmt","","",204,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",204,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",204,{"inputs":[{"name":"d"}],"output":{"generics":["tokenstream"],"name":"result"}}],[11,"hash","","",204,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"encode","","",208,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",208,{"inputs":[{"name":"d"}],"output":{"generics":["thintokenstream"],"name":"result"}}],[11,"hash","","",208,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[0,"visit","syntax","AST walker. Each overridden visit method has full control over what happens with its node, it can do its own traversal of the node's children, call `visit::walk_*` to apply the default traversal algorithm, or prevent deeper traversal by doing nothing.",null,null],[4,"FnKind","syntax::visit","",null,null],[13,"ItemFn","","fn foo() or extern \"Abi\" fn foo()",212,null],[13,"Method","","fn foo(&self)",212,null],[13,"Closure","","|x, y| body",212,null],[5,"walk_ident","","",null,{"inputs":[{"name":"v"},{"name":"ident"}],"output":null}],[5,"walk_crate","","",null,{"inputs":[{"name":"v"},{"name":"crate"}],"output":null}],[5,"walk_mod","","",null,{"inputs":[{"name":"v"},{"name":"mod"}],"output":null}],[5,"walk_local","","",null,{"inputs":[{"name":"v"},{"name":"local"}],"output":null}],[5,"walk_label","","",null,{"inputs":[{"name":"v"},{"name":"label"}],"output":null}],[5,"walk_lifetime","","",null,{"inputs":[{"name":"v"},{"name":"lifetime"}],"output":null}],[5,"walk_poly_trait_ref","","",null,{"inputs":[{"name":"v"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[5,"walk_trait_ref","","",null,{"inputs":[{"name":"v"},{"name":"traitref"}],"output":null}],[5,"walk_item","","",null,{"inputs":[{"name":"v"},{"name":"item"}],"output":null}],[5,"walk_enum_def","","",null,{"inputs":[{"name":"v"},{"name":"enumdef"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[5,"walk_variant","","",null,{"inputs":[{"name":"v"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[5,"walk_ty","","",null,{"inputs":[{"name":"v"},{"name":"ty"}],"output":null}],[5,"walk_path","","",null,{"inputs":[{"name":"v"},{"name":"path"}],"output":null}],[5,"walk_use_tree","","",null,{"inputs":[{"name":"v"},{"name":"usetree"},{"name":"nodeid"}],"output":null}],[5,"walk_path_segment","","",null,{"inputs":[{"name":"v"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[5,"walk_path_parameters","","",null,{"inputs":[{"name":"v"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[5,"walk_assoc_type_binding","","",null,{"inputs":[{"name":"v"},{"name":"typebinding"}],"output":null}],[5,"walk_pat","","",null,{"inputs":[{"name":"v"},{"name":"pat"}],"output":null}],[5,"walk_foreign_item","","",null,{"inputs":[{"name":"v"},{"name":"foreignitem"}],"output":null}],[5,"walk_global_asm","","",null,{"inputs":[{"name":"v"},{"name":"globalasm"}],"output":null}],[5,"walk_ty_param_bound","","",null,{"inputs":[{"name":"v"},{"name":"typarambound"}],"output":null}],[5,"walk_generic_param","","",null,{"inputs":[{"name":"v"},{"name":"genericparam"}],"output":null}],[5,"walk_generics","","",null,{"inputs":[{"name":"v"},{"name":"generics"}],"output":null}],[5,"walk_where_predicate","","",null,{"inputs":[{"name":"v"},{"name":"wherepredicate"}],"output":null}],[5,"walk_fn_ret_ty","","",null,{"inputs":[{"name":"v"},{"name":"functionretty"}],"output":null}],[5,"walk_fn_decl","","",null,{"inputs":[{"name":"v"},{"name":"fndecl"}],"output":null}],[5,"walk_fn","","",null,{"inputs":[{"name":"v"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"}],"output":null}],[5,"walk_trait_item","","",null,{"inputs":[{"name":"v"},{"name":"traititem"}],"output":null}],[5,"walk_impl_item","","",null,{"inputs":[{"name":"v"},{"name":"implitem"}],"output":null}],[5,"walk_struct_def","","",null,{"inputs":[{"name":"v"},{"name":"variantdata"}],"output":null}],[5,"walk_struct_field","","",null,{"inputs":[{"name":"v"},{"name":"structfield"}],"output":null}],[5,"walk_block","","",null,{"inputs":[{"name":"v"},{"name":"block"}],"output":null}],[5,"walk_stmt","","",null,{"inputs":[{"name":"v"},{"name":"stmt"}],"output":null}],[5,"walk_mac","","",null,{"inputs":[{"name":"v"},{"name":"mac"}],"output":null}],[5,"walk_expr","","",null,{"inputs":[{"name":"v"},{"name":"expr"}],"output":null}],[5,"walk_arm","","",null,{"inputs":[{"name":"v"},{"name":"arm"}],"output":null}],[5,"walk_vis","","",null,{"inputs":[{"name":"v"},{"name":"visibility"}],"output":null}],[5,"walk_attribute","","",null,{"inputs":[{"name":"v"},{"name":"attribute"}],"output":null}],[5,"walk_tt","","",null,{"inputs":[{"name":"v"},{"name":"tokentree"}],"output":null}],[5,"walk_tts","","",null,{"inputs":[{"name":"v"},{"name":"tokenstream"}],"output":null}],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially overridden.  Each method's default implementation recursively visits the substructure of the input via the corresponding `walk` method; e.g. the `visit_mod` method by default calls `visit::walk_mod`.",null,null],[11,"visit_name","","",213,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":null}],[11,"visit_ident","","",213,{"inputs":[{"name":"self"},{"name":"ident"}],"output":null}],[11,"visit_mod","","",213,null],[11,"visit_foreign_item","","",213,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":null}],[11,"visit_global_asm","","",213,{"inputs":[{"name":"self"},{"name":"globalasm"}],"output":null}],[11,"visit_item","","",213,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_local","","",213,{"inputs":[{"name":"self"},{"name":"local"}],"output":null}],[11,"visit_block","","",213,{"inputs":[{"name":"self"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",213,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":null}],[11,"visit_arm","","",213,{"inputs":[{"name":"self"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",213,{"inputs":[{"name":"self"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",213,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_expr_post","","",213,{"inputs":[{"name":"self"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",213,{"inputs":[{"name":"self"},{"name":"ty"}],"output":null}],[11,"visit_generic_param","","",213,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":null}],[11,"visit_generics","","",213,{"inputs":[{"name":"self"},{"name":"generics"}],"output":null}],[11,"visit_where_predicate","","",213,{"inputs":[{"name":"self"},{"name":"wherepredicate"}],"output":null}],[11,"visit_fn","","",213,{"inputs":[{"name":"self"},{"name":"fnkind"},{"name":"fndecl"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",213,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",213,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":null}],[11,"visit_trait_ref","","",213,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":null}],[11,"visit_ty_param_bound","","",213,{"inputs":[{"name":"self"},{"name":"typarambound"}],"output":null}],[11,"visit_poly_trait_ref","","",213,{"inputs":[{"name":"self"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_variant_data","","",213,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_struct_field","","",213,{"inputs":[{"name":"self"},{"name":"structfield"}],"output":null}],[11,"visit_enum_def","","",213,{"inputs":[{"name":"self"},{"name":"enumdef"},{"name":"generics"},{"name":"nodeid"},{"name":"span"}],"output":null}],[11,"visit_variant","","",213,{"inputs":[{"name":"self"},{"name":"variant"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_label","","",213,{"inputs":[{"name":"self"},{"name":"label"}],"output":null}],[11,"visit_lifetime","","",213,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":null}],[11,"visit_mac","","",213,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[11,"visit_mac_def","","",213,{"inputs":[{"name":"self"},{"name":"macrodef"},{"name":"nodeid"}],"output":null}],[11,"visit_path","","",213,{"inputs":[{"name":"self"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_use_tree","","",213,{"inputs":[{"name":"self"},{"name":"usetree"},{"name":"nodeid"},{"name":"bool"}],"output":null}],[11,"visit_path_segment","","",213,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[11,"visit_path_parameters","","",213,{"inputs":[{"name":"self"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[11,"visit_assoc_type_binding","","",213,{"inputs":[{"name":"self"},{"name":"typebinding"}],"output":null}],[11,"visit_attribute","","",213,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_tt","","",213,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":null}],[11,"visit_tts","","",213,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":null}],[11,"visit_token","","",213,{"inputs":[{"name":"self"},{"name":"token"}],"output":null}],[11,"visit_vis","","",213,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":null}],[11,"visit_fn_ret_ty","","",213,{"inputs":[{"name":"self"},{"name":"functionretty"}],"output":null}],[11,"clone","","",212,{"inputs":[{"name":"self"}],"output":{"name":"fnkind"}}],[11,"eq","","",212,{"inputs":[{"name":"self"},{"name":"fnkind"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"self"},{"name":"fnkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",212,null],[0,"print","syntax","",null,null],[0,"pp","syntax::print","This pretty-printer is a direct reimplementation of Philip Karlton's Mesa pretty-printer, as described in appendix A of",null,null],[3,"BreakToken","syntax::print::pp","",null,null],[12,"offset","","",214,null],[12,"blank_space","","",214,null],[3,"BeginToken","","",null,null],[12,"offset","","",215,null],[12,"breaks","","",215,null],[3,"PrintStackElem","","",null,null],[12,"offset","","",216,null],[12,"pbreak","","",216,null],[3,"Printer","","",null,null],[12,"out","","",217,null],[12,"buf_max_len","","",217,null],[12,"margin","","Width of lines we're constrained to",217,null],[12,"space","","Number of spaces left on line",217,null],[12,"left","","Index of left side of input stream",217,null],[12,"right","","Index of right side of input stream",217,null],[12,"buf","","Ring-buffer of tokens and calculated sizes",217,null],[12,"left_total","","Running size of stream \"...left\"",217,null],[12,"right_total","","Running size of stream \"...right\"",217,null],[12,"scan_stack","","Pseudo-stack, really a ring too. Holds the primary-ring-buffers index of the Begin that started the current block, possibly with the most recent Break after that Begin (if there is any) on top of it. Stuff is flushed off the bottom as it becomes irrelevant due to the primary ring-buffer advancing.",217,null],[12,"print_stack","","Stack of blocks-in-progress being flushed by print",217,null],[12,"pending_indentation","","Buffered indentation to avoid writing trailing whitespace",217,null],[3,"BufEntry","","",null,null],[12,"token","","",218,null],[12,"size","","",218,null],[4,"Breaks","","How to break. Described in more detail in the module docs.",null,null],[13,"Consistent","","",219,null],[13,"Inconsistent","","",219,null],[4,"Token","","",null,null],[13,"String","","",220,null],[13,"Break","","",220,null],[13,"Begin","","",220,null],[13,"End","","",220,null],[13,"Eof","","",220,null],[4,"PrintStackBreak","","",null,null],[13,"Fits","","",221,null],[13,"Broken","","",221,null],[5,"buf_str","","",null,null],[5,"mk_printer","","",null,{"inputs":[{"generics":["write"],"name":"box"},{"name":"usize"}],"output":{"name":"printer"}}],[17,"SIZE_INFINITY","","",null,null],[11,"clone","","",219,{"inputs":[{"name":"self"}],"output":{"name":"breaks"}}],[11,"eq","","",219,{"inputs":[{"name":"self"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"clone","","",214,{"inputs":[{"name":"self"}],"output":{"name":"breaktoken"}}],[11,"clone","","",215,{"inputs":[{"name":"self"}],"output":{"name":"begintoken"}}],[11,"clone","","",220,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"is_eof","","",220,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_hardbreak_tok","","",220,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",220,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",221,{"inputs":[{"name":"self"}],"output":{"name":"printstackbreak"}}],[11,"clone","","",216,{"inputs":[{"name":"self"}],"output":{"name":"printstackelem"}}],[11,"clone","","",218,{"inputs":[{"name":"self"}],"output":{"name":"bufentry"}}],[11,"default","","",218,{"inputs":[],"output":{"name":"self"}}],[11,"last_token","","",217,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"replace_last_token","","be very careful with this!",217,{"inputs":[{"name":"self"},{"name":"token"}],"output":null}],[11,"pretty_print","","",217,{"inputs":[{"name":"self"},{"name":"token"}],"output":{"name":"result"}}],[11,"check_stream","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"scan_push","","",217,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"scan_pop","","",217,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"scan_top","","",217,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"scan_pop_bottom","","",217,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"advance_right","","",217,{"inputs":[{"name":"self"}],"output":null}],[11,"advance_left","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"check_stack","","",217,{"inputs":[{"name":"self"},{"name":"isize"}],"output":null}],[11,"print_newline","","",217,{"inputs":[{"name":"self"},{"name":"isize"}],"output":{"name":"result"}}],[11,"indent","","",217,{"inputs":[{"name":"self"},{"name":"isize"}],"output":null}],[11,"get_top","","",217,{"inputs":[{"name":"self"}],"output":{"name":"printstackelem"}}],[11,"print_str","","",217,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"print","","",217,{"inputs":[{"name":"self"},{"name":"token"},{"name":"isize"}],"output":{"name":"result"}}],[11,"rbox","","\"raw box\"",217,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"breaks"}],"output":{"name":"result"}}],[11,"ibox","","Inconsistent breaking box",217,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"cbox","","Consistent breaking box",217,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"break_offset","","",217,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[11,"end","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"eof","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"word","","",217,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"huge_word","","",217,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"zero_word","","",217,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"spaces","","",217,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"zerobreak","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"space","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"hardbreak","","",217,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"hardbreak_tok_offset","","",217,{"inputs":[{"name":"isize"}],"output":{"name":"token"}}],[11,"hardbreak_tok","","",217,{"inputs":[],"output":{"name":"token"}}],[0,"pprust","syntax::print","",null,null],[3,"NoAnn","syntax::print::pprust","",null,null],[3,"State","","",null,null],[12,"s","","",222,null],[12,"cm","","",222,null],[12,"comments","","",222,null],[12,"literals","","",222,null],[12,"cur_cmnt","","",222,null],[12,"boxes","","",222,null],[12,"ann","","",222,null],[4,"AnnNode","","",null,null],[13,"NodeIdent","","",223,null],[13,"NodeName","","",223,null],[13,"NodeBlock","","",223,null],[13,"NodeItem","","",223,null],[13,"NodeSubItem","","",223,null],[13,"NodeExpr","","",223,null],[13,"NodePat","","",223,null],[5,"rust_printer","","",null,{"inputs":[{"generics":["write"],"name":"box"},{"name":"ppann"}],"output":{"name":"state"}}],[5,"print_crate","","Requires you to pass an input filename and reader so that it can scan the input text for comments and literals to copy forward.",null,{"inputs":[{"name":"codemap"},{"name":"parsesess"},{"name":"crate"},{"name":"filename"},{"name":"read"},{"generics":["write"],"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"result"}}],[5,"to_string","","",null,{"inputs":[{"name":"f"}],"output":{"name":"string"}}],[5,"binop_to_string","","",null,{"inputs":[{"name":"binoptoken"}],"output":{"name":"str"}}],[5,"token_to_string","","",null,{"inputs":[{"name":"token"}],"output":{"name":"string"}}],[5,"ty_to_string","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[5,"bounds_to_string","","",null,null],[5,"pat_to_string","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"string"}}],[5,"arm_to_string","","",null,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[5,"expr_to_string","","",null,{"inputs":[{"name":"expr"}],"output":{"name":"string"}}],[5,"lifetime_to_string","","",null,{"inputs":[{"name":"lifetime"}],"output":{"name":"string"}}],[5,"tt_to_string","","",null,{"inputs":[{"name":"tokentree"}],"output":{"name":"string"}}],[5,"tts_to_string","","",null,null],[5,"tokens_to_string","","",null,{"inputs":[{"name":"tokenstream"}],"output":{"name":"string"}}],[5,"stmt_to_string","","",null,{"inputs":[{"name":"stmt"}],"output":{"name":"string"}}],[5,"attr_to_string","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"string"}}],[5,"item_to_string","","",null,{"inputs":[{"name":"item"}],"output":{"name":"string"}}],[5,"impl_item_to_string","","",null,{"inputs":[{"name":"implitem"}],"output":{"name":"string"}}],[5,"trait_item_to_string","","",null,{"inputs":[{"name":"traititem"}],"output":{"name":"string"}}],[5,"generic_params_to_string","","",null,null],[5,"where_clause_to_string","","",null,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[5,"fn_block_to_string","","",null,{"inputs":[{"name":"fndecl"}],"output":{"name":"string"}}],[5,"path_to_string","","",null,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[5,"path_segment_to_string","","",null,{"inputs":[{"name":"pathsegment"}],"output":{"name":"string"}}],[5,"ident_to_string","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[5,"vis_to_string","","",null,{"inputs":[{"name":"visibility"}],"output":{"name":"string"}}],[5,"fun_to_string","","",null,{"inputs":[{"name":"fndecl"},{"name":"unsafety"},{"name":"constness"},{"name":"ident"},{"name":"generics"}],"output":{"name":"string"}}],[5,"block_to_string","","",null,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[5,"meta_list_item_to_string","","",null,{"inputs":[{"name":"nestedmetaitem"}],"output":{"name":"string"}}],[5,"meta_item_to_string","","",null,{"inputs":[{"name":"metaitem"}],"output":{"name":"string"}}],[5,"attribute_to_string","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"string"}}],[5,"lit_to_string","","",null,{"inputs":[{"name":"lit"}],"output":{"name":"string"}}],[5,"variant_to_string","","",null,{"inputs":[{"name":"variant"}],"output":{"name":"string"}}],[5,"arg_to_string","","",null,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[5,"mac_to_string","","",null,{"inputs":[{"name":"mac"}],"output":{"name":"string"}}],[5,"foreign_item_to_string","","",null,{"inputs":[{"name":"foreignitem"}],"output":{"name":"string"}}],[5,"visibility_qualified","","",null,{"inputs":[{"name":"visibility"},{"name":"str"}],"output":{"name":"string"}}],[5,"repeat","","",null,{"inputs":[{"name":"str"},{"name":"usize"}],"output":{"name":"string"}}],[17,"INDENT_UNIT","","",null,null],[17,"DEFAULT_COLUMNS","","",null,null],[8,"PpAnn","","",null,null],[11,"pre","","",224,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"post","","",224,{"inputs":[{"name":"self"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[8,"PrintState","","",null,null],[10,"writer","","",225,{"inputs":[{"name":"self"}],"output":{"name":"printer"}}],[10,"boxes","","",225,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[10,"comments","","",225,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[10,"cur_cmnt","","",225,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[10,"cur_lit","","",225,{"inputs":[{"name":"self"}],"output":{"generics":["literal"],"name":"option"}}],[10,"bump_lit","","",225,{"inputs":[{"name":"self"}],"output":{"generics":["literal"],"name":"option"}}],[11,"word_space","","",225,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"popen","","",225,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"pclose","","",225,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"is_begin","","",225,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_end","","",225,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_bol","","",225,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"hardbreak_if_not_bol","","",225,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"rbox","","",225,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"breaks"}],"output":{"name":"result"}}],[11,"ibox","","",225,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"end","","",225,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"commasep","","",225,null],[11,"next_lit","","",225,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"generics":["literal"],"name":"option"}}],[11,"maybe_print_comment","","",225,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"result"}}],[11,"print_comment","","",225,{"inputs":[{"name":"self"},{"name":"comment"}],"output":{"name":"result"}}],[11,"next_comment","","",225,{"inputs":[{"name":"self"}],"output":{"generics":["comment"],"name":"option"}}],[11,"print_literal","","",225,{"inputs":[{"name":"self"},{"name":"lit"}],"output":{"name":"result"}}],[11,"print_string","","",225,{"inputs":[{"name":"self"},{"name":"str"},{"name":"strstyle"}],"output":{"name":"result"}}],[11,"print_inner_attributes","","",225,null],[11,"print_inner_attributes_no_trailing_hardbreak","","",225,null],[11,"print_outer_attributes","","",225,null],[11,"print_inner_attributes_inline","","",225,null],[11,"print_outer_attributes_inline","","",225,null],[11,"print_either_attributes","","",225,null],[11,"print_attribute_path","","",225,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"result"}}],[11,"print_attribute","","",225,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"name":"result"}}],[11,"print_attribute_inline","","",225,{"inputs":[{"name":"self"},{"name":"attribute"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_meta_list_item","","",225,{"inputs":[{"name":"self"},{"name":"nestedmetaitem"}],"output":{"name":"result"}}],[11,"print_meta_item","","",225,{"inputs":[{"name":"self"},{"name":"metaitem"}],"output":{"name":"result"}}],[11,"print_tt","","This doesn't deserve to be called \"pretty\" printing, but it should be meaning-preserving. A quick hack that might help would be to look at the spans embedded in the TTs to decide where to put spaces and newlines. But it'd be better to parse these according to the grammar of the appropriate macro, transcribe back into the grammar we just parsed from, and then pretty-print the resulting AST nodes (so, e.g., we print expression arguments as expressions). It can be done! I think.",225,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"result"}}],[11,"print_tts","","",225,{"inputs":[{"name":"self"},{"name":"tokenstream"}],"output":{"name":"result"}}],[11,"space_if_not_bol","","",225,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"nbsp","","",225,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"print_dollar_crate","","",225,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"result"}}],[11,"clone","","",226,{"inputs":[{"name":"self"}],"output":{"name":"noann"}}],[11,"new_from_input","","",222,{"inputs":[{"name":"codemap"},{"name":"parsesess"},{"name":"filename"},{"name":"read"},{"generics":["write"],"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"state"}}],[11,"new","","",222,{"inputs":[{"name":"codemap"},{"generics":["write"],"name":"box"},{"name":"ppann"},{"generics":["vec"],"name":"option"},{"generics":["vec"],"name":"option"}],"output":{"name":"state"}}],[11,"writer","","",222,{"inputs":[{"name":"self"}],"output":{"name":"printer"}}],[11,"boxes","","",222,{"inputs":[{"name":"self"}],"output":{"name":"vec"}}],[11,"comments","","",222,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"cur_cmnt","","",222,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"cur_lit","","",222,{"inputs":[{"name":"self"}],"output":{"generics":["literal"],"name":"option"}}],[11,"bump_lit","","",222,{"inputs":[{"name":"self"}],"output":{"generics":["literal"],"name":"option"}}],[11,"cbox","","",222,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"word_nbsp","","",222,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"head","","",222,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"result"}}],[11,"bopen","","",222,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"bclose_","","",222,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"}],"output":{"name":"result"}}],[11,"bclose_maybe_open","","",222,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"},{"name":"bool"}],"output":{"name":"result"}}],[11,"bclose","","",222,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"result"}}],[11,"in_cbox","","",222,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"break_offset_if_not_bol","","",222,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[11,"synth_comment","","",222,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"name":"result"}}],[11,"commasep_cmnt","","",222,null],[11,"commasep_exprs","","",222,null],[11,"print_mod","","",222,null],[11,"print_foreign_mod","","",222,null],[11,"print_opt_lifetime","","",222,{"inputs":[{"name":"self"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_type","","",222,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"result"}}],[11,"print_foreign_item","","",222,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"name":"result"}}],[11,"print_associated_const","","",222,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"ty"},{"generics":["expr"],"name":"option"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_associated_type","","",222,{"inputs":[{"name":"self"},{"name":"ident"},{"generics":["typarambounds"],"name":"option"},{"generics":["ty"],"name":"option"}],"output":{"name":"result"}}],[11,"print_item","","Pretty-print an item",222,{"inputs":[{"name":"self"},{"name":"item"}],"output":{"name":"result"}}],[11,"print_trait_ref","","",222,{"inputs":[{"name":"self"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"print_formal_generic_params","","",222,null],[11,"print_poly_trait_ref","","",222,{"inputs":[{"name":"self"},{"name":"polytraitref"}],"output":{"name":"result"}}],[11,"print_enum_def","","",222,{"inputs":[{"name":"self"},{"name":"enumdef"},{"name":"generics"},{"name":"ident"},{"name":"span"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_variants","","",222,null],[11,"print_visibility","","",222,{"inputs":[{"name":"self"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_defaultness","","",222,{"inputs":[{"name":"self"},{"name":"defaultness"}],"output":{"name":"result"}}],[11,"print_struct","","",222,{"inputs":[{"name":"self"},{"name":"variantdata"},{"name":"generics"},{"name":"ident"},{"name":"span"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_variant","","",222,{"inputs":[{"name":"self"},{"name":"variant"}],"output":{"name":"result"}}],[11,"print_method_sig","","",222,{"inputs":[{"name":"self"},{"name":"ident"},{"name":"generics"},{"name":"methodsig"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_trait_item","","",222,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"name":"result"}}],[11,"print_impl_item","","",222,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"name":"result"}}],[11,"print_stmt","","",222,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"name":"result"}}],[11,"print_block","","",222,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed","","",222,{"inputs":[{"name":"self"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed_with_attrs","","",222,null],[11,"print_block_unclosed_indent","","",222,{"inputs":[{"name":"self"},{"name":"block"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_block_with_attrs","","",222,null],[11,"print_block_maybe_unclosed","","",222,null],[11,"print_else","","",222,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"option"}],"output":{"name":"result"}}],[11,"print_if","","",222,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"block"},{"generics":["expr"],"name":"option"}],"output":{"name":"result"}}],[11,"print_if_let","","",222,null],[11,"print_mac","","",222,{"inputs":[{"name":"self"},{"name":"mac"},{"name":"delimtoken"}],"output":{"name":"result"}}],[11,"print_call_post","","",222,null],[11,"print_expr_maybe_paren","","",222,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"i8"}],"output":{"name":"result"}}],[11,"print_expr_as_cond","","Print an expr using syntax that's acceptable in a condition position, such as the `cond` in `if cond { ... }`.",222,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_vec","","",222,null],[11,"print_expr_repeat","","",222,null],[11,"print_expr_struct","","",222,null],[11,"print_expr_tup","","",222,null],[11,"print_expr_call","","",222,null],[11,"print_expr_method_call","","",222,null],[11,"print_expr_binary","","",222,{"inputs":[{"name":"self"},{"name":"binop"},{"name":"expr"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_unary","","",222,{"inputs":[{"name":"self"},{"name":"unop"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_addr_of","","",222,{"inputs":[{"name":"self"},{"name":"mutability"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr","","",222,{"inputs":[{"name":"self"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr_outer_attr_style","","",222,{"inputs":[{"name":"self"},{"name":"expr"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_local_decl","","",222,{"inputs":[{"name":"self"},{"name":"local"}],"output":{"name":"result"}}],[11,"print_ident","","",222,{"inputs":[{"name":"self"},{"name":"ident"}],"output":{"name":"result"}}],[11,"print_usize","","",222,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_name","","",222,{"inputs":[{"name":"self"},{"name":"name"}],"output":{"name":"result"}}],[11,"print_for_decl","","",222,{"inputs":[{"name":"self"},{"name":"local"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_path","","",222,{"inputs":[{"name":"self"},{"name":"path"},{"name":"bool"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_path_segment","","",222,{"inputs":[{"name":"self"},{"name":"pathsegment"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_qpath","","",222,{"inputs":[{"name":"self"},{"name":"path"},{"name":"qself"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_path_parameters","","",222,{"inputs":[{"name":"self"},{"name":"pathparameters"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_pat","","",222,{"inputs":[{"name":"self"},{"name":"pat"}],"output":{"name":"result"}}],[11,"print_pats","","",222,null],[11,"print_arm","","",222,{"inputs":[{"name":"self"},{"name":"arm"}],"output":{"name":"result"}}],[11,"print_explicit_self","","",222,{"inputs":[{"name":"self"},{"name":"explicitself"}],"output":{"name":"result"}}],[11,"print_fn","","",222,{"inputs":[{"name":"self"},{"name":"fndecl"},{"name":"unsafety"},{"name":"constness"},{"name":"abi"},{"generics":["ident"],"name":"option"},{"name":"generics"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_fn_args_and_ret","","",222,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_fn_block_args","","",222,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_movability","","",222,{"inputs":[{"name":"self"},{"name":"movability"}],"output":{"name":"result"}}],[11,"print_capture_clause","","",222,{"inputs":[{"name":"self"},{"name":"captureby"}],"output":{"name":"result"}}],[11,"print_bounds","","",222,null],[11,"print_lifetime","","",222,{"inputs":[{"name":"self"},{"name":"lifetime"}],"output":{"name":"result"}}],[11,"print_lifetime_bounds","","",222,null],[11,"print_generic_params","","",222,null],[11,"print_ty_param","","",222,{"inputs":[{"name":"self"},{"name":"typaram"}],"output":{"name":"result"}}],[11,"print_where_clause","","",222,{"inputs":[{"name":"self"},{"name":"whereclause"}],"output":{"name":"result"}}],[11,"print_use_tree","","",222,{"inputs":[{"name":"self"},{"name":"usetree"}],"output":{"name":"result"}}],[11,"print_mutability","","",222,{"inputs":[{"name":"self"},{"name":"mutability"}],"output":{"name":"result"}}],[11,"print_mt","","",222,{"inputs":[{"name":"self"},{"name":"mutty"}],"output":{"name":"result"}}],[11,"print_arg","","",222,{"inputs":[{"name":"self"},{"name":"arg"},{"name":"bool"}],"output":{"name":"result"}}],[11,"print_fn_output","","",222,{"inputs":[{"name":"self"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_ty_fn","","",222,{"inputs":[{"name":"self"},{"name":"abi"},{"name":"unsafety"},{"name":"fndecl"},{"generics":["ident"],"name":"option"},{"name":"vec"}],"output":{"name":"result"}}],[11,"maybe_print_trailing_comment","","",222,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["bytepos"],"name":"option"}],"output":{"name":"result"}}],[11,"print_remaining_comments","","",222,{"inputs":[{"name":"self"}],"output":{"name":"result"}}],[11,"print_opt_abi_and_extern_if_nondefault","","",222,{"inputs":[{"name":"self"},{"generics":["abi"],"name":"option"}],"output":{"name":"result"}}],[11,"print_extern_opt_abi","","",222,{"inputs":[{"name":"self"},{"generics":["abi"],"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_header_info","","",222,{"inputs":[{"name":"self"},{"name":"unsafety"},{"name":"constness"},{"name":"abi"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_unsafety","","",222,{"inputs":[{"name":"self"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"print_is_auto","","",222,{"inputs":[{"name":"self"},{"name":"isauto"}],"output":{"name":"result"}}],[0,"ext","syntax","",null,null],[0,"hygiene","syntax::ext","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",null,null],[3,"SyntaxContext","syntax::ext::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",null,null],[12,"0","","",227,null],[3,"SyntaxContextData","","",null,null],[12,"outer_mark","","",228,null],[12,"prev_ctxt","","",228,null],[12,"modern","","",228,null],[3,"Mark","","A mark is a unique id associated with a macro expansion.",null,null],[12,"0","","",229,null],[4,"MarkKind","","",null,null],[13,"Modern","","",230,null],[13,"Builtin","","",230,null],[13,"Legacy","","",230,null],[3,"HygieneData","","",null,null],[12,"marks","","",231,null],[12,"syntax_contexts","","",231,null],[12,"markings","","",231,null],[12,"gensym_to_ctxt","","",231,null],[5,"clear_markings","","",null,null],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",null,null],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",136,null],[12,"callee","","Information about the expansion.",136,null],[3,"NameAndSpan","","",null,null],[12,"format","","The format with which the macro was invoked.",137,null],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",137,null],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",137,null],[12,"span","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None.",137,null],[4,"ExpnFormat","","The source of expansion.",null,null],[13,"MacroAttribute","","e.g. #[derive(...)] ",135,null],[13,"MacroBang","","e.g. `format!()`",135,null],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",135,null],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",null,null],[13,"DotFill","","",232,null],[13,"QuestionMark","","",232,null],[13,"Catch","","",232,null],[0,"base","syntax::ext","",null,null],[3,"MacEager","syntax::ext::base","`MacResult` implementation for the common case where you've already built each form of AST that you might return.",null,null],[12,"expr","","",233,null],[12,"pat","","",233,null],[12,"items","","",233,null],[12,"impl_items","","",233,null],[12,"trait_items","","",233,null],[12,"foreign_items","","",233,null],[12,"stmts","","",233,null],[12,"ty","","",233,null],[3,"DummyResult","","Fill-in macro expansion result, to allow compilation to continue after hitting errors.",null,null],[12,"expr_only","","",234,null],[12,"span","","",234,null],[3,"DummyResolver","","",null,null],[3,"ModuleData","","",null,null],[12,"mod_path","","",235,null],[12,"directory","","",235,null],[3,"ExpansionData","","",null,null],[12,"mark","","",236,null],[12,"depth","","",236,null],[12,"module","","",236,null],[12,"directory_ownership","","",236,null],[12,"crate_span","","",236,null],[3,"ExtCtxt","","One of these is made during expansion and incrementally updated as we go; when a macro expansion occurs, the resulting nodes have the `backtrace() -> expn_info` of their expansion context stored into their span.",null,null],[12,"parse_sess","","",237,null],[12,"ecfg","","",237,null],[12,"root_path","","",237,null],[12,"resolver","","",237,null],[12,"resolve_err_count","","",237,null],[12,"current_expansion","","",237,null],[12,"expansions","","",237,null],[4,"Annotatable","","",null,null],[13,"Item","","",238,null],[13,"TraitItem","","",238,null],[13,"ImplItem","","",238,null],[13,"ForeignItem","","",238,null],[13,"Stmt","","",238,null],[13,"Expr","","",238,null],[4,"MacroKind","","Represents different kinds of macro invocations that can be resolved.",null,null],[13,"Bang","","A bang macro - foo!()",239,null],[13,"Attr","","An attribute macro - #[foo]",239,null],[13,"Derive","","A derive attribute macro - #[derive(Foo)]",239,null],[4,"SyntaxExtension","","An enum representing the different kinds of syntax extensions.",null,null],[13,"MultiDecorator","","A syntax extension that is attached to an item and creates new items based upon it.",240,null],[13,"MultiModifier","","A syntax extension that is attached to an item and modifies it in-place. Also allows decoration, i.e., creating new items.",240,null],[13,"ProcMacro","","A function-like procedural macro. TokenStream -> TokenStream.",240,null],[13,"AttrProcMacro","","An attribute-like procedural macro. TokenStream, TokenStream -> TokenStream. The first TokenSteam is the attribute, the second is the annotated item. Allows modification of the input items and adding new items, similar to MultiModifier, but uses TokenStreams, rather than AST nodes.",240,null],[13,"NormalTT","","A normal, function-like syntax extension.",240,null],[12,"expander","syntax::ext::base::SyntaxExtension","",240,null],[12,"def_info","","",240,null],[12,"allow_internal_unstable","","Whether the contents of the macro can directly use `#[unstable]` things (true == yes).",240,null],[12,"allow_internal_unsafe","","Whether the contents of the macro can use `unsafe` without triggering the `unsafe_code` lint.",240,null],[12,"unstable_feature","","The macro's feature name if it is unstable, and the stability feature",240,null],[13,"IdentTT","syntax::ext::base","A function-like syntax extension that has an extra ident before the block.",240,null],[13,"ProcMacroDerive","","An attribute-like procedural macro. TokenStream -> TokenStream. The input is the annotated item. Allows generating code to implement a Trait for a given struct or enum item.",240,null],[13,"BuiltinDerive","","An attribute-like procedural macro that derives a builtin trait.",240,null],[13,"DeclMacro","","A declarative macro, e.g. `macro m() {}`.",240,null],[4,"Determinacy","","",null,null],[13,"Determined","","",241,null],[13,"Undetermined","","",241,null],[5,"expr_to_spanned_string","","Extract a string literal from the macro expanded version of `expr`, emitting `err_msg` if `expr` is not a string literal. This does not stop compilation on error, merely emits a non-fatal error and returns None.",null,{"inputs":[{"name":"extctxt"},{"generics":["expr"],"name":"p"},{"name":"str"}],"output":{"generics":["spanned"],"name":"option"}}],[5,"expr_to_string","","",null,{"inputs":[{"name":"extctxt"},{"generics":["expr"],"name":"p"},{"name":"str"}],"output":{"name":"option"}}],[5,"check_zero_tts","","Non-fatally assert that `tts` is empty. Note that this function returns even when `tts` is non-empty, macros that need to stop compilation should call `cx.parse_sess.span_diagnostic.abort_if_errors()` (this should be done as rarely as possible).",null,null],[5,"get_single_str_from_tts","","Interpreting `tts` as a comma-separated sequence of expressions, expect exactly one string literal, or emit an error and return None.",null,null],[5,"get_exprs_from_tts","","Extract comma-separated expressions from `tts`. If there is a parsing error, emit a non-fatal error and return None.",null,null],[6,"MacroExpanderFn","","",null,null],[6,"IdentMacroExpanderFn","","",null,null],[6,"BuiltinDeriveFn","","",null,null],[6,"NamedSyntaxExtension","","",null,null],[8,"MultiItemDecorator","","",null,null],[10,"expand","","",242,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[8,"MultiItemModifier","","",null,null],[10,"expand","","",243,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"}],"output":{"generics":["annotatable"],"name":"vec"}}],[8,"ProcMacro","","",null,null],[10,"expand","","",244,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[8,"AttrProcMacro","","",null,null],[10,"expand","","",245,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[8,"TTMacroExpander","","Represents a thing that maps token trees to Macro Results",null,null],[10,"expand","","",246,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"}],"output":{"generics":["macresult"],"name":"box"}}],[8,"IdentMacroExpander","","",null,null],[10,"expand","","",247,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"generics":["tokentree"],"name":"vec"}],"output":{"generics":["macresult"],"name":"box"}}],[8,"MacResult","","The result of a macro expansion. The return values of the various methods are spliced into the AST at the callsite of the macro.",null,null],[11,"make_expr","","Create an expression.",248,{"inputs":[{"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_items","","Create zero or more items.",248,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_impl_items","","Create zero or more impl items.",248,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_trait_items","","Create zero or more trait items.",248,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_foreign_items","","Create zero or more items in an `extern {}` block",248,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_pat","","Create a pattern.",248,{"inputs":[{"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_stmts","","Create zero or more statements.",248,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_ty","","",248,{"inputs":[{"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[8,"Resolver","","",null,null],[10,"next_node_id","","",249,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[10,"get_module_scope","","",249,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"mark"}}],[10,"eliminate_crate_var","","",249,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"is_whitelisted_legacy_custom_derive","","",249,{"inputs":[{"name":"self"},{"name":"name"}],"output":{"name":"bool"}}],[10,"visit_expansion","","",249,null],[10,"add_builtin","","",249,{"inputs":[{"name":"self"},{"name":"ident"},{"generics":["syntaxextension"],"name":"lrc"}],"output":null}],[10,"resolve_imports","","",249,{"inputs":[{"name":"self"}],"output":null}],[10,"find_legacy_attr_invoc","","",249,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"bool"}],"output":{"generics":["attribute"],"name":"option"}}],[10,"resolve_invoc","","",249,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"mark"},{"name":"bool"}],"output":{"generics":["option","determinacy"],"name":"result"}}],[10,"resolve_macro","","",249,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"path"},{"name":"macrokind"},{"name":"bool"}],"output":{"generics":["lrc","determinacy"],"name":"result"}}],[10,"check_unused_macros","","",249,{"inputs":[{"name":"self"}],"output":null}],[11,"fmt","","",238,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"self"}],"output":{"name":"annotatable"}}],[11,"attrs","","",238,null],[11,"map_attrs","","",238,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"span","","",238,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"expect_item","","",238,{"inputs":[{"name":"self"}],"output":{"generics":["item"],"name":"p"}}],[11,"map_item_or","","",238,{"inputs":[{"name":"self"},{"name":"f"},{"name":"g"}],"output":{"name":"annotatable"}}],[11,"expect_trait_item","","",238,{"inputs":[{"name":"self"}],"output":{"name":"traititem"}}],[11,"expect_impl_item","","",238,{"inputs":[{"name":"self"}],"output":{"name":"implitem"}}],[11,"expect_foreign_item","","",238,{"inputs":[{"name":"self"}],"output":{"name":"foreignitem"}}],[11,"expect_stmt","","",238,{"inputs":[{"name":"self"}],"output":{"name":"stmt"}}],[11,"expect_expr","","",238,{"inputs":[{"name":"self"}],"output":{"generics":["expr"],"name":"p"}}],[11,"derive_allowed","","",238,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"into","","",238,{"inputs":[{"name":"self"}],"output":{"generics":["annotatable"],"name":"vec"}}],[11,"default","","",233,{"inputs":[],"output":{"name":"maceager"}}],[11,"expr","","",233,{"inputs":[{"generics":["expr"],"name":"p"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"pat","","",233,{"inputs":[{"generics":["pat"],"name":"p"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"items","","",233,{"inputs":[{"generics":["p"],"name":"smallvector"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"impl_items","","",233,{"inputs":[{"generics":["implitem"],"name":"smallvector"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"trait_items","","",233,{"inputs":[{"generics":["traititem"],"name":"smallvector"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"foreign_items","","",233,{"inputs":[{"generics":["foreignitem"],"name":"smallvector"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"stmts","","",233,{"inputs":[{"generics":["stmt"],"name":"smallvector"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"ty","","",233,{"inputs":[{"generics":["ty"],"name":"p"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"make_expr","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_items","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_impl_items","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_trait_items","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_foreign_items","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_stmts","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_pat","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_ty","","",233,{"inputs":[{"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"clone","","",234,{"inputs":[{"name":"self"}],"output":{"name":"dummyresult"}}],[11,"any","","Create a default MacResult that can be anything.",234,{"inputs":[{"name":"span"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"expr","","Create a default MacResult that can only be an expression.",234,{"inputs":[{"name":"span"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"raw_expr","","A plain dummy expression.",234,{"inputs":[{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"raw_pat","","A plain dummy pattern.",234,{"inputs":[{"name":"span"}],"output":{"name":"pat"}}],[11,"raw_ty","","",234,{"inputs":[{"name":"span"}],"output":{"generics":["ty"],"name":"p"}}],[11,"make_expr","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_pat","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_items","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_impl_items","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_trait_items","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_foreign_items","","",234,{"inputs":[{"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_stmts","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_ty","","",234,{"inputs":[{"generics":["dummyresult"],"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"clone","","",239,{"inputs":[{"name":"self"}],"output":{"name":"macrokind"}}],[11,"eq","","",239,{"inputs":[{"name":"self"},{"name":"macrokind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",239,null],[11,"encode","","",239,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",239,{"inputs":[{"name":"__d"}],"output":{"generics":["macrokind"],"name":"result"}}],[11,"hash","","",239,null],[11,"fmt","","",239,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"kind","","Return which kind of macro calls this syntax extension.",240,{"inputs":[{"name":"self"}],"output":{"name":"macrokind"}}],[11,"is_modern","","",240,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",241,{"inputs":[{"name":"self"}],"output":{"name":"determinacy"}}],[11,"fmt","","",241,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",241,{"inputs":[{"name":"self"},{"name":"determinacy"}],"output":{"name":"bool"}}],[11,"next_node_id","","",250,{"inputs":[{"name":"self"}],"output":{"name":"nodeid"}}],[11,"get_module_scope","","",250,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"mark"}}],[11,"eliminate_crate_var","","",250,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"is_whitelisted_legacy_custom_derive","","",250,{"inputs":[{"name":"self"},{"name":"name"}],"output":{"name":"bool"}}],[11,"visit_expansion","","",250,null],[11,"add_builtin","","",250,{"inputs":[{"name":"self"},{"name":"ident"},{"generics":["syntaxextension"],"name":"lrc"}],"output":null}],[11,"resolve_imports","","",250,{"inputs":[{"name":"self"}],"output":null}],[11,"find_legacy_attr_invoc","","",250,{"inputs":[{"name":"self"},{"name":"vec"},{"name":"bool"}],"output":{"generics":["attribute"],"name":"option"}}],[11,"resolve_invoc","","",250,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"mark"},{"name":"bool"}],"output":{"generics":["option","determinacy"],"name":"result"}}],[11,"resolve_macro","","",250,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"path"},{"name":"macrokind"},{"name":"bool"}],"output":{"generics":["lrc","determinacy"],"name":"result"}}],[11,"check_unused_macros","","",250,{"inputs":[{"name":"self"}],"output":null}],[11,"clone","","",235,{"inputs":[{"name":"self"}],"output":{"name":"moduledata"}}],[11,"clone","","",236,{"inputs":[{"name":"self"}],"output":{"name":"expansiondata"}}],[11,"new","","",237,{"inputs":[{"name":"parsesess"},{"name":"expansionconfig"},{"name":"resolver"}],"output":{"name":"extctxt"}}],[11,"expander","","Returns a `Folder` for deeply expanding all macros in an AST node.",237,{"inputs":[{"name":"self"}],"output":{"name":"macroexpander"}}],[11,"monotonic_expander","","Returns a `Folder` that deeply expands all macros and assigns all node ids in an AST node. Once node ids are assigned, the node may not be expanded, removed, or otherwise modified.",237,{"inputs":[{"name":"self"}],"output":{"name":"macroexpander"}}],[11,"new_parser_from_tts","","",237,null],[11,"codemap","","",237,{"inputs":[{"name":"self"}],"output":{"name":"codemap"}}],[11,"parse_sess","","",237,{"inputs":[{"name":"self"}],"output":{"name":"parsesess"}}],[11,"cfg","","",237,{"inputs":[{"name":"self"}],"output":{"name":"crateconfig"}}],[11,"call_site","","",237,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"backtrace","","",237,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"expansion_cause","","Returns span for the macro which originally caused the current expansion to happen.",237,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"option"}}],[11,"struct_span_warn","","",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_err","","",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"struct_span_fatal","","",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_fatal","","Emit `msg` attached to `sp`, and stop compilation immediately.",237,null],[11,"span_err","","Emit `msg` attached to `sp`, without immediately stopping compilation.",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_err_with_code","","",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"},{"name":"diagnosticid"}],"output":null}],[11,"mut_span_err","","",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":{"name":"diagnosticbuilder"}}],[11,"span_warn","","",237,{"inputs":[{"name":"self"},{"name":"s"},{"name":"str"}],"output":null}],[11,"span_unimpl","","",237,null],[11,"span_bug","","",237,null],[11,"trace_macros_diag","","",237,{"inputs":[{"name":"self"}],"output":null}],[11,"bug","","",237,null],[11,"trace_macros","","",237,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"set_trace_macros","","",237,{"inputs":[{"name":"self"},{"name":"bool"}],"output":null}],[11,"ident_of","","",237,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"ident"}}],[11,"std_path","","",237,null],[11,"name_of","","",237,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"name"}}],[11,"check_unused_macros","","",237,{"inputs":[{"name":"self"}],"output":null}],[0,"build","syntax::ext","",null,null],[0,"syntax","syntax::ext::build","",null,null],[8,"AstBuilder","","",null,null],[10,"path","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"}],"output":{"name":"path"}}],[10,"path_ident","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[10,"path_global","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"}],"output":{"name":"path"}}],[10,"path_all","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"},{"generics":["ident"],"name":"vec"},{"generics":["lifetime"],"name":"vec"},{"generics":["p"],"name":"vec"},{"generics":["typebinding"],"name":"vec"}],"output":{"name":"path"}}],[10,"qpath","","",251,null],[10,"qpath_all","","",251,null],[10,"ty_mt","","",251,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"},{"name":"mutability"}],"output":{"name":"mutty"}}],[10,"ty","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"tykind"}],"output":{"generics":["ty"],"name":"p"}}],[10,"ty_path","","",251,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["ty"],"name":"p"}}],[10,"ty_ident","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["ty"],"name":"p"}}],[10,"ty_rptr","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"p"},{"generics":["lifetime"],"name":"option"},{"name":"mutability"}],"output":{"generics":["ty"],"name":"p"}}],[10,"ty_ptr","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"p"},{"name":"mutability"}],"output":{"generics":["ty"],"name":"p"}}],[10,"ty_option","","",251,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"}],"output":{"generics":["ty"],"name":"p"}}],[10,"ty_infer","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["ty"],"name":"p"}}],[10,"typaram","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"name":"typarambounds"},{"generics":["p"],"name":"option"}],"output":{"name":"typaram"}}],[10,"trait_ref","","",251,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"traitref"}}],[10,"poly_trait_ref","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"}],"output":{"name":"polytraitref"}}],[10,"typarambound","","",251,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"typarambound"}}],[10,"lifetime","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"name":"lifetime"}}],[10,"lifetime_def","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"generics":["lifetime"],"name":"vec"}],"output":{"name":"lifetimedef"}}],[10,"stmt_expr","","",251,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[10,"stmt_semi","","",251,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[10,"stmt_let","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[10,"stmt_let_typed","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[10,"stmt_let_type_only","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"p"}],"output":{"name":"stmt"}}],[10,"stmt_item","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["item"],"name":"p"}],"output":{"name":"stmt"}}],[10,"block","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"vec"}],"output":{"generics":["block"],"name":"p"}}],[10,"block_expr","","",251,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["block"],"name":"p"}}],[10,"expr","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"exprkind"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_path","","",251,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_qpath","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"qself"},{"name":"path"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_ident","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_self","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_binary","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"binopkind"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_deref","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_unary","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"unop"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_addr_of","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_mut_addr_of","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_field_access","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_tup_field_access","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"usize"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_call","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_call_ident","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_call_global","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_method_call","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"ident"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_block","","",251,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_cast","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["ty"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"field_imm","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["expr"],"name":"p"}],"output":{"name":"field"}}],[10,"expr_struct","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["field"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_struct_ident","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["field"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_lit","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"litkind"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_usize","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_isize","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"isize"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_u8","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"u8"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_u16","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"u16"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_u32","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"u32"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_bool","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_vec","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_vec_ng","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_vec_slice","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_str","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"symbol"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_some","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_none","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_break","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_tuple","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_fail","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"symbol"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_unreachable","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_ok","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_err","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_try","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"pat","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"patkind"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_wild","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_lit","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_ident","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_ident_binding_mode","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"bindingmode"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_path","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_tuple_struct","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["p"],"name":"vec"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_struct","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["spanned"],"name":"vec"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_tuple","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_some","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_none","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_ok","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[10,"pat_err","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[10,"arm","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"},{"generics":["expr"],"name":"p"}],"output":{"name":"arm"}}],[10,"arm_unreachable","","",251,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"arm"}}],[10,"expr_match","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["arm"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_if","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"},{"generics":["p"],"name":"option"}],"output":{"generics":["expr"],"name":"p"}}],[10,"expr_loop","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["block"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda_fn_decl","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["fndecl"],"name":"p"},{"generics":["expr"],"name":"p"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda0","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda1","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda_stmts","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"},{"generics":["stmt"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda_stmts_0","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[10,"lambda_stmts_1","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"vec"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[10,"item","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"name":"itemkind"}],"output":{"generics":["item"],"name":"p"}}],[10,"arg","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"}],"output":{"name":"arg"}}],[10,"fn_decl","","",251,{"inputs":[{"name":"self"},{"generics":["arg"],"name":"vec"},{"name":"functionretty"}],"output":{"generics":["fndecl"],"name":"p"}}],[10,"item_fn_poly","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["arg"],"name":"vec"},{"generics":["ty"],"name":"p"},{"name":"generics"},{"generics":["block"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_fn","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["arg"],"name":"vec"},{"generics":["ty"],"name":"p"},{"generics":["block"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"variant","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["p"],"name":"vec"}],"output":{"name":"variant"}}],[10,"item_enum_poly","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_enum","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"enumdef"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_struct_poly","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"variantdata"},{"name":"generics"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_struct","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"variantdata"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_mod","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"generics":["p"],"name":"vec"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_extern_crate","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_static","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"name":"mutability"},{"generics":["expr"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_const","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_ty_poly","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"name":"generics"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_ty","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"attribute","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"metaitem"}],"output":{"name":"attribute"}}],[10,"meta_word","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":{"name":"metaitem"}}],[10,"meta_list_item_word","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":{"name":"nestedmetaitem"}}],[10,"meta_list","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"generics":["nestedmetaitem"],"name":"vec"}],"output":{"name":"metaitem"}}],[10,"meta_name_value","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"litkind"}],"output":{"name":"metaitem"}}],[10,"item_use","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["usetree"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_use_simple","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"name":"path"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_use_simple_","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["ident"],"name":"option"},{"name":"path"}],"output":{"generics":["item"],"name":"p"}}],[10,"item_use_list","","",251,null],[10,"item_use_glob","","",251,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["ident"],"name":"vec"}],"output":{"generics":["item"],"name":"p"}}],[11,"path","syntax::ext::base","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"}],"output":{"name":"path"}}],[11,"path_ident","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[11,"path_global","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"}],"output":{"name":"path"}}],[11,"path_all","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"},{"generics":["ident"],"name":"vec"},{"generics":["lifetime"],"name":"vec"},{"generics":["p"],"name":"vec"},{"generics":["typebinding"],"name":"vec"}],"output":{"name":"path"}}],[11,"qpath","","Constructs a qualified path.",237,null],[11,"qpath_all","","Constructs a qualified path.",237,null],[11,"ty_mt","","",237,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"},{"name":"mutability"}],"output":{"name":"mutty"}}],[11,"ty","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"tykind"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ty_path","","",237,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ty_ident","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ty_rptr","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"p"},{"generics":["lifetime"],"name":"option"},{"name":"mutability"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ty_ptr","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"p"},{"name":"mutability"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ty_option","","",237,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"}],"output":{"generics":["ty"],"name":"p"}}],[11,"ty_infer","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["ty"],"name":"p"}}],[11,"typaram","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"name":"typarambounds"},{"generics":["p"],"name":"option"}],"output":{"name":"typaram"}}],[11,"trait_ref","","",237,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"traitref"}}],[11,"poly_trait_ref","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"}],"output":{"name":"polytraitref"}}],[11,"typarambound","","",237,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"typarambound"}}],[11,"lifetime","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"name":"lifetime"}}],[11,"lifetime_def","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"generics":["lifetime"],"name":"vec"}],"output":{"name":"lifetimedef"}}],[11,"stmt_expr","","",237,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[11,"stmt_semi","","",237,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[11,"stmt_let","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[11,"stmt_let_typed","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[11,"stmt_let_type_only","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ty"],"name":"p"}],"output":{"name":"stmt"}}],[11,"stmt_item","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["item"],"name":"p"}],"output":{"name":"stmt"}}],[11,"block_expr","","",237,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["block"],"name":"p"}}],[11,"block","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"vec"}],"output":{"generics":["block"],"name":"p"}}],[11,"expr","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"exprkind"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_path","","",237,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_qpath","","Constructs a QPath expression.",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"qself"},{"name":"path"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_ident","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_self","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_binary","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"binopkind"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_deref","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_unary","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"unop"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_field_access","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_tup_field_access","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"usize"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_addr_of","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_mut_addr_of","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_call","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_call_ident","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_call_global","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_method_call","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"ident"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_block","","",237,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"field_imm","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["expr"],"name":"p"}],"output":{"name":"field"}}],[11,"expr_struct","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["field"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_struct_ident","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["field"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_lit","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"litkind"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_usize","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"usize"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_isize","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"isize"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_u32","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"u32"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_u16","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"u16"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_u8","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"u8"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_bool","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"bool"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_vec","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_vec_ng","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_vec_slice","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_str","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"symbol"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_cast","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["ty"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_some","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_none","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_break","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_tuple","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_fail","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"symbol"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_unreachable","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_ok","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_err","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_try","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"pat","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"patkind"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_wild","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_lit","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_ident","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_ident_binding_mode","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"bindingmode"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_path","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_tuple_struct","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["p"],"name":"vec"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_struct","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"path"},{"generics":["spanned"],"name":"vec"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_tuple","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_some","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_none","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_ok","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"pat_err","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"arm","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["p"],"name":"vec"},{"generics":["expr"],"name":"p"}],"output":{"name":"arm"}}],[11,"arm_unreachable","","",237,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"arm"}}],[11,"expr_match","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["arm"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_if","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["expr"],"name":"p"},{"generics":["p"],"name":"option"}],"output":{"generics":["expr"],"name":"p"}}],[11,"expr_loop","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["block"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda_fn_decl","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["fndecl"],"name":"p"},{"generics":["expr"],"name":"p"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda0","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda1","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["expr"],"name":"p"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda_stmts","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["ident"],"name":"vec"},{"generics":["stmt"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda_stmts_0","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[11,"lambda_stmts_1","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"generics":["stmt"],"name":"vec"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[11,"arg","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"}],"output":{"name":"arg"}}],[11,"fn_decl","","",237,{"inputs":[{"name":"self"},{"generics":["arg"],"name":"vec"},{"name":"functionretty"}],"output":{"generics":["fndecl"],"name":"p"}}],[11,"item","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"name":"itemkind"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_fn_poly","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["arg"],"name":"vec"},{"generics":["ty"],"name":"p"},{"name":"generics"},{"generics":["block"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_fn","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["arg"],"name":"vec"},{"generics":["ty"],"name":"p"},{"generics":["block"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"variant","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["p"],"name":"vec"}],"output":{"name":"variant"}}],[11,"item_enum_poly","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_enum","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"enumdef"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_struct","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"variantdata"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_struct_poly","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"name":"variantdata"},{"name":"generics"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_mod","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"},{"name":"ident"},{"generics":["attribute"],"name":"vec"},{"generics":["p"],"name":"vec"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_extern_crate","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_static","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"name":"mutability"},{"generics":["expr"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_const","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"generics":["expr"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_ty_poly","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"},{"name":"generics"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_ty","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"ident"},{"generics":["ty"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"attribute","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"metaitem"}],"output":{"name":"attribute"}}],[11,"meta_word","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":{"name":"metaitem"}}],[11,"meta_list_item_word","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"}],"output":{"name":"nestedmetaitem"}}],[11,"meta_list","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"generics":["nestedmetaitem"],"name":"vec"}],"output":{"name":"metaitem"}}],[11,"meta_name_value","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"name"},{"name":"litkind"}],"output":{"name":"metaitem"}}],[11,"item_use","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["usetree"],"name":"p"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_use_simple","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"name":"path"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_use_simple_","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["ident"],"name":"option"},{"name":"path"}],"output":{"generics":["item"],"name":"p"}}],[11,"item_use_list","","",237,null],[11,"item_use_glob","","",237,{"inputs":[{"name":"self"},{"name":"span"},{"name":"visibility"},{"generics":["ident"],"name":"vec"}],"output":{"generics":["item"],"name":"p"}}],[0,"derive","syntax::ext","",null,null],[5,"collect_derives","syntax::ext::derive","",null,{"inputs":[{"name":"extctxt"},{"name":"vec"}],"output":{"generics":["path"],"name":"vec"}}],[5,"add_derived_markers","","",null,null],[0,"expand","syntax::ext","",null,null],[3,"Invocation","syntax::ext::expand","",null,null],[12,"kind","","",252,null],[12,"expansion_kind","","",252,null],[12,"expansion_data","","",252,null],[3,"MacroExpander","","",null,null],[12,"cx","","",253,null],[12,"monotonic","","",253,null],[3,"InvocationCollector","","",null,null],[12,"cx","","",254,null],[12,"cfg","","",254,null],[12,"invocations","","",254,null],[12,"monotonic","","",254,null],[3,"ExpansionConfig","","",null,null],[12,"crate_name","","",255,null],[12,"features","","",255,null],[12,"recursion_limit","","",255,null],[12,"trace_mac","","",255,null],[12,"should_test","","",255,null],[12,"single_step","","",255,null],[12,"keep_macs","","",255,null],[3,"Marker","","",null,null],[12,"0","","",256,null],[4,"ExpansionKind","","",null,null],[13,"OptExpr","","",257,null],[13,"Expr","","",257,null],[13,"Pat","","",257,null],[13,"Ty","","",257,null],[13,"Stmts","","",257,null],[13,"Items","","",257,null],[13,"TraitItems","","",257,null],[13,"ImplItems","","",257,null],[13,"ForeignItems","","",257,null],[4,"Expansion","","",null,null],[13,"OptExpr","","",258,null],[13,"Expr","","",258,null],[13,"Pat","","",258,null],[13,"Ty","","",258,null],[13,"Stmts","","",258,null],[13,"Items","","",258,null],[13,"TraitItems","","",258,null],[13,"ImplItems","","",258,null],[13,"ForeignItems","","",258,null],[4,"InvocationKind","","",null,null],[13,"Bang","","",259,null],[12,"mac","syntax::ext::expand::InvocationKind","",259,null],[12,"ident","","",259,null],[12,"span","","",259,null],[13,"Attr","syntax::ext::expand","",259,null],[12,"attr","syntax::ext::expand::InvocationKind","",259,null],[12,"traits","","",259,null],[12,"item","","",259,null],[13,"Derive","syntax::ext::expand","",259,null],[12,"path","syntax::ext::expand::InvocationKind","",259,null],[12,"item","","",259,null],[5,"macro_bang_format","syntax::ext::expand","",null,{"inputs":[{"name":"path"}],"output":{"name":"expnformat"}}],[5,"find_attr_invoc","","",null,{"inputs":[{"name":"vec"}],"output":{"generics":["attribute"],"name":"option"}}],[11,"clone","","",257,{"inputs":[{"name":"self"}],"output":{"name":"expansionkind"}}],[11,"eq","","",257,{"inputs":[{"name":"self"},{"name":"expansionkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",257,null],[11,"name","","",257,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"make_from","","",257,{"inputs":[{"name":"self"},{"generics":["macresult"],"name":"box"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"make_opt_expr","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_expr","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["expr"],"name":"p"}}],[11,"make_pat","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["pat"],"name":"p"}}],[11,"make_ty","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["ty"],"name":"p"}}],[11,"make_stmts","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"make_items","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"make_trait_items","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"make_impl_items","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"make_foreign_items","","",258,{"inputs":[{"name":"self"}],"output":{"generics":["foreignitem"],"name":"smallvector"}}],[11,"fold_with","","",258,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"visit_with","","",258,{"inputs":[{"name":"self"},{"name":"v"}],"output":null}],[11,"fold_opt_expr","","",253,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["p"],"name":"option"}}],[11,"fold_expr","","",253,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"fold_pat","","",253,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"fold_ty","","",253,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"}],"output":{"generics":["ty"],"name":"p"}}],[11,"fold_stmt","","",253,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"fold_item","","",253,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_trait_item","","",253,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"fold_impl_item","","",253,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"fold_foreign_item","","",253,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"generics":["foreignitem"],"name":"smallvector"}}],[11,"dummy","","",257,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"expect_from_annotatables","","",257,{"inputs":[{"name":"self"},{"name":"i"}],"output":{"name":"expansion"}}],[11,"span","","",252,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"new","","",253,{"inputs":[{"name":"extctxt"},{"name":"bool"}],"output":{"name":"self"}}],[11,"expand_crate","","",253,{"inputs":[{"name":"self"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"expand","","",253,{"inputs":[{"name":"self"},{"name":"expansion"}],"output":{"name":"expansion"}}],[11,"resolve_imports","","",253,{"inputs":[{"name":"self"}],"output":null}],[11,"collect_invocations","","",253,null],[11,"fully_configure","","",253,{"inputs":[{"name":"self"},{"name":"annotatable"}],"output":{"name":"annotatable"}}],[11,"expand_invoc","","",253,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"syntaxextension"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"expand_attr_invoc","","",253,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"syntaxextension"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"extract_proc_macro_attr_input","","",253,{"inputs":[{"name":"self"},{"name":"tokenstream"},{"name":"span"}],"output":{"name":"tokenstream"}}],[11,"gate_proc_macro_attr_item","","",253,{"inputs":[{"name":"self"},{"name":"span"},{"name":"annotatable"}],"output":null}],[11,"expand_bang_invoc","","Expand a macro invocation. Returns the result of expansion.",253,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"syntaxextension"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"gate_proc_macro_expansion_kind","","",253,{"inputs":[{"name":"self"},{"name":"span"},{"name":"expansionkind"}],"output":null}],[11,"expand_derive_invoc","","Expand a derive invocation. Returns the result of expansion.",253,{"inputs":[{"name":"self"},{"name":"invocation"},{"name":"syntaxextension"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"parse_expansion","","",253,{"inputs":[{"name":"self"},{"name":"tokenstream"},{"name":"expansionkind"},{"name":"path"},{"name":"span"}],"output":{"generics":["expansion"],"name":"option"}}],[11,"parse_expansion","syntax::parse::parser","",164,{"inputs":[{"name":"self"},{"name":"expansionkind"},{"name":"bool"}],"output":{"generics":["expansion"],"name":"presult"}}],[11,"ensure_complete_parse","","",164,{"inputs":[{"name":"self"},{"name":"path"},{"name":"str"},{"name":"span"}],"output":null}],[11,"collect","syntax::ext::expand","",254,{"inputs":[{"name":"self"},{"name":"expansionkind"},{"name":"invocationkind"}],"output":{"name":"expansion"}}],[11,"collect_bang","","",254,{"inputs":[{"name":"self"},{"name":"mac"},{"name":"span"},{"name":"expansionkind"}],"output":{"name":"expansion"}}],[11,"collect_attr","","",254,{"inputs":[{"name":"self"},{"generics":["attribute"],"name":"option"},{"generics":["path"],"name":"vec"},{"name":"annotatable"},{"name":"expansionkind"}],"output":{"name":"expansion"}}],[11,"classify_item","","If `item` is an attr invocation, remove and return the macro attribute and derive traits.",254,null],[11,"classify_nonitem","","Alternative of `classify_item()` that ignores `#[derive]` so invocations fallthrough to the unused-attributes lint (making it an error on statements and expressions is a breaking change)",254,null],[11,"configure","","",254,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"option"}}],[11,"check_attributes","","",254,null],[11,"check_attribute","","",254,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"check_attribute_inner","","",254,{"inputs":[{"name":"self"},{"name":"attribute"},{"name":"features"}],"output":null}],[11,"fold_expr","","",254,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"fold_opt_expr","","",254,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["p"],"name":"option"}}],[11,"fold_pat","","",254,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"fold_stmt","","",254,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"fold_block","","",254,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"}],"output":{"generics":["block"],"name":"p"}}],[11,"fold_item","","",254,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_trait_item","","",254,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"fold_impl_item","","",254,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"fold_ty","","",254,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"}],"output":{"generics":["ty"],"name":"p"}}],[11,"fold_foreign_mod","","",254,{"inputs":[{"name":"self"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fold_foreign_item","","",254,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"generics":["foreignitem"],"name":"smallvector"}}],[11,"fold_item_kind","","",254,{"inputs":[{"name":"self"},{"name":"itemkind"}],"output":{"name":"itemkind"}}],[11,"fold_generic_param","","",254,{"inputs":[{"name":"self"},{"name":"genericparam"}],"output":{"name":"genericparam"}}],[11,"fold_attribute","","",254,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":{"generics":["attribute"],"name":"option"}}],[11,"new_id","","",254,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"default","","",255,{"inputs":[{"name":"string"}],"output":{"name":"expansionconfig"}}],[11,"enable_quotes","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_asm","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_global_asm","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_log_syntax","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_concat_idents","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_trace_macros","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_allow_internal_unstable","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"enable_custom_derive","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"proc_macro_enabled","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"macros_in_extern_enabled","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"proc_macro_mod","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"proc_macro_expr","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"proc_macro_non_items","","",255,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"fmt","","",256,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fold_ident","","",256,{"inputs":[{"name":"self"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"new_span","","",256,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"fold_mac","","",256,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[0,"placeholders","syntax::ext","",null,null],[3,"PlaceholderExpander","syntax::ext::placeholders","",null,null],[12,"expansions","","",260,null],[12,"cx","","",260,null],[12,"monotonic","","",260,null],[5,"placeholder","","",null,{"inputs":[{"name":"expansionkind"},{"name":"nodeid"}],"output":{"name":"expansion"}}],[11,"new","","",260,{"inputs":[{"name":"extctxt"},{"name":"bool"}],"output":{"name":"self"}}],[11,"add","","",260,{"inputs":[{"name":"self"},{"name":"nodeid"},{"name":"expansion"},{"generics":["mark"],"name":"vec"}],"output":null}],[11,"remove","","",260,{"inputs":[{"name":"self"},{"name":"nodeid"}],"output":{"name":"expansion"}}],[11,"fold_item","","",260,{"inputs":[{"name":"self"},{"generics":["item"],"name":"p"}],"output":{"generics":["p"],"name":"smallvector"}}],[11,"fold_trait_item","","",260,{"inputs":[{"name":"self"},{"name":"traititem"}],"output":{"generics":["traititem"],"name":"smallvector"}}],[11,"fold_impl_item","","",260,{"inputs":[{"name":"self"},{"name":"implitem"}],"output":{"generics":["implitem"],"name":"smallvector"}}],[11,"fold_foreign_item","","",260,{"inputs":[{"name":"self"},{"name":"foreignitem"}],"output":{"generics":["foreignitem"],"name":"smallvector"}}],[11,"fold_expr","","",260,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["expr"],"name":"p"}}],[11,"fold_opt_expr","","",260,{"inputs":[{"name":"self"},{"generics":["expr"],"name":"p"}],"output":{"generics":["p"],"name":"option"}}],[11,"fold_stmt","","",260,{"inputs":[{"name":"self"},{"name":"stmt"}],"output":{"generics":["stmt"],"name":"smallvector"}}],[11,"fold_pat","","",260,{"inputs":[{"name":"self"},{"generics":["pat"],"name":"p"}],"output":{"generics":["pat"],"name":"p"}}],[11,"fold_ty","","",260,{"inputs":[{"name":"self"},{"generics":["ty"],"name":"p"}],"output":{"generics":["ty"],"name":"p"}}],[11,"fold_block","","",260,{"inputs":[{"name":"self"},{"generics":["block"],"name":"p"}],"output":{"generics":["block"],"name":"p"}}],[11,"fold_mod","","",260,{"inputs":[{"name":"self"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_mac","","",260,{"inputs":[{"name":"self"},{"name":"mac"}],"output":{"name":"mac"}}],[0,"quote","syntax::ext","",null,null],[5,"unflatten","syntax::ext::quote","",null,{"inputs":[{"generics":["tokentree"],"name":"vec"}],"output":{"generics":["tokentree"],"name":"vec"}}],[5,"parse_expr_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"generics":["expr"],"name":"p"}}],[5,"parse_item_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"generics":["p"],"name":"option"}}],[5,"parse_pat_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"generics":["pat"],"name":"p"}}],[5,"parse_arm_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"name":"arm"}}],[5,"parse_ty_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"generics":["ty"],"name":"p"}}],[5,"parse_stmt_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"generics":["stmt"],"name":"option"}}],[5,"parse_attribute_panic","","",null,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"attribute"}}],[5,"parse_arg_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"name":"arg"}}],[5,"parse_block_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"generics":["block"],"name":"p"}}],[5,"parse_meta_item_panic","","",null,{"inputs":[{"name":"parser"}],"output":{"name":"metaitem"}}],[5,"parse_path_panic","","",null,{"inputs":[{"name":"parser"},{"name":"pathstyle"}],"output":{"name":"path"}}],[5,"expand_quote_tokens","","",null,null],[5,"expand_quote_expr","","",null,null],[5,"expand_quote_item","","",null,null],[5,"expand_quote_pat","","",null,null],[5,"expand_quote_arm","","",null,null],[5,"expand_quote_ty","","",null,null],[5,"expand_quote_stmt","","",null,null],[5,"expand_quote_attr","","",null,null],[5,"expand_quote_arg","","",null,null],[5,"expand_quote_block","","",null,null],[5,"expand_quote_meta_item","","",null,null],[5,"expand_quote_path","","",null,null],[5,"ids_ext","","",null,{"inputs":[{"generics":["string"],"name":"vec"}],"output":{"generics":["ident"],"name":"vec"}}],[5,"id_ext","","",null,{"inputs":[{"name":"str"}],"output":{"name":"ident"}}],[5,"mk_ident","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[5,"mk_name","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[5,"mk_tt_path","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":{"generics":["expr"],"name":"p"}}],[5,"mk_token_path","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":{"generics":["expr"],"name":"p"}}],[5,"mk_parser_path","","",null,null],[5,"mk_binop","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"binoptoken"}],"output":{"generics":["expr"],"name":"p"}}],[5,"mk_delim","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"delimtoken"}],"output":{"generics":["expr"],"name":"p"}}],[5,"expr_mk_token","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"token"}],"output":{"generics":["expr"],"name":"p"}}],[5,"statements_mk_tt","","",null,{"inputs":[{"name":"extctxt"},{"name":"tokentree"},{"name":"bool"}],"output":{"generics":["stmt"],"name":"vec"}}],[5,"parse_arguments_to_quote","","",null,null],[5,"mk_stmts_let","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"generics":["stmt"],"name":"vec"}}],[5,"statements_mk_tts","","",null,{"inputs":[{"name":"extctxt"},{"name":"tokenstream"}],"output":{"generics":["stmt"],"name":"vec"}}],[5,"expand_tts","","",null,null],[5,"expand_wrapper","","",null,null],[5,"expand_parse_call","","",null,null],[0,"rt","","Quasiquoting works via token trees.",null,null],[3,"BytePos","syntax::ext::quote::rt","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",null,null],[12,"0","","",261,null],[3,"Span","","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",null,null],[12,"0","","",262,null],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",null,null],[4,"FileName","","Differentiates between real files and common virtual files",null,null],[13,"Real","","",263,null],[13,"Macros","","e.g. \"std\" macros",263,null],[13,"QuoteExpansion","","call to `quote!`",263,null],[13,"Anon","","Command line",263,null],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",263,null],[13,"ProcMacroSourceCode","","",263,null],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",263,null],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",263,null],[8,"ToTokens","","",null,null],[10,"to_tokens","","",264,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[8,"ExtParseUtils","","",null,null],[10,"parse_item","","",265,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"generics":["item"],"name":"p"}}],[10,"parse_expr","","",265,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"generics":["expr"],"name":"p"}}],[10,"parse_stmt","","",265,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"name":"stmt"}}],[10,"parse_tts","","",265,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::tokenstream","",209,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::codemap","",138,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ast","",0,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",27,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",56,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",40,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",33,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",34,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ptr","",193,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ast","",54,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ptr","",193,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ast","",53,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",43,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ptr","",193,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",193,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ast","",45,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",60,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ptr","",193,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ast","",25,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",39,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","","",69,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"to_tokens","syntax::ext::quote::rt","",134,{"inputs":[{"name":"self"},{"name":"extctxt"}],"output":{"generics":["tokentree"],"name":"vec"}}],[11,"parse_item","syntax::ext::base","",237,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"generics":["item"],"name":"p"}}],[11,"parse_stmt","","",237,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"name":"stmt"}}],[11,"parse_expr","","",237,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"generics":["expr"],"name":"p"}}],[11,"parse_tts","","",237,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"generics":["tokentree"],"name":"vec"}}],[0,"source_util","syntax::ext","",null,null],[5,"expand_line","syntax::ext::source_util","line!(): expands to the current line number",null,null],[5,"expand_column","","",null,null],[5,"expand_column_gated","","",null,null],[5,"expand_file","","file!(): expands to the current filename */ The filemap (`loc.file`) contains a bunch more information we could spit out if we wanted.",null,null],[5,"expand_stringify","","",null,null],[5,"expand_mod","","",null,null],[5,"expand_include","","include! : parse the given file as an expr This is generally a bad idea because it's going to behave unhygienically.",null,null],[5,"expand_include_str","","",null,null],[5,"expand_include_bytes","","",null,null],[5,"res_rel_file","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"string"}],"output":{"name":"pathbuf"}}],[0,"tt","syntax::ext","",null,null],[0,"transcribe","syntax::ext::tt","",null,null],[4,"Frame","syntax::ext::tt::transcribe","",null,null],[13,"Delimited","","",266,null],[12,"forest","syntax::ext::tt::transcribe::Frame","",266,null],[12,"idx","","",266,null],[12,"span","","",266,null],[13,"Sequence","syntax::ext::tt::transcribe","",266,null],[12,"forest","syntax::ext::tt::transcribe::Frame","",266,null],[12,"idx","","",266,null],[12,"sep","","",266,null],[4,"LockstepIterSize","syntax::ext::tt::transcribe","",null,null],[13,"Unconstrained","","",267,null],[13,"Constraint","","",267,null],[13,"Contradiction","","",267,null],[5,"transcribe","","This can do Macro-By-Example transcription. On the other hand, if `src` contains no `TokenTree::{Sequence, MetaVar, MetaVarDecl}`s, `interp` can (and should) be None.",null,{"inputs":[{"name":"extctxt"},{"generics":["hashmap"],"name":"option"},{"generics":["tokentree"],"name":"vec"}],"output":{"name":"tokenstream"}}],[5,"lookup_cur_matched","","",null,null],[5,"lockstep_iter_size","","",null,null],[11,"new","","",266,{"inputs":[{"generics":["tokentree"],"name":"vec"}],"output":{"name":"frame"}}],[11,"next","","",266,{"inputs":[{"name":"self"}],"output":{"generics":["tokentree"],"name":"option"}}],[11,"clone","","",267,{"inputs":[{"name":"self"}],"output":{"name":"lockstepitersize"}}],[11,"add","","",267,{"inputs":[{"name":"self"},{"name":"lockstepitersize"}],"output":{"name":"lockstepitersize"}}],[0,"macro_parser","syntax::ext::tt","This is an NFA-based parser, which calls out to the main rust parser for named nonterminals (which it commits to fully when it hits one in a grammar). There's a set of current NFA threads and a set of next ones. Instead of NTs, we have a special case for Kleene star. The big-O, in pathological cases, is worse than traditional use of NFA or Earley parsing, but it's an easier fit for Macro-by-Example-style rules.",null,null],[3,"MatcherTtFrame","syntax::ext::tt::macro_parser","An unzipping of `TokenTree`s... see the `stack` field of `MatcherPos`.",null,null],[12,"elts","","The \"parent\" matcher that we are descending into.",268,null],[12,"idx","","The position of the \"dot\" in `elts` at the time we descended.",268,null],[3,"MatcherPos","","Represents a single \"position\" (aka \"matcher position\", aka \"item\"), as described in the module documentation.",null,null],[12,"top_elts","","The token or sequence of tokens that make up the matcher",269,null],[12,"idx","","The position of the \"dot\" in this matcher",269,null],[12,"sp_lo","","The beginning position in the source that the beginning of this matcher corresponds to. In other words, the token in the source at `sp_lo` is matched against the first token of the matcher.",269,null],[12,"matches","","For each named metavar in the matcher, we keep track of token trees matched against the metavar by the black box parser. In particular, there may be more than one match per metavar if we are in a repetition (each repetition matches each of the variables). Moreover, matchers and repetitions can be nested; the `matches` field is shared (hence the `Rc`) among all \"nested\" matchers. `match_lo`, `match_cur`, and `match_hi` keep track of the current position of the `self` matcher position in the shared `matches` list.",269,null],[12,"match_lo","","The position in `matches` corresponding to the first metavar in this matcher's sequence of token trees. In other words, the first metavar in the first token of `top_elts` corresponds to `matches[match_lo]`.",269,null],[12,"match_cur","","The position in `matches` corresponding to the metavar we are currently trying to match against the source token stream. `match_lo <= match_cur <= match_hi`.",269,null],[12,"match_hi","","Similar to `match_lo` except `match_hi` is the position in `matches` of the last metavar in this matcher.",269,null],[12,"seq_op","","The KleeneOp of this sequence if we are in a repetition.",269,null],[12,"sep","","The separator if we are in a repetition",269,null],[12,"up","","The \"parent\" matcher position if we are in a repetition. That is, the matcher position just before we enter the sequence.",269,null],[12,"stack","","When matching against matchers with nested delimited submatchers (e.g. `pat ( pat ( .. ) pat ) pat`), we need to keep track of the matchers we are descending into. This stack does that where the bottom of the stack is the outermost matcher.",269,null],[4,"TokenTreeOrTokenTreeVec","","Either a sequence of token trees or a single one. This is used as the representation of the sequence of tokens that make up a matcher.",null,null],[13,"Tt","","",270,null],[13,"TtSeq","","",270,null],[4,"ParseResult","","Represents the possible results of an attempted parse.",null,null],[13,"Success","","Parsed successfully.",271,null],[13,"Failure","","Arm failed to match. If the second parameter is `token::Eof`, it indicates an unexpected end of macro invocation. Otherwise, it indicates that no rules expected the given token.",271,null],[13,"Error","","Fatal error (malformed macro?). Abort compilation.",271,null],[4,"NamedMatch","","`NamedMatch` is a pattern-match result for a single `token::MATCH_NONTERMINAL`: so it is associated with a single ident in a parse, and all `MatchedNonterminal`s in the `NamedMatch` have the same nonterminal type (expr, item, etc). Each leaf in a single `NamedMatch` corresponds to a single `token::MATCH_NONTERMINAL` in the `TokenTree` that produced it.",null,null],[13,"MatchedSeq","","",272,null],[13,"MatchedNonterminal","","",272,null],[5,"count_names","","Count how many metavars are named in the given matcher `ms`.",null,null],[5,"create_matches","","Initialize `len` empty shared `Vec`s to be used to store matches of metavars.",null,{"inputs":[{"name":"usize"}],"output":{"generics":["rc"],"name":"vec"}}],[5,"initial_matcher_pos","","Generate the top-level matcher position in which the \"dot\" is before the first token of the matcher `ms` and we are going to start matching at position `lo` in the source.",null,{"inputs":[{"generics":["tokentree"],"name":"vec"},{"name":"bytepos"}],"output":{"generics":["matcherpos"],"name":"box"}}],[5,"nameize","","Takes a sequence of token trees `ms` representing a matcher which successfully matched input and an iterator of items that matched input and produces a `NamedParseResult`.",null,null],[5,"parse_failure_msg","","Generate an appropriate parsing failure message. For EOF, this is \"unexpected end...\". For other tokens, this is \"unexpected token...\".",null,{"inputs":[{"name":"token"}],"output":{"name":"string"}}],[5,"token_name_eq","","Perform a token equality check, ignoring syntax context (that is, an unhygienic comparison)",null,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[5,"inner_parse_loop","","Process the matcher positions of `cur_items` until it is empty. In the process, this will produce more items in `next_items`, `eof_items`, and `bb_items`.",null,{"inputs":[{"name":"parsesess"},{"name":"smallvector"},{"name":"vec"},{"name":"smallvector"},{"name":"smallvector"},{"name":"token"},{"name":"span"}],"output":{"name":"parseresult"}}],[5,"parse","","Use the given sequence of token trees (`ms`) as a matcher. Match the given token stream `tts` against it and return the match.",null,null],[5,"get_macro_ident","","The token is an identifier, but not `_`. We prohibit passing `_` to macros expecting `ident` for now.",null,{"inputs":[{"name":"token"}],"output":{"name":"option"}}],[5,"may_begin_with","","Checks whether a non-terminal may begin with a particular token.",null,{"inputs":[{"name":"str"},{"name":"token"}],"output":{"name":"bool"}}],[5,"parse_nt","","A call to the \"black-box\" parser to parse some rust nonterminal.",null,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":{"name":"nonterminal"}}],[6,"NamedParseResult","","A `ParseResult` where the `Success` variant contains a mapping of `Ident`s to `NamedMatch`es. This represents the mapping of metavars to the token trees they bind to.",null,null],[11,"clone","","",270,{"inputs":[{"name":"self"}],"output":{"name":"tokentreeortokentreevec"}}],[11,"len","","Returns the number of constituent top-level token trees of `self` (top-level in that it will not recursively descend into subtrees).",270,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"get_tt","","The the `index`-th token tree of `self`.",270,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"tokentree"}}],[11,"clone","","",268,{"inputs":[{"name":"self"}],"output":{"name":"matcherttframe"}}],[11,"clone","","",269,{"inputs":[{"name":"self"}],"output":{"name":"matcherpos"}}],[11,"push_match","","Add `m` as a named match for the `idx`-th metavar.",269,{"inputs":[{"name":"self"},{"name":"usize"},{"name":"namedmatch"}],"output":null}],[11,"fmt","","",272,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",272,{"inputs":[{"name":"self"}],"output":{"name":"namedmatch"}}],[0,"macro_rules","syntax::ext::tt","",null,null],[3,"ParserAnyMacro","syntax::ext::tt::macro_rules","",null,null],[12,"parser","","",273,null],[12,"site_span","","Span of the expansion site of the macro this parser is for",273,null],[12,"macro_ident","","The ident of the macro we're parsing",273,null],[3,"MacroRulesMacroExpander","","",null,null],[12,"name","","",274,null],[12,"lhses","","",274,null],[12,"rhses","","",274,null],[12,"valid","","",274,null],[3,"FirstSets","","",null,null],[12,"first","","",275,null],[3,"TokenSet","","",null,null],[12,"tokens","","",276,null],[12,"maybe_empty","","",276,null],[5,"trace_macros_note","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"string"}],"output":null}],[5,"generic_extension","","Given `lhses` and `rhses`, this is the new macro we create",null,null],[5,"compile","","Converts a `macro_rules!` invocation into a syntax extension.",null,{"inputs":[{"name":"parsesess"},{"name":"features"},{"name":"item"}],"output":{"name":"syntaxextension"}}],[5,"check_lhs_nt_follows","","",null,null],[5,"check_lhs_no_empty_seq","","Check that the lhs contains no repetition which could match an empty token tree, because then the matcher would hang indefinitely.",null,null],[5,"check_rhs","","",null,{"inputs":[{"name":"parsesess"},{"name":"tokentree"}],"output":{"name":"bool"}}],[5,"check_matcher","","",null,null],[5,"check_matcher_core","","",null,null],[5,"token_can_be_followed_by_any","","",null,{"inputs":[{"name":"tokentree"}],"output":{"name":"bool"}}],[5,"frag_can_be_followed_by_any","","True if a fragment of type `frag` can be followed by any sort of token.  We use this (among other things) as a useful approximation for when `frag` can be followed by a repetition like `$(...)*` or `$(...)+`. In general, these can be a bit tricky to reason about, so we adopt a conservative position that says that any fragment specifier which consumes at most one token tree can be followed by a fragment specifier (indeed, these fragments can be followed by ANYTHING without fear of future compatibility hazards).",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"is_in_follow","","True if `frag` can legally be followed by the token `tok`. For fragments that can consume an unbounded number of tokens, `tok` must be within a well-defined follow set. This is intended to guarantee future compatibility: for example, without this rule, if we expanded `expr` to include a new binary operator, we might break macros that were relying on that binary operator as a separator.",null,{"inputs":[{"name":"tokentree"},{"name":"str"}],"output":{"generics":["bool"],"name":"result"}}],[5,"has_legal_fragment_specifier","","",null,null],[5,"is_legal_fragment_specifier","","",null,null],[5,"quoted_tt_to_string","","",null,{"inputs":[{"name":"tokentree"}],"output":{"name":"string"}}],[11,"make","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"},{"name":"expansionkind"}],"output":{"name":"expansion"}}],[11,"expand","","",274,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"}],"output":{"generics":["macresult"],"name":"box"}}],[11,"new","","",275,null],[11,"first","","",275,null],[11,"clone","","",276,{"inputs":[{"name":"self"}],"output":{"name":"tokenset"}}],[11,"fmt","","",276,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",276,{"inputs":[],"output":{"name":"self"}}],[11,"singleton","","",276,{"inputs":[{"name":"tokentree"}],"output":{"name":"self"}}],[11,"replace_with","","",276,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":null}],[11,"replace_with_irrelevant","","",276,{"inputs":[{"name":"self"}],"output":null}],[11,"add_one","","",276,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":null}],[11,"add_one_maybe","","",276,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":null}],[11,"add_all","","",276,{"inputs":[{"name":"self"},{"name":"self"}],"output":null}],[0,"quoted","syntax::ext::tt","",null,null],[3,"Delimited","syntax::ext::tt::quoted","Contains the sub-token-trees of a \"delimited\" token tree, such as the contents of `(`. Note that the delimiter itself might be `NoDelim`.",null,null],[12,"delim","","",277,null],[12,"tts","","",277,null],[3,"SequenceRepetition","","",null,null],[12,"tts","","The sequence of token trees",278,null],[12,"separator","","The optional separator",278,null],[12,"op","","Whether the sequence can be repeated zero (*), or one or more times (+)",278,null],[12,"num_captures","","The number of `Match`s that appear in the sequence (and subsequences)",278,null],[4,"KleeneOp","","A Kleene-style repetition operator for token sequences.",null,null],[13,"ZeroOrMore","","Kleene star (`*`) for zero or more repetitions",279,null],[13,"OneOrMore","","Kleene plus (`+`) for one or more repetitions",279,null],[13,"ZeroOrOne","","",279,null],[4,"TokenTree","","Similar to `tokenstream::TokenTree`, except that `$i`, `$i:ident`, and `$(...)` are \"first-class\" token trees. Useful for parsing macros.",null,null],[13,"Token","","",280,null],[13,"Delimited","","",280,null],[13,"Sequence","","A kleene-style repetition sequence",280,null],[13,"MetaVar","","E.g. `$var`",280,null],[13,"MetaVarDecl","","E.g. `$var:expr`. This is only used in the left hand side of MBE macros.",280,null],[5,"parse","","Takes a `tokenstream::TokenStream` and returns a `Vec<self::TokenTree>`. Specifically, this takes a generic `TokenStream`, such as is used in the rest of the compiler, and returns a collection of `TokenTree` for use in parsing a macro.",null,null],[5,"parse_tree","","Takes a `tokenstream::TokenTree` and returns a `self::TokenTree`. Specifically, this takes a generic `TokenTree`, such as is used in the rest of the compiler, and returns a `TokenTree` for use in parsing a macro.",null,null],[5,"kleene_op","","Takes a token and returns `Some(KleeneOp)` if the token is `+` `*` or `?`. Otherwise, return `None`.",null,{"inputs":[{"name":"token"}],"output":{"generics":["kleeneop"],"name":"option"}}],[5,"parse_kleene_op","","Parse the next token tree of the input looking for a KleeneOp. Returns",null,{"inputs":[{"name":"i"},{"name":"span"}],"output":{"generics":["result","span"],"name":"result"}}],[5,"parse_sep_and_kleene_op","","Attempt to parse a single Kleene star, possibly with a separator.",null,null],[11,"clone","","",277,{"inputs":[{"name":"self"}],"output":{"name":"delimited"}}],[11,"eq","","",277,{"inputs":[{"name":"self"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"ne","","",277,{"inputs":[{"name":"self"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",277,null],[11,"encode","","",277,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",277,{"inputs":[{"name":"__d"}],"output":{"generics":["delimited"],"name":"result"}}],[11,"hash","","",277,null],[11,"fmt","","",277,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"open_token","","Return the opening delimiter (possibly `NoDelim`).",277,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"close_token","","Return the closing delimiter (possibly `NoDelim`).",277,{"inputs":[{"name":"self"}],"output":{"name":"token"}}],[11,"open_tt","","Return a `self::TokenTree` with a `Span` corresponding to the opening delimiter.",277,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"tokentree"}}],[11,"close_tt","","Return a `self::TokenTree` with a `Span` corresponding to the closing delimiter.",277,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"tokentree"}}],[11,"clone","","",278,{"inputs":[{"name":"self"}],"output":{"name":"sequencerepetition"}}],[11,"eq","","",278,{"inputs":[{"name":"self"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"ne","","",278,{"inputs":[{"name":"self"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",278,null],[11,"encode","","",278,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",278,{"inputs":[{"name":"__d"}],"output":{"generics":["sequencerepetition"],"name":"result"}}],[11,"hash","","",278,null],[11,"fmt","","",278,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",279,{"inputs":[{"name":"self"}],"output":{"name":"kleeneop"}}],[11,"eq","","",279,{"inputs":[{"name":"self"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",279,null],[11,"encode","","",279,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",279,{"inputs":[{"name":"__d"}],"output":{"generics":["kleeneop"],"name":"result"}}],[11,"hash","","",279,null],[11,"fmt","","",279,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",280,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",280,{"inputs":[{"name":"self"}],"output":{"name":"tokentree"}}],[11,"eq","","",280,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"ne","","",280,{"inputs":[{"name":"self"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",280,null],[11,"encode","","",280,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",280,{"inputs":[{"name":"__d"}],"output":{"generics":["tokentree"],"name":"result"}}],[11,"hash","","",280,null],[11,"len","","Return the number of tokens in the tree.",280,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the given token tree contains no other tokens. This is vacuously true for single tokens or metavar/decls, but may be false for delimited trees or sequences.",280,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"get_tt","","Get the `index`-th sub-token-tree. This only makes sense for delimited trees and sequences.",280,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"name":"tokentree"}}],[11,"span","","Retrieve the `TokenTree`'s span.",280,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[7,"GLOBALS","syntax","",null,null],[17,"DIAGNOSTICS","","",null,null],[11,"new","","",6,{"inputs":[],"output":{"name":"globals"}}],[14,"panictry","","",null,null],[14,"unwrap_or","","",null,null],[14,"register_diagnostic","","",null,null],[14,"span_fatal","","",null,null],[14,"span_err","","",null,null],[14,"span_warn","","",null,null],[14,"struct_err","","",null,null],[14,"span_err_or_warn","","",null,null],[14,"struct_span_fatal","","",null,null],[14,"struct_span_err","","",null,null],[14,"stringify_error_code","","",null,null],[14,"type_error_struct","","",null,null],[14,"struct_span_warn","","",null,null],[14,"struct_span_err_or_warn","","",null,null],[14,"span_note","","",null,null],[14,"span_help","","",null,null],[14,"help","","",null,null],[14,"register_diagnostics","","",null,null],[14,"register_long_diagnostics","","",null,null],[14,"walk_list","","",null,null],[11,"new","syntax::ast","",0,{"inputs":[{"name":"symbol"},{"name":"span"}],"output":{"name":"ident"}}],[11,"with_empty_ctxt","","",0,{"inputs":[{"name":"symbol"}],"output":{"name":"ident"}}],[11,"from_interned_str","","Maps an interned string to an identifier with an empty syntax context.",0,{"inputs":[{"name":"internedstring"}],"output":{"name":"ident"}}],[11,"from_str","","Maps a string to an identifier with an empty syntax context.",0,{"inputs":[{"name":"str"}],"output":{"name":"ident"}}],[11,"with_span_pos","","Replace `lo` and `hi` with those from `span`, but keep hygiene context.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"ident"}}],[11,"without_first_quote","","",0,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"modern","","",0,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"gensym","","",0,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"default_decode","syntax::ext::quote::rt","",262,{"inputs":[{"name":"d"}],"output":{"generics":["span"],"name":"result"}}],[11,"deref","syntax::symbol","",4,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"decode","syntax::ext::quote::rt","",261,{"inputs":[{"name":"d"}],"output":{"generics":["bytepos"],"name":"result"}}],[11,"decode","syntax::ast","",1,{"inputs":[{"name":"d"}],"output":{"generics":["symbol"],"name":"result"}}],[11,"decode","syntax::symbol","",5,{"inputs":[{"name":"d"}],"output":{"generics":["internedstring"],"name":"result"}}],[11,"decode","syntax::ext::hygiene","",232,{"inputs":[{"name":"__d"}],"output":{"generics":["compilerdesugaringkind"],"name":"result"}}],[11,"decode","","",229,{"inputs":[{"name":"__d"}],"output":{"generics":["mark"],"name":"result"}}],[11,"decode","","",137,{"inputs":[{"name":"__d"}],"output":{"generics":["nameandspan"],"name":"result"}}],[11,"decode","","",136,{"inputs":[{"name":"__d"}],"output":{"generics":["expninfo"],"name":"result"}}],[11,"decode","","",135,{"inputs":[{"name":"__d"}],"output":{"generics":["expnformat"],"name":"result"}}],[11,"decode","","",227,{"inputs":[{"name":"d"}],"output":{"generics":["syntaxcontext"],"name":"result"}}],[11,"decode","syntax::ast","",0,{"inputs":[{"name":"d"}],"output":{"generics":["ident"],"name":"result"}}],[11,"decode","syntax::symbol","",4,{"inputs":[{"name":"d"}],"output":{"generics":["localinternedstring"],"name":"result"}}],[11,"decode","syntax::ext::quote::rt","",263,{"inputs":[{"name":"__d"}],"output":{"generics":["filename"],"name":"result"}}],[11,"cmp","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"ordering"}}],[11,"cmp","syntax::symbol","",4,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"ordering"}}],[11,"cmp","syntax::ast","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"ordering"}}],[11,"cmp","syntax::symbol","",5,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"ordering"}}],[11,"cmp","syntax::ext::quote::rt","",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"ordering"}}],[11,"cmp","syntax::ext::hygiene","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"ordering"}}],[11,"cmp","syntax::ext::quote::rt","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"le","","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"gt","","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"ge","","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"partial_cmp","syntax::ast","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"le","","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"gt","","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"ge","","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"partial_cmp","syntax::ext::quote::rt","",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"partial_cmp","syntax::ext::hygiene","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"le","","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"gt","","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"ge","","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"partial_cmp","syntax::ext::quote::rt","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"le","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"gt","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ge","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"partial_cmp","syntax::symbol","",5,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"partial_cmp","","",4,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",4,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"le","","",4,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"gt","","",4,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"ge","","",4,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"default_encode","syntax::ext::quote::rt","",262,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"fmt","syntax::symbol","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ast","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ext::quote::rt","",263,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ast","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"from","syntax::ext::quote::rt","",263,{"inputs":[{"name":"pathbuf"}],"output":{"name":"filename"}}],[11,"default","syntax::ext::hygiene","",227,{"inputs":[],"output":{"name":"syntaxcontext"}}],[11,"default","syntax::symbol","",2,{"inputs":[],"output":{"name":"interner"}}],[11,"default","syntax::ext::quote::rt","",262,{"inputs":[],"output":{"name":"span"}}],[11,"add","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"as_ref","syntax::symbol","",4,{"inputs":[{"name":"self"}],"output":{"name":"u"}}],[11,"hash","syntax::ext::quote::rt","",261,null],[11,"hash","syntax::ext::hygiene","",232,null],[11,"hash","syntax::symbol","",4,null],[11,"hash","syntax::ext::hygiene","",136,null],[11,"hash","syntax::ast","",1,null],[11,"hash","syntax::ext::hygiene","",229,null],[11,"hash","","",135,null],[11,"hash","syntax::ext::quote::rt","",262,null],[11,"hash","syntax::ext::hygiene","",137,null],[11,"hash","syntax::symbol","",5,null],[11,"hash","syntax::ast","",0,null],[11,"hash","syntax::ext::quote::rt","",263,null],[11,"hash","syntax::ext::hygiene","",227,null],[11,"encode","","",229,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",137,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",136,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","syntax::ast","",1,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"encode","syntax::ext::quote::rt","",261,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"encode","syntax::symbol","",4,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"encode","syntax::ext::quote::rt","",263,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","syntax::symbol","",5,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"encode","syntax::ext::hygiene","",135,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","","",232,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"encode","syntax::ast","",0,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"encode","syntax::ext::hygiene","",227,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","syntax::ext::quote::rt","",263,null],[11,"assert_receiver_is_total_eq","syntax::ast","",0,null],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",230,null],[11,"assert_receiver_is_total_eq","syntax::ast","",1,null],[11,"assert_receiver_is_total_eq","syntax::ext::quote::rt","",261,null],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",135,null],[11,"assert_receiver_is_total_eq","syntax::symbol::keywords","",3,null],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",229,null],[11,"assert_receiver_is_total_eq","","",227,null],[11,"assert_receiver_is_total_eq","syntax::symbol","",5,null],[11,"assert_receiver_is_total_eq","","",4,null],[11,"assert_receiver_is_total_eq","syntax::ext::hygiene","",232,null],[11,"eq","syntax::symbol","",4,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"eq","syntax::ext::quote::rt","",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"eq","syntax::ext::hygiene","",230,{"inputs":[{"name":"self"},{"name":"markkind"}],"output":{"name":"bool"}}],[11,"eq","syntax::ast","",0,{"inputs":[{"name":"self"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"eq","","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"eq","syntax::symbol::keywords","",3,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"eq","syntax::ext::hygiene","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"ne","","",227,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"eq","","",232,{"inputs":[{"name":"self"},{"name":"compilerdesugaringkind"}],"output":{"name":"bool"}}],[11,"eq","","",135,{"inputs":[{"name":"self"},{"name":"expnformat"}],"output":{"name":"bool"}}],[11,"ne","","",135,{"inputs":[{"name":"self"},{"name":"expnformat"}],"output":{"name":"bool"}}],[11,"eq","syntax::symbol","",5,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"eq","syntax::ext::hygiene","",229,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"ne","","",229,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"eq","syntax::ast","",1,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"eq","syntax::ext::quote::rt","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"ne","","",263,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"eq","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ne","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"from_usize","","",261,{"inputs":[{"name":"usize"}],"output":{"name":"bytepos"}}],[11,"to_usize","","",261,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"sub","","",261,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"clone","syntax::ext::hygiene","",232,{"inputs":[{"name":"self"}],"output":{"name":"compilerdesugaringkind"}}],[11,"clone","syntax::ext::quote::rt","",261,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"clone","","",262,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",263,{"inputs":[{"name":"self"}],"output":{"name":"filename"}}],[11,"clone","syntax::ast","",1,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"clone","syntax::ext::hygiene","",137,{"inputs":[{"name":"self"}],"output":{"name":"nameandspan"}}],[11,"clone","","",228,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontextdata"}}],[11,"clone","","",230,{"inputs":[{"name":"self"}],"output":{"name":"markkind"}}],[11,"clone","","",229,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"clone","","",135,{"inputs":[{"name":"self"}],"output":{"name":"expnformat"}}],[11,"clone","","",227,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"clone","syntax::ast","",0,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"clone","syntax::symbol","",4,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"clone","syntax::ext::hygiene","",136,{"inputs":[{"name":"self"}],"output":{"name":"expninfo"}}],[11,"clone","syntax::symbol","",5,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"clone","syntax::symbol::keywords","",3,{"inputs":[{"name":"self"}],"output":{"name":"keyword"}}],[11,"fmt","syntax::ext::hygiene","",136,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ext::quote::rt","",261,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::symbol","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ext::quote::rt","",262,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::symbol","",5,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ext::hygiene","",137,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",227,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ast","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ext::quote::rt","",263,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ext::hygiene","",229,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",135,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","","",232,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"fmt","syntax::ast","",1,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[11,"from_ident","","",1,{"inputs":[{"name":"ident"}],"output":{"name":"symbol"}}],[11,"to_ident","","",1,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"intern","","Maps a string to its interned representation.",1,{"inputs":[{"name":"str"}],"output":{"name":"symbol"}}],[11,"interned","","",1,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"gensym","","gensym's a new usize, using the current interner.",1,{"inputs":[{"name":"str"}],"output":{"name":"symbol"}}],[11,"gensymed","","",1,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"as_str","","",1,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"as_interned_str","","",1,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"as_u32","","",1,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"new","syntax::symbol","",2,{"inputs":[],"output":{"name":"interner"}}],[11,"intern","","",2,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"symbol"}}],[11,"interned","","",2,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"symbol"}}],[11,"get","","",2,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"str"}}],[11,"fresh","","",2,{"inputs":[],"output":{"name":"interner"}}],[11,"ident","syntax::symbol::keywords","",3,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"name","","",3,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"as_interned_str","syntax::symbol","",4,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"with","","",5,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"as_symbol","","",5,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"as_str","","",5,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"move_flat_map","syntax::ptr","",193,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","syntax::codemap","",138,null],[11,"map_attrs","","",138,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"attrs","syntax::ptr","",193,null],[11,"map_attrs","","",193,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"self"}}],[11,"name","syntax::ext::hygiene","",137,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"empty","","",227,{"inputs":[],"output":{"name":"syntaxcontext"}}],[11,"allocate_directly","","",227,{"inputs":[{"name":"expninfo"}],"output":{"name":"syntaxcontext"}}],[11,"apply_mark","","Extend a syntax context with a given mark",227,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"syntaxcontext"}}],[11,"remove_mark","","Pulls a single mark off of the syntax context. This effectively moves the context up one macro definition level. That is, if we have a nested macro definition as follows:",227,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"marks","","",227,{"inputs":[{"name":"self"}],"output":{"generics":["mark"],"name":"vec"}}],[11,"adjust","","Adjust this context for resolution in a scope created by the given expansion. For example, consider the following three resolutions of `f`:",227,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"generics":["mark"],"name":"option"}}],[11,"glob_adjust","","Adjust this context for resolution in a scope created by the given expansion via a glob import with the given `SyntaxContext`. For example:",227,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"reverse_glob_adjust","","Undo `glob_adjust` if possible:",227,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"modern","","",227,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"outer","","",227,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"fresh","","",229,{"inputs":[{"name":"mark"}],"output":{"name":"mark"}}],[11,"root","","The mark of the theoretical expansion that generates freshly parsed, unexpanded AST.",229,{"inputs":[],"output":{"name":"mark"}}],[11,"as_u32","","",229,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_u32","","",229,{"inputs":[{"name":"u32"}],"output":{"name":"mark"}}],[11,"expn_info","","",229,{"inputs":[{"name":"self"}],"output":{"generics":["expninfo"],"name":"option"}}],[11,"set_expn_info","","",229,null],[11,"modern","","",229,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"kind","","",229,{"inputs":[{"name":"self"}],"output":{"name":"markkind"}}],[11,"set_kind","","",229,null],[11,"is_descendant_of","","",229,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"least_ancestor","","Computes a mark such that both input marks are descendants of (or equal to) the returned mark. That is, the following holds:",229,{"inputs":[{"name":"mark"},{"name":"mark"}],"output":{"name":"mark"}}],[11,"new","","",231,{"inputs":[],"output":{"name":"hygienedata"}}],[11,"as_symbol","","",232,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"make_expr","syntax::ext::tt::macro_rules","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_pat","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_ty","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["p"],"name":"option"}}],[11,"make_stmts","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_items","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_trait_items","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_impl_items","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"make_foreign_items","","",273,{"inputs":[{"generics":["parseranymacro"],"name":"box"}],"output":{"generics":["smallvector"],"name":"option"}}],[11,"new","syntax::ext::quote::rt","",262,{"inputs":[{"name":"bytepos"},{"name":"bytepos"},{"name":"syntaxcontext"}],"output":{"name":"span"}}],[11,"data","","",262,{"inputs":[{"name":"self"}],"output":{"name":"spandata"}}],[11,"lo","","",262,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"with_lo","","",262,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"hi","","",262,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"with_hi","","",262,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"ctxt","","",262,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"with_ctxt","","",262,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"span"}}],[11,"shrink_to_lo","","Returns a new span representing an empty span at the beginning of this span",262,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"shrink_to_hi","","Returns a new span representing an empty span at the end of this span",262,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"substitute_dummy","","Returns `self` if `self` is not the dummy span, and `other` otherwise.",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"contains","","Return true if `self` fully encloses `other`.",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"source_equal","","Return true if the spans are equal with regards to the source text.",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"trim_start","","Returns `Some(span)`, where the start is trimmed by the end of `other`",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"source_callsite","","Return the source span - this is either the supplied span, or the span for the macro callsite that expanded to it.",262,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated, if any",262,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"option"}}],[11,"source_callee","","Return the source callee.",262,{"inputs":[{"name":"self"}],"output":{"generics":["nameandspan"],"name":"option"}}],[11,"allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable] items can be used (that is, a macro marked with `#[allow_internal_unstable]`).",262,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_compiler_desugaring","","Check if this span arises from a compiler desugaring of kind `kind`.",262,{"inputs":[{"name":"self"},{"name":"compilerdesugaringkind"}],"output":{"name":"bool"}}],[11,"compiler_desugaring_kind","","Return the compiler desugaring that created this span, or None if this span is not from a desugaring.",262,{"inputs":[{"name":"self"}],"output":{"generics":["compilerdesugaringkind"],"name":"option"}}],[11,"allows_unsafe","","Check if a span is \"internal\" to a macro in which `unsafe` can be used without triggering the `unsafe_code` lint",262,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"macro_backtrace","","",262,{"inputs":[{"name":"self"}],"output":{"generics":["macrobacktrace"],"name":"vec"}}],[11,"to","","Return a `Span` that would enclose both `self` and `end`.",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"between","","Return a `Span` between the end of `self` to the beginning of `end`.",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"until","","Return a `Span` between the beginning of `self` to the beginning of `end`.",262,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"apply_mark","","",262,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"span"}}],[11,"remove_mark","","",262,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"adjust","","",262,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"generics":["mark"],"name":"option"}}],[11,"glob_adjust","","",262,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"reverse_glob_adjust","","",262,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"modern","","",262,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"is_real","","",263,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_macros","","",263,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}]],"paths":[[3,"Ident"],[3,"Name"],[3,"Interner"],[3,"Keyword"],[3,"LocalInternedString"],[3,"InternedString"],[3,"Globals"],[3,"ErrorInfo"],[3,"ErrorMetadata"],[3,"ErrorLocation"],[3,"ThinVec"],[3,"RcSlice"],[3,"NodeCounter"],[4,"AssocOp"],[4,"Fixity"],[4,"ExprPrecedence"],[8,"MoveMap"],[6,"SmallVector"],[3,"JsonEmitter"],[3,"Diagnostic"],[3,"DiagnosticSpan"],[3,"DiagnosticSpanLine"],[3,"DiagnosticSpanMacroExpansion"],[3,"DiagnosticCode"],[3,"Label"],[3,"Lifetime"],[3,"LifetimeDef"],[3,"Path"],[3,"PathSegment"],[3,"AngleBracketedParameterData"],[3,"ParenthesizedParameterData"],[3,"NodeId"],[3,"TyParam"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"MetaItem"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Stmt"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"Expr"],[3,"QSelf"],[3,"Mac_"],[3,"MacroDef"],[3,"MutTy"],[3,"MethodSig"],[3,"TraitItem"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"InlineAsmOutput"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"GlobalAsm"],[3,"EnumDef"],[3,"Variant_"],[3,"UseTree"],[3,"AttrId"],[3,"Attribute"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField"],[3,"Item"],[3,"ForeignItem"],[4,"PathParameters"],[4,"TyParamBound"],[4,"TraitBoundModifier"],[4,"GenericParam"],[4,"WherePredicate"],[4,"NestedMetaItemKind"],[4,"MetaItemKind"],[4,"BindingMode"],[4,"RangeEnd"],[4,"RangeSyntax"],[4,"PatKind"],[4,"Mutability"],[4,"BinOpKind"],[4,"UnOp"],[4,"StmtKind"],[4,"MacStmtStyle"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"RangeLimits"],[4,"ExprKind"],[4,"CaptureBy"],[4,"Movability"],[4,"StrStyle"],[4,"LitIntType"],[4,"LitKind"],[4,"TraitItemKind"],[4,"ImplItemKind"],[4,"IntTy"],[4,"UintTy"],[4,"FloatTy"],[4,"TyKind"],[4,"TraitObjectSyntax"],[4,"AsmDialect"],[4,"SelfKind"],[4,"IsAuto"],[4,"Unsafety"],[4,"Constness"],[4,"Defaultness"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"UseTreeKind"],[4,"AttrStyle"],[4,"CrateSugar"],[4,"VisibilityKind"],[4,"VariantData"],[4,"ItemKind"],[4,"ForeignItemKind"],[3,"Stability"],[3,"RustcDeprecation"],[3,"RustcConstUnstable"],[3,"Deprecation"],[4,"AttrError"],[4,"InlineAttr"],[4,"UnwindAttr"],[4,"StabilityLevel"],[4,"ReprAttr"],[4,"IntType"],[8,"HasAttrs"],[6,"NestedMetaItem"],[6,"Lit"],[4,"ExpnFormat"],[3,"ExpnInfo"],[3,"NameAndSpan"],[3,"Spanned"],[3,"StableFilemapId"],[3,"CodeMapFiles"],[3,"CodeMap"],[3,"FilePathMapping"],[8,"FileLoader"],[3,"RealFileLoader"],[3,"StripUnconfigured"],[4,"EntryPointType"],[4,"Edition"],[3,"Features"],[3,"GatedCfg"],[3,"Context"],[3,"PostExpansionVisitor"],[3,"FeatureChecker"],[4,"AttributeType"],[4,"AttributeGate"],[4,"Stability"],[4,"GateIssue"],[4,"GateStrength"],[4,"UnstableFeatures"],[8,"Folder"],[3,"ParseSess"],[3,"Directory"],[4,"DirectoryOwnership"],[3,"Restrictions"],[3,"Parser"],[3,"TokenCursor"],[3,"TokenCursorFrame"],[3,"ModulePath"],[3,"ModulePathSuccess"],[3,"ModulePathError"],[4,"PathStyle"],[4,"SemiColonMode"],[4,"BlockMode"],[4,"PrevTokenKind"],[4,"LastToken"],[4,"TokenType"],[4,"Error"],[4,"LhsExpr"],[4,"TokenExpectType"],[8,"RecoverQPath"],[3,"TokenAndSpan"],[3,"StringReader"],[3,"Comment"],[3,"Literal"],[4,"CommentStyle"],[3,"LazyTokenStream"],[4,"BinOpToken"],[4,"DelimToken"],[4,"Lit"],[4,"Token"],[4,"Nonterminal"],[4,"InnerAttributeParsePolicy"],[3,"SeqSep"],[3,"P"],[3,"ShowSpanVisitor"],[4,"Mode"],[3,"Test"],[3,"TestCtxt"],[3,"TestHarnessGenerator"],[3,"EntryPointCleaner"],[4,"ShouldPanic"],[4,"HasTestSignature"],[4,"BadTestSignature"],[3,"Delimited"],[3,"TokenStream"],[3,"TokenStreamBuilder"],[3,"Cursor"],[3,"StreamCursor"],[3,"ThinTokenStream"],[4,"TokenTree"],[4,"TokenStreamKind"],[4,"CursorKind"],[4,"FnKind"],[8,"Visitor"],[3,"BreakToken"],[3,"BeginToken"],[3,"PrintStackElem"],[3,"Printer"],[3,"BufEntry"],[4,"Breaks"],[4,"Token"],[4,"PrintStackBreak"],[3,"State"],[4,"AnnNode"],[8,"PpAnn"],[8,"PrintState"],[3,"NoAnn"],[3,"SyntaxContext"],[3,"SyntaxContextData"],[3,"Mark"],[4,"MarkKind"],[3,"HygieneData"],[4,"CompilerDesugaringKind"],[3,"MacEager"],[3,"DummyResult"],[3,"ModuleData"],[3,"ExpansionData"],[3,"ExtCtxt"],[4,"Annotatable"],[4,"MacroKind"],[4,"SyntaxExtension"],[4,"Determinacy"],[8,"MultiItemDecorator"],[8,"MultiItemModifier"],[8,"ProcMacro"],[8,"AttrProcMacro"],[8,"TTMacroExpander"],[8,"IdentMacroExpander"],[8,"MacResult"],[8,"Resolver"],[3,"DummyResolver"],[8,"AstBuilder"],[3,"Invocation"],[3,"MacroExpander"],[3,"InvocationCollector"],[3,"ExpansionConfig"],[3,"Marker"],[4,"ExpansionKind"],[4,"Expansion"],[4,"InvocationKind"],[3,"PlaceholderExpander"],[3,"BytePos"],[3,"Span"],[4,"FileName"],[8,"ToTokens"],[8,"ExtParseUtils"],[4,"Frame"],[4,"LockstepIterSize"],[3,"MatcherTtFrame"],[3,"MatcherPos"],[4,"TokenTreeOrTokenTreeVec"],[4,"ParseResult"],[4,"NamedMatch"],[3,"ParserAnyMacro"],[3,"MacroRulesMacroExpander"],[3,"FirstSets"],[3,"TokenSet"],[3,"Delimited"],[3,"SequenceRepetition"],[4,"KleeneOp"],[4,"TokenTree"]]};
searchIndex["syntax_ext"] = {"doc":"Syntax extensions in the Rust compiler.","items":[[5,"register_builtins","syntax_ext","",null,{"inputs":[{"name":"resolver"},{"generics":["namedsyntaxextension"],"name":"vec"},{"name":"bool"}],"output":null}],[0,"diagnostics","","",null,null],[0,"__register_diagnostic_E0660","syntax_ext::diagnostics","",null,null],[0,"__register_diagnostic_E0661","","",null,null],[0,"assert","syntax_ext","",null,null],[5,"expand_assert","syntax_ext::assert","",null,null],[0,"asm","syntax_ext","",null,null],[4,"State","syntax_ext::asm","",null,null],[13,"Asm","","",0,null],[13,"Outputs","","",0,null],[13,"Inputs","","",0,null],[13,"Clobbers","","",0,null],[13,"Options","","",0,null],[13,"StateNone","","",0,null],[5,"expand_asm","","",null,null],[17,"OPTIONS","","",null,null],[11,"next","","",0,{"inputs":[{"name":"self"}],"output":{"name":"state"}}],[0,"cfg","syntax_ext","",null,null],[5,"expand_cfg","syntax_ext::cfg","",null,null],[0,"compile_error","syntax_ext","",null,null],[5,"expand_compile_error","syntax_ext::compile_error","",null,null],[0,"concat","syntax_ext","",null,null],[5,"expand_syntax_ext","syntax_ext::concat","",null,null],[0,"concat_idents","syntax_ext","",null,null],[5,"expand_syntax_ext","syntax_ext::concat_idents","",null,null],[0,"env","syntax_ext","",null,null],[5,"expand_option_env","syntax_ext::env","",null,null],[5,"expand_env","","",null,null],[0,"format","syntax_ext","",null,null],[3,"Context","syntax_ext::format","",null,null],[12,"ecx","","",1,null],[12,"macsp","","The macro's call site. References to unstable formatting internals must use this span to pass the stability checker.",1,null],[12,"fmtsp","","The span of the format string literal.",1,null],[12,"args","","List of parsed argument expressions. Named expressions are resolved early, and are appended to the end of argument expressions.",1,null],[12,"arg_types","","Placeholder slot numbers indexed by argument.",1,null],[12,"arg_unique_types","","Unique format specs seen for each argument.",1,null],[12,"names","","Map from named arguments to their resolved indices.",1,null],[12,"literal","","The latest consecutive literal strings, or empty if there weren't any.",1,null],[12,"pieces","","Collection of the compiled `rt::Argument` structures",1,null],[12,"str_pieces","","Collection of string literals",1,null],[12,"all_pieces_simple","","Stays `true` if all formatting parameters are default (as in \"{}{}\").",1,null],[12,"arg_index_map","","Mapping between positional argument references and indices into the final generated static argument array. We record the starting indices corresponding to each positional argument, and number of references consumed so far for each argument, to facilitate correct `Position` mapping in `trans_piece`. In effect this can be seen as a \"flattened\" version of `arg_unique_types`.",1,null],[12,"count_args_index_offset","","Starting offset of count argument slots.",1,null],[12,"count_args","","Count argument slots and tracking data structures. Count arguments are separately tracked for de-duplication in case multiple references are made to one argument. For example, in this format string:",1,null],[12,"count_positions","","Relative slot numbers for count arguments.",1,null],[12,"count_positions_count","","Number of count slots assigned.",1,null],[12,"curarg","","Current position of the implicit positional arg pointer, as if it still existed in this phase of processing. Used only for `all_pieces_simple` tracking in `trans_piece`.",1,null],[12,"invalid_refs","","Keep track of invalid references to positional arguments",1,null],[4,"ArgumentType","","",null,null],[13,"Placeholder","","",2,null],[13,"Count","","",2,null],[4,"Position","","",null,null],[13,"Exact","","",3,null],[13,"Named","","",3,null],[5,"parse_args","","Parses the arguments from the given list of tokens, returning None if there's a parse error so we can continue parsing other format! expressions.",null,null],[5,"expand_format_args","","",null,null],[5,"expand_preparsed_format_args","","Take the various parts of `format_args!(efmt, args..., name=names...)` and construct the appropriate formatting expression.",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"generics":["expr"],"name":"p"},{"generics":["p"],"name":"vec"},{"generics":["string","usize"],"name":"hashmap"}],"output":{"generics":["expr"],"name":"p"}}],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"argumenttype"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"argumenttype"}],"output":{"name":"bool"}}],[11,"resolve_name_inplace","","",1,{"inputs":[{"name":"self"},{"name":"piece"}],"output":null}],[11,"verify_piece","","Verifies one piece of a parse string, and remembers it if valid. All errors are not emitted as fatal so we can continue giving errors about this and possibly other format strings.",1,{"inputs":[{"name":"self"},{"name":"piece"}],"output":null}],[11,"verify_count","","",1,{"inputs":[{"name":"self"},{"name":"count"}],"output":null}],[11,"describe_num_args","","",1,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"report_invalid_references","","Handle invalid references to positional arguments. Output different errors for the case where all arguments are positional and for when there are named arguments or numbered positional arguments in the format string.",1,{"inputs":[{"name":"self"},{"name":"bool"}],"output":null}],[11,"verify_arg_type","","Actually verifies and tracks a given format placeholder (a.k.a. argument).",1,{"inputs":[{"name":"self"},{"name":"position"},{"name":"argumenttype"}],"output":null}],[11,"build_index_map","","Builds the mapping between format placeholders and argument objects.",1,{"inputs":[{"name":"self"}],"output":null}],[11,"rtpath","","",1,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"generics":["ident"],"name":"vec"}}],[11,"trans_count","","",1,{"inputs":[{"name":"self"},{"name":"count"}],"output":{"generics":["expr"],"name":"p"}}],[11,"trans_literal_string","","Translate the accumulated string literals to a literal expression",1,{"inputs":[{"name":"self"}],"output":{"generics":["expr"],"name":"p"}}],[11,"trans_piece","","Translate a `parse::Piece` to a static `rt::Argument` or append to the `literal` string.",1,{"inputs":[{"name":"self"},{"name":"piece"},{"name":"vec"}],"output":{"generics":["p"],"name":"option"}}],[11,"into_expr","","Actually builds the expression which the format_args! block will be expanded to",1,{"inputs":[{"name":"self"}],"output":{"generics":["expr"],"name":"p"}}],[11,"format_arg","","",1,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"span"},{"name":"argumenttype"},{"name":"ident"}],"output":{"generics":["expr"],"name":"p"}}],[0,"format_foreign","syntax_ext","",null,null],[0,"printf","syntax_ext::format_foreign","",null,null],[3,"Format","syntax_ext::format_foreign::printf","A single `printf`-style formatting directive.",null,null],[12,"span","","The entire original formatting directive.",4,null],[12,"parameter","","The (1-based) parameter to be converted.",4,null],[12,"flags","","Formatting flags.",4,null],[12,"width","","Minimum width of the output.",4,null],[12,"precision","","Precision of the conversion.",4,null],[12,"length","","Length modifier for the conversion.",4,null],[12,"type_","","Type of parameter being converted.",4,null],[3,"Substitutions","","Iterator over substitutions in a string.",null,null],[12,"s","","",5,null],[4,"Substitution","","Represents a single `printf`-style substitution.",null,null],[13,"Format","","A formatted output substitution.",6,null],[13,"Escape","","A literal `%%` escape.",6,null],[4,"Num","","A general number used in a `printf` formatting directive.",null,null],[13,"Num","","A specific, fixed value.",7,null],[13,"Arg","","The value is derived from a positional argument.",7,null],[13,"Next","","The value is derived from the \"next\" unconverted argument.",7,null],[4,"State","","",null,null],[13,"Start","","",8,null],[13,"Flags","","",8,null],[13,"Width","","",8,null],[13,"WidthArg","","",8,null],[13,"Prec","","",8,null],[13,"PrecInner","","",8,null],[13,"Length","","",8,null],[13,"Type","","",8,null],[5,"iter_subs","","Returns an iterator over all substitutions in a given string.",null,{"inputs":[{"name":"str"}],"output":{"name":"substitutions"}}],[5,"parse_next_substitution","","Parse the next substitution from the input string.",null,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[5,"at_next_cp_while","","",null,{"inputs":[{"name":"cur"},{"name":"f"}],"output":{"name":"cur"}}],[5,"is_digit","","",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[5,"is_flag","","",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"substitution"}}],[11,"assert_receiver_is_total_eq","","",6,null],[11,"eq","","",6,{"inputs":[{"name":"self"},{"name":"substitution"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"self"},{"name":"substitution"}],"output":{"name":"bool"}}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_str","","",6,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"translate","","Translate this substitution into an equivalent Rust formatting directive.",6,{"inputs":[{"name":"self"}],"output":{"generics":["string"],"name":"option"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"format"}}],[11,"assert_receiver_is_total_eq","","",4,null],[11,"eq","","",4,{"inputs":[{"name":"self"},{"name":"format"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"self"},{"name":"format"}],"output":{"name":"bool"}}],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"translate","","Translate this directive into an equivalent Rust formatting directive.",4,{"inputs":[{"name":"self"}],"output":{"generics":["string"],"name":"option"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"num"}}],[11,"assert_receiver_is_total_eq","","",7,null],[11,"eq","","",7,{"inputs":[{"name":"self"},{"name":"num"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"self"},{"name":"num"}],"output":{"name":"bool"}}],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_str","","",7,{"inputs":[{"name":"str"},{"generics":["str"],"name":"option"}],"output":{"name":"self"}}],[11,"translate","","",7,{"inputs":[{"name":"self"},{"name":"string"}],"output":{"name":"result"}}],[11,"next","","",5,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",5,null],[0,"shell","syntax_ext::format_foreign","",null,null],[3,"Substitutions","syntax_ext::format_foreign::shell","Iterator over substitutions in a string.",null,null],[12,"s","","",9,null],[4,"Substitution","","",null,null],[13,"Ordinal","","",10,null],[13,"Name","","",10,null],[13,"Escape","","",10,null],[5,"iter_subs","","Returns an iterator over all substitutions in a given string.",null,{"inputs":[{"name":"str"}],"output":{"name":"substitutions"}}],[5,"parse_next_substitution","","Parse the next substitution from the input string.",null,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[5,"at_next_cp_while","","",null,{"inputs":[{"name":"cur"},{"name":"f"}],"output":{"name":"cur"}}],[5,"is_ident_head","","",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[5,"is_ident_tail","","",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"self"}],"output":{"name":"substitution"}}],[11,"assert_receiver_is_total_eq","","",10,null],[11,"eq","","",10,{"inputs":[{"name":"self"},{"name":"substitution"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"self"},{"name":"substitution"}],"output":{"name":"bool"}}],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_str","","",10,{"inputs":[{"name":"self"}],"output":{"name":"string"}}],[11,"translate","","",10,{"inputs":[{"name":"self"}],"output":{"generics":["string"],"name":"option"}}],[11,"next","","",9,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"size_hint","","",9,null],[0,"strcursor","syntax_ext::format_foreign","",null,null],[3,"StrCursor","syntax_ext::format_foreign::strcursor","",null,null],[12,"s","","",11,null],[12,"at","","",11,null],[5,"str_eq_literal","","",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"bool"}}],[11,"new_at_start","","",11,{"inputs":[{"name":"str"}],"output":{"name":"strcursor"}}],[11,"at_next_cp","","",11,{"inputs":[{"name":"self"}],"output":{"generics":["strcursor"],"name":"option"}}],[11,"next_cp","","",11,{"inputs":[{"name":"self"}],"output":{"name":"option"}}],[11,"slice_before","","",11,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"slice_after","","",11,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"slice_between","","",11,{"inputs":[{"name":"self"},{"name":"strcursor"}],"output":{"generics":["str"],"name":"option"}}],[11,"cp_after","","",11,{"inputs":[{"name":"self"}],"output":{"generics":["char"],"name":"option"}}],[11,"try_seek_right_cp","","",11,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"seek_right","","",11,{"inputs":[{"name":"self"},{"name":"usize"}],"output":null}],[11,"clone","","",11,{"inputs":[{"name":"self"}],"output":{"name":"strcursor"}}],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"generics":["error"],"name":"result"}}],[0,"global_asm","syntax_ext","",null,null],[5,"expand_global_asm","syntax_ext::global_asm","",null,null],[17,"MACRO","","",null,null],[0,"log_syntax","syntax_ext","",null,null],[5,"expand_syntax_ext","syntax_ext::log_syntax","",null,null],[0,"trace_macros","syntax_ext","",null,null],[5,"expand_trace_macros","syntax_ext::trace_macros","",null,null],[0,"proc_macro_registrar","syntax_ext","",null,null],[3,"ProcMacroDerive","syntax_ext::proc_macro_registrar","",null,null],[12,"trait_name","","",12,null],[12,"function_name","","",12,null],[12,"span","","",12,null],[12,"attrs","","",12,null],[3,"ProcMacroDef","","",null,null],[12,"function_name","","",13,null],[12,"span","","",13,null],[3,"CollectProcMacros","","",null,null],[12,"derives","","",14,null],[12,"attr_macros","","",14,null],[12,"bang_macros","","",14,null],[12,"in_root","","",14,null],[12,"handler","","",14,null],[12,"is_proc_macro_crate","","",14,null],[12,"is_test_crate","","",14,null],[5,"modify","","",null,{"inputs":[{"name":"parsesess"},{"name":"resolver"},{"name":"crate"},{"name":"bool"},{"name":"bool"},{"name":"usize"},{"name":"handler"}],"output":{"name":"crate"}}],[5,"is_proc_macro_attr","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"mk_registrar","","",null,null],[17,"PROC_MACRO_KINDS","","",null,null],[11,"check_not_pub_in_root","","",14,{"inputs":[{"name":"self"},{"name":"visibility"},{"name":"span"}],"output":null}],[11,"collect_custom_derive","","",14,{"inputs":[{"name":"self"},{"name":"item"},{"name":"attribute"}],"output":null}],[11,"collect_attr_proc_macro","","",14,{"inputs":[{"name":"self"},{"name":"item"},{"name":"attribute"}],"output":null}],[11,"collect_bang_proc_macro","","",14,{"inputs":[{"name":"self"},{"name":"item"},{"name":"attribute"}],"output":null}],[11,"visit_item","","",14,{"inputs":[{"name":"self"},{"name":"item"}],"output":null}],[11,"visit_mod","","",14,null],[11,"visit_mac","","",14,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[0,"deriving","syntax_ext","The compiler code necessary to implement the `#[derive]` extensions.",null,null],[5,"is_builtin_trait","syntax_ext::deriving","",null,{"inputs":[{"name":"name"}],"output":{"name":"bool"}}],[5,"register_builtin_derives","","",null,{"inputs":[{"name":"resolver"}],"output":null}],[5,"warn_if_deprecated","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[5,"hygienic_type_parameter","","Construct a name for the inner type parameter that can't collide with any type parameters of the item. This is achieved by starting with a base and then concatenating the names of all other type parameters.",null,{"inputs":[{"name":"annotatable"},{"name":"str"}],"output":{"name":"string"}}],[5,"call_intrinsic","","Constructs an expression that calls an intrinsic",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"},{"generics":["p"],"name":"vec"}],"output":{"generics":["expr"],"name":"p"}}],[0,"bounds","","",null,null],[5,"expand_deriving_unsafe_bound","syntax_ext::deriving::bounds","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"expand_deriving_copy","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[0,"clone","syntax_ext::deriving","",null,null],[5,"expand_deriving_clone","syntax_ext::deriving::clone","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"cs_clone_shallow","","",null,{"inputs":[{"name":"str"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"},{"name":"bool"}],"output":{"generics":["expr"],"name":"p"}}],[5,"cs_clone","","",null,{"inputs":[{"name":"str"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[0,"encodable","syntax_ext::deriving","The compiler code necessary to implement the `#[derive(Encodable)]` (and `Decodable`, in decodable.rs) extension.  The idea here is that type-defining items may be tagged with `#[derive(Encodable, Decodable)]`.",null,null],[5,"expand_deriving_rustc_encodable","syntax_ext::deriving::encodable","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"expand_deriving_encodable","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"expand_deriving_encodable_imp","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"},{"name":"str"}],"output":null}],[5,"encodable_substructure","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"},{"name":"str"}],"output":{"generics":["expr"],"name":"p"}}],[0,"decodable","syntax_ext::deriving","The compiler code necessary for `#[derive(Decodable)]`. See encodable.rs for more.",null,null],[5,"expand_deriving_rustc_decodable","syntax_ext::deriving::decodable","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"expand_deriving_decodable","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"expand_deriving_decodable_imp","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"},{"name":"str"}],"output":null}],[5,"decodable_substructure","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"},{"name":"str"}],"output":{"generics":["expr"],"name":"p"}}],[5,"decode_static_fields","","Create a decoder for a single enum variant/struct: - `outer_pat_path` is the path to this enum variant/struct - `getarg` should retrieve the `usize`-th field with name `@str`.",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"staticfields"},{"name":"f"}],"output":{"generics":["expr"],"name":"p"}}],[0,"hash","syntax_ext::deriving","",null,null],[5,"expand_deriving_hash","syntax_ext::deriving::hash","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"hash_substructure","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[0,"debug","syntax_ext::deriving","",null,null],[5,"expand_deriving_debug","syntax_ext::deriving::debug","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"show_substructure","","We use the debug builders to do the heavy lifting here",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[5,"stmt_let_undescore","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"generics":["expr"],"name":"p"}],"output":{"name":"stmt"}}],[0,"default","syntax_ext::deriving","",null,null],[5,"expand_deriving_default","syntax_ext::deriving::default","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"default_substructure","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[0,"custom","syntax_ext::deriving","",null,null],[3,"MarkAttrs","syntax_ext::deriving::custom","",null,null],[12,"0","","",15,null],[3,"ProcMacroDerive","","",null,null],[12,"inner","","",16,null],[12,"attrs","","",16,null],[11,"visit_attribute","","",15,{"inputs":[{"name":"self"},{"name":"attribute"}],"output":null}],[11,"visit_mac","","",15,{"inputs":[{"name":"self"},{"name":"mac"}],"output":null}],[11,"new","","",16,null],[11,"expand","","",16,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"}],"output":{"generics":["annotatable"],"name":"vec"}}],[0,"partial_eq","syntax_ext::deriving","",null,null],[5,"expand_deriving_partial_eq","syntax_ext::deriving::partial_eq","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[0,"eq","syntax_ext::deriving","",null,null],[5,"expand_deriving_eq","syntax_ext::deriving::eq","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"cs_total_eq_assert","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[0,"partial_ord","syntax_ext::deriving","",null,null],[4,"OrderingOp","syntax_ext::deriving::partial_ord","",null,null],[13,"PartialCmpOp","","",17,null],[13,"LtOp","","",17,null],[13,"LeOp","","",17,null],[13,"GtOp","","",17,null],[13,"GeOp","","",17,null],[5,"expand_deriving_partial_ord","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"some_ordering_collapsed","","",null,null],[5,"cs_partial_cmp","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[5,"cs_op","","Strict inequality.",null,{"inputs":[{"name":"bool"},{"name":"bool"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[11,"clone","","",17,{"inputs":[{"name":"self"}],"output":{"name":"orderingop"}}],[0,"ord","syntax_ext::deriving","",null,null],[5,"expand_deriving_ord","syntax_ext::deriving::ord","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[5,"ordering_collapsed","","",null,null],[5,"cs_cmp","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[0,"generic","syntax_ext::deriving","Some code that abstracts away much of the boilerplate of writing `derive` instances for traits. Among other things it manages getting access to the fields of the 4 different sorts of structs and enum variants, as well as creating the method and impl ast instances.",null,null],[3,"TraitDef","syntax_ext::deriving::generic","",null,null],[12,"span","","The span for the current #[derive(Foo)] header.",18,null],[12,"attributes","","",18,null],[12,"path","","Path of the trait, including any type parameters",18,null],[12,"additional_bounds","","Additional bounds required of any type parameters of the type, other than the current trait",18,null],[12,"generics","","Any extra lifetimes and/or bounds, e.g. `D: serialize::Decoder`",18,null],[12,"is_unsafe","","Is it an `unsafe` trait?",18,null],[12,"supports_unions","","Can this trait be derived for unions?",18,null],[12,"methods","","",18,null],[12,"associated_types","","",18,null],[3,"MethodDef","","",null,null],[12,"name","","name of the method",19,null],[12,"generics","","List of generics, e.g. `R: rand::Rng`",19,null],[12,"explicit_self","","Whether there is a self argument (outer Option) i.e. whether this is a static function, and whether it is a pointer (inner Option)",19,null],[12,"args","","Arguments other than the self argument",19,null],[12,"ret_ty","","Return type",19,null],[12,"attributes","","",19,null],[12,"is_unsafe","","",19,null],[12,"unify_fieldless_variants","","Can we combine fieldless variants for enums into a single match arm?",19,null],[12,"combine_substructure","","",19,null],[3,"Substructure","","All the data about the data structure/method being derived upon.",null,null],[12,"type_ident","","ident of self",20,null],[12,"method_ident","","ident of the method",20,null],[12,"self_args","","dereferenced access to any `Self_` or `Ptr(Self_, _)` arguments",20,null],[12,"nonself_args","","verbatim access to any other arguments",20,null],[12,"fields","","",20,null],[3,"FieldInfo","","Summary of the relevant parts of a struct/enum field.",null,null],[12,"span","","",21,null],[12,"name","","None for tuple structs/normal enum variants, Some for normal structs/struct enum variants.",21,null],[12,"self_","","The expression corresponding to this field of `self` (specifically, a reference to it).",21,null],[12,"other","","The expressions corresponding to references to this field in the other `Self` arguments.",21,null],[12,"attrs","","The attributes on the field",21,null],[4,"StaticFields","","Fields for a static method",null,null],[13,"Unnamed","","Tuple and unit structs/enum variants like this.",22,null],[13,"Named","","Normal structs/struct variants.",22,null],[4,"SubstructureFields","","A summary of the possible sets of fields.",null,null],[13,"Struct","","",23,null],[13,"EnumMatching","","Matching variants of the enum: variant index, variant count, ast::Variant, fields: the field name is only non-`None` in the case of a struct variant.",23,null],[13,"EnumNonMatchingCollapsed","","Non-matching variants of the enum, but with all state hidden from the consequent code.  The first component holds `Ident`s for all of the `Self` arguments; the second component is a slice of all of the variants for the enum itself, and the third component is a list of `Ident`s bound to the variant index values for each of the actual input `Self` arguments.",23,null],[13,"StaticStruct","","A static method where `Self` is a struct.",23,null],[13,"StaticEnum","","A static method where `Self` is an enum.",23,null],[5,"combine_substructure","","",null,{"inputs":[{"name":"combinesubstructurefunc"}],"output":{"generics":["combinesubstructurefunc"],"name":"refcell"}}],[5,"find_type_parameters","","This method helps to extract all the type parameters referenced from a type. For a type parameter `<T>`, it looks for either a `TyPath` that is not global and starts with `T`, or a `TyQPath`.",null,null],[5,"find_repr_type_name","","",null,null],[5,"cs_fold_fields","","",null,null],[5,"cs_fold_enumnonmatch","","",null,{"inputs":[{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[5,"cs_fold_static","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"generics":["expr"],"name":"p"}}],[5,"cs_fold","","Fold the fields. `use_foldl` controls whether this is done left-to-right (`true`) or right-to-left (`false`).",null,{"inputs":[{"name":"bool"},{"name":"f"},{"generics":["expr"],"name":"p"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[5,"cs_fold1","","Function to fold over fields, with three cases, to generate more efficient and concise code. When the `substructure` has grouped fields, there are two cases: Zero fields: call the base case function with None (like the usual base case of `cs_fold`). One or more fields: call the base case function on the first value (which depends on `use_fold`), and use that as the base case. Then perform `cs_fold` on the remainder of the fields. When the `substructure` is a `EnumNonMatchingCollapsed`, the result of `enum_nonmatch_f` is returned. Statics may not be folded over. See `cs_op` in `partial_ord.rs` for a model example.",null,{"inputs":[{"name":"bool"},{"name":"f"},{"name":"b"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[5,"cs_same_method","","Call the method that is being derived on all the fields, and then process the collected results. i.e.",null,{"inputs":[{"name":"f"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"generics":["expr"],"name":"p"}}],[5,"is_type_without_fields","","Return true if the type has no value fields (for an enum, no variant has any fields)",null,{"inputs":[{"name":"annotatable"}],"output":{"name":"bool"}}],[0,"ty","","A mini version of ast::Ty, which is easier to use, and features an explicit `Self` type to use when specifying impls to be derived.",null,null],[3,"Path","syntax_ext::deriving::generic::ty","A path, e.g. `::std::option::Option::<i32>` (global). Has support for type parameters and a lifetime.",null,null],[12,"path","","",24,null],[12,"lifetime","","",24,null],[12,"params","","",24,null],[12,"kind","","",24,null],[3,"LifetimeBounds","","Lifetimes and bounds on type parameters",null,null],[12,"lifetimes","","",25,null],[12,"bounds","","",25,null],[4,"PtrTy","","The types of pointers",null,null],[13,"Borrowed","","&'lifetime mut",26,null],[13,"Raw","","*mut",26,null],[4,"PathKind","","",null,null],[13,"Local","","",27,null],[13,"Global","","",27,null],[13,"Std","","",27,null],[4,"Ty","","A type. Supports pointers, Self, and literals",null,null],[13,"Self_","","",28,null],[13,"Ptr","","&/Box/ Ty",28,null],[13,"Literal","","mod::mod::Type<[lifetime], [Params...]>, including a plain type parameter, and things like `i32`",28,null],[13,"Tuple","","includes unit",28,null],[5,"borrowed_ptrty","","",null,{"inputs":[],"output":{"name":"ptrty"}}],[5,"borrowed","","",null,{"inputs":[{"generics":["ty"],"name":"box"}],"output":{"name":"ty"}}],[5,"borrowed_explicit_self","","",null,{"inputs":[],"output":{"generics":["option"],"name":"option"}}],[5,"borrowed_self","","",null,{"inputs":[],"output":{"name":"ty"}}],[5,"nil_ty","","",null,{"inputs":[],"output":{"name":"ty"}}],[5,"mk_lifetime","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"option"}],"output":{"generics":["lifetime"],"name":"option"}}],[5,"mk_lifetimes","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"option"}],"output":{"generics":["lifetime"],"name":"vec"}}],[5,"mk_ty_param","","",null,null],[5,"mk_generics","","",null,{"inputs":[{"generics":["genericparam"],"name":"vec"},{"name":"span"}],"output":{"name":"generics"}}],[5,"get_explicit_self","","",null,null],[11,"clone","","",26,{"inputs":[{"name":"self"}],"output":{"name":"ptrty"}}],[11,"assert_receiver_is_total_eq","","",26,null],[11,"eq","","",26,{"inputs":[{"name":"self"},{"name":"ptrty"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"self"},{"name":"ptrty"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"path"}}],[11,"assert_receiver_is_total_eq","","",24,null],[11,"eq","","",24,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"self"},{"name":"path"}],"output":{"name":"bool"}}],[11,"clone","","",27,{"inputs":[{"name":"self"}],"output":{"name":"pathkind"}}],[11,"assert_receiver_is_total_eq","","",27,null],[11,"eq","","",27,{"inputs":[{"name":"self"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",24,{"inputs":[{"generics":["str"],"name":"vec"}],"output":{"name":"path"}}],[11,"new_local","","",24,{"inputs":[{"name":"str"}],"output":{"name":"path"}}],[11,"new_","","",24,{"inputs":[{"generics":["str"],"name":"vec"},{"generics":["str"],"name":"option"},{"generics":["box"],"name":"vec"},{"name":"pathkind"}],"output":{"name":"path"}}],[11,"to_ty","","",24,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"generics":["ty"],"name":"p"}}],[11,"to_path","","",24,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",28,{"inputs":[{"name":"self"}],"output":{"name":"ty"}}],[11,"assert_receiver_is_total_eq","","",28,null],[11,"eq","","",28,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ne","","",28,{"inputs":[{"name":"self"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"to_ty","","",28,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"generics":["ty"],"name":"p"}}],[11,"to_path","","",28,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"lifetimebounds"}}],[11,"empty","","",25,{"inputs":[],"output":{"name":"lifetimebounds"}}],[11,"to_generics","","",25,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"generics"}}],[6,"CombineSubstructureFunc","syntax_ext::deriving::generic","Combine the values of all the fields together. The last argument is all the fields of all the structures.",null,null],[6,"EnumNonMatchCollapsedFunc","","Deal with non-matching enum variants.  The tuple is a list of identifiers (one for each `Self` argument, which could be any of the variants since they have been collapsed together) and the identifiers holding the variant index value for each of the `Self` arguments.  The last argument is all the non-`Self` args of the method being derived.",null,null],[11,"expand","","",18,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"}],"output":null}],[11,"expand_ext","","",18,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"metaitem"},{"name":"annotatable"},{"name":"fnmut"},{"name":"bool"}],"output":null}],[11,"create_derived_impl","","Given that we are deriving a trait `DerivedTrait` for a type like:",18,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"ident"},{"name":"generics"},{"generics":["p"],"name":"vec"},{"generics":["implitem"],"name":"vec"}],"output":{"generics":["item"],"name":"p"}}],[11,"expand_struct_def","","",18,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"variantdata"},{"name":"ident"},{"name":"generics"},{"name":"bool"},{"name":"bool"}],"output":{"generics":["item"],"name":"p"}}],[11,"expand_enum_def","","",18,null],[11,"call_substructure_method","","",19,null],[11,"get_ret_ty","","",19,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"traitdef"},{"name":"generics"},{"name":"ident"}],"output":{"generics":["ty"],"name":"p"}}],[11,"is_static","","",19,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"split_self_nonself_args","","",19,null],[11,"create_method","","",19,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"traitdef"},{"name":"ident"},{"name":"generics"},{"name":"abi"},{"generics":["explicitself"],"name":"option"},{"name":"vec"},{"generics":["expr"],"name":"p"}],"output":{"name":"implitem"}}],[11,"expand_struct_method_body","","",19,null],[11,"expand_static_struct_method_body","","",19,null],[11,"expand_enum_method_body","","",19,null],[11,"build_enum_match_tuple","","Creates a match for a tuple of all `self_args`, where either all variants match, or it falls into a catch-all for when one variant does not match. There are N + 1 cases because is a case for each of the N variants where all of the variants match, and one catch-all for when one does not match. As an optimization we generate code which checks whether all variants match first which makes llvm see that C-like enums can be compiled into a simple equality check (for PartialEq). The catch-all handler is provided access the variant index values for each of the self-args, carried in precomputed variables. ```{.text} let __self0_vi = unsafe {     std::intrinsics::discriminant_value(&self) } as i32; let __self1_vi = unsafe {     std::intrinsics::discriminant_value(&arg1) } as i32; let __self2_vi = unsafe {     std::intrinsics::discriminant_value(&arg2) } as i32;",19,null],[11,"expand_static_enum_method_body","","",19,null],[11,"summarise_struct","","",18,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"variantdata"}],"output":{"name":"staticfields"}}],[11,"create_subpatterns","","",18,{"inputs":[{"name":"self"},{"name":"extctxt"},{"generics":["ident"],"name":"vec"},{"name":"mutability"},{"name":"bool"}],"output":{"generics":["p"],"name":"vec"}}],[11,"create_struct_pattern","","",18,null],[11,"create_enum_variant_pattern","","",18,null],[0,"proc_macro_impl","syntax_ext","",null,null],[3,"AttrProcMacro","syntax_ext::proc_macro_impl","",null,null],[12,"inner","","",29,null],[3,"BangProcMacro","","",null,null],[12,"inner","","",30,null],[11,"expand","","",29,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[11,"expand","","",30,{"inputs":[{"name":"self"},{"name":"extctxt"},{"name":"span"},{"name":"tokenstream"}],"output":{"name":"tokenstream"}}],[14,"path_local","syntax_ext","",null,null],[14,"pathvec_std","","",null,null],[14,"path_std","","",null,null]],"paths":[[4,"State"],[3,"Context"],[4,"ArgumentType"],[4,"Position"],[3,"Format"],[3,"Substitutions"],[4,"Substitution"],[4,"Num"],[4,"State"],[3,"Substitutions"],[4,"Substitution"],[3,"StrCursor"],[3,"ProcMacroDerive"],[3,"ProcMacroDef"],[3,"CollectProcMacros"],[3,"MarkAttrs"],[3,"ProcMacroDerive"],[4,"OrderingOp"],[3,"TraitDef"],[3,"MethodDef"],[3,"Substructure"],[3,"FieldInfo"],[4,"StaticFields"],[4,"SubstructureFields"],[3,"Path"],[3,"LifetimeBounds"],[4,"PtrTy"],[4,"PathKind"],[4,"Ty"],[3,"AttrProcMacro"],[3,"BangProcMacro"]]};
searchIndex["syntax_pos"] = {"doc":"The source positions and related helper functions","items":[[3,"Span","syntax_pos","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",null,null],[12,"0","","",0,null],[3,"Globals","","",null,null],[12,"symbol_interner","","",1,null],[12,"span_interner","","",1,null],[12,"hygiene_data","","",1,null],[3,"SpanData","","Spans represent a region of code, used for error reporting. Positions in spans are absolute positions from the beginning of the codemap, not positions relative to FileMaps. Methods on the CodeMap can be used to relate spans back to the original source. You must be careful if the span crosses more than one file - you will not be able to use many of the functions on spans in codemap and you cannot assume that the length of the span = hi - lo; there may be space in the BytePos range between files.",null,null],[12,"lo","","",2,null],[12,"hi","","",2,null],[12,"ctxt","","Information about where the macro came from, if this piece of code was created by a macro expansion.",2,null],[3,"MultiSpan","","A collection of spans. Spans have two orthogonal attributes:",null,null],[12,"primary_spans","","",3,null],[12,"span_labels","","",3,null],[3,"SpanLabel","","",null,null],[12,"span","","The span we are going to include in the final snippet.",4,null],[12,"is_primary","","Is this a primary span? This is the \"locus\" of the message, and is indicated with a `^^^^` underline, versus `----`.",4,null],[12,"label","","What label should we attach to this span (if any)?",4,null],[3,"MultiByteChar","","Identifies an offset of a multi-byte character in a FileMap",null,null],[12,"pos","","The absolute offset of the character in the CodeMap",5,null],[12,"bytes","","The number of bytes, >=2",5,null],[3,"FileMap","","A single source in the CodeMap.",null,null],[12,"name","","The name of the file that the source came from, source that doesn't originate from files has names between angle brackets by convention, e.g. `<anon>`",6,null],[12,"name_was_remapped","","True if the `name` field above has been modified by --remap-path-prefix",6,null],[12,"unmapped_path","","The unmapped path of the file that the source came from. Set to `None` if the FileMap was imported from an external crate.",6,null],[12,"crate_of_origin","","Indicates which crate this FileMap was imported from.",6,null],[12,"src","","The complete source code",6,null],[12,"src_hash","","The source code's hash",6,null],[12,"external_src","","The external source code (used for external crates, which will have a `None` value as `self.src`.",6,null],[12,"start_pos","","The start position of this source in the CodeMap",6,null],[12,"end_pos","","The end position of this source in the CodeMap",6,null],[12,"lines","","Locations of lines beginnings in the source code",6,null],[12,"multibyte_chars","","Locations of multi-byte characters in the source code",6,null],[12,"non_narrow_chars","","Width of characters that are not narrow in the source code",6,null],[12,"name_hash","","A hash of the filename, used for speeding up the incr. comp. hashing.",6,null],[3,"BytePos","","A byte offset. Keep this small (currently 32-bits), as AST contains a lot of them.",null,null],[12,"0","","",7,null],[3,"CharPos","","A character offset. Because of multibyte utf8 characters, a byte offset is not equivalent to a character offset. The CodeMap will convert BytePos values to CharPos values as necessary.",null,null],[12,"0","","",8,null],[3,"Loc","","A source code location used for error reporting",null,null],[12,"file","","Information about the original source",9,null],[12,"line","","The (1-based) line number",9,null],[12,"col","","The (0-based) column offset",9,null],[12,"col_display","","The (0-based) column offset when displayed",9,null],[3,"LocWithOpt","","A source code location used as the result of lookup_char_pos_adj",null,null],[12,"filename","","",10,null],[12,"line","","",10,null],[12,"col","","",10,null],[12,"file","","",10,null],[3,"FileMapAndLine","","",null,null],[12,"fm","","",11,null],[12,"line","","",11,null],[3,"FileMapAndBytePos","","",null,null],[12,"fm","","",12,null],[12,"pos","","",12,null],[3,"LineInfo","","",null,null],[12,"line_index","","Index of line, starting from 0.",13,null],[12,"start_col","","Column in line where span begins, starting from 0.",13,null],[12,"end_col","","Column in line where span ends, starting from 0, exclusive.",13,null],[3,"FileLines","","",null,null],[12,"file","","",14,null],[12,"lines","","",14,null],[3,"MacroBacktrace","","",null,null],[12,"call_site","","span where macro was applied to generate this code",15,null],[12,"macro_decl_name","","name of macro that was applied (e.g., \"foo!\" or \"#[derive(Eq)]\")",15,null],[12,"def_site_span","","span where macro was defined (if known)",15,null],[3,"DistinctSources","","",null,null],[12,"begin","","",16,null],[12,"end","","",16,null],[3,"MalformedCodemapPositions","","",null,null],[12,"name","","",17,null],[12,"source_len","","",17,null],[12,"begin_pos","","",17,null],[12,"end_pos","","",17,null],[4,"FileName","","Differentiates between real files and common virtual files",null,null],[13,"Real","","",18,null],[13,"Macros","","e.g. \"std\" macros",18,null],[13,"QuoteExpansion","","call to `quote!`",18,null],[13,"Anon","","Command line",18,null],[13,"MacroExpansion","","Hack in src/libsyntax/parse.rs FIXME(jseyfried)",18,null],[13,"ProcMacroSourceCode","","",18,null],[13,"CfgSpec","","Strings provided as --cfg [cfgspec] stored in a crate_cfg",18,null],[13,"Custom","","Custom sources for explicit parser calls from plugins and drivers",18,null],[4,"NonNarrowChar","","Identifies an offset of a non-narrow character in a FileMap",null,null],[13,"ZeroWidth","","Represents a zero-width character",19,null],[13,"Wide","","Represents a wide (fullwidth) character",19,null],[13,"Tab","","Represents a tab character, represented visually with a width of 4 characters",19,null],[4,"ExternalSource","","The state of the lazy external source loading mechanism of a FileMap.",null,null],[13,"Present","","The external source has been loaded already.",20,null],[13,"AbsentOk","","No attempt has been made to load the external source.",20,null],[13,"AbsentErr","","A failed attempt has been made to load the external source.",20,null],[13,"Unneeded","","No external source has to be loaded, since the FileMap represents a local crate.",20,null],[4,"SpanLinesError","","",null,null],[13,"IllFormedSpan","","",21,null],[13,"DistinctSources","","",21,null],[4,"SpanSnippetError","","",null,null],[13,"IllFormedSpan","","",22,null],[13,"DistinctSources","","",22,null],[13,"MalformedForCodemap","","",22,null],[13,"SourceNotAvailable","","",22,null],[12,"filename","syntax_pos::SpanSnippetError","",22,null],[5,"default_span_debug","syntax_pos","",null,{"inputs":[{"name":"span"},{"name":"formatter"}],"output":{"name":"result"}}],[5,"remove_bom","","Remove utf-8 BOM if any.",null,{"inputs":[{"name":"string"}],"output":null}],[5,"lookup_line","","",null,null],[0,"hygiene","","Machinery for hygienic macros, inspired by the `MTWT[1]` paper.",null,null],[3,"SyntaxContext","syntax_pos::hygiene","A SyntaxContext represents a chain of macro expansions (represented by marks).",null,null],[12,"0","","",23,null],[3,"SyntaxContextData","","",null,null],[12,"outer_mark","","",24,null],[12,"prev_ctxt","","",24,null],[12,"modern","","",24,null],[3,"Mark","","A mark is a unique id associated with a macro expansion.",null,null],[12,"0","","",25,null],[3,"MarkData","","",null,null],[12,"parent","","",26,null],[12,"kind","","",26,null],[12,"expn_info","","",26,null],[3,"HygieneData","","",null,null],[12,"marks","","",27,null],[12,"syntax_contexts","","",27,null],[12,"markings","","",27,null],[12,"gensym_to_ctxt","","",27,null],[3,"ExpnInfo","","Extra information for tracking spans of macro and syntax sugar expansion",null,null],[12,"call_site","","The location of the actual macro invocation or syntax sugar , e.g. `let x = foo!();` or `if let Some(y) = x {}`",28,null],[12,"callee","","Information about the expansion.",28,null],[3,"NameAndSpan","","",null,null],[12,"format","","The format with which the macro was invoked.",29,null],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated features internally without forcing the whole crate to opt-in to them.",29,null],[12,"allow_internal_unsafe","","Whether the macro is allowed to use `unsafe` internally even if the user crate has `#![forbid(unsafe_code)]`.",29,null],[12,"span","","The span of the macro definition itself. The macro may not have a sensible definition span (e.g. something defined completely inside libsyntax) in which case this is None.",29,null],[4,"MarkKind","","",null,null],[13,"Modern","","",30,null],[13,"Builtin","","",30,null],[13,"Legacy","","",30,null],[4,"ExpnFormat","","The source of expansion.",null,null],[13,"MacroAttribute","","e.g. #[derive(...)] ",31,null],[13,"MacroBang","","e.g. `format!()`",31,null],[13,"CompilerDesugaring","","Desugaring done by the compiler during HIR lowering.",31,null],[4,"CompilerDesugaringKind","","The kind of compiler desugaring.",null,null],[13,"DotFill","","",32,null],[13,"QuestionMark","","",32,null],[13,"Catch","","",32,null],[5,"clear_markings","","",null,{"inputs":[],"output":null}],[11,"clone","","",23,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"eq","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",23,null],[11,"default","","",23,{"inputs":[],"output":{"name":"syntaxcontext"}}],[11,"partial_cmp","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"le","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"gt","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"ge","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"bool"}}],[11,"cmp","","",23,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"ordering"}}],[11,"hash","","",23,null],[11,"clone","","",24,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontextdata"}}],[11,"clone","","",25,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"eq","","",25,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",25,null],[11,"hash","","",25,null],[11,"fmt","","",25,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",25,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",25,{"inputs":[{"name":"__d"}],"output":{"generics":["mark"],"name":"result"}}],[11,"clone","","",30,{"inputs":[{"name":"self"}],"output":{"name":"markkind"}}],[11,"eq","","",30,{"inputs":[{"name":"self"},{"name":"markkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",30,null],[11,"fresh","","",25,{"inputs":[{"name":"mark"}],"output":{"name":"self"}}],[11,"root","","The mark of the theoretical expansion that generates freshly parsed, unexpanded AST.",25,{"inputs":[],"output":{"name":"self"}}],[11,"as_u32","","",25,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"from_u32","","",25,{"inputs":[{"name":"u32"}],"output":{"name":"mark"}}],[11,"expn_info","","",25,{"inputs":[{"name":"self"}],"output":{"generics":["expninfo"],"name":"option"}}],[11,"set_expn_info","","",25,{"inputs":[{"name":"self"},{"name":"expninfo"}],"output":null}],[11,"modern","","",25,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"kind","","",25,{"inputs":[{"name":"self"}],"output":{"name":"markkind"}}],[11,"set_kind","","",25,{"inputs":[{"name":"self"},{"name":"markkind"}],"output":null}],[11,"is_descendant_of","","",25,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"bool"}}],[11,"least_ancestor","","Computes a mark such that both input marks are descendants of (or equal to) the returned mark. That is, the following holds:",25,{"inputs":[{"name":"mark"},{"name":"mark"}],"output":{"name":"mark"}}],[11,"new","","",27,{"inputs":[],"output":{"name":"self"}}],[11,"with","","",27,{"inputs":[{"name":"f"}],"output":{"name":"t"}}],[11,"empty","","",23,{"inputs":[],"output":{"name":"self"}}],[11,"allocate_directly","","",23,{"inputs":[{"name":"expninfo"}],"output":{"name":"self"}}],[11,"apply_mark","","Extend a syntax context with a given mark",23,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"syntaxcontext"}}],[11,"apply_mark_internal","","",23,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"syntaxcontext"}}],[11,"remove_mark","","Pulls a single mark off of the syntax context. This effectively moves the context up one macro definition level. That is, if we have a nested macro definition as follows:",23,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"marks","","",23,{"inputs":[{"name":"self"}],"output":{"generics":["mark"],"name":"vec"}}],[11,"adjust","","Adjust this context for resolution in a scope created by the given expansion. For example, consider the following three resolutions of `f`:",23,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"generics":["mark"],"name":"option"}}],[11,"glob_adjust","","Adjust this context for resolution in a scope created by the given expansion via a glob import with the given `SyntaxContext`. For example:",23,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"reverse_glob_adjust","","Undo `glob_adjust` if possible:",23,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"modern","","",23,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"outer","","",23,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"fmt","","",23,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",28,{"inputs":[{"name":"self"}],"output":{"name":"expninfo"}}],[11,"hash","","",28,null],[11,"fmt","","",28,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",28,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",28,{"inputs":[{"name":"__d"}],"output":{"generics":["expninfo"],"name":"result"}}],[11,"clone","","",29,{"inputs":[{"name":"self"}],"output":{"name":"nameandspan"}}],[11,"hash","","",29,null],[11,"fmt","","",29,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",29,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",29,{"inputs":[{"name":"__d"}],"output":{"generics":["nameandspan"],"name":"result"}}],[11,"name","","",29,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"clone","","",31,{"inputs":[{"name":"self"}],"output":{"name":"expnformat"}}],[11,"hash","","",31,null],[11,"fmt","","",31,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",31,{"inputs":[{"name":"self"},{"name":"expnformat"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"self"},{"name":"expnformat"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",31,null],[11,"encode","","",31,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",31,{"inputs":[{"name":"__d"}],"output":{"generics":["expnformat"],"name":"result"}}],[11,"clone","","",32,{"inputs":[{"name":"self"}],"output":{"name":"compilerdesugaringkind"}}],[11,"hash","","",32,null],[11,"fmt","","",32,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",32,{"inputs":[{"name":"self"},{"name":"compilerdesugaringkind"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",32,null],[11,"encode","","",32,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",32,{"inputs":[{"name":"__d"}],"output":{"generics":["compilerdesugaringkind"],"name":"result"}}],[11,"as_symbol","","",32,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"encode","","",23,{"inputs":[{"name":"self"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"d"}],"output":{"generics":["syntaxcontext"],"name":"result"}}],[0,"span_encoding","syntax_pos","",null,null],[3,"Span","syntax_pos::span_encoding","A compressed span. Contains either fields of `SpanData` inline if they are small, or index into span interner. The primary goal of `Span` is to be as small as possible and fit into other structures (that's why it uses `packed` as well). Decoding speed is the second priority. See `SpanData` for the info on span fields in decoded representation.",null,null],[12,"0","","",0,null],[3,"SpanInterner","","",null,null],[12,"spans","","",33,null],[12,"span_data","","",33,null],[5,"encode","","",null,{"inputs":[{"name":"spandata"}],"output":{"name":"span"}}],[5,"decode","","",null,{"inputs":[{"name":"span"}],"output":{"name":"spandata"}}],[5,"with_span_interner","","",null,{"inputs":[{"name":"f"}],"output":{"name":"t"}}],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",null,null],[17,"TAG_INLINE","","",null,null],[17,"TAG_INTERNED","","",null,null],[17,"TAG_MASK","","",null,null],[17,"BASE_INDEX","","",null,null],[17,"LEN_INDEX","","",null,null],[17,"CTXT_INDEX","","",null,null],[17,"INLINE_SIZES","","",null,null],[17,"INLINE_OFFSETS","","",null,null],[17,"INTERNED_INDEX_SIZE","","",null,null],[17,"INTERNED_INDEX_OFFSET","","",null,null],[11,"clone","syntax_pos","",0,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"eq","","",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"hash","","",0,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"new","","",0,{"inputs":[{"name":"bytepos"},{"name":"bytepos"},{"name":"syntaxcontext"}],"output":{"name":"self"}}],[11,"data","","",0,{"inputs":[{"name":"self"}],"output":{"name":"spandata"}}],[11,"default","syntax_pos::span_encoding","",33,{"inputs":[],"output":{"name":"spaninterner"}}],[11,"intern","","",33,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"u32"}}],[11,"get","","",33,{"inputs":[{"name":"self"},{"name":"u32"}],"output":{"name":"spandata"}}],[0,"symbol","syntax_pos","An \"interner\" is a data structure that associates values with usize tags and allows bidirectional lookup; i.e. given a value, one can easily find the type, and vice versa.",null,null],[3,"Ident","syntax_pos::symbol","",null,null],[12,"name","","",34,null],[12,"span","","",34,null],[3,"Symbol","","A symbol is an interned or gensymed string.",null,null],[12,"0","","",35,null],[3,"Interner","","",null,null],[12,"names","","",36,null],[12,"strings","","",36,null],[12,"gensyms","","",36,null],[3,"LocalInternedString","","Represents a string stored in the interner. Because the interner outlives any thread which uses this type, we can safely treat `string` which points to interner data, as an immortal string, as long as this type never crosses between threads.",null,null],[12,"string","","",37,null],[3,"InternedString","","Represents a string stored in the string interner",null,null],[12,"symbol","","",38,null],[5,"with_interner","","",null,{"inputs":[{"name":"f"}],"output":{"name":"t"}}],[0,"keywords","","",null,null],[3,"Keyword","syntax_pos::symbol::keywords","",null,null],[12,"ident","","",39,null],[17,"Invalid","","",null,null],[17,"CrateRoot","","",null,null],[17,"DollarCrate","","",null,null],[17,"Underscore","","",null,null],[17,"As","","",null,null],[17,"Box","","",null,null],[17,"Break","","",null,null],[17,"Const","","",null,null],[17,"Continue","","",null,null],[17,"Crate","","",null,null],[17,"Else","","",null,null],[17,"Enum","","",null,null],[17,"Extern","","",null,null],[17,"False","","",null,null],[17,"Fn","","",null,null],[17,"For","","",null,null],[17,"If","","",null,null],[17,"Impl","","",null,null],[17,"In","","",null,null],[17,"Let","","",null,null],[17,"Loop","","",null,null],[17,"Match","","",null,null],[17,"Mod","","",null,null],[17,"Move","","",null,null],[17,"Mut","","",null,null],[17,"Pub","","",null,null],[17,"Ref","","",null,null],[17,"Return","","",null,null],[17,"SelfValue","","",null,null],[17,"SelfType","","",null,null],[17,"Static","","",null,null],[17,"Struct","","",null,null],[17,"Super","","",null,null],[17,"Trait","","",null,null],[17,"True","","",null,null],[17,"Type","","",null,null],[17,"Unsafe","","",null,null],[17,"Use","","",null,null],[17,"Where","","",null,null],[17,"While","","",null,null],[17,"Abstract","","",null,null],[17,"Alignof","","",null,null],[17,"Become","","",null,null],[17,"Do","","",null,null],[17,"Final","","",null,null],[17,"Macro","","",null,null],[17,"Offsetof","","",null,null],[17,"Override","","",null,null],[17,"Priv","","",null,null],[17,"Pure","","",null,null],[17,"Sizeof","","",null,null],[17,"Typeof","","",null,null],[17,"Unsized","","",null,null],[17,"Virtual","","",null,null],[17,"Yield","","",null,null],[17,"UnderscoreLifetime","","",null,null],[17,"StaticLifetime","","",null,null],[17,"Auto","","",null,null],[17,"Catch","","",null,null],[17,"Default","","",null,null],[17,"Dyn","","",null,null],[17,"Union","","",null,null],[11,"clone","","",39,{"inputs":[{"name":"self"}],"output":{"name":"keyword"}}],[11,"eq","","",39,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"self"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",39,null],[11,"ident","","",39,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"name","","",39,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"clone","syntax_pos::symbol","",34,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"assert_receiver_is_total_eq","","",34,null],[11,"new","","",34,{"inputs":[{"name":"symbol"},{"name":"span"}],"output":{"name":"ident"}}],[11,"with_empty_ctxt","","",34,{"inputs":[{"name":"symbol"}],"output":{"name":"ident"}}],[11,"from_interned_str","","Maps an interned string to an identifier with an empty syntax context.",34,{"inputs":[{"name":"internedstring"}],"output":{"name":"ident"}}],[11,"from_str","","Maps a string to an identifier with an empty syntax context.",34,{"inputs":[{"name":"str"}],"output":{"name":"ident"}}],[11,"with_span_pos","","Replace `lo` and `hi` with those from `span`, but keep hygiene context.",34,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"ident"}}],[11,"without_first_quote","","",34,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"modern","","",34,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"gensym","","",34,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}],[11,"eq","","",34,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"bool"}}],[11,"hash","","",34,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"fmt","","",34,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",34,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",34,{"inputs":[{"name":"d"}],"output":{"generics":["ident"],"name":"result"}}],[11,"clone","","",35,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"eq","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",35,null],[11,"partial_cmp","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"le","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"gt","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"ge","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"cmp","","",35,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"ordering"}}],[11,"hash","","",35,null],[11,"intern","","Maps a string to its interned representation.",35,{"inputs":[{"name":"str"}],"output":{"name":"self"}}],[11,"interned","","",35,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"gensym","","gensym's a new usize, using the current interner.",35,{"inputs":[{"name":"str"}],"output":{"name":"self"}}],[11,"gensymed","","",35,{"inputs":[{"name":"self"}],"output":{"name":"self"}}],[11,"as_str","","",35,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"as_interned_str","","",35,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"as_u32","","",35,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",35,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",35,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",35,{"inputs":[{"name":"d"}],"output":{"generics":["symbol"],"name":"result"}}],[11,"eq","","",35,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"default","","",36,{"inputs":[],"output":{"name":"interner"}}],[11,"new","","",36,{"inputs":[],"output":{"name":"self"}}],[11,"prefill","","",36,null],[11,"intern","","",36,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"symbol"}}],[11,"interned","","",36,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"symbol"}}],[11,"gensym","","",36,{"inputs":[{"name":"self"},{"name":"str"}],"output":{"name":"symbol"}}],[11,"gensymed","","",36,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"symbol"}}],[11,"is_gensymed","","",36,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"bool"}}],[11,"get","","",36,{"inputs":[{"name":"self"},{"name":"symbol"}],"output":{"name":"str"}}],[11,"fresh","","",36,{"inputs":[],"output":{"name":"self"}}],[11,"clone","","",37,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"hash","","",37,null],[11,"partial_cmp","","",37,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",37,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"le","","",37,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"gt","","",37,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"ge","","",37,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",37,null],[11,"cmp","","",37,{"inputs":[{"name":"self"},{"name":"localinternedstring"}],"output":{"name":"ordering"}}],[11,"as_interned_str","","",37,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"as_ref","","",37,{"inputs":[{"name":"self"}],"output":{"name":"u"}}],[11,"eq","","",37,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"deref","","",37,{"inputs":[{"name":"self"}],"output":{"name":"str"}}],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",37,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",37,{"inputs":[{"name":"d"}],"output":{"generics":["localinternedstring"],"name":"result"}}],[11,"encode","","",37,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"clone","","",38,{"inputs":[{"name":"self"}],"output":{"name":"internedstring"}}],[11,"assert_receiver_is_total_eq","","",38,null],[11,"with","","",38,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"r"}}],[11,"as_symbol","","",38,{"inputs":[{"name":"self"}],"output":{"name":"symbol"}}],[11,"as_str","","",38,{"inputs":[{"name":"self"}],"output":{"name":"localinternedstring"}}],[11,"hash","","",38,{"inputs":[{"name":"self"},{"name":"h"}],"output":null}],[11,"partial_cmp","","",38,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",38,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"ordering"}}],[11,"eq","","",38,{"inputs":[{"name":"self"},{"name":"t"}],"output":{"name":"bool"}}],[11,"eq","","",38,{"inputs":[{"name":"self"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",38,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",38,{"inputs":[{"name":"d"}],"output":{"generics":["internedstring"],"name":"result"}}],[11,"encode","","",38,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[6,"FileLinesResult","syntax_pos","",null,null],[7,"GLOBALS","","",null,null],[17,"DUMMY_SP","","Dummy span, both position and length are zero, syntax context is zero as well. This span is kept inline and encoded with format 0.",null,null],[17,"NO_EXPANSION","","",null,null],[17,"SPAN_DEBUG","","",null,null],[8,"Pos","","",null,null],[10,"from_usize","","",40,{"inputs":[{"name":"usize"}],"output":{"name":"self"}}],[10,"to_usize","","",40,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"new","","",1,{"inputs":[],"output":{"name":"globals"}}],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"assert_receiver_is_total_eq","","",18,null],[11,"eq","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"self"}],"output":{"name":"filename"}}],[11,"cmp","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"self"},{"name":"filename"}],"output":{"name":"bool"}}],[11,"hash","","",18,null],[11,"decode","","",18,{"inputs":[{"name":"__d"}],"output":{"generics":["filename"],"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",18,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from","","",18,{"inputs":[{"name":"pathbuf"}],"output":{"name":"self"}}],[11,"is_real","","",18,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_macros","","",18,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"clone","","",2,{"inputs":[{"name":"self"}],"output":{"name":"spandata"}}],[11,"hash","","",2,null],[11,"eq","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",2,null],[11,"cmp","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"bool"}}],[11,"le","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"bool"}}],[11,"gt","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"bool"}}],[11,"ge","","",2,{"inputs":[{"name":"self"},{"name":"spandata"}],"output":{"name":"bool"}}],[11,"with_lo","","",2,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"with_hi","","",2,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"with_ctxt","","",2,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"span"}}],[11,"partial_cmp","","",0,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"cmp","","",0,{"inputs":[{"name":"self"},{"name":"self"}],"output":{"name":"ordering"}}],[11,"clone","","",3,{"inputs":[{"name":"self"}],"output":{"name":"multispan"}}],[11,"fmt","","",3,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",3,null],[11,"eq","","",3,{"inputs":[{"name":"self"},{"name":"multispan"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"self"},{"name":"multispan"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",3,null],[11,"encode","","",3,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",3,{"inputs":[{"name":"__d"}],"output":{"generics":["multispan"],"name":"result"}}],[11,"lo","","",0,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"with_lo","","",0,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"hi","","",0,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"with_hi","","",0,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"span"}}],[11,"ctxt","","",0,{"inputs":[{"name":"self"}],"output":{"name":"syntaxcontext"}}],[11,"with_ctxt","","",0,{"inputs":[{"name":"self"},{"name":"syntaxcontext"}],"output":{"name":"span"}}],[11,"shrink_to_lo","","Returns a new span representing an empty span at the beginning of this span",0,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"shrink_to_hi","","Returns a new span representing an empty span at the end of this span",0,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"substitute_dummy","","Returns `self` if `self` is not the dummy span, and `other` otherwise.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"contains","","Return true if `self` fully encloses `other`.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"source_equal","","Return true if the spans are equal with regards to the source text.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"bool"}}],[11,"trim_start","","Returns `Some(span)`, where the start is trimmed by the end of `other`",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"generics":["span"],"name":"option"}}],[11,"source_callsite","","Return the source span - this is either the supplied span, or the span for the macro callsite that expanded to it.",0,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"parent","","The `Span` for the tokens in the previous macro expansion from which `self` was generated, if any",0,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"option"}}],[11,"source_callee","","Return the source callee.",0,{"inputs":[{"name":"self"}],"output":{"generics":["nameandspan"],"name":"option"}}],[11,"allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable] items can be used (that is, a macro marked with `#[allow_internal_unstable]`).",0,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_compiler_desugaring","","Check if this span arises from a compiler desugaring of kind `kind`.",0,{"inputs":[{"name":"self"},{"name":"compilerdesugaringkind"}],"output":{"name":"bool"}}],[11,"compiler_desugaring_kind","","Return the compiler desugaring that created this span, or None if this span is not from a desugaring.",0,{"inputs":[{"name":"self"}],"output":{"generics":["compilerdesugaringkind"],"name":"option"}}],[11,"allows_unsafe","","Check if a span is \"internal\" to a macro in which `unsafe` can be used without triggering the `unsafe_code` lint",0,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"macro_backtrace","","",0,{"inputs":[{"name":"self"}],"output":{"generics":["macrobacktrace"],"name":"vec"}}],[11,"to","","Return a `Span` that would enclose both `self` and `end`.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"between","","Return a `Span` between the end of `self` to the beginning of `end`.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"until","","Return a `Span` between the beginning of `self` to the beginning of `end`.",0,{"inputs":[{"name":"self"},{"name":"span"}],"output":{"name":"span"}}],[11,"apply_mark","","",0,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"name":"span"}}],[11,"remove_mark","","",0,{"inputs":[{"name":"self"}],"output":{"name":"mark"}}],[11,"adjust","","",0,{"inputs":[{"name":"self"},{"name":"mark"}],"output":{"generics":["mark"],"name":"option"}}],[11,"glob_adjust","","",0,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"reverse_glob_adjust","","",0,{"inputs":[{"name":"self"},{"name":"mark"},{"name":"syntaxcontext"}],"output":{"generics":["option"],"name":"option"}}],[11,"modern","","",0,{"inputs":[{"name":"self"}],"output":{"name":"span"}}],[11,"clone","","",4,{"inputs":[{"name":"self"}],"output":{"name":"spanlabel"}}],[11,"fmt","","",4,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",0,{"inputs":[],"output":{"name":"self"}}],[11,"default_encode","","",0,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"default_decode","","",0,{"inputs":[{"name":"d"}],"output":{"generics":["span"],"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",3,{"inputs":[],"output":{"name":"multispan"}}],[11,"from_span","","",3,{"inputs":[{"name":"span"}],"output":{"name":"multispan"}}],[11,"from_spans","","",3,{"inputs":[{"generics":["span"],"name":"vec"}],"output":{"name":"multispan"}}],[11,"push_span_label","","",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"string"}],"output":null}],[11,"primary_span","","Selects the first primary span (if any)",3,{"inputs":[{"name":"self"}],"output":{"generics":["span"],"name":"option"}}],[11,"primary_spans","","Returns all primary spans.",3,null],[11,"replace","","Replaces all occurrences of one Span with another. Used to move Spans in areas that don't display well (like std macros). Returns true if replacements occurred.",3,{"inputs":[{"name":"self"},{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"span_labels","","Returns the strings to highlight. We always ensure that there is an entry for each of the primary spans -- for each primary span P, if there is at least one label with span P, we return those labels (marked as primary). But otherwise we return `SpanLabel` instances with empty labels.",3,{"inputs":[{"name":"self"}],"output":{"generics":["spanlabel"],"name":"vec"}}],[11,"from","","",3,{"inputs":[{"name":"span"}],"output":{"name":"multispan"}}],[11,"from","","",3,{"inputs":[{"generics":["span"],"name":"vec"}],"output":{"name":"multispan"}}],[11,"clone","","",5,{"inputs":[{"name":"self"}],"output":{"name":"multibytechar"}}],[11,"encode","","",5,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",5,{"inputs":[{"name":"__d"}],"output":{"generics":["multibytechar"],"name":"result"}}],[11,"assert_receiver_is_total_eq","","",5,null],[11,"eq","","",5,{"inputs":[{"name":"self"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"self"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"self"}],"output":{"name":"nonnarrowchar"}}],[11,"encode","","",19,{"inputs":[{"name":"self"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"__d"}],"output":{"generics":["nonnarrowchar"],"name":"result"}}],[11,"assert_receiver_is_total_eq","","",19,null],[11,"eq","","",19,{"inputs":[{"name":"self"},{"name":"nonnarrowchar"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"self"},{"name":"nonnarrowchar"}],"output":{"name":"bool"}}],[11,"new","","",19,{"inputs":[{"name":"bytepos"},{"name":"usize"}],"output":{"name":"self"}}],[11,"pos","","Returns the absolute offset of the character in the CodeMap",19,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"width","","Returns the width of the character, 0 (zero-width) or 2 (wide)",19,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"add","","",19,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"self"}}],[11,"sub","","",19,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"self"}}],[11,"eq","","",20,{"inputs":[{"name":"self"},{"name":"externalsource"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"self"},{"name":"externalsource"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",20,null],[11,"clone","","",20,{"inputs":[{"name":"self"}],"output":{"name":"externalsource"}}],[11,"is_absent","","",20,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"get_source","","",20,{"inputs":[{"name":"self"}],"output":{"generics":["str"],"name":"option"}}],[11,"clone","","",6,{"inputs":[{"name":"self"}],"output":{"name":"filemap"}}],[11,"encode","","",6,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",6,{"inputs":[{"name":"d"}],"output":{"generics":["filemap"],"name":"result"}}],[11,"fmt","","",6,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",6,{"inputs":[{"name":"filename"},{"name":"bool"},{"name":"filename"},{"name":"string"},{"name":"bytepos"}],"output":{"name":"filemap"}}],[11,"next_line","","EFFECT: register a start-of-line offset in the table of line-beginnings. UNCHECKED INVARIANT: these offsets must be added in the right order and must be in the right places; there is shared knowledge about what ends a line between this file and parse.rs WARNING: pos param here is the offset relative to start of CodeMap, and CodeMap will append a newline when adding a filemap without a newline at the end, so the safe way to call this is with value calculated as filemap.start_pos + newline_offset_relative_to_the_start_of_filemap.",6,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":null}],[11,"add_external_src","","Add externally loaded source. If the hash of the input doesn't match or no input is supplied via None, it is interpreted as an error and the corresponding enum variant is set. The return value signifies whether some kind of source is present.",6,{"inputs":[{"name":"self"},{"name":"f"}],"output":{"name":"bool"}}],[11,"get_line","","Get a line from the list of pre-computed line-beginnings. The line number here is 0-based.",6,{"inputs":[{"name":"self"},{"name":"usize"}],"output":{"generics":["cow"],"name":"option"}}],[11,"record_multibyte_char","","",6,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"usize"}],"output":null}],[11,"record_width","","",6,{"inputs":[{"name":"self"},{"name":"bytepos"},{"name":"char"}],"output":null}],[11,"is_real_file","","",6,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"is_imported","","",6,{"inputs":[{"name":"self"}],"output":{"name":"bool"}}],[11,"byte_length","","",6,{"inputs":[{"name":"self"}],"output":{"name":"u32"}}],[11,"count_lines","","",6,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"lookup_line","","Find the line containing the given position. The return value is the index into the `lines` array of this FileMap, not the 1-based line number. If the filemap is empty or the position is located before the first line, None is returned.",6,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"generics":["usize"],"name":"option"}}],[11,"line_bounds","","",6,null],[11,"contains","","",6,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"self"}],"output":{"name":"bytepos"}}],[11,"eq","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",7,null],[11,"hash","","",7,null],[11,"partial_cmp","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"le","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"gt","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ge","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"cmp","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"ordering"}}],[11,"fmt","","",7,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",8,{"inputs":[{"name":"self"}],"output":{"name":"charpos"}}],[11,"eq","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",8,null],[11,"hash","","",8,null],[11,"partial_cmp","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"generics":["ordering"],"name":"option"}}],[11,"lt","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"le","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"gt","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ge","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"cmp","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"ordering"}}],[11,"fmt","","",8,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_usize","","",7,{"inputs":[{"name":"usize"}],"output":{"name":"bytepos"}}],[11,"to_usize","","",7,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"add","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"sub","","",7,{"inputs":[{"name":"self"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"encode","","",7,{"inputs":[{"name":"self"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",7,{"inputs":[{"name":"d"}],"output":{"generics":["bytepos"],"name":"result"}}],[11,"from_usize","","",8,{"inputs":[{"name":"usize"}],"output":{"name":"charpos"}}],[11,"to_usize","","",8,{"inputs":[{"name":"self"}],"output":{"name":"usize"}}],[11,"add","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"sub","","",8,{"inputs":[{"name":"self"},{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"fmt","","",9,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"self"}],"output":{"name":"loc"}}],[11,"fmt","","",10,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",11,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",13,{"inputs":[{"name":"self"}],"output":{"name":"lineinfo"}}],[11,"fmt","","",13,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"self"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"self"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",13,null],[11,"fmt","","",15,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",21,{"inputs":[{"name":"self"}],"output":{"name":"spanlineserror"}}],[11,"eq","","",21,{"inputs":[{"name":"self"},{"name":"spanlineserror"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"self"},{"name":"spanlineserror"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",21,null],[11,"fmt","","",21,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"self"}],"output":{"name":"spansnippeterror"}}],[11,"eq","","",22,{"inputs":[{"name":"self"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"self"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",22,null],[11,"fmt","","",22,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",16,{"inputs":[{"name":"self"}],"output":{"name":"distinctsources"}}],[11,"eq","","",16,{"inputs":[{"name":"self"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"self"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",16,null],[11,"fmt","","",16,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",17,{"inputs":[{"name":"self"}],"output":{"name":"malformedcodemappositions"}}],[11,"eq","","",17,{"inputs":[{"name":"self"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"self"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"assert_receiver_is_total_eq","","",17,null],[11,"fmt","","",17,{"inputs":[{"name":"self"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_ident","syntax_pos::symbol","",35,{"inputs":[{"name":"ident"}],"output":{"name":"symbol"}}],[11,"to_ident","","",35,{"inputs":[{"name":"self"}],"output":{"name":"ident"}}]],"paths":[[3,"Span"],[3,"Globals"],[3,"SpanData"],[3,"MultiSpan"],[3,"SpanLabel"],[3,"MultiByteChar"],[3,"FileMap"],[3,"BytePos"],[3,"CharPos"],[3,"Loc"],[3,"LocWithOpt"],[3,"FileMapAndLine"],[3,"FileMapAndBytePos"],[3,"LineInfo"],[3,"FileLines"],[3,"MacroBacktrace"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[4,"FileName"],[4,"NonNarrowChar"],[4,"ExternalSource"],[4,"SpanLinesError"],[4,"SpanSnippetError"],[3,"SyntaxContext"],[3,"SyntaxContextData"],[3,"Mark"],[3,"MarkData"],[3,"HygieneData"],[3,"ExpnInfo"],[3,"NameAndSpan"],[4,"MarkKind"],[4,"ExpnFormat"],[4,"CompilerDesugaringKind"],[3,"SpanInterner"],[3,"Ident"],[3,"Symbol"],[3,"Interner"],[3,"LocalInternedString"],[3,"InternedString"],[3,"Keyword"],[8,"Pos"]]};
initSearch(searchIndex);
